<?php
$dir = substr(dirname(__FILE__), 0, -5);

require_once($dir.'lib/sbFunctions.inc.php');
require_once($dir.'kernel/init.inc.php');

// Основные константы системы
require_once(SB_CMS_KERNEL_PATH.'/data.inc.php');
// Языковые константы ядра системы
require_once(SB_CMS_LANG_PATH.'/kernel.lng.php');
// Вспомогательные функции ядра системы
require_once(SB_CMS_LANG_PATH.'/index.lng.php');

/*
 * Запрещаем кэширование страницы барузером и проксей
 */
header('ETag: PUB' . time());
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: '.date('r'));
header('Cache-Control: no-store, no-cache, must-revalidate, proxy-revalidate, post-check=0, pre-check=0', false);
header('Pragma: no-cache');

/*
 * Сообщаем браузеру кодировку страницы
 */
header('Content-Language: '.SB_CMS_LANG.', en');
header('Content-Type: text/html; charset='.strtolower(SB_CHARSET));

if (isset($_POST['sb_pass']))
{
    echo sb_encrypt($_POST['sb_pass'], SB_HASH);    
}
else 
{
    echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
        <html lang="ru">
        <head>
        <style type="text/css">
        img
        {
            behavior: url("'.SB_CMS_JSCRIPT_URL.'/sbFixPng.htc.php");
        }
        </style>
        <script src="'.SB_CMS_JSCRIPT_URL.'/sbFunctions.js.php"></script>
        <script src="'.SB_CMS_JSCRIPT_URL.'/sbAJAX.js.php"></script>
        <script>
        function sbMakePass()
        {
            sbShowLoadingDiv(true);
            setTimeout("sbSendForm()", 0);
            return false;
        }
        function sbShowLoadingDiv(vis)
        {
            var loadingDiv = sbGetE("sb_loading_div");
            
            loadingDiv.style.left = (document.body.clientWidth / 2) - 200 + "px";
            loadingDiv.style.display = (vis ? "block" : "none");
        }
        function sbSendForm()
        {
            var pass = sbGetE("sb_pass");
            var enc_pass = sbGetE("sb_pass_encrypted");
            var pass_tr = sbGetE("sb_pass_tr");
            var form = sbGetE("sb_form");
        
            var data = sbEncodeForm(form);
    	    var res = sbPostSync("'.$_SERVER['PHP_SELF'].'", data);
    	    
    	    enc_pass.value = res;
    	    pass_tr.style.display = "";
            
            sbShowLoadingDiv(false);
        	return false;
        }
        </script>
        <link rel="stylesheet" type="text/css" href="'.SB_CMS_CSS_URL.'/sbIndex.css">
        <title>'.INDEX_PASS_TITLE.'</title>
        </head>
        <body>
        <form id="sb_form" action="" method="post" onsubmit="return sbMakePass();">
        <table cellpadding="0" cellspacing="0" style="height:100%;width:100%;">
        <tr><td valign="middle" align="center">';

    if (CMS_SITE_NAME == 'www.sbuilder.ru')
        echo '<div class="login_img">
                <a href="http://www.sbuilder.ru" target="_blank"><img src="'.SB_CMS_IMG_URL.'/login.png" class="login_img" width="161" height="207" /></a>
            </div>';
    
    echo '<table cellpadding="0" cellspacing="0" class="form" width="350">
          <tr>
            <th class="header" colspan="2">
              '.INDEX_PASS_TITLE_FORM.'
            </th>
          </tr>
          <tr>
            <th width="100" style="padding-top: 15px;">'.INDEX_PASSWORD.':</th>
            <td style="padding-top: 15px;">
                <input type="text" id="sb_pass" name="sb_pass" value="" tabIndex="1" style="width: 200px;" onkeypress="sbGetE(\'sb_pass_tr\').style.display=\'none\';">
            </td>
          </tr>
          <tr id="sb_pass_tr" style="display: none;">
              <th width="100">'.INDEX_PASS_ENCRYPT_PASSWORD.':</th>
              <td>
                <input type="text" id="sb_pass_encrypted" value="" tabIndex="2" style="width: 200px;">
              </td>
          </tr>
          <tr>
            <td colspan="2" align="center" style="padding: 5px 2px 2px 2px;">
                <div class="footer"><input type="submit" tabIndex="3" value="'.INDEX_PASS_ENCRYPT.'"></div>
            </td>
          </tr>
        </table>
        </td></tr>';

    if (CMS_SITE_NAME == 'www.sbuilder.ru')
    {
        echo '<tr><td class="links">
            <a href="http://know.sbuilder.ru/" target="_blank">'.INDEX_KNOW_LINK.'</a><br>
            <a href="http://api.sbuilder.ru" target="_blank">'.INDEX_API_LINK.'</a><br>
            <a href="http://www.sbuilder.ru/forum/" target="_blank">'.INDEX_FORUM_LINK.'</a><br>
            <a href="http://www.sbuilder.ru" target="_blank">'.INDEX_SITE_LINK.'</a><br>
            '.INDEX_COPYRIGHT.'
        </td></tr>';
    }

        echo '</table></form>
        <div id="sb_loading_div" class="sb_msg_div"><table cellspacing="0" cellpadding="0" width="100%"><tr><td width="60"><img src="'.SB_CMS_IMG_URL.'/loading.gif"></td><td id="sb_msg_div_text" class="sb_msg_div_text">'.INDEX_PASS_LOADING.'</td></tr></table></div>
        </body></html>';
}
?>