<?php
require_once(dirname(__FILE__).'/../kernel/header.inc.php');

$res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident=? AND cat_title=?', 'pl_editor_styles', SB_COOKIE_DOMAIN);

$xml = '';
    
if ($res)
{
    list($cat_id) = $res[0];
    
    $res = sql_query('SELECT t.se_name, t.se_tag, t.se_attrs FROM sb_editor_styles t, sb_catlinks l 
    			WHERE l.link_cat_id=?d AND l.link_el_id=t.se_id 
    			ORDER BY t.se_sort, t.se_name', $cat_id);
    
    if($res)
    {
        foreach($res as $value)
        {
            list($se_name, $se_tag, $se_attrs) = $value;
            
            if (trim($se_name) == '' || trim($se_tag) == '')
            	continue;

            if (trim($se_attrs) != '')
            	$se_attrs = unserialize($se_attrs);
            else 
            	$se_attrs = array();
            	
            $se_name = sb_str_replace(array("\r\n", "\r", "\n", '"'), array('', '', '', '\''), $se_name);
    	    
            $xml .= '<Style name="'.$se_name.'" element="'.$se_tag.'">';

            foreach ($se_attrs as $value)
            {
            	$xml .= '<'.$value['type'].' name="'.preg_replace('/[^a-zA-Z0-9\-_]/', '', $value['name']).'" value="'.trim($value['value'], ' ;').'" />';	
            }
            
			$xml .= '</Style>';
        }
    }
}

echo '<?xml version="1.0" encoding="utf-8" ?><Styles>'.$xml.'</Styles>';

require_once(dirname(__FILE__).'/../kernel/footer.inc.php');
?>