<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

var wnd = (_isIE ? dialogArguments : window.opener.sbModalDialog.args);

var oFakeImage = wnd.sbEditorSelection._GetSelectedElement() ;
var oAnchor ;

if ( oFakeImage )
{
	if ( oFakeImage.tagName == 'IMG' && oFakeImage.getAttribute('_sbanchor') )
		oAnchor = wnd.sbEditorGetRealElement( oFakeImage ) ;
	else
		oFakeImage = null ;
}

if ( !oFakeImage )
{
	oAnchor = wnd.sbEditorSelection._MoveToAncestorNode( 'A' ) ;
	if ( oAnchor )
		wnd.sbEditorSelection._SelectNode( oAnchor ) ;
}

window.onload = function()
{
	if ( oAnchor )
		sbGetE('txtName').value = oAnchor.name ;
	else
		oAnchor = null ;

	sbSelectField( 'txtName' ) ;
}

function save()
{
	var sNewName = sbGetE('txtName').value ;
	sNewName = sNewName.replace( /[^\w-_\.:]/g, '_' ) ;

	if ( sNewName.length == 0 )
	{
		if ( oAnchor )
		{
			wnd.sbEditorAnchorDeleteAction() ;
			sbCloseDialog() ;
			return true ;
		}

		alert( "<?php echo EDITOR_ANCHOR_NO_NAME; ?>" ) ;
		return false ;
	}

	wnd.sbEditorUndo._SaveUndoStep() ;

	if ( oAnchor )
	{
		ReadjustLinksToAnchor( oAnchor.name, sNewName );

		oAnchor.removeAttribute( 'name' ) ;
		oAnchor.name = sNewName ;

		sbCloseDialog() ;
		return true ;
	}

	var aNewAnchors = wnd.sbEditorCreateLink( '#' ) ;

	if ( aNewAnchors.length == 0 )
	{
		if ( _isIE )
			aNewAnchors.push( wnd.sbEditorInsertElement( '<a name="' + wnd.sbEditorHTMLEncode( sNewName ).replace( '"', '&quot;' ) + '">' ) ) ;
		else
		{
			var n = wnd.sbEditorInsertElement( 'a' ) ;
			n.name = sNewName ;
			aNewAnchors.push( n ) ;
		}
	}
	else
	{
		for ( var i = 0 ; i < aNewAnchors.length ; i++ )
			aNewAnchors[i].removeAttribute( 'href' ) ;
	}

	for ( var i = 0 ; i < aNewAnchors.length ; i++ )
	{
		oAnchor = aNewAnchors[i] ;

		if ( _isIE || _isOpera )
		{
			if ( oAnchor.innerHTML != '' )
			{
				if ( _isIE )
					oAnchor.className += ' sb__AnchorC' ;
			}
			else
			{
				var oImg = wnd.sbEditorDocumentProcessor._CreateFakeImage( 'sb__Anchor', oAnchor.cloneNode(true) ) ;
				oImg.setAttribute( '_sbanchor', 'true', 0 ) ;

				oAnchor.parentNode.insertBefore( oImg, oAnchor ) ;
				oAnchor.parentNode.removeChild( oAnchor ) ;
			}

		}
		else
		{
			oAnchor.name = sNewName ;
		}
	}

	sbCloseDialog() ;
}

function ReadjustLinksToAnchor( sCurrent, sNew )
{
	var oDoc = wnd.sbEditorAreaDoc ;
	var aLinks = wnd.sbEditorArea.getElementsByTagName( 'A' ) ;
	var sReference = '#' + sCurrent ;
	var sFullReference = oDoc.location.href.replace( /(#.*$)/, '') ;
	sFullReference += sReference ;

	var oLink ;
	var i = aLinks.length - 1 ;
	while ( i >= 0 && ( oLink = aLinks[i--] ) )
	{
		var sHRef = oLink.getAttribute( '_sbsavedurl' ) ;
		if ( sHRef == null )
			sHRef = oLink.getAttribute( 'href' , 2 ) || '' ;

		if ( sHRef == sReference || sHRef == sFullReference )
		{
			oLink.href = '#' + sNew ;
			sbSetAttribute( oLink, '_sbsavedurl', '#' + sNew ) ;
		}
	}
}

function setSaveBtn(el)
{
	if (el.value == "" && oAnchor)
		sbGetE("btnSave").value = "<?php echo EDITOR_ANCHOR_DELETE; ?>";
}
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>