<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

function sbGetAttribute( element, attName, valueIfNull )
{
	var oAtt = element.attributes[attName] ;
	if ( oAtt == null || !oAtt.specified )
		return valueIfNull ? valueIfNull : '' ;

	var oValue = element.getAttribute( attName, 2 ) ;

	if ( oValue == null )
		oValue = oAtt.nodeValue ;

	return ( oValue == null ? valueIfNull : oValue ) ;
}

function sbSetAttribute( element, attName, attValue )
{
	if ( attValue == null || attValue.length == 0 )
		element.removeAttribute( attName, 0 ) ;	
	else
		element.setAttribute( attName, attValue, 0 ) ;
}

String.prototype.Trim = function()
{
	return this.replace( /(^\s*)|(\s*$)/g, '' ) ;
}

function AddSelectOption ( selectElement, optionText, optionValue )
{
	var oDoc = selectElement.ownerDocument || selectElement.document ;
	var oOption = oDoc.createElement( "OPTION" ) ;

	oOption.text = optionText ;
	oOption.value = optionValue ;

	selectElement.options.add(oOption) ;

	return oOption ;
}

function ShowE( element, isVisible )
{
	if ( typeof( element ) == 'string' )
		element = sbGetE( element ) ;
		
	element.style.display = isVisible ? '' : 'none' ;
}

<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>