<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

var wnd = (_isIE ? dialogArguments : window.opener.sbModalDialog.args);

var table ;
var e = wnd.sbEditorSelection._GetSelectedElement() ;

if ( ( !e && document.location.search.indexOf("&props=true") != -1 ) || ( e && e.tagName != 'TABLE' ) )
	e = wnd.sbEditorSelection._MoveToAncestorNode( 'TABLE' ) ;

if ( e && e.tagName == "TABLE" )
	table = e ;

window.onload = function()
{
	if (table)
	{
		var tm = wnd.sbEditorTableHandler._CreateTableMap( table );
		sbGetE('spin_Rows').value = tm.length ;
		sbGetE('spin_Cols').value = tm[0].length ;

		var iWidth  = (table.style.width  ? table.style.width  : sbGetAttribute(table, "width") ) ;
		var iHeight = (table.style.height ? table.style.height : sbGetAttribute(table, "height") ) ;

		if (iWidth.indexOf('%') >= 0)
		{
			iWidth = parseInt( iWidth.substr(0, iWidth.length - 1), 10 ) ;
			sbGetE('selWidthType').value = "percent" ;
		}
		else if (iWidth.indexOf('px') >= 0)
		{
			iWidth = iWidth.substr(0, iWidth.length - 2);
			sbGetE('selWidthType').value = "pixels" ;
		}

		if (iHeight && iHeight.indexOf('%') >= 0)
		{
			iHeight = parseInt( iHeight.substr(0, iHeight.length - 1), 10 ) ;
			sbGetE('selHeightType').value = "percent" ;
		}
		else if (iHeight && iHeight.indexOf('px') >= 0)
		{
			iHeight = iHeight.substr(0, iHeight.length - 2);
			sbGetE('selHeightType').value = "pixels" ;
		}
		
		sbGetE('spin_Width').value = iWidth || '' ;
		sbGetE('spin_Height').value = iHeight || '' ;
		sbGetE('spin_Border').value = sbGetAttribute( table, 'border', '' ) ;

		function getHexString(clr)
    	{
    		clr = clr.split(",");
    		
      		var rStr = parseInt(clr[0]).toString(16);
      		if (rStr.length == 1)
        		rStr = '0' + rStr;
      		var gStr = parseInt(clr[1]).toString(16);
      		if (gStr.length == 1)
        		gStr = '0' + gStr;
      		var bStr = parseInt(clr[2]).toString(16);
      		if (bStr.length == 1)
        		bStr = '0' + bStr;
      		
      		return ('#' + rStr + gStr + bStr).toUpperCase();
    	}
	    	
		if (table.style.borderColor.indexOf("rgb") != -1)
		{
			var _start = table.style.borderColor.indexOf("(") + 1;
			var _end = table.style.borderColor.indexOf(")");
	    	var brdColor = getHexString(table.style.borderColor.substr( _start, _end - _start));
		}
		else
			var brdColor = table.style.borderColor;
		
		if ( _isIE)
		{
			var brdStyle = table.style.borderStyle ;
		}
		else
		{
			var brdStyle = table.style.borderStyle.split(" ") ;
			var brdStyle = brdStyle[0] ;
		}
		
		if (table.style.backgroundColor.indexOf("rgb") != -1)
		{
			var _start = table.style.backgroundColor.indexOf("(") + 1;
			var _end = table.style.backgroundColor.indexOf(")");
	    	var bgColor = getHexString(table.style.backgroundColor.substr( _start, _end - _start));
		}
		else
			var bgColor = table.style.backgroundColor;

		var bgImage = table.style.backgroundImage ;
		var _start = bgImage.indexOf("(") + 1;
		var _end = bgImage.indexOf(")");
	    var bgImage = bgImage.substr( _start, _end - _start);
		 
		sbGetE('txtBorderColor').value = brdColor ;
		sbGetE('selBorderType').value = brdStyle ;
		sbGetE('txtBackColor').value = bgColor ;
		sbGetE('txtBackImage').value = bgImage ;
		sbGetE('selBackImagePos').value = table.style.backgroundRepeat ;
		sbGetE('selAlignment').value = sbGetAttribute( table, 'align', '' ) ;
		sbGetE('spin_CellPadding').value = sbGetAttribute( table, 'cellPadding', '' ) ;
		sbGetE('spin_CellSpacing').value = sbGetAttribute( table, 'cellSpacing', '' ) ;
		sbGetE('txtAttId').value = table.id ;
		
		var reg = new RegExp("(border-color|border-right-color|border-left-color|border-top-color|border-bottom-color|border-style|border-right-style|border-left-style|border-top-style|border-bottom-style|background-color|background-image|background-repeat)\s*:.*[;]?", "ig");
		var sti ;
		if ( _isIE )
		{
			sbGetE('txtAttClasses').value = table.className || '' ;
			sti = table.style.cssText ;
		}
		else
		{
			sbGetE('txtAttClasses').value = table.getAttribute('class', 2) || '' ;
			sti = table.getAttribute('style', 2) ;
		}
	
		if (sti)
			sbGetE('txtAttStyle').value = sti.replace(reg, "");
	
		sbGetE('txtSummary').value = sbGetAttribute( table, 'summary', '' ) ;

		var eCaption = wnd.sbEditorGetFirstChild( table, 'CAPTION' ) ;
		if ( eCaption ) sbGetE('txtCaption').value = eCaption.innerHTML ;

		sbGetE('spin_Rows').disabled = true ;
		sbGetE('spin_Cols').disabled = true ;
		sbSelectField( 'spin_Width' ) ;
	}
	else
		sbSelectField( 'spin_Rows' ) ;
}

function save()
{
	var bExists = ( table != null ) ;

	if ( ! bExists )
		table = wnd.sbEditorAreaDoc.createElement( "TABLE" ) ;

	if ( bExists && table.style.width )		
		table.style.width = null ;
	if ( bExists && table.style.height )	
		table.style.height = null ;

	var sWidth = sbGetE('spin_Width').value ;
	if ( sWidth.length > 0 && sbGetE('selWidthType').value == 'percent' )
		sWidth += '%' ;

	var sHeight = sbGetE('spin_Height').value ;
	if ( sHeight.length > 0 && sbGetE('selHeightType').value == 'percent' )
		sHeight += '%' ;
		
	sbSetAttribute( table, 'width', sWidth ) ;
	sbSetAttribute( table, 'height', sHeight ) ;
	sbSetAttribute( table, 'border', sbGetE('spin_Border').value ) ;
	sbSetAttribute( table, 'align', sbGetE('selAlignment').value ) ;
	sbSetAttribute( table, 'cellPadding', sbGetE('spin_CellPadding').value ) ;
	sbSetAttribute( table, 'cellSpacing', sbGetE('spin_CellSpacing').value ) ;
	sbSetAttribute( table, 'id', sbGetE('txtAttId').value ) ;
	sbSetAttribute( table, 'summary', sbGetE('txtSummary').value ) ;

	var addStyle = "";
	if (sbGetE('spin_Border').value.Trim() != "" && sbGetE('spin_Border').value != 0)
	{
	    if (sbGetE('txtBorderColor').value.Trim() != "")
	    	addStyle += "border-color:" + sbGetE('txtBorderColor').value + ";";
	    if (sbGetE('selBorderType').value != "")
	    	addStyle += "border-style:" + sbGetE('selBorderType').value + ";";
	}
    
    if (sbGetE('txtBackColor').value != "")
    	addStyle += "background-color:" + sbGetE('txtBackColor').value + ";";
    if (sbGetE('txtBackImage').value != "")
    {
    	addStyle += "background-image: url(" + sbGetE('txtBackImage').value + ");";
    	if (sbGetE('selBackImagePos').value != "")
    		addStyle += "background-repeat:" + sbGetE('selBackImagePos').value + ";";
    }
    	
    var ownStyle = sbGetE('txtAttStyle').value;
    if (ownStyle != "" && ownStyle.substr(ownStyle.length - 2, 1) != ';')
    	ownStyle += ";";
    	
	if ( _isIE )
	{
		table.className = sbGetE('txtAttClasses').value ;
		table.style.cssText = ownStyle + addStyle;
	}
	else
	{
		sbSetAttribute( table, 'class', sbGetE('txtAttClasses').value ) ;
		sbSetAttribute( table, 'style', ownStyle + addStyle) ;
	}
	
	var eCaption = wnd.sbEditorGetFirstChild( table, 'CAPTION' ) ;

	if ( sbGetE('txtCaption').value != '')
	{
		if ( !eCaption )
		{
			eCaption = wnd.sbEditorAreaDoc.createElement( 'CAPTION' ) ;
			table.insertBefore( eCaption, table.firstChild ) ;
		}

		eCaption.innerHTML = sbGetE('txtCaption').value ;
	}
	else if ( bExists && eCaption )
	{
		eCaption.parentNode.removeChild( eCaption ) ;
	}

	if (! bExists)
	{
		var iRows = sbGetE('spin_Rows').value ;
		var iCols = sbGetE('spin_Cols').value ;

		for ( var r = 0 ; r < iRows ; r++ )
		{
			var oRow = table.insertRow(-1) ;
			for ( var c = 0 ; c < iCols ; c++ )
			{
				var oCell = oRow.insertCell(-1) ;
				if ( !_isIE )
					wnd.sbEditorAppendBogusBr( oCell ) ;
			}
		}

		wnd.sbEditorUndo._SaveUndoStep() ;
		wnd.sbEditorInsertElement( table ) ;
	}

	sbCloseDialog();
}

<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>