<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

var wnd = (_isIE ? dialogArguments : window.opener.sbModalDialog.args);

var oFakeImage = wnd.sbEditorSelection._GetSelectedElement() ;
var oObject, oEmbed, strMimeType ;
if ( oFakeImage )
{
	if ( oFakeImage.tagName == 'IMG' && oFakeImage.getAttribute('_sbmovie') )
	{
		oObject = wnd.sbEditorGetRealElement( oFakeImage ) ;
		if (oObject)
		{
			for (var i = 0; i < oObject.childNodes.length; i++)
			{
				if (oObject.childNodes[i].nodeName.toLowerCase() == 'embed')
				{
					oEmbed = oObject.childNodes[i];
					break; 
				}
			}
		}
		setMimeType(oFakeImage.getAttribute('_sbmovie'));
	}
	else
		oFakeImage = null ;
}

window.onload = function()
{
	if (!oFakeImage)
		setMimeType(sbGetE('cmbType').value) ;
	else
		sbGetE('cmbType').value = oFakeImage.getAttribute('_sbmovie') ;
		
	LoadSelection() ;
		
	sbSelectField( 'txtUrl' ) ;
}

function setMimeType(strType)
{
	switch (strType)
	{
		case 'avi':
			strMimeType = 'application/x-mplayer2';
			break;
			
		case 'mov':
			strMimeType = 'video/quicktime';
			break;
			
		case 'rm':
			strMimeType = 'audio/x-pn-realaudio-plugin';
			break;
			
		default: 
			strMimeType = '';
			break;
	}
}

function LoadSelection()
{
	if ( ! oEmbed ) return ;

	sbGetE('txtUrl').value = sbGetAttribute( oEmbed, 'src', '' ) ;
	sbGetE('spin_Width').value = sbGetAttribute( oObject, 'width', '' ) ;
	sbGetE('spin_Height').value = sbGetAttribute( oObject, 'height', '' ) ;

	sbGetE('txtAttId').value = oObject.id ;
	sbGetE('chkAutoPlay').checked = sbGetAttribute( oEmbed, 'autostart', 'true' ) == 'true' ;
	sbGetE('chkLoop').checked = sbGetAttribute( oEmbed, 'loop', 'true' ) == 'true' ;

	UpdatePreview() ;
}

function save()
{
	if ( sbGetE('txtUrl').value.length == 0 )
	{
		tabs.loadTab(0, true);
		sbSelectField( 'txtUrl' ) ;

		alert( "<?php echo EDITOR_MOVIE_NO_URL; ?>" ) ;

		return false ;
	}

	wnd.sbEditorUndo._SaveUndoStep() ;
	
	if ( !oObject )
	{
		oObject = wnd.sbEditorAreaDoc.createElement( 'OBJECT' ) ;
		oFakeImage  = null ;
	}
	
	UpdateObject( oObject ) ;
	if (_isIE)
	{
	    sbCloseDialog();
 	    return;
    }
    
	if ( !oFakeImage )
	{
		switch( sbGetE('cmbType').value )
		{
			case 'avi':
				oFakeImage = wnd.sbEditorDocumentProcessor._CreateFakeImage( 'sb__AVI', oObject ) ;
				oFakeImage.setAttribute( '_sbmovie', 'avi', 0 ) ;
				break;
				
			case 'mov':
				oFakeImage = wnd.sbEditorDocumentProcessor._CreateFakeImage( 'sb__MOV', oObject ) ;
				oFakeImage.setAttribute( '_sbmovie', 'mov', 0 ) ;
				break;
				
			case 'rm':
				oFakeImage = wnd.sbEditorDocumentProcessor._CreateFakeImage( 'sb__RM', oObject ) ;
				oFakeImage.setAttribute( '_sbmovie', 'rm', 0 ) ;
				break;
		}
		
		oFakeImage = wnd.sbEditorInsertElement( oFakeImage ) ;
	}
	else
	{
		switch( sbGetE('cmbType').value )
		{
			case 'avi':
				oFakeImage.className = 'sb__AVI' ;
				break;
				
			case 'mov':
				oFakeImage.className = 'sb__MOV' ;
				break;
				
			case 'rm':
				oFakeImage.className = 'sb__RM' ;
				break;
		}
		
		oFakeImage.setAttribute( '_sbmovie', sbGetE('cmbType').value, 0 ) ;
	}

	wnd.sbEditorEmbedAndObjectProcessor._RefreshView( oFakeImage, oObject ) ;

	sbCloseDialog();
}

function UpdateObject(e)
{
	switch( sbGetE('cmbType').value )
	{
		case 'avi':
			var strClass = 'clsid:22d6f312-b0f6-11d0-94ab-0080c74c7e95';
			var strBase = 'http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701';
			var strPlugin = 'http://www.microsoft.com/windows/mediaplayer/en/download/';
			break;
			
		case 'mov':
			var strClass = 'clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b';
			var strBase = 'http://www.apple.com/qtactivex/qtplugin.cab';
			var strPlugin = 'http://www.apple.com/quicktime/download/';
			break;
			
		case 'rm':
			var strClass = 'clsid:cfcdaa03-8be4-11cf-b84b-0020afbbccfa';
			var strBase = '';
			var strPlugin = 'http://forms.real.com/real/realone/intl/focus.html';
			break;
	}
	
	if (_isIE)
	{
	    var html = '<object' +
	       (sbGetE('txtAttId').value != "" ? ' id="' + sbGetE('txtAttId').value + '"' : '') + 
	       (sbGetE('spin_Width').value != "" ? ' width="' + sbGetE('spin_Width').value + '"' : '') +
	       (sbGetE('spin_Height').value != "" ? ' height="' + sbGetE('spin_Height').value + '"' : '') +
	       ' classid="' + strClass + '" codebase="' + strBase + '">' +
           '<param name="src" value="' + sbGetE('txtUrl').value + '">' +
           '<param name="autostart" value="' + (sbGetE('chkAutoPlay').checked ? 'true' : 'false') + '">' +
           '<param name="loop" value="' + (sbGetE('chkLoop').checked ? 'true' : 'false') + '">' +
           '<embed type="' + strMimeType + '" pluginspage="' + strPlugin + '" src="' + sbGetE('txtUrl').value + '"' + 
           (sbGetE('spin_Width').value != "" ? ' width="' + sbGetE('spin_Width').value + '"' : '') +
           (sbGetE('spin_Height').value != "" ? ' height="' + sbGetE('spin_Height').value + '"' : '') +
           ' autostart="' + (sbGetE('chkAutoPlay').checked ? 'true' : 'false') + '"' + 
           ' loop="' + (sbGetE('chkLoop').checked ? 'true' : 'false') + '"></embed></object>';
           
        e.removeNode(true);
        wnd.sbEditorInsertHtml( html ) ;
	}
	else
	{
		sbSetAttribute( e, 'classid', strClass ) ;
		sbSetAttribute( e, 'codebase', strBase ) ;
		if (sbGetE('spin_Width').value != "")
		    sbSetAttribute( e, 'width', sbGetE('spin_Width').value ) ;
		if (sbGetE('spin_Height').value != "")
		    sbSetAttribute( e, 'height', sbGetE('spin_Height').value ) ;
		sbSetAttribute( e, 'id', sbGetE('txtAttId').value ) ; 
		
		while ( e.firstChild )
			e.removeChild( e.firstChild ) ;
		
		var ch = wnd.sbEditorAreaDoc.createElement( 'PARAM' ) ;
		sbSetAttribute( ch, 'name', 'src' ) ;
		sbSetAttribute( ch, 'value', sbGetE('txtUrl').value ) ; 
		e.appendChild(ch);
			
		ch = wnd.sbEditorAreaDoc.createElement( 'PARAM' ) ;
		sbSetAttribute( ch, 'name', 'autostart' ) ;
		sbSetAttribute( ch, 'value', sbGetE('chkAutoPlay').checked ? 'true' : 'false' ) ; 
		e.appendChild(ch);
		
		ch = wnd.sbEditorAreaDoc.createElement( 'PARAM' ) ;
		sbSetAttribute( ch, 'name', 'loop' ) ;
		sbSetAttribute( ch, 'value', sbGetE('chkLoop').checked ? 'true' : 'false' ) ; 
		e.appendChild(ch);
		
		ch = wnd.sbEditorAreaDoc.createElement( 'EMBED' ) ;
		sbSetAttribute( ch, 'type', strMimeType ) ;
		sbSetAttribute( ch, 'pluginspage', strPlugin ) ;
		sbSetAttribute( ch, 'width', sbGetE('spin_Width').value ) ;
		sbSetAttribute( ch, 'height', sbGetE('spin_Height').value ) ;
		sbSetAttribute( ch, 'autostart', sbGetE('chkAutoPlay').checked ? 'true' : 'false' ) ;
		sbSetAttribute( ch, 'loop', sbGetE('chkLoop').checked ? 'true' : 'false' ) ;
		sbSetAttribute( ch, 'src', sbGetE('txtUrl').value ) ;
		e.appendChild(ch);
	}
}

var ePreview ;

function SetPreviewElement( previewEl )
{
	ePreview = previewEl ;

	if ( sbGetE('txtUrl').value.length > 0 )
		UpdatePreview() ;
}

function CheckKey(e)
{
	var keystroke = e.keyCode || e.which ;
	if (keystroke == 13)
		UpdatePreview();
}

var oldType, oldSrc, oldWidth, oldHeight;
function UpdatePreview()
{
	if ( !ePreview || strMimeType == '')
		return ;
		
	if ( sbGetE('txtUrl').value == "" )
	{
		oldType = '';
		oldSrc = '';
		ePreview.innerHTML = '&nbsp;' ;
	}
	else
	{
		if (oldType == sbGetE('cmbType').value && oldSrc == sbGetE('txtUrl').value && 
		    oldWidth == sbGetE('spin_Width').value && oldHeight == sbGetE('spin_Height').value)
			return;
		
		while ( ePreview.firstChild )
			ePreview.removeChild( ePreview.firstChild ) ;
			
		switch( sbGetE('cmbType').value )
		{
			case 'avi':
				var strClass = 'clsid:22d6f312-b0f6-11d0-94ab-0080c74c7e95';
				var strBase = 'http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701';
				var strPlugin = 'http://www.microsoft.com/windows/mediaplayer/en/download/';
				break;
				
			case 'mov':
				var strClass = 'clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b';
				var strBase = 'http://www.apple.com/qtactivex/qtplugin.cab';
				var strPlugin = 'http://www.apple.com/quicktime/download/';
				break;
				
			case 'rm':
				var strClass = 'clsid:cfcdaa03-8be4-11cf-b84b-0020afbbccfa';
				var strBase = '';
				var strPlugin = 'http://forms.real.com/real/realone/intl/focus.html';
				break;
		}

		oldType = sbGetE('cmbType').value;
		oldSrc = sbGetE('txtUrl').value;
		oldWidth = sbGetE('spin_Width').value;
		oldHeight = sbGetE('spin_Height').value;
		
		var oDoc = ePreview.ownerDocument || ePreview.document ;
		if (_isIE)
		{
			var obj = oDoc.createElement( 'OBJECT' ) ;
			
			if (sbGetE('spin_Width').value != "")
                sbSetAttribute( obj, 'width', sbGetE('spin_Width').value ) ;
            else
                sbSetAttribute( obj, 'width', '100%' ) ;
                
            if (sbGetE('spin_Height').value != "")
                sbSetAttribute( obj, 'height', sbGetE('spin_Height').value ) ;
			else
			    sbSetAttribute( obj, 'height', '100%' ) ;
			    
			sbSetAttribute( obj, 'classid', strClass ) ;
			sbSetAttribute( obj, 'codebase', strBase ) ;
			
			ch = oDoc.createElement( 'PARAM' ) ;
			sbSetAttribute( ch, 'name', 'autostart' ) ;
			sbSetAttribute( ch, 'value', 'true' ) ; 
			obj.appendChild(ch);

            ch = oDoc.createElement( 'PARAM' ) ;
            sbSetAttribute( ch, 'name', 'loop' ) ;
            sbSetAttribute( ch, 'value', 'true' ) ;
            obj.appendChild(ch);
            
            var ch = oDoc.createElement( 'PARAM' ) ;
            sbSetAttribute( ch, 'name', 'src' ) ;
            sbSetAttribute( ch, 'value', sbGetE('txtUrl').value ) ; 
            obj.appendChild(ch);
            
	        ePreview.innerHTML = obj.outerHTML;
	    }
	    else
	    {
		    var emb = oDoc.createElement( 'EMBED' ) ;
		
		    if (sbGetE('spin_Width').value != "")
                sbSetAttribute( emb, 'width', sbGetE('spin_Width').value ) ;
            else
                sbSetAttribute( emb, 'width', '100%' ) ;
                
            if (sbGetE('spin_Height').value != "")
                sbSetAttribute( emb, 'height', sbGetE('spin_Height').value ) ;
            else
                sbSetAttribute( emb, 'height', '100%' ) ;
                
			sbSetAttribute( emb, 'src', sbGetE('txtUrl').value ) ;
			sbSetAttribute( emb, 'type', strMimeType ) ;
			sbSetAttribute( emb, 'pluginspage', strPlugin ) ;
			sbSetAttribute( emb, 'autostart', 'true' ) ;
			sbSetAttribute( emb, 'loop', 'true' ) ;
			
			ePreview.appendChild( emb ) ;
	    }	
	}
}

<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>