<?php
ob_start();

$dir = substr(dirname(__FILE__), 0, -7);

// Вспомогательные функции ядра системы
require_once($dir.'lib/sbFunctions.inc.php');

define('SB_JSCRIPT', 1);

require_once($dir.'kernel/init.inc.php');

/*
 * Сообщаем браузеру кодировку страницы
 */
header('Content-Language: '.SB_CMS_LANG.', en');
header('Content-Type: text/javascript; charset='.strtoupper(SB_CHARSET));

// Основные константы системы
require_once(SB_CMS_KERNEL_PATH.'/data.inc.php');
// Языковые константы ядра системы
require_once(SB_CMS_LANG_PATH.'/kernel.lng.php');
// Языковые константы яваскриптовых файлов
require_once(SB_CMS_LANG_PATH.'/jscript.lng.php');
// Определяем браузер
require_once(SB_CMS_LIB_PATH.'/sbCheckBrowser.inc.php');

/*
 * Устанавливаем перехват ошибок PHP нашей функцией, чтобы в дальнейшем
 * записывать ошибки в системный журнал.
 */

set_error_handler('sb_php_error_reporting');
register_shutdown_function('sb_php_shutdown');

// Подключение библиотеки работы с СУБД
$GLOBALS['sb_sql_not_exit'] = true;
require_once(SB_CMS_LIB_PATH.'/sbSql.inc.php');

// Подключение библиотеки работы с модулями системы
require_once(SB_CMS_LIB_PATH.'/sbPlugins.inc.php');

// Считываем настройки системы
sbPlugins::initSettings();
?>