<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
var sbCharClosed = false;
var sbCharTimer = null;
var sbCharDelay = false;

function sbSkipDelayChar()
{
    sbCharDelay = false;
}

function sbCloseCharHelp()
{
    var helpEl = sbGetE("sb_character_help");
    if (helpEl)
    {
        helpEl.style.visibility = "hidden";
        helpEl.style.left = -1000;
        helpEl.style.top = -1000;
        sbCharClosed = true;
        clearInterval(sbCharTimer);
    }
}
function sbShowCharHelp()
{
    if (sbCharDelay)
        return;
     
    var imgEl = sbGetE("sb_character_img");
    if (imgEl)
    {
    	sbLoadAsync(sb_char_help_url + "&tip_index="+imgEl.getAttribute('help_index'), sbAfterChangeCharHelp);
        
		sbCharDelay = true;
    	setTimeout("sbSkipDelayChar()", 1000);
    }
}
function sbChangeCharHelp()
{
	var imgEl = sbGetE("sb_character_img");
	if (imgEl)
	{
    	sbLoadAsync(sb_char_help_url + "&tip_index="+imgEl.getAttribute('help_index'), sbAfterChangeCharHelp);
    }
}
function sbAfterChangeCharHelp(res)
{
	if (res)
    {
    	var hintEl = sbGetE("sb_character_hint");
        var imgEl = sbGetE("sb_character_img");
    
    	if (hintEl && imgEl)
    	{
	        res = res.split("~~");
	        hintEl.innerHTML = res[0];
	        imgEl.setAttribute('help_index', res[1]);
	        imgEl.src = res[2];
	        sbCharClosed = false;
	        sbInitCharHelp();
	    }
    }
}
function sbInitCharHelp()
{
    var helpEl = sbGetE("sb_character_help");
    var tblEl = sbGetE("sb_character_table");
    var imgEl = sbGetE("sb_character_img");

    if (tblEl && helpEl && imgEl)
    {
        imgEl.style.top = Math.max(0, parseInt(document.body.clientHeight) - 135);
        imgEl.style.left = Math.max(0, parseInt(document.body.clientWidth) - 150);

        var t = Math.max(0, parseInt(document.body.clientHeight) - 150 - parseInt(tblEl.offsetHeight));
        var l = Math.max(0, parseInt(document.body.clientWidth) - 70 - parseInt(helpEl.offsetWidth));

        if (t == 0 || l == 0)
        {
            helpEl.style.visibility = "hidden";
            helpEl.style.left = -1000;
            helpEl.style.top = -1000;
        }
        else if (!sbCharClosed)
        {
            helpEl.style.visibility = "visible";
            helpEl.style.top = t;
            helpEl.style.left = l;
            clearInterval(sbCharTimer);
            sbCharTimer = setInterval("sbChangeCharHelp()", 10000);
        }
    }
}
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>