<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
var sbModalDialog = new Object();

function sbFocusDialog()
{
    if (sbModalDialog.win && !sbModalDialog.win.closed)
    {
    	if ( _isSafari )
    	{
    		var els = sbModalDialog.win.document.getElementsByTagName("input");
    		if (els.length > 0)
    		{
    			els[1].focus();
    		}
    	}
    	else
        	sbModalDialog.win.focus();
        return false;
    }
    else
    {
        sbUnblockEvents();
        return false;
    }
}

function sbShowDisDiv()
{
    var dis_div_con = sbGetE("disable_div");

    if (dis_div_con)
    {
        dis_div_con.style.height = document.body.clientHeight;
        dis_div_con.style.width = document.body.clientWidth;
        dis_div_con.style.display = "block";
    }

    if (window.parent.navmenu)
    {
        var dis_div_nav = window.parent.navmenu.sbGetE("disable_div");

        if (dis_div_nav)
        {
            dis_div_nav.style.height = window.parent.navmenu.document.body.clientHeight;
            dis_div_nav.style.width = window.parent.navmenu.document.body.clientWidth;
            dis_div_nav.style.display = "block";
        }
    }
}

function sbHideDisDiv()
{
    var dis_div_con = sbGetE("disable_div");

    if (dis_div_con)
    {
        dis_div_con.style.height = 0;
        dis_div_con.style.width = 0;
        dis_div_con.style.display = "none";
    }

    if (window.parent.navmenu)
    {
        var dis_div_nav = window.parent.navmenu.sbGetE("disable_div");

        if (dis_div_nav)
        {
            dis_div_nav.style.height = 0;
            dis_div_nav.style.width = 0;
            dis_div_nav.style.display = "none";
        }
    }
}

function sbBlockEvents()
{
    sbShowDisDiv();
    
    if (!_isIE && !_isFF)
    {
        sbAddEvent(window, 'click', sbFocusDialog);
        sbAddEvent(window, 'focus', sbCheckModal);
        if (window.parent.navmenu)
        {
            sbAddEvent(window.parent.navmenu, 'click', sbFocusDialog);
            sbAddEvent(window.parent.navmenu, 'focus', sbCheckModal);
        }
    }
}

function sbUnblockEvents()
{
    if (!_isIE && !_isFF)
    {
        sbRemoveEvent(window, 'click', sbFocusDialog);
        sbRemoveEvent(window, 'focus', sbCheckModal);
        if (window.parent.navmenu)
        {
            sbRemoveEvent(window.parent.navmenu, 'click', sbFocusDialog);
            sbRemoveEvent(window.parent.navmenu, 'focus', sbCheckModal);
        }
    }
    
    with (sbModalDialog)
    {
        if (!was_called && typeof(returnFunc) == "function")
        {
            returnValue = false;
            returnFunc();
        }

        returnFunc = null;
        returnValue = null;
        win = null;
        was_called = false;
    }
    sbHideDisDiv();
}

function sbCheckModal()
{
    setTimeout('sbFocusDialog()', 10);
    return true;
}

function sbDialogFeatures(feature)
{
    if(feature == null)
        feature = "";

    var WF = new Object();
    WF["width"] = 400;
    WF["height"] = 400;
    WF["left"] = "";
    WF["top"] =  "";
    WF["resizable"] = "";
    
    if(feature != null && feature != "")
    {
        feature = ( feature.toLowerCase()).split(",");

        for(var i=0; i < feature.length;i++)
	    {
            if(feature[i].isArgument())
		    {
                 var featureName = feature[i].split("=")[0];
		         var featureValue = feature[i].split("=")[1];

		         if(WF[featureName] != null)
		         {
		             WF[featureName] = featureValue;
		         }
		    }
	    }
    }

    if(WF["resizable"]==1 || WF["resizable"]=="1" || WF["resizable"].toString().toLowerCase()=="yes")
    {
        WF["resizable"] = (_isIE || _isFF ? "resizable:yes;" : "resizable=1;");
    }
    else
    {
        WF["resizable"] = (_isIE || _isFF ? "resizable:no;" : "resizable=0;");
    }
    
    if(WF["left"] != "")
    {
        WF["left"] = (_isIE || _isFF ? "dialogLeft:" +  WF["left"] +"px;" : "left=" +  WF["left"] +",");
    }
    else
    {
        var l = parseInt((parseInt(screen.availWidth) - WF["width"]) / 2);
        if (_isFF)
            WF["left"] = "dialogLeft:" + l + "px;";
        else if (!_isIE)
            WF["left"] = "left=" + l + ",";
    }
    
    if(WF["top"] != "")
    {
        WF["top"] = (_isIE || _isFF ? "dialogTop:" + WF["top"] +"px;" : "top=" + WF["top"] +",");
    }
    else
    {
    	var t = parseInt((parseInt(screen.availHeight) - WF["height"]) / 2);
        if (_isFF)
            WF["top"] = "dialogTop:" + t + "px;";
        else if (!_isIE)  
            WF["top"] = "top=" + t + ",";
    }

    return WF;
}

function sbShowModalDialog(url, feature, func, arguments)
{
    if(url == null || url == "" || (sbModalDialog.win && !sbModalDialog.win.closed))
        return;

    sbModalDialog.returnFunc = func;
    sbModalDialog.args = arguments;
    sbModalDialog.returnValue = "";
    sbModalDialog.name = (new Date()).getSeconds().toString();
    sbModalDialog.win = null;
    sbModalDialog.was_called = false;

    with (sbModalDialog)
    {
        var WF = sbDialogFeatures(feature);
        
        if (_isIE || _isFF)
        {
            var F = WF["left"]+WF["top"]+"dialogWidth:"+WF["width"]+"px;dialogHeight:"+WF["height"]+"px;status:no;help:no;"+WF["resizable"];
            sbBlockEvents();
            returnValue = showModalDialog(url, args, F);
            if (typeof(returnFunc) == "function")
            {
                returnFunc();
            }

            was_called = true;
            sbUnblockEvents();
        }
        else
        {
            var F = WF["left"]+WF["top"]+"width="+WF["width"]+",height="+WF["height"]+",toolbars=0,location=0,status=0,menubar=0,modal=yes,"+WF["resizable"];
            
            try
            {
	            win = window.open(url, "", F);
	            sbBlockEvents();
	            win.focus();
	        }
	        catch(e)
	        {
	        	alert("<?php echo sprintf(DIALOGS_POPUP_BLOCKED, SB_COOKIE_DOMAIN); ?>");
	        }
        }
    }
}

function sbShowDialog(url, feature, args)
{
    var isIE = _isIE;
    var isFF = _isFF;
    _isIE = false;
    _isFF = false;

    var WF = sbDialogFeatures(feature);
    _isIE = isIE;
    _isFF = isFF;

    var F = WF["left"]+WF["top"]+"width="+WF["width"]+",height="+WF["height"]+",toolbars=0,location=0,status=0,menubar=0,modal=1,"+WF["resizable"];

    try
    {
    	win = window.open(url, "", F);
    	win.focus();
    }
    catch (e)
    {
    	alert("<?php echo sprintf(DIALOGS_POPUP_BLOCKED, SB_COOKIE_DOMAIN); ?>");
    }
}
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>