<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
var sbDocument = (_isIE ? dialogArguments[0] : window.opener.sbModalDialog.args[0]);
var	sbTextarea = (_isIE ? dialogArguments[1] : window.opener.sbModalDialog.args[1]);
var sbCodeditor = (_isIE ? dialogArguments[2] : window.opener.sbModalDialog.args[2]);

var sbFound = false;
var sbRange = null;
var sbDocRange = null;

if ( _isIE && !sbCodeditor )
{
	sbRange = sbDocument.body.createTextRange();
    sbDocRange = sbDocument.body.createTextRange();
    sbDocRange.moveToElementText(sbTextarea);
}

function sbBtnStat()
{
    sbHideMsgDiv();
    var dis = ( sbGetE("txtFind").value == "" );
    sbGetE("btnFind").disabled = dis;
    sbGetE("btnReplace").disabled = dis;
    sbGetE("btnReplaceAll").disabled = dis;
    if (_isIE && !sbCodeditor)
       sbRange = sbDocument.body.createTextRange();;
}

function sbBtnStatDelayed()
{
	setTimeout( sbBtnStat, 1 ) ;
}

function _sbReplaceText(textEl, newText)
{
    if ( _isIE && textEl.isTextEdit )
    {
        var caretPos = sbDocument.selection.createRange();
        caretPos.text = newText;
        sbRange.select() ;
		sbRange.collapse(false) ;
    }
    else if (!_isIE)
    {
        if (typeof(textEl.setSelectionRange) != "undefined")
        {
            var oldSelectionStart = textEl.selectionStart;
            var oldSelectionEnd = textEl.selectionEnd;
            var selectedText = textEl.value.substring(oldSelectionStart, oldSelectionEnd);
            var scrollTop, scrollLeft;
            if (textEl.type == "textarea" && typeof(textEl.scrollTop) != "undefined")
            {
                scrollTop  = textEl.scrollTop;
                scrollLeft = textEl.scrollLeft;
            }
            textEl.value = textEl.value.substring(0, oldSelectionStart) + newText + textEl.value.substring(oldSelectionEnd);

            if (typeof(scrollTop) != "undefined")
            {
                textEl.scrollTop  = scrollTop;
                textEl.scrollLeft = scrollLeft;
            }
            textEl.setSelectionRange(oldSelectionStart + newText.length, oldSelectionStart + newText.length);
        }
    }
}

function sbReplace()
{
    sbHideMsgDiv();
    if (sbFound)
    {
        if (sbCodeditor)
        {
        	sbRange.replace(sbGetE("txtReplace").value);
        }
        else
        {
        	_sbReplaceText(sbTextarea, sbGetE("txtReplace").value);
        }
    }

    sbFind(true);
}

function sbReplaceAll()
{
    sbHideMsgDiv();
    sbFound = false;
    
    if (_isIE && !sbCodeditor) sbRange = sbDocument.body.createTextRange();

    sbFind(true);
    var num = 0;
    while (sbFound)
    {
    	if (sbCodeditor)
        {
        	sbRange.replace(sbGetE("txtReplace").value);
        }
        else
        {
        	_sbReplaceText(sbTextarea, sbGetE("txtReplace").value);
        }
        
        sbFind(false);
        num++;
    }
    
    if (num != 0)
    {
        var str = new String("<?php echo EDITOR_FINDDLG_REPLACE_MSG; ?>");
	    sbShowMsgDiv(str.replace("%s", num), "information.png");
    }
}

function sbFind(showMsg)
{
    sbHideMsgDiv();
    if ( sbGetE("txtFind").value.length == 0 )
		return;

	if (sbCodeditor)
	{
		_sbFind(showMsg);
	}	
	else
	{
		sbTextarea.focus();
		 
	    if (!_isIE && !sbFound)
	        sbTextarea.setSelectionRange(0, 0);
	
		if ( _isIE )
			_sbFindIE(showMsg) ;
		else
			_sbFindGecko(showMsg) ;
	}
}

function _sbFind(showMsg)
{
    if (!sbRange)
	{
		sbRange = sbCodeditor.getSearchCursor(sbGetE("txtFind").value, false, !sbGetE("chkCase").checked);
	}
	
	sbFound = sbRange.findNext();
	if (sbFound)
	{
		sbRange.select();
	}
	else
	{
	    sbRange = null;
		if (showMsg) 
		    sbShowMsgDiv("<?php echo EDITOR_FINDDLG_NOTFOUND_MSG; ?>", "information.png") ;
	}
}

function _sbFindIE(showMsg)
{
	var iFlags = 0 ;

	if ( sbGetE("chkCase").checked )
		iFlags = iFlags | 4 ;

	if ( sbGetE("chkWord").checked )
		iFlags = iFlags | 2 ;

    sbFound = sbRange.findText( sbGetE("txtFind").value, 1, iFlags ) ;

	if ( sbFound && sbDocRange.inRange(sbRange) )
	{
		sbRange.scrollIntoView() ;
		sbRange.select() ;
		sbRange.collapse(false) ;
	}
	else
	{
		sbDocument.selection.empty(false) ;
		sbRange = sbDocument.body.createTextRange();
		sbFound = false;
		if (showMsg) 
		    sbShowMsgDiv("<?php echo EDITOR_FINDDLG_NOTFOUND_MSG; ?>", "information.png") ;
	}
}

function _sbFindGecko(showMsg)
{
	var bCase = sbGetE("chkCase").checked ;
	var bWord = sbGetE("chkWord").checked ;
    sbFound = window.opener.find( sbGetE("txtFind").value, bCase, false, false, bWord, true, false);

    if (!sbFound)
	{
		sbTextarea.selectionStart = sbTextarea.selectionEnd;
		if (showMsg) sbShowMsgDiv("<?php echo EDITOR_FINDDLG_NOTFOUND_MSG; ?>", "information.png");
	}

	if (sbTextarea.selectionStart == sbTextarea.selectionEnd)
	{
        if (showMsg) sbShowMsgDiv("<?php echo EDITOR_FINDDLG_NOTFOUND_MSG; ?>", "information.png");
        var els = sbDocument.getElementsByTagName("textarea");
        try
        {
            for (var i = 0; i < els.length; i++)
                els[i].setSelectionRange(0, 0);
        }
        catch (e) {};
        sbFound = false;
	}
}
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>