<?php
require_once(dirname(__FILE__).'/jheader.inc.php');
require_once(SB_CMS_LANG_PATH.'/pl_plugin_data.lng.php');
?>
function sbPDEChangeMandatory(el)
{
	var el_val = sbGetE("mandatory_val");
    var el_err = sbGetE("mandatory_err");

    if (el_val)
    	el_val.disabled = !el.checked;

    if (el_err)
    	el_err.disabled = !el.checked;
}

function sbPDESetDateCurrent(el)
{
	if (el.checked)
    {
    	var display = "none";
        sbGetE("default").value = "";
    }
    else
    {
        var display = "";
    }

    sbGetE("default_button").style.display=display;
    sbGetE("default_drop_button").style.display=display;
    sbGetE("default").style.display=display;
}

function sbPDEMaxLengthToggle()
{
	var max = sbGetE ("spin_max_length");
    var el = sbGetE ("char_count");

    if (el.checked == true)
    {
    	max.disabled = false;
    }

    else
    {
    	max.disabled = true;
    }
}

function sbPDEChangeIdent(el)
{
	var cat_el = sbGetE(sbCatIdFieldId);
    var text_el = sbGetE(sbCatIdFieldId + "_text");
    var cat_cat_el = sbGetE(sbCatIdFieldId + "_cat");
    var ident_el = sbGetE(sbCatIdFieldId + "_ident");

    cat_el.value = "";
    text_el.innerHTML = "<b style='font-size:11px;'><?php echo SB_LAYOUT_NO_CATEG ?></b>";
    cat_cat_el.value = "";
    ident_el.value = el.value;
    if(sbGetE('modules_title_fld').length)
	{
		sbPDEChangeIdentPluginsTitle('');
	}
}

function sbPDEChangeIdentPluginsTitle(sel)
{
	var ident = sbGetE("ident").value;
	var res = eval('(' + sbLoadSync(sb_cms_empty_file + "?event=pl_plugin_data_get_fields&ident="+ident) + ')');
	var fields = sbGetE('modules_title_fld');
	while (fields.childNodes.length)
	{
    	if (fields.firstChild.tagName == 'OPTGROUP')
    	{
        	while (fields.firstChild.childNodes.length)
        	{
            	fields.firstChild.removeChild(fields.firstChild.firstChild);
            }
        }
        fields.removeChild(fields.firstChild);
    }
	for(var i = 0; i < res.length; i++)
	{
		var selected = '';
		var option = document.createElement("OPTION");
	    fields.appendChild(option);
	    option.value = res[i].field;
	    option.innerHTML = res[i].title;
		if(sel == res[i].field)
			option.selected = true;
	}
}

function sbPDESetTableDateCurrent(el,key)
{
	if (el.checked)
    {
    	var display = "none";
        sbGetE(key+"_date_default").value = "";
    }
    else
    {
    	var display = "";
    }

    sbGetE(key+"_date_default_button").style.display = display;
    sbGetE(key+"_date_default_drop_button").style.display = display;
    sbGetE(key+"_date_default").style.display = display;
}

function sbPDEChangeLocal(f)
{
	var path = sbGetE("path");
	var local = sbGetE("local");
    if(!f)
    {
	    var path_btn = sbGetE("path_button");
	    var resize = sbGetE("resize");
	    var img_width = sbGetE("spin_img_width");
	    var img_height = sbGetE("spin_img_height");
	    var img_quality = sbGetE("spin_img_quality");

	    var watermark = sbGetE("watermark");
	    var watermark_position = sbGetE("watermark_position");
	    var watermark_margin = sbGetE("spin_watermark_margin");

	    var watermark_file = sbGetE("watermark_file");
	    var watermark_file_btn = sbGetE("watermark_file_button");

	    var copyright = sbGetE("copyright");
	    var copyright_color = sbGetE("copyright_color");
	    var copyright_font = sbGetE("copyright_font");
	    var copyright_size = sbGetE("copyright_size");
	}

	var dis = true;
	if (!local || local.checked)
	{
		dis = false;
	}
	path.disabled = dis;
	if(!f)
    {
    	path_btn.disabled = dis;
	    resize.disabled = dis;
	    img_width.disabled = dis || !resize.checked;
	    img_height.disabled = dis || !resize.checked;
	    img_quality.disabled = dis || !resize.checked;

	    watermark.disabled = dis;
	    watermark_position.disabled = dis || !watermark.checked;
	    watermark_margin.disabled = dis || !watermark.checked;

	    watermark_file.disabled = dis || !watermark.checked;
	    watermark_file_btn.disabled = dis || !watermark.checked;

	    copyright.disabled = dis || !watermark.checked;
	    copyright_color.disabled = dis || !watermark.checked;
	    copyright_font.disabled = dis || !watermark.checked;
	    copyright_size.disabled = dis || !watermark.checked;
	}
}

function sbPDEChangeResize(el)
{
	var img_width = sbGetE("spin_img_width");
    var img_height = sbGetE("spin_img_height");
    var img_quality = sbGetE("spin_img_quality");

    img_width.disabled = !el.checked;
    img_height.disabled = !el.checked;
    img_quality.disabled = !el.checked;
}

function sbPDEChangeWatermark(el)
{
	var watermark_position = sbGetE("watermark_position");
    var watermark_margin = sbGetE("spin_watermark_margin");

    var watermark_file = sbGetE("watermark_file");
    var watermark_file_btn = sbGetE("watermark_file_button");

    var copyright = sbGetE("copyright");
    var copyright_color = sbGetE("copyright_color");
    var copyright_font = sbGetE("copyright_font");
    var copyright_size = sbGetE("copyright_size");

    watermark_position.disabled = !el.checked;
    watermark_margin.disabled = !el.checked;

    watermark_file.disabled = !el.checked;
    watermark_file_btn.disabled = !el.checked;

    copyright.disabled = !el.checked;
    copyright_color.disabled = !el.checked;
    copyright_font.disabled = !el.checked;
    copyright_size.disabled = !el.checked;
}

function sbPDEChangeTable()
{
	var table = sbGetE("last_tr").parentNode;
    var html = "";

    var rows = parseInt(sbGetE("spin_table_rows").value);
    var colls = parseInt(sbGetE("spin_table_colls").value);
    var rows_vals = sbPDEGetOldValues("row");
    var colls_vals = sbPDEGetOldValues("coll");

    sbPDETableClean(table);
    for(i = 0; i < rows; i++)
    {
    	if(rows_vals[i])
        	value = rows_vals[i];
		else
        	value = "";
        sbPDEAddInp("row", value, i+1);
	}

	if(rows == 0)
		sbGetE("rows_delim").style.display = "none";
	else if(rows > 0)
		sbGetE("rows_delim").style.display = "";

    if(colls > 0)
    	sbPDEAddDelim();

	for(i = 0; i < colls; i++)
    {
    	if(colls_vals[i])
        	value = colls_vals[i];
        else
        	value = "";
        sbPDEAddInp("coll", value, i + 1);
    }
}

function sbPDETableClean(el)
{
	var table = sbGetE("last_tr").parentNode;
    var old_trs = el.getElementsByTagName("tr");
    for (var i = 0; i < old_trs.length; i++)
    {
    	if(old_trs[i].getAttribute("class") == "custom_tr")
        {
 			table.removeChild(old_trs[i]);
 			sbPDETableClean(el);
 			return false;
		}
	}
	var delim = sbGetE("custom_delim");
	if(delim)
		delim.parentNode.removeChild(delim);
}

function sbPDEAddInp(type, value, num)
{
	var table = sbGetE("last_tr").parentNode;
    if(type == "row")
    {
    	var txt = "<?php echo PL_PLUGIN_DATA_FIELD_TABLE_ROWS_NAMES ?>";
        var name = "table_rows_name[]"
    }
    if(type == "coll")
    {
    	var txt = "<?php echo PL_PLUGIN_DATA_FIELD_TABLE_COLLS_NAMES ?>";
        var name = "table_colls_name[]"
    }
    var tr = document.createElement("tr");
    tr.setAttribute("class","custom_tr");
    var td1 = document.createElement("th");
    td1.setAttribute("width","200");
    var td1_cap = document.createTextNode(txt+num);
    var td2 = document.createElement("td");
    td2.setAttribute("width","100%");
    var input = document.createElement("input");
    input.setAttribute("type","text");
    input.setAttribute("name",name);
    input.setAttribute("value",value);
    input.setAttribute("style","width: 480px;");

    td1.appendChild(td1_cap);
    tr.appendChild(td1);
    td2.appendChild(input);
    tr.appendChild(td2);
    table.appendChild(tr);
}

function sbPDEAddDelim()
{
	var table = sbGetE("last_tr").parentNode;
    var tr = document.createElement("tr");
    tr.setAttribute("id","custom_delim");
    var td = document.createElement("td");
    td.setAttribute("class","delim");
    td.setAttribute("colspan","2");
    tr.appendChild(td);
    table.appendChild(tr);
}

function sbPDEGetOldValues(type)
{
	var table = sbGetE("last_tr").parentNode;
    var ret_arr = [];
    var form = sbGetE("main");
    if(type == "row")
    	var name = "table_rows_name[]";
    if(type == "coll")
    	var name = "table_colls_name[]";
    var childs = form.getElementsByTagName("input");
    for(i = 1; i <= childs.length; i++)
    {
    	if(childs[i] && childs[i].getAttribute("name") == name)
        {
        	ret_arr.push(childs[i].value);
        }
     }
     return ret_arr;
}

function sbPDETypeChengeInit()
{
	var row_up = sbGetE("table_cell_type");
	sbAddEvent(row_up, "change", sbPDEAddTypeSettings);
	sbPDEAddTypeSettings();
}

function sbPDEAddTypeSettings()
{
	sbPDEHideTableSettings();
    type = sbGetE("table_cell_type").value;
    switch (type)
    {
    	case "string":
    		sbGetE("table_cell_string_width").style.display = "table-row";
    		sbGetE("table_cell_string_max").style.display = "table-row";
	    	sbGetE("table_cell_string_min").style.display = "table-row";
    	break;

	    case "num":
	    	sbGetE("table_cell_mum_width").style.display = "table-row";
	    	sbGetE("table_cell_num_max").style.display = "table-row";
			sbGetE("table_cell_num_min").style.display = "table-row";
			sbGetE("table_cell_num_inc_hint").style.display = "table-row";
			sbGetE("table_cell_num_inc").style.display = "table-row";
			sbGetE("table_cell_num_def").style.display = "table-row";
		break;

    	case "color":
    		sbGetE("table_cell_color_def").style.display = "table-row";
    		sbGetE("table_cell_color_allow").style.display = "table-row";
    	break;

    	case "check":
    		sbGetE("table_cell_check_def").style.display = "table-row";
    	break;

    	case "date":
    		sbGetE("table_cell_date_def").style.display = "table-row";
    		sbGetE("table_cell_date_show_time").style.display = "table-row";
	    	sbGetE("table_cell_date_allow").style.display = "table-row";
    	break;
	}
}

function sbPDEHideTableSettings()
{
	sbGetE("table_cell_string_width").style.display = "none";
	sbGetE("table_cell_string_max").style.display = "none";
	sbGetE("table_cell_string_min").style.display = "none";
	sbGetE("table_cell_mum_width").style.display = "none";
	sbGetE("table_cell_num_max").style.display = "none";
	sbGetE("table_cell_num_min").style.display = "none";
	sbGetE("table_cell_num_inc_hint").style.display = "none";
	sbGetE("table_cell_num_inc").style.display = "none";
	sbGetE("table_cell_num_def").style.display = "none";
	sbGetE("table_cell_color_def").style.display = "none";
	sbGetE("table_cell_color_allow").style.display = "none";
	sbGetE("table_cell_check_def").style.display = "none";
	sbGetE("table_cell_date_def").style.display = "none";
	sbGetE("table_cell_date_allow").style.display = "none";
	sbGetE("table_cell_date_show_time").style.display = "none";
}

function sbPDEBrowseGroups(id,ident)
{
	var el = sbGetE("rights_set");
	if (!el || !el.checked)
		return;

	group_ident = ident;
	var group_ids = sbGetE(id).value;

	var strPage = "<?php echo SB_CMS_MODAL_DIALOG_FILE ?>?event=pl_users_get_groups_print&sel_ids="+group_ids;
	var strAttr = "resizable=1,width=500,height=500";
	if(id == "rights_view_list_ids")
	{
		sbShowModalDialog(strPage, strAttr, sbPDEAfterBrowseUsersView);
	}
	else if(id == "rights_edit_list_ids")
	{
		sbShowModalDialog(strPage, strAttr, sbPDEAfterBrowseUsersEdit);
	}
}

function sbPDEAfterBrowseUsersView()
{
	if (sbModalDialog.returnValue)
	{
		var group_ids = sbGetE('rights_view_list_ids');
	    var group_names = sbGetE('rights_view_list');

	    group_ids.value = sbModalDialog.returnValue.ids;
	    group_names.value = sbModalDialog.returnValue.text;
	}
	group_ident = "";
}

function sbPDEAfterBrowseUsersEdit()
{
	if (sbModalDialog.returnValue)
	{
		var group_ids = sbGetE('rights_edit_list_ids');
	    var group_names = sbGetE('rights_edit_list');

	    group_ids.value = sbModalDialog.returnValue.ids;
	    group_names.value = sbModalDialog.returnValue.text;
	}
	group_ident = "";
}

function sbPDEDropGroups(id, ident)
{
	var group_names = sbGetE(id);
	if (!group_names || group_names.disabled)
		return;

	var group_ids = sbGetE(id+"_ids");

	group_ids.value = "";
	group_names.value = "";
}

function sbPDEChangeType(el)
{
	var view = sbGetE("rights_view_list");
	var view_ids = sbGetE("rights_view_list_ids");
	var edit = sbGetE("rights_edit_list");
	var edit_ids = sbGetE("rights_edit_list_ids");

    if (el.checked)
    {
    	view.disabled = false;
    	if (edit)
        	edit.disabled = false;
	}
    else
    {
    	view.disabled = true;
        view.value = "";
        view_ids.value = "";

        if (edit)
        {
	        edit.disabled = true;
	        edit.value = "";
	        edit_ids.value = "";
	    }
    }
}

<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>