<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>

function sbDeleteResult(id, option_id)
{
	if(confirm("<?php echo POLLS_CONFIRM_DELETE; ?>"))
	{
		if(id == "all")
		{
			sbLoadAsync(sb_cms_empty_file + "?event=pl_polls_delete_result&poll_id="+option_id+"&all=1", afterLoadDeleteResult);
			sbGetE("polls_graph").style.display = "none";
			sbGetE("save_graph").style.display = "none";
		}
	}
}

function afterLoadDeleteResult(res)
{
	var table = sbGetE("variant_table");
	table = table.tBodies[0];

	var count = table.rows.length;
	var t = count-1;

	while(t >= 0)
	{
		if(table.rows[t].id != "last_tr")
		{
			var curRow = sbGetE(table.rows[t].id);
			table.removeChild(curRow);
		}
		t--;
	}

	if(table.rows.length == 1)
	{
		var tr = document.createElement("TR");
		tr.id = "msg";
		td = document.createElement("TD");
		td.setAttribute("colSpan", 5);
		td.align = "center";
		td.innerHTML = "<div class=\'hint_div\'><?php echo POLLS_EDIT_NO_RESULTS; ?></div>";
		tr.appendChild(td);

		if(table)
		{
			table.insertBefore(tr, sbGetE("last_tr"));
		}
	}
}

function checkValues(edit_group)
{
	if(edit_group)
		return;

	if (window.sbCodeditor_sp_question)
	{
		var el_question = sbCodeditor_sp_question.getCode();
    }
	else
	{
		var el_question = sbGetE("sp_question").value;
	}

    if (!el_question)
    {
    	alert("<?php echo POLLS_EDIT_NO_TITLE_MSG;?>");
        return false;
	}
}

_sbPDPreventNsDrag = function (e, call)
{
	if(e && e.preventDefault)
    {
    	e.preventDefault();
        return false;
	}
    return false;
}

sbPDDraggingEl = null;
sbPDOverEl = null;
sbPDTempOverEvent = new Array();

sbPDSetBorder = function(el, border)
{
	if(el)
    {
    	var childs = el.childNodes;
        for(var i = 0; i < childs.length; i++)
        {
        	if(childs[i].tagName == "TD")
            {
            	if (_isIE)
                	childs[i].style.borderTop = "1px solid " + border;
				else
                	childs[i].style.borderTop = "1px solid " + border;
			}
		}
	}
}

sbPDChangeRowClass = function(el_id, cls)
{
	var el_tr = sbGetE(el_id);
    if (el_tr)
    {
    	if (!cls)
        {
        	if (_isIE)
            	el_tr.setAttribute("className", el_tr.getAttribute("oldClassName"));
			else
            	el_tr.setAttribute("class", el_tr.getAttribute("oldClassName"));
		}
		else
        {
			if (_isIE)
            {
				if (el_tr.getAttribute("className") != "drag")
				{
					el_tr.setAttribute("oldClassName", el_tr.getAttribute("className"));
				}
			}
            else
            {
				if (el_tr.getAttribute("class") != "drag")
                {
                	el_tr.setAttribute("oldClassName", el_tr.getAttribute("class"));
				}
		    }

			if (_isIE)
            	el_tr.setAttribute("className", cls);
			else
				el_tr.setAttribute("class", cls);
		}
	}
}

        sbPDStartDrag = function(e, el)
        {
            sbAddEvent(document, "mousemove", sbPDDrag);
            sbAddEvent(document, "mouseup", sbPDStopDrag);

            if (sbPDDraggingEl && sbPDDraggingEl != el)
                sbPDChangeRowClass(sbPDDraggingEl.id, null);

            sbPDChangeRowClass(el.id, "drag");
            sbPDDraggingEl = el;

            if(_isIE)
            {
                window.document.body.setCapture();
            }
            else
            {
                if (window.parent.frames)
                {
                    for(var i=0; i < window.parent.frames.length; i++)
                    {
                        if(window.parent.frames[i] != window)
                        {
                            sbPDTempOverEvent[sbPDTempOverEvent.length] = window.parent.frames[i].onmouseover;
                            window.parent.frames[i].onmouseover = sbPDStopDrag;
                        }
                    }
                }
            }
        }

        sbPDDrag = function(e)
        {
            if (!sbPDDraggingEl)
            {
                sbPDOverEl = null;
                return;
            }
        
            var el = sbEventTarget(e);
            if (!el)
                return;
        
            while(el && el.tagName != "TR")
                el = el.parentNode;
        
            if (!el)
                return;

            var table = el;
            while(table.tagName != "TABLE")
                table = table.parentNode;

            if (table.id != "pl_polls_answer_table")
                return;

            var first_tr = table.tBodies[0].childNodes[0];

            var tab = sbGetE("sb_tabs_con");
            var a1=sbGetAbsoluteTop(el);
            var a2=sbGetAbsoluteTop(tab);

            if(a1-a2-parseInt(tab.scrollTop)>parseInt(tab.offsetHeight)-50)
                tab.scrollTop=parseInt(tab.scrollTop)+30;
            if(a1-a2 < parseInt(tab.scrollTop)+30)
                tab.scrollTop=parseInt(tab.scrollTop)-30;

            if (el == sbPDDraggingEl || el == sbPDDraggingEl.nextSibling || el == first_tr)
            {
                sbPDSetBorder(sbPDOverEl, "#FFF5E0");
                sbPDOverEl = null;
                return;
            }

            sbPDSetBorder(sbPDOverEl, "#FFF5E0");
            sbPDSetBorder(el, "black");
            sbPDOverEl = el;
        }

        sbPDStopDrag = function(e)
        {
            if(_isIE)
            {
                window.document.body.releaseCapture();
            }
            else
            {
                if (window.parent.frames)
                {
                    for(var i=0; i < window.parent.frames.length; i++)
                    {
                        if(window.parent.frames[i] != window)
                        {
                            window.parent.frames[i].onmouseover = sbPDTempOverEvent.shift();
                        }
                    }
                }
            }

            sbRemoveEvent(document, "mousemove", sbPDDrag);
            sbRemoveEvent(document, "mouseup", sbPDStopDrag);

            if (!sbPDDraggingEl || !sbPDOverEl)
                return;

			sbPDSetBorder(sbPDOverEl, "#FFF5E0");

            var table = sbGetE("pl_polls_answer_table");
            table = table.tBodies[0];
            table.insertBefore(sbPDDraggingEl, sbPDOverEl);

	for (var i = 1; i < table.rows.length; i++)
	{
		if (i % 2 == 0)
        {
        	if (_isIE)
            	table.rows[i].setAttribute("className", "even");
			else
            	table.rows[i].setAttribute("class", "even");
			table.rows[i].setAttribute("oldClassName", "even");
		}
		else
		{
            if (_isIE)
            	table.rows[i].removeAttribute("className");
			else
            	table.rows[i].removeAttribute("class");
			table.rows[i].removeAttribute("oldClassName");
		}
	}

	sbPDDraggingEl = null;
	sbPDOverEl = null;
	resortAll();
}

var lastSortPosition = 0;
var editingAnswerId = -1;

function editAnswerClick(answer_id)
{
	var el_type = sbGetE("type_variant");

	var cur_type = sbGetE("sp_polls_" + answer_id + "_type");
	var cur_answer = sbGetE("sp_polls_" + answer_id + "_answer_text");

	editingAnswerId = answer_id;

	var cancelButton = sbGetE("answerCancelButton");
	var addButton = sbGetE("answerAddButton");

	addButton.innerHTML = "<?php echo POLLS_EDIT_EDIT_ANSWER; ?>";
	cancelButton.style.display = "inline";

	if (window.sbCodeditor_new_answer)
	{
		sbCodeditor_new_answer.setCode(cur_answer.innerHTML);
    }
    else
	{
		var el_answer = sbGetE("new_answer");
		el_answer.value = cur_answer.innerHTML;
    }

	for(var i = 0; i < el_type.length; i++)
	{
		if(el_type[i].value == cur_type.value)
		{
			el_type[i].selected = "selected";
		}
	}

	window.scrollTo(0, 0);
	return false;
}

sbPDAddTr = function(id, answer, type, type_label)
{
	var table = sbGetE("pl_polls_answer_table");
	var null_tr = sbGetE("null_tr");

	if (!table || !null_tr)
		return;

	if (null_tr.className != "")
	{
		var cls = "even";
		if (_isIE)
                    null_tr.removeAttribute("className");
		else
			null_tr.removeAttribute("class");
	}
	else
	{
                var cls = "";
                null_tr.className = "even";
            }
            var tr = document.createElement("TR");

            tr.setAttribute("id", id);
            if (_isIE)
                tr.setAttribute("className", cls);
            else
                tr.setAttribute("class", cls);
            tr.style.cursor = "default";
            if(_isIE)
            {
		tr.setAttribute("onmousedown", function(){sbPDStartDrag(event, this)});
            }
            else
            {
		tr.setAttribute("onmousedown", "sbPDStartDrag(event, this)");
            }

            // Первая ячейка
            var td1 = document.createElement("TD");
            
            var icon_src = "";
            if(type == "checkbox")
            {
		icon_src = "/data_types/checkbox.gif";
	}
            else if(type == "radio")
            {
		icon_src = "/data_types/radio_sprav.gif";
	}
	else if (type == "text")
	{
		icon_src =  "/data_types/string.gif";
	}
	else if (type == "group")
	{
		icon_src =  "/data_types/tab.gif";
	}

            td1.innerHTML = "<img id=\'img_type"+ id +"\' src=\'<?php echo SB_CMS_IMG_URL; ?>"+icon_src+"\'\'><textarea style=\'width:1px;height:1px;visibility:hidden;\' id=\'sp_polls_" + id + "_answer\' name=\'sp_polls_" + id + "_answer\' onmousedown=\'_sbPDPreventNsDrag(event, true);\' ondragstart=\'_sbPDPreventNsDrag(event);\'>"+answer+"</textarea><input type=\'hidden\' name=\'sp_polls[]\' id=\'sp_polls_" + id + "_id\' value=\'" + id + "\'>";
            td1.align = "center";
            td1.style.verticalAlign = "middle";
            td1.style.width = "5px";
            td1.style.borderTop = "1px solid FFF5E0";
            tr.appendChild(td1);

	// тип варианта ответа
            var td2 = document.createElement("TD");
            td2.align = "center";
	td2.style.verticalAlign = "middle";
	td2.style.borderTop = "1px solid FFF5E0";
	td2.style.width = "150px";
	td2.innerHTML = "<div id=\'sp_polls_" + id + "_type_answer\'>" + type_label + "</div>";
	tr.appendChild(td2);
	
	// Вариант ответа
	var td3 = document.createElement("TD");
	td3.style.verticalAlign = "middle";
	td3.align = "center";
	td3.style.borderTop = "1px solid FFF5E0";
	td3.innerHTML = "<span id=\'sp_polls_" + id + "_answer_text\'>" + answer + "</span>";
            tr.appendChild(td3);

            // Редактировать
            var td4 = document.createElement("TD");
            td4.align = "center";
            td4.style.verticalAlign = "middle";
            td4.style.borderTop = "1px solid FFF5E0";
            td4.style.width = "30px";
            td4.innerHTML = "<img src=\'/cms/images/btn_props.png\' title=\'<?php echo POLLS_EDIT_PROPS_LABEL; ?>\' onmousedown=\'_sbPDPreventNsDrag(event, true);\' ondragstart=\'_sbPDPreventNsDrag(event);\' onclick=\'return editAnswerClick(" + id + ");\' style=\'cursor: pointer;\' width=\'20\' border=\'0\' height=\'20\'>";
            tr.appendChild(td4);

	// Удалить
	var td5 = document.createElement("TD");
	td5.align = "center";
	td5.style.verticalAlign = "middle";
	td5.style.borderTop = "1px solid FFF5E0";
	td5.style.width = "30px";
	td5.innerHTML = "<img src=\'/cms/images/btn_delete.png\'  title=\'<?php echo POLLS_EDIT_DEL_LABEL; ?>\' onmousedown=\'_sbPDPreventNsDrag(event, true);\' ondragstart=\'_sbPDPreventNsDrag(event);\' onclick=\'deleteAnswerClick(" + id + ");\' style=\'cursor: pointer;\' width=\'20\' height=\'20\'><input type=\'hidden\' name=\'sp_polls_" + id + "_order\' id=\'sp_polls_" + id + "_order\' value=\'"+lastSortPosition+"\'><input type=\'hidden\' name=\'sp_polls_" + id + "_type\' id=\'sp_polls_" + id + "_type\' value=\'"+type+"\'>";
	tr.appendChild(td5);

	var el = table.tBodies[0];
	if(el)
	{
		el.insertBefore(tr, null_tr);
	}
        }

function addAnswerClick()
{
	if (editingAnswerId == -1)
            {
            //  добавление варианта ответа
            if (window.sbCodeditor_new_answer)
            {
            var el_answer = sbCodeditor_new_answer.getCode();
            }
            else
            {
			var el_answer = sbGetE("new_answer").value;
            }

		var el_type = sbGetE("type_variant");
		if (el_type.value == "")
		{
			sbShowMsgDiv("<?php echo POLLS_EDIT_NO_ANSWER_TYPE; ?>", "warning.png");
			return false;
		}

                if (!el_answer)
                {
			if(el_type.value == "group")
				sbShowMsgDiv("<?php echo POLLS_EDIT_NO_ANSWER_TEXT_GROUP; ?>", "warning.png");
			else
				sbShowMsgDiv("<?php echo POLLS_EDIT_NO_ANSWER_TEXT; ?>", "warning.png");
			
			return false;
                }

		var el_type = sbGetE("type_variant");
		var newId = new Number(new Date());

		lastSortPosition++;

		var type = "";
		for(var r = 0; r < el_type.length; r++)
		{
			if(el_type[r].selected)
			{
				type = el_type[r].innerHTML;
			}
		}

		sbPDAddTr(newId, el_answer, el_type.value, type);
            if (window.sbCodeditor_new_answer)
            {
            sbCodeditor_new_answer.setCode("");
            }
            else
            {
            sbGetE("new_answer").value = "";
            }
		return false;
            }
            else
            {
                //изменение ответа
                var prevRow = sbGetE(editingAnswerId);
		if (prevRow)
		{
			if (window.sbCodeditor_new_answer)
            {
				var el_answer = sbCodeditor_new_answer.getCode();
            }
            else
            {
				var el_answer = sbGetE("new_answer").value;
            }

			var el_type = sbGetE("type_variant");

			var el_cur_answer = sbGetE("sp_polls_" + editingAnswerId + "_answer");
			var el_cur_answer_text = sbGetE("sp_polls_" + editingAnswerId + "_answer_text");

			var el_cur_type_answer = sbGetE("sp_polls_" + editingAnswerId + "_type_answer");
			var el_cur_type = sbGetE("sp_polls_" + editingAnswerId + "_type");

			var img = sbGetE("img_type"+editingAnswerId);
			
			editingAnswerId = -1;

			var cancelButton = sbGetE("answerCancelButton");
			var addButton = sbGetE("answerAddButton");

			addButton.innerHTML = "<?php echo KERNEL_ADD; ?>";
			cancelButton.style.display = "none";

			el_cur_answer.value = el_answer;
			el_cur_answer_text.innerHTML = el_answer;

			for(var i = 0; i < el_type.length; i++)
			{
				if(el_type[i].selected)
				{
					el_cur_type.value = el_type[i].value;
					el_cur_type_answer.innerHTML = el_type[i].innerHTML;

					var src_str = "";
					switch(el_type[i].value)
					{
						case "checkbox":
							src_str = "/data_types/checkbox.gif";
							break;
						case "radio":
							src_str = "/data_types/radio_sprav.gif";
							break;
						case "text":
							src_str = "/data_types/string.gif";
							break;
						case "group":
							src_str = "/data_types/tab.gif";
							break;
					}
					img.src = "<?php echo SB_CMS_IMG_URL; ?>"+src_str;
				}
			}

			if(window.sbCodeditor_new_answer)
            {
				sbCodeditor_new_answer.setCode("");
            }
            else
            {
            	sbGetE("new_answer").value = "";
            }

			el_type[0].selected = "selected";
                }
            }
            return false;
        }

function deleteAnswerClick(answer_id)
{
            // определить строку в таблице
            var curRow = sbGetE(answer_id);
            curRow.removeNode(curRow);

	var table = sbGetE("pl_polls_answer_table");
	for (var i = 1; i < table.rows.length; i++)
	{
            if (i % 2 == 0)
            {
                if (_isIE)
				table.rows[i].setAttribute("className", "even");
                else
				table.rows[i].setAttribute("class", "even");
			table.rows[i].setAttribute("oldClassName", "even");
		}
		else
		{
			if (_isIE)
                    table.rows[i].removeAttribute("className");
                else
                    table.rows[i].removeAttribute("class");
                table.rows[i].removeAttribute("oldClassName");
            }
	}

	//Пересортировать все
	resortAll();
        }

        function resortAll()
        {
            var els = document.getElementsByName("sp_polls[]");
            if (els)
            {
                for (var i = 0; i < els.length; i++)
                {
                    var curPos = sbGetE("sp_polls_" + els[i].value + "_order");
                    curPos.value = parseInt(i + 1);
                }
            }
	lastSortPosition = els.length;
        }

        function cancelClick()
        {
	var el_type = sbGetE("type_variant");

	editingAnswerId = -1;

	var cancelButton = sbGetE("answerCancelButton");
	var addButton = sbGetE("answerAddButton");

	addButton.innerHTML = "<?php echo KERNEL_ADD; ?>";
	cancelButton.style.display = "none";

	if (window.sbCodeditor_new_answer)
	{
		sbCodeditor_new_answer.setCode("");
        }
        else
	{
		sbGetE("new_answer").value = "";
    }

	el_type[0].selected = "selected";

	return false;
}

function sbShowResult(id)
{
	var strPage = sb_cms_modal_dialog_file + "?event=pl_polls_show_result&id="+id;
	var strAttr = "resizable=1,width=850,height=630";
	sbShowModalDialog(strPage, strAttr, afterShowResult);
}

function afterShowResult()
{
	if(sbModalDialog.returnValue)
	{
		var res = sbLoadSync("<?php echo SB_CMS_EMPTY_FILE; ?>?event=pl_polls_stat&id=" + sbModalDialog.returnValue.spr_id);
		if(res && res != "")
		{
			var table = sbGetE("pl_polls_variant_table");
			table.innerHTML = res;

			if(sbModalDialog.returnValue.changed == "1")
				reload_graph();
		}
	}
}

function findSWF(movieName)
{
  	if (navigator.appName.indexOf("Microsoft")!= -1) 
  	{
    	return document.forms[0][movieName];
  	}
  	else
  	{
    	return document[movieName];
  	}
}

function after_save_graph(str)
{
	if (str == "FALSE")
	{
		alert("<?php echo POLLS_EDIT_IMG_SAVE_ERROR; ?>");
		return;
	}

	window.open("<?php echo SB_CMS_EMPTY_FILE; ?>?event=pl_kernel_download_graph_image&image=" + str);
}

function save_graph(el_id)
{
	var graph = findSWF(el_id);
	sbPostAsync("<?php echo SB_CMS_EMPTY_FILE; ?>?event=pl_kernel_upload_graph_image", graph.get_img_binary(), after_save_graph, "application/octet-stream");
}

function changeActive(el)
{
                var pub_s = sbGetE("sp_pub_start");
                var pub_e = sbGetE("sp_pub_end");
  
                pub_s.disabled = !el.checked;
                pub_e.disabled = !el.checked;
                
                pub_s.value = "";
                pub_e.value = "";
}

function changeDescr(val)
{
	var el = sbGetE("desrc_type_opt");
	if(val == "radio")
	{
		el.innerHTML = "<?php echo POLLS_TYPE_MSG_RADIO; ?>";
	}
	else if(val == "checkbox")
	{
		el.innerHTML = "<?php echo POLLS_TYPE_MSG_CHECKBOX; ?>";
	}
	else if (val == "text")
	{
		el.innerHTML = "<?php echo POLLS_TYPE_MSG_TEXT; ?>";
	}
	else if (val == "group")
	{
		el.innerHTML = "<?php echo POLLS_TYPE_MSG_GROUP; ?>";
	}
}

function sbPollsExportResults(c, id)
{
	var args = new Object();

	var strPage = "<?php echo SB_CMS_DIALOG_FILE; ?>?event=pl_export_edit&ident=pl_polls_results&cat_id="+ c + "&id="+id;
	var strAttr = "resizable=1,width=700,height=600";
	sbShowModalDialog(strPage, strAttr, null, args);
}

<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>