<?php require_once(dirname(__FILE__).'/jheader.inc.php');?>
function sbSetSpin()
{
    var inp_els = document.getElementsByTagName("INPUT");
    var els = [];
    for (var i=0; i < inp_els.length; i++)
    {
        var el = inp_els[i];
        if (el.id && el.type == 'text' && el.id.indexOf('spin_') == 0 && el.getAttribute("spin") != 1)
            els[els.length] = el;
    }

    for (i = 0; i < els.length;i++)
    {
        var id = els[i].id.substr(5);

        els[i].setAttribute("spin", 1);
        if (!els[i].getAttribute("min_value"))
            els[i].setAttribute("min_value", -1000000000000);
        if (!els[i].getAttribute("max_value"))
            els[i].setAttribute("max_value", +1000000000000);
        if (!els[i].getAttribute("incr"))
            els[i].setAttribute("incr", "1");

        els[i].style.textAlign='center';
        sbAddEvent(els[i], "change", sbChangeValue);
        sbAddEvent(els[i], "focus", sbSpinFocused);
        sbAddEvent(els[i], "blur", sbSpinBlur);

        var par = els[i].parentNode;

        var table = document.createElement('table');
        table.border=0;
        table.cellPadding=0;
        table.cellSpacing=0;
        var tbody = document.createElement('tbody');
        var tr = document.createElement('tr');
        tr.style.backgroundColor = "transparent";
        var td1 = document.createElement('td');
        td1.style.padding='0px';
        var td2 = document.createElement('td');
        td2.style.padding='0px';
        td2.style.paddingLeft="2px";
        var img1 = document.createElement('img');
        img1.src='/cms/images/up.gif';
        img1.width=9;
        img1.height=9;
        img1.align='absmiddle';
        img1.onmousedown=sbChangeSpin;
        img1.id=id+"_up";
        var br=document.createElement('br');
        var img2 = document.createElement('img');
        img2.src='/cms/images/down.gif';
        img2.width=9;
        img2.height=9;
        img2.align='absmiddle';
        img2.onmousedown=sbChangeSpin;
        img2.id=id+"_dn";
        td2.appendChild(img1);
        td2.appendChild(br);
        td2.appendChild(img2);
        td1.appendChild(els[i]);
        tr.appendChild(td1);
        tr.appendChild(td2);
        tbody.appendChild(tr);
        table.appendChild(tbody);
        par.appendChild(table);
    }
}

var sbSpinChangeEl=null;
var sbSpinChangeSpeed=500;
function sbChangeSpin(e)
{
    if (!e) e = window.event;
    var i_el = sbEventTarget(e);
    var el = sbGetE('spin_'+i_el.id.substr(0, i_el.id.length - 3));
    if (el.disabled || el.getAttribute("readonly"))
        return;

    if (i_el.id.substr(i_el.id.length - 3) == '_up')
        var sign = "+";
    else
        var sign = "-";

    sbSpinChangeEl = el;
    _sbChangeSpin(sign);
    sbAddEvent(document,'mouseup',_sbStopSpin);
    setTimeout("_sbChangeSpin('"+sign+"')", sbSpinChangeSpeed);
}
function _sbChangeSpin(sign)
{
    if (sbSpinChangeEl)
    {
        sbChangeValue(null, null, sign);
        sbSpinChangeSpeed = Math.max(50, sbSpinChangeSpeed-5);
        setTimeout("_sbChangeSpin('"+sign+"')", sbSpinChangeSpeed);
    }
}
function _sbStopSpin()
{
    sbSpinChangeEl = null;
    sbSpinChangeSpeed = 250;
    sbRemoveEvent(document, 'mouseup', _sbStopSpin);
}
function sbChangeValue(e, wheel_pos, sign)
{
    if (!sbSpinChangeEl)
        return;

    var max = parseFloat(sbSpinChangeEl.getAttribute("max_value"));
    var min = parseFloat(sbSpinChangeEl.getAttribute("min_value"));

    if (sbSpinChangeEl.value == "" && e != null && typeof(wheel_pos) == "undefined")
    {
        return;
    }
    else if (sbSpinChangeEl.value == "")
    {
        sbSpinChangeEl.value = Math.max(0, min);
    }

    var val = parseFloat(sbSpinChangeEl.value.replace(/,/, "."));
    var float_pow = 0;
    var incr = sbSpinChangeEl.getAttribute("incr");
    if (!isNaN(incr))
    {
        var dot_pos = incr.indexOf(".");
        if (dot_pos != -1)
        {
            incr = new String(parseFloat(incr));
            dot_pos = incr.indexOf(".");
            float_pow =  incr.length - dot_pos - 1;
        }
    }

    if (typeof(sign) == "undefined" && isNaN(wheel_pos))
    {
        var incr = 0;
    }
    else
    {
        if (isNaN(incr))
        {
            incr = 1;
        }
        else
        {
            if (typeof(sign) == "undefined" || sign == "+")
                incr = parseFloat(incr);
            else
                incr = -parseFloat(incr);
        }
    }

    if (wheel_pos != null && typeof(wheel_pos) != "undefined" && !isNaN(wheel_pos))
    {
        val = val + incr * wheel_pos;
    }
    else
    {
        val = val + incr;
    }

    if(val < min)
        val = min;
    if(val > max)
        val = max;

    val = new String(float_pow != 0 ? Math.round(Math.pow(10, float_pow)*val)/Math.pow(10, float_pow) : parseInt(val));
    if (float_pow != 0)
    {
        dot_pos = val.indexOf(".");
        if (dot_pos != -1)
        {
        	var signs = val.length - dot_pos - 1;
        	for (var i = 0; i < float_pow - signs; i++)
            	val += "0";
        }
    }

    sbSpinChangeEl.value = val;
    if (sbSpinChangeEl && typeof(sbSpinChangeEl.onchange) != "undefined" && sbSpinChangeEl.onchange)
        sbSpinChangeEl.onchange();
}

function sbSpinFocused(e)
{
    var e = e ? e : window.event;
    var el = sbEventTarget(e);
    if (!el)
        return;

    sbSpinChangeEl = el;

    sbAddEvent(window, 'DOMMouseScroll', sbSpinWheel);
    sbAddEvent(document, 'mousewheel', sbSpinWheel);

    return sbCancelEvent(e);
}

function sbSpinBlur(e)
{
    if (sbSpinChangeEl == null)
        return;

    sbRemoveEvent(window, 'DOMMouseScroll', sbSpinWheel);
    sbRemoveEvent(document, 'mousewheel', sbSpinWheel);

    if (sbSpinChangeEl.value != "")
    {
    	sbSpinChangeEl.value = parseFloat(sbSpinChangeEl.value);
    	if (isNaN(sbSpinChangeEl.value))
    		sbSpinChangeEl.value = "";
    }

    sbSpinChangeEl = null;

    return sbCancelEvent(e);
}

function sbSpinWheel(e)
{
    var movement = e.detail ? e.detail / -3 : e.wheelDelta/120;
    sbChangeValue(e, movement);

    sbCancelEvent(e);
}

sbAddEvent(window, "load", sbSetSpin);
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>