<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
var sbTabsAr = [];
var sbTabsLoadFunc = null;

if (typeof(sbTabsWaitLoad) == "undefined")
	var sbTabsWaitLoad = 0;

sbTabs = function(name)
{
    this.name = name;
    this.tabItems = [];
    this.width = 0;
    this.height = 0;
    this.imgPath = "img/";

    this.beforeSpace = 2;
    this.spaceWidth = 10;

    this.beforeImages = ["before_n.gif","before_s.gif","before_s.gif"];
    this.beforeImageW = 4;
    this.beforeImageH = 18;

    this.afterImages  = ["after_n.gif","after_s.gif","after_s.gif"];
    this.afterImageW = 4;
    this.afterImageH = 18;

    this.backImages = ["back_n.gif","back_s.gif","back_s.gif"];
    this.blankImage = "blank.gif";

    this.selectedItem = 0;
    this.loadingURL = '';
    this.loadingText = '';
    this.numRows = 0;
    this.clickFunc = null;
    this.tabsLoadFunc = null;
    this.id = "sb_tabs_"+sbTabsAr.length;
	this.disabled = false;
	
    sbTabsAr[sbTabsAr.length] = this;

    return this;
}

sbTabsItems = function(id, i)
{
    this.id = id + "_" + i;
    this.num = i;

    this.title = "";
    this.object = null;
    this.tooltip = "";
    this.row = 0;
    this.showBotton = true;

    return this;
}

var btbpt = sbTabs.prototype;

btbpt.setAutoLoading=function(filePath)
{with(this){
    loadingURL=filePath;
}};

btbpt.addTab = function (title, object, tooltip, showBotton)
{with(this){
    if ( title.charAt(0) == "$" )
    {
        title = title.substring( 1, title.length );
        numRows++;
    }

    var i = tabItems.length;
    tabItems[i] = new sbTabsItems(id, i);
    tabItems[i].title = title;
    tabItems[i].object = object;
    tabItems[i].tooltip = tooltip;
    tabItems[i].row = numRows;
    tabItems[i].showBotton = showBotton;
    tabItems[i].loaded = 0;
}};

btbpt.show = function (obj)
{
    var el = sbGetE("sb_tabs_tabs");
    if (!el)
    {
        setTimeout(new sbCallerFunction(obj.show, obj), 500);
        return;
    }
    else
    {
        obj._show();
    }
}

btbpt._show = function ()
{with(this){ 
    var s = "";

    s += "<div id='" + id + "'" + " class='sbTabsContainer'>";
    s += "<table" + (numRows > 0 ? " width='100%'" : "") + " height='100%' border='0' cellpadding='0' cellspacing='0' class='sbTabsTable' id='"+id+"table'>";

    var curItem, curTabs=this;

    function getBackImage( image, prefix, w, h )
    {
        if ( !image )
            return "";

        var s = "";

        s += "<td id='" + curItem.id + prefix + "' nowrap style='padding:0px; width:" + w + "px; height:" + h + "px; background-repeat: no-repeat; background-image:url(" + curTabs.imgPath + image + ")'>";
        s += "<img src='" + curTabs.blankImage + "' width='" + w + "' height='" + h + "'></td>";

        return s;
    };

    function getSpace( w )
    {
        if ( !w )
            return "";

        return "<td width='" + w + "' nowrap class='sbTabsSpace'><img src='" + curTabs.blankImage + "' width='" + w + "' height='1'></td>";
    };

    function getLabel()
    {
        var s = "";
        s += "<td id='" + curItem.id + "text' width='100%' nowrap align='center' valign='middle' class='sbTabsNormal' style='background-image:url(" + curTabs.imgPath + curTabs.backImages[0] + ");font-size:<?php echo browser_get_platform() == 'Mac' ? '10' : '11'; ?>px;'>" + curItem.title + "</td>";

        return s;
    };

    var curRow = -1;

    for ( var i = 0; i < tabItems.length; i++ )
    {
        curItem = tabItems[i];
        curItem.loaded = (loadingURL == '' ? 1 : 0);
        if ( curItem.row > curRow )
        {
            s += "<tr class='sbTabsTr'><td" + ( height ? " height='" + height + "'" : "" ) + (curItem.row > 0 ? " style='padding-bottom: 1px;'" : "") + "><table border='0' cellpadding='0' cellspacing='0' width='100%' height='100%'><tr>";
            curRow = curItem.row;
        }

        if ( curItem.title == "-" )
        {
            s += "<td id='" + curItem.id + "' style='width:" + spaceWidth + "px;'><img src='" + blankImage + "' width='" + spaceWidth + "' height='1'></td>";
        }
        else
        {
            s += "<td id='" + curItem.id + "' title='" + curItem.tooltip + "' style='" + ( width ? "width:" + width + "px;" : "" ) + (curItem.showBotton? "" : " display: none;") + " class='sbTabsItem'>";
            s += "<table cellpadding='0' cellspacing='0' border='0' width='100%' height='100%'><tr onMouseOver='"+name+".itemOver(" + i + ",1)' onMouseOut='"+name+".itemOver(" + i + ",0)' onClick='"+name+".itemClick(" + i + ")'>";
            s += getSpace( beforeSpace ) + getBackImage( beforeImages[0], 'bimg', beforeImageW, beforeImageH );
            s += getLabel() + getBackImage( afterImages[0], 'aimg', afterImageW, afterImageH );
            s += "</tr></table></td>";
        }

        if ( i == tabItems.length - 1 || tabItems[i+1].row > curRow)
            s += "</tr></table></td></tr>";
    }
    s += "</table></div>";
    
    var el = sbGetE("sb_tabs_tabs");
    el.innerHTML = s;
}};

btbpt.getLabelClass=function(state)
{
    switch(state)
    {
        case 1: return "sbTabsOver";
        case 2: return "sbTabsSelected";
        default: return "sbTabsNormal";
    }
}

btbpt.loadTab = function (i, s)
{with(this){
    if (tabItems[i])
    {
        var tab = sbGetE(tabItems[i].object);
        if (tabItems[i].loaded)
        {
            tab.style.display = ( s ? "" : "none" );
        }
        else if (!s)
        {
            tab.style.display = "none";
        }
        else
        {
            tab.innerHTML = loadingText;
            tab.style.display = "";
            sbLoadAsync(loadingURL+sbGetUrlSymbol(loadingURL)+"tab_id="+escape(i), new sbCallerFunction(this._loadTab, this, i));
        }
    }
}};

btbpt._loadTab = function (el, tabIndex, str)
{with(el){
    var tab=sbGetE(tabItems[tabIndex].object);
    tab.innerHTML = str;
    tabItems[tabIndex].loaded = 1;
    if (typeof(sbTabsTabLoadFunc) == "function")
        sbTabsTabLoadFunc();
}};

btbpt.showTab = function (i)
{with(this){
	var el = sbGetE(tabItems[i].id);
	el.style.display = "";
}};

btbpt.hideTab = function (i)
{with(this){
	var el = sbGetE(tabItems[i].id);
	el.style.display = "none";
}};

btbpt.getTitle = function (itemIndex)
{with(this){
    if (typeof(tabItems[ itemIndex ]) != "undefined")
        return tabItems[ itemIndex ].title;
    else
        return "";    
}};

btbpt.itemClick = function ( itemIndex )
{with(this){
    if ( selectedItem == itemIndex || disabled)
        return ;

    if (typeof(sbTabCheck) == "function")
    {
        if (!sbTabCheck(itemIndex))
            return;
    }
    
    var curItem = tabItems[ itemIndex ], selItem = selectedItem;
    if (typeof(curItem) == "undefined")
        return;

    var curRow = sbGetE(tabItems[itemIndex].id);
    while (curRow && curRow.parentNode && curRow.className != "sbTabsTr")
        curRow = curRow.parentNode;

    if ( !curRow )
    	return;
    	
    selectedItem = -1;
    itemOver(selItem, 0 );
    selectedItem = itemIndex;
    itemOver(selectedItem, 2);
    // меняем местами ряды
    var tbl = sbGetE(id+"table");
    var lastRow = (tbl ? tbl.rows[tbl.rows.length-1] : null);

    if (curRow.className == "sbTabsTr" && lastRow && curRow != lastRow)
    {
        curRow.swapNode(lastRow);
    }

    loadTab(selItem, false);
    loadTab(itemIndex, true);
    
    setTimeout("sbResizeTabs();", 100);

    if (typeof(clickFunc) == "function")
        clickFunc(itemIndex);
}};

btbpt.changeBgImage = function( itemId, image )
{with(this){
    var td = sbGetE(itemId);
    if ( td && image )
    {
        td.style.backgroundImage = "url(" + imgPath + image + ")";
    }
}};

// вызывается при наведении мышки на закладку
btbpt.itemOver = function (itemIndex, over)
{with(this){
    var curItem = tabItems[ itemIndex ];
    if (typeof(curItem) == "undefined")
        return;
    if (selectedItem == itemIndex && over != 2)
        return ;

    changeBgImage( curItem.id + 'bimg', beforeImages[ over ] );
    changeBgImage( curItem.id + 'aimg', afterImages[ over ] );

    var el = sbGetE(curItem.id + "text");
    if (el)
    {
        el.className = getLabelClass(over);
        el.style.backgroundImage = "url(" + imgPath + backImages[ over ] + ")";
    }
}};

sbLoadTabs = function()
{
    if (!sbGetE("sb_tabs_con") || sbTabsWaitLoad > 0)
    {
        setTimeout("sbLoadTabs();", 500);
        return;
    }

    for (var i = 0; i < sbTabsAr.length; i++)
    {
        var selItem = sbTabsAr[i].selectedItem;
        if (typeof(sbTabsAr[i].tabItems) == "undefined" || typeof(sbTabsAr[i].tabItems[ selItem ]) == "undefined")
        {
            selItem = 0;
   		}
   		else if (typeof(sbTabsAr[i].tabItems) != "undefined")
   		{
   			for (var j = 0; j < sbTabsAr[i].tabItems.length; j++)
   			{
   				var tab = sbGetE(sbTabsAr[i].tabItems[j].object);
   				if (tab)
   				{
   					tab.style.display = "none";
   				}
   			}
   		}
   		
        sbTabsAr[i].selectedItem = -1;
        sbTabsAr[i].itemClick(selItem);
    }
    
    sbGetE("sb_tabs_con").style.overflow = "auto";
    
    var tab_el = sbGetE("sb_tabs");
    if (tab_el) tab_el.style.visibility = "visible";
    
    if (typeof(sbTabsLoadFunc) == "function")
        sbTabsLoadFunc();
}

sbResizeTabs = function()
{
    var tab_el = sbGetE("sb_tabs");
    var tab_table = sbGetE("sb_tabs_table");
    var tab_con_el = sbGetE("sb_tabs_con");
    var tab_con_td_el = sbGetE("sb_tabs_con_td");
    var tab_bot_el = sbGetE("sb_tabs_bottom");
    var tab_top_el = sbGetE("sb_tabs_top");
    var tab_tab_el = sbGetE("sb_tabs_tabs");

    var cnt = sbGetE("elems_list");
    
    if (tab_el && tab_con_el && tab_tab_el)
    {
        var h = Math.max(0, parseInt(document.body.clientHeight) - (_isIE ? 65 : 85) - (tab_top_el ? parseInt(tab_top_el.offsetHeight) : 0));
        var con_h = Math.max(0, h - parseInt(tab_tab_el.offsetHeight) - (tab_bot_el ? parseInt(tab_bot_el.offsetHeight) : 0));
        
        tab_el.style.height = h;
        
        tab_con_el.style.height = con_h;
        
        if (cnt)
        {
            tab_table.style.width = parseInt(cnt.offsetWidth) - 50;
            tab_con_el.style.width = parseInt(cnt.offsetWidth) - 50;
        }
        else
        {
            tab_table.style.width = parseInt(document.body.clientWidth) - 50;
            tab_con_el.style.width = parseInt(document.body.clientWidth) - 50;
        }
    }
}

sbAddEvent(window, "load", sbLoadTabs);
sbResizeFuncs[sbResizeFuncs.length]=sbResizeTabs;
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>