<?php
/**
 * Вывод верхнего фрейма системы
 *
 * В данном файле выводится панель инструментов системы, инициализируется меню системы, проверяется
 * соединение с сервером и каждые 15 сек. продлевается пользовательская сессия.
 *
 * @author Казбек Елекоев <elekoev@binn.ru>
 * @version 4.0
 * @package SB_Core
 * @copyright Copyright (c) 2007, OOO "СИБИЭС Групп"
 */

require_once(dirname(__FILE__).'/header.inc.php');
/**
 * Подключение языковых констант
 */
require_once(SB_CMS_LANG_PATH.'/navmenu.lng.php');

/**
 * Старт пользовательской сессии
 */
if(isset($_SESSION['sbAuth'])){
	$_SESSION['sbAuth']->updateSession();
}
 
if ($_SESSION['sbAuth']->mError != '')
{
    sb_exit($_SESSION['sbAuth']->mError);
}

$GLOBALS['sbVfs']->mFileMode = octdec(sbPlugins::getSetting('sb_file_rights'));
$GLOBALS['sbVfs']->mDirMode = octdec(sbPlugins::getSetting('sb_folder_rights'));

echo '
    <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
    <html>
    <head>
        <title></title>
        <meta http-equiv="Content-Type" content="text/html; charset='.SB_CHARSET.'">
        <meta http-equiv="Content-Script-Type" content="text/javascript">
        <style type="text/css">
        img
        {
            behavior: url("'.SB_CMS_JSCRIPT_URL.'/sbFixPng.htc.php");
        }
        </style>
        <link rel="stylesheet" href="'.SB_CMS_CSS_URL.'/sbNavmenu.css"></link>
        <script src="'.SB_CMS_JSCRIPT_URL.'/sbFunctions.js.php"></script>
        <script src="'.SB_CMS_JSCRIPT_URL.'/sbNavmenu.js.php"></script>
        <script src="'.SB_CMS_JSCRIPT_URL.'/sbMainMenuEvents.js.php"></script>
        <script src="'.SB_CMS_JSCRIPT_URL.'/sbAJAX.js.php"></script>
        <script>
            var sb_cms_empty_file = "'.SB_CMS_EMPTY_FILE.'";
            
            var numErrors = 0;
            var wasReported = false;
            var erStr = "";
            function sbReportUserStatus()
            {
                sbLoadAsync("'.SB_CMS_EMPTY_FILE.'?event=user_status", sbReportUserStatusHelper);
            }
            
            function sbReportUserStatusHelper(res)
            {
                var error = "";
                if (res)
                {
                    error = res.substr(0, 2);
                    var params = res.split("^");
                }
                
                if (error != "OK")
                {
                    if (res)
                    {
                        if (res != erStr)
                        {
                            alert("'.NAVMENU_ERROR.': " + res);
                            erStr = res;
                        }
                    }';
        if (sbPlugins::getSetting('sb_report_user_status') == 1)
        {
            echo '  else
                    {
                        numErrors++;
                        if (numErrors >= 2 && !wasReported)
                        {
                        	alert("'.NAVMENU_LINE_BREAK.'");
							
                            numErrors = 0;
                            wasReported = true;
                            var onlineEl = sbGetE("sb_user_status");
                            if (onlineEl)
                            {
                                onlineEl.className = "offline";
                                onlineEl.innerHTML = "'.NAVMENU_USER_OFFLINE.'";
                                onlineEl.title = "'.NAVMENU_USER_OFFLINE_DESCR.'";
                            }
                        }
                    }
                 ';
        }
echo '          }
                else
                {
                	numErrors = 0;
                    wasReported = false;
                    var onlineEl = sbGetE("sb_user_status");
                    if (onlineEl)
                    {
                        onlineEl.className = "online";
                        onlineEl.innerHTML = "'.NAVMENU_USER_ONLINE.'";
                        onlineEl.title = "'.NAVMENU_USER_ONLINE_DESCR.'";
                    }
                    
                    var msg_td = sbGetE("msg_td");
                    if (parseInt(params[1]) > 0)
                    {
                        sbGetE("msg_num").innerHTML = params[1];
                        msg_td.style.display = "";
                    }
                    else
                    {
                        msg_td.style.display = "none";
                    }
                }
            }

            var statusInterval = setInterval("sbReportUserStatus()", 15000);
        </script>
    </head>
    <body onunload="if (statusInterval) clearInterval(statusInterval);" onselectstart="return sbCancelEvent(event);" oncontextmenu="return sbCancelEvent(event);" unselectable="on">
    <table cellpadding="0" cellspacing="0" width="100%" height="100%">
    <tr>
        <td class="nav_logo">
        <a href="http://'.CMS_SITE_NAME.'" target="_blank" title="'.CMS_NAME.'"><img src="'.SB_CMS_IMG_URL.'/logo.gif" class="logo"></a>
        </td>
        <td onmousedown="sbPressDown(event);" id="sb_toolbar"><nobr>';

// вывод панели инструментов
$icons = $_SESSION['sbPlugins']->getToolbarIcons();

if (count($_SESSION['sbPlugins']->mContainers) > 0)
{
	echo '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_kernel_read" target="content" title="'.NAVMENU_HOME.'"><img class="button" src="'.SB_CMS_IMG_URL.'/plugins/pl_kernel_24.png" width="24" height="24"></a>';
	
	if (CMS_SITE_NAME == 'www.sbuilder.ru')
	{
		echo '&nbsp;&nbsp;&nbsp;';
	}
}

if (CMS_SITE_NAME == 'www.sbuilder.ru')
{
    echo '<a id="help_url" href="http://www.sbuilder.ru/training/helps/" target="_blank" title="'.NAVMENU_HELP.'"><img class="button" src="'.SB_CMS_IMG_URL.'/plugins/pl_help_24.png" style="cursor:help;" width="24" height="24"></a>';
}

$count = count($icons);
for ($i = 0; $i < $count; $i++)
{
    if ($i == 0)
    {
        echo '<img src="'.SB_CMS_IMG_URL.'/bardelim.gif" style="margin-top: -4px;">';
    }
    
    echo '<a href="'.$icons[$i]['href'].'" target="'.$icons[$i]['target'].'" title="'.$icons[$i]['desc'].'"><img class="button" src="'.$icons[$i]['icon'].'"></a>';
    if ($i != $count - 1)
    {
        echo '&nbsp;&nbsp;&nbsp;';
    }
}

echo '  </nobr></td>
        <td onmousedown="sbPressDown(event);" id="sb_quick_toolbar"><nobr>';

// вывод панели быстрого запуска
$all_count = sbPlugins::getUserSetting('sb_toolbar_qicons_count');
if ($all_count > 0)
{
	$count = count($_SESSION['sbQuickToolbar']);
	$i = 0;
	foreach ($_SESSION['sbQuickToolbar'] as $event => $value)
	{
	    if ($i == 0)
	    {
	        echo '<img src="'.SB_CMS_IMG_URL.'/bardelim.gif" style="margin-top: -4px;">';
	    }
	    
	    echo '<a href="'.SB_CMS_CONTENT_FILE.'?event='.$event.'" target="content" title="'.$value['desc'].'"><img class="button" src="'.$value['icon'].'"></a>';
	    
	    if ($i != $count - 1 && $i != $all_count - 1)
	    {
	        echo '&nbsp;&nbsp;&nbsp;';
	    }
	    $i++;
	    
	    if ($i == $all_count)
	    	break;
	}
}

$res_inbox_new = sql_query('SELECT COUNT(*) FROM sb_users_messages WHERE um_to_id=?d AND um_delete = 0 AND um_look = 0', $_SESSION['sbAuth']->getUserId());

require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
$idn = new sbIDN();
$idn_domain = $idn->decode(SB_COOKIE_DOMAIN);
    
echo '  </nobr></td>
    <td>
        <div align="right" style="margin-left: 30px;">
        <table cellpadding="0" cellspacing="0" id="nav_table">
        <tr>
            <td'.($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') ? ' style="padding-top: 4px;"' : '').'>
                <nobr>
                    '.NAVMENU_SITE.': <a href="'.SB_DOMAIN.'" target="_blank">'.$idn_domain.'</a><br />';

if ($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow'))
{
	echo NAVMENU_DEMO_SITE.': <a href="http://www-demo.'.SB_COOKIE_DOMAIN.'" target="_blank">www-demo.'.$idn_domain.'</a><br />';
}

echo '              <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_kernel_who_is_online" target="content" style="color: green;">'.NAVMENU_USER_WHO_IS_ONLINE.'</a>
                </nobr>
            </td>
            <td>
                <nobr>
                    '.NAVMENU_USER.': <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_kernel_user_info&id='.$_SESSION['sbAuth']->getUserId().'" target="content">'.($_SESSION['sbAuth']->mName != '' ? $_SESSION['sbAuth']->mName : $_SESSION['sbAuth']->getUserLogin()).'</a><br />
                    '.NAVMENU_USER_STATUS.': <span id="sb_user_status" class="online" title="'.NAVMENU_USER_ONLINE_DESCR.'">'.NAVMENU_USER_ONLINE.'</span>
                </nobr>    
            </td>
            <td onmousedown="sbPressDown(event);">
                <nobr>
                    <a href="/cms/admin/index.php?logout=1" target="_top" title="'.NAVMENU_EXIT.'"><img class="button" src="'.SB_CMS_IMG_URL.'/icon_exit.png" align="absMiddle" width="24" height="24" onclick="if (statusInterval) clearInterval(statusInterval);" /></a>&nbsp;&nbsp;&nbsp;
                </nobr>
            </td>
        </tr>
        <tr>
            <td>&nbsp;</td>
            <td style="'.($res_inbox_new[0][0] == 0 ? 'display:none;' : '').($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') ? 'padding-top: 5px;' : '').'" id="msg_td"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_messages_read&ident=inbox" target="content" style="color: #000;"><img src="'.SB_CMS_IMG_URL.'/plugins/pl_messages_16.png" align="absmiddle" border="0" width="16" height="16">&nbsp;&nbsp;'.NAVMENU_INBOX.'</a>&nbsp;(<span id="msg_num">'.$res_inbox_new[0][0].'</span>)</td>
            <td>&nbsp;</td>
        </tr>
        </table>
        </div>
    </td>
    </tr>
    </table><div id="disable_div" class="disable"></div>
    </body></html>';

require_once(SB_CMS_KERNEL_PATH.'/footer.inc.php');
?>