<?php
define ('PL_FILELIST_H_PLUGIN_NAME', 'Файловая панель');
define ('PL_FILELIST_H_TITLE', 'Управление файловой структурой сайта');
define ('PL_FILELIST_H_EDIT_TITLE', 'Редактирование/Создание файла');
define ('PL_FILELIST_H_RIGHTS_TITLE', 'Изменить атрибуты файла');

define ('PL_FILELIST_H_FOLDERS_EDIT_RIGHT', 'Управление папками');
define ('PL_FILELIST_H_FOLDERS_DELETE_RIGHT', 'Удаление папок');
define ('PL_FILELIST_H_FOLDERS_RIGHTS_RIGHT', 'Установка прав доступа к папкам');
define ('PL_FILELIST_H_FOLDERS_UPLOAD_RIGHT', 'Загрузка файлов на сервер');
define ('PL_FILELIST_H_FILES_CUT_COPY_RIGHT', 'Копирование и перенос файлов');
define ('PL_FILELIST_H_FILES_EDIT_RIGHT', 'Редактирование и создание файлов');
define ('PL_FILELIST_H_FILES_DELETE_RIGHT', 'Удаление файлов');
define ('PL_FILELIST_H_FILES_FOLDERS_ACCESS_RIGHT', 'Установка атрибутов файлов и папок');

define ('PL_FILELIST_H_SETTING', 'Файловая панель');
define ('PL_FILELIST_H_SETTING_FILE_RIGHTS', 'Права на генерируемые системой файлы');
define ('PL_FILELIST_H_SETTING_FOLDER_RIGHTS', 'Права на генерируемые системой папки');
define ('PL_FILELIST_H_SETTING_MAX_UPLOAD_FILESIZE', 'Максимально разрешенный размер файлов для загрузки на сервер (в байтах)');
define ('PL_FILELIST_H_SETTING_MAX_IMAGE_WIDTH', 'Максимально разрешенная ширина изображений для загрузки на сервер (в пикселах)');
define ('PL_FILELIST_H_SETTING_MAX_IMAGE_HEIGHT', 'Максимально разрешенная высота изображений для загрузки на сервер (в пикселах)');

define ('PL_FILELIST_H_SETTING_RESIZE', 'Изменять размер всех загружаемых изображений');
define ('PL_FILELIST_H_SETTING_MAX_RESIZE_WIDTH', 'Максимальная ширина изображения (в пикселах)');
define ('PL_FILELIST_H_SETTING_MAX_RESIZE_HEIGHT', 'Максимальная высота изображения (в пикселах)');
define ('PL_FILELIST_H_SETTING_RESIZE_QUALITY', 'Степень сжатия изображения (в процентах)');

define ('PL_FILELIST_H_SETTING_WATERMARK', 'Накладывать водяной знак на все загружаемые изображения');
define ('PL_FILELIST_H_SETTING_WATERMARK_POSITION', 'Расположение водяного знака');

define ('PL_FILELIST_H_SETTING_WATERMARK_IMG', 'Относительный путь к изображению водяного знака (*.gif, *.jpg, *.png)');
define ('PL_FILELIST_H_SETTING_WATERMARK_OPACITY', 'Процент прозрачности водяного знака<br>(0 - полностью прозрачный, 100 - полностью не прозрачный)');
define ('PL_FILELIST_H_SETTING_WATERMARK_MARGIN', 'Отступ для водяного знака');

define ('PL_FILELIST_H_SETTING_COPYRIGHT', 'Текст для водяного знака');
define ('PL_FILELIST_H_SETTING_COPYRIGHT_COLOR', 'Цвет текста для водяного знака');
define ('PL_FILELIST_H_SETTING_COPYRIGHT_FONT', 'Шрифт текста для водяного знака');
define ('PL_FILELIST_H_SETTING_COPYRIGHT_SIZE', 'Размер шрифта текста для водяного знака');

define ('PL_FILELIST_H_SETTING_NUM_COLS', 'Кол-во столбцов в таблице списка файлов');
define ('PL_FILELIST_H_SETTING_NUM_ROWS', 'Кол-во рядов в таблице списка файлов');
define ('PL_FILELIST_H_SETTING_TRUNCATE_NAMES', 'Не обрезать длиные имена файлов при выводе');
define ('PL_FILELIST_H_SETTING_SMALL_ICONS', 'Показывать маленькие иконки в списке файлов');

$GLOBALS['sb_character_help']['pl_filelist_init'] = array();
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Вы находитесь в модуле <strong>«Файловая панель»</strong>.<br /><br />
    Отсюда Вы можете управлять файловой структурой сайта:
    <ul>
    <li>создавать новые папки и файлы,</li>
    <li>копировать/перемещать папки и файлы,</li>
    <li>удалять файлы и папки,</li>
    <li>назначать права доступа к файлам и папкам,</li>
    <li>изменять атрибуты файлов и папок.</li>
    </ul>
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'В правой части окна отображается дерево файловой структуры сайта для работы с папками. Перемещение по дереву файловой структуры происходит аналогично перемещению в стандартном Проводнике Windows.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Если Вы хотите просмотреть содержимое файла, щелкните левой кнопкой мыши по его наименованию. Файл откроется в новом окне.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы создать новую папку щелкните в правой части окна правой кнопкой мыши:
    <ul>
    <li>по значку <img src="'.SB_CMS_IMG_URL.'/tips/root.gif" align="absmiddle" />, если хотите создать папку в корневом каталоге сайта;</li>
    <li>по имени папки, если хотите создать вложенную папку.</li>
    </ul>
    В открывшемся контекстном меню выберите команду <strong>Создать папку</strong>.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы скопировать папку, щелкните по ее имени правой кнопкой мыши и в открывшемся контекстном меню выберите команду <strong>Копировать папку</strong>.<br /><br />
    Далее в дереве файловой структуры щелкните правой кнопкой мыши по имени папки, в которую будет помещена копия (если копию необходимо поместить в корневой каталог, щелкните по значку <img src="'.SB_CMS_IMG_URL.'/tips/root.gif" align="absmiddle" />). В контекстном меню выберите команду <strong>Вставить папку</strong>.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Когда копируете папку, учитывайте, что:
    <ol>
    <li>Копировать папку саму в себя нельзя!</li>
    <li>Папка копируется со всеми вложенными в нее папками и файлами.</li>
    </ol>
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Для перемещения папки, щелкните по ее имени правой кнопкой мыши и в открывшемся контекстном меню выберите команду <strong>Вырезать папку</strong>.<br /><br />
    После чего в дереве файловой структуры щелкните правой кнопкой мыши по имени папки, в которую будет перемещена папка (если папку необходимо переместить в корневой каталог, щелкните по значку <img src="'.SB_CMS_IMG_URL.'/tips/root.gif" align="absmiddle" />). В контекстном меню выберите команду <strong>Вставить папку</strong>.<br /><br />
    Папки перемещаются со всеми вложенными папками и файлами.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Вы можете перемещать папки методом <strong>drag & drop</strong>: щелкните левой кнопкой по имени папки в дереве файловой структуры сайта и, держа кнопку нажатой, перетащите папку в новое место.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Для переименования папки (файла), щелкните правой кнопкой мыши по текущему имени. В контекстном меню выберите команду <strong>Переименовать папку (файл)</strong>.<br /><br />
    В открывшемся диалоговом окне в поле <strong>Укажите имя папки (файла)</strong> введите новое (отредактируйте имеющееся) имя. Нажмите на кнопку <strong>Переименовать</strong>.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Для того чтобы увидеть папки, созданные другими пользователями, работающими одновременно с Вами, щелкните правой кнопкой мыши в любом месте дерева файловой структуры сайта и в появившемся контекстном меню выберите команду <strong>Обновить</strong>.<br /><br />
    Через некоторое время список папок обновится и будет отображен на экране.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы удалить папку, щелкните по ее имени правой кнопкой мыши и в контекстном меню выберите команду <strong>Удалить папку</strong>.<br /><br />
    Будьте внимательны при удалении, так как папка удалится со всеми вложенными в нее папками и файлами.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы просмотреть и, при необходимости, изменить атрибуты папки (файла), щелкните правой кнопкой мыши по имени папки (файла) и в контекстном меню выберите команду <strong>Атрибуты папки (файла)</strong>.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'При необходимости создания файла, выберите папку в дереве файловой структуры, затем щелкните правой кнопкой мыши в любом месте области списка файлов данной папки. В контекстном меню выберите команду <strong>Создать файл</strong>.<br /><br />
    В открывшемся диалоговом окне введите, к примеру, текст или html-код. По окончании нажмите на кнопку <strong>Сохранить</strong>.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы загрузить файлы на сервер выберите папку, в которую будут помещены файлы, щелкните по имени папки правой кнопкой мыши. В контекстном меню выберите команду <strong>Загрузить файлы</strong>.
    Контекстное меню с командой <strong>Загрузить файлы</strong> можно также открыть в любом месте области списка файлов текущей папки (левая часть рабочего окна).';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы редактировать файл, ранее загруженный на сервер, выберите его имя и вызовите контекстное меню. Выберите команду <strong>Редактировать файл</strong>.<br /><br />
    Откроется форма редактирования файла, в которой произведите требуемые изменения.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы создать копию файла, щелкните по его имени правой кнопкой мыши. В открывшемся контекстном меню выберите команду <strong>Копировать файлы</strong>.<br /><br />
    Далее щелкните правой кнопкой мыши по имени папки, в которую будет помещена копия файла. В области отображения списка файлов вызовите контекстное меню и выберите команду <strong>Вставить файлы</strong>.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы выбрать для копирования/перемещения/удаления несколько файлов из списка, щелкайте по их именам, удерживая нажатой клавишу <strong>Ctrl</strong>.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы выделить все файлы в текущей папке щелкните правой кнопкой мыши в любом месте области отображения файлов. В контекстном меню выберите команду <strong>Выделить все</strong>.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Чтобы переместить файл, щелкните по его имени правой кнопкой мыши. В открывшемся контекстном меню выберите команду <strong>Вырезать файлы</strong>.<br /><br />
    Далее щелкните правой кнопкой мыши по имени папки, в которую будет перемещен файл. В области отображения списка файлов вызовите контекстное меню и выберите команду <strong>Вставить файлы</strong>.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Для того чтобы увидеть файлы, вновь созданные и/или загруженные другими пользователями, щелкните правой кнопкой мыши в любом месте области отображения списка файлов, в появившемся контекстном меню выберите команду <strong>Обновить</strong>.<br /><br />
    Через некоторое время список файлов обновится и новые файлы (если они есть на сервере) будут отображены на экране.
';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Для удаления файла щелкните по его имени правой кнопкой мыши и в контекстном меню выберите команду <strong>Удалить файлы</strong>.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Кнопка <img src="'.SB_CMS_IMG_URL.'/tips/find.gif" align="absmiddle" /> облегчит Вам поиск по тексту или html-коду.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Расширение создаваемого файла должно быть разрешено данному пользователю для загрузки на сервер. Это разрешение выдается администратором в модуле <strong>Пользователи системы</strong> при распределении прав пользователям.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Для создания сразу нескольких вложенных папок, введите их наименования, разделяя знаком «<strong>/</strong>». Например, <strong>folder1/folder2/folder3</strong>.<br /><br />
    Вновь создаваемая папка наследует права доступа родительской папки.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Вы можете загрузить на сервер от одного до пяти файлов за один прием.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = 'Если Вы, загружая на сайт архив с изображениями, установите флажок в поле <strong>Разархивировать файл после загрузки</strong> и, при этом, укажете настройки для изображений (изменение размеров, наложение водяных знаков и т.д.), то Система разархивирует загруженный файл, а потом соответственным образом обработает все изображения, которые находятся в загружаемом архиве.';
$GLOBALS['sb_character_help']['pl_filelist_init'][] = '<strong>ВНИМАНИЕ!</strong><br /><br />
    Время работы PHP-сценария на сервере строго ограничено (обычно это 30 секунд)! Вследствие этого, если загружается архив большого размера или архив содержит много изображений, системе может не хватить времени на обработку полученных данных и сервер сам прервет работу сценария.<br /><br />
    В этом случае нужно либо уменьшить размер архива и/или количество или размер содержащихся в нем файлов, либо обратиться к хостинг-провайдеру с просьбой увеличить время работы PHP-сценариев на сервере.<br /><br />
    Подобное может случиться даже с одним файлом, если он имеет большой размер, а на сервере заданы довольно ”жесткие” настройки.
';
?>