<?php
define ('PL_REDIRECT_H_PLUGIN_NAME', 'Переадресации');
define ('PL_REDIRECT_H_EDIT_TITLE', 'Редактирование / Добавление переадресации');

define ('PL_REDIRECT_H_404_TITLE', 'Журнал отсутствующих страниц');
define ('PL_REDIRECT_H_404_SETTING_DATE', 'Промежуток времени (дни), за который хранятся сообщения в журнале отсутствующих страниц<br />(0 - запись в журнал производиться не будет)');
define ('PL_REDIRECT_H_404_USER_SETTING_COUNT', 'Кол-во сообщений журнала отсутствующих страниц, выводимых на рабочем столе');

define ('PL_REDIRECT_H_404_CRON_TITLE', 'Архивирование журнала отсутствующих страниц');
define ('PL_REDIRECT_H_404_CRON_DESCR', 'Данное задание осуществляет создание архива журнала отсутствующих страниц.');

define ('PL_REDIRECT_H_404_ARCHIVE_TITLE', 'Архив журнала отсутствующих страниц');

define ('PL_REDIRECT_H_404_RIGHTS_DESCR', 'Просмотр журнала отсутствующих страниц');

define ('PL_REDIRECT_INC_NO_PAGES', 'Сообщений нет.');

define ('PL_REDIRECT_INC_404_DATE', 'Дата / Время<br />последнего запроса');
define ('PL_REDIRECT_INC_404_IP', 'IP<br />последнего запроса');
define ('PL_REDIRECT_INC_404_COUNT', 'Кол-во запросов');
define ('PL_REDIRECT_INC_404_DOMAIN', 'Домен');
define ('PL_REDIRECT_INC_404_URL', 'URL');
define ('PL_REDIRECT_INC_404_REFRESH', 'Обновить');
define ('PL_REDIRECT_INC_404_NO_MESSAGES', 'Отсутствующих страниц нет.');

$GLOBALS['sb_character_help']['pl_redirect_init'] = array();
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Модуль <b>Переадресации</b> предназначен для настройки корректных переадресаций в случаях, когда сайт обновляется или переносится на новый домен, или когда обнаружена неработающая ("битая") ссылка.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Чтобы добавить переадресацию, выберите раздел на панели разделов, затем щелкните правой кнопкой мыши в любом месте рабочей области окна. В контекстном меню выберите команду <b>Добавить новую переадресацию</b>.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Если страницы, на которую необходимо настроить переадресацию, еще не существует, Вы можете ее создать тут же, используя модуль <b>Управление страницами</b>.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Установите флажок в поле <b>Переадресация активна</b>, чтобы активировать настроенную переадресацию сразу же после сохранения параметров.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Обратите внимание, что в списке в качестве заголовка переадресации используется старый адрес страницы.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Чтобы редактировать ранее настроенную переадресацию щелкните левой кнопкой мыши по ее заголовку или щелкните правой кнопкой мыши по заголовку переадресации и в контекстном меню выберите команду <b>Редактировать переадресацию</b>.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Чтобы сохранить внесенные изменения без закрытия диалогового окна редактирования переадресации нажмите на кнопку <b>Применить</b>. Если же хотите сохранить параметры переадресации и закрыть диалоговое окно, то нажмите на копку <b>Сохранить</b>.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Чтобы выбрать для копирования/перемещения/удаления несколько переадресаций из подраздела, щелкайте по их заголовкам, удерживая нажатой клавишу <b>Ctrl</b>. Чтобы выбрать все переадресации в текущем подразделе, щелкните правой кнопкой мыши в любом месте рабочей области. В контекстном меню выберите команду <b>Выделить все</b>.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Если при добавлении переадресации флажок в поле <b>Переадресация активна</b> не был поставлен, то ситуацию можно исправить: вызовите контекстное меню нажатием правой кнопки по заголовку переадресации и выберите команду <b>Активна  / Не активна</b>.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Для того чтобы увидеть переадресации, настроенные другими пользователями, необходимо обновить список переадресаций в разделе. Для этого щелкните правой кнопкой мыши в любом месте рабочей области окна, в появившемся контекстном меню выберите команду <b>Обновить</b>.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = '<p>Чтобы отсортировать записи в списке переадресаций, например, по типу переадресации, выберите команду <b>Сортировать по Типу переадресации</b> в контекстном меню, вызванном в поле отображения списка изображений.</p>
<p>Аналогично можно сортировать записи по новому/старому адресу (URL) и по признаку &laquo;Активна/Не активна&raquo;.</p>';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Чтобы на экране остались только записи, соответствующие строго определенным условиям, нажмите на кнопку <img src="'.SB_CMS_IMG_URL.'/tips/filter.gif" align="absmiddle" /> в верхней части окна. Заполните поля фильтра условиями, по которым требуется отсортировать переадресации из списка и нажмите на кнопку <b>Применить</b>.';
$GLOBALS['sb_character_help']['pl_redirect_init'][] = 'Для удаления переадресации щелкните по ее заголовку правой кнопкой мыши и в контекстном меню выберите команду <b>Удалить</b>.';

$GLOBALS['sb_character_help']['pl_redirect_404_read'] = array();
$GLOBALS['sb_character_help']['pl_redirect_404_read'][] = 'Модуль, в котором Вы находитесь, предназначен для перехвата запросов на несуществующие страницы или файлы, ссылки на которые имеются на Ваших сайтах, а также для формирования отчетов об этих запросах. Использование данного модуля позволяет отследить неработающие ссылки, а также исправить ситуацию: настроить переадресацию, создать новые страницы с необходимым содержимым или добавить нужный файл.';
$GLOBALS['sb_character_help']['pl_redirect_404_read'][] = 'Пиктограмма в первом столбце таблицы указывает на статус отсутствующей страницы:
<ul style="list-style-type:none;">
<li><img src="'.SB_CMS_IMG_URL.'/warning_log.png" align="absmiddle" width="20" height="20" /> переадресация не настроена;
<li><img src="'.SB_CMS_IMG_URL.'/information_log.png" align="absmiddle" width="20" height="20" /> переадресация настроена и работает.
</ul>';
$GLOBALS['sb_character_help']['pl_redirect_404_read'][] = 'Вы можете отсортировать записи в таблице по тому или иному признаку, щелкнув мышью в соответствующем столбце по значку <img src="'.SB_CMS_IMG_URL.'/s_asc.gif" align="absmiddle" /> (сортировка по возрастанию) или по значку <img src="'.SB_CMS_IMG_URL.'/s_desc.gif" align="absmiddle" /> (сортировка по убыванию). Столбец, по которому отсортированы записи, будет отмечен значком <img src="'.SB_CMS_IMG_URL.'/s_asc_sel.gif" align="absmiddle" /> или <img src="'.SB_CMS_IMG_URL.'/s_desc_sel.gif" align="absmiddle" /> в зависимости от типа сортировки.';
$GLOBALS['sb_character_help']['pl_redirect_404_read'][] = '<p>Если записей в журнале отсутствующих страниц очень много, то бывает удобнее записи отфильтровать. Для этого следует нажать на кнопку <img src="'.SB_CMS_IMG_URL.'/tips/filter.gif" align="absmiddle" />.</p> 
<p>Задайте вручную или выберите из выпадающего списка признак, по которому следует фильтровать записи, после чего нажмите на кнопку <b>Применить</b>.';
$GLOBALS['sb_character_help']['pl_redirect_404_read'][] = 'Для обновления записей в журнале отсутствующих страниц воспользуйтесь кнопкой <img src="'.SB_CMS_IMG_URL.'/tips/refresh.gif" align="absmiddle" />.';
$GLOBALS['sb_character_help']['pl_redirect_404_read'][] = 'Чтобы настроить переадресацию для отсутствующей страницы нажмите на соответствующую ей ссылку в столбце <b>URL</b>. Произойдет автоматический переход в модуль <b>Переадресации</b>.';
$GLOBALS['sb_character_help']['pl_redirect_404_read'][] = 'Вы можете сохранить информацию, содержащуюся в журнале отсутствующих страниц, в файл формата .xls. Для этого нажмите на кнопку <img src="'.SB_CMS_IMG_URL.'/tips/excel_export.gif" align="absmiddle" />.';
$GLOBALS['sb_character_help']['pl_redirect_404_read'][] = 'Для просмотра архива записей в журнале отсутствующих страниц нажмите на кнопку <img src="'.SB_CMS_IMG_URL.'/tips/archive.gif" align="absmiddle" />.';
?>