<?php
define('INDEX_KERNEL_SOCIAL_LOGIN', 'Авторизация через соц. сети');
define('PL_SOCIAL_LOGIN_H_PLUGIN_NAME', 'Авторизация через соц. сети');

//Для соц. сетей
define('PL_SOCIAL_LOGIN_CAT', 'Категория пользователей');
//Twitter
define('PL_SOCIAL_LOGIN_TWITTER_LABEL', 'Twitter');
define('PL_SOCIAL_LOGIN_TWITTER_DELIM', '<div style="text-align:left;">Для возможности регистрации пользователей через Twitter нужно пройти процедуру регистрации.
Для этого зарегистрируйтесь на сайте <a target="_blank" href="http://twitter.com">twitter.com</a>.
На странице <a target="_blank" href="http://dev.twitter.com/apps/new">dev.twitter.com/apps/new</a> зарегистрируйте приложение со следующими значениями:
<ul>
	<li>Default Access type: <b>Read</b></li>
    <li>Callback URL: <b>%s/cms/admin/scmedia.php?name=twitter</b></li>
</ul>

После этого установите в настройках системы следующие настройки (полученные после регистрации):
<ul>
	<li>Ключ потребителя Twitter (Consumer key)</li>
	<li>Секретный ключ потребителя Twitter (Consumer secret)</li>
</ul>
</div>');
define('PL_SOCIAL_LOGIN_TWITTER_CONSUMER_KEY', 'Ключ потребителя Twitter (Consumer Key)');
define('PL_SOCIAL_LOGIN_TWITTER_SECRET_KEY', 'Секретный ключ потребителя Twitter (Consumer secret)');

//Facebook
define('PL_SOCIAL_LOGIN_FACEBOOK_LABEL', 'Facebook');
define('PL_SOCIAL_LOGIN_FACEBOOK_DELIM', '<div style="text-align:left;">Для возможности регистрации пользователей через Facebook Вам нужно пройти процедуру регистрации.
Для этого зарегистрируйтесь на сайте <a href="http://facebook.com" target="_blank">facebook.com</a>.
На странице <a href="http://www.facebook.com/developers/createapp.php" target="_blank">http://www.facebook.com/developers/createapp.php</a> зарегистрируйте приложение со следующими значениями:
<ul>
	<li>Название приложения: <b>Любое название</b></li>
	<li>Как ваше приложение встроено в Facebook? -> Сайт -> Site URL: <b>%s</b></li>
</ul>

После этого установите в настройках системы следующие настройки (полученные после регистрации):
<ul>
	<li>Идентификатор приложения (App ID)</li>
	<li>Секретный ключ приложения (App Secret)</li>
</ul>
</div>');
define('PL_SOCIAL_LOGIN_FACEBOOK_CONSUMER_KEY', 'Ключ приложения Facebook (App ID/API key)');
define('PL_SOCIAL_LOGIN_FACEBOOK_SECRET_KEY', 'Секретный ключ приложения Facebook (App Secret)');

//ВКонтакте
define('PL_SOCIAL_LOGIN_VK_LABEL', 'ВКонтакте');
define('PL_SOCIAL_LOGIN_VK_DELIM', '<div style="text-align:left;">Для возможности регистрации пользователей через ВКонтакте Вам нужно пройти процедуру регистрации.
Для этого зарегистрируйтесь на сайте <a href="http://vk.com" target="_blank">vk.com</a>.
На странице <a href="http://vk.com/editapp?act=create" target="_blank">http://vk.com/editapp?act=create</a> зарегистрируйте приложение со следующими значениями:
<ul>
	<li>Название приложения: <b>Любое название</b></li>
	<li>Тип: <b>Веб-сайт</b></li>
    <li>Адрес сайта: <b>%s</b></li>
    <li>Базовый домен: <b>%s</b></li>
</ul>

После этого установите в настройках системы следующие настройки (полученные после регистрации):
<ul>
	<li>ID приложения</li>
	<li>Защищенный ключ</li>
</ul>
</div>');
define('PL_SOCIAL_LOGIN_VK_CONSUMER_KEY', 'ID приложения');
define('PL_SOCIAL_LOGIN_VK_SECRET_KEY', 'Защитный ключ');

//Одноклассники
define('PL_SOCIAL_LOGIN_ODK_LABEL', 'Одноклассники');
define('PL_SOCIAL_LOGIN_ODK_DELIM', '<div style="text-align:left;">Для возможности регистрации пользователей через Одноклассники Вам нужно пройти процедуру регистрации.
Для этого зарегистрируйтесь на сайте <a href="http://odnoklassniki.ru" target="_blank">odnoklassniki.ru</a>.
На странице <a href="http://ok.ru/devaccess" target="_blank">http://ok.ru/devaccess</a> зарегистрируйтесь как разработчик.
В случае успешной регистрации в качестве разработчика, создайте приложение как указано на странице <a href="https://apiok.ru/wiki/pages/viewpage.action?pageId=42476486" target="_blank">
https://apiok.ru/wiki/pages/viewpage.action?pageId=42476486</a> со следующими параметрами:
<ul>
	<li>Название приложения: <b>Любое название</b></li>
	<li>Тип приложения: <b>EXTERNAL</b></li>
    <li>Статус: <b>PUBLIC</b></li>
</ul>

После этого установите в настройках системы следующие настройки (полученные после регистрации на E-mail):
<ul>
	<li>Application ID</li>
	<li>Публичный ключ приложения</li>
    <li>Секретный ключ приложения</li>
</ul>
</div>');
define('PL_SOCIAL_LOGIN_ODK_APP_ID', 'ID приложения');
define('PL_SOCIAL_LOGIN_ODK_PUBLIC_KEY', 'Публичный ключ');
define('PL_SOCIAL_LOGIN_ODK_SECRET_KEY', 'Секретный ключ');

//LiveJournal
define('PL_SOCIAL_LOGIN_LJ_LABEL', 'Livejournal');
define('PL_SOCIAL_LOGIN_LJ_ENABLED', 'Использовать авторизацию');

//Сообщения об ошибках
define('PL_SOCIAL_LOGIN_NOSETTINGS', 'Не заданы настройки модуля или модуль отключен, но не изменен макет дизайна формы авторизации');
define('PL_SOCIAL_LOGIN_LJ_NOLOGIN', 'Не указаны логин и/или пароль');
define('PL_SOCIAL_LOGIN_NOAUTH', 'Авторизация невозможна по техническим причинам.<br/>Приносим свои извинения за временные неудобства.');
define('PL_SOCIAL_LOGIN_WRONG_LOGIN', 'Неверный логин и/или пароль');
define('PL_SOCIAL_LOGIN_NONAME', 'Не удалось определить имя социальной сети при авторизации пользователя на сайте.');
define('PL_SOCIAL_LOGIN_UNKNOW_ERROR', 'Непредвиденная ошибка.');
define('PL_SOCIAL_LOGIN_MESSAGES_REGISTRATE_ERROR', 'Ошибка! Невозможно произвести регистрацию в данный момент. Попробуйте сделать это позже.');
define('PL_SOCIAL_LOGIN_NO_CURL', 'Не поддерживается расширение CURL');