<?php
define ('PL_USERS_H_PLUGIN_NAME', 'Пользователи системы');
define ('PL_USERS_H_EDIT_TITLE', 'Добавление / Редактирование пользователя');
define ('PL_USERS_H_CAT_EDIT_TITLE', 'Создание / Редактирование группы пользователей');

define ('PL_USERS_H_CATEGS_EDIT_RIGHT', 'Управление группами пользователей');
define ('PL_USERS_H_CATEGS_DELETE_RIGHT', 'Удаление групп пользователей');
define ('PL_USERS_H_CATEGS_RIGHTS_RIGHT', 'Установка прав доступа к группам пользователей');
define ('PL_USERS_H_ELEMS_EDIT_RIGHT', 'Редактирование пользователей');
define ('PL_USERS_H_ELEMS_DELETE_RIGHT', 'Удаление пользователей');

define ('PL_USERS_H_GET_GROUP_TITLE', 'Группы пользователей');
define ('PL_USERS_H_GET_GROUP_NO_USERS', 'Внимание! В системе нет пользователей, кроме администраторов.');
define ('PL_USERS_H_SUBCATEGS', 'Применить права доступа к подразделам');
define ('PL_USERS_H_SUBFOLDERS', 'Применить права доступа к вложенным папкам');

define ('PL_USERS_H_PASS_LIMIT_DATE', 'Промежуток времени (дни), в течение которого пароль пользователя системы является валидным <br />(0 - нет ограничения)');
define ('PL_USERS_H_PASS_LIMIT_PASS', 'Минимальная длина пароля');
define ('PL_USERS_H_PASS_FIRST_NEED_CHANGE', 'Требовать смену пароля для пользователей системы при первом входе в систему');

define ('PL_USERS_H_ID_LABEL', 'Идентификатор пользователя системы');
define ('PL_USERS_H_AUTO_LOGIN_LABEL', 'Хеш для автологина');
define ('PL_USERS_H_BLOCK_LABEL', 'Аккаунт заблокирован');
define ('PL_USERS_H_NOTIFY_LABEL', 'Получать системные уведомления');
define ('PL_USERS_H_LOGIN_LABEL', 'Логин пользователя');
define ('PL_USERS_H_PASS_LABEL', 'Пароль пользователя');
define ('PL_USERS_H_PASS_DATE_LABEL', 'Дата последнего изменения пароля');
define ('PL_USERS_H_NAME_LABEL', 'Ф.И.О.');
define ('PL_USERS_H_ADMIN_LABEL', 'Администратор');
define ('PL_USERS_H_REG_DATE_LABEL', 'Дата регистрации');
define ('PL_USERS_H_LAST_IP_LABEL', 'IP пользователя');
define ('PL_USERS_H_LAST_DATE_LABEL', 'Дата последней активности');
define ('PL_USERS_H_EMAIL_LABEL', 'E-mail пользователя');
define ('PL_USERS_H_ACTIVE_DATE_LABEL', 'Дата активности пользователя');
define ('PL_USERS_H_DOMAINS_LABEL', 'Домены, администрируемые пользователем');
define ('PL_USERS_H_UPLOADING_EXTS_LABEL', 'Расширения файлов, доступные для загрузки');
define ('PL_USERS_H_STRIP_PHP_LABEL', 'Вырезать PHP-код');
define ('PL_USERS_H_PERS_BIRTH_LABEL', 'Дата рождения');
define ('PL_USERS_H_PERS_FROF_LABEL', 'Профессия');
define ('PL_USERS_H_PERS_OTDEL_LABEL', 'Отдел / Подразделение');
define ('PL_USERS_H_PERS_DOLJ_LABEL', 'Должность');
define ('PL_USERS_H_PERS_MESS_TYPE_LABEL', 'Интернет-пейджер');
define ('PL_USERS_H_PERS_MESS_ID_LABEL', 'Номер интернет-пейджера');
define ('PL_USERS_H_PERS_PHONE_LABEL', 'Телефон');
define ('PL_USERS_H_PERS_MOB_LABEL', 'Мобильный телефон');
define ('PL_USERS_H_PERS_ADDR_LABEL', 'Адрес');
define ('PL_USERS_H_PERS_DOP_LABEL', 'Персональная дополнительная информация');
define ('PL_USERS_H_PERS_FOTO_LABEL', 'Фотография');
define ('PL_USERS_H_WORK_TITLE_LABEL', 'Название компании');
define ('PL_USERS_H_WORK_PHONE_LABEL', 'Корпоративный телефон');
define ('PL_USERS_H_WORK_INNER_PHONE_LABEL', 'Корпоративный внутренний телефон');
define ('PL_USERS_H_WORK_FAX_LABEL', 'Факс');
define ('PL_USERS_H_WORK_EMAIL_LABEL', 'Корпоративный E-mail');
define ('PL_USERS_H_WORK_OFFICE_LABEL', 'Номер офиса');
define ('PL_USERS_H_WORK_DOP_LABEL', 'Корпоративная дополнительная информация');
define ('PL_USERS_H_EXT_ID_LABEL', 'Внешний идентификатор пользователя');
define ('PL_USERS_H_WRONG_PASS_COUN_LABEL', 'Кол-во входов с неправильным паролем');

define ('PL_USERS_H_CAT_USERS_RIGHT_LABEL', 'Права группы пользователей');
define ('PL_USERS_H_CAT_WORKFLOW_LABEL', 'Цепочки публикации');



$GLOBALS['sb_character_help']['pl_users_init'] = array();
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Вы находитесь в модуле <b>«Пользователи системы»</b>. Здесь Вы можете управлять списком пользователей, организовать доступ пользователей к функционалу Системы, распределить полномочия пользователям.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'В правой части окна отображается список групп пользователей Системы в формате <b>Название группы [N]</b>, где N – количество пользователей в группе.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Флажок <img src="'.SB_CMS_IMG_URL.'/tree/iconCheckAll.gif" align="absmiddle" />, установленный в поле слева от наименования группы, означает активность группы, то есть пользователи этой группы имеют доступ к Системе. Если флажок будет снят, то доступ в Систему для пользователей данной группы будет заблокирован.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Группа <b>Администраторы [N]</b> создается по умолчанию. Удалить группу или деактивировать ее пользователей нельзя.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Администраторам Системы разрешен полный доступ ко всем операциям со всеми группами пользователей.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Для создания новой группы пользователей щелкните по надписи <strong>Пользователи системы [N]</strong> правой кнопкой мыши. В контекстном меню выберите команду <strong>Создать новую группу пользователей</strong>.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Права пользователей Системы задаются на уровне групп пользователей.<br /><br />
    Чтобы назначить права перейдите на закладку <strong>Права группы пользователей</strong> окна <strong>Создание/Редактирование группы пользователей</strong>.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Одновременно в Системе могут работать несколько администраторов, соответственно, список групп и списки пользователей могут изменяться. Для того чтобы увидеть вновь созданные группы, новых зарегистрированных пользователей или другие изменения, необходимо щелкнуть правой кнопкой мыши по названию 
    любой группы пользователей или в любом месте поля отображения списка пользователей и в контекстном меню выберите команду <strong>Обновить</strong>.<br /><br />
    Через некоторое время список групп и список пользователей обновятся и будут отображены на экране.
';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Для создания копии группы пользователей (с присвоенными ранее правами пользователей в группе) щелкните по названию группы правой кнопкой мыши и в контекстном меню выберите команду <strong>Копировать группу пользователей</strong>.<br /><br />
    Далее щелкните правой кнопкой мыши по надписи <strong>Пользователи системы [N]</strong>. В контекстном меню выберите команду <strong>Вставить группу пользователей</strong>.
';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Группа копируется с сохранением всех заданных для нее прав доступа, но без пользователей.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Чтобы редактировать группу, щелкните по ее названию правой кнопкой мыши и в контекстном меню выберите команду <strong>Редактировать группу пользователей</strong>.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Для удаления группы пользователей из списка щелкните правой кнопкой мыши по названию группы и в контекстном меню выберите команду <strong>Удалить группу</strong>.<br /><br />
    Группу нельзя удалить, если она содержит хоть одного зарегистрированного пользователя.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Щелкните по названию группы, список пользователей в которой хотите просмотреть. Список пользователей данной группы откроется в левой части рабочего окна.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Если пользователь является членом нескольких групп, то при нажатии на ярлык <img src="'.SB_CMS_IMG_URL.'/tips/link.gif" align="absmiddle" /> откроется группа, в которой пользователь был зарегистрирован изначально.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Чтобы редактировать информацию о пользователе, щелкните по его логину в списке пользователей, либо щелкните по полю с информацией о пользователе правой кнопкой мыши и выберите команду <strong>Редактировать пользователя</strong>.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Если пользователь был временно заблокирован, его можно разблокировать, сняв флажок в поле <strong>Заблокирован</strong> на закладке <strong>Основные</strong> окна <strong>Добавление /Редактирование пользователя</strong>.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Права пользователям задаются на Закладке <strong>Права</strong> окна <strong>Добавление /Редактирование пользователя</strong>.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Чтобы добавить в группу нового пользователя, выберите нужную группу щелкнув по ней левой кнопкой мыши, затем в поле списка пользователей вызовите контекстное меню, в котором выберите команду <strong>Добавить нового пользователя</strong>.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'При необходимости сделать пользователя членом нескольких групп, во вторую (и последующие) группы следует поместить ссылку на ранее зарегистрированного пользователя.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Чтобы создать ссылку на пользователя, щелкните правой кнопкой мыши по полю с информацией о пользователе. В контекстном меню выберите команду <strong>Копировать</strong>. Перейдите в группу, в которую требуется поместить ссылку на пользователя. Вызовите контекстное меню в поле списка пользователей и выберите команду <strong>Вставить ссылки на пользователей</strong>.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Чтобы выбрать несколько пользователей из списка, щелкайте по полям с информацией о них, удерживая нажатой клавишу <strong>Ctrl</strong>.<br /><br />
    Чтобы выбрать всех пользователей группы в контекстном меню выберите команду <strong>Выделить всё</strong>.
';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Чтобы переместить пользователя из одной группы в другую, щелкните правой кнопкой мыши по полю с информацией о пользователе. В контекстном меню выберите команду <strong>Вырезать</strong>.<br /><br />
    Перейдите в группу, в которую требуется переместить пользователя. Вызовите контекстное меню в поле списка пользователей и выберите команду <strong>Вставить пользователей</strong>.
';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Чтобы удалить пользователя из списка зарегистрированных пользователей, щелкните правой кнопкой мыши по полю с информацией о нем. В контекстном меню выберите команду <strong>Удалить</strong>.<br /><br />
    При удалении пользователя автоматически удаляются все ссылки на него из других групп.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Чтобы отсортировать записи на экране, например, по логинам, выберите команду <strong>Сортировать по Логину</strong> в контекстном меню, вызванном в поле отображения списка пользователей группы. Аналогично можно сортировать записи по электронному адресу (E-mail), ФИО, дате регистрации и дате последнего входа в Систему.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Чтобы на экране остались только записи, соответствующие строго определенным условиям, нажмите на кнопку <img src="'.SB_CMS_IMG_URL.'/tips/filter.gif" align="absmiddle" /> в верхней части окна. Заполните поля фильтра условиями, по которым требуется отсортировать записи. Нажмите на кнопку <strong>Применить</strong>.<br /><br />
    В строковых полях фильтра пользователей (<strong>Логин, Ф.И.О., IP адрес, Электронный адрес</strong>) поиск осуществляется по вхождению подстроки.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'Список прав для каждого модуля может быть различным в зависимости от функционала модуля.';
$GLOBALS['sb_character_help']['pl_users_init'][] = 'После того, как Вы определите права группам пользователей, необходимо определить права доступа к разделам непосредственно в выбранных модулях (если модулей несколько, то повторите операцию для каждого из них).';
?>