<?php
require_once(SB_CMS_LIB_PATH.'/graph/Elements/OFC_Elements_Base.php');

class OFC_Elements_Menu_Item extends OFC_Elements_Base
{
	/**
	 * @param $text as string. The menu item text.
	 * @param $javascript_function_name as string. The javascript function name, the
	 * js function takes one parameter, the chart ID. See ofc_menu_item_camera for
	 * some example code.
	 */
	function OFC_Elements_Menu_Item($text, $javascript_function_name)
	{
		$this->type = "text";
		$this->text = $text;
		$tmp = 'javascript-function';
		$this->$tmp = $javascript_function_name;
	}
}

class OFC_Elements_Menu extends OFC_Elements_Base
{
	function OFC_Elements_Menu($colour, $outline_colour)
	{
		$this->colour = $colour;
		$this->outline_colour = $outline_colour;
	}
	
	function set_values($values)
	{
		$this->values = $values;
	}
}
?>