<?php
function fAbout()
{
	// проверка прав доступа
	if (!$_SESSION['sbPlugins']->isRightAvailable('pl_about', 'read'))
		return;

	$res = sql_query('SELECT MAX(u_update_id) FROM sb_updates');
    if ($res)
    {
    	list($u_update_id) = $res[0];

		$major_ver = trim(substr($u_update_id, 0, 2), '0');
		$minor_ver = trim(substr($u_update_id, 2));

		$ver = $major_ver.'.'.$minor_ver;

		if ($ver == '.' || $ver < CMS_DISTR_VERSION)
		{
			$ver = CMS_DISTR_VERSION;
		}
	}
    else
    {
        $ver = CMS_DISTR_VERSION;
    }

    echo '<script>
	    	document.body.onselectstart = "";
	    	document.body.setAttribute("unselectable", "off");

	    	function sb_renew()
	    	{
	    		var res = sbLoadSync(sb_cms_empty_file + "?event=pl_about_renew&lic='.SB_CLIENT_LIC.'");
		        if (res == "TRUE")
		        {
		            sbShowMsgDiv("'.PL_ABOUT_RENEW_OK.'", "information.png");
		        }
		        else
		        {
		            sbShowMsgDiv("'.PL_ABOUT_RENEW_ERROR.'", "warning.png");
		        }
	    	}
    	</script>

    	<script src="'.SB_CMS_JSCRIPT_URL.'/sbTools.js"></script>
        <br /><center><div class="sb_about_div">
        <p><a href="http://'.CMS_SITE_NAME.'/" target="_blank"><img border="0" align="left" src="'.SB_CMS_IMG_URL.'/site_logo.gif" style="margin-right: 25px"></a>
           <span style="font-weight:bold;font-size:12pt;">'.PL_ABOUT_CMS.' '.CMS_NAME_FULL.', '.PL_ABOUT_VERSION.' '.$ver.'</span>
        </p>
        <p><br><br><br>'.sprintf(PL_ABOUT_LICENSE, CMS_NAME_FULL,'<b>'.CMS_COMP_NAME.'</b>', SB_CLIENT_LIC).'. ';

    if (SB_CLIENT_VALIDITY != -1)
        echo sprintf(PL_ABOUT_EXPIRE_ON, '<b>'.sb_date('d.m.Y', SB_CLIENT_VALIDITY).'</b>').' ';
    else
        echo PL_ABOUT_UNLIMITED.' ';

    echo sbAuth::checkSupport() ? '<p>'.PL_ABOUT_RENEW.'</p>' : '';

    require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();

    echo sbAuth::checkSupport() ? '<hr size="1" color="#E76E24"><p>'.sprintf(PL_ABOUT_SUPPORT, $idn->decode(SB_MAIN_DOMAIN)).'</p>
    <hr size="1" color="#E76E24"><p><span style="color:#990066;"><b>'.PL_ABOUT_ATTENTION.'</b></span> '.PL_ABOUT_COPYRIGHT.'</p>' : '';

    if (CMS_SHOW_LIC == '1')
        echo '<center><a href=\'javascript:sbPopupImg("'.SB_CMS_IMG_URL.'/patent_big.jpg", "")\'><img src="'.SB_CMS_IMG_URL.'/patent_small.jpg" width="150" height="211" border="0" /></a></center>';

    echo '<p><b>'.PL_ABOUT_SYSTEM_REQ.'</b> '.sprintf(PL_ABOUT_REQ, '<b>'.CMS_NAME_FULL.'</b>').'<br />
          <hr size="1" color="#E76E24"><br /><a href="http://'.CMS_SITE_NAME.'" target="_blank">'.PL_ABOUT_COPY.CMS_COMP_NAME.', '.CMS_COMP_YEAR.'</a>
          </p>
          </div></center>';
}

function fAbout_Renew()
{
	require_once(SB_CMS_LIB_PATH.'/sbDownload.inc.php');

    $httpRequest = new sbDownload('http://www.sbuilder.ru/keygen/kg.php?keygen&lic='.SB_CLIENT_LIC.'&status=full');
    $result = $httpRequest->download();

    if (trim($result) == '')
    {
    	sb_add_system_message(PL_ABOUT_RENEW_ERROR_SITE, SB_MSG_WARNING);
    	return;
    }

    $GLOBALS['sbVfs']->mLocal = true;
	$file = SB_BASEDIR.'/cms/kernel/key.php';
	$file = str_replace('//', '/', $file);

	if(!$GLOBALS['sbVfs']->is_writable($file))
	{
		sb_add_system_message(PL_ABOUT_RENEW_ERROR_FILE, SB_MSG_WARNING);
		return;
	}

	$GLOBALS['sbVfs']->file_put_contents($file, $result);

	sb_add_system_message(PL_ABOUT_RENEW_OK);
	echo 'TRUE';
}

function fAbout_Renew_NoAuth()
{
    $auth = new sbAuth('', '', '');

    if(!defined('SB_CLIENT_LIC'))
    {
        echo 'FALSE';
        exit(0);
    }

    if(isset($_GET['buy']) && $_GET['buy'] == 1)
    {
        echo 'http://www.sbuilder.ru/buy_cms/about_lic/get_invoice.php?lic='.SB_CLIENT_LIC.'&dop=0';
        exit(0);
    }

    if (SB_CLIENT_VALIDITY == -1 || SB_CLIENT_VALIDITY > time())
    {
        echo 'TRUE';
        exit(0);
    }

    require SB_CMS_LANG_PATH . '/pl_about.lng.php';
    fAbout_Renew();
}
?>