<?php
require_once (SB_CMS_LANG_PATH.'/pl_banners.h.lng.php');
if ($_SESSION['sbPlugins']->register('pl_banners', PL_BANNERS_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_BANNERS_H_SUB_MENU.'>'.PL_BANNERS_H_PLUGIN_NAME, 'init');
    $_SESSION['sbPlugins']->addToExportImport(true, false);

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_banners', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_BANNERS_H_PLUGIN_NAME.'>'.PL_BANNERS_H_DESIGN , 'design_init', 'pl_banners_graphic_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_BANNERS_H_PLUGIN_NAME.'>'.PL_BANNERS_H_ELEM_LIST , 'design_list_init', 'pl_banners_list_24.png');
	}
	$_SESSION['sbPlugins']->setMainEvent('init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fBanners_Init', 'read', PL_BANNERS_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('edit', 'fBanners_Edit', 'read', PL_BANNERS_H_EDIT_BANNERS);
    $_SESSION['sbPlugins']->addUserEvent('submit', 'fBanners_Submit', 'elems_edit', PL_BANNERS_H_EDIT_BANNERS);
    $_SESSION['sbPlugins']->addUserEvent('set_active', 'fBanners_Set_Active', 'elems_public');
    $_SESSION['sbPlugins']->addUserEvent('delete', 'fBanners_Delete', 'elems_delete');
    $_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements', 'fBanners_Delete_With_Elements', 'elems_delete');

	$_SESSION['sbPlugins']->addUserEvent('after_paste', 'fBanners_After_Paste', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fBanners_After_Paste_With_Elements', 'categs_edit|elems_edit');

    $_SESSION['sbPlugins']->addUserEvent('stat_show', 'fBanners_Stat_Show', 'read');
    $_SESSION['sbPlugins']->addUserEvent('stat_delete', 'fBanners_Stat_Delete', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('stat_delete_submit', 'fBanners_Stat_Delete_Submit', 'elems_edit');

	$_SESSION['sbPlugins']->addToConstructor('sb_banners', false);
	$_SESSION['sbPlugins']->addToWorkflow();

    $_SESSION['sbPlugins']->addUserEvent('design_init', 'fBanners_Design_Init', 'design_read', PL_BANNERS_H_DESIGN);
    $_SESSION['sbPlugins']->addUserEvent('design_edit', 'fBanners_Design_Edit', 'design_read', PL_BANNERS_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_submit', 'fBanners_Design_Submit', 'design_edit', PL_BANNERS_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_delete', 'fBanners_Design_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('design_list_init', 'fBanners_Design_List_Init', 'design_read', PL_BANNERS_H_ELEM_LIST);
    $_SESSION['sbPlugins']->addUserEvent('design_list_edit', 'fBanners_Design_List_Edit', 'design_edit', PL_BANNERS_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_list_edit_submit', 'fBanners_Design_List_Edit_Submit', 'design_edit', PL_BANNERS_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_list_delete', 'fBanners_Design_List_Delete', 'design_edit');

	$fields = array();
	$fields['sb_id'] = array('title' => PL_BANNERS_H_ID_LABEL, 'flags' => '8');
	$fields['sb_name'] = array('title' => PL_BANNERS_H_NAME_LABEL, 'flags' => '4');
	$fields['sb_link'] = array('title' => PL_BANNERS_H_LINK_LABEL, 'flags' => '4');
	$fields['sb_code'] = array('title' => PL_BANNERS_H_CODE_LABEL, 'flags' => '5');
	$fields['sb_upload_name'] = array('title' => PL_BANNERS_H_UPLOAD_NAME_LABEL, 'flags' => '4');
	$fields['sb_count_show'] = array('title' => PL_BANNERS_H_COUNT_SHOW_LABEL, 'flags' => '8');
	$fields['sb_priority'] = array('title' => PL_BANNERS_H_PRIORITY_LABEL, 'flags' => '8');
	$fields['sb_date_from'] = array('title' => PL_BANNERS_H_DATE_FROM_LABEL, 'flags' => '9');
	$fields['sb_date_to'] = array('title' => PL_BANNERS_H_DATE_TO_LABEL, 'flags' => '9');
	$fields['sb_plan_dates'] = array('title' => PL_BANNERS_H_PLAN_DATES_LABEL, 'flags' => '5');
	$fields['sb_active'] = array('title' => PL_BANNERS_H_ACTIVE_LABEL, 'flags' => '8');
	$fields['sb_statistics'] = array('title' => PL_BANNERS_H_STATISTICS_LABEL, 'flags' => '8');
	$fields['sb_restricted_cats'] = array('title' => PL_BANNERS_H_RESTRICTED_LABEL, 'flags' => '5');
	$fields['sb_ext_id'] = array('title' => PL_BANNERS_H_EXT_ID, 'flags' => '8');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_banners', 'sb_id', 'sb_name', $fields);
}

$_SESSION['sbPlugins']->addSystemEvent('banner_elem', 'fBanners_Get_Elem', PL_BANNERS_H_ELEM_BANNER);
$_SESSION['sbPlugins']->addSystemEvent('banner_list', 'fBanners_Get_Elem_List', PL_BANNERS_H_ELEM_LIST);

$_SESSION['sbPlugins']->addElem(PL_BANNERS_H_ELEM_BANNER, 'design', 'fBanners_Elem', 'fBanners_Elem_Info', 'banner_elem', 800, 700, 'design_edit', 'pl_banners_design');
$_SESSION['sbPlugins']->addElem(PL_BANNERS_H_ELEM_LIST, 'design_list', 'fBanners_Elem_List', 'fBanners_Elem_List_Info', 'banner_list', 800, 700, 'design_list_edit', 'pl_banners_design_list');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
?>