<?php
require_once(SB_CMS_LANG_PATH.'/pl_basket.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_basket', PL_BASKET_PLUGIN_NAME, ''))
{
	if($_SESSION['sbPlugins']->isRightAvailable('pl_basket', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_BASKET_PLUGIN_NAME.'>'.PL_BASKET_H_MINI_DESIGN_MENU, 'mini_basket_init', '');
	}

	// добавление в настройки системы установок для плагина "Корзина"
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_basket_delim', PL_BASKET_PLUGIN_NAME, '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_basket_datespan', PL_BASKET_PLUGIN_DATESPAN, 'number', '', '7');

	//макеты миникорзины
	$_SESSION['sbPlugins']->addUserEvent('mini_basket_init', 'fBasket_Mini_Basket_Design_Init', 'design_read', PL_BASKET_H_MINI_DESIGNS);
	$_SESSION['sbPlugins']->addUserEvent('mini_basket_edit', 'fBasket_Mini_Basket_Design_Edit', 'design_read', PL_BASKET_H_MINI_DESIGNS);
	$_SESSION['sbPlugins']->addUserEvent('mini_basket_submit', 'fBasket_Mini_Basket_Design_Submit', 'design_edit', PL_BASKET_H_EDIT_MINI_DESIGNS);
	$_SESSION['sbPlugins']->addUserEvent('mini_basket_delete', 'fBasket_Mini_Basket_Design_Delete', 'design_edit');
}

$_SESSION['sbPlugins']->addSystemEvent('mini', 'fBasket_Get_Elem_Mini_Form', PL_BASKET_H_MINI_DESIGN_MENU);

$_SESSION['sbPlugins']->addElem(PL_BASKET_H_MINI_DESIGN_MENU, 'mini_basket', 'fBasket_Elem_Mini_Form_Prog', 'fBasket_Elem_Mini_Form_Info', 'mini', 800, 500, 'mini_basket_edit', 'pl_basket_mini_basket');

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
?>