<?php




/**
 * Функции управления макетами дизайна миникорзины
 */
function fBasket_Mini_Basket_Design_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['ptf_title'].'</a></b>
    <div class="smalltext" style="margin-top: 7px;">';

	static $view_info_pages = null;
	static $view_info_temps = null;

	if (is_null($view_info_pages))
	{
		$view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
	}

	if (is_null($view_info_temps))
	{
		$view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
	}

	$id = intval($args['ptf_id']);
	$pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_basket_mini_basket" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

	$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_basket_mini_basket" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

	if ($pages)
	{
		$result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_PAGES.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($pages));
	    for ($i = 0; $i < $num; $i++)
		{
			list($p_id, $p_name) = $pages[$i];
			$result .= ($view_info_pages ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
		}

		if ($num < count($pages))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
	    $result .= KERNEL_USED_ON_PAGES.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	if ($temps)
	{
		$result .= '<table cellpadding="0" cellspacing="0">
					<tr>
						<td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_TEMPS.':&nbsp;</td>
						<td class="smalltext"><span style="color:green;">';

		$num = min(3, count($temps));
		for ($i = 0; $i < $num; $i++)
		{
			list($t_id, $t_name) = $temps[$i];
			$result .= ($view_info_temps ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_templates_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
		}

		if ($num < count($temps))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
		else
			$result = substr($result, 0, -2);

		$result .= '</span></td></tr></table>';
	}
	else
	{
		$result .= KERNEL_USED_ON_TEMPS.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	$result .= '</div>';
	return $result;
}

function fBasket_Mini_Basket_Design_Init()
{
	require_once(SB_CMS_LIB_PATH . '/sbElements.inc.php');
	$elems = new sbElements('sb_plugins_temps_form', 'ptf_id', 'ptf_title', 'fBasket_Mini_Basket_Design_Get', 'pl_basket_mini_basket_init', 'pl_basket_mini_basket');

	$elems->addField('ptf_id');
	$elems->addField('ptf_title');

	$elems->mCategsRootName = PL_BASKET_MINI_BASKET_EDIT_ROOT_NAME;
	$elems->mCategsDeleteWithElementsMenu = true;

    $elems->mElemsEditEvent =  'pl_basket_mini_basket_edit';
    $elems->mElemsEditDlgWidth = 800;
	$elems->mElemsEditDlgHeight = 660;

	$elems->mElemsAddEvent =  'pl_basket_mini_basket_edit';
    $elems->mElemsAddDlgWidth = 800;
	$elems->mElemsAddDlgHeight = 660;

	$elems->mElemsDeleteEvent = 'pl_basket_mini_basket_delete';
	$elems->mElemsCopyMenuTitle = PL_BASKET_MINI_BASKET_EDIT_COPY_MENU_TITLE;
	$elems->mElemsCutMenuTitle = PL_BASKET_MINI_BASKET_EDIT_CUT_MENU_TITLE;
	$elems->mElemsDeleteMenuTitle= PL_BASKET_MINI_BASKET_EDIT_DELETE_MENU_TITLE;
	$elems->mElemsEditMenuTitle = PL_BASKET_MINI_BASKET_EDIT_EDIT_MENU_TITLE;
	$elems->mCategsPasteLinksMenuTitle = PL_BASKET_MINI_BASKET_EDIT_PASTE_LINK_MENU_TITLE;
    $elems->mCategsPasteElemsMenuTitle = PL_BASKET_MINI_BASKET_EDIT_PASTE_MENU_TITLE;
	$elems->mElemsAddMenuTitle = PL_BASKET_MINI_BASKET_EDIT_ADD;

	$elems->mElemsUseLinks = false;
	$elems->mCategsPasteElemsMenu = 'all';
	$elems->mCategsClosed = false;

	$elems->mElemsJavascriptStr .= '
			function linkPages(e)
			{
				if (!sbSelEl)
				{
					var el = sbEventTarget(e);
					while (el.parentNode && !el.getAttribute("true_id"))
						el = el.parentNode;

					var el_id = el.getAttribute("el_id");
				}
				else
					var el_id = sbSelEl.getAttribute("el_id");

				strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id +"&ident[]=pl_basket_mini_basket";
				strAttr = "resizable=1,width=800,height=600";
				sbShowModalDialog(strPage, strAttr, null, window);
			}

			function linkTemps(e)
			{
				if (!sbSelEl)
				{
					var el = sbEventTarget(e);

					while (el.parentNode && !el.getAttribute("true_id"))
						el = el.parentNode;

					var el_id = el.getAttribute("el_id");
				}
				else
					var el_id = sbSelEl.getAttribute("el_id");

				strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id +"&ident[]=pl_basket_mini_basket";
				strAttr = "resizable=1,width=800,height=600";
				sbShowModalDialog(strPage, strAttr, null, window);
			}';

	$elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
	$elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');

	$elems->init();
}

function fBasket_Mini_Basket_Design_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_basket_mini_basket'))
		return;

    if(count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$res = sql_param_query('SELECT ptf_id, ptf_title, ptf_form, ptf_messages, ptf_user_data_id FROM sb_plugins_temps_form WHERE ptf_id=?d', intval($_GET['id']));
		if(!$res)
		{
            sb_show_message(PL_BASKET_MINI_BASKET_EDIT_DESIGN_ERROR, false, 'warning');
            return;
		}

		list($ptf_id, $ptf_title, $ptf_form, $ptf_messages, $ptf_user_data_id) = $res[0];
		$ptf_messages = unserialize($ptf_messages);
	}
	elseif(count($_POST) > 0)
	{
		$ptf_user_data_id = 0;

		extract($_POST);
        if (!isset($_GET['id']))
            $_GET['id'] = '';
    }
    else
	{
		$ptf_user_data_id = 0;

		$ptf_messages = array();
		$ptf_messages['no_elems'] = PL_BASKET_MINI_BASKET_EDIT_NO_ELEMS_DEFAULT;

		$ptf_title = $ptf_form = '';
		$_GET['id'] = '';
	}

	echo '<script>
				function checkValues()
	            {
	                var el_title = sbGetE("ptf_title");
	                if (el_title.value == "")
	                {
	                     alert("'.PL_BASKET_MINI_BASKET_EDIT_NO_TITLE_MSG.'");
	                     return false;
					}
				}';

	if ($htmlStr != '')
	{
        echo '
            function cancel()
            {
                var res = new Object();
                res.html = "'.$htmlStr.'";
                res.footer = "'.$footerStr.'";
                res.footer_link = "";
                sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
    }
    echo '</script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_basket_mini_basket_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
    $layout->mTitleWidth = '160';
	$layout->mTableWidth = '95%';

    echo '<br /><br />';
	$layout->addHeader(PL_BASKET_MINI_BASKET_EDIT_TAB1);

    $layout->addField(PL_BASKET_MINI_BASKET_EDIT_DESIGN_TITLE, new sbLayoutInput('text', $ptf_title, 'ptf_title', '', 'style="width:100%;"'));

	$layout->addField('', new sbLayoutDelim());

//  Вывод миникорзины
	$fld = new sbLayoutTextarea($ptf_form, 'ptf_form', '', 'style="width:100%;height:250px;"');
	$fld->mTags = array('-', '{TOVAR_COUNT}', '{TOVAR_COUNT_OVERALL}', '{TOVAR_SUM}', '{TOVAR_SUM_DISCOUNT}', PL_BASKET_MINI_BASKET_EDIT_BASKET_LINK_VAL, PL_BASKET_MINI_BASKET_EDIT_DEL_FROM_BASKET_VAL, '{USER_DATA}');
	$fld->mValues = array(PL_BASKET_MINI_BASKET_EDIT_TAB1, PL_BASKET_MINI_BASKET_EDIT_TOVAR_COUNT, PL_BASKET_MINI_BASKET_EDIT_TOVAR_COUNT_OVERALL, PL_BASKET_MINI_BASKET_EDIT_TOVAR_TOVAR_SUM, PL_BASKET_MINI_BASKET_EDIT_TOVAR_SUM_DISCOUNT, PL_BASKET_MINI_BASKET_EDIT_BASKET_LINK, PL_BASKET_MINI_BASKET_EDIT_DEL_FROM_BASKET, PL_BASKET_MINI_BASKET_EDIT_USER_DATA);
	$layout->addField(PL_BASKET_MINI_BASKET_EDIT_MINI_BASKET_TEMP, $fld);

	fSite_Users_Design_Get($layout, $ptf_user_data_id, 'ptf_user_data_id');

	$layout->addField('', new sbLayoutDelim());

//  Сообщение "Товаров нет"
    $layout->addField(PL_BASKET_MINI_BASKET_EDIT_NO_ELEMS, new sbLayoutTextarea($ptf_messages['no_elems'], 'ptf_messages[no_elems]', '', 'style="width:100%;height:70px;"'));

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_basket', 'elems_edit') ? '' : 'disabled="disabled"'));
	if ($_GET['id'] != '')
		$layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_basket', 'elems_edit') ? '' : 'disabled="disabled"'));

	$layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
	$layout->show();
}

function fBasket_Mini_Basket_Design_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_basket_mini_basket'))
		return;

	if (!isset($_GET['id']))
		$_GET['id'] = '';

	$ptf_form = '';
	$ptf_messages = array();
	$ptf_user_data_id = 0;

	extract($_POST);

	if($ptf_title == '')
	{
		sb_show_message(PL_BASKET_MINI_BASKET_EDIT_NO_TITLE_MSG, false, 'warning');
		fBasket_Mini_Basket_Design_Edit();
		return;
	}

	$row = array();
	$row['ptf_title'] = $ptf_title;
	$row['ptf_lang'] = '';
	$row['ptf_form'] = $ptf_form;
	$row['ptf_fields_temps'] = '';
	$row['ptf_categs_temps'] = '';
	$row['ptf_messages'] = serialize($ptf_messages);
	$row['ptf_user_data_id'] = $ptf_user_data_id;

	if ($_GET['id'] != '')
	{
		sql_param_query('UPDATE sb_plugins_temps_form SET ?a WHERE ptf_id=?d', $row, $_GET['id']);
        sbQueryCache::updateTemplate('sb_plugins_temps_form', $_GET['id']);

        $footer_ar = fCategs_Edit_Elem();
	    if (!$footer_ar)
	    {
	        sb_show_message(sprintf(PL_BASKET_MINI_BASKET_SUBMIT_SYSTEMLOG_ERROR, $ptf_title), false, 'warning');
            sb_add_system_message(sprintf(PL_BASKET_MINI_BASKET_SUBMIT_SYSTEMLOG_ERROR, $ptf_title), SB_MSG_WARNING);
            fBasket_Mini_Basket_Design_Edit();
		    return;
	    }

		$footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
		$footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

		$row['ptf_id'] = $_GET['id'];

        $html_str = fBasket_Mini_Basket_Design_Get($row);
	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
        $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

        if (!isset($_POST['btn_apply']))
        {
			echo '<script>
						var res = new Object();
						res.html = "'.$html_str.'";
						res.footer = "'.$footer_str.'";
						res.footer_link = "";
						sbReturnValue(res);
				</script>';
        }
        else
        {
			fBasket_Mini_Basket_Design_Edit($html_str, $footer_str);
        }
	}
	else
	{
	    $error = true;

	    if (sql_param_query('INSERT INTO sb_plugins_temps_form SET ?a', $row))
	    {
			$id = sql_insert_id();

    		if (fCategs_Add_Elem($id))
    		{
                sbQueryCache::updateTemplate('sb_plugins_temps_form', $id);
				sb_add_system_message(sprintf(PL_BASKET_MINI_BASKET_SUBMIT_OK, $ptf_title));
       			echo '<script>
        				 sbReturnValue('.$id.');
        			    </script>';

        		$error = false;
    		}
    		else
    		{
				sql_query('DELETE FROM sb_plugins_temps_form WHERE ptf_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_BASKET_MINI_BASKET_SUBMIT_ADD_SYSTEMLOG_ERROR, $ptf_title), false, 'warning');
            sb_add_system_message(sprintf(PL_BASKET_MINI_BASKET_SUBMIT_ADD_SYSTEMLOG_ERROR, $ptf_title), SB_MSG_WARNING);
            fBasket_Mini_Basket_Design_Edit();
		    return;
	    }
	}
}

function fBasket_Mini_Basket_Design_Delete()
{
	$id = intval($_GET['id']);
	$pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
					WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_basket_mini_basket" AND pages.p_id=elems.e_p_id LIMIT 1');

    $temps = false;
    if (!$pages)
    {
        $temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
					WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_basket_mini_basket" AND temps.t_id=elems.e_p_id LIMIT 1');
    }

    if ($pages || $temps)
    {
		echo PL_BASKET_MINI_BASKET_DELETE_ERROR;
    }
}


?>