<?php
require_once(SB_CMS_LANG_PATH.'/pl_calendar.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_calendar', PL_CALENDAR_H_PLUGIN_NAME, ''))
{
	if ($_SESSION['sbPlugins']->isRightAvailable('pl_calendar', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_CALENDAR_H_PLUGIN_GENERAL.'>'.PL_CALENDAR_H_PLUGIN_MENU_ITEM, 'init');
	}
	
	$_SESSION['sbPlugins']->addUserEvent('init', 'fCalendar_Init', 'design_read', PL_CALENDAR_H_PLUGIN_INIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fCalendar_Edit', 'design_read', PL_CALENDAR_H_PLUGIN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fCalendar_Edit_Submit', 'design_edit', PL_CALENDAR_H_PLUGIN_EDIT_TITLE);
}

$_SESSION['sbPlugins']->addToCache();

$_SESSION['sbPlugins']->addSystemEvent('elem_calendar', 'fCalendar_Get_Elem', PL_CALENDAR_H_ELEM);
$_SESSION['sbPlugins']->addSystemEvent('elem_calendar_components', 'fCalendar_Get_Elem_Components');

$_SESSION['sbPlugins']->addElem(PL_CALENDAR_H_ELEM, 'elem', 'fCalendar_Elem', 'fCalendar_Elem_Info', 'elem_calendar', 800, 450, 'edit', 'pl_calendar');

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);

?>