<?php
/********************************** функции построения диалоговых окон ***********************************/

function fCalendar_Get_Elem_Components($page_url = '')
{
	$components = array('' => ' --- ');
	if (isset($_GET['p_url']))
	{
		$page_url = $_GET['p_url'];
	}

    $page_id = fPages_Get_Page_By_Url($page_url);
        
    if ($page_id != -1)
    {
		$res = sql_param_query('SELECT p_temp_id FROM sb_pages WHERE p_id=?d', $page_id);
	    if ($res)
	    {
	    	list($p_temp_id) = $res[0];
	    	
	    	$res = sql_param_query('SELECT e_tag, e_ident, e_link FROM sb_elems WHERE ((e_p_id=?d AND e_link="page") OR (e_p_id=?d AND e_link="temp")) AND e_ident != ""', $page_id, $p_temp_id);
	    	if ($res)
	    	{
	    		$elems = $_SESSION['sbPlugins']->getElems();
	    		foreach ($res as $value)
	    		{
	    			list($e_tag, $e_ident, $e_link) = $value;
	    			
	    			if (array_key_exists($e_ident, $_SESSION['sbPlugins']->mCalendar))
	    			{
	    				$key = trim($e_tag, '{}');
	
	    				if ((array_key_exists($key, $components) && $e_link != 'temp') || !array_key_exists($key, $components))
	    				{
	    					if ($e_link == 'temp')
	    					{
	    						$res_dup = sql_query('SELECT COUNT(*) FROM sb_elems WHERE e_p_id=?d AND e_link="page" AND e_tag=?', $page_id, $e_tag);
	    						if ($res_dup && $res_dup[0][0] > 0)
	    							continue;
	    					}
	    					$components[$key] = array();
	    					$components[$key]['ident'] = $e_ident;
	    					$components[$key]['get_func'] = $_SESSION['sbPlugins']->mCalendar[$e_ident]['get_func'];
	    					$components[$key]['get_func_file'] = $_SESSION['sbPlugins']->mCalendar[$e_ident]['get_func_file'];
	    					$components[$key]['name'] = $elems[$e_ident]['name'].' ('.str_replace('_', ' ', $key).')';
	    					$components[$key]['link'] = $e_link;
	    				}
	    			}
	    		}
	    		
	    		$cur_group = '';
	    		$new_components = array();
	    		foreach ($components as $key => $value)
	    		{
	    			if ($key == '')
	    			{
	    				$new_components[$key] = $components[$key];
	    			    continue;
	    			}
	    			   
	    			$name = explode('|', $value['name']);
	    			if ($cur_group != $name[0])
	    			{
	    				$new_components[$key.'_group'] = '-'.$name[0];
	    			}
	    			
	    			$key = $key.'::'.$value['ident'].'::'.$value['link'].'::'.$value['get_func'].'::'.$value['get_func_file'];
	    			$new_components[$key] = $name[1];
	    		}
	    		
	    		$components = $new_components;
	    	}
	    }
    }
    
    if (!isset($_GET['p_url']))
    {
    	return $components;
    }
    else 
    {
    	$keys = '';
    	$values = '';
    	foreach ($components as $key => $value)
    	{
    		$keys .= '"'.addslashes($key).'",';
    		$values .= '"'.addslashes($value).'",';
    	}
    	$keys = sb_substr($keys, 0, -1);
    	$values = sb_substr($values, 0, -1);
    	
    	$result = '{"keys":['.$keys.'],"values":['.$values.']}';
    	
    	echo $result;
    }
}

/********************************** функции построения диалоговых окон ***********************************/

/**
 * Вывод календаря
 */
function fCalendar_Get_Elem()
{
    $params = unserialize($_GET['params']);

    echo '<script>
        function chooseElem()
        {
            var res = new Object();
            var params = new Array();
            
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_CALENDAR_H_ELEM_NO_TEMPS_ALERT.'");
                return;
            }
            
            var el_page = sbGetE("page");
            if (el_page.value == "")
            {
                alert("'.PL_CALENDAR_H_ELEM_NO_PAGE_ALERT.'");
                return;
            }
            
            var el_comp = sbGetE("component");
            if (el_comp.value == "")
            {
                alert("'.PL_CALENDAR_H_ELEM_NO_COMPONENT_ALERT.'");
                return;
            }
            
            params["page"] = el_page.value;
            params["component"] = el_comp.value;
            params["rubrikator"] = sbGetE("rubrikator").checked ? 1 : 0;
            params["filter"] = sbGetE("filter").checked ? 1 : 0;
            
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
        
        function choosePage()
        {
            var p_url = sbGetE("page").value;
            p_url = p_url.split("&");
            
			var comp_el = sbGetE("component");
			while (comp_el.childNodes.length > 1)
                comp_el.removeChild(comp_el.childNodes[1]);

            var res = sbLoadSync(sb_cms_empty_file + "?event=pl_calendar_elem_calendar_components&p_url=" + p_url[0]);

            if (res)
            {
                comp_el.remove(0);
                
                res = eval("(" + res + ")");
                var oGroup = false;
            	for(var i = 0; i < res.keys.length; i++)
            	{
            	    if (res.values[i].charAt(0) == "-")
            	    {
            	        oGroup = document.createElement("OPTGROUP");
            	        comp_el.appendChild(oGroup);
            	        oGroup.label = res.values[i].substr(1); 
            	    }
            	    else
            	    {
	            	    var oOption = document.createElement("OPTION");
	            	    if (oGroup == false)
	                        comp_el.appendChild(oOption);
	                    else
	                        oGroup.appendChild(oOption);

	                    oOption.value = res.keys[i];
	                    oOption.innerHTML = res.values[i];
	                }
            	}
            }
        }
    </script>
    <br><br>';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '200';
    
    $layout->addHeader(PL_CALENDAR_H_ELEM_PROPS_TAB);
    
    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.ct_id, temps.ct_title FROM sb_categs categs, sb_catlinks links, sb_calendar_temps temps WHERE temps.ct_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_calendar" ORDER BY categs.cat_left, temps.ct_title');
    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }
    }
       
    if (count($options) > 0)
    { 
    	$fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    }
    else 
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_CALENDAR_H_ELEM_NO_TEMPS_MSG.'</div>', '', '', false);    
    }

    $layout->addField(PL_CALENDAR_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());
       
    $fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;" onchange="choosePage();"', false);
    $fld->mHTML = '<div class="hint_div">'.PL_CALENDAR_H_ELEM_PAGE_HINT.'</div>';
    
    $layout->addField(PL_CALENDAR_H_ELEM_PAGE, $fld);   
    $layout->addField('', new sbLayoutDelim());

    $components = array('' => ' --- ');
    if (isset($params['page']))
    {
    	$components = fCalendar_Get_Elem_Components($params['page']);
    }

    $fld = new sbLayoutSelect($components, 'component');
    $fld->mSelOptions = array((isset($params['component']) && $params['component'] != '' ? $params['component'] : ''));
    $fld->mHTML = '<div class="hint_div">'.PL_CALENDAR_H_ELEM_COMPONENT_HINT.'</div>';
    $layout->addField(PL_CALENDAR_H_ELEM_COMPONENT, $fld);
    
    $layout->addField('', new sbLayoutDelim());
    
    $layout->addField(PL_CALENDAR_H_ELEM_RUBRIKATOR, new sbLayoutInput('checkbox', '1', 'rubrikator', '', (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_CALENDAR_H_ELEM_FILTER, new sbLayoutInput('checkbox', '1', 'filter', '', (isset($params['filter']) && $params['filter'] == 1 ? 'checked="checked"' : '')));
    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseElem();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    
    $layout->show();
}

/********************************** функции получения информации по элементам модуля ***********************************/

/**
 * Вывод календаря
 * 
 */
function fCalendar_Elem_Info($params)
{
    $component = '';
    
    $comp_ident = explode('::', $params['component']);
    
    if (count($comp_ident) > 2)
    {
	    $comp_ident = $comp_ident[1];
	    $elems = $_SESSION['sbPlugins']->getElems();
	    
	    if (isset($elems[$comp_ident]))
	    {
	    	$component = explode('|', $elems[$comp_ident]['name']);
	    	$component = $component[0].' -&gt; '.$component[1];	    
	    }
    }
    
    $res = sql_param_query('SELECT categs.cat_title, temps.ct_title FROM sb_categs categs, sb_catlinks links, sb_calendar_temps temps
							WHERE temps.ct_id=?d AND links.link_el_id=temps.ct_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_calendar"', $params['temp_id']);
    
    echo '<div style="padding-bottom: 5px;"><b>'.PL_CALENDAR_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_CALENDAR_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_CALENDAR_H_INFO_PAGE.':</b> '.$params['page'].'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_CALENDAR_H_INFO_COMPONENT.':</b> '.$component.'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_CALENDAR_H_INFO_RUBRIKATOR.':</b> '.(isset($params['rubrikator']) && $params['rubrikator'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_CALENDAR_H_INFO_FILTER.':</b> '.(isset($params['filter']) && $params['filter'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/********************************** функции получения элементов модуля ***********************************/

/**
 * Вывод календаря
 * 
 */
function fCalendar_Elem($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_calendar/prog/pl_calendar.php';\n
        fCalendar_Elem_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}
?>