<?php
function fCalendar_Get($args)
{
    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['ct_title'].'</a></b>';

    return $result;
}

function fCalendar_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	$elems = new sbElements('sb_calendar_temps', 'ct_id', 'ct_title', 'fCalendar_Get', 'pl_calendar_init', 'pl_calendar');

	$elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
	$elems->mCategsDeleteWithElementsMenu = true;

	$elems->addSorting(PL_CALENDAR_SORT_BY_NAME, 'ct_title');

    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;
    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_calendar_edit';
    $elems->mElemsEditDlgWidth = 900;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_calendar_edit';
    $elems->mElemsAddDlgWidth = 900;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mElemsUseLinks = false;

	$elems->init();
}

function fCalendar_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_calendar'))
		return;

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
   		$result = sql_param_query('SELECT ct_title, ct_lang, ct_top, ct_num, ct_fields, ct_empty, ct_delim, ct_bottom
   		                           FROM sb_calendar_temps WHERE ct_id=?d', $_GET['id']);

   		if ($result)
	    {
        	list($ct_title, $ct_lang, $ct_top, $ct_num, $ct_fields, $ct_empty, $ct_delim, $ct_bottom) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_CALENDAR_EDIT_ERROR, true, 'warning');
	        return;
	    }

	    if ($ct_fields != '')
	        $ct_fields = unserialize($ct_fields);
	    else
	        $ct_fields = array();
	}
	elseif (count($_POST) > 0)
	{
		$ct_fields = array();

		extract($_POST);

    	if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
	    $ct_title = '';
	    $ct_top = PL_CALENDAR_EDIT_TOP_DEFAULT;
	    $ct_num = PL_CALENDAR_EDIT_NUM_DEFAULT;
	    $ct_empty = PL_CALENDAR_EDIT_EMPTY_DEFAULT;
	    $ct_delim = PL_CALENDAR_EDIT_DELIM_DEFAULT;
	    $ct_bottom = PL_CALENDAR_EDIT_BOTTOM_DEFAULT;

	    $ct_lang = SB_CMS_LANG;

	    $ct_fields = array();
	    $ct_fields['prev_year'] = PL_CALENDAR_EDIT_PREV_YEAR_DEFAULT;
	    $ct_fields['prev_month'] = PL_CALENDAR_EDIT_PREV_MONTH_DEFAULT;
	    $ct_fields['year'] = PL_CALENDAR_EDIT_YEAR_DEFAULT;
	    $ct_fields['month'] = PL_CALENDAR_EDIT_MONTH_DEFAULT;
	    $ct_fields['next_year'] = PL_CALENDAR_EDIT_NEXT_YEAR_DEFAULT;
	    $ct_fields['next_month'] = PL_CALENDAR_EDIT_NEXT_MONTH_DEFAULT;

	    $ct_fields['num'] = PL_CALENDAR_EDIT_DAY_DEFAULT;
	    $ct_fields['num_active'] = PL_CALENDAR_EDIT_DAY_ACTIVE_DEFAULT;
	    $ct_fields['cur_num'] = PL_CALENDAR_EDIT_CUR_DAY_DEFAULT;
	    $ct_fields['cur_num_active'] = PL_CALENDAR_EDIT_CUR_DAY_ACTIVE_DEFAULT;
	    $ct_fields['sat_num'] = PL_CALENDAR_EDIT_SAT_DAY_DEFAULT;
	    $ct_fields['sat_num_active'] = PL_CALENDAR_EDIT_SAT_DAY_ACTIVE_DEFAULT;
		$ct_fields['sun_num'] = PL_CALENDAR_EDIT_SUN_DAY_DEFAULT;
	    $ct_fields['sun_num_active'] = PL_CALENDAR_EDIT_SUN_DAY_ACTIVE_DEFAULT;
	    $ct_fields['sel_num'] = PL_CALENDAR_EDIT_SEL_DAY_DEFAULT;

	    $_GET['id'] = '';
	}

    echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("ct_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_CALENDAR_NO_TITLE_MSG.'");
          	         return false;
                }
            }';

	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_calendar_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_CALENDAR_EDIT_TAB1);
	$layout->addHeader(PL_CALENDAR_EDIT_TAB1);

	$layout->addField(PL_CALENDAR_EDIT_TITLE, new sbLayoutInput('text', $ct_title, 'ct_title', '', 'style="width:520px;"', true));

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'ct_lang');
	$fld->mSelOptions = array($ct_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_CALENDAR_EDIT_LANG_LABEL.'</div>';
	$layout->addField(PL_CALENDAR_EDIT_LANG, $fld);

	$layout->addTab(PL_CALENDAR_EDIT_TAB2);
	$layout->addHeader(PL_CALENDAR_EDIT_TAB2);

	$fld = new sbLayoutTextarea($ct_fields['prev_year'], 'ct_fields[prev_year]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{LONG_YEAR}', '{SHORT_YEAR}');
	$fld->mValues = array(PL_CALENDAR_EDIT_PREV_YEAR_LINK_TAG, KERNEL_YEAR_4_TAG, KERNEL_YEAR_2_TAG);
	$layout->addField(PL_CALENDAR_EDIT_PREV_YEAR, $fld);

	$fld = new sbLayoutTextarea($ct_fields['prev_month'], 'ct_fields[prev_month]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{MONTH}', '{MONTH_TEXTUAL}');
	$fld->mValues = array(PL_CALENDAR_EDIT_PREV_MONTH_LINK_TAG, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG);
	$layout->addField(PL_CALENDAR_EDIT_PREV_MONTH, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($ct_fields['year'], 'ct_fields[year]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{LONG_YEAR}', '{SHORT_YEAR}');
	$fld->mValues = array(PL_CALENDAR_EDIT_YEAR_LINK_TAG, KERNEL_YEAR_4_TAG, KERNEL_YEAR_2_TAG);
	$layout->addField(PL_CALENDAR_EDIT_YEAR, $fld);

	$fld = new sbLayoutTextarea($ct_fields['month'], 'ct_fields[month]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{MONTH}', '{MONTH_TEXTUAL}');
	$fld->mValues = array(PL_CALENDAR_EDIT_MONTH_LINK_TAG, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG);
	$layout->addField(PL_CALENDAR_EDIT_MONTH, $fld);

    $layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($ct_fields['next_year'], 'ct_fields[next_year]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{LONG_YEAR}', '{SHORT_YEAR}');
	$fld->mValues = array(PL_CALENDAR_EDIT_NEXT_YEAR_LINK_TAG, KERNEL_YEAR_4_TAG, KERNEL_YEAR_2_TAG);
	$layout->addField(PL_CALENDAR_EDIT_NEXT_YEAR, $fld);

	$fld = new sbLayoutTextarea($ct_fields['next_month'], 'ct_fields[next_month]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{MONTH}', '{MONTH_TEXTUAL}');
	$fld->mValues = array(PL_CALENDAR_EDIT_NEXT_MONTH_LINK_TAG, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG);
	$layout->addField(PL_CALENDAR_EDIT_NEXT_MONTH, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($ct_fields['num'], 'ct_fields[num]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_DAY, $fld);

	$fld = new sbLayoutTextarea($ct_fields['num_active'], 'ct_fields[num_active]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY_LINK_TAG, PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_DAY_ACTIVE, $fld);

	$fld = new sbLayoutTextarea($ct_fields['cur_num'], 'ct_fields[cur_num]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_CUR_DAY, $fld);

	$fld = new sbLayoutTextarea($ct_fields['cur_num_active'], 'ct_fields[cur_num_active]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY_LINK_TAG, PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_CUR_DAY_ACTIVE, $fld);

	$fld = new sbLayoutTextarea($ct_fields['sat_num'], 'ct_fields[sat_num]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_SAT_DAY, $fld);

	$fld = new sbLayoutTextarea($ct_fields['sat_num_active'], 'ct_fields[sat_num_active]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY_LINK_TAG, PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_SAT_DAY_ACTIVE, $fld);

	$fld = new sbLayoutTextarea($ct_fields['sun_num'], 'ct_fields[sun_num]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_SUN_DAY, $fld);

	$fld = new sbLayoutTextarea($ct_fields['sun_num_active'], 'ct_fields[sun_num_active]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY_LINK_TAG, PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_SUN_DAY_ACTIVE, $fld);

	$fld = new sbLayoutTextarea($ct_fields['sel_num'], 'ct_fields[sel_num]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{LINK}', '{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY_LINK_TAG, PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_SEL_DAY, $fld);

	$layout->addTab(PL_CALENDAR_EDIT_TAB3);
	$layout->addHeader(PL_CALENDAR_EDIT_TAB3);

	$fld = new sbLayoutTextarea($ct_top, 'ct_top', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array('{PREV_YEAR}', '{PREV_MONTH}', '{YEAR}', '{MONTH}', '{NEXT_MONTH}', '{NEXT_YEAR}');
	$fld->mValues = array(PL_CALENDAR_EDIT_PREV_YEAR, PL_CALENDAR_EDIT_PREV_MONTH, PL_CALENDAR_EDIT_YEAR, PL_CALENDAR_EDIT_MONTH, PL_CALENDAR_EDIT_NEXT_MONTH, PL_CALENDAR_EDIT_NEXT_YEAR);
	$layout->addField(PL_CALENDAR_EDIT_TOP, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($ct_num, 'ct_num', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array('{DAY}');
	$fld->mValues = array(PL_CALENDAR_EDIT_DAY);
	$layout->addField(PL_CALENDAR_EDIT_NUM, $fld);

	$fld = new sbLayoutTextarea($ct_empty, 'ct_empty', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_CALENDAR_EDIT_EMPTY, $fld);

	$fld = new sbLayoutTextarea($ct_delim, 'ct_delim', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_CALENDAR_EDIT_DELIM, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($ct_bottom, 'ct_bottom', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array('{PREV_YEAR}', '{PREV_MONTH}', '{YEAR}', '{MONTH}', '{NEXT_MONTH}', '{NEXT_YEAR}');
	$fld->mValues = array(PL_CALENDAR_EDIT_PREV_YEAR, PL_CALENDAR_EDIT_PREV_MONTH, PL_CALENDAR_EDIT_YEAR, PL_CALENDAR_EDIT_MONTH, PL_CALENDAR_EDIT_NEXT_MONTH, PL_CALENDAR_EDIT_NEXT_YEAR);
	$layout->addField(PL_CALENDAR_EDIT_BOTTOM, $fld);

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_calendar', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_calendar', 'design_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fCalendar_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_calendar'))
		return;

    if (!isset($_GET['id']))
        $_GET['id'] = '';

    $ct_fields = array();

    extract($_POST);

    if ($ct_title == '')
    {
        sb_show_message(PL_CALENDAR_NO_TITLE_MSG, false, 'warning');
        fCalendar_Edit();
        return;
    }

    $row['ct_title'] = $ct_title;
    $row['ct_lang'] = $ct_lang;
    $row['ct_top'] = $ct_top;
    $row['ct_num'] = $ct_num;
    $row['ct_empty'] = $ct_empty;
    $row['ct_delim'] = $ct_delim;
    $row['ct_bottom'] = $ct_bottom;
    $row['ct_fields'] = serialize($ct_fields);

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT ct_title FROM sb_calendar_temps WHERE ct_id=?d', $_GET['id']);
	    if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_calendar_temps SET ?a WHERE ct_id=?d', $row, $_GET['id'], sprintf(PL_CALENDAR_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_calendar_temps', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem('design_edit');
    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_CALENDAR_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_CALENDAR_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fCalendar_Edit();
    		    return;
    	    }
    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	    $row['st_id'] = intval($_GET['id']);

            $html_str = fCalendar_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fCalendar_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_CALENDAR_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_CALENDAR_EDIT_SYSTEMLOG_ERROR, $ct_title), SB_MSG_WARNING);

            fCalendar_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_calendar_temps SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id, 'design_edit'))
    		{
                sbQueryCache::updateTemplate('sb_calendar_temps', $id);
        		sb_add_system_message(sprintf(PL_CALENDAR_ADD_OK, $ct_title));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_calendar_temps WHERE ct_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_CALENDAR_ADD_ERROR, $ct_title), false, 'warning');
            sb_add_system_message(sprintf(PL_CALENDAR_ADD_SYSTEMLOG_ERROR, $ct_title), SB_MSG_WARNING);

            fCalendar_Edit();
		    return;
	    }
	}
}
?>