<?php
function fCalendar_Elem_List($el_id, $temp_id, $params, $tag_id)
{
	if ($GLOBALS['sbCache']->check('pl_calendar', $tag_id, array($el_id, $temp_id, $params)))
        return;

	//$res_temp = sql_param_query('SELECT ct_lang, ct_top, ct_num, ct_empty, ct_delim, ct_bottom, ct_fields  
    //			FROM sb_calendar_temps WHERE ct_id=?d', $temp_id);
    $res_temp = sbQueryCache::getTemplate('sb_calendar_temps', $temp_id);

    if (!$res_temp)
    {
    	$GLOBALS['sbCache']->save('pl_calendar', '');
        return;
    }
    
    list($ct_lang, $ct_top, $ct_num, $ct_empty, $ct_delim, $ct_bottom, $ct_fields) = $res_temp[0];
    
    if ($ct_fields != '')
    	$ct_fields = unserialize($ct_fields);
    else
    	$ct_fields = array();
    	
    $params = unserialize(stripslashes($params));
    $tmp = explode('::', $params['component']);
    
    $component_fields = array();
    $component_fields['tag'] = $tmp[0];
    $component_fields['ident'] = $tmp[1];
    $component_fields['link'] = $tmp[2];
    $component_fields['get_func'] = $tmp[3];
    $component_fields['get_func_file'] = $tmp[4];
    
    $now = time();
    $now_year = sb_date('Y', time());
    $now_month = sb_date('n', time());

    if (isset($_GET['sb_year']))
    {
    	$year = intval($_GET['sb_year']);
    }
    else 
    {
    	$year = sb_date('Y', $now);
    }
    
	if (isset($_GET['sb_month']))
    {
    	$month = intval($_GET['sb_month']);
    }
    else 
    {
    	$month = sb_date('n', $now);
    }
    
    $today = sb_date('j', $now);
	if (isset($_GET['sb_day']))
    {
    	$day = intval($_GET['sb_day']);
    }
    else 
    {
    	$day = $today;
    }

    $get_file_path = trim(str_replace(array('http', 'ftp', 'https', '://', ':\\\\'), array('', '', '', '', ''), strtolower($component_fields['get_func_file'])), '\\/');
    @include_once SB_CMS_PL_PATH.'/'.$get_file_path;
    
    if (!function_exists($component_fields['get_func']))
    {
    	$GLOBALS['sbCache']->save('pl_calendar', '');
    	return;
    }
   
    // получаем числа, за которые есть элементы в связанном компоненте
    @include_once SB_CMS_PL_PATH.'/pl_pages/pl_pages.inc.php';
    $page_id = fPages_Get_Page_By_Url($params['page']);
     
    if ($component_fields['link'] == 'temp')
    {
    	$res = sql_param_query('SELECT p_temp_id FROM sb_pages WHERE p_id=?d', $page_id);
    	if ($res)
    	{
    		$page_id = $res[0][0];
    	}
    	else 
    	{
    		$page_id = -1;
    	}
    }

    $sel_days = array();
    
   	$res = sql_param_query('SELECT e_params FROM sb_elems WHERE e_tag=? AND e_ident=? AND e_link=? AND e_p_id=?d', '{'.$component_fields['tag'].'}', $component_fields['ident'], $component_fields['link'], $page_id);
    if ($res)
    {
    	$sel_days = $component_fields['get_func']($year, $month, $res[0][0], $params['rubrikator'], $params['filter']);
    }

    // вывод календаря
    $result = '';
	list($more_page, $more_ext) = sbGetMorePage($params['page']);
	
	$prev_year = '';
	$prev_month = '';
	$next_year = '';
	$next_month = '';
	$cur_year = '';
	$cur_month = '';
	
    if (isset($ct_fields['prev_year']) && $year - 1 > $now_year - 100)
    {
    	$prev_year = sb_parse_date(mktime(12, 0, 0, 1, 1, $year - 1), $ct_fields['prev_year'], $ct_lang);
    	
    	$href = $more_page;
        if (sbPlugins::getSetting('sb_static_urls') == 1)
        {
            // ЧПУ
            $href .= 'y'.($year - 1).($more_ext != 'php' ? '.'.$more_ext : '/');
        }
        else
        {
            $href .= '?sb_year='.($year - 1);
        }

        $prev_year = str_replace('{LINK}', $href, $prev_year);
    }
    
	if (isset($ct_fields['prev_month']))
    {
    	$month_num = $month;
    	$year_num = $year;

    	if ($month_num == 1)
    	{
    		$month_num = 12;
    		$year_num--;	
    	}
    	else 
    	{
    		$month_num--;
    	}
    	
    	if ($year_num > $now_year - 100)
    	{
	    	$prev_month = sb_parse_date(mktime(12, 0, 0, $month_num, 1, $year_num), $ct_fields['prev_month'], $ct_lang, true);
	    	
	    	$href = $more_page;
	        if (sbPlugins::getSetting('sb_static_urls') == 1)
	        {
	            // ЧПУ
	            $href .= 'y'.$year_num.'/m'.($month_num < 10 ? '0'.$month_num : $month_num).($more_ext != 'php' ? '.'.$more_ext : '/');
	        }
	        else
	        {
	            $href .= '?sb_year='.$year_num.'&sb_month='.$month_num;
	        }
	
	        $prev_month = str_replace('{LINK}', $href, $prev_month);
    	}
    }
  
	if (isset($ct_fields['next_year']) && $year + 1 < $now_year + 100)
    {
    	$next_year = sb_parse_date(mktime(12, 0, 0, 1, 1, $year + 1), $ct_fields['next_year'], $ct_lang);

    	$href = $more_page;
        if (sbPlugins::getSetting('sb_static_urls') == 1)
        {
            // ЧПУ
            $href .= 'y'.($year + 1).($more_ext != 'php' ? '.'.$more_ext : '/');
        }
        else
        {
            $href .= '?sb_year='.($year + 1);
        }

        $next_year = str_replace('{LINK}', $href, $next_year);
    }

	if (isset($ct_fields['next_month']))
    {
    	$month_num = $month;
    	$year_num = $year;

    	if ($month_num == 12)
    	{
    		$month_num = 1;
    		$year_num++;	
    	}
    	else 
    	{
    		$month_num++;
    	}
    	
    	if ($year_num < $now_year + 100)
    	{
	    	$next_month = sb_parse_date(mktime(12, 0, 0, $month_num, 1, $year_num), $ct_fields['next_month'], $ct_lang, true);
	    	
	    	$href = $more_page;
	        if (sbPlugins::getSetting('sb_static_urls') == 1)
	        {
	            // ЧПУ
	            $href .= 'y'.$year_num.'/m'.($month_num < 10 ? '0'.$month_num : $month_num).($more_ext != 'php' ? '.'.$more_ext : '/');
	        }
	        else
	        {
	            $href .= '?sb_year='.$year_num.'&sb_month='.$month_num;
	        }
	
	        $next_month = str_replace('{LINK}', $href, $next_month);
    	}
    }
    
	if (isset($ct_fields['year']))
    {
    	$cur_year = sb_parse_date(mktime(12, 0, 0, 1, 1, $year), $ct_fields['year'], $ct_lang);

    	$href = $more_page;
    	if (sbPlugins::getSetting('sb_static_urls') == 1)
        {
            // ЧПУ
            $href .= 'y'.$year.($more_ext != 'php' ? '.'.$more_ext : '/');
        }
        else
        {
            $href .= '?sb_year='.$year;
        }

        $cur_year = str_replace('{LINK}', $href, $cur_year);
    }
    
	if (isset($ct_fields['month']))
    {
    	$cur_month = sb_parse_date(mktime(12, 0, 0, $month, 1, $year), $ct_fields['month'], $ct_lang, true);
	    	
	    $href = $more_page;
	    if (sbPlugins::getSetting('sb_static_urls') == 1)
	    {
	        // ЧПУ
	        $href .= 'y'.$year.'/m'.($month < 10 ? '0'.$month : $month).($more_ext != 'php' ? '.'.$more_ext : '/');
	    }
	    else
	    {
	        $href .= '?sb_year='.$year.'&sb_month='.$month;
	    }
	
	    $cur_month = str_replace('{LINK}', $href, $cur_month);
    }
    
    $result .= str_replace(array('{PREV_YEAR}', '{PREV_MONTH}', '{NEXT_MONTH}', '{NEXT_YEAR}', '{YEAR}', '{MONTH}'), 
    					   array($prev_year, $prev_month, $next_month, $next_year, $cur_year, $cur_month), 
    					   $ct_top);
    
    //вывод календарной сетки
    $first_day_info = getdate(mktime(12, 0, 0, $month, 1, $year));
    $first_week_day = $first_day_info['wday'] - 1;
	if ($first_week_day == -1)
    {
        $first_week_day = 6;
    }
    
	for ($i = 0; $i < $first_week_day; $i++) 
    { 
        $result .= $ct_empty;
    }
    
    $last_day = sb_get_last_day($month, $year);
	
	if (sbPlugins::getSetting('sb_static_urls') == 1)
    {
        // ЧПУ
        $more_page .= 'y'.$year.'/m'.($month < 10 ? '0'.$month : $month);
    }
    else
    {
        $more_page .= '?sb_year='.$year.'&sb_month='.$month;
    }
    
    $wday = $first_week_day;
    $i = 1;
    while ($i <= $last_day) 
    {   
        if ($wday == 0 && $i != 1) 
        { 
            $result .= $ct_delim;
        }
        
        $num = '';
        $num_temp = '';
        $num_active_temp = '';
        
        if ($i == $day && isset($_GET['sb_day']))
        {
        	// выбранный день
        	$num_temp = isset($ct_fields['sel_num']) ? $ct_fields['sel_num'] : ''; 
        	$num_active_temp = isset($ct_fields['sel_num']) ? $ct_fields['sel_num'] : ''; 
        }
        else
        {
            if($i == $today && $year == $now_year && $month == $now_month)
            {
                // текущий день
            	$num_temp = isset($ct_fields['cur_num']) ? $ct_fields['cur_num'] : ''; 
        		$num_active_temp = isset($ct_fields['cur_num_active']) ? $ct_fields['cur_num_active'] : '';
            }
            else
            {
                if($wday == 5)
                {
                    // суббота
            		$num_temp = isset($ct_fields['sat_num']) ? $ct_fields['sat_num'] : ''; 
        			$num_active_temp = isset($ct_fields['sat_num_active']) ? $ct_fields['sat_num_active'] : '';
                }
                elseif($wday == 6)
                {
                    // воскресенье
            		$num_temp = isset($ct_fields['sun_num']) ? $ct_fields['sun_num'] : ''; 
        			$num_active_temp = isset($ct_fields['sun_num_active']) ? $ct_fields['sun_num_active'] : '';
                }
                else
                {
                    // обычный день 
                    $num_temp = isset($ct_fields['num']) ? $ct_fields['num'] : ''; 
        			$num_active_temp = isset($ct_fields['num_active']) ? $ct_fields['num_active'] : '';
                }
            }
        }

    	if (in_array($i, $sel_days))
        {
        	//ссылка
            if (sbPlugins::getSetting('sb_static_urls') == 1)
		    {
		        // ЧПУ
                $href = $more_page.'/d'.($i < 10 ? '0'.$i : $i).($more_ext != 'php' ? '.'.$more_ext : '/');
		    }
		    else 
		    {
		    	$href = $more_page.'&sb_day='.$i;
		    }
			    
            $num = str_replace(array('{LINK}', '{DAY}'), array($href, $i), $num_active_temp);
        }
        else 
        {
            $num = str_replace('{DAY}', $i, $num_temp);    	
        }
                    
        $result .= str_replace('{DAY}', $num, $ct_num);
        
        $wday = ($wday + 1) % 7;
        $i++;
    }
    
    if ($i < 35 && $wday > 0)
    {   
        for ($j = $wday; $j < 7; $j++)
        {   
            $result .= $ct_empty;
        }
    }					   
    					   
    $result .= str_replace(array('{PREV_YEAR}', '{PREV_MONTH}', '{NEXT_MONTH}', '{NEXT_YEAR}', '{YEAR}', '{MONTH}'), 
    					   array($prev_year, $prev_month, $next_month, $next_year, $cur_year, $cur_month), 
    					   $ct_bottom);
    					   
    $result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);
    $GLOBALS['sbCache']->save('pl_calendar', $result);
}
?>