<?php
require_once(SB_CMS_LANG_PATH.'/pl_clouds.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_clouds', PL_CLOUDS_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_CLOUDS_H_PLUGIN_GENERAL.'>'.PL_CLOUDS_H_PLUGIN_MENU_ITEM, 'init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fClouds_Init', 'design_read', PL_CLOUDS_H_PLUGIN_INIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fClouds_Edit', 'design_read', PL_CLOUDS_H_PLUGIN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fClouds_Edit_Submit', 'design_edit', PL_CLOUDS_H_PLUGIN_EDIT_TITLE);
}

$_SESSION['sbPlugins']->addSystemEvent('load_tags', 'fClouds_Load_Tags');

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);

?>