<?php
function fClouds_Get($args)
{
    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['ct_title'].'</a></b>';
    
    return $result;
}

function fClouds_Init()
{
    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
    
    $elems = new sbElements('sb_clouds_temps', 'ct_id', 'ct_title', 'fClouds_Get', 'pl_clouds_init', 'pl_clouds');
    
    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
	$elems->mCategsDeleteWithElementsMenu = true;
	
    $elems->addSorting(PL_CLOUDS_SORT_BY_NAME, 'ct_title');
    
    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;
    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;
    
    $elems->mElemsEditEvent =  'pl_clouds_edit';
    $elems->mElemsEditDlgWidth = 900;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_clouds_edit';
    $elems->mElemsAddDlgWidth = 900;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mElemsUseLinks = false;
	
	$elems->init();
}

function fClouds_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_clouds'))
		return;
		
    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
   		$result = sql_query('SELECT ct_title, ct_perpage, ct_pagelist_id, ct_count, ct_top, ct_element, ct_empty, ct_delim, ct_bottom, ct_font_from, ct_font_to, ct_size_from, ct_size_to, ct_strip_words, ct_color, ct_color_percent
   		                           FROM sb_clouds_temps WHERE ct_id=?d', $_GET['id']);
   		
   		if ($result)
	    {
        	list($ct_title, $ct_perpage, $ct_pagelist_id, $ct_count, $ct_top, $ct_element, $ct_empty, $ct_delim, $ct_bottom, $ct_font_from, $ct_font_to, $ct_size_from, $ct_size_to, $ct_strip_words, $ct_color, $ct_color_percent) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_CLOUDS_EDIT_ERROR, true, 'warning');
	        return;
	    }
	}
	elseif (count($_POST) > 0)
	{
		$ct_pagelist_id = 0;
		
    	extract($_POST);
    	if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else 
	{
	    $ct_title = $ct_top = $ct_element = $ct_empty = $ct_delim = $ct_bottom = '';
		$ct_pagelist_id = 0;
	    $ct_perpage = 0;
	    $ct_font_from = 8;
		$ct_font_to = 14;
		$ct_size_from = 1;
		$ct_size_to = 100;
		$ct_strip_words = PL_CLOUDS_STRIP_WORDS;
		$ct_color = '#003366';
		$ct_color_percent = '50';
	    $ct_count = 1;
	    
	    $_GET['id'] = '';
	}
	
    echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("ct_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_CLOUDS_NO_TITLE_MSG.'");
          	         return false;
                }
                
                var el_from = sbGetE("ct_font_from");
                var el_to = sbGetE("ct_font_to");
                if (parseInt(el_from.value) > parseInt(el_to.value))
                {
                	alert("'.PL_CLOUDS_FONTS_ERROR_MSG.'");
                	return false;
                }
                
                el_from = sbGetE("ct_size_from");
                el_to = sbGetE("ct_size_to");
                if (parseInt(el_from.value) > parseInt(el_to.value))
                {
                	alert("'.PL_CLOUDS_SIZES_ERROR_MSG.'");
                	return false;
                }
            }';
    
	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script>';
	
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	
	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_clouds_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_CLOUDS_EDIT_TAB1);
	$layout->addHeader(PL_CLOUDS_EDIT_TAB1);

	$layout->addField(PL_CLOUDS_EDIT_TITLE, new sbLayoutInput('text', $ct_title, 'ct_title', '', 'style="width:520px;"', true));
	
	fPager_Design_Get($layout, $ct_pagelist_id, 'ct_pagelist_id', $ct_perpage, 'ct_perpage');
	
	$layout->addField('', new sbLayoutDelim());
	
	$fld = new sbLayoutInput('text', $ct_font_from, 'ct_font_from', 'spin_ct_font_from', 'style="width:100px;"');
	$fld->mMinValue = 0;
	$layout->addField(PL_CLOUDS_EDIT_FONT_FROM, $fld);
	
	$fld = new sbLayoutInput('text', $ct_font_to, 'ct_font_to', 'spin_ct_font_to', 'style="width:100px;"');
	$fld->mMinValue = 0;
	$layout->addField(PL_CLOUDS_EDIT_FONT_TO, $fld);
	
	$layout->addField('', new sbLayoutDelim());
	
	$fld = new sbLayoutInput('text', $ct_size_from, 'ct_size_from', 'spin_ct_size_from', 'style="width:100px;"');
	$fld->mMinValue = 0;
	$layout->addField(PL_CLOUDS_EDIT_SIZE_FROM, $fld);
	
	$fld = new sbLayoutInput('text', $ct_size_to, 'ct_size_to', 'spin_ct_size_to', 'style="width:100px;"');
	$fld->mMinValue = 0;
	$layout->addField(PL_CLOUDS_EDIT_SIZE_TO, $fld);
	
	$layout->addField('', new sbLayoutDelim());
	
	$layout->addField(PL_CLOUDS_EDIT_COLOR, new sbLayoutColor($ct_color, 'ct_color'));
	
	$fld = new sbLayoutInput('text', $ct_color_percent, 'ct_color_percent', 'spin_ct_color_percent', 'style="width:100px;"');
	$fld->mMinValue = 0;
	$fld->mMaxValue = 100;
	$layout->addField(PL_CLOUDS_EDIT_COLOR_PERCENT, $fld);
	
	$layout->addField('', new sbLayoutDelim());
	
	$layout->addField(PL_CLOUDS_EDIT_STRIP_WORDS, new sbLayoutTextarea($ct_strip_words, 'ct_strip_words', '', 'style="width:100%;height:100px;"'));
	    
	$layout->addTab(PL_CLOUDS_EDIT_TAB2);
	$layout->addHeader(PL_CLOUDS_EDIT_TAB2);
	
	$layout->addField(PL_CLOUDS_EDIT_COUNT, new sbLayoutInput('text', $ct_count, 'ct_count', 'spin_ct_count', 'style="width:100px;"'));
	
	$fld = new sbLayoutTextarea($ct_top, 'ct_top', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array('{NUM_LIST}', '{ALL_COUNT}');
	$fld->mValues = array(PL_CLOUDS_EDIT_PAGELIST_TAG, PL_CLOUDS_EDIT_ALLNUM_TAG);
	$layout->addField(PL_CLOUDS_EDIT_TOP, $fld);
	
	$layout->addField('', new sbLayoutDelim());
	
	$fld = new sbLayoutTextarea($ct_element, 'ct_element', '', 'style="width:100%;height:250px;"');
	$fld->mTags = array('{ID}', '{TEXT}', '{COUNT}', '{LINK}', '{FONT_SIZE}', '{COLOR}');
	$fld->mValues = array(PL_CLOUDS_EDIT_ID_TAG, PL_CLOUDS_EDIT_TEXT_TAG, PL_CLOUDS_EDIT_COUNT_TAG, PL_CLOUDS_EDIT_LINK_TAG, 
	                      PL_CLOUDS_EDIT_FONT_SIZE_TAG, PL_CLOUDS_EDIT_COLOR_TAG, $fld);
	$layout->addField(PL_CLOUDS_EDIT_ELEMENT, $fld);
	
	$fld = new sbLayoutTextarea($ct_empty, 'ct_empty', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_CLOUDS_EDIT_EMPTY, $fld);
	
	$fld = new sbLayoutTextarea($ct_delim, 'ct_delim', '', 'style="width:100%;height:100px;"');
	$layout->addField(PL_CLOUDS_EDIT_DELIM, $fld);
	
	$layout->addField('', new sbLayoutDelim());
	
	$fld = new sbLayoutTextarea($ct_bottom, 'ct_bottom', '', 'style="width:100%;height:100px;"');
	$fld->mTags = array('{NUM_LIST}', '{ALL_COUNT}');
	$fld->mValues = array(PL_CLOUDS_EDIT_PAGELIST_TAG, PL_CLOUDS_EDIT_ALLNUM_TAG);
	$layout->addField(PL_CLOUDS_EDIT_BOTTOM, $fld);
	
	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_clouds', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_clouds', 'design_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
    
    $layout->show();
}

function fClouds_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_clouds'))
		return;
		
    if (!isset($_GET['id']))
        $_GET['id'] = '';
        
    $ct_pagelist_id = 0;
    
    extract($_POST);
    
    if ($ct_title == '')
    {
        sb_show_message(PL_CLOUDS_NO_TITLE_MSG, false, 'warning');
        fClouds_Edit();
        return;
    }

	if ($ct_font_from > $ct_font_to)
    {
        sb_show_message(PL_CLOUDS_FONTS_ERROR_MSG, false, 'warning');
        fClouds_Edit();
        return;
    }
    
	if ($ct_size_from > $ct_size_to)
    {
        sb_show_message(PL_CLOUDS_SIZES_ERROR_MSG, false, 'warning');
        fClouds_Edit();
        return;
    }
    
    $row['ct_title'] = $ct_title;
    $row['ct_pagelist_id'] = $ct_pagelist_id;
    $row['ct_perpage'] = $ct_perpage;
    $row['ct_count'] = $ct_count;
    $row['ct_top'] = $ct_top;
    $row['ct_element'] = $ct_element;
    $row['ct_empty'] = $ct_empty;
    $row['ct_delim'] = $ct_delim;
    $row['ct_bottom'] = $ct_bottom;
    $row['ct_font_from'] = $ct_font_from;
    $row['ct_font_to'] = $ct_font_to;
    $row['ct_size_from'] = $ct_size_from;
    $row['ct_size_to'] = $ct_size_to;
    $row['ct_strip_words'] = $ct_strip_words;
    $row['ct_color'] = $ct_color;
    $row['ct_color_percent'] = $ct_color_percent;

    if ($_GET['id'] != '')
	{
	    $res = sql_query('SELECT ct_title FROM sb_clouds_temps WHERE ct_id=?d', $_GET['id']);
	    if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

	        sql_query('LOCK TABLES sb_clouds_temps WRITE');
    	    sql_query('UPDATE sb_clouds_temps SET ?a WHERE ct_id=?d', $row, $_GET['id'], sprintf(PL_CLOUDS_EDIT_OK, $old_title));
            sql_query('UNLOCK TABLES');
            
            sbQueryCache::updateTemplate('sb_clouds_temps', $_GET['id']);
        	
            $footer_ar = fCategs_Edit_Elem('design_edit');
    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_CLOUDS_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_CLOUDS_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);
    
                fClouds_Edit();
    		    return;
    	    }
    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
    	    
    	    $row['st_id'] = intval($_GET['id']);
    	    
            $html_str = fClouds_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);
    	    
    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else 
    	    {
    	        fClouds_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_CLOUDS_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_CLOUDS_EDIT_SYSTEMLOG_ERROR, $ct_title), SB_MSG_WARNING);

            fClouds_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    sql_query('LOCK TABLES sb_clouds_temps WRITE');
	    if (sql_query('INSERT INTO sb_clouds_temps (?#) VALUES (?a)', array_keys($row), array_values($row)))
	    {
    		$id = sql_insert_id();
    		sql_query('UNLOCK TABLES');
    		if (fCategs_Add_Elem($id, 'design_edit'))
    		{
                sbQueryCache::updateTemplate('sb_clouds_temps', $id);
    			sb_add_system_message(sprintf(PL_CLOUDS_ADD_OK, $ct_title));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';
        		
        		$error = false;
    		}
    		else 
    		{
    		    sql_query('DELETE FROM sb_clouds_temps WHERE ct_id=?d', $id);
    		}
	    }
	    
	    if ($error)
	    {
	        sql_query('UNLOCK TABLES');
	        sb_show_message(sprintf(PL_CLOUDS_ADD_ERROR, $ct_title), false, 'warning');
            sb_add_system_message(sprintf(PL_CLOUDS_ADD_SYSTEMLOG_ERROR, $ct_title), SB_MSG_WARNING);

            fClouds_Edit();
		    return;
	    }
	}
}
?>