<?php
function fComments_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['ctl_title'].'</a></b>';

	return $result;
}

function fComments_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	$elems = new sbElements('sb_comments_temps_list', 'ctl_id', 'ctl_title', 'fComments_Get', 'pl_comments_init', 'pl_comments');

	$elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
	$elems->addSorting(PL_COMMENTS_DESIGN_SORT_BY_TITILE, 'ctl_title');

    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;
    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

	$elems->mElemsEditEvent =  'pl_comments_edit';
	$elems->mElemsEditDlgWidth = 900;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent = 'pl_comments_edit';
	$elems->mElemsAddDlgWidth = 900;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mCategsClosed = false;
	$elems->mElemsUseLinks = false;
	$elems->mCategsRubrikator = false;

	$elems->init();
}

function fComments_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_comments'))
		return;

	if(count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$res = sql_query('SELECT ctl_title, ctl_lang, ctl_perpage, ctl_pagelist_id, ctl_user_data_id, ctl_top, ctl_element, ctl_bottom, ctl_form, ctl_fields_temps, ctl_messages FROM sb_comments_temps_list WHERE ctl_id = ?d', $_GET['id']);

		list($ctl_title, $ctl_lang, $ctl_perpage, $ctl_pagelist_id, $ctl_user_data_id, $ctl_top, $ctl_element, $ctl_bottom, $ctl_form, $ctl_fields_temps, $ctl_messages) = $res[0];

		if ($ctl_fields_temps != '')
			$ctl_fields_temps = unserialize($ctl_fields_temps);
		else
			$ctl_fields_temps = array();

		if ($ctl_messages != '')
			$ctl_messages = unserialize($ctl_messages);
		else
			$ctl_messages = array();

		if(!isset($ctl_messages['rights_error']))
			$ctl_messages['rights_error'] = PL_COMMENTS_EDIT_MESSAGES_RIGHTS_ERROR;

		if(!isset($ctl_fields_temps['ctl_answer_top']))
			$ctl_fields_temps['ctl_answer_top'] = '';

		if(!isset($ctl_fields_temps['ctl_answer_bottom']))
			$ctl_fields_temps['ctl_answer_bottom'] = '';
		if(!isset($ctl_messages['edit_ok']))
			$ctl_messages['edit_ok'] = PL_COMMENTS_EDIT_MESSAGES_EDIT_OK;
		if(!isset($ctl_messages['edit_error']))
			$ctl_messages['edit_error'] = PL_COMMENTS_EDIT_MESSAGES_EDIT_ERROR;
		if(!isset($ctl_messages['auth_add_error']))
			$ctl_messages['auth_add_error'] = PL_COMMENTS_EDIT_MESSAGES_AUTH_ADD_ERROR;
		if(!isset($ctl_messages['auth_edit_error']))
			$ctl_messages['auth_edit_error'] = PL_COMMENTS_EDIT_MESSAGES_AUTH_EDIT_ERROR;
		if(!isset($ctl_messages['admin_subj_edit']))
			$ctl_messages['admin_subj_edit'] = '';
		if(!isset($ctl_messages['admin_text_edit']))
			$ctl_messages['admin_text_edit'] = '';
		if(!isset($ctl_fields_temps['c_date_el']))
			$ctl_fields_temps['c_date_el'] = PL_COMMENTS_EDIT_DESIGN_DATE_FORM;
		if(!isset($ctl_fields_temps['c_author_el']))
			$ctl_fields_temps['c_author_el'] = PL_COMMENTS_EDIT_DESIGN_AUTHOR_FORM;
		if(!isset($ctl_fields_temps['c_mail_el']))
			$ctl_fields_temps['c_mail_el'] = PL_COMMENTS_EDIT_DESIGN_EMAIL_FORM;
		if(!isset($ctl_fields_temps['c_subject_el']))
			$ctl_fields_temps['c_subject_el'] = PL_COMMENTS_EDIT_DESIGN_SUBJECT_FORM;
		if(!isset($ctl_fields_temps['c_text_el']))
			$ctl_fields_temps['c_text_el'] = PL_COMMENTS_EDIT_DESIGN_TEXT_FORM;
		if(!isset($ctl_fields_temps['c_file_el']))
			$ctl_fields_temps['c_file_el'] = PL_COMMENTS_EDIT_DESIGN_FILE_FORM;
		if(!isset($ctl_fields_temps['c_file_now_el']))
			$ctl_fields_temps['c_file_now_el'] = PL_COMMENTS_EDIT_DESIGN_FILE_NOW_FORM;
		if(!isset($ctl_fields_temps['c_captcha_code_el']))
			$ctl_fields_temps['c_captcha_code_el'] = PL_COMMENTS_EDIT_DESIGN_CAPTCHA_CODE_FORM;
		if(!isset($ctl_fields_temps['c_captcha_image_el']))
			$ctl_fields_temps['c_captcha_image_el'] = PL_COMMENTS_EDIT_DESIGN_CAPTCHA_IMG_FORM;
		if(!isset($ctl_fields_temps['ctl_edit_link']))
			$ctl_fields_temps['ctl_edit_link'] = PL_COMMENTS_EDIT_DESIGN_EDIT_LINK_FORM;

	}
	elseif(count($_POST) > 0)
	{
		$ctl_pagelist_id = -1;
		$ctl_user_data_id = -1;

		extract($_POST);
		if (!isset($_GET['id']))
		    $_GET['id'] = '';
	}
	else
	{
		$_GET['id'] = '';

		$ctl_title = $ctl_top = $ctl_element = $ctl_bottom = $ctl_form = '';
		$ctl_lang = SB_CMS_LANG;
		$ctl_pagelist_id = -1;
		$ctl_user_data_id = -1;
		$ctl_perpage = 10;

		$ctl_fields_temps = array();
		// поля
		$ctl_fields_temps['ctl_date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
		$ctl_fields_temps['ctl_author'] = '{VALUE}';
		$ctl_fields_temps['ctl_field_need_author'] = 0;
		$ctl_fields_temps['ctl_email'] = '{VALUE}';
		$ctl_fields_temps['ctl_field_need_email'] = 0;
		$ctl_fields_temps['ctl_subj'] = '{VALUE}';
		$ctl_fields_temps['ctl_field_need_subj'] = 0;
		$ctl_fields_temps['ctl_text'] = '{VALUE}';
		$ctl_fields_temps['ctl_field_need_text'] = 1;
		$ctl_fields_temps['ctl_file'] = '{VALUE}';
		$ctl_fields_temps['ctl_edit_link'] = PL_COMMENTS_EDIT_DESIGN_EDIT_LINK_FORM;
		$ctl_fields_temps['ctl_field_need_file'] = 0;

		$ctl_fields_temps['ctl_date_mes'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';
		$ctl_fields_temps['ctl_author_mes'] = '{VALUE}';
		$ctl_fields_temps['ctl_email_mes'] = '{VALUE}';
		$ctl_fields_temps['ctl_subj_mes'] = '{VALUE}';
		$ctl_fields_temps['ctl_text_mes'] = '{VALUE}';
		$ctl_fields_temps['ctl_file_mes'] = '{VALUE}';

		// цитаты
		$ctl_fields_temps['ctl_quote_top'] = '<div style=\'border: 1px dashed #000;background-color:#FFFF99;padding: 5px;\'>';
		$ctl_fields_temps['ctl_quote_bottom'] = '</div>';

		$ctl_fields_temps['ctl_answer_top'] = '<div style=\'margin-left:20px;\'>';
		$ctl_fields_temps['ctl_answer_bottom'] = '</div>';

		// настройки
		$ctl_fields_temps['ctl_sort'] = 0;
		$ctl_fields_temps['ctl_bb_codes'] = 1;
		$ctl_fields_temps['registred_users_edit_link'] = 1;
		$ctl_fields_temps['registred_users_add_only'] = 1;
		$ctl_fields_temps['ctl_files_ext'] = 'gif jpg png jpeg rar zip txt doc pdf xls ppt';
		$ctl_fields_temps['ctl_files_size'] = sbPlugins::getSetting('sb_files_max_upload_size');
		$ctl_fields_temps['c_date_el'] = PL_COMMENTS_EDIT_DESIGN_DATE_FORM;
		$ctl_fields_temps['c_author_el'] = PL_COMMENTS_EDIT_DESIGN_AUTHOR_FORM;
		$ctl_fields_temps['c_mail_el'] = PL_COMMENTS_EDIT_DESIGN_EMAIL_FORM;
		$ctl_fields_temps['c_subject_el'] = PL_COMMENTS_EDIT_DESIGN_SUBJECT_FORM;
		$ctl_fields_temps['c_text_el'] = PL_COMMENTS_EDIT_DESIGN_TEXT_FORM;
		$ctl_fields_temps['c_file_el'] = PL_COMMENTS_EDIT_DESIGN_FILE_FORM;
		$ctl_fields_temps['c_file_now_el'] = PL_COMMENTS_EDIT_DESIGN_FILE_NOW_FORM;
		$ctl_fields_temps['c_captcha_code_el'] = PL_COMMENTS_EDIT_DESIGN_CAPTCHA_CODE_FORM;
		$ctl_fields_temps['c_captcha_image_el'] = PL_COMMENTS_EDIT_DESIGN_CAPTCHA_IMG_FORM;

		// начало выделения полей
		$ctl_fields_temps['ctl_select_start'] = '<span style="color:red;">';
		$ctl_fields_temps['ctl_select_end'] = '</span>';

		// сообщения
		$ctl_messages = array();
		$ctl_messages['no_comments'] = PL_COMMENTS_EDIT_MESSAGES_NO_COMMENTS;
		$ctl_messages['add_ok'] = PL_COMMENTS_EDIT_MESSAGES_ADD_OK;
		$ctl_messages['edit_ok'] = PL_COMMENTS_EDIT_MESSAGES_EDIT_OK;
		$ctl_messages['fields_error'] = PL_COMMENTS_EDIT_MESSAGES_FIELDS_ERROR;
		$ctl_messages['file_size_error'] = PL_COMMENTS_EDIT_MESSAGES_FILE_SIZE_ERROR;
		$ctl_messages['file_ext_error'] = PL_COMMENTS_EDIT_MESSAGES_FILE_EXT_ERROR;
		$ctl_messages['file_error'] = PL_COMMENTS_EDIT_MESSAGES_FILE_ERROR;
		$ctl_messages['captcha_error'] = PL_COMMENTS_EDIT_MESSAGES_CAPTCHA_ERROR;
		$ctl_messages['add_error'] = PL_COMMENTS_EDIT_MESSAGES_ADD_ERROR;
		$ctl_messages['edit_error'] = PL_COMMENTS_EDIT_MESSAGES_EDIT_ERROR;
		$ctl_messages['rights_error'] = PL_COMMENTS_EDIT_MESSAGES_RIGHTS_ERROR;
		$ctl_messages['auth_add_error'] = PL_COMMENTS_EDIT_MESSAGES_AUTH_ADD_ERROR;
		$ctl_messages['auth_edit_error'] = PL_COMMENTS_EDIT_MESSAGES_AUTH_EDIT_ERROR;

		// письма
		$ctl_messages['admin_subj'] = '';
		$ctl_messages['admin_text'] = '';
		$ctl_messages['admin_subj_edit'] = '';
		$ctl_messages['admin_text_edit'] = '';
	}

	echo '<script>
	function checkValues()
	{
		var el = sbGetE("ctl_title");

		if(el.value == "")
		{
			alert(" '.PL_COMMENTS_ERROR_INPUT_DESIGN_NAME.' ");
			return false;
		}

		return true;
	}';

	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_comments_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()', '', 'enctype="multipart/form-data"');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_COMMENTS_TAB1);
	$layout->addHeader(PL_COMMENTS_TAB1);

	// Название макета дизайна
	$layout->addField(PL_COMMENTS_EDIT_TITLE, new sbLayoutInput('text', $ctl_title, 'ctl_title', '', 'style="width:100%" '));
	$layout->addField('', new sbLayoutDelim());

	// Язык
	$fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'ctl_lang');
	$fld->mSelOptions = array($ctl_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'. PL_COMMENTS_EDIT_DESIGN_LANG_LABEL.'</div>';
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_LANG, $fld);
	$layout->addField('', new sbLayoutDelim());

	// Расширения файлов доступных для загрузки
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_FILES_EXT, new sbLayoutInput('text', $ctl_fields_temps['ctl_files_ext'], 'ctl_fields_temps[ctl_files_ext]', '', 'style="width:100%"'));

	// Макcимальный размер файлов
	$fld = new sbLayoutInput('text', $ctl_fields_temps['ctl_files_size'], 'ctl_fields_temps[ctl_files_size]', 'spin_file_size',  'style="width:100px"');
	$fld->mMinValue = 1;
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_FILE_MAX_SIZE, $fld);
	$layout->addField('', new sbLayoutDelim());

	// Разрешать BB-коды
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_BBCODES, new sbLayoutInput('checkbox', '1', 'ctl_fields_temps[ctl_bb_codes]', '', (isset($ctl_fields_temps['ctl_bb_codes']) && $ctl_fields_temps['ctl_bb_codes'] == 1 ? 'checked="checked"' : '')));

	// Редактирование комментария, добавленного авторизованным пользователем
	$fld = new sbLayoutInput('checkbox', '1', 'ctl_fields_temps[registred_users_edit_link]', '', (isset($ctl_fields_temps['registred_users_edit_link']) && $ctl_fields_temps['registred_users_edit_link'] == 1 ? 'checked="checked"' : ''));
	$fld->mSelOptions = array($ctl_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'. PL_COMMENTS_EDIT_DESIGN_AUTH_EDIT_LABEL.'</div>';
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_AUTH_EDIT, $fld);

	// Добавление комментария авторизованным пользователем
	$fld = new sbLayoutInput('checkbox', '1', 'ctl_fields_temps[registred_users_add_only]', '', (isset($ctl_fields_temps['registred_users_add_only']) && $ctl_fields_temps['registred_users_add_only'] == 1 ? 'checked="checked"' : ''));
	$fld->mSelOptions = array($ctl_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'. PL_COMMENTS_EDIT_DESIGN_AUTH_ADD_LABEL.'</div>';
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_AUTH_ADD, $fld);

	// Сортировка
	$fld = new sbLayoutSelect(array(PL_COMMENTS_EDIT_DESIGN_SORT_DESC, PL_COMMENTS_EDIT_DESIGN_SORT_ASC), 'ctl_fields_temps[ctl_sort]');
	$fld->mSelOptions = array($ctl_fields_temps['ctl_sort']);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_SORT, $fld);
	$layout->addField('', new sbLayoutDelim());

	// Макет дизайна данных пользователя
    fSite_Users_Design_Get($layout, $ctl_user_data_id, 'ctl_user_data_id');

	// Макет дизайна постраничного вывода
    fPager_Design_Get($layout, $ctl_pagelist_id, 'ctl_pagelist_id', $ctl_perpage, 'ctl_perpage');

	$layout->addTab(PL_COMMENTS_TAB2);
	$layout->addHeader(PL_COMMENTS_TAB2);

	$tags = array('{VALUE}');
	$values = array(SB_LAYOUT_VALUE);

	$dop_tags = array('{AUTHOR}', '{EMAIL}', '{USER_ID}', '{ID}');
	$dop_values = array(PL_COMMENTS_EDIT_DESIGN_AUTHOR_TAG, PL_COMMENTS_EDIT_DESIGN_EMAIL_TAG, PL_COMMENTS_EDIT_DESIGN_AUTHOR_ID_TAG, PL_COMMENTS_EDIT_DESIGN_ID_TAG);

	// Дата комментария
	$fld = new sbLayoutTextarea($ctl_fields_temps['ctl_date'], 'ctl_fields_temps[ctl_date]', '', 'style="width:100%"');
	$fld->mTags = array_merge(array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}'), $dop_tags);
	$fld->mValues = array_merge(array(KERNEL_DAY_TAG, KERNEL_WEEKDAY_TAG_FULL, KERNEL_WEEKDAY_TAG_SHORT, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG, KERNEL_YEAR_4_TAG, KERNEL_YEAR_2_TAG, KERNEL_HOURS_TAG, KERNEL_MINUTES_TAG), $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_DATE, $fld);

	// Автор комментария
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_author'], 'ctl_fields_temps[ctl_author]', '', 'style="width:100%"');
	$field->mTags = array_merge($tags, $dop_tags);
	$field->mValues = array_merge($values, $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_AUTHOR, $field);

	// E-Mail Автора
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_email'], 'ctl_fields_temps[ctl_email]', '', 'style="width:100%"');
	$field->mTags = array_merge($tags, $dop_tags);
	$field->mValues = array_merge($values, $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_EMAIL, $field);

	// Тема обсуждения
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_subj'], 'ctl_fields_temps[ctl_subj]', '', 'style="width:100%"');
	$field->mTags = array_merge($tags, $dop_tags);
	$field->mValues = array_merge($values, $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_SUBJ, $field);

	// Текст обсуждения
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_text'], 'ctl_fields_temps[ctl_text]', '', 'style="width:100%"');
	$field->mTags = array_merge($tags, $dop_tags);
	$field->mValues = array_merge($values, $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_TEXT, $field);

	// Прикрепленный файл
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_file'], 'ctl_fields_temps[ctl_file]', '', 'style="width:100%"');
	$field->mTags = array_merge(array('{VALUE}', '{NAME}', '{SIZE}'), $dop_tags);
	$field->mValues = array_merge(array(PL_COMMENTS_EDIT_DESIGN_FILE_HREF_TAG, PL_COMMENTS_EDIT_DESIGN_FILE_NAME_TAG, PL_COMMENTS_EDIT_DESIGN_FILE_NAME_SIZE), $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_FILE, $field);

	// Ссылка "Редактировать"
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_edit_link'], 'ctl_fields_temps[ctl_edit_link]', '', 'style="width:100%"');
	$field->mTags = array_merge(array('{URL}'), $dop_tags);
	$field->mValues = array_merge(array(PL_COMMENTS_EDIT_DESIGN_EDIT_LINK_HREF_TAG), $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_EDIT_LINK, $field);

	$layout->addTab(PL_COMMENTS_TAB3);
	$layout->addHeader(PL_COMMENTS_TAB3);

	// Верх вывода
	$field = new sbLayoutTextarea($ctl_top, 'ctl_top' , '', 'style = "width:100%"');
	$field->mTags = array('{NUM_LIST}', '{ALL_COUNT}', '{COMMENTS_FORM}');
	$field->mValues = array(PL_COMMENTS_EDIT_DESIGN_NUM_LIST_TAG, PL_COMMENTS_EDIT_DESIGN_ALL_COUNT_TAG, PL_COMMENTS_EDIT_DESIGN_FORM_TAG);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_TOP, $field);

	// Коментарий
	$field = new sbLayoutTextarea($ctl_element, 'ctl_element' , '', 'style="height:250px;width:100%"');
	$field->mTags = array('-', '{COMMENTS_NUMBER}',  '{COMMENTS_ID}', '{COMMENTS_DATE}', '{COMMENTS_AUTHOR}', '{COMMENTS_EMAIL}', '{COMMENTS_SUBJ}',
			'{COMMENTS_TEXT}', '{COMMENTS_AUTHOR_IP}', '{COMMENTS_FILE}', PL_COMMENTS_EDIT_DESIGN_QUOTE_ACTION_VAL, '{COMMENTS_HASH}',
			PL_COMMENTS_EDIT_DESIGN_TO_ANSWER_TAG_VAL, '{COMMENTS_EDIT_LINK}',
			'{LINK}',
			'-', '{ELEM_ID}', '{ELEM_TITLE}', '{ELEM_URL}', '-', '{CAT_ID}', '{CAT_TITLE}', '{CAT_URL}',
			'-', '{COMMENTS_USER_ID}', '{COMMENTS_USER_DATA}');
	$field->mValues = array (PL_COMMENTS_EDIT_DESIGN_MAIN_GROUP_TAG, PL_COMMENTS_EDIT_NUMBER_TAG, PL_COMMENTS_EDIT_DESIGN_ID_TAG,  PL_COMMENTS_EDIT_DESIGN_DATE,
						PL_COMMENTS_EDIT_DESIGN_AUTHOR, PL_COMMENTS_EDIT_DESIGN_EMAIL, PL_COMMENTS_EDIT_DESIGN_SUBJ,
						PL_COMMENTS_EDIT_DESIGN_TEXT, PL_COMMENTS_EDIT_DESIGN_AUTHOR_IP_TAG, PL_COMMENTS_EDIT_DESIGN_FILE,
						PL_COMMENTS_EDIT_DESIGN_QUOTE_ACTION, PL_COMMENTS_EDIT_DESIGN_HASH_TAG,
						PL_COMMENTS_EDIT_DESIGN_TO_ANSWER_TAG, PL_COMMENTS_EDIT_COMMENTS_EDIT_LINK,
						PL_COMMENTS_EDIT_ELEM_LINK,
						PL_COMMENTS_EDIT_ELEM,
						PL_COMMENTS_EDIT_ELEM_ID_TAG, PL_COMMENTS_EDIT_ELEM_TITLE_TAG, PL_COMMENTS_EDIT_ELEM_URL_TAG,
						PL_COMMENTS_EDIT_CAT_ELEM, PL_COMMENTS_EDIT_CAT_ELEM_ID_TAG,
						PL_COMMENTS_EDIT_CAT_ELEM_TITLE_TAG, PL_COMMENTS_EDIT_CAT_ELEM_URL_TAG,
						PL_COMMENTS_EDIT_DESIGN_USER_GROUP_TAG,
						PL_COMMENTS_EDIT_DESIGN_AUTHOR_ID_TAG, PL_COMMENTS_EDIT_DESIGN_USER_DATA_TAG);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_ELEMENT,  $field);

	// Низ вывода (общий)
	$field =  new sbLayoutTextarea($ctl_bottom, 'ctl_bottom', '', 'style="width:100%"');
	$field->mTags  = array('{NUM_LIST}', '{ALL_COUNT}', '{COMMENTS_FORM}');
	$field->mValues = array(PL_COMMENTS_EDIT_DESIGN_NUM_LIST_TAG, PL_COMMENTS_EDIT_DESIGN_ALL_COUNT_TAG, PL_COMMENTS_EDIT_DESIGN_FORM_TAG);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_BOTTOM, $field);

	$layout->addField('', new sbLayoutDelim());

	// Верх вывода цитаты
	$fld = new sbLayoutTextarea($ctl_fields_temps['ctl_quote_top'], 'ctl_fields_temps[ctl_quote_top]' , '', 'style="width:100%"');
	$fld->mTags  = array('{AUTHOR}', '{DATE}');
	$fld->mValues = array(PL_COMMENTS_EDIT_DESIGN_AUTHOR, PL_COMMENTS_EDIT_DESIGN_DATE);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_QUOTE_TOP, $fld);

	// Низ вывода цитаты
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_QUOTE_BOTTOM, new sbLayoutTextarea($ctl_fields_temps['ctl_quote_bottom'], 'ctl_fields_temps[ctl_quote_bottom]' , '', 'style="width:100%"'));
	$layout->addField('', new sbLayoutDelim());

	// Верх вывода ответа
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_ANSWER_TOP, new sbLayoutTextarea($ctl_fields_temps['ctl_answer_top'], 'ctl_fields_temps[ctl_answer_top]' , '', 'style="width:100%"'));

	// Низ вывода ответа
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_ANSWER_BOTTOM, new sbLayoutTextarea($ctl_fields_temps['ctl_answer_bottom'], 'ctl_fields_temps[ctl_answer_bottom]' , '', 'style="width:100%"'));

	$layout->addTab(PL_COMMENTS_TAB8);
	$layout->addHeader(PL_COMMENTS_TAB8);

	//	Поле ввода "Дата"
	$fld = new sbLayoutTextarea($ctl_fields_temps['c_date_el'], 'ctl_fields_temps[c_date_el]', '', 'style="width:100%; height:50px;"');
    $fld->mTags = array_merge(array(PL_COMMENTS_EDIT_DESIGN_DATE_FORM), $tags);
	$fld->mValues = array_merge(array(PL_COMMENTS_EDIT_DESIGN_DATE_FIELD), $values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_DATE_FIELD.'<br><input type="checkbox" value="1" name="ctl_fields_temps[ctl_field_need_date]"'. ((isset($ctl_fields_temps['ctl_field_need_date']) && $ctl_fields_temps['ctl_field_need_date'] == 1) ? 'checked="checked"' : '') .'>'.PL_COMMENTS_EDIT_DESIGN_NEED, $fld);

	//	Поле ввода "Автор"
	$fld = new sbLayoutTextarea($ctl_fields_temps['c_author_el'], 'ctl_fields_temps[c_author_el]', '', 'style="width:100%; height:50px;"');
    $fld->mTags = array_merge(array(PL_COMMENTS_EDIT_DESIGN_AUTHOR_FORM), $tags);
	$fld->mValues = array_merge(array(PL_COMMENTS_EDIT_DESIGN_AUTHOR_FIELD), $values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_AUTHOR_FIELD.'<br><input type="checkbox" value="1" name="ctl_fields_temps[ctl_field_need_author]"'. ((isset($ctl_fields_temps['ctl_field_need_author']) && $ctl_fields_temps['ctl_field_need_author'] == 1) ? 'checked="checked"' : '') .'>'.PL_COMMENTS_EDIT_DESIGN_NEED, $fld);

	//	Поле ввода "e-mail"
	$fld = new sbLayoutTextarea($ctl_fields_temps['c_mail_el'], 'ctl_fields_temps[c_mail_el]', '', 'style="width:100%; height:50px;"');
    $fld->mTags = array_merge(array(PL_COMMENTS_EDIT_DESIGN_EMAIL_FORM), $tags);
	$fld->mValues = array_merge(array(PL_COMMENTS_EDIT_DESIGN_EMAIL_FIELD), $values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_EMAIL_FIELD.'<br><input type="checkbox" value="1" name="ctl_fields_temps[ctl_field_need_email]"'. ((isset($ctl_fields_temps['ctl_field_need_email']) && $ctl_fields_temps['ctl_field_need_email'] == 1) ? 'checked="checked"' : '') .'>'.PL_COMMENTS_EDIT_DESIGN_NEED, $fld);

	//	Поле ввода "Тема"
	$fld = new sbLayoutTextarea($ctl_fields_temps['c_subject_el'], 'ctl_fields_temps[c_subject_el]', '', 'style="width:100%; height:50px;"');
    $fld->mTags = array_merge(array(PL_COMMENTS_EDIT_DESIGN_SUBJECT_FORM), $tags);
	$fld->mValues = array_merge(array(PL_COMMENTS_EDIT_DESIGN_SUBJ_FIELD), $values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_SUBJ_FIELD.'<br><input type="checkbox" value="1" name="ctl_fields_temps[ctl_field_need_subj]"'. ((isset($ctl_fields_temps['ctl_field_need_subj']) && $ctl_fields_temps['ctl_field_need_subj'] == 1) ? 'checked="checked"' : '') .'>'.PL_COMMENTS_EDIT_DESIGN_NEED, $fld);

	//	Поле ввода "Текст коментария"
	$fld = new sbLayoutTextarea($ctl_fields_temps['c_text_el'], 'ctl_fields_temps[c_text_el]', '', 'style="width:100%; height:50px;"');
    $fld->mTags = array_merge(array(PL_COMMENTS_EDIT_DESIGN_TEXT_FORM), $tags);
	$fld->mValues = array_merge(array(PL_COMMENTS_EDIT_DESIGN_TEXT_FIELD), $values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_TEXT_FIELD.'<br><input type="checkbox" value="1" name="ctl_fields_temps[ctl_field_need_text]"'. ((isset($ctl_fields_temps['ctl_field_need_text']) && $ctl_fields_temps['ctl_field_need_text'] == 1) ? 'checked="checked"' : '') .'>'.PL_COMMENTS_EDIT_DESIGN_NEED, $fld);

	//	Поле ввода "Файл"
	$fld = new sbLayoutTextarea($ctl_fields_temps['c_file_el'], 'ctl_fields_temps[c_file_el]', '', 'style="width:100%; height:50px;"');
    $fld->mTags = array_merge(array(PL_COMMENTS_EDIT_DESIGN_FILE_FORM), $tags);
	$fld->mValues = array_merge(array(PL_COMMENTS_EDIT_DESIGN_FILE_FIELD), $values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_FILE_FIELD.'<br><input type="checkbox" value="1" name="ctl_fields_temps[ctl_field_need_file]"'. ((isset($ctl_fields_temps['ctl_field_need_file']) && $ctl_fields_temps['ctl_field_need_file'] == 1) ? 'checked="checked"' : '') .'>'.PL_COMMENTS_EDIT_DESIGN_NEED, $fld);

	//	Текущий файл
	$fld = new sbLayoutTextarea($ctl_fields_temps['c_file_now_el'], 'ctl_fields_temps[c_file_now_el]', '', 'style="width:100%; height:50px;"');
    $fld->mTags = array(PL_COMMENTS_EDIT_DESIGN_FILE_NOW_FORM, PL_COMMENTS_EDIT_DESIGN_FILE_NOW_DELETE_FORM);
	$fld->mValues = array(PL_COMMENTS_EDIT_DESIGN_FILE_NOW_FIELD, PL_COMMENTS_EDIT_DESIGN_FILE_NOW_DELETE_FIELD);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_FILE_NOW_FIELD, $fld);

	//	Поле ввода кода с картинки (CAPTCHA)
	$fld = new sbLayoutTextarea($ctl_fields_temps['c_captcha_code_el'], 'ctl_fields_temps[c_captcha_code_el]', '', 'style="width:100%; height:50px;"');
   	$fld->mTags = array(PL_COMMENTS_EDIT_DESIGN_CAPTCHA_CODE_FORM);
	$fld->mValues = array(PL_COMMENTS_EDIT_DESIGN_CAPTCHA_FIELD);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_CAPTCHA_FIELD, $fld);

	//	Картика с кодом (CAPTCHA)
	$fld = new sbLayoutTextarea($ctl_fields_temps['c_captcha_image_el'], 'ctl_fields_temps[c_captcha_image_el]', '', 'style="width:100%; height:50px;"');
   	$fld->mTags = array(PL_COMMENTS_EDIT_DESIGN_CAPTCHA_IMG_FORM);
	$fld->mValues = array(PL_COMMENTS_EDIT_DESIGN_CAPTCHA_IMAGE);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_CAPTCHA_IMAGE, $fld);


	$layout->addTab(PL_COMMENTS_TAB4);
	$layout->addHeader(PL_COMMENTS_TAB4);

	// Форма
	$field = new sbLayoutTextarea($ctl_form, 'ctl_form', '', 'style="width:100%;height:320px"');
	$field->mTags = array('{SYSTEM_MESSAGE}', PL_COMMENTS_EDIT_DESIGN_FORM_CODE, PL_COMMENTS_EDIT_DESIGN_DATE_CODE, PL_COMMENTS_EDIT_DESIGN_AUTHOR_CODE,
						  PL_COMMENTS_EDIT_DESIGN_EMAIL_CODE, PL_COMMENTS_EDIT_DESIGN_SUBJECT_CODE, PL_COMMENTS_EDIT_DESIGN_TEXT_CODE,
						  PL_COMMENTS_EDIT_DESIGN_FILE_CODE, PL_COMMENTS_EDIT_DESIGN_FILE_NOW_CODE, PL_COMMENTS_EDIT_DESIGN_CAPTCHA_CODE, PL_COMMENTS_EDIT_DESIGN_CAPTCHA_IMG_CODE);

	$field->mValues = array(PL_COMMENTS_EDIT_DESIGN_SYSTEM_MESSAGE, PL_COMMENTS_EDIT_DESIGN_HTML_FORM_TAG, PL_COMMENTS_EDIT_DESIGN_DATE_FIELD,
						  PL_COMMENTS_EDIT_DESIGN_AUTHOR_FIELD, PL_COMMENTS_EDIT_DESIGN_EMAIL_FIELD, PL_COMMENTS_EDIT_DESIGN_SUBJ_FIELD,
						  PL_COMMENTS_EDIT_DESIGN_TEXT_FIELD, PL_COMMENTS_EDIT_DESIGN_FILE_FIELD, PL_COMMENTS_EDIT_DESIGN_FILE_NOW_FIELD, PL_COMMENTS_EDIT_DESIGN_CAPTCHA_FIELD,
						  PL_COMMENTS_EDIT_DESIGN_CAPTCHA_IMAGE);

	$layout->addField(PL_COMMENTS_EDIT_DESIGN_ADD_FORM, $field);

	// Начало выделения обязательных полей
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_select_start'], 'ctl_fields_temps[ctl_select_start]', '', 'style="width:100%"');
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_FIELD_START, $field);

	// Конец выделения обязательных полей
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_select_end'], 'ctl_fields_temps[ctl_select_end]', '', 'style="width:100%"');
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_FIELD_END, $field);

	$layout->addTab(PL_COMMENTS_TAB7);
	$layout->addHeader(PL_COMMENTS_TAB7);

	// Дата комментария
	$fld = new sbLayoutTextarea($ctl_fields_temps['ctl_date_mes'], 'ctl_fields_temps[ctl_date_mes]', '', 'style="width:100%"');
	$fld->mTags = array_merge(array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}'), $dop_tags);
	$fld->mValues = array_merge(array(KERNEL_DAY_TAG, KERNEL_WEEKDAY_TAG_FULL, KERNEL_WEEKDAY_TAG_SHORT, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG, KERNEL_YEAR_4_TAG, KERNEL_YEAR_2_TAG, KERNEL_HOURS_TAG, KERNEL_MINUTES_TAG), $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_DATE, $fld);

	// Автор комментария
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_author_mes'], 'ctl_fields_temps[ctl_author_mes]', '', 'style="width:100%"');
	$field->mTags = array_merge($tags, $dop_tags);
	$field->mValues = array_merge($values, $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_AUTHOR, $field);

	// E-Mail Автора
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_email_mes'], 'ctl_fields_temps[ctl_email_mes]', '', 'style="width:100%"');
	$field->mTags = array_merge($tags, $dop_tags);
	$field->mValues = array_merge($values, $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_EMAIL, $field);

	// Тема обсуждения
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_subj_mes'], 'ctl_fields_temps[ctl_subj_mes]', '', 'style="width:100%"');
	$field->mTags = array_merge($tags, $dop_tags);
	$field->mValues = array_merge($values, $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_SUBJ, $field);

	// Текст обсуждения
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_text_mes'], 'ctl_fields_temps[ctl_text_mes]', '', 'style="width:100%"');
	$field->mTags = array_merge($tags, $dop_tags);
	$field->mValues = array_merge($values, $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_TEXT, $field);

	// Прикрепленный файл
	$field = new sbLayoutTextarea($ctl_fields_temps['ctl_file_mes'], 'ctl_fields_temps[ctl_file_mes]', '', 'style="width:100%"');
	$field->mTags = array_merge(array('{VALUE}', '{NAME}', '{SIZE}'), $dop_tags);
	$field->mValues = array_merge(array(PL_COMMENTS_EDIT_DESIGN_FILE_HREF_TAG, PL_COMMENTS_EDIT_DESIGN_FILE_NAME_TAG, PL_COMMENTS_EDIT_DESIGN_FILE_NAME_SIZE), $dop_values);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_FILE, $field);

	$layout->addTab(PL_COMMENTS_TAB5);
	$layout->addHeader(PL_COMMENTS_TAB5);

	// Комментариев нет
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_NO_COMMENTS,  new sbLayoutTextarea($ctl_messages['no_comments'], 'ctl_messages[no_comments]', '', 'style="width:100%"'));

	// Комментарий добавлен
	$field =  new sbLayoutTextarea($ctl_messages['add_ok'], 'ctl_messages[add_ok]', '', 'style = "width:100%"');
	$field->mTags = array('-', '{COMMENTS_ID}', '{COMMENTS_DATE}', '{COMMENTS_AUTHOR}', '{COMMENTS_EMAIL}', '{COMMENTS_SUBJ}', '{COMMENTS_TEXT}', '{COMMENTS_AUTHOR_IP}', '{COMMENTS_FILE}', '-', '{COMMENTS_USER_ID}', '{COMMENTS_USER_DATA}');
	$field->mValues = array (PL_COMMENTS_EDIT_DESIGN_MAIN_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_ID_TAG,  PL_COMMENTS_EDIT_DESIGN_DATE, PL_COMMENTS_EDIT_DESIGN_AUTHOR, PL_COMMENTS_EDIT_DESIGN_EMAIL, PL_COMMENTS_EDIT_DESIGN_SUBJ, PL_COMMENTS_EDIT_DESIGN_TEXT, PL_COMMENTS_EDIT_DESIGN_AUTHOR_IP_TAG, PL_COMMENTS_EDIT_DESIGN_FILE, PL_COMMENTS_EDIT_DESIGN_USER_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_AUTHOR_ID_TAG, PL_COMMENTS_EDIT_DESIGN_USER_DATA_TAG);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_MESSAGE_OK, $field);

	// Комментарий изменен
	$field =  new sbLayoutTextarea($ctl_messages['edit_ok'], 'ctl_messages[edit_ok]', '', 'style = "width:100%"');
	$field->mTags = array('-', '{COMMENTS_ID}', '{COMMENTS_DATE}', '{COMMENTS_AUTHOR}', '{COMMENTS_EMAIL}', '{COMMENTS_SUBJ}', '{COMMENTS_TEXT}', '{COMMENTS_AUTHOR_IP}', '{COMMENTS_FILE}', '-', '{COMMENTS_USER_ID}', '{COMMENTS_USER_DATA}');
	$field->mValues = array (PL_COMMENTS_EDIT_DESIGN_MAIN_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_ID_TAG,  PL_COMMENTS_EDIT_DESIGN_DATE, PL_COMMENTS_EDIT_DESIGN_AUTHOR, PL_COMMENTS_EDIT_DESIGN_EMAIL, PL_COMMENTS_EDIT_DESIGN_SUBJ, PL_COMMENTS_EDIT_DESIGN_TEXT, PL_COMMENTS_EDIT_DESIGN_AUTHOR_IP_TAG, PL_COMMENTS_EDIT_DESIGN_FILE, PL_COMMENTS_EDIT_DESIGN_USER_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_AUTHOR_ID_TAG, PL_COMMENTS_EDIT_DESIGN_USER_DATA_TAG);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_MESSAGE_EDIT_OK, $field);

	$layout->addField('', new sbLayoutDelim());

	// Не все поля формы заполнены корректно
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_MESSAGES_TEMP, new sbLayoutTextarea($ctl_messages['fields_error'], 'ctl_messages[fields_error]', '', 'style="width:100%"'));

	// Размер файла
	$fld = new sbLayoutTextarea($ctl_messages['file_size_error'], 'ctl_messages[file_size_error]', '', 'style="width:100%"');
	$fld->mTags = array('{FILE_SIZE}', '{FILE}');
	$fld->mValues = array(PL_COMMENTS_EDIT_DESIGN_MESSAGE_FILE_SIZE_TAG, PL_COMMENTS_EDIT_DESIGN_MESSAGE_FILE_TAG);
	$layout->addField('', $fld);

	// Тип файла
	$fld = new sbLayoutTextarea($ctl_messages['file_ext_error'], 'ctl_messages[file_ext_error]', '', 'style="width:100%"');
	$fld->mTags = array('{FILE_EXT}', '{FILE}');
	$fld->mValues = array(PL_COMMENTS_EDIT_DESIGN_MESSAGE_FILE_EXT_TAG, PL_COMMENTS_EDIT_DESIGN_MESSAGE_FILE_TAG);
	$layout->addField('', $fld);

	// Ошибка загрузки файла
	$fld = new sbLayoutTextarea($ctl_messages['file_error'], 'ctl_messages[file_error]', '', 'style="width:100%"');
	$fld->mTags = array('{FILE}');
	$fld->mValues = array(PL_COMMENTS_EDIT_DESIGN_MESSAGE_FILE_TAG);
	$layout->addField('', $fld);

	// Код с картинки не верен
	$layout->addField('', new sbLayoutTextarea($ctl_messages['captcha_error'], 'ctl_messages[captcha_error]', '', 'style="width:100%"'));

	// Ошибка добавления комментария
	$layout->addField('', new sbLayoutTextarea($ctl_messages['add_error'], 'ctl_messages[add_error]', '', 'style="width:100%"'));

	// Ошибка изменения комментария
	$layout->addField('', new sbLayoutTextarea($ctl_messages['edit_error'], 'ctl_messages[edit_error]', '', 'style="width:100%"'));

	// у вас не достаточно прав на просмотр комментариев
	$layout->addField('', new sbLayoutTextarea($ctl_messages['rights_error'], 'ctl_messages[rights_error]', '', 'style="width:100%"'));

	// Только авторизированные пользователи могут добавлять комментарии
	$layout->addField('', new sbLayoutTextarea($ctl_messages['auth_add_error'], 'ctl_messages[auth_add_error]', '', 'style="width:100%"'));

	// Можно редактировать только свои комментарии
	$layout->addField('', new sbLayoutTextarea($ctl_messages['auth_edit_error'], 'ctl_messages[auth_edit_error]', '', 'style="width:100%"'));

	$layout->addTab(PL_COMMENTS_TAB6);
	$layout->addHeader(PL_COMMENTS_TAB6);

	// Тема письма модератору
	$field = new sbLayoutTextarea($ctl_messages['admin_subj'], 'ctl_messages[admin_subj]', '', 'style="height:50px;width:100%"');
	$field->mTags = array('-', '{COMMENTS_ID}', '{COMMENTS_DATE}', '{COMMENTS_AUTHOR}', '{COMMENTS_EMAIL}', '{COMMENTS_SUBJ}', '{COMMENTS_TEXT}', '{COMMENTS_AUTHOR_IP}', '{COMMENTS_FILE}', '-', '{COMMENTS_USER_ID}', '{COMMENTS_USER_DATA}');
	$field->mValues = array (PL_COMMENTS_EDIT_DESIGN_MAIN_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_ID_TAG,  PL_COMMENTS_EDIT_DESIGN_DATE, PL_COMMENTS_EDIT_DESIGN_AUTHOR, PL_COMMENTS_EDIT_DESIGN_EMAIL, PL_COMMENTS_EDIT_DESIGN_SUBJ, PL_COMMENTS_EDIT_DESIGN_TEXT, PL_COMMENTS_EDIT_DESIGN_AUTHOR_IP_TAG, PL_COMMENTS_EDIT_DESIGN_FILE, PL_COMMENTS_EDIT_DESIGN_USER_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_AUTHOR_ID_TAG, PL_COMMENTS_EDIT_DESIGN_USER_DATA_TAG);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_EMAIL_SUBJECT, $field);

	// Текст письма модератору
	$field = new sbLayoutTextarea($ctl_messages['admin_text'], 'ctl_messages[admin_text]', '', 'style="height:300px;width:100%"');
	$field->mTags = array('-', '{COMMENTS_ID}', '{COMMENTS_DATE}', '{COMMENTS_AUTHOR}', '{COMMENTS_EMAIL}', '{COMMENTS_SUBJ}', '{COMMENTS_TEXT}', '{COMMENTS_AUTHOR_IP}', '{COMMENTS_FILE}', '-', '{COMMENTS_USER_ID}', '{COMMENTS_USER_DATA}');
	$field->mValues = array (PL_COMMENTS_EDIT_DESIGN_MAIN_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_ID_TAG,  PL_COMMENTS_EDIT_DESIGN_DATE, PL_COMMENTS_EDIT_DESIGN_AUTHOR, PL_COMMENTS_EDIT_DESIGN_EMAIL, PL_COMMENTS_EDIT_DESIGN_SUBJ, PL_COMMENTS_EDIT_DESIGN_TEXT, PL_COMMENTS_EDIT_DESIGN_AUTHOR_IP_TAG, PL_COMMENTS_EDIT_DESIGN_FILE, PL_COMMENTS_EDIT_DESIGN_USER_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_AUTHOR_ID_TAG, PL_COMMENTS_EDIT_DESIGN_USER_DATA_TAG);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_EMAIL_TEXT, $field);

	// Тема письма модератору (при редактировнии)
	$field = new sbLayoutTextarea($ctl_messages['admin_subj_edit'], 'ctl_messages[admin_subj_edit]', '', 'style="height:50px;width:100%"');
	$field->mTags = array('-', '{COMMENTS_ID}', '{COMMENTS_DATE}', '{COMMENTS_AUTHOR}', '{COMMENTS_EMAIL}', '{COMMENTS_SUBJ}', '{COMMENTS_TEXT}', '{COMMENTS_AUTHOR_IP}', '{COMMENTS_FILE}', '-', '{COMMENTS_USER_ID}', '{COMMENTS_USER_DATA}');
	$field->mValues = array (PL_COMMENTS_EDIT_DESIGN_MAIN_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_ID_TAG,  PL_COMMENTS_EDIT_DESIGN_DATE, PL_COMMENTS_EDIT_DESIGN_AUTHOR, PL_COMMENTS_EDIT_DESIGN_EMAIL, PL_COMMENTS_EDIT_DESIGN_SUBJ, PL_COMMENTS_EDIT_DESIGN_TEXT, PL_COMMENTS_EDIT_DESIGN_AUTHOR_IP_TAG, PL_COMMENTS_EDIT_DESIGN_FILE, PL_COMMENTS_EDIT_DESIGN_USER_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_AUTHOR_ID_TAG, PL_COMMENTS_EDIT_DESIGN_USER_DATA_TAG);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_EMAIL_SUBJECT_EDIT, $field);

	// Текст письма модератору (при редактировнии)
	$field = new sbLayoutTextarea($ctl_messages['admin_text_edit'], 'ctl_messages[admin_text_edit]', '', 'style="height:300px;width:100%"');
	$field->mTags = array('-', '{COMMENTS_ID}', '{COMMENTS_DATE}', '{COMMENTS_AUTHOR}', '{COMMENTS_EMAIL}', '{COMMENTS_SUBJ}', '{COMMENTS_TEXT}', '{COMMENTS_AUTHOR_IP}', '{COMMENTS_FILE}', '-', '{COMMENTS_USER_ID}', '{COMMENTS_USER_DATA}');
	$field->mValues = array (PL_COMMENTS_EDIT_DESIGN_MAIN_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_ID_TAG,  PL_COMMENTS_EDIT_DESIGN_DATE, PL_COMMENTS_EDIT_DESIGN_AUTHOR, PL_COMMENTS_EDIT_DESIGN_EMAIL, PL_COMMENTS_EDIT_DESIGN_SUBJ, PL_COMMENTS_EDIT_DESIGN_TEXT, PL_COMMENTS_EDIT_DESIGN_AUTHOR_IP_TAG, PL_COMMENTS_EDIT_DESIGN_FILE, PL_COMMENTS_EDIT_DESIGN_USER_GROUP_TAG, PL_COMMENTS_EDIT_DESIGN_AUTHOR_ID_TAG, PL_COMMENTS_EDIT_DESIGN_USER_DATA_TAG);
	$layout->addField(PL_COMMENTS_EDIT_DESIGN_EMAIL_TEXT_EDIT, $field);

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_comments', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_comments', 'design_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

	$layout->show();
}

function fComments_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_comments'))
		return;

	if (!isset($_GET['id']))
        $_GET['id'] = '';

    $ctl_lang = SB_CMS_LANG;
	$ctl_pagelist_id = 0;
	$ctl_user_data_id = 0;
	$ctl_fields_temps = array();
	$ctl_fields_temps['ctl_field_need_author'] = 0;
	$ctl_fields_temps['ctl_field_need_email'] = 0;
	$ctl_fields_temps['ctl_field_need_subj'] = 0;
	$ctl_fields_temps['ctl_field_need_text'] = 0;
	$ctl_fields_temps['ctl_field_need_file'] = 0;
	$ctl_messages = array();

	extract($_POST);

	if($ctl_title == '')
	{
		sb_show_message(PL_COMMENTS_ERROR_INPUT_DESIGN_NAME, false, 'warning');
		fComments_Edit();
		return;
	}

	$row['ctl_title'] = $ctl_title;
	$row['ctl_lang'] = $ctl_lang;
	$row['ctl_perpage'] = $ctl_perpage;
	$row['ctl_pagelist_id'] = $ctl_pagelist_id;
	$row['ctl_user_data_id'] = $ctl_user_data_id;
	$row['ctl_top'] = $ctl_top;
	$row['ctl_element'] = $ctl_element;
	$row['ctl_bottom'] = $ctl_bottom;
	$row['ctl_fields_temps'] = serialize($ctl_fields_temps);
	$row['ctl_messages'] = serialize($ctl_messages);
	$row['ctl_form'] = $ctl_form;

	if ($_GET['id'] != '')
	{
		$res = sql_query('SELECT ctl_title FROM sb_comments_temps_list WHERE ctl_id = ?d', $_GET['id']);
		if($res)
		{
			list($ctl_oldname) = $res[0];
		}
		else
		{
		    sb_show_message(PL_COMMENTS_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_COMMENTS_DESIGN_EDIT_SYSTEMLOG_ERROR, $ctl_title), SB_MSG_WARNING);
            fComments_Edit();
		    return;
		}

	    sql_query('UPDATE sb_comments_temps_list SET ?a WHERE ctl_id=?d', $row, $_GET['id'], sprintf(PL_COMMENTS_DESIGN_EDIT_SYSTEMLOG_OK, $ctl_oldname, $ctl_title));
        sbQueryCache::updateTemplate('sb_comments_temps_list', $_GET['id']);

        $footer_ar = fCategs_Edit_Elem();
	    if (!$footer_ar)
	    {
	        sb_show_message(PL_COMMENTS_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_COMMENTS_DESIGN_EDIT_SYSTEMLOG_ERROR, $ctl_title), SB_MSG_WARNING);
            fComments_Edit();
		    return;
	    }

	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

	    $row['ctl_id'] = $_GET['id'];

	    $html_str = fComments_Get($row);
	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
        $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

	    if (!isset($_POST['btn_apply']))
    	{
    		echo '<script>
     	    	    	var res = new Object();
		        		res.html = "'.$html_str.'";
		        		res.footer = "'.$footer_str.'";
		        		res.footer_link = "";
						sbReturnValue(res);
			  		</script>';
       }
       else
       {
   	        fComments_Edit($html_str, $footer_str);
   	        return;
       }
    }
	else
	{
	  	$error = true;
	  	if (sql_query('INSERT INTO sb_comments_temps_list (?#) VALUES (?a)', array_keys($row), array_values($row)))
		{
		   	$id = sql_insert_id();

		   	if (fCategs_Add_Elem($id) !== false)
		   	{
                sbQueryCache::updateTemplate('sb_comments_temps_list', $id);
		       	sb_add_system_message(sprintf(PL_COMMENTS_DESIGN_ADD_OK, $ctl_title));

		       	echo '<script>
		        	sbReturnValue('.$id.');
		        </script>';

		        $error = false;
		    }
		    else
		    {
		        sql_query('DELETE FROM sb_comments_temps_list WHERE ctl_id=?d', $id);
		    }
		}

		if ($error)
		{
			sb_show_message(sprintf(PL_COMMENTS_DESIGN_ADD_ERROR, $ctl_title), false, 'warning');
			sb_add_system_message(sprintf(PL_COMMENTS_DESIGN_ADD_SYSTEMLOG_ERROR, $ctl_title), SB_MSG_WARNING);
			fComments_Edit();
			return;
	    }
    }
}

function fComments_List_Init()
{
	$order = '';
	if(isset($_GET['order']))
	{
		$order = trim(preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']));
		sb_setcookie('sb_c_order', $order);
	}
	elseif (isset($_COOKIE['sb_c_order']))
	{
		$order = trim(preg_replace('/[^a-zA-Z0-9_|]+/', '', $_COOKIE['sb_c_order']));
	}

	if (empty($order))
		$order = 'c_date|desc';

	if($order == 'trees')
	{
		$order_str = ' ORDER BY c.c_el_id DESC, c.c_left ASC ';
	}
	else
	{
		$order_str = explode('|', $order);
		if (count($order_str) == 2)
	    {
			$order_str = ' ORDER BY '.$order_str[0].' '.strtoupper($order_str[1]).', c.c_id DESC';
	    }
	    else
	    {
	    	$order_str = ' ORDER BY c.c_date DESC';
	    }
	}

	$order_get = '&order='.$order;

    $filter_str = '';
    $filter_get = '';
    if (isset($_GET['c_date_from']) && !empty($_GET['c_date_from']))
    {
        $_GET['c_date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['c_date_from']);
        $date_time = explode(' ', $_GET['c_date_from']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND c.c_date >= '.sb_datetoint($_GET['c_date_from']);
            $filter_get .= '&c_date_from='.$_GET['c_date_from'];
        }
    }

    if (isset($_GET['c_date_to']) && !empty($_GET['c_date_to']))
    {
        $_GET['c_date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['c_date_to']);
        $date_time = explode(' ', $_GET['c_date_to']);
        if (count($date_time) > 0)
        {
			$filter_str .= ' AND c.c_date <= '.sb_datetoint($_GET['c_date_to']);
			$filter_get .= '&c_date_to='.$_GET['c_date_to'];
		}
	}

	if (isset($_GET['c_subj']) && !empty($_GET['c_subj']))
	{
		$filter_str .= ' AND c.c_subj LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['c_subj']).'%');
		$filter_get .= '&c_subj='.urldecode($_GET['c_subj']);
	}

	if (isset($_GET['c_file']) && !empty($_GET['c_file']))
	{
		$filter_str .= ' AND c.c_file_name LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['c_file']).'%');
		$filter_get .= '&c_file='.urldecode($_GET['c_file']);
	}

	if (isset($_GET['c_author']) && !empty($_GET['c_author']))
	{
		$filter_str .= ' AND (c.c_author != \'\' AND c.c_author LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['c_author']).'%').' OR su.su_login LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['c_author']).'%').')';
		$filter_get .= '&c_author='.$_GET['c_author'];
	}

	if (isset($_GET['c_text']) && !empty($_GET['c_text']))
	{
		$filter_str .= ' AND c.c_text LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['c_text']).'%');
		$filter_get .= '&c_text='.urldecode($_GET['c_text']);
	}

	if (isset($_GET['c_ip']) && !empty($_GET['c_ip']))
    {
		$filter_str .= ' AND c.c_ip LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['c_ip']).'%');
		$filter_get .= '&c_ip='.urldecode($_GET['c_ip']);
    }

	if (isset($_GET['c_id_lo']) && !empty($_GET['c_id_lo']))
    {
		$filter_str .= ' AND c.c_id >= '.intval($_GET['c_id_lo']);
		$filter_get .= '&c_id_lo='.intval($_GET['c_id_lo']);
    }

	if (isset($_GET['c_id_hi']) && !empty($_GET['c_id_hi']))
    {
		$filter_str .= ' AND c.c_id <= '.intval($_GET['c_id_hi']);
		$filter_get .= '&c_id_hi='.intval($_GET['c_id_hi']);
    }

	if (isset($_GET['module']) && $_GET['module'] != '' && $_GET['module'] != '0')
    {
		$filter_str .= ' AND c.c_plugin = '.$GLOBALS['sbSql']->escape($_GET['module']);
		$filter_get .= '&module='.$_GET['module'];
	}

	echo '
		<style type="text/css">
			#event_content table.form tr.even:hover,
			#event_content table.form tr.odd:hover
			{
				background-color: #E1FFE1;
			}
			#event_content
			{
				overflow-x: auto;
			}
		</style>
        <script src="'.SB_CMS_JSCRIPT_URL.'/sbElements.js.php"></script>
		<script>
		    document.body.onselectstart = "";
		    document.body.setAttribute("unselectable", "off");

			function editComment(c_plugin, c_id)
			{
				var strPage = sb_cms_modal_dialog_file + "?event=pl_comments_edit_comment&pl_ident="+c_plugin+"&title=&id="+c_id+"&event_ident=edit";
			    var strAttr = "resizable=1,width=750,height=500";
			    sbShowModalDialog(strPage, strAttr, afterEditComment);
			}

			function afterEditComment(del)
			{
				if(sbModalDialog.returnValue || del)
				{
					window.location.href = sb_cms_content_file+"?event=pl_comments_all_comments'.(isset($_GET['page_comments']) ? '&page_comments='.$_GET['page_comments'] : '').$order_get.$filter_get.'";
				}
			}

			function deleteComment(c_plugin, c_id)
			{
				if (!confirm("'.PL_COMMENTS_CONFIRM_DELETE.'"))
					return;

				var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_comments_delete&pl_ident="+c_plugin+"&title=&id="+c_id);
				if(res != "")
				{
					sbShowMsgDiv(res);
					return;
				}
				afterEditComment(true);
			}

			function deleteFile(c_plugin, c_id)
			{
				if (!confirm("'.PL_COMMENTS_H_DELETE_FILE_CONFIRM.'"))
					return;

				var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_comments_delete_file&pl_ident="+c_plugin+"&title=&id="+c_id);
				if(res != "")
				{
					sbShowMsgDiv(res);
					return;
				}

				afterEditComment(true);
			}

		    function showFilter()
		    {
		        var filter = sbGetE("sb_filter");
		        var filter_arr = sbGetE("filter_arrow");
		        if (!filter) return;
		        if (filter.style.display == "none")
		        {
		            filter.style.display = "";
		            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
		        }
		        else
		        {
		            filter.style.display = "none";
		            filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
		        }
		    }

		    function setFilter()
		    {
		        var str = "'.SB_CMS_CONTENT_FILE.'?event=pl_comments_all_comments'.$order_get.'";
		        var found = false;
		        var frm = sbGetE("filter_form");

		        for (var i = 0; i < frm.elements.length; i++)
		        {
		            var el = frm.elements[i];
		            if (el.type == "select-one")
		            {
		                if (el.value != -1)
		                {
		                    str += "&"+el.name+"="+el.value;
		                    found = true;
		                }
		            }
		            else
		            {
		                if (el.name != "" && el.value != "")
		                {
		                    str += "&"+el.name+"="+el.value;
		                    found = true;
		                }
		            }
		        }

		        if (!found)
		        {
		            return false;
		        }

		        window.location = str;
		        return false;
		    }

		    function setActive(el, id)
		    {
            	var res = sbLoadSync(sb_cms_empty_file + "?event=pl_comments_set_active&id="+id);
  				if (res != "TRUE")
                {
                    sbShowMsgDiv("'.PL_COMMENTS_SET_ACTIVE_SHOWHIDE_ERROR.'");
                    el.checked = !el.checked;
                    return;
                }
			}

		    function removeFilter(e)
		    {
		        window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_comments_all_comments'.$order_get.'";
		        return sbCancelEvent(e);
		    }
	    </script>';

	$href = SB_CMS_CONTENT_FILE.'?event=pl_comments_all_comments'.$filter_get;

	$opt_ident = array(' --- ');
	$edit_rights = array();
	$delete_rights = array();
	$edit_com_rights = array();
	$res_ident = sql_query('SELECT DISTINCT(c_plugin) FROM sb_comments');
	if($res_ident)
	{
		foreach($res_ident as $value)
		{
			$opt_ident[$value[0]] = $_SESSION['sbPlugins']->getPluginTitle($value[0]);
            if($_SESSION['sbPlugins']->isRightAvailable($value[0], 'elems_edit'))
            {
                $edit_rights[] = $value[0];
            }
            if($_SESSION['sbPlugins']->isRightAvailable($value[0], 'elems_com_edit'))
            {
                $edit_com_rights[] = $value[0];
            }
            
            if($_SESSION['sbPlugins']->isRightAvailable($value[0], 'elems_com_del'))
            {
                $delete_rights[] = $value[0];
            }
		}
	}

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	echo '
    <table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
        	<table cellpadding="0" cellspacing="0">
        	<tr>
            	<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/fil_arrow_down.gif" id="filter_arrow" align="absmiddle" /></span></td>
            	<td class="sb_filter_on" id="sb_filter_on" style="'.($filter_str != '' ? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
            </tr></table>
        </td>
    </tr>
    <tr>
    	<td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter" style="display:none;">
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">'.PL_COMMENTS_EDIT_ELEM_ID_TAG.':</th>
                <td class="sb_filter_td">
                	<table style="font-size:12px;">
                		<tr>
                			<td>'.KERNEL_FROM.'</td>
							<td>';

	$fld = new sbLayoutInput('text', isset($_GET['c_id_lo']) ? $_GET['c_id_lo'] : '', 'c_id_lo', 'spin_c_id_lo', 'style="width:50px;"');
	echo $fld->getJavaScript().$fld->getField().'

							</td>
							<td>&nbsp;'.KERNEL_TO.'&nbsp;</td>
							<td>';

	$fld = new sbLayoutInput('text', isset($_GET['c_id_hi']) ? $_GET['c_id_hi'] : '', 'c_id_hi', 'spin_c_id_hi', 'style="width:50px;"');
	echo $fld->getField().'</td>

						</tr>
					</table>
				</td>
				<th class="sb_filter_th">'.PL_COMMENTS_ALL_COMMENTS_TITLE_AUTHOR.':</th>
				<td class="sb_filter_td_noborder">';

	$fld = new sbLayoutInput('text', isset($_GET['c_author']) ? $_GET['c_author'] : '', 'c_author', '', 'style="width: 100%;"');
	echo $fld->getField().

				'</td>
			</tr>
			<tr>
				<th class="sb_filter_th">'.PL_COMMENTS_ALL_COMMENTS_TITLE_DATE.':</th>
				<td class="sb_filter_td"><nobr>';

	$fld_lo = new sbLayoutDate((isset($_GET['c_date_from']) ? $_GET['c_date_from'] : ''), 'c_date_from');
	$fld_lo->mDropButton = true;

	$fld_hi = new sbLayoutDate((isset($_GET['c_date_to']) ? $_GET['c_date_to'] : ''), 'c_date_to');
	$fld_hi->mDropButton = true;

	echo $fld_lo->getJavaScript().'
			    <table cellpadding="0" cellspacing="0"><tr><td>'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld_lo->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld_hi->getField().'</td></tr></table>
			    </nobr></td>
				<th class="sb_filter_th">'.PL_COMMENTS_EDIT_DESIGN_FILE.':</th>
            	<td class="sb_filter_td_noborder">';

	$fld = new sbLayoutInput('text', isset($_GET['c_file']) ? $_GET['c_file'] : '', 'c_file', '', 'style="width: 100%;"');
    echo $fld->getField().'

				</td>
			</tr>
			<tr>
                <th class="sb_filter_th">'.PL_COMMENTS_EDIT_DESIGN_SUBJ.':</th>
                <td class="sb_filter_td">';

    $fld = new sbLayoutInput('text', isset($_GET['c_subj']) ? $_GET['c_subj'] : '', 'c_subj', '', 'style="width: 100%;"');
    echo $fld->getField().'

    			</td>
				<th class="sb_filter_th">'.PL_COMMENTS_EDIT_DESIGN_AUTHOR_IP_TAG.':</th>
				<td class="sb_filter_td_noborder">';

	$fld = new sbLayoutInput('text', isset($_GET['c_ip']) ? $_GET['c_ip'] : '', 'c_ip', '', 'style="width: 100%;"');
    echo $fld->getField().'

				</td>
			</tr>
			<tr>
				<th class="sb_filter_th">'.PL_COMMENTS_EDIT_DESIGN_TEXT.':</th>
				<td class="sb_filter_td">';

	$fld = new sbLayoutInput('text', isset($_GET['c_text']) ? $_GET['c_text'] : '', 'c_text', '', 'style="width: 100%;"');
	echo $fld->getField().'

				</td>
				<th class="sb_filter_th">'.PL_COMMENTS_EDIT_MODULE.'</th>
				<td class="sb_filter_td_noborder">';

	$fld = new sbLayoutSelect($opt_ident, 'module');
	if (isset($_GET['module']))
	{
		$fld->mSelOptions = array($_GET['module']);
	}
	echo $fld->getField().'

				</td>
			</tr>
			</table>
					<div class="sb_filter_footer">
						<input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;
					</div>
				</div>
			</form>
			</table>
		</td>
	</tr></table>
	<br>
	<center>';

	$total = true;

	require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
	$pager = new sbDBPager('comments', 7, 25, 'content');

	if (!$_SESSION['sbAuth']->isAdmin())
	{
		$cat_rights_str = '';
		if(count($_SESSION['sbAuth']->getUserGroups()) > 0)
		{
			$cat_rights_str .= ' AND (';
			foreach($_SESSION['sbAuth']->getUserGroups() as $value)
			{
				$cat_rights_str .= ' CONCAT("^", cat.cat_rights, "^") LIKE "%^g'.$value.'^%" OR ';
			}
			$cat_rights_str .= ' CONCAT("^", cat.cat_rights, "^") LIKE "%^u'.$_SESSION['sbAuth']->getUserId().'^%" OR ';
			$cat_rights_str = sb_substr($cat_rights_str, 0, -4).') ';
		}

		$result = $pager->init($total, 'SELECT c.c_id, c.c_plugin, c.c_el_id, c.c_author, c.c_subj, c.c_text, c.c_date, c.c_show, c.c_el_id, c.c_user_id, su.su_login, su.su_email, c.c_level, c.c_file, c.c_file_name
				FROM sb_comments c LEFT JOIN sb_site_users su ON su.su_id = c.c_user_id LEFT JOIN sb_catlinks l ON l.link_el_id = c.c_el_id
				LEFT JOIN sb_categs cat ON cat.cat_id = l.link_cat_id, sb_users_rights r
				WHERE r.ur_plugin = c.c_plugin AND  r.ur_cat_id IN (?a) AND r.ur_plugin_rights <> ""
					AND (r.ur_plugin_rights LIKE "%elems_com_show%" AND r.ur_plugin LIKE "%pl_plugin%" OR r.ur_plugin NOT LIKE "%pl_plugin%")
				'.$cat_rights_str.
				($filter_str != '' ? $filter_str : '').'
				GROUP BY c.c_id  '.$order_str, $_SESSION['sbAuth']->getUserGroups());
/*
		Когда правки по правам к комменатриям добавяться к остальным модулям нужно будет заменить строку в запросе
		AND (r.ur_plugin_rights LIKE "%elems_com_show%" AND r.ur_plugin LIKE "%pl_plugin%" OR r.ur_plugin NOT LIKE "%pl_plugin%")
		AND r.ur_plugin_rights LIKE "%elems_com_show%"
*/

	}
	else
	{
		$result = $pager->init($total, 'SELECT c.c_id, c.c_plugin, c.c_el_id, c.c_author, c.c_subj, c.c_text, c.c_date, c.c_show, c.c_el_id, c.c_user_id, su.su_login, su.su_email, c.c_level, c.c_file, c.c_file_name
			FROM sb_comments c LEFT JOIN sb_site_users su ON su.su_id = c.c_user_id '.($filter_str != '' ? 'WHERE '.substr($filter_str, 5) : '').' GROUP BY c.c_id '.$order_str);
	}
    

	$num_list = $pager->show();
	echo '<br />'.$num_list.'<br /><br />
	<table width="98%" cellspacing="0" cellpadding="5" class="form">
	<tr>
        <th class="header" width="20"><a href="'.$href.'&order=trees" title="'.PL_COMMENTS_TREES_TITLE_IMG.'"><img alt="'.PL_COMMENTS_TREES_TITLE_IMG.'" src="'.SB_CMS_IMG_URL.'/trees.gif" border="0"></a></th>
        <th class="header" width="100">
            <nobr>
            	<a href="'.$href.'&order=c_show|asc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_show|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
            	&nbsp;'.PL_COMMENTS_ALL_COMMENTS_TITLE_SHOW.'&nbsp;
				<a href="'.$href.'&order=c_show|desc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_show|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" width="80">
            <nobr>
                <a href="'.$href.'&order=c_date|asc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_date|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                &nbsp;'.PL_COMMENTS_ALL_COMMENTS_TITLE_DATE.'&nbsp;
                <a href="'.$href.'&order=c_date|desc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_date|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" width="100">
            <nobr>
				<a href="'.$href.'&order=c_author|asc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_author|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
				&nbsp;'.PL_COMMENTS_ALL_COMMENTS_TITLE_AUTHOR.'&nbsp;
				<a href="'.$href.'&order=c_author|desc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_author|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
			</nobr>
		</th>
        <th class="header" width="100">
            <nobr>
                <a href="'.$href.'&order=c_subj|asc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_subj|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                &nbsp;'.PL_COMMENTS_EDIT_DESIGN_SUBJ.'&nbsp;
                <a href="'.$href.'&order=c_subj|desc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_subj|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header">
            <nobr>
                <a href="'.$href.'&order=c_text|asc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_text|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                &nbsp;'.PL_COMMENTS_EDIT_DESIGN_TEXT.'&nbsp;
                <a href="'.$href.'&order=c_text|desc"><img src="'.SB_CMS_IMG_URL.'/'.($order == 'c_text|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" width="90"></th>
    </tr>';

    if ($result)
    {
    	include_once(SB_CMS_LIB_PATH.'/prog/sbFunctions.inc.php');
        /**
         * Вывод таблицы
         */
		$view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_site_users', 'read');
		$plugin_info = $_SESSION['sbPlugins']->getPluginsInfo();

		for($i = 0; $i < count($result); $i++)
		{
			list($c_id, $c_plugin, $c_el_id, $c_author, $c_subj, $c_text, $c_date, $c_show, $c_el_id, $c_user_id, $su_login, $su_email, $c_level, $c_file, $c_file_name) = $result[$i];

			if($c_author == '')
				$c_author = $su_login;
			elseif($su_login == '' && $c_author == '')
				$c_author = $su_email;

			if(!is_null($c_user_id) && $c_user_id > 0 && $view_info)
			{
				$link_author = '<a style="font-size:11px;" href="'.SB_CMS_CONTENT_FILE.'?event=pl_kernel_site_user_info&id='.$c_user_id.'">'.$c_author.'</a>';
			}
			else
			{
				$link_author = $c_author;
			}

			$margin_str = '';
			if($c_level > 1 && isset($_REQUEST['order']) && $_REQUEST['order'] == 'trees')
			{
				$margin_str = ' style="margin-left:'.(20 * ($c_level - 1)).'px;" ';
			}
			echo '<tr'.($i % 2 != 0 ? ' class="even"' : ' class="odd"').'>

                    <td style="text-align:center;width:20px;"><a href="'.SB_CMS_CONTENT_FILE.'?event='.$plugin_info[$c_plugin]['main_event'].'&sb_sel_id='.$c_el_id.'&show_comments=1"><img border="0" title="'.$plugin_info[$c_plugin]['title'].'" src="'.sb_str_replace('24', '16', $plugin_info[$c_plugin]['icon']).'"></a></td>
					<td style="text-align:center;width:100px;"><input type="checkbox" id="'.$c_id.'" '.($c_show == 1 ? 'checked="checked"' : '').' onclick="setActive(this, this.id);" '.(in_array($c_plugin, $edit_rights)? '': 'disabled="disabled"').'></td>
					<td style="font-size:11px;text-align:center;width:80px;">'.sb_date('d.m.Y', $c_date).'<br />'.KERNEL_IN.'<br />'.sb_date('H:i:s', $c_date).'</td>
					<td style="font-size:11px;text-align:center;width:100px;">'.$link_author.'</td>
                    <td style="text-align:center;width:100px;"><a style="font-size:11px;" href="'.SB_CMS_CONTENT_FILE.'?event='.$plugin_info[$c_plugin]['main_event'].'&sb_sel_id='.$c_el_id.'&show_comments=1">'.($c_subj != '' ? $c_subj : '&#8212;').'</a></td>
                    <td><div class="hint_div" '.$margin_str.'>'.
						sbProgParseBBCodes($c_text, '<div style="border: 1px solid #616161; border-style: dashed; margin:5px 5px 5px 15px;padding:4px;">Автор: {AUTHOR}, дата: {DATE}<br />', '</div>').
						'</div>'.
						($c_file != '' ? '<div style="padding-top: 7px;"><a href="'.$c_file.'" target="_blank" class="smalltext"><img src="'.SB_CMS_IMG_URL.'/clip.gif" width="7" height="13" border="0" align="absmiddle" />&nbsp;'.$c_file_name.'</a></div>' : '').
					'</td>
					<td style="vertical-align: middle;">'.
                    (in_array($c_plugin, $edit_com_rights)?
						'<img src="/cms/images/btn_props.png" title="'.KERNEL_EDIT.'" onclick="editComment(\''.$c_plugin.'\', \''.$c_id.'\');" style="cursor:hand;cursor: pointer;" width="20" border="0" height="20">
						&nbsp;&nbsp;' : '').
                    (in_array($c_plugin, $delete_rights)? 
                        '<img src="/cms/images/btn_delete.png" title="'.KERNEL_DELETE.'" onclick="deleteComment(\''.$c_plugin.'\', \''.$c_id.'\');" style="cursor:hand;cursor: pointer;" width="20" height="20">
						'.($c_file != '' ? '&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/images_drop.png" width="20" height="20" title="'.PL_COMMENTS_H_SHOW_DELETE_FILE.'" onclick="deleteFile(\''.$c_plugin.'\', \''.$c_id.'\');" style="cursor:hand;cursor:pointer;" />' : '') : '').'
					</td>
				</tr>';
		}
	}
	else
    {
		$num_list = PL_COMMENTS_ALL_COMMENTS_NO_COMMETS;
    }

	echo '</table>
		<br />'.$num_list.'<br /><br /></center>';
}

function fComments_Set_Active()
{
	$res = sql_query('SELECT c_id, c_subj, c_show, c_author, c_plugin FROM sb_comments WHERE c_id = ?d', $_GET['id']);
	if ($res)
	{
		if (!isset($res[0][4]) || $res[0][4] == '' || !$_SESSION['sbPlugins']->isRightAvailable($res[0][4], 'elems_com_edit'))
		{
			return '';
		}
		foreach ($res as $value)
		{
			list($c_id, $c_subj, $c_show, $c_author) = $value;
			$c_show = ($c_show == 1 ? 0 : 1);

			if (trim($c_author) != '')
			{
				$c_subj .= ' ('.PL_COMMENTS_SET_ACTIVE_AUTHOR.': '.$c_author.')';
			}

			sql_query('UPDATE sb_comments SET c_show=?d WHERE c_id=?d', $c_show, $c_id, sprintf(PL_COMMENTS_SET_ACTIVE_EDIT_OK, $c_subj));
		}
		echo 'TRUE';
	}
}

?>