<?php

function fCron_Init()
{
    echo '<script>
    function sbEditTask(id)
    {
        var el_id = id.substr(5);
        var strPage = sb_cms_modal_dialog_file + "?event=pl_cron_edit&id="+el_id;
        var strAttr = "resizable=1,width=850,height=670";
        sbShowModalDialog(strPage, strAttr, afterEditTask);
    }

    function afterEditTask()
    {
        if (sbModalDialog.returnValue)
        {
            var el_id = sbModalDialog.returnValue.id;
            sbGetE("d_"+el_id).innerHTML = sbModalDialog.returnValue.minutes+" '.PL_CRON_MINUTE_LABEL.'";
            sbGetE("mod_"+el_id).innerHTML = "<b>"+sbModalDialog.returnValue.pl_name+"</b><br /><span class=\'smalltext\'>"+sbModalDialog.returnValue.sc_name+"</span>";
            sbGetE("sc_date_"+el_id).innerHTML = sbModalDialog.returnValue.sc_date;
            sbGetE("checkbox_"+el_id).checked = (sbModalDialog.returnValue.active == 1);
            sbGetE("revoke_"+el_id).innerHTML = sbModalDialog.returnValue.revoke+" '.PL_CRON_MINUTE_LABEL.'";
        }
    }

    function sbAddTask()
    {
        var strPage = sb_cms_modal_dialog_file + "?event=pl_cron_edit";
        var strAttr = "resizable=1,width=850,height=670";
        sbShowModalDialog(strPage, strAttr, afterAddTask);
    }

    function afterAddTask()
    {
        if (sbModalDialog.returnValue)
        {
            var table = sbGetE("events_table");
            if(!table)
            {
                window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_cron_init";
                return;
            }

            var tr = document.createElement("TR");
            var last = sbGetE("last_tr");

            if (_isIE)
            {
                tr.setAttribute("className", last.className);
            }
            else
            {
                tr.setAttribute("class", last.className);
            }

            if(last.className == "odd")
                last.className = "even";
            else if(last.className == "even")
                last.className = "odd";

            var el_id = sbModalDialog.returnValue.id;
            tr.setAttribute("id", "tr_" + el_id);

            var td1 = document.createElement("TD");
            td1.align = "center";
            td1.innerHTML = "<input type=\'checkbox\' id=\'checkbox_"+el_id+"\' "+(sbModalDialog.returnValue.active == \'1\' ? \'checked="checked"\' : \'\')+" onClick=\'sbSetActive(this.id);\'>";
            tr.appendChild(td1);

            var td2 = document.createElement("TD");
            td2.align = "center";
			td2.setAttribute("id", "mod_"+el_id);
            td2.innerHTML = "<b>"+sbModalDialog.returnValue.pl_name+"</b><br /><span class=\'smalltext\'>"+sbModalDialog.returnValue.sc_name+"</span>";
            tr.appendChild(td2);

            var td3 = document.createElement("TD");
            td3.align = "center";
            td3.setAttribute("id", "sc_date_"+el_id);
            td3.innerHTML = "-";
            tr.appendChild(td3);

            var td_manual = document.createElement("TD");
            td_manual.align = "center";
            td_manual.innerHTML = \'<td align="center"><button onclick="startManual(\'+el_id+\')">'.PL_CRON_START_MANUAL.'</button>\';
            tr.appendChild(td_manual);

            var td4 = document.createElement("TD");
            td4.setAttribute("id", "d_"+el_id);
            td4.align = "center";
            td4.innerHTML = sbModalDialog.returnValue.minutes+" '.PL_CRON_MINUTE_LABEL.'";
            tr.appendChild(td4);

            var td_revoke = document.createElement("TD");
            td_revoke.setAttribute("id", "revoke_"+el_id);
            td_revoke.align = "center";
            td_revoke.innerHTML = sbModalDialog.returnValue.revoke+" '.PL_CRON_MINUTE_LABEL.'";
            tr.appendChild(td_revoke);

            var td5 = document.createElement("TD");
            td5.align = "center";
            td5.innerHTML = "<img height=\'20\' width=\'20\' border=\'0\' style=\'cursor: pointer;\' id=\'edit_"+el_id+"\' onClick = \'sbEditTask(this.id);\' title=\''.KERNEL_EDIT.'\' src=\''.SB_CMS_IMG_URL.'/btn_props.png\'/>";
            tr.appendChild(td5);

            var td5 = document.createElement("TD");
            td5.align = "center";
            td5.innerHTML = "<img height=\'20\' width=\'20\' style=\'cursor: pointer;\' id=\'delete_"+el_id+"\'  onClick = \'sbDeleteTask(this.id);\' title=\''.KERNEL_DELETE.'\' src=\''.SB_CMS_IMG_URL.'/btn_delete.png\'/>";
            tr.appendChild(td5);

            var el = table.tBodies[0];
            if(el)
            {
                el.insertBefore(tr, last);
            }
        }
    }

    function sbDeleteTask(id)
    {
        if(confirm("'.PL_CRON_DELETE_EVENT_MSG.'"))
	    {
	        var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_cron_delete&id=" + id);

	        if (res == "FALSE")
	        {
	        	alert("'.PL_CRON_DELETE_ERROR.'");
	        }
	        else if(res == "RELOAD")
	        {
                window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_cron_init";
            }
	        else
	        {
	            var table = sbGetE("events_table");
                var el = sbGetE("tr_"+res);

                if (!table || !el)
                	return;

		        table = table.tBodies[0];
			    el.removeNode(el);

			    for (var i = 1; i < table.rows.length; i++)
			    {
			        if (i % 2 == 0)
			        {
			            if (_isIE)
			                table.rows[i].setAttribute("className", "odd");
			            else
			                table.rows[i].setAttribute("class", "odd");
			        }
			        else
			        {
			            if (_isIE)
			                table.rows[i].setAttribute("className", "even");
			            else
			                table.rows[i].setAttribute("class", "even");
			        }
			    }
            }
	    }
    }

    function sbSetActive(id)
    {
        var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_cron_set_active&id=" + id);
        if(res != "TRUE")
        {
            alert("'.PL_CRON_SET_ACTIVE_ERROR.'");
        }
    }

    function startManual(id)
    {
        var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_cron_start_manual&id=" + id);

        if(res == "RELOAD")
        {
            window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_cron_init";
        }
        else
        {
            sbShowMsgDiv(res);
        }
    }
    </script>';

    echo '<br /><br />';

	$res = sql_query('SELECT sc_id, sc_name, sc_date, sc_plugin_ident, sc_active, sc_manual, sc_inprogress, sc_start_interval, sc_revoke FROM sb_cron ORDER BY sc_id');
    if($res)
    {
		$html = '<table id="events_table" style="width:100%;" cellpadding="5" cellspacing="0" class="form">
					<tr>
	                	<th class="header" style="width:10%;">'.PL_CRON_EDIT_ACTIVE.'</th>
	                	<th class="header" style="width:40%;">'.PL_CRON_EDIT_NAME.'</th>
	                    <th class="header" style="width:20%;">'.PL_CRON_EDIT_DATE.'</th>
                        <th class="header" style="width:10%;"></th>
	                	<th class="header" style="width:10%;">'.PL_CRON_EDIT_INTERVAL.'</th>
                        <th class="header" style="width:10%;">'.PL_CRON_EDIT_MAX_TIME.'</th>
	                    <th class="header" style="width:1px;">&nbsp;</th>
	                    <th class="header" style="width:1px;">&nbsp;</th>
                    </tr>';

        $plugins_info = $_SESSION['sbPlugins']->getPluginsInfo();

        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
        $layout = new sbLayout();

		$class = '';
		$r = 1;

		foreach ($res as $value)
        {
            list ($sc_id, $sc_name, $sc_date, $sc_plugin_ident, $sc_active, $sc_manual, $sc_inprogress, $sc_start_interval, $sc_revoke) = $value;

            if (!isset($plugins_info[$sc_plugin_ident]) || !isset($_SESSION['sbPlugins']->mCron[$sc_plugin_ident]))
            	continue;

            $pl_name = $plugins_info[$sc_plugin_ident]['title'];
            $sc_date = is_null($sc_date) ? '-' : sb_date('d.m.Y '.KERNEL_IN.' H:i:s', $sc_date);

            $fld = new sbLayoutInput('checkbox', '1', '', 'checkbox_'.$sc_id, ($sc_active == 1 ? 'checked="checked"' : '').' onClick="sbSetActive(this.id);"');

            $class = ($r % 2 == 0 ? 'odd' : 'even');
            $r++;

            $html .= '<tr class="'.$class.'" id="tr_'.$sc_id.'">
                <td align="center">'.$fld->getField().'</td>
                <td align="center" id="mod_'.$sc_id.'"><b>'.$pl_name.'</b><br /><span class="smalltext">'.$sc_name.'</span></td>
                <td align="center" id="sc_date_'.$sc_id.'">'.$sc_date.'</td>';
            if($sc_inprogress == 0 && $sc_manual == 0)
            {
                $html .= '<td align="center"><button onclick="startManual('.$sc_id.')">'.PL_CRON_START_MANUAL.'</button></td>';
            }
            else
            {
                $html .= '<td align="center">'.PL_CRON_IN_PROGRESS.'</td>';
            }

            $html .= '<td align="center" id="d_'.$sc_id.'">'.$sc_start_interval.' '.PL_CRON_MINUTE_LABEL.'</td>
                <td align="center" id="revoke_'.$sc_id.'">'.$sc_revoke.' '.PL_CRON_MINUTE_LABEL.'</td>
                <td align="center"><img height="20" width="20" border="0" style="cursor: pointer;" id="edit_'.$sc_id.'" onClick = "sbEditTask(this.id);" title="'.KERNEL_EDIT.'" src="'.SB_CMS_IMG_URL.'/btn_props.png"/></td>
                <td align="center"><img height="20" width="20" style="cursor: pointer;" id="delete_'.$sc_id.'" onClick = "sbDeleteTask(this.id);" title="'.KERNEL_DELETE.'" src="'.SB_CMS_IMG_URL.'/btn_delete.png"/></td>
            </tr>';
        }

        $class = ($class == 'odd' ? 'even' : 'odd');
        $html .= '<tr id="last_tr" class="'.$class.'">
                        <td></td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td></td>
                    </tr>
                </table>
                <br />
                <div class="hint_div">'.PL_CRON_HINT.'</div>';

        $layout->addField('', new sbLayoutHTML($html, true));
        $layout->addButton('submit', KERNEL_ADD, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_cron', 'elems_edit') ? '' : 'disabled="disabled"').' onClick="sbAddTask();"' );
    	$layout->show();
    }
    else
    {
        sb_show_message(PL_CRON_NO_EVENTS_MSG.'<br /><br /><a href="javascript:sbAddTask();" >'.PL_CRON_ADD_EVENT.'</a>', true);
    }
}

function fCron_Edit()
{
	if(count($_SESSION['sbPlugins']->mCron) == 0)
	{
		sb_show_message(PL_CRON_EDIT_NO_EVENTS_MSG, true);
		echo '<br /><br /><a href="javascript:window.close();">[ '.KERNEL_CLOSE.' ]</a>';
    	return;
	}

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
    {
        $result = sql_query('SELECT sc_plugin_ident, sc_file_path, sc_func_name, sc_active, sc_time_table, sc_start_interval, sc_revoke FROM sb_cron WHERE sc_id=?d', $_GET['id']);
        if($result)
        {
            list($sc_plugin_ident, $sc_file_path, $sc_func_name, $sc_active, $sc_time_table, $sc_start_interval, $sc_revoke) = $result[0];
        }
        else
        {
            sb_show_message(PL_CRON_EDIT_ERROR, true, 'warning');
            return;
        }
    }
    elseif (count($_POST) > 0)
    {
        $sc_time_table = '';
        $sc_active = 0;
        $sc_revoke = 1440;

    	extract($_POST);

        if (!isset($_GET['id']))
            $_GET['id'] = '';

		$cron_events = explode('|', $cron_events);
        if(count($cron_events) > 0)
        {
        	$sc_file_path = $cron_events[0];
        	$sc_func_name = $cron_events[1];
	        $sc_plugin_ident = $cron_events[2];
        }
    }
    else
    {
        $sc_plugin_ident = $sc_file_path = $sc_func_name = $sc_time_table = '';
        $sc_active = 1;
        $sc_start_interval = 0;
        $sc_revoke = 1440;

        $_GET['id'] = '';
    }

    echo '<script>
    function sbChangeDescription(ident)
    {
		sbGetE("descr").innerHTML = "<div style=\'width:300px; text-align:center;\'><img src=\''.SB_CMS_IMG_URL.'/loading.gif\' /></div>";
		sbLoadAsync("'.SB_CMS_EMPTY_FILE.'?event=pl_cron_change_descr&ident=" + ident, sbAfterLoadDescr);
    }

    function sbAfterLoadDescr(res)
    {
        if(res != "")
        {
            sbGetE("descr").innerHTML = "<div class=\'hint_div\'>" + res + "</div>";
        }
        else
        {
            sbGetE("descr").innerHTML = "";
        }
    }
    </script>
    <br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_cron_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', '');
	$layout->mTableWidth = '95%';
	$layout->addHeader(PL_CRON_EDIT_TITLE);

	$plugins_info = $_SESSION['sbPlugins']->getPluginsInfo();

	$options = array();
	$first = true;
	$sc_description = '';

	foreach($_SESSION['sbPlugins']->mCron as $key => $value)
    {
        $options[uniqid()] = '-'.$plugins_info[$key]['title'];

	    foreach($value as $val)
	    {
			$options[$val['task_path'].'|'.$val['task_func'].'|'.$key] = $val['task_name'];
			if($first)
			{
				$first = false;
				$sc_description = $val['task_descr'];
			}

			if ($key == $sc_plugin_ident && $val['task_path'] == $sc_file_path && $val['task_func'] == $sc_func_name)
			{
				$sc_description = $val['task_descr'];
			}
		}
	}

	$fld = new sbLayoutSelect($options, 'cron_events', 'cron_events', 'onkeyup="sbChangeDescription(this.value);" onChange="sbChangeDescription(this.value);"');
	$fld->mSelOptions = array($sc_file_path.'|'.$sc_func_name.'|'.$sc_plugin_ident);

	if($sc_description != '')
	{
		$sc_description = '<div class="hint_div">'.$sc_description.'</div>';
	}

	$html = '
	<table>
	<tr class="even">
        <td style="vertical-align:top;">'.$fld->getField().'</td>
        <td id="descr">'.$sc_description.'</td>
	</tr>
    </table>';

    $layout->addField(PL_CRON_EDIT_NAME, new sbLayoutHTML($html));
    $layout->addField(PL_CRON_EDIT_ACTIVE, new sbLayoutInput('checkbox', '1', 'sc_active', '', (isset($sc_active) && $sc_active ==1 ? 'checked="checked"' : '' )));

	$layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_CRON_EDIT_TIME_START, new sbLayoutPlanTable($sc_time_table));
	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutInput('text', $sc_start_interval, 'sc_start_interval', 'spin_sc_start_interval', 'style="width:90px;"');
	$fld->mMinValue = 0;
	$fld->mMaxValue = 59;
	$layout->addField(PL_CRON_EDIT_INTERVAL2, $fld);

    $fld = new sbLayoutInput('text', $sc_revoke, 'sc_revoke', 'spin_sc_revoke', 'style="width:90px;"');
	$fld->mMinValue = 1;
	$fld->mMaxValue = 1440;
	$layout->addField(PL_CRON_EDIT_MAX_TIME2, $fld);

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_cron', 'elems_edit') ? '' : 'disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show();
}

function fCron_Submit()
{
	if (!isset($_GET['id']))
		$_GET['id'] = '';

	$sc_active = 0;

	extract($_POST);

	if(isset($cron_events))
	{
		$cron_events = explode('|', $cron_events);
	}
	else
	{
		$cron_events = array('', '', '');
	}

	$exists = sql_query('SELECT sc_id FROM sb_cron WHERE sc_plugin_ident=? AND sc_file_path=? AND sc_func_name=?', $cron_events[2], $cron_events[0], $cron_events[1]);

	if($exists)
    {
        $exists = ($exists[0][0] == $_GET['id'] ? false : true);
    }
    else
    {
		$exists = false;
    }

    if($exists)
    {
     	sb_show_message(PL_CRON_TASK_EXISTS_MSG, false, 'warning');
        fCron_Edit();
        return;
    }

	$sc_name = '';
	$plugins_info = $_SESSION['sbPlugins']->getPluginsInfo();

    if (isset($plugins_info[$cron_events[2]]) && isset($_SESSION['sbPlugins']->mCron[$cron_events[2]]))
    {
		foreach($_SESSION['sbPlugins']->mCron[$cron_events[2]] as $val)
	    {
	        if($val['task_path'] == $cron_events[0] && $val['task_func'] == $cron_events[1])
	        {
	            $sc_name = $val['task_name'];
	        }
	    }
    }

    if ($sc_name == '')
    {
    	sb_show_message(PL_CRON_NO_TASK_MSG, false, 'warning');
        fCron_Edit();
        return;
    }

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $row = array();
    $row['sc_name'] = $sc_name;
    $row['sc_file_path'] = $cron_events[0];
    $row['sc_func_name'] = $cron_events[1];
    $row['sc_plugin_ident'] = $cron_events[2];
    $row['sc_active'] = $sc_active;
    $row['sc_time_table'] = sbLayoutPlanTable::getStrForDb();
    $row['sc_start_interval'] = $sc_start_interval;
    $row['sc_revoke'] = $sc_revoke;

    $sc_date = null;
    if ($_GET['id'] != '')
    {
        $res = sql_query('SELECT sc_name, sc_file_path, sc_func_name, sc_date FROM sb_cron WHERE sc_id=?d', $_GET['id']);
        if ($res)
        {
            // редактирование
            list($old_name, $old_file_path, $old_func_name, $sc_date) = $res[0];

            if ($old_file_path != $cron_events[0] || $old_func_name != $cron_events[1])
            {
            	$row['sc_date'] = null;
            	$sc_date = null;
            }

            sql_query('UPDATE sb_cron SET ?a WHERE sc_id=?d', $row, $_GET['id'], sprintf(PL_CRON_EDIT_OK, $old_name));

            $id = intval($_GET['id']);
		}
		else
		{
			sb_show_message(PL_CRON_EDIT_ERROR, false, 'warning');
			sb_add_system_message(sprintf(PL_CRON_EDIT_SYSTEMLOG_ERROR, $sc_name), SB_MSG_WARNING);

			fCron_Edit();
			return;
		}
	}
	else
	{
		$error = true;
		sql_query('INSERT INTO sb_cron (?#) VALUES (?a)', array_keys($row), array_values($row));

		$id = sql_insert_id();

		if($id)
		{
			sb_add_system_message(sprintf(PL_CRON_ADD_OK, $sc_name));
			$error = false;
        }

		if ($error)
        {
            sb_show_message(sprintf(PL_CRON_ADD_ERROR, $sc_name), false, 'warning');
            sb_add_system_message(sprintf(PL_CRON_ADD_SYSTEMLOG_ERROR, $sc_name), SB_MSG_WARNING);

            fCron_Edit();
            return;
        }
    }

    echo '<script>
    var res = new Object();
    res.id = "'.$id.'";
    res.minutes = "'.$sc_start_interval.'";
    res.pl_name = "'.$GLOBALS['sbSql']->escape($plugins_info[$cron_events[2]]['title'], false, false).'";
    res.sc_name = "'.$GLOBALS['sbSql']->escape($sc_name, false, false).'";
    res.sc_date = "'.(is_null($sc_date) ? '-' : sb_date('d.m.Y '.KERNEL_IN.' H:i:s', $sc_date)).'";
    res.active = "'.($sc_active == 1 ? '1' : '0').'";
    res.revoke = "'.$sc_revoke.'";
    sbReturnValue(res);
    </script>';
}

function fCron_Delete()
{
	$res = sql_query('SELECT sc_id, sc_name FROM sb_cron WHERE sc_id = ?d', preg_replace('/[^0-9]+/'.SB_PREG_MOD, '', $_GET['id']));
	if (!$res)
	{
		echo 'FALSE';
		return;
	}

	list($sc_id, $sc_name) = $res[0];

    if (!sql_query('DELETE FROM sb_cron WHERE sc_id=?d ', intval(preg_replace('/[^0-9]+/'.SB_PREG_MOD, '', $_GET['id'])), sprintf(PL_CRON_DELETE_OK, $sc_name)))
    {
        echo 'FALSE';
		return;
    }

    $res = sql_query('SELECT COUNT(*) FROM sb_cron');
	// Если нет ни одного события то устанавливаем флаг что нет событий
    if(!$res || $res[0][0] <= 0)
    {
    	// Флаг. Если возваращается то перезагружаем стараницу
        echo 'RELOAD';
    }
    else
    {
    	echo $sc_id;
    }
}

function fCron_Set_Active()
{
    $res = sql_query('SELECT sc_id, sc_name, sc_active FROM sb_cron WHERE sc_id = ?d', preg_replace('/[^0-9]+/'.SB_PREG_MOD, '', $_GET['id']));

    if ($res)
    {
        list($sc_id, $sc_name, $sc_active) = $res[0];
        $sc_active = ($sc_active == 1 ? 0 : 1);
        sql_query('UPDATE sb_cron SET sc_active = ?d WHERE sc_id = ?d', $sc_active, $sc_id, sprintf(PL_CRON_EDIT_OK, $sc_name));

        echo 'TRUE';
    }
}

function fCron_Change_Descr()
{
    $values = explode('|', $_GET['ident']);
    if (count($values) == 3 && isset($_SESSION['sbPlugins']->mCron[$values[2]]))
    {
	    foreach($_SESSION['sbPlugins']->mCron[$values[2]] as $value)
	    {
	        if($value['task_path'] == $values[0] && $value['task_func'] == $values[1])
	        {
	            echo $value['task_descr'];
	            return;
	        }
	    }
    }
}

function fCron_Start_Manual()
{
    $sc_id = preg_replace('/[^0-9]+/'.SB_PREG_MOD, '', $_GET['id']);
    $res = sql_query('SELECT sc_name FROM sb_cron WHERE sc_id = ?d', $sc_id);
    if ($res)
    {
        sql_query('UPDATE sb_cron SET sc_manual = 1 WHERE sc_id = ?d', $sc_id, sprintf(PL_CRON_MANUAL_OK, $res[0][0]));

        echo 'RELOAD';
    }
    else
    {
        echo PL_CRON_MANUAL_ERROR;
    }
}
?>