<?php
function fExport_Outing()
{
    if(!isset($_GET['ident']) || $_GET['ident'] == '')
    {
        return;
    }

    $ident = $_GET['ident'];



    $exportInfo = $_SESSION['sbPlugins']->getExportImportInfo();

    $export_html = '';
    $import_html = '';
    $tabs_ids = '';

    if(isset($exportInfo[$ident]))
    {
        switch ($exportInfo[$ident]['export'].$exportInfo[$ident]['import'])
        {
            case '01':
                $tabs_ids = 'var tab_ids = ["import"];';
                break;
            case '11':
                $tabs_ids = 'var tab_ids = ["export", "import"];';
                break;
            case '10':
                $tabs_ids = 'var tab_ids = ["export"];';
                break;
        }
    }

    if($tabs_ids == '')
    {
        return;
    }

    $tabs = new sbTabs();

    $templates = sql_param_assoc('SELECT * FROM sb_export_import_templates WHERE seit_plugin_ident=?s ORDER BY seit_id', $ident);

    //Закладка "Экспорт"
    if(isset($exportInfo[$ident]) && $exportInfo[$ident]['export'] == 1)
    {
        $rows_html = '';
        if($templates)
        {
            $class = 'class="even"';
            foreach($templates as $row)
            {
                if($row['seit_export'] == '')
                {
                    continue;
                }

                $class = ('' == $class)? ' class="even"' : '';

                $rows_html .= '<tr'.$class.'><td align="center">'.$row['seit_id'].'</td>
                    <td>'.$row['seit_title'].'</td>
                    <td>
                        <img src="'.SB_CMS_IMG_URL.'/btn_props.png" alt="'.PL_EXPORT_BTN_EDIT.'" title="'.PL_EXPORT_BTN_EDIT.'" onclick="editTemplate('.$row['seit_id'].');">&nbsp;
                        <img src="'.SB_CMS_IMG_URL.'/btn_delete.png" alt="'.PL_EXPORT_BTN_DELETE.'" title="'.PL_EXPORT_BTN_DELETE.'" onclick="deleteTemplate('.$row['seit_id'].');">
                    </td></tr>';
            }

            $export_html = '<table id="export_tbl" width="100%" class="form" cellpadding="5" cellspacing="0">
                    <tr>
                        <th class="header" width="30">ID</th>
                        <th class="header">'.PL_EXPORT_TH_NAME_TPL.'</th>
                        <th class="header" width="60"></th>
                    </tr>
                    '.(($rows_html != '')? $rows_html : '<tr><td colspan="3" align="center">'.PL_EXPORT_NO_TPL_FOUND.'</td></tr>').'</table>';
        }
        $tabs->addTab(PL_EXPORT_TAB_NAME, $export_html);
    }

    //Закладка "Импорт"
    if(isset($exportInfo[$ident]) && $exportInfo[$ident]['import'] == 1)
    {
        $rows_html = '';
        if($templates)
        {
            $class = 'class="even"';
            foreach($templates as $row)
            {
                if($row['seit_import'] == '')
                {
                    continue;
                }

                $class = ('' == $class)? ' class="even"' : '';

                $rows_html .= '<tr'.$class.'><td align="center">'.$row['seit_title'].'</td>
                    <td>
                        <img src="'.SB_CMS_IMG_URL.'/btn_props.png" alt="'.PL_EXPORT_BTN_EDIT.'" title="'.PL_EXPORT_BTN_EDIT.'" onclick="editTemplate('.$row['seit_id'].');">&nbsp;
                        <img src="'.SB_CMS_IMG_URL.'/btn_delete.png" alt="'.PL_EXPORT_BTN_DELETE.'" title="'.PL_EXPORT_BTN_DELETE.'" onclick="deleteTemplate('.$row['seit_id'].');">
                    </td></tr>';
            }

            $import_html = '<table id="import_tbl" width="100%" class="form" cellpadding="5" cellspacing="0">
                    <tr>
                        <th class="header" width="30">ID</th>
                        <th class="header">'.PL_EXPORT_TH_NAME_TPL.'</th>
                        <th class="header" width="60"></th>
                    </tr>
                    '.(($rows_html != '')? $rows_html : '<tr><td colspan="3" align="center">'.PL_EXPORT_NO_TPL_FOUND.'</td></tr>').'</table>';
        }
        $tabs->addTab(PL_IMPORT_TAB_NAME, $import_html);
    }

    $tabs->setBottom('<button onclick="addNewTemplate();">'.PL_IMPORT_ADD_TEMPLATE_BTN.'</button>');

    $tabs->show();

    echo '<script type="text/javascript">
        sbLoadTabs();', "\r\n", $tabs_ids, "\r\n", '

        function deleteTemplate(id)
        {
            if(confirm("'.PL_EXPORT_DELETE_MSG.'"))
            {
                window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_export_init&del_id="+id;
            }
        }

        function editTemplate(id)
        {
            var url = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_export_add_template&ident='.$ident.'&id="+id+"&type="+tab_ids[sbTabsAr[sbTabsAr.length-1].selectedItem];
            var attr = "resizable=1,width=700,height=600";
            sbShowModalDialog(url, attr, afterAddItem);
        }

        function addNewTemplate()
        {
            var url = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_export_add_template&ident='.$ident.'&type="+tab_ids[sbTabsAr[sbTabsAr.length-1].selectedItem];
            var attr = "resizable=1,width=700,height=600";
            sbShowModalDialog(url, attr, afterAddItem);
        }

        function afterAddItem(res)
        {
            window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_export_init";
        }
    </script>';
}
?>
