<?php

function fFaq_Info()
{
	@require_once(SB_CMS_LIB_PATH.'/prog/sbFunctions.inc.php');

	$count_q = sbPlugins::getUserSetting('sb_faq_count_question');

	$cat_right_str = '';
	$cats = array();
	if (!$_SESSION['sbAuth']->isAdmin())
    {
		$res = sql_query('SELECT cat_id, cat_rights FROM sb_categs WHERE cat_rights != "" AND cat_ident="pl_faq"');
        if ($res)
        {
        	foreach($res as $value)
        	{
	            $cat_rights = trim($value[1]);
	            
	            if($cat_rights == '')
	            	continue;

			    $cat_rights = explode('^', $cat_rights);
			    $cat_groups = array();

			    foreach ($cat_rights as $right)
			    {
			    	if ($right[0] == 'g')
			    	{
						$cat_groups[] = intval(substr($right, 1));
			    	}
			    	elseif ($right[0] == 'u')
			    	{
						if (intval(substr($right, 1)) == $_SESSION['sbAuth']->getUserId())
			    		{
							$cats[] = $value[0];
							break;
			    		}
					}
					else
			    	{
						$cat_groups[] = intval($right);
			    	}
			    }

				$groups = $_SESSION['sbAuth']->getUserGroups();
			    if (count(array_intersect($groups, $cat_groups)) > 0)
			    {
					$cats[] = $value[0];
			    }
        	}
        }
	}

	if(count($cats) > 0)
	{
		$cat_right_str = ' AND c.cat_id IN ('.implode(',', $cats).') ';
	}

	$res = false;
	if(count($cats) > 0 || $_SESSION['sbAuth']->isAdmin())
	{
		$res = sql_query('SELECT f.f_author, f.f_question, f.f_date, f.f_id, c.cat_title, c.cat_id FROM sb_faq f, sb_categs c, sb_catlinks l
			WHERE c.cat_id=l.link_cat_id AND l.link_el_id=f.f_id AND l.link_src_cat_id = 0 AND c.cat_ident="pl_faq" '.$cat_right_str.' AND f.f_answer = "" ORDER BY f.f_date DESC LIMIT 0, '.$count_q);
	}

	if($res)
    {
		$result = '<table width="100%" cellspacing="0" cellpadding="5" class="form" style="border: 0;">
	               <tr>
	                   <td colspan="3">
							<div class="hint_div" style="text-align:center;">'.PL_FAQ_H_NO_ANSWER_QUESTION.'</div>
	                   </td>
	               </tr>';
        $r = 0;
        foreach($res as $key => $value)
        {
			$r++;
			if($r%2 == 0)
				$class = 'even';
            else
                $class = 'add';

			$result .= '<tr style="border-bottom:1px solid red;"  class="'.$class.'">
                    <td style="padding:5px 10px 5px 10px; vertical-align:top; width:1%;">
                        <div class="smalltext">
                        	<nobr>'.sb_date('d.m.Y  H:i', $value[2]).'</nobr><br />
                        	<b>'.$value[0].'</b>
                        </div>
                    </td>
                    <td style="padding:5px 10px 0px 10px; vertical-align:top;">
						<div style="margin-bottom:7px;"><i><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_faq_init&sel_c='.$value[5].'">'.$value[4].'</a></i></div>
                        <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_faq_init&sb_sel_id='.$value[3].'">'.sbProgParseBBCodes($value[1], '', '', true).'</a>
                    </td>
                    <td style="width:80px;">
						<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_faq_init&show_answer=1&sb_sel_id='.$value[3].'">'.PL_FAQ_H_ANSWER_LINK.'</a>
                    </td>
                </tr>';
	    }

        $result .= '</table><br />
        <div class="sbDS_more"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_faq_init">'.KERNEL_MORE.'</a></div>';
        echo $result;
    }
    else
    {
        echo '<div class="hint_div" style="text-align:center; height:30px; margin:20px 5px 20px 5px; padding:10px 0px 0px 0px;">'.PL_FAQ_H_NO_QUESTION.'</div>';  
    }
}

/********************************** функции построения диалоговых окон *************************************************/

/**
 * Вывод диалогового окна списка вопросов
 */      
function fFaq_Get_Elem_List()
{
	require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
	$params = unserialize($_GET['params']);

	if (!isset($params['use_filter']))
    	$params['use_filter'] = 0;

	if (!isset($params['filter']))
		$params['filter'] = 'all';

    if (!isset($params['subcategs']))
    	$params['subcategs'] = 1;

	if (!isset($params['rubrikator']))
		$params['rubrikator'] = 1;

    if (!isset($params['cloud']))
		$params['cloud'] = 0;

    if (!isset($params['cloud_comp']))
		$params['cloud_comp'] = 0;

	if (!isset($params['calendar']))
		$params['calendar'] = 0;

    if (!isset($params['calendar_field']))
    	$params['calendar_field'] = 'f_date';

    if (!isset($params['filter_compare']))
    	$params['filter_compare'] = 'IN';

    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();
            
            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_FAQ_H_ELEM_LIST_NO_CATEGS_MSG.'");
                return;
            }
            params["ids"] = el_cats;

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_FAQ_H_ELEM_LIST_NO_TEMPS_ALERT.'");
                return;
            }

            if (sbGetE("calendar").checked && sbGetE("calendar_field").value == "")
            {
            	alert("'.PL_FAQ_H_ELEM_LIST_NO_CALENDAR_FIELD_ALERT.'");
            	return;
            }
            
            var r_filter_all = sbGetE("r_filter_all");
            var r_filter_last = sbGetE("r_filter_last");
            var r_filter_from_to = sbGetE("r_filter_from_to");
            
            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }
            else if (r_filter_last.checked)
            {
                params["filter"] = r_filter_last.value;
                var el_filter_last = sbGetE("spin_filter_last");
                params["filter_last"] = el_filter_last.value;
            }
            else if (r_filter_from_to.checked)
            {
                params["filter"] = r_filter_from_to.value;
                var el_filter_from = sbGetE("spin_filter_from");
                var el_filter_to = sbGetE("spin_filter_to");

                if (el_filter_to.value != "" && el_filter_to.value != 0 && parseInt(el_filter_from.value) > parseInt(el_filter_to.value))
                {
                    alert("'.PL_FAQ_H_ELEM_LIST_FILTER_FROM_TO_ERROR.'");
                    return;
                }

                params["filter_from"] = el_filter_from.value;
                params["filter_to"] = el_filter_to.value;
            }

            var el_sort1 = sbGetE("sort1");
            var el_order1 = sbGetE("order1");
            var el_sort2 = sbGetE("sort2");
            var el_order2 = sbGetE("order2");
            var el_sort3 = sbGetE("sort3");
            var el_order3 = sbGetE("order3");

            params["sort1"] = el_sort1.value;
            params["sort2"] = el_sort2.value;
            params["sort3"] = el_sort3.value;

            params["order1"] = el_order1.disabled ? "" : el_order1.value;
            params["order2"] = el_order2.disabled ? "" : el_order2.value;
            params["order3"] = el_order3.disabled ? "" : el_order3.value;

            params["page"] = sbGetE("page").value;
            params["auth_page"] = sbGetE("auth_page").value;
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["show_selected"] = sbGetE("show_selected").checked ? 1 : 0;
            params["show_hidden"] = sbGetE("show_hidden").checked ? 1 : 0;
            params["rubrikator"] = sbGetE("rubrikator").checked ? 1 : 0;
            params["show_all"] = sbGetE("show_all").checked ? 1 : 0;

            params["moderate"] = (sbGetE("moderate").checked ? 1 : 0);
            params["moderate_email"] = sbGetE("moderate_email").value;
			params["cloud"] = sbGetE("cloud").checked ? 1 : 0;
			params["cloud_comp"] = sbGetE("cloud_comp").checked ? 1 : 0;
			params["use_filter"] = sbGetE("use_filter").checked ? 1 : 0;
			params["registred_users"] = sbGetE("registred_users").checked ? 1 : 0;
			params["allow_bbcode"] = sbGetE("allow_bbcode").checked ? 1 : 0;
			params["use_sort"] = sbGetE("use_sort").checked ? 1 : 0;

            params["filter_logic"] = sbGetE("filter_logic").value;
            params["filter_text_logic"] = sbGetE("filter_text_logic").value;
            params["filter_compare"] = sbGetE("filter_compare").value;
            params["filter_morph"] = sbGetE("filter_morph").checked ? 1 : 0;
			
			params["calendar"] = sbGetE("calendar").checked ? 1 : 0;
			params["calendar_field"] = sbGetE("calendar_field").value;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
        
        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }

        function changeCalendarField(el)
        {
            sbGetE("calendar_field").disabled = !el.checked;
        }

        function changeFilterMorph(el)
        {
            sbGetE("filter_morph").disabled = (el.value != "IN");
        }
        
        function changeUseFilter(el)
        {
        	sbGetE("filter_morph").disabled = !el.checked || sbGetE("filter_compare").value != "IN";
        	sbGetE("filter_logic").disabled = !el.checked;
        	sbGetE("filter_text_logic").disabled = !el.checked;
        	sbGetE("filter_compare").disabled = !el.checked;
        }
	</script>';
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_FAQ_H_ELEM_LIST_CATEGS_TAB);

    $categs = new sbJustCategs('pl_faq');

    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());
    
    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();
    
    $layout->addTab(PL_FAQ_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_FAQ_H_ELEM_LIST_PROPS_TAB);
    
    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.fdl_id, temps.fdl_title
                      FROM sb_categs categs, sb_catlinks links, sb_faq_temps_list temps
                      WHERE temps.fdl_id=links.link_el_id
                      AND categs.cat_id=links.link_cat_id 
                      AND categs.cat_ident="pl_faq_list"
                      ORDER BY categs.cat_left, temps.fdl_title');
    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $fdl_id, $fdl_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$fdl_id] = $fdl_title;
        }
    }
       
    if (count($options) > 0)
    { 
        $fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    }
    else
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_FAQ_H_ELEM_LIST_NO_TEMPS_MSG.'</div>', '', '', false);    
    }
    $layout->addField(PL_FAQ_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 400px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_LIST_PAGE_HINT.'</div>';
    $layout->addField(PL_FAQ_H_ELEM_LIST_PAGE, $fld);   
    
    $fld = new sbLayoutPage(isset($params['auth_page']) ? $params['auth_page'] : '', 'auth_page', '', 'style="width: 400px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_LIST_AUTH_PAGE_HINT.'</div>';
    $layout->addField(PL_FAQ_H_ELEM_LIST_AUTH_PAGE, $fld);   
    
	$layout->addField('', new sbLayoutDelim());
	$fields = sbPlugins::getSortFields('pl_faq');

	$calendar_fields = array('' => ' --- ');
   	foreach ($_SESSION['sbPlugins']->mCalendar['pl_faq_list']['date_fields'] as $key => $value)
   	{
   		$calendar_fields[$key] = $value;
   	}

    $res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident="pl_faq"');
    if ($res)
    {
        list($pd_fields) = $res[0];

        if($pd_fields != '')
        {
            $pd_fields = unserialize($pd_fields);
	        foreach($pd_fields as $value)
	        {
	            if ($value['type'] == 'string' || 
	                $value['type'] == 'number' || 
	                $value['type'] == 'date' ||
	                $value['type'] == 'checkbox' || 
	                $value['type'] == 'image' ||
	                $value['type'] == 'link' ||
	                $value['type'] == 'file' ||
	                $value['type'] == 'color' || 
	                $value['type'] == 'select_sprav' ||
	                $value['type'] == 'radio_sprav' || 
	                $value['type'] == 'select_plugin' ||
	                $value['type'] == 'radio_plugin' ||
	                $value['type'] == 'elems_plugin')
	            {
	                $fields['f.user_f_'.$value['id']] = $value['title'];

	                if ($value['type'] == 'date')
	                {
	                    $calendar_fields['user_f_'.$value['id']] = $value['title'];
	                }
	            }
	        }
        }
    }

    $order = array('DESC' => PL_FAQ_H_ELEM_LIST_SORT_DESC, 
                   'ASC'  => PL_FAQ_H_ELEM_LIST_SORT_ASC);

    $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
    $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'f.f_date'));

    $fld2 = new sbLayoutSelect($order, 'order1');
    $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_FAQ_H_ELEM_LIST_SORT_FIELD.' 1', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
    $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order2');
    $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();
    
    $layout->addField(PL_FAQ_H_ELEM_LIST_SORT_FIELD.' 2', $fld1);
    
    $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
    $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order3');
    $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_FAQ_H_ELEM_LIST_SORT_FIELD.' 3', $fld1);

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_FAQ_H_ELEM_LIST_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_FAQ_H_ELEM_LIST_SHOW_HIDDEN, new sbLayoutInput('checkbox', '1', 'show_hidden', '', (isset($params['show_hidden']) && $params['show_hidden'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_FAQ_H_ELEM_LIST_SHOW_SELECTED, new sbLayoutInput('checkbox', '1', 'show_selected', '', (isset($params['show_selected']) && $params['show_selected'] == 1 ? 'checked="checked"' : '')));

	$fld = new sbLayoutInput('checkbox', '1', '', 'registred_users', (isset($params['registred_users']) && $params['registred_users'] == 1 ? 'checked="checked"' : '') );
	$fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_OUTPUT_USERS_QUESTIONS_LABEL.'</div>';
	$layout->addField(PL_FAQ_H_ELEM_OUTPUT_USERS_QUESTIONS, $fld);

	$layout->addField('', new sbLayoutDelim());
	
    $layout->addField(PL_FAQ_H_DESIGN_EDIT_SHOW_ALL, new sbLayoutInput('checkbox', '1', 'show_all', '', (isset($params['show_all']) && $params['show_all'] == 0 ? '' : 'checked="checked"')));
    $layout->addField(PL_FAQ_H_ELEM_LIST_RUBRIK_LINK, new sbLayoutInput('checkbox', '1', 'rubrikator', '', (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? 'checked="checked"' : '')));

    $layout->addField('', new sbLayoutDelim());
    
    $layout->addField(PL_FAQ_H_ELEM_LIST_CLOUD_LINK, new sbLayoutInput('checkbox', '1', 'cloud', '', (isset($params['cloud']) && $params['cloud'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_FAQ_H_ELEM_LIST_CLOUD_COMP_LINK, new sbLayoutInput('checkbox', '1', 'cloud_comp', '', (isset($params['cloud_comp']) && $params['cloud_comp'] == 1 ? 'checked="checked"' : '')));
    
    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_FAQ_H_ELEM_LIST_CALENDAR_LINK, new sbLayoutInput('checkbox', '1', 'calendar', '', (isset($params['calendar']) && $params['calendar'] == 1 ? 'checked="checked"' : '').' onclick="changeCalendarField(this)"'));

   	$fld = new sbLayoutSelect($calendar_fields, 'calendar_field', '', (!isset($params['calendar']) || $params['calendar'] != 1 ? 'disabled="disabled"' : ''));
    $fld->mSelOptions = array((isset($params['calendar_field']) && $params['calendar_field'] != '' ? $params['calendar_field'] : ''));
    $fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_LIST_CALENDAR_FIELD_HINT.'</div>';
    $layout->addField(PL_FAQ_H_ELEM_LIST_CALENDAR_FIELD, $fld);

    $layout->addField('', new sbLayoutDelim());
    
    $layout->addField(PL_FAQ_H_ELEM_PREMOD_COMMENTS, new sbLayoutInput('checkbox', 'moderate', '1', 'moderate', (isset($params['moderate']) && $params['moderate'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_FAQ_H_ELEM_BBCODE_ALLOW, new sbLayoutInput('checkbox', 'allow_bbcode', '0', 'allow_bbcode', (isset($params['allow_bbcode']) && $params['allow_bbcode'] == 1 ? 'checked="checked"' : '')));  
    $layout->addField(PL_FAQ_H_ELEM_MODER_EMAIL, new sbLayoutInput('text', (isset($params['moderate_email']) ? $params['moderate_email'] : ''), 'moderate_email', 'moderate_email', 'style="width:400px;"'));  

    $layout->addTab(PL_FAQ_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_FAQ_H_ELEM_LIST_FILTER_TAB);

    $layout->addField(PL_FAQ_H_ELEM_LIST_USE_FILTER, new sbLayoutInput('checkbox', '1', 'use_filter', '', (isset($params['use_filter']) && $params['use_filter'] == 1 ? 'checked="checked"' : '').' onclick="changeUseFilter(this)"'));

    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_logic');
    $fld->mSelOptions = array((isset($params['filter_logic']) && $params['filter_logic'] != '' ? $params['filter_logic'] : ''));
    $layout->addField(PL_FAQ_H_ELEM_LIST_FILTER_LOGIC, $fld);
    
    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_text_logic');
    $fld->mSelOptions = array((isset($params['filter_text_logic']) && $params['filter_text_logic'] != '' ? $params['filter_text_logic'] : ''));
    
    $fld1 = new sbLayoutSelect(array('EQ' => PL_FAQ_H_ELEM_LIST_FILTER_TEXT_LOGIC_EQ, 'IN' => PL_FAQ_H_ELEM_LIST_FILTER_TEXT_LOGIC_IN), 'filter_compare', '', 'onchange="changeFilterMorph(this);"');
    $fld1->mSelOptions = array((isset($params['filter_compare']) && $params['filter_compare'] != '' ? $params['filter_compare'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;<input type="checkbox" value="1" id="filter_morph"'.(isset($params['filter_morph']) && $params['filter_morph'] == 1 ? ' checked="checked"' : '').(isset($params['filter_compare']) && $params['filter_compare'] != 'IN' ? ' disabled="disabled"' : '').' />&nbsp;&nbsp;'.PL_FAQ_H_ELEM_LIST_FILTER_MORPH;
    $fld->mHTML = '&nbsp;&nbsp;'.$fld1->getField();

	$layout->addField(PL_FAQ_H_ELEM_LIST_FILTER_TEXT_LOGIC, $fld);
	$layout->addField('', new sbLayoutDelim());

    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.PL_FAQ_H_ELEM_LIST_FILTER_ALL;
    $html .= $fld1->getField().'<br /><br />';
    
    $fld2 = new sbLayoutInput('radio', 'last', 'filter', 'r_filter_last', ($params['filter'] == 'last' ? ' checked="checked"' : ''));
    $fld2_1 = new sbLayoutInput('input', (isset($params['filter_last']) ? $params['filter_last'] : ''), 'filter_last', 'spin_filter_last', 'style="width: 50px;"');
    $fld2_1->mMinValue = 1;
    $html .= $fld2_1->getJavaScript().'<table cellpadding="0" cellspacing="0"><tr><td>'.$fld2->getField().'</td><td>&nbsp;&nbsp;'.PL_FAQ_H_ELEM_LIST_FILTER_LAST.'&nbsp;&nbsp;</td><td>'.$fld2_1->getField().'</td><td>&nbsp;&nbsp;'.PL_FAQ_H_ELEM_LIST_FILTER_DAYS.'</td></tr></table><br />';

    $fld3 = new sbLayoutInput('radio', 'from_to', 'filter', 'r_filter_from_to', ($params['filter'] == 'from_to' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutInput('input', (isset($params['filter_from']) ? $params['filter_from'] : ''), 'filter_from', 'spin_filter_from', 'style="width: 50px;"');
    $fld3_2 = new sbLayoutInput('input', (isset($params['filter_to']) ? $params['filter_to'] : ''), 'filter_to', 'spin_filter_to', 'style="width: 50px;"');
    $fld3_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>'.$fld3->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld3_1->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld3_2->getField().'</td></tr></table>
              <div class="hint_div">'.PL_FAQ_H_ELEM_LIST_FILTER_FROM_TO_HINT.'</div>';

	$fld = new sbLayoutHTML($html);
	$layout->addField(PL_FAQ_H_ELEM_LIST_FILTER, $fld);
	//Использовать сортировку
   	$layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_FAQ_H_ELEM_USE_SORT, new sbLayoutInput('checkbox', '0', '', 'use_sort', (isset($params['use_sort']) && $params['use_sort'] == 1 ? 'checked="checked"' : '')));

	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show();
}

/**
 * Вывод диалогового окна полного текста вопроса
 */      
function fFaq_Get_Elem_Full()
{
    $params = unserialize($_GET['params']);
    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();
            
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
				alert("'.PL_FAQ_H_ELEM_FULL_NO_TEMPS_ALERT.'");
				return;
            }

			var el_page = sbGetE("page");
            if (el_page)
            {
                params["page"] = el_page.value;
            }
            else
            {
                params["page"] = "";
            }

			params["auth_page"] = sbGetE("auth_page").value;
			res.temp_id = el_temp.value;

			params["moderate"] = (sbGetE("moderate").checked ? 1 : 0);
			params["moderate_email"] = sbGetE("moderate_email").value;
			params["registred_users"] = sbGetE("registred_users").checked ? 1 : 0;
			params["allow_bbcode"] = sbGetE("allow_bbcode").checked ? 1 : 0;
			params["component"] = sbGetE("component").value;

			res.params = sb_serialize(params);
			sbReturnValue(res);
        }
        function getPageComponents()
        {
        	var p_url = sbGetE("page").value;
            p_url = p_url.split("&");
            
			var comp_el = sbGetE("component");
			while (comp_el.childNodes.length > 1)
                comp_el.removeChild(comp_el.childNodes[1]);

            var res = sbLoadSync(sb_cms_empty_file + "?event=pl_faq_elem_list_components&p_url=" + p_url[0]);
            if (res)
            {
                comp_el.remove(0);
                
                res = eval("(" + res + ")");
                for(var i = 0; i < res.keys.length; i++)
            	{
            	   
            	    var oOption = document.createElement("OPTION");
            	    comp_el.appendChild(oOption);
                    oOption.value = res.keys[i];
                    oOption.innerHTML = res.values[i];
            	}
            }
        }
    </script><br /><br />';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '150';
    $layout->addHeader(PL_FAQ_H_FULL_ELEM);

    $res = sql_query('SELECT categs.cat_title, temps.ftf_id, temps.ftf_title FROM sb_categs categs, sb_catlinks links, sb_faq_temps_full temps WHERE temps.ftf_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_faq_full" ORDER BY categs.cat_left, temps.ftf_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }

        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = array($params['temp_id']);

		$layout->addField(PL_FAQ_H_ELEM_TEMP, $fld);
	}
	else
	{
		$layout->addField(PL_FAQ_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_FAQ_H_ELEM_FULL_NO_TEMPS_MSG.'</div>', '', '', false));
	}

	$layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 400px;" onchange="getPageComponents()"');
    $fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_LIST_PAGE_HINT_LIST.'</div>';
    $layout->addField(PL_FAQ_H_ELEM_LIST_PAGE_LIST, $fld);
    
    $components = array('' => ' --- ');
    if (isset($params['page']) && $params['page'] != '')
    {
    	$components = sb_get_elem_components($params['page'], 'pl_faq_list', 'php');
    }
    $fld = new sbLayoutSelect($components, 'component');
    $fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_COMPONENT_HINT.'</div>';
    if(isset($params['component']))
    	$fld -> mSelOptions = array($params['component']);
    $layout->addField(PL_FAQ_H_ELEM_COMPONENT, $fld);

    $fld = new sbLayoutPage(isset($params['auth_page']) ? $params['auth_page'] : '', 'auth_page', '', 'style="width: 400px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_LIST_AUTH_PAGE_HINT.'</div>';
    $layout->addField(PL_FAQ_H_ELEM_LIST_AUTH_PAGE, $fld);

    $layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutInput('checkbox', '1', '', 'registred_users', (isset($params['registred_users']) && $params['registred_users'] == 1 ? 'checked="checked"' : '') );
	$fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_OUTPUT_USERS_QUESTIONS_FULL_LABEL.'</div>';
	$layout->addField(PL_FAQ_H_ELEM_OUTPUT_USERS_QUESTIONS, $fld);

	$layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_FAQ_H_ELEM_PREMOD_COMMENTS, new sbLayoutInput('checkbox', 'moderate', '1', 'moderate', (isset($params['moderate']) && $params['moderate'] == 1 ? 'checked="checked"' : ''))); 
    $layout->addField(PL_FAQ_H_ELEM_BBCODE_ALLOW, new sbLayoutInput('checkbox', 'allow_bbcode', '0', 'allow_bbcode', (isset($params['allow_bbcode']) && $params['allow_bbcode'] == 1 ? 'checked="checked"' : ''))); 
    $layout->addField(PL_FAQ_H_ELEM_MODER_EMAIL, new sbLayoutInput('text', (isset($params['moderate_email']) ? $params['moderate_email'] : ''), 'moderate_email', 'moderate_email', 'style="width:400px;"'));  
                    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    $layout->show();
}

/**
 * Вывод диалогового окна формы добавления вопросов
 */
function fFaq_Get_Elem_Form()
{
    $params = unserialize($_GET['params']);
    
    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_FAQ_H_ELEM_FORM_NO_CATEGS_MSG.'");
                return;
            }
            params["ids"] = el_cats;
           

            var el_temp = sbGetE("temp_id");

            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_FAQ_H_ELEM_FORM_NO_TEMPS_ALERT.'");
                return;
            }

            var premod = sbGetE("premod_question");
            if(premod.checked)
            {
                params["premod_question"] = premod.value;
            }

            var rubrikator = sbGetE("rubrikator_form");
            if(rubrikator.checked)
            {
                params["rubrikator_form"] = rubrikator.value;
            }

            params["page"] = sbGetE("page").value;
            params["mod_emails"] = sbGetE("mod_emails").value;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    </script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_FAQ_H_ELEM_LIST_CATEGS_TAB);

    $categs = new sbJustCategs('pl_faq');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_FAQ_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_FAQ_H_ELEM_LIST_PROPS_TAB);

    $res = sql_query('SELECT categs.cat_title, temps.sftf_id, temps.sftf_title FROM sb_categs categs, sb_catlinks links, sb_faq_temps_form temps WHERE temps.sftf_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_faq_form" ORDER BY categs.cat_left, temps.sftf_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }

        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

        $layout->addField(PL_FAQ_H_ELEM_TEMP, $fld);
    }
    else 
    {
        $layout->addField(PL_FAQ_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_FAQ_H_ELEM_FORM_NO_TEMPS_MSG.'</div>', '', '', false));
    }

    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_FAQ_H_ELEM_FORM_PAGE, new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 460px;"'));   

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_FAQ_H_ELEM_PREMOD_QUESTION, new sbLayoutInput('checkbox', '1', 'premod_question', 'premod_question', (isset($params['premod_question']) && $params['premod_question'] == 1 ? 'checked="checked"' : '' )));
    $layout->addField(PL_FAQ_H_ELEM_LIST_RUBRIK_LINK, new sbLayoutInput('checkbox', '1', 'rubrikator_form', 'rubrikator_form', (isset($params['rubrikator_form']) && $params['rubrikator_form'] == 1 ? 'checked="checked"' : '' )));

    $layout->addField(PL_FAQ_H_ELEM_FORM_MOD, new sbLayoutInput('input', (isset($params['mod_emails']) ? $params['mod_emails'] : ''), 'mod_emails', '', 'style="width: 500px;"'));

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/**
 * Вывод разделов
 */
function fFaq_Get_Elem_Categs()
{
    fCategs_Get_Elem_Categs('pl_faq', 'pl_faq_design_categs', PL_FAQ_H_ELEM_CATEGS_NO_TEMPS_MSG);
}

/**
 * Вывод выбранного раздела
 *
 */
function fFaq_Get_Elem_Sel_Cat()
{
    fCategs_Get_Elem_Sel_Cat('pl_faq', 'pl_faq_design_sel_cat', PL_FAQ_H_ELEM_SELCAT_NO_TEMPS_MSG);
}

/**
 * Вывод диалогового окна облака тегов
 *
 */
function fFaq_Get_Elem_Cloud()
{
	$params = unserialize($_GET['params']);

	if (!isset($params['filter']))
		$params['filter'] = 'all';

	if (!isset($params['subcategs']))
		$params['subcategs'] = 1;

	echo '<script>
		function chooseCat()
        {
            var res = new Object();
            var params = new Array();

			var el_cats = sbCatTree.getAllSelected();
			if (el_cats.length == 0)
            {
                alert("'.PL_FAQ_H_ELEM_CLOUD_NO_CATEGS_MSG.'");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_FAQ_H_ELEM_CLOUD_NO_TEMPS_ALERT.'");
                return;
            }

            var r_filter_all = sbGetE("r_filter_all");
            var r_filter_last = sbGetE("r_filter_last");
            var r_filter_from_to = sbGetE("r_filter_from_to");
            
            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }
            else if (r_filter_last.checked)
            {
                params["filter"] = r_filter_last.value;
                var el_filter_last = sbGetE("spin_filter_last");
                params["filter_last"] = el_filter_last.value;
            }
            else if (r_filter_from_to.checked)
            {
                params["filter"] = r_filter_from_to.value;
                var el_filter_from = sbGetE("spin_filter_from");
                var el_filter_to = sbGetE("spin_filter_to");

                if (el_filter_to.value != "" && el_filter_to.value != 0 && parseInt(el_filter_from.value) > parseInt(el_filter_to.value))
                {
                    alert("'.PL_FAQ_H_ELEM_LIST_FILTER_FROM_TO_ERROR.'");
                    return;
                }

                params["filter_from"] = el_filter_from.value;
                params["filter_to"] = el_filter_to.value;
            }

            params["sort"] = sbGetE("sort").value;
            params["order"] = sbGetE("order").value;
            params["page"] = sbGetE("page").value;
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["rubrikator"] = sbGetE("rubrikator").checked ? 1 : 0;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    </script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_FAQ_H_ELEM_LIST_CATEGS_TAB);

    $categs = new sbJustCategs('pl_faq');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_FAQ_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_FAQ_H_ELEM_LIST_PROPS_TAB);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.ct_id, temps.ct_title
				    FROM sb_categs categs, sb_catlinks links, sb_clouds_temps temps 
				    WHERE temps.ct_id=links.link_el_id 
				    AND categs.cat_id=links.link_cat_id
				    AND categs.cat_ident="pl_clouds"
				    ORDER BY categs.cat_left, temps.ct_title');

    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $ct_id, $ct_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$ct_id] = $ct_title;
        }
    }

    if (count($options) > 0)
    {
        $fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    }
    else 
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_CLOUDS_H_ELEM_CLOUD_NO_TEMPS_MSG.'</div>', '', '', false);
    }

    $layout->addField(PL_FAQ_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_CLOUDS_PAGE_HINT.'</div>';

    $layout->addField(PL_FAQ_H_ELEM_CLOUD_PAGE, $fld);   
    $layout->addField('', new sbLayoutDelim());

    $fields = array('ct.ct_tag' => PL_FAQ_H_ELEM_CLOUD_SORT_TAG,
                    'ct_rating' => PL_FAQ_H_ELEM_CLOUD_SORT_RATING);

    $order = array('DESC' => PL_FAQ_H_ELEM_LIST_SORT_DESC,
                   'ASC'  => PL_FAQ_H_ELEM_LIST_SORT_ASC);

    $fld1 = new sbLayoutSelect($fields, 'sort');
    $fld1->mSelOptions = array((isset($params['sort']) ? $params['sort'] : 'tag'));
    $fld2 = new sbLayoutSelect($order, 'order');
    $fld2->mSelOptions = array((isset($params['order']) && $params['order'] != '' ? $params['order'] : 'ASC'));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_FAQ_H_ELEM_LIST_SORT_FIELD, $fld1);
    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_FAQ_H_ELEM_CLOUD_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_FAQ_H_ELEM_CLOUD_RUBRIK_LINK, new sbLayoutInput('checkbox', '1', 'rubrikator', '', (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? 'checked="checked"' : '')));

    $layout->addTab(PL_FAQ_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_FAQ_H_ELEM_LIST_FILTER_TAB);

    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.PL_FAQ_H_ELEM_CLOUD_FILTER_ALL;
    $html .= $fld1->getField().'<br /><br />';

    $fld2 = new sbLayoutInput('radio', 'last', 'filter', 'r_filter_last', ($params['filter'] == 'last' ? ' checked="checked"' : ''));
    $fld2_1 = new sbLayoutInput('input', (isset($params['filter_last']) ? $params['filter_last'] : ''), 'filter_last', 'spin_filter_last', 'style="width: 50px;"');
    $fld2_1->mMinValue = 1;
    $html .= $fld2_1->getJavaScript().'<table cellpadding="0" cellspacing="0"><tr><td>'.$fld2->getField().'</td><td>&nbsp;&nbsp;'.PL_FAQ_H_ELEM_LIST_FILTER_LAST.'&nbsp;&nbsp;</td><td>'.$fld2_1->getField().'</td><td>&nbsp;&nbsp;'.PL_FAQ_H_ELEM_LIST_FILTER_DAYS.'</td></tr></table><br />';

    $fld3 = new sbLayoutInput('radio', 'from_to', 'filter', 'r_filter_from_to', ($params['filter'] == 'from_to' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutInput('input', (isset($params['filter_from']) ? $params['filter_from'] : ''), 'filter_from', 'spin_filter_from', 'style="width: 50px;"');
    $fld3_2 = new sbLayoutInput('input', (isset($params['filter_to']) ? $params['filter_to'] : ''), 'filter_to', 'spin_filter_to', 'style="width: 50px;"');
    $fld3_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>'.$fld3->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld3_1->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld3_2->getField().'</td></tr></table>
              <div class="hint_div">'.PL_FAQ_H_ELEM_CLOUD_FILTER_FROM_TO_HINT.'</div>';

    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_FAQ_H_ELEM_CLOUD_FILTER, $fld);

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    $layout->show();
}

/**
 *
 * Вывод формы фильтра вопросов
 *
 */
function fFaq_Get_Elem_Filter()
{
	$params = unserialize($_GET['params']);
	echo '<script>
		function choose()
        {
			var res = new Object();
			var params = new Array();

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
			}
			else
            {
				alert("'.PL_FAQ_H_FILTER_FORM_NO_TEMPS_ALERT.'");
				return;
			}
			params["page"] = sbGetE("page").value;

			res.temp_id = el_temp.value;
			res.params = sb_serialize(params);

            sbReturnValue(res);
        }
	</script>';

	echo '<br /><br />';
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	$layout = new sbLayout();
	$layout->mTableWidth = '90%';
	$layout->mTitleWidth = '200';

	$layout->addHeader(PL_FAQ_H_FILTER_ELEM_FORM);

	$res = sql_query('SELECT categs.cat_title, temps.sftf_id, temps.sftf_title FROM sb_categs categs, sb_catlinks links, sb_faq_temps_form temps WHERE temps.sftf_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_faq_filter" ORDER BY categs.cat_left, temps.sftf_title');
	if ($res)
	{
		$options = array();
		$old_cat_title = '';

		foreach ($res as $value)
		{
			list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
				$options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
			}
			$options[$st_id] = $st_title;
        }

		$fld = new sbLayoutSelect($options, 'temp_id');
		$fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

		$layout->addField(PL_FAQ_H_ELEM_TEMP, $fld);
    }
	else
	{
		$layout->addField(PL_FAQ_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_FAQ_H_FILTER_FORM_NO_TEMPS_MSG.'</div>', '', '', false));
	}

	$fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"');
	$fld->mHTML = '<div class="hint_div">'.PL_FAQ_H_ELEM_LIST_PAGE_HINT_LIST.'</div>';
	$layout->addField(PL_FAQ_H_ELEM_LIST_PAGE_LIST, $fld);

	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show();
}

/********************************** функции получения информации по элементам модуля ***********************************/

/**
 * Вывод информации по элементу: список вопросов.
 */
function fFaq_Elem_List_Info($params)
{
	$in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';

    $categs_str = '';

    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
    	$categs_str = '';
    	foreach ($res as $value)
        {
        	$categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }
    $res = sql_param_query('SELECT categs.cat_title, temps.fdl_title 
                    FROM sb_categs categs, sb_catlinks links, sb_faq_temps_list temps
                    WHERE temps.fdl_id=?d 
                    AND links.link_el_id=temps.fdl_id 
                    AND categs.cat_id=links.link_cat_id 
                    AND categs.cat_ident="pl_faq_list"', $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FAQ_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FAQ_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          '.(isset($params['page']) && $params['page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_PAGE.':</b> '.$params['page'].'</div>' : '').'
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_SUBCATEGS.':</b> '.(isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_RUBRIK_LINK.':</b> '.(isset($params['rubrikator']) && $params['rubrikator'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_CALENDAR_LINK.':</b> '.(isset($params['calendar']) && $params['calendar'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_FILTER_LINK.':</b> '.(isset($params['use_filter']) && $params['use_filter'] == 1 || !isset($params['use_filter']) ? KERNEL_YES : KERNEL_NO).'</div>';
}

/**
 *  Вывод информации по элементу: полный текст вопроса.
 */
function fFaq_Elem_Full_Info($params)
{
    $res = sql_param_query('SELECT categs.cat_title, temps.ftf_title FROM sb_categs categs, sb_catlinks links, sb_faq_temps_full temps
                          WHERE temps.ftf_id=?d AND links.link_el_id=temps.ftf_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_faq_full"', $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FAQ_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>';
}

/**
 * Вывод информации по элементу: Форма добавления вопросов
 */
function fFaq_Elem_Form_Info($params)
{
    $in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';

    $categs_str = '';

    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        $categs_str = '';
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }
    $res = sql_param_query('SELECT categs.cat_title, temps.sftf_title
                    FROM sb_categs categs, sb_catlinks links, sb_faq_temps_form temps
                    WHERE temps.sftf_id=?d 
                    AND links.link_el_id=temps.sftf_id 
                    AND categs.cat_id=links.link_cat_id 
                    AND categs.cat_ident="pl_faq_form"', $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FAQ_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FAQ_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_ELEM_PREMOD_QUESTION.':</b> '.(isset($params['premod_question']) && $params['premod_question'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_ELEM_NOTIFY_EMAIL.':</b> '.(isset($params['notify_email']) && $params['notify_email'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/**
 * Вывод информации по элементу: вывод разделов
 */
function fFaq_Elem_Categs_List_Info($params)
{
    fCategs_Elem_Categs_Info($params, 'pl_faq_design_categs');
}

/**
 * Вывод выбранного раздела
 *
 */
function fFaq_Elem_Sel_Cat_Info($params)
{
    fCategs_Elem_Sel_Cat_Info($params, 'pl_faq_design_sel_cat');
}

/**
 * Вывод информации о выводе облака тегов
 *
 */
function fFaq_Elem_Cloud_Info($params)
{
	$in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';

    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');

    if ($res)
    {
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }

        $categs_str = substr($categs_str, 0, -2);
    }

    $res = sql_param_query('SELECT categs.cat_title, temps.ct_title FROM sb_categs categs, sb_catlinks links, sb_clouds_temps temps
                            WHERE temps.ct_id=?d AND links.link_el_id=temps.ct_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_clouds"', $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FAQ_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FAQ_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          '.(isset($params['page']) && $params['page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_ELEM_CLOUD_PAGE.':</b> '.$params['page'].'</div>' : '').'
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_SUBCATEGS.':</b> '.(isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_INFO_RUBRIK_LINK.':</b> '.(isset($params['rubrikator']) && $params['rubrikator'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/**
 * Вывод формы фильтра вопросов
 *
 */
function fFaq_Elem_Filter_Info($params)
{
	$res = sql_param_query('SELECT categs.cat_title, temps.sftf_title FROM sb_categs categs, sb_catlinks links, sb_faq_temps_form temps
			WHERE temps.sftf_id=?d AND links.link_el_id=temps.sftf_id AND categs.cat_id=links.link_cat_id
			AND categs.cat_ident="pl_faq_filter"', $params['temp_id']);

	echo '<div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FAQ_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
			<div style="padding-bottom: 5px;"><b>'.PL_FAQ_H_ELEM_LIST_PAGE_LIST.':</b> '.($params['page'] != '' ? $params['page'] : '').'</div>';
}

/********************************** функции получения элементов модуля ************************************************/

/**
 * Вывод списка вопрсов
 */
function fFaq_Elem_List_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_faq/prog/pl_faq.php';\n
		fFaq_Elem_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
}

/**
 * Вывод полного текста вопроса
 */
function fFaq_Elem_Full_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_faq/prog/pl_faq.php';\n
        fFaq_Elem_Full('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод формы добавления вопросов
 */
function fFaq_Elem_Form_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_faq/prog/pl_faq.php';\n
        fFaq_Elem_Form('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n	
        ?>";
}

/**
 * Вывод разделов
 */
function fFaq_Elem_Categs_List_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_faq/prog/pl_faq.php';\n
        fFaq_Elem_Categs('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";

}

/**
 * Вывод выбранного раздела
 *
 */
function fFaq_Elem_Sel_Cat_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_faq/prog/pl_faq.php';\n
        fFaq_Elem_Sel_Cat('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод облака тегов
 * 
 */
function fFaq_Elem_Cloud_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_faq/prog/pl_faq.php';\n
            fFaq_Elem_Cloud('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
            ?>";
}

/**
 * Вывод формы фильтра вопросов
 * 
 */
function fFaq_Elem_Filter_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_faq/prog/pl_faq.php'; \n
			fFaq_Elem_Filter('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
			?>";
}
function fFaq_Get_Elem_Components()
{
	if (isset($_GET['p_url']))
	{
		echo sb_get_elem_components($_GET['p_url'],'pl_faq_list');
	}
}
?>