<?php
require_once(SB_CMS_LANG_PATH.'/pl_imagelib.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_imagelib', PL_IMAGELIB_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_IMAGELIB_H_SUB_MENU.'>'.PL_IMAGELIB_H_PLUGIN_NAME, 'init');
    $_SESSION['sbPlugins']->addToExportImport(true, false);

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_imagelib', 'design_read'))
    {
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_IMAGELIB_H_PLUGIN_NAME.'>'.PL_IMAGELIB_H_PLUGIN_DESIGN_LIST, 'design_init', 'pl_imagelib_list_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_IMAGELIB_H_PLUGIN_NAME.'>'.PL_IMAGELIB_H_PLUGIN_DESIGN_BIG, 'design_full_init', 'pl_imagelib_full_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_IMAGELIB_H_PLUGIN_NAME.'>'.PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG, 'design_categ_init', 'pl_imagelib_design_cat_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_IMAGELIB_H_PLUGIN_NAME.'>'.PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG_SELECT, 'design_categ_select_init', 'pl_imagelib_design_cat_select_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_IMAGELIB_H_PLUGIN_NAME.'>'.PL_IMAGELIB_H_PLUGIN_DESIGN_FORM, 'design_form_init', 'pl_imagelib_plus_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_IMAGELIB_H_PLUGIN_NAME.'>'.PL_IMAGELIB_H_PLUGIN_FILTER_FORM, 'design_filter_form_init', 'pl_imagelib_filter_form_24.png');
    }

	$_SESSION['sbPlugins']->setMainEvent('init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fImagelib_Init', 'read', PL_IMAGELIB_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fImagelib_Edit','read',PL_IMAGELIB_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fImagelib_Edit_Submit','elems_edit',PL_IMAGELIB_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('multi_edit', 'fImagelib_Multi_Edit','read',PL_IMAGELIB_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('multi_edit_submit', 'fImagelib_Multi_Edit_Submit','elems_edit',PL_IMAGELIB_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('del_nouse', 'fImagelib_Del_No_Use','elems_edit');

	$_SESSION['sbPlugins']->addUserEvent('delete_all', 'fImagelib_Delete', 'elems_edit', PL_IMAGELIB_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('set_active', 'fImagelib_Set_Active', 'elems_public', PL_IMAGELIB_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('voting', 'fImagelib_Delete_Voting', 'elems_edit', PL_IMAGELIB_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements', 'fImagelib_Delete_Cat_With_Elements', 'elems_edit', PL_IMAGELIB_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('paste', 'fImagelib_Paste', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fImagelib_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');
    
	$_SESSION['sbPlugins']->addUserEvent('design_init', 'fImagelib_Design_Init', 'design_read', PL_IMAGELIB_H_PLUGIN_DESIGN_LIST);
	$_SESSION['sbPlugins']->addUserEvent('design_edit', 'fImagelib_Design_Edit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_edit_submit', 'fImagelib_Design_Edit_Submit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_delete', 'fImagelib_Design_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_full_init', 'fImagelib_Design_Full_Init', 'design_read', PL_IMAGELIB_H_PLUGIN_DESIGN_BIG);
	$_SESSION['sbPlugins']->addUserEvent('design_full_edit', 'fImagelib_Design_Full_Edit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_full_edit_submit', 'fImagelib_Design_Full_Edit_Submit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_full_delete', 'fImagelib_Design_full_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_form_init', 'fImagelib_Design_Form_Init', 'design_read', PL_IMAGELIB_H_PLUGIN_DESIGN_FORM);
	$_SESSION['sbPlugins']->addUserEvent('design_form_edit', 'fImagelib_Design_Form_Edit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_form_edit_submit', 'fImagelib_Design_Form_Edit_Submit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_form_delete', 'fImagelib_Design_Form_Delete', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_FORM);

	$_SESSION['sbPlugins']->addUserEvent('design_categ_init', 'fImagelib_Design_Categ_Init', 'design_read', PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG);
	$_SESSION['sbPlugins']->addUserEvent('design_categ_edit', 'fImagelib_Design_Categ_Edit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_categ_edit_submit', 'fImagelib_Design_Categ_Edit_Submit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_categ_delete', 'fImagelib_Design_Categ_Delete', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG);

	$_SESSION['sbPlugins']->addUserEvent('design_categ_select_init', 'fImagelib_Design_Categ_Select_Init', 'design_read', PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG_SELECT);
	$_SESSION['sbPlugins']->addUserEvent('design_categ_select_edit', 'fImagelib_Design_Categ_Select_Edit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_categ_select_edit_submit', 'fImagelib_Design_Categ_Select_Edit_Submit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_categ_select_delete', 'fImagelib_Design_Categ_Select_Delete', PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG_SELECT);

	$_SESSION['sbPlugins']->addUserEvent('design_filter_form_init', 'fImagelib_Design_Filter_Form_Init', 'design_read', PL_IMAGELIB_H_PLUGIN_DESIGN_FILTER_FORM);
	$_SESSION['sbPlugins']->addUserEvent('design_filter_form_edit', 'fImagelib_Design_Filter_Form_Edit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_filter_form_edit_submit', 'fImagelib_Design_Filter_Form_Edit_Submit', 'design_edit', PL_IMAGELIB_H_PLUGIN_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_filter_form_delete', 'fImagelib_Design_Filter_Form_Delete');

	$_SESSION['sbPlugins']->addToConstructor('sb_imagelib');
	$_SESSION['sbPlugins']->addToCache();
	$_SESSION['sbPlugins']->addToComments('sb_imagelib', 'im_id', 'im_title', 'im_url');
	$_SESSION['sbPlugins']->addToWorkflow();

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_delim', PL_IMAGELIB_H_PLUGIN_NAME, '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_max_upload_size', PL_IMAGELIB_H_SETTING_MAX_UPLOAD_SIZE, 'number', '', '2097152');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_max_upload_width', PL_IMAGELIB_H_SETTING_MAX_UPLOAD_WIDTH, 'number', '', '640');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_max_upload_height', PL_IMAGELIB_H_SETTING_MAX_UPLOAD_HEIGHT, 'number', '', '480');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_big_width', PL_IMAGELIB_H_SETTING_BIG_UPLOAD_WIDTH, 'number', '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_big_height', PL_IMAGELIB_H_SETTING_BIG_UPLOAD_HEIGHT, 'number', '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_middle_width', PL_IMAGELIB_H_SETTING_MIDDLE_UPLOAD_WIDTH, 'number', '', '640');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_middle_height', PL_IMAGELIB_H_SETTING_MIDDLE_UPLOAD_HEIGHT, 'number', '', '480');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_small_width', PL_IMAGELIB_H_SETTING_SMALL_UPLOAD_WIDTH, 'number', '', '320');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_small_height', PL_IMAGELIB_H_SETTING_SMALL_UPLOAD_HEIGHT, 'number', '', '240');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_imagelib_max_upload_ext', PL_IMAGELIB_H_SETTING_UPLOAD_EXT, 'string', '', 'jpg jpeg png gif');
	
	$fields = array();
	$fields['im_id'] = array('title' => PL_IMAGELIB_H_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['im_title'] = array('title' => PL_IMAGELIB_H_TITLE_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_IM_TITLE}');
	$fields['im_desc'] = array('title' => PL_IMAGELIB_H_DESC_LABEL, 'flags' => '5', 'link_title' => '1', 'tag' => '{OPT_STD_IM_DESC}');
	$fields['im_url'] = array('title' => PL_IMAGELIB_H_URL_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_IM_URL}');
	$fields['im_big'] = array('title' => PL_IMAGELIB_H_BIG_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
	$fields['im_big_from_server'] = array('title' => PL_IMAGELIB_H_BIG_FROM_S_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['im_middle'] = array('title' => PL_IMAGELIB_H_MIDDLE_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
	$fields['im_middle_from_server'] = array('title' => PL_IMAGELIB_H_MIDDLE_FROM_S_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['im_small'] = array('title' => PL_IMAGELIB_H_SMALL_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
	$fields['im_small_from_server'] = array('title' => PL_IMAGELIB_H_SMALL_FROM_S_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['im_gal'] = array('title' => PL_IMAGELIB_H_GAL_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['im_user_id'] = array('title' => PL_IMAGELIB_H_USER_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['im_order_num'] = array('title' => PL_IMAGELIB_H_ORDER_NUM_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['im_date'] = array('title' => PL_IMAGELIB_H_DATE_LABEL, 'flags' => '9', 'link_title' => '1', 'tag' => '{OPT_STD_IM_DATE}');
	$fields['im_active_date_start'] = array('title' => PL_IMAGELIB_H_DATE_START_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
	$fields['im_active_date_end'] = array('title' => PL_IMAGELIB_H_DATE_END_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
	$fields['im_ext_id'] = array('title' => PL_IMAGELIB_H_EXT_ID, 'flags' => '8', 'link_title' => '0', 'tag' => '');

	$cat_fields = array();
	$cat_fields['moderates_list'] = array('title' => PL_IMAGELIB_H_CAT_MODLIST_ID_LABEL, 'flags' => '20');
	$cat_fields['categs_moderate_email'] = array('title' => PL_IMAGELIB_H_CAT_MODEMAIL_ID_LABEL, 'flags' => '4');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_imagelib', 'im_id', 'im_title', $fields, $cat_fields);
}

$_SESSION['sbPlugins']->addSystemEvent('elem_list', 'fImagelib_Get_Elem_List', PL_IMAGELIB_H_ELEM_LIST);
$_SESSION['sbPlugins']->addSystemEvent('elem_full', 'fImagelib_Get_Elem_Full', PL_IMAGELIB_H_ELEM_FULL);
$_SESSION['sbPlugins']->addSystemEvent('elem_form', 'fImagelib_Get_Elem_Form', PL_IMAGELIB_H_ELEM_FORM_ADD);
$_SESSION['sbPlugins']->addSystemEvent('elem_form_edit', 'fImagelib_Get_Elem_Form_Edit', PL_IMAGELIB_H_ELEM_FORM_EDIT);
$_SESSION['sbPlugins']->addSystemEvent('elem_categs', 'fImagelib_Get_Elem_Categs', PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG);
$_SESSION['sbPlugins']->addSystemEvent('elem_selcat', 'fImagelib_Get_Elem_Sel_Cat', PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG_SELECT);
$_SESSION['sbPlugins']->addSystemEvent('elem_cloud', 'fImagelib_Get_Elem_Cloud', PL_IMAGELIB_H_ELEM_CLOUD);
$_SESSION['sbPlugins']->addSystemEvent('elem_filter', 'fImagelib_Get_Elem_Filter', PL_IMAGELIB_H_PLUGIN_FILTER_FORM);
$_SESSION['sbPlugins']->addSystemEvent('elem_list_components', 'fImagelib_Get_Elem_Components');

$_SESSION['sbPlugins']->addToRubrikator('pl_imagelib', PL_IMAGELIB_H_PLUGIN_NAME, 'imagelib', 'pl_imagelib_design_categ', 'pl_imagelib_categs_select');
$_SESSION['sbPlugins']->addToCalendar('list', 'fImagelib_Get_Calendar', 'pl_imagelib/prog/pl_imagelib.php', array('im_date' => PL_IMAGELIB_H_CALENDAR_DATE));

$_SESSION['sbPlugins']->addElem(PL_IMAGELIB_H_PLUGIN_DESIGN_LIST, 'list', 'fImagelib_Elem_List', 'fImagelib_Elem_List_Info', 'elem_list', 800, 700, 'design_edit', 'pl_imagelib_list');
$_SESSION['sbPlugins']->addElem(PL_IMAGELIB_H_PLUGIN_DESIGN_BIG, 'full', 'fImagelib_Elem_Full', 'fImagelib_Elem_Full_Info', 'elem_full', 750, 700, 'design_full_edit', 'pl_imagelib_full');
$_SESSION['sbPlugins']->addElem(PL_IMAGELIB_H_ELEM_FORM_ADD, 'form', 'fImagelib_Elem_Form', 'fImagelib_Elem_Form_Info', 'elem_form', 800, 700, 'design_form_edit', 'pl_imagelib_form');
$_SESSION['sbPlugins']->addElem(PL_IMAGELIB_H_ELEM_FORM_EDIT, 'form_edit', 'fImagelib_Elem_Form', 'fImagelib_Elem_Form_Info', 'elem_form_edit', 800, 700, 'design_form_edit', 'pl_imagelib_form');

$_SESSION['sbPlugins']->addElem(PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG, 'categs', 'fImagelib_Elem_Categs', 'fImagelib_Elem_Categs_Info', 'elem_categs', 800, 700, 'design_categ_edit', 'pl_imagelib_design_categ');
$_SESSION['sbPlugins']->addElem(PL_IMAGELIB_H_PLUGIN_DESIGN_CATEG_SELECT, 'sel_cat', 'fImagelib_Elem_Sel_Cat', 'fImagelib_Elem_Sel_Cat_Info', 'elem_selcat', 800, 350, 'design_categ_select_edit', 'pl_imagelib_design_categ_select');
$_SESSION['sbPlugins']->addElem(PL_IMAGELIB_H_ELEM_CLOUD, 'cloud', 'fImagelib_Elem_Cloud', 'fImagelib_Elem_Cloud_Info', 'elem_cloud', 800, 700);
$_SESSION['sbPlugins']->addElem(PL_IMAGELIB_H_PLUGIN_FILTER_FORM, 'filter', 'fImagelib_Elem_Filter', 'fImagelib_Elem_Filter_Info', 'elem_filter', 800, 300, 'design_filter_form_edit', 'pl_imagelib_filter');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
?>