<?php
require_once(SB_CMS_LANG_PATH.'/pl_kernel.h.lng.php');

$_SESSION['sbPlugins']->register('pl_kernel', PL_KERNEL_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/interface.doc', false, true);

//$_SESSION['sbPlugins']->addToMainPage('sbuilder_news', PL_KERNEL_H_SBUILDER_NEWS, SB_CMS_IMG_URL.'/logo_16.png');

$_SESSION['sbPlugins']->addSystemEvent('sbuilder_news', 'fKernel_Sbuilder_News');

$_SESSION['sbPlugins']->addSystemEvent('read', 'fKernel_Read', PL_KERNEL_H_PLUGIN_NAME);
$_SESSION['sbPlugins']->addSystemEvent('save_position_container', 'fKernel_Save_Position_Container');
$_SESSION['sbPlugins']->addSystemEvent('user_info', 'fKernel_User_Info', PL_KERNEL_H_USER_INFO_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('site_user_info', 'fKernel_Site_User_Info', PL_KERNEL_H_SITE_USER_INFO_TITLE);

$_SESSION['sbPlugins']->addSystemEvent('who_is_online', 'fKernel_Who_Is_Online', PL_KERNEL_H_WHO_IS_ONLINE_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('who_is_online_ajax', 'fKernel_Who_Is_Online_Ajax', PL_KERNEL_H_WHO_IS_ONLINE_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('who_is_online_ban', 'fKernel_Who_Is_Online_Ban', PL_KERNEL_H_WHO_IS_ONLINE_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('who_is_online_delete', 'fKernel_Who_Is_Online_Delete', PL_KERNEL_H_WHO_IS_ONLINE_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('who_is_online_drop_password', 'fKernel_Who_Is_Online_Drop_Password', PL_KERNEL_H_WHO_IS_ONLINE_TITLE);

$_SESSION['sbPlugins']->addSystemEvent('show_toolbar', 'fKernel_Show_Toolbar');
$_SESSION['sbPlugins']->addSystemEvent('show_quick_toolbar', 'fKernel_Show_Quick_Toolbar');

$_SESSION['sbPlugins']->addSystemEvent('upload_graph_image', 'fKernel_Upload_Graph_Image');
$_SESSION['sbPlugins']->addSystemEvent('download_graph_image', 'fKernel_Download_Graph_Image');

$_SESSION['sbPlugins']->addUserSetting(INDEX_USER_SETTING, 'pl_kernel_who_is_online_interval', PL_KERNEL_H_WHO_IS_SETTING, 'number', '', '30');

// Считываем события, выносимые на главную страницу
$GLOBALS['sb_cmp_sort_field'] = 'title';
uasort($_SESSION['sbPlugins']->mContainers, 'sb_cmp_array');

if (count($_SESSION['sbPlugins']->mContainers))
{
	$containers_ar = array();
	$containers_val_ar = array();
	foreach ($_SESSION['sbPlugins']->mContainers as $value)
	{
	    $containers_ar[$value['event']] = ($value['icon'] != '' ? '<img src="'.$value['icon'].'" />&nbsp;&nbsp;&nbsp;' : '').$value['title'];
	    $containers_val_ar[] = $value['event'];
	}

	$_SESSION['sbPlugins']->addUserSetting(PL_KERNEL_H_SETTING, 'sb_containers_count', PL_KERNEL_H_SETTING_CONTAINERS_COUNT, 'number', '', 2, false);
	$_SESSION['sbPlugins']->addUserSetting(PL_KERNEL_H_SETTING, 'sb_containers_delim', '', '');
	$_SESSION['sbPlugins']->addUserSetting('', 'sb_containers', '', '', '', array());
	$_SESSION['sbPlugins']->addUserSetting(PL_KERNEL_H_SETTING, 'sb_containers_ar', PL_KERNEL_H_SETTING_CONTAINERS, 'checkboxes', $containers_ar, $containers_val_ar);
}
?>