<?php
function fKernel_Read()
{
    require_once(SB_CMS_LIB_PATH.'/sbContainers.inc.php');

    $containers = new sbContainers();
    $containers->show();
}

function fKernel_Save_Position_Container()
{
    if(isset($_GET['delete']))
    {
        // скидываем в настройках вывод контейнера
        $output_ar = sbPlugins::getUserSetting('sb_containers_ar');
        $pos = array_search($_GET['ident'], $output_ar);
        if ($pos !== false)
        {
            array_splice($output_ar, $pos, 1);
            $_SESSION['sbPlugins']->setUserSetting('sb_containers_ar', $output_ar);
        }

        return;
    }

    $ar = sbPlugins::getUserSetting('sb_containers');

    $col = intval($_GET['col']);
    $row = max(0, intval($_GET['row']) - 1);

    if(isset($_GET['roll']))
    {
        if ($_GET['roll'] == '0')
        {
            $ar[$row][$col]['roll'] = true;
        }
        else
        {
            $ar[$row][$col]['roll'] = false;
        }
    }
    else
    {
        $col_el = intval($_GET['col_el']);
        $row_el = max(intval($_GET['row_el']) - 1, 0);
        $num = intval($_GET['num']);

        $temp = $ar[$row_el][$col_el];
        $ar[$row_el][$col_el] = array();

        if (!isset($ar[$row]))
        {
            $ar[$row] = array();
            for ($j = 0; $j < $num; $j++)
            {
                if ($j == $col)
                    $ar[$row][$j] = $temp;
                else
                    $ar[$row][$j] = array();
            }
        }
        else
        {
            $temp1 = $ar[$row][$col];
            $ar[$row][$col] = $temp;
            $temp = $temp1;

            for ($i = $row + 1; $i < count($ar); $i++)
            {
                $temp1 = $ar[$i][$col];
                $ar[$i][$col] = $temp;
                $temp = $temp1;
            }

            $row = $i;
            if (count($temp) > 0)
            {
                $ar[$row] = array();
                for ($j = 0; $j < $num; $j++)
                {
                    if ($j == $col)
                        $ar[$row][$j] = $temp;
                    else
                        $ar[$row][$j] = array();
                }
            }
        }
    }

    // упаковываем массив
    $output_ar = array();

    if (isset($ar[0]))
    {
        // упаковываем массив
        $num_i = count($ar);
        $num_j = count($ar[0]);
        $max_i = 0;
        for ($j = 0; $j < $num_j; $j++)
        {
            $n = 0;
            for ($i = 0; $i < $num_i; $i++)
            {
                if (count($ar[$i][$j]) == 0)
                {
                    $r_i = $i;
                    $i++;
                    while ($i < $num_i)
                    {
                        if (count($ar[$i][$j]) != 0)
                        {
                            $ar[$r_i][$j] = $ar[$i][$j];
                            $ar[$i][$j] = array();
                            $n++;
                            $i--;
                            break;
                        }
                        $i++;
                    }
                }
                else
                {
                    $n++;
                    $output_ar[] = $ar[$i][$j]['event'];
                }
            }

            if ($n > $max_i)
                $max_i = $n;
        }

        if ($num_i > $max_i)
        {
            for ($i = $max_i; $i < $num_i; $i++)
            {
                unset($ar[$i]);
            }
        }
    }

    $_SESSION['sbPlugins']->setUserSetting('sb_containers', $ar);
    $_SESSION['sbPlugins']->setUserSetting('sb_containers_ar', $output_ar);
}

function fKernel_Actions_JavaScript()
{
    if (isset($_GET['dialog']))
    {
        if ($_GET['dialog'] == 1)
            $file = SB_CMS_DIALOG_FILE;
        else
            $file = SB_CMS_MODAL_DIALOG_FILE;
    }
    else
        $file = SB_CMS_CONTENT_FILE;
    return '<script>
        updateFrame = function()
        {
            window.location = "'.$file.'"+location.search;
        }
        clickBan = function(u_id)
        {
            if(confirm("'.PL_KERNEL_WHO_IS_BAN_CONFIRM.'"))
            {
                var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_kernel_who_is_online_ban&u_id="+u_id);
                if(res == "true")
                {
                    updateFrame();
                }
                else
                {
                    sbShowMsgDiv("'.PL_KERNEL_WHO_IS_BAN_CONFIRM_NO.'");
                }
            }

        }
        clickDelete = function(u_id)
        {
            if(confirm("'.PL_KERNEL_WHO_IS_DELETE_CONFIRM.'"))
            {
                var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_kernel_who_is_online_delete&u_id="+u_id);
                if(res == "true")
                {
                    updateFrame();
                }
                else
                {
                    sbShowMsgDiv("'.PL_KERNEL_WHO_IS_DELETE_CONFIRM_NO.'");
                }
            }
        }
        clickDropPassword = function(u_id)
        {
            if(confirm("'.PL_KERNEL_WHO_IS_DROP_CONFIRM.'"))
            {
                var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_kernel_who_is_online_drop_password&u_id="+u_id);
                if(res == "true")
                {
                    sbShowMsgDiv("'.PL_KERNEL_WHO_IS_NEW_PASSWORD.'", "information.png");
                }
                else
                {
                    sbShowMsgDiv("'.PL_KERNEL_WHO_IS_DROP_CONFIRM_NO.'");
                }
            }
        }
        clickSendMessages = function(u_id)
        {
            var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_messages_add&u_id=" + u_id;
            var strAttr = "resizable=1,width=700,height=500";
            sbShowDialog(strPage, strAttr);
        }
         </script>';
}

function fKernel_User_Info()
{
    $id = intval($_GET['id']);
    $tab_id = isset($_GET['tab_id']) ? intval($_GET['tab_id']) : -1;

    if (!$_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read') && $_SESSION['sbAuth']->getUserId() != $id)
    {
        sb_show_message(PL_KERNEL_NO_RIGHTS_TO_VIEW, true, 'warning');
        return;
    }

    $res = sql_query('SELECT u_login, u_name, u_reg_date, u_last_ip, u_last_date, u_email, u_pers_birth, u_pers_prof, u_pers_otdel, u_pers_dolj, u_pers_messanger_type, u_pers_messanger_id, u_pers_phone, u_pers_mob_phone, u_pers_address, u_pers_dop, u_pers_foto, u_work_title, u_work_phone, u_work_inner_phone, u_work_fax, u_work_email, u_work_office, u_work_dop FROM sb_users WHERE u_id=?d', $id);

    if ($res)
    {
        list($u_login, $u_name, $u_reg_date, $u_last_ip, $u_last_date, $u_email, $u_pers_birth, $u_pers_prof, $u_pers_otdel, $u_pers_dolj, $u_pers_messanger_type, $u_pers_messanger_id, $u_pers_phone, $u_pers_mob_phone, $u_pers_address, $u_pers_dop, $u_pers_foto, $u_work_title, $u_work_phone, $u_work_inner_phone, $u_work_fax, $u_work_email, $u_work_office, $u_work_dop) = $res[0];

        if ($tab_id == 0)
        {
            $u_pers_foto_width = 88;
            $GLOBALS['sbVfs']->mLocal = true;

            if ($u_pers_foto == '' || !$GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto))
            {
                // фото не указано
                $u_pers_foto = SB_CMS_IMG_URL.'/nofoto.png';
            }
            else
            {
                // проверяем, является ли файл картинкой
                $ar = $GLOBALS['sbVfs']->getimagesize(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto);
                if (!$ar || !in_array($ar[2], array(1,2,3)))
                {
                    // не картинка
                    $u_pers_foto = SB_CMS_IMG_URL.'/nofoto.png';
                }
                else
                {
                    $u_pers_foto_width = min(100, $ar[0]);
                    $u_pers_foto = SB_CMS_USER_UPLOAD_URL.'/users/'.$u_pers_foto;
                }
            }

            $GLOBALS['sbVfs']->mLocal = false;
        }

        if ($u_email != '')
        {
            $u_email = '<a href="mailto:'.$u_email.'">'.$u_email.'</a>';
        }

        if ($u_work_email != '')
        {
            $u_work_email = '<a href="mailto:'.$u_work_email.'">'.$u_work_email.'</a>';
        }

        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

        if (basename($_SERVER['PHP_SELF']) == 'dialog.php')
            $dialog = 1;
        elseif (basename($_SERVER['PHP_SELF']) == 'modal_dialog.php')
            $dialog = 2;
        else
            $dialog = 0;

        $layout = new sbLayout('');

        $layout->setAutoLoading(SB_CMS_EMPTY_FILE.'?event=pl_kernel_user_info&id='.$id.($dialog != 0 ? '&dialog='.$dialog : ''));
        $layout->mTableWidth = '100%';

        $layout->addTab(PL_KERNEL_UI_TAB1);
        $layout->addHeader(PL_KERNEL_UI_TAB1);

        if ($tab_id == 0)
        {
            $layout->addField(PL_KERNEL_UI_LOGIN, new sbLayoutLabel($u_login));
            $layout->addField(PL_KERNEL_UI_EMAIL, new sbLayoutLabel($u_email, '', '', false));
            $layout->addField('', new sbLayoutDelim());
            $layout->addField(PL_KERNEL_UI_FOTO, new sbLayoutLabel('<img src="'.$u_pers_foto.'" id="pers_foto" border="0" width="'.$u_pers_foto_width.'">', '', '', false));
            $layout->addField('', new sbLayoutDelim());
            $layout->addField(PL_KERNEL_UI_DATE_REG, new sbLayoutLabel(sb_date('d.m.Y '.KERNEL_IN.' H:i', $u_reg_date)));
            $layout->addField(PL_KERNEL_UI_DATE_LAST, new sbLayoutLabel(sb_date('d.m.Y '.KERNEL_IN.' H:i', $u_last_date).' ('.PL_KERNEL_UI_IP_LAST.': '.$u_last_ip.')'));

            $view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read');
            $send_message = $_SESSION['sbPlugins']->isRightAvailable('pl_messages', 'read');

            if(($_SESSION['sbAuth']->isAdmin() || $view_info) && $_SESSION['sbAuth']->getUserId() != $id)
            {
                if (basename($_SERVER['PHP_SELF']) == 'dialog.php')
                    $file = SB_CMS_DIALOG_FILE;
                elseif (basename($_SERVER['PHP_SELF']) == 'modal_dialog.php')
                    $file = SB_CMS_MODAL_DIALOG_FILE;
                else
                    $file = SB_CMS_CONTENT_FILE;

                $html = fKernel_Actions_JavaScript($file).
                        '<a href="javascript:void(0)" title="'.PL_KERNEL_WHO_IS_BAN.'" onclick="clickBan(\''.$id.'\')"><img src="'.SB_CMS_IMG_URL.'/icon_block.png" width="16" height="16" alt="'.PL_KERNEL_WHO_IS_BAN.'" border="0" /></a>&nbsp;&nbsp;&nbsp;'.
                        '<a href="javascript:void(0)" title="'.PL_KERNEL_WHO_IS_DROP_PASSWORD.'" onclick="clickDropPassword(\''.$id.'\')"><img src="'.SB_CMS_IMG_URL.'/icon_drop.png" width="16" height="16" alt="'.PL_KERNEL_WHO_IS_DROP_PASSWORD.'" border="0" /></a>&nbsp;&nbsp;&nbsp;'.
                        '<a href="javascript:void(0)" title="'.PL_KERNEL_WHO_IS_DELETE.'" onclick="clickDelete(\''.$id.'\')"><img src="'.SB_CMS_IMG_URL.'/icon_delete.png" width="16" height="16" alt="'.PL_KERNEL_WHO_IS_DELETE.'" border="0" /></a>&nbsp;&nbsp;&nbsp;'.
                        ($send_message ? '<a href="javascript:void(0)" title="'.PL_KERNEL_WHO_IS_SEND_MESSAGE.'" onclick="clickSendMessages(\''.$id.'\')"><img src="'.SB_CMS_IMG_URL.'/messages/add.png" width="16" height="11" alt="'.PL_KERNEL_WHO_IS_SEND_MESSAGE.'" border="0" /></a>' : '');

                $layout->addField(PL_KERNEL_UI_ACTIONS, new sbLayoutHTML($html));
            }
        }

        $layout->addTab(PL_KERNEL_UI_TAB2);
        $layout->addHeader(PL_KERNEL_UI_TAB2);

        if ($tab_id == 1)
        {
            $layout->addField(PL_KERNEL_UI_FIO, new sbLayoutLabel($u_name));
            $layout->addField(PL_KERNEL_UI_BIRTH, new sbLayoutLabel($u_pers_birth));
            $layout->addField(PL_KERNEL_UI_PROF, new sbLayoutLabel($u_pers_prof));
            $layout->addField(PL_KERNEL_UI_OTDEL, new sbLayoutLabel($u_pers_otdel));
            $layout->addField(PL_KERNEL_UI_DOLZJ, new sbLayoutLabel($u_pers_dolj));

            if (!is_null($u_pers_messanger_type) && $u_pers_messanger_type != 0)
            {
                require_once(SB_CMS_LANG_PATH.'/pl_users.lng.php');

                $layout->addField(PL_KERNEL_UI_MESSANGER_TYPE, new sbLayoutLabel($GLOBALS['PL_USERS_MESSANGER_TYPE'][$u_pers_messanger_type]));
                $layout->addField(PL_KERNEL_UI_MESSANGER_ID, new sbLayoutLabel($u_pers_messanger_id));
            }

            $layout->addField(PL_KERNEL_UI_TELEPHONE, new sbLayoutLabel($u_pers_phone));
            $layout->addField(PL_KERNEL_UI_MOB_TELEPHONE, new sbLayoutLabel($u_pers_mob_phone));
            $layout->addField(PL_KERNEL_UI_ADRESS, new sbLayoutLabel($u_pers_address));
            $layout->addField(PL_KERNEL_UI_DOP, new sbLayoutLabel($u_pers_dop));
        }

        $layout->addTab(PL_KERNEL_UI_TAB3);
        $layout->addHeader(PL_KERNEL_UI_TAB3);

        if ($tab_id == 2)
        {
            $layout->addField(PL_KERNEL_UI_WORK_TITLE, new sbLayoutLabel($u_work_title));
            $layout->addField(PL_KERNEL_UI_WORK_TELEPHONE, new sbLayoutLabel($u_work_phone));
            $layout->addField(PL_KERNEL_UI_WORK_INNER_TELEPHONE, new sbLayoutLabel($u_work_inner_phone));
            $layout->addField(PL_KERNEL_UI_WORK_FAX, new sbLayoutLabel($u_work_fax));
            $layout->addField(PL_KERNEL_UI_WORK_EMAIL, new sbLayoutLabel($u_work_email, '', '', false));
            $layout->addField(PL_KERNEL_UI_WORK_OFFICE, new sbLayoutLabel($u_work_office));
            $layout->addField(PL_KERNEL_UI_DOP, new sbLayoutLabel($u_work_dop));
        }

        if ($dialog != 0)
        {
            $layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="window.close();"');
        }

        $layout->show();
    }
    else
    {
        sb_show_message(PL_KERNEL_NO_USER, true, 'warning');
    }
}

function fKernel_Site_User_Info()
{
	$id = intval($_GET['id']);
    $tab_id = isset($_GET['tab_id']) ? intval($_GET['tab_id']) : -1;

    if (!$_SESSION['sbPlugins']->isRightAvailable('pl_site_users', 'read') && $_SESSION['sbAuth']->getUserId() != $id)
    {
        sb_show_message(PL_KERNEL_NO_RIGHTS_TO_VIEW, true, 'warning');
        return;
    }

	$res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident = ?', 'pl_site_users');

	$elems_fields = array();
	$elems_fields_select_sql = '';

	$titles = array();

	// формируем SQL-запрос для пользовательских полей
	if ($res)
	{
		if($res[0][0] != '')
		{
			$elems_fields = unserialize($res[0][0]);
    	}

        if ($elems_fields)
        {
	        foreach ($elems_fields as $value)
	        {
	            if (isset($value['sql']) && $value['sql'] == 1)
	            {
	                $elems_fields_select_sql .= ', user_f_'.$value['id'];
	                $titles[] = $value['title'];
	            }
	        }
        }
    }

	$res = sql_query('SELECT su_login, su_name, su_reg_date, su_last_ip, su_last_date, su_email, su_pers_birth, su_pers_phone, su_work_unit, su_work_position, su_pers_mob_phone, su_pers_adress, su_pers_addition, su_pers_foto, su_work_name, su_work_phone, su_work_phone_inner, su_work_fax, su_work_email, su_work_office_number, su_work_addition, su_active_date, su_status, su_pers_sex, su_pers_zip, su_last_ip, su_domains, su_forum_nick, su_forum_text, su_mail_status, su_mail_date, su_mail_lang, su_mail_subscription '.$elems_fields_select_sql.' FROM sb_site_users WHERE su_id=?d', $id);
    if ($res)
    {
		$num_fields = count($res[0]);
		list($su_login, $su_name, $su_reg_date, $su_last_ip, $su_last_date, $su_email, $su_pers_birth, $su_pers_phone, $su_work_unit, $su_work_position, $su_pers_mob_phone, $su_pers_adress, $su_pers_addition, $su_pers_foto, $su_work_name, $su_work_phone, $su_work_phone_inner, $su_work_fax, $su_work_email, $su_work_office_number, $su_work_addition, $su_active_date, $su_status, $su_pers_sex, $su_pers_zip, $su_last_ip, $su_domains, $su_forum_nick, $su_forum_text, $su_mail_status, $su_mail_date, $su_mail_lang, $su_mail_subscription) = $res[0];
		$su_mail_subscription = explode(',', $su_mail_subscription);

		$tmp_su_mail = array();
		foreach($su_mail_subscription as $key => $value)
		{
			$tmp_su_mail[$value] = $value;
		}
		$su_mail_subscription = $tmp_su_mail;

        if ($tab_id == 0)
        {
            $su_pers_foto_width = 88;
            $GLOBALS['sbVfs']->mLocal = true;

            if ($su_pers_foto == '' || !$GLOBALS['sbVfs']->exists(SB_SITE_USER_UPLOAD_PATH.'/pl_site_users/'.$su_pers_foto))
            {
                // фото не указано
                $su_pers_foto = SB_CMS_IMG_URL.'/nofoto.png';
            }
            else
            {
                // проверяем, является ли файл картинкой
                $ar = $GLOBALS['sbVfs']->getimagesize(SB_SITE_USER_UPLOAD_PATH.'/pl_site_users/'.$su_pers_foto);
                if (!$ar || !in_array($ar[2], array(1,2,3)))
                {
                    // не картинка
                    $su_pers_foto = SB_CMS_IMG_URL.'/nofoto.png';
                }
                else
                {
                    $su_pers_foto_width = min(100, $ar[0]);
                    $su_pers_foto = SB_SITE_USER_UPLOAD_PATH.'/pl_site_users/'.$su_pers_foto;
                }
            }

			$GLOBALS['sbVfs']->mLocal = false;
        }

		$values = array();
		if ($num_fields > 24)
		{
			for ($i = 24; $i < $num_fields; $i++)
			{
				$values[] = $res[0][$i];
			}
		}

		if ($su_email != '')
        {
            $su_email = '<a href="mailto:'.$su_email.'">'.$su_email.'</a>';
        }

        if ($su_work_email != '')
        {
            $su_work_email = '<a href="mailto:'.$su_work_email.'">'.$su_work_email.'</a>';
        }

        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

        if (basename($_SERVER['PHP_SELF']) == 'dialog.php')
            $dialog = 1;
        elseif (basename($_SERVER['PHP_SELF']) == 'modal_dialog.php')
            $dialog = 2;
        else
            $dialog = 0;

        $layout = new sbLayout('');

        $layout->setAutoLoading(SB_CMS_EMPTY_FILE.'?event=pl_kernel_site_user_info&id='.$id.($dialog != 0 ? '&dialog='.$dialog : ''));
        $layout->mTableWidth = '100%';

        $layout->addTab(PL_KERNEL_UI_TAB1);
        $layout->addHeader(PL_KERNEL_UI_TAB1);

        if ($tab_id == 0)
        {
            $layout->addField(PL_KERNEL_UI_LOGIN, new sbLayoutLabel($su_login));
            $layout->addField(PL_KERNEL_UI_EMAIL, new sbLayoutLabel($su_email, '', '', false));
            $layout->addField('', new sbLayoutDelim());
            $layout->addField(PL_KERNEL_UI_FOTO, new sbLayoutLabel('<img src="'.$su_pers_foto.'" id="pers_foto" border="0" width="'.$su_pers_foto_width.'">', '', '', false));
            $layout->addField('', new sbLayoutDelim());
            $layout->addField(PL_KERNEL_UI_DATE_REG, new sbLayoutLabel(sb_date('d.m.Y '.KERNEL_IN.' H:i', $su_reg_date)));
            $layout->addField(PL_KERNEL_UI_DATE_LAST, new sbLayoutLabel(sb_date('d.m.Y '.KERNEL_IN.' H:i', $su_last_date).' ('.PL_KERNEL_UI_IP_LAST.': '.$su_last_ip.')'));

			$result = '';
			switch ($su_status)
			{
				case 0:
					$result .= '<span style="color: green;">'.PL_KERNEL_USER_GET_STATUS_REG.'</span>';
					break;
				case 1:
					$result .= '<span style="color: magenta;">'.PL_KERNEL_USER_GET_STATUS_MOD.'</span>';
					break;
		        case 2:
		            $result .= '<span style="color: magenta;">'.PL_KERNEL_USER_GET_STATUS_EMAIL.'</span>';
		            break;
		        case 3:
					$result .= '<span style="color: magenta;">'.PL_KERNEL_USER_GET_STATUS_MOD_EMAIL.'</span>';
					break;
				case 4:
					$result .= '<span style="color: red;">'.PL_KERNEL_USER_GET_STATUS_BLOCK.'</span>';
					break;
			}

			$layout->addField(PL_KERNEL_USER_STATUS_LABEL, new sbLayoutHTML($result));
			$layout->addField(PL_KERNEL_USER_ACTIVE_DATE, new sbLayoutLabel(($su_active_date > 0 ? sb_date('d.m.Y H:i', $su_active_date) : '')));
			$layout->addField(PL_KERNEL_USER_LAST_IP, new sbLayoutLabel($su_last_ip));
			$layout->addField(PL_KERNEL_USER_DOMAINS, new sbLayoutLabel($su_domains));

			$view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_site_users', 'read');
			$send_message = $_SESSION['sbPlugins']->isRightAvailable('pl_messages', 'read');
        }

        $layout->addTab(PL_KERNEL_UI_TAB2);
        $layout->addHeader(PL_KERNEL_UI_TAB2);

        if ($tab_id == 1)
        {
            $layout->addField(PL_KERNEL_UI_FIO, new sbLayoutLabel($su_name));
            $layout->addField(PL_KERNEL_UI_BIRTH, new sbLayoutLabel($su_pers_birth));
            $layout->addField(PL_KERNEL_UI_OTDEL, new sbLayoutLabel($su_work_unit));
            $layout->addField(PL_KERNEL_UI_DOLZJ, new sbLayoutLabel($su_work_position));
            $layout->addField(PL_KERNEL_UI_TELEPHONE, new sbLayoutLabel($su_pers_phone));
            $layout->addField(PL_KERNEL_UI_MOB_TELEPHONE, new sbLayoutLabel($su_pers_mob_phone));
			$layout->addField(PL_KERNEL_USER_PERS_ZIP, new sbLayoutLabel($su_pers_zip));
            $layout->addField(PL_KERNEL_UI_ADRESS, new sbLayoutLabel($su_pers_adress));
            $layout->addField(PL_KERNEL_UI_DOP, new sbLayoutLabel($su_pers_addition));
			$layout->addField(PL_KERNEL_USER_SEX, new sbLayoutLabel(($su_pers_sex == 0 ? PL_KERNEL_USER_SEX_MAN : PL_KERNEL_USER_SEX_WOMAN)));
        }

		$layout->addTab(PL_KERNEL_UI_TAB3);
		$layout->addHeader(PL_KERNEL_UI_TAB3);

        if ($tab_id == 2)
        {
			$layout->addField(PL_KERNEL_UI_WORK_TITLE, new sbLayoutLabel($su_work_name));
            $layout->addField(PL_KERNEL_UI_WORK_TELEPHONE, new sbLayoutLabel($su_work_phone));
            $layout->addField(PL_KERNEL_UI_WORK_INNER_TELEPHONE, new sbLayoutLabel($su_work_phone_inner));

            $layout->addField(PL_KERNEL_UI_WORK_FAX, new sbLayoutLabel($su_work_fax));
            $layout->addField(PL_KERNEL_UI_WORK_EMAIL, new sbLayoutLabel($su_work_email, '', '', false));
			$layout->addField(PL_KERNEL_UI_WORK_OFFICE, new sbLayoutLabel($su_work_office_number));
			$layout->addField(PL_KERNEL_UI_DOP, new sbLayoutLabel($su_work_addition));
        }

		$layout->addTab(PL_KERNEL_SUI_USERS_MAIL_TAB5);
		$layout->addHeader(PL_KERNEL_SUI_USERS_MAIL_TAB5);

		$layout->addField(PL_KERNEL_USER_DELIVERY_LANG, new sbLayoutLabel($GLOBALS['sb_site_langs'][$su_mail_lang]));

		if($su_mail_status == 0)
		{
			$value = PL_KERNEL_USER_DELIVERY_ACTIVE;
		}
		elseif($su_mail_status == 1)
		{
			$value = PL_KERNEL_USER_DELIVERY_NO_ACTIVE;
    	}
		elseif($su_mail_status == 2)
		{
			$value = PL_KERNEL_USER_DELIVERY_NO_ACTIVE_TO.' '.sb_date('d.m.Y H:i', $su_mail_date);
		}
		$layout->addField(PL_KERNEL_USER_STATUS_DELIVERIES, new sbLayoutLabel($value));

		$res = sql_query('SELECT mail.m_name, link.link_el_id FROM sb_categs cat, sb_catlinks link, sb_maillist mail
								WHERE cat.cat_ident = ? AND link.link_cat_id = cat.cat_id
								AND mail.m_id = link.link_el_id ORDER BY cat.cat_left, mail.m_name', 'pl_maillist');
		if($res)
		{
			$html = '';
		    foreach($res as $key => $value)
		    {
				list($m_name, $link_el_id) = $value;
                if (isset($su_mail_subscription[$link_el_id]) && $su_mail_subscription[$link_el_id] == $link_el_id)
                {
					$html .= $m_name.', ';
                }
			}

			$html = sb_substr($html, 0, -2);
			$layout->addField(PL_KERNEL_USER_DELIVERIES, new sbLayoutLabel($html));
	    }

		$layout->addTab(PL_KERNEL_SUI_USERS_FORUM_TAB6);
		$layout->addHeader(PL_KERNEL_SUI_USERS_FORUM_TAB6);

		$layout->addField(PL_KERNEL_USER_FORUM_NICK, new sbLayoutLabel($su_forum_nick));
		$layout->addField(PL_KERNEL_USER_FORUM_TEXT, new sbLayoutLabel($su_forum_text));

		if (count($titles) > 0)
		{
			$layout->addTab(PL_KERNEL_SUI_USERS_TAB4);
			$layout->addHeader(PL_KERNEL_SUI_USERS_TAB4);

			foreach($titles as $key => $value)
	        {
				$layout->addField($value, new sbLayoutLabel($values[$key]));
	        }

			if ($dialog != 0)
	        {
				$layout->addButton('button', KERNEL_CLOSE, '', '', 'onclick="window.close();"');
	        }
		}

		$layout->show();
    }
    else
    {
        sb_show_message(PL_KERNEL_NO_USER, true, 'warning');
    }
}

function fKernel_Who_Is_Online()
{
    echo fKernel_Actions_JavaScript();

    if(sbPlugins::getUserSetting('pl_kernel_who_is_online_interval') > 0)
    {
        echo '
        <script>
            setInterval("updateFrame()", '.(max(1, sbPlugins::getUserSetting('pl_kernel_who_is_online_interval')) * 1000).');
        </script>';
    }

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();

    $layout->mTableWidth = '95%';

    $timeout = sbPlugins::getSetting('sb_session_timeout') * 60;

    //--------------------------Запрос сортировки-------------------//
    $order = 'ORDER BY users.u_login ASC';
    if(isset($_GET['u_login']))
    {
        $order = 'ORDER BY users.u_login '.($_GET['u_login'] == 'up' ? 'ASC' : 'DESC');
    }
    elseif(isset($_GET['us_ip']))
    {
        $order = 'ORDER BY ses.us_ip '.($_GET['us_ip'] == 'up' ? 'ASC' : 'DESC');
    }
    elseif(isset($_GET['us_browser']))
    {
        $order = 'ORDER BY ses.us_browser '.($_GET['us_browser'] == 'up' ? 'ASC' : 'DESC');
    }
    elseif(isset($_GET['u_last_date']))
    {
        $order = 'ORDER BY users.u_last_date '.($_GET['u_last_date'] == 'up' ? 'ASC' : 'DESC');
    }
    elseif(isset($_GET['us_active_time']))
    {
        $order = 'ORDER BY ses.us_active_time '.($_GET['us_active_time'] == 'up' ? 'ASC' : 'DESC');
    }
    else
    {
        $_GET['u_login'] = 'up';
    }

    $result = sql_query('SELECT ses.us_ip, ses.us_browser, ses.us_active_time,
                                users.u_id, users.u_login, users.u_last_date, users.u_name
                         FROM sb_users_sessions ses, sb_users users
                         WHERE users.u_id=ses.us_user_id AND ses.us_active_time > '.(time() - $timeout).' '.$order);

    if ($result)
    {
        $values = array();
        $view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read');
        $send_message = $_SESSION['sbPlugins']->isRightAvailable('pl_messages', 'read');
        for($i = 0; $i < count($result); $i++)
        {
            list($us_ip, $us_browser, $us_active_time, $u_id, $u_login, $u_last_date, $u_name) = $result[$i];

            $us_ip = sb_htmlspecialchars($us_ip);
            $us_browser = sb_htmlspecialchars($us_browser);
            $us_active_time = intval($us_active_time);
            $u_id = intval($u_id);
            $u_login = sb_htmlspecialchars($u_login);
            $u_last_date = intval($u_last_date);

            // определяем время пребывания в системе
            $time_of_stay = time() - $u_last_date;

            $hour = floor($time_of_stay / (60 * 60));
            $min  = floor(($time_of_stay - $hour * 60 * 60) / 60);
            $sec  = $time_of_stay - $hour * 60 * 60 - $min * 60;

            $time_of_stay = ($hour != 0 ? $hour.' '.PL_KERNEL_WHO_IS_HOUR.' ' : '').
                            ($min != 0 ? $min.' '.PL_KERNEL_WHO_IS_MIN.' ' : '').
                            ($sec != 0 ? $sec.' '.PL_KERNEL_WHO_IS_SEC.' ' : '');

            //---------------------------Определяем браузер--------------------//
            $browser = browser_get_agent($us_browser);
	        switch ($browser[0])
			{
			    case 'IE':
			        $browser = 'Internet Explorer '.$browser[1];
			        break;

			    case 'OPERA':
			        $browser = 'Opera '.$browser[1];
			        break;

			    case 'MOZILLA':
			        $browser = 'Firefox '.$browser[1];
			        break;

			    case 'SAFARI':
			    	$browser = 'Safari '.$browser[1];
			    	break;

			    case 'CHROME':
			    	$browser = 'Google Chrome '.$browser[1];
			    	break;

			    case 'OTHER':
			    	$browser = '-';
			    	break;
			}

            //----------------------------------Массив сортировки---------------//
            $sort = array();
            $sort[0] = 'u_login';
            $sort[1] = 'us_ip';
            $sort[2] = 'us_browser';
            $sort[3] = 'u_last_date';
            $sort[4] = 'us_active_time';

            //-------------------------------Строим массив значений-------------//
            if($_SESSION['sbAuth']->isAdmin() || $view_info)
                $values[] = array('<center><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_kernel_user_info&id='.$u_id.'">'.$u_login.'</a>'.($u_name != '' ? '<br><span class="smalltext">('.$u_name.')</span>' : '').'</center>',
                                  '<center>'.$us_ip.'</center>',
                                  '<center><nobr>'.$browser.'</nobr></center>',
                                  '<center>'.$time_of_stay.'</center>',
                                  '<center>'.sb_date('H:i:s', $us_active_time).'</center>',
                                  $_SESSION['sbAuth']->getUserId() != $u_id ? '<a href="javascript:void(0)" title="'.PL_KERNEL_WHO_IS_BAN.'" onclick="clickBan(\''.$u_id.'\')"><img src="'.SB_CMS_IMG_URL.'/icon_block.png" width="16" height="16" alt="'.PL_KERNEL_WHO_IS_BAN.'" border="0" /></a>' : '',
                                  $_SESSION['sbAuth']->getUserId() != $u_id ? '<a href="javascript:void(0)" title="'.PL_KERNEL_WHO_IS_DROP_PASSWORD.'" onclick="clickDropPassword(\''.$u_id.'\')"><img src="'.SB_CMS_IMG_URL.'/icon_drop.png" width="16" height="16" alt="'.PL_KERNEL_WHO_IS_DROP_PASSWORD.'" border="0" /></a>' : '',
                                  $_SESSION['sbAuth']->getUserId() != $u_id ? '<a href="javascript:void(0)" title="'.PL_KERNEL_WHO_IS_DELETE.'" onclick="clickDelete(\''.$u_id.'\')"><img src="'.SB_CMS_IMG_URL.'/icon_delete.png" width="16" height="16" alt="'.PL_KERNEL_WHO_IS_DELETE.'" border="0" /></a>' : '',
                                  $_SESSION['sbAuth']->getUserId() != $u_id && $send_message ? '<a href="javascript:void(0)" title="'.PL_KERNEL_WHO_IS_SEND_MESSAGE.'" onclick="clickSendMessages(\''.$u_id.'\')"><img src="'.SB_CMS_IMG_URL.'/messages/add.png" width="16" height="11" alt="'.PL_KERNEL_WHO_IS_SEND_MESSAGE.'" border="0" /></a>' : '');
            else
                $values[] = array( '<center>'.($_SESSION['sbAuth']->getUserId() != $u_id ? $u_login : '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_kernel_user_info&id='.$u_id.'">'.$u_login.'</a>').'</center>',
                                   '<center>'.$us_ip.'</center>', '<center><nobr>'.$browser.'</nobr></center>',
                                   '<center>'.$time_of_stay.'</center>',
                                   '<center>'.sb_date('H:i:s', $us_active_time).'</center>',
                                   '',
                                   '',
                                   '',
                                   $_SESSION['sbAuth']->getUserId() != $u_id && $send_message ? '<a href="javascript:void(0)" title="'.PL_KERNEL_WHO_IS_SEND_MESSAGE.'" onclick="clickSendMessages(\''.$u_id.'\')"><img src="'.SB_CMS_IMG_URL.'/messages/add.png" width="16" height="11" alt="'.PL_KERNEL_WHO_IS_SEND_MESSAGE.'" border="0" /></a>' : '');
        }

        $labels = array(PL_KERNEL_WHO_IS_LOGIN, PL_KERNEL_WHO_IS_IP, PL_KERNEL_WHO_IS_BROWSER, PL_KERNEL_WHO_IS_TIME_OF_STAY, PL_KERNEL_WHO_IS_LAST_ACTIVITY, '', '', '', '');

        $layout->addField('', new sbLayoutTable($labels, $values, $sort));

        //------------------------Вывод таблицы-------------------//
        echo '<table width="100%"><tr><td align="center" valign="top" style="padding-top: 20px" id="kernel_who_is_online_content">';

        $layout->show();

        echo '</td></tr>
        <tr><td align="center"><br><a href="javascript:updateFrame();void(0);">[ '.KERNEL_REFRESH.' ]</a></table>';
    }
}

function fKernel_Who_Is_Online_Ban()
{
    if($_SESSION['sbAuth']->getUserId() == intval($_GET['u_id']))
    {
        return;
    }

    $res = sql_query('SELECT u_login, u_name FROM sb_users WHERE u_id=?d', $_GET['u_id']);
    if ($res)
    {
        if( sql_query('UPDATE sb_users SET u_block=1 WHERE u_id=?d', $_GET['u_id'], sprintf(PL_KERNEL_WHO_IS_BAN_LOG, '<b>'.$_SESSION['sbAuth']->getUserLogin().'</b>'.($_SESSION['sbAuth']->mName != '' ? ' ('.$_SESSION['sbAuth']->mName.')' : ''), '<b>'.$res[0][0].'</b>'.($res[0][1] != '' ? ' ('.$res[0][1].')' : '')), SB_MSG_INFORMATION) )
        {
            sql_query('DELETE FROM sb_users_sessions WHERE us_user_id=?d', $_GET['u_id']);
            echo 'true';
        }
    }
}

function fKernel_Who_Is_Online_Delete()
{
    $res = sql_query('SELECT u_login, u_name, u_pers_foto FROM sb_users WHERE u_id=?d', $_GET['u_id']);
    if (!$res)
        return;

    list($u_login, $u_name, $u_pers_foto) = $res[0];

    $res = sql_query('DELETE FROM sb_users WHERE u_id=?d', $_GET['u_id'], sprintf(PL_KERNEL_WHO_IS_DEL_LOG, '<b>'.$_SESSION['sbAuth']->getUserLogin().'</b>'.($_SESSION['sbAuth']->mName != '' ? ' ('.$_SESSION['sbAuth']->mName.')' : ''), '<b>'.$u_login.'</b>'.($u_name != '' ? ' ('.$u_name.')' : '')), SB_MSG_INFORMATION);
    if ($res)
    {
        // удаляем связь с разделом
        $res = sql_query('SELECT links.link_id FROM sb_catlinks links, sb_categs categs WHERE links.link_el_id=?d AND links.link_cat_id=categs.cat_id AND categs.cat_ident=?', $_GET['u_id'], 'pl_users');
        if($res)
        {
            list($link_id) = $res[0];
            sql_query('DELETE FROM sb_catlinks WHERE link_id=?d', $link_id);
        }

        // чистим сессии пользователя и настройки интерфейса
		sql_query('DELETE FROM sb_users_sessions WHERE us_user_id=?d', $_GET['u_id']);
		sql_query('DELETE FROM sb_users_settings WHERE us_user_id=?d', $_GET['u_id']);

		$GLOBALS['sbVfs']->mLocal = true;

		if ($u_pers_foto != '' && $GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto) && $GLOBALS['sbVfs']->is_file(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto))
		    $GLOBALS['sbVfs']->delete(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto);

		// чистим личные сообщения пользователя
		$res = sql_query('SELECT um_files FROM sb_users_messages WHERE um_to_id=?d OR (um_from_id=?d AND um_to_ids <> ?)', $_GET['u_id'], $_GET['u_id'], '');
		if ($res)
		{
		    for ($i = 0; $i < count($res); $i++)
		    {
		        $um_files = @unserialize($res[0][0]);
		        for($j = 0; $j < count($um_files); $j++)
                {
                    $file = SB_CMS_USER_UPLOAD_PATH.'/messages/'.$um_files[$j];
                    if ($um_files[$j] != '' && $GLOBALS['sbVfs']->exists($file) && $GLOBALS['sbVfs']->is_file($file))
                        $GLOBALS['sbVfs']->delete($file);
                }
		    }
		}

		$GLOBALS['sbVfs']->mLocal = false;

		sql_query('DELETE FROM sb_users_messages WHERE um_to_id=?d OR (um_from_id=?d AND um_to_ids <> ?)', $_GET['u_id'], $_GET['u_id'], '');

        echo 'true';
    }
}

function fKernel_Who_Is_Online_Drop_Password()
{
    $password = substr(md5('%%%'.time().'%%%'.$_SESSION['sbAuth']->getUserLogin()), 0, intval(sbPlugins::getSetting('sb_pass_length_limit')));

    $res = sql_query('SELECT u_login, u_name, u_email FROM sb_users WHERE u_id=?d', $_GET['u_id']);

    if($res && sql_query('UPDATE sb_users SET u_pass=?, u_pass_date=?d WHERE u_id=?d', md5($password), time(), $_GET['u_id'], sprintf(PL_KERNEL_WHO_IS_PASS_LOG, '<b>'.$_SESSION['sbAuth']->getUserLogin().'</b>'.($_SESSION['sbAuth']->mName != '' ? ' ('.$_SESSION['sbAuth']->mName.')' : ''), '<b>'.$res[0][0].'</b>'.($res[0][1] != '' ? ' ('.$res[0][1].')' : '')), SB_MSG_INFORMATION) )
    {
        $subject = sprintf(PL_KERNEL_WHO_IS_MESSAGE_EMAIL_SUBJECT, SB_COOKIE_DOMAIN);
        $body = sprintf(PL_KERNEL_WHO_IS_MESSAGE_EMAIL_BODY, SB_COOKIE_DOMAIN, ($res[0][2] != '' ? '<a href="mailto:'.$res[0][2].'">' : '').$res[0][0].($res[0][2] != '' ? '</a>' : '').($res[0][1] != '' ? ' ('.$res[0][1].')' : ''), $password);


        $mail = new sbMail();
        $mail->setSubject($subject);

        if (sbPlugins::getSetting('sb_letters_type') == 'html')
        {
            $mail->setHtml($body);
        }
        else
        {
            $body = preg_replace('=<br.*?/?>=i'.SB_PREG_MOD, '', $body);
            $mail->setText(strip_tags($body));
        }

        $mail->send(array($_SESSION['sbAuth']->getUserEmail()));

        echo 'true';
    }
}

function fKernel_Show_Toolbar()
{
    require_once(SB_CMS_LANG_PATH.'/navmenu.lng.php');
    // вывод панели инструментов
    $icons = $_SESSION['sbPlugins']->getToolbarIcons();
    echo '<nobr><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_kernel_read" target="content" title="'.NAVMENU_HOME.'"><img class="button" src="'.SB_CMS_IMG_URL.'/plugins/pl_kernel_24.png" width="24" height="24" /></a>';
    if (CMS_SITE_NAME == 'www.sbuilder.ru')
    {
        echo '&nbsp;&nbsp;&nbsp;<a id="help_url" href="http://www.sbuilder.ru/training/helps/" target="_blank" title="'.NAVMENU_HELP.'"><img class="button" src="'.SB_CMS_IMG_URL.'/plugins/pl_help_24.png" width="24" height="24" style="cursor:help;" /></a>';
    }

    $count = count($icons);
    for ($i = 0; $i < $count; $i++)
    {
        if ($i == 0)
        {
            echo '<img src="'.SB_CMS_IMG_URL.'/bardelim.gif" style="margin-top: -4px;">';
        }

        echo '<a href="'.$icons[$i]['href'].'" target="'.$icons[$i]['target'].'" title="'.$icons[$i]['desc'].'"><img class="button" src="'.$icons[$i]['icon'].'"></a>';
        if ($i != $count - 1)
        {
            echo '&nbsp;&nbsp;&nbsp;';
        }
    }

    echo '</nobr>';
}

function fKernel_Show_Quick_Toolbar()
{
    // вывод панели инструментов
    $all_count = sbPlugins::getUserSetting('sb_toolbar_qicons_count');
    echo '<nobr>';
    if ($all_count > 0)
    {
	    $count = count($_SESSION['sbQuickToolbar']);
	    $i = 0;
	    foreach ($_SESSION['sbQuickToolbar'] as $event => $value)
	    {
	        if ($i == 0)
	        {
	            echo '<img src="'.SB_CMS_IMG_URL.'/bardelim.gif" style="margin-top: -4px;">';
	        }

	        echo '<a href="'.SB_CMS_CONTENT_FILE.'?event='.$event.'" target="content" title="'.$value['desc'].'"><img class="button" src="'.$value['icon'].'"></a>';

	        if ($i != $count - 1 && $i != $all_count - 1)
	        {
	            echo '&nbsp;&nbsp;&nbsp;';
	        }
	        $i++;

	        if ($i == $all_count)
	        	break;
	    }
    }
    echo '</nobr>';
}

function fKernel_Upload_Graph_Image()
{
	$image = base64_decode(@file_get_contents('php://input'));

	$file_text = sb_strtolower($image);

 	if (strpos($file_text, '<script') > -1 ||
 		strpos($file_text, '<embed') > -1 ||
 		strpos($file_text, '<applet') > -1 ||
 		strpos($file_text, '<object') > -1 ||
 		strpos($file_text, '<html') > -1 ||
 		strpos($file_text, '<body') > -1 ||
 		strpos($file_text, 'javascript') > -1 ||
 		strpos($file_text, '<head') > -1 )
 	{
 		echo 'FALSE';
        return;
 	}

	$GLOBALS['sbVfs']->mLocal = true;

	// проверяем права на папки и файлы
    if (!$GLOBALS['sbVfs']->exists(SB_CMS_TMP_PATH))
    {
        if (!$GLOBALS['sbVfs']->mkdir(SB_CMS_TMP_PATH))
        {
        	echo 'FALSE';
        	$GLOBALS['sbVfs']->mLocal = false;
            return;
        }
    }

    if (!$GLOBALS['sbVfs']->is_writable(SB_CMS_TMP_PATH))
    {
        echo 'FALSE';
        $GLOBALS['sbVfs']->mLocal = false;
        return;
    }

    $file = 'graph_'.time().uniqid().'.png';
    $GLOBALS['sbVfs']->file_put_contents(SB_CMS_TMP_PATH.'/'.$file, $image);
    $GLOBALS['sbVfs']->mLocal = false;

    echo $file;
}

function fKernel_Download_Graph_Image()
{
	$image = $_GET['image'];
	$image = sb_strtolat($image);
	// только малые буквы, цифры, знак подчеркивания, точка и тире
	$image = preg_replace('/[^a-z0-9\._\-]/i', '', str_replace(array(' ', '%20'), array('_', '_'), sb_strtolower($image)));

	$GLOBALS['sbVfs']->mLocal = true;

	if (!$GLOBALS['sbVfs']->exists(SB_CMS_TMP_PATH.'/'.$image) || !$GLOBALS['sbVfs']->is_file(SB_CMS_TMP_PATH.'/'.$image))
    {
        return;
    }

    header('Content-type: image/png', true);
    header('Content-Disposition: attachment; filename="'.sb_sanitize_header($image).'"');

    echo $GLOBALS['sbVfs']->file_get_contents(SB_CMS_TMP_PATH.'/'.$image);
    $GLOBALS['sbVfs']->delete(SB_CMS_TMP_PATH.'/'.$image);
}

function fKernel_Sbuilder_News()
{
	try
	{
		$rss = new SimpleXMLElement('http://sbuilder.ru/rss.php', null, true);
		if($rss)
	    {
		    $result = '<table width="100%" cellspacing="0" cellpadding="5" class="form" style="border: 0;">';

			for($i = 0; $i < min(7, count($rss->channel->item) - 1); $i++)
			{
				if ($i % 2 == 0)
					$class = 'even';
				else
					$class = 'odd';

				$link = (string) $rss->channel->item[$i]->link;
				$title = (string) $rss->channel->item[$i]->title;
				$pubDate = strtotime((string) $rss->channel->item[$i]->pubDate);

				$result .= '
				<tr class="'.$class.'">
					<td style="text-align:center;">
	                        <nobr><span class="smalltext">'.sb_date('d.m.Y '.KERNEL_IN.' H:i', $pubDate).'</span></nobr>
					</td>
                    <td>
                        <a href="'.$link.'" target="_blank">'.$title.'</a>
					</td>
				</tr>';
		    }

			$result .= '</table><br />
	        <div class="sbDS_more"><a href="'.(string) $rss->channel->link.'" target="_blank">'.KERNEL_MORE.'</a></div>';

	        echo $result;
	    }
	    else
	    {
	        sb_show_message(PL_KERNEL_INC_NO_NEWS, true);
	    }
	}
	catch (Exception $e)
	{
		return;
	}
}
?>