<?php

//   Замена тегов
//
//   $str  string строка текста
//   $id  integer Ид пользователя
//   $m_fields  array() Шаблоны стандартных полей пользователя
//   $su_fields_temps array() Шаблоны пользовательских полей пользователя

function replace_tags($str, $id, $m_fields, $su_fields_temps, $lang)
{
	if(is_array($m_fields) == false)
    {
    	$m_fields = array();
	}

	if(is_array($su_fields_temps) == false)
	{
		$su_fields_temps = array();
	}
	$res = sql_param_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident = "pl_site_users"');

    $elems_fields = array();
    $elems_fields_select_sql = '';
    $tags = array();

	// формируем SQL-запрос для пользовательских полей
	if ($res)
    {
        if($res[0][0] != '')
        {
            $elems_fields = unserialize($res[0][0]);
        }

        if ($elems_fields)
        {
			foreach ($elems_fields as $value)
	        {
				if (isset($value['sql']) && $value['sql'] == 1)
	            {
	                $elems_fields_select_sql .= ', user_f_'.$value['id'];

	                if ($value['type'] == 'google_coords' || $value['type'] == 'yandex_coords')
	                {
	                	$tags[] = '{'.$value['tag'].'_LATITUDE}';
	                	$tags[] = '{'.$value['tag'].'_LONGTITUDE}';

		                if ($value['type'] == 'yandex_coords')
	                	{
	                		$tags[] = '{'.$value['tag'].'_API_KEY}';
	                	}
	                }
	                else
	                {
	                	$tags[] = '{'.$value['tag'].'}';
	                }
	            }
	        }
        }
    }

	$res = sql_param_query('SELECT su_id,su_last_ip,su_activation_code,su_name,su_pass,su_email,su_login,su_reg_date,su_last_ip,su_status,su_pers_foto,su_pers_phone,su_pers_mob_phone,su_pers_birth,su_pers_sex,su_pers_zip,su_pers_adress,su_pers_addition,su_work_name,su_work_phone,su_work_phone_inner,su_work_fax,su_work_email,su_work_addition,su_work_office_number,su_work_unit,su_work_position,su_forum_nick,su_forum_text,su_mail_lang,su_mail_status,su_mail_date,su_mail_subscription, su_last_date'.$elems_fields_select_sql.' FROM sb_site_users WHERE su_id = ?d',$id);
    list($su_id, $su_last_ip, $su_activation_code, $su_name, $su_pass, $su_email, $su_login,
             $su_reg_date,$su_last_ip,$su_status,$su_pers_foto,$su_pers_phone,$su_pers_mob_phone,
             $su_pers_birth,$su_pers_sex,$su_pers_zip,$su_pers_adress,$su_pers_addition,$su_work_name,
             $su_work_phone,$su_work_phone_inner,$su_work_fax,$su_work_email,$su_work_addition,
             $su_work_office_number,$su_work_unit,$su_work_position,$su_forum_nick,
             $su_forum_text,$su_mail_lang,$su_mail_status,$su_mail_date,$su_mail_subscription, $su_last_date) = $res[0];

	$tags = array_merge($tags, array('{SU_ID}', '{SU_REG_DATE}', '{SU_LAST_DATE}', '{SU_PERS_BIRTH}', '{SU_STATUS}', '{SU_PERS_SEX}', '{SU_LAST_IP}', '{SU_NAME}',
	'{SU_EMAIL}', '{SU_LOGIN}', '{SU_PERS_FOTO}', '{SU_PERS_PHONE}', '{SU_PERS_MOB_PHONE}', '{SU_PERS_ZIP}', '{SU_PERS_ADRESS}',
	'{SU_PERS_ADDITION}', '{SU_WORK_NAME}', '{SU_WORK_PHONE}', '{SU_WORK_PHONE_INNER}', '{SU_WORK_FAX}', '{SU_WORK_EMAIL}',
	'{SU_WORK_ADDITION}', '{SU_WORK_OFFICE_NUMBER}', '{SU_WORK_UNIT}', '{SU_WORK_POSITION}', '{SU_FORUM_NICK}', '{SU_FORUM_TEXT}',
	'{SU_MAIL_LANG}', '{SU_MAIL_STATUS}'));

	$dop_tags = array('{SU_ID}', '{VALUE}');
	$dop_values = array($su_id);

	$values = array();
	$num_fields = count($res[0]);

    if ($num_fields > 34)
	{
		for ($i = 34; $i < $num_fields; $i++)
		{
			$vals[] = $res[0][$i];
		}
		include_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
		$values = sbLayout::parsePluginFields($elems_fields, $vals, $su_fields_temps, $dop_tags, $dop_values, $lang);
	}

    $values[] = $su_id;
	if(isset($m_fields['su_reg_date']) && $m_fields['su_reg_date'] != '') // Дата регистрации
	{
		$values[] = str_replace('{SU_ID}', $su_id, sb_parse_date($su_reg_date, $m_fields['su_reg_date'], $lang));
	}
    else
    {
		$values[] = '';
    }

    if(isset($m_fields['su_last_date']) && $m_fields['su_last_date'] != '') // Дата последней активности
    {
		$values[] = str_replace('{SU_ID}', $su_id, sb_parse_date($su_last_date, $m_fields['su_last_date'], $lang));
    }
    else
    {
		$values[] = '';
    }

    if(isset($m_fields['su_pers_birth']) && $su_pers_birth != 0) // Дата рождения
    {
		$values[] = str_replace('{SU_ID}', $su_id, sb_parse_date($su_pers_birth, $m_fields['su_pers_birth'], $lang));
    }
    else
    {
		$values[] = '';
    }

    switch ($su_status) // Статус активен, не активен, заблокирован и. т. д.
    {
    	case 0:
        {
			$values[] = PL_MAILLIST_EDIT_SU_GET_STATUS_REG;
			break;
		}
        case 1:
		{
			$values[] = PL_MAILLIST_EDIT_SU_GET_STATUS_MOD;
			break;
        }
        case 2:
        {
            $values[] = PL_MAILLIST_EDIT_SU_GET_STATUS_EMAIL;
			break;
		}
        case 3:
        {
            $values[] = PL_MAILLIST_EDIT_SU_GET_STATUS_MOD_EMAIL;
			break;
        }
        case 4:
        {
			$values[] = PL_MAILLIST_EDIT_SU_GET_STATUS_BLOCK;
            break;
        }
        default:
      	$values[] = '';
	}

	$values[] = str_replace($dop_tags, array_merge($dop_values, array(isset($GLOBALS['sb_sex_arr'][SB_CMS_LANG][$su_pers_sex]) ? $GLOBALS['sb_sex_arr'][SB_CMS_LANG][$su_pers_sex] : '')), $m_fields['su_pers_sex']);
    $values[] = $su_last_ip;
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_name)), $m_fields['su_name']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_email)), $m_fields['su_email']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_login)), $m_fields['su_login']);
    $values[] = str_replace(array_merge($dop_tags, array('{IMG_LINK}')), array_merge($dop_values, array('', $su_pers_foto)), $m_fields['su_pers_foto']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_pers_phone)), $m_fields['su_pers_phone']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_pers_mob_phone)), $m_fields['su_pers_mob_phone']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_pers_zip)), $m_fields['su_pers_zip']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_pers_adress)), $m_fields['su_pers_adress']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_pers_addition)), $m_fields['su_pers_addition']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_work_name)), $m_fields['su_work_name']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_work_phone)), $m_fields['su_work_phone']);
    $values[] = str_replace($dop_tags, array_merge($dop_values, array($su_name)), $m_fields['su_work_phone_inner']);
	$values[] = str_replace($dop_tags, array_merge($dop_values, array($su_work_fax)), $m_fields['su_work_fax']);
	$values[] = str_replace($dop_tags, array_merge($dop_values, array($su_work_email)), $m_fields['su_work_email']);
	$values[] = str_replace($dop_tags, array_merge($dop_values, array($su_work_addition)), $m_fields['su_work_addition']);
	$values[] = str_replace($dop_tags, array_merge($dop_values, array($su_work_office_number)), $m_fields['su_work_office_number']);
	$values[] = str_replace($dop_tags, array_merge($dop_values, array($su_work_unit)), $m_fields['su_work_unit']);
	$values[] = str_replace($dop_tags, array_merge($dop_values, array($su_work_position)), $m_fields['su_work_position']);

	// Пол пользователя
	if(isset($m_fields['su_forum_nick']) && $m_fields['su_forum_nick'] != '')
    {
		$values[] = str_replace($dop_tags, array_merge($dop_values, array($su_forum_nick)), $m_fields['su_forum_nick']);
    }
    else
    {
        $values[] = '';
    }

    if(isset($m_fields['su_forum_text']) && $m_fields['su_forum_text'] != '')
    {
		$values[] = str_replace($dop_tags, array_merge($dop_values, array($su_forum_text)), $m_fields['su_forum_text']);
    }
    else
    {
        $values[] = '';
    }

    if(isset($m_fields['su_mail_lang'])&& $m_fields['su_mail_lang'] != '')
    {
        $values[] = str_replace($dop_tags, array_merge($dop_values, array((isset($GLOBALS['sb_site_langs'][$su_mail_lang]) ? $GLOBALS['sb_site_langs'][$su_mail_lang] : ''))), $m_fields['su_mail_lang']);  //  SU_MAIL_LANG
    }
    else
    {
        $values[] = '';
    }

	if(isset($m_fields['su_mail_status']) && $m_fields['su_mail_status'] != '')   //   Статус рассылки
    {
		if($su_mail_status == 0)
			$values[] = str_replace($dop_tags, array_merge($dop_values, array(PL_MAILLIST_EDIT_SU_MAIL_STATUS_ACTIVE)), $m_fields['su_mail_lang']);
		if($su_mail_status == 1)
			$values[] = str_replace($dop_tags, array_merge($dop_values, array(PL_MAILLIST_EDIT_SU_MAIL_STATUS_NO_ACTIVE)), $m_fields['su_mail_lang']);
        if($su_mail_status == 2)
            $values[] = str_replace($dop_tags, array_merge($dop_values, array(PL_MAILLIST_EDIT_SU_MAIL_STATUS_NO_ACTIVE_BY_DATE.' '.sb_date('d.m.Y', $su_mail_date))), $m_fields['su_mail_lang']);
	}
    else
    {
		$values[] = '';
	}

	$str = str_replace($tags, $values, $str);
		return $str;
}


function fMaillist_Cron($maillist_id = 0)
{
//	вытаскиваем пользовательские поля
	$res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident= ? ', 'pl_maillist');

	$m_fields = array();
	$su_fields_temps = array();
	$elems_fields = array();
	$elems_fields_select_sql = '';
	$m_conf_images_attach = 0;

//  массив тегов для поля подписи
	$signed_tags = array('{LINK_UNSUB}');

//	формируем SQL-запрос для пользовательских полей
	if($res)
	{
		if($res[0][0] != '')
		{
			$elems_fields = unserialize($res[0][0]);
		}
		else
	    {
			$elems_fields = array();
		}

		if ($elems_fields)
	    {
	    	foreach ($elems_fields as $value)
	        {
				if (isset($value['sql']) && $value['sql'] == 1)
	            {
					$elems_fields_select_sql .= ', m.user_f_'.$value['id'];
					$signed_tags[] = '{'.$value['tag'].'}';
				}
			}
		}
	}

//	подключаем константы листа рассылки
	include_once(SB_CMS_LANG_PATH.'/pl_maillist.lng.php');
	include_once(SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php');
	$mail = new sbMail();

//	Достаем рассылки, но только те на которые подписаны новости, чтобы потом не было лишних итераций.
	$res = sql_query('SELECT m.m_id, m.m_news_temp_id, m.m_mail_designs, m.m_conf_charset, m.m_conf_email, m.m_conf_signed, m.m_site_users_fields,
							m.m_site_users_custom_fields, m.m_unsub_page, m.m_conf_format, m.m_conf_images_attach, m.m_name
							'.$elems_fields_select_sql.' FROM sb_maillist m, sb_news n
							WHERE m.m_use_default = 1
							'.($maillist_id > 0 ? ' AND m.m_id='.$maillist_id : '').'
							AND CONCAT("|", n.n_ml_ids) LIKE CONCAT("%|", m.m_id, "|%") GROUP BY m.m_id');
	if(!$res)
	{
		return;
	}

	foreach($res as $key => $value)
	{
		list($m_id, $m_news_temp_id, $m_mail_designs, $m_conf_charset, $m_conf_email, $m_conf_signed, $m_fields, $su_fields_temps, $m_unsub_page, $m_conf_format, $m_conf_images_attach, $m_name) = $value;

	    $m_conf_signed = unserialize($m_conf_signed);
	    $m_fields = unserialize($m_fields);
	    $su_fields_temps = unserialize($su_fields_temps);

		$first_key_signed = 'ru';

		$m_unsub_page = isset($m_unsub_page) && $m_unsub_page != '' ? $m_unsub_page.'?ml_unsub_id='.$m_id : '';
		$signed_values = array($m_unsub_page);

		$values = array();
		$m_message = array();
		$m_title = array();

		if(trim($m_mail_designs) != '')
		{
			$m_mail_designs = unserialize($m_mail_designs);
			$m_page_full_news = isset($m_mail_designs['m_page_full_news']) ? $m_mail_designs['m_page_full_news'] : '';
			foreach($m_mail_designs as $key => $value)
			{
				$m_message[$key] = isset($value['m_message']) ? $value['m_message'] : '';
				$m_title[$key] = isset($value['m_title']) ? $value['m_title'] : '';
				$m_page_full_news[$key] = isset($value['m_page_full_news']) ? $value['m_page_full_news'] : '';
			}
		}
		else
		{
			sb_add_system_message(PL_MAILLIST_CRON_NO_FOUND_TEMPS);
			continue;
		}

	    if($m_news_temp_id != '')
			$m_news_temp_id = explode('|', $m_news_temp_id);
		else
			$m_news_temp_id = array();

//		Достаем идентификаторы новостей которые еще не отправлялись, но которые надо отправить в текущей рассылке.
		$news = sql_query('SELECT n_id, cat_id FROM sb_news, sb_categs WHERE CONCAT("|", n_ml_ids) LIKE "%|'.intval($m_id).'|%"
								AND (CONCAT("|", n_ml_ids_sent) NOT LIKE "%|'.intval($m_id).'|%" OR  n_ml_ids_sent IS NULL)
								AND cat_ident="pl_news" AND cat_level=0');
		$root_cat_id = 0;
		if($news)
		{
			$ml_news_ids = array();
			foreach($news as $val)
			{
				$ml_news_ids[] = $val[0];
			}
			$root_cat_id = isset($news[0][1]) ? $news[0][1] : 0;
		}
		else
		{
			sb_add_system_message(PL_MAILLIST_CRON_NO_FOUND_NEWS);
			continue;
		}

		if(count($ml_news_ids) <= 0)
		{
			sb_add_system_message(PL_MAILLIST_CRON_NO_FOUND_NEWS);
			continue;
		}

		if(count($m_news_temp_id) <= 0)
		{
			sb_add_system_message(PL_MAILLIST_CRON_NO_FOUND_NEWS_TEMP);
			continue;
		}

		if(count($m_message) == 0)
		{
			sb_add_system_message(PL_MAILLIST_CRON_NO_FOUND_TEMPS);
			continue;
        }

		$send_count_ok = 0;

		if(count(array_intersect_key($m_message, $m_title)) != count($m_message))
		{
			continue;
		}

		$counter = 0;
		$first_key = '';

		$use_langs = array();
		foreach ($m_message as $key => $value)
		{
			if ($m_message[$key] != ''  && $m_title[$key] == '')
			{
				sb_add_system_message(PL_MAILLIST_MESSAGES_MSG_NO_TITLE);
				continue;
            }

            if ($m_message[$key] == '' && $m_title[$key] != '')
            {
				sb_add_system_message(PL_MAILLIST_MESSAGES_TITLE_NO_MSG);
				continue;
			}

            if ($m_message[$key] == '')
            {
                $counter++ ;
            }
			else
			{
				$use_langs[] = $key;

				if($first_key == '')
                {
					$first_key = $key;
                }
				$counter--;
            }
		}

        if($counter == count($m_message))
        {
			sb_add_system_message(PL_MAILLIST_CRON_NO_FOUND_TEMPS);
			continue;
		}

        if($m_conf_email == '')
        {
            sb_add_system_message(PL_MAILLIST_EDIT_ERROR_NO_EMAIL);
            continue;
        }

        if($m_conf_charset == '')
        {
            sb_add_system_message(PL_MAILLIST_EDIT_ERROR_NO_CHARSET);
            continue;
		}

		foreach ($m_conf_signed as $key => $value)
        {
            if($m_conf_signed[$key] != '')
            {
                $first_key_signed = $key;
                break;
            }
        }

        $mail->setFrom($m_conf_email);  // E-Mail Отправителя
        $mail->setHeadCharset($m_conf_charset); // Кодировка письма

//		Достаем всех активных пользователей подписанных на текущую рассылку
		$res_su = sql_query('SELECT su.su_id, su.su_login, su.su_email, su.su_mail_status, su.su_mail_date, su.su_mail_lang
							FROM sb_site_users su, sb_categs c, sb_catlinks l
							WHERE su.su_id=l.link_el_id
							AND l.link_cat_id = c.cat_id
							AND c.cat_ident = ?
							AND c.cat_rubrik = 1
							AND su.su_status = 0
							AND (su.su_active_date >= ? OR su.su_active_date = ?)
							AND CONCAT(?, su.su_mail_subscription , ?) LIKE ?
							GROUP BY su.su_id', 'pl_site_users', time(), 0, ',', ',', '%,'.$m_id.',%');

		$news_list_arr = array();
		foreach($use_langs as $lang)
		{
			$params = array();
			$params['ids'] = $root_cat_id;
			$params['filter'] = 'all';
			$params['sort1'] = 'n.n_date';
			$params['sort2'] = 'n.n_title';
			$params['sort3'] = '';
			$params['order1'] = 'DESC';
			$params['order2'] = 'DESC';
			$params['order3'] = '';
			$params['subcategs'] = 1;
			$params['rubrikator'] = 0;
			$params['cloud'] = 0;
			$params['calendar'] = 0;
			$params['use_filter'] = 0;
			$params['moderate'] = 1;
			$params['moderate_email'] = '';
			$params['page'] = (isset($m_page_full_news[$lang]) ? $m_page_full_news[$lang] : '');

			$params = addslashes(serialize($params));
			$temp_id = 0;

			foreach($m_news_temp_id as $val)
			{
				if(strpos($val, $lang) !== false)
				{
					$temp_id = substr($val, 4);
					break;
				}
			}

			$news_list_arr[$lang] = fNews_Elem_List('0', $temp_id, $params, '1', $ml_news_ids);
		}

		if($res_su)
		{
//			В этом цикле формируем письмо с новостями и рассылаем подписчикам.
			foreach ($res_su as $key => $value)
			{
				list($su_id, $su_login, $su_email, $su_mail_status, $su_mail_date, $su_mail_lang) = $res_su[$key];

				$news_ids = array(); //	массив идентификаторов новостей которые попали в вывод новостей для рассылки.
				if(!isset($news_list_arr[$su_mail_lang]) || !$news_list_arr[$su_mail_lang])
				{
					sb_add_system_message(PL_MAILLIST_CRON_NO_FOUND_NEWS);
					continue;
				}
				else
				{
					$news_html = explode('||#$', $news_list_arr[$su_mail_lang]);

					$news_ids = unserialize(stripslashes($news_html[1]));
					$news_html = $news_html[0];
				}

                // Если статус активен и имееться e-mail адрес
                if(($su_mail_status == 0 && $su_email != '') || ($su_mail_status == 2 && $su_mail_date <= time()))
                {
					$num = count($res[0]);
					if ($num > 12)
				    {
				    	$signed_val = array();
						for ($in = 12; $in < $num; $in++)
				        {
							$signed_val[] = $res[0][$in];
						}

						include_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

						$values = sbLayout::parsePluginFields($elems_fields, $signed_val, $su_fields_temps, array('{SU_ID}'), array($su_id), $first_key_signed);
						$signed_values  = array_merge($signed_values, $values);
					}

					if(array_key_exists($su_mail_lang, $m_message) && $m_message[$su_mail_lang] != '')
			        {
						$tmp_message = $m_message[$su_mail_lang];
						$tmp_title = $m_title[$su_mail_lang];
			        }
			        else
			        {
						$tmp_message = $m_message[$first_key];
						$tmp_title = $m_title[$first_key];
			        }

			        if($signed_values[0] != '')
			        {
						$signed_values[0] = trim(preg_replace('/ml_unsub=[0-9a-z]+/i'.SB_PREG_MOD, '', $signed_values[0]), '&');
						$signed_values[0] = $signed_values[0].'&ml_unsub='.md5('*##'.$su_id.'##*');
			        }

					if(array_key_exists($su_mail_lang, $m_conf_signed) && $m_conf_signed[$su_mail_lang] != '')
					{
						$tmp_signed = str_replace($signed_tags, $signed_values, $m_conf_signed[$su_mail_lang]);
			        }
					elseif(count($m_conf_signed) > 0 && array_key_exists($first_key_signed, $m_conf_signed))
			        {
						$tmp_signed = str_replace($signed_tags, $signed_values, $m_conf_signed[$first_key_signed]);
			        }
					else
					{
						$tmp_signed = '';
					}

					$tmp = replace_tags($tmp_message, $su_id, $m_fields, $su_fields_temps, (isset($su_mail_lang) ? $su_mail_lang : $first_key))."\n".$tmp_signed;
					$tmp = sb_str_replace('{NEWS_LIST}', $news_html, $tmp);
					$mail->setSubject($tmp_title);   // Тема письма
					
					//	Формат письма 0 - HTML 1 - Текст
					if($m_conf_format == 1)
					{
						$mail->setText($tmp);
						$mail->setTextCharset($m_conf_charset);
					}
		            else	//	Тоже самое для HTML
		            {
						$mail->setHtml($tmp, '', $m_conf_images_attach);
						$mail->setHtmlCharset($m_conf_charset);
					}

					//	Отправляем письмо
					if($mail->send(array($su_email), false))
					{
						$send_count_ok++;
					}
				}
			}

			if($send_count_ok > 0)
			{
				sql_param_query('UPDATE sb_news SET n_ml_ids_sent = IF (n_ml_ids_sent IS NULL, CONCAT(?, "|"), CONCAT(n_ml_ids_sent, ?, "|"))
						WHERE n_id IN (?a) AND (CONCAT("|", n_ml_ids_sent) NOT LIKE "%|'.intval($m_id).'|%" || n_ml_ids_sent IS NULL)', $m_id, $m_id, $news_ids);
			}
		}
		else
		{
			sb_add_system_message(sprintf(PL_MAILLIST_CRON_NO_FOUND_USER, $m_name));
		}
	}
}

?>