<?php
require_once(SB_CMS_LANG_PATH.'/pl_news.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_news', PL_NEWS_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/news.doc'))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_NEWS_H_SUB_MENU.'>'.PL_NEWS_H_PLUGIN_NAME, 'init');
    $_SESSION['sbPlugins']->addToExportImport(true, false);

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_news', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_NEWS_H_PLUGIN_NAME.'>'.PL_NEWS_H_ELEM_LIST, 'design_list', 'pl_news_list_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_NEWS_H_PLUGIN_NAME.'>'.PL_NEWS_H_ELEM_FULLTEXT, 'design_full', 'pl_news_full_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_NEWS_H_PLUGIN_NAME.'>'.PL_NEWS_H_ELEM_CATEGS, 'design_categs', 'pl_news_categs_24.png');
	    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_NEWS_H_PLUGIN_NAME.'>'.PL_NEWS_H_ELEM_SEL_CAT, 'design_sel_cat', 'pl_news_sel_cat_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_NEWS_H_PLUGIN_NAME.'>'.PL_NEWS_H_ELEM_FORM_MENU, 'design_form', 'pl_news_form_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_NEWS_H_PLUGIN_NAME.'>'.PL_NEWS_H_ELEM_FILTER_FORM, 'filter_form', 'pl_news_filter_form_24.png');
	}

	$_SESSION['sbPlugins']->setMainEvent('init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fNews_Init', 'read', PL_NEWS_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fNews_Edit', 'read', PL_NEWS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fNews_Edit_Submit', 'elems_edit', PL_NEWS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('set_active', 'fNews_Set_Active', 'elems_public');
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fNews_Delete', 'elems_delete');
	$_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements', 'fNews_Delete_With_Elements', 'elems_delete');
	$_SESSION['sbPlugins']->addUserEvent('paste', 'fNews_Paste', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fNews_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_list', 'fNews_Design_List', 'design_read', PL_NEWS_H_DESIGN_LIST_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_list_edit', 'fNews_Design_List_Edit', 'design_read', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_list_edit_submit', 'fNews_Design_List_Edit_Submit', 'design_edit', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_list_delete', 'fNews_Design_List_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_full', 'fNews_Design_Full', 'design_read', PL_NEWS_H_DESIGN_FULL_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_full_edit', 'fNews_Design_Full_Edit', 'design_read', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_full_edit_submit', 'fNews_Design_Full_Edit_Submit', 'design_edit', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_full_delete', 'fNews_Design_Full_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_categs', 'fNews_Design_Categs', 'design_read', PL_NEWS_H_DESIGN_CATEGS_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_categs_edit', 'fNews_Design_Categs_Edit', 'design_read', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_categs_edit_submit', 'fNews_Design_Categs_Edit_Submit', 'design_edit', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_categs_delete', 'fNews_Design_Categs_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_sel_cat', 'fNews_Design_Selcat', 'design_read', PL_NEWS_H_DESIGN_SEL_CAT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_sel_cat_edit', 'fNews_Design_Selcat_Edit', 'design_read', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_sel_cat_edit_submit', 'fNews_Design_Selcat_Edit_Submit', 'design_edit', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_sel_cat_delete', 'fNews_Design_Selcat_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_form', 'fNews_Design_Form', 'design_read', PL_NEWS_H_DESIGN_FORM_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_form_edit', 'fNews_Design_Form_Edit', 'design_read', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_form_submit', 'fNews_Design_Form_Edit_Submit', 'design_edit', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_form_delete', 'fNews_Design_Form_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('filter_form', 'fNews_Design_Filter_Form', 'design_read', PL_NEWS_H_DESIGN_FILTER_FORM_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('filter_form_edit', 'fNews_Design_Filter_Form_Edit', 'design_read', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('filter_form_submit', 'fNews_Design_Filter_Form_Edit_Submit', 'design_edit', PL_NEWS_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('filter_form_delete', 'fNews_Design_Filter_Form_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addToConstructor('sb_news');
	$_SESSION['sbPlugins']->addToCache();
	$_SESSION['sbPlugins']->addToWorkflow();
	$_SESSION['sbPlugins']->addToComments('sb_news', 'n_id', 'n_title', 'n_url');

	$fields = array();
	$fields['n_id'] = array('title' => PL_NEWS_H_ID_LABEL, 'flags' => '8', 'link_title' => '1', 'tag' => '');
	$fields['n_title'] = array('title' => PL_NEWS_H_TITLE_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_N_TITLE}');
	$fields['n_date'] = array('title' => PL_NEWS_H_DATE_LABEL, 'flags' => '9', 'link_title' => '1', 'tag' => '{OPT_STD_N_DATE}');
	$fields['n_short'] = array('title' => PL_NEWS_H_SHORT_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
	$fields['n_short_foto'] = array('title' => PL_NEWS_H_S_FOTO_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
	$fields['n_full'] = array('title' => PL_NEWS_H_FULL_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
	$fields['n_full_foto'] = array('title' => PL_NEWS_H_F_FOTO_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
	$fields['n_pub_start'] = array('title' => PL_NEWS_H_PUB_START_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
	$fields['n_pub_end'] = array('title' => PL_NEWS_H_PUB_END_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
	$fields['n_active'] = array('title' => PL_NEWS_H_ACTIVE_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['n_url'] = array('title' => PL_NEWS_H_URL_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_N_URL}');
	$fields['n_sort'] = array('title' => PL_NEWS_H_SORT_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['n_ext_id'] = array('title' => PL_NEWS_H_EXT_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['n_user_id'] = array('title' => PL_NEWS_H_USERS_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['n_ml_ids'] = array('title' => PL_NEWS_H_ML_IDS_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
	$fields['n_ml_ids_sent'] = array('title' => PL_NEWS_H_ML_IDS_SENT_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');

	$cat_fields = array();
	$cat_fields['categs_moderate_email'] = array('title' => PL_NEWS_H_CAT_EMAILS_LABEL, 'flags' => '4');
	$cat_fields['moderates_list'] = array('title' => PL_NEWS_H_CAT_LIST_LABEL, 'flags' => '20');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_news', 'n_id', 'n_title', $fields, $cat_fields);
}

$_SESSION['sbPlugins']->addToRubrikator('pl_news', PL_NEWS_H_PLUGIN_NAME, 'news', 'pl_news_design_categs', 'pl_news_design_sel_cat');
$_SESSION['sbPlugins']->addToCalendar('list', 'fNews_Get_Calendar', 'pl_news/prog/pl_news.php', array('n_date' => PL_NEWS_H_CALENDAR_DATE));

$_SESSION['sbPlugins']->addSystemEvent('elem_list', 'fNews_Get_Elem_List', PL_NEWS_H_ELEM_LIST);
$_SESSION['sbPlugins']->addSystemEvent('elem_full', 'fNews_Get_Elem_Full', PL_NEWS_H_ELEM_FULLTEXT);
$_SESSION['sbPlugins']->addSystemEvent('elem_categs', 'fNews_Get_Elem_Categs', PL_NEWS_H_ELEM_CATEGS);
$_SESSION['sbPlugins']->addSystemEvent('elem_sel_cat', 'fNews_Get_Elem_Sel_Cat', PL_NEWS_H_ELEM_SEL_CAT);
$_SESSION['sbPlugins']->addSystemEvent('elem_cloud', 'fNews_Get_Elem_Cloud', PL_NEWS_H_ELEM_CLOUD);
$_SESSION['sbPlugins']->addSystemEvent('elem_rss', 'fNews_Get_Elem_Rss', PL_NEWS_H_ELEM_RSS);
$_SESSION['sbPlugins']->addSystemEvent('elem_form', 'fNews_Get_Elem_Form', PL_NEWS_H_ELEM_FORM);
$_SESSION['sbPlugins']->addSystemEvent('elem_form_edit', 'fNews_Get_Elem_Form_Edit', PL_NEWS_H_ELEM_FORM_EDIT);
$_SESSION['sbPlugins']->addSystemEvent('elem_filter', 'fNews_Get_Elem_Filter_Form', PL_NEWS_H_ELEM_FILTER_FORM);
$_SESSION['sbPlugins']->addSystemEvent('fb_get_access_token', 'fNews_Facebook_Get_Access_Token', PL_NEWS_H_FB_GET_ACCESS_TOKEN);
$_SESSION['sbPlugins']->addSystemEvent('fb_save_access_token', 'fNews_Facebook_Save_Access_Token', '');
$_SESSION['sbPlugins']->addSystemEvent('elem_list_components', 'fNews_Get_Elem_Components');

$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_LIST, 'list', 'fNews_Elem_List_Prog', 'fNews_Elem_List_Info', 'elem_list', 800, 700, 'design_list_edit', 'pl_news_list', 'init');
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_FULLTEXT, 'full', 'fNews_Elem_Full_Prog', 'fNews_Elem_Full_Info', 'elem_full', 800, 720, 'design_full_edit', 'pl_news_full');
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_TITLE_HTML, 'header_html', 'fNews_Elem_Header_Html_Prog');
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_TITLE_PLAIN, 'header_plain', 'fNews_Elem_Header_Plain_Prog');
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_CATEGS, 'categs', 'fNews_Elem_Categs_Prog', 'fNews_Elem_Categs_Info', 'elem_categs', 800, 700, 'design_categs_edit', 'pl_news_design_categs');
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_SEL_CAT, 'sel_cat', 'fNews_Elem_Sel_Cat_Prog', 'fNews_Elem_Sel_Cat_Info', 'elem_sel_cat', 800, 360, 'design_sel_cat_edit', 'pl_news_design_sel_cat');
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_CLOUD, 'cloud', 'fNews_Elem_Cloud_Prog', 'fNews_Elem_Cloud_Info', 'elem_cloud', 800, 700);
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_RSS, 'rss', 'fNews_Elem_Rss_Prog', 'fNews_Elem_Rss_Info', 'elem_rss', 800, 700);
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_FORM, 'form', 'fNews_Elem_Form_Prog', 'fNews_Elem_Form_Info', 'elem_form', 800, 700, 'design_form_edit', 'pl_news_form');
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_FORM_EDIT, 'form_edit', 'fNews_Elem_Form_Prog', 'fNews_Elem_Form_Info', 'elem_form_edit', 800, 700, 'design_form_edit', 'pl_news_form');
$_SESSION['sbPlugins']->addElem(PL_NEWS_H_ELEM_FILTER_FORM, 'filter', 'fNews_Elem_Filter_Form_Prog', 'fNews_Elem_Filter_Form_Info', 'elem_filter', 800, 300, 'filter_form_edit', 'pl_news_filter');

$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_news_delim', PL_NEWS_H_PLUGIN_NAME, '', '', '', SB_COOKIE_DOMAIN, false);

$options = array();
$options['0'] = PL_NEWS_H_SETTING_USE_DELIM_DEFAULT;
$res = sql_query('SELECT categs.cat_title, temps.pt_id, temps.pt_title FROM sb_categs categs, sb_catlinks links, sb_pager_temps temps WHERE temps.pt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.pt_title', 'pl_pager_temps');
if ($res)
{
    $old_cat_title = '';
    foreach ($res as $value)
    {
        list($cat_title, $pt_id, $pt_title) = $value;
        if ($old_cat_title != $cat_title)
        {
			$options['-'.uniqid()] = '-'.$cat_title;
			$old_cat_title = $cat_title;
		}
		$options[$pt_id] = $pt_title;
	}
}
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_news_use_delim', PL_NEWS_H_SETTING_USE_DELIM, 'select', $options, '0', SB_COOKIE_DOMAIN, false);


$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_label', PL_NEWS_H_SETTING_TWITTER_LABEL, '', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_descr_delim', PL_NEWS_H_SETTING_TWITTER_DELIM, '', '', '', SB_COOKIE_DOMAIN, false);

$options = array();
$options['0'] = PL_NEWS_H_SETTING_TWITTER_MANUAL;
$options['3'] = PL_NEWS_H_SETTING_TWITTER_TITLE;
$options['1'] = PL_NEWS_H_SETTING_TWITTER_USE;
$options['2'] = PL_NEWS_H_SETTING_TWITTER_USE_FULL;

$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_use', PL_NEWS_H_SETTING_TWITTER, 'select', $options, '0', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_url', PL_NEWS_H_SETTING_TWITTER_URL, 'string', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_consumer_key', PL_NEWS_H_SETTING_TWITTER_CONSUMER_KEY, 'password', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_consumer_secret', PL_NEWS_H_SETTING_TWITTER_CONSUMER_SECRET, 'password', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_access_token', PL_NEWS_H_SETTING_TWITTER_ACCESS_TOKEN, 'password', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_access_token_secret', PL_NEWS_H_SETTING_TWITTER_ACCESS_TOKEN_SECRET, 'password', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_delim', PL_NEWS_H_SETTING_TWITTER_BITLY_DESCR, '', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_bit_ly_login', PL_NEWS_H_SETTING_TWITTER_BITLY_LOGIN, 'string', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_twitter_bit_ly_key', PL_NEWS_H_SETTING_TWITTER_BITLY_KEY, 'password', '', '', SB_COOKIE_DOMAIN, false);

$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_facebook_label', PL_NEWS_H_SETTING_FACEBOOK_LABEL, '', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_facebook_descr_delim', sprintf(PL_NEWS_H_SETTING_FACEBOOK_DELIM, SB_DOMAIN, SB_COOKIE_DOMAIN), '', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_facebook_use', PL_NEWS_H_SETTING_FACEBOOK, 'select', $options, '0', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_facebook_url', PL_NEWS_H_SETTING_FACEBOOK_URL, 'string', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_facebook_application_id', PL_NEWS_H_SETTING_FACEBOOK_APPLICATION_ID, 'string', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_facebook_application_secret', PL_NEWS_H_SETTING_FACEBOOK_APPLICATION_SECRET, 'password', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_facebook_profile_id', PL_NEWS_H_SETTING_FACEBOOK_PROFILE_ID, 'string', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_facebook_page_id', PL_NEWS_H_SETTING_FACEBOOK_PAGE_ID, 'string', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_facebook_access_token', '', 'hidden', '', '', SB_COOKIE_DOMAIN, false);


$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_lj_label', PL_NEWS_H_SETTING_LJ_LABEL, '', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_lj_use', PL_NEWS_H_SETTING_LJ, 'select', $options, '0', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_lj_url', PL_NEWS_H_SETTING_LJ_URL, 'string', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_lj_login', PL_NEWS_H_SETTING_LJ_LOGIN, 'string', '', '', SB_COOKIE_DOMAIN, false);
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_SOCIAL_MEDIAS, 'sb_news_lj_password', PL_NEWS_H_SETTING_LJ_PASSWORD, 'password', '', '', SB_COOKIE_DOMAIN, false);

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);

?>