<?php
/********************************** функции построения диалоговых окон ***********************************/

/**
 * Вывод новостной ленты
 */
function fNews_Get_Elem_List()
{
    $params = unserialize($_GET['params']);

    if (!isset($params['use_filter']))
    	$params['use_filter'] = 0;

    if (!isset($params['filter']))
        $params['filter'] = 'all';

    if (!isset($params['subcategs']))
    	$params['subcategs'] = 1;

    if (!isset($params['rubrikator']))
    	$params['rubrikator'] = 1;

    if (!isset($params['cloud']))
    	$params['cloud'] = 0;

    if (!isset($params['calendar']))
    	$params['calendar'] = 0;

    if (!isset($params['calendar_field']))
    	$params['calendar_field'] = 'n_date';

    if (!isset($params['filter_compare']))
    	$params['filter_compare'] = 'IN';
    if(!isset($params['registred_users_edit_link']))
    	$params['registred_users_edit_link'] = 1;
    
    if(!isset($params['cache_not_url']))
    {
        $params['cache_not_url'] = 0;
    }
    
    if(!isset($params['cache_not_get']))
    {
        $params['cache_not_get'] = 0;
    }
    
    if(!isset($params['cache_not_get_list']))
    {
        $params['cache_not_get_list'] = '';
    }
    
    if(!isset($params['use_component_cache']))
    {
        $params['use_component_cache'] = 0;
    }

    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_NEWS_H_ELEM_LIST_NO_CATEGS_MSG.'");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_NEWS_H_ELEM_LIST_NO_TEMPS_ALERT.'");
                return;
            }

            if (sbGetE("calendar").checked && sbGetE("calendar_field").value == "")
            {
            	alert("'.PL_NEWS_H_ELEM_LIST_NO_CALENDAR_FIELD_ALERT.'");
            	return;
            }

            var r_filter_all = sbGetE("r_filter_all");
            var r_filter_last = sbGetE("r_filter_last");
            var r_filter_next = sbGetE("r_filter_next");
            var r_filter_from_to = sbGetE("r_filter_from_to");

            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }
            else if (r_filter_last.checked)
            {
                params["filter"] = r_filter_last.value;
                var el_filter_last = sbGetE("spin_filter_last");
                params["filter_last"] = el_filter_last.value;
            }
            else if (r_filter_next.checked)
            {
                params["filter"] = r_filter_next.value;
                var el_filter_next = sbGetE("spin_filter_next");
                params["filter_next"] = el_filter_next.value;
            }
            else if (r_filter_from_to.checked)
            {

                params["filter"] = r_filter_from_to.value;
                var el_filter_from = sbGetE("spin_filter_from");
                var el_filter_to = sbGetE("spin_filter_to");

                if (el_filter_to.value != "" && el_filter_to.value != 0 && parseInt(el_filter_from.value) > parseInt(el_filter_to.value))
                {
                    alert("'.PL_NEWS_H_ELEM_LIST_FILTER_FROM_TO_ERROR.'");
                    return;
                }

                params["filter_from"] = el_filter_from.value;
                params["filter_to"] = el_filter_to.value;
            }

            var el_sort1 = sbGetE("sort1");
            var el_order1 = sbGetE("order1");
            var el_sort2 = sbGetE("sort2");
            var el_order2 = sbGetE("order2");
            var el_sort3 = sbGetE("sort3");
            var el_order3 = sbGetE("order3");

            params["sort1"] = el_sort1.value;
            params["sort2"] = el_sort2.value;
            params["sort3"] = el_sort3.value;

            params["order1"] = el_order1.disabled ? "" : el_order1.value;
            params["order2"] = el_order2.disabled ? "" : el_order2.value;
            params["order3"] = el_order3.disabled ? "" : el_order3.value;

            params["allow_bbcode"] = sbGetE("allow_bbcode").checked ? 1 : 0;
            params["use_sort"] = sbGetE("use_sort").checked ? 1 : 0;

            params["page"] = sbGetE("page").value;
            params["auth_page"] = sbGetE("auth_page").value;
            params["edit_page"] = sbGetE("edit_page").value;
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["show_hidden"] = sbGetE("show_hidden").checked ? 1 : 0;
            params["show_selected"] = sbGetE("show_selected").checked ? 1 : 0;
            params["rubrikator"] = sbGetE("rubrikator").checked ? 1 : 0;
            params["cloud"] = sbGetE("cloud").checked ? 1 : 0;
			params["cloud_comp"] = sbGetE("cloud_comp").checked ? 1 : 0;
            params["calendar"] = sbGetE("calendar").checked ? 1 : 0;
            params["calendar_field"] = sbGetE("calendar_field").value;

			params["registred_users"] = sbGetE("registred_users").checked ? 1 : 0;
            params["use_filter"] = sbGetE("use_filter").checked ? 1 : 0;
            params["filter_logic"] = sbGetE("filter_logic").value;
            params["filter_text_logic"] = sbGetE("filter_text_logic").value;
            params["filter_compare"] = sbGetE("filter_compare").value;
            params["filter_morph"] = sbGetE("filter_morph").checked ? 1 : 0;
            params["registred_users_edit_link"] = sbGetE("registred_users_edit_link").checked ? 1 : 0;

            params["moderate"] = (sbGetE("moderate").checked ? 1 : 0);
            params["moderate_email"] = sbGetE("moderate_email").value;
            
            params["use_component_cache"] = (sbGetE("use_component_cache").checked ? 1 : 0);
            params["cache_not_url"] = (sbGetE("cache_not_url").checked ? 1 : 0);
            params["cache_not_get"] = (sbGetE("cache_not_get").checked ? 1 : 0);
            params["cache_not_get_list"] = sbGetE("cache_not_get_list").value;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }

        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }

        function changeCalendarField(el)
        {
            sbGetE("calendar_field").disabled = !el.checked;
        }

        function changeFilterMorph(el)
        {
            sbGetE("filter_morph").disabled = (el.value != "IN");
        }

        function changeUseFilter(el)
        {
        	sbGetE("filter_morph").disabled = !el.checked || sbGetE("filter_compare").value != "IN";
        	sbGetE("filter_logic").disabled = !el.checked;
        	sbGetE("filter_text_logic").disabled = !el.checked;
        	sbGetE("filter_compare").disabled = !el.checked;
        }
        
        function showHideGETList(checked)
        {
            if(checked)
            {
                sbGetE("cache_not_get_list").disabled = false;
            }
            else
            {
                sbGetE("cache_not_get_list").disabled = true;
            }
        }
        
        function showHideCacheParams(checked)
        {
            if(!checked)
            {
                sbGetE("cache_not_url").disabled = false;
                var get = sbGetE("cache_not_get");
                get.disabled = false;
                if(get.checked)
                    sbGetE("cache_not_get_list").disabled = false;
            }
            else
            {
                sbGetE("cache_not_url").disabled = true;
                sbGetE("cache_not_get").disabled = true;
                sbGetE("cache_not_get_list").disabled = true;
            }
        }
    </script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_NEWS_H_ELEM_LIST_CATEGS_TAB);

    $categs = new sbJustCategs('pl_news');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_NEWS_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_PROPS_TAB);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.ndl_id, temps.ndl_title FROM sb_categs categs, sb_catlinks links, sb_news_temps_list temps WHERE temps.ndl_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.ndl_title', 'pl_news_list');
    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $ndl_id, $ndl_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$ndl_id] = $ndl_title;
        }
    }

    if (count($options) > 0)
    {
    	$fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
			$fld->mSelOptions = array($_GET['temp_id']);
        }
    }
	else
    {
		$fld = new sbLayoutLabel('<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_NO_TEMPS_MSG.'</div>', '', '', false);
    }

    $layout->addField(PL_NEWS_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_PAGE_HINT.'</div>';
    $layout->addField(PL_NEWS_H_ELEM_LIST_PAGE, $fld);

    $fld = new sbLayoutPage(isset($params['auth_page']) ? $params['auth_page'] : '', 'auth_page', '', 'style="width: 450px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_PAGE_HINT_LIST.'</div>';
    $layout->addField(PL_NEWS_H_ELEM_LIST_AUTH_PAGE, $fld);

    //Инпут для странички вывода формы редактирования
	$fld = new sbLayoutPage(isset($params['edit_page']) ? $params['edit_page'] : '', 'edit_page', '', 'style="width: 450px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_PAGE_HINT_EDIT.'</div>';
    $layout->addField(PL_NEWS_H_ELEM_LIST_EDIT_PAGE, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fields = sbPlugins::getSortFields('pl_news');

	$calendar_fields = array('' => ' --- ');
   	foreach ($_SESSION['sbPlugins']->mCalendar['pl_news_list']['date_fields'] as $key => $value)
   	{
   		$calendar_fields[$key] = $value;
   	}

    $res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident=?', 'pl_news');
    if ($res)
    {
        list($pd_fields) = $res[0];

        if ($pd_fields != '')
        {
	        $pd_fields = unserialize($pd_fields);

	        foreach($pd_fields as $value)
	        {
	            if ($value['type'] == 'string' ||
	                $value['type'] == 'number' ||
	                $value['type'] == 'date' ||
	                $value['type'] == 'checkbox' ||
	                $value['type'] == 'image' ||
	                $value['type'] == 'link' ||
	                $value['type'] == 'file' ||
	                $value['type'] == 'color' ||
	                $value['type'] == 'select_sprav' ||
	                $value['type'] == 'radio_sprav' ||
	                $value['type'] == 'select_plugin' ||
	                $value['type'] == 'radio_plugin' ||
	                $value['type'] == 'elems_plugin')
	            {
	                $fields['n.user_f_'.$value['id']] = $value['title'];

	                if ($value['type'] == 'date')
	                {
	                    $calendar_fields['user_f_'.$value['id']] = $value['title'];
	                }
	            }
	        }
        }
    }

    $order = array('DESC' => PL_NEWS_H_ELEM_LIST_SORT_DESC,
                   'ASC'  => PL_NEWS_H_ELEM_LIST_SORT_ASC);

    $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
    $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'n.n_date'));
    $fld2 = new sbLayoutSelect($order, 'order1');
    $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_NEWS_H_ELEM_LIST_SORT_FIELD.' 1', $fld1);
    $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
    $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order2');
    $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_NEWS_H_ELEM_LIST_SORT_FIELD.' 2', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
    $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order3');
    $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_NEWS_H_ELEM_LIST_SORT_FIELD.' 3', $fld1);

    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_NEWS_H_ELEM_LIST_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_NEWS_H_ELEM_LIST_SHOW_HIDDEN, new sbLayoutInput('checkbox', '1', 'show_hidden', '', (isset($params['show_hidden']) && $params['show_hidden'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_NEWS_H_ELEM_LIST_SHOW_SELECTED, new sbLayoutInput('checkbox', '1', 'show_selected', '', (isset($params['show_selected']) && $params['show_selected'] == 1 ? 'checked="checked"' : '')));

    $fld = new sbLayoutInput('checkbox', '1', '', 'registred_users', (isset($params['registred_users']) && $params['registred_users'] == 1 ? 'checked="checked"' : '') );
	$fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_OUTPUT_USERS_NEWS_LABEL.'</div>';
	$layout->addField(PL_NEWS_H_ELEM_OUTPUT_USERS_NEWS, $fld);

	$fld = new sbLayoutInput('checkbox', '1', '', 'registred_users_edit_link', ($params['registred_users_edit_link'] == 1 ? 'checked="checked"' : ''));
	$fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_OUTPUT_EDIT_LINK_USERS_NEWS_LABEL.'</div>';
	$layout->addField(PL_NEWS_H_ELEM_OUTPUT_EDIT_LINK_USERS_NEWS, $fld);

	$layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_NEWS_H_ELEM_LIST_RUBRIK_LINK, new sbLayoutInput('checkbox', '1', 'rubrikator', '', (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? 'checked="checked"' : '')));

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_NEWS_H_ELEM_LIST_CLOUD_LINK, new sbLayoutInput('checkbox', '1', 'cloud', '', (isset($params['cloud']) && $params['cloud'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_NEWS_H_ELEM_LIST_CLOUD_COMP_LINK, new sbLayoutInput('checkbox', '1', 'cloud_comp', '', (isset($params['cloud_comp']) && $params['cloud_comp'] == 1 ? 'checked="checked"' : '')));

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_NEWS_H_ELEM_LIST_CALENDAR_LINK, new sbLayoutInput('checkbox', '1', 'calendar', '', (isset($params['calendar']) && $params['calendar'] == 1 ? 'checked="checked"' : '').' onclick="changeCalendarField(this)"'));

    $fld = new sbLayoutSelect($calendar_fields, 'calendar_field', '', (!isset($params['calendar']) || $params['calendar'] != 1 ? 'disabled="disabled"' : ''));
    $fld->mSelOptions = array((isset($params['calendar_field']) && $params['calendar_field'] != '' ? $params['calendar_field'] : ''));
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_CALENDAR_FIELD_HINT.'</div>';
    $layout->addField(PL_NEWS_H_ELEM_LIST_CALENDAR_FIELD, $fld);

    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_NEWS_H_ELEM_PREMOD_COMMENTS, new sbLayoutInput('checkbox', 'moderate', '1', 'moderate', (isset($params['moderate']) && $params['moderate'] == 1 ? 'checked="checked"' : '')));
    //Разрешать bb коды
    $fld = new sbLayoutInput('checkbox', '0', '', 'allow_bbcode', (isset($params['allow_bbcode']) && $params['allow_bbcode'] == 1 ? 'checked="checked"' : '') );
	$layout->addField(PL_NEWS_H_ELEM_ALLOW_BB, $fld);

    $layout->addField(PL_NEWS_H_ELEM_MODER_EMAIL, new sbLayoutInput('text', (isset($params['moderate_email']) ? $params['moderate_email'] : ''), 'moderate_email', 'moderate_email', 'style="width:400px;"'));

    $layout->addTab(PL_NEWS_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_FILTER_TAB);

    $layout->addField(PL_NEWS_H_ELEM_LIST_USE_FILTER, new sbLayoutInput('checkbox', '1', 'use_filter', '', (isset($params['use_filter']) && $params['use_filter'] == 1 ? 'checked="checked"' : '').' onclick="changeUseFilter(this)"'));

    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_logic');
    $fld->mSelOptions = array((isset($params['filter_logic']) && $params['filter_logic'] != '' ? $params['filter_logic'] : ''));
    $layout->addField(PL_NEWS_H_ELEM_LIST_FILTER_LOGIC, $fld);

    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_text_logic');
    $fld->mSelOptions = array((isset($params['filter_text_logic']) && $params['filter_text_logic'] != '' ? $params['filter_text_logic'] : ''));

    $fld1 = new sbLayoutSelect(array('EQ' => PL_NEWS_H_ELEM_LIST_FILTER_TEXT_LOGIC_EQ, 'IN' => PL_NEWS_H_ELEM_LIST_FILTER_TEXT_LOGIC_IN), 'filter_compare', '', 'onchange="changeFilterMorph(this);"');
    $fld1->mSelOptions = array((isset($params['filter_compare']) && $params['filter_compare'] != '' ? $params['filter_compare'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;<input type="checkbox" value="1" id="filter_morph"'.(isset($params['filter_morph']) && $params['filter_morph'] == 1 ? ' checked="checked"' : '').(isset($params['filter_compare']) && $params['filter_compare'] != 'IN' ? ' disabled="disabled"' : '').' />&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_MORPH;
    $fld->mHTML = '&nbsp;&nbsp;'.$fld1->getField();

    $layout->addField(PL_NEWS_H_ELEM_LIST_FILTER_TEXT_LOGIC, $fld);

    $layout->addField('', new sbLayoutDelim());

    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_ALL;
    $html .= $fld1->getField().'<br /><br />';

    $fld2 = new sbLayoutInput('radio', 'last', 'filter', 'r_filter_last', ($params['filter'] == 'last' ? ' checked="checked"' : ''));
    $fld2_1 = new sbLayoutInput('input', (isset($params['filter_last']) ? $params['filter_last'] : ''), 'filter_last', 'spin_filter_last', 'style="width: 50px;"');
    $fld2_1->mMinValue = 1;
    $html .= $fld2_1->getJavaScript().'<table cellpadding="0" cellspacing="0"><tr><td>'.$fld2->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_LAST.'&nbsp;&nbsp;</td><td>'.$fld2_1->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_DAYS.'</td></tr></table><br />';

    $fld4 = new sbLayoutInput('radio', 'next', 'filter', 'r_filter_next', ($params['filter'] == 'next' ? ' checked="checked"' : ''));
    $fld4_1 = new sbLayoutInput('input', (isset($params['filter_next']) ? $params['filter_next'] : ''), 'filter_next', 'spin_filter_next', 'style="width: 50px;"');
    $fld4_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>'.$fld4->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_NEXT.'&nbsp;&nbsp;</td><td>'.$fld4_1->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_DAYS.'</td></tr></table><br />';

    $fld3 = new sbLayoutInput('radio', 'from_to', 'filter', 'r_filter_from_to', ($params['filter'] == 'from_to' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutInput('input', (isset($params['filter_from']) ? $params['filter_from'] : ''), 'filter_from', 'spin_filter_from', 'style="width: 50px;"');
    $fld3_2 = new sbLayoutInput('input', (isset($params['filter_to']) ? $params['filter_to'] : ''), 'filter_to', 'spin_filter_to', 'style="width: 50px;"');
    $fld3_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>'.$fld3->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld3_1->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld3_2->getField().'</td></tr></table>
              <div class="hint_div">'.PL_NEWS_H_ELEM_LIST_FILTER_FROM_TO_HINT.'</div>';

    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_NEWS_H_ELEM_LIST_FILTER, $fld);

    //Использовать сортировку
    $layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_NEWS_H_ELEM_USE_SORT, new sbLayoutInput('checkbox', '0', '', 'use_sort', (isset($params['use_sort']) && $params['use_sort'] == 1 ? 'checked="checked"' : '')));

    //Кеширование
    $layout->addTab(PL_NEWS_H_ELEM_LIST_CACHE_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_CACHE_TAB);
    
    $layout->addField(PL_NEWS_H_ELEM_LIST_USE_COMPONENT_CACHE, new sbLayoutInput('checkbox', '1', 'use_component_cache', '', ($params['use_component_cache'] == 1 ? 'checked="checked"' : '').' onclick=showHideCacheParams(this.checked)'));
    
    $layout->addField(PL_NEWS_H_ELEM_LIST_NOT_URL, new sbLayoutInput('checkbox', '1', 'cache_not_url', '', ($params['cache_not_url'] == 1 ? 'checked="checked"' : '').' '.($params['use_component_cache'] == 0 ? '' : 'disabled="disabled"')));
    $layout->addField(PL_NEWS_H_ELEM_LIST_NOT_GET, new sbLayoutInput('checkbox', '1', 'cache_not_get', '', ($params['cache_not_get'] == 1 ? 'checked="checked"' : '').' '.($params['use_component_cache'] == 0 ? '' : 'disabled="disabled"').' onclick=showHideGETList(this.checked)'));
    
    $fld = new sbLayoutInput('text', $params['cache_not_get_list'], 'cache_not_get_list', 'cache_not_get_list', (($params['cache_not_get'] == 0 || $params['use_component_cache'] == 1) ? 'disabled="disabled" ' : '').'style="width:400px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_NOT_GET_LIST_HINT.'</div>';
    $layout->addField(PL_NEWS_H_ELEM_LIST_NOT_GET_LIST, $fld);
    
	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show();
}

/**
 * Вывод полного текста новости
 *
 */
function fNews_Get_Elem_Full()
{
    $params = unserialize($_GET['params']);

    if(!isset($params['registred_users_edit_link']))
    	$params['registred_users_edit_link'] = 1;
    if(!isset($params['cache_not_url']))
    {
        $params['cache_not_url'] = 0;
    }
    
    if(!isset($params['cache_not_get']))
    {
        $params['cache_not_get'] = 0;
    }
    
    if(!isset($params['cache_not_get_list']))
    {
        $params['cache_not_get_list'] = '';
    }
    
    if(!isset($params['use_component_cache']))
    {
        $params['use_component_cache'] = 0;
    }

    echo '<script>
        function choose()
        {
			var res = new Object();
            var params = new Array();

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
				alert("'.PL_NEWS_H_ELEM_FULL_NO_TEMPS_ALERT.'");
				return;
            }

            params["moderate"] = (sbGetE("moderate").checked ? 1 : 0);
            params["moderate_email"] = sbGetE("moderate_email").value;
			params["registred_users"] = sbGetE("registred_users").checked ? 1 : 0;
			params["allow_bbcode"] = sbGetE("allow_bbcode").checked ? 1 : 0;
			params["registred_users_edit_link"] = sbGetE("registred_users_edit_link").checked ? 1 : 0;
			params["component"] = sbGetE("component").value;
            var el_page = sbGetE("page");
            if(el_page)
            {
            	params["page"] = el_page.value;
			}
            else
            {
            	params["page"] = "";
			}

            params["auth_page"] = sbGetE("auth_page").value;
            params["edit_page"] = sbGetE("edit_page").value;
            params["component"] = sbGetE("component").value;
            
            params["use_component_cache"] = (sbGetE("use_component_cache").checked ? 1 : 0);
            params["cache_not_url"] = (sbGetE("cache_not_url").checked ? 1 : 0);
            params["cache_not_get"] = (sbGetE("cache_not_get").checked ? 1 : 0);
            params["cache_not_get_list"] = sbGetE("cache_not_get_list").value;
            
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

			sbReturnValue(res);
		}
		function getPageComponents()
        {
        	var p_url = sbGetE("page").value;
            p_url = p_url.split("&");

			var comp_el = sbGetE("component");
			while (comp_el.childNodes.length > 1)
                comp_el.removeChild(comp_el.childNodes[1]);

            var res = sbLoadSync(sb_cms_empty_file + "?event=pl_news_elem_list_components&p_url=" + p_url[0]);
            if (res)
            {
                comp_el.remove(0);
                res = eval("(" + res + ")");

                for(var i = 0; i < res.keys.length; i++)
            	{
            	    var oOption = document.createElement("OPTION");

            	    comp_el.appendChild(oOption);
                    oOption.value = res.keys[i];
                    oOption.innerHTML = res.values[i];
            	}
            }
        }
        function showHideGETList(checked)
        {
            if(checked)
            {
                sbGetE("cache_not_get_list").disabled = false;
            }
            else
            {
                sbGetE("cache_not_get_list").disabled = true;
            }
        }
        
        function showHideCacheParams(checked)
        {
            if(!checked)
            {
                sbGetE("cache_not_url").disabled = false;
                var get = sbGetE("cache_not_get");
                get.disabled = false;
                if(get.checked)
                    sbGetE("cache_not_get_list").disabled = false;
            }
            else
            {
                sbGetE("cache_not_url").disabled = true;
                sbGetE("cache_not_get").disabled = true;
                sbGetE("cache_not_get_list").disabled = true;
            }
        }
	</script><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    
    $layout->addTab(PL_NEWS_H_ELEM_BASIC_TAB);
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '250';
    $layout->addHeader(PL_NEWS_H_ELEM_FULLTEXT);

    $res = sql_query('SELECT categs.cat_title, temps.ntf_id, temps.ntf_title FROM sb_categs categs, sb_catlinks links, sb_news_temps_full temps WHERE temps.ntf_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.ntf_title', 'pl_news_full');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }

        $fld = new sbLayoutSelect($options, 'temp_id');
        if(isset($params['temp_id']))
        	$fld->mSelOptions = array($params['temp_id']);

        $layout->addField(PL_NEWS_H_ELEM_TEMP, $fld);
    }
	else
	{
	    $layout->addField(PL_NEWS_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_NEWS_H_ELEM_FULL_NO_TEMPS_MSG.'</div>', '', '', false));
	}

	$layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;" onchange="getPageComponents()"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_PAGE_HINT_LIST.'</div>';
    $layout->addField(PL_NEWS_H_ELEM_LIST_PAGE_LIST, $fld);

    $components = array('' => ' --- ');
    if (isset($params['page']) && $params['page'] != '')
    {
    	$components = sb_get_elem_components($params['page'], 'pl_news_list', 'php');
    }
    $fld = new sbLayoutSelect($components, 'component');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_COMPONENT_HINT.'</div>';
    if(isset($params['component']))
    	$fld -> mSelOptions = array($params['component']);
    $layout->addField(PL_NEWS_H_ELEM_COMPONENT, $fld);

    $fld = new sbLayoutPage(isset($params['auth_page']) ? $params['auth_page'] : '', 'auth_page', '', 'style="width: 450px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_PAGE_HINT_LIST.'</div>';
    $layout->addField(PL_NEWS_H_ELEM_LIST_AUTH_PAGE, $fld);

    //Инпут для странички вывода формы редактирования
	$fld = new sbLayoutPage(isset($params['edit_page']) ? $params['edit_page'] : '', 'edit_page', '', 'style="width: 450px;"');
	$fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_PAGE_HINT_EDIT.'</div>';
	$layout->addField(PL_NEWS_H_ELEM_LIST_EDIT_PAGE, $fld);
    $layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutInput('checkbox', '1', '', 'registred_users', (isset($params['registred_users']) && $params['registred_users'] == 1 ? 'checked="checked"' : '') );
	$fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_OUTPUT_USERS_NEWS_FULL_LABEL.'</div>';
	$layout->addField(PL_NEWS_H_ELEM_OUTPUT_USERS_NEWS, $fld);

	$fld = new sbLayoutInput('checkbox', '1', '', 'registred_users_edit_link', ($params['registred_users_edit_link'] == 1 ? 'checked="checked"' : ''));
	$fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_OUTPUT_EDIT_LINK_USERS_NEWS_LABEL.'</div>';
	$layout->addField(PL_NEWS_H_ELEM_OUTPUT_EDIT_LINK_USERS_NEWS, $fld);

	$layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_NEWS_H_ELEM_PREMOD_COMMENTS, new sbLayoutInput('checkbox', 'moderate', '1', 'moderate', (isset($params['moderate']) && $params['moderate'] == 1 ? 'checked="checked"' : '')));
    $fld = new sbLayoutInput('checkbox', '0', '', 'allow_bbcode', (isset($params['allow_bbcode']) && $params['allow_bbcode'] == 1 ? 'checked="checked"' : '') );
	$layout->addField(PL_NEWS_H_ELEM_ALLOW_BB, $fld);
    $layout->addField(PL_NEWS_H_ELEM_MODER_EMAIL, new sbLayoutInput('text', (isset($params['moderate_email']) ? $params['moderate_email'] : ''), 'moderate_email', 'moderate_email', 'style="width:400px;"'));

    $layout->addTab(PL_NEWS_H_ELEM_LIST_CACHE_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_CACHE_TAB);
    
    $layout->addField(PL_NEWS_H_ELEM_LIST_USE_COMPONENT_CACHE, new sbLayoutInput('checkbox', '1', 'use_component_cache', '', ($params['use_component_cache'] == 1 ? 'checked="checked"' : '').' onclick=showHideCacheParams(this.checked)'));
    
    $layout->addField(PL_NEWS_H_ELEM_LIST_NOT_URL, new sbLayoutInput('checkbox', '1', 'cache_not_url', '', ($params['cache_not_url'] == 1 ? 'checked="checked"' : '').' '.($params['use_component_cache'] == 0 ? '' : 'disabled="disabled"')));
    $layout->addField(PL_NEWS_H_ELEM_LIST_NOT_GET, new sbLayoutInput('checkbox', '1', 'cache_not_get', '', ($params['cache_not_get'] == 1 ? 'checked="checked"' : '').' '.($params['use_component_cache'] == 0 ? '' : 'disabled="disabled"').' onclick=showHideGETList(this.checked)'));
    
    $fld = new sbLayoutInput('text', $params['cache_not_get_list'], 'cache_not_get_list', 'cache_not_get_list', (($params['cache_not_get'] == 0 || $params['use_component_cache'] == 1) ? 'disabled="disabled" ' : '').'style="width:400px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_NOT_GET_LIST_HINT.'</div>';
    $layout->addField(PL_NEWS_H_ELEM_LIST_NOT_GET_LIST, $fld);
    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/**
 * Вывод разделов
 *
 */
function fNews_Get_Elem_Categs()
{
	fCategs_Get_Elem_Categs('pl_news', 'pl_news_design_categs', PL_NEWS_H_ELEM_CATEGS_NO_TEMPS_MSG);
}

/**
 * Вывод выбранного раздела
 *
 */
function fNews_Get_Elem_Sel_Cat()
{
    fCategs_Get_Elem_Sel_Cat('pl_news', 'pl_news_design_sel_cat', PL_NEWS_H_ELEM_SEL_CAT_NO_TEMPS_MSG);
}

/**
 * Вывод облака тегов
 *
 */
function fNews_Get_Elem_Cloud()
{
	$params = unserialize($_GET['params']);

    if (!isset($params['filter']))
        $params['filter'] = 'all';

    if (!isset($params['subcategs']))
    	$params['subcategs'] = 1;
    
    if(!isset($params['cache_not_url']))
    {
        $params['cache_not_url'] = 0;
    }
    
    if(!isset($params['cache_not_get']))
    {
        $params['cache_not_get'] = 0;
    }
    
    if(!isset($params['cache_not_get_list']))
    {
        $params['cache_not_get_list'] = '';
    }
    
    if(!isset($params['use_component_cache']))
    {
        $params['use_component_cache'] = 0;
    }

    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_NEWS_H_ELEM_CLOUD_NO_CATEGS_MSG.'");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_NEWS_H_ELEM_CLOUD_NO_TEMPS_ALERT.'");
                return;
            }

            var r_filter_all = sbGetE("r_filter_all");
            var r_filter_last = sbGetE("r_filter_last");
            var r_filter_next = sbGetE("r_filter_next");
            var r_filter_from_to = sbGetE("r_filter_from_to");

            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }
            else if (r_filter_last.checked)
            {
                params["filter"] = r_filter_last.value;
                var el_filter_last = sbGetE("spin_filter_last");
                params["filter_last"] = el_filter_last.value;
            }
            else if (r_filter_next.checked)
            {
                params["filter"] = r_filter_next.value;
                var el_filter_next = sbGetE("spin_filter_next");
                params["filter_next"] = el_filter_next.value;
            }
            else if (r_filter_from_to.checked)
            {
                params["filter"] = r_filter_from_to.value;
                var el_filter_from = sbGetE("spin_filter_from");
                var el_filter_to = sbGetE("spin_filter_to");

                if (el_filter_to.value != "" && el_filter_to.value != 0 && el_filter_from.value > el_filter_to.value)
                {
                    alert("'.PL_NEWS_H_ELEM_LIST_FILTER_FROM_TO_ERROR.'");
                    return;
                }

                params["filter_from"] = el_filter_from.value;
                params["filter_to"] = el_filter_to.value;
            }

            params["sort"] = sbGetE("sort").value;
            params["order"] = sbGetE("order").value;
            params["page"] = sbGetE("page").value;
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["rubrikator"] = sbGetE("rubrikator").checked ? 1 : 0;
            
            params["use_component_cache"] = (sbGetE("use_component_cache").checked ? 1 : 0);
            params["cache_not_url"] = (sbGetE("cache_not_url").checked ? 1 : 0);
            params["cache_not_get"] = (sbGetE("cache_not_get").checked ? 1 : 0);
            params["cache_not_get_list"] = sbGetE("cache_not_get_list").value;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
        
        function showHideGETList(checked)
        {
            if(checked)
            {
                sbGetE("cache_not_get_list").disabled = false;
            }
            else
            {
                sbGetE("cache_not_get_list").disabled = true;
            }
        }
        
        function showHideCacheParams(checked)
        {
            if(!checked)
            {
                sbGetE("cache_not_url").disabled = false;
                var get = sbGetE("cache_not_get");
                get.disabled = false;
                if(get.checked)
                    sbGetE("cache_not_get_list").disabled = false;
            }
            else
            {
                sbGetE("cache_not_url").disabled = true;
                sbGetE("cache_not_get").disabled = true;
                sbGetE("cache_not_get_list").disabled = true;
            }
        }
    </script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_NEWS_H_ELEM_LIST_CATEGS_TAB);

    $categs = new sbJustCategs('pl_news');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_NEWS_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_PROPS_TAB);

    $design_found = fClouds_Design_Get($layout, (isset($_GET['temp_id']) ? $_GET['temp_id'] : -1), 'temp_id');
	$layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_CLOUD_PAGE_HINT.'</div>';

    $layout->addField(PL_NEWS_H_ELEM_CLOUD_PAGE, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fields = array('ct.ct_tag' => PL_NEWS_H_ELEM_CLOUD_SORT_TAG,
    				'ct_rating' => PL_NEWS_H_ELEM_CLOUD_SORT_RATING);

    $order = array('DESC' => PL_NEWS_H_ELEM_LIST_SORT_DESC,
                   'ASC'  => PL_NEWS_H_ELEM_LIST_SORT_ASC);

    $fld1 = new sbLayoutSelect($fields, 'sort');
    $fld1->mSelOptions = array((isset($params['sort']) ? $params['sort'] : 'tag'));
    $fld2 = new sbLayoutSelect($order, 'order');
    $fld2->mSelOptions = array((isset($params['order']) && $params['order'] != '' ? $params['order'] : 'ASC'));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_NEWS_H_ELEM_LIST_SORT_FIELD, $fld1);

    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_NEWS_H_ELEM_CLOUD_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_NEWS_H_ELEM_CLOUD_RUBRIK_LINK, new sbLayoutInput('checkbox', '1', 'rubrikator', '', (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? 'checked="checked"' : '')));

    $layout->addTab(PL_NEWS_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_FILTER_TAB);

    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.PL_NEWS_H_ELEM_CLOUD_FILTER_ALL;
    $html .= $fld1->getField().'<br /><br />';

    $fld2 = new sbLayoutInput('radio', 'last', 'filter', 'r_filter_last', ($params['filter'] == 'last' ? ' checked="checked"' : ''));
    $fld2_1 = new sbLayoutInput('input', (isset($params['filter_last']) ? $params['filter_last'] : ''), 'filter_last', 'spin_filter_last', 'style="width: 50px;"');
    $fld2_1->mMinValue = 1;
    $html .= $fld2_1->getJavaScript().'<table cellpadding="0" cellspacing="0"><tr><td>'.$fld2->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_LAST.'&nbsp;&nbsp;</td><td>'.$fld2_1->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_DAYS.'</td></tr></table><br />';

    $fld4 = new sbLayoutInput('radio', 'next', 'filter', 'r_filter_next', ($params['filter'] == 'next' ? ' checked="checked"' : ''));
    $fld4_1 = new sbLayoutInput('input', (isset($params['filter_next']) ? $params['filter_next'] : ''), 'filter_next', 'spin_filter_next', 'style="width: 50px;"');
    $fld4_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>'.$fld4->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_NEXT.'&nbsp;&nbsp;</td><td>'.$fld4_1->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_DAYS.'</td></tr></table><br />';

    $fld3 = new sbLayoutInput('radio', 'from_to', 'filter', 'r_filter_from_to', ($params['filter'] == 'from_to' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutInput('input', (isset($params['filter_from']) ? $params['filter_from'] : ''), 'filter_from', 'spin_filter_from', 'style="width: 50px;"');
    $fld3_2 = new sbLayoutInput('input', (isset($params['filter_to']) ? $params['filter_to'] : ''), 'filter_to', 'spin_filter_to', 'style="width: 50px;"');
    $fld3_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>'.$fld3->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld3_1->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld3_2->getField().'</td></tr></table>
              <div class="hint_div">'.PL_NEWS_H_ELEM_CLOUD_FILTER_FROM_TO_HINT.'</div>';

    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_NEWS_H_ELEM_CLOUD_FILTER, $fld);
    
    //Кеширование
    $layout->addTab(PL_NEWS_H_ELEM_LIST_CACHE_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_CACHE_TAB);
    
    $layout->addField(PL_NEWS_H_ELEM_LIST_USE_COMPONENT_CACHE, new sbLayoutInput('checkbox', '1', 'use_component_cache', '', ($params['use_component_cache'] == 1 ? 'checked="checked"' : '').' onclick=showHideCacheParams(this.checked)'));
    
    $layout->addField(PL_NEWS_H_ELEM_LIST_NOT_URL, new sbLayoutInput('checkbox', '1', 'cache_not_url', '', ($params['cache_not_url'] == 1 ? 'checked="checked"' : '').' '.($params['use_component_cache'] == 0 ? '' : 'disabled="disabled"')));
    $layout->addField(PL_NEWS_H_ELEM_LIST_NOT_GET, new sbLayoutInput('checkbox', '1', 'cache_not_get', '', ($params['cache_not_get'] == 1 ? 'checked="checked"' : '').' '.($params['use_component_cache'] == 0 ? '' : 'disabled="disabled"').' onclick=showHideGETList(this.checked)'));
    
    $fld = new sbLayoutInput('text', $params['cache_not_get_list'], 'cache_not_get_list', 'cache_not_get_list', (($params['cache_not_get'] == 0 || $params['use_component_cache'] == 1) ? 'disabled="disabled" ' : '').'style="width:400px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_NOT_GET_LIST_HINT.'</div>';
    $layout->addField(PL_NEWS_H_ELEM_LIST_NOT_GET_LIST, $fld);

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.($design_found ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/**
 * Вывод в формате RSS 2.0
 *
 */
function fNews_Get_Elem_Rss()
{
	$params = unserialize($_GET['params']);

	if (!isset($params['filter']))
    {
        $params['filter'] = 'last';
        $params['filter_last'] = '5';
    }

    if (!isset($params['subcategs']))
    	$params['subcategs'] = 1;

    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_NEWS_H_ELEM_LIST_NO_CATEGS_MSG.'");
                return;
            }

            if (sbGetE("rss_title").value == "")
            {
            	alert("'.PL_NEWS_H_ELEM_RSS_NO_TITLE.'");
            	return;
            }

            if (sbGetE("list_page").value == "")
            {
            	alert("'.PL_NEWS_H_ELEM_RSS_NO_PAGE.'");
            	return;
            }

            params["ids"] = el_cats;

            var r_filter_all = sbGetE("r_filter_all");
            var r_filter_last = sbGetE("r_filter_last");
            var r_filter_next = sbGetE("r_filter_next");
            var r_filter_from_to = sbGetE("r_filter_from_to");

            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }
            else if (r_filter_last.checked)
            {
                params["filter"] = r_filter_last.value;
                var el_filter_last = sbGetE("spin_filter_last");
                params["filter_last"] = el_filter_last.value;
            }
            else if (r_filter_next.checked)
            {
                params["filter"] = r_filter_next.value;
                var el_filter_next = sbGetE("spin_filter_next");
                params["filter_next"] = el_filter_next.value;
            }
            else if (r_filter_from_to.checked)
            {

                params["filter"] = r_filter_from_to.value;
                var el_filter_from = sbGetE("spin_filter_from");
                var el_filter_to = sbGetE("spin_filter_to");

                if (el_filter_to.value != "" && el_filter_to.value != 0 && parseInt(el_filter_from.value) > parseInt(el_filter_to.value))
                {
                    alert("'.PL_NEWS_H_ELEM_LIST_FILTER_FROM_TO_ERROR.'");
                    return;
                }

                params["filter_from"] = el_filter_from.value;
                params["filter_to"] = el_filter_to.value;
            }

            var el_sort1 = sbGetE("sort1");
            var el_order1 = sbGetE("order1");
            var el_sort2 = sbGetE("sort2");
            var el_order2 = sbGetE("order2");
            var el_sort3 = sbGetE("sort3");
            var el_order3 = sbGetE("order3");

            params["sort1"] = el_sort1.value;
            params["sort2"] = el_sort2.value;
            params["sort3"] = el_sort3.value;

            params["order1"] = el_order1.disabled ? "" : el_order1.value;
            params["order2"] = el_order2.disabled ? "" : el_order2.value;
            params["order3"] = el_order3.disabled ? "" : el_order3.value;

            params["rss_title"] = sbGetE("rss_title").value;
            params["rss_descr"] = sbGetE("rss_descr").value;
            params["rss_logo"] = sbGetE("rss_logo").value;

            params["list_page"] = sbGetE("list_page").value;
            params["full_page"] = sbGetE("full_page").value;

            params["make_anons"] = sbGetE("make_anons").checked ? 1 : 0;
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["yandex"] = sbGetE("yandex").checked ? 1 : 0;
			
			params["use_filter"] = sbGetE("use_filter").checked ? 1 : 0;
			params["filter_logic"] = sbGetE("filter_logic").value;
            params["filter_text_logic"] = sbGetE("filter_text_logic").value;
            params["filter_compare"] = sbGetE("filter_compare").value;
			params["filter_morph"] = sbGetE("filter_morph").checked ? 1 : 0;

            res.temp_id = -1;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }

        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }
		
		function changeFilterMorph(el)
        {
            sbGetE("filter_morph").disabled = (el.value != "IN");
        }

        function changeUseFilter(el)
        {
        	sbGetE("filter_morph").disabled = !el.checked || sbGetE("filter_compare").value != "IN";
        	sbGetE("filter_logic").disabled = !el.checked;
        	sbGetE("filter_text_logic").disabled = !el.checked;
        	sbGetE("filter_compare").disabled = !el.checked;
        }
    </script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_NEWS_H_ELEM_LIST_CATEGS_TAB);

    $categs = new sbJustCategs('pl_news');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_NEWS_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_PROPS_TAB);

    $layout->addField(PL_NEWS_H_ELEM_RSS_TITLE, new sbLayoutInput('text', isset($params['rss_title']) ? $params['rss_title'] : '', 'rss_title', '', 'style="width: 480px;"', true));
    $layout->addField(PL_NEWS_H_ELEM_RSS_DESCR, new sbLayoutTextarea(isset($params['rss_descr']) ? $params['rss_descr'] : '', 'rss_descr', '', 'style="width:100%;height:100px;"'));
    $layout->addField(PL_NEWS_H_ELEM_RSS_LOGO, new sbLayoutImage(isset($params['rss_logo']) ? $params['rss_logo'] : '', 'rss_logo', '', 'style="width:460px;"'));

    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutPage(isset($params['list_page']) ? $params['list_page'] : '', 'list_page', '', 'style="width: 460px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_RSS_LIST_PAGE_HINT.'</div>';

    $layout->addField(PL_NEWS_H_ELEM_RSS_LIST_PAGE, $fld);

    $fld = new sbLayoutPage(isset($params['full_page']) ? $params['full_page'] : '', 'full_page', '', 'style="width: 460px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_LIST_PAGE_HINT.'</div>';

    $layout->addField(PL_NEWS_H_ELEM_LIST_PAGE, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fields = array('' => ' --- ',
                    'RAND()' => PL_NEWS_H_ELEM_LIST_SORT_RAND,
                    'n.n_title' => PL_NEWS_H_ELEM_LIST_SORT_TITLE,
                    'n.n_date' => PL_NEWS_H_ELEM_LIST_SORT_DATE,
                    'n.n_sort' => PL_NEWS_H_ELEM_LIST_SORT_SORT,
    				'n_rating' => PL_NEWS_H_ELEM_LIST_SORT_RATING,
    				'v.vr_num' => PL_NEWS_H_ELEM_LIST_SORT_COUNT,
    				'v.vr_count' => PL_NEWS_H_ELEM_LIST_SORT_SUM);

    $res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident=?', 'pl_news');
    if ($res)
    {
        list($pd_fields) = $res[0];

        if ($pd_fields != '')
        {
	        $pd_fields = unserialize($pd_fields);

	        foreach($pd_fields as $value)
	        {
	            if ($value['type'] == 'string' ||
	                $value['type'] == 'number' ||
	                $value['type'] == 'date' ||
	                $value['type'] == 'checkbox' ||
	                $value['type'] == 'image' ||
	                $value['type'] == 'link' ||
	                $value['type'] == 'file' ||
	                $value['type'] == 'color' ||
	                $value['type'] == 'select_sprav' ||
	                $value['type'] == 'radio_sprav' )
	            {
	                $fields['n.user_f_'.$value['id']] = $value['title'];
	            }
	        }
        }
    }

    $order = array('DESC' => PL_NEWS_H_ELEM_LIST_SORT_DESC,
                   'ASC'  => PL_NEWS_H_ELEM_LIST_SORT_ASC);

    $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
    $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'n.n_date'));
    $fld2 = new sbLayoutSelect($order, 'order1');
    $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_NEWS_H_ELEM_LIST_SORT_FIELD.' 1', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
    $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order2');
    $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_NEWS_H_ELEM_LIST_SORT_FIELD.' 2', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
    $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order3');
    $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_NEWS_H_ELEM_LIST_SORT_FIELD.' 3', $fld1);

    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_NEWS_H_ELEM_LIST_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_NEWS_H_ELEM_RSS_MAKE_ANONS, new sbLayoutInput('checkbox', '1', 'make_anons', '', (isset($params['make_anons']) && $params['make_anons'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_NEWS_H_ELEM_RSS_YANDEX, new sbLayoutInput('checkbox', '1', 'yandex', '', (isset($params['yandex']) && $params['yandex'] == 1 ? 'checked="checked"' : '')));

    $layout->addTab(PL_NEWS_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_FILTER_TAB);

    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_ALL;
    $html .= $fld1->getField().'<br /><br />';

    $fld2 = new sbLayoutInput('radio', 'last', 'filter', 'r_filter_last', ($params['filter'] == 'last' ? ' checked="checked"' : ''));
    $fld2_1 = new sbLayoutInput('input', (isset($params['filter_last']) ? $params['filter_last'] : ''), 'filter_last', 'spin_filter_last', 'style="width: 50px;"');
    $fld2_1->mMinValue = 1;
    $html .= $fld2_1->getJavaScript().'<table cellpadding="0" cellspacing="0"><tr><td>'.$fld2->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_LAST.'&nbsp;&nbsp;</td><td>'.$fld2_1->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_DAYS.'</td></tr></table><br />';

    $fld4 = new sbLayoutInput('radio', 'next', 'filter', 'r_filter_next', ($params['filter'] == 'next' ? ' checked="checked"' : ''));
    $fld4_1 = new sbLayoutInput('input', (isset($params['filter_next']) ? $params['filter_next'] : ''), 'filter_next', 'spin_filter_next', 'style="width: 50px;"');
    $fld4_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>'.$fld4->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_NEXT.'&nbsp;&nbsp;</td><td>'.$fld4_1->getField().'</td><td>&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_DAYS.'</td></tr></table><br />';

    $fld3 = new sbLayoutInput('radio', 'from_to', 'filter', 'r_filter_from_to', ($params['filter'] == 'from_to' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutInput('input', (isset($params['filter_from']) ? $params['filter_from'] : ''), 'filter_from', 'spin_filter_from', 'style="width: 50px;"');
    $fld3_2 = new sbLayoutInput('input', (isset($params['filter_to']) ? $params['filter_to'] : ''), 'filter_to', 'spin_filter_to', 'style="width: 50px;"');
    $fld3_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>'.$fld3->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld3_1->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld3_2->getField().'</td></tr></table>
              <div class="hint_div">'.PL_NEWS_H_ELEM_LIST_FILTER_FROM_TO_HINT.'</div>';

    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_NEWS_H_ELEM_LIST_FILTER, $fld);

 	$layout->addField('', new sbLayoutDelim());
	
	//TODO интерфейс настройки фильтра по RSS
	$layout->addField(PL_NEWS_H_ELEM_LIST_USE_FILTER, new sbLayoutInput('checkbox', '1', 'use_filter', '', (isset($params['use_filter']) && $params['use_filter'] == 1 ? 'checked="checked"' : '').' onclick="changeUseFilter(this)"'));

    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_logic');
    $fld->mSelOptions = array((isset($params['filter_logic']) && $params['filter_logic'] != '' ? $params['filter_logic'] : ''));
    $layout->addField(PL_NEWS_H_ELEM_LIST_FILTER_LOGIC, $fld);

    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_text_logic');
    $fld->mSelOptions = array((isset($params['filter_text_logic']) && $params['filter_text_logic'] != '' ? $params['filter_text_logic'] : ''));

    $fld1 = new sbLayoutSelect(array('EQ' => PL_NEWS_H_ELEM_LIST_FILTER_TEXT_LOGIC_EQ, 'IN' => PL_NEWS_H_ELEM_LIST_FILTER_TEXT_LOGIC_IN), 'filter_compare', '', 'onchange="changeFilterMorph(this);"');
    $fld1->mSelOptions = array((isset($params['filter_compare']) && $params['filter_compare'] != '' ? $params['filter_compare'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;<input type="checkbox" value="1" id="filter_morph"'.(isset($params['filter_morph']) && $params['filter_morph'] == 1 ? ' checked="checked"' : '').(isset($params['filter_compare']) && $params['filter_compare'] != 'IN' ? ' disabled="disabled"' : '').' />&nbsp;&nbsp;'.PL_NEWS_H_ELEM_LIST_FILTER_MORPH;
    $fld->mHTML = '&nbsp;&nbsp;'.$fld1->getField();

    $layout->addField(PL_NEWS_H_ELEM_LIST_FILTER_TEXT_LOGIC, $fld);
	
	
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"');
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/**
 * Вывод формы редактирования новостей
 */
function fNews_Get_Elem_Form_Edit()
{
	fNews_Get_Elem_Form(true);
}

/**
 * Вывод формы добавления новостей
 */
function fNews_Get_Elem_Form($edit = false)
{
	$params = unserialize($_GET['params']);
	if(!isset($params['registred_users_news_add']))
		$params['registred_users_news_add'] = 1;

	if(!isset($params['registred_users_edit_link']))
		$params['registred_users_edit_link'] = 1;



	echo '<script>
		function choose()
        {
			var res = new Object();
			var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_NEWS_H_FORM_NO_CATEGS_MSG.'");
                return;
            }
            params["ids"] = el_cats;

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_NEWS_H_FORM_NO_TEMPS_ALERT.'");
                return;
            }

            var premod = sbGetE("premod_news");
            if(premod.checked)
            {
                params["premod_news"] = premod.value;
            }';

	if ($edit)
	{
		echo 'params["edit"] = 1;';
	}
	else
	{
        echo 'var rubrikator = sbGetE("rubrikator_form");
            if(rubrikator.checked)
            {
                params["rubrikator_form"] = rubrikator.value;
            }';
	}

    echo '  params["page"] = sbGetE("page").value;
            params["mod_emails"] = sbGetE("mod_emails").value;
            if(sbGetE("registred_users_edit_link") != null)
            	params["registred_users_edit_link"] = sbGetE("registred_users_edit_link").checked ? 1 : 0;
            if(sbGetE("registred_users_news_add") != null)
            	params["registred_users_news_add"] = sbGetE("registred_users_news_add").checked ? 1 : 0;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
	</script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_NEWS_H_FORM_CATEG_TAB);

	$categs = new sbJustCategs('pl_news');
	$categs->mCategsUseRights = false;
	$categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
	$categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

	$layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
	$categs->init();

    $layout->addTab(PL_NEWS_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_NEWS_H_ELEM_LIST_PROPS_TAB);

	$res = sql_query('SELECT categs.cat_title, temps.sntf_id, temps.sntf_title FROM sb_categs categs, sb_catlinks links, sb_news_temps_form temps WHERE temps.sntf_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.sntf_title', 'pl_news_form');
	if ($res)
	{
		$options = array();
		$old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
				$options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
			$options[$st_id] = $st_title;
        }

		$fld = new sbLayoutSelect($options, 'temp_id');
		$fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

		$layout->addField(PL_NEWS_H_ELEM_TEMP, $fld);
    }
	else
    {
		$layout->addField(PL_NEWS_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_NEWS_H_FORM_NO_TEMPS_MSG.'</div>', '', '', false));
	}

	$layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_NEWS_H_FORM_PAGE, new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 460px;"'));

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_NEWS_H_FORM_PREMOD_NEWS, new sbLayoutInput('checkbox', '1', 'premod_news', 'premod_news', (isset($params['premod_news']) && $params['premod_news'] == 1 ? 'checked="checked"' : '' )));

	if($edit)
	{
		$fld = new sbLayoutInput('checkbox', '1', '', 'registred_users_edit_link', ($params['registred_users_edit_link'] == 1 ? 'checked="checked"' : ''));
		$fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_OUTPUT_EDIT_NEWS_AUTH_ONLY_LABEL.'</div>';
		$layout->addField(PL_NEWS_H_ELEM_OUTPUT_EDIT_LINK_USERS_NEWS, $fld);
	}
	else
	{
		$fld = new sbLayoutInput('checkbox', '1', '', 'registred_users_news_add', ($params['registred_users_news_add'] == 1 ? 'checked="checked"' : ''));
		$fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_ELEM_OUTPUT_ADD_NEWS_AUTH_ONLY_LABEL.'</div>';
		$layout->addField(PL_NEWS_H_ELEM_OUTPUT_ADD_NEWS_AUTH_ONLY, $fld);
	}
	if (!$edit)
	{
		$layout->addField(PL_NEWS_H_FORM_RUBRIK_LINK, new sbLayoutInput('checkbox', '1', 'rubrikator_form', 'rubrikator_form', (isset($params['rubrikator_form']) && $params['rubrikator_form'] == 1 ? 'checked="checked"' : '' )));
	}

	$layout->addField(PL_NEWS_H_FORM_MOD_EMAILS, new sbLayoutInput('input', (isset($params['mod_emails']) ? $params['mod_emails'] : ''), 'mod_emails', '', 'style="width: 500px;"'));

	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show();
}

/**
 * Вывод формы фильтра новостей
 */
function fNews_Get_Elem_Filter_Form()
{
	$params = unserialize($_GET['params']);
	echo '<script>
		function choose()
        {
			var res = new Object();
			var params = new Array();

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
			}
			else
            {
				alert("'.PL_NEWS_H_FILTER_FORM_NO_TEMPS_ALERT.'");
				return;
			}
			params["page"] = sbGetE("page").value;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
	</script>';

	echo '<br /><br />';
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '200';

    $layout->addHeader(PL_NEWS_H_ELEM_FILTER_FORM);

	$res = sql_query('SELECT categs.cat_title, temps.sntf_id, temps.sntf_title FROM sb_categs categs, sb_catlinks links, sb_news_temps_form temps WHERE temps.sntf_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.sntf_title', 'pl_news_filter');
	if ($res)
	{
		$options = array();
		$old_cat_title = '';
		foreach ($res as $value)
		{
			list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
				$options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
			$options[$st_id] = $st_title;
        }

		$fld = new sbLayoutSelect($options, 'temp_id');
		$fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

		$layout->addField(PL_NEWS_H_ELEM_TEMP, $fld);
    }
	else
    {
		$layout->addField(PL_NEWS_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_NEWS_H_FILTER_FORM_NO_TEMPS_MSG.'</div>', '', '', false));
	}

	$fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"');
	$fld->mHTML = '<div class="hint_div">'.PL_NEWS_H_FILTER_FORM_ELEMS_LIST_PAGE_HINT.'</div>';
	$layout->addField(PL_NEWS_H_FILTER_FORM_NEWS_PAGE, $fld);

	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show();
}


/********************************** функции получения информации по элементам модуля ***********************************/

/**
 * Вывод новостной ленты
 */
function fNews_Elem_List_Info($params)
{
    $in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';

    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }

    $res = sql_query('SELECT categs.cat_title, temps.ndl_title FROM sb_categs categs, sb_catlinks links, sb_news_temps_list temps
							WHERE temps.ndl_id=?d AND links.link_el_id=temps.ndl_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=?', $params['temp_id'], 'pl_news_list');

    echo '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_NEWS_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_NEWS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          '.(isset($params['page']) && $params['page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_PAGE.':</b> '.$params['page'].'</div>' : '').'
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_SUBCATEGS.':</b> '.(isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_RUBRIK_LINK.':</b> '.(isset($params['rubrikator']) && $params['rubrikator'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_CLOUD_LINK.':</b> '.(isset($params['cloud']) && $params['cloud'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_CALENDAR_LINK.':</b> '.(isset($params['calendar']) && $params['calendar'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_FILTER_LINK.':</b> '.(isset($params['use_filter']) && $params['use_filter'] == 1 || !isset($params['use_filter']) ? KERNEL_YES : KERNEL_NO).'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_ELEM_PREMOD_COMMENTS.':</b> '.(isset($params['moderate']) && $params['moderate'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
    	  <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_MODERATE_EMAILS.':</b> '.(isset($params['moderate_email']) ? $params['moderate_email'] : '').'</div>';
}

/**
 * Вывод полного текста новости
 *
 */
function fNews_Elem_Full_Info($params)
{
    $res = sql_query('SELECT categs.cat_title, temps.ntf_title FROM sb_categs categs, sb_catlinks links, sb_news_temps_full temps
                          WHERE temps.ntf_id=?d AND links.link_el_id=temps.ntf_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=?', $params['temp_id'], 'pl_news_full');

    echo '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_NEWS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
    <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_ELEM_PREMOD_COMMENTS.':</b> '.(isset($params['moderate']) && $params['moderate'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
    <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_MODERATE_EMAILS.':</b> '.(isset($params['moderate_email']) ? $params['moderate_email'] : '').'</div>';
}

/**
 * Вывод разделов
 *
 */
function fNews_Elem_Categs_Info($params)
{
    fCategs_Elem_Categs_Info($params, 'pl_news_design_categs');
}

/**
 * Вывод выбранного раздела
 *
 */
function fNews_Elem_Sel_Cat_Info($params)
{
    fCategs_Elem_Sel_Cat_Info($params, 'pl_news_design_sel_cat');
}

/**
 * Вывод облака тегов
 *
 */
function fNews_Elem_Cloud_Info($params)
{
    $in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';

    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }

    $res = sql_query('SELECT categs.cat_title, temps.ct_title FROM sb_categs categs, sb_catlinks links, sb_clouds_temps temps
							WHERE temps.ct_id=?d AND links.link_el_id=temps.ct_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=?', $params['temp_id'], 'pl_clouds');

    echo '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_NEWS_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_NEWS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          '.(isset($params['page']) && $params['page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_ELEM_CLOUD_PAGE.':</b> '.$params['page'].'</div>' : '').'
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_SUBCATEGS.':</b> '.(isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_RUBRIK_LINK.':</b> '.(isset($params['rubrikator']) && $params['rubrikator'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/**
 * Вывод в формате RSS 2.0
 *
 */
function fNews_Elem_Rss_Info($params)
{
	$in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';

    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }

    echo '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_NEWS_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_RSS_TITLE.':</b> '.$params['rss_title'].'</div>
          '.(isset($params['list_page']) && $params['list_page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_LIST_PAGE.':</b> '.$params['list_page'].'</div>' : '').'
          '.(isset($params['full_page']) && $params['full_page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_PAGE.':</b> '.$params['full_page'].'</div>' : '').'
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_YANDEX.':</b> '.(isset($params['yandex']) && $params['yandex'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_SUBCATEGS.':</b> '.(isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/**
 * Вывод формы добавления новостей
 */
function fNews_Elem_Form_Info($params)
{
	$in_str = implode(',', explode('^', $params['ids']));
	$in_str = '(0,'.$in_str.')';

	$categs_str = '';

	$res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
	if ($res)
    {
		$categs_str = '';
		foreach ($res as $value)
        {
			$categs_str .= $value[0].', ';
        }
		$categs_str = substr($categs_str, 0, -2);
	}

	$res = sql_query('SELECT categs.cat_title, temps.sntf_title
                    FROM sb_categs categs, sb_catlinks links, sb_news_temps_form temps
                    WHERE temps.sntf_id=?d
                    AND links.link_el_id=temps.sntf_id
                    AND categs.cat_id=links.link_cat_id
                    AND categs.cat_ident=?', $params['temp_id'], 'pl_news_form');

	echo '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_INFO_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_NEWS_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
			<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_NEWS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
			<div class="delim"></div>
			<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_FORM_PREMOD_NEWS.':</b> '.(isset($params['premod_news']) && $params['premod_news'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
}

/**
 *
 * Вывод формы фильтра новостей
 */
function fNews_Elem_Filter_Form_Info($params)
{
	$res = sql_query('SELECT categs.cat_title, temps.sntf_title FROM sb_categs categs, sb_catlinks links, sb_news_temps_form temps
			WHERE temps.sntf_id=?d AND links.link_el_id=temps.sntf_id AND categs.cat_id=links.link_cat_id
			AND categs.cat_ident=?', $params['temp_id'], 'pl_news_filter');

	echo '<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_NEWS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
			<div style="padding-bottom: 5px;"><b>'.PL_NEWS_H_FILTER_FORM_NEWS_PAGE.':</b> '.($params['page'] != '' ? $params['page'] : '').'</div>';
}

/********************************** функции получения элементов модуля ***********************************/

/**
 * Вывод новостной ленты
 */
function fNews_Elem_List_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php';\n
        fNews_Elem_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод полного текста новости
 *
 */
function fNews_Elem_Full_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php';\n
        fNews_Elem_Full('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод заголовка новости (HTML)
 *
 */
function fNews_Elem_Header_Html_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php';\n
        fNews_Elem_Header_Html('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод заголовка новости (без форматирования)
 *
 */
function fNews_Elem_Header_Plain_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php';\n
        fNews_Elem_Header_Plain('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод разделов
 *
 */
function fNews_Elem_Categs_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php';\n
        fNews_Elem_Categs('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод выбранного раздела
 *
 */
function fNews_Elem_Sel_Cat_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php';\n
        fNews_Elem_Sel_Cat('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод облака тегов
 *
 */
function fNews_Elem_Cloud_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php';\n
        fNews_Elem_Cloud('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод в формате RSS 2.0
 *
 */
function fNews_Elem_Rss_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php';\n
        fNews_Elem_Rss('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод формы добавления новостей
 */
function fNews_Elem_Form_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php';\n
		fNews_Elem_Form('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
}

/**
 * Вывод формы фильтра новостей
 *
 */
function fNews_Elem_Filter_Form_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_news/prog/pl_news.php'; \n
		fNews_Elem_Filter_Form('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id'); \n
		?>";
}

function fNews_Facebook_Get_Access_Token()
{
	echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
	<html lang="ru">
	<head>
	<title>'.PL_NEWS_H_PERMS_GRANTED_MSG.'</title>
	<meta http-equiv="Content-Script-Type" content="text/javascript">
	<style type="text/css">
	    img
	    {
	        behavior: url(/cms/jscript/sbFixPng.htc.php);
	    }
	</style>
	<link rel="stylesheet" type="text/css" href="'.SB_CMS_CSS_URL.'/sbIndex.css">
	<script src="'.SB_CMS_JSCRIPT_URL.'/sbFunctions.js.php"></script>
	<script src="'.SB_CMS_JSCRIPT_URL.'/sbAJAX.js.php"></script>
	<script>
		sbAddEvent(window, "load", sbSaveAT);
		function sbSaveAT()
		{
			var access_token = window.location.hash;
			access_token = access_token.replace(/#access_token=/,"");
			access_token = access_token.replace(/&expires_in=0/,"");
			var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_news_fb_save_access_token&at=" + access_token);
			sbGetE("fb_mess").innerHTML = res;
		}
	</script>
	</head>
	<body>
	<table cellpadding="0" cellspacing="0" style="margin-top:30px; width:100%;">
	    <tr><td valign="middle" align="center">

	<table cellpadding="0" cellspacing="0" class="form" width="330">
		<tr>
	    	<th width="80" id="fb_mess">
	  			<img src = "/cms/images/loading.gif" align="left">
			</th>
        </tr>
    </table>
</td></tr></table></body></html>';
}

function fNews_Facebook_Save_Access_Token()
{
	if(!isset($_GET['at']) || $_GET['at'] == '' || !preg_match('/^([A-Za-z0-9_\-\.\|]+)/i'.SB_PREG_MOD, urldecode($_GET['at'])))
	{
		echo sb_show_message(PL_NEWS_H_PERMS_GRANTED_ERROR_MSG, false, 'warning', true);
		return;
	}
	sql_query('UPDATE sb_settings SET s_value = ? WHERE s_setting = ? and s_domain = ?',serialize($_GET['at']), 'sb_news_facebook_access_token', SB_COOKIE_DOMAIN);
	echo sb_show_message(PL_NEWS_H_PERMS_GRANTED_MSG, false, 'information', true);
	return;
}

function fNews_Get_Elem_Components()
{
	if (isset($_GET['p_url']))
	{
		echo sb_get_elem_components($_GET['p_url'], 'pl_news_list');
	}
}
?>