<?php
require_once(SB_CMS_LANG_PATH.'/pl_pager_temps.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_pager_temps', PL_PAGER_TEMPS_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_PAGER_TEMPS_H_MENU_NAME.'>'.PL_PAGER_TEMPS_H_MENU_ITEM, 'init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fPager_Temps_Init', 'design_read', PL_PAGER_TEMPS_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fPager_Temps_Edit', 'design_read', PL_PAGER_TEMPS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fPager_Temps_Edit_Submit', 'design_edit', PL_PAGER_TEMPS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fPager_Temps_Delete', 'design_edit');
	$_SESSION['sbPlugins']->addUserEvent('paste', 'fPager_Temps_Paste', 'design_edit');
}

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);    
?>