<?php
function fPager_Get($args)
{
    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['pt_title'].'</a></b>';

    return $result;
}

function fPager_Temps_Init()
{
    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_pager_temps', 'pt_id', 'pt_title', 'fPager_Get', 'pl_pager_temps_init', 'pl_pager_temps');
	$elems->mCategsDeleteWithElementsMenu = true;

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;

    $elems->addField('pt_title');     // название макета дизайна

    $elems->addSorting(PL_PAGER_TEMPS_SORT_BY_TITLE, 'pt_title');

    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_pager_temps_edit';
    $elems->mElemsEditDlgWidth = 800;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_pager_temps_edit';
    $elems->mElemsAddDlgWidth = 800;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mElemsDeleteEvent = 'pl_pager_temps_delete';
	$elems->mElemsAfterPasteEvent = 'pl_pager_temps_paste';
	$elems->mCategsAfterEditEvent = 'pl_pager_temps_paste';

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mElemsUseLinks = false;

    $elems->init();
}

function fPager_Temps_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_pager_temps'))
		return;

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
   		$result = sql_param_query('SELECT pt_title, pt_perstage, pt_begin, pt_next, pt_previous, pt_end, pt_number, pt_sel_number, pt_page_list, pt_delim
   		                     FROM sb_pager_temps WHERE pt_id=?d', $_GET['id']);

   		if ($result)
	    {
        	list($pt_title, $pt_perstage, $pt_begin, $pt_next, $pt_previous, $pt_end, $pt_number, $pt_sel_number, $pt_page_list, $pt_delim) = $result[0];

        	if (is_null($pt_delim))
        	{
        		$pt_delim = '...';
        	}
	    }
	    else
	    {
	        sb_show_message(PL_PAGER_TEMPS_EDIT_ERROR, true, 'warning');
	        return;
	    }
	}
	elseif (count($_POST) > 0)
	{
    	extract($_POST);
    	if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
	    $pt_title = '';
	    $pt_begin = '<a href="{HREF}">&lt;&lt;&lt;</a>';
	    $pt_previous = '<a href="{HREF}">&lt;&lt;</a>';
	    $pt_next = '<a href="{HREF}">&gt;&gt;</a>';
	    $pt_end = '<a href="{HREF}">&gt;&gt;&gt;</a>';
	    $pt_number = '&nbsp;<a href="{HREF}">{NUMBER}</a>&nbsp;';
	    $pt_sel_number = '&nbsp;<b>{NUMBER}</b>&nbsp;';
	    $pt_page_list = '{BEGIN} &nbsp; {PREV} {LIST} {NEXT} &nbsp; {END}';
	    $pt_delim = '...';

	    $pt_perstage = 10;

	    $_GET['id'] = '';
	}

	echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("pt_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_PAGER_TEMPS_EDIT_NO_TITLE_MSG.'");
          	         return false;
                }
            }';
	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}

	echo '</script><br /><br />';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_pager_temps_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addHeader(PL_PAGER_TEMPS_EDIT_HEADER);

	$layout->addField(PL_PAGER_TEMPS_EDIT_TITLE, new sbLayoutInput('text', $pt_title, 'pt_title', '', 'style="width:450px;"', true));

	$fld = new sbLayoutInput('text', $pt_perstage, 'pt_perstage', 'spin_pt_perstage', 'style="width: 100px;"');
	$fld->mMinValue = 1;
	$layout->addField(PL_PAGER_TEMPS_EDIT_PERSTAGE, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($pt_begin, 'pt_begin', '', 'style="width: 100%; height: 70px;"');
	$fld->mTags = array('{HREF}', '{CUR_PAGE}', '{ALL_PAGES}', '{ALL_ELEMS}');
	$fld->mValues = array(PL_PAGER_TEMPS_EDIT_BEGIN_TAG, PL_PAGER_TEMPS_EDIT_SEL_NUMBER, PL_PAGER_TEMPS_EDIT_ALL_PAGES_TAG, PL_PAGER_TEMPS_EDIT_ALL_ELEMS_TAG);
	$layout->addField(PL_PAGER_TEMPS_EDIT_BEGIN, $fld);

	$fld = new sbLayoutTextarea($pt_previous, 'pt_previous', '', 'style="width: 100%; height: 70px;"');
	$fld->mTags = array('{HREF}', '{CUR_PAGE}', '{ALL_PAGES}', '{ALL_ELEMS}');
	$fld->mValues = array(PL_PAGER_TEMPS_EDIT_PREVIOUS_TAG, PL_PAGER_TEMPS_EDIT_SEL_NUMBER, PL_PAGER_TEMPS_EDIT_ALL_PAGES_TAG, PL_PAGER_TEMPS_EDIT_ALL_ELEMS_TAG);
	$layout->addField(PL_PAGER_TEMPS_EDIT_PREVIOUS, $fld);

	$fld = new sbLayoutTextarea($pt_next, 'pt_next', '', 'style="width: 100%; height: 70px;"');
	$fld->mTags = array('{HREF}', '{CUR_PAGE}', '{ALL_PAGES}', '{ALL_ELEMS}');
	$fld->mValues = array(PL_PAGER_TEMPS_EDIT_NEXT_TAG, PL_PAGER_TEMPS_EDIT_SEL_NUMBER, PL_PAGER_TEMPS_EDIT_ALL_PAGES_TAG, PL_PAGER_TEMPS_EDIT_ALL_ELEMS_TAG);
	$layout->addField(PL_PAGER_TEMPS_EDIT_NEXT, $fld);

	$fld = new sbLayoutTextarea($pt_end, 'pt_end', '', 'style="width: 100%; height: 70px;"');
	$fld->mTags = array('{HREF}', '{CUR_PAGE}', '{ALL_PAGES}', '{ALL_ELEMS}');
	$fld->mValues = array(PL_PAGER_TEMPS_EDIT_END_TAG, PL_PAGER_TEMPS_EDIT_SEL_NUMBER, PL_PAGER_TEMPS_EDIT_ALL_PAGES_TAG, PL_PAGER_TEMPS_EDIT_ALL_ELEMS_TAG);
	$layout->addField(PL_PAGER_TEMPS_EDIT_END, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($pt_number, 'pt_number', '', 'style="width: 100%; height: 70px;"');
	$fld->mTags = array('{HREF}', '{NUMBER}', '{CUR_PAGE}', '{ALL_PAGES}', '{ALL_ELEMS}');
	$fld->mValues = array(PL_PAGER_TEMPS_EDIT_NUMBER_LINK_TAG, PL_PAGER_TEMPS_EDIT_NUMBER_TAG, PL_PAGER_TEMPS_EDIT_SEL_NUMBER, PL_PAGER_TEMPS_EDIT_ALL_PAGES_TAG, PL_PAGER_TEMPS_EDIT_ALL_ELEMS_TAG);
	$layout->addField(PL_PAGER_TEMPS_EDIT_NUMBER, $fld);

	$fld = new sbLayoutTextarea($pt_sel_number, 'pt_sel_number', '', 'style="width: 100%; height: 70px;"');
	$fld->mTags = array('{HREF}', '{NUMBER}', '{ALL_PAGES}', '{ALL_ELEMS}');
	$fld->mValues = array(PL_PAGER_TEMPS_EDIT_NUMBER_LINK_TAG, PL_PAGER_TEMPS_EDIT_SEL_NUMBER, PL_PAGER_TEMPS_EDIT_ALL_PAGES_TAG, PL_PAGER_TEMPS_EDIT_ALL_ELEMS_TAG);
	$layout->addField(PL_PAGER_TEMPS_EDIT_SEL_NUMBER, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($pt_delim, 'pt_delim', '', 'style="width: 100%; height: 70px;"');
	$layout->addField(PL_PAGER_TEMPS_EDIT_DELIM, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($pt_page_list, 'pt_page_list', '', 'style="width: 100%; height: 70px;"');
	$fld->mTags = array('{BEGIN}', '{PREV}', '{LIST}', '{NEXT}', '{END}', '{CUR_PAGE}', '{ALL_PAGES}', '{ALL_ELEMS}');
	$fld->mValues = array(PL_PAGER_TEMPS_EDIT_BEGIN_TAG, PL_PAGER_TEMPS_EDIT_PREVIOUS_TAG, PL_PAGER_TEMPS_EDIT_PAGE_LIST_TAG,
	                      PL_PAGER_TEMPS_EDIT_NEXT_TAG, PL_PAGER_TEMPS_EDIT_END_TAG, PL_PAGER_TEMPS_EDIT_SEL_NUMBER, PL_PAGER_TEMPS_EDIT_ALL_PAGES_TAG, PL_PAGER_TEMPS_EDIT_ALL_ELEMS_TAG);
	$layout->addField(PL_PAGER_TEMPS_EDIT_PAGE_LIST, $fld);

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_pager_temps', 'elems_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_pager_temps', 'elems_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();

    echo '<br><br>';
}

function fPager_Temps_Edit_Setting($pt_id = -1)
{
	$options = array();
	$options['0'] = PL_TEXTS_H_SETTING_USE_DELIM_DEFAULT;
	$res = sql_param_query('SELECT categs.cat_title, temps.pt_id, temps.pt_title
	                  FROM sb_categs categs, sb_catlinks links, sb_pager_temps temps
					  WHERE temps.pt_id=links.link_el_id AND categs.cat_id=links.link_cat_id
					  AND categs.cat_ident=? AND temps.pt_id <> ?d
					  ORDER BY categs.cat_left, temps.pt_title', 'pl_pager_temps', $pt_id);
	if ($res)
	{
	    $old_cat_title = '';
	    foreach ($res as $value)
	    {
	        list($cat_title, $pt_id, $pt_title) = $value;
	        if ($old_cat_title != $cat_title)
	        {
	            $options['-'.uniqid()] = '-'.$cat_title;
	            $old_cat_title = $cat_title;
	        }
	        $options[$pt_id] = $pt_title;
	    }
	}

	$_SESSION['sbPlugins']->editSettingValues('sb_texts_use_delim', $options, SB_COOKIE_DOMAIN);
	$_SESSION['sbPlugins']->editSettingValues('sb_news_use_delim', $options, SB_COOKIE_DOMAIN);
}


function fPager_Temps_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_pager_temps'))
		return;

    if (!isset($_GET['id']))
        $_GET['id'] = '';

    extract($_POST);
    $pt_perstage = intval($pt_perstage);

    if ($pt_title == '')
    {
        sb_show_message(PL_PAGER_TEMPS_EDIT_NO_TITLE_MSG, false, 'warning');
        fPager_Temps_Edit();
        return;
    }

    $row['pt_title'] = $pt_title;
    $row['pt_perstage'] = $pt_perstage;
    $row['pt_begin'] = $pt_begin;
    $row['pt_previous'] = $pt_previous;
    $row['pt_next'] = $pt_next;
    $row['pt_end'] = $pt_end;
    $row['pt_number'] = $pt_number;
    $row['pt_sel_number'] = $pt_sel_number;
    $row['pt_delim'] = $pt_delim;
    $row['pt_page_list'] = $pt_page_list;

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT pt_title FROM sb_pager_temps WHERE pt_id=?d', $_GET['id']);
	    if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_pager_temps SET ?a WHERE pt_id=?d', $row, $_GET['id'], sprintf(PL_PAGER_TEMPS_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_pager_temps', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem();
    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_PAGER_TEMPS_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_PAGER_TEMPS_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fPager_Temps_Edit();
    		    return;
    	    }
    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	    $row['pt_id'] = intval($_GET['id']);

            $html_str = fPager_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fPager_Temps_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_PAGER_TEMPS_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_PAGER_TEMPS_EDIT_SYSTEMLOG_ERROR, $pt_title), SB_MSG_WARNING);

            fPager_Temps_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_pager_temps SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id))
    		{
                sbQueryCache::updateTemplate('sb_pager_temps', $id);
        		sb_add_system_message(sprintf(PL_PAGER_TEMPS_ADD_OK, $pt_title));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_pager_temps WHERE pt_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_PAGER_TEMPS_ADD_ERROR, $pt_title), false, 'warning');
            sb_add_system_message(sprintf(PL_PAGER_TEMPS_ADD_SYSTEMLOG_ERROR, $pt_title), SB_MSG_WARNING);

            fPager_Temps_Edit();
		    return;
	    }
	}

	fPager_Temps_Edit_Setting();
}

function fPager_Temps_Delete()
{
	fPager_Temps_Edit_Setting($_GET['id']);
}

function fPager_Temps_Paste()
{
	fPager_Temps_Edit_Setting();
}
?>