<?php

function fPages_Cron_Generate_Pages()
{
	$res = sql_query('SELECT p.p_name, p.p_filepath, p.p_filename, p.p_crc,
					(
						SELECT cat.cat_title FROM sb_categs cat WHERE cat.cat_left <= c.cat_left AND cat.cat_right >= c.cat_right AND cat.cat_level = 1 
						AND cat.cat_ident = ?

					) as domain, c.cat_left, c.cat_right

					FROM sb_pages p, sb_categs c, sb_catlinks l
					WHERE p.p_state = 1 && p.p_id = l.link_el_id AND c.cat_id = l.link_cat_id AND c.cat_ident = ?', 'pl_pages', 'pl_pages');
	if(!$res)
		return;

	$links = $old_domain = $domains = '';
	$send = false;
	$GLOBALS['sbVfs']->mLocal = true;
	foreach($res as $value)
	{
		list($p_name, $p_filepath, $p_filename, $p_crc, $domain) = $value;

		$p_filepath = ($p_filepath != '' ? $p_filepath.'/' : '').$p_filename;

		$GLOBALS['sbVfs']->mDomain = $domain;

		$file_code = '';
		if($GLOBALS['sbVfs']->exists($GLOBALS['sb_domains'][$domain]['basedir'].'/'.$p_filepath))
		{
			$file_code = $GLOBALS['sbVfs']->file_get_contents($GLOBALS['sb_domains'][$domain]['basedir'].'/'.$p_filepath);
		}

		$fresh_crc = sb_crc($file_code);
//      если контрольные суммы не совпадают
		if($fresh_crc != $p_crc)
		{
			$send = true;
			if($old_domain != $domain)
			{
				$domains .= $domain.', ';
				$links .= '<tr><td colspan="2">
								<b>'.$domain.'</b>
							</td></tr>';
			}
			$links .= '<tr>
							<td>
								'.$p_name.'
							</td>
							<td>
								<a style="color:#94521D;" href="http://'.$domain.'/'.$p_filepath.'">http://'.$domain.'/'.$p_filepath.'</a>
							</td>
						</tr>';
			$old_domain = $domain;
		}
	}
	$GLOBALS['sbVfs']->mLocal = false;

	if($send === false)
		return;

	$links = '<table style="background-color:#EDE1C7; font-size:14px;">'.$links.'</table>';

	$domains = sb_substr($domains, 0, -2);
	$mod_emails = array();

//	Достаем администраторов системы. Не всех пользователей системы, а только администраторов.
	$mail_res = sql_query('SELECT u.u_email FROM sb_users u, sb_catlinks l, sb_categs c 
								WHERE u.u_notify = 1 AND u.u_id = l.link_el_id AND c.cat_id = l.link_cat_id AND c.cat_ident = ? AND c.cat_closed = 1', 'pl_users');
	if($mail_res)
	{
		foreach($mail_res as $key => $value)
		{
			if(isset($value[0]) && trim($value[0]) != '')
				$mod_emails[] = $value[0];
		}
	}
	if(count($mod_emails) <= 0)
		return;

	$mail = new sbMail();
	$mail->setSubject(sprintf(KERNEL_PROG_PL_PAGES_CRON_SUBJ_LETER, (count(explode(', ', $domains)) > 1 ? KERNEL_PROG_PL_PAGES_CRON_ON_SITES_LABEL : KERNEL_PROG_PL_PAGES_CRON_ON_SITE_LABEL), $domains));
	$mail->setHtml(sprintf(KERNEL_PROG_PL_PAGES_CRON_TEXT_LETER, (count(explode(', ', $domains)) > 1 ? KERNEL_PROG_PL_PAGES_CRON_SITES_LABEL : KERNEL_PROG_PL_PAGES_CRON_SITE_LABEL), $domains, $links));

	$mail->send($mod_emails, false);
}

?>