<?php
require_once(SB_CMS_LANG_PATH . '/pl_pages.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_pages', PL_PAGES_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/pages.doc')) {
    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER . '>' . PL_PAGES_H_PLUGIN_NAME, 'init');

    $_SESSION['sbPlugins']->setMainEvent('init');

    $_SESSION['sbPlugins']->addUserEvent('init', 'fPages_Init', 'read', PL_PAGES_H_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('edit', 'fPages_Edit', 'read', PL_PAGES_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fPages_Edit_Submit', 'elems_edit', PL_PAGES_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('cat_edit', 'fPages_Cat_Edit', 'categs_edit', PL_PAGES_H_CATEGS_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('cat_edit_submit', 'fPages_Cat_Edit_Submit', 'categs_edit', PL_PAGES_H_CATEGS_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('gen_pages', 'fPages_Gen_Pages', 'categs_edit|elems_edit', PL_PAGES_H_GEN_PAGES_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('check_filename', 'fPages_Check_Filename', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('delete', 'fPages_Delete', 'elems_delete');
    $_SESSION['sbPlugins']->addUserEvent('before_paste', 'fPages_Before_Paste', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('paste', 'fPages_Paste', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('paste_categs', 'fPages_Paste_Categs', 'categs_edit');
    $_SESSION['sbPlugins']->addUserEvent('edit_content', 'fPages_Edit_Content', 'elems_edit', PL_PAGES_H_EDIT_CONTENT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('set_main', 'fPages_Set_Main', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fPages_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements', 'fPages_Before_Delete_Categs_With_Elements', 'categs_edit|elems_edit');

    $fields = array();
    $fields['p_id'] = array('title' => PL_PAGES_H_NAME_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
    $fields['p_name'] = array('title' => PL_PAGES_H_NAME_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
    $fields['p_filepath'] = array('title' => PL_PAGES_H_FILEPATH_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
    $fields['p_filename'] = array('title' => PL_PAGES_H_FILENAME_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
    $fields['p_state'] = array('title' => PL_PAGES_H_STATE_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
    $fields['p_temp_id'] = array('title' => PL_PAGES_H_TEMP_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
    $fields['p_xslt'] = array('title' => PL_PAGES_H_XSLT_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
    $fields['p_title'] = array('title' => PL_PAGES_H_TITLE_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
    $fields['p_keywords'] = array('title' => PL_PAGES_H_KEYWORDS_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
    $fields['p_description'] = array('title' => PL_PAGES_H_DESCRIPTION_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
    $fields['p_meta'] = array('title' => PL_PAGES_H_META_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
    $fields['p_default'] = array('title' => PL_PAGES_H_DEFAULT_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
    $fields['p_crc'] = array('title' => PL_PAGES_H_DEFAULT_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
    $fields['p_ctype'] = array('title' => PL_PAGES_H_CT_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');

    $_SESSION['sbPlugins']->addFieldsInfo('sb_pages', 'p_id', 'p_name', $fields);
}

$_SESSION['sbPlugins']->addSystemEvent('get_page', 'fPages_Get_Page', PL_PAGES_H_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('get_links', 'fPages_Get_Links', PL_PAGES_H_GET_LINKS_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('elem_page', 'fPages_Get_Elem_Page', PL_PAGES_H_ELEM_PAGE);
$_SESSION['sbPlugins']->addSystemEvent('elem_categs', 'fPages_Get_Elem_Categs', PL_PAGES_H_ELEM_CATEGS);
$_SESSION['sbPlugins']->addSystemEvent('elem_path', 'fPages_Get_Elem_Path', PL_PAGES_H_ELEM_PATH);
$_SESSION['sbPlugins']->addSystemEvent('get_status', 'fPages_Get_Status', PL_PAGES_H_ELEM_GET_STATUS);
$_SESSION['sbPlugins']->addSystemEvent('get_status_submit', 'fPages_Get_Status_Submit', PL_PAGES_H_ELEM_GET_STATUS);


$_SESSION['sbPlugins']->addToWorkflow();
$_SESSION['sbPlugins']->addToRubrikator('pl_pages', PL_PAGES_H_PLUGIN_NAME, 'pl_pages');
$_SESSION['sbPlugins']->addToCron('pl_pages/cron/pl_pages.php', 'fPages_Cron_Generate_Pages', PL_PAGES_H_CRON_EVENT_TITLE, PL_PAGES_H_CRON_EVENT_DESCRIPTION);

$_SESSION['sbPlugins']->addElem(PL_PAGES_H_ELEM_PAGE, 'page', 'fPages_Elem_Page', 'fPages_Elem_Page_Info', 'elem_page', 700, 300);
$_SESSION['sbPlugins']->addElem(PL_PAGES_H_ELEM_CATEGS, 'categs', 'fPages_Elem_Categs', 'fPages_Elem_Categs_Info', 'elem_categs', 800, 700);
$_SESSION['sbPlugins']->addElem(PL_PAGES_H_ELEM_PATH_HTML, 'path_html', 'fPages_Elem_Path_Html', 'fPages_Elem_Path_Info', 'elem_path', 800, 700);
$_SESSION['sbPlugins']->addElem(PL_PAGES_H_ELEM_PATH_PLAIN, 'path_plain', 'fPages_Elem_Path_Plain', 'fPages_Elem_Path_Info', 'elem_path', 800, 700);
$_SESSION['sbPlugins']->addElem(PL_PAGES_H_ELEM_PAGE_TITLE_PLAIN, 'page_name', 'fPages_Elem_Page_Name');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_seo_edit', RIGHTS_H_ELEMS_SEO_EDIT_RIGHT);
?>