<?php
function fPages_Elem_Categs($el_id, $temp_id, $params, $tag_id)
{
	require_once SB_CMS_PL_PATH.'/pl_categs/prog/pl_categs.php';
	$num_sub = 0;
    fCategs_Show_Categs($temp_id, $params, $tag_id, 'pl_pages', 'pl_pages', 'pl_pages', $num_sub);
}

function fPages_Elem_Path($el_id, $temp_id, $params, $tag_id, $strip_tags=false)
{
	if ($GLOBALS['sbCache']->check('pl_menu', $tag_id, array($el_id, $temp_id, $params)))
        return;

    $params = unserialize(stripslashes($params));

    $res = sql_query('SELECT mpt_top, mpt_bottom FROM sb_menu_path_temps WHERE mpt_id=?d', $params['temp_id']);
    if (!$res)
    {
        sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_MENU_PLUGIN), SB_MSG_WARNING);
        $GLOBALS['sbCache']->save('pl_menu', '');
        return;
    }

    list($mpt_top, $mpt_bottom) = $res[0];

    require_once SB_CMS_PL_PATH.'/pl_categs/prog/pl_categs.php';

    $cat_params = array();
    $cat_params['ids'] = $params['ids'];
    $cat_params['from'] = 1;
    $cat_params['to'] = '';
    $cat_params['show_closed'] = isset($params['show_closed']) ? $params['show_closed'] : 0;
    $cat_params['show_hidden'] = isset($params['show_hidden']) ? $params['show_hidden'] : 0;
    $cat_params['page'] = 'pl_pages';
	$cat_params['menu_temp_id'] = $params['temp_id'];

    $num = 1;
    $result = fCategs_Show_Menu_Path($params['temp_id'], $cat_params, 'pl_pages', 'pl_pages', 'pl_pages', $num, $params['num_items']);

    if ($result != '')
    {
    	$result = $mpt_top.preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result).$mpt_bottom;

    	if ($strip_tags)
    		$result = strip_tags($result);
    }

    $GLOBALS['sbCache']->save('pl_menu', $result);
}

function fPages_Elem_Page_Name_Plain($el_id, $temp_id, $params, $tag_id)
{
	if ($GLOBALS['sbCache']->check('pl_pages', $tag_id, array($el_id, $temp_id, $params)))
		return;

	if(!defined('SB_PAGE_ID'))
		return;

	$res = sql_query('SELECT p.p_name, c.cat_id, c.cat_closed FROM sb_categs c, sb_pages p, sb_catlinks l
                          WHERE p.p_id = ? AND l.link_el_id=p.p_id AND c.cat_id=l.link_cat_id AND c.cat_ident=?', SB_PAGE_ID, 'pl_pages');
	if (!$res)
	{
		sb_404();
	}

	list($p_name, $cat_id, $cat_closed) = $res[0];

	if ($cat_closed)
	{
		$cat_ids = sbAuth::checkRights(array($cat_id), array($cat_id), 'pl_pages_read');
        if (count($cat_ids) == 0)
        {
			$GLOBALS['sbCache']->save('pl_pages', '');
			return;
		}
	}

	$p_name = strip_tags($p_name);

	$GLOBALS['sbCache']->save('pl_pages', $p_name);
}

?>