<?php

include_once(SB_CMS_LANG_PATH . '/pl_payment.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_payment', PL_PAYMENT_H_PLUGIN_NAME, '')) {
    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER . '>' . PL_PAYMENT_H_SUB_MENU . '>' . PL_PAYMENT_H_PLUGIN_NAME,
        'init', 'pl_payment_24.png');

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_payment', 'design_read')) {
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP . '>' . KERNEL_MENU_DEVELOP_DESIGN . '>' . PL_PAYMENT_H_PLUGIN_NAME . '>' . PL_PAYMENT_H_PAYMENT_FORM,
            'temps', 'pl_payment_temps_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP . '>' . KERNEL_MENU_DEVELOP_DESIGN . '>' . PL_PAYMENT_H_PLUGIN_NAME . '>' . PL_PAYMENT_H_TRANS_LIST,
            'temps_list', 'pl_payment_temps_list_24.png');
    }
    $_SESSION['sbPlugins']->setMainEvent('init');

    $_SESSION['sbPlugins']->addUserEvent('init', 'fPayment_Init', 'read', PL_PAYMENT_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('edit', 'fPayment_Edit', 'read', PL_PAYMENT_H_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('paste', 'fPayment_Paste', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('update', 'fPayment_Update', 'elems_edit', PL_PAYMENT_H_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('set_active', 'fPayment_Set_Active', 'elems_public');

    $_SESSION['sbPlugins']->addUserEvent('cat_edit', 'fPayment_Cat_Edit', 'categs_edit');
    $_SESSION['sbPlugins']->addUserEvent('cat_delete', 'fPayment_Cat_Delete', 'categs_edit',
        PL_PAYMENT_H_EDIT_CAT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('cat_update', 'fPayment_Cat_Update', 'categs_edit',
        PL_PAYMENT_H_EDIT_CAT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('add_cat_fields', 'fPayment_Cat_Fields', 'categs_edit');

    $_SESSION['sbPlugins']->addUserEvent('temps_list', 'fPayment_Temps_List', 'design_read',
        PL_PAYMENT_H_DESIGN_LIST_TR);
    $_SESSION['sbPlugins']->addUserEvent('temps_edit_list', 'fPayment_Temps_Edit_List', 'design_read',
        PL_PAYMENT_H_DESIGN_EDIT_ORDER);
    $_SESSION['sbPlugins']->addUserEvent('temps_update_list', 'fPayment_Temps_Update_List', 'design_edit',
        PL_PAYMENT_H_DESIGN_EDIT_ORDER);
    $_SESSION['sbPlugins']->addUserEvent('temps_delete_list', 'fPayment_Temps_Delete_List', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('temps', 'fPayment_Temps', 'design_read', PL_PAYMENT_H_DESIGN_ORDER);
    $_SESSION['sbPlugins']->addUserEvent('temps_edit', 'fPayment_Temps_Edit', 'design_read',
        PL_PAYMENT_H_DESIGN_EDIT_ORDER);
    $_SESSION['sbPlugins']->addUserEvent('temps_update', 'fPayment_Temps_Update', 'design_edit',
        PL_PAYMENT_H_DESIGN_EDIT_ORDER);
    $_SESSION['sbPlugins']->addUserEvent('temps_delete', 'fPayment_Temps_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addToConstructor('sb_payments', false);
}

$_SESSION['sbPlugins']->addSystemEvent('get_preform', 'fPayment_Get_PreForm', PL_PAYMENT_H_PRE_FORM);
$_SESSION['sbPlugins']->addSystemEvent('get_list_transaction', 'fPayment_Get_List_Transaction',
    PL_PAYMENT_H_TRANSACTIONS);

$_SESSION['sbPlugins']->addElem(PL_PAYMENT_H_PRE_FORM, 'preform', 'fPayment_Get_ListForm', 'fPayment_Get_PreForm_Info',
    'get_preform', 800, 500, 'temps_edit', 'pl_payment_temps');
$_SESSION['sbPlugins']->addElem(PL_PAYMENT_H_TRANSACTIONS, 'list_transaction', 'fPayment_Set_List_Trans',
    'fPayment_Set_List_Trans_Info', 'get_list_transaction', 800, 500, 'temps_edit_list', 'pl_payments_temps_list');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
