<?php
function fProfiling_SQL_Read()
{
    echo '<style type="text/css">
    	#event_content table.form tr.even:hover,
		#event_content table.form tr.odd:hover
		{
			background-color: #E1FFE1;
		}

		#event_content
		{
			overflow-x: auto;
		}
	</style>
    
    <script>
    document.body.onselectstart = "";
    document.body.setAttribute("unselectable", "off");

    function showFilter()
    {
        var filter = sbGetE("sb_filter");
        var filter_arr = sbGetE("filter_arrow");
        if (!filter) return;
        if (filter.style.display == "none")
        {
            filter.style.display = "";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
        }
        else
        {
            filter.style.display = "none";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
        }
    }
    function setFilter()
    {
        var str = "'.SB_CMS_CONTENT_FILE.'?event=pl_profiling_sql_read'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
        var found = false;
        var frm = sbGetE("filter_form");
        for (var i = 0; i < frm.elements.length; i++)
        {
            var el = frm.elements[i];
            if (el.type == "select-one")
            {
                if (el.value != -1)
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
            else
            {
                if (el.name != "" && el.value != "")
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
        }

        if (!found)
        {
            return false;
        }

        window.location = str;
        return false;
    }
    function removeFilter(e)
    {
        window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_profiling_sql_read'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
        return sbCancelEvent(e);
    }
    function refreshJournal()
    {
    	window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_profiling_sql_read'
        .(isset($_GET['order']) ? '&order='.$_GET['order'] : '')
        .(isset($_GET['date_from']) ? '&date_from='.$_GET['date_from'] : '')
        .(isset($_GET['date_to']) ? '&date_to='.$_GET['date_to'] : '')
        .(isset($_GET['domain']) ? '&domain='.$_GET['domain'] : '')
        .(isset($_GET['query']) ? '&query='.$_GET['query'] : '')
        .(isset($_GET['time_from']) ? '&time_from='.$_GET['time_from'] : '')
        .(isset($_GET['time_to']) ? '&time_to='.$_GET['time_to'] : '')
        .(isset($_GET['plugin']) ? '&plugin='.$_GET['plugin'] : '')
        .(isset($_GET['hash']) ? '&hash='.$_GET['hash'] : '')
        .(isset($_GET['url']) ? '&url='.$_GET['url'] : '').'";
    }
    
    function clearJournal()
    {
        if(confirm("'.PL_PROFILE_CONFIRM_MESSAGE.'"))
            window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_profiling_sql_clear";
    }
    </script>
    ';
    
    $href = SB_CMS_CONTENT_FILE.'?event=pl_profiling_sql_read';
    $order_by = '';
    $filter_str = '';
    
    if(isset($_GET['time_from']) && floatval($_GET['time_from']) >0)
    {
        $filter_str .= ' AND pr_time >= '.floatval($_GET['time_from']);
    }
    
    if(isset($_GET['time_to']) && floatval($_GET['time_to']) >0)
    {
        $filter_str .= ' AND pr_time <= '.floatval($_GET['time_to']);
    }
    
    if (isset($_GET['date_from']) && !empty($_GET['date_from']))
    {
        $_GET['date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['date_from']);
        $date_time = explode(' ', $_GET['date_from']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND pr_date >= '.sb_datetoint($_GET['date_from']);
        }
    }

    if (isset($_GET['date_to']) && !empty($_GET['date_to']))
    {
        $_GET['date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['date_to']);
        $date_time = explode(' ', $_GET['date_to']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND pr_date <= '.sb_datetoint($_GET['date_to']);
        }
    }
    
    if (isset($_GET['domain']) && !empty($_GET['domain']))
    {
        $_GET['domain'] = preg_replace('/[^a-zA-Z0-9\-\.]+/', '', $_GET['domain']);

        if (!empty($_GET['domain']))
            $filter_str .= ' AND pr_domain = "'.$_GET['domain'].'"';
    }
    
    if (isset($_GET['plugin']) && !empty($_GET['plugin']))
    {
        $_GET['plugin'] = preg_replace('/[^a-zA-Z0-9\-_\s]+/', '', $_GET['plugin']);

        if (!empty($_GET['plugin']))
        {
            $filter_str .= ' AND pr_plugin = "'.$_GET['plugin'].'"';
        }
    }
    
    if (isset($_GET['query']) && !empty($_GET['query']))
    {
        $filter_str .= ' AND pr_text_sql LIKE "%'.$_GET['query'].'%" ';
    }
    
    if (isset($_GET['url']) && !empty($_GET['url']))
    {
        $_GET['url'] = preg_replace('/[^a-zA-Z0-9\-\/:\_\.&=\?]+/', '', $_GET['url']);
        $filter_str .= ' AND pr_url LIKE "%'.$_GET['url'].'%" ';
    }
    
    if (isset($_GET['hash']) && !empty($_GET['hash']))
    {
        $_GET['hash'] = preg_replace('/[^a-z0-9]+/', '', $_GET['hash']);
        $filter_str .= ' AND pr_hash="'.$_GET['hash'].'" ';
    }
    
    if (!isset($_GET['order']))
    {
        $_GET['order'] = 'pr_date|desc';
    }
    else
    {
        $_GET['order'] = preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']);
        if (empty($_GET['order']))
            $_GET['order'] = 'pr_date|desc';
    }
    
    foreach ($_GET as $key => $value)
    {
        if ($key != 'event')
        {
            if (!is_array($value))
            {
                if ($key != 'order')
                {
                    $href .= '&'.$key.'='.urlencode($value);
                }
                else
                {
                    $order_by = sb_str_replace('|', ' ', $value).',';
                }
            }
            else
            {
                foreach ($value as $value2)
                {
                    if ($key != 'order')
                    {
                        $href .= '&'.$key.'[]'.'='.urlencode($value2);
                    }
                }
            }
        }
    }
    
    //Фильтр
    echo '
    <table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
        	<table cellpadding="0" cellspacing="0">
        	<tr>
            	<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.(($filter_str != '' && !isset($_GET['hash'])) ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" /></span></td>
            	<td class="sb_filter_on" id="sb_filter_on" style="'.(($filter_str != '' && !isset($_GET['hash']))? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
            </tr></table>
        </td>
    </tr>
    <tr><td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter"'.(($filter_str != '' && !isset($_GET['hash'])) ? '' : ' style="display:none;"').'>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">'.PL_PROFILING_FILTER_DATE.':</th>
                <td class="sb_filter_td"><nobr>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $fld_lo = new sbLayoutDate((isset($_GET['date_from']) ? $_GET['date_from'] : ''), 'date_from');
    $fld_lo->mDropButton = true;

    $fld_hi = new sbLayoutDate((isset($_GET['date_to']) ? $_GET['date_to'] : ''), 'date_to');
    $fld_hi->mDropButton = true;

    echo $fld_lo->getJavaScript().
    	'<table cellpadding="0" cellspacing="0"><tr><td>'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld_lo->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld_hi->getField().'</td></tr></table>
    	</nobr>
                </td>
                <th class="sb_filter_th">'.PL_PROFILING_FILTER_DOMAIN.':</th>
                <td class="sb_filter_td_noborder">';

    $idn = new sbIDN();

    $options = array('-1' => ' --- ');
    $u_domains = array();
    foreach ($GLOBALS['sb_domains'] as $domain => $value)
    {
        $options[$domain] = $idn->decode($domain);
        $u_domains[] = $domain;
    }

    $fld = new sbLayoutSelect($options, 'domain');
    if (isset($_GET['domain']))
        $fld->mSelOptions[] = $_GET['domain'];
    echo $fld->getField();

    echo '      </td>
            </tr>';

    $fld_time_from = new sbLayoutInput('text', (isset($_GET['time_from']) ? $_GET['time_from'] : 0), 'time_from', 'spin_time_from', 'style="width: 100px"');
    $fld_time_from->mMinValue = 0;
    $fld_time_from->mIncrement = 0.000001;
    
    $fld_time_to = new sbLayoutInput('text', (isset($_GET['time_to']) ? $_GET['time_to'] : 0), 'time_to', 'spin_time_to', 'style="width: 100px"');
    $fld_time_to->mMinValue = 0;
    $fld_time_to->mIncrement = 0.000001;
    
    //Выбираем список модулей, имеющихся в профайле
    $prof_plugins = array('-1' => ' --- ');
    $res = sql_param_query('SELECT DISTINCT pr_plugin FROM sb_profiler_sql');

    if($res)
    {
        foreach($res as $row)
        {
            $prof_plugins[$row[0]] = $row[0];
        }
        $prof_plugins['Unknown'] = PL_PROFILING_UNKNOW;
    }
    
    $fld = new sbLayoutSelect($prof_plugins, 'plugin', '');
    $fld->mSelOptions = isset($_GET['plugin']) ? array($_GET['plugin']) : array();
    
    echo '<tr>
        <th class="sb_filter_th">'.PL_PROFILING_FILTER_WORKTIME.':</th>
        <td class="sb_filter_td">
            <table cellpadding="0" cellspacing="0"><tr><td>
        '.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld_time_from->getField().'</td><td>&nbsp;&nbsp;</td><td>'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld_time_to->getField().'
            </td></tr></table>
        </td>
        <th class="sb_filter_th">'.PL_PROFILING_FILTER_PLUGIN.':</th>
        <td class="sb_filter_td_noborder">'.$fld->getField().'</td>
    </tr>';
    echo '<tr>
                <th class="sb_filter_th">'.PL_PROFILING_FILTER_QUERY.':</th>
                <td class="sb_filter_td">';

    $fld = new sbLayoutInput('text', isset($_GET['query']) ? $_GET['query'] : '', 'query', '', 'style="width: 100%;"');
    echo $fld->getField();

    echo '</td>';

    $fld = new sbLayoutInput('text', isset($_GET['url']) ? $_GET['url'] : '', 'url', '', 'style="width: 100%;"');
    echo '<th class="sb_filter_th">'.PL_PROFILING_FILTER_URL.':</th>
                <td class="sb_filter_td_noborder">'.$fld->getField().'</td>';
    
	echo '
            </tr>
            </table>
			<div class="sb_filter_footer">
					<input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;
            </div>
            </div>
            </form>
        </table>
    </td></tr></table>
    <br>
    <center>
    <div align="right" style="width:95%">
    <a href="javascript:refreshJournal();"><img src="'.SB_CMS_IMG_URL.'/link.png" width="12" height="12" border="0" align="absmiddle">&nbsp;'.PL_PROFILING_FILTER_RELOAD.'</a>
    &nbsp;&nbsp;
    <a href="javascript:clearJournal();"><img src="'.SB_CMS_IMG_URL.'/btn_delete.png" width="12" height="12" border="0" align="absmiddle">&nbsp;'.PL_PROFILING_CLEAR.'</a>
	</div>';
    
    echo $fld_time_from->getJavaScript();

    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
    $idn = new sbIDN();

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $domains) = $res[0];
        
    //Вывод данных
    $total = true;
    $pager = new sbDBPager('prof', 7, 25, 'content');
    
    if ($u_admin != 1)
    {
        $u_domains = explode(',', $domains);
        $query_str = 'SELECT pr_id, pr_date, pr_time, pr_text_sql, pr_tracker, pr_plugin, pr_url, pr_domain 
        FROM sb_profiler_sql 
        WHERE pr_domain IN (?a)'.(($filter_str != '')? $filter_str: '')
        .(($order_by != '')? ' ORDER BY '.sb_substr($order_by, 0, -1) : '');
        $result = $pager->init($total, $query_str, $u_domains);
    }
	else
	{
		$query_str = 'SELECT pr_id, pr_date, pr_time, pr_text_sql, pr_tracker, pr_plugin, pr_url, pr_domain 
        FROM sb_profiler_sql '.(($filter_str != '')? 'WHERE '.sb_substr($filter_str, 5) : '')
        .(($order_by != '')? ' ORDER BY '.sb_substr($order_by, 0, -1) : '');
        
        $result = $pager->init($total, $query_str);
	}
    
    
    $num_list = $pager->show();
    
    echo '<br/>', $num_list, '<br/><br/>';
    
    echo '<table width="98%" cellspacing="0" cellpadding="5" class="form">
        <tr>
            <th class="header" width="50">
                <nobr>
                    <a href="'.$href.'&order=pr_date|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'pr_date|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                    &nbsp;'.PL_PROFILING_H_DATE.'&nbsp;
                    <a href="'.$href.'&order=pr_date|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'pr_date|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    <a href="'.$href.'&order=pr_time|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'pr_time|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                    &nbsp;'.PL_PROFILING_H_WORKTIME.'&nbsp;
                    <a href="'.$href.'&order=pr_time|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'pr_time|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    <a href="'.$href.'&order=pr_domain|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'pr_domain|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                    &nbsp;'.PL_PROFILING_H_DOMAIN.'&nbsp;
                    <a href="'.$href.'&order=pr_domain|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'pr_domain|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    &nbsp;'.PL_PROFILING_H_TEXT_SQL.'&nbsp;
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    &nbsp;'.PL_PROFILING_H_TRACKER.'&nbsp;
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    <a href="'.$href.'&order=pr_plugin|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'pr_plugin|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                    &nbsp;'.PL_PROFILING_H_INIT_PLUGIN.'&nbsp;
                    <a href="'.$href.'&order=pr_plugin|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'pr_plugin|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    &nbsp;'.PL_PROFILING_H_INIT_URL.'&nbsp;
                </nobr>
            </th>
        </tr>
    ';
    
    if($result)
    {
        $i=0;
        foreach($result as $row)
        {
            list(, $date, $time, $text_sql, $tracker, $plugin, $url, $domain) = $row;
            if($plugin == 'Unknown')
            {
                $plugin = PL_PROFILING_UNKNOW;
            }
            $class = ($i++ % 2 != 0)? 'even': 'odd';
            echo '<tr class="'.$class.'">
                <td style="font-size: 10px;text-align: center;">',sb_date('d.m.Y', $date),'<br />',KERNEL_IN,'<br />',sb_date('H:i:s', $date),'</td>
                <td style="font-size: 10px;text-align: center;"><b>',$time,'</b></td>
                <td style="font-size: 10px;text-align: center;"><b>'.$idn->decode($domain).'</b></td>
                <td><textarea rows="10" cols="50">',$text_sql,'</textarea></td>
                <td style="font-size: 10px;">',fProfiling_Parse_Tracker($tracker),'</td>
                <td style="font-size: 10px;">',$plugin,'</td>
                <td><a href="',$url,'" target="_blank" style="font-size: 10px;">',chunk_split($url, 70),'</a></td>
            </tr>';
        }
    }
    else
    {
        $num_list = sb_show_message(PL_PROFILING_NO_ITEMS, true, 'information', true);
    }
    
    echo '</table>';
    echo '<br/>', $num_list, '<br/><br/>';
}

function fProfiling_SQL_Clear()
{
    sql_param_query('TRUNCATE TABLE sb_profiler_sql');
    fProfiling_SQL_Read();
}

function fProfiling_Components_Read()
{
    $elems = $_SESSION['sbPlugins']->getElems();
    
    echo '<style type="text/css">
    	#event_content table.form tr.even:hover,
		#event_content table.form tr.odd:hover
		{
			background-color: #E1FFE1;
		}

		#event_content
		{
			overflow-x: auto;
		}
	</style>
    
    <script>
    document.body.onselectstart = "";
    document.body.setAttribute("unselectable", "off");

    function showFilter()
    {
        var filter = sbGetE("sb_filter");
        var filter_arr = sbGetE("filter_arrow");
        if (!filter) return;
        if (filter.style.display == "none")
        {
            filter.style.display = "";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
        }
        else
        {
            filter.style.display = "none";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
        }
    }
    function setFilter()
    {
        var str = "'.SB_CMS_CONTENT_FILE.'?event=pl_profiling_components_read'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
        var found = false;
        var frm = sbGetE("filter_form");
        for (var i = 0; i < frm.elements.length; i++)
        {
            var el = frm.elements[i];
            if (el.type == "select-one")
            {
                if (el.value != -1)
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
            else
            {
                if (el.name != "" && el.value != "")
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
        }

        if (!found)
        {
            return false;
        }

        window.location = str;
        return false;
    }
    function removeFilter(e)
    {
        window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_profiling_components_read'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
        return sbCancelEvent(e);
    }
    function refreshJournal()
    {
    	window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_profiling_components_read'
        .(isset($_GET['order']) ? '&order='.$_GET['order'] : '')
        .(isset($_GET['date_from']) ? '&date_from='.$_GET['date_from'] : '')
        .(isset($_GET['date_to']) ? '&date_to='.$_GET['date_to'] : '')
        .(isset($_GET['domain']) ? '&domain='.$_GET['domain'] : '')
        .(isset($_GET['time_from']) ? '&time_from='.$_GET['time_from'] : '')
        .(isset($_GET['time_to']) ? '&time_to='.$_GET['time_to'] : '')
        .(isset($_GET['plugin']) ? '&plugin='.$_GET['plugin'] : '')
        .(isset($_GET['url']) ? '&url='.$_GET['url'] : '').'";
    }
    
    function clearJournal()
    {
        if(confirm("'.PL_PROFILE_CONFIRM_MESSAGE.'"))
            window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_profiling_components_clear";
    }
    
    function showQuery(hash)
    {
    	window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_profiling_sql_read&hash="+hash;
    }
    </script>
    ';
    
    $href = SB_CMS_CONTENT_FILE.'?event=pl_profiling_components_read';
    $order_by = '';
    $filter_str = '';
    
    if(isset($_GET['time_from']) && floatval($_GET['time_from']) >0)
    {
        $filter_str .= ' AND prp_time >= '.floatval($_GET['time_from']);
    }
    
    if(isset($_GET['time_to']) && floatval($_GET['time_to']) >0)
    {
        $filter_str .= ' AND prp_time <= '.floatval($_GET['time_to']);
    }
    
    if (isset($_GET['date_from']) && !empty($_GET['date_from']))
    {
        $_GET['date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['date_from']);
        $date_time = explode(' ', $_GET['date_from']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND prp_date >= '.sb_datetoint($_GET['date_from']);
        }
    }

    if (isset($_GET['date_to']) && !empty($_GET['date_to']))
    {
        $_GET['date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['date_to']);
        $date_time = explode(' ', $_GET['date_to']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND prp_date <= '.sb_datetoint($_GET['date_to']);
        }
    }
    
    if (isset($_GET['domain']) && !empty($_GET['domain']))
    {
        $_GET['domain'] = preg_replace('/[^a-zA-Z0-9\-\.]+/', '', $_GET['domain']);

        if (!empty($_GET['domain']))
            $filter_str .= ' AND prp_domain = "'.$_GET['domain'].'"';
    }
    
    if (isset($_GET['plugin']) && !empty($_GET['plugin']))
    {
        $_GET['plugin'] = preg_replace('/[^a-zA-Z0-9\-_\s]+/', '', $_GET['plugin']);

        if (!empty($_GET['plugin']))
        {
            $filter_str .= ' AND prp_ident LIKE "'.$_GET['plugin'].'%"';
        }
    }
    
    if (isset($_GET['url']) && !empty($_GET['url']))
    {
        $_GET['url'] = preg_replace('/[^a-zA-Z0-9\-\/:\_\.&=\?]+/', '', $_GET['url']);
        $filter_str .= ' AND prp_uri LIKE "%'.$_GET['url'].'%" ';
    }
    
    if (!isset($_GET['order']))
    {
        $_GET['order'] = 'prp_date|desc';
    }
    else
    {
        $_GET['order'] = preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']);
        if (empty($_GET['order']))
            $_GET['order'] = 'prp_date|desc';
    }
    
    foreach ($_GET as $key => $value)
    {
        if ($key != 'event')
        {
            if (!is_array($value))
            {
                if ($key != 'order')
                {
                    $href .= '&'.$key.'='.urlencode($value);
                }
                else
                {
                    $order_by = sb_str_replace('|', ' ', $value).',';
                }
            }
            else
            {
                foreach ($value as $value2)
                {
                    if ($key != 'order')
                    {
                        $href .= '&'.$key.'[]'.'='.urlencode($value2);
                    }
                }
            }
        }
    }
    
    //Фильтр
    echo '
    <table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
        	<table cellpadding="0" cellspacing="0">
        	<tr>
            	<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.($filter_str != '' ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" /></span></td>
            	<td class="sb_filter_on" id="sb_filter_on" style="'.($filter_str != '' ? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
            </tr></table>
        </td>
    </tr>
    <tr><td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter"'.($filter_str != '' ? '' : ' style="display:none;"').'>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">'.PL_PROFILING_FILTER_DATE.':</th>
                <td class="sb_filter_td"><nobr>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $fld_lo = new sbLayoutDate((isset($_GET['date_from']) ? $_GET['date_from'] : ''), 'date_from');
    $fld_lo->mDropButton = true;

    $fld_hi = new sbLayoutDate((isset($_GET['date_to']) ? $_GET['date_to'] : ''), 'date_to');
    $fld_hi->mDropButton = true;

    echo $fld_lo->getJavaScript().
    	'<table cellpadding="0" cellspacing="0"><tr><td>'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld_lo->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld_hi->getField().'</td></tr></table>
    	</nobr>
                </td>
                <th class="sb_filter_th">'.PL_PROFILING_FILTER_DOMAIN.':</th>
                <td class="sb_filter_td_noborder">';

    $idn = new sbIDN();

    $options = array('-1' => ' --- ');
    $u_domains = array();
    foreach ($GLOBALS['sb_domains'] as $domain => $value)
    {
        $options[$domain] = $idn->decode($domain);
        $u_domains[] = $domain;
    }

    $fld = new sbLayoutSelect($options, 'domain');
    if (isset($_GET['domain']))
        $fld->mSelOptions[] = $_GET['domain'];
    echo $fld->getField();

    echo '      </td>
            </tr>';

    $fld_time_from = new sbLayoutInput('text', (isset($_GET['time_from']) ? $_GET['time_from'] : 0), 'time_from', 'spin_time_from', 'style="width: 100px"');
    $fld_time_from->mMinValue = 0;
    $fld_time_from->mIncrement = 0.000001;
    
    $fld_time_to = new sbLayoutInput('text', (isset($_GET['time_to']) ? $_GET['time_to'] : 0), 'time_to', 'spin_time_to', 'style="width: 100px"');
    $fld_time_to->mMinValue = 0;
    $fld_time_to->mIncrement = 0.000001;
    
    //Выбираем список модулей, имеющихся в профайле
    $prof_plugins = array('-1' => ' --- ');
    $res = sql_param_query('SELECT DISTINCT prp_ident FROM sb_profiler_plugins');

    if($res)
    {
        foreach($res as $row)
        {
            if(isset($elems[$row[0]]))
            {
                $plugin_name = preg_replace('/([^|]+)\|.+/', '$1', $elems[$row[0]]['name']);
                $prof_plugins[$elems[$row[0]]['plugin']] = $plugin_name;
            }
        }
        $prof_plugins['Unknown'] = PL_PROFILING_UNKNOW;
    }
    
    $fld = new sbLayoutSelect($prof_plugins, 'plugin', '');
    $fld->mSelOptions = isset($_GET['plugin']) ? array($_GET['plugin']) : array();
    
    echo '<tr>
        <th class="sb_filter_th">'.PL_PROFILING_FILTER_WORKTIME.':</th>
        <td class="sb_filter_td">
            <table cellpadding="0" cellspacing="0"><tr><td>
        '.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld_time_from->getField().'</td><td>&nbsp;&nbsp;</td><td>'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld_time_to->getField().'
            </td></tr></table>
        </td>
        <th class="sb_filter_th">'.PL_PROFILING_FILTER_PLUGIN.':</th>
        <td class="sb_filter_td_noborder">'.$fld->getField().'</td>
    </tr>';
    echo '<tr>
          <td class="sb_filter_td" colspan="2"></td>';

    $fld = new sbLayoutInput('text', isset($_GET['url']) ? $_GET['url'] : '', 'url', '', 'style="width: 100%;"');
    echo '<th class="sb_filter_th">'.PL_PROFILING_FILTER_URL.':</th>
                <td class="sb_filter_td_noborder">'.$fld->getField().'</td>';
    
	echo '
            </tr>
            </table>
			<div class="sb_filter_footer">
					<input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;
            </div>
            </div>
            </form>
        </table>
    </td></tr></table>
    <br>
    <center>
    <div align="right" style="width:95%">
    <a href="javascript:refreshJournal();"><img src="'.SB_CMS_IMG_URL.'/link.png" width="12" height="12" border="0" align="absmiddle">&nbsp;'.PL_PROFILING_FILTER_RELOAD.'</a>
    &nbsp;&nbsp;
    <a href="javascript:clearJournal();"><img src="'.SB_CMS_IMG_URL.'/btn_delete.png" width="12" height="12" border="0" align="absmiddle">&nbsp;'.PL_PROFILING_CLEAR.'</a>
	</div>';
    
    echo $fld_time_from->getJavaScript();

    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $domains) = $res[0];

        
    //Вывод данных
    $total = true;
    $pager = new sbDBPager('profc', 7, 25, 'content');
    
    if ($u_admin != 1)
    {
        $u_domains = explode(',', $domains);
        $query_str = 'SELECT prp_id, prp_ident, prp_time, prp_sql_count, prp_uri, prp_domain, prp_date, prp_hash 
        FROM sb_profiler_plugins 
        WHERE prp_domain IN (?a)'.(($filter_str != '')? $filter_str: '')
        .(($order_by != '')? ' ORDER BY '.sb_substr($order_by, 0, -1) : '');
        $result = $pager->init($total, $query_str, $u_domains);
    }
	else
	{
		$query_str = 'SELECT prp_id, prp_ident, prp_time, prp_sql_count, prp_uri, prp_domain, prp_date, prp_hash 
        FROM sb_profiler_plugins '.(($filter_str != '')? 'WHERE '.sb_substr($filter_str, 5) : '')
        .(($order_by != '')? ' ORDER BY '.sb_substr($order_by, 0, -1) : '');
        
        $result = $pager->init($total, $query_str);
	}
    
    
    $num_list = $pager->show();
    
    echo '<br/>', $num_list, '<br/><br/>';
    
    echo '<table width="98%" cellspacing="0" cellpadding="5" class="form">
        <tr>
            <th class="header" width="50">
                <nobr>
                    <a href="'.$href.'&order=prp_date|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_date|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                    &nbsp;'.PL_PROFILING_H_DATE.'&nbsp;
                    <a href="'.$href.'&order=prp_date|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_date|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    <a href="'.$href.'&order=prp_time|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_time|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                    &nbsp;'.PL_PROFILING_H_WORKTIME.'&nbsp;
                    <a href="'.$href.'&order=prp_time|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_time|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    <a href="'.$href.'&order=prp_domain|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_domain|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                    &nbsp;'.PL_PROFILING_FILTER_DOMAIN.'&nbsp;
                    <a href="'.$href.'&order=prp_domain|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_domain|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    <a href="'.$href.'&order=prp_ident|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_ident|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                    &nbsp;'.PL_PROFILING_FILTER_PLUGIN.'&nbsp;
                    <a href="'.$href.'&order=prp_ident|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_ident|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    &nbsp;'.PL_PROFILING_FILTER_COMPONENT.'&nbsp;
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    <a href="'.$href.'&order=prp_sql_count|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_sql_count|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                    &nbsp;'.PL_PROFILING_H_SQL_COUNT.'&nbsp;
                    <a href="'.$href.'&order=prp_sql_count|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'prp_sql_count|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
                </nobr>
            </th>
            <th class="header" width="50">
                <nobr>
                    &nbsp;'.PL_PROFILING_H_INIT_URL.'&nbsp;
                </nobr>
            </th>
            <th class="header" width="50">
                &nbsp;
            </th>
        </tr>
    ';
    
    if($result)
    {
        $i=0;
        foreach($result as $row)
        {
            list(, $ident, $time, $sql_count, $uri, $domain, $date, $hash) = $row;
            $class = ($i++ % 2 != 0)? 'even': 'odd';
            $module = $component = PL_PROFILING_UNKNOW;
            if(isset($elems[$ident]))
            {
                $module = $elems[$ident]['plugin'];
                $component = sb_str_replace('|', '->', $elems[$ident]['name']);
            }
            echo '<tr class="'.$class.'">
                <td style="font-size: 10px;text-align: center;">', sb_date('d.m.Y', $date),'<br />',KERNEL_IN,'<br />',sb_date('H:i:s', $date),'</td>
                <td style="font-size: 10px;text-align: center;"><b>',$time,'</b></td>
                <td style="font-size: 10px;text-align: center;"><b>',$domain,'</b></td>
                <td style="font-size: 10px;text-align: center;">',$module,'</td>
                <td style="font-size: 10px;text-align: center;">',$component,'</td>
                <td style="font-size: 10px;text-align: center;">',$sql_count,'</td>
                <td><a href="',$uri,'" target="_blank" style="font-size: 10px;">',chunk_split($uri,70),'</a></td>
                <td><a href="javascript:showQuery(\'',$hash,'\');"><img src="'.SB_CMS_IMG_URL.'/files.png" alt="',PL_PROFILING_SHOW_QUERY,'" title="',PL_PROFILING_SHOW_QUERY,'" border="0" align="absmiddle"></a></td>
            </tr>';
        }
    }
    else
    {
    	$num_list = sb_show_message(PL_PROFILING_NO_ITEMS, true, 'information', true);
    }
    
    echo '</table>';
    echo '<br/>', $num_list, '<br/><br/>';
}

function fProfiling_Components_Clear()
{
    sql_param_query('TRUNCATE TABLE sb_profiler_plugins');
    fProfiling_Components_Read();
}

function fProfiling_Parse_Tracker($tracker)
{
    $html = '<table class="form" width="100%">
        <tr>
            <th class="debug">№</th>
            <th class="debug">'.PL_PROFILING_TRACKER_FUNC.'</th>
            <th class="debug">'.PL_PROFILING_TRACKER_FILE.'</th>
            <th class="debug">'.PL_PROFILING_TRACKER_LINE.'</th>
        </tr>';
    
    if($tracker != '')
    {
        $tracker = unserialize($tracker);
        
        $i = 0;
        foreach($tracker as $item)
        {
            $class = ($i%2 == 0)? 'even_debug' : 'odd_debug';
            
            $html .= '<tr class="'.$class.'">
                <td>'.(++$i).'</td>
                <td>'.$item['function'].'</td>
                <td>'.$item['file'].'</td>
                <td>'.$item['line'].'</td>
            </tr>';
        }
        $html .= '</table>';
        
        return $html;
    }
}
?>
