<?php
require_once(SB_CMS_LANG_PATH.'/pl_redirect.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_redirect', PL_REDIRECT_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/pl_redirect.doc'))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_REDIRECT_H_PLUGIN_NAME, 'init');
	
	if ($_SESSION['sbPlugins']->isRightAvailable('pl_redirect', '404_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_ADMIN.'>'.KERNEL_MENU_LOGS.'>'.PL_REDIRECT_H_404_TITLE, '404_read', 'pl_redirect_404_24.png');
	}
	
	$_SESSION['sbPlugins']->addToMainPage('info', PL_REDIRECT_H_404_TITLE, SB_CMS_IMG_URL.'/plugins/pl_redirect_404_16.png');
	
    $_SESSION['sbPlugins']->addUserEvent('init', 'fRedirect_Init', 'read', PL_REDIRECT_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('edit', 'fRedirect_Edit', 'read', PL_REDIRECT_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fRedirect_Edit_Submit', 'elems_edit', PL_REDIRECT_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('set_active', 'fRedirect_Set_Active', 'elems_edit');
    
    $_SESSION['sbPlugins']->addUserEvent('404_read', 'fRedirect_404_Read', '404_read', PL_REDIRECT_H_404_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('404_excel', 'fRedirect_404_Excel', '404_read');
	$_SESSION['sbPlugins']->addUserEvent('404_archive', 'fRedirect_404_Archive', 'read', PL_REDIRECT_H_404_ARCHIVE_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('404_archive_delete', 'fRedirect_404_Archive_Delete', '404_read');
	$_SESSION['sbPlugins']->addUserEvent('404_archive_view', 'fRedirect_404_Archive_View', '404_read');
	$_SESSION['sbPlugins']->addUserEvent('404_archive_excel', 'fRedirect_404_Archive_Excel', '404_read');
	
    $_SESSION['sbPlugins']->addSystemEvent('info', 'fRedirect_404_Info');
    $_SESSION['sbPlugins']->addSystemEvent('404_get_list', 'fRedirect_404_Get_List', PL_REDIRECT_H_404_TITLE);
    
    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_404_log_delim', PL_REDIRECT_H_404_TITLE, '', '', '', 'all');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_404_log_date', PL_REDIRECT_H_404_SETTING_DATE, 'number', '', '60', 'all');
    
	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_404_log_user_delim', PL_REDIRECT_H_404_TITLE, '', '');
	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_404_log_main_page_count', PL_REDIRECT_H_404_USER_SETTING_COUNT, 'number', '', '7');
}

$_SESSION['sbPlugins']->addToCron('pl_redirect/cron/pl_redirect.php', 'fRedirect_Create_Archive', PL_REDIRECT_H_404_CRON_TITLE, PL_REDIRECT_H_404_CRON_DESCR);

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('404_read', PL_REDIRECT_H_404_RIGHTS_DESCR);
?>