<?php
function fRedirect_404_Info()
{
    $res = sql_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $u_domains) = $res[0];
    
    if ($u_admin != 1)
    {
    	$u_domains = explode(',', $u_domains);
    }
    
    $result = sql_query('SELECT l_id, l_domain, l_url FROM sb_404_log {WHERE l_domain IN (?a)} ORDER BY l_date DESC LIMIT '.max(1, sbPlugins::getUserSetting('sb_404_log_main_page_count')), ($u_admin != 1 ? $u_domains : SB_SQL_SKIP));

    if ($result)
    {
        echo '<table width="100%" cellspacing="0" cellpadding="5" class="form" style="border: 0;">';

        for($i = 0; $i < count($result); $i++)
        {
            list($l_id, $l_domain, $l_url) = $result[$i];

            if (sb_strlen($l_url) > 50)
            	$url = sb_substr($l_url, 0, 50).' ...';
            else
            	$url = $l_url;
            		
            echo '<tr '.($i % 2 == 0 ? 'class="odd"' : 'class="even"').'>
                    <td align="center" width="30">
                        <img src="'.SB_CMS_IMG_URL.'/warning_log.png" \>
                    </td>
                    <td>
                        <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_init&l_id='.$l_id.'" title="http://'.$l_domain.'/'.$l_url.'">http://'.$l_domain.'/'.$url.'</a>
                    </td>
                </tr>';
        }

        echo '</table><br />
        <div class="sbDS_more"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_redirect_404_read">'.KERNEL_MORE.'</a></div>';
    }
    else
    {
        echo '<div align="center" style="padding: 10px;">'.PL_REDIRECT_INC_NO_PAGES.'</div>';
    }
}

function fRedirect_404_Get_List()
{
	echo '<style type="text/css">
    	#event_content table.form tr.even:hover,
		#event_content table.form tr.odd:hover
		{
		    background-color: #E1FFE1;
		}
		
		#event_content
		{
			overflow-x: auto;
		}
	</style>
    <script>
    function showFilter()
    {
        var filter = sbGetE("sb_filter");
        var filter_arr = sbGetE("filter_arrow");
        if (!filter) return;
        if (filter.style.display == "none")
        {
            filter.style.display = "";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
        }
        else
        {
            filter.style.display = "none";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
        }
    }
    function setFilter()
    {
        var str = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_redirect_404_get_list'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
        var found = false;
        var frm = sbGetE("filter_form");
        for (var i = 0; i < frm.elements.length; i++)
        {
            var el = frm.elements[i];
            if (el.type == "select-one")
            {
                if (el.value != -1)
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
            else
            {
                if (el.name != "" && el.value != "")
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
        }
        if (!found)
        {
            return false;
        }

        window.location = str;
        return false;
    }
    function removeFilter(e)
    {
        window.location = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_redirect_404_get_list'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'&l_domain='.$_GET['l_domain'].'";
        return sbCancelEvent(e);
    }
    function refreshJournal()
    {
    	window.location = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_redirect_404_get_list'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').(isset($_GET['l_date_from']) ? '&l_date_from='.$_GET['l_date_from'] : '').(isset($_GET['l_date_to']) ? '&l_date_to='.$_GET['l_date_to'] : '').(isset($_GET['l_ip']) ? '&l_ip='.$_GET['l_ip'] : '').(isset($_GET['l_domain']) ? '&l_domain='.$_GET['l_domain'] : '').(isset($_GET['l_url']) ? '&l_url='.$_GET['l_url'] : '').'";
    }
    function selectURL(url)
    {
    	sbReturnValue(url);
    }
    </script>';

	$time = time() - intval(sbPlugins::getSetting('sb_404_log_date')) * 24 * 60 * 60;
    sql_query('DELETE FROM sb_404_log WHERE l_date < '.$time);
        
    if (!isset($_GET['order']))
    {
        $_GET['order'] = 'l_date|desc';
    }
    else
    {
        $_GET['order'] = preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']);
        if (empty($_GET['order']))
            $_GET['order'] = 'l_date|desc';
    }

    $order_str = explode('|', $_GET['order']);
    if ($_GET['order'] != 'l_date|desc' && count($order_str) == 2)
    {
        $order_str = 'ORDER BY l.'.$order_str[0].' '.strtoupper($order_str[1]).', l.l_date DESC';
    }
    else 
    {
    	$order_str = 'ORDER BY l.l_date DESC';
    }

    $filter_str = '';
    if (isset($_GET['l_date_from']) && !empty($_GET['l_date_from']))
    {
        $_GET['l_date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_from']);
        $date_time = explode(' ', $_GET['l_date_from']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND l.l_date >= '.sb_datetoint($_GET['l_date_from']);
        }
    }

    if (isset($_GET['l_date_to']) && !empty($_GET['l_date_to']))
    {
        $_GET['l_date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_to']);
        $date_time = explode(' ', $_GET['l_date_to']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND l.l_date <= '.sb_datetoint($_GET['l_date_to']);
        }
    }

    if (isset($_GET['l_ip']) && !empty($_GET['l_ip']))
    {
        $_GET['l_ip'] = preg_replace('/[^0-9\.]+/', '', $_GET['l_ip']);
        if (!empty($_GET['l_ip']))
            $filter_str .= ' AND l.l_ip LIKE "'.$_GET['l_ip'].'%"';
    }

    if (isset($_GET['l_domain']) && !empty($_GET['l_domain']))
    {
        $_GET['l_domain'] = preg_replace('/[^a-zA-Z0-9\-\.]+/', '', $_GET['l_domain']);

        if (!empty($_GET['l_domain']))
            $filter_str .= ' AND l.l_domain = "'.$_GET['l_domain'].'"';
    }

	if (isset($_GET['l_url']) && !empty($_GET['l_url']))
    {
        $filter_str .= ' AND l.l_url LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['l_url']).'%');
    }
    
    $href = SB_CMS_MODAL_DIALOG_FILE.'?event=pl_redirect_404_get_list';
    
    foreach ($_GET as $key => $value)
    {
        if ($key != 'event')
        {
            if (!is_array($value))
            {
                if ($key != 'order')
                {
                    $href .= '&'.$key.'='.urlencode($value);
                }
            }
            else
            {
                foreach ($value as $value2)
                {
                    if ($key != 'order')
                    {
                        $href .= '&'.$key.'[]'.'='.urlencode($value2);
                    }
                }
            }
        }
    }

    echo '
    <table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
        	<table cellpadding="0" cellspacing="0">
        	<tr>
            	<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.($filter_str != '' ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" /></span></td>
            	<td class="sb_filter_on" id="sb_filter_on" style="'.($filter_str != '' ? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
            </tr></table>
        </td>
    </tr>
    <tr><td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter"'.($filter_str != '' ? '' : ' style="display:none;"').'>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">'.PL_REDIRECT_INC_404_DATE.':</th>
                <td class="sb_filter_td"><nobr>';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $fld_lo = new sbLayoutDate((isset($_GET['l_date_from']) ? $_GET['l_date_from'] : ''), 'l_date_from');
    $fld_lo->mDropButton = true;
    
    $fld_hi = new sbLayoutDate((isset($_GET['l_date_to']) ? $_GET['l_date_to'] : ''), 'l_date_to');
    $fld_hi->mDropButton = true;
    
    echo $fld_lo->getJavaScript().
    	'<table cellpadding="0" cellspacing="0"><tr><td>'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld_lo->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld_hi->getField().'</td></tr></table>
    	</nobr>
                </td>
                <th class="sb_filter_th">'.PL_REDIRECT_INC_404_DOMAIN.':</th>
                <td class="sb_filter_td_noborder">';
    
    require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();
    
    $options = array('-1' => ' --- ');
    $u_domains = array();
    foreach ($GLOBALS['sb_domains'] as $domain => $value)
    {
        $options[$domain] = $idn->decode($domain);
        $u_domains[] = $domain;
    }
    
    $fld = new sbLayoutSelect($options, 'l_domain', '', 'disabled="disabled"');
    if (isset($_GET['l_domain']))
        $fld->mSelOptions[] = $_GET['l_domain'];
    echo $fld->getField();
                            
    echo '      </td>
            </tr>
            <tr>
                <th class="sb_filter_th">'.PL_REDIRECT_INC_404_IP.':</th>
                <td class="sb_filter_td">';
    
    $fld = new sbLayoutInput('text', isset($_GET['l_ip']) ? $_GET['l_ip'] : '', 'l_ip', '', 'style="width: 100%;"');
    echo $fld->getField();
    
    echo '      </td>
                <th class="sb_filter_th">'.PL_REDIRECT_INC_404_URL.':</th>
                <td class="sb_filter_td_noborder">';
    
    $fld = new sbLayoutInput('text', isset($_GET['l_url']) ? $_GET['l_url'] : '', 'l_url', '', 'style="width: 100%;"');
    echo $fld->getField();
    
    echo '      </td>
            </tr>
            </table>
            <div class="sb_filter_footer">
                    <input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;
            </div>
            </div>
            </form>
        </table>
    </td></tr></table>
    <br>
    <center>
    <div align="right" style="width:95%">
    <a href="javascript:refreshJournal();"><img src="'.SB_CMS_IMG_URL.'/link.png" width="12" height="12" border="0" align="absmiddle">&nbsp;'.PL_REDIRECT_INC_404_REFRESH.'</a>
	</div>';
    
    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
    
    $res = sql_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $domains) = $res[0];
    
    $total = true;
    $pager = new sbDBPager('l', 7, 25, 'thisDialog');
    
    if ($u_admin != 1)
    {
        $u_domains = explode(',', $domains);
        $result = $pager->init($total, 'SELECT l.l_date, l.l_count, l.l_ip, l.l_url, l.l_domain FROM sb_404_log l WHERE l.l_domain IN (?a) '.$filter_str.' '.$order_str, $u_domains);
    }
	else 
	{
		$result = $pager->init($total, 'SELECT l.l_date, l.l_count, l.l_ip, l.l_url, l.l_domain FROM sb_404_log l '.($filter_str != '' ? 'WHERE '.substr($filter_str, 5) : '').' '.$order_str);
	}

    $num_list = $pager->show();
    
    echo '<br>'.$num_list.'<br><br>
    <table width="98%" cellspacing="0" cellpadding="5" class="form">
    <tr>
        <th class="header" width="50">
            &nbsp;
        </th>
        <th class="header" width="150">
            <table cellpadding="2" cellspacing="0" width="100%">
            <tr style="background-color: transparent;">
            	<td><a href="'.$href.'&order=l_date|asc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_date|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a></td>
            	<th class="header" style="background-image: none;">
		            <nobr>
		                &nbsp;'.PL_REDIRECT_INC_404_DATE.'&nbsp;
		            </nobr>
		        </th>
		        <td><a href="'.$href.'&order=l_date|desc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_date|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a></td>
		    </tr>
		    </table>
        </th>
        <th class="header" width="150">
        	<table cellpadding="2" cellspacing="0" width="100%">
            <tr style="background-color: transparent;">
            	<td><a href="'.$href.'&order=l_ip|asc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_ip|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a></td>
            	<th class="header" style="background-image: none;">
		            <nobr>
		                &nbsp;'.PL_REDIRECT_INC_404_IP.'&nbsp;
		            </nobr>
		        </th>
		        <td><a href="'.$href.'&order=l_ip|desc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_ip|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></td>
		    </tr>
		    </table>
        </th>
        <th class="header" width="100" style="padding-top: 14px;">
            <nobr>
                <a href="'.$href.'&order=l_count|asc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_count|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                &nbsp;'.PL_REDIRECT_INC_404_COUNT.'&nbsp;
                <a href="'.$href.'&order=l_count|desc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_count|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" width="100" style="padding-top: 14px;">
            <nobr>
                <a href="'.$href.'&order=l_domain|asc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_domain|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                &nbsp;'.PL_REDIRECT_INC_404_DOMAIN.'&nbsp;
                <a href="'.$href.'&order=l_domain|desc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_domain|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" style="padding-top: 14px;">
            <nobr>
                <a href="'.$href.'&order=l_url|asc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_url|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
                &nbsp;'.PL_REDIRECT_INC_404_URL.'&nbsp;
                <a href="'.$href.'&order=l_url|desc" target="thisDialog"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'l_url|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
            </nobr>
        </th>
    </tr>';

    if ($result)
    {
        /**
         * Вывод таблицы
         */
        for($i = 0; $i < count($result); $i++)
        {
            list($l_date, $l_count, $l_ip, $l_url, $l_domain) = $result[$i];

            $l_idn_domain = $idn->decode($l_domain);
            
            echo '<tr'.($i % 2 != 0 ? ' class="even"' : ' class="odd"').' onclick="selectURL(\'http://'.$l_domain.'/'.$l_url.'\')" title="'.KERNEL_CHOOSE.'">
                    <td style="text-align:center;">
                        <img src="'.SB_CMS_IMG_URL.'/warning_log.png" \>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        '.sb_date('d.m.Y', $l_date).'<br />'.KERNEL_IN.'<br />'.sb_date('H:i:s', $l_date).'
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        '.$l_ip.'
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>'.$l_count.'</b>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>'.$l_idn_domain.'</b>
                    </td>
                    <td>
                    	<div class="hint_div">http://'.$l_idn_domain.'/'.$l_url.'</div>
            		</td>
                </tr>';
        }
    }
    else
    {
        $num_list = PL_REDIRECT_INC_404_NO_MESSAGES;
    }

    echo '</table>
          <br>'.$num_list.'<br /><br /><a href="#" onclick="sbCloseDialog();">[ '.KERNEL_CLOSE.' ]</a></center>';
}

function fRedirect_Get_Domain_Name($cat_id, $cat_title, $cat_level, $cat_rubrik, $cat_closed)
{
	if ($cat_level == 1)
	{
		require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();
    
    	$cat_title = $idn->decode($cat_title);
	}

	return $cat_title;
}
?>