<?php
require_once(SB_CMS_LANG_PATH.'/pl_rss.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_rss', PL_RSS_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_RSS_H_SUB_MENU.'>'.PL_RSS_H_PLUGIN_NAME, 'init');
	
	$_SESSION['sbPlugins']->addUserEvent('init', 'fRss_Init', 'read', PL_RSS_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fRss_Edit', 'read', PL_RSS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fRss_Edit_Submit', 'elems_edit', PL_RSS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('set_active', 'fRss_Set_Active', 'elems_edit');
	
	$_SESSION['sbPlugins']->addUserEvent('get_channel_info', 'fRss_Get_Channel_Info', 'read');
	$_SESSION['sbPlugins']->addUserEvent('get_channel_props', 'fRss_Get_Channel_Props', 'read');
	$_SESSION['sbPlugins']->addUserEvent('get_fields', 'fRss_Get_Fields', 'read');

	$_SESSION['sbPlugins']->addUserEvent('refresh', 'fRss_Refresh', 'elems_refresh');
}

$_SESSION['sbPlugins']->addToCron('pl_rss/cron/pl_rss.php', 'fRss_Cron_Refresh', PL_RSS_H_CRON_TITLE, PL_RSS_H_CRON_DESCR);

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_edit', PL_RSS_ELEMS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_delete', PL_RSS_ELEMS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_refresh', PL_RSS_ELEMS_REFRESH_RIGHT);
?>