<?php
/********************************** функции построения диалоговых окон ***********************************/

function fSearch_Get_Elem_Form()
{
	$params = unserialize($_GET['params']);
	echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SEARCH_H_ELEM_FORM_NO_TEMPS_ALERT.'");
                return;
            }

			params["page"] = sbGetE("page").value;

			res.temp_id = el_temp.value;
			res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    </script>';

    echo '<br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '150';

    $layout->addHeader(PL_SEARCH_H_FORM_ELEM);

    $res = sql_query('SELECT categs.cat_title, temps.sstf_id, temps.sstf_title FROM sb_categs categs, sb_catlinks links, sb_search_temps_form temps WHERE temps.sstf_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_search_design_search_form" ORDER BY categs.cat_left, temps.sstf_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }

        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

        $layout->addField(PL_SEARCH_H_TEMP, $fld);
    }
    else 
    {
		$layout->addField(PL_SEARCH_H_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_SEARCH_H_ELEM_FORM_NO_TEMPS_MSG.'</div>', '', '', false));
    }

	$fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width:450px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_SEARCH_H_ELEM_RESULT_PAGE_HINT.'</div>';
	$layout->addField(PL_SEARCH_H_ELEM_FORM_PAGE, $fld);

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show();
}

function fSearch_Get_Elem_Results()
{
	$params = unserialize($_GET['params']);
	echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SEARCH_H_ELEM_RESULTS_NO_TEMPS_ALERT.'");
                return;
            }

			var ss_id = sbGetE("ss_id");
            if (ss_id)
            {
				params["ss_id"] = ss_id.value;
			}
			else

            {
				alert("'.PL_SEARCH_H_ELEM_RESULTS_NO_DOMAIN_ALERT.'");
                return;
            }

            params["sort"] = sbGetE("sort").value;
            params["order"] = sbGetE("order").value;
            params["partial_matching"] = sbGetE("partial_matching").checked ? 1 : 0;

			res.temp_id = el_temp.value;
			res.params = sb_serialize(params);
			sbReturnValue(res);
		}
	</script>';
	echo '<br /><br />';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout();
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '150';

	$layout->addHeader(PL_SEARCH_H_RESULTS_ELEM);

	$res = sql_query('SELECT categs.cat_title, temps.sstr_id, temps.sstr_title FROM sb_categs categs, sb_catlinks links, sb_search_temps_results temps WHERE temps.sstr_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_search_design_results" ORDER BY categs.cat_left, temps.sstr_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }

        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

        $layout->addField(PL_SEARCH_H_TEMP, $fld);
    }
    else 
    {
		$layout->addField(PL_SEARCH_H_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_SEARCH_H_ELEM_RESULTS_NO_TEMPS_MSG.'</div>', '', '', false));
    }

	$res = sql_query('SELECT ss_id, ss_domains FROM sb_search');
	if($res)
	{
		$options = array();
		foreach ($res as $value)
		{
			list($ss_id, $ss_domains) = $value;
			$options[$ss_id] = trim($ss_domains);
        }

		$fld = new sbLayoutSelect($options, 'ss_id');
		$fld->mSelOptions = isset($params['ss_id']) ? array($params['ss_id']) : array();

		$layout->addField(PL_SEARCH_H_DOMAIN, $fld);
    }
	else
    {
		$layout->addField(PL_SEARCH_H_DOMAIN, new sbLayoutLabel('<div class="hint_div">'.PL_SEARCH_H_ELEM_RESULTS_NO_DOMAINS_MSG.'</div>', '', '', false));
    }

    $fields = array('relevancy' => PL_SEARCH_H_SORT_BY_RELEVANCY,
    				 'count' => PL_SEARCH_H_SORT_BY_COUNT);
    
    $order = array('DESC' => PL_SEARCH_H_SORT_DESC, 
                   'ASC'  => PL_SEARCH_H_SORT_ASC);
    
	$fld1 = new sbLayoutSelect($fields, 'sort');
    $fld1->mSelOptions = array((isset($params['sort']) ? $params['sort'] : 'relevancy'));
    $fld2 = new sbLayoutSelect($order, 'order');
    $fld2->mSelOptions = array((isset($params['order']) && $params['order'] != '' ? $params['order'] : 'DESC'));
    $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

    $layout->addField(PL_SEARCH_H_SORT_BY, $fld1);

    $layout->addField('', new sbLayoutDelim());
	$layout->addField(PL_SEARCH_H_ELEM_RESULTS_PARTIAL_MATCHING, new sbLayoutInput('checkbox', '1', 'partial_matching', '', (isset($params['partial_matching']) && $params['partial_matching'] == 1 ? 'checked="checked"' : '')));
    
	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
	$layout->show();
}

/********************************** функции получения информации по элементам модуля ***********************************/

function fSearch_Elem_Form_Info($params)
{
	$res = sql_param_query('SELECT categs.cat_title, temps.sstf_title
                    FROM sb_categs categs, sb_catlinks links, sb_search_temps_form temps
                    WHERE temps.sstf_id=?d
                    AND links.link_el_id=temps.sstf_id
                    AND categs.cat_id=links.link_cat_id
                    AND categs.cat_ident="pl_search_design_search_form"', $params['temp_id']);

	echo '<div style="padding-bottom: 5px;"><b>'.PL_SEARCH_H_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SEARCH_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
			<div style="padding-bottom: 5px;"><b>'.PL_SEARCH_H_ELEM_FORM_PAGE.':</b> '.(isset($params['page']) && $params['page'] != '' ? $params['page'] : '').'</div>';
}

function fSearch_Elem_Results_Info($params)
{
	$res = sql_param_query('SELECT categs.cat_title, temps.sstr_title
                    FROM sb_categs categs, sb_catlinks links, sb_search_temps_results temps
                    WHERE temps.sstr_id=?d
                    AND links.link_el_id=temps.sstr_id
                    AND categs.cat_id=links.link_cat_id
                    AND categs.cat_ident="pl_search_design_results"', $params['temp_id']);

	if(isset($params['ss_id']))
	{
		$res_domain = sql_param_query('SELECT ss_domains FROM sb_search WHERE ss_id = ?d', $params['ss_id']);
	}

	if (!isset($params['sort']))
		$params['sort'] = 'relevancy';
		
	if (!isset($params['order']))
		$params['order'] = 'DESC';
		
	echo '<div style="padding-bottom: 5px;"><b>'.PL_SEARCH_H_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SEARCH_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
		<div style="padding-bottom: 5px;"><b>'.PL_SEARCH_H_DOMAIN.':</b> '.(isset($res_domain[0][0]) ? $res_domain[0][0] : '').'</div>
		<div style="padding-bottom: 5px;"><b>'.PL_SEARCH_H_SORT_BY.':</b> '.($params['sort'] == 'relevancy' ? PL_SEARCH_H_SORT_BY_RELEVANCY : PL_SEARCH_H_SORT_BY_COUNT).' '.($params['order'] == 'DESC' ? PL_SEARCH_H_SORT_DESC : PL_SEARCH_H_SORT_ASC).'</div>';
}

/********************************** функции получения элементов модуля ***********************************/

function fSearch_Elem_Form_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_search/prog/pl_search.php';\n
		fSearch_Elem_Form('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
}

function fSearch_Elem_Results_Prog($el_id, $temp_id, $params, $tag_id)
{
	return "<?php include_once SB_CMS_PL_PATH.'/pl_search/prog/pl_search.php';\n
		fSearch_Elem_Results('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
}

?>