<?php
require_once(SB_CMS_LANG_PATH.'/pl_services_cb.h.lng.php');

if($_SESSION['sbPlugins']->register('pl_services_cb', PL_SERVICES_CB_H_PLUGIN_NAME, ''))
{
    if ($_SESSION['sbPlugins']->isRightAvailable('pl_services_cb', 'design_read'))
    {
		$_SESSION['sbPlugins']->addToMenu (KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SERVICES_CB_H_PLUGIN_NAME.'>'.PL_SERVICES_CB_K_H_PLUGIN_NAME, 'design_init&serv_id=k', 'pl_services_cb_k_24.png');
		$_SESSION['sbPlugins']->addToMenu (KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SERVICES_CB_H_PLUGIN_NAME.'>'.PL_SERVICES_CB_DME_H_PLUGIN_NAME, 'design_init&serv_id=dme', 'pl_services_cb_dme_24.png');
		$_SESSION['sbPlugins']->addToMenu (KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SERVICES_CB_H_PLUGIN_NAME.'>'.PL_SERVICES_CB_MR_H_PLUGIN_NAME, 'design_init&serv_id=mr', 'pl_services_cb_mr_24.png');
		$_SESSION['sbPlugins']->addToMenu (KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SERVICES_CB_H_PLUGIN_NAME.'>'.PL_SERVICES_CB_DEPOZ_H_PLUGIN_NAME, 'design_init&serv_id=depoz', 'pl_services_cb_depoz_24.png');
		$_SESSION['sbPlugins']->addToMenu (KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SERVICES_CB_H_PLUGIN_NAME.'>'.PL_SERVICES_CB_SVOP_H_PLUGIN_NAME, 'design_init&serv_id=svop', 'pl_services_cb_svop_24.png');
		$_SESSION['sbPlugins']->addToMenu (KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SERVICES_CB_H_PLUGIN_NAME.'>'.PL_SERVICES_CB_MONET_H_PLUGIN_NAME, 'design_init&serv_id=monet', 'pl_services_cb_monet_24.png');
    }
	
	$_SESSION['sbPlugins']->addUserEvent ('design_init', 'fServices_Cb_Temps', 'design_read', PL_SERVICES_CB_H_DESIGN_LIST);
	$_SESSION['sbPlugins']->addUserEvent ('design_edit', 'fServices_Cb_Temps_Edit', 'design_read', PL_SERVICES_CB_H_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent ('design_edit_submit', 'fServices_Cb_Temps_Edit_Submit', 'design_edit', PL_SERVICES_CB_H_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent ('design_delete', 'fServices_Cb_Temps_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addToCache();
}

$_SESSION['sbPlugins']->addToCron('pl_services_cb/prog/pl_services_cb.php', 'fServices_cb_Get_K', PL_SERVICES_CB_H_K_CRON, PL_SERVICES_CB_H_K_CRON_DESCR);
$_SESSION['sbPlugins']->addToCron('pl_services_cb/prog/pl_services_cb.php', 'fServices_cb_Get_Dme', PL_SERVICES_CB_H_DME_CRON, PL_SERVICES_CB_H_DME_CRON_DESCR);
$_SESSION['sbPlugins']->addToCron('pl_services_cb/prog/pl_services_cb.php', 'fServices_cb_Get_Mr', PL_SERVICES_CB_H_MR_CRON, PL_SERVICES_CB_H_MR_CRON_DESCR);
$_SESSION['sbPlugins']->addToCron('pl_services_cb/prog/pl_services_cb.php', 'fServices_cb_Get_Depoz', PL_SERVICES_CB_H_DEPOZ_CRON, PL_SERVICES_CB_H_DEPOZ_CRON_DESCR);
$_SESSION['sbPlugins']->addToCron('pl_services_cb/prog/pl_services_cb.php', 'fServices_cb_Get_Svop', PL_SERVICES_CB_H_SVOP_CRON, PL_SERVICES_CB_H_SVOP_CRON_DESCR);
$_SESSION['sbPlugins']->addToCron('pl_services_cb/prog/pl_services_cb.php', 'fServices_cb_Get_Monet', PL_SERVICES_CB_H_MONET_CRON, PL_SERVICES_CB_H_MONET_CRON_DESCR);

$_SESSION['sbPlugins']->addSystemEvent('elem_k', 'fServices_cb_Get_Elem_K', PL_SERVICES_CB_H_K);
$_SESSION['sbPlugins']->addSystemEvent('elem_dme', 'fServices_cb_Get_Elem_Dme', PL_SERVICES_CB_H_DME);
$_SESSION['sbPlugins']->addSystemEvent('elem_mr', 'fServices_cb_Get_Elem_Mr', PL_SERVICES_CB_H_MR);
$_SESSION['sbPlugins']->addSystemEvent('elem_depoz', 'fServices_cb_Get_Elem_Depoz', PL_SERVICES_CB_H_DEPOZ);
$_SESSION['sbPlugins']->addSystemEvent('elem_svop', 'fServices_cb_Get_Elem_Svop', PL_SERVICES_CB_H_SVOP);
$_SESSION['sbPlugins']->addSystemEvent('elem_monet', 'fServices_cb_Get_Elem_Monet', PL_SERVICES_CB_H_MONET);

$_SESSION['sbPlugins']->addElem(PL_SERVICES_CB_H_K, 'k', 'fServices_cb_Elem_K', 'fServices_cb_Get_Elem_Info', 'elem_k', 720, 250, 'design_edit', 'pl_services_cb_k');
$_SESSION['sbPlugins']->addElem(PL_SERVICES_CB_H_DME, 'dme', 'fServices_cb_Elem_Dme', 'fServices_cb_Get_Elem_Info', 'elem_dme', 720, 250, 'design_edit', 'pl_services_cb_dme');
$_SESSION['sbPlugins']->addElem(PL_SERVICES_CB_H_MR, 'mr', 'fServices_cb_Elem_Mr', 'fServices_cb_Get_Elem_Info', 'elem_mr', 720, 250, 'design_edit', 'pl_services_cb_mr');
$_SESSION['sbPlugins']->addElem(PL_SERVICES_CB_H_DEPOZ, 'depoz', 'fServices_cb_Elem_Depoz', 'fServices_cb_Get_Elem_Info', 'elem_depoz', 720, 250, 'design_edit', 'pl_services_cb_depoz');
$_SESSION['sbPlugins']->addElem(PL_SERVICES_CB_H_SVOP, 'svop', 'fServices_cb_Elem_Svop', 'fServices_cb_Get_Elem_Info', 'elem_svop', 720, 250, 'design_edit', 'pl_services_cb_svop');
$_SESSION['sbPlugins']->addElem(PL_SERVICES_CB_H_MONET, 'monet', 'fServices_cb_Elem_Monet', 'fServices_cb_Get_Elem_Info', 'elem_monet', 720, 250, 'design_edit', 'pl_services_cb_monet');

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);

?>