<?php

/********************************** функции построения диалоговых окон ***********************************/

/**
 * Вывод окна макетов курса валют 
 *
 */
function fServices_cb_Get_Elem_K ()
{
    $params = unserialize($_GET['params']);

	echo '
	<script language="JavaScript">
    	function chooseCat()
        {
        	var res = new Object();
            var params = new Array();

            params["cat_ident"] = "pl_services_cb_k";

    		var el_temps = sbGetE("temps");
            if (el_temps)
            {
                params["temp_id"] = el_temps.value;
            }
            else
            {
                alert("'.PL_SERVICES_CB_K_H_NO_TEMPS_MSG.'");
                return;
            }

            var get_el = sbGetE("get_next_day_kurs");
            params["get_next_day_kurs"] = get_el.checked ? 1 : 0; 
            
            res.temp_id = el_temps.value;
            res.params = sb_serialize(params);
            
            sbReturnValue(res);
        }
	</script><br /><br />';
    
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '200';
	$layout->addHeader(PL_SERVICES_CB_H_K);

	$res = sql_query('SELECT categs.cat_title, services.ssct_id, services.ssct_title FROM sb_categs categs, sb_catlinks links, sb_services_cb_temps services WHERE services.ssct_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_services_cb_k" ORDER BY categs.cat_left, services.ssct_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;                
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temps');
        $fld->mSelOptions = array($params['temp_id'], $params['cat_ident']);
        $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, $fld);
    }
	else
	{
		$layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, new sbLayoutLabel('<div class="hint_div">'.PL_SERVICES_CB_K_H_NO_TEMPS_LABEL.'</div>', '', '', false));
	}

	$layout->addField(PL_SERVICES_CB_H_GET_NEXT_KURS_TITLE, new sbLayoutInput('checkbox', '1', 'get_next_day_kurs', '', (isset($params['get_next_day_kurs']) && $params['get_next_day_kurs'] == 1 ? 'checked="checked"' : '')));

	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.($res ? '' : ' disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/**
 * Вывод окна макетов цен драгоценных металлов
 *
 */
function fServices_cb_Get_Elem_Dme ()
{
    $params = unserialize($_GET['params']);

    echo '
	<script language="JavaScript">
    	function chooseCat()
        {
        	var res = new Object();
            var params = new Array();

            params["cat_ident"] = "pl_services_cb_dme";

            var el_temps = sbGetE("temps");
            if (el_temps)
            {
                params["temp_id"] = el_temps.value;
            }
            else
            {
                alert("'.PL_SERVICES_CB_DME_H_NO_TEMPS_MSG.'");
                return;
            }

            res.temp_id = el_temps.value;
            res.params = sb_serialize(params);
            
            sbReturnValue(res);
        }
	</script><br /><br />';
    
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '200';
	$layout->addHeader(PL_SERVICES_CB_H_DME);

	$res = sql_query('SELECT categs.cat_title, services.ssct_id, services.ssct_title FROM sb_categs categs, sb_catlinks links, sb_services_cb_temps services WHERE services.ssct_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_services_cb_dme" ORDER BY categs.cat_left, services.ssct_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;                
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temps');
        $fld->mSelOptions = array($params['temp_id']);
        $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, $fld);
    }
	else 
	{
	    $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, new sbLayoutLabel('<div class="hint_div">'.PL_SERVICES_CB_DME_H_NO_TEMPS_LABEL.'</div>', '', '', false));
	}
	$layout->addField ('', new sbLayoutInput('hidden', 'pl_services_cb_dme', 'cat_id', 'cat_id', '', false));
	
	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/**
 * Вывод окна макетов ставок межбанковского рынка
 *
 */
function fServices_cb_Get_Elem_Mr ()
{
    $params = unserialize($_GET['params']);

    echo '
	<script language="JavaScript">
    	function chooseCat()
        {
        	var res = new Object();
            var params = new Array();

           	params["cat_ident"] = "pl_services_cb_mr";

            var el_temps = sbGetE("temps");
            if (el_temps)
            {
                params["temp_id"] = el_temps.value;
            }
            else
            {
                alert("'.PL_SERVICES_CB_MR_H_NO_TEMPS_MSG.'");
                return;
            }
            res.temp_id = el_temps.value;
            res.params = sb_serialize(params);
            sbReturnValue(res);
        }
	</script><br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '200';
	$layout->addHeader(PL_SERVICES_CB_H_MR);

	$res = sql_query('SELECT categs.cat_title, services.ssct_id, services.ssct_title FROM sb_categs categs, sb_catlinks links, sb_services_cb_temps services WHERE services.ssct_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_services_cb_mr" ORDER BY categs.cat_left, services.ssct_title');
	if ($res)
	{
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;                
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temps');
        $fld->mSelOptions = array($params['temp_id']);
        $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, $fld);
    }
	else 
	{
	    $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, new sbLayoutLabel('<div class="hint_div">'.PL_SERVICES_CB_MR_H_NO_TEMPS_LABEL.'</div>', '', '', false));
	}
	$layout->addField ('', new sbLayoutInput('hidden', 'pl_services_cb_mr', 'cat_id', 'cat_id', '', false));
	
	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/**
 * Вывод окна макетов ставок по депозитным операциям
 *
 */
function fServices_cb_Get_Elem_Depoz ()
{
    $params = unserialize($_GET['params']);

    echo '
	<script language="JavaScript">
    	function chooseCat()
        {
        	var res = new Object();
            var params = new Array();

           	params["cat_ident"] = "pl_services_cb_depoz";

           	var el_temps = sbGetE("temps");
            if (el_temps)
            {
                params["temp_id"] = el_temps.value;
            }
            else
            {
                alert("'.PL_SERVICES_CB_DEPOZ_H_NO_TEMPS_MSG.'");
                return;
            }
            res.temp_id = el_temps.value;
            res.params = sb_serialize(params);
            sbReturnValue(res);
        }
	</script><br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '200';
	$layout->addHeader(PL_SERVICES_CB_H_DEPOZ);

	$res = sql_query('SELECT categs.cat_title, services.ssct_id, services.ssct_title FROM sb_categs categs, sb_catlinks links, sb_services_cb_temps services WHERE services.ssct_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_services_cb_depoz" ORDER BY categs.cat_left, services.ssct_title');
	if ($res)
	{
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;                
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temps');
        $fld->mSelOptions = array($params['temp_id']);
        $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, $fld);
    }
	else 
	{
	    $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, new sbLayoutLabel('<div class="hint_div">'.PL_SERVICES_CB_DEPOZ_H_NO_TEMPS_LABEL.'</div>', '', '', false));
	}
	$layout->addField ('', new sbLayoutInput('hidden', 'pl_services_cb_depoz', 'cat_id', 'cat_id', '', false));
	
	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();

}

/**
 * Вывод окна макетов ставок валютный своп
 *
 */
function fServices_cb_Get_Elem_Svop ()
{
    $params = unserialize($_GET['params']);
    echo '
	<script language="JavaScript">
    	function chooseCat()
        {
        	var res = new Object();
            var params = new Array();
            params["cat_ident"] = "pl_services_cb_svop";

            var el_temps = sbGetE("temps");
            if (el_temps)
            {
                params["temp_id"] = el_temps.value;
            }
            else
            {
                alert("'.PL_SERVICES_CB_SVOP_H_NO_TEMPS_MSG.'");
                return;
            }
            res.temp_id = el_temps.value;
            res.params = sb_serialize(params);
            sbReturnValue(res);
        }
	</script><br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '200';
	$layout->addHeader(PL_SERVICES_CB_H_DEPOZ);

	$res = sql_query('SELECT categs.cat_title, services.ssct_id, services.ssct_title FROM sb_categs categs, sb_catlinks links, sb_services_cb_temps services WHERE services.ssct_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_services_cb_svop" ORDER BY categs.cat_left, services.ssct_title');
	if ($res)
	{
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;                
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temps');
        $fld->mSelOptions = array($params['temp_id']);
        $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, $fld);
    }
	else 
	{
	    $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, new sbLayoutLabel('<div class="hint_div">'.PL_SERVICES_CB_SVOP_H_NO_TEMPS_LABEL.'</div>', '', '', false));
	}
	$layout->addField ('', new sbLayoutInput('hidden', 'pl_services_cb_svop', 'cat_id', 'cat_id', '', false));
	
	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();

}

/**
 * Вывод окна макетов цен инвестиционных монет
 *
 */
function fServices_cb_Get_Elem_Monet ()
{
    $params = unserialize($_GET['params']);
    echo '
	<script language="JavaScript">
    	function chooseCat()
        {
        	var res = new Object();
            var params = new Array();

           	params["cat_ident"] = "pl_services_cb_monet";

           	var el_temps = sbGetE("temps");
            if (el_temps)
            {
                params["temp_id"] = el_temps.value;
            }
            else
            {
                alert("'.PL_SERVICES_CB_MONET_H_NO_TEMPS_MSG.'");
                return;
            }
            res.temp_id = el_temps.value;
            res.params = sb_serialize(params);
            sbReturnValue(res);
        }
	</script><br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '200';
	$layout->addHeader(PL_SERVICES_CB_H_DEPOZ);

	$res = sql_query('SELECT categs.cat_title, services.ssct_id, services.ssct_title FROM sb_categs categs, sb_catlinks links, sb_services_cb_temps services WHERE services.ssct_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_services_cb_monet" ORDER BY categs.cat_left, services.ssct_title');
	if ($res)
	{
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;                
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temps');
        $fld->mSelOptions = array($params['temp_id']);
        $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, $fld);
    }
	else 
	{
	    $layout->addField(PL_SERVICES_CB_H_TEMPS_TITLE, new sbLayoutLabel('<div class="hint_div">'.PL_SERVICES_CB_MONET_H_NO_TEMPS_LABEL.'</div>', '', '', false));
	}
	$layout->addField ('', new sbLayoutInput('hidden', 'pl_services_cb_monet', 'cat_id', 'cat_id', '', false));
	
	$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();

}


/********************************** функции получения информации по элементам модуля ***********************************/

/**
 * Вывод информации о настройках сервисов ЦБ
 * 
 */
function fServices_cb_Get_Elem_Info ($params)
{
    $res = sql_param_query('
    SELECT categs.cat_title, temps.ssct_title FROM sb_categs categs, sb_catlinks links, sb_services_cb_temps temps
		WHERE temps.ssct_id=?d AND links.link_el_id=temps.ssct_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=?'
    , $params['temp_id'], $params['cat_ident']);

   echo '<div style="padding-bottom: 5px;"><b>'.PL_SERVICES_CB_H_TEMPS_TITLE.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SERVICES_CB_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>';
	
}

/******************************************* функции получения элементов модуля ***************************************/

/**
 * Вывод курса валют
 */
function fServices_cb_Elem_K ($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_services_cb/prog/pl_services_cb.php';\n
        fServices_cb_Elem_K('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод цен драгоценных металлов
 */
function fServices_cb_Elem_Dme ($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_services_cb/prog/pl_services_cb.php';\n
        fServices_cb_Elem_Dme ('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод ставок межбанковского рынка
 */
function fServices_cb_Elem_Mr ($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_services_cb/prog/pl_services_cb.php';\n
        fServices_cb_Elem_Mr ('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод ставок по депозитным операциям
 */
function fServices_cb_Elem_Depoz ($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_services_cb/prog/pl_services_cb.php';\n
        fServices_cb_Elem_Depoz ('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод ставок валютный своп
 */
function fServices_cb_Elem_Svop ($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_services_cb/prog/pl_services_cb.php';\n
        fServices_cb_Elem_Svop ('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод цен инвестиционных монет
 */
function fServices_cb_Elem_Monet ($el_id, $temp_id, $params, $tag_id) 
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_services_cb/prog/pl_services_cb.php';\n
        fServices_cb_Elem_Monet ('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}


?>