<?php

/**
 * Функции управления макетами дизайна сервисов ЦБ
 */

function fServices_Cb_Temps_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['ssct_title'].'</a></b>
	<div class="smalltext" style="margin-top:7px;">';

	static $serv_id = null;
	if (is_null($serv_id))
	    $serv_id = preg_replace('/[^a-z]/', '', isset($_GET['serv_id']) ? $_GET['serv_id'] : '');

	static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages))
    {
    	$view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
    }

    if (is_null($view_info_temps))
    {
    	$view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
    }

    $id = intval($args['ssct_id']);
    $pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_services_cb_'.$serv_id.'" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

	$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_services_cb_'.$serv_id.'" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

	if ($pages)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_PAGES.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($pages));
	    for ($i = 0; $i < $num; $i++)
		{
			list($p_id, $p_name) = $pages[$i];
			$result .= ($view_info_pages ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
		}

		if ($num < count($pages))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';

	}
	else
	{
	    $result .= KERNEL_USED_ON_PAGES.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	if ($temps)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_TEMPS.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($temps));
	    for ($i = 0; $i < $num; $i++)
		{
			list($t_id, $t_name) = $temps[$i];
			$result .= ($view_info_temps ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_templates_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
		}

		if ($num < count($temps))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);
		$result .= '</span></td></tr></table>';
	}
	else
	{
		$result .= KERNEL_USED_ON_TEMPS.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}
    $result .= '</div>';
    return $result;
}

function fServices_Cb_Temps ()
{
	$serv_id = preg_replace('/[^a-z]/', '', isset($_GET['serv_id']) ? $_GET['serv_id'] : '');
	$root_name = KERNEL_DESIGN_ROOT_NAME;

	switch($serv_id)
	{
		case('k'):
			$root_name = PL_SERVICES_CB_K_ROOT_NAME; break;
		case('dme'):
			$root_name = PL_SERVICES_CB_DME_ROOT_NAME; break;
		case('mr'):
			$root_name = PL_SERVICES_CB_MR_ROOT_NAME; break;
		case('depoz'):
			$root_name = PL_SERVICES_CB_DEPOZ_ROOT_NAME; break;
		case('svop'):
			$root_name = PL_SERVICES_CB_SVOP_ROOT_NAME; break;
		case('monet'):
			$root_name = PL_SERVICES_CB_MONET_ROOT_NAME; break;
	}

    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	$elems = new sbElements('sb_services_cb_temps', 'ssct_id', 'ssct_title', 'fServices_Cb_Temps_Get', 'pl_services_cb_design_init&serv_id='.$serv_id, 'pl_services_cb_'.$serv_id);
    $elems->mCategsDeleteWithElementsMenu = true;

	$elems->mCategsRootName = $root_name;
	$elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_services_cb_'.$serv_id.'_32.png';

	$elems->addSorting(PL_SERVICES_CB_DESIGN_EDIT_SORT_BY_TITLE, 'ssct_title');
	$elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

	$elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_services_cb_design_edit&serv_id='.$serv_id;
    $elems->mElemsEditDlgWidth = 900;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_services_cb_design_edit&serv_id='.$serv_id;
    $elems->mElemsAddDlgWidth = 900;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mElemsDeleteEvent = 'pl_services_cb_design_delete&serv_id='.$serv_id;

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mElemsUseLinks = false;

	$elems->mElemsJavascriptStr .= '
	      function linkPages(e)
	      {
	          if (!sbSelEl)
	          {
	              var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
	          }
	          else
	              var el_id = sbSelEl.getAttribute("el_id");

	          strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_services_cb_'.$serv_id.'";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
	      }
	      function linkTemps(e)
	      {
	          if (!sbSelEl)
	          {
	              var el = sbEventTarget(e);

	              while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
	          }
	          else
	              var el_id = sbSelEl.getAttribute("el_id");

	          strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_services_cb_'.$serv_id.'";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
	      }';

	$elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
	$elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');

	$elems->init();
}

function fServices_Cb_Temps_Edit ($htmlStr = '', $footerStr = '', $footerLinkStr = '')
{
	$serv_id = preg_replace('/[^a-z]/', '', isset($_GET['serv_id']) ? $_GET['serv_id'] : '');

	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_services_cb_'.$serv_id))
		return;

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$result = sql_param_query ('SELECT ssct_title, ssct_date, ssct_lang, ssct_body, ssct_error
									FROM sb_services_cb_temps WHERE ssct_id=?d ', $_GET['id'] );
		if ($result)
	    {
			list($ssct_title, $ssct_date, $ssct_lang, $ssct_body, $ssct_error) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_SERVICES_CB_DESIGN_EDIT_ERROR, true, 'warning');
	        return;
	    }
	}
	elseif (count($_POST) > 0)
	{
		extract($_POST);
		if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
		$ssct_title = $ssct_body = '';
		$ssct_lang = SB_CMS_LANG;
	    $ssct_date = '{DAY}.{MONTH}.{LONG_YEAR}';
		$ssct_error = PL_SERVICES_CB_NO_CONNECT_CB;

		switch($serv_id)
		{
			case('k'):
				$ssct_body = PL_SERVICES_CB_K_TEMP_TITLE; break;
			case('dme'):
				$ssct_body = PL_SERVICES_CB_DME_TEMP_TITLE; break;
			case('mr'):
				$ssct_body = PL_SERVICES_CB_MR_TEMP_TITLE; break;
			case('depoz'):
				$ssct_body = PL_SERVICES_CB_DEPOZ_TEMP_TITLE; break;
			case('svop'):
				$ssct_body = PL_SERVICES_CB_SVOP_TEMP_TITLE; break;
			case('monet'):
				$ssct_body = PL_SERVICES_CB_MONET_TEMP_TITLE; break;
		}
		$_GET['id'] = '';
	}

	echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("ssct_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_SERVICES_CB_DESIGN_NO_TITLE_MSG.'");
          	         return false;
                }
            }';

	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "'.$footerLinkStr.'";
				sbReturnValue(res);
            }
			sbAddEvent(window, "close", cancel);';
	}

	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_services_cb_design_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_SERVICES_CB_DESIGN_EDIT_TAB1);
	$layout->addHeader(PL_SERVICES_CB_DESIGN_EDIT_TAB1);

	$layout->addField(PL_SERVICES_CB_DESIGN_EDIT_TITLE, new sbLayoutInput('text', $ssct_title, 'ssct_title', '', 'style="width:100%;"', false));
	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea ($ssct_date, 'ssct_date', '', 'style="width:100%; height:80px;"');
	$fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}',  '{SHORT_YEAR}');
	$fld->mValues = array(KERNEL_DAY_TAG, KERNEL_WEEKDAY_TAG_FULL, KERNEL_WEEKDAY_TAG_SHORT, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG, KERNEL_YEAR_4_TAG,  KERNEL_YEAR_2_TAG);
	$layout->addField (PL_SERVICES_CB_DESIGN_EDIT_DATE, $fld);

	$fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'ssct_lang');
	$fld->mSelOptions = array($ssct_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_SERVICES_CB_DESIGN_EDIT_LANG_LABEL.'</div>';
	$layout->addField (PL_SERVICES_CB_DESIGN_EDIT_LANG, $fld);

	$layout->addField ('', new sbLayoutDelim());
	$layout->addField (PL_SERVICES_CB_ERROR_MESSAGE, new sbLayoutInput('text', $ssct_error, 'ssct_error', '', 'style="width:100%;"'));

	$layout->addTab(PL_SERVICES_CB_DESIGN_EDIT_TAB2);
	$layout->addHeader(PL_SERVICES_CB_DESIGN_EDIT_TAB2);

	switch($serv_id)
	{
		case('k'):
				$query_date = sb_date('d/m/Y', time());
				$xml_kurs = simplexml_load_file('http://www.cbr.ru/scripts/XML_daily.asp?date_req='.$query_date);

				$mTags = array('{DATE}');
    			$mValues = array(PL_SERVICES_CB_DESIGN_DATE);

				if (isset($xml_kurs->Valute))
				{
    				foreach($xml_kurs->Valute as $valute)
    				{
    					array_push($mTags,
    							'-',
    							'{NUM_'.$valute->CharCode.'}',
    							'{CHAR_'.$valute->CharCode.'}',
    							'{VALUE_'.$valute->CharCode.'}');

    					$name = SB_CHARSET != 'UTF-8' ? iconv('UTF-8', SB_CHARSET.'//IGNORE', $valute->Name) : $valute->Name;
    					array_push($mValues,
    							$name,
    							PL_SERVICES_CB_K_NUM_CODE,
    							PL_SERVICES_CB_K_CHAR_CODE,
    							PL_SERVICES_CB_K_VALUE_CODE);
    				}
				}

				$fld = new sbLayoutTextarea($ssct_body, 'ssct_body', '', 'style="width:100%; height:400px;"');
				$fld->mTags = $mTags;
				$fld->mValues = $mValues;
				$layout->addField (PL_SERVICES_CB_K_DESIGN_EDIT_ELEM, $fld);
				break;

		case('dme'):
				$fld = new sbLayoutTextarea($ssct_body, 'ssct_body', '', 'style="width:100%; height:400px;"');
				$fld->mTags = array (
							'{DATE}',
							'-', '{AU_BUY}', '{AU_SELL}',
							'-', '{AG_BUY}', '{AG_SELL}',
							'-', '{PT_BUY}', '{PT_SELL}',
							'-', '{PD_BUY}', '{PD_SELL}');
				$fld->mValues = array (
							PL_SERVICES_CB_DESIGN_DATE,
							PL_SERVICES_CB_DME_AURUM, PL_SERVICES_CB_DME_BUY, PL_SERVICES_CB_DME_SELL,
							PL_SERVICES_CB_DME_ARGENTUM, PL_SERVICES_CB_DME_BUY, PL_SERVICES_CB_DME_SELL,
							PL_SERVICES_CB_DME_PLATINUM, PL_SERVICES_CB_DME_BUY, PL_SERVICES_CB_DME_SELL,
							PL_SERVICES_CB_DME_PALLADIUM, PL_SERVICES_CB_DME_BUY, PL_SERVICES_CB_DME_SELL);

				$layout->addField (PL_SERVICES_CB_DME_DESIGN_EDIT_ELEM, $fld);
				break;

		case('mr'):
				$fld = new sbLayoutTextarea($ssct_body, 'ssct_body', '', 'style="width:100%; height:400px;"');
				$fld->mTags = array(
							'{DATE}',
							'-',
							'{MIBID_C1}', '{MIBID_C7}', '{MIBID_C30}', '{MIBID_C90}', '{MIBID_C180}', '{MIBID_C360}',
							'-',
							'{MIBOR_C1}', '{MIBOR_C7}', '{MIBOR_C30}', '{MIBOR_C90}', '{MIBOR_C180}', '{MIBOR_C360}',
							'-',
							'{MIACR_C1}', '{MIACR_C7}', '{MIACR_C30}', '{MIACR_C90}', '{MIACR_C180}', '{MIACR_C360}');
				$fld->mValues = array(
							PL_SERVICES_CB_DESIGN_DATE,
							PL_SERVICES_CB_MR_DESIGN_MIBID,
							PL_SERVICES_CB_MR_DESIGN_C1, PL_SERVICES_CB_MR_DESIGN_C7, PL_SERVICES_CB_MR_DESIGN_C30, PL_SERVICES_CB_MR_DESIGN_C90, PL_SERVICES_CB_MR_DESIGN_C180, PL_SERVICES_CB_MR_DESIGN_C360,
							PL_SERVICES_CB_MR_DESIGN_MIBOR,
							PL_SERVICES_CB_MR_DESIGN_C1, PL_SERVICES_CB_MR_DESIGN_C7, PL_SERVICES_CB_MR_DESIGN_C30, PL_SERVICES_CB_MR_DESIGN_C90, PL_SERVICES_CB_MR_DESIGN_C180, PL_SERVICES_CB_MR_DESIGN_C360,
							PL_SERVICES_CB_MR_DESIGN_MIACR,
							PL_SERVICES_CB_MR_DESIGN_C1, PL_SERVICES_CB_MR_DESIGN_C7, PL_SERVICES_CB_MR_DESIGN_C30, PL_SERVICES_CB_MR_DESIGN_C90, PL_SERVICES_CB_MR_DESIGN_C180, PL_SERVICES_CB_MR_DESIGN_C360);
				$layout->addField (PL_SERVICES_CB_MR_DESIGN_EDIT_ELEM, $fld);
				break;

		case('depoz'):
				$fld = new sbLayoutTextarea($ssct_body, 'ssct_body', '', 'style="width:100%; height:400px;"');
				$fld->mTags = array('{DATE}', '{OVERNIGHT}', '{TOM_NEXT}', '{SPOT_NEXT}', '{P1WEEK}', '{SPOT_WEEK}', '{P2WEEKS}', '{SPOT_2WEEKS}', '{P1MONTH}', '{P3MONTH}');
				$fld->mValues = array (PL_SERVICES_CB_DESIGN_DATE, PL_SERVICES_CB_DEPOZ_DESIGN_OVERNIGHT, PL_SERVICES_CB_DEPOZ_DESIGN_TOM_NEXT, PL_SERVICES_CB_DEPOZ_DESIGN_SPOT_NEXT, PL_SERVICES_CB_DEPOZ_DESIGN_P1WEEK, PL_SERVICES_CB_DEPOZ_DESIGN_SPOT_WEEK, PL_SERVICES_CB_DEPOZ_DESIGN_P2WEEKS, PL_SERVICES_CB_DEPOZ_DESIGN_SPOT_2WEEKS, PL_SERVICES_CB_DEPOZ_DESIGN_P1MONTH, PL_SERVICES_CB_DEPOZ_DESIGN_P3MONTH);
				$layout->addField (PL_SERVICES_CB_DEPOZ_DESIGN_EDIT_ELEM, $fld);
				break;

		case('svop'):
				$fld = new sbLayoutTextarea($ssct_body, 'ssct_body', '', 'style="width:100%; height:400px;"');
				$fld->mTags = array (
									'-',
									'{DATEBUY_USD}', '{DATESELL_USD}', '{BASERATE_USD}', '{SD_USD}', '{TIR_USD}',
									'-',
									'{DATEBUY_EUR}', '{DATESELL_EUR}', '{BASERATE_EUR}', '{SD_EUR}', '{TIR_EUR}');
				$fld->mValues = array (
									PL_SERVICES_CB_SVOP_DESIGN_USD,
									PL_SERVICES_CB_SVOP_DESIGN_DATEBUY_USD, PL_SERVICES_CB_SVOP_DESIGN_DATESELL_USD, PL_SERVICES_CB_SVOP_DESIGN_BASERATE_USD, PL_SERVICES_CB_SVOP_DESIGN_SD_USD, PL_SERVICES_CB_SVOP_DESIGN_TIR_USD,
									PL_SERVICES_CB_SVOP_DESIGN_EUR,
									PL_SERVICES_CB_SVOP_DESIGN_DATEBUY_EUR, PL_SERVICES_CB_SVOP_DESIGN_DATESELL_EUR, PL_SERVICES_CB_SVOP_DESIGN_BASERATE_EUR, PL_SERVICES_CB_SVOP_DESIGN_SD_EUR, PL_SERVICES_CB_SVOP_DESIGN_TIR_EUR);

				$layout->addField (PL_SERVICES_CB_SVOP_DESIGN_EDIT_ELEM, $fld);
				break;

		case('monet'):
				$fld = new sbLayoutTextarea($ssct_body, 'ssct_body', '', 'style="width:100%; height:400px;"');

	            $query_date_end = sb_date('d/m/Y', time());
	            $query_date_start = sb_date('d/m/Y', (time() - (60*60*24*10)));

                $xml = simplexml_load_file('http://www.cbr.ru/scripts/XMLCoinsBase.asp?date_req1='.$query_date_start.'&date_req2='.$query_date_end);

	            $result = $xml->xpath('/CoinsBase/Record[last()]/Date');
	            $result = $xml->xpath('/CoinsBase/Record[Date="'.$result[0][0].'"]');

                $mTags = array('{DATE}',);
				$mValues = array(PL_SERVICES_CB_DESIGN_DATE);

				$num = count($result);
				for ($i = 0; $i < $num; $i++)
				{
				    $code = trim($result[$i]->attributes()->CoinsID);

				    if(isset($GLOBALS['pl_services_cb_monet_design_name'][$code]))
					{
						$coinsid = $GLOBALS['pl_services_cb_monet_design_name'][$code].' ('.$code.')';
					}
					else
					{
						$coinsid =	$code;
					}

					$tag = sb_str_replace('-', '_', trim($result[$i]->attributes()->CoinsID));
					array_push($mTags, '-', '{'.$tag.'_PRICE}', '{'.$tag.'_NOMINAL}', '{'.$tag.'_METALL}', '{'.$tag.'_CLEAN_METALL}');
					array_push($mValues, $coinsid,
                                PL_SERVICES_CB_MONET_DESIGN_PRICE,
                                PL_SERVICES_CB_MONET_DESIGN_NOMINAL,
                                PL_SERVICES_CB_MONET_DESIGN_METALL,
                                PL_SERVICES_CB_MONET_DESIGN_CLEAN_METALL);
				}

				$fld->mTags = $mTags;
				$fld->mValues = $mValues;

				$layout->addField (PL_SERVICES_CB_MONET_DESIGN_EDIT_ELEM, $fld);
				break;
	}

	$layout->addButton('submit', KERNEL_SAVE, 'ssct_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_services_cb', 'design_edit') ? '' : 'disabled="disabled"'));
	if ($_GET['id'] != '')
		$layout->addButton('submit', KERNEL_APPLY, 'ssct_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_services_cb', 'design_edit') ? '' : 'disabled="disabled"'));

    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fServices_Cb_Temps_Edit_Submit()
{
	if (!isset($_GET['id']))
        $_GET['id'] = '';

    $serv_id = preg_replace('/[^a-z]/', '', isset($_GET['serv_id']) ? $_GET['serv_id'] : '');

    // проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_services_cb_'.$serv_id))
		return;

	$text_id = '';
	switch($serv_id)
	{
		case('k'):
			$text_id = PL_SERVICES_CB_K_NAME; break;
		case('dme'):
			$text_id = PL_SERVICES_CB_DME_NAME; break;
		case('mr'):
			$text_id = PL_SERVICES_CB_MR_NAME; break;
		case('depoz'):
			$text_id = PL_SERVICES_CB_DEPOZ_NAME; break;
		case('svop'):
			$text_id = PL_SERVICES_CB_SVOP_NAME; break;
		case('monet'):
			$text_id = PL_SERVICES_CB_MONET_NAME; break;
	}

    $ssct_lang = SB_CMS_LANG;
    $ssct_body = '';
    $ssct_title = '';
    $ssct_date = '';
    $ssct_error = '';

    extract($_POST);

    if ($ssct_title == '')
    {
    	sb_show_message(PL_SERVICES_CB_DESIGN_EDIT_NO_TITLE_MSG, false, 'warning');
    	fServices_Cb_Temps_Edit();
    	return;
    }
    $row = array();
    $row['ssct_title'] = $ssct_title;
    $row['ssct_date'] = $ssct_date;
    $row['ssct_lang'] = $ssct_lang;
    $row['ssct_body'] = $ssct_body;
    $row['ssct_error'] = $ssct_error;

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT ssct_title FROM sb_services_cb_temps WHERE ssct_id=?d', $_GET['id']);
	    if ($res)
	    {
	    	//редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_services_cb_temps SET ?a WHERE ssct_id=?d', $row, $_GET['id'], sprintf(PL_SERVICES_CB_DESIGN_EDIT_OK, $text_id, $old_title));
            sbQueryCache::updateTemplate('sb_services_cb_temps', $_GET['id']);

    	    $footer_ar = fCategs_Edit_Elem('design_edit');
			if (!$footer_ar)
    	    {
    	    	sb_show_message(PL_SERVICES_CB_DESIGN_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_SERVICES_CB_DESIGN_EDIT_SYST_ERROR, $text_id, $old_title), SB_MSG_WARNING);
                fServices_Cb_Temps_Edit();
    		    return;
    	    }
    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	    $row['ssct_id'] = intval($_GET['id']);

            $html_str = fServices_Cb_Temps_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['ssct_apply']))
    	    {
    	    	echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	    	fServices_Cb_Temps_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_SERVICES_CB_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_SERVICES_CB_DESIGN_EDIT_SYST_ERROR, $ssct_title), SB_MSG_WARNING);

            fServices_Cb_Temps_Edit();
		    return;
	    }
	}
	else
	{
		$error = true;
	    if (sql_param_query('INSERT INTO sb_services_cb_temps SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id, 'design_edit'))
    		{
                sbQueryCache::updateTemplate('sb_services_cb_temps', $id);
        		sb_add_system_message(sprintf(PL_SERVICES_CB_DESIGN_ADD_OK, $text_id, $ssct_title));
        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';
        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_services_cb_temps WHERE ssct_id="'.$id.'"');
    		}
	    }
	    if ($error)
	    {
	        sb_show_message(sprintf(PL_SERVICES_CB_DESIGN_ADD_ERROR, $text_id, $ssct_title), false, 'warning');
            sb_add_system_message(sprintf(PL_SERVICES_CB_DESIGN_ADD_SYST_ERROR, $text_id, $ssct_title), SB_MSG_WARNING);

            fServices_Cb_Temps_Edit();
		    return;
	    }
	}
}

function fServices_Cb_Temps_Delete ()
{
	$id = intval($_GET['id']);

	$serv_id = preg_replace('/[^a-z]/', '', isset($_GET['serv_id']) ? $_GET['serv_id'] : '');

	$pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_services_cb_'.$serv_id.'" AND pages.p_id=elems.e_p_id LIMIT 1');

	$temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
						WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_services_cb_'.$serv_id.'" AND temps.t_id=elems.e_p_id LIMIT 1');

	if ($pages || $temps)
    {
		echo PL_SERVICES_CB_DESIGN_DELETE_ERROR;
    }
}

?>