<?php

if (!function_exists('fServices_cb_Elem_K'))
{
	/**
	 * Вывод курса валют
	 */
	function fServices_cb_Elem_K ($el_id, $temp_id, $params, $tag_id)
	{
	    if($GLOBALS['sbCache']->check('pl_services_cb', $tag_id, array($el_id, $temp_id, $params), false))
			return;

		$params = unserialize(stripslashes($params));

	    $mTags = array ();
	    $mTagsVal = array ();
	    $error = false;

		$next_kurs = isset($params['get_next_day_kurs']) && $params['get_next_day_kurs'] == 1 ? true : false;

//		Если нужно выводить курс на завтра, то и дату курса меняем на завтрашнюю . Как только наступило время после 17:30
		if($next_kurs)
		{
			$sec_count = 0;
			$cur_time = sb_date('H:i', time(), 3);
			$cur_time = explode(':', $cur_time);

			$sec_count = ($cur_time[0] * 60 * 60) + ($cur_time[1] * 60); // Количество секунд сегодняшнего дня.
			$kurs_date = time() + ($sec_count >= 63000 ? 86400 : 0);
		}
		else
		{
			$kurs_date = time();
		}

		fServices_cb_Get_K($mTags, $mTagsVal, $error, $next_kurs, $kurs_date);

		if($error)
		{
		    $res = sql_param_query('SELECT ssct_error FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
	        if($res)
	        {
	            eval(' ?>'.$res[0][0].'<?php ');
	        }
	        return;
	    }

		//$res = sql_param_query('SELECT ssct_date, ssct_lang, ssct_body FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
        $res = sbQueryCache::getTemplate('sb_services_cb_temps', $temp_id);
		if($res)
		{
			$date = sb_parse_date($kurs_date, $res[0][0], $res[0][1]);

		    array_push($mTags, '{DATE}');
		    array_push($mTagsVal, $date);

			$result = str_replace($mTags, $mTagsVal, $res[0][2]);
			$result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);
			$GLOBALS['sbCache']->save('pl_services_cb', $result);
		}
		else
		{
		    sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SERVICIES_CB_PLUGIN), SB_MSG_WARNING);
		}
	}
}

if (!function_exists('fServices_cb_Elem_Dme'))
{
	/**
	 * Вывод цен драгоценных металлов
	 */
	function fServices_cb_Elem_Dme ($el_id, $temp_id, $params, $tag_id)
	{
		if($GLOBALS['sbCache']->check('pl_services_cb', $tag_id, array($el_id, $temp_id, $params), false))
			return;

	    $mTags = array();
	    $mTagsVal = array();
	    $error = false;

	    fServices_cb_Get_Dme($mTags, $mTagsVal, $error);

	    if($error)
	    {
	        $res = sql_param_query('SELECT ssct_error FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
	        eval(' ?>'.$res[0][0].'<?php ');
	        return;
	    }


		//$res = sql_param_query('SELECT ssct_date, ssct_lang, ssct_body FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
        $res = sbQueryCache::getTemplate('sb_services_cb_temps', $temp_id);
		if($res)
		{
	        $date = sb_parse_date(time(), $res[0][0], $res[0][1]);

	        array_push($mTags, '{DATE}');
			array_push($mTagsVal, $date);

			$result = str_replace($mTags, $mTagsVal, $res[0][2]);
	        $result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);
	    	$GLOBALS['sbCache']->save('pl_services_cb', $result);
		}
		else
		{
		    sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SERVICIES_CB_PLUGIN), SB_MSG_WARNING);
		}
	}
}

if (!function_exists('fServices_cb_Elem_Mr'))
{
	/**
	 * Вывод ставок межбанковского рынка
	 */
	function fServices_cb_Elem_Mr ($el_id, $temp_id, $params, $tag_id)
	{
		if ($GLOBALS['sbCache']->check('pl_services_cb', $tag_id, array($el_id, $temp_id, $params), false))
	        return;

	    $mTags = array();
	    $mTagsVal = array();
	    $error = false;

	    fServices_cb_Get_Mr($mTags, $mTagsVal, $error);

	    if($error)
	    {
	        $res = sql_param_query('SELECT ssct_error FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
	        eval('?> '.$res[0][0].'<?php ');
	        return;
	    }

		//$res = sql_param_query('SELECT ssct_date, ssct_lang, ssct_body FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
        $res = sbQueryCache::getTemplate('sb_services_cb_temps', $temp_id);
		if ($res)
		{
	    	$date = sb_parse_date(time(), $res[0][0], $res[0][1]);

	    	array_push($mTags, '{DATE}');
	    	array_push($mTagsVal, $date);

	    	$result = str_replace($mTags, $mTagsVal, $res[0][2]);
	        $result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);
	    	$GLOBALS['sbCache']->save('pl_services_cb', $result);
		}
		else
		{
		    sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SERVICIES_CB_PLUGIN), SB_MSG_WARNING);
		}
	}
}

if (!function_exists('fServices_cb_Elem_Depoz'))
{
	/**
	 * Вывод ставок по депозитным операциям
	 */
	function fServices_cb_Elem_Depoz ($el_id, $temp_id, $params, $tag_id)
	{
		if($GLOBALS['sbCache']->check('pl_services_cb', $tag_id, array($el_id, $temp_id, $params), false))
			return;

	    $mTags = array();
	    $mTagsVal = array();
	    $error = false;

	    fServices_cb_Get_Depoz($mTags, $mTagsVal, $error);

	    if($error)
	    {
	        $res = sql_param_query('SELECT ssct_error FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
	        eval(' ?>'.$res[0][0].'<?php ');
	        return;
	    }

		//$res = sql_param_query('SELECT ssct_date, ssct_lang, ssct_body FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
        $res = sbQueryCache::getTemplate('sb_services_cb_temps', $temp_id);
		if ($res)
		{
	        $date = sb_parse_date(time(), $res[0][0], $res[0][1]);

	        array_push($mTags, '{DATE}');
	        array_push($mTagsVal, $date);

	    	$result = str_replace($mTags, $mTagsVal, $res[0][2]);
	        $result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);

	        $GLOBALS['sbCache']->save('pl_services_cb', $result);
		}
		else
		{
		    sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SERVICIES_CB_PLUGIN), SB_MSG_WARNING);
		}
	}
}

if (!function_exists('fServices_cb_Elem_Svop'))
{

	/**
	 * Вывод ставок валютный своп
	 */
	function fServices_cb_Elem_Svop ($el_id, $temp_id, $params, $tag_id)
	{
		if($GLOBALS['sbCache']->check('pl_services_cb', $tag_id, array($el_id, $temp_id, $params), false))
			return;

	    $mTags = array();
	    $mTagsVal = array();
	    $error = false;

	    fServices_cb_Get_Svop($mTags, $mTagsVal, $error);

	    if($error)
	    {
	        $res = sql_param_query('SELECT ssct_error FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
	        eval(' ?>'.$res[0][0].'<?php ');
	        return;
	    }

		//$res = sql_param_query('SELECT ssct_date, ssct_lang, ssct_body FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
        $res = sbQueryCache::getTemplate('sb_services_cb_temps', $temp_id);
		if ($res)
		{
	    	$date = sb_parse_date (time(), $res[0][0], $res[0][1]);

	    	array_push ($mTags, '{DATE}');
	    	array_push ($mTagsVal, $date);

	    	$result = str_replace($mTags, $mTagsVal, $res[0][2]);
	        $result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);
	    	$GLOBALS['sbCache']->save('pl_services_cb', $result);
		}
		else
		{
		    sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SERVICIES_CB_PLUGIN), SB_MSG_WARNING);
		}
	}
}

if (!function_exists('fServices_cb_Elem_Monet'))
{
	/**
	 * Вывод цен инвестиционных монет
	 */
	function fServices_cb_Elem_Monet ($el_id, $temp_id, $params, $tag_id)
	{
		if($GLOBALS['sbCache']->check('pl_services_cb', $tag_id, array($el_id, $temp_id, $params), false))
			return;

	    $mTags = array();
	    $mTagsVal = array();
	    $error = false;

	    fServices_cb_Get_Monet($mTags, $mTagsVal, $error);

	    if($error)
	    {
	        $res = sql_param_query('SELECT ssct_error FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
	        eval(' ?>'.$res[0][0].'<?php ');
	        return;
	    }

		//$res = sql_param_query('SELECT ssct_date, ssct_lang, ssct_body FROM sb_services_cb_temps WHERE ssct_id=?d', $temp_id);
        $res = sbQueryCache::getTemplate('sb_services_cb_temps', $temp_id);

		if ($res)
		{
	    	$date = sb_parse_date(time(), $res[0][0], $res[0][1]);

	    	array_push($mTags, '{DATE}');
	        array_push($mTagsVal, $date);

	        $result = str_replace($mTags, $mTagsVal, $res[0][2]);
	        $result = preg_replace('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, '', $result);
	    	$GLOBALS['sbCache']->save('pl_services_cb', $result);
		}
		else
		{
		    sb_add_system_message(sprintf(KERNEL_PROG_NO_TEMPLATE, $_SERVER['PHP_SELF'], KERNEL_PROG_SERVICIES_CB_PLUGIN), SB_MSG_WARNING);
		}
	}
}


// ----------------------------- Функции получения данных с сервиса ЦБ ---------------------------------------------//

function fServices_cb_Get_K (&$mTags = array(), &$mTagsVal = array(), &$error = false, $next_kurs = false, $query_date = '')
{
	if($query_date == '')
	{
		$query_date = sb_date('d/m/Y', time());
	}
	else
	{
		$query_date = sb_date('d/m/Y', $query_date);
	}

	$res_cache = sql_param_query('SELECT sscc_params FROM sb_services_cb_cache WHERE sscc_date ="'.$query_date.'" AND sscc_ident="pl_services_cb_k"');
	if($res_cache)
    {
        $res_cache = unserialize($res_cache[0][0]);
        $mTags = $res_cache[0];
        $mTagsVal = $res_cache[1];
    }
    else
    {
        $xml_kurs = simplexml_load_file('http://www.cbr.ru/scripts/XML_daily.asp?date_req='.$query_date);
        if(isset($xml_kurs->Valute))
        {
            foreach($xml_kurs->Valute as $value)
            {
                array_push ($mTags,
                        '{NUM_'.$value->CharCode.'}',
                        '{CHAR_'.$value->CharCode.'}',
                        '{VALUE_'.$value->CharCode.'}');

                array_push ($mTagsVal,
                        (string) $value->NumCode,
                        (string) $value->CharCode,
                        (string) $value->Value);
            }

            $row = array();
            $row['sscc_date'] = $query_date;
            $row['sscc_ident'] = 'pl_services_cb_k';
            $row['sscc_params'] = serialize(array($mTags, $mTagsVal));

            sql_param_query('INSERT INTO sb_services_cb_cache SET ?a', $row);
        }
        else
        {
			if($next_kurs)
			{
				$query_date = sb_date('d/m/Y', time());

				$res_cache = sql_param_query('SELECT sscc_params FROM sb_services_cb_cache WHERE sscc_date ="'.$query_date.'" AND sscc_ident="pl_services_cb_k"');
			    if($res_cache)
			    {
			        $res_cache = unserialize($res_cache[0][0]);
			        $mTags = $res_cache[0];
			        $mTagsVal = $res_cache[1];
			        return;
			    }
			}

            sb_add_system_message(KERNEL_PROG_PL_CB_K_CRON_ERR, SB_MSG_ERROR);
            $error = true;
        }
    }
}

function fServices_cb_Get_Dme (&$mTags = array(), &$mTagsVal = array(), &$error = false)
{
    $query_date_end = sb_date('d/m/Y', time());
    $query_date_start = sb_date('d/m/Y', (time() - (60*60*24*10)));

    $res_cache = sql_param_query('SELECT sscc_params FROM sb_services_cb_cache WHERE sscc_date ="'.$query_date_end.'" AND sscc_ident="pl_services_cb_dme"');

    if($res_cache)
    {
        $res_cache = unserialize($res_cache[0][0]);
        $mTags = $res_cache[0];
        $mTagsVal = $res_cache[1];
    }
    else
    {
        $xml_dme = simplexml_load_file('http://www.cbr.ru/scripts/xml_metall.asp?date_req1='.$query_date_start.'&date_req2='.$query_date_end);
        if(isset($xml_dme->Record))
        {
            // вытаскиваем последний Record
            $result = $xml_dme->xpath('/Metall/Record[last()]');
            $result = $xml_dme->xpath('/Metall/Record[@Date="'.$result[0]['Date'].'"]');

            $mTags = array('{AU_BUY}', '{AU_SELL}', '{AG_BUY}', '{AG_SELL}', '{PT_BUY}', '{PT_SELL}', '{PD_BUY}', '{PD_SELL}');
            foreach($result as $value)
            {
                array_push($mTagsVal, (string) $value->Buy, (string)$value->Sell);
            }

            $row = array();
            $row['sscc_date'] = $query_date_end;
            $row['sscc_ident'] = 'pl_services_cb_dme';
            $row['sscc_params'] = serialize(array($mTags, $mTagsVal));

            sql_param_query('INSERT INTO sb_services_cb_cache SET ?a', $row);
        }
        else
        {
            sb_add_system_message(KERNEL_PROG_PL_CB_K_CRON_ERR, SB_MSG_ERROR);
            $error = true;
        }
    }
}

function fServices_cb_Get_Mr (&$mTags = array(), &$mTagsVal = array(), &$error = false)
{
    $query_date_end = sb_date ('d/m/Y', time());
    $query_date_start = sb_date('d/m/Y', (time() - (60*60*24*10)));

    $res_cache = sql_param_query('SELECT sscc_params FROM sb_services_cb_cache WHERE sscc_date ="'.$query_date_end.'" AND sscc_ident="pl_services_cb_mr"');
    if($res_cache)
    {
        $res_cache = unserialize($res_cache[0][0]);
        $mTags = $res_cache[0];
        $mTagsVal = $res_cache[1];
    }
    else
    {
        $xml_mr = simplexml_load_file('http://www.cbr.ru/scripts/xml_mkr.asp?date_req1='.$query_date_start.'&date_req2='.$query_date_end.'');
        if(isset($xml_mr->Record))
        {
            $result = $xml_mr->xpath('/MKR/Record[last()]');
            $result = $xml_mr->xpath('/MKR/Record[@Date="'.$result[0]['Date'].'"]');
            $coun = count($result);
            if($coun == 2)
            {
                $res = $xml_mr->xpath('/MKR/Record[last()]');
                list($day, $month, $year) = explode('/', $res[0]['Date']);
                $timest = mktime(0,0,0, $month, $day, $year);
                $timest = $timest - 60*60*24;
                $timest = date('d/m/Y', $timest);

                $res = $xml_mr->xpath('/MKR/Record[@Date="'.$timest.'" and @Code="3"]');
                $result[] = (isset($res[0]) ? $res[0] : '');
            }

            foreach($result as $value)
            {
                if($value)
                {
                    array_push($mTagsVal,
                        (string) $value->C1,
                        (string) $value->C7,
                        (string) $value->C30,
                        (string) $value->C90,
                        (string) $value->C180,
                        (string) $value->C360);
                }
            }
            $mTags = array(
                    '{MIBID_C1}', '{MIBID_C7}', '{MIBID_C30}', '{MIBID_C90}', '{MIBID_C180}', '{MIBID_C360}',
                    '{MIBOR_C1}', '{MIBOR_C7}', '{MIBOR_C30}', '{MIBOR_C90}', '{MIBOR_C180}', '{MIBOR_C360}');

            $coun = count($result);
            if($coun == 3)
            {
                array_push($mTags, '{MIACR_C1}', '{MIACR_C7}', '{MIACR_C30}', '{MIACR_C90}', '{MIACR_C180}', '{MIACR_C360}');
            }

            $row = array();
            $row['sscc_date'] = $query_date_end;
            $row['sscc_ident'] = 'pl_services_cb_mr';
            $row['sscc_params'] = serialize(array($mTags, $mTagsVal));

            sql_param_query('INSERT INTO sb_services_cb_cache SET ?a', $row);
        }
        else
        {
            sb_add_system_message(KERNEL_PROG_PL_CB_K_CRON_ERR, SB_MSG_ERROR);
            $error = true;
        }
    }
}

function fServices_cb_Get_Depoz (&$mTags = array(), &$mTagsVal = array(), &$error = false)
{
    $query_date_end = sb_date ('d/m/Y', time());
    $query_date_start = sb_date('d/m/Y', (time() - (60*60*24*10)));

    $res_cache = sql_param_query('SELECT sscc_params FROM sb_services_cb_cache WHERE sscc_date ="'.$query_date_end.'" AND sscc_ident="pl_services_cb_depoz"');
    if($res_cache)
    {
        $res_cache = unserialize($res_cache[0][0]);
        $mTags = $res_cache[0];
        $mTagsVal = $res_cache[1];
    }
    else
    {
        $xml = simplexml_load_file('http://www.cbr.ru/scripts/xml_depo.asp?date_req1='.$query_date_start.'&date_req2='.$query_date_end.'');
        if(isset($xml->Record))
        {
            $result = $xml->xpath('/Deposit/Record[last()]');
            foreach($result[0] as $value)
            {
               array_push($mTagsVal, (string)$value);
            }
            $mTags = array('{OVERNIGHT}', '{TOM_NEXT}', '{SPOT_NEXT}', '{P1WEEK}', '{SPOT_WEEK}', '{P2WEEKS}', '{SPOT_2WEEKS}', '{P1MONTH}', '{P3MONTH}');

            $row = array();
            $row['sscc_date'] = $query_date_end;
            $row['sscc_ident'] = 'pl_services_cb_depoz';
            $row['sscc_params'] = serialize(array($mTags, $mTagsVal));

            sql_param_query('INSERT INTO sb_services_cb_cache SET ?a', $row);
        }
        else
        {
            sb_add_system_message(KERNEL_PROG_PL_CB_K_CRON_ERR, SB_MSG_ERROR);
            $error = true;
        }
    }
}

function fServices_cb_Get_Svop (&$mTags = array(), &$mTagsVal = array(), &$error = false)
{
    $query_date_end = sb_date ('d/m/Y', time());
    $query_date_start = sb_date('d/m/Y', (time() - (60*60*24*10)));

    $res_cache = sql_param_query('SELECT sscc_params FROM sb_services_cb_cache WHERE sscc_date ="'.$query_date_end.'" AND sscc_ident="pl_services_cb_svop"');

    if($res_cache)
    {
        $res_cache = unserialize($res_cache[0][0]);
        $mTags = $res_cache[0];
        $mTagsVal = $res_cache[1];
    }
    else
    {
        $xml = simplexml_load_file('http://www.cbr.ru/scripts/xml_swap.asp?date_req1='.$query_date_start.'&date_req2='.$query_date_end);
        if(isset($xml->Record))
        {
            $result = $xml->xpath('/Swap/Record[last()]/DateBuy');
            $result = $xml->xpath('/Swap/Record[DateBuy="'.$result[0][0].'"]');

            foreach($result as $values)
            {
                array_push($mTagsVal, (string)$values->DateBuy, (string)$values->DateSell, (string)$values->BaseRate, (string)$values->SD, (string)$values->TIR);
            }

            $mTags = array ('{DATEBUY_USD}', '{DATESELL_USD}', '{BASERATE_USD}', '{SD_USD}', '{TIR_USD}',
                            '{DATEBUY_EUR}', '{DATESELL_EUR}', '{BASERATE_EUR}', '{SD_EUR}', '{TIR_EUR}');
            $row = array();
            $row['sscc_date'] = $query_date_end;
            $row['sscc_ident'] = 'pl_services_cb_svop';
            $row['sscc_params'] = serialize(array($mTags, $mTagsVal));

            sql_param_query('INSERT INTO sb_services_cb_cache SET ?a', $row);
        }
        else
        {
            sb_add_system_message(KERNEL_PROG_PL_CB_K_CRON_ERR, SB_MSG_ERROR);
            $error = true;
        }
    }
}

function fServices_cb_Get_Monet (&$mTags = array(), &$mTagsVal = array(), &$error = false)
{
    $query_date_end = sb_date ('d/m/Y', time());
    $query_date_start = sb_date('d/m/Y', (time() - (60*60*24*10)));

    $res_cache = sql_param_query('SELECT sscc_params FROM sb_services_cb_cache WHERE sscc_date ="'.$query_date_end.'" AND sscc_ident="pl_services_cb_monet"');
    if($res_cache)
    {
        $res_cache = unserialize($res_cache[0][0]);
        $mTags = $res_cache[0];
        $mTagsVal = $res_cache[1];
    }
    else
    {
        $xml = simplexml_load_file('http://www.cbr.ru/scripts/XMLCoinsBase.asp?date_req1='.$query_date_start.'&date_req2='.$query_date_end.'');
        if(isset($xml->Record))
        {
            $result = $xml->xpath('/CoinsBase/Record[last()]/Date');
            $result = $xml->xpath('/CoinsBase/Record[Date="'.$result[0][0].'"]');

            foreach($result as $values)
            {
                array_push($mTagsVal, (string)$values->Price, (string)$values->Nominal, (string)$values->Metall, (string)$values->Q);
                $tag = str_replace('-', '_', trim($values['CoinsID']));
                array_push($mTags, '{'.$tag.'_PRICE}', '{'.$tag.'_NOMINAL}', '{'.$tag.'_METALL}', '{'.$tag.'_CLEAN_METALL}');
            }

            $row = array();
            $row['sscc_date'] = $query_date_end;
            $row['sscc_ident'] = 'pl_services_cb_monet';
            $row['sscc_params'] = serialize(array($mTags, $mTagsVal));

            sql_param_query('INSERT INTO sb_services_cb_cache SET ?a', $row);
        }
        else
        {
            sb_add_system_message(KERNEL_PROG_PL_CB_K_CRON_ERR, SB_MSG_ERROR);
            $error = true;
        }
    }
}

?>