<?php
require_once(SB_CMS_LANG_PATH.'/pl_settings.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_settings', PL_SETTINGS_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/settings_cms.doc'))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_ADMIN.'>'.PL_SETTINGS_H_PLUGIN_NAME, 'read');

	require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();
    
	if (!$_SESSION['sbAuth']->isAdmin())
	{
		$res = sql_param_query('SELECT u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
		if ($res)
		{
		    $u_domains = explode(',', $res[0][0]);
		    $i = 0;
		    foreach ($GLOBALS['sb_domains'] as $domain => $tmp)
		    {
		    	if (in_array($domain, $u_domains))
		    	{
		    		// Настройки
		    		$_SESSION['sbPlugins']->addUserEvent('read_'.$i, 'fSettings_Read', 'read', PL_SETTINGS_H_PLUGIN_NAME);
		    		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SETTINGS_H_DOMAINS_SETTINGS.'>'.PL_SETTINGS_H_SETTING.' '.$idn->decode($domain).' > '.KERNEL_SETTINGS, 'read_'.$i.'&domain='.$domain);
		    		// Счетчики
		    		$_SESSION['sbPlugins']->addUserEvent('counts_google_'.$i, 'fSettings_Count', 'read', PL_SETTINGS_H_COUNTS_GOOGLE);
		    		$_SESSION['sbPlugins']->addUserEvent('counts_yandex_'.$i, 'fSettings_Count', 'read', PL_SETTINGS_H_COUNTS_YANDEX);
		    		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SETTINGS_H_DOMAINS_SETTINGS.'>'.PL_SETTINGS_H_SETTING.' '.$idn->decode($domain).' > '.PL_SETTINGS_H_COUNTS_GOOGLE, 'counts_google_'.$i.'&domain='.$domain.'&service=google', 'pl_settings_analitic_24.png');
		    		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SETTINGS_H_DOMAINS_SETTINGS.'>'.PL_SETTINGS_H_SETTING.' '.$idn->decode($domain).' > '.PL_SETTINGS_H_COUNTS_YANDEX, 'counts_yandex_'.$i.'&domain='.$domain.'&service=yandex', 'pl_settings_metrika_24.png');
		    		$i++;
		    	}
		    }
		}
	}
	else
	{
		$i = 0;
		foreach ($GLOBALS['sb_domains'] as $domain => $tmp)
	    {
	    	// Настройки
	    	$_SESSION['sbPlugins']->addUserEvent('read_'.$i, 'fSettings_Read', 'read', PL_SETTINGS_H_PLUGIN_NAME);
	    	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SETTINGS_H_DOMAINS_SETTINGS.'>'.PL_SETTINGS_H_SETTING.' '.$idn->decode($domain).' > '.KERNEL_SETTINGS, 'read_'.$i.'&domain='.$domain);
	    	// Счетчики
	    	$_SESSION['sbPlugins']->addUserEvent('counts_google_'.$i, 'fSettings_Count', 'read', PL_SETTINGS_H_COUNTS_GOOGLE);
    		$_SESSION['sbPlugins']->addUserEvent('counts_yandex_'.$i, 'fSettings_Count', 'read', PL_SETTINGS_H_COUNTS_YANDEX);
    		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SETTINGS_H_DOMAINS_SETTINGS.'>'.PL_SETTINGS_H_SETTING.' '.$idn->decode($domain).' > '.PL_SETTINGS_H_COUNTS_GOOGLE, 'counts_google_'.$i.'&domain='.$domain.'&service=google', 'pl_settings_analitic_24.png');
		    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SETTINGS_H_DOMAINS_SETTINGS.'>'.PL_SETTINGS_H_SETTING.' '.$idn->decode($domain).' > '.PL_SETTINGS_H_COUNTS_YANDEX, 'counts_yandex_'.$i.'&domain='.$domain.'&service=yandex', 'pl_settings_metrika_24.png');
		    $i++;
		    		
	    }
	}
	
	$_SESSION['sbPlugins']->addUserEvent('read', 'fSettings_Read', 'read', PL_SETTINGS_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('submit', 'fSettings_Submit', 'read', PL_SETTINGS_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('counts_google_submit', 'fSettings_Counts_Submit', 'read', PL_SETTINGS_H_COUNTS_GOOGLE);
	$_SESSION['sbPlugins']->addUserEvent('counts_yandex_submit', 'fSettings_Counts_Submit', 'read', PL_SETTINGS_H_COUNTS_YANDEX);
}
?>