<?php

function fSite_Users_Info()
{
    $count_su = sbPlugins::getUserSetting('sb_site_users_count_site_users');
    
    // Kazbek: добавлена проверка прав на просмотр групп пользователей 
    if ($_SESSION['sbAuth']->isAdmin())
    {
        $res = sql_query('SELECT su_id, su_login, su_name, su_email, su_reg_date, su_status, su_domains, su_pers_sex FROM sb_site_users ORDER BY su_reg_date DESC LIMIT 0, '.$count_su);
    }
    else
    {
        $where_str = ''; 
        foreach ($_SESSION['sbAuth']->getUserGroups() as $gid)
        {
            $where_str .= "CONCAT('^', c.cat_rights, '^') LIKE '%^g$gid^%' OR ";
        }
            
        $where_str .= "CONCAT('^', c.cat_rights, '^') LIKE '%^u".$_SESSION['sbAuth']->getUserId()."^%'";
        $where_str = ' AND ('.$where_str.')';
            
        $res = sql_query('SELECT s.su_id, s.su_login, s.su_name, s.su_email, s.su_reg_date, s.su_status, s.su_domains, s.su_pers_sex FROM sb_site_users s, sb_catlinks l, sb_categs c WHERE c.cat_ident="pl_site_users" AND l.link_cat_id=c.cat_id AND s.su_id=l.link_el_id '.$where_str.' ORDER BY s.su_reg_date DESC LIMIT 0, '.$count_su);
    }
    
    if($res)
    {
        $result = '<table width="100%" cellspacing="0" cellpadding="5" class="form" style="border: 0;">
                   <tr>
                       <td colspan="4">
                            <div class="hint_div" style="text-align:center;">'.PL_SITE_USERS_H_INFO_LAST_SU_LABEL.'</div>
                       </td>
                   </tr>';

        $r = 0;
        foreach($res as $key=>$value)
        {
            list($su_id, $su_login, $su_name, $su_email, $su_reg_date, $su_status, $su_domains, $su_pers_sex) = $value;

            $r++;
            if($r%2 == 0)
                $class = 'even';
            else
                $class = 'add';

            if($su_login != '')
                $name = $su_login;
            elseif($su_name != '')
                $name = $su_name;
            else
                $name = $su_email;

            $status = '';
            switch($su_status)
            {
                case 0:
                    $status .= '<span style="color: green;">'.PL_SITE_USERS_H_INFO_STATUS_REG.'</span>';
                    break;
                case 1:
                    $status .= '<span style="color: magenta;">'.PL_SITE_USERS_H_INFO_STATUS_MOD.'</span>';
                    break;
                case 2:
                    $status .= '<span style="color: magenta;">'.PL_SITE_USERS_H_INFO_STATUS_EMAIL.'</span>';
                    break;
                case 3:
                    $status .= '<span style="color: magenta;">'.PL_SITE_USERS_H_INFO_STATUS_MOD_EMAIL.'</span>';
                    break;
                case 4:
                    $status .= '<span style="color: red;">'.PL_SITE_USERS_H_INFO_STATUS_BLOCK.'</span>';
            }

            if($su_pers_sex == 0)
                $sex = KERNEL_PROG_PL_SITE_USERS_SEX_MALE;
            else
                $sex = KERNEL_PROG_PL_SITE_USERS_SEX_FEMALE;

            $result .= '<tr style="border-bottom:1px solid red;"  class="'.$class.'">
                    <td style="padding:5px 10px 5px 10px; vertical-align:top; width:1%;">
                        <div class="smalltext">
                            <nobr>'.sb_date('d.m.Y  H:i', $su_reg_date).'</nobr><br />
                            <b>'.$status.'</b>
                        </div>
                    </td>
                    <td style="padding:5px 10px 0px 10px; vertical-align:top; width:33%; text-align:center;">
                        <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_site_users_init&sb_sel_id='.$su_id.'">'.$name.'</a>
                    </td>
                    <td style="padding:5px 10px 0px 10px; vertical-align:top; width:33%; text-align:center;">
                        '.$sex.'
                    </td>
                    <td style="padding:5px 10px 0px 10px; vertical-align:top; width:33%; text-align:center;">
                        '.$su_domains.'
                    </td>
                </tr>';
        }
        $result .= '</table><br />
            <div class="sbDS_more"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_site_users_init">'.KERNEL_MORE.'</a></div>';
        echo $result;
    }
    else
    {
        echo '<div class="hint_div" style="text-align:center; height:30px; margin:20px 5px 20px 5px; padding:10px 0px 0px 0px;">'.PL_SITE_USERS_H_INFO_NO_SU_MSG.'</div>';  
    }
}

/********************************** вспомогательные функции, использующиеся другими модулями ***********************************/

function fSite_Users_Get_Groups()
{
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
    
    $sel_cat_ids = array();
    
    if (isset($_GET['sel_cat_ids']) && $_GET['sel_cat_ids'] != '')
    {
        $sel_cat_ids = explode('^', trim($_GET['sel_cat_ids'], '^'));
    }
        
    $js_str = '
        function chooseCat()
        {
            var id_ar = sbCatTree.getAllSelected();
            var text_ar = sbCatTree.getAllSelectedText();

            if (id_ar.length > 1)
            {
                id_ar = id_ar.replace(/\,/g, "^");
                id_ar = "^" + id_ar + "^";
                text_ar = text_ar.replace(/\s\[[0-9]+\]/g, "");
            }
        
            var res = new Object();
            res.ids = id_ar;
            res.text = text_ar;
            
            sbReturnValue(res);
        }';
    
    $footer_str = '<table cellspacing="0" cellpadding="7" width="100%" class="form">
    <tr><td class="footer" style="padding-top: 2px;">
        <div class="footer" style="margin: 0px;">
        <button onclick="chooseCat();">'.KERNEL_CHOOSE.'</button>&nbsp;&nbsp;&nbsp;
        <button onclick="sbCloseDialog();">'.KERNEL_CANCEL.'</button>
        </div>
    </td></tr></table>';
    
    $categs = new sbJustCategs('pl_site_users');

    $categs->mCategsSelectedIds = $sel_cat_ids;
    $categs->mCategsMultiSelect = true;

    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;

    $categs->mCategsJavascriptStr = $js_str;
    
    $categs->showTree($footer_str);
    $categs->init();
}

/**
 * Функция выводит вкладку пользователя сайта.
 *
 * @param object $layout Объект sbLayout, к которому будут добавлены поля.
 * @param int $user_id ID пользователя сайта данные которого будут выводиться
 */
function fSite_Users_Get_Author_Tab(&$layout, $user_id)
{
    if(isset($_GET['id']) && $_GET['id'] != '' && !is_null($user_id) && $user_id > 0)
    {
        $res = sql_param_query('SELECT su_login, su_name, su_email, su_pers_phone, su_pers_mob_phone, su_work_name, su_work_unit,
                su_work_position, su_work_phone, su_work_phone_inner, su_work_email, su_work_office_number 
                FROM sb_site_users
                WHERE su_id = ?d', $user_id);

        $layout->addTab (PL_SITE_USERS_H_TAB_SITE_USER);
        $layout->addHeader (PL_SITE_USERS_H_TAB_SITE_USER);

        if($res)
        {
            $html = '<div align="center" class="hint_div" style="margin-top: 5px;">'.PL_SITE_USERS_H_PERSONAL.'</div>';
            $layout->addField('', new sbLayoutHTML($html, true));
            $layout->addField ('', new sbLayoutDelim());

            $html = fSite_Users_Get_User_Link($user_id);
            $layout->addField(PL_SITE_USERS_H_TAB_SITE_USER, new sbLayoutHTML($html));
            $layout->addField (PL_SITE_USERS_H_LOGIN, new sbLayoutLabel($res[0][0]));
            $layout->addField (PL_SITE_USERS_H_EMAIL, new sbLayoutLabel($res[0][2]));
            $layout->addField (PL_SITE_USERS_H_FIO_NAME, new sbLayoutLabel($res[0][1]));
            $layout->addField ('', new sbLayoutDelim());
            $layout->addField (PL_SITE_USERS_H_PHONE, new sbLayoutLabel($res[0][3]));
            $layout->addField (PL_SITE_USERS_H_MOB_PHONE, new sbLayoutLabel($res[0][4]));
            $html = '<div align="center" class="hint_div" style="margin-top: 5px;">'.PL_SITE_USERS_H_CORPORATE.'</div>';
            $layout->addField('', new sbLayoutHTML($html, true));
            $layout->addField ('', new sbLayoutDelim());
            $layout->addField (PL_SITE_USERS_H_WORK_NAME, new sbLayoutLabel($res[0][5], '', '', false));
            $layout->addField (PL_SITE_USERS_H_WORK_UNIT, new sbLayoutLabel($res[0][6], '', '', false));
            $layout->addField (PL_SITE_USERS_H_POSITION, new sbLayoutLabel($res[0][7], '', '', false));
            $layout->addField (PL_SITE_USERS_H_WORK_PHONE, new sbLayoutLabel($res[0][8]));
            $layout->addField (PL_SITE_USERS_H_WORK_PHONE_INNER, new sbLayoutLabel($res[0][9]));
            $layout->addField (PL_SITE_USERS_H_WORK_EMAIL, new sbLayoutLabel($res[0][10]));
            $layout->addField (PL_SITE_USERS_H_OFFICE_NUMBER, new sbLayoutLabel($res[0][11]));
        }
        else
        {
            $layout->addField ('', new sbLayoutHTML(sb_show_message(PL_SITE_USERS_H_USER_DELETE, true, 'warning', true), true));
        }
    }
}

/**
 * Функция выводит ссылку на пользователя сайта.
 * 
 * @param int $user_id Идентификатор пользователя сайта
 * @return string Ссылка на пользователя сайта
 */
function fSite_Users_Get_User_Link($user_id)
{
    if(!is_null($user_id) && $user_id > 0)
    {
        $result = '';
        $res = sql_param_query('SELECT su_name, su_login, su_email FROM sb_site_users WHERE su_id =?d', $user_id);

        if($res)
        {
            list($su_name, $su_login, $su_email) = $res[0];

            if($su_name != '')
               $name = $su_name;
            elseif($su_login != '')         
               $name = $su_login;
            else
                $name = $su_email;

            $result = '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_site_users_init&sb_sel_id='.$user_id.'">'.$name.'</a><br />';
        }

        return $result;
    }
}

/**
 * Функция, выводящая поле выбора макет дизайна данных пользователя
 *
 * @param object $layout Объект sbLayout, к которому будут добавлены поля.
 * @param string $field_value Идентификатор выбранного макета дизайна.
 * @param string $field_name Имя поля, в котором будет храниться идентификатор макета дизайна(в базе данных).
 * @param string $field_title Заголовок поля.
 * @param string $msg_no_temp Сообщение об отсутствии макета дизайна.
 * 
 */
function fSite_Users_Design_Get (&$layout, $field_value, $field_name, $field_title = '', $msg_no_temp = '')
{
    $res = sql_query('SELECT categs.cat_title, sut.sut_id, sut.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps sut WHERE sut.sut_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_data_temp" ORDER BY categs.cat_left, sut.sut_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $sut_id, $sut_title) = $value;

            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$sut_id] = $sut_title;
        }
        $fld = new sbLayoutSelect($options, $field_name, '', '');
        $fld->mSelOptions = array($field_value);
    }
    else
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.($msg_no_temp != '' ? $msg_no_temp : PL_SITE_USERS_H_ELEM_DATA_NO_TEMPS_MSG).'</div>', '','', false);
    }
    $layout->addField(($field_title != '' ? $field_title : PL_SITE_USERS_H_DESIGN_GET), $fld);

}


/********************************** функции построения диалоговых окон ***********************************/

/**
 * Форма логина
 */
function fSite_Users_Get_Elem_Login()
{
   $params = unserialize($_GET['params']);
    
    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();
            
            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_SITE_USERS_H_ELEM_REG_NO_GROUPS_MSG.'");
                return;
            }
            
            params["ids"] = el_cats;
            
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SITE_USERS_H_ELEM_LOGIN_NO_TEMPS_ALERT.'");
                return;
            }
            
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
    
            sbReturnValue(res);
        }
    </script>';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '150';
    
    $layout->addTab(PL_SITE_USERS_H_GROUPS);
    
    $categs = new sbJustCategs('pl_site_users');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());
    
    $layout->addField('', new sbLayoutHTML($categs->showTree('', '<div class="hint_div">'.PL_SITE_USERS_H_SOC_GROUPS_DESC.'</div>', '', false), true));
    $categs->init();
    
    $layout->addTab(PL_SITE_USERS_H_ELEM_REG_PROPS_TAB);
    $layout->addHeader(PL_SITE_USERS_H_ELEM_LOGIN);
    
    $res = sql_query('SELECT categs.cat_title, temps.sut_id, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps WHERE temps.sut_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_temp" ORDER BY categs.cat_left, temps.sut_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();
        
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, $fld);
    }
    else 
    {
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_SITE_USERS_H_ELEM_LOGIN_NO_TEMPS_MSG.'</div>', '', '', false));
    }
                    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    
    $layout->show(); 
}

/**
 * Форма регистрации
 */
function fSite_Users_Get_Elem_Reg()
{
    $params = unserialize($_GET['params']);
    
    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();
            
            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_SITE_USERS_H_ELEM_REG_NO_GROUPS_MSG.'");
                return;
            }
            
            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SITE_USERS_H_ELEM_REG_NO_TEMPS_ALERT.'");
                return;
            }
            
            params["page"] = sbGetE("page").value;
            params["do_login"] = sbGetE("do_login").checked ? 1 : 0;
            params["mod_emails"] = sbGetE("mod_emails").value;';

        if($_SESSION['sbPlugins']->isPluginAvailable('pl_maillist'))
        {
            echo 'params["maillist_categs"] = sbGetE("maillist_categs").value;
                  params["maillist_subcats"] = sbGetE("maillist_subcats").checked ? 1 : 0;';
        }
          echo '
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
    
            sbReturnValue(res);
        }
    </script>';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';
    
    $layout->addTab(PL_SITE_USERS_H_GROUPS);
    
    $categs = new sbJustCategs('pl_site_users');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());
    
    $layout->addField('', new sbLayoutHTML($categs->showTree('', '<div class="hint_div">'.PL_SITE_USERS_H_GROUPS_DESC.'</div>', '', false), true));
    $categs->init();
    
    $layout->addTab(PL_SITE_USERS_H_ELEM_REG_PROPS_TAB);
    $layout->addHeader(PL_SITE_USERS_H_ELEM_REG_PROPS_TAB);
    
    $res = sql_query('SELECT categs.cat_title, temps.sut_id, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps WHERE temps.sut_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_reg_temp" ORDER BY categs.cat_left, temps.sut_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();
        
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, $fld);
    }
    else 
    {
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_SITE_USERS_H_ELEM_REG_NO_TEMPS_MSG.'</div>', '', '', false));
    }

    $layout->addField('', new sbLayoutDelim());
    
    $layout->addField(PL_SITE_USERS_H_ELEM_REG_PAGE, new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"'));   
    
    $layout->addField('', new sbLayoutDelim());
    
    $layout->addField(PL_SITE_USERS_H_ELEM_REG_AUTH, new sbLayoutInput('checkbox', '1', 'do_login', '', (isset($params['do_login']) && $params['do_login'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_SITE_USERS_H_ELEM_REG_MOD, new sbLayoutInput('input', (isset($params['mod_emails']) ? $params['mod_emails'] : ''), 'mod_emails', '', 'style="width: 480px;"'));

    if($_SESSION['sbPlugins']->isPluginAvailable('pl_maillist'))
    {
        $layout->addField('', new sbLayoutDelim());

        $fld = new sbLayoutCategs('pl_maillist', '', (isset($params['maillist_categs']) ? $params['maillist_categs'] : ''), 'maillist_categs');
        $fld->mMultiSelect = true;
        $layout->addField(PL_SITE_USERS_H_ELEM_REG_MAILLIST_CATS, $fld);

        $layout->addField(PL_SITE_USERS_H_ELEM_REG_MAILLIST_SUBCATS, new sbLayoutInput('checkbox', '1', 'maillist_subcats', '', (isset($params['maillist_subcats']) && $params['maillist_subcats'] == 1 ? 'checked="checked"' : '')));
    }
   
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    
    $layout->show();
}

/**
 * Форма изменения данных
 */
function fSite_Users_Get_Elem_Update()
{
    $params = unserialize($_GET['params']);
    
    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();
            
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SITE_USERS_H_ELEM_UPDATE_NO_TEMPS_ALERT.'");
                return;
            }
            
            params["page"] = sbGetE("page").value;
            params["mod_emails"] = sbGetE("mod_emails").value;';

        if($_SESSION['sbPlugins']->isPluginAvailable('pl_maillist'))
        {
            echo 'params["maillist_categs"] = sbGetE("maillist_categs").value;
                  params["maillist_subcats"] = sbGetE("maillist_subcats").checked ? 1 : 0;';
        }
          echo '

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
    
            sbReturnValue(res);
        }
    </script>';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';
    
    $layout->addTab(PL_SITE_USERS_H_ELEM_REG_PROPS_TAB);
    $layout->addHeader(PL_SITE_USERS_H_ELEM_REG_PROPS_TAB);
    
    $res = sql_query('SELECT categs.cat_title, temps.sut_id, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps WHERE temps.sut_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_update_temp" ORDER BY categs.cat_left, temps.sut_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();
        
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, $fld);
    }
    else 
    {
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_SITE_USERS_H_ELEM_UPDATE_NO_TEMPS_MSG.'</div>', '', '', false));
    }

    $layout->addField('', new sbLayoutDelim());
    
    $layout->addField(PL_SITE_USERS_H_ELEM_UPDATE_PAGE, new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"'));   
    $layout->addField(PL_SITE_USERS_H_ELEM_REG_MOD, new sbLayoutInput('input', (isset($params['mod_emails']) ? $params['mod_emails'] : ''), 'mod_emails', '', 'style="width: 480px;"'));

    if($_SESSION['sbPlugins']->isPluginAvailable('pl_maillist'))
    {
        $layout->addField('', new sbLayoutDelim());

        $fld = new sbLayoutCategs('pl_maillist', '', (isset($params['maillist_categs']) ? $params['maillist_categs'] : ''), 'maillist_categs');
        $fld->mMultiSelect = true;
        $layout->addField(PL_SITE_USERS_H_ELEM_REG_MAILLIST_CATS, $fld);

        $layout->addField(PL_SITE_USERS_H_ELEM_REG_MAILLIST_SUBCATS, new sbLayoutInput('checkbox', '1', 'maillist_subcats', '', (isset($params['maillist_subcats']) && $params['maillist_subcats'] == 1 ? 'checked="checked"' : '')));
    }
    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    
    $layout->show();
}

/**
 * Форма напоминания пароля
 *
 */
function fSite_Users_Get_Elem_Remind()
{
    $params = unserialize($_GET['params']);
    
    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();
            
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SITE_USERS_H_ELEM_REMIND_NO_TEMPS_ALERT.'");
                return;
            }
            
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
    
            sbReturnValue(res);
        }
    </script><br /><br />';
    
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '150';
    $layout->addHeader(PL_SITE_USERS_H_ELEM_LOGIN);
    
    $res = sql_query('SELECT categs.cat_title, temps.sut_id, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps WHERE temps.sut_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_remind_temp" ORDER BY categs.cat_left, temps.sut_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();
        
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, $fld);
    }
    else 
    {
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_SITE_USERS_H_ELEM_REMIND_NO_TEMPS_MSG.'</div>', '', '', false));
    }
                    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    
    $layout->show(); 
}

/**
 * Данные пользователя
 */
function fSite_Users_Get_Elem_Data()
{
   $params = unserialize($_GET['params']);

   if (!isset($params['need_auth']))
   {
       $params['need_auth'] = 1;    
   }
   
   echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();
            
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SITE_USERS_H_ELEM_DATA_NO_TEMPS_ALERT.'");
                return;
            }
            
            params["need_auth"] = sbGetE("need_auth").checked ? 1 : 0;
            params["moderate"] = (sbGetE("moderate").checked ? 1 : 0);
            params["allow_bbcode"] = (sbGetE("allow_bbcode").checked ? 1 : 0);
            params["moderate_email"] = sbGetE("moderate_email").value;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);
    
            sbReturnValue(res);
        }
    </script><br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '150';
    $layout->addHeader(PL_SITE_USERS_H_ELEM_LOGIN);
    
    $res = sql_query('SELECT categs.cat_title, temps.sut_id, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps WHERE temps.sut_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_data_temp" ORDER BY categs.cat_left, temps.sut_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }
        
        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();
        
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, $fld);
    }
    else 
    {
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_SITE_USERS_H_ELEM_DATA_NO_TEMPS_MSG.'</div>', '', '', false));
    }

    $layout->addField(PL_SITE_USERS_H_ELEM_DATA_NEED_AUTH, new sbLayoutInput('checkbox', '1', 'need_auth', '', (isset($params['need_auth']) && $params['need_auth'] == 1 ? 'checked="checked"' : '')));
    
    $layout->addField('', new sbLayoutDelim());
    
    $layout->addField(PL_SITE_USERS_H_ELEM_PREMOD_COMMENTS, new sbLayoutInput('checkbox', 'moderate', '1', 'moderate', (isset($params['moderate']) && $params['moderate'] == 1 ? 'checked="checked"' : '')));    
    $layout->addField(PL_SITE_USERS_H_ELEM_BBCODE_ALLOW, new sbLayoutInput('checkbox', 'allow_bbcode', '0', 'allow_bbcode', (isset($params['allow_bbcode']) && $params['allow_bbcode'] == 1 ? 'checked="checked"' : '')));    
    $layout->addField(PL_SITE_USERS_H_ELEM_MODER_EMAIL, new sbLayoutInput('text', (isset($params['moderate_email']) ? $params['moderate_email'] : ''), 'moderate_email', 'moderate_email', 'style="width:400px;"'));    
    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    
    $layout->show(); 
}

/**
 * Список пользователей
 */
function fSite_Users_Get_Elem_List()
{
    $params = unserialize($_GET['params']);

    if (!isset($params['use_filter']))
        $params['use_filter'] = 0;
        
    if (!isset($params['filter']))
        $params['filter'] = 'all';

    if (!isset($params['subcategs']))
        $params['subcategs'] = 1;

    if (!isset($params['calendar']))
        $params['calendar'] = 0;
        
    if (!isset($params['calendar_field']))
        $params['calendar_field'] = 'su_pers_birth';

    if (!isset($params['filter_compare']))
        $params['filter_compare'] = 'IN';
        
    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();
            
            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("'.PL_SITE_USERS_H_ELEM_LIST_NO_GROUPS_MSG.'");
                return;
            }
            
            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SITE_USERS_H_ELEM_LIST_NO_TEMPS_ALERT.'");
                return;
            }

            if (sbGetE("calendar").checked && sbGetE("calendar_field").value == "")
            {
                alert("'.PL_SITE_USERS_H_ELEM_LIST_NO_CALENDAR_FIELD_ALERT.'");
                return;
            }
            
            var r_filter_all = sbGetE("r_filter_all");
            var r_filter_last = sbGetE("r_filter_last");
            var r_filter_from_to = sbGetE("r_filter_from_to");
            
            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }
            else if (r_filter_last.checked)
            {
                params["filter"] = r_filter_last.value;
                var el_filter_last = sbGetE("spin_filter_last");
                params["filter_last"] = el_filter_last.value;
            }
            else if (r_filter_from_to.checked)
            {
                
                params["filter"] = r_filter_from_to.value;
                var el_filter_from = sbGetE("spin_filter_from");
                var el_filter_to = sbGetE("spin_filter_to");
                
                if (el_filter_to.value != "" && el_filter_to.value != 0 && parseInt(el_filter_from.value) > parseInt(el_filter_to.value))
                {
                    alert("'.PL_SITE_USERS_H_ELEM_LIST_FILTER_FROM_TO_ERROR.'");
                    return;
                }
                
                params["filter_from"] = el_filter_from.value;
                params["filter_to"] = el_filter_to.value;
            }
                
            var el_sort1 = sbGetE("sort1");
            var el_order1 = sbGetE("order1");
            var el_sort2 = sbGetE("sort2");
            var el_order2 = sbGetE("order2");
            var el_sort3 = sbGetE("sort3");
            var el_order3 = sbGetE("order3");
            
            if(el_sort1)
            {
                params["sort1"] = el_sort1.value;
                params["order1"] = el_order1.disabled ? "" : el_order1.value;
            }
                
            if(el_sort2)
            {
                params["sort2"] = el_sort2.value;
                params["order2"] = el_order2.disabled ? "" : el_order2.value;
            }
            
            if(el_sort3)
            {
                params["sort3"] = el_sort3.value;
                params["order3"] = el_order3.disabled ? "" : el_order3.value;
            }
            
            
            params["use_filter"] = sbGetE("use_filter").checked ? 1 : 0;
            params["filter_logic"] = sbGetE("filter_logic").value;
            params["filter_text_logic"] = sbGetE("filter_text_logic").value;
            params["filter_compare"] = sbGetE("filter_compare").value;
            params["filter_morph"] = sbGetE("filter_morph").checked ? 1 : 0;
            params["allow_bbcode"] = sbGetE("allow_bbcode").checked ? 1 : 0;
            params["use_sort"] = sbGetE("use_sort").checked ? 1 : 0;
            params["rubrikator"] = sbGetE("rubrikator").checked ? 1 : 0;
            
            params["page"] = sbGetE("page").value;
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["show_selected"] = sbGetE("show_selected").checked ? 1 : 0;
            params["status"] = sbGetE("status").checked ? 1 : 0;
            params["calendar"] = sbGetE("calendar").checked ? 1 : 0;
            params["calendar_field"] = sbGetE("calendar_field").value;';

            if($_SESSION['sbPlugins']->isPluginAvailable('pl_forum'))
            {
                echo 'params["author_msg_page"] = sbGetE("author_msg_page").value;';
            }

        echo '
            params["moderate"] = (sbGetE("moderate").checked ? 1 : 0);
            params["moderate_email"] = sbGetE("moderate_email").value;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }

        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }

        function changeCalendarField(el)
        {
            sbGetE("calendar_field").disabled = !el.checked;
        }
        
        function changeFilterMorph(el)
        {
            sbGetE("filter_morph").disabled = (el.value != "IN");
        }
        
        function changeUseFilter(el)
        {
            sbGetE("filter_morph").disabled = !el.checked || sbGetE("filter_compare").value != "IN";
            sbGetE("filter_logic").disabled = !el.checked;
            sbGetE("filter_text_logic").disabled = !el.checked;
            sbGetE("filter_compare").disabled = !el.checked;
        }
    </script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
    
    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';
    
    $layout->addTab(PL_SITE_USERS_H_GROUPS);
    
    $categs = new sbJustCategs('pl_site_users');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsMultiSelect = true;
    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());
    
    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();
    
    $layout->addTab(PL_SITE_USERS_H_ELEM_REG_PROPS_TAB);
    $layout->addHeader(PL_SITE_USERS_H_ELEM_REG_PROPS_TAB);
    
    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.sutl_id, temps.sutl_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps_list temps WHERE temps.sutl_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_list_temp" ORDER BY categs.cat_left, temps.sutl_title');
    if ($res)
    {
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $sutl_id, $sutl_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$sutl_id] = $sutl_title;
        }
    }
       
    if (count($options) > 0)
    { 
        $fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id']))
        {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    }
    else 
    {
        $fld = new sbLayoutLabel('<div class="hint_div">'.PL_SITE_USERS_H_ELEM_LIST_NO_TEMPS_MSG.'</div>', '', '', false);    
    }

    $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_SITE_USERS_H_ELEM_LIST_PAGE_HINT.'</div>';
    
    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_PAGE, $fld);
    
    if($_SESSION['sbPlugins']->isPluginAvailable('pl_forum'))
    {
        $fld = new sbLayoutPage(isset($params['author_msg_page']) ? $params['author_msg_page'] : '', 'author_msg_page', '', 'style="width: 450px;"');
        $fld->mHTML = '<div class="hint_div">'.PL_SITE_USERS_H_ELEM_LIST_AUTHOR_MSG_PAGE_HINT.'</div>';

        $layout->addField(PL_SITE_USERS_H_ELEM_LIST_AUTHOR_MSG_PAGE, $fld);
    }

    $layout->addField('', new sbLayoutDelim());
    sbPlugins::getSortFields('pl_site_users');

    $calendar_fields = array('' => ' --- ');
    foreach ($_SESSION['sbPlugins']->mCalendar['pl_site_users_list']['date_fields'] as $key => $value)
       {
        $calendar_fields[$key] = $value;
       }
       
    $fields = sbPlugins::getSortFields('pl_site_users');
    $res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident="pl_site_users"');
    if ($res)
    {
        list($pd_fields) = $res[0];
        
        if (trim($pd_fields) != '')
        {
            $pd_fields = unserialize($pd_fields);
            
            foreach($pd_fields as $value)
            {
                if ($value['type'] == 'string' || 
                    $value['type'] == 'number' || 
                    $value['type'] == 'date' || 
                    $value['type'] == 'checkbox' || 
                    $value['type'] == 'image' || 
                    $value['type'] == 'link' || 
                    $value['type'] == 'file' || 
                    $value['type'] == 'color' || 
                    $value['type'] == 'select_sprav' ||
                    $value['type'] == 'radio_sprav' )
                {
                    $fields['su.user_f_'.$value['id']] = $value['title'];
                    
                    if ($value['type'] == 'date')
                    {
                        $calendar_fields['user_f_'.$value['id']] = $value['title'];
                    }
                }
            }
        }
    }
    
    if (!empty($fields))
    {
        $order = array('DESC' => PL_SITE_USERS_H_ELEM_LIST_SORT_DESC,
            'ASC' => PL_SITE_USERS_H_ELEM_LIST_SORT_ASC);

        $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
        $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'n.n_date'));
        $fld2 = new sbLayoutSelect($order, 'order1');
        $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
        $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

        $layout->addField(PL_SITE_USERS_H_ELEM_LIST_SORT_FIELD . ' 1', $fld1);

        $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
        $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
        $fld2 = new sbLayoutSelect($order, 'order2');
        $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
        $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

        $layout->addField(PL_SITE_USERS_H_ELEM_LIST_SORT_FIELD . ' 2', $fld1);

        $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
        $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
        $fld2 = new sbLayoutSelect($order, 'order3');
        $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
        $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

        $layout->addField(PL_SITE_USERS_H_ELEM_LIST_SORT_FIELD . ' 3', $fld1);

        $layout->addField('', new sbLayoutDelim());
    }
    
    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_SHOW_SELECTED, new sbLayoutInput('checkbox', '1', 'show_selected', '', (isset($params['show_selected']) && $params['show_selected'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_STATUS, new sbLayoutInput('checkbox', '1', 'status', '', (isset($params['status']) && $params['status'] == 1 ? 'checked="checked"' : '')));
    
    $layout->addField('', new sbLayoutDelim());
    
    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_RUBRIK_LINK, new sbLayoutInput('checkbox', '1', 'rubrikator', '', (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? 'checked="checked"' : '')));
    
    $layout->addField('', new sbLayoutDelim());
    
    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_CALENDAR_LINK, new sbLayoutInput('checkbox', '1', 'calendar', '', (isset($params['calendar']) && $params['calendar'] == 1 ? 'checked="checked"' : '').' onclick="changeCalendarField(this)"'));

    $fld = new sbLayoutSelect($calendar_fields, 'calendar_field', '', (!isset($params['calendar']) || $params['calendar'] != 1 ? 'disabled="disabled"' : ''));
    $fld->mSelOptions = array((isset($params['calendar_field']) && $params['calendar_field'] != '' ? $params['calendar_field'] : ''));
    $fld->mHTML = '<div class="hint_div">'.PL_SITE_USERS_H_ELEM_LIST_CALENDAR_FIELD_HINT.'</div>';
    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_CALENDAR_FIELD, $fld);
    
    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_SITE_USERS_H_ELEM_PREMOD_COMMENTS, new sbLayoutInput('checkbox', 'moderate', '1', 'moderate', (isset($params['moderate']) && $params['moderate'] == 1 ? 'checked="checked"' : '')));    
    $layout->addField(PL_SITE_USERS_H_ELEM_BBCODE_ALLOW, new sbLayoutInput('checkbox', 'allow_bbcode', '0', 'allow_bbcode', (isset($params['allow_bbcode']) && $params['allow_bbcode'] == 1 ? 'checked="checked"' : '')));    
    $layout->addField(PL_SITE_USERS_H_ELEM_MODER_EMAIL, new sbLayoutInput('text', (isset($params['moderate_email']) ? $params['moderate_email'] : ''), 'moderate_email', 'moderate_email', 'style="width:480px;"'));    

    $layout->addTab(PL_SITE_USERS_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_SITE_USERS_H_ELEM_LIST_FILTER_TAB);

    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_USE_FILTER, new sbLayoutInput('checkbox', '1', 'use_filter', '', (isset($params['use_filter']) && $params['use_filter'] == 1 ? 'checked="checked"' : '').' onclick="changeUseFilter(this)"'));
    
    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_logic');
    $fld->mSelOptions = array((isset($params['filter_logic']) && $params['filter_logic'] != '' ? $params['filter_logic'] : ''));
    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_FILTER_LOGIC, $fld);
    
    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_text_logic');
    $fld->mSelOptions = array((isset($params['filter_text_logic']) && $params['filter_text_logic'] != '' ? $params['filter_text_logic'] : ''));
    
    $fld1 = new sbLayoutSelect(array('EQ' => PL_SITE_USERS_H_ELEM_LIST_FILTER_TEXT_LOGIC_EQ, 'IN' => PL_SITE_USERS_H_ELEM_LIST_FILTER_TEXT_LOGIC_IN), 'filter_compare', '', 'onchange="changeFilterMorph(this);"');
    $fld1->mSelOptions = array((isset($params['filter_compare']) && $params['filter_compare'] != '' ? $params['filter_compare'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;<input type="checkbox" value="1" id="filter_morph"'.(isset($params['filter_morph']) && $params['filter_morph'] == 1 ? ' checked="checked"' : '').(isset($params['filter_compare']) && $params['filter_compare'] != 'IN' ? ' disabled="disabled"' : '').' />&nbsp;&nbsp;'.PL_SITE_USERS_H_ELEM_LIST_FILTER_MORPH;
    $fld->mHTML = '&nbsp;&nbsp;'.$fld1->getField();
    
    $layout->addField(PL_SITE_USERS_H_ELEM_LIST_FILTER_TEXT_LOGIC, $fld);
    
    $layout->addField('', new sbLayoutDelim());
    
    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all', ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;'.PL_SITE_USERS_H_ELEM_LIST_FILTER_ALL;
    $html .= $fld1->getField().'<br /><br />';

    $fld2 = new sbLayoutInput('radio', 'last', 'filter', 'r_filter_last', ($params['filter'] == 'last' ? ' checked="checked"' : ''));
    $fld2_1 = new sbLayoutInput('input', (isset($params['filter_last']) ? $params['filter_last'] : ''), 'filter_last', 'spin_filter_last', 'style="width: 50px;"');
    $fld2_1->mMinValue = 1;
    $html .= $fld2_1->getJavaScript().'<table cellpadding="0" cellspacing="0"><tr><td>'.$fld2->getField().'</td><td>&nbsp;&nbsp;'.PL_SITE_USERS_H_ELEM_LIST_FILTER_LAST_REG.'&nbsp;&nbsp;</td><td>'.$fld2_1->getField().'</td><td>&nbsp;&nbsp;'.PL_SITE_USERS_H_ELEM_LIST_FILTER_DAYS.'</td></tr></table><br />';

    $fld3 = new sbLayoutInput('radio', 'from_to', 'filter', 'r_filter_from_to', ($params['filter'] == 'from_to' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutInput('input', (isset($params['filter_from']) ? $params['filter_from'] : ''), 'filter_from', 'spin_filter_from', 'style="width: 50px;"');
    $fld3_2 = new sbLayoutInput('input', (isset($params['filter_to']) ? $params['filter_to'] : ''), 'filter_to', 'spin_filter_to', 'style="width: 50px;"');
    $fld3_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>'.$fld3->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld3_1->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld3_2->getField().'</td></tr></table>
              <div class="hint_div">'.PL_SITE_USERS_H_ELEM_LIST_FILTER_FROM_TO_HINT.'</div>';

    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_SITE_USERS_H_ELEM_USE_SORT, $fld);
    
    //Использовать сортировку
       $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_NEWS_H_ELEM_USE_SORT, new sbLayoutInput('checkbox', '0', '', 'use_sort', (isset($params['use_sort']) && $params['use_sort'] == 1 ? 'checked="checked"' : '')));
    
    
    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    
    $layout->show();
}

/**
 * Вывод разделов
 *
 */
function fSite_Users_Get_Elem_Categs()
{
    fCategs_Get_Elem_Categs('pl_site_users', 'pl_site_users_categs', PL_SITE_USERS_H_ELEM_CATEGS_NO_TEMPS_MSG);
}

function fSite_Users_Categs_Info($params)
{
    fCategs_Elem_Categs_Info($params, 'pl_site_users_categs');
}

/**
 * Вывод формы фильтра пользователей сайта
 */
function fSite_Users_Get_Elem_Filter()
{
    $params = unserialize($_GET['params']);
    echo '<script>
        function choose()
        {
            var res = new Object();
            var params = new Array();

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("'.PL_SITE_USERS_H_FILTER_FORM_NO_TEMPS_ALERT.'");
                return;
            }
            params["page"] = sbGetE("page").value;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    </script>';

    echo '<br /><br />';
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    $layout = new sbLayout();
    $layout->mTableWidth = '90%';
    $layout->mTitleWidth = '200';

    $layout->addHeader(PL_SITE_USERS_H_ELEM_FILTER);

    $res = sql_query('SELECT categs.cat_title, temps.sut_id, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps WHERE temps.sut_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_filter" ORDER BY categs.cat_left, temps.sut_title');
    if ($res)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res as $value)
        {
            list($cat_title, $st_id, $st_title) = $value;
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$st_id] = $st_title;
        }

        $fld = new sbLayoutSelect($options, 'temp_id');
        $fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, $fld);
    }
    else
    {
        $layout->addField(PL_SITE_USERS_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_SITE_USERS_H_FILTER_FORM_NO_TEMPS_MSG.'</div>', '', '', false));
    }

    $fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"');
    $fld->mHTML = '<div class="hint_div">'.PL_SITE_USERS_H_FILTER_LIST_PAGE_HINT.'</div>';
    $layout->addField(PL_SITE_USERS_H_FILTER_PAGE_USERS_LIST, $fld);

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}

/********************************** функции получения информации по элементам модуля ***********************************/

/**
 * Форма логина
 */
function fSite_Users_Elem_Login_Info($params)
{
    $res = sql_param_query('SELECT categs.cat_title, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps
                          WHERE temps.sut_id=?d AND links.link_el_id=temps.sut_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_temp"', $params['temp_id']);
        
    echo '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SITE_USERS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>';
}

/**
 * Форма регистрации
 */
function fSite_Users_Elem_Reg_Info($params)
{
    $in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';
    
    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = sb_substr($categs_str, 0, -2);
    }
    
    $res = sql_param_query('SELECT categs.cat_title, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps
                          WHERE temps.sut_id=?d AND links.link_el_id=temps.sut_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_reg_temp"', $params['temp_id']);
    
    echo '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_GROUPS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_SITE_USERS_H_INFO_GROUPS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SITE_USERS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div class="delim"></div>
          '.(isset($params['page']) && $params['page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_INFO_PAGE.':</b> '.$params['page'].'</div>' : '').'
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_INFO_AUTH.':</b> '.(isset($params['do_login']) && $params['do_login'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          '.(isset($params['mod_emails']) && $params['mod_emails'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_INFO_MODS.':</b> '.$params['mod_emails'].'</div>' : '');
}

/**
 * Форма изменения данных
 */
function fSite_Users_Elem_Update_Info($params)
{
    $res = sql_param_query('SELECT categs.cat_title, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps
                          WHERE temps.sut_id=?d AND links.link_el_id=temps.sut_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_update_temp"', $params['temp_id']);
    
    echo '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SITE_USERS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div class="delim"></div>
          '.(isset($params['page']) && $params['page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_INFO_PAGE.':</b> '.$params['page'].'</div>' : '').
          (isset($params['mod_emails']) && $params['mod_emails'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_INFO_MODS.':</b> '.$params['mod_emails'].'</div>' : '');
}

/**
 * Форма напоминания пароля
 */
function fSite_Users_Elem_Remind_Info($params)
{
    $res = sql_param_query('SELECT categs.cat_title, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps
                          WHERE temps.sut_id=?d AND links.link_el_id=temps.sut_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_remind_temp"', $params['temp_id']);
        
    echo '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SITE_USERS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>';
}

/**
 * Вывод данных
 */
function fSite_Users_Elem_Data_Info($params)
{
    $res = sql_param_query('SELECT categs.cat_title, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps
                          WHERE temps.sut_id=?d AND links.link_el_id=temps.sut_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_data_temp"', $params['temp_id']);
        
    echo '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SITE_USERS_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_NEED_AUTH.':</b> '.(isset($params['need_auth']) && $params['need_auth'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_ELEM_PREMOD_COMMENTS.':</b> '.(isset($params['moderate']) && $params['moderate'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_INFO_MODERATE_EMAILS.':</b> '.(isset($params['moderate_email']) ? $params['moderate_email'] : '').'</div>';
}

/**
 * Вывод списка пользователей
 */
function fSite_Users_Elem_List_Info($params)
{
    $in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,'.$in_str.')';
    
    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
    if ($res)
    {
        foreach ($res as $value)
        {
            $categs_str .= $value[0].', ';
        }
        $categs_str = sb_substr($categs_str, 0, -2);
    }
    
    $res = sql_param_query('SELECT categs.cat_title, temps.sutl_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps_list temps
                            WHERE temps.sutl_id=?d AND links.link_el_id=temps.sutl_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_site_users_list_temp"', $params['temp_id']);
        
    echo '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_LIST_INFO_GROUPS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_SITE_USERS_H_LIST_INFO_GROUPS_WAS_DELETED_MSG.'</span>').'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SITE_USERS_H_LIST_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
          '.(isset($params['page']) && $params['page'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_LIST_INFO_PAGE.':</b> '.$params['page'].'</div>' : '').'
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_LIST_INFO_SUBCATEGS.':</b> '.(isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_LIST_INFO_STATUS.':</b> '.(isset($params['status']) && $params['status'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_LIST_INFO_CALENDAR_LINK.':</b> '.(isset($params['calendar']) && $params['calendar'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_INFO_FILTER_LINK.':</b> '.(isset($params['use_filter']) && $params['use_filter'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div class="delim"></div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_ELEM_PREMOD_COMMENTS.':</b> '.(isset($params['moderate']) && $params['moderate'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
          <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_INFO_MODERATE_EMAILS.':</b> '.(isset($params['moderate_email']) ? $params['moderate_email'] : '').'</div>';
}

/**
 * Вывод формы фильтра пользователей сайта
 */
function fSite_Users_Elem_Filter_Info($params)
{
    $res = sql_param_query('SELECT categs.cat_title, temps.sut_title FROM sb_categs categs, sb_catlinks links, sb_site_users_temps temps
            WHERE temps.sut_id=?d AND links.link_el_id=temps.sut_id AND categs.cat_id=links.link_cat_id
            AND categs.cat_ident="pl_site_users_filter"', $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_SITE_USERS_H_LIST_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
            <div style="padding-bottom: 5px;"><b>'.PL_SITE_USERS_H_FILTER_PAGE_USERS_LIST.':</b> '.($params['page'] != '' ? $params['page'] : '').'</div>';
}

/********************************** функции получения элементов модуля ***********************************/

/**
 * Форма логина
 */
function fSite_Users_Elem_Login($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_site_users/prog/pl_site_users.php';\n
        fSite_Users_Elem_Login('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Форма регистрации
 */
function fSite_Users_Elem_Reg($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_site_users/prog/pl_site_users.php';\n
        fSite_Users_Elem_Reg('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Форма изменения данных
 */
function fSite_Users_Elem_Update($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_site_users/prog/pl_site_users.php';\n
        fSite_Users_Elem_Update('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Форма напоминания пароля
 */
function fSite_Users_Elem_Remind($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_site_users/prog/pl_site_users.php';\n
        fSite_Users_Elem_Remind('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод данных
 */
function fSite_Users_Elem_Data($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_site_users/prog/pl_site_users.php';\n
        fSite_Users_Elem_Data('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод списка пользователей
 */
function fSite_Users_Elem_List($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_site_users/prog/pl_site_users.php';\n
        fSite_Users_Elem_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Вывод формы фильтра пользователей сайта
 */
function fSite_Users_Elem_Filter($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_site_users/prog/pl_site_users.php';\n
        fSite_Users_Elem_Filter('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}


/**
 * Вывод разделов
 *
 */
function fSite_Users_Categs_Prog($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_site_users/prog/pl_site_users.php';\n
        fSite_Users_Elem_Categs('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}
