<?php

/*
 * Функции управления файлом sitemap.txt
 */
function fSitemap_Init()
{
	if($_SESSION['sbPlugins']->isRightAvailable('pl_sitemap', 'edit_sitemap'))
	{
		echo '<script>
	    function sbEditDomain(id)
	    {
			var strPage = sb_cms_modal_dialog_file + "?event=pl_sitemap_edit&id="+id;
	        var strAttr = "resizable=1,width=850,height=600";
	        sbShowModalDialog(strPage, strAttr, afterEditDomain);
	    }

	    function afterEditDomain()
	    {
	    	var return_v = sbModalDialog.returnValue;
	        if (return_v)
	        {
				sbGetE("domain_"+return_v.id).innerHTML = return_v.domain;
	        }
	    }

	    function sbAddDomain()
	    {
	        var strPage = sb_cms_modal_dialog_file + "?event=pl_sitemap_edit";
	        var strAttr = "resizable=1,width=850,height=520";
	        sbShowModalDialog(strPage, strAttr, afterAddDomain);
		}

	    function afterAddDomain()
	    {
	        if (sbModalDialog.returnValue)
	        {
	            window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_sitemap_init";
			}
	    }
	    function sbDeleteDomains(sm_id)
	    {
	        if(confirm("'.PL_SITEMAP_DELETE_CONFIRM_DELETE.'"))
		    {
				var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_sitemap_delete&id="+sm_id);
				if (res == "")
		        {
		        	window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_sitemap_init";
				}
				else
				{
					alert("'.PL_SITEMAP_DELETE_NO_DELETED_ERR_MSG.'");
	            }
		    }
		}

		function sbClearIndexingBase()
		{
			if(confirm("'.PL_SITEMAP_INIT_CONFIRM_CLEAR_INDEXING_BASE.'"))
			{
				var res = sbLoadSync(sb_cms_empty_file+"?event=pl_sitemap_clear_indexing_base");
				if(res == "")
				{
					window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_sitemap_init";
				}
				else
				{
					alert("'.PL_SITEMAP_INIT_NOT_CLEAR_INDEXING_BASE.'");
				}
			}
		}
		</script>';
	}

	echo '<br /><br />';

	$res = sql_query('SELECT sm_id, sm_date, sm_domain FROM sb_sitemap');
	if($res)
	{
		$html = '<table id="domain_table" style="width:100%;" cellpadding="5" cellspacing="0" class="form">
					<tr>
						<th class="header" style="width:33%;">'.PL_SITEMAP_INIT_SEARCH_DOMAIN.'</th>
						<th class="header" style="width:33%;">'.PL_SITEMAP_INIT_INDEXING_TIME.'</th>
						<th class="header" style="width:33%;">'.PL_SITEMAP_INIT_COUNT_INDEXING_PAGES.'</th>
						<th class="header" style="width:1px;">&nbsp;</th>
					</tr>';

		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
		$layout = new sbLayout();

		require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

		// общее число проиндексированных страниц
	    $all_count_pages = 0;
	    $r = 0;
		foreach($res as $value)
		{
			list($sm_id, $sm_date, $sm_domain) = $value;

			$decode_domain = $idn->decode($sm_domain);

			// дата последней индексации
			$sm_date = is_null($sm_date) ? '-' : sb_date('d.m.Y '.KERNEL_IN.' H:i:s', $sm_date);

			// кол-во проиндексированных страниц
			$count = 0;

			$count_res = sql_query('SELECT COUNT(*) FROM sb_sitemap_pages_'.intval($sm_id));
			if($count_res)
			{
				list($count) = $count_res[0];
				$all_count_pages += $count;
			}

			$class = ($r % 2 == 0 ? 'odd' : 'even');
			$r++;

			$html .= '<tr class="'.$class.'">
					<td align="center" id="domain_'.$sm_id.'">'.$decode_domain.'</td>
					<td align="center">'.$sm_date.'</td>
					<td align="center">'.$count.'</td>
					<td align="right"><nobr>
						<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_sitemap_edit_sitemap&domain='.$sm_domain.'"><img src="'.SB_CMS_IMG_URL.'/files.png" alt="'.PL_SITEMAP_INIT_INDEXING_LOG_LINK.'" title="'.PL_SITEMAP_INIT_INDEXING_LOG_LINK.'" border="0"></a>
						&nbsp;
						'.($_SESSION['sbPlugins']->isRightAvailable('pl_sitemap', 'edit_sitemap') ? '
						<img height="20" width="20" style="cursor: pointer;" onClick = "sbEditDomain('.$sm_id.');" title="'.KERNEL_EDIT.'" src="'.SB_CMS_IMG_URL.'/btn_props.png"/>
						&nbsp;
						<img height="20" width="20" style="cursor: pointer;" onClick = "sbDeleteDomains('.$sm_id.');" title="'.KERNEL_DELETE.'" src="'.SB_CMS_IMG_URL.'/btn_delete.png"/>' : '').'
					</nobr></td>
			</tr>';
		}

		$html .= '</table>';
		$layout->addField('', new sbLayoutHTML('<div class="hint_div">
														'.PL_SITEMAP_INIT_COUNT_ALL_INDEXING_PAGES.': <span id="all_count_pages"><b>'.$all_count_pages.'</b></span>
													'.($_SESSION['sbPlugins']->isRightAvailable('pl_sitemap', 'edit_sitemap') ? '<br /><br />[ <a href="#" onclick="sbClearIndexingBase();">'.PL_SITEMAP_INIT_CLEAR_INDEXING_BASE.'</a> ]' : '').'
												</div><br />'.$html, true));

		$layout->addButton('button', KERNEL_ADD, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_sitemap', 'edit_sitemap') ? '' : 'disabled="disabled"').' onClick="sbAddDomain();"' );
		$layout->show();
	}
	else
	{
		sb_show_message(PL_SITEMAP_INIT_NO_SET_INDEXING_DOMAINS.($_SESSION['sbPlugins']->isRightAvailable('pl_sitemap', 'edit_sitemap') ? '<br /><br /><a href="#" onClick="sbAddDomain();">'.PL_SITEMAP_INIT_ADD_INDEXING_DOMAIN.'</a>' : ''), true);
	}
}

function fSitemap_Edit()
{
	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$result = sql_query('SELECT sm_domain, sm_settings FROM sb_sitemap WHERE sm_id=?d', $_GET['id']);
        if($result)
        {
            list($sm_domain, $sm_settings) = $result[0];
            $sm_settings = unserialize($sm_settings);
        }
		else
		{
			sb_show_message(PL_SITEMAP_EDIT_ERROR, true, 'warning');
			return;
        }
    }
    elseif (count($_POST) > 0)
    {
		$sm_domain = '';
		extract($_POST);

		if(!isset($_GET['id']))
			$_GET['id'] = '';
	}
	else
	{
		$sm_settings = array();
		$sm_settings['dirs_not_allow'] = PL_SITEMAP_EDIT_DEFAULT_DIRS_NOT_ALLLOW;
		$sm_settings['files_not_allow'] = PL_SITEMAP_EDIT_DEFAULT_FILES_NOT_ALLLOW;
		$sm_settings['impermissible_params'] = 'bid mess_hash c_hash';
		$sm_settings['port'] = 80;
		$sm_domain = str_replace(array('http://', 'https://'), array('',''), SB_DOMAIN);

		$_GET['id'] = '';
	}

	$sm_domain = trim($sm_domain);

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    echo '<script>
    function setPage(el)
    {
    	if(el.value.substr(0, 7).toLowerCase() == "http://" || el.value.substr(0, 8).toLowerCase() == "https://")
    	{
    		el.value = el.value.replace("http://", "");
    		el.value = el.value.replace("https://", "");

    		var pos = el.value.indexOf("/");
    		if (pos != -1)
    		{
    			el.value = el.value.substr(pos + 1);
    		}
    	}
    }

    function checkDomain(list)
    {
        sbGetE("sm_settings[www]").checked = (list.options[list.selectedIndex].getAttribute("www") == 1)? true : false;
    }
    </script><br /><br />';

    $initFormScript = <<<EOF
        <script type="text/javascript">
            var selectHost = sbGetE('sm_domain');
            sbGetE("sm_settings[www]").checked = (selectHost.options[selectHost.selectedIndex].getAttribute("www") == 1)? true : false;
        </script>
EOF;

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_sitemap_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', '');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '230';

	$layout->addHeader(PL_SITEMAP_EDIT_EDIT_DOMAIN);

	require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();

	$options = array();
    $options_attrib = array();
	foreach($GLOBALS['sb_domains'] as $key => $value)
	{
        // Проверяем Host в robots.txt
        $options_attrib[$key] = 'www="0"';

        if (isset($_GET['id']) && $_GET['id'] != '')
        {
            $options_attrib[$key] = 'www="' . (isset($sm_settings['www']) ? $sm_settings['www'] : 0) . '"';
        }
        else
        {
            $basedir = sb_str_replace(SB_BASEDIR, '', $value['basedir']);
            $robots = $GLOBALS['sbVfs']->file_get_contents($basedir . '/robots.txt');

            if ($robots != '')
            {
                $matches = array();
                preg_match('/Host:\s*(\S+)\s*/i' . SB_PREG_MOD, $robots, $matches);

                if (isset($matches[1]))
                {
                    if (preg_match('/^www\./i', $matches[1]))
                    {
                        $options_attrib[$key] = 'www="1"';
                    }
                }

                $matches = array();
                preg_match_all('/Disallow:\s+(\S*)\s+/si' . SB_PREG_MOD, $robots, $matches);

                if (isset($matches[1]) && is_array($matches[1]))
                {
                    $matches[1] = array_map('fSitemap_Trim', $matches[1]);
                    foreach($matches[1] as $k => $val)
                    {
                        if(preg_match('/[\*\$]/', $val))
                        {
                            unset($matches[1][$k]);
                        }
                    }
                    $default = explode(' ', $sm_settings['dirs_not_allow']);
                    $diff = array_diff($matches[1], $default);
                    if(!empty($diff))
                    {
                        $sm_settings['dirs_not_allow'] .= ' ' . implode(' ', $diff);
                    }
                }
            }
        }

		$options[$key] = $idn->decode($key);
	}

	$fld = new sbLayoutSelect($options, 'sm_domain', 'sm_domain', 'onChange="checkDomain(this)"');
	$fld->mSelOptions = array(isset($sm_domain) ? $sm_domain : '');
    $fld->mOptionsDopStr = $options_attrib;
	$layout->addField(PL_SITEMAP_INIT_SEARCH_DOMAIN, $fld);

    $layout->addField(PL_SITEMAP_INIT_DOMAIN_WITH_WWW, new sbLayoutInput('checkbox', '1', 'sm_settings[www]', ''));

	$options = array();
	$options['http'] = 'http';
	$options['https'] = 'https';
	$options['ftp'] = 'ftp';

	$fld = new sbLayoutSelect($options, 'sm_settings[scheme]');
	$fld->mSelOptions = array(isset($sm_settings['scheme']) ? $sm_settings['scheme'] : '');
	$layout->addField(PL_SITEMAP_EDIT_PROTOCOL, $fld);

	$layout->addField(PL_SITEMAP_EDIT_PORT, new sbLayoutInput('text', (isset($sm_settings['port']) ? $sm_settings['port'] : 80), 'sm_settings[port]', 'spin_sm_settings[port]', 'style="width:80px;"'));
	$layout->addField(PL_SITEMAP_EDIT_START_INDEXING_PAGE, new sbLayoutPage(isset($sm_settings['indexing_start_page']) ? $sm_settings['indexing_start_page'] : '/index.php', 'sm_settings[indexing_start_page]', '', 'style="width:440px;" onchange="setPage(this)"'));

	$layout->addField('', new sbLayoutDelim());

	$priority = array();
	$priority[0] = 0.0;
	$priority[1] = 0.1;
	$priority[2] = 0.2;
	$priority[3] = 0.3;
	$priority[4] = 0.4;
	$priority[5] = 0.5;
	$priority[6] = 0.6;
	$priority[7] = 0.7;
	$priority[8] = 0.8;
	$priority[9] = 0.9;
	$priority[10] = 1.0;

	$fld = new sbLayoutSelect($priority, 'sm_settings[priority_default]');
	$fld->mSelOptions = array((isset($sm_settings['priority_default']) ? $sm_settings['priority_default'] * 10 : '5'));
	$layout->addField(PL_SITEMAP_EDIT_PRIORITY_DEFAULT, $fld);

	$change_freq = array();
	$change_freq['always'] = PL_SITEMAP_CHANGE_ALWAYS;
	$change_freq['hourly'] = PL_SITEMAP_CHANGE_HOURLY;
	$change_freq['daily'] = PL_SITEMAP_CHANGE_DAILY;
	$change_freq['weekly'] = PL_SITEMAP_CHANGE_WEEKLY;
	$change_freq['monthly'] = PL_SITEMAP_CHANGE_MONTHLY;
	$change_freq['yearly'] = PL_SITEMAP_CHANGE_YEARLY;
	$change_freq['never'] = PL_SITEMAP_CHANGE_NEVER;

	$fld = new sbLayoutSelect($change_freq, 'sm_settings[freq]');
	$fld->mSelOptions = array((isset($sm_settings['freq']) ? $sm_settings['freq'] : 'weekly'));
	$layout->addField(PL_SITEMAP_EDIT_FREQ_DEFAULT, $fld);

	$layout->addField(PL_SITEMAP_EDIT_MANUAL_MODERATE, new sbLayoutInput('checkbox', '1', 'sm_settings[manual_moderate]', '', (isset($sm_settings['manual_moderate']) && $sm_settings['manual_moderate'] == 1 ? 'checked="checked"' : '')));

	$layout->addField(PL_SITEMAP_EDIT_IMPERMISSIBLE_WORDS, new sbLayoutInput('text', $sm_settings['impermissible_params'], 'sm_settings[impermissible_params]', '', 'style="width:100%;"'));

    if(!empty($sm_settings['dirs_not_allow']))
    {
        $sm_settings['dirs_not_allow'] = sb_str_replace(' ', "\r\n", $sm_settings['dirs_not_allow']);
    }
	$layout->addField(PL_SITEMAP_EDIT_DIRS_NOT_ALLOW_INDEXING, new sbLayoutTextarea($sm_settings['dirs_not_allow'], 'sm_settings[dirs_not_allow]', '', 'style="width:100%;"'));

    //Список допустимых расширений файлов
    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_SITEMAP_EDIT_PASSIBLE_EXTENSIONS, new sbLayoutInput('text', isset($sm_settings['passible_extensions'])?$sm_settings['passible_extensions']:'php', 'sm_settings[passible_extensions]', '', 'style="width:100%;"'));

    //Допустимый уровень вложенности
    $layout->addField(PL_SITEMAP_EDIT_NESTING_LEVEL, new sbLayoutInput('text', (isset($sm_settings['nesting_level']) ? $sm_settings['nesting_level'] : 30), 'sm_settings[nesting_level]', 'spin_sm_settings[nesting_level]', 'style="width:80px;" min_value="0"'));

    //Использование сжатия
    if(extension_loaded('zlib'))
    {
        $layout->addField(PL_SITEMAP_EDIT_GZIP_COMPRESSION, new sbLayoutInput('checkbox', '1', 'sm_settings[gzip_compression]', '', (isset($sm_settings['gzip_compression']) && $sm_settings['gzip_compression'] == 1 ? 'checked="checked"' : '')));
    }
    else
    {
        $sm_settings['gzip_compression'] = 0;
        $layout->addField('', new sbLayoutInput('hidden', '0', 'sm_settings[gzip_compression]'));
    }

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_sitemap', 'edit_sitemap') ? '' : 'disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	$layout->show().'<br /><br />';
    echo $initFormScript;
}

function fSitemap_Submit()
{
	if (!isset($_GET['id']))
		$_GET['id'] = '';

	$sm_settings = array();
	extract($_POST);

	if(!isset($sm_settings['port']) || $sm_settings['port'] == '0')
	{
		sb_show_message(PL_SITEMAP_SUBMIT_NO_PORT, false, 'warning');
		fSitemap_Edit();
		return;
	}

	if(!isset($sm_domain))
	{
		sb_show_message(PL_SITEMAP_SUBMIT_NO_DOMAIN, false, 'warning');
		fSitemap_Edit();
		return;
	}

	$res = sql_query('SELECT sm_id FROM sb_sitemap WHERE sm_domain=?', $sm_domain);
	if($res && $_GET['id'] == '')
	{
		sb_show_message(PL_SITEMAP_SUBMIT_DOMAIN_EXISTS, false, 'warning');
		fSitemap_Edit();
		return;
	}
	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$row = array();
	$row['sm_domain'] = $sm_domain;

	$priority = array();
	$priority[0] = 0.0;
	$priority[1] = 0.1;
	$priority[2] = 0.2;
	$priority[3] = 0.3;
	$priority[4] = 0.4;
	$priority[5] = 0.5;
	$priority[6] = 0.6;
	$priority[7] = 0.7;
	$priority[8] = 0.8;
	$priority[9] = 0.9;
	$priority[10] = 1.0;

	if(isset($sm_settings['priority_default']))
	{
		$sm_settings['priority_default'] = (isset($priority[$sm_settings['priority_default']]) ? $priority[$sm_settings['priority_default']] : '');
	}

    if(!extension_loaded('zlib') || !isset($sm_settings['gzip_compression']))
    {
        $sm_settings['gzip_compression'] = 0;
    }


    $sm_settings['dirs_not_allow'] = str_replace(array("\r\n", "\r", "\n"), ' ', $sm_settings['dirs_not_allow']);
	$row['sm_settings'] = serialize($sm_settings);

    if ($_GET['id'] != '')
    {
		$res = sql_query('SELECT sm_domain FROM sb_sitemap WHERE sm_id=?d', $_GET['id']);
        if ($res)
        {
			// редактирование
			list($old_domain) = $res[0];

			sql_query('UPDATE sb_sitemap SET ?a WHERE sm_id=?d', $row, $_GET['id'], sprintf(PL_SITEMAP_SUBMIT_EDIT_OK, $old_domain));

            echo '<script>
                    var res = new Object();
                    res.id = "'.$_GET['id'].'";
                    res.domain = "'.$sm_domain.'";
					sbReturnValue(res);
				</script>';
		}
		else
		{
			sb_show_message(PL_SITEMAP_SUBMIT_EDIT_ERROR, false, 'warning');
			sb_add_system_message(sprintf(PL_SITEMAP_SUBMIT_EDIT_SYSTEMLOG_ERROR, $sm_domain), SB_MSG_WARNING);

			fSitemap_Edit();
			return;
		}
	}
	else
	{
		$error = true;

		sql_query('INSERT INTO sb_sitemap SET ?a', $row);
		$id = sql_insert_id();

		if(intval($id) > 0)
		{
			$sql = 'CREATE TABLE IF NOT EXISTS `sb_sitemap_pages_'.$id.'` (
				`smp_url` varchar(255) character set '.SB_DB_CHARSET.' NOT NULL COMMENT  "'.PL_SITEMAP_SUBMIT_BD_COMMENT_RELATIVE_PATH.'",
				`smp_title` varchar( 255 ) character set '.SB_DB_CHARSET.' NULL COMMENT  "'.PL_SITEMAP_SUBMIT_BD_COMMENT_TITLE.'",
				`smp_last_modified` int(11) unsigned NULL COMMENT "'.PL_SITEMAP_SUBMIT_BD_COMMENT_LAST_MODIFIED.'",
				`smp_flags` tinyint(1) unsigned NOT NULL COMMENT "'.PL_SITEMAP_SUBMIT_BD_COMMENT_FLAGS.'",
				`smp_active` tinyint(1) unsigned NOT NULL COMMENT "'.PL_SITEMAP_SUBMIT_BD_COMMENT_XML.'",
				`smp_change_freq` varchar( 255 ) character set '.SB_DB_CHARSET.' NOT NULL COMMENT "'.PL_SITEMAP_SUBMIT_BD_COMMENT_FREQ.'",
				`smp_priority` float( 2 ) NOT NULL COMMENT "'.PL_SITEMAP_PRIORITY_TITLE.'",
				`smp_delete` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT  "0" COMMENT  "'.PL_SITEMAP_DELETE_TITLE.'",
				 PRIMARY KEY (`smp_url`),
				 KEY `smp_flags` (`smp_flags`, `smp_active`)
				) ENGINE = MYISAM DEFAULT CHARSET='.SB_DB_CHARSET;

			if(!sql_query($sql))
			{
				sql_query('DELETE FROM sb_sitemap WHERE sm_id=?d', $id);

				sb_show_message(sprintf(PL_SITEMAP_SUBMIT_ADD_ERROR, $sm_domain), false, 'warning');
				sb_add_system_message(sprintf(PL_SITEMAP_SUBMIT_ADD_SYSTEMLOG_ERROR, $sm_domain), SB_MSG_WARNING);

				fSitemap_Edit();
				return;
			}

			sb_add_system_message(sprintf(PL_SITEMAP_SUBMIT_ADD_OK, $sm_domain));
			echo '<script>
					var res = new Object();
                    res.id = "'.$id.'";
                    res.domain = "'.$sm_domain.'";
                    sbReturnValue(res);
                </script>';

			$count = 0;
			if (!isset($_SESSION['sbPlugins']->mCron['pl_sitemap']))
        	{
				$_SESSION['sbPlugins']->mCron['pl_sitemap'] = array();
			}
			else
			{
				$count = count($_SESSION['sbPlugins']->mCron['pl_sitemap']);
			}

			$_SESSION['sbPlugins']->mCron['pl_sitemap'][$count] = array();
			$_SESSION['sbPlugins']->mCron['pl_sitemap'][$count]['task_path'] = 'pl_sitemap/cron/pl_sitemap.php';
        	$_SESSION['sbPlugins']->mCron['pl_sitemap'][$count]['task_func'] = 'fSitemap_Cron_Refresh('.$id.')';
    	    $_SESSION['sbPlugins']->mCron['pl_sitemap'][$count]['task_name'] = sprintf(PL_SITEMAP_H_CRON_INDEXING, $sm_domain);
	        $_SESSION['sbPlugins']->mCron['pl_sitemap'][$count]['task_descr'] = PL_SITEMAP_H_CRON_INDEXING_DESCR;

			$error = false;
        }

		if ($error)
		{
			sb_show_message(sprintf(PL_SITEMAP_SUBMIT_ADD_ERROR, $sm_domain), false, 'warning');
			sb_add_system_message(sprintf(PL_SITEMAP_SUBMIT_ADD_SYSTEMLOG_ERROR, $sm_domain), SB_MSG_WARNING);

			fSitemap_Edit();
			return;
        }
    }
}

function fSitemap_Delete()
{
	$id = intval($_GET['id']);
	$res = sql_query('SELECT sm_domain FROM sb_sitemap WHERE sm_id = ?d', $id);
	if(!$res)
	{
		echo 'FALSE';
		return;
	}

	list($sm_domain) = $res[0];

	$index = -1;
	if(isset($_SESSION['sbPlugins']->mCron['pl_sitemap']) && count($_SESSION['sbPlugins']->mCron['pl_sitemap']) > 0)
	{
		foreach ($_SESSION['sbPlugins']->mCron['pl_sitemap'] as $key => $value)
		{
			if ($value['task_func'] == 'fSitemap_Cron_Refresh('.$id.')')
			{
				$index = $key;
				break;
			}
		}
	}
	if ($index == 0 && isset($_SESSION['sbPlugins']->mCron['pl_sitemap']) && count($_SESSION['sbPlugins']->mCron['pl_sitemap']) == 1)
    {
    	$_SESSION['sbPlugins']->mCron['pl_sitemap'] = array();
    }
    elseif ($index >= 0)
    {
		$tmp = array();
		$j = 0;
    	for ($i = 0; $i < count($_SESSION['sbPlugins']->mCron['pl_sitemap']); $i++)
    	{
			if ($i == $index)
				continue;

    		$tmp[$j] = array();
    		$tmp[$j]['task_path'] = $_SESSION['sbPlugins']->mCron['pl_sitemap'][$i]['task_path'];
		    $tmp[$j]['task_func'] = $_SESSION['sbPlugins']->mCron['pl_sitemap'][$i]['task_func'];
		    $tmp[$j]['task_name'] = $_SESSION['sbPlugins']->mCron['pl_sitemap'][$i]['task_name'];
		    $tmp[$j]['task_descr'] = $_SESSION['sbPlugins']->mCron['pl_sitemap'][$i]['task_descr'];
		    $j++;
		}
		$_SESSION['sbPlugins']->mCron['pl_sitemap'] = $tmp;
    }

	if(isset($_SESSION['sbPlugins']->mCron['pl_sitemap']) && count($_SESSION['sbPlugins']->mCron['pl_sitemap']) == 0)
	{
		unset($_SESSION['sbPlugins']->mCron['pl_sitemap']);
	}

	sql_query('DELETE FROM sb_sitemap WHERE sm_id = ?d ', $id, sprintf(PL_SITEMAP_DELETE_DELETED_MSG, $sm_domain));
	sql_query('DELETE FROM sb_cron WHERE sc_plugin_ident="pl_sitemap" AND sc_func_name="fSitemap_Cron_Refresh('.$id.')"');
	sql_query('DROP TABLE sb_sitemap_pages_'.$id);
}

function fSitemap_Edit_Data()
{
	if(!isset($_GET['domain']) || trim($_GET['domain']) == '')
	{
		sb_show_message(PL_SITEMAP_LOST_ID, true);
		return;
	}

	$res = sql_query('SELECT sm_id FROM sb_sitemap WHERE sm_domain = ?', $_GET['domain']);
	if($res && $res[0][0] != '')
	{
		$id = intval($res[0][0]);
	}
	else
	{
		sb_show_message(PL_SITEMAP_INDEXING_LOG_NO_RECORDS_IN_LOG, true);
		return;
	}

	echo '
		<style type="text/css">
	    	#event_content table.form tr.even:hover,
			#event_content table.form tr.odd:hover
			{
			    background-color: #E1FFE1;
			}

			#event_content
			{
				overflow-x: auto;
			}
		</style>
	    <script>
		    document.body.onselectstart = "";
		    document.body.setAttribute("unselectable", "off");

			function sbDeleteFromLog(id, url, sitemap_id)
		    {
		    	if (confirm("'.PL_SITEMAP_INIT_CONFIRM_DELETE_PAGE.'"))
		    	{
					var res = sbLoadSync(sb_cms_empty_file+"?event=pl_sitemap_clear_indexing_base&sitemap_base_id="+sitemap_id+"&url="+url);
					if(res == "")
					{
						var from = sbGetE("log_table").getAttribute("from");
		                window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_sitemap_edit_sitemap&domain='.$_GET['domain'].(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'" + "&page_elems=" + from;
					}
					else
					{
						alert("'.PL_SITEMAP_INDEXING_LOG_NOT_DELETE_PAGE.'");
					}
				}
			}

		    function showFilter()
		    {
		        var filter = sbGetE("sb_filter");
		        var filter_arr = sbGetE("filter_arrow");

		        if (!filter) return;
		        if (filter.style.display == "none")
		        {
		            filter.style.display = "";
		            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
		        }
		        else
		        {
		            filter.style.display = "none";
					filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
		        }
			}

		    function setFilter()
		    {
				var str = "'.SB_CMS_CONTENT_FILE.'?event=pl_sitemap_edit_sitemap&domain='.$_GET['domain'].(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
				var found = false;
				var frm = sbGetE("filter_form");

		        for (var i = 0; i < frm.elements.length; i++)
		        {
		            var el = frm.elements[i];
		            if (el.type == "select-one")
		            {
		                if (el.value != -1)
		                {
		                    str += "&"+el.name+"="+el.value;
		                    found = true;
		                }
		            }
		            else
		            {
		                if (el.name != "" && el.value != "")
		                {
		                    str += "&"+el.name+"="+el.value;
		                    found = true;
		                }
		            }
		        }

		        if (!found)
		        {
		            return false;
		        }

				window.location.href = str;
				return false;
		    }

			function removeFilter(e)
		    {
		        window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_sitemap_edit_sitemap&domain='.$_GET['domain'].(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
		        return sbCancelEvent(e);
		    }
		</script>';

	if(isset($_GET['gen']) && $_GET['gen'] == 1)
	{
		sb_show_message(PL_SITEMAP_GENERATION_OK, false);
	}
	elseif(isset($_GET['gen']) && $_GET['gen'] == 2)
	{
		sb_show_message(PL_SITEMAP_GENERATE_ERR_MSG, false, 'warning');
	}

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	if (!isset($_GET['order']))
    {
        $_GET['order'] = 'smp_last_modified|desc';
	}
	else
    {
		$_GET['order'] = preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']);
		if (empty($_GET['order']))
		{
			$_GET['order'] = 'smp_last_modified|desc';
		}
    }

	$order_str = '';
    $order = explode('|', $_GET['order']);
    if (count($order) == 2)
    {
    	list($field, $ord) = $order;
    	$order_str = ' ORDER BY '.$field.' '.$ord;
	}

	$filter_str = '';
	if (isset($_GET['l_date_from']) && !empty($_GET['l_date_from']))
    {
		$_GET['l_date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_from']);
        if (sb_strpos($_GET['l_date_from'], ' ') > 0)
        {
			$filter_str .= ' AND smp_last_modified >= '.sb_datetoint($_GET['l_date_from']);
        }
    }

    if (isset($_GET['l_date_to']) && !empty($_GET['l_date_to']))
    {
        $_GET['l_date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_to']);
        if (sb_strpos($_GET['l_date_to'], ' ') > 0)
        {
            $filter_str .= ' AND smp_last_modified <= '.sb_datetoint($_GET['l_date_to']);
        }
    }

    if (isset($_GET['l_page_title']) && !empty($_GET['l_page_title']))
    {
		$filter_str .= ' AND smp_title LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['l_page_title']).'%');
    }

    if (isset($_GET['l_url']) && !empty($_GET['l_url']))
    {
		$filter_str .= ' AND smp_url LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['l_url']).'%');
    }

	if (isset($_GET['l_flags']) && !empty($_GET['l_flags']) && ($_GET['l_flags'] == 1 || $_GET['l_flags'] == 2))
    {
		$filter_str .= ' AND smp_flags = '.($_GET['l_flags'] == 2 ? '0' : '1');
    }

	$href = SB_CMS_CONTENT_FILE.'?event=pl_sitemap_edit_sitemap';
	foreach ($_GET as $key => $value)
    {
		if ($key != 'event')
        {
			if (!is_array($value))
            {
                if ($key != 'order')
                {
					$href .= '&'.$key.'='.urlencode($value);
                }
            }
            else
            {
                foreach ($value as $value2)
                {
					if ($key != 'order')
					{
						$href .= '&'.$key.'[]'.'='.urlencode($value2);
					}
				}
			}
		}
	}

//  строим фильтр
    echo '<table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
        	<table cellpadding="0" cellspacing="0">
        	<tr>
            	<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.($filter_str != '' ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" /></span></td>
            	<td class="sb_filter_on" id="sb_filter_on" style="'.($filter_str != '' ? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
            </tr></table>
        </td>
    </tr>
    <tr><td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter" '.($filter_str != '' ? '' : ' style="display:none;"').'>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">'.PL_SITEMAP_INDEXING_LOG_FILTER_DATE_TITLE.':</th>
                <td class="sb_filter_td"><nobr>';

	$fld_lo = new sbLayoutDate((isset($_GET['l_date_from']) ? $_GET['l_date_from'] : ''), 'l_date_from');
	$fld_lo->mDropButton = true;

	$fld_hi = new sbLayoutDate((isset($_GET['l_date_to']) ? $_GET['l_date_to'] : ''), 'l_date_to');
	$fld_hi->mDropButton = true;

	echo $fld_lo->getJavaScript().'
					<table cellpadding="0" cellspacing="0">
					<tr>
				    	<td>'.KERNEL_FROM.'&nbsp;&nbsp;</td>
				    	<td>'.$fld_lo->getField().'</td>
				    	<td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td>
				    	<td>'.$fld_hi->getField().'</td>
				    </tr>
					</table>
				    </nobr>
                </td>
                <th class="sb_filter_th">'.PL_SITEMAP_INDEXING_LOG_FILTER_PAGE_TITLE_TITLE.':</th>
                <td class="sb_filter_td_noborder">';
	$fld = new sbLayoutInput('text', isset($_GET['l_page_title']) ? $_GET['l_page_title'] : '', 'l_page_title', '', 'style="width: 100%;"');
	echo $fld->getField().
				'</td>
          	</tr>
			<tr>
				<th class="sb_filter_th">'.PL_SITEMAP_INDEXING_LOG_TYPE_TITLE.':</th>
				<td class="sb_filter_td">';

	$options = array();
	$options[0] = ' --- ';
	$options[1] = PL_SITEMAP_INDEXING_LOG_FILTER_OPT_OPENED;
	$options[2] = PL_SITEMAP_INDEXING_LOG_FILTER_OPT_NOT_OPENED;

	$fld = new sbLayoutSelect($options, 'l_flags');
	$fld->mSelOptions = array(isset($_GET['l_flags']) ? $_GET['l_flags'] : '');
	echo $fld->getField().'
				</td>
				<th class="sb_filter_th">'.PL_SITEMAP_INDEXING_LOG_URL_TITLE.':</th>
				<td class="sb_filter_td_noborder">';
	$fld = new sbLayoutInput('text', isset($_GET['l_url']) ? $_GET['l_url'] : '', 'l_url', '', 'style="width:100%;"');
	echo $fld->getField().'</td>
			</tr>
			</table>
				<div class="sb_filter_footer"><input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;</div>
			</div>
			</form>
		</table>
	</td></tr></table><center>';

	//строим список проиндексированных страниц

	require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
	$pager = new sbDBPager('indexlog', 10, 20, 'content');

	$total = true;
	$res = $pager->init($total, 'SELECT smp_url, smp_title, smp_last_modified, smp_flags, smp_active, smp_change_freq, smp_priority FROM sb_sitemap_pages_'.$id.
					($filter_str != '' ? ' WHERE '.substr($filter_str, 5) : '').$order_str);
	$num_list = $pager->show();

	echo '<br /><br />'.$num_list.'<br /><br />';

	if($res)
	{
		$html = '<table id="log_table" style="width:100%;" cellpadding="5" cellspacing="0" class="form" from="'.$pager->mPage.'">
					<tr>
						<th class="header" style="width:70px;">
				            <nobr>
				            	<a href="'.$href.'&order=smp_flags|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'smp_flags|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
				            	&nbsp;'.PL_SITEMAP_INDEXING_LOG_TYPE_TITLE.'&nbsp;
								<a href="'.$href.'&order=smp_flags|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'smp_flags|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
				            </nobr>
						</th>
						<th class="header" style="width:150px;">
							<nobr>
				            	<a href="'.$href.'&order=smp_last_modified|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'smp_last_modified|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
				            	&nbsp;'.PL_SITEMAP_INDEXING_LOG_DATE_TITLE.'&nbsp;
								<a href="'.$href.'&order=smp_last_modified|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'smp_last_modified|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
				            </nobr>
						</th>
						<th class="header">
							<nobr>
				            	<a href="'.$href.'&order=smp_title|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'smp_title|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
				            	&nbsp;'.PL_SITEMAP_INDEXING_LOG_TITLE_TITLE.'<input type="hidden" name="sm_id" value="'.$id.'" />&nbsp;
								<a href="'.$href.'&order=smp_title|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'smp_title|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
				            </nobr>
						</th>
						<th class="header" style="width:150px;">
							<nobr>
				            	&nbsp;'.PL_SITEMAP_ADD_XML_TITLE.'&nbsp;
				            </nobr>
						</th>
						<th class="header" style="width:150px;">
							<nobr>
				            	&nbsp;'.PL_SITEMAP_CHANGE_FREQUENCY_TITLE.'&nbsp;
				            </nobr>
						</th>
						<th class="header" style="width:150px;">
							<nobr>
				            	&nbsp;'.PL_SITEMAP_PRIORITY_TITLE.'&nbsp;
				            </nobr>
						</th>
						<th class="header" style="width:1px;">&nbsp;</th>
					</tr>';

		$g_string = (isset($_GET['page_indexlog']) && $_GET['page_indexlog'] != '' ? '&page_indexlog='.$_GET['page_indexlog'] : '');
		$layout = new sbLayout(SB_CMS_CONTENT_FILE.'?event=pl_sitemap_edit_sitemap_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : '').$g_string, 'thisDialog', 'post', '');
		require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

		$priority = array();
		$priority[0] = 0.0;
		$priority[1] = 0.1;
		$priority[2] = 0.2;
		$priority[3] = 0.3;
		$priority[4] = 0.4;
		$priority[5] = 0.5;
		$priority[6] = 0.6;
		$priority[7] = 0.7;
		$priority[8] = 0.8;
		$priority[9] = 0.9;
		$priority[10] = 1.0;

		$change_freq = array();
		$change_freq['always'] = PL_SITEMAP_CHANGE_ALWAYS;
		$change_freq['hourly'] = PL_SITEMAP_CHANGE_HOURLY;
		$change_freq['daily'] = PL_SITEMAP_CHANGE_DAILY;
		$change_freq['weekly'] = PL_SITEMAP_CHANGE_WEEKLY;
		$change_freq['monthly'] = PL_SITEMAP_CHANGE_MONTHLY;
		$change_freq['yearly'] = PL_SITEMAP_CHANGE_YEARLY;
		$change_freq['never'] = PL_SITEMAP_CHANGE_NEVER;

		$r = 1;
		foreach($res as $value)
		{
			list($smp_url, $smp_title, $smp_last_modified, $smp_flags, $smp_active, $smp_change_freq, $smp_priority) = $value;

			$smp_last_modified = is_null($smp_last_modified) ? '-' : sb_date('d.m.Y '.KERNEL_IN.' H:i:s', $smp_last_modified);

			$url = $idn->decode($smp_url);

			if (sb_strlen($url) > 100)
			{
				$url = sb_substr($url, 0, 100).'...';
			}

			$page_link = '<a href="'.($smp_url != '' ? $smp_url : '#').'" style="font-size:10px;color:#'.(isset($smp_flags) && $smp_flags == 1 ? '33805E' : 'CC0066').';" target="_blank">'.$url.'</a>';

			$class = ($r % 2 == 0 ? 'odd' : 'even');
			$r++;

			if($smp_flags == 0 || trim($smp_url) == '')
			{
				$type_title = PL_SITEMAP_INDEXING_LOG_FILTER_OPT_NOT_OPENED;
				$img_src = '/warning_log.png';
			}
			else
			{
				$type_title = PL_SITEMAP_INDEXING_LOG_FILTER_OPT_OPENED;
				$img_src = '/information_log.png';
			}

			$priority_fld = new sbLayoutSelect($priority, 'priorfield['.($r-1).']', '', ($smp_flags == 0 ? ' disabled="disabled"' : ''));
			if ($smp_flags != 0)
			{
				$priority_fld->mSelOptions = array($smp_priority * 10);
			}

			$change_freq_fld = new sbLayoutSelect($change_freq, 'changefield['.($r-1).']', '', ($smp_flags == 0 ? ' disabled="disabled"' : ''));
			$change_freq_fld->mSelOptions = array($smp_change_freq);

			$add_to_xml = new sbLayoutInput('checkbox', '1', 'ch_['.($r-1).']', '', (($smp_active == 1 && $smp_flags == 1) ? 'checked="checked"' : '').($smp_flags == 0 ? ' disabled="disabled"' : ''));

			$html .= '<tr class="'.$class.'" id="id_'.($r-1).'">
				<td style="text-align:center"><img src="'.SB_CMS_IMG_URL.$img_src.'" title="'.$type_title.'"></td>
				<td style="font-size: 10px;text-align:center">'.$smp_last_modified.'</td>
				<td>'.$smp_title.'<br />'.$page_link.'<input type="hidden" name="url['.($r-1).']" value="'.$smp_url.'" /></td>
				<td style="font-size: 10px;text-align:center">'.$add_to_xml->getField().'</td>
				<td style="font-size: 10px;text-align:center">'.$change_freq_fld->getField().'</td>
				<td style="font-size: 10px;text-align:center">'.$priority_fld->getField().'</td>
				<td style="text-align:right">'.($_SESSION['sbPlugins']->isRightAvailable('pl_sitemap', 'edit_sitemap') ? '<img height="20" width="20" style="cursor: pointer;" onClick = "sbDeleteFromLog(\''.($r-1).'\', \''.urlencode($smp_url).'\', \''.$id.'\');" title="'.PL_SITEMAP_INDEXING_LOG_DELETE_FROM_LOG.'" src="'.SB_CMS_IMG_URL.'/btn_delete.png"/>' : '&nbsp;').'</td>
			</tr>';
		}

		$html .= '</table>';

		$layout->addField('', new sbLayoutHTML($html, true));

		$layout->addButton('submit', PL_SITEMAP_SAVE_GEN_BOTTOM, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_sitemap', 'edit_sitemap') ? '' : 'disabled="disabled"'));
		$layout->show();

		echo '<br /><br />'.$num_list.'<br /><br />';
	}
	else
	{
		sb_show_message(PL_SITEMAP_INDEXING_LOG_NO_RECORDS_IN_LOG, true);
	}
}

function fSitemap_Edit_Data_Submit()
{
	if(!isset($_POST['sm_id']) || intval($_POST['sm_id']) <= 0)
	{
		sb_add_system_message(PL_SITEMAP_LOST_ID, SB_MSG_ERROR);
		return;
	}
	$url = array();

	$sm_id = 0;
	extract($_POST);

	$sm_id = intval($sm_id);
	if($sm_id == 0)
	{
		sb_add_system_message(PL_SITEMAP_LOST_ID, SB_MSG_ERROR);
		return;
	}

	if (count($url) > 0)
	{
		$priority = array();
		$priority[0] = 0.0;
		$priority[1] = 0.1;
		$priority[2] = 0.2;
		$priority[3] = 0.3;
		$priority[4] = 0.4;
		$priority[5] = 0.5;
		$priority[6] = 0.6;
		$priority[7] = 0.7;
		$priority[8] = 0.8;
		$priority[9] = 0.9;
		$priority[10] = 1.0;

		$i = 1;
		foreach($url as $value)
		{
			if(trim($value) == '')
			{
				sb_add_system_message(PL_SITEMAP_LOST_URL, SB_MSG_ERROR);
				continue;
			}
			$row = array();
			$row['smp_active'] = (isset($_POST['ch_'][$i]) && $_POST['ch_'][$i] == 1 ? 1 : 0);
			$row['smp_change_freq'] = (isset($_POST['changefield'][$i]) ? $_POST['changefield'][$i] : 'weekly');
			$row['smp_priority'] = (isset($_POST['priorfield'][$i]) && isset($priority[$_POST['priorfield'][$i]])) ? $priority[$_POST['priorfield'][$i]] : '5';

			sql_query('UPDATE sb_sitemap_pages_'.$sm_id.' SET ?a WHERE smp_url=?', $row, $value);
			$i++;
		}
	}

	$arr_settings = array();
	$settings = sql_query('SELECT sm_id, sm_settings FROM sb_sitemap WHERE sm_domain = ?', $_GET['domain']);
	if($settings)
	{
		list($sm_id, $arr_settings) = $settings[0];
		$arr_settings = unserialize($arr_settings);
	}

	$gen = 0;
	$res = sql_query('SELECT smp_url, smp_last_modified, smp_change_freq, smp_priority
					FROM sb_sitemap_pages_'.$sm_id.' WHERE smp_flags=1 AND smp_active=1 ');
	if ($res)
	{
		$file = SB_BASEDIR.'/sitemap.xml';
		$str = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";

		foreach($res as $value)
		{
			list($smp_url, $smp_last_modified, $smp_change_freq, $smp_priority) = $value;

			$smp_change_freq = $smp_priority = '';



			$smp_last_modified = sb_date('Y-m-d', $smp_last_modified);

			if(isset($arr_settings['priority_default']) && trim($smp_priority) == '')
			{
				$smp_priority = $arr_settings['priority_default'];
			}

			if(isset($arr_settings['freq']) && trim($smp_change_freq) == '')
			{
				$smp_change_freq = $arr_settings['freq'];
			}
			$str .= "<url>
	<loc>".sb_str_replace('&', '&amp;', $smp_url)."</loc>
	<lastmod>".$smp_last_modified."</lastmod>
	<changefreq>".$smp_change_freq."</changefreq>
	<priority>".$smp_priority."</priority>
</url>\n";
		}
		$str .= '</urlset>';

		$GLOBALS['sbVfs']->mLocal = true;
		$fileres = $GLOBALS['sbVfs']->file_put_contents($file, $str);
		$GLOBALS['sbVfs']->mLocal = false;
		if ($fileres)
		{
			$gen = 1;
			sb_add_system_message(PL_SITEMAP_GENERATED, SB_MSG_INFORMATION);
		}
		else
		{
			$gen = 2;
			sb_add_system_message(PL_SITEMAP_UNABLE_TO_CREATE, SB_MSG_ERROR);
		}
	}
	else
	{
		sb_add_system_message(PL_SITEMAP_NO_LOG_DATA, SB_MSG_ERROR);
	}

	$str = ($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : '');
	$str = preg_replace('/[?&]?gen=1+/i', '', $str);
	if($gen > 0)
	{
		$str .= '&gen='.$gen;
	}

	if(isset($_GET['page_indexlog']) && $_GET['page_indexlog'] != '')
	{
		$str .= '&page_indexlog='.$_GET['page_indexlog'];
	}

	header('Location: '.sb_sanitize_header(SB_CMS_CONTENT_FILE.'?event=pl_sitemap_edit_sitemap'.$str));
	exit(0);
}

function fSitemap_Clear_Indexing_Base()
{
	$error = false;
	if(isset($_GET['sitemap_base_id']))
	{
 		$url = urldecode($_GET['url']);
		$res = sql_query('SELECT sm_domain FROM sb_sitemap WHERE sm_id=?d', $_GET['sitemap_base_id']);
		if (!$res)
		{
			$error = true;
		}
		else
		{
			list($sm_domain) = $res[0];

			$res = sql_query('DELETE FROM sb_sitemap_pages_'.intval($_GET['sitemap_base_id']).' WHERE smp_url=?', $url, sprintf(PL_SITEMAP_INDEXING_LOG_PAGE_DELETED, $url, $sm_domain));
			if(!$res)
			{
				$error = true;
			}
		}

		if($error)
		{
			sb_add_system_message(sprintf(PL_SITEMAP_INDEXING_LOG_ERROR_PAGE_DELETED, $url, $sm_domain), SB_MSG_ERROR);
			echo 'ERROR';
			return;
		}
	}
	else
	{
		$res = sql_query('SELECT sm_id FROM sb_sitemap');
		if($res)
		{
			foreach($res as $value)
			{
				list($id) = $value;

				$res2 = sql_query('TRUNCATE TABLE sb_sitemap_pages_'.intval($id));
				if(!$res2)
				{
					$error = true;
				}
			}
		}

		if ($error)
		{
			sb_add_system_message(PL_SITEMAP_INDEXING_LOG_ERROR_BASE_DELETED, SB_MSG_ERROR);
			echo 'ERROR';
			return;
		}
	}
}

function fSitemap_Trim($val)
{
    return trim($val, '/');
}
?>