<?php
function fSystemlog_Info()
{
    $res = sql_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $u_domains) = $res[0];
    
    if ($u_admin != 1)
    {
    	$u_domains = explode(',', $u_domains);
    }
    
    $result = sql_query('SELECT sl_type, sl_message, sl_date FROM sb_system_log {WHERE sl_domain IN (?a)} ORDER BY sl_id DESC LIMIT 0, '.max(1, sbPlugins::getUserSetting('sb_system_log_main_page_count')), ($u_admin != 1 ? $u_domains : SB_SQL_SKIP));

    if ($result)
    {
        echo '<table width="100%" cellspacing="0" cellpadding="5" class="form" style="border: 0;">';

        for($i = 0; $i < count($result); $i++)
        {
            list($sl_type, $sl_message, $sl_time) = $result[$i];

            switch ($sl_type)
            {
                case 1:
                    $img = 'information_log.png';
                    break;
                case 2:
                    $img = 'prevention_log.png';
                    break;
                case 3:
                case 4:
                case 5:
                    $img = 'warning_log.png';
                    break;
                default:
                    $img = '';
                    break;
            }

            echo '<tr '.($i % 2 == 0 ? 'class="odd"' : 'class="even"').'>
                    <td align="center" width="30">
                        <img src="'.SB_CMS_IMG_URL.'/'.$img.'" \>
                    </td>
                    <td>
                        '.sb_break_long_words('<div class="sbDS_date">'.date('d.m.Y '.KERNEL_IN.' H:i:s', $sl_time).'</div>&nbsp;'.$sl_message, 70, '<br />').'
                    </td>
                </tr>';
        }

        echo '</table><br />
        <div class="sbDS_more"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_systemlog_read">'.KERNEL_MORE.'</a></div>';
    }
    else
    {
        echo '<div align="center" style="padding: 10px;">'.PL_SYSTEMLOG_INC_NO_MESSAGES.'</div>';
    }
}
?>