<?php
function fTemplates_Get_Links()
{
    $where_str = '';
    if (isset($_GET['ident']) && is_array($_GET['ident']))
    {
        foreach ($_GET['ident'] as $value)
        {
            $value = preg_replace('/[^a-zA-Z0-9_]+/', '', $value);
            
            $where_str .= 'elems.e_ident="'.$value.'" OR ';
        }
    }
    
    if ($where_str != '')
    {
        $where_str = 'AND ('.substr($where_str, 0, -4).')';
    }
    
    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

    $total = true;
    $pager = new sbDBPager('lp', 7, 30, 'thisDialog');
    
    if (isset($_GET['id']))
    {
        $result = $pager->init($total, 'SELECT DISTINCT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems 
	                                    WHERE elems.e_link="temp" AND elems.e_temp_id=?d '.$where_str.' AND temps.t_id=elems.e_p_id', $_GET['id']);
    }
    elseif (isset($_GET['e_id']))
    {
        $result = $pager->init($total, 'SELECT DISTINCT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems 
	                                    WHERE elems.e_link="temp" AND elems.e_el_id=?d '.$where_str.' AND temps.t_id=elems.e_p_id', $_GET['e_id']);        
    }
    
    $num_list = $pager->show();
    
    if ($result)
    {
        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
        
        echo '<br />
        <script>
        function showTemp(tid)
        {
            if (_isFF || _isIE)
                var wnd = dialogArguments;
            else
                var wnd = window.opener;
            wnd.location = sb_cms_content_file + "?event=pl_templates_init&sb_sel_id=" + tid;
            window.close();
        }
        </script>';
        
        $layout = new sbLayout();
        $layout->mTableWidth = '95%';
        
        $values = array();
        $view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
        
        foreach ($result as $value)
        {
            list($t_id, $t_name) = $value;
            
            $res = sql_param_query('SELECT COUNT(*) FROM sb_pages WHERE p_temp_id=?d GROUP BY p_temp_id', $t_id);
            if ($res)
            {
        	    list($num_pages) = $res[0];
        	    $num_pages = '<span style="color:green;">'.$num_pages.'</span>';
            }
        	else
        	{
        	    $num_pages = '<span style="color:red;">'.PL_TEMPLATES_H_GET_NOT_USED.'</span>';
        	}
            PL_TEMPLATES_H_GET_NUM_PAGES.': ';
	
            if($view_info)
            {
            	$temp = '<b><a href="javascript:void(0);" onclick="showTemp('.$t_id.');">'.$t_name.'</a></b>
	                     <div class="smalltext" style="margin-top: 7px;">'.
	                     PL_TEMPLATES_H_GET_NUM_PAGES.': '.$num_pages.'</div>';
            }
            else 
            {
                $temp = '<b>'.$t_name.'</b>
	                     <div class="smalltext" style="margin-top: 7px;">'.
	                     PL_TEMPLATES_H_GET_NUM_PAGES.': '.$num_pages.'</div>';
            }
            
            $values[] = array('<img src="'.SB_CMS_IMG_URL.'/plugins/pl_templates_32.png" align="absMiddle" width="32" height="32" border="0" title="ID - '.$t_id.'">', $temp);
        }
        
        $width = array('1', '');
        $valign = array('top', 'top');
        $labels = array('', PL_TEMPLATES_H_GET_LINKS_TITLE);
        $fld = new sbLayoutTable($labels, $values);
        $fld->mWidth = $width;
        $fld->mVAlign = $valign;
        
        $layout->addField('', $fld);
        
        $layout->show();
        
        echo '<br />'.$num_list;
    }
    else 
    {
        sb_show_message(PL_TEMPLATES_H_GET_LINKS_ERROR, true);
    }
    
    echo '<br /><br /><a href="javascript:window.close();">[ '.KERNEL_CLOSE.' ]</a><br /><br />';
}

function fTemplates_Load_Info()
{
    $elems = $_SESSION['sbPlugins']->getElems();
    if (isset($_GET['e_ident']) && isset($_GET['e_params']))
    {
        if (isset($elems[$_GET['e_ident']]) && $elems[$_GET['e_ident']]['info_func'] != '')
        {
            $params = unserialize(str_replace('\\"', '"', $_GET['e_params']));
            echo $elems[$_GET['e_ident']]['info_func']($params);
        }
    }
    elseif (isset($_GET['e_id']))
    {
        $res = sql_param_query('SELECT e_ident, e_params FROM sb_elems WHERE e_id=?d', $_GET['e_id']);
        if($res)
        {
            list($ident, $params) = $res[0];
            if (isset($elems[$ident]) && $elems[$ident]['info_func'] != '')
            {
                $params = unserialize(str_replace('\\"', '"', $params));
                echo $elems[$ident]['info_func']($params);
            }
        }
    }
}
?>