<?php
@require_once(SB_CMS_LANG_PATH.'/pl_voting.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_voting', PL_VOTING_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_VOTING_H_MENU_COMMON.'>'.PL_VOTING_H_PLUGIN_TITLE, 'design_init');
	
	$_SESSION['sbPlugins']->addUserEvent('design_init', 'fVoting_Design_Init', 'design_read', PL_VOTING_H_DESING_FORM);
	$_SESSION['sbPlugins']->addUserEvent('design_edit', 'fVoting_Design_Edit', 'design_read', PL_VOTING_H_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_edit_submit', 'fVoting_Design_Edit_Submit', 'design_edit', PL_VOTING_H_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_delete', 'fVoting_Design_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_voting_delim', PL_VOTING_H_SETTING_HEADER, '', '', '', SB_COOKIE_DOMAIN, false);        
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_voting_ip_count', PL_VOTING_H_SETTING_ONE_IP, 'number', '', '1', SB_COOKIE_DOMAIN, false);        
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_voting_cookie_time', PL_VOTING_H_SETTING_COOKIE_TIME, 'number', '', '365', SB_COOKIE_DOMAIN, false);        
}

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
?>