<?php

/**
 * Сообщаем браузеру кодировку страницы
 **/

header('Content-Language: ru, en');
header('Content-Type: text/html; charset=utf-8');

?>
<html>
<head> 
<title>ОФЕРТА НА ПЕРЕДАЧУ НЕИСКЛЮЧИТЕЛЬНЫХ ПРАВ НА ИСПОЛЬЗОВАНИЕ ПРОГРАММНОГО ПРОДУКТА CMS S.Builder</title> 
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"> 
</head> 
<style>
  body {
     font-size: 11px;
     font-family: arial,tahoma,verdana,sans-serif;
  }
  td {
     font-size: 11px;
     font-family: arial,tahoma,verdana,sans-serif;
  }
  H1 {
     font-size: 15px;
  }
  H2 {
     font-size: 14px;
     text-align: center;
  }
  p {
     padding: 0 0 0 25px;
     margin: 0 0 5px 0;
     text-indent: -23px;
  }
</style>
<body>
<div align="center">
<div style="width: 100%;">
<H1 align="center">ОФЕРТА<br>
НА ПЕРЕДАЧУ НЕИСКЛЮЧИТЕЛЬНЫХ ПРАВ НА ИСПОЛЬЗОВАНИЕ ПРОГРАММНОГО ПРОДУКТА</H1>
<br>
<table width="100%">
<tr>
<td width="50%">Российская Федерация, Москва</td>
<td width="50%" align="right"><01> января 2009 г.</td>
</tr>
</table>
<br>
<div align="justify">
Настоящий документ представляет собой предложение Общества с Ограниченной Ответственностью "СИБИЭС-Групп" (далее - Лицензиар) заключить Договор на передачу неисключительных прав на использование программного продукта.<br>
<br>
<H2>1.ТЕРМИНЫ И ОПРЕДЕЛЕНИЯ</H2>
<p>1.1. В целях настоящего документа, нижеприведенные термины используются в следующем значении:</p>
<div style="padding: 0 0 5px 50px;">
<i>Оферта</i> - настоящий документ <Оферта на передачу неисключительных прав на использование программного продукта>, размещенный в сети Интернет по адресу <a href="http://www.sbuilder.ru/dogs/oferta_sbuilder.html" target="_blank">http://www.sbuilder.ru/dogs/oferta_sbuilder.rtf</a>.<br>
<i>Программный продукт</i> - программа для ЭВМ BinN S.Builder (далее - S.Builder), авторскими правами и правами интеллектуальной собственности на которую обладает Общество с Ограниченной Ответственностью <СИБИЭС-Групп>, что подтверждается свидетельством об официальной регистрации программы для ЭВМ №2005610459 от 18 февраля 2004 года выданным Федеральной службой по интеллектуальной собственности, патентам и товарным знакам.<br>
<i>Территория</i> - территория всех стран мира.<br>
<i>Сайт Лицензиара</i> - сайт, размещенный в сети Интернет по адресу <a href="http://www.sbuilder.ru/" target="_blank">http://www.sbuilder.ru/</a>.<br> 
<i>Лицензионный ключ</i> - файл, содержащий в зашифрованном Виде информацию о комплектации Программного продукта, доменных именах, на которых разрешено использование программного продукта и другую информацию о Программном Продукте, по усмотрению Лицензиара.<br>
<i>Акцепт Оферты</i> - полное и безоговорочное принятие Оферты путем осуществления действий, указанных в разделе 7. Оферты. Акцептом Оферты заключается Договор.
Договор - возмездный договор между Лицензиатом и Лицензиаром на передачу неисключительных прав на использование программного продукта, который заключается посредством Акцепта Оферты.<br>
</div>
<p>1.2.   В данной Оферте могут быть использованы термины, не определенные в п. 1.1. Оферты. В этом случае толкование такого термина производится в соответствии с текстом Оферты. В случае отсутствия однозначного толкования термина в тексте Оферты следует руководствоваться толкованием термина, определенным в первую очередь - законодательством РФ, затем -  общепринятым в сети Интернет.</p>


<h2>2.ПРЕДМЕТ ДОГОВОРА</h2>
<p>2.1. Предметом Договора является возмездная передача Лицензиаром Лицензиату неисключительных прав на использование Программного продукта на Территории, указанной в настоящем договоре и на срок действия настоящего договора. </p>

<h2>3.УСЛОВИЯ ПЕРЕДАЧИ ПРАВ НА ИСПОЛЬЗОВАНИЕ ПРОГРАМНОГО ПРОДУКТА</h2>
<p>3.1. Передача прав осуществляется путем предоставления возможности загрузки Программного продукта с сайта Лицензиара и генерации лицензионного ключа к Программному продукту через специализированный интерфейс на сайте Лицензиара по адресу: <a href="http://www.sbuilder.ru/buy_cms/" target="_blank">http://www.sbuilder.ru/buy_cms/</a>.</p>
<p>3.2. Лицензиар не несет ответственности за возможные негативные последствия, вызванные несовместимостью или конфликтами с другими Программными продуктами, установленными на компьютере, на котором Лицензиат использует Программное обеспечение. </p>
<p>3.3. Лицензиар не несет ответственности за какой-либо явный, случайный, косвенный или иной ущерб, возникший в результате использования и обладания программой, или за невозможность использования программы.</p>

<h2>4.ПРАВА И ОБЯЗАННОСТИ ЛИЦЕНЗИАТА</h2>
<p><b>Лицензиат имеет право: </b></p>
<p>4.1. На воспроизведение Программного продукта с его носителей в память ЭВМ. Доменные имена, на которых возможна работа Программного продукта и дополнительные модули которые доступны Лицензиату, определяются настоящим Договором, перечислены в Акте и Лицензионном ключе Программного продукта;</p>
<p>4.2. На использование Программного продукта в соответствии с его функциональным назначением, указанным в руководстве разработчика, размещенном на сайте Лицензиара, и в рамках функциональных модулей, оплаченных Лицензиатом в соответствии с разделом 6 настоящего договора;</p>
<p>4.3. На все результаты, полученные при помощи Программного продукта;</p>
<p><b>Лицензиат обязан: </b></p>
<p>4.4. Не модифицировать, не распространять, не вскрывать и не расшифровывать исходные коды Программного продукта и его функциональных модулей без письменного разрешения Лицензиара;</p>
<p>4.5. Ознакомиться с функциональными характеристиками Программного Продукта, представленными на сайте Лицензиара и полностью принять на себя риск того, что они могут не соответствовать его требованиям; </p>
<p>4.6. Не передавать свои права по данному Договору третьим лицам без письменного разрешения Лицензиара;</p>
<p>4.7. В случае расторжения настоящего договора удалить все принадлежавшие ему экземпляры Программного продукта с носителей, на которых они хранятся;</p>
<p>4.8. В случае использования Программного продукта для оказания услуг третьим лицам, самостоятельно нести перед ними всю ответственность по заключенным с ними Договорам;</p>

<H2>5.ПРАВА И ОБЯЗАННОСТИ ЛИЦЕНЗИАРА</H2>
<p><b>Лицензиар имеет право:</b></p>
<p>5.1. Расторгнуть настоящий договор в одностороннем порядке в случае нарушения Лицензиатом условий передачи прав на использование Программного продукта (раздел 3 настоящего Договора)  и в случае нарушения Лицензиатом своих обязательств, перечисленных в пунктах 4.4 - 4.8 настоящего договора;</p>
<p><b>Лицензиар обязуется:</b></p>
<p>5.2. Обеспечить возможность использования Программного продукта по назначению;</p>
<p>5.3. Обеспечить техническую поддержку на протяжении 1 (одного) года работы;</p>

<h2>6.СТОИМОСТЬ УСЛУГ И ПОРЯДОК РАСЧЕТОВ</h2>
<p>6.1. Базовая версия Программного продукта составляет 5900 (пять тысяч девятьсот) рублей 00 копеек (НДС не облагается согласно статье 149, пункту 2, подпункту 26 Налогового Кодекса Российской Федерации).</p>
<p>6.2. Состав базовой версии Программного продукта и стоимость дополнительных модулей опубликована на сайте Лицензиара по адресу <a href="http://www.sbuilder.ru/buy_cms/" target="_blank">http://www.sbuilder.ru/buy_cms/</a>. </p>
<p>6.3. Итоговая стоимость Программного продукта складывается из стоимости базовой версии Программного продукта и выбранных Лицензиатом дополнительных модулей. Итоговая стоимость Программного продукта НДС не облагается согласно статье 149, пункту 2, подпункту 26 Налогового Кодекса Российской Федерации.</p>
<p>6.4. Лицензиат делает заявку на покупку Программного продукта и функциональных модулей через специальный интерфейс на сайте Лицензиара. На основании заявки формируется Лицензионный ключ и Счет на оплату услуг по передаче неисключительных прав на использование Программного продукта, в котором перечислены все дополнительные модули Программного продукта. </p>
<p>6.5. После оплаты Счета на услуги по передаче неисключительных прав на использование Программного продукта Лицензиатом, составляется акт приема-передачи неисключительных прав на использование Программного продукта (далее - Акт).</p>
<p>6.6. Лицензиат обязуется выслать подписанный со своей стороны Акт Лицензиару в течении 5 (пяти) рабочих дней после получения неисключительных прав на использование Программного продукта по настоящему договору. Если в течение 5 (пяти) рабочих дней от Лицензиата не поступило подписанного Акта, либо мотивированных письменных возражений, то Услуги считаются оказанными Лицензиаром надлежащим образом и принятыми Лицензиатом в указанном в Акте объеме, а Акт, составленный Лицензиаром, имеет силу двухстороннего.</p>

<h2>7.АКЦЕПТ ОФЕРТЫ И ЗАКЛЮЧЕНИЕ ДОГОВОРА</h2>
<p>7.1. Лицензиат производит Акцепт Оферты путем предварительной оплаты по Счету Услуг Лицензиара, в отношении которых заключается Договор, в течение установленного срока. В случае если Акцепт Оферты (оплата Счета) не был произведен в течение установленного срока оплаты, Оферта теряет силу в отношении таких заказываемых Услуг.</p>


<h2>8.СРОК ДЕЙСТВИЯ И ИЗМЕНЕНИЕ УСЛОВИЙ ОФЕРТЫ</h2>
<p>8.1. Оферта вступает в силу с момента размещения в сети Интернет по адресу http://www.sbuilder.ru/oferta_sbuilder.rtf и действует до момента отзыва Оферты Лицензиаром. </p>
<p>8.2. Лицензиар оставляет за собой право внести изменения в условия Оферты и/или отозвать Оферту в любой момент по своему усмотрению. В случае внесения Лицензиаром изменений в Оферту, такие изменения вступают в силу с момента размещения измененного текста Оферты в сети Интернет по указанному в пункте 8.1 адресу, если иной срок вступления изменений в силу не определен дополнительно при таком размещении.</p>

<H2>9.ИЗМЕНЕНИЕ И РАСТОРЖЕНИЕ ДОГОВОРА</h2>
<p>9.1. Акцепт Оферты Лицензиатом, произведенный согласно статье 7 Оферты, создает Договор (статья 438 Гражданского Кодекса Российской Федерации) на условиях Оферты.</p>
<p>9.2. Договор вступает в силу с момента Акцепта Оферты Лицензиатом.</p>
<p>9.3. В случае, если Лицензионный ключ не оплачен в течение 30 дней с момента Акцепта Оферты, Договор теряет силу.</p>
<p>9.4. Лицензиат соглашается и признает, что внесение изменений в Оферту влечет за собой внесение этих изменений в заключенный и действующий между Лицензиатом и Лицензиаром Договор, и эти изменения в Договор вступают в силу одновременно с такими изменениями в Оферту. </p>
<p>9.5. В случае отзыва Оферты Лицензиаром в течение срока действия Договора, Договор считается прекращенным с момента отзыва, если иное не оговорено Лицензиаром при отзыве Оферты.  </p>
<p>9.6. Договор может быть расторгнут:</p>
<p style="margin-left: 33px; text-indent: -33px;">9.6.1. По соглашению Сторон в любое время;</p>
<p style="margin-left: 33px; text-indent: -33px;">9.6.2. По инициативе любой из Сторон в случае нарушения другой Стороной условий Договора с письменным уведомлением другой Стороны;</p>
<p style="margin-left: 33px; text-indent: -33px;">9.6.3. По иным основаниям, предусмотренным настоящей Офертой законодательством Российской Федерации;</p>

<h2>10.ГАРАНТИЙНЫЕ ОБЯЗАТЕЛЬСТВА</h2>
<p>10.1. За исключением гарантий, прямо указанных в тексте Оферты, Лицензиар не предоставляет никаких иных прямых или подразумеваемых гарантий по Договору и прямо отказывается от каких-либо гарантий или условий в отношении не нарушения прав, соответствия Услуг конкретным целям Лицензиата.</p>
<p>10.1. Соглашаясь с условиями и принимая условия настоящей Оферты путем Акцепта Оферты, Лицензиат (или представитель Лицензиата, в т.ч. физическое лицо, должным образом уполномоченное заключить Договор от лица Лицензиата) заверяет Лицензиара и гарантирует Лицензиару, что:</p>
<p style="margin-left: 40px; text-indent: -40px;">10.2.1. Лицензиат (представитель Лицензиата) указал достоверные данные, в том числе персональные, Лицензиата при оформлении платежных документов по оплате Услуг.</p>
<p style="margin-left: 40px; text-indent: -40px;">10.2.2. Лицензиат заключает Договор добровольно, при этом Лицензиат (представитель Лицензиата) полностью ознакомился с условиями Оферты, полностью понимает предмет Оферты и Договора, полностью понимает значение и последствия своих действий в отношении заключения и исполнения Договора.</p>
<p>10.3. Лицензиат (представитель Лицензиата) обладает всеми правами и полномочиями, необходимыми для заключения и исполнения Договора.</p>

<h2>11.ОТВЕТСТВЕННОСТЬ СТОРОН</h2>
<p>11.1. За нарушение условий Договора Стороны несут ответственность, установленную Договором и/или действующим законодательством РФ.</p>
<p>11.2. Стороны освобождаются от ответственности в случае невыполнения или ненадлежащего выполнения каких-либо обязательств по Договору и не вправе требовать возмещения понесённых убытков либо компенсации за неполученные доходы, если указанное невыполнение или ненадлежащее выполнение обусловлены обстоятельствами непреодолимой силы (форс-мажор), возникшими после заключения договора в результате обстоятельств чрезвычайного характера, которые стороны не могли предвидеть или предотвратить.</p>
<p>11.3. К форс-мажорным обстоятельствам относятся: стихийные бедствия (наводнения, землетрясения, бури, пожары и иные природные либо технические катастрофы), эпидемии, военные действия, общественные беспорядки и межнациональные конфликты, диверсии, изменение социально-политической либо экономической обстановки, приведших к невозможности исполнять обязательства по настоящему договору, а также все иные события, не поддающиеся разумному контролю Сторон.</p>
<p>11.4. В случаях возникновения таких обстоятельств, Сторона, не выполнившая какие-либо обязательства по Договору, обязана в течение суток информировать другую Сторону о наступлении форс-мажорных обстоятельств.</p>
<p>11.5. В случае, если Сторона, выполнению обязательств которой препятствуют обстоятельства непреодолимой силы, не известит другую Сторону об этом в 10-тидневный срок, исчисляемый со дня наступления таковых, такая Сторона теряет право ссылаться на указанные обстоятельства.</p>
<p>11.6. Все споры, разногласия и претензии, касающиеся Договора или возникающие в связи с ним, которые Стороны не смогли решить путём переговоров, подлежат окончательному урегулированию в судебном порядке в соответствии с действующим законодательством РФ.</p>

<h2>12.ДОПОЛНИТЕЛЬНЫЕ УСЛОВИЯ</h2>
<p>12.1. Договор, его заключение и исполнение регулируется действующим законодательством Российской Федерации. Все вопросы, не урегулированные Офертой или урегулированные не полностью, регулируются в соответствии с законодательством Российской Федерации. Если споры между Лицензиатом и Лицензиаром в отношении Договора не разрешены путем переговоров Сторон, они подлежат рассмотрению в порядке, предусмотренном действующим законодательством в Арбитражном суде г. Москвы.</p>
<p>12.2. Любые уведомления по Договору могут направляться одной Стороной другой Стороне:</p>
<p style="margin-left: 40px; text-indent: -40px;">12.2.1. По электронной почте,  на адрес электронной почты Лицензиата, указанный им при создании Лицензионного ключа, с адреса электронной почты Лицензиара, указанного в п. 13 Оферты в случае, если получателем является Лицензиат;</p>
<p style="margin-left: 40px; text-indent: -40px;">12.2.1. На адрес электронной почты Лицензиара, указанный в п. 13 Оферты, с адреса электронной почты Рекламодателя, указанного им при создании Рекламной кампании; </p>
<p style="margin-left: 40px; text-indent: -40px;">12.3.1. По факсу; </p>
<p style="margin-left: 40px; text-indent: -40px;">12.4.1. Почтой с уведомлением о вручении или курьерской службой с подтверждением доставки;</p>
<p>12.3. В случае если одно или более положений Оферты являются по какой-либо причине недействительными, не имеющими юридической силы, такая недействительность не оказывает влияния на действительность любого другого положения Оферты (Договора), которые остаются в силе.</p>
<p>12.4. Не вступая в противоречие с условиями Оферты, Лицензиар и Лицензиат вправе в любое время оформить Договор на оказание Услуг в форме письменного двухстороннего документа.</p>

<h2>13.РЕКВИЗИТЫ ЛИЦЕНЗИАРА</h2>
<b>Наименование:</b> Общество с Ограниченной Ответственностью "СИБИЭС-Групп"<br>
<b>Юридический адрес:</b> Российская Федерация, 127254, г. Москва, Огородный пр., д. 5, стр. 7<br>
<b>Почтовый адрес:</b> Российская Федерация, г. Москва, 1-ый Котляковский пер, д.4<br>
<b>ОГРН</b> 1047796792031, <b>ИНН</b> 7715540575, <b>КПП</b> 771501001, <b>р/c</b> 40702810580170725301 в ОАО АКБ "Промсвязьбанк", доп.офис "АиФ", г.Москва (к/c 30101810600000000119, БИК 044583119)<br>
<b>Тел.:</b> +7 (495) 988-07-66<br>
<b>Факс:</b> +7 (495) 980-62-63<br>
<b>Электронная почта:</b> <a href="mailto:support@sbuilder.ru">support@sbuilder.ru</a><br>
</pre>
</div>
</div>
</div>
</body>
</html>