<?php
if (!isset($_GET['id']) || !isset($_GET['ident']) || !isset($_GET['s_id']))
{
	exit(0);
}
	
$dir = substr(dirname(__FILE__), 0, -5).'kernel/prog';

require_once $dir.'/header.inc.php';

$f_name = preg_replace('/[^A-Za-z_0-9\-]+/', '', $_GET['id']);
$ident = preg_replace('/[^A-Za-z0-9\-_]+/', '', $_GET['ident']);
$plugin_id = intval($_GET['s_id']);
$categs = substr($ident, -7);

if ($categs == '_categs')
{
	$categs = true;
	$ident = substr($ident, 0, -7);
}
else 
{
	$categs = false;
}

$res = sql_query('SELECT '.($categs ? 'pd_categs' : 'pd_fields').' FROM sb_plugins_data WHERE pd_plugin_ident=?', $ident);
if (!$res || $res[0][0] == '')
{
	exit(0);
}

$fields = unserialize($res[0][0]);
if (!$fields || count($fields) <= 0)
{
	exit(0);
}
$cat_id = -1;
$subcategs = false;
$title_fld = '';
$link_ident = '';

foreach ($fields as $key => $value)
{
	if ('user_f_'.$value['id'] == $f_name)
	{
		$subcategs = $value['settings']['modules_subcategs'] == 1;
		$cat_id = $value['settings']['modules_cat_id'];
		if (isset($value['settings']['modules_title_fld']) && $value['settings']['modules_title_fld'] != '')
		{
			$link_ident = $value['settings']['ident'];
			$title_fld = preg_replace('/[^a-zA-Z0-9_\-]+/', '', $value['settings']['modules_title_fld']);
		}
		break;
	}
}

if ($cat_id <= 0 || $title_fld == '' || $link_ident == '')
{
	exit(0);
}

$sql_params = getPluginSqlParams($link_ident);
$res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $cat_id);

if (!$res)
{
	exit(0);
}

list($left, $right) = $res[0];

$res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_left > ?d AND cat_right < ?d AND cat_id=?d', $left, $right, $plugin_id);

if (!$res)
{
	exit(0);
}
    
if ($subcategs)
{
    list($left, $right) = $res[0];
    $res = sql_query('SELECT DISTINCT el.'.$sql_params['id'].', el.'.$title_fld.' FROM '.$sql_params['table'].' el, sb_catlinks l, sb_categs c WHERE el.p_active = 1 AND c.cat_ident=? AND c.cat_left >= ?d AND c.cat_right <= ?d AND l.link_cat_id=c.cat_id AND l.link_el_id=el.'.$sql_params['id'].' ORDER BY el.'.$sql_params['sort'].', el.'.$title_fld, $link_ident, $left, $right);
}
else 
{
    $res = sql_query('SELECT DISTINCT el.'.$sql_params['id'].', el.'.$title_fld.' FROM '.$sql_params['table'].' el, sb_catlinks l WHERE el.p_active = 1 AND l.link_cat_id = ?d AND l.link_el_id=el.'.$sql_params['id'].' ORDER BY el.'.$sql_params['sort'].', el.'.$title_fld, $plugin_id);
}
if (!$res)
{
	exit(0);
}
    
$result = '';
$num = count($res);
foreach($res as $key => $value)
{
	list($s_id, $s_title) = $value;
            
    $result .= $s_id.'^^'.$s_title.($key != $num - 1 ? '::' : '');
}
    
echo $result;

require_once SB_PROG_KERNEL_PATH.'/footer.inc.php';
?>