<?php
$dir = substr(dirname(__FILE__), 0, -5).'kernel/prog';

require_once $dir.'/header.inc.php';

if(isset($_GET['wsdl']))
{
	// Разрешен ли доступ с данного IP
	$availIPs = sbPlugins::getSetting('sb_admin_soap_ip');
	if ($availIPs != '')
	{
    	$u_ip = sbAuth::getIP();
    	$error = true;
        $availIPs = explode(' ', $availIPs);
        foreach ($availIPs as $value)
        {
        	if (trim($value) != '')
            {
            	if (sbAuth::compareIP($value, $u_ip))
                {
                	$error = false;
                    break;
                }
            }
        }
        if ($error)
        {
        	// Пытаемся зайти не с разрешенного IP-адреса
        	echo '<?xml version="1.0" encoding="UTF-8"?><sbanswer>
        		      <sbmessage code="2007">'.SOAP_AT_IP_ERROR.'</sbmessage>
        	      </sbanswer>';
        	sb_add_system_message(SOAP_SYSTEM_MESSAGE_PREFIX.sprintf(SOAP_AT_IP_ERROR_MSG, '', $u_ip), SB_MSG_WARNING);
        	return false;
        }
    }

	header('Connection: close');
	header('Content-Type: text/xml; charset='.strtolower(SB_CHARSET));

	echo '<?xml version ="1.0" encoding ="UTF-8" ?>
<definitions name="soap"
 targetNamespace="'.SB_DOMAIN.'/cms/admin/soap.php?wsdl"
 xmlns:tns="'.SB_DOMAIN.'/cms/admin/soap.php?wsdl"
 xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
 xmlns:xsd="http://www.w3.org/2001/XMLSchema"
 xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/"
 xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
 xmlns="http://schemas.xmlsoap.org/wsdl/">

<message name="elements_add_xml">
 <part name="key" type="xsd:string"/>
 <part name="xml" type="xsd:string"/>
</message>
<message name="elements_add_result">
 <part name="symbol" type="xsd:string"/>
</message>

<portType name="elements">
 <operation name="plPluginsAdd">
  <input message="tns:elements_add_xml"/>
  <output message="tns:elements_add_result"/>
 </operation>
</portType>

<binding name="elements_bind" type="tns:elements">
 <soap:binding style="rpc"
  transport="http://schemas.xmlsoap.org/soap/http"/>
 <operation name="plPluginsAdd">
  <soap:operation soapAction="urn:xmethods-delayed-quotes#getQuote"/>
  <input>
   <soap:body use="encoded" namespace="urn:xmethods-delayed-quotes"
    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
     </input>
  <output>
   <soap:body use="encoded" namespace="urn:xmethods-delayed-quotes"
    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
  </output>
 </operation>
</binding>

<service name="serv">
 <port name="serv_elements_port" binding="tns:elements_bind">
  <soap:address location="'.SB_DOMAIN.'/cms/admin/soap.php"/>
 </port>
</service>
</definitions>
';
}
else
{
	if (class_exists('SoapServer'))
	{
		require_once(SB_CMS_LIB_PATH.'/sbSoap.inc.php');
		require_once SB_CMS_LIB_PATH.'/prog/sbFunctions.inc.php';

		@ini_set('soap.wsdl_cache_enabled', '0'); // отключаем кэширование WSDL

		$server = new SoapServer(SB_DOMAIN.'/cms/admin/soap.php?wsdl');
		$server->setClass('sbSoap');
		$server->handle();
	}
	else
	{
		sb_add_system_message(SOAP_SYSTEM_MESSAGE_PREFIX.SOAP_NO_LIB_ERROR, SB_MSG_WARNING);
	}
}
?>