<?php
require_once(dirname(__FILE__).'/../kernel/header.inc.php');
    
$res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident=? AND cat_title=?', 'pl_editor_templates', SB_COOKIE_DOMAIN);
$xml = '';
    
if ($res)
{
    list($cat_id) = $res[0];
    
    $res = sql_query('SELECT t.te_name, t.te_desc, t.te_img, t.te_code FROM sb_editor_templates t, sb_catlinks l 
    			WHERE l.link_cat_id=?d AND l.link_el_id=t.te_id 
    			ORDER BY t.te_sort, t.te_name', $cat_id);
    
    if($res)
    {
        foreach($res as $value)
        {
            list($te_name, $te_desc, $te_img, $te_code) = $value;
            
            $te_name = sb_str_replace(array("\r\n", "\r", "\n", '"'), array('', '', '', '\''), $te_name);
    	    
            $xml .= '<Template title="'.$te_name.'"'.($te_img != '' ? ' image="'.$te_img.'"' : '').'>
					   <Description>'.$te_desc.'</Description>
					   <Html><![CDATA['.$te_code.']]></Html>
					 </Template>';
        }
    }
}
       
echo '<?xml version="1.0" encoding="utf-8" ?><Templates imagesBasePath="/cms/editor/templates/">'.$xml.'</Templates>';

require_once(dirname(__FILE__).'/../kernel/footer.inc.php');
?>
