<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>
var sbEditorRemoveFormatTags = 'b,big,code,del,dfn,em,font,i,ins,kbd,q,samp,small,span,strike,strong,sub,sup,tt,u,var' ;
var sbEditorRemoveAttributesArray = new String('class,style,lang,width,height,align,hspace,valign').split(',') ;
var sbEditorStylesXmlPath = '<?php echo SB_CMS_EDITOR_URL; ?>/styles.php';
var sbEditorTemplatesXmlPath = '<?php echo SB_CMS_EDITOR_URL; ?>/templates.php';
var sbEditorCoreStyles = 
{
	//'Bold'			: { Element : 'strong', Overrides : 'b' },
	//'Italic'		: { Element : 'em', Overrides : 'i' },
	'Underline'		: { Element : 'u' },
	'StrikeThrough'	: { Element : 'strike' },
	'Subscript'		: { Element : 'sub' },
	'Superscript'	: { Element : 'sup' },

	'p'				: { Element : 'p' },
	'div'			: { Element : 'div' },
	'pre'			: { Element : 'pre' },
	'address'		: { Element : 'address' },
	'h1'			: { Element : 'h1' },
	'h2'			: { Element : 'h2' },
	'h3'			: { Element : 'h3' },
	'h4'			: { Element : 'h4' },
	'h5'			: { Element : 'h5' },
	'h6'			: { Element : 'h6' },

	'FontFace' :
	{
		Element		: 'span',
		Styles		: { 'font-family' : '#("Font")' },
		Overrides	: [ { Element : 'font', Attributes : { 'face' : null } } ]
	},

	'Size' :
	{
		Element		: 'span',
		Styles		: { 'font-size' : '#("Size","fontSize")' },
		Overrides	: [ { Element : 'font', Attributes : { 'size' : null } } ]
	},

	'Color' :
	{
		Element		: 'span',
		Styles		: { 'color' : '#("Color","color")' },
		Overrides	: [ { Element : 'font', Attributes : { 'color' : null } } ]
	},

	'BackColor'		: { Element : 'span', Styles : { 'background-color' : '#("Color","color")' } },

	'SelectionHighlight' : { Element : 'span', Styles : { 'background-color' : 'navy', 'color' : 'white' } }
};

if (SB_EDITOR_STRONG_OVERRIDE)
	sbEditorCoreStyles.Bold = { Element : 'b', Overrides : 'strong' };
else
	sbEditorCoreStyles.Bold = { Element : 'strong', Overrides : 'b' };

if (SB_EDITOR_EM_OVERRIDE)
	sbEditorCoreStyles.Italic = { Element : 'i', Overrides : 'em' };
else
	sbEditorCoreStyles.Italic = { Element : 'em', Overrides : 'i' };
	
var sbEditorListsLib =
{
	BlockElements : { address:1,blockquote:1,center:1,div:1,dl:1,fieldset:1,form:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,hr:1,marquee:1,noscript:1,ol:1,p:1,pre:1,script:1,table:1,ul:1 },
	NonEmptyBlockElements : { p:1,div:1,form:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,address:1,pre:1,ol:1,ul:1,li:1,td:1,th:1 },
	InlineChildReqElements : { abbr:1,acronym:1,b:1,bdo:1,big:1,cite:1,code:1,del:1,dfn:1,em:1,font:1,i:1,ins:1,label:1,kbd:1,q:1,samp:1,small:1,span:1,strike:1,strong:1,sub:1,sup:1,tt:1,u:1,'var':1 },
	InlineNonEmptyElements : { a:1,abbr:1,acronym:1,b:1,bdo:1,big:1,cite:1,code:1,del:1,dfn:1,em:1,font:1,i:1,ins:1,label:1,kbd:1,q:1,samp:1,small:1,span:1,strike:1,strong:1,sub:1,sup:1,tt:1,u:1,'var':1 },
	EmptyElements : { base:1,col:1,meta:1,link:1,hr:1,br:1,param:1,img:1,area:1,input:1 },
	PathBlockElements : { address:1,blockquote:1,dl:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,p:1,pre:1,li:1,dt:1,de:1 },
	PathBlockLimitElements : { body:1,div:1,td:1,th:1,caption:1,form:1 },
	StyleBlockElements : { address:1,div:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,p:1,pre:1 },
	StyleObjectElements : { img:1,hr:1,li:1,table:1,tr:1,td:1,embed:1,object:1,ol:1,ul:1 },
	NonEditableElements : { button:1,option:1,script:1,iframe:1,textarea:1,object:1,embed:1,map:1,applet:1 },
	BlockBoundaries : { p:1,div:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,hr:1,address:1,pre:1,ol:1,ul:1,li:1,dt:1,de:1,table:1,thead:1,tbody:1,tfoot:1,tr:1,th:1,td:1,caption:1,col:1,colgroup:1,blockquote:1,body:1 },
	ListBoundaries  : { p:1,div:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,hr:1,address:1,pre:1,ol:1,ul:1,li:1,dt:1,de:1,table:1,thead:1,tbody:1,tfoot:1,tr:1,th:1,td:1,caption:1,col:1,colgroup:1,blockquote:1,body:1,br:1 }
};

var sbEditorRegexLib =
{
	AposEntity		: /&apos;/gi ,
	ObjectElements	: /^(?:IMG|TABLE|TR|TD|TH|INPUT|SELECT|TEXTAREA|HR|OBJECT|A|UL|OL|LI)$/i ,
	NamedCommands	: /^(?:Cut|Copy|Paste|Print|SelectAll|RemoveFormat|Unlink|Undo|Redo|Bold|Italic|Underline|StrikeThrough|Subscript|Superscript|JustifyLeft|JustifyCenter|JustifyRight|JustifyFull|Outdent|Indent|InsertOrderedList|InsertUnorderedList|InsertHorizontalRule)$/i ,
	BeforeBody	: /(^[\s\S]*\<body[^\>]*\>)/i,
	AfterBody	: /(\<\/body\>[\s\S]*$)/i,
	ToReplace		: /___sbtoreplace:([\w]+)/ig ,
	MetaHttpEquiv	: /http-equiv\s*=\s*["']?([^"' ]+)/i ,
	HasBaseTag		: /<base /i ,
	HasBodyTag		: /<body[\s|>]/i ,
	HtmlOpener		: /<html\s?[^>]*>/i ,
	HeadOpener		: /<head\s?[^>]*>/i ,
	HeadCloser		: /<\/head\s*>/i ,
	SB_Class		: /\s*SB__[^ ]*(?=\s+|$)/ ,
	ElementName		: /(^[a-z_:][\w.\-:]*\w$)|(^[a-z_]$)/ ,
	ForceSimpleAmpersand : /___SBAmp___/g ,
	SpaceNoClose	: /\/>/g ,
	EmptyParagraph	: /^<(p|div|address|h\d|center)(?=[ >])[^>]*>\s*(<\/\1>)?$/ ,
	EmptyOutParagraph : /^<(p|div|address|h\d|center)(?=[ >])[^>]*>(?:\s*|&nbsp;)(<\/\1>)?$/ ,
	TagBody			: /></ ,
	GeckoEntitiesMarker : /#\?-\:/g ,
	ProtectUrlsImg	: /<img(?=\s).*?\ssrc=((?:(?:\s*)("|').*?\2)|(?:[^"'][^ >]+))/gi ,
	ProtectUrlsA	: /<a(?=\s).*?\shref=((?:(?:\s*)("|').*?\2)|(?:[^"'][^ >]+))/gi ,
	ProtectUrlsArea	: /<area(?=\s).*?\shref=((?:(?:\s*)("|').*?\2)|(?:[^"'][^ >]+))/gi ,
	Html4DocType	: /HTML 4\.0 Transitional/i ,
	DocTypeTag		: /<!DOCTYPE[^>]*>/i ,
	HtmlDocType		: /DTD HTML/ ,
	TagsWithEvent	: /<[^\>]+ on\w+[\s\r\n]*=[\s\r\n]*?('|")[\s\S]+?\>/g ,
	EventAttributes	: /\s(on\w+)[\s\r\n]*=[\s\r\n]*?('|")([\s\S]*?)\2/g,
	ProtectedEvents : /\s\w+_sbprotectedatt="([^"]+)"/g,
	StyleProperties : /\S+\s*:/g,
	InvalidSelfCloseTags : /(<(?!base|meta|link|hr|br|param|img|area|input)([a-zA-Z0-9:]+)[^>]*)\/>/gi,
	StyleVariableAttName : /#\(\s*("|')(.+?)\1[^\)]*\s*\)/g,
	RegExp : /^\/(.*)\/([gim]*)$/,
	HtmlTag : /<[^\s<>](?:"[^"]*"|'[^']*'|[^<])*>/
};

/**
 * @param object styleDesc Объект описания стиля следующего формата:
 *		'<название стиля>' : {
 *			Element : '<название элемента (тэг)>',
 *			Attributes : {
 *				'<название атрибута>' : '<значение атрибута>',
 *				...
 *			},
 *			Styles : {
 *				'<название стиля>' : '<значение стиля>',
 *				...
 *			},
 *			Overrides : '<название элемента (тэг)>'|{
 *				Element : '<назввание элемента (тэг)>',
 *				Attributes : {
 *					'<название атрибута>' : '<значение атрибута>'|/<регулярное выражение для значения атрибута>/
 *				},
 *				Styles : {
 *					'<название стиля>' : '<значение стиля>'|/<регулярное выражение для значения стиля>/
 *				},
 *			}
 *		}
 */
var sbEditorStyle = function( styleDesc )
{
	this._Element = ( styleDesc.Element || 'span' ).toLowerCase() ;
	this._StyleDesc = styleDesc ;
}

var sbespt = sbEditorStyle.prototype;

/**
 * Возвращает тип элемента стиля 
 */
sbespt._GetType = function()
{
	var type = this._GetType_$ ;

	if ( type != undefined )
		return type ;

	var elementName = this._Element ;

	if ( elementName == '#' || sbEditorListsLib.StyleBlockElements[ elementName ] )
		type = SB_EDITOR_STYLE_BLOCK ;
	else if ( sbEditorListsLib.StyleObjectElements[ elementName ] )
		type = SB_EDITOR_STYLE_OBJECT ;
	else
		type = SB_EDITOR_STYLE_INLINE ;

	return ( this._GetType_$ = type ) ;
}

/**
 * Применяет стиль к текущему выделению
 */
sbespt._ApplyToSelection = function( targetWindow )
{
	var range = new sbEditorDomRange( targetWindow ) ;
	range._MoveToSelection() ;

	this._ApplyToRange( range, true ) ;
}

sbespt._ApplyToRange = function( range, selectIt, updateRange )
{
	switch ( this._GetType() )
	{
		case SB_EDITOR_STYLE_BLOCK :
			this._ApplyToRange = this._ApplyBlockStyle ;
			break ;
			
		case SB_EDITOR_STYLE_INLINE :
			this._ApplyToRange = this._ApplyInlineStyle ;
			break ;
			
		default :
			return ;
	}

	this._ApplyToRange( range, selectIt, updateRange ) ;
}

sbespt._ApplyToObject = function( objectElement )
{
	if ( !objectElement )
		return ;

	this._BuildElement( null, objectElement ) ;
}

sbespt._RemoveFromSelection = function( targetWindow )
{
	var range = new sbEditorDomRange( targetWindow ) ;
	range._MoveToSelection() ;

	this._RemoveFromRange( range, true ) ;
}

sbespt._RemoveFromRange = function( range, selectIt, updateRange )
{
	var bookmark ;
	var styleAttribs = this._GetAttribsForComparison() ;
	var styleOverrides = this._GetOverridesForComparison() ;

	if ( range._IsCollapsed() )
	{
		var bookmark = range._CreateBookmark( true ) ;
		var bookmarkStart = range._GetBookmarkNode( bookmark, true ) ;
		var path = new sbEditorElementPath( bookmarkStart.parentNode ) ;

		var boundaryElements = [] ;

		var isBoundaryRight = !sbEditorGetNextSibling( bookmarkStart ) ;
		var isBoundary = isBoundaryRight || !sbEditorGetPreviousSibling( bookmarkStart ) ;

		var lastBoundaryElement ;
		var boundaryLimitIndex = -1 ;

		for ( var i = 0 ; i < path._Elements.length ; i++ )
		{
			var pathElement = path._Elements[i] ;
			if ( this._IsRemovable( pathElement ) )
			{
				if ( isBoundary && !sbEditorIsEmptyElement( pathElement,
							function( el )
							{
								return ( el != bookmarkStart ) ;
							} )
					)
				{
					lastBoundaryElement = pathElement ;
					boundaryLimitIndex = boundaryElements.length - 1 ;
				}
				else
				{
					var pathElementName = pathElement.nodeName.toLowerCase() ;

					if ( pathElementName == this._Element )
					{
						for ( var att in styleAttribs )
						{
							if ( sbEditorHasAttribute( pathElement, att ) )
							{
								switch ( att )
								{
									case 'style' :
										this._RemoveStylesFromElement( pathElement ) ;
										break ;

									case 'class' :
										if ( sbEditorGetAttributeValue( pathElement, att ) != this._GetFinalAttributeValue( att ) )
											continue ;

									default :
										sbEditorRemoveAttribute( pathElement, att ) ;
								}
							}
						}
					}

					this._RemoveOverrides( pathElement, styleOverrides[ pathElementName ] ) ;

					if ( this._GetType() == SB_EDITOR_STYLE_INLINE)
						this._RemoveNoAttribElement( pathElement ) ;
				}
			}
			else if ( isBoundary )
				boundaryElements.push( pathElement ) ;

			isBoundary = isBoundary && ( ( isBoundaryRight && !sbEditorGetNextSibling( pathElement ) ) || ( !isBoundaryRight && !sbEditorGetPreviousSibling( pathElement ) ) ) ;

			if ( lastBoundaryElement && ( !isBoundary || ( i == path._Elements.length - 1 ) ) )
			{
				var currentElement = sbEditorRemoveNode( bookmarkStart ) ;

				for ( var j = 0 ; j <= boundaryLimitIndex ; j++ )
				{
					var newElement = sbEditorCloneElement( boundaryElements[j] ) ;
					newElement.appendChild( currentElement ) ;
					currentElement = newElement ;
				}

				if ( isBoundaryRight )
					sbEditorInsertAfterNode( lastBoundaryElement, currentElement ) ;
				else
					lastBoundaryElement.parentNode.insertBefore( currentElement, lastBoundaryElement ) ;

				isBoundary = false ;
				lastBoundaryElement = null ;
			}
		}

		if ( selectIt )
			range._SelectBookmark( bookmark ) ;

		if ( updateRange )
			range._MoveToBookmark( bookmark ) ;

		return ;
	}

	range._Expand( 'inline_elements' ) ;

	bookmark = range._CreateBookmark( true ) ;
	var startNode = range._GetBookmarkNode( bookmark, true ) ;
	var endNode = range._GetBookmarkNode( bookmark, false ) ;

	range._Release( true ) ;

	var path = new sbEditorElementPath( startNode ) ;
	var pathElements = path._Elements ;
	var pathElement ;

	for ( var i = 1 ; i < pathElements.length ; i++ )
	{
		pathElement = pathElements[i] ;

		if ( pathElement == path._Block || pathElement == path._BlockLimit )
			break ;

		if ( this._IsRemovable( pathElement ) )
			sbEditorBreakParent( startNode, pathElement, range ) ;
	}

	path = new sbEditorElementPath( endNode ) ;
	pathElements = path._Elements ;

	for ( var i = 1 ; i < pathElements.length ; i++ )
	{
		pathElement = pathElements[i] ;

		if ( pathElement == path._Block || pathElement == path._BlockLimit )
			break ;

		elementName = pathElement.nodeName.toLowerCase() ;

		if ( this._IsRemovable( pathElement ) )
			sbEditorBreakParent( endNode, pathElement, range ) ;
	}

	var currentNode = sbEditorGetNextSourceNode( startNode, true ) ;
	while ( currentNode )
	{
		var nextNode = sbEditorGetNextSourceNode( currentNode ) ;

		if ( currentNode.nodeType == 1 )
		{
			var elementName = currentNode.nodeName.toLowerCase() ;

			var mayRemove = ( elementName == this._Element ) ;
			if ( mayRemove )
			{
				for ( var att in styleAttribs )
				{
					if ( sbEditorHasAttribute( currentNode, att ) )
					{
						switch ( att )
						{
							case 'style' :
								this._RemoveStylesFromElement( currentNode ) ;
								break ;

							case 'class' :
								if ( sbEditorGetAttributeValue( currentNode, att ) != this._GetFinalAttributeValue( att ) )
									continue ;

							default :
								sbEditorRemoveAttribute( currentNode, att ) ;
						}
					}
				}
			}
			else
				mayRemove = !!styleOverrides[ elementName ] ;

			if ( mayRemove )
			{
				this._RemoveOverrides( currentNode, styleOverrides[ elementName ] ) ;
				this._RemoveNoAttribElement( currentNode ) ;
			}
		}

		if ( nextNode == endNode )
			break ;

		currentNode = nextNode ;
	}

	this._FixBookmarkStart( startNode ) ;

	if ( selectIt )
		range._SelectBookmark( bookmark ) ;

	if ( updateRange )
		range._MoveToBookmark( bookmark ) ;
}

sbespt._IsRemovable = function( element, fullMatch )
{
	if ( !element )
		return false ;

	var elementName = element.nodeName.toLowerCase() ;

	if ( elementName == this._Element )
	{
		if ( !fullMatch && !sbEditorHasAttributes( element ) )
			return true ;

		var attribs = this._GetAttribsForComparison() ;
		var allMatched = ( attribs._length == 0 ) ;
		for ( var att in attribs )
		{
			if ( att == '_length' )
				continue ;

			if ( this._CompareAttributeValues( att, sbEditorGetAttributeValue( element, att ), ( this._GetFinalAttributeValue( att ) || '' ) ) )
			{
				allMatched = true ;
				if ( !fullMatch )
					break ;
			}
			else
			{
				allMatched = false ;
				if ( fullMatch )
					return false ;
			}
		}
		if ( allMatched )
			return true ;
	}

	var override = this._GetOverridesForComparison()[ elementName ] ;
	if ( override )
	{
		if ( !( attribs = override.Attributes ) )
			return true ;

		for ( var i = 0 ; i < attribs.length ; i++ )
		{
			var attName = attribs[i][0] ;
			if ( sbEditorHasAttribute( element, attName ) )
			{
				var attValue = attribs[i][1] ;

				if ( attValue == null ||
						( typeof (attValue) == 'string' && sbEditorGetAttributeValue( element, attName ) == attValue ) ||
						attValue.test( sbEditorGetAttributeValue( element, attName ) ) )
					return true ;
			}
		}
	}

	return false ;
}

sbespt._IsActive = function( elementPath )
{
	switch ( this._GetType() )
	{
		case SB_EDITOR_STYLE_BLOCK :
			return this._IsRemovable( elementPath._Block || elementPath._BlockLimit, true ) ;

		case SB_EDITOR_STYLE_INLINE :

			var elements = elementPath._Elements ;

			for ( var i = 0 ; i < elements.length ; i++ )
			{
				var element = elements[i] ;

				if ( element == elementPath._Block || element == elementPath._BlockLimit )
					continue ;

				if ( this._IsRemovable( element, true ) )
					return true ;
			}
			break;
	}
	return false ;
}

sbespt._RemoveFromElement = function( element )
{
	var attribs = this._GetAttribsForComparison() ;
	var overrides = this._GetOverridesForComparison() ;

	var innerElements = element.getElementsByTagName( this._Element ) ;

	for ( var i = innerElements.length - 1 ; i >= 0 ; i-- )
	{
		var innerElement = innerElements[i] ;

		for ( var att in attribs )
		{
			if ( sbEditorHasAttribute( innerElement, att ) )
			{
				switch ( att )
				{
					case 'style' :
						this._RemoveStylesFromElement( innerElement ) ;
						break ;

					case 'class' :
						if ( sbEditorGetAttributeValue( innerElement, att ) != this._GetFinalAttributeValue( att ) )
							continue ;

					default :
						sbEditorRemoveAttribute( innerElement, att ) ;
				}
			}
		}

		this._RemoveOverrides( innerElement, overrides[ this._Element ] ) ;
		this._RemoveNoAttribElement( innerElement ) ;
	}

	for ( var overrideElement in overrides )
	{
		if ( overrideElement != this._Element )
		{
			innerElements = element.getElementsByTagName( overrideElement ) ;

			for ( var i = innerElements.length - 1 ; i >= 0 ; i-- )
			{
				var innerElement = innerElements[i] ;
				this._RemoveOverrides( innerElement, overrides[ overrideElement ] ) ;
				this._RemoveNoAttribElement( innerElement ) ;
			}
		}
	}
}

sbespt._RemoveStylesFromElement = function( element )
{
	var elementStyle = element.style.cssText ;
	var pattern = this._GetFinalStyleValue() ;

	if ( elementStyle.length > 0 && pattern.length == 0 )
		return ;

	pattern = '(^|;)\\s*(' +
		pattern.replace( /\s*([^ ]+):.*?(;|$)/g, '$1|' ).replace( /\|$/, '' ) +
		'):[^;]+' ;

	var regex = new RegExp( pattern, 'gi' ) ;
	elementStyle = elementStyle.replace( regex, '' ).Trim() ;
	if ( elementStyle.length == 0 || elementStyle == ';' )
		sbEditorRemoveAttribute( element, 'style' ) ;
	else
		element.style.cssText = elementStyle.replace( regex, '' ) ;
}

sbespt._RemoveOverrides = function( element, override )
{
	var attributes = override && override.Attributes ;

	if ( attributes )
	{
		for ( var i = 0 ; i < attributes.length ; i++ )
		{
			var attName = attributes[i][0] ;

			if ( sbEditorHasAttribute( element, attName ) )
			{
				var attValue = attributes[i][1] ;

				if ( attValue == null ||
						( attValue.test && attValue.test( sbEditorGetAttributeValue( element, attName ) ) ) ||
						( typeof (attValue) == 'string' && sbEditorGetAttributeValue( element, attName ) == attValue ) )
					sbEditorRemoveAttribute( element, attName ) ;
			}
		}
	}
}

sbespt._RemoveNoAttribElement = function( element )
{
	if ( !sbEditorHasAttributes( element ) )
	{
		var firstChild = element.firstChild ;
		var lastChild = element.lastChild ;

		sbEditorRemoveNode( element, true ) ;

		this._MergeSiblings( firstChild ) ;

		if ( firstChild != lastChild )
			this._MergeSiblings( lastChild ) ;
	}
}

sbespt._BuildElement = function( targetDoc, element )
{
	var el = element || targetDoc.createElement( this._Element ) ;
	var attribs	= this._StyleDesc.Attributes ;
	var attValue ;
	if ( attribs )
	{
		for ( var att in attribs )
		{
			attValue = this._GetFinalAttributeValue( att ) ;

			if ( att.toLowerCase() == 'class' )
				el.className = attValue ;
			else
				el.setAttribute( att, attValue ) ;
		}
	}

	if ( this._GetStyleText().length > 0 )
		el.style.cssText = this._GetFinalStyleValue() ;

	return el ;
}

sbespt._CompareAttributeValues = function( attName, valueA, valueB )
{
	if ( attName == 'style' && valueA && valueB )
	{
		valueA = valueA.replace( /;$/, '' ).toLowerCase() ;
		valueB = valueB.replace( /;$/, '' ).toLowerCase() ;
	}

	return ( valueA == valueB || ( ( valueA === null || valueA === '' ) && ( valueB === null || valueB === '' ) ) )
}

sbespt._GetFinalAttributeValue = function( attName )
{
	var attValue = this._StyleDesc.Attributes ;
	var attValue = attValue ? attValue[ attName ] : null ;

	if ( !attValue && attName == 'style' )
		return this._GetFinalStyleValue() ;

	if ( attValue && this._Variables )
		attValue = attValue.Replace( sbEditorRegexLib.StyleVariableAttName, this._GetVariableReplace, this ) ;

	return attValue ;
}

sbespt._GetFinalStyleValue = function()
{
	var attValue = this._GetStyleText() ;

	if ( attValue.length > 0 && this._Variables )
	{
		attValue = attValue.Replace( sbEditorRegexLib.StyleVariableAttName, this._GetVariableReplace, this ) ;
		attValue = sbEditorNormalizeCssText( attValue ) ;
	}

	return attValue ;
}

sbespt._GetVariableReplace = function()
{
	return this._Variables[ arguments[2] ] || arguments[0] ;
}

sbespt._SetVariable = function( name, value )
{
	var variables = this._Variables ;

	if ( !variables )
		variables = this._Variables = {} ;

	this._Variables[ name ] = value ;
}

sbespt._FromPre = function( doc, block, newBlock )
{
	var innerHTML = block.innerHTML ;

	innerHTML = innerHTML.replace( /(\r\n|\r)/g, '\n' ) ;
	innerHTML = innerHTML.replace( /^[ \t]*\n/, '' ) ;
	innerHTML = innerHTML.replace( /\n$/, '' ) ;

	innerHTML = innerHTML.replace( /^[ \t]+|[ \t]+$/g, function( match, offset, s )
			{
				if ( match.length == 1 )
					return '&nbsp;' ;
				else if ( offset == 0 )
					return new Array( match.length ).join( '&nbsp;' ) + ' ' ;
				else	
					return ' ' + new Array( match.length ).join( '&nbsp;' ) ;
			} ) ;

	var htmlIterator = new sbEditorHtmlIterator( innerHTML ) ;
	var results = [] ;
	htmlIterator._Each( function( isTag, value )
		{
			if ( !isTag )
			{
				value = value.replace( /\n/g, '<br>' ) ;
				value = value.replace( /[ \t]{2,}/g,
						function ( match )
						{
							return new Array( match.length ).join( '&nbsp;' ) + ' ' ;
						} ) ;
			}
			results.push( value ) ;
		} ) ;
		
	newBlock.innerHTML = results.join( '' ) ;
	return newBlock ;
}

sbespt._ToPre = function( doc, block, newBlock )
{
	var innerHTML = block.innerHTML.Trim() ;

	innerHTML = innerHTML.replace( /[ \t\r\n]*(<br[^>]*>)[ \t\r\n]*/gi, '<br />' ) ;

	var htmlIterator = new sbEditorHtmlIterator( innerHTML ) ;
	var results = [] ;
	htmlIterator._Each( function( isTag, value )
		{
			if ( !isTag )
				value = value.replace( /([ \t\n\r]+|&nbsp;)/g, ' ' ) ;
			else if ( isTag && value == '<br />' )
				value = '\n' ;
			results.push( value ) ;
		} ) ;

	if ( _isIE )
	{
		var temp = doc.createElement( 'div' ) ;
		temp.appendChild( newBlock ) ;
		newBlock.outerHTML = '<pre>\n' + results.join( '' ) + '</pre>' ;
		newBlock = temp.removeChild( temp.firstChild ) ;
	}
	else
		newBlock.innerHTML = results.join( '' ) ;

	return newBlock ;
}

sbespt._CheckAndMergePre = function( previousBlock, preBlock )
{
	if ( previousBlock != sbEditorGetPreviousSourceElement( preBlock, true ) )
		return ;

	var innerHTML = previousBlock.innerHTML.replace( /\n$/, '' ) + '\n\n' +
			preBlock.innerHTML.replace( /^\n/, '' ) ;

	if ( _isIE )
		preBlock.outerHTML = '<pre>' + innerHTML + '</pre>' ;
	else
		preBlock.innerHTML = innerHTML ;

	sbEditorRemoveNode( previousBlock ) ;
}

sbespt._CheckAndSplitPre = function( newBlock )
{
	var lastNewBlock ;

	var cursor = newBlock.firstChild ;
	cursor = cursor && cursor.nextSibling ;

	while ( cursor )
	{
		var next = cursor.nextSibling ;

		if ( next && next.nextSibling && cursor.nodeName.IEquals( 'br' ) && next.nodeName.IEquals( 'br' ) )
		{
			sbEditorRemoveNode( cursor ) ;
			cursor = next.nextSibling ;
			sbEditorRemoveNode( next ) ;
			lastNewBlock = sbEditorInsertAfterNode( lastNewBlock || newBlock, sbEditorCloneElement( newBlock ) ) ;

			continue ;
		}

		if ( lastNewBlock )
		{
			cursor = cursor.previousSibling ;
			sbEditorMoveNode(cursor.nextSibling, lastNewBlock ) ;
		}

		cursor = cursor.nextSibling ;
	}
}

sbespt._ApplyBlockStyle = function( range, selectIt, updateRange )
{
	var bookmark ;

	if ( selectIt )
		bookmark = range._CreateBookmark() ;

	var iterator = new sbEditorDomRangeIterator( range ) ;
	iterator._EnforceRealBlocks = true ;

	var block ;
	var doc = range._Window.document ;
	var previousPreBlock ;

	while( ( block = iterator._GetNextParagraph() ) )
	{
		var newBlock = this._BuildElement( doc ) ;

		var newBlockIsPre = newBlock.nodeName.IEquals( 'pre' ) ;
		var blockIsPre = block.nodeName.IEquals( 'pre' ) ;

		var toPre = newBlockIsPre && !blockIsPre ;
		var fromPre	= !newBlockIsPre && blockIsPre ;

		if ( toPre )
			newBlock = this._ToPre( doc, block, newBlock ) ;
		else if ( fromPre )
			newBlock = this._FromPre( doc, block, newBlock ) ;
		else	
			sbEditorMoveChildren( block, newBlock ) ;

		block.parentNode.insertBefore( newBlock, block ) ;
		sbEditorRemoveNode( block ) ;

		if ( newBlockIsPre )
		{
			if ( previousPreBlock )
				this._CheckAndMergePre( previousPreBlock, newBlock ) ;	
			previousPreBlock = newBlock ;
		}
		else if ( fromPre )
			this._CheckAndSplitPre( newBlock ) ;
	}

	if ( selectIt )
		range._SelectBookmark( bookmark ) ;

	if ( updateRange )
		range._MoveToBookmark( bookmark ) ;
}

sbespt._ApplyInlineStyle = function( range, selectIt, updateRange )
{
	var doc = range._Window.document ;

	if ( range._IsCollapsed() )
	{
		var collapsedElement = this._BuildElement( doc ) ;
		range._InsertNode( collapsedElement ) ;
		range._MoveToPosition( collapsedElement, 2 ) ;
		range._Select() ;

		return ;
	}

	var elementName = this._Element ;
	var elementDTD = sbEditorDTD[ elementName ] || sbEditorDTD.span ;
	var styleAttribs = this._GetAttribsForComparison() ;
	var styleNode ;

	range._Expand( 'inline_elements' ) ;

	var bookmark = range._CreateBookmark( true ) ;
	var startNode = range._GetBookmarkNode( bookmark, true ) ;
	var endNode = range._GetBookmarkNode( bookmark, false ) ;

	range._Release( true ) ;

	var currentNode = sbEditorGetNextSourceNode( startNode, true ) ;
	while ( currentNode )
	{
		var applyStyle = false ;
		var nodeType = currentNode.nodeType ;
		var nodeName = nodeType == 1 ? currentNode.nodeName.toLowerCase() : null ;

		if ( !nodeName || elementDTD[ nodeName ] )
		{
			if ( ( sbEditorDTD[ currentNode.parentNode.nodeName.toLowerCase() ] || sbEditorDTD.span )[ elementName ] || !sbEditorDTD[ elementName ] )
			{
				if ( !range._HasRange() )
					range.setStart( currentNode, 3 ) ;

				if ( nodeType != 1 || currentNode.childNodes.length == 0 )
				{
					var includedNode = currentNode ;
					var parentNode = includedNode.parentNode ;

					while ( includedNode == parentNode.lastChild && elementDTD[ parentNode.nodeName.toLowerCase() ] )
					{
						includedNode = parentNode ;
					}

					range.setEnd( includedNode, 4 ) ;

					if ( includedNode == includedNode.parentNode.lastChild && !elementDTD[ includedNode.parentNode.nodeName.toLowerCase() ] )
						applyStyle = true ;
				}
				else
				{
					range.setEnd( currentNode, 3 ) ;
				}
			}
			else
				applyStyle = true ;
		}
		else
			applyStyle = true ;

		currentNode = sbEditorGetNextSourceNode( currentNode ) ;

		if ( currentNode == endNode )
		{
			currentNode = null ;
			applyStyle = true ;
		}

		if ( applyStyle && range._HasRange() && !range._IsCollapsed() )
		{
			styleNode = this._BuildElement( doc ) ;

			range._ExtractContents()._AppendTo( styleNode ) ;

			if ( styleNode.innerHTML.RTrim().length > 0 )
			{
				range._InsertNode( styleNode ) ;
				this._RemoveFromElement( styleNode ) ;
				this._MergeSiblings( styleNode ) ;
				
				if ( !_isIE )
					styleNode.normalize() ;
			}

			range._Release( true ) ;
		}
	}

	this._FixBookmarkStart( startNode ) ;

	if ( selectIt )
		range._SelectBookmark( bookmark ) ;

	if ( updateRange )
		range._MoveToBookmark( bookmark ) ;
}

sbespt._FixBookmarkStart = function( startNode )
{
	var startSibling ;
	while ( ( startSibling = startNode.nextSibling ) )
	{
		if ( startSibling.nodeType == 1
			&& sbEditorListsLib.InlineNonEmptyElements[ startSibling.nodeName.toLowerCase() ] )
		{
			if ( !startSibling.firstChild )
				sbEditorRemoveNode( startSibling ) ;
			else
				sbEditorMoveNode( startNode, startSibling, true ) ;
			continue ;
		}

		if ( startSibling.nodeType == 3 && startSibling.length == 0 )
		{
			sbEditorRemoveNode( startSibling ) ;
			continue ;
		}

		break ;
	}
}

sbespt._MergeSiblings = function( element, attribs )
{
	if ( !element || element.nodeType != 1 || !sbEditorListsLib.InlineNonEmptyElements[ element.nodeName.toLowerCase() ] )
		return ;

	this._MergeNextSibling( element, attribs ) ;
	this._MergePreviousSibling( element, attribs ) ;
}

sbespt._MergeNextSibling = function( element, attribs )
{
	var sibling = element.nextSibling ;
	var hasBookmark = ( sibling && sibling.nodeType == 1 && sibling.getAttribute( '_sb_bookmark' ) ) ;
	if ( hasBookmark )
		sibling = sibling.nextSibling ;

	if ( sibling && sibling.nodeType == 1 && sibling.nodeName == element.nodeName )
	{

		if ( !attribs )
			attribs = this._CreateElementAttribsForComparison( element ) ;

		if ( this._CheckAttributesMatch( sibling, attribs ) )
		{
			var innerSibling = element.lastChild ;

			if ( hasBookmark )
				sbEditorMoveNode( element.nextSibling, element ) ;

			sbEditorMoveChildren( sibling, element ) ;
			sbEditorRemoveNode( sibling ) ;

			if ( innerSibling )
				this._MergeNextSibling( innerSibling ) ;
		}
	}
}

sbespt._MergePreviousSibling = function( element, attribs )
{
	var sibling = element.previousSibling ;
	var hasBookmark = ( sibling && sibling.nodeType == 1 && sibling.getAttribute( '_sb_bookmark' ) ) ;
	if ( hasBookmark )
		sibling = sibling.previousSibling ;

	if ( sibling && sibling.nodeType == 1 && sibling.nodeName == element.nodeName )
	{
		if ( !attribs )
			attribs = this._CreateElementAttribsForComparison( element ) ;

		if ( this._CheckAttributesMatch( sibling, attribs ) )
		{
			var innerSibling = element.firstChild ;

			if ( hasBookmark )
				sbEditorMoveNode( element.previousSibling, element, true ) ;

			sbEditorMoveChildren( sibling, element, true ) ;
			sbEditorRemoveNode( sibling ) ;

			if ( innerSibling )
				this._MergePreviousSibling( innerSibling ) ;
		}
	}
}

sbespt._GetStyleText = function()
{
	var stylesDef = this._StyleDesc.Styles ;
	var stylesText = ( this._StyleDesc.Attributes ? this._StyleDesc.Attributes['style'] || '' : '' ) ;

	if ( stylesText.length > 0 )
		stylesText += ';' ;

	for ( var style in stylesDef )
		stylesText += style + ':' + stylesDef[style] + ';' ;

	if ( stylesText.length > 0 && !( /#\(/.test( stylesText ) ) )
	{
		stylesText = sbEditorNormalizeCssText( stylesText ) ;
	}

	return (this._GetStyleText = function() { return stylesText ; })() ;
}

sbespt._GetAttribsForComparison = function()
{
	var attribs = this._GetAttribsForComparison_$ ;
	if ( attribs )
		return attribs ;

	attribs = new Object() ;

	var styleAttribs = this._StyleDesc.Attributes ;
	if ( styleAttribs )
	{
		for ( var styleAtt in styleAttribs )
		{
			attribs[ styleAtt.toLowerCase() ] = styleAttribs[ styleAtt ].toLowerCase() ;
		}
	}

	if ( this._GetStyleText().length > 0 )
	{
		attribs['style'] = this._GetStyleText().toLowerCase() ;
	}

	sbEditorAppendLengthProperty( attribs, '_length' ) ;

	return ( this._GetAttribsForComparison_$ = attribs ) ;
}

sbespt._GetOverridesForComparison = function()
{
	var overrides = this._GetOverridesForComparison_$ ;
	if ( overrides )
		return overrides ;

	overrides = new Object() ;

	var overridesDesc = this._StyleDesc.Overrides ;

	if ( overridesDesc )
	{
		if ( !( overridesDesc instanceof Array ) )
			overridesDesc = [ overridesDesc ] ;

		for ( var i = 0 ; i < overridesDesc.length ; i++ )
		{
			var override = overridesDesc[i] ;
			var elementName ;
			var overrideEl ;
			var attrs ;

			if ( typeof (override) == 'string' )
				elementName = override.toLowerCase() ;
			else
			{
				elementName = override.Element ? override.Element.toLowerCase() : this._Element ;
				attrs = override.Attributes ;
			}

			overrideEl = overrides[ elementName ] || ( overrides[ elementName ] = {} ) ;

			if ( attrs )
			{
				var overrideAttrs = ( overrideEl.Attributes = overrideEl.Attributes || new Array() ) ;
				for ( var attName in attrs )
				{
					overrideAttrs.push( [ attName.toLowerCase(), attrs[ attName ] ] ) ;
				}
			}
		}
	}

	return ( this._GetOverridesForComparison_$ = overrides ) ;
}

sbespt._CreateElementAttribsForComparison = function( element )
{
	var attribs = new Object() ;
	var attribsCount = 0 ;

	for ( var i = 0 ; i < element.attributes.length ; i++ )
	{
		var att = element.attributes[i] ;

		if ( att.specified )
		{
			attribs[ att.nodeName.toLowerCase() ] = sbEditorGetAttributeValue( element, att ).toLowerCase() ;
			attribsCount++ ;
		}
	}

	attribs._length = attribsCount ;

	return attribs ;
}

sbespt._CheckAttributesMatch = function( element, styleAttribs )
{
	var elementAttrbs = element.attributes ;
	var matchCount = 0 ;

	for ( var i = 0 ; i < elementAttrbs.length ; i++ )
	{
		var att = elementAttrbs[i] ;
		if ( att.specified )
		{
			var attName = att.nodeName.toLowerCase() ;
			var styleAtt = styleAttribs[ attName ] ;

			if ( !styleAtt )
				break ;

			if ( styleAtt != sbEditorGetAttributeValue( element, att ).toLowerCase() )
				break ;

			matchCount++ ;
		}
	}

	return ( matchCount == styleAttribs._length ) ;
}

////////////////////////////////////////////////////////////////////////////////////

var sbEditorStyles = new Object();

sbEditorStyles._Callbacks = {};
sbEditorStyles._ObjectStyles = {};

sbEditorStyles._ApplyStyle = function( style )
{
	if ( typeof (style) == 'string' )
		style = this._GetStyles()[ style ] ;

	if ( style )
	{
		if ( style._GetType() == SB_EDITOR_STYLE_OBJECT )
			style._ApplyToObject( sbEditorSelection._GetSelectedElement() ) ;
		else
			style._ApplyToSelection( sbEditorAreaWnd ) ;

		sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
	}
}

sbEditorStyles._RemoveStyle = function( style )
{
	if ( typeof (style) == 'string' )
		style = this._GetStyles()[ style ] ;

	if ( style )
	{
		style._RemoveFromSelection( sbEditorAreaWnd ) ;
		sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
	}
}

sbEditorStyles._AttachStyleStateChange = function( styleName, callback )
{
	var callbacks = this._Callbacks[ styleName ] ;

	if ( !callbacks )
		callbacks = this._Callbacks[ styleName ] = [] ;

	callbacks.push( [ callback ] ) ;
}

sbEditorStyles._CheckSelectionChanges = function()
{
	var startElement = sbEditorSelection._GetBoundaryParentElement( true ) ;

	if ( !startElement )
		return ;

	var path = new sbEditorElementPath( startElement ) ;
	var styles = this._GetStyles() ;

	for ( var styleName in styles )
	{
		var callbacks = this._Callbacks[ styleName ] ;

		if ( callbacks )
		{
			var style = styles[ styleName ] ;
			var state = style._IsActive( path ) ;

			if ( state != ( style._LastState || null ) )
			{
				style._LastState = state ;

				for ( var i = 0 ; i < callbacks.length ; i++ )
				{
					var callback = callbacks[i][0] ;
					callback( styleName, state ) ;
				}
			}
		}
	}
}

sbEditorStyles._CheckStyleInSelection = function( styleName )
{
	return false ;
}

sbEditorStyles._GetRemoveFormatTagsRegex = function ()
{
	var regex = new RegExp( '^(?:' + sbEditorRemoveFormatTags.replace( /,/g,'|' ) + ')$', 'i' ) ;

	return (this._GetRemoveFormatTagsRegex = function()
	{
		return regex ;
	})
	&& regex  ;
}

sbEditorStyles._RemoveAll = function()
{
	var range = new sbEditorDomRange( sbEditorAreaWnd ) ;
	range._MoveToSelection() ;

	if ( range._IsCollapsed() )
		return ;

	range._Expand( 'inline_elements' ) ;

	var bookmark = range._CreateBookmark( true ) ;
	var startNode = range._GetBookmarkNode( bookmark, true ) ;
	var endNode = range._GetBookmarkNode( bookmark, false ) ;

	range._Release( true ) ;

	var tagsRegex = this._GetRemoveFormatTagsRegex() ;
	var path = new sbEditorElementPath( startNode ) ;
	var pathElements = path._Elements ;
	var pathElement ;

	for ( var i = 1 ; i < pathElements.length ; i++ )
	{
		pathElement = pathElements[i] ;

		if ( pathElement == path._Block || pathElement == path._BlockLimit )
			break ;

		if ( tagsRegex.test( pathElement.nodeName ) )
			sbEditorBreakParent( startNode, pathElement, range ) ;
	}

	path = new sbEditorElementPath( endNode ) ;
	pathElements = path._Elements ;

	for ( var i = 1 ; i < pathElements.length ; i++ )
	{
		pathElement = pathElements[i] ;

		if ( pathElement == path._Block || pathElement == path._BlockLimit )
			break ;

		elementName = pathElement.nodeName.toLowerCase() ;

		if ( tagsRegex.test( pathElement.nodeName ) )
			sbEditorBreakParent( endNode, pathElement, range ) ;
	}

	var currentNode = sbEditorGetNextSourceNode( startNode, true, 1 ) ;

	while ( currentNode )
	{
		if ( currentNode == endNode )
			break ;

		var nextNode = sbEditorGetNextSourceNode( currentNode, false, 1 ) ;

		if ( !currentNode.getAttribute('_sbfakelement') )
		{
			if ( tagsRegex.test( currentNode.nodeName ) )
				sbEditorRemoveNode( currentNode, true ) ;
			else
				sbEditorRemoveAttributes( currentNode, sbEditorRemoveAttributesArray );
		}
		
		currentNode = nextNode ;
	}

	range._SelectBookmark( bookmark ) ;

	sbEditorEvents._FireEvent( 'OnSelectionChange' ) ;
}

sbEditorStyles._GetStyle = function( styleName )
{
	return this._GetStyles()[ styleName ] ;
}

sbEditorStyles._GetStyles = function()
{
	var styles = this._GetStylesHelper ;
	if ( !styles )
	{
		styles = this._GetStylesHelper = sbEditorMerge(
			this._LoadStylesCore(),
			this._LoadStylesXml() ) ;
	}
	return styles ;
}

sbEditorStyles._HasObjectStyle = function( elementName )
{
	return !!this._ObjectStyles[ elementName ] ;
}

sbEditorStyles._LoadStylesCore = function()
{
	var styles = {};
	var styleDefs = sbEditorCoreStyles ;

	for ( var styleName in styleDefs )
	{
		var style = styles[ '_sb_' + styleName ] = new sbEditorStyle( styleDefs[ styleName ] ) ;
		style._IsCore = true ;
	}
	return styles ;
}

sbEditorStyles._LoadStylesXml = function()
{
	var styles = {};

	if ( !sbEditorStylesXmlPath || sbEditorStylesXmlPath.length == 0 )
		return styles ;

	var xml = new sbXMLLoader(null, null, false) ;
	xml.loadXML( sbEditorStylesXmlPath ) ;

	var stylesXmlObj = xml.transformToObject( xml.selectSingleNode( 'Styles' ) ) ;
	var styleNodes = stylesXmlObj.$Style ;

	if ( !styleNodes )
		return styles ;

	for ( var i = 0 ; i < styleNodes.length ; i++ )
	{
		var styleNode = styleNodes[i] ;

		var element = ( styleNode.element || '' ).toLowerCase() ;

		if ( element.length == 0 )
			throw( 'Требуется название элемента. Ошибка при загрузке "' + sbEditorStylesXmlPath + '"' ) ;

		var styleDef = {
			Element : element,
			Attributes : {},
			Styles : {},
			Overrides : []
		} ;

		var attNodes = styleNode.$Attribute || [] ;
		for ( var j = 0 ; j < attNodes.length ; j++ )
		{
			styleDef.Attributes[ attNodes[j].name ] = attNodes[j].value ;
		}

		var cssStyleNodes = styleNode.$Style || [] ;
		for ( j = 0 ; j < cssStyleNodes.length ; j++ )
		{
			styleDef.Styles[ cssStyleNodes[j].name ] = cssStyleNodes[j].value ;
		}

		var cssStyleOverrideNodes = styleNode.$Override ;
		if ( cssStyleOverrideNodes )
		{
			for ( j = 0 ; j < cssStyleOverrideNodes.length ; j++ )
			{
				var overrideNode = cssStyleOverrideNodes[j] ;
				var overrideDef =
				{
					Element : overrideNode.element
				} ;

				var overrideAttNode = overrideNode.$Attribute ;
				if ( overrideAttNode )
				{
					overrideDef.Attributes = {} ;
					for ( var k = 0 ; k < overrideAttNode.length ; k++ )
					{
						var overrideAttValue = overrideAttNode[k].value || null ;
						if ( overrideAttValue )
						{
							var regexMatch = overrideAttValue && sbEditorRegexLib.RegExp.exec( overrideAttValue ) ;
							if ( regexMatch )
								overrideAttValue = new RegExp( regexMatch[1], regexMatch[2] || '' ) ;
						}
						overrideDef.Attributes[ overrideAttNode[k].name ] = overrideAttValue ;
					}
				}

				styleDef.Overrides.push( overrideDef ) ;
			}
		}

		var style = new sbEditorStyle( styleDef ) ;
		style._Name = styleNode.name || element ;

		if ( style._GetType() == SB_EDITOR_STYLE_OBJECT )
			this._ObjectStyles[ element ] = true ;

		styles[ style._Name ] = style ;
	}

	return styles ;
}

<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>