<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>
var sbEditorUndo = new Object() ;

sbEditorUndo._SavedData = new Array() ;
sbEditorUndo._CurrentIndex = -1 ;
sbEditorUndo._TypesCount = 0 ;
sbEditorUndo._Changed = false ;
sbEditorUndo._MaxTypes = 25 ;
sbEditorUndo._Typing = false ;
sbEditorUndo._SaveLocked = false ;

sbEditorUndo._GetBookmark = function()
{
	sbEditorSelection._Restore() ;

	var range = new sbEditorDomRange( sbEditorAreaWnd ) ;
	try
	{
		range._MoveToSelection() ;
	}
	catch ( e )
	{
		return null ;
	}
	if ( _isIE )
	{
		var bookmark = range._CreateBookmark() ;
		var dirtyHtml = sbEditorArea.innerHTML ;
		range._MoveToBookmark( bookmark ) ;
		return [ bookmark, dirtyHtml ] ;
	}
	
	return range._CreateBookmark2() ;
}

sbEditorUndo._SelectBookmark = function( bookmark )
{
	if ( ! bookmark )
		return ;

	var range = new sbEditorDomRange( sbEditorAreaWnd ) ;
	if ( bookmark instanceof Object )
	{
		if ( _isIE )
		{
			range._MoveToBookmark( bookmark[0] ) ;
		}
		else
			range._MoveToBookmark2( bookmark ) ;
	
		try
		{
			range._Select() ;
		}
		catch ( e )
		{
			range._MoveToPosition( sbEditorArea, 4 ) ;
			range._Select() ;
		}
	}
}

sbEditorUndo._CompareCursors = function( cursor1, cursor2 )
{
	for ( var i = 0 ; i < Math.min( cursor1.length, cursor2.length ) ; i++ )
	{
		if ( cursor1[i] < cursor2[i] )
			return -1;
		else if (cursor1[i] > cursor2[i] )
			return 1;
	}
	if ( cursor1.length < cursor2.length )
		return -1;
	else if (cursor1.length > cursor2.length )
		return 1;
	return 0;
}

sbEditorUndo._IsBookmarksEqual = function( bookmark1, bookmark2 )
{
	if ( ! ( bookmark1 && bookmark2 ) )
		return false ;
	if ( _isIE )
	{
		var startOffset1 = bookmark1[1].search( bookmark1[0]._StartId ) ;
		var startOffset2 = bookmark2[1].search( bookmark2[0]._StartId ) ;
		var endOffset1 = bookmark1[1].search( bookmark1[0]._EndId ) ;
		var endOffset2 = bookmark2[1].search( bookmark2[0]._EndId ) ;
		return startOffset1 == startOffset2 && endOffset1 == endOffset2 ;
	}
	else
	{
		return this._CompareCursors( bookmark1._Start, bookmark2._Start ) == 0
			&& this._CompareCursors( bookmark1._End, bookmark2._End ) == 0 ;
	}
}

sbEditorUndo._SaveUndoStep = function()
{with(this){
	if ( _SaveLocked )
		return ;

	_Changed = true ;

	var sHtml = sbEditorArea.innerHTML ;
	var bookmark = _GetBookmark() ;

	_SavedData = _SavedData.slice( 0, _CurrentIndex + 1 ) ;

	if ( _CurrentIndex > 0 && sHtml == _SavedData[ _CurrentIndex ][0] && _IsBookmarksEqual( bookmark, _SavedData[ _CurrentIndex ][1] ) )
	{
		return ;
	}
	else if ( _CurrentIndex == 0 && _SavedData.length && sHtml == _SavedData[0][0] )
	{
		_SavedData[0][1] = bookmark ;
		return ;
	}

	if ( _CurrentIndex + 1 >= 100 )
		_SavedData.shift() ;
	else
		_CurrentIndex++ ;

	_SavedData[ _CurrentIndex ] = [ sHtml, bookmark ] ;
}}

sbEditorUndo._CheckUndoState = function(obj)
{
	obj = obj || this;
	with(obj)
	{
		return ( _Changed || _CurrentIndex > 0 ? SB_EDITOR_STATE_OFF : SB_EDITOR_STATE_DISABLED ) ;
	}
}

sbEditorUndo._CheckRedoState = function(obj)
{
	obj = obj || this;
	with(obj)
	{
		return ( _CurrentIndex < ( _SavedData.length - 1 ) ? SB_EDITOR_STATE_OFF : SB_EDITOR_STATE_DISABLED ) ;
	}
}

sbEditorUndo._Undo = function()
{with(this){
	if ( _CheckUndoState() == SB_EDITOR_STATE_OFF )
	{
		if ( _CurrentIndex == 0 )
			_SaveUndoStep() ;

		_ApplyUndoLevel( --_CurrentIndex ) ;

		sbEditorEvents._FireEvent( "OnSelectionChange" ) ;
	}
}}

sbEditorUndo._Redo = function()
{with(this){
	if ( _CheckRedoState() == SB_EDITOR_STATE_OFF)
	{
		_ApplyUndoLevel( ++_CurrentIndex ) ;

		sbEditorEvents._FireEvent( "OnSelectionChange" ) ;
	}
}}

sbEditorUndo._ApplyUndoLevel = function( level )
{with(this){
	var oData = _SavedData[ level ] ;

	if ( !oData )
		return ;

	if ( _isIE )
	{
		if ( oData[1] && oData[1][1] )
			sbEditorSetInnerHtml( oData[1][1] ) ;
		else
			sbEditorSetInnerHtml( oData[0] ) ;
	}
	else
		sbEditorArea.innerHTML = oData[0] ;

	_SelectBookmark( oData[1] ) ;

	_TypesCount = 0 ;
	_Changed = false ;
	_Typing = false ;
}}
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>