<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>
var sbEditorXHtmlEntities = new Object() ;

sbEditorXHtmlEntities._Initialize = function()
{
	if ( sbEditorXHtmlEntities._Entities )
		return ;

	var sChars = '' ;

	sbEditorXHtmlEntities._Entities = {
		// Latin-1 Entities
		' ':'nbsp',
		'¡':'iexcl',
		'¢':'cent',
		'£':'pound',
		'¤':'curren',
		'¥':'yen',
		'¦':'brvbar',
		'§':'sect',
		'¨':'uml',
		'©':'copy',
		'ª':'ordf',
		'«':'laquo',
		'¬':'not',
		'­':'shy',
		'®':'reg',
		'¯':'macr',
		'°':'deg',
		'±':'plusmn',
		'²':'sup2',
		'³':'sup3',
		'´':'acute',
		'µ':'micro',
		'¶':'para',
		'·':'middot',
		'¸':'cedil',
		'¹':'sup1',
		'º':'ordm',
		'»':'raquo',
		'¼':'frac14',
		'½':'frac12',
		'¾':'frac34',
		'¿':'iquest',
		'×':'times',
		'÷':'divide',

		// Symbols
		'ƒ':'fnof',
		'•':'bull',
		'…':'hellip',
		'′':'prime',
		'″':'Prime',
		'‾':'oline',
		'⁄':'frasl',
		'℘':'weierp',
		'ℑ':'image',
		'ℜ':'real',
		'™':'trade',
		'ℵ':'alefsym',
		'←':'larr',
		'↑':'uarr',
		'→':'rarr',
		'↓':'darr',
		'↔':'harr',
		'↵':'crarr',
		'⇐':'lArr',
		'⇑':'uArr',
		'⇒':'rArr',
		'⇓':'dArr',
		'⇔':'hArr',
		'∀':'forall',
		'∂':'part',
		'∃':'exist',
		'∅':'empty',
		'∇':'nabla',
		'∈':'isin',
		'∉':'notin',
		'∋':'ni',
		'∏':'prod',
		'∑':'sum',
		'−':'minus',
		'∗':'lowast',
		'√':'radic',
		'∝':'prop',
		'∞':'infin',
		'∠':'ang',
		'∧':'and',
		'∨':'or',
		'∩':'cap',
		'∪':'cup',
		'∫':'int',
		'∴':'there4',
		'∼':'sim',
		'≅':'cong',
		'≈':'asymp',
		'≠':'ne',
		'≡':'equiv',
		'≤':'le',
		'≥':'ge',
		'⊂':'sub',
		'⊃':'sup',
		'⊄':'nsub',
		'⊆':'sube',
		'⊇':'supe',
		'⊕':'oplus',
		'⊗':'otimes',
		'⊥':'perp',
		'⋅':'sdot',
		'\u2308':'lceil',
		'\u2309':'rceil',
		'\u230a':'lfloor',
		'\u230b':'rfloor',
		'\u2329':'lang',
		'\u232a':'rang',
		'◊':'loz',
		'♠':'spades',
		'♣':'clubs',
		'♥':'hearts',
		'♦':'diams',

		// Other Special Characters
		'"':'quot',
		'ˆ':'circ',
		'˜':'tilde',
		' ':'ensp',
		' ':'emsp',
		' ':'thinsp',
		'‌':'zwnj',
		'‍':'zwj',
		'‎':'lrm',
		'‏':'rlm',
		'–':'ndash',
		'—':'mdash',
		'‘':'lsquo',
		'’':'rsquo',
		'‚':'sbquo',
		'“':'ldquo',
		'”':'rdquo',
		'„':'bdquo',
		'†':'dagger',
		'‡':'Dagger',
		'‰':'permil',
		'‹':'lsaquo',
		'›':'rsaquo',
		'€':'euro',
		
		'À':'Agrave',
		'Á':'Aacute',
		'Â':'Acirc',
		'Ã':'Atilde',
		'Ä':'Auml',
		'Å':'Aring',
		'Æ':'AElig',
		'Ç':'Ccedil',
		'È':'Egrave',
		'É':'Eacute',
		'Ê':'Ecirc',
		'Ë':'Euml',
		'Ì':'Igrave',
		'Í':'Iacute',
		'Î':'Icirc',
		'Ï':'Iuml',
		'Ð':'ETH',
		'Ñ':'Ntilde',
		'Ò':'Ograve',
		'Ó':'Oacute',
		'Ô':'Ocirc',
		'Õ':'Otilde',
		'Ö':'Ouml',
		'Ø':'Oslash',
		'Ù':'Ugrave',
		'Ú':'Uacute',
		'Û':'Ucirc',
		'Ü':'Uuml',
		'Ý':'Yacute',
		'Þ':'THORN',
		'ß':'szlig',
		'à':'agrave',
		'á':'aacute',
		'â':'acirc',
		'ã':'atilde',
		'ä':'auml',
		'å':'aring',
		'æ':'aelig',
		'ç':'ccedil',
		'è':'egrave',
		'é':'eacute',
		'ê':'ecirc',
		'ë':'euml',
		'ì':'igrave',
		'í':'iacute',
		'î':'icirc',
		'ï':'iuml',
		'ð':'eth',
		'ñ':'ntilde',
		'ò':'ograve',
		'ó':'oacute',
		'ô':'ocirc',
		'õ':'otilde',
		'ö':'ouml',
		'ø':'oslash',
		'ù':'ugrave',
		'ú':'uacute',
		'û':'ucirc',
		'ü':'uuml',
		'ý':'yacute',
		'þ':'thorn',
		'ÿ':'yuml',
		'Œ':'OElig',
		'œ':'oelig',
		'Š':'Scaron',
		'š':'scaron',
		'Ÿ':'Yuml',
		
		'Α':'Alpha',
		'Β':'Beta',
		'Γ':'Gamma',
		'Δ':'Delta',
		'Ε':'Epsilon',
		'Ζ':'Zeta',
		'Η':'Eta',
		'Θ':'Theta',
		'Ι':'Iota',
		'Κ':'Kappa',
		'Λ':'Lambda',
		'Μ':'Mu',
		'Ν':'Nu',
		'Ξ':'Xi',
		'Ο':'Omicron',
		'Π':'Pi',
		'Ρ':'Rho',
		'Σ':'Sigma',
		'Τ':'Tau',
		'Υ':'Upsilon',
		'Φ':'Phi',
		'Χ':'Chi',
		'Ψ':'Psi',
		'Ω':'Omega',
		'α':'alpha',
		'β':'beta',
		'γ':'gamma',
		'δ':'delta',
		'ε':'epsilon',
		'ζ':'zeta',
		'η':'eta',
		'θ':'theta',
		'ι':'iota',
		'κ':'kappa',
		'λ':'lambda',
		'μ':'mu',
		'ν':'nu',
		'ξ':'xi',
		'ο':'omicron',
		'π':'pi',
		'ρ':'rho',
		'ς':'sigmaf',
		'σ':'sigma',
		'τ':'tau',
		'υ':'upsilon',
		'φ':'phi',
		'χ':'chi',
		'ψ':'psi',
		'ω':'omega',
		'\u03d1':'thetasym',
		'\u03d2':'upsih',
		'\u03d6':'piv'
	} ;

	for (var e in sbEditorXHtmlEntities._Entities )
		sChars += e ;

	var sRegexPattern = '[' + sChars + ']' ;

	sbEditorXHtmlEntities._EntitiesRegex = new RegExp( sRegexPattern, 'g' ) ;
}

////////////////////////////////////////////////////////////////////////////

var sbEditorCodeFormatter = new Object() ;

sbEditorCodeFormatter._Init = function()
{
	var oRegex = this._Regex = new Object() ;

	oRegex.BlocksOpener = /\<(P|DIV|H1|H2|H3|H4|H5|H6|ADDRESS|PRE|OL|UL|LI|TITLE|META|LINK|BASE|SCRIPT|LINK|TD|TH|AREA|OPTION)[^\>]*\>/gi ;
	oRegex.BlocksCloser = /\<\/(P|DIV|H1|H2|H3|H4|H5|H6|ADDRESS|PRE|OL|UL|LI|TITLE|META|LINK|BASE|SCRIPT|LINK|TD|TH|AREA|OPTION)[^\>]*\>/gi ;
	oRegex.NewLineTags	= /\<(BR|HR)[^\>]*\>/gi ;
	oRegex.MainTags = /\<\/?(HTML|HEAD|BODY|FORM|TABLE|TBODY|THEAD|TR)[^\>]*\>/gi ;
	oRegex.LineSplitter = /\s*\n+\s*/g ;
	oRegex.IncreaseIndent = /^\<(HTML|HEAD|BODY|FORM|TABLE|TBODY|THEAD|TR|UL|OL)[ \/\>]/i ;
	oRegex.DecreaseIndent = /^\<\/(HTML|HEAD|BODY|FORM|TABLE|TBODY|THEAD|TR|UL|OL)[ \>]/i ;
	oRegex.FormatIndentatorRemove = new RegExp( '^    ' ) ;
	oRegex.ProtectedTags = /(<PRE[^>]*>)([\s\S]*?)(<\/PRE>)/gi ;
}

sbEditorCodeFormatter._ProtectData = function( outer, opener, data, closer )
{
	return opener + '___sbpd___' + sbEditorCodeFormatter._ProtectedData.AddItem( data ) + closer ;
}

sbEditorCodeFormatter._Format = function( html )
{
	if ( !this._Regex )
		this._Init() ;

	sbEditorCodeFormatter._ProtectedData = new Array() ;

	var sFormatted = html.replace( this._Regex.ProtectedTags, sbEditorCodeFormatter._ProtectData ) ;

	sFormatted = sFormatted.replace( this._Regex.BlocksOpener, '\n$&' ) ;
	sFormatted = sFormatted.replace( this._Regex.BlocksCloser, '$&\n' ) ;
	sFormatted = sFormatted.replace( this._Regex.NewLineTags, '$&\n' ) ;
	sFormatted = sFormatted.replace( this._Regex.MainTags, '\n$&\n' ) ;

	var sIndentation = '' ;
	var asLines = sFormatted.split( this._Regex.LineSplitter ) ;
	sFormatted = '' ;

	for ( var i = 0 ; i < asLines.length ; i++ )
	{
		var sLine = asLines[i] ;

		if ( sLine.length == 0 )
			continue ;

		if ( this._Regex.DecreaseIndent.test( sLine ) )
			sIndentation = sIndentation.replace( this._Regex.FormatIndentatorRemove, '' ) ;

		sFormatted += sIndentation + sLine + '\n' ;

		if ( this._Regex.IncreaseIndent.test( sLine ) )
			sIndentation += '    ' ;
	}

	for ( var j = 0 ; j < sbEditorCodeFormatter._ProtectedData.length ; j++ )
	{
		var oRegex = new RegExp( '___sbpd___' + j ) ;
		sFormatted = sFormatted.replace( oRegex, sbEditorCodeFormatter._ProtectedData[j].replace( /\$/g, '$$$$' ) ) ;
	}

	return sFormatted.Trim() ;
}

////////////////////////////////////////////////////////////////////////////

var sbEditorXHtml = new Object() ;

sbEditorXHtml._CurrentJobNum = 0 ;

sbEditorXHtml._GetXHTML = function( node, includeNode )
{
	sbEditorCheckAndRemovePaddingNode( sbGetElementDocument( node ), SB_EDITOR_ENTER_MODE ) ;
	sbEditorXHtmlEntities._Initialize() ;

	this._NbspEntity = 'nbsp' ;
	this._SpecialBlocks = new Array() ;

	if (_isIE)
	{
		try 
		{
			this._XML = new ActiveXObject('MSXML2.DOMDocument');
		}
		catch(e)
		{
			this._XML = new ActiveXObject('Microsoft.XmlDom');
		}
	}
	else
	{
		this._XML = ( new DOMParser() ).parseFromString( '<tmp></tmp>', 'text/xml' ) ;
		sbEditorRemoveNode( this._XML.firstChild ) ;
	}
	
	this._MainNode = this._XML.appendChild( this._XML.createElement( 'xhtml' ) ) ;

	sbEditorXHtml._CurrentJobNum++ ;

	if ( includeNode )
		this._AppendNode( this._MainNode, node ) ;
	else
		this._AppendChildNodes( this._MainNode, node, false ) ;

	var sXHTML = this._GetMainXmlString() ;

	this._XML = null ;

	if ( _isSafari )
		sXHTML = sXHTML.replace( /^<xhtml.*?>/, '<xhtml>' ) ;

	sXHTML = sXHTML.substr( 7, sXHTML.length - 15 ).Trim() ;

	if (sbEditorDocType.length > 0 && sbEditorRegexLib.HtmlDocType.test( sbEditorDocType ) )
		sXHTML = sXHTML.replace( sbEditorRegexLib.SpaceNoClose, '>');
	else
		sXHTML = sXHTML.replace( sbEditorRegexLib.SpaceNoClose, ' />');

	sXHTML = sbEditorCodeFormatter._Format( sXHTML ) ;

	for ( var i = 0 ; i < sbEditorXHtml._SpecialBlocks.length ; i++ )
	{
		var oRegex = new RegExp( '___sbsi___' + i ) ;
		sXHTML = sXHTML.replace( oRegex, sbEditorXHtml._SpecialBlocks[i] ) ;
	}

	sXHTML = sXHTML.replace( sbEditorRegexLib.GeckoEntitiesMarker, '&' ) ;
	sbEditorEnforcePaddingNode( sbGetElementDocument( node ), SB_EDITOR_ENTER_MODE ) ;
	
	return sXHTML ;
}

sbEditorXHtml._AppendAttribute = function( xmlNode, aName, aValue )
{
	function GetEntity( chr )
	{
		var sEntity = sbEditorXHtmlEntities._Entities[ chr ] || ( '#' + chr.charCodeAt(0) ) ;
		return '#?-:' + sEntity + ';' ;
	}

	try
	{
		if ( aValue == undefined || aValue == null )
			aValue = '' ;
		else if ( aValue.replace )
		{
			aValue = aValue.replace( sbEditorXHtmlEntities._EntitiesRegex, GetEntity ) ;
		}

		var oXmlAtt = this._XML.createAttribute( aName ) ;
		oXmlAtt.value = aValue ;

		xmlNode.attributes.setNamedItem( oXmlAtt ) ;
	}
	catch (e)
	{}
}

sbEditorXHtml._AppendChildNodes = function( xmlNode, htmlNode, isBlockElement )
{
	var oNode = htmlNode.firstChild ;

	while ( oNode )
	{
		this._AppendNode( xmlNode, oNode ) ;
		oNode = oNode.nextSibling ;
	}

	if ( isBlockElement && htmlNode.tagName && htmlNode.tagName.toLowerCase() != 'pre' )
	{
		sbEditorTrimNode( xmlNode ) ;

		var lastChild = xmlNode.lastChild ;
		if ( lastChild && lastChild.nodeType == 1 && lastChild.nodeName == 'br' )
			this._AppendEntity( xmlNode, this._NbspEntity ) ;
	}

	if ( xmlNode.childNodes.length == 0 )
	{
		if ( isBlockElement )
		{
			this._AppendEntity( xmlNode, this._NbspEntity ) ;
			return xmlNode ;
		}
		
		var sNodeName = xmlNode.nodeName ;

		if ( sbEditorListsLib.InlineChildReqElements[ sNodeName ] )
			return null ;

		if ( !sbEditorListsLib.EmptyElements[ sNodeName ] )
			xmlNode.appendChild( this._XML.createTextNode('') ) ;
	}
	
	return xmlNode ;
}

sbEditorXHtml._AppendNode = function( xmlNode, htmlNode )
{
	if ( !htmlNode )
		return false ;

	switch ( htmlNode.nodeType )
	{
		// Element Node.
		case 1 :
			if ( _isFF && htmlNode.tagName.toLowerCase() == 'br' && htmlNode.parentNode.tagName.toLowerCase() == 'pre' )
			{
				var val = '\r' ;
				if ( htmlNode == htmlNode.parentNode.firstChild )
					val += '\r' ;
				return sbEditorXHtml._AppendNode( xmlNode, this.XML.createTextNode( val ) ) ;
			}

			if ( htmlNode.getAttribute('_sbfakelement') )
				return this._AppendNode( xmlNode, sbEditorGetRealElement( htmlNode ) ) ;
				
			if ( _isFF && ( htmlNode.hasAttribute('_moz_editor_bogus_node') || htmlNode.getAttribute( 'type' ) == '_moz' ) )
			{
				if ( htmlNode.nextSibling )
					return false ;
				else
				{
					htmlNode.removeAttribute( '_moz_editor_bogus_node' ) ;
					htmlNode.removeAttribute( 'type' ) ;
				}
			}

			if ( htmlNode.getAttribute('_sbtemp') )
				return false ;

			var sNodeName = htmlNode.tagName.toLowerCase()  ;

			if ( _isIE )
			{
				if ( htmlNode.scopeName && htmlNode.scopeName != 'HTML' && htmlNode.scopeName != 'SB' )
					sNodeName = htmlNode.scopeName.toLowerCase() + ':' + sNodeName ;
			}
			else
			{
				if ( sNodeName.StartsWith( 'sb:' ) )
					sNodeName = sNodeName.Remove( 0,4 ) ;
			}

			if ( !sbEditorRegexLib.ElementName.test( sNodeName ) )
				return false ;

			if ( htmlNode._sbxhtmljob && htmlNode._sbxhtmljob == sbEditorXHtml._CurrentJobNum )
				return false ;

			var oNode = this._XML.createElement( sNodeName ) ;

			sbEditorXHtml._AppendAttributes( xmlNode, htmlNode, oNode, sNodeName ) ;

			htmlNode._sbxhtmljob = sbEditorXHtml._CurrentJobNum ;

			var oTagProcessor = sbEditorXHtml._TagProcessors[ sNodeName ] ;

			if ( oTagProcessor )
				oNode = oTagProcessor( oNode, htmlNode, xmlNode ) ;
			else
				oNode = this._AppendChildNodes( oNode, htmlNode, Boolean( sbEditorListsLib.NonEmptyBlockElements[ sNodeName ] ) ) ;

			if ( !oNode )
				return false ;

			xmlNode.appendChild( oNode ) ;

			break ;

		case 3 :
			if ( htmlNode.parentNode && htmlNode.parentNode.nodeName.IEquals( 'pre' ) )
				return this._AppendTextNode( xmlNode, htmlNode.nodeValue ) ;
			return this._AppendTextNode( xmlNode, htmlNode.nodeValue.ReplaceNewLineChars(' ') ) ;

		case 8 :
			if ( _isIE && !htmlNode.innerHTML )
				break ;

			try { xmlNode.appendChild( this._XML.createComment( htmlNode.nodeValue ) ) ; }
			catch (e) { }
			break ;

		default :
			xmlNode.appendChild( this._XML.createComment( "Element not supported - Type: " + htmlNode.nodeType + " Name: " + htmlNode.nodeName ) ) ;
			break ;
	}
	return true ;
}

sbEditorXHtml._AppendSpecialItem = function( item )
{
	return '___sbsi___' + sbEditorXHtml._SpecialBlocks.AddItem( item ) ;
}

sbEditorXHtml._AppendEntity = function( xmlNode, entity )
{
	xmlNode.appendChild( this._XML.createTextNode( '#?-:' + entity + ';' ) ) ;
}

sbEditorXHtml._AppendTextNode = function( targetNode, textValue )
{
	function GetEntity( chr )
	{
		var sEntity = sbEditorXHtmlEntities._Entities[ chr ] || ( '#' + chr.charCodeAt(0) ) ;
		return '#?-:' + sEntity + ';' ;
	}
	
	var bHadText = textValue.length > 0 ;
	if ( bHadText )
		targetNode.appendChild( this._XML.createTextNode( textValue.replace( sbEditorXHtmlEntities._EntitiesRegex, GetEntity ) ) ) ;
	return bHadText ;
}

////////////////////////////////////////////////////////////////////////////

sbEditorXHtml._TagProcessors =
{
	a : function( node, htmlNode )
	{
		if ( htmlNode.innerHTML.Trim().length == 0 && !htmlNode.name && !htmlNode.id )
			return false ;

		var sSavedUrl = htmlNode.getAttribute( '_sbsavedurl' ) ;
		if ( sSavedUrl != null )
			sbEditorXHtml._AppendAttribute( node, 'href', sSavedUrl ) ;

		if ( _isIE )
		{
			if ( htmlNode.name )
				sbEditorXHtml._AppendAttribute( node, 'name', htmlNode.name ) ;
		}

		node = sbEditorXHtml._AppendChildNodes( node, htmlNode, false ) ;

		return node ;
	},

	area : function( node, htmlNode )
	{
		var sSavedUrl = htmlNode.getAttribute( '_sbsavedurl' ) ;
		if ( sSavedUrl != null )
			sbEditorXHtml._AppendAttribute( node, 'href', sSavedUrl ) ;

		if ( _isIE )
		{
			if ( ! node.attributes.getNamedItem( 'coords' ) )
			{
				var sCoords = htmlNode.getAttribute( 'coords', 2 ) ;
				if ( sCoords && sCoords != '0,0,0' )
					sbEditorXHtml._AppendAttribute( node, 'coords', sCoords ) ;
			}

			if ( ! node.attributes.getNamedItem( 'shape' ) )
			{
				var sShape = htmlNode.getAttribute( 'shape', 2 ) ;
				if ( sShape && sShape.length > 0 )
					sbEditorXHtml._AppendAttribute( node, 'shape', sShape.toLowerCase() ) ;
			}
		}

		return node ;
	},

	body : function( node, htmlNode )
	{
		node = sbEditorXHtml._AppendChildNodes( node, htmlNode, false ) ;
		node.removeAttribute( 'spellcheck' ) ;
		return node ;
	},

	iframe : function( node, htmlNode )
	{
		var sHtml = htmlNode.innerHTML ;

		if ( _isFF )
			sHtml = sbEditorHTMLDecode( sHtml );

		sHtml = sHtml.replace( /\s_sbsavedurl="[^"]*"/g, '' ) ;

		node.appendChild( sbEditorXHtml._XML.createTextNode( sbEditorXHtml._AppendSpecialItem( sHtml ) ) ) ;

		return node ;
	},

	img : function( node, htmlNode )
	{
		if ( ! node.attributes.getNamedItem( 'alt' ) )
			sbEditorXHtml._AppendAttribute( node, 'alt', '' ) ;

		var sSavedUrl = htmlNode.getAttribute( '_sbsavedurl' ) ;
		if ( sSavedUrl != null )
			sbEditorXHtml._AppendAttribute( node, 'src', sSavedUrl ) ;

		if ( htmlNode.style.width )
			node.removeAttribute( 'width' ) ;
		if ( htmlNode.style.height )
			node.removeAttribute( 'height' ) ;

		return node ;
	},

	li : function( node, htmlNode, targetNode )
	{
		if ( targetNode.nodeName.IEquals( ['ul', 'ol'] ) )
			return sbEditorXHtml._AppendChildNodes( node, htmlNode, true ) ;

		var newTarget = sbEditorXHtml._XML.createElement( 'ul' ) ;

		htmlNode._sbxhtmljob = null ;

		do
		{
			sbEditorXHtml._AppendNode( newTarget, htmlNode ) ;

			do
			{
				htmlNode = sbEditorGetNextSibling( htmlNode ) ;

			} while ( htmlNode && htmlNode.nodeType == 3 && htmlNode.nodeValue.Trim().length == 0 )

		}	while ( htmlNode && htmlNode.nodeName.toLowerCase() == 'li' )

		return newTarget ;
	},

	ol : function( node, htmlNode, targetNode )
	{
		if ( htmlNode.innerHTML.Trim().length == 0 )
			return false ;

		var ePSibling = targetNode.lastChild ;

		if ( ePSibling && ePSibling.nodeType == 3 )
			ePSibling = ePSibling.previousSibling ;

		if ( ePSibling && ePSibling.nodeName.toUpperCase() == 'LI' )
		{
			htmlNode._sbxhtmljob = null ;
			sbEditorXHtml._AppendNode( ePSibling, htmlNode ) ;
			return false ;
		}

		node = sbEditorXHtml._AppendChildNodes( node, htmlNode ) ;

		return node ;
	},

	pre : function ( node, htmlNode )
	{
		var firstChild = htmlNode.firstChild ;

		if ( firstChild && firstChild.nodeType == 3 )
			node.appendChild( sbEditorXHtml._XML.createTextNode( sbEditorXHtml._AppendSpecialItem( '\r\n' ) ) ) ;

		sbEditorXHtml._AppendChildNodes( node, htmlNode, true ) ;

		return node ;
	},

	script : function( node, htmlNode )
	{
		if ( ! node.attributes.getNamedItem( 'type' ) )
			sbEditorXHtml._AppendAttribute( node, 'type', 'text/javascript' ) ;

		node.appendChild( sbEditorXHtml._XML.createTextNode( sbEditorXHtml._AppendSpecialItem( htmlNode.text ) ) ) ;

		return node ;
	},

	span : function( node, htmlNode )
	{
		if ( htmlNode.innerHTML.length == 0 )
			return false ;

		node = sbEditorXHtml._AppendChildNodes( node, htmlNode, false ) ;

		return node ;
	},

	style : function( node, htmlNode )
	{
		if ( ! node.attributes.getNamedItem( 'type' ) )
			sbEditorXHtml._AppendAttribute( node, 'type', 'text/css' ) ;

		var cssText = htmlNode.innerHTML ;
		if ( _isIE )
			cssText = cssText.replace( /^(\r\n|\n|\r)/, '' ) ;

		node.appendChild( sbEditorXHtml._XML.createTextNode( sbEditorXHtml._AppendSpecialItem( cssText ) ) ) ;

		return node ;
	},

	title : function( node, htmlNode )
	{
		node.appendChild( sbEditorXHtml._XML.createTextNode( sbEditorDocumentTitle ) ) ;

		return node ;
	}
} ;

sbEditorXHtml._TagProcessors.ul = sbEditorXHtml._TagProcessors.ol ;

if (_isIE)
{
	sbEditorXHtml._GetMainXmlString = function()
	{
		return this._MainNode.xml ;
	}
	
	sbEditorXHtml._AppendAttributes = function( xmlNode, htmlNode, node, nodeName )
	{
		var aAttributes = htmlNode.attributes,
			bHasStyle ;
	
		for ( var n = aAttributes.length - 1 ; n >= 0  ; n-- )
		{
			var oAttribute = aAttributes[n] ;
	
			if ( oAttribute.specified )
			{
				var sAttName = oAttribute.nodeName.toLowerCase() ;
				var sAttValue ;
	
				if ( sAttName.StartsWith( '_sb' ) )
					continue ;
				else if ( sAttName == 'style' )
				{
					bHasStyle = true ;
					continue ;
				}
				else if ( sAttName == 'class' )
				{
					sAttValue = oAttribute.nodeValue.replace( sbEditorRegexLib.SB_Class, '' ) ;
					if ( sAttValue.length == 0 )
						continue ;
				}
				else if ( sAttName.indexOf('on') == 0 )
					sAttValue = oAttribute.nodeValue ;
				else if ( (nodeName == 'body' || nodeName == 'div') && sAttName == 'contenteditable' )
					continue ;
				else if ( oAttribute.nodeValue === true )
					sAttValue = sAttName ;
				else
				{
					try
					{
						sAttValue = htmlNode.getAttribute( sAttName, 2 ) ;
					}
					catch (e) {}
				}
				this._AppendAttribute( node, sAttName, sAttValue || oAttribute.nodeValue ) ;
			}
		}
		
		function ToLowerCase ( strValue )
		{
			return strValue.toLowerCase() ;
		}
	
		if ( bHasStyle || htmlNode.style.cssText.length > 0 )
		{
			var sStyleValue = htmlNode.style.cssText.replace( sbEditorRegexLib.StyleProperties, ToLowerCase ) ;
			this._AppendAttribute( node, 'style', sStyleValue ) ;
		}
	}
	
	sbEditorXHtml._TagProcessors['div'] = function( node, htmlNode )
	{
		if ( htmlNode.align.length > 0 )
			sbEditorXHtml._AppendAttribute( node, 'align', htmlNode.align ) ;
	
		node = sbEditorXHtml._AppendChildNodes( node, htmlNode, true ) ;
	
		return node ;
	}
	
	sbEditorXHtml._TagProcessors['font'] = function( node, htmlNode )
	{
		if ( node.attributes.length == 0 )
			node = sbEditorXHtml._XML.createDocumentFragment() ;
	
		node = sbEditorXHtml._AppendChildNodes( node, htmlNode ) ;
	
		return node ;
	}
	
	sbEditorXHtml._TagProcessors['form'] = function( node, htmlNode )
	{
		if ( htmlNode.acceptCharset && htmlNode.acceptCharset.length > 0 && htmlNode.acceptCharset != 'UNKNOWN' )
			sbEditorXHtml._AppendAttribute( node, 'accept-charset', htmlNode.acceptCharset ) ;
	
		var nameAtt = htmlNode.attributes['name'] ;
	
		if ( nameAtt && nameAtt.value.length > 0 )
			sbEditorXHtml._AppendAttribute( node, 'name', nameAtt.value ) ;
	
		node = sbEditorXHtml._AppendChildNodes( node, htmlNode, true ) ;
	
		return node ;
	}
	
	sbEditorXHtml._TagProcessors['input'] = function( node, htmlNode )
	{
		if ( htmlNode.name )
			sbEditorXHtml._AppendAttribute( node, 'name', htmlNode.name ) ;
	
		if ( htmlNode.value && !node.attributes.getNamedItem( 'value' ) )
			sbEditorXHtml._AppendAttribute( node, 'value', htmlNode.value ) ;
	
		if ( !node.attributes.getNamedItem( 'type' ) )
			sbEditorXHtml._AppendAttribute( node, 'type', 'text' ) ;
	
		return node ;
	}
	
	sbEditorXHtml._TagProcessors['label'] = function( node, htmlNode )
	{
		if ( htmlNode.htmlFor.length > 0 )
			sbEditorXHtml._AppendAttribute( node, 'for', htmlNode.htmlFor ) ;
	
		node = sbEditorXHtml._AppendChildNodes( node, htmlNode ) ;
	
		return node ;
	}
	
	sbEditorXHtml._TagProcessors['map'] = function( node, htmlNode )
	{
		if ( ! node.attributes.getNamedItem( 'name' ) )
		{
			var name = htmlNode.name ;
			if ( name )
				sbEditorXHtml._AppendAttribute( node, 'name', name ) ;
		}
	
		node = sbEditorXHtml._AppendChildNodes( node, htmlNode, true ) ;
	
		return node ;
	}
	
	sbEditorXHtml._TagProcessors['meta'] = function( node, htmlNode )
	{
		var oHttpEquiv = node.attributes.getNamedItem( 'http-equiv' ) ;
	
		if ( oHttpEquiv == null || oHttpEquiv.value.length == 0 )
		{
			var sHttpEquiv = htmlNode.outerHTML.match( sbEditorRegexLib.MetaHttpEquiv ) ;
	
			if ( sHttpEquiv )
			{
				sHttpEquiv = sHttpEquiv[1] ;
				sbEditorXHtml._AppendAttribute( node, 'http-equiv', sHttpEquiv ) ;
			}
		}
	
		return node ;
	}
	
	sbEditorXHtml._TagProcessors['option'] = function( node, htmlNode )
	{
		if ( htmlNode.selected && !node.attributes.getNamedItem( 'selected' ) )
			sbEditorXHtml._AppendAttribute( node, 'selected', 'selected' ) ;
	
		node = sbEditorXHtml._AppendChildNodes( node, htmlNode ) ;
	
		return node ;
	}
	
	sbEditorXHtml._TagProcessors['textarea'] = sbEditorXHtml._TagProcessors['select'] = function( node, htmlNode )
	{
		if ( htmlNode.name )
			sbEditorXHtml._AppendAttribute( node, 'name', htmlNode.name ) ;
	
		node = sbEditorXHtml._AppendChildNodes( node, htmlNode ) ;
	
		return node ;
	}
}
else
{
	sbEditorXHtml._GetMainXmlString = function()
	{
		return ( new XMLSerializer() ).serializeToString( this._MainNode ) ;
	}
	
	sbEditorXHtml._AppendAttributes = function( xmlNode, htmlNode, node )
	{
		var aAttributes = htmlNode.attributes ;
	
		for ( var n = aAttributes.length - 1 ; n >= 0  ; n-- )
		{
			var oAttribute = aAttributes[n] ;
	
			if ( oAttribute.specified )
			{
				var sAttName = oAttribute.nodeName.toLowerCase() ;
				var sAttValue ;
	
				if ( sAttName.StartsWith( '_sb' ) )
					continue ;
				else if ( sAttName.indexOf( '_moz' ) == 0 )
					continue ;
				else if ( sAttName == 'class' )
				{
					sAttValue = oAttribute.nodeValue.replace( sbEditorRegexLib.SB_Class, '' ) ;
					if ( sAttValue.length == 0 )
						continue ;
				}
				else if ( oAttribute.nodeValue === true )
					sAttValue = sAttName ;
				else
					sAttValue = htmlNode.getAttribute( sAttName, 2 ) ;
	
				this._AppendAttribute( node, sAttName, sAttValue ) ;
			}
		}
	}
	
	if ( _isOpera )
	{
		sbEditorXHtml._TagProcessors['head'] = function( node, htmlNode )
		{
			this._XML._HeadElement = node ;
	
			node = sbEditorXHtml._AppendChildNodes( node, htmlNode, true ) ;
	
			return node ;
		}
	
		sbEditorXHtml._TagProcessors['meta'] = function( node, htmlNode, xmlNode )
		{
			if ( htmlNode.parentNode.nodeName.toLowerCase() != 'head' )
			{
				var headElement = sbEditorXHtml._XML._HeadElement ;
	
				if ( headElement && xmlNode != headElement )
				{
					delete htmlNode._sbxhtmljob ;
					sbEditorXHtml._AppendNode( headElement, htmlNode ) ;
					return null ;
				}
			}
	
			return node ;
		}
	}
	
	if ( _isFF )
	{
		sbEditorXHtml._TagProcessors['link'] = function( node, htmlNode )
		{
			if ( htmlNode.href.substr(0, 9).toLowerCase() == 'chrome://' )
				return false ;
	
			return node ;
		}
	}
}

////////////////////////////////////////////////////////////////////////////

var sbEditorDataProcessor = 
{
	_ConvertToHtml : function( data )
	{
		if ( sbEditorFullPage )
		{
			sbEditorDocTypeDeclaration = data.match( sbEditorRegexLib.DocTypeTag ) ;

			if ( !sbEditorRegexLib.HasBodyTag.test( data ) )
				data = '<body>' + data + '</body>' ;

			if ( !sbEditorRegexLib.HtmlOpener.test( data ) )
				data = '<html>' + data + '</html>' ;

			if ( !sbEditorRegexLib.HeadOpener.test( data ) )
				data = data.replace( sbEditorRegexLib.HtmlOpener, '$&<head><title></title></head>' ) ;

			return data ;
		}
		else
		{
			return data ;
		}
	},

	_ConvertToDataFormat : function( rootNode, excludeRoot )
	{
		var data = sbEditorXHtml._GetXHTML( rootNode, !excludeRoot ) ;

		if ( sbEditorRegexLib.EmptyOutParagraph.test( data ) )
			return '' ;

		return data ;
	}
};
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>