<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

var wnd = (_isIE ? dialogArguments : window.opener.sbModalDialog.args);
var oImage = wnd.sbEditorSelection._GetSelectedElement() ;
if ( !oImage || oImage.getAttribute('_sbfakelement') || oImage.nodeName.toLowerCase() != 'img')
{
	sbCloseDialog();
}		

var imgSrc = oImage.src;
var imgWidth = sbGetAttribute(oImage, "width");
var imgHeight =	sbGetAttribute(oImage, "height");
var imgTop = 0;
var imgLeft = 0;

var oldMapName = _isIE ? oImage.getAttribute("usemap") : sbGetAttribute(oImage, "usemap");
if (oldMapName)
	oldMapName = oldMapName.replace(/#/, "");

function setUrlChange()
{
	sbGetE("txtUrl").onchange = function()
	{
		updateArea();
		this.onchange = null;
	}
}

function setMapInfo()
{
	if (_isIE && sbGetE("event_content").style.visibility != "visible")
	{
		setTimeout(setMapInfo, 100);
		return;
	} 

    sbAddEvent(sbGetE("txtUrl_button"), "mousedown", setUrlChange);
	sbAddEvent(document, 'keydown', onKeyDown);
	sbAddEvent(document, 'mousemove', onMouseMove);
	sbAddEvent(document, 'mouseup', onMouseUp);
	sbAddEvent(window, 'resize', onResize);
	
    var par = sbGetE('editedImg');
    imgTop = sbGetAbsoluteTop(par) - 24;
    imgLeft = sbGetAbsoluteLeft(par);
    
    if (oldMapName.length > 0)
    {
    	var aMaps = wnd.sbEditorAreaDoc.body.getElementsByTagName("MAP");
    	
        for (var i = 0; i < aMaps.length; i++)
        {
            if (aMaps[i].getAttribute("name") == oldMapName)
            {
            	if (_isIE)
            		var aAreas = aMaps[i].areas;
            	else
            		var aAreas = aMaps[i].childNodes;
                for (var j = 0; j < aAreas.length; j++)
                {
                    var oArea = aAreas[j];
                    if (oArea.nodeType == 1 && oArea.nodeName.toLowerCase() == "area")
                    {
	                    var _target = _isIE ? oArea.getAttribute("target") : sbGetAttribute(oArea, "target");
	                    var _href = _isIE ? oArea.getAttribute("href") : sbGetAttribute(oArea, "href");
	                    var _alt = _isIE ? oArea.getAttribute("alt") : sbGetAttribute(oArea, "alt");
	                    if (_alt)
	                    	_alt = _alt.replace(/%22/g, '"');
	                    var _title = _isIE ? oArea.getAttribute("title") : sbGetAttribute(oArea, "title");
	                    if (_title)
	                    	_title = _title.replace(/%22/g, '"');
	                    var _coords = _isIE ? oArea.getAttribute("coords") : sbGetAttribute(oArea, "coords");
	                    if (_coords.length > 0)
	                    {
	                        var aCoords = _coords.split(',');
	                        if (aCoords.length == 4)
	                            createMap(null, true, _href, _alt, _title, _target, parseInt(aCoords[0]) + imgLeft, parseInt(aCoords[1]) + imgTop, parseInt(aCoords[2])-parseInt(aCoords[0]), parseInt(aCoords[3])-parseInt(aCoords[1]));
	                    }
	                }
                }
                break;
            }
        }
    }
    
    setFields();
}

var action = null;
var newDiv = false;
var activeElement = null;
var sX, sY;

function onMouseMove(e) 
{
    var nX = (_isIE ? e.x : e.pageX);
    var nY = (_isIE ? e.y : e.pageY) - 24;
    
    if (!action && !newDiv)
    {
        var overEl = sbEventTarget(e);
        var divEvt = sbGetE("event_content");
        if (overEl && overEl.getAttribute("_sbmapdiv"))
            setCursor(overEl, nX + divEvt.scrollLeft, nY + divEvt.scrollTop);
    }

	
    var dLeft = nX - sX;
    var dTop = nY - sY;
	sbGetE("areaX").innerHTML = nX - imgLeft;
    sbGetE("areaY").innerHTML = nY - imgTop;
    
    if (!activeElement)
        return;
        
    if (!action && newDiv)
    {
        if (Math.abs(dLeft) < 2 || Math.abs(dTop) < 2)
            return;
        if (dLeft < 0 && dTop < 0)
            action = 'nw';
        else if (dLeft > 0 && dTop < 0)
            action = 'ne';
        else if (dLeft < 0 && dTop > 0)
            action = 'sw';
        else
            action = 'se';
    }
    
    if (action == 'move')
    {
        moveElement(nX, nY, dLeft, dTop);
    }
    else
    {
        resizeElement(nX, nY, dLeft, dTop);
        sbGetE("areaWidth").innerHTML = activeElement.offsetWidth;
        sbGetE("areaHeight").innerHTML = activeElement.offsetHeight;
    }
}

function setCursor(overEl, nX, nY)
{
	var h = parseInt(overEl.style.height);
	var w = parseInt(overEl.style.width);
	var l = parseInt(overEl.style.left);
	var t = parseInt(overEl.style.top);
	
    if(nX >= (l+w-3) && 
       nY >= (t+h-3))
    {
        overEl.style.cursor='se-resize';
    }
    else if (nX <= (l+3) &&
             nY <= (t+3))
    {
        overEl.style.cursor='nw-resize';
    }
    else if (nX >= (l+w-3) && 
             nY <= (t+3))
    {
        overEl.style.cursor='ne-resize';
    }
    else if (nX <= (l+6) && 
             nY >= (t+h-3))
    {
        overEl.style.cursor='sw-resize';
    }
    else if (nX >= (l+w-3))
    {
        overEl.style.cursor='e-resize';
    }
    else if (nX <= (l+6))
    {
        overEl.style.cursor='w-resize';
    }
    else if (nY >= (t+h-3))
    {
        overEl.style.cursor='s-resize';
    }
    else if (nY <= (t+3))
    {
        overEl.style.cursor='n-resize';
    }
    else
    {
        overEl.style.cursor='move';
    }
}

function onMouseDown(e) 
{
    var mp = sbEventTarget(e);
    if (mp && mp.getAttribute("_sbmapdiv"))
    {
    	setActive(mp);
    }
    
    sX = (_isIE ? e.x : e.pageX);
    sY = (_isIE ? e.y : e.pageY) - 24;
    
    sbCancelEvent(e);
    
    if (!action)
        setAction();
}

function setAction()
{
    if (!activeElement) 
        return;
        
    switch (activeElement.style.cursor)
    {
        case 'move':
            action = 'move';
            break;
        case 'n-resize':
            action = 'n';
            break;
        case 'ne-resize':
            action = 'ne';
            break;
        case 'e-resize':
            action = 'e';
            break;
        case 'se-resize':
            action = 'se';
            break;
        case 's-resize':
            action = 's';
            break;
        case 'sw-resize':
            action = 'sw';
            break;
        case 'w-resize':
            action = 'w';
            break;
        case 'nw-resize':
            action = 'nw';
            break;
        default: 
            action = null;
    }
}

function onMouseUp()
{
	action = null;
    newDiv = false;
}

function moveElement(nX, nY, dLeft, dTop) 
{
	if (!activeElement)
		return;
	
	var h = parseInt(activeElement.style.height);
	var w = parseInt(activeElement.style.width);
	var l = parseInt(activeElement.style.left);
	var t = parseInt(activeElement.style.top);
		
    if (l + dLeft <= imgLeft)
    {
        l = imgLeft;
    }
    else if (l + w + dLeft >= imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0))
    {
        l = imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0) - w;
    }
    else
    {
        sX = nX;
        l += dLeft;
    }
    
    if (t + dTop <= imgTop)
    {
        t = imgTop;
    }
    else if (t + h + dTop >= imgTop + oImage.offsetHeight + (_isIE ? 2 : 0))
    {
        t = imgTop + oImage.offsetHeight + (_isIE ? 2 : 0) - h;
    }
    else
    {
        sY = nY;
        t += dTop;
    }
    
    activeElement.style.height = h;
	activeElement.style.width = w;
	activeElement.style.left = l;
	activeElement.style.top = t;
}

function resizeElement(nX, nY, dLeft, dTop) 
{
	if (!activeElement)
		return;
	
	var h = parseInt(activeElement.style.height);
	var w = parseInt(activeElement.style.width);
	var l = parseInt(activeElement.style.left);
	var t = parseInt(activeElement.style.top);
	
    switch (action)
    {
        case 'n':
            if (h - dTop - 5 > 0 && t + dTop > imgTop)
            {
                sY = nY;
                t += dTop;
                h -= dTop;
            }
            break;
        case 'e':
            if (w + dLeft - 5 > 0 && l + w + dLeft <= imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0))
            {
                sX = nX;
                w += dLeft;
            }
            break;
        case 's':
            if (h + dTop + 5 > 0 && t + h + dTop <= imgTop + oImage.offsetHeight + (_isIE ? 2 : 0))
            {
                sY = nY;
                h += dTop;
            }
            break;
        case 'w':
            if (w - dLeft - 5 > 0 && l+dLeft > imgLeft)
            {
                sX = nX;
                l += dLeft;
                w -= dLeft;
            }
            break;
        case 'se':
            if (h + dTop + 5 > 0 && t + h + dTop <= imgTop + oImage.offsetHeight + (_isIE ? 2 : 0))
            {
                sY = nY;
                h += dTop;
            }
            if (w + dLeft - 5 > 0 && l + w + dLeft <= imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0))
            {
                sX = nX;
                w += dLeft;
            }
            break;
        case 'sw':
            if (h + dTop + 5 > 0 && t + h + dTop <= imgTop + oImage.offsetHeight + (_isIE ? 2 : 0))
            {
                sY = nY;
                h += dTop;
            }
            if (w - dLeft - 5 > 0 && l+dLeft > imgLeft)
            {
                sX = nX;
                l += dLeft;
                w -= dLeft;
            }
            break;
        case 'nw':
            if (h - dTop - 5 > 0 && t + dTop > imgTop)
            {
                sY = nY;
                t += dTop;
                h -= dTop;
            }
            if (w - dLeft - 5 > 0 && l+dLeft > imgLeft)
            {
                sX = nX;
                l += dLeft;
                w -= dLeft;
            }
            break;
        case 'ne':
            if (h - dTop - 5 > 0 && t + dTop > imgTop)
            {
                sY = nY;
                t += dTop;
                h -= dTop;
            }
            if (w + dLeft - 5 > 0 && l + w + dLeft <= imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0))
            {
                sX = nX;
                w += dLeft;
            }
            break;
    }
    
    activeElement.style.height = Math.max( 5, h );
	activeElement.style.width = Math.max( 5, w );
	activeElement.style.left = l;
	activeElement.style.top = t;
}

var curId = 0;
function createMap(e, _new, _href, _alt, _title, _target, _left, _top, _width, _height)
{
    oDiv = document.createElement('DIV');
    
    sbSetAttribute(oDiv, "_sbmapdiv", 1);
    sbSetAttribute(oDiv, "id", '_sbmap' + curId);
    
    if (_new)
    {
        if (_left < imgLeft)
            _left = imgLeft;
        if (_top < imgTop)
            _top = imgTop;
        if (_left + _width > imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0))
            _width = imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0) - _left;
        if (_top + _height > imgTop + oImage.offsetHeight + (_isIE ? 2 : 0))
            _height = imgTop + oImage.offsetHeight + (_isIE ? 2 : 0) - _top;

		sbSetAttribute(oDiv, "_sbmaphref", _href);
		sbSetAttribute(oDiv, "_sbmapalt", _alt);
		sbSetAttribute(oDiv, "_sbmaptitle", _title);
		sbSetAttribute(oDiv, "_sbmaptarget", _target);

		oDiv.title = _href;
        oDiv.style.left = _left;
        oDiv.style.top = _top;
        oDiv.style.width = _width;
        oDiv.style.height = _height;
    }
    else
    {
    	sbGetE("txtUrl").value = "";
        sbGetE("cmbTarget").value = "";
        sbGetE("txtAlt").value = "";
        sbGetE("txtTitle").value = "";
        
    	sbSetAttribute(oDiv, "_sbmaphref", "");
		sbSetAttribute(oDiv, "_sbmapalt", "");
		sbSetAttribute(oDiv, "_sbmaptitle", "");
		sbSetAttribute(oDiv, "_sbmaptarget", "");
		
		var divEvt = sbGetE("event_content");
    	
    	sX = (_isIE ? e.x : e.pageX);
        sY = (_isIE ? e.y : e.pageY) - 24;
        
        oDiv.style.width = 4;
        oDiv.style.height = 4;
        oDiv.style.left = sX + divEvt.scrollLeft;
        oDiv.style.top = sY + divEvt.scrollTop;
        
        newDiv = true;
    }
    
    if (_isIE)
	    sbSetAttribute(oDiv, "className", "sbmap");
	else
		sbSetAttribute(oDiv, "class", "sbmap");
		
    oDiv.style.border = "1px solid red";
    sbGetE("event_content").insertBefore(oDiv, null);

    sbAddEvent(oDiv, 'mouseup', onMouseUp);
    sbAddEvent(oDiv, 'mousedown', onMouseDown);

    setActive(oDiv);

	if (e)
		sbCancelEvent(e);

    curId++;
}

function setActive(el)
{
	if (activeElement)
    {
    	if (_isIE)
        	activeElement.style.filter = 'alpha(opacity=40)';
        else
        	activeElement.style.opacity = '0.40';
        activeElement.style.border = '1px solid red';
        activeElement.style.zIndex = 100;
    }
    
    activeElement = el;
    
    if (activeElement && activeElement.getAttribute("_sbmapdiv"))
    {
        activeElement.style.zIndex = 200;
        activeElement.style.border = "1px solid green";
        if (_isIE)
        	activeElement.style.filter = 'alpha(opacity=80)';
        else
        	activeElement.style.opacity = '0.80';
        	
        document.body.focus();
        
        setFields();
        setSizes();
    }
    else
    	activeElement = null;
}

function onKeyDown(e)
{
	var el = sbEventTarget(e);
    if (!activeElement || el.tagName == "INPUT" || el.tagName == "SELECT")
        return;
	
	var keyCode = e.keyCode;
	
    if (keyCode == 8 || keyCode == 46 )
    {
        activeElement.removeNode(true);
        activeElement = null;
        
        var aDivs = document.getElementsByTagName("DIV");
        for (var i = 0; i < aDivs.length; i++)
        {
        	if (aDivs[i].getAttribute("_sbmapdiv"))
        		activeElement = aDivs[i];	
        }
        
        if (activeElement)
        {
        	setActive(activeElement);
        }
        else
        {	
	        setFields();
        	setSizes();
        }
    }
    else
    {
        var _step = e.ctrlKey ? 5 : 1;

		var w = parseInt(activeElement.style.width);
		var h = parseInt(activeElement.style.height);
		var t = parseInt(activeElement.style.top);
		var l = parseInt(activeElement.style.left);

        if (e.shiftKey)
        {
            switch (keyCode)
            {
                case 37:
                    activeElement.style.width = w - _step;
                    break;
                    
                case 39:
                    if (w + l + _step <= imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0))
                        activeElement.style.width = w + _step;
                    else
                        activeElement.style.width = imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0) - l;
                    break;
                    
                case 38:
                    activeElement.style.height= h - _step;
                    break;
                    
                case 40:
                    if (h + t + _step <= imgTop + oImage.offsetHeight + (_isIE ? 2 : 0))
                        activeElement.style.height = h + _step;
                    else
                        activeElement.style.height = imgTop + oImage.offsetHeight + (_isIE ? 2 : 0) - t;
                    break;
            }
        }
        else
        {
            switch (keyCode)
            {
                case 37:
                    if (l - _step > imgLeft)
                        activeElement.style.left = l - _step;
                    break;
                    
                case 39:
                    if (l + w + _step <= imgLeft + oImage.offsetWidth + (_isIE ? 2 : 0)) 
                        activeElement.style.left = l + _step;
                    break;
                    
                case 38:
                    if (t - _step > imgTop)
                        activeElement.style.top = t - _step;
                    break;
                    
                case 40:
                    if (t + h + _step <= imgTop + oImage.offsetHeight + (_isIE ? 2 : 0))
                        activeElement.style.top = t + _step;
                    break;
            }
        }
    }
    
    return sbCancelEvent(e);
}

function setFields()
{
	if(activeElement)
    {
        sbGetE("txtUrl").value = sbGetAttribute(activeElement, "_sbmaphref");
        sbGetE("cmbTarget").value = sbGetAttribute(activeElement, "_sbmaptarget");
        sbGetE("txtAlt").value = sbGetAttribute(activeElement, "_sbmapalt");
        sbGetE("txtTitle").value = sbGetAttribute(activeElement, "_sbmaptitle");
        
        sbGetE("txtUrl").disabled = false;
        sbGetE("cmbTarget").disabled = false;
        sbGetE("txtAlt").disabled = false;
        sbGetE("txtTitle").disabled = false;
        
        sbGetE("areaWidth").innerHTML = activeElement.offsetWidth;
        sbGetE("areaHeight").innerHTML = activeElement.offsetHeight;
    }
    else
    {
    	sbGetE("txtUrl").value = "";
        sbGetE("cmbTarget").value = "";
        sbGetE("txtAlt").value = "";
        sbGetE("txtTitle").value = "";
        
        sbGetE("txtUrl").disabled = true;
        sbGetE("cmbTarget").disabled = true;
        sbGetE("txtAlt").disabled = true;
        sbGetE("txtTitle").disabled = true;
        
        sbGetE("areaWidth").innerHTML = "";
        sbGetE("areaHeight").innerHTML = "";
    }
}

function setSizes()
{
	if(activeElement)
    {
        sbGetE("areaWidth").innerHTML = activeElement.offsetWidth;
        sbGetE("areaHeight").innerHTML = activeElement.offsetHeight;
    }
    else
    {
    	sbGetE("areaWidth").innerHTML = "";
        sbGetE("areaHeight").innerHTML = "";
    }
}

function updateArea()
{
    if (activeElement)
    {
    	sbSetAttribute(activeElement, "_sbmaphref", sbGetE("txtUrl").value );
		sbSetAttribute(activeElement, "_sbmaptarget", sbGetE("cmbTarget").value );
		sbSetAttribute(activeElement, "_sbmapalt", sbGetE("txtAlt").value );
		sbSetAttribute(activeElement, "_sbmaptitle", sbGetE("txtTitle").value );

		activeElement.title = sbGetE("txtUrl").value;
    }
}

function onResize()
{
    oldTop = imgTop;
    oldLeft = imgLeft;
    
    var par = sbGetE('editedImg');
    imgTop = sbGetAbsoluteTop(par) - 24;
    imgLeft = sbGetAbsoluteLeft(par);
    
    oDivs = document.getElementsByTagName('DIV');
    for (i = 0; i < oDivs.length; i++)
    {
    	if (oDivs[i].getAttribute("_sbmapdiv"))
    	{
        	oDivs[i].style.top = parseInt(oDivs[i].style.top) + imgTop - oldTop;
        	oDivs[i].style.left = parseInt(oDivs[i].style.left) + imgLeft - oldLeft;
        }
    }
}

function save()
{
	var map_source = makeMapAreas();
    var map_name = makeMapName();
    
    removeMap(oldMapName);
    
    if (map_source.length > 0)
    {
        var map_source = '<map name="'+map_name+'">' + map_source + '</map>';
        
        if (!_isFF)
	        wnd.sbEditorArea.insertAdjacentHTML("afterBegin", map_source);
	    else
	    {
	    	var r = wnd.sbEditorAreaDoc.createRange(); 
			r.setStartBefore(wnd.sbEditorArea); 
			map_source = r.createContextualFragment(map_source);
			wnd.sbEditorArea.insertBefore(map_source, wnd.sbEditorArea.firstChild);
	    }
        
        sbSetAttribute(oImage, "useMap", "#" + map_name);
    }
    else
    {
        oImage.removeAttribute('useMap');
    }
    
    sbCloseDialog();
}

function makeMapAreas()
{
    var map_source = '';
    var oDivs = document.getElementsByTagName('DIV');
    
    for(var i = 0; i < oDivs.length; i++)
    {
        var oDiv = oDivs[i];
        if (!oDiv.getAttribute("_sbmapdiv"))
        	continue;
        
        var _href = sbGetAttribute(oDiv, "_sbmaphref");
        if (_href.Trim() == '')
	       continue; 
	       	 
        var ut = parseInt(oDiv.style.top) - imgTop;
        var ul = parseInt(oDiv.style.left) - imgLeft;
        var bb = parseInt(oDiv.style.top) - imgTop + parseInt(oDiv.style.height);
        var br = parseInt(oDiv.style.left) - imgLeft + parseInt(oDiv.style.width);
        
        var _target = sbGetAttribute(oDiv, "_sbmaptarget");
        var _alt = sbGetAttribute(oDiv, "_sbmapalt").replace(/"/g, "%22");
        var _title = sbGetAttribute(oDiv, "_sbmaptitle").replace(/"/g, "%22");
        
        map_source += '<area shape="rect" href="'+_href+'" coords="'+ul+','+ut+','+br+','+bb+'"' + (_target.Trim() != '' ? ' target="'+_target+'"' : '') + (_title.Trim() != '' ? ' title="'+_title+'"' : '') + (_alt.Trim() != '' ? ' alt="'+_alt+'"' : '') + ' />';
    }
    
    return map_source;
}

function makeMapName()
{
    if (oldMapName && oldMapName.length > 0)
        return oldMapName;

    var zeit = new Date();
    return "map"+Date.UTC(zeit.getYear(),zeit.getMonth(),zeit.getDay(),zeit.getHours(),zeit.getMinutes(),zeit.getSeconds());
}

function removeMap(mapname)
{
    if (mapname.length > 0)
    {
    	var maps = wnd.sbEditorAreaDoc.getElementsByTagName("MAP");
	    for (var i = 0; i < maps.length; i++)
	    {
	    	var oMap = maps[i];
	    	var oMapName = _isIE ? oMap.getAttribute("name") : sbGetAttribute(oMap, "name"); 
	        if ( oMapName == mapname )
	        {
	            wnd.sbEditorRemoveNode(oMap);
	            return;
	        }   
	    }
	}
}

sbAddEvent(window, 'load', setMapInfo);

<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>