<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

var wnd = (_isIE ? dialogArguments : window.opener.sbModalDialog.args);

var oImage = wnd.sbEditorSelection._GetSelectedElement() ;
if ( oImage && (oImage.tagName != 'IMG' || oImage.getAttribute('_sbfakelement')) )
	oImage = null ;

var oLink = wnd.sbEditorSelection._MoveToAncestorNode( 'A' ) ;
var oImageOriginal ;
var eImgPreview ;
var eImgPreviewLink ;

function UpdateOriginal( setSizes )
{
	if ( !eImgPreview )
		return ;

	if ( sbGetE('txtUrl').value.length == 0 )
	{
		oImageOriginal = null ;
		return ;
	}

	oImageOriginal = document.createElement( 'IMG' ) ;
	if (setSizes)
	{
		oImageOriginal.onload = function()
		{
			oImageOriginal.onload = null;
			ResetSizes();
		}
	}
	oImageOriginal.src = sbGetE('txtUrl').value ;
}

var bPreviewInitialized ;

window.onload = function()
{
	LoadSelection() ;
	UpdateOriginal(true) ;

	sbSelectField( 'txtUrl' ) ;
}

function LoadSelection()
{
	if ( ! oImage ) return ;

	var sUrl = oImage.getAttribute( '_sbsavedurl' ) ;
	if ( sUrl == null )
		sUrl = sbGetAttribute( oImage, 'src', '' ) ;

	sbGetE('txtUrl').value = sUrl ;
	sbGetE('txtAlt').value = sbGetAttribute( oImage, 'alt', '' ) ;
	sbGetE('spin_VSpace').value = sbGetAttribute( oImage, 'vspace', '' ) ;
	sbGetE('spin_HSpace').value = sbGetAttribute( oImage, 'hspace', '' ) ;
	sbGetE('spin_Border').value = sbGetAttribute( oImage, 'border', '' ) ;
	
	if (oImage.style.borderColor.indexOf("rgb") != -1)
	{
		var _start = oImage.style.borderColor.indexOf("(") + 1;
		var _end = oImage.style.borderColor.indexOf(")");
		
		function getHexString(clr)
    	{
    		clr = clr.split(",");
    		
      		var rStr = parseInt(clr[0]).toString(16);
      		if (rStr.length == 1)
        		rStr = '0' + rStr;
      		var gStr = parseInt(clr[1]).toString(16);
      		if (gStr.length == 1)
        		gStr = '0' + gStr;
      		var bStr = parseInt(clr[2]).toString(16);
      		if (bStr.length == 1)
        		bStr = '0' + bStr;
      		
      		return ('#' + rStr + gStr + bStr).toUpperCase();
    	}
    	
    	var brdColor = getHexString(oImage.style.borderColor.substr( _start, _end - _start));
	}
	else
		var brdColor = oImage.style.borderColor;
	
	if ( _isIE)
	{
		var brdStyle = oImage.style.borderStyle ;
	}
	else
	{
		var brdStyle = oImage.style.borderStyle.split(" ") ;
		var brdStyle = brdStyle[0] ;
	}
		
	sbGetE('txtBorderColor').value = brdColor ;
	sbGetE('selBorderType').value = brdStyle ;
	sbGetE('cmbAlign').value = sbGetAttribute( oImage, 'align', '' ) ;

	var iWidth, iHeight ;

	var regexSize = /^\s*(\d+)px\s*$/i ;

	if ( oImage.style.width )
	{
		var aMatchW = oImage.style.width.match( regexSize ) ;
		if ( aMatchW )
		{
			iWidth = aMatchW[1] ;
			oImage.style.width = '' ;
			sbSetAttribute( oImage, 'width' , iWidth ) ;
		}
	}

	if ( oImage.style.height )
	{
		var aMatchH  = oImage.style.height.match( regexSize ) ;
		if ( aMatchH )
		{
			iHeight = aMatchH[1] ;
			oImage.style.height = '' ;
			sbSetAttribute( oImage, 'height', iHeight ) ;
		}
	}

	sbGetE('spin_Width').value = iWidth ? iWidth : sbGetAttribute( oImage, "width", '' ) ;
	sbGetE('spin_Height').value = iHeight ? iHeight : sbGetAttribute( oImage, "height", '' ) ;

	sbGetE('txtAttId').value = oImage.id ;
	sbGetE('txtAttTitle').value = oImage.title ;

	var reg = new RegExp("(border-color|border-right-color|border-left-color|border-top-color|border-bottom-color|border-style|border-right-style|border-left-style|border-top-style|border-bottom-style)\s*:.*[;]?", "ig");
	var sti ;
	if ( _isIE )
	{
		sbGetE('txtAttClasses').value = oImage.className || '' ;
		sti = oImage.style.cssText ;
	}
	else
	{
		sbGetE('txtAttClasses').value = oImage.getAttribute('class', 2) || '' ;
		sti = oImage.getAttribute('style', 2) ;
	}
	
	if (sti)
		sbGetE('txtAttStyle').value = sti.replace(reg, "");
	
	if ( oLink )
	{
		var sLinkUrl = oLink.getAttribute( '_sbsavedurl' ) ;
		if ( sLinkUrl == null )
			sLinkUrl = oLink.getAttribute('href', 2) ;
		
		var r = sLinkUrl.match(/[\s]*sbPopupImg[\s]*\([\s]*['|"](.*)['|"].*['|"](.*)['|"]/);
		if (r)
		{
			sbGetE('txtPopup').value = r[1];
			var imageTitle = new String(r[2]);
			imageTitle = imageTitle.replace(/##/g, '"');
    		imageTitle = imageTitle.replace(/\^\^/g, "'");
			sbGetE('txtPopupTitle').value = imageTitle;
		}
		else
		{
			sbGetE('txtLnkUrl').value = sLinkUrl ;
		}
		
		sbGetE('cmbLnkTarget').value = oLink.target.Trim() ;
	}

	UpdatePreview() ;
}

function save()
{
	if ( sbGetE('txtUrl').value.length == 0 )
	{
		tabs.loadTab(0, true);
		sbSelectField( 'txtUrl' ) ;

		alert( "<?php echo EDITOR_IMAGE_NO_URL; ?>" ) ;

		return false ;
	}

	var bHasImage = ( oImage != null ) ;

	wnd.sbEditorUndo._SaveUndoStep() ;
	if ( !bHasImage )
	{
		oImage = wnd.sbEditorInsertElement( 'img' ) ;
	}

	UpdateImage( oImage ) ;

	var sLnkUrl = sbGetE('txtLnkUrl').value.Trim() ;
	if (sLnkUrl.length == 0)
	{
		var sPopupUrl = sbGetE('txtPopup').value.Trim() ;
		var sPopupTitle = sbGetE('txtPopupTitle').value.Trim();
		
		if (sPopupUrl.length != 0)
		{
			sPopupTitle = sPopupTitle.replace(/'/g, "^^");
			sPopupTitle = sPopupTitle.replace(/"/g, "##");
			sLnkUrl = "javascript: sbPopupImg('" + sPopupUrl + "', '" + sPopupTitle + "')";
		}
	}
	
	if ( sLnkUrl.length == 0 && sPopupUrl == 0 )
	{
		if ( oLink )
			wnd.sbEditorExecuteNamedCommand( 'Unlink' ) ;
	}
	else
	{
		if ( oLink )
		{
			oLink.href = sLnkUrl ;
		}
		else		
		{
			if ( !bHasImage )
				wnd.sbEditorSelection._SelectNode( oImage ) ;

			oLink = wnd.sbEditorCreateLink( sLnkUrl )[0] ;

			if ( !bHasImage )
			{
				wnd.sbEditorSelection._SelectNode( oLink ) ;
				wnd.sbEditorSelection._Collapse( false ) ;
			}
		}

		sbSetAttribute( oLink, '_sbsavedurl', sLnkUrl ) ;
		sbSetAttribute( oLink, 'target', sbGetE('cmbLnkTarget').value ) ;
	}

	sbCloseDialog();
}

function UpdateImage( e, skipId )
{
	e.src = sbGetE('txtUrl').value ;
	sbSetAttribute( e, "_sbsavedurl", sbGetE('txtUrl').value ) ;
	sbSetAttribute( e, "alt", sbGetE('txtAlt').value ) ;
	sbSetAttribute( e, "width", sbGetE('spin_Width').value) ;
	sbSetAttribute( e, "height", sbGetE('spin_Height').value) ;
	sbSetAttribute( e, "vspace", sbGetE('spin_VSpace').value ) ;
	sbSetAttribute( e, "hspace", sbGetE('spin_HSpace').value ) ;
	sbSetAttribute( e, "border", sbGetE('spin_Border').value ) ;
	sbSetAttribute( e, "align" , sbGetE('cmbAlign').value ) ;

	if ( ! skipId )
		sbSetAttribute( e, 'id', sbGetE('txtAttId').value ) ;

	sbSetAttribute( e, 'title', sbGetE('txtAttTitle').value ) ;

	var addStyle = "";
	if (sbGetE('spin_Border').value.Trim() != "" && sbGetE('spin_Border').value != 0)
	{
	    if (sbGetE('txtBorderColor').value.Trim() != "")
	    	addStyle += "border-color:" + sbGetE('txtBorderColor').value + ";";
	    if (sbGetE('selBorderType').value != "")
	    	addStyle += "border-style:" + sbGetE('selBorderType').value + ";";
    }
    	
    var ownStyle = sbGetE('txtAttStyle').value;
    if (ownStyle != "" && ownStyle.substr(ownStyle.length - 2, 1) != ';')
    	ownStyle += ";";
    
	if ( _isIE )
	{
		e.className = sbGetE('txtAttClasses').value ;
		e.style.cssText = ownStyle + addStyle;
	}
	else
	{
		sbSetAttribute( e, 'class', sbGetE('txtAttClasses').value ) ;
		sbSetAttribute( e, 'style', ownStyle + addStyle) ;
	}
	
}

function SetPreviewElements( imageElement, linkElement )
{
	eImgPreview = imageElement ;
	eImgPreviewLink = linkElement ;

	UpdatePreview() ;
	UpdateOriginal() ;

	bPreviewInitialized = true ;
}

function CheckKey(e)
{
	var keystroke = e.keyCode || e.which ;
	if (keystroke == 13)
		UpdatePreview(true);
}

function UpdatePreview(orig)
{
	if ( !eImgPreview || !eImgPreviewLink )
		return ;

	if ( sbGetE('txtUrl').value.length == 0 )
		eImgPreviewLink.style.display = 'none' ;
	else
	{
		if (orig)
			UpdateOriginal( true );

		UpdateImage( eImgPreview, true ) ;

		if ( sbGetE('txtLnkUrl').value.Trim().length > 0 )
			eImgPreviewLink.href = 'javascript:void(null);' ;
		else
			sbSetAttribute( eImgPreviewLink, 'href', '' ) ;
		
		eImgPreviewLink.style.display = '' ;
	}
}

var bLockRatio = true ;

function SwitchLock( lockButton )
{
	bLockRatio = !bLockRatio ;
	lockButton.src = bLockRatio ? '<?php echo SB_CMS_IMG_URL; ?>/editor/lock.gif' : '<?php echo SB_CMS_IMG_URL; ?>/editor/unlock.gif' ;

	if ( bLockRatio )
	{
		if ( sbGetE('spin_Width').value.length > 0 )
			OnSizeChanged( 'Width', sbGetE('spin_Width').value ) ;
		else
			OnSizeChanged( 'Height', sbGetE('spin_Height').value ) ;
	}
}

function OnSizeChanged( dimension, value )
{
	if ( oImageOriginal && bLockRatio )
	{
		var e = dimension == 'Width' ? sbGetE('spin_Height') : sbGetE('spin_Width') ;

		if ( value.length == 0 || isNaN( value ) )
		{
			e.value = '' ;
			return ;
		}

		if ( dimension == 'Width' )
			value = value == 0 ? 0 : Math.round( oImageOriginal.height * ( value  / oImageOriginal.width ) ) ;
		else
			value = value == 0 ? 0 : Math.round( oImageOriginal.width  * ( value / oImageOriginal.height ) ) ;

		if ( !isNaN( value ) )
			e.value = value ;
	}

	UpdatePreview() ;
}

function ResetSizes()
{
	if ( ! oImageOriginal ) return ;
	if ( _isFF && !oImageOriginal.complete )
	{
		setTimeout( ResetSizes, 50 ) ;
		return ;
	}

	sbGetE('spin_Width').value  = oImageOriginal.width ;
	sbGetE('spin_Height').value = oImageOriginal.height ;

	UpdatePreview() ;
}

function SetPopup()
{
	if (sbGetE("txtPopup").value.Trim() != "")
	{
		sbGetE("txtLnkUrl").value = "";
	}
}

function SetLink()
{
	if (sbGetE("txtLnkUrl").value.Trim() != "")
	{
		sbGetE("txtPopup").value = "";
		sbGetE("txtAlt").value = sbGetE("txtLnkUrl_title").value;
	}
}
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>