<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

var wnd = (_isIE ? dialogArguments : window.opener.sbModalDialog.args);

window.onload = function()
{
	sbGetE('txtHtml').value = wnd.sbEditorArea.innerHTML ;

	var oSpeller = new sbSpellChecker( sbGetE('txtHtml') ) ;
	oSpeller.spellCheckScript = '<?php echo SB_CMS_EMPTY_FILE; ?>?event=pl_editor_spell_checker' ;
	oSpeller.OnFinished = OnFinished ;
	oSpeller.openChecker() ;
}

function OnFinished( num )
{
	if ( num > 0 )
	{
		wnd.sbEditorUndo._SaveUndoStep();
		wnd.sbEditorArea.innerHTML = sbGetE('txtHtml').value ;
		wnd.sbEditorUndo._SaveUndoStep();
		
		if ( _isIE )
			wnd.sbEditorSelection._Collapse( true ) ;
	}
	
	wnd.sbEditorEvents._FireEvent("OnSelectionChange");
	sbCloseDialog();
}


function sbSpellChecker( textObject ) 
{
	this.replWordFlag = "R";	
	this.ignrWordFlag = "I";	
	this.replAllFlag = "RA";	
	this.ignrAllFlag = "IA";	
	this.fromReplAll = "~RA";	
	this.fromIgnrAll = "~IA";	
	
	this.wordFlags = [];
	this.currentWordIndex = 0;
	this.spellCheckerWin = null;
	this.controlWin = null;
	this.wordWin = null;
	this.textInput = textObject;

	window.speller = this;
}

var pt = sbSpellChecker.prototype;
pt.openChecker = function() 
{
	this.spellCheckerWin = window.open( '<?php echo SB_CMS_EMPTY_FILE; ?>?event=pl_editor_spell_dialog', 'spellchecker' );
	if( !this.spellCheckerWin.opener ) 
	{
		this.spellCheckerWin.opener = window;
	}
}

pt.startCheck = function( wordWindowObj, controlWindowObj ) 
{
	this.wordWin = wordWindowObj;
	this.controlWin = controlWindowObj;

	this.controlWin.resetForm();
	
	this.currentWordIndex = 0;
	this.wordFlags = [];
	
	this._spellcheck();

	return true;
}

pt._spellcheck = function()
{
	var ww = this.wordWin;

	if( this.currentWordIndex == ww.totalWords() ) 
	{
		this.terminateSpell();
		return;
	}

	if( this.currentWordIndex > 0 ) 
	{
		this.controlWin.enableUndo();
	}

	if( this.wordFlags[this.currentWordIndex] ) 
	{
		this.currentWordIndex++;
		this._spellcheck();
	} 
	else 
	{
		var evalText = ww.getTextVal( this.currentWordIndex );
		if( evalText ) 
		{
			this.controlWin.evaluatedText.value = evalText;
			ww.setFocus( this.currentWordIndex );
			this._getSuggestions( this.currentWordIndex );
		}
		else
		{
			this.currentWordIndex++;
			this._spellcheck();
		}
	}
}

pt._getSuggestions = function ( word_num ) 
{
	this.controlWin.clearSuggestions();
	var a_suggests = this.wordWin.suggestions[this.wordWin.indexes[word_num]['word']];
	if( a_suggests ) 
	{
		for( var i = 0; i < a_suggests.length; i++ ) 
		{
			this.controlWin.addSuggestion( a_suggests[i] );
		}
	}
	
	this.controlWin.selectDefaultSuggestion();
}

pt.terminateSpell = function() 
{
	var msg = "";
	var numrepl = this._getTotalReplaced();

	if( numrepl == 0 ) 
	{
		if( !this.wordWin ) 
		{
			msg = "";
		} 
		else 
		{
			if( this.wordWin.totalWords() ) 
			{
				msg = "<?php echo EDITOR_SPELL_NO_REPLACES; ?>";
			} 
			else 
			{
				msg = "<?php echo EDITOR_SPELL_NO_ERRORS; ?>";
			}
		}
	} 
	else 
	{
		msg = "<?php echo EDITOR_SPELL_NUM_REPLACES; ?>";
		msg = msg.replace( /%s/g, numrepl ) ;
	}
	
	if( msg ) 
	{
		alert( msg );
	}

	if( numrepl > 0 ) 
	{
		this.textInput.value = this.wordWin.textInput;
	}

	if ( typeof( this.OnFinished ) == 'function' )
		this.OnFinished(numrepl) ;					

	return true;
}

pt._setAsIgnored = function ( word_num, flag ) 
{
	this.wordWin.removeFocus( word_num );
	this.wordFlags[word_num] = flag;
	return true;
}

pt._getTotalReplaced = function() 
{
	var i_replaced = 0;
	for( var i = 0; i < this.wordFlags.length; i++ ) 
	{
		if(( this.wordFlags[i] == this.replWordFlag ) || ( this.wordFlags[i] == this.replAllFlag ) 	|| ( this.wordFlags[i] == this.fromReplAll )) 
			i_replaced++;
	}
	
	return i_replaced;
}

pt.ignoreWord = function() 
{
	var wi = this.currentWordIndex;
	if( !this.wordWin ) 
	{
		return false;
	}
	if( !this.wordWin.getTextVal( wi )) 
	{
		return false;
	}
	if( this._setAsIgnored( wi, this.ignrWordFlag )) 
	{
		this.currentWordIndex++;
		this._spellcheck();
	}
	return true;
}

pt.ignoreAll = function() 
{
	var wi = this.currentWordIndex;
	if( !this.wordWin ) 
	{
		return false;
	}

	var s_word_to_repl = this.wordWin.getTextVal( wi );
	if( !s_word_to_repl ) 
	{
		return false;
	}

	this._setAsIgnored( wi, this.ignrAllFlag );

	for( var i = 0; i < this.wordWin.totalWords(); i++ ) 
	{
		if( i > wi ) 
		{
			if(( this.wordWin.getTextVal( i ) == s_word_to_repl ) && ( !this.wordFlags[i] )) 
			{
				this._setAsIgnored( i, this.fromIgnrAll );
			}
		}
	}

	this.currentWordIndex++;
	this._spellcheck();
	return true;
}

pt._setWordText = function ( word_num, newText, flag ) 
{
	this.wordWin.setText( word_num, newText );
	this.wordFlags[word_num] = flag;
	return true;
}

pt.replaceWord = function() 
{
	var wi = this.currentWordIndex;
	if( !this.wordWin ) 
	{
		return false;
	}
	if( !this.wordWin.getTextVal( wi )) 
	{
		return false;
	}
	if( !this.controlWin.replacementText ) 
	{
		return false ;
	}
	var txt = this.controlWin.replacementText;
	if( txt.value ) 
	{
		var newspell = new String( txt.value );
		if( this._setWordText( wi, newspell, this.replWordFlag )) 
		{
			this.currentWordIndex++;
			this._spellcheck();
		}
	}
	return true;
}

pt.replaceAll = function() 
{
	var wi = this.currentWordIndex;
	if( !this.wordWin ) 
	{
		return false;
	}
	var s_word_to_repl = this.wordWin.getTextVal( wi );
	if( !s_word_to_repl ) 
	{
		return false;
	}
	
	var txt = this.controlWin.replacementText;
	if( !txt.value ) return false;
	var newspell = new String( txt.value );

	this._setWordText( wi, newspell, this.replAllFlag );

	for( var j = 0; j < this.wordWin.totalWords(); j++ ) 
	{
		if( j > wi ) 
		{
			if(( this.wordWin.getTextVal( j ) == s_word_to_repl ) && ( !this.wordFlags[j] )) 
			{
				this._setWordText( j, newspell, this.fromReplAll );
			}
		}
	}

	this.currentWordIndex++;
	this._spellcheck();
	return true;
}

pt.undo = function() 
{
	var wi = this.currentWordIndex;

	if( this.wordWin.totalPreviousWords( wi ) > 0 ) 
	{
		this.wordWin.removeFocus( wi );

		do 
		{
			if( this.currentWordIndex > 0 ) 
				this.currentWordIndex--;
		} while (
			this.wordWin.totalWords() == 0
			|| this.wordFlags[this.currentWordIndex] == this.fromIgnrAll
			|| this.wordFlags[this.currentWordIndex] == this.fromReplAll
		);

		var idx = this.currentWordIndex;
		var preReplSpell = this.wordWin.originalSpellings[this.wordWin.indexes[idx]['word']];

		if( this.wordWin.totalPreviousWords( idx ) == 0 ) 
		{
			this.controlWin.disableUndo();
		}

		var i, j, origSpell ;
		switch( this.wordFlags[idx] ) 
		{
			case this.replAllFlag :
				for( j = 0; j < this.wordWin.totalWords(); j++ ) 
				{
					if( j >= idx ) 
					{
						origSpell = this.wordWin.originalSpellings[this.wordWin.indexes[j]['word']];
						if( origSpell == preReplSpell ) 
						{
							this._setWordText ( j, origSpell, undefined );
						}
					}
				}
				break;

			case this.ignrAllFlag :
				for( j = 0; j < this.wordWin.totalWords(); j++ ) 
				{
					if( j >= idx ) 
					{
						origSpell = this.wordWin.originalSpellings[this.wordWin.indexes[j]['word']];
						if( origSpell == preReplSpell ) 
						{
							this.wordFlags[j] = undefined;
						}
					}
				}
				break;

			case this.replWordFlag :
				this._setWordText ( idx, preReplSpell, undefined );
				break;
		}

		this.wordFlags[idx] = undefined;
		this._spellcheck();
	}
}

<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>