<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

var wnd = (_isIE || _isFF ? dialogArguments : window.opener.sbModalDialog.args);
if (!wnd)
	sbCloseDialog();
	
window.onload = loadTemplates ;

function loadTemplates()
{
	var oTemplate ;

	if ( !wnd.sbEditorTemplates )
	{
		sbGetE("eLoading").style.display = "" ;

		wnd.sbEditorTemplates = new Array() ;

		var xml = new sbXMLLoader(null, null, false) ;
		xml.loadXML( wnd.sbEditorTemplatesXmlPath ) ;

		var oAtt = xml.selectSingleNode( "Templates/@imagesBasePath" ) ;
		var sImagesBasePath = oAtt ? oAtt.value : "" ;

		var aTplNodes = xml.selectNodes( "Templates/Template" ) ;
		for ( var i = 0 ; i < aTplNodes.length ; i++ )
		{
			var oNode = aTplNodes[i] ;

			oTemplate = new Object() ;

			var oPart ;

			if ( (oPart = oNode.attributes.getNamedItem("title")) )
				oTemplate.Title = oPart.value ;
			else
				oTemplate.Title = "<?php echo EDITOR_TEMPLATES_TITLE; ?> " + ( i + 1 ) ;

			if ( (oPart = xml.selectSingleNode( "Description", oNode )) )
				oTemplate.Description = oPart.text ? oPart.text : oPart.textContent ;

			if ( (oPart = oNode.attributes.getNamedItem("image")) )
				oTemplate.Image = sImagesBasePath + oPart.value ;

			if ( (oPart = xml.selectSingleNode( "Html", oNode )) )
				oTemplate.Html = oPart.text ? oPart.text : oPart.textContent ;
			else
			{
				continue ;
			}

			wnd.sbEditorTemplates[ wnd.sbEditorTemplates.length ] = oTemplate ;
		}

		sbGetE("eLoading").style.display = "none" ;
	}

	if ( wnd.sbEditorTemplates.length == 0 )
		sbGetE("eEmpty").style.display = "" ;
	else
	{
		for ( var j = 0 ; j < wnd.sbEditorTemplates.length ; j++ )
		{
			oTemplate = wnd.sbEditorTemplates[j] ;

			var oItemDiv = sbGetE("eList").appendChild( document.createElement( "DIV" ) ) ;
			oItemDiv.TplIndex = j ;
			oItemDiv.className = "sbTplItem" ;

			var sInner = "<table><tr>" ;

			if ( oTemplate.Image )
				sInner += "<td valign=\"top\"><img src=\"" + oTemplate.Image + "\"><\/td>" ;

			sInner += "<td valign=\"top\"><div class=\"sbTplTitle\">" + oTemplate.Title + "<\/div>" ;

			if ( oTemplate.Description )
				sInner += "<div class=\"sbTplDescr\">" + oTemplate.Description + "<\/div>" ;

			sInner += "<\/td><\/tr><\/table>" ;

			oItemDiv.innerHTML = sInner ;

			oItemDiv.onmouseover = itemOver ;
			oItemDiv.onmouseout = itemOut ;
			oItemDiv.onclick = itemClick ;
		}
	}
}

function itemOver()
{
	this.className += " sbTplItemOver" ;
}

function itemOut()
{
	this.className = this.className.replace( /\s*sbTplItemOver\s*/, "" ) ;
}

function itemClick()
{
	sbReturnValue(wnd.sbEditorTemplates[this.TplIndex].Html ) ;
}

function resizeList()
{
	var el = sbGetE("eList");
	if (el)
	{
		el.style.height = parseInt(document.body.clientHeight) - 150;
	}
}

sbResizeFuncs[sbResizeFuncs.length]=resizeList;
	
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>