<?php require_once(dirname(__FILE__).'/../jheader.inc.php'); ?>

//стиль обрамления визуального редактора
var sbBorderStyle = {};
	sbBorderStyle.style = 'outlineStyle';
	sbBorderStyle.color = 'outlineColor';

/*
var sbBorderStyle = {};
	sbBorderStyle.style = 'borderStyle';
	sbBorderStyle.color = 'borderColor';
*/

var sbEditorMenu = new sbCMenu("sbEditorMenu", "15#FF9933", "15#fff5e0", "highItemText", "lowItemText", 90);
sbEditorMenu.topIdent = 128;

sbEditorMenu.addItem("edit", "<?php echo VISUAL_EDITOR_EDIT; ?>", sbEditorEditElem);
sbEditorMenu.addItem("new_text", "<?php echo VISUAL_EDITOR_NEW_TEXT; ?>", sbEditorNewText);
sbEditorMenu.addItem("elem_delimeter");
sbEditorMenu.addItem("new_elem", "<?php echo VISUAL_EDITOR_NEW_ELEM; ?>", sbEditorReplaceElem);
sbEditorMenu.addItem("replace_elem", "<?php echo VISUAL_EDITOR_REPLACE; ?>", sbEditorReplaceElem);
sbEditorMenu.addItem("delete", "<?php echo VISUAL_EDITOR_DELETE; ?>", sbEditorDeleteElem);
sbEditorMenu.addItem("temp_delimeter");

if (sbEditorDesignItem)
    sbEditorMenu.addItem("template", "<?php echo VISUAL_EDITOR_TEMPLATE; ?>", sbEditorShowTemplate);

sbEditorMenu.addItem("settings", "<?php echo VISUAL_EDITOR_SETTINGS; ?>", sbEditorShowSettings);
sbEditorMenu.addItem("block_delimeter");
sbEditorMenu.addItem("block_add", "<?php echo VISUAL_EDITOR_ADD_BLOCK; ?>", sbEditorAddBlock);

sbEditorMenu.hideFunc = sbEditorOnMenuHide;

var sbEditorMenuArea = null;

function sbEditorShowMenu(e)
{
	sbHideMsgDiv();
    
    if (sbEditorMenuArea && sbEditorMenuArea.getAttribute("old_border_color"))
		sbEditorMenuArea.style[sbBorderStyle.color] = sbEditorMenuArea.getAttribute("old_border_color");
	 
    sbEditorMenuArea = sbEventTarget(e);
	while (sbEditorMenuArea && (sbEditorMenuArea.nodeType != 1 || sbEditorMenuArea.getAttribute("sb_type") === null))
		sbEditorMenuArea = sbEditorMenuArea.parentNode;

	if (!sbEditorMenuArea)
		return;
		
	if (sbGetE("sb_editor_toolbar").contentWindow.sbEditorArea == sbEditorMenuArea)
		return;
		
	if (sbEditorMenuArea.getAttribute("sb_e_id") == "-1" || sbEditorMenuArea.getAttribute("sb_type") == "")
	{
		sbEditorMenu.hideItem("edit");
		sbEditorMenu.hideItem("replace_elem");
		sbEditorMenu.hideItem("temp_delimeter");
		sbEditorMenu.hideItem("template");
		sbEditorMenu.hideItem("settings");
		sbEditorMenu.showItem("new_elem");
	}
	else
	{
		var type = sbEditorMenuArea.getAttribute("sb_type");
		if (type == "pl_texts_html" || type == "pl_texts_plain" || sbEditorMenuArea.getAttribute("sb_edit") )
			sbEditorMenu.showItem("edit");
		else
			sbEditorMenu.hideItem("edit");
			
		if (sbEditorMenuArea.getAttribute("sb_template"))
			sbEditorMenu.showItem("template");
		else				
			sbEditorMenu.hideItem("template");
							
		sbEditorMenu.showItem("replace_elem");
		sbEditorMenu.hideItem("new_elem");
		
		var get_event = sbEditorMenuArea.getAttribute("sb_get_event");
		if (get_event == "")
			sbEditorMenu.hideItem("settings");
		else
			sbEditorMenu.showItem("settings");
			
		if (get_event == "" && !sbEditorMenuArea.getAttribute("sb_template"))
			sbEditorMenu.hideItem("temp_delimeter");
		else
			sbEditorMenu.showItem("temp_delimeter");
	}
	
	if (sbEditorMenuArea.getAttribute("sb_e_link") == "page")
		sbEditorMenu.showItem("delete");
	else
		sbEditorMenu.hideItem("delete");
	
	sbEditorMenu.show(e);

	sbEditorMenuArea.setAttribute("old_border_color", sbEditorMenuArea.style[sbBorderStyle.color]);
	sbEditorMenuArea.style[sbBorderStyle.color] = "green";
}

function sbEditorOnMenuHide()
{
	if (sbEditorMenuArea && sbEditorMenuArea.getAttribute("old_border_color"))
		sbEditorMenuArea.style[sbBorderStyle.color] = sbEditorMenuArea.getAttribute("old_border_color");
}

function sbEditorBlockEvents(e)
{
	return sbCancelEvent(e);
}

function sbEditorEditElem(e)
{
	if (e)
	{
		if (sbEditorMenuArea)
		{
			sbEditorMenuArea.style[sbBorderStyle.style] = "dotted";
			sbEditorMenuArea.style[sbBorderStyle.color] = sbEditorMenuArea.getAttribute("old_border_color");
		}
		
		var el = sbEventTarget(e);
		while (el && (el.nodeType != 1 || !el.getAttribute("sb_type")))
			el = el.parentNode;
	}
	else
	{
		var el = sbEditorMenuArea;
	}
	
	var wnd = sbGetE("sb_editor_toolbar").contentWindow;
	
	if (!el || el == wnd.sbEditorArea)
		return;
		
	if (e)
		sbCancelEvent(e);

	if (wnd.sbEditorArea)
	{
		if (sbGetE("sb_editor_value").value != wnd.sbEditorGetData() && confirm("<?php echo EDITOR_CONFIRM_SAVE; ?>"))
		{
			wnd.sbEditorSaveAction(wnd.sbGetE("sbEditorBtnSave"), true);
		}
		
		sbEditorCancelTextEdit(wnd.sbEditorArea);
	}

    if (el.getAttribute("sb_avail") != "1")
    {
        sbShowMsgDiv("<?php echo VISUAL_EDITOR_AVAIL_ERROR; ?>", "warning.png");
        return;
    }
    
    var wnd_a = sbGetE("sb_editor_area").contentWindow;
    var doc = wnd_a.document;
    var aCol = el.getElementsByTagName("a");
    var aColShd = new Array();
    for (var i = 0; i < aCol.length; i++)
    {
        sbRemoveEvent(aCol[i], "click", sbEditorCheckLink);
        if (aCol[i].getAttribute("rel") == "shadowbox" && wnd_a.Shadowbox)
        	aColShd.push(aCol[i]);
    }
    
    if (wnd_a.Shadowbox && typeof(wnd_a.Shadowbox.teardown) == "function")
    {
        wnd_a.Shadowbox.teardown(aColShd);
    }
    
	var type = el.getAttribute("sb_type"); 
	if (type == "pl_texts_html" || type == "pl_texts_plain")
	{
		el.style.display = "block";
		el.style[sbBorderStyle.style] = "solid";
		el.setAttribute("old_border_color", el.style[sbBorderStyle.color]); 
		el.style[sbBorderStyle.color] = "green";
		el.style.cursor = "text";
	
		sbAddEvent(doc, "click", sbEditorBlockEvents);
		sbAddEvent(doc, "dblclick", sbEditorBlockEvents);
	
		wnd.sbEditorAreaId = el.id;
		wnd.sbEditorInitArea();
		sbGetE("sb_editor_value").value = wnd.sbEditorGetData();
	}
	else if (el.getAttribute("sb_edit"))
	{
		var strPage = sb_cms_modal_dialog_file + "?event=" + el.getAttribute("sb_edit");
    	var strAttr = "resizable=1,width=" + (screen.availWidth - 100) + ",height=" + (screen.availHeight - 100);
    	sbShowModalDialog(strPage, strAttr, sbEditorAfterEvent);
	}
}

function sbEditorCancelTextEdit(el)
{
	var wnd = sbGetE("sb_editor_toolbar").contentWindow; 
	var doc = wnd.document;
	
	wnd.sbEditorMakeUneditable();
	
	el.style.cursor = "default";
	el.style[sbBorderStyle.style] = "dotted";
	el.style[sbBorderStyle.color] = el.getAttribute("old_border_color");;
	
	wnd.sbEditorArea.innerHTML = sbGetE("sb_editor_value").value; 
	sbGetE("sb_editor_value").value = "";
	
	sbRemoveEvent(doc, "click", sbEditorBlockEvents);
	sbRemoveEvent(doc, "dblclick", sbEditorBlockEvents);
	
	var wnd_a = sbGetE("sb_editor_area").contentWindow;
    var aCol = wnd_a.document.getElementsByTagName("a");
    var aColShd = new Array();
    for (var i = 0; i < aCol.length; i++)
    {
    	sbRemoveEvent(aCol[i], "click", sbEditorCheckLink);
        sbAddEvent(aCol[i], "click", sbEditorCheckLink);
        if (aCol[i].getAttribute("rel") == "shadowbox" && wnd_a.Shadowbox)
        	aColShd.push(aCol[i]);
    }
    
    if (wnd_a.Shadowbox)
    {
        wnd_a.Shadowbox.setup(aColShd);
    }
    
	wnd.sbEditorAreaId = "";
	wnd.sbEditorArea = null;
	wnd.sbEditorSelectionChangeLocked = false;
	wnd.sbEditorLastOnChangeTimer = null;

	wnd.sbEditorRefreshButtons();
	wnd.sbEditorStylesCombo._Disable();
	wnd.sbEditorFontFormatsCombo._Disable();
	wnd.sbEditorFontNamesCombo._Disable();
	wnd.sbEditorFontSizesCombo._Disable();
}

function sbEditorNewText()
{
	if (sbWorkflow)
	{	
		sbCallWorkflowFunc = "sbEditorNewText";
		sbEditorSetWorkflowStatus();
		return;
	}
	
    var tag = "{" + sbEscapeEx(sbEditorMenuArea.getAttribute("sb_tag")) + "}";
 
    if (sbEditorDefaultNewText)
    {
        var val = sbLoadSync(sb_cms_empty_file + "?event=pl_editor_new_text_submit&default=1&e_id=" + sbEditorMenuArea.getAttribute("sb_e_id") + "&p_id=" + sbGetE("sb_editor_page").value + "&e_tag=" + tag);
        if (val == 'FALSE')
        {
            alert("<?php echo VISUAL_EDITOR_NEW_TEXT_ERROR; ?>");
            
            var strPage = sb_cms_modal_dialog_file + "?event=pl_editor_new_text&e_id=" + sbEditorMenuArea.getAttribute("sb_e_id") + "&p_id=" + sbGetE("sb_editor_page").value + "&e_tag=" + tag;
	        var strAttr = "resizable=1,width=500,height=600";
	        sbShowModalDialog(strPage, strAttr, sbEditorAfterNewText);
            return;
        }

        sbEditorAfterNewText(res);
    }
    else
    {
        var strPage = sb_cms_modal_dialog_file + "?event=pl_editor_new_text&e_id=" + sbEditorMenuArea.getAttribute("sb_e_id") + "&p_id=" + sbGetE("sb_editor_page").value + "&e_tag=" + tag;
        var strAttr = "resizable=1,width=500,height=600";
        sbShowModalDialog(strPage, strAttr, sbEditorAfterNewText);
    }
}

function sbEditorAfterNewText(res)
{
    if (!sbModalDialog.returnValue && !res)
        return;
        
    if (sbModalDialog.returnValue)
        res = sbModalDialog.returnValue;
        
    var el = sbEditorMenuArea;
        
    el.setAttribute("sb_tag", res.sb_tag);
    el.setAttribute("sb_type", res.sb_type);
    el.setAttribute("sb_el_id", res.sb_el_id);
    el.setAttribute("sb_avail", res.sb_avail);
    el.setAttribute("sb_e_id", res.sb_e_id);
    el.setAttribute("sb_e_link", res.sb_e_link);
    el.setAttribute("sb_template", res.sb_template);
    el.setAttribute("sb_edit", res.sb_edit);
    el.setAttribute("sb_settings_width", res.sb_settings_width);
    el.setAttribute("sb_settings_height", res.sb_settings_height);
    el.innerHTML = "&nbsp;";
    
    sbEditorEditElem();
}

function sbEditorReplaceElem()
{
	if (sbWorkflow)
	{	
		sbCallWorkflowFunc = "sbEditorReplaceElem";
		sbEditorSetWorkflowStatus();
		return;
	}
	
	var strPage = sb_cms_modal_dialog_file + "?event=pl_editor_replace_block&e_id=" + sbEditorMenuArea.getAttribute("sb_e_id") + "&p_id=" + sbGetE("sb_editor_page").value + "&e_tag=" + sbEscapeEx(sbEditorMenuArea.getAttribute("sb_tag"));
    var strAttr = "resizable=1,width=1000,height=300";
    sbShowModalDialog(strPage, strAttr, sbEditorAfterEvent);
}

function sbEditorAfterEvent()
{
	if (!sbModalDialog.returnValue)
		return;
		
	sbEditorReload();
}

function sbEditorReload()
{
	var wnd = sbGetE("sb_editor_toolbar").contentWindow;
	if (wnd.sbEditorArea)
	{
		wnd.sbEditorExitAction(wnd.sbGetE("sbEditorBtnExit"));
	}
	
	sbEditorMenuArea = null;
	if (_isIE)
       sbGetE("sb_editor_area").src = sbGetE("sb_editor_area").src;
    else
       sbGetE("sb_editor_area").contentDocument.location.replace(sbGetE("sb_editor_area").src);
}

function sbEditorDeleteElem()
{
	if (!sbEditorMenuArea)
		return;
	
	if (sbWorkflow)
	{	
		sbCallWorkflowFunc = "sbEditorDeleteElem";
		sbEditorSetWorkflowStatus();
		return;
	}
	
	var e_id = sbEditorMenuArea.getAttribute("sb_e_id");
	var res = sbLoadSync(sb_cms_empty_file + "?event=pl_editor_delete_block&e_id=" + e_id);
	if (res == "SB_EMPTY")
	{
		var tag_name = "<?php echo VISUAL_EDITOR_NO_ELEM; ?>";
		tag_name = tag_name.replace("NAME", sbEditorMenuArea.title); 
	
		sbEditorMenuArea.innerHTML = "<center style=\"color:red;font-family:Verdana,Arial,Tahoma;font-size:12px;\">&nbsp;" + tag_name + "&nbsp;</center>";
		sbEditorMenuArea.setAttribute("sb_type", "");
		sbEditorMenuArea.setAttribute("sb_e_id", "-1");
		sbEditorMenuArea.setAttribute("sb_el_id", "-1");
		sbEditorMenuArea.setAttribute("sb_e_link", "");
		sbEditorMenuArea.setAttribute("sb_template", "");
		sbEditorMenuArea.setAttribute("sb_edit", "");
	}
	else if (res.substr(0, 8) == "SB_ERROR")
	{
		var code = res.substr(8, 1);
		switch (code)
		{
			case "1":
				sbShowMsgDiv("<?php echo VISUAL_EDITOR_DELETE_ERROR1; ?>", 'warning.png');
				break;
			
			case "2":
				sbShowMsgDiv("<?php echo VISUAL_EDITOR_DELETE_ERROR2; ?>", 'warning.png');
				break;
		}
	}
	else
	{
		sbEditorReload();
	}
}

function sbEditorShowTemplate()
{
	if ( !sbEditorMenuArea || sbGetE("sb_editor_toolbar").contentWindow.sbEditorArea )
		return;
	
	if (sbWorkflow)
	{	
		sbCallWorkflowFunc = "sbEditorShowTemplate";
		sbEditorSetWorkflowStatus();
		return;
	}
	
	var strPage = sb_cms_modal_dialog_file + sbEditorMenuArea.getAttribute("sb_template");
    var strAttr = "resizable=1,width=1000,height=750";
    sbShowModalDialog(strPage, strAttr, sbEditorAfterEvent);
}

function sbEditorShowSettings()
{
	if (sbWorkflow)
	{	
		sbCallWorkflowFunc = "sbEditorShowSettings";
		sbEditorSetWorkflowStatus();
		return;
	}
	
	var strPage = sb_cms_modal_dialog_file + "?event=pl_editor_block_settings&e_id=" + sbEditorMenuArea.getAttribute("sb_e_id");
    var strAttr = "resizable=1,width=" + eval(sbEditorMenuArea.getAttribute("sb_settings_width")) + ",height=" + eval(sbEditorMenuArea.getAttribute("sb_settings_height"));
    sbShowModalDialog(strPage, strAttr, sbEditorAfterShowSettings);
}

function sbEditorAfterShowSettings()
{
	if (!sbModalDialog.returnValue)
		return;

	var res = sbModalDialog.returnValue;
	var data = [];
	
    if (typeof(res.el_id) != "undefined")
        data[data.length] = "el_id=" + res.el_id;
    else
        data[data.length] = "el_id=-1";
        
    if (typeof(res.temp_id) != "undefined")
    	data[data.length] = "temp_id=" + res.temp_id;
    else
        data[data.length] = "temp_id=-1";
        
    if (typeof(res.params) != "undefined")
    	data[data.length] = "params=" + sbEscapeEx(res.params);

	data = data.join("&");    	
	res = sbPostSync(sb_cms_empty_file + "?event=pl_editor_block_settings_submit&e_id=" + sbEditorMenuArea.getAttribute("sb_e_id") + "&p_id=" + sbGetE("sb_editor_page").value, data);
	
	if (res == "FALSE")
	{
		sbShowMsgDiv("<?php echo VISUAL_EDITOR_SETTINGS_ERROR; ?>", 'warning.png');
		return;
	}
		
	sbEditorReload();
}

function sbEditorInitMenu()
{
	sbEditorMenu.init();
}

function sbEditorHideMenu()
{
	sbEditorMenu.hide();
}

function sbEditorCheckLink(e)
{
    if (!e)
    	e = event;
    
    sbCancelEvent(e);
    	
    var el = sbEventTarget(e);
    if (!el)
    	return;
    
    if (el.tagName != "A")
    {
    	while (el.parentNode && el.tagName != "A")
    		el = el.parentNode;
    }
    
    if (!el || el.tagName != "A" || sbGetE("sb_editor_area").contentWindow.Shadowbox && el.getAttribute("rel") == "shadowbox")
    	return;
    	
    var url = el.getAttribute("href");
    if (!url)
    	return;
    	
    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_pages_edit_content&p_url=" + url);
    if (res == -1)
    {
        sbShowMsgDiv("<?php echo VISUAL_EDITOR_CHECK_LINK_ERROR; ?>", 'warning.png');
        return;
    }
    
    var wnd = sbGetE("sb_editor_toolbar").contentWindow;
	if (wnd.sbEditorArea)
	{
		wnd.sbEditorExitAction(wnd.sbGetE("sbEditorBtnExit"));
	}
	
    window.location = sb_cms_dialog_file + "?event=pl_pages_edit_content&p_id=" + res;
}

function sbEditorAreaLoad()
{
	var wnd = sbGetE("sb_editor_area").contentWindow;
    var doc = sbGetE("sb_editor_area").contentWindow.document;
    
    sbAddEvent(doc.body, 'contextmenu', sbDisCMenu);
    
    var aCol = doc.getElementsByTagName("a");
    
    for (var i = 0; i < aCol.length; i++)
    {
        sbAddEvent(aCol[i], "click", sbEditorCheckLink);
    }
    
    sbGetE("sb_editor_toolbar").contentWindow.sbEditorAreaWnd = sbGetE("sb_editor_area").contentWindow;
	sbGetE("sb_editor_toolbar").contentWindow.sbEditorAreaDoc = sbGetE("sb_editor_area").contentWindow.document;
	
	sbAddEvent(sbGetE("sb_editor_toolbar").contentWindow.sbEditorAreaDoc, "click", sbEditorHideMenu);
}

function sbEditorAddBlock()
{
	if (sbWorkflow)
	{	
		sbCallWorkflowFunc = "sbEditorAddBlock";
		sbEditorSetWorkflowStatus();
		return;
	}
	
	var strPage = sb_cms_modal_dialog_file + "?event=pl_editor_add_block&p_id=" + sbGetE("sb_editor_page").value + "&e_tag=" + sbEscapeEx(sbEditorMenuArea.getAttribute("sb_tag"));
    var strAttr = "resizable=1,width=600,height=400";
    sbShowModalDialog(strPage, strAttr, sbEditorAfterEvent);
}

var sbCallWorkflowFunc = "";
function sbEditorSetWorkflowStatus()
{	
	var strPage = sb_cms_modal_dialog_file + "?event=pl_pages_get_status&id=" + sbGetE("sb_editor_page").value;
    var strAttr = "resizable=0,width=600,height=600";
                
    sbShowModalDialog(strPage, strAttr, sbEditorAfterSetWorkflowStatus);
}

function sbEditorAfterSetWorkflowStatus()
{
	if (sbModalDialog.returnValue)
	{
		sbWorkflow = false;
		if (sbCallWorkflowFunc != "")
    	{
    		setTimeout(sbCallWorkflowFunc + "()", 100);
    		sbCallWorkflowFunc = "";
    	}
	}
}

sbAddEvent(window, "load", sbEditorInitMenu);
<?php require_once(dirname(__FILE__).'/../jfooter.inc.php'); ?>