<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
var sbAutocompleteCurrentLetters = new Array();
var sbAutocompleteCachedLists = new Array();
var sbAutocompleteObjects = new Array();

var sbAutocompleteActiveInput = false;
var sbAutocompleteDiv = false;
var sbAutocompleteListIndex = 0; 
var sbAutocompleteActiveItem;
var sbAutocompleteFirstItem;
var sbAutocompleteTimer = null;
var sbAutocompleteTimerParams = new Object;

function sbAutocompleteGetPhrase(el)
{
	var letters = new String(el.value);
	var pos = sbGetCaretPosition(el);
	
	letters = letters.substr(0, pos); 
	letters = letters.split(",");
	letters = letters[letters.length - 1].replace(/(^\s*)|(\s*$)/g, "");
	
	return letters;
}

function sbAutocompleteShowOptions(inputObj, actionSrc, e)
{
	if(actionSrc == "" || e.keyCode == 13 || e.keyCode == 9 || sbAutocompleteCurrentLetters[inputObj.name] == inputObj.value) 
		return;
    
    if(!sbAutocompleteCachedLists[actionSrc])
    	sbAutocompleteCachedLists[actionSrc] = new Array();
    
    sbAutocompleteCurrentLetters[inputObj.name] = inputObj.value;
        
    if(!sbAutocompleteDiv)
    {
    	sbAutocompleteDiv = document.createElement('DIV');
        sbAutocompleteDiv.id = 'sb_autocomplete_div';   
        document.body.appendChild(sbAutocompleteDiv);
	}
       
    var letter = sbAutocompleteGetPhrase(inputObj).toLowerCase();
    if(letter.length < 1)
    {
    	sbAutocompleteHide();
        return;
    }
    
    sbAutocompleteDiv.style.left = sbGetAbsoluteLeft(inputObj) + 'px';
    sbAutocompleteDiv.style.top = (sbGetAbsoluteTop(inputObj) + inputObj.offsetHeight) + 'px';
    
    sbAutocompleteActiveInput = inputObj;
    sbAutocompleteDiv.onselectstart =  sbCancelEvent;
    
    sbAutocompleteListIndex++;
        
    if(sbAutocompleteCachedLists[actionSrc][letter])
    {
    	sbAutocompleteBuildList(sbAutocompleteCachedLists[actionSrc][letter]);            
    }
    else
    {
        var tmpObj = new Object();
        tmpObj.index = sbAutocompleteListIndex;
        tmpObj.action = actionSrc;
        
        sbAutocompleteTimerParams.inputObj = inputObj;
        sbAutocompleteTimerParams.tmpObj = tmpObj;
        sbAutocompleteTimerParams.actionSrc = actionSrc;
        
        if (sbAutocompleteTimer) clearTimeout(sbAutocompleteTimer);
        
        sbAutocompleteTimer = setTimeout("sbAutocompleteLoadHelper()", 300);
    }
}

function sbAutocompleteLoadHelper()
{
	sbAutocompleteDiv.innerHTML = '<div class="img"><img src="<?php echo SB_CMS_IMG_URL ?>/loading.gif" width="16" height="16" /></div>';
	
	var letter = sbAutocompleteGetPhrase(sbAutocompleteTimerParams.inputObj);
    if(letter.length < 1)
    {
    	sbAutocompleteHide();
        return;
    }

	sbLoadAsync(sbAutocompleteTimerParams.actionSrc + '&letters=' + letter, new sbCallerFunction(sbAutocompleteLoad, sbAutocompleteTimerParams.inputObj, sbAutocompleteTimerParams.tmpObj));
}

function sbAutocompleteHide()
{
    if(sbAutocompleteDiv)
    {
    	sbAutocompleteDiv.style.display = "none";
    	sbAutocompleteActiveInput = false;
    }  
}
    
function sbAutocompleteLoad(inputObj, obj, res)
{
    if(!res || obj.index != sbAutocompleteListIndex)
    {
    	sbAutocompleteHide();
    	return;
    }
    
    var letter = sbAutocompleteGetPhrase(sbAutocompleteTimerParams.inputObj);
    var elements = res.split('|');
    sbAutocompleteCachedLists[obj.action][letter.toLowerCase()] = elements;
    sbAutocompleteBuildList(elements);
}
       
function sbAutocompleteBuildList(elements)
{
    sbAutocompleteDiv.innerHTML = '';
    sbAutocompleteActiveItem = false;
    sbAutocompleteFirstItem = false;
    
    if(elements.length == 0)
    {
    	sbAutocompleteHide();
        return;         
    }
        
    var optionsAdded = false;
        
    for(var i = 0; i < elements.length; i++)
    {
    	if(elements[i] == "")
    		continue;
            
        optionsAdded = true;
        var div = document.createElement('DIV');
        var options = elements[i].split(/###/gi);
            
        if(elements.length == 1 && sbAutocompleteActiveInput.value == options[0])
        {
        	sbAutocompleteHide();
            return;                     
        }
            
        div.innerHTML = '<table><tr><td>' + options[1] + '</td><td class="count">' + options[0] + '</td></tr></table>';
        div.className='option';
        div.onmouseover = function(){ sbAutocompleteOver(this, false) }
        div.onclick = sbAutocompleteClick;

        if(!sbAutocompleteFirstItem)
			sbAutocompleteFirstItem = div;
            
        sbAutocompleteDiv.appendChild(div);
    }   
        
    if(optionsAdded)
    {
        sbAutocompleteDiv.style.display = "block";
        sbAutocompleteOver(sbAutocompleteFirstItem, true);
    }
}

function sbAutocompleteOver(item, fromKeyBoard)
{
    if(sbAutocompleteActiveItem)
    	sbAutocompleteActiveItem.className='option';
    
    item.className='selOption';
    sbAutocompleteActiveItem = item;
        
    if(fromKeyBoard)
    {
        if(sbAutocompleteActiveItem.offsetTop > sbAutocompleteDiv.offsetHeight)
        {
            sbAutocompleteDiv.scrollTop = sbAutocompleteActiveItem.offsetTop - sbAutocompleteDiv.offsetHeight + sbAutocompleteActiveItem.offsetHeight + 2 ;
        }
        if(sbAutocompleteActiveItem.offsetTop < sbAutocompleteDiv.scrollTop)
        {
            sbAutocompleteActiveItem.scrollTop = 0;   
        }
    }
}       
     
function sbAutocompleteClick(e, inputObj)
{
    if(!inputObj)
    	inputObj=this;
    
    inputObj = inputObj.getElementsByTagName("TD");
    inputObj = inputObj[0];
    
    if(_isIE)
    	tmpValue = inputObj.innerText;
   	else 
   		tmpValue = inputObj.textContent;
   		
    if(!tmpValue)
    	tmpValue = inputObj.innerHTML;
 
 	var letters = new String(sbAutocompleteActiveInput.value);
	var pos = sbGetCaretPosition(sbAutocompleteActiveInput);
	
	var repl_letters = letters.substr(0, pos); 
	repl_letters = repl_letters.split(",");
	
	var other_letters = "";
	var delim_pos = letters.indexOf(",", pos);
	if (delim_pos != -1)
	{
		other_letters = letters.substr(delim_pos);
	}

	repl_letters[repl_letters.length - 1] = tmpValue;
	
	for (var i = 0; i < repl_letters.length; i++)
	{
		repl_letters[i] = repl_letters[i].replace(/(^\s*)|(\s*$)/g, "");
	}
	
    sbAutocompleteActiveInput.value = repl_letters.join(", ") + other_letters;
    sbAutocompleteHide();
    sbAutocompleteActiveInput.focus();
}
    
function sbAutocompleteResize(inputObj)
{
	sbAutocompleteHide();
}    

function sbAutocompleteKeyDown(e)
{
    if(!sbAutocompleteDiv || sbAutocompleteDiv.style.display == "none")
    	return;

    var e = window.event ? window.event : e;
        
    if(e.keyCode == 38)
    {
    	// Up
    	sbCancelEvent(e);
    	
        if(!sbAutocompleteActiveItem)
        	return false;
        
        if(sbAutocompleteActiveItem && !sbAutocompleteActiveItem.previousSibling)
        	return false;
            
        sbAutocompleteOver(sbAutocompleteActiveItem.previousSibling, true);
        
        return false;
    }
    else if(e.keyCode == 40)
    {  
    	// Down
        sbCancelEvent(e);
        
        if(!sbAutocompleteActiveItem)
        {
        	sbAutocompleteOver(sbAutocompleteFirstItem, true);
        }
        else
        {
            if(!sbAutocompleteActiveItem.nextSibling)
                return false;
                
            sbAutocompleteOver(sbAutocompleteActiveItem.nextSibling, true);
        }

        return false;
    }
    else if(e.keyCode == 13 || e.keyCode == 9)
    {  
    	// Enter или Tab
        if(sbAutocompleteActiveItem && sbAutocompleteActiveItem.className=='selOption')
        	sbAutocompleteClick(false, sbAutocompleteActiveItem);
        	
        if(e.keyCode == 13)
        {
        	sbCancelEvent(e);
        	return false;
        } 
        else 
            return true;
    }
    else if(e.keyCode == 27)
    {  
    	// Escape
        sbAutocompleteHide();
        sbCancelEvent(e);
        return false;
    }
}

var oldonkeydown=document.body.onkeydown;
if(typeof oldonkeydown != 'function')
{
	document.body.onkeydown = sbAutocompleteKeyDown;
}
else
{
    document.body.onkeydown=function()
    {
    	oldonkeydown();
        sbAutocompleteKeyDown();
    }
}
            
sbAddEvent(document, "click", sbAutocompleteHide);
sbResizeFuncs[sbResizeFuncs.length]=sbAutocompleteResize;
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>