<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
function sbCMenu(id, ovrColor, outColor, ovrClass, outClass, opacity)
{
    var r = RegExp;
    this.id = id;
    this.tree=null;
    if (opacity)
        this.opacity = opacity;
    else
        this.opacity = '100';

    this.itemHeight = 0;
	this.topIdent = 0;
	
    this.fade = new Array();
    outColor.match(/^(\d+)\#(..)(..)(..)$/);
    this.fade[0]=[r.$1,r.$2,r.$3,r.$4];
    this.bgColOut = r.$2+r.$3+r.$4;
    ovrColor.match(/^(\d+)\#(..)(..)(..)$/);
    this.fade[1]=[r.$1,r.$2,r.$3,r.$4];
    this.bgColOvr = r.$2+r.$3+r.$4;

    var col = '#';
    var oc,hexD='0123456789ABCDEF';
    for(var i=1;i<4;i++)
    {
        oc=parseInt('0x'+this.fade[0][i])-100;
        col+=hexD.charAt(Math.floor(oc/16)).toString()+hexD.charAt(oc%16);
    }
    this.delimeterColor = col;
    this.ovrClass = ovrClass;
    this.outClass = outClass;
    this.empty = true;
    this.items = [];
    this.hideFunc=null;
    this.showFunc=null;
    this.triggerEl=null;

    sbCMenu.list[id] = this;
}
sbCMenu.list = [];

var bcmpt = sbCMenu.prototype;
bcmpt.addItem=function(itemId, itemTitle, onClickEvent){with(this)
{
    itemId = 'cmi_' + id + itemId;
    items[itemId] = [];
    if (itemTitle)
        items[itemId]['title'] = itemTitle;
    else
        items[itemId]['title'] = '';
    items[itemId]['onClickEvent'] = onClickEvent;
    items[itemId]['timer'] = 0;
    items[itemId]['visible'] = true;
    empty = false;
}};

bcmpt.removeItem=function(itemId){with(this)
{
    itemId = 'cmi_' + id + itemId;
    if (!sbGetE(itemId))
        return;

    var tmpItems = [];
    var count = 0;
    for (idx in items)
    {
        if (idx != itemId)
        {
            tmpItems[idx] = items[idx];
            count++;
        }
    }
    items = tmpItems;

    if (count == 0)
        empty = true;
}};

bcmpt.changeCol=function(itemId, count, ovr){with(this)
{
    if(fade[0][0])
    {
        clearTimeout(items[itemId]['timer']);
        var col = '#';
        count = Math.max(0, Math.min(count+(2*ovr-1)*parseInt(fade[ovr][0]),100));
        var oc,nc,hexD='0123456789ABCDEF';
        for(var i=1;i<4;i++)
        {
            oc=parseInt('0x'+fade[0][i]);
            nc=parseInt(oc+(parseInt('0x'+fade[1][i])-oc)*(count/100));
            col+=hexD.charAt(Math.floor(nc/16)).toString()+hexD.charAt(nc%16);
        }
        var el = sbGetE(itemId);
        el.childNodes[1].style.backgroundColor = col;
        if(count%100 != 0)
            this.items[el.id]['timer'] = setTimeout(id+'.changeCol("'+itemId+'",'+count+','+ovr+')', 50);
    }
    else
    {
        var el = sbGetE(itemId).childNodes[1];
        if (ovr == 1)
            el.style.backgroundColor = bgColOvr;
        else
            el.style.backgroundColor = bgColOut;
    }
}};

bcmpt.itemOver=function(){with(this)
{
    var tr = this.parentNode;
    if (tr.parentObject.ovrClass)
        className = tr.parentObject.ovrClass;

    tr.parentObject.changeCol(tr.id, 0, 1);
}};

bcmpt.itemOut=function(){with(this)
{
    var tr = this.parentNode;
    if (tr.parentObject.outClass)
        className = tr.parentObject.outClass;

    tr.parentObject.changeCol(tr.id, 100, 0);
}};

bcmpt.itemClick=function(){with(this)
{
    var tr = this.parentNode;
    tr.parentObject.hide();
    if(typeof(tr.parentObject.items[tr.id]['onClickEvent'])=="function")
    {
        tr.parentObject.items[tr.id]['onClickEvent']();
    }
    else
    {
        eval(tr.parentObject.items[tr.id]['onClickEvent']);
    }
}};

bcmpt.init=function(){with(this)
{
    var menuDiv = sbGetE('cm_' + id);
    if (menuDiv)
        return;

    if (!empty)
    {
        var mDiv = document.createElement("DIV");
        mDiv.id="cm_"+id;
        mDiv.className="cmenuDiv";
        mDiv.style.MozOpacity = opacity/100;
        mDiv.style.visibility="hidden";
        mDiv.style.zIndex=400;
        mDiv.style.left=0;
        mDiv.style.top=0;
        mDiv.style.position="absolute";
        
        if (_isIE)
        {
            var mFrame=document.createElement("IFRAME");
            mFrame.id="cm_"+id+"_iframe";
            mFrame.scrolling="no";
            mFrame.border="0";
            mFrame.frameBorder="0";
            mFrame.style.filter = 'alpha(opacity=0)';
            mFrame.style.zIndex=300;
            mFrame.style.position="absolute";
            mFrame.style.left=0;
            mFrame.style.top=0;

            mDiv.appendChild(mFrame);
        }

        var mTable = document.createElement("TABLE");
        mTable.id="cm_"+id+"_table";
        mTable.bgColor=bgColOut;
        mTable.cellPadding=0;
        mTable.cellSpacing=0;
        mTable.border=0;
        mTable.className="cmenuTable";
        mTable.style.zIndex=500;
        mTable.style.position="absolute";
        mTable.style.filter = 'alpha(opacity='+opacity+')';
        
        var tbody=document.createElement('tbody');

        for (menuId in items)
        {
            var tr=document.createElement("TR");
            tr.id=menuId;

            if (items[menuId]['title'] == '')
            {
                tr.style.cursor="default";
                tr.onclick=sbCancelEvent;

                var td=document.createElement("TD");
                td.className = "cmenuHrTD";
                
                var hr=document.createElement("HR");
                hr.size=1;
                if (_isOpera) 
                {
                	hr.noShade=1;
                	hr.style.marginTop = "7px";
                	hr.style.marginBottom = "7px";
                }
                hr.color=delimeterColor;

                td.appendChild(hr);
            }
            else
            {
                tr.className=outClass;
                tr.parentObject=this;

                var td=document.createElement("TD");
                td.className=outClass;
                td.style.paddingLeft="10px";
                td.style.paddingRight="10px";
                td.style.paddingTop="5px";
                td.style.paddingBottom="5px";
                td.vAlign="top";
                td.style.whiteSpace="nowrap";
                td.style.cursor=(_isIE?"hand":"pointer");
                td.innerHTML=items[menuId]['title'];

                td.onmouseover=itemOver;
                td.onmouseout=itemOut;
                td.onclick=itemClick;
            }

            var td1 = document.createElement("TD");
            td1.className = "cmenuPaddingTD";

            tr.appendChild(td1);
            tr.appendChild(td);
            tbody.appendChild(tr);
        }

        mTable.appendChild(tbody);
        mDiv.appendChild(mTable);
        document.body.appendChild(mDiv);
        _setSizes();
    }
}};

bcmpt._setSizes=function(){with(this)
{
    var mDiv = sbGetE('cm_' + id);
    var mTable = sbGetE('cm_'+id+"_table");

    mDiv.style.height = mTable.offsetHeight+(_isIE?6:0);
    mDiv.style.width = mTable.offsetWidth+(_isIE?6:0);

    if (_isIE)
    {
        var mFrame = sbGetE('cm_' + id + "_iframe");
        mFrame.style.height = mTable.offsetHeight + 4;
        mFrame.style.width = mTable.offsetWidth + 4;
    }
}};

bcmpt.hideItem=function(itemId){with(this)
{
    itemId = 'cmi_' + id + itemId;
    var el = sbGetE(itemId);
    if (!el)
        return;
    if (el.style.display != 'none')
    {
        el.style.display = 'none';
        items[itemId]['visible'] = false;

        _setSizes();
    }
}};

bcmpt.showItem=function(itemId){with(this)
{
    itemId = 'cmi_' + id + itemId;
    var el = sbGetE(itemId);
    if (!el)
        return false;
    if (el.style.display != '')
    {
        el.style.display = '';
        items[itemId]['visible'] = true;

        _setSizes();
    }
    return true;
}};

bcmpt.isShowedItem=function(itemId){with(this)
{
    itemId = 'cmi_' + id + itemId;
    var el = sbGetE(itemId);
    if (!el)
        return false;
    if (el.style.display != '')
        return false;

    return true;
}};

bcmpt.show=function(myEvent){with(this)
{
    for (cMenu in sbCMenu.list)
        sbCMenu.list[cMenu].hide();

    if (typeof(showFunc) == "function")
    {
        if (!showFunc())
        {
            if (typeof(hideFunc)=="function") hideFunc();
            return;
        }
    }

    var found = false;
    for (var itemId in items)
    {
        if (items[itemId]['visible'])
        {
            found = true;
            break;
        }
    }
    if (!found)
    {
        if (typeof(hideFunc)=="function") hideFunc();
        return;
    }

    var menuDiv = sbGetE('cm_' + id);
    if (!menuDiv)
    {
        if (typeof(hideFunc)=="function") hideFunc();
        return;
    }

    var w = parseInt(menuDiv.style.width);
    var h = parseInt(menuDiv.style.height);

    menuDiv.style.left = Math.min(myEvent.clientX + document.body.scrollLeft + 1, document.body.scrollLeft + document.body.clientWidth - w);
    var menuTop = myEvent.clientY + topIdent;
    if (menuTop + h > document.body.clientHeight)
        menuTop = document.body.clientHeight - h;
    menuDiv.style.top = menuTop + document.body.scrollTop + 1;
    menuDiv.style.visibility = 'visible';
    
    sbCancelEvent(myEvent);
   
    return;
}};

bcmpt.hide=function(){with(this)
{
    var menuDiv = sbGetE("cm_" + id);
    if (menuDiv&&menuDiv.style.visibility!="hidden")
    {
        menuDiv.style.visibility = "hidden";
        menuDiv.style.top = 0;
        menuDiv.style.left = 0;
        if (typeof(hideFunc)=="function") hideFunc();
    }
}};

function sbInitCMenu()
{
    for (cMenu in sbCMenu.list)
        sbCMenu.list[cMenu].init();
}

function sbHideCMenu()
{
    for (cMenu in sbCMenu.list)
        sbCMenu.list[cMenu].hide();
}

sbAddEvent(window, 'scroll', sbHideCMenu);
sbAddEvent(window, 'resize', sbHideCMenu);
sbAddEvent(document, 'click', sbHideCMenu);
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>