<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
var sbCatTree=null; // дерево разделов

function sbCategsClick(cat_id)
{
    sbCatTree.active=false;

    try
    {
        var evt = sbCatTree.getUserData(cat_id, "evt");
        if (evt)
        {
            sbElemsShow(sb_cms_empty_file + "?event=" + evt + "&cat_id="+cat_id);
        }
        else
        {
            sbCatTree.active=true;
        }
    }
    catch(e)
    {
        sbCatTree.active=true;
    }
    
    sbSetCookie("sb_custom_categs_"+sb_categs_ident , sbCatTree.getSelectedItemId());
}

function sbCategsAfterLoad()
{
    sbHideMsgDiv();

    sbCatTree.openItem(sbCatTree.getParentId(sb_categs_selected_id));
    sbCatTree.selectItem(sb_categs_selected_id, true);
    
    var elems_table = sbGetE("elems_list_table");
    if (elems_table)
    {
        var c_list = sbGetE("categs_list");
        var c_list_td = sbGetE("categs_list_td");

        c_list.style.width = panel_width;
        c_list_td.style.width = panel_width;
        sbCatTree.allTree.style.width = panel_width;

        if (typeof(sbResizeEldiv) == "function")
            sbResizeEldiv();

        var e_header = sbGetE("elems_list_header");
        if (e_header) e_header.style.visibility = "visible";

        elems_table.style.visibility = "visible";

        var e_footer = sbGetE("elems_list_footer");
        if (e_footer) e_footer.style.visibility = "visible";
    }

    if (typeof(sbCategsLoad) == "function")
        sbCategsLoad();
}

var sbCatDelDrag = false;
function sbCategsDragDel(e, start)
{
    if (e.button == 2)
        return;

    var ddiv = sbGetE("categs_drag_div");
    var c_list = sbGetE("categs_list");
    var e_list_header = sbGetE("elems_list_header");
    var list_header = sbGetE("list_header");

    if (ddiv && start)
    {
        sbCatDelDrag = true;
        ddiv.style.left = e.clientX - 2;
        ddiv.style.top = (e_list_header ? e_list_header.offsetHeight : 0) + (list_header ? list_header.offsetHeight : 0);
        ddiv.style.height = c_list.offsetHeight;
        ddiv.style.display = 'block';
        sbAddEvent(document, "mouseup", sbCategsDragDel);
        sbAddEvent(document, "selectstart", sbCancelEvent);
        
        return sbCancelEvent(e);
    }
    else if (sbCatDelDrag)
    {
        sbRemoveEvent(document, "mouseup", sbCategsDragDel);
        sbRemoveEvent(document, "selectstart", sbCancelEvent);
        sbCatDelDrag = false;
        ddiv.style.display = 'none';
        panel_width = Math.max(document.body.clientWidth - e.clientX, 0);
        sbSetCookie("sb_panel_width", panel_width, 0, '/', '');

        var c_list_td = sbGetE("categs_list_td");
        c_list.style.width = panel_width;
        c_list_td.style.width = panel_width;
        sbCatTree.allTree.style.width = panel_width-5;

        _sbCallResize();
    }
}

function sbCategsMouseMove(e)
{
    if (sbCatDelDrag)
    {
        var ddiv = sbGetE("categs_drag_div");
        ddiv.style.left = e.clientX - 2;
    }
}

sbAddEvent(document, 'mousemove', sbCategsMouseMove);
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>