<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
function sbDragAndDrop()
{
	this.lastRealLanding=0;
    this.lastLanding=0;
    this.dragNode=0;
    this.dragStartNode=0;
    this.dragStartObject=0;
    this.tempUpEvent=null;
    this.tempMoveEvent=null;
    this.tempOverEvent=new Array();
    this.waitDrag=0;
    
    window.sbDAD=this;

    return this;
};
 
sbDragAndDrop.prototype.removeDraggableItem=function(htmlNode)
{
    htmlNode.onmousedown=null;
    htmlNode.dragStarter=null;
    htmlNode.dragLanding=null;
}
 
sbDragAndDrop.prototype.addDraggableItem=function(htmlNode,dhtmlObject)
{
    htmlNode.onmousedown=this.preCreateDragCopy;
    htmlNode.dragStarter=dhtmlObject;
 
    this.addDragLanding(htmlNode,dhtmlObject);
}

sbDragAndDrop.prototype.addDragLanding=function(htmlNode,dhtmlObject)
{
    htmlNode.dragLanding=dhtmlObject;
}
 
sbDragAndDrop.prototype.preCreateDragCopy=function(e)
{
    if (!e) e = window.event;
    if (e.button == 2) return true;

    if(window.sbDAD.waitDrag)
    {
        window.sbDAD.waitDrag=0;
        document.body.onmouseup=window.sbDAD.tempUpEvent;
        document.body.onmousemove=window.sbDAD.tempMoveEvent;
 
        return false;
    }

	if (typeof(this.dragStarter._preventDrag) == "function")
	{
		if (this.dragStarter._preventDrag())
			return true;
	}
	
    window.sbDAD.waitDrag=1;
    window.sbDAD.tempUpEvent=document.body.onmouseup;
    window.sbDAD.tempMoveEvent=document.body.onmousemove;
    
    window.sbDAD.dragStartNode=this;
    window.sbDAD.dragStartObject=this.dragStarter;
 
    document.body.onmouseup=window.sbDAD.preCreateDragCopy;
    document.body.onmousemove=window.sbDAD.callDrag;
    if (window.parent.frames && _isFF)
    {
        var frms = window.parent.frames;
        for(var i=0; i < frms.length; i++)
        {
            if(frms[i] != window)
            {
                window.sbDAD.tempOverEvent[window.sbDAD.tempOverEvent.length-1] = window.parent.frames[i].onmouseover;
                frms[i].onmouseover = window.sbDAD.stopDrag;
            }
        }
    }
        
    if((e)&&(e.preventDefault))
    {
        e.preventDefault();
        return false;
    }

    return false;
};

sbDragAndDrop.prototype.callDrag=function(e)
{
    if(!e) e=window.event;

    dragger=window.sbDAD;
    if(e.button == 0 && _isIE)
    {
    	dragger.stopDrag();
    	return true;
    }
    
    if (typeof(window.sbDAD.dragStartObject._preventDrag) == "function")
	{
		if (window.sbDAD.dragStartObject._preventDrag())
		{
			dragger.stopDrag();
			return true;
		}
	}
	
    if(!dragger.dragNode)
    {
        dragger.dragNode=dragger.dragStartObject._createDragNode(dragger.dragStartNode,e);
        if(!dragger.dragNode)
        {
        	dragger.stopDrag();
        	return true;
        }
 
 		dragger.dragNode.style.position="absolute";
        dragger.gldragNode=dragger.dragNode;
        document.body.appendChild(dragger.dragNode);
        document.body.onmouseup=dragger.stopDrag;
 
        dragger.waitDrag=0;
        dragger.dragNode.pWindow=window;
    }

    if(dragger.dragNode.parentNode!=window.document.body)
    {
        var grd=dragger.gldragNode;
        if(dragger.gldragNode.old) grd=dragger.gldragNode.old;

        grd.parentNode.removeChild(grd);
        var oldBody=dragger.dragNode.pWindow;
        if(_isIE)
        {
            var div=document.createElement("DIV");
            div.innerHTML=dragger.dragNode.outerHTML;
            dragger.dragNode=div.childNodes[0];
        }
        else 
        {
            dragger.dragNode=dragger.dragNode.cloneNode(true);
        }
           
        dragger.dragNode.pWindow=window;
        dragger.gldragNode.old=dragger.dragNode;
        document.body.appendChild(dragger.dragNode);
        dragger.dragNode.style.position="absolute";
        oldBody.sbDAD.dragNode=dragger.dragNode;
    }

	if (_isIE)
    {
    	document.body.onselectstart=function(){return false};
    }
    
	var docTop = document.documentElement.scrollTop > document.body.scrollTop ? document.documentElement : document.body;
	var docLeft = document.documentElement.scrollLeft > document.body.scrollLeft ? document.documentElement : document.body;
	
    dragger.dragNode.style.left=e.clientX+15+(dragger.fx?dragger.fx*(-1):0)+docLeft.scrollLeft+"px";
    dragger.dragNode.style.top=e.clientY+(dragger.fy?dragger.fy*(-1):0)+docTop.scrollTop+"px";

    var z=sbEventTarget(e);

	dragger.checkLanding(z, z, e.clientX, e.clientY);
};
 
sbDragAndDrop.prototype.checkLanding=function(htmlObject,htmlRealObject,x,y)
{
    if((htmlObject)&&(htmlObject.dragLanding))
    {
        if(this.lastLanding && this.lastLanding != htmlObject)
        {
            this.lastLanding.dragLanding._dragOut(this.lastLanding);
        }
        
        if (this.lastRealLanding && this.lastRealLanding != htmlRealObject)
        {
            this.lastLanding=htmlObject;
            this.lastRealLanding=htmlRealObject;
            this.lastLanding=this.lastLanding.dragLanding._dragIn(this.lastLanding,this.dragStartNode,this.lastRealLanding,x,y);
        }
        else if (!this.lastRealLanding)
        {
            this.lastLanding=htmlObject;
            this.lastRealLanding=htmlRealObject;
            this.lastLanding=this.lastLanding.dragLanding._dragIn(this.lastLanding,this.dragStartNode,this.lastRealLanding,x,y);
        }
    }
    else
    {
        if((htmlObject)&&(htmlObject.tagName!="BODY"))
            this.checkLanding(htmlObject.parentNode, htmlRealObject,x, y);
        else
        {
            if(this.lastLanding)
                this.lastLanding.dragLanding._dragOut(this.lastLanding,x,y);
            this.lastLanding=0;
            this.lastRealLanding=0;
        }
    }
}
 
sbDragAndDrop.prototype.stopDrag=function(e)
{
    var dragger=window.sbDAD;
    if (_isIE)
    {
    	document.body.onselectstart=function(){return true};
    }
    	
    if(dragger.lastLanding)
    {
        dragger.lastLanding.dragLanding._drag(dragger.dragStartNode,dragger.dragStartObject,dragger.lastLanding,dragger.lastRealLanding);
    }
 
    dragger.lastLanding=0;
    dragger.lastRealLanding=0;
    
    if((dragger.dragNode)&&(dragger.dragNode.parentNode==document.body))
        dragger.dragNode.parentNode.removeChild(dragger.dragNode);
 
    dragger.dragNode=0;
    dragger.gldragNode=0;
    dragger.fx=0;
    dragger.fy=0;
    dragger.dragStartNode=0;
    dragger.dragStartObject=0;
    document.body.onmouseup=dragger.tempUpEvent;
    document.body.onmousemove=dragger.tempMoveEvent;
    dragger.tempUpEvent=null;
    dragger.tempMoveEvent=null;
    if (window.parent.frames && _isFF)
    {
        var frms = window.parent.frames;
        for(var i=0; i < frms.length; i++)
        {
            if(frms[i] != window)
            {
                frms[i].onmouseover = window.sbDAD.tempOverEvent.shift();
            }
        }
    }
    dragger.waitDrag=0;
}
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>