<?php require_once(dirname(__FILE__).'/jheader.inc.php');?>
var sbFoldersTree=null; // дерево папок
var sbSelFolder = 0; // папка, для которой вызвано контекстное меню
var sbCopyCutFolder = 0; // папка, из которой были скопированы элементы

if (typeof(sbFoldersMenu) == "undefined")
    var sbFoldersMenu=null; // контекстное меню папок
if (typeof(sbFoldersClick) == "undefined")
    var sbFoldersClick=null; // функция, вызываемая при клике на папку

var sbCopiedFiles = new Array(); // скопированные файлы
var sbCuttedFiles = new Array(); // вырезанные файлы
var sbSelectedFiles = new Array(); // выделенные файлы

function sbFoldersPreloadImages()
{
    var imSrcAr = new Array("folderClosed.gif","folderClosedCopy.gif","folderClosedCut.gif","folderOpen.gif","folderOpenCopy.gif","folderOpenCut.gif","line1.gif","line2.gif","line3.gif","line4.gif","minus.gif","minus2.gif","minus3.gif","minus4.gif","minus5.gif","plus.gif","plus2.gif","plus3.gif","plus4.gif","plus5.gif");
	var imAr = new Array(0);
	for(var i=0; i < imSrcAr.length; i++)
	{
	    imAr[imAr.length] = new Image();
        imAr[imAr.length-1].src = sb_cms_img_url+"/tree/"+imSrcAr[i];
    }
}

/**
 * Функция, вызываемая после загрузки дерева папок
 */
function sbFoldersAfterLoad()
{
    sbFoldersPreloadImages();

    sbHideMsgDiv();

    var item = sbFoldersTree.getParentId(sb_folders_selected_path);
    if (!item)
    {
        if (typeof(sbFoldersTree._gis[1]) != 'undefined')
        {
            sbFoldersTree.selectItem(sbFoldersTree._gis[1], true);
        }
    }
    else
    {
        sbFoldersTree.openItem(item);
        sbFoldersTree.selectItem(sb_folders_selected_path, true);
    }
    
    if (sbFoldersMenu)
        sbFoldersMenu.init();

    var files_table = sbGetE("files_list_table");
    if (files_table)
    {
        var f_list = sbGetE("sb_folders_list");
        var f_list_td = sbGetE("sb_folders_list_td");

        f_list.style.width = panel_width;
        f_list_td.style.width = panel_width;
        sbFoldersTree.allTree.style.width = panel_width;

        if (typeof(sbResizeFldiv) == "function")
            sbResizeFldiv();

        var f_header = sbGetE("files_list_header");
        if (f_header) f_header.style.visibility = "visible";

        files_table.style.visibility = "visible";

        var f_footer = sbGetE("files_list_footer");
        if (f_footer) f_footer.style.visibility = "visible";
    }
}

var sbFoldDelDrag = false;
function sbFoldersDragDel(e, start)
{
    if (e.button == 2)
        return;

    var ddiv = sbGetE("sb_folders_drag_div");
    var f_list = sbGetE("sb_folders_list");
    var f_list_header = sbGetE("sb_folders_list_header");

    if (ddiv && start)
    {
        sbFoldDelDrag = true;
        ddiv.style.left = e.clientX - 2;
        ddiv.style.top = (f_list_header ? f_list_header.offsetHeight:0)+1;
        ddiv.style.height = f_list.offsetHeight-1;
        ddiv.style.display = 'block';
        sbAddEvent(document, "mouseup", sbFoldersDragDel);
        return sbCancelEvent(e);
    }
    else if (sbFoldDelDrag)
    {
        sbRemoveEvent(document, "mouseup", sbFoldersDragDel);
        sbFoldDelDrag = false;
        ddiv.style.display = 'none';
        panel_width = Math.max(document.body.clientWidth - e.clientX, 0);
        sbSetCookie("sb_panel_width", panel_width, 0, '/', '');

        var f_list_td = sbGetE("sb_folders_list_td");
        f_list.style.width = panel_width;
        f_list_td.style.width = panel_width;
        sbFoldersTree.allTree.style.width = panel_width-5;

        if (typeof(sbResizeFldiv) == "function")
            sbResizeFldiv();
    }
}

function sbFoldersMouseMove(e)
{
    if (sbFoldDelDrag)
    {
        var ddiv = sbGetE("sb_folders_drag_div");
        ddiv.style.left = e.clientX - 2;
    }
}

function sbFoldersShowMenu()
{
    if (!sbFoldersMenu || !sbFoldersTree)
        return false;

    sbSelFolder = sbFoldersTree.lastMenuSelected;
    var foldId = sbSelFolder.id;
    var level = sbFoldersTree.getLevel(foldId);

    if (foldId == sbCopyCutFolder || (sbCuttedFiles.length == 0 && sbCopiedFiles.length == 0))
        sbFoldersMenu.hideItem("paste");
    else
        sbFoldersMenu.showItem("paste");

    if ((!sbFoldersTree.nodeCopy && !sbFoldersTree.nodeCut) || (sbFoldersTree.nodeCopy && foldId == sbFoldersTree.nodeCopy.id) || (sbFoldersTree.nodeCut && foldId == sbFoldersTree.nodeCut.id))
        sbFoldersMenu.hideItem("paste_folders");
    else
    {
        if (sbFoldersTree.nodeCut)
        {
            if(sbFoldersTree._checkParentNodes(sbFoldersTree.nodeCut.id, sbSelFolder) || (sbFoldersTree.nodeCut.parentObject && sbSelFolder.id == sbFoldersTree.nodeCut.parentObject.id))
                sbFoldersMenu.hideItem("paste_folders");
            else
                sbFoldersMenu.showItem("paste_folders");
        }
        else
        {
            if(sbFoldersTree._checkParentNodes(sbFoldersTree.nodeCopy.id, sbSelFolder) || (sbFoldersTree.nodeCopy.parentObject && sbSelFolder.id == sbFoldersTree.nodeCopy.parentObject.id))
                sbFoldersMenu.hideItem("paste_folders");
            else
                sbFoldersMenu.showItem("paste_folders");
        }
    }

    if (level == 1)
    {
        sbFoldersMenu.hideItem("copy");
        sbFoldersMenu.hideItem("cut");
        sbFoldersMenu.hideItem("rename");
        sbFoldersMenu.hideItem("delete");
        for (var i=0;i < sb_folders_add_menu.length;i++)
        {
            if (sb_folders_add_menu[i]['hide'])
            {
                sbFoldersMenu.hideItem("additional_"+i);
            }
            else
            {
                sbFoldersMenu.showItem("additional_"+i);
            }
        }
    }
    else
    {
        sbFoldersMenu.showItem("copy");
        sbFoldersMenu.showItem("cut");
        sbFoldersMenu.showItem("rename");
        sbFoldersMenu.showItem("delete");
        for (var i=0; i < sb_folders_add_menu.length; i++)
        {
            sbFoldersMenu.showItem("additional_"+i);
        }
    }

    var pasteShowed = (sbFoldersMenu.isShowedItem("paste"));
    var foldersPasteShowed = (sbFoldersMenu.isShowedItem("copy") || sbFoldersMenu.isShowedItem("cut") || sbFoldersMenu.isShowedItem("paste_folders"));
    var mainShowed = (sbFoldersMenu.isShowedItem("refresh") || sbFoldersMenu.isShowedItem("add") || sbFoldersMenu.isShowedItem("edit") || sbFoldersMenu.isShowedItem("delete") || sbFoldersMenu.isShowedItem("upload"));
    var rightsShowed = sbFoldersMenu.isShowedItem("rights");

    if (pasteShowed && (foldersPasteShowed || mainShowed || rightsShowed))
        sbFoldersMenu.showItem("paste_delimeter");
    else
        sbFoldersMenu.hideItem("paste_delimeter");

    if (foldersPasteShowed && (mainShowed || rightsShowed))
        sbFoldersMenu.showItem("paste_folders_delimeter");
    else
        sbFoldersMenu.hideItem("paste_folders_delimeter");

    if (mainShowed && rightsShowed)
        sbFoldersMenu.showItem("delimeter");
    else
        sbFoldersMenu.hideItem("delimeter");

    return true;
};

function sbFoldersAdd()
{
    if (!sbSelFolder)
        return;

    var path = sbSelFolder.id;

    strPage = sb_cms_modal_dialog_file+"?event=pl_folders_add_folder&par_path="+encodeURI(path);
    strAttr = "resizable=1,width=600,height=450";
    sbShowModalDialog(strPage, strAttr, sbFoldersAfterAdd);
}

function sbFoldersAfterAdd()
{
    if (!sbModalDialog.returnValue || !sbSelFolder)
    {
        sbSelFolder = 0;
        return;
    }

    var folds = sbModalDialog.returnValue.split('/');
    var path = "";
    var parId = sbSelFolder.id;
    var parObj = sbSelFolder;
        
    for (var i = 0; i < folds.length; i++)
    {
        path = path + "/" + folds[i];
        var itemId = (sbSelFolder.id != "/" ? sbSelFolder.id : "")+path;
        if (sbFoldersTree._gisf(itemId))
        {
            parId = itemId;
            parObj = sbFoldersTree._gisf(itemId);
            continue;
        }

        if (!parObj.XMLload)
        {
            setTimeout("sbFoldersTree.openItem('"+parId+"');", 0);
            break;
        }
        
        var obj = sbFoldersTree.insertNewChild(parId, itemId, folds[i], false, "", false);
        if (obj)
        {
            if (sbFoldersTree.nodeCopy && sbFoldersTree._checkParentNodes(sbFoldersTree.nodeCopy.id, sbSelFolder) && sbFoldersTree.getLevel(obj.id) > sbFoldersTree.getLevel(sbFoldersTree.nodeCopy.id))
            {
                sbFoldersTree._changeSubImages(obj, "copy", true);
            }
        }
        
        parId = itemId;
    }

    sbSelFolder = 0;
}

function sbFoldersRename()
{
    if (!sbSelFolder)
        return;

    var path = sbSelFolder.id;
    var level = sbFoldersTree.getLevel(path);

    if (level == 1)
        return;

    strPage = sb_cms_modal_dialog_file+"?event=pl_folders_add_folder&path="+encodeURI(path);
    strAttr = "resizable=1,width=600,height=450";
    sbShowModalDialog(strPage, strAttr, sbFoldersAfterRename);
}

function sbFoldersAfterRename()
{
    if (!sbModalDialog.returnValue || !sbSelFolder)
    {
        sbSelFolder = 0;
        return;
    }

    var itemId = sbSelFolder.id;

    if (sbModalDialog.returnValue.title != '')
    {
        sbFoldersTree.setItemText(itemId, sbModalDialog.returnValue.title, "");
        sbFoldersTree.setItemId(itemId, sbModalDialog.returnValue.id);
    }

    sbSelFolder = 0;
}

function sbFoldersDelete()
{
    if (!sbSelFolder)
        return;

    var itemId = sbSelFolder.id;
    var level = sbFoldersTree.getLevel(itemId);

    if (level == 1)
    {
        sbSelFolder = 0;
        return;
    }

    if (confirm("<?php echo FOLDERS_CONFIRM_DELETE_MSG; ?>"))
    {
        res = sbLoadSync(sb_cms_empty_file + "?event=pl_folders_delete_folder&path=" + encodeURI(itemId));
        if (res == "TRUE")
            sbFoldersTree.deleteItem(sbSelFolder.id, true);
        else
            sbShowMsgDiv("<?php echo FOLDERS_DELETE_ERROR; ?>");
    }

    sbSelFolder = 0;
}

function sbFoldersRefresh()
{
    if (!sbSelFolder)
        return;

    sbFoldersTree.XMLLoadDopStr = "&folds_autoloading="+sb_folders_autoloading+"&folds_never_show="+encodeURI(sb_folders_never_show)+"&folds_only_show="+encodeURI(sb_folders_only_show)+"&folds_selected_path="+encodeURI(sbFoldersTree.getSelectedItemId());
    sbFoldersTree.refreshItem(sbSelFolder.id);
    sbFoldersTree.XMLLoadDopStr = "";

    sbSelFolder = 0;
}

function sbFoldersCopy()
{
    if (!sbSelFolder)
        return;

    sbFoldersTree.doCopy(sbSelFolder.id);

    sbSelFolder = 0;
}

function sbFoldersCut()
{
    if (!sbSelFolder)
        return;

    sbFoldersTree.doCut(sbSelFolder.id);

    sbSelFolder = 0;
}

function sbFoldersPaste(sId, tId, bId)
{
    if (!sbSelFolder&&!sId)
    {
        sbSelFolder = 0;
        return false;
    }

    var itemId = (sbSelFolder?sbSelFolder.id:tId);
    if (!sId)
    {
        if (sbFoldersTree.nodeCopy)
        {
            var pasteFolderId = sbFoldersTree.nodeCopy.id;
            var action = "copy";
        }
        else if (sbFoldersTree.nodeCut)
        {
            var pasteFolderId = sbFoldersTree.nodeCut.id;
            var action = "cut";
        }
        else
            var pasteFolderId = '';
    }
    else
    {
        pasteFolderId = sId;
        action = "cut";
    }

    if (pasteFolderId == '')
    {
        sbSelFolder = 0;
        return false;
    }

    if(action == 'cut' && sb_folders_need_conf==1 && !confirm('<?php echo FOLDERS_CUT_CONFIRM_MSG; ?>'))
    {
        pasteFolderId = '';
        sbSelFolder = 0;
        return false;
    }
    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_folders_paste_folder&path=" + encodeURI(itemId) + "&paste_path=" + encodeURI(pasteFolderId) + "&action=" + action);

    if (res != "TRUE")
    {
        sbShowMsgDiv(res);
        sbSelFolder = 0;
        return false;
    }

    if (typeof(sbClearFiles) != "undefined")
        sbClearFiles();
    
    if (action == "copy")
    {
        sbFoldersRefresh();
    }
    else
    {
        if (sbFoldersTree.nodeCut && !sId)
        {
            sbFoldersTree.doPaste(itemId);
        }

        sbFoldersRefreshIds(sbFoldersTree._gisf(pasteFolderId), itemId);
    }
    sbSelFolder = 0;
    return true;
}

function sbFoldersRefreshIds(el, to_path)
{
    if (!el)
        return;

    if (to_path == "/")
        to_path = "";

    var fold = sbFoldersTree.getItemText(el.id);

    sbFoldersTree.setItemId(el.id, to_path+"/"+fold);
    for (var i = 0; i < el.childNodes.length; i++)
    {
        sbFoldersRefreshIds(el.childNodes[i], el.id);
    }
}

function sbFoldersPasteFiles()
{
    var new_path = (sbSelFolder ? sbSelFolder.id : sbFoldersTree.getSelectedItemId());
    var old_path = sbCopyCutFolder;

    sbSelFolder = 0;

    var sRequest = sb_cms_empty_file + '?event=pl_folders_paste_files&new_path=' + encodeURI(new_path) + '&old_path=' + encodeURI(old_path);
    var cutAction = false;

    var ar = (sbCuttedFiles.length != 0 ? sbCuttedFiles : (sbCopiedFiles.length != 0 ? sbCopiedFiles : false));
    if (!ar)
        return;

    if (sbCuttedFiles.length != 0)
    {
        sRequest += "&action=cut";
        cutAction = true;
    }
    else if (sbCopiedFiles.length != 0)
    {
        sRequest += "&action=copy";
    }

    for (var i = 0; i < ar.length; i++)
    {
        sRequest += "&file_" + i + "="+encodeURI(ar[i].el_id);
    }

    if(cutAction && sb_folders_need_conf==1 && !confirm('<?php echo FOLDERS_CUT_CONFIRM_MSG; ?>'))
    {
        sbFolderReload();
        return false;
    }
    var numEls = sbLoadSync(sRequest);
    if (numEls != ar.length)
    {
        sbShowMsgDiv("<?php echo FILES_PASTE_ERROR; ?>");
        setTimeout(sbFolderReload,5000);
    }
    else
    {
        sbFolderReload();
    }
    
    function sbFolderReload()
    {
        var div_el = sbGetE("files_list_div");
        var from = "";
        if (div_el)
        {
            from = div_el.getAttribute("from");
        }

        sbCuttedFiles.splice(0, sbCuttedFiles.length);
        if (typeof(sbFilesShow) == "function" && (cutAction && (new_path == sbFoldersTree.getSelectedItemId() || old_path == sbFoldersTree.getSelectedItemId())) || new_path == sbFoldersTree.getSelectedItemId())
        {
            sbFilesShow(sb_cms_empty_file + "?event=pl_filelist_read&path="+sbFoldersTree.getSelectedItemId()+"&files_from="+from+"&files_exts="+sb_files_extensions + "&files_selected_file=" + sb_files_selected_file + "&files_link_title=" + sb_files_link_title);
        }
    }
}



function sbFoldersUploadFiles()
{
    var path = sbSelFolder ? sbSelFolder.id : sbFoldersTree.getSelectedItemId();
    var url = window.location.href;
    var fld_id = url.replace(/.+fld_id=([^&]+).*/, '$1');
    
    strPage = sb_cms_modal_dialog_file+"?event=pl_folders_upload_files&path="+encodeURI(path);
    if(fld_id != url)
    {
        strPage += "&fld_id="+fld_id;
    }
    strAttr = "resizable=1,width=800,height=730";
    sbFoldersTree.active=false;
    sbShowModalDialog(strPage, strAttr, sbFoldersAfterUploadFiles);
}

function sbFoldersAfterUploadFiles()
{
    if (!sbModalDialog.returnValue)
    {
        sbSelFolder = 0;
        sbFoldersTree.active=true;
        return;
    }
    
    if (sbModalDialog.returnValue.error)
    {
        alert("<?php echo FILES_UPLOAD_ERROR; ?>");
    }
    setTimeout('sbFolderAfterUploadFilesHelper("'+(sbModalDialog.returnValue.refresh_tree ? 'refresh' : '')+'")', 0);
}

function sbFolderAfterUploadFilesHelper(refresh_tree)
{
    sbFoldersTree.active=true;
    
    try
    {
        if (refresh_tree == "refresh")
        {
            sbFoldersTree.XMLLoadDopStr = "&folds_autoloading="+sb_folders_autoloading+"&folds_never_show="+encodeURI(sb_folders_never_show)+"&folds_only_show="+encodeURI(sb_folders_only_show)+"&folds_selected_path="+encodeURI(sbFoldersTree.getSelectedItemId());
            sbFoldersTree.refreshItem(sbSelFolder ? sbSelFolder.id : sbFoldersTree.getSelectedItemId());
            sbFoldersTree.XMLLoadDopStr = "";
        }
        
        if (typeof(sbFilesShow) == "function" && (!sbSelFolder || sbSelFolder.id == sbFoldersTree.getSelectedItemId()))
        {
            sbFilesShow(sb_cms_empty_file + "?event=pl_filelist_read&path="+sbFoldersTree.getSelectedItemId()+"&files_exts="+sb_files_extensions + "&files_selected_file=" + sb_files_selected_file + "&files_link_title=" + sb_files_link_title);
        }
    }
    catch(e)
    {
        sbSelFolder = 0;
    }

    sbSelFolder = 0;
}

function sbFoldersRights()
{
    if (!sbSelFolder)
        return;

    var strPage = sb_cms_modal_dialog_file + "?event=pl_users_get_groups&folder=1&path="+sbSelFolder.id;
    var strAttr = "resizable=1,width=500,height=500";
    sbShowModalDialog(strPage, strAttr, sbFoldersAfterRights);
}

function sbFoldersAfterRights()
{    
    if (!sbSelFolder || !sbModalDialog.returnValue)
    {
        sbSelFolder = 0;
        return;
    }
    
    try
    {
        sbLoadSync(sb_cms_empty_file + "?event=pl_folders_set_rights&path="+sbSelFolder.id+"&rights="+sbModalDialog.returnValue.ids+"&subcategs="+sbModalDialog.returnValue.subcategs);
    }
    catch(e)
    {
        sbSelFolder = 0;
    }

    sbSelFolder = 0;
}

sbAddEvent(document, 'mousemove', sbFoldersMouseMove);
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>