<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
var sbCatTree=null; // дерево разделов
var sbSelCat = 0; // раздел, для которого вызвано контекстное меню
var sbCopyCutCat = 0; // раздел, из которого были скопированны элементы

if (typeof(sbCatMenu) == "undefined")
    var sbCatMenu=null; // контекстное меню разделов

if (typeof(sbCategClick) == "undefined")
    var sbCategClick=null; // функция, вызываемая при клике на раздел

var sbCopiedEls = new Array(); // скопированные элементы
var sbCuttedEls = new Array(); // вырезанные элементы
var sbSelectedEls = new Array(); // выделенные элементы

function sbCategsPreloadImages()
{
    var imSrcAr = new Array("folderClosed.gif","folderClosedCl.gif","folderClosedCopy.gif","folderClosedCopyCl.gif","folderClosedCut.gif","folderClosedCutCl.gif","folderOpen.gif","folderOpenCl.gif","folderOpenCopy.gif","folderOpenCopyCl.gif","folderOpenCut.gif","folderOpenCutCl.gif","line1.gif","line2.gif","line3.gif","line4.gif","minus.gif","minus2.gif","minus3.gif","minus4.gif","minus5.gif","plus.gif","plus2.gif","plus3.gif","plus4.gif","plus5.gif","iconCheckAll.gif","iconUnCheckAll.gif");
	var imAr = new Array(0);
	for(var i=0; i < imSrcAr.length; i++)
	{
	    imAr[imAr.length] = new Image();
        imAr[imAr.length-1].src = sb_cms_img_url+"/tree/"+imSrcAr[i];
    }
}

function sbCategsAfterLoad()
{
    sbCategsPreloadImages();
    sbHideMsgDiv();

    if (!sbCatTree.multiSelect)
    {
        sbCatTree.openItem(sbCatTree.getParentId(sb_categs_selected_id));
        sbCatTree.selectItem(sb_categs_selected_id, true);
    }
    else
    {
        for (var i = 0; i < sb_categs_selected_ids.length; i++)
        {
            sbCatTree.openItem(sbCatTree.getParentId(sb_categs_selected_ids[i]));
            sbCatTree.selectItem(sb_categs_selected_ids[i], true);
        }
    }
    
    if (sbCatMenu)
        sbCatMenu.init();

    var elems_table = sbGetE("elems_list_table");
    if (elems_table)
    {
        var c_list = sbGetE("categs_list");
        var c_list_td = sbGetE("categs_list_td");

        c_list.style.width = panel_width;
        c_list_td.style.width = panel_width;
        sbCatTree.allTree.style.width = panel_width-5;

        if (typeof(sbResizeEldiv) == "function")
            sbResizeEldiv();

        var e_header = sbGetE("elems_list_header");
        if (e_header) e_header.style.visibility = "visible";

        elems_table.style.visibility = "visible";

        var e_footer = sbGetE("elems_list_footer");
        if (e_footer) e_footer.style.visibility = "visible";
    }

    if (typeof(sbCategsLoad) == "function")
        sbCategsLoad();
}

var sbCatDelDrag = false;
function sbCategsDragDel(e, start)
{
    if (e.button == 2)
        return;

    var ddiv = sbGetE("categs_drag_div");
    var c_list = sbGetE("categs_list");
    var e_list_header = sbGetE("elems_list_header");

    if (ddiv && start)
    {
        sbCatDelDrag = true;
        ddiv.style.left = e.clientX - 2;
        ddiv.style.top = (e_list_header ? e_list_header.offsetHeight:0) + 1;
        ddiv.style.height = c_list.offsetHeight - 1;
        ddiv.style.display = 'block';
        sbAddEvent(document, "mouseup", sbCategsDragDel);
        sbAddEvent(document, "selectstart", sbCancelEvent);
        return sbCancelEvent(e);
    }
    else if (sbCatDelDrag)
    {
        sbRemoveEvent(document, "mouseup", sbCategsDragDel);
        sbRemoveEvent(document, "selectstart", sbCancelEvent);
        sbCatDelDrag = false;
        ddiv.style.display = 'none';
        panel_width = Math.max(document.body.clientWidth - e.clientX, 0);
        sbSetCookie("sb_panel_width", panel_width, 0, '/', '');

        _sbCallResize();
        
        var c_list_td = sbGetE("categs_list_td");
        c_list.style.width = panel_width;
        c_list_td.style.width = panel_width;
        sbCatTree.allTree.style.width = panel_width-5;
    }
}

function sbCategsMouseMove(e)
{
    if (sbCatDelDrag)
    {
        var ddiv = sbGetE("categs_drag_div");
        ddiv.style.left = e.clientX - 2;
    }
}

function sbShowCategsMenu()
{
    if (!sbCatMenu || !sbCatTree)
        return false;

    sbSelCat = sbCatTree.lastMenuSelected;
    var catId = sbSelCat.id;
    var level = parseInt(sbSelCat.level);

    if (level < sb_categs_menu_level)
    {
        return false;
    }
    else
    {
        var additionalShowed = false;

        if (level < sb_categs_paste_menu_level || (catId == sbCopyCutCat && sbCuttedEls.length != 0) || (sbCuttedEls.length == 0 && sbCopiedEls.length == 0) ||
            (sb_categs_paste_menu == "copy" && sbCopiedEls.length == 0) || (sb_categs_paste_menu == "cut" && sbCuttedEls.length == 0))
            sbCatMenu.hideItem("paste");
        else
            sbCatMenu.showItem("paste");

        if (level < sb_categs_paste_menu_level || sbCopiedEls.length == 0)
            sbCatMenu.hideItem("paste_links");
        else
            sbCatMenu.showItem("paste_links");

        if (level < sb_categs_copy_menu_level)
        {
            sbCatMenu.hideItem("copy");
        }
        else
        {
            var hide = false;
            for (var i = 0; i < sb_categs_not_copyable.length; i++)
            {
                if (sb_categs_not_copyable[i] == catId)
                {
                    sbCatMenu.hideItem("copy");
                    hide = true;
                    break;
                }
            }
            
            if (!hide)
                sbCatMenu.showItem("copy");
        }
        if (level < sb_categs_cut_menu_level)
            sbCatMenu.hideItem("cut");
        else
            sbCatMenu.showItem("cut");

        if (level < sb_categs_paste_categs_menu_level || (!sbCatTree.nodeCopy && !sbCatTree.nodeCut) || (level + 1 > sb_categs_max_deep))
        {
            sbCatMenu.hideItem("paste_categs");
        }
        else
        {
            if (sbCatTree.nodeCut)
            {
                if(sbCatTree._checkParentNodes(sbCatTree.nodeCut.id, sbSelCat) || sbCatTree.nodeCut.parentObject == sbSelCat)
                    sbCatMenu.hideItem("paste_categs");
                else
                    sbCatMenu.showItem("paste_categs");
            }
            else
            {
                if(sbCatTree._checkParentNodes(sbCatTree.nodeCopy.id, sbSelCat) && level >= sbCatTree.nodeCopy.level)
                    sbCatMenu.hideItem("paste_categs");
                else
                    sbCatMenu.showItem("paste_categs");
            }
        }
        
        if (level < sb_categs_paste_categs_menu_level || !sbCatTree.nodeCopy || (level + 1 > sb_categs_max_deep))
        {
            sbCatMenu.hideItem("paste_categs_with_element");
        }
        else
        {
            if(sbCatTree._checkParentNodes(sbCatTree.nodeCopy.id, sbSelCat) && level >= sbCatTree.nodeCopy.level)
                sbCatMenu.hideItem("paste_categs_with_element");
            else
                sbCatMenu.showItem("paste_categs_with_element");
        }

        if (level < sb_categs_edit_menu_level)
        {
            sbCatMenu.hideItem("edit");
        }
        else
        {
            var hide = false;
            for (var i = 0; i < sb_categs_not_editable.length; i++)
            {
                if (sb_categs_not_editable[i] == catId)
                {
                    sbCatMenu.hideItem("edit");
                    hide = true;
                    break;
                }
            }
            
            if (!hide)
                sbCatMenu.showItem("edit");
        }

        if (level < sb_categs_delete_menu_level)
        {
            sbCatMenu.hideItem("delete");
            sbCatMenu.hideItem("delete_with_elements");
        }
        else
        {
            var hide = false;
            for (var i = 0; i < sb_categs_not_deletable.length; i++)
            {
                if (sb_categs_not_deletable[i] == catId)
                {
                    sbCatMenu.hideItem("delete");
                    hide = true;
                    break;
                }
            }
            
            if (!hide)
            {
                sbCatMenu.showItem("delete");
                sbCatMenu.showItem("delete_with_elements");
            }
        }

		if (level <= sbCatTree.dadlevel)
		{
			sbCatMenu.hideItem("up");
			sbCatMenu.hideItem("down");
		}
		else
		{
	        if (sbCatTree.getPrevNode(sbSelCat))
	        	sbCatMenu.showItem("up");
	        else
	        	sbCatMenu.hideItem("up");
	        	
	        if (sbCatTree.getNextNode(sbSelCat))
	        	sbCatMenu.showItem("down");
	        else
	        	sbCatMenu.hideItem("down");
	    }

        for (var i = 0; i < sb_categs_add_menu.length; i++)
        {
            if (level < sb_categs_add_menu[i]["level"])
            {
                sbCatMenu.hideItem("additional_" + i);
            }
            else
            {
                additionalShowed = true;
                sbCatMenu.showItem("additional_" + i);
            }
        }

        if (level >= sb_categs_max_deep || level < sb_categs_add_menu_level)
        {
            sbCatMenu.hideItem("add");
        }
        else
        {
            var hide = false;
            for (var i = 0; i < sb_categs_not_addable.length; i++)
            {
                if (sb_categs_not_addable[i] == catId)
                {
                    sbCatMenu.hideItem("add");
                    hide = true;
                    break;
                }
            }

            if (!hide)
                sbCatMenu.showItem("add");
        }

        var pasteShowed = (sbCatMenu.isShowedItem("paste") || sbCatMenu.isShowedItem("paste_links"));
        var categsPasteShowed = (sbCatMenu.isShowedItem("copy") || sbCatMenu.isShowedItem("cut") || sbCatMenu.isShowedItem("paste_categs"));
        var mainShowed = (sbCatMenu.isShowedItem("add") || sbCatMenu.isShowedItem("edit") || sbCatMenu.isShowedItem("delete"));
        var rightsShowed = sbCatMenu.isShowedItem("rights");

        if (pasteShowed && (categsPasteShowed || mainShowed || rightsShowed || additionalShowed))
            sbCatMenu.showItem("paste_delimeter");
        else
            sbCatMenu.hideItem("paste_delimeter");

        if (categsPasteShowed && (mainShowed || rightsShowed || additionalShowed))
            sbCatMenu.showItem("paste_categs_delimeter");
        else
            sbCatMenu.hideItem("paste_categs_delimeter");

        if (mainShowed && (rightsShowed || additionalShowed || sbCatMenu.isShowedItem("up") || sbCatMenu.isShowedItem("down")))
            sbCatMenu.showItem("delimeter");
        else
            sbCatMenu.hideItem("delimeter");

		if ((sbCatMenu.isShowedItem("up") || sbCatMenu.isShowedItem("down")) && (rightsShowed || additionalShowed))
			sbCatMenu.showItem("updown_delimeter");
		else
			sbCatMenu.hideItem("updown_delimeter");
		
        if (rightsShowed && additionalShowed)
            sbCatMenu.showItem("additional_delimeter");
        else
            sbCatMenu.hideItem("additional_delimeter");
    }

    return true;
};

function sbCategsUp()
{
	if (!sbSelCat)
        return;

	var mPrev = sbCatTree.getPrevNode(sbSelCat);
	if (!mPrev)
		return;
	
	var mSel = mPrev;
	var mPar = sbCatTree.getParentNode(sbSelCat.id);	
	var mNext = sbCatTree.getNextNode(sbSelCat);
	
	sbSelCat = 0;
	
	if (mNext)
	{
    	sbCatTree._moveNodeTo(mSel, mPar, mNext);
    }
    else
    {
    	sbCatTree._moveNodeTo(mSel, mPar);
    }
}

function sbCategsDown()
{
	if (!sbSelCat)
        return;

	var mNext = sbCatTree.getNextNode(sbSelCat);
	if (!mNext)
		return;
	
	var mSel = sbSelCat;
	var mPar = sbCatTree.getParentNode(sbSelCat.id);	
	var mNextNext = sbCatTree.getNextNode(mNext);
	
	sbSelCat = 0;
	
	if (mNextNext)
	{
    	sbCatTree._moveNodeTo(mSel, mPar, mNextNext);
    }
    else
    {
    	sbCatTree._moveNodeTo(mSel, mPar);
    }
}

function sbCategsAdd()
{
    if (!sbSelCat)
        return;

    var catId = sbSelCat.id;
    var catLevel = parseInt(sbSelCat.level);

    if (catLevel < sb_categs_add_menu_level || catLevel == sb_categs_max_deep)
    {
        return;
    }
    
    if (sb_categs_before_add_event != "")
    {
        var res = sbLoadSync(sb_cms_empty_file + "?event="+sb_categs_before_add_event+"&cat_id_p=" + catId);
        if (res != "")
        {
            sbShowMsgDiv(res, 'warning.png');
            return;
        }
    }
    
    if (sb_categs_add_event != "")
    {
        var strPage = sb_cms_modal_dialog_file+"?event="+sb_categs_add_event+"&cat_id_p=" + catId;
        var strAttr = "resizable=1,width="+sb_categs_add_dlg_width+",height="+sb_categs_add_dlg_height;

        sbShowModalDialog(strPage, strAttr, sbCategsAfterAdd);
    }
    else
    {
        var strPage = sb_cms_modal_dialog_file+"?event=pl_categs_add_edit&cat_ident="+sb_categs_ident+"&fields="+sb_categs_fields+"&cat_id_p="+catId+"&closed="+sb_categs_closed+"&cat_count="+sb_categs_count+"&cat_url="+sb_categs_url+"&cat_mods="+sb_categs_moderators+"&plugin="+sbEscapeEx(sb_elems_plugin)+"&plugin_ident="+sb_elems_plugin_ident;
        var strAttr = "resizable=1,width=800,height=550";
        sbShowModalDialog(strPage, strAttr, sbCategsAfterAdd);
    }
}

function sbCategsAfterAdd()
{
    if (!sbModalDialog.returnValue || !sbSelCat)
    {
        sbSelCat = 0;
        return;
    }

    var p_id = sbSelCat.id;

    var cat_id = sbModalDialog.returnValue.cat_id;
    var cat_title = sbModalDialog.returnValue.cat_title;
    var cat_closed = sbModalDialog.returnValue.cat_closed;
    var cat_rubrik = sbModalDialog.returnValue.cat_rubrik;

    if (cat_id != -1 && cat_id != "")
    {
        var obj = sbCatTree.insertNewChild(p_id, cat_id, cat_title, false, (cat_closed==1 ? "SECURE" : "")+(cat_closed==1&&cat_rubrik==1 ? "," : "")+(cat_rubrik==1 ? "CHECKED" : ""), false);
        if (obj)
        {
            obj.level = parseInt(sbSelCat.level) + 1;
        
            if (sbCatTree.nodeCopy && sbCatTree._checkParentNodes(sbCatTree.nodeCopy.id, sbSelCat)  && obj.level > sbCatTree.nodeCopy.level)
            {
                sbCatTree._changeSubImages(obj, "copy", true);
            }
        }
            
        if (sb_categs_after_add_event != "")
        {
            var res = sbLoadSync(sb_cms_empty_file + "?event="+sb_categs_after_add_event+"&cat_id=" + cat_id + "&cat_id_p=" + p_id);
            if (res != "")
                sbShowMsgDiv(res, 'warning.png');
        }
    }

    if (typeof(sb_categs_after_add_func) == "function" && (typeof(sbModalDialog.returnValue.not_call) == "undefined" || sbModalDialog.returnValue.not_call != 1))
        sb_categs_after_add_func(cat_id);
        
    sbSelCat = 0;
}

function sbCategsEdit()
{
    if (!sbSelCat)
        return;

    var catId = sbSelCat.id;
    var catLevel = parseInt(sbSelCat.level);

    if (catLevel < sb_categs_edit_menu_level)
    {
        return;
    }
    if (sb_categs_before_edit_event != "")
    {
        var res = sbLoadSync(sb_cms_empty_file + "?event="+sb_categs_before_edit_event+"&cat_id=" + catId);
        if (res != "")
        {
            sbShowMsgDiv(res, 'warning.png');
            return;
        }
    }
    if (sb_categs_edit_event != "")
    {
        var strPage = sb_cms_modal_dialog_file+"?event="+sb_categs_edit_event+"&cat_id=" + catId;
        var strAttr = "resizable=1,width="+sb_categs_edit_dlg_width+",height="+sb_categs_edit_dlg_height;

        sbShowModalDialog(strPage, strAttr, sbCategsAfterEdit);
    }
    else
    {
        var strPage = sb_cms_modal_dialog_file+"?event=pl_categs_add_edit&cat_ident="+sb_categs_ident+"&fields="+sb_categs_fields+"&cat_id="+catId+"&closed="+sb_categs_closed+"&cat_count="+sb_categs_count+"&cat_url="+sb_categs_url+"&cat_mods="+sb_categs_moderators+"&plugin="+sbEscapeEx(sb_elems_plugin)+"&plugin_ident="+sb_elems_plugin_ident;
        var strAttr = "resizable=1,width=800,height=550";
        sbShowModalDialog(strPage, strAttr, sbCategsAfterEdit);
    }
}

function sbCategsAfterEdit()
{
    if (!sbModalDialog.returnValue || !sbSelCat)
    {
        sbSelCat = 0;
        return;
    }

    var cat_id = sbSelCat.id;
    var cat_title = sbModalDialog.returnValue.cat_title;

    if (cat_title != "")
    {
        sbCatTree.setItemText(cat_id, cat_title, "");
        sbCatTree.setCheck(cat_id, sbModalDialog.returnValue.cat_rubrik);
        if (sbModalDialog.returnValue.cat_close_sub == 1)
        {
        	sbCatTree.setSecureAll(cat_id, sbModalDialog.returnValue.cat_closed);
        }
        else
        {
        	sbCatTree.setSecure(cat_id, sbModalDialog.returnValue.cat_closed);
        }
        
        if (sb_categs_after_edit_event != "")
        {
            var res = sbLoadSync(sb_cms_empty_file + "?event="+sb_categs_after_edit_event+"&cat_id=" + cat_id);
            if (res != "")
                sbShowMsgDiv(res, 'warning.png');
        }
    }
    
    if (typeof(sb_categs_after_edit_func) == "function"  && (typeof(sbModalDialog.returnValue.not_call) == "undefined" || sbModalDialog.returnValue.not_call != 1))
        sb_categs_after_edit_func(cat_id);

    sbSelCat = 0;
}

function sbCategsRefresh()
{
    if (!sbSelCat)
        return;

    sbCatTree.XMLLoadDopStr = "&cat_sel_id="+sbCatTree.getSelectedItemId()+"&cat_autoloading="+sb_categs_autoloading;
    sbCatTree.refreshItem(sbSelCat.id);
    sbCatTree.XMLLoadDopStr = "";

    sbSelCat = 0;
}

function sbCategsCopy()
{
    if (!sbSelCat)
        return;

    var catLevel = parseInt(sbSelCat.level);
    if (catLevel < sb_categs_copy_menu_level)
    {
        sbSelCat = 0;
        return;
    }

    sbCatTree.doCopy(sbSelCat.id);
    sbSelCat = 0;
}

function sbCategsCut()
{
    if (!sbSelCat)
        return;

    var catLevel = parseInt(sbSelCat.level);
    if (catLevel < sb_categs_cut_menu_level)
    {
        sbSelCat = 0;
        return;
    }

    sbCatTree.doCut(sbSelCat.id);
    sbSelCat = 0;
}

function sbCategsDelete()
{
    if (!sbSelCat)
        return;

    var catId = sbSelCat.id;
    var catLevel = parseInt(sbSelCat.level);
    if (catLevel < sb_categs_delete_menu_level)
    {
        sbSelCat = 0;
        return;
    }

    if (catLevel == 1)
    {
        alert("<?php echo CATEGS_DELETE_ROOT_MSG; ?>");
        sbSelCat = 0;
        return;
    }
    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_categs_count_subcategs&cat_id=" + catId);

    if (parseInt(res) > 0)
    {
        alert("<?php echo CATEGS_DELETE_ERROR_MSG1; ?>");
        sbSelCat = 0;
        return;
    }
    if (confirm("<?php echo CATEGS_CONFIRM_DELETE_MSG; ?>"))
    {
        if (sb_categs_delete_event != "")
        {
            res = sbLoadSync(sb_cms_empty_file + "?event=" + sb_categs_delete_event + "&cat_id=" + catId);
            if (res != "")
            {
                sbShowMsgDiv(res, 'warning.png');
                sbSelCat = 0;
                return;
            }
        }
        res = sbLoadSync(sb_cms_empty_file + "?event=pl_categs_delete&cat_id=" + catId + "&plugin=" + sb_elems_plugin+"&plugin_ident="+sb_elems_plugin_ident);
        if (res == "TRUE")
        {
            if (sbCatTree.nodeCopy.id == catId)
                sbCatTree.nodeCopy = 0;
            if (sbCatTree.nodeCut.id == catId)
                sbCatTree.nodeCut = 0;
            sbCatTree.deleteItem(catId, true);

        }
        else
            alert("<?php echo CATEGS_DELETE_ERROR_MSG2; ?>");
    }

    sbSelCat = 0;
}

function sbCategsDeleteWithElements()
{
	if (!sbSelCat)
		return;

	var par = sbCatTree.getParentNode(sbSelCat.id);
    var catId = sbSelCat.id;
    var catLevel = parseInt(sbSelCat.level);
    
    if (catLevel < sb_categs_delete_menu_level)
    {
        sbSelCat = 0;
        return;
    }

    if (catLevel == 1)
    {
        alert("<?php echo CATEGS_DELETE_ROOT_MSG; ?>");
        sbSelCat = 0;
        return;
    }

    if (confirm("<?php echo CATEGS_CONFIRM_DELETE_WITH_ELEMENTS_MSG; ?>"))
    {
    	if (sb_categs_delete_with_elements_event_before != "")
        {
            res = sbLoadSync(sb_cms_empty_file + "?event=" + sb_categs_delete_with_elements_event_before + "&cat_id=" + catId + "&plugin=" + sb_elems_plugin + "&plugin_ident="+sb_elems_plugin_ident);
            if (res != "")
            {
                sbShowMsgDiv(res, 'warning.png');
                sbSelCat = 0;
                return;
            }
        }
        res = sbLoadSync(sb_cms_empty_file + "?event=pl_categs_delete&cat_id=" + catId + "&plugin=" + sb_elems_plugin+"&plugin_ident="+sb_elems_plugin_ident+"&with_el=1");
        if (res !== "FALSE")
        {
        	if (sb_categs_delete_with_elements_event != "")
        	{
        		res = res.split("|");
        	    res = sbLoadSync(sb_cms_empty_file + "?event=" + sb_categs_delete_with_elements_event + "&elems_id=" + res[0] + "&del_parent_id=" + par.id + "&c_ids=" + res[1]);
        	    if (res != "")
        	    {
        	        sbShowMsgDiv(res, 'warning.png');
        	        sbSelCat = 0;
        	        return;
        	    }
        	}
        
            if (sbCatTree.nodeCopy.id == catId)
                sbCatTree.nodeCopy = 0;
            if (sbCatTree.nodeCut.id == catId)
                sbCatTree.nodeCut = 0;
            sbCatTree.deleteItem(catId, true);
        }
        else
            alert("<?php echo CATEGS_DELETE_ERROR_MSG2; ?>");
            
    }

    sbSelCat = 0;
}

function sbCategsPasteCategs(sId, tId, bId)
{
    if (!sbSelCat && !sId)
    {
        sbSelCat = 0;
        return false;
    }
    var catId = (sbSelCat ? sbSelCat.id : tId);

    if (!sId)
    {
        if (sbCatTree.nodeCopy)
        {
            var pasteCatId = sbCatTree.nodeCopy.id;
            var action = "copy";
        }
        else if (sbCatTree.nodeCut)
        {
            var pasteCatId = sbCatTree.nodeCut.id;
            var action = "cut";
        }
        else
            var pasteCatId = -1;
    }
    else
    {
        pasteCatId = sId;
        action = "cut";
    }

    if (pasteCatId == -1)
    {
        sbSelCat = 0;
        return false;
    }

    if (sb_categs_before_paste_event != "")
    {
        var res = sbLoadSync(sb_cms_empty_file + "?event=" + sb_categs_before_paste_event + "&cat_id=" + catId + "&paste_cat_id=" + pasteCatId + "&before_cat_id=" + (bId ? bId : 0) + "&action=" + action);
        if (res != "")
        {
            sbShowMsgDiv(res, 'warning.png');
            sbSelCat = 0;
            return false;
        }
    }

    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_categs_paste_categs&cat_id=" + catId + "&paste_cat_id=" + pasteCatId + "&before_cat_id=" + (bId ? bId : 0) + "&max_level=" + sb_categs_max_deep + "&action=" + action + "&plugin=" + sb_elems_plugin+"&plugin_ident="+sb_elems_plugin_ident);
    if (res != "" && isNaN(parseInt(res.substr(0,1))))
    {
        sbShowMsgDiv(res, 'warning.png');
        sbSelCat = 0;
        return false;
    }

    var new_cat_id = -1;
    if (action == "copy")
    {
        res = res.split("|");
        var tmp_res = [];
        var copy_result = [];
        for (var i = 0; i < res.length; i++)
        {
            tmp_res = res[i].split("::");
            copy_result[tmp_res[0]] = tmp_res[1];
            if (tmp_res[0] == pasteCatId)
                new_cat_id = tmp_res[1];
        }
        sbCatTree.XMLLoadDopStr = "&cat_sel_id="+sbCatTree.getSelectedItemId()+"&cat_autoloading="+sb_categs_autoloading;
        sbCatTree.doPaste(sbSelCat.id, copy_result);
        sbCatTree.XMLLoadDopStr = "";
    }
    else
    {
        if (sbCatTree.nodeCut && !sId)
        {
            sbCatTree.doPaste(catId);
        }
    }

    if (sb_categs_after_paste_event != "")
    {
        res = sbLoadSync(sb_cms_empty_file + "?event=" + sb_categs_after_paste_event + "&cat_id=" + catId + "&paste_cat_id=" + pasteCatId + "&before_cat_id=" + (bId ? bId : 0) + "&action=" + action + (action == "copy" ? "&new_cat_id=" + new_cat_id : ""));
        if (res != "")
        {
            sbShowMsgDiv(res, 'warning.png');
        }
    }

    sbSelCat = 0;
    return true;
}

function sbCategsRights()
{
    if (!sbSelCat)
        return;

    var strPage = sb_cms_modal_dialog_file+"?event=pl_users_get_groups&cat_id=" + sbSelCat.id;
    var strAttr = "resizable=1,width=500,height=600";
    sbShowModalDialog(strPage, strAttr, sbCategsAfterRights);
}

function sbCategsAfterRights()
{
    if (!sbSelCat || !sbModalDialog.returnValue)
    {
        sbSelCat = 0;
        return;
    }

    try
    {
        sbLoadSync(sb_cms_empty_file + "?event=pl_categs_set_rights&cat_id=" + sbSelCat.id + "&rights=" + sbModalDialog.returnValue.ids + "&subcategs=" + sbModalDialog.returnValue.subcategs + "&plugin=" + sb_elems_plugin+"&plugin_ident="+sb_elems_plugin_ident);
    }
    catch(e)
    {
        sbSelCat = 0;
    }
    
    sbSelCat = 0;
}

function sbElemsPaste()
{
    var catId = (sbSelCat ? sbSelCat.id : sbCatTree.getSelectedItemId());
    sbSelCat = 0;
    
    var numEls = 0;
    var oldEls = "";
    var sAction = "";
    
    if (sbCuttedEls.length != 0)
    {
        numEls = sbCuttedEls.length;
        sAction = "cut";
        for (var i = 0; i < numEls; i++)
        {
            if (sbCuttedEls[i].is_link == 0)
                oldEls += "&e[" + sbCuttedEls[i].true_id + "]="+sbCuttedEls[i].el_id;
            else
                oldEls += "&l[" + sbCuttedEls[i].true_id + "]="+sbCuttedEls[i].el_id;
        }
    }
    else if (sbCopiedEls.length != 0)
    {
        numEls = sbCopiedEls.length;
        sAction = "copy";
        for (var i = 0; i < numEls; i++)
        {
            if (sbCopiedEls[i].is_link == 0)
                oldEls += "&e[" + sbCopiedEls[i].true_id + "]=" + sbCopiedEls[i].el_id;
            else
                oldEls += "&l[" + sbCopiedEls[i].true_id + "]=" + sbCopiedEls[i].el_id;
        }
    }
    else
    {
        return;
    }
    
    if (sb_elems_before_paste_event != '')
    {
        var res = sbLoadSync(sb_cms_empty_file + "?event="+sb_elems_before_paste_event+"&new_cat_id=" + catId + "&old_cat_id=" + sbCopyCutCat + "&action=" + sAction + oldEls);
        if (res != "")
        {
            sbShowMsgDiv(res, 'warning.png');
            return;
        }
    }
    var newEls = sbLoadSync(sb_cms_empty_file + "?event=pl_categs_paste_elems&new_cat_id=" + catId + "&old_cat_id=" + sbCopyCutCat + "&id_field="+sb_elems_id_field+"&table="+sb_elems_table + "&plugin=" + sb_elems_plugin +"&plugin_ident="+sb_elems_plugin_ident + "&title_field="+sb_elems_title_field + "&null_fields=" + sb_elems_null_fields + "&action=" + sAction + oldEls);

    if (newEls == "")
    {
        alert("<?php echo ELEMS_PASTE_ERROR; ?>");
        return;
    }
    
    if (sAction == "cut")
        newEls = "";
        
    if (sb_elems_after_paste_event != '')
    {
        var res = sbLoadSync(sb_cms_empty_file + "?event="+sb_elems_after_paste_event+"&new_cat_id="+catId+"&old_cat_id="+sbCopyCutCat+"&action="+sAction+newEls+oldEls);
        if (res != "")
        {
            alert(res);
        }
    }
    
    sbCuttedEls.splice(0, sbCuttedEls.length);
    
    var curId = sbCatTree.getSelectedItemId();

    if (sAction == "cut" && (curId == catId || curId == sbCopyCutCat))
    {
        sbElemsShow(sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + curId + "&page_elems=0");
    }
    else if (sAction == "copy" && curId == catId)
    {
        var div_el = sbGetE("elems_list_div");
        var from = "";
        if (div_el)
        {
            from = div_el.getAttribute("from");
        }
        sbElemsShow(sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + curId + "&page_elems=" + from);
    }
}

function sbElemsPasteLinks()
{
    if (sbCopiedEls.length == 0)
        return;

    var catId = (sbSelCat ? sbSelCat.id : sbCatTree.getSelectedItemId());
    var els = "";
    for (var i = 0; i < sbCopiedEls.length; i++)
        els += "&e["+sbCopiedEls[i].true_id+"]="+sbCopiedEls[i].el_id;

    if (sb_elems_before_paste_event != '')
    {
        res = sbLoadSync(sb_cms_empty_file + "?event="+sb_elems_before_paste_event+"&new_cat_id=" + catId + "&old_cat_id=" + sbCopyCutCat + "&action=copylinks" + els);
        if (res != "")
        {
            sbShowMsgDiv(res, 'warning.png');
            return;
        }
    }

    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_categs_paste_links&cat_id=" + catId + els + "&plugin=" + sb_elems_plugin +"&plugin_ident="+sb_elems_plugin_ident + "&table="+sb_elems_table+"&id_field="+sb_elems_id_field+"&title_field="+sb_elems_title_field);
    if (res == 'FALSE')
    {
        alert("<?php echo ELEMS_PASTE_LINKS_ERROR; ?>");
        return;
    }
    
    var curId = sbCatTree.getSelectedItemId();
    
    if (curId == catId)
    {
        var div_el = sbGetE("elems_list_div");
        var from = "";
        if (div_el)
        {
            from = div_el.getAttribute("from");
        }
        
        sbElemsShow(sb_cms_empty_file + "?event=" + sb_elems_event + "&id=" + curId + "&page_elems=" + from);
    }
}

function sbElemsPasteWithElements(sId, tId, bId)
{
	if (!sbSelCat && !sId)
    {
        sbSelCat = 0;
        return false;
    }
    var catId = (sbSelCat ? sbSelCat.id : tId);

    if (!sId)
    {
        if (sbCatTree.nodeCopy)
        {
            var pasteCatId = sbCatTree.nodeCopy.id;
            var action = "copy";
        }
        else
            var pasteCatId = -1;
    }
    else
    {
        pasteCatId = sId;
        action = "cut";
    }

    if (pasteCatId == -1)
    {
        sbSelCat = 0;
        return false;
    }
    if (sb_categs_before_paste_with_elements_event != "")
    {
        var res = sbLoadSync(sb_cms_empty_file + "?event=" + sb_categs_before_paste_with_elements_event + "&cat_id=" + catId + "&paste_cat_id=" + pasteCatId + "&before_cat_id=" + (bId ? bId : 0));
        if (res != "")
        {
            sbShowMsgDiv(res, 'warning.png');
            sbSelCat = 0;
            return false;
        }
    }

    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_categs_paste_categs&cat_id=" + catId + "&paste_cat_id=" + pasteCatId + "&before_cat_id=" + (bId ? bId : 0) + "&max_level=" + sb_categs_max_deep + "&action=" + action + "&plugin=" + sb_elems_plugin+"&plugin_ident="+sb_elems_plugin_ident+"&with_elements=1");
    
    if (res != "" && isNaN(parseInt(res.substr(0,1))))
    {
        sbShowMsgDiv(res, 'warning.png');
        sbSelCat = 0;
        return false;
    }

    var new_cat_id = -1;
    
    res = res.split("|");
    var tmp_res = [];
    var copy_result = [];
    for (var i = 0; i < res.length; i++)
    {
    	tmp_res = res[i].split("::");
        copy_result[tmp_res[0]] = tmp_res[1];
        if (tmp_res[0] == pasteCatId)
        	new_cat_id = tmp_res[1];
    }
    sbCatTree.XMLLoadDopStr = "&cat_sel_id="+sbCatTree.getSelectedItemId()+"&cat_autoloading="+sb_categs_autoloading;
    sbCatTree.doPaste(sbSelCat.id, copy_result);
    sbCatTree.XMLLoadDopStr = "";

    if (sb_categs_after_paste_with_elements_event != "")
    {
        res = sbLoadSync(sb_cms_empty_file + "?event=" + sb_categs_after_paste_with_elements_event + "&cat_id=" + catId + "&paste_cat_id=" + pasteCatId + "&before_cat_id=" + (bId ? bId : 0) + "&new_cat_id=" + new_cat_id);
        if (res != "")
        {
            sbShowMsgDiv(res, 'warning.png');
        }
    }

    sbSelCat = 0;
    return true;
}

sbAddEvent(document, 'mousemove', sbCategsMouseMove);
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>