<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
function sbLayoutHighlight(img_el, el_id, ind)
{
	var el_name = el_id.replace(/[^a-zA-Z0-9_\-]+/g, "");
	
	var editor = eval ('window.sbCodeditor_' + el_name);
	if (!editor)
	{
		eval ('window.sbCodeditor_' + el_name + ' = sbCodeditor.fromTextArea(el_id, {parserfile: ["sbParser.js.php"], stylesheet: ["<?php echo SB_CMS_CSS_URL; ?>/sbCodeColors.css"], path: "<?php echo SB_CMS_JSCRIPT_URL; ?>/codeditor/", autoMatchParens: true, undoDelay: 500, indentUnit: 4, tabMode: "shift", iframeClass: "sb_codeditor"})');
		img_el.src = "<?php echo SB_CMS_IMG_URL; ?>/icon_indent.gif";
		img_el.alt = "<?php echo LAYOUT_INDENT_ALL; ?>";
		img_el.title = "<?php echo LAYOUT_INDENT_ALL; ?>";
	}
	else if (ind)
	{
		editor.reindent();
	}
}

function sbLayoutFind(el_id)
{
	sbLayoutHighlight(sbGetE("btnHighlight_" + el_id), el_id, false);
	
    var el = sbGetE(el_id);
    if (!el || el.disabled) return;

    var strPage = sb_cms_modal_dialog_file + "?event=pl_editor_find";
    var strAttr = "resizable=1,width=500,height=300";

	var args = new Array();
	var codeEl = eval("window.sbCodeditor_" + el_id.replace(/[^a-zA-Z0-9_\-]+/g, ""));
    if (codeEl)
    {
    	args[2] = codeEl;
    }
    else
    {
    	el.focus();
    }
    
    args[0] = window.document;
    args[1] = el;

    sbShowModalDialog(strPage, strAttr, null, args);
}

function sbLayoutChooseTag(elId)
{
    var selElId = "sel_" + elId;
    var el = sbGetE(elId);
    var selEl = sbGetE(selElId);
    if (!el || el.disabled || !selEl)
    {
        return;
    }
    
    var editor = eval("window.sbCodeditor_" + elId.replace(/[^a-zA-Z0-9_\-]+/g, ""));
    if (editor)
	{
		editor.replaceSelection(selEl.options[selEl.selectedIndex].value);
	}
	else
	{
		el.focus();        
	    sbInsertAtCaret(el, selEl.options[selEl.selectedIndex].value);
	}
}

sbResizeDiv = null;
sbResizeBtn = null;
sbAreaOldWidth = 0;
sbAreaOldHeight = 0;

function sbLayoutEnlargeArea(btn, el_id)
{
    if (!sbResizeDiv)
    {
        var divEl = sbGetE("div_" + el_id);
        var btnEl = sbGetE("edit_btn_" + el_id);
        var textEls = divEl.getElementsByTagName("TEXTAREA");
        var iframeEls = divEl.getElementsByTagName("IFRAME");
        if (textEls.length == 0 || textEls[0].disabled)
            return;
        
        btn.src = "<?php echo SB_CMS_IMG_URL; ?>/roll_or_on.gif";
    	btn.style.marginRight = 20;
    	
    	var textEl;
        if (iframeEls.length > 0)
        {
        	textEl = iframeEls[0];
        }
        else
        {
            textEl = textEls[0]; 
        }
        
        var conEl = sbGetE("sb_tabs_con");
        var tabs = false;
        if (conEl)
        {
        	tabs = true;
        	window.tabs.disabled = true;
        }
        else
        {
        	conEl = sbGetE("event_content");
        	if (!conEl)
        		return;
        }
        
        iframeEls = conEl.getElementsByTagName("IFRAME");
        if (iframeEls.length > 0)
        {
        	for (var i = 0; i < iframeEls.length; i++)
        	{
        	    if (iframeEls[i] != textEl)
        	    {
        	    	iframeEls[i].style.display = "none";
        	    	iframeEls[i].parentNode.style.display = "none";
        	    }
        	}
        }
        
        var mapEls = conEl.getElementsByTagName("DIV");
        if (mapEls.length > 0)
        {
        	for (var i = 0; i < mapEls.length; i++)
        	{
        		var map_id = mapEls[i].getAttribute("id");
        	    if (map_id && (map_id.search(/.*?_yandex_map/) != -1 || map_id.search(/.*?_google_map/) != -1))
        	    {
        	    	mapEls[i].style.display = "none";
        	    }
        	}
        }
        
        conEl.style.overflow = "hidden";
        
        if (_isIE6)
        {
        	var selEls = conEl.getElementsByTagName("SELECT");
        	for (var i = 0; i < selEls.length; i++)
        	{
        		selEls[i].style.display = "none";
        	}
        	
        	var selEl = sbGetE("sel_" + el_id);
        	if (selEl)
        	{
        		selEl.style.display = "";
        	}
        }
         
        sbAreaOldWidth = textEl.style.width;
        sbAreaOldHeight = textEl.style.height;
        
        divEl.style.position = "absolute";
        divEl.style.backgroundColor = tabs ? "#FFF5E0" : "#e6e6e6";
        
        if (tabs)
        {
        	divEl.style.left = _isIE ? conEl.scrollLeft : 0; 
        	divEl.style.top = _isIE ? conEl.scrollTop : 0;
        	divEl.style.width = _isIE ? conEl.offsetWidth - 10 : document.body.clientWidth;
        	divEl.style.height = _isIE ? conEl.offsetHeight - 31 : document.body.clientHeight - 55;
        	
        	textEl.style.width = _isIE ? conEl.offsetWidth - 10 : document.body.clientWidth - 10;
			textEl.style.height = _isIE ? conEl.offsetHeight - 31 : document.body.clientHeight - 55;
		}
		else
		{
			divEl.style.left = sbGetAbsoluteLeft(conEl) + conEl.scrollLeft; 
        	divEl.style.top = sbGetAbsoluteTop(conEl) + conEl.scrollTop - 24;
        	divEl.style.width = document.body.clientWidth;
        	divEl.style.height = conEl.offsetHeight + (_isIE ? -10 : 4);
        	
        	textEl.style.width = conEl.offsetWidth - (_isIE ? 14 : 12);
			textEl.style.height = parseInt(divEl.offsetHeight) - 44;
		}
		
		textEl.style.marginLeft = 5;
		textEl.style.marginRight = 5;
			
		if (btnEl)
		{
			btnEl.style.display = "none";
		}
		
		sbResizeDiv = divEl;
		sbResizeBtn = btnEl;
		sbAddEvent(window, "resize", sbLayoutAreaResize);
		
		if (_isIE)
		{
			setTimeout("sbLayoutAreaResize();", 100);
		}
    }
    else
    {
        btn.src = "<?php echo SB_CMS_IMG_URL; ?>/roll_or_off.gif";
        btn.style.marginRight = 0;
        
        var conEl = sbGetE("sb_tabs_con");
        var tabs = false;
        
        if (conEl)
        {
            var tabs = true;
            window.tabs.disabled = false;
        }
        else
        {
        	conEl = sbGetE("event_content");
        	if (!conEl)
        		return;
        }

		var textEls = sbResizeDiv.getElementsByTagName("TEXTAREA");
		var iframeEls = sbResizeDiv.getElementsByTagName("IFRAME");
		var textEl;
        if (iframeEls.length > 0)
        {
            textEl = iframeEls[0];
        }
        else
        {
            textEl = textEls[0];
        }
        
		iframeEls = conEl.getElementsByTagName("IFRAME");
        if (iframeEls.length > 0)
        {
        	for (var i = 0; i < iframeEls.length; i++)
        	{
        	    if (iframeEls[i] != textEl)
        	    {
        	    	iframeEls[i].style.display = "block";
        	    	iframeEls[i].parentNode.style.display = "block";
        	    }
        	}
        }
        
        var mapEls = conEl.getElementsByTagName("DIV");
        if (mapEls.length > 0)
        {
        	for (var i = 0; i < mapEls.length; i++)
        	{
        		var map_id = mapEls[i].getAttribute("id");
        	    if (map_id && (map_id.search(/.*?_yandex_map/) != -1 || map_id.search(/.*?_google_map/) != -1))
        	    {
        	    	mapEls[i].style.display = "block";
        	    }
        	}
        }
        
  		conEl.style.overflow = "auto";
        	
        if (_isIE6)
        {
        	var selEls = conEl.getElementsByTagName("SELECT");
        	for (var i = 0; i < selEls.length; i++)
        	{
        		selEls[i].style.display = "";
        	}
        }

		if (!tabs)
		{
			textEl.style.marginLeft = 0;
			textEl.style.marginRight = 0;
		}
		
		sbResizeDiv.style.position = "static";
        sbResizeDiv.style.backgroundColor = "transparent";
        sbResizeDiv.style.width = "auto";
        sbResizeDiv.style.height = "auto";
        sbResizeDiv.style.top = "auto";
        sbResizeDiv.style.left = "auto";
        
        textEl.style.width = sbAreaOldWidth;
        textEl.style.height = sbAreaOldHeight;
        
        if (sbResizeBtn)
        {
        	sbResizeBtn.style.display = "";
        }
        
        sbResizeDiv = null;
        sbResizeBtn = null;
        
        sbAreaOldWidth = 0;
        sbAreaOldHeight = 0;

        sbRemoveEvent(window, "resize", sbLayoutAreaResize);
        sbCallResize();
    }
}

function sbLayoutAreaResize()
{
    if (sbResizeDiv)
    {
        var conEl = sbGetE("sb_tabs_con");
        var tabs = false;
        if (conEl)
        {
        	tabs = true;
        }
        else
        {
        	conEl = sbGetE("event_content");
        	if (!conEl)
        		return;
        }
        
        var textEls = sbResizeDiv.getElementsByTagName("TEXTAREA");
		var iframeEls = sbResizeDiv.getElementsByTagName("IFRAME");
		var textEl;
        if (iframeEls.length > 0)
        {
            textEl = iframeEls[0];
        }
        else
        {
            textEl = textEls[0];
        }
    
    	if (tabs)
        {
        	sbResizeDiv.style.left = _isIE ? conEl.scrollLeft : 0; 
        	sbResizeDiv.style.top = _isIE ? conEl.scrollTop : 0;
        	sbResizeDiv.style.width = _isIE ? conEl.offsetWidth - 10 : document.body.clientWidth;
        	sbResizeDiv.style.height = _isIE ? conEl.offsetHeight - 31 : document.body.clientHeight - 55;
        	
        	textEl.style.width = _isIE ? conEl.offsetWidth - 10 : document.body.clientWidth - 10;
			textEl.style.height = _isIE ? conEl.offsetHeight - 31 : document.body.clientHeight - 55;
		}
		else
		{
			sbResizeDiv.style.left = sbGetAbsoluteLeft(conEl) + conEl.scrollLeft; 
        	sbResizeDiv.style.top = sbGetAbsoluteTop(conEl) + conEl.scrollTop - 24;
        	sbResizeDiv.style.width = document.body.clientWidth;
        	sbResizeDiv.style.height = conEl.offsetHeight + (_isIE ? -10 : 4);
        	
        	textEl.style.width = conEl.offsetWidth - (_isIE ? 14 : 12);
			textEl.style.height = conEl.offsetHeight - (_isIE ? 31 : 40);
		}
    }
}

sbInfoEl = false;
function sbLayoutShowInfo(e)
{
    var el = sbEventTarget(e);
    var tabs_con = sbGetE("sb_tabs_con");
    var el_info = sbGetE("sb_layout_info");
    var el_info_txt = sbGetE("sb_layout_info_text");
    
    if(el_info && el && sbInfoEl != el && el.getAttribute("info"))
    {
        var text_info = el.getAttribute("info");
        if(text_info.substr(0, 6) == "event:")
        {
            el_info_txt.innerHTML = "<center><img src='" + sb_cms_img_url + "/loading.gif' height='16' width='16' /></center>";
            sbLoadAsync(sb_cms_empty_file + "?event=" + text_info.substr(6, text_info.length), sbLayoutLoadInfo);
        }
        else
        {
            el_info_txt.innerHTML = text_info;
        }
        
        
        el_info.style.left = sbGetAbsoluteLeft(el) - el_info.offsetWidth + (_isIE ? 96 : 92) - (tabs_con ? tabs_con.scrollLeft : 0);
        var t = sbGetAbsoluteTop(el) - el_info.offsetHeight - 24 - (tabs_con ? tabs_con.scrollTop : 0);
        if (t < 0)
        {
            t = sbGetAbsoluteTop(el) + el.offsetHeight - (tabs_con ? tabs_con.scrollTop : 0) - 24;
        }
        
        el_info.style.top = t;
        el_info.style.visibility = "visible";
        
        sbInfoEl = el;
        sbAddEvent(el, "mouseout", sbLayoutHideInfo);
    }
}

function sbLayoutHideInfo(e)
{
    if (sbInfoEl)
    {
        sbRemoveEvent(sbInfoEl, "mouseout", sbLayoutHideInfo);
        var el_info = sbGetE("sb_layout_info");
        var el_info_txt = sbGetE("sb_layout_info_text");
        if (el_info && el_info_txt)
        {
            el_info.style.visibility = "hidden";
            el_info_txt.innerHTML = "&nbsp;";
        }
           
        sbInfoEl = false;
    }
}

function sbLayoutLoadInfo(str)
{
    var el_info_txt = sbGetE("sb_layout_info_text");
    var el_info = sbGetE("sb_layout_info");
    var tabs_con = sbGetE("sb_tabs_con");
    
    if (sbInfoEl && el_info && el_info_txt)
    {
        str = (str && str != "" ? str : "<?php echo LAYOUT_NO_INFO; ?>");
        el_info_txt.innerHTML = str;
        sbInfoEl.setAttribute("info", str);
        
        el_info.style.left = sbGetAbsoluteLeft(sbInfoEl) - el_info.offsetWidth + (_isIE ? 96 : 92) - (tabs_con ? tabs_con.scrollLeft : 0);
        var t = sbGetAbsoluteTop(sbInfoEl) - el_info.offsetHeight - (_isIE || _isSafari ? 22 : 0) - (tabs_con ? tabs_con.scrollTop : 0);
        if (t < 0)
        {
            t = sbGetAbsoluteTop(sbInfoEl) + sbInfoEl.offsetHeight - (tabs_con ? tabs_con.scrollTop : 0) - (_isIE ? 22 : 0);
        }
        
        el_info.style.top = t;
    }
}

function sbLayoutLoad()
{
    var frm = document.forms[0];
    if (frm)
    {
        var old_onsubmit = frm.onsubmit;
        frm.onsubmit = function (e, not_call_old)
        {
            if (!not_call_old && old_onsubmit && old_onsubmit() === false)
                return false;

            for (var i = 0; i < frm.elements.length; i++)
            {
                var el = frm.elements[i];
                var is_notdis = el.getAttribute("sbnotdisable");

                if (!is_notdis)
                {
	                el.disabled = false;
	                
	                if (el.tagName.toLowerCase() == "button" || 
	                    (el.tagName.toLowerCase() == "input" && (el.type.toLowerCase() == "submit" || el.type.toLowerCase() == "button")))
	                {
	                    el.disabled = true;
	                }
	            }
            }    
        }
        
        for (var i = 0; i < frm.elements.length; i++)
        {
            var el = frm.elements[i];
                
            if (el.tagName.toLowerCase() == "input" && el.type.toLowerCase() == "submit" && el.name != "")
            {
                sbAddEvent(el, "click", sbLayoutSubmitClick);
            }
        } 
    }
}

function sbLayoutSubmitClick(e)
{
    var frm = document.forms[0];
    if (frm)
    {
	    var btn = sbEventTarget(e);
	    var fld = document.createElement('INPUT');
	    fld.type = 'hidden';
	    fld.name = btn.name;
	    fld.value = "1";
	    frm.appendChild(fld);
	}
}

function sbLayoutMarkRowsInit(t_id) 
{
    if ( !_isIE )
        return;
        
    var rows = document.getElementsByTagName("tr");
    for ( var i = 0; i < rows.length; i++ ) 
    {
        if ( 'odd' != rows[i].className.substr(0,3) && 'even' != rows[i].className.substr(0,4) ) 
            continue;

        rows[i].onmouseover = function() { this.className += ' hover'; }
        rows[i].onmouseout = function() { this.className = this.className.replace( ' hover', '' ); }
    }
}

var sbEditEl = null;
function sbLayoutEdit(el_id)
{
	var el = sbGetE(el_id);
	if (!el || el.disabled)
		return;

	var strPage = sb_cms_modal_dialog_file + "?event=pl_editor_popup";
	var strAttr = "resizable=1,width=" + (screen.width -  50) + ",height=" + (screen.height - 50);
	var args = new Object();

	sbEditEl = el_id;
                    
	var editor = eval("window.sbCodeditor_" + el_id.replace(/[^a-zA-Z0-9_\-]+/g, ""));
	if (editor)
	{
		args.value = editor.getCode();
	}
	else
	{
		sbEditEl = el_id;
		args.value = el.value;
	}
                    
	sbShowModalDialog(strPage, strAttr, sbLayoutAfterEdit, args);
}    

function sbLayoutAfterEdit()
{
	if (sbModalDialog.returnValue)
	{
		var el = sbGetE(sbEditEl);
		if (!el)
			return;
                    		
		var divEl = sbGetE("div_" + sbEditEl);
                        
		if (divEl && divEl.getElementsByTagName("IFRAME").length > 0)
		{
			var editor = eval("sbCodeditor_" + sbEditEl.replace(/[^a-zA-Z0-9_\-]+/g, ""));
			editor.setCode(sbModalDialog.returnValue);
		}
		else
		{
           	el.value = sbModalDialog.returnValue;
		}
    	                
		if (typeof(el.onchange) != "undefined" && el.onchange)
			el.onchange();
    	                        
		sbEditEl = null;
		el.focus();
	}
}

var sbSubmitStatus = "";
var sbCountMinus = new Array();
	            	
function sbLayoutCharCount(el, id, max)
{
	var count_place = sbGetE("char_count_" + id);
	var str = el.value;
	str = str.replace(/<\/?[^><]+>/g, "");
	var count = max - str.length;
	var frm = document.getElementsByTagName("input");
	            		
	if(count > 20)
	{
		count_place.style.color = "black";
	}
	else if (count <= 20 && count > 10)
	{
		count_place.style.color = "#ac0002";
	}
	else if(count <= 10)
	{
		count_place.style.color = "red";
	}
	
	if (count >= 0 && typeof sbCountMinus[id] != "undefined")
	{	
		delete (sbCountMinus[id]);	
	}
	            		
	if (count < 0 && typeof sbCountMinus[id] == "undefined")
	{
		sbCountMinus[id] = "";
	}
	            		
	var hasElems = false;
	var key;
					    
	for (key in sbCountMinus) 
	{
		if (sbCountMinus.hasOwnProperty(key))
		{
			hasElems = true;
			break;
		}
	}
					    
	if (hasElems)
	{
		for (var i = 0; i < frm.length; i++)
		{
			if (frm[i].type == "submit")
			{
				frm[i].disabled = true;
			}
		}
	}
	else
	{
		for (var i = 0; i < frm.length; i++)
		{
			if (frm[i].type == "submit")
			{
				frm[i].disabled = sbSubmitStatus;
			}
		}
	}
					    
	count_place.innerHTML = count;
	return true;
}
	            	
sbAddEvent(window, "load", function() {
	var frm = document.getElementsByTagName("input");
	var btn = false;            		
	for (var i = 0; i < frm.length; i++)
	{
		if (frm[i].type == "submit")
		{
			btn = frm[i];
			break;
		}
	}
		            	
	sbSubmitStatus = btn.disabled;
});
	            	
sbAddEvent(window, "load", sbLayoutLoad);
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>