<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
var sbMenuTree = null;
var sbSelMenu = 0; // пункт, для которого вызвано контекстное меню

var sbMenu = new sbCMenu("sbMenu", "15#FF9933", "15#fff5e0", "highItemText", "lowItemText", 90);
sbMenu.showFunc = sbShowMenu;

if (sb_menu_edit_rights)
{
    sbMenu.addItem("copy", "<?php echo MENU_COPY_ITEM; ?>", sbMenuCopy);
    sbMenu.addItem("cut", "<?php echo MENU_CUT_ITEM; ?>", sbMenuCut);
    sbMenu.addItem("paste", "<?php echo MENU_PASTE_ITEM; ?>", sbMenuPaste);
    sbMenu.addItem("paste_menu_delimeter");
    sbMenu.addItem("add", "<?php echo MENU_ADD_ITEM; ?>", sbMenuAdd);
    sbMenu.addItem("add_categs", "<?php echo MENU_ADD_CATEGS_ITEM; ?>", sbMenuAddCategs);
    sbMenu.addItem("add_delim", "<?php echo MENU_ADD_DELIM_ITEM; ?>", sbMenuAddDelim);
}

sbMenu.addItem("edit", "<?php echo MENU_EDIT_ITEM; ?>", sbMenuEdit);

if (sb_menu_delete_rights)
{
    sbMenu.addItem("delete", "<?php echo MENU_DELETE_ITEM; ?>", sbMenuDelete);
}

sbMenu.addItem("refresh", "<?php echo MENU_REFRESH_ITEM; ?>", sbMenuRefresh);

sbMenu.addItem("export_menu_delimeter");
sbMenu.addItem("export", "<?php echo MENU_EXPORT_ITEM; ?>", sbMenuExport);

if (sb_menu_edit_rights)
{
	sbMenu.addItem("updown_menu_delimeter");
	sbMenu.addItem("up", "<?php echo MENU_UP_ITEM; ?>", sbMenuUp);
    sbMenu.addItem("down", "<?php echo MENU_DOWN_ITEM; ?>", sbMenuDown);
}

sbMenu.addItem("fold_menu_delimeter");
sbMenu.addItem("unfold", "<?php echo MENU_UNFOLD_ITEM; ?>", sbMenuUnfold);
sbMenu.addItem("fold", "<?php echo MENU_FOLD_ITEM; ?>", sbMenuFold);

function sbMenuPreloadImages()
{
    var imSrcAr = new Array("menuItem.gif","menuOpen.gif","menuClosed.gif","menuItemCut.gif","menuOpenCut.gif","menuClosedCut.gif","menuItemCopy.gif","menuOpenCopy.gif","menuClosedCopy.gif","menuCategs.gif","menuCategsCopy.gif","menuCategsCut.gif","menuDelimCut.gif","menuDelimCopy.gif","menuDelim.gif","folderOpenCutCl.gif","line1.gif","line2.gif","line3.gif","line4.gif","minus.gif","minus2.gif","minus3.gif","minus4.gif","minus5.gif","plus.gif","plus2.gif","plus3.gif","plus4.gif","plus5.gif","iconCheckAll.gif","iconUnCheckAll.gif");
    var imAr = new Array(0);
    for(var i=0; i < imSrcAr.length; i++)
    {
        imAr[imAr.length] = new Image();
        imAr[imAr.length-1].src = sb_cms_img_url+"/tree/"+imSrcAr[i];
    }
}

function sbMenuLoad()
{
    sbMenuTree=new sbTree(document.getElementById("menu_list"), "100%", "100%", 0);
    sbMenuTree.imPath = sb_cms_img_url + "/tree/";
    if (sb_menu_edit_rights)
    {
        sbMenuTree.checkFuncHandler=sbMenuCheck;
        sbMenuTree.dragFunc=sbMenuPaste;
        sbMenuTree.moveFunc=sbMenuCheckMove;
        sbMenuTree.checkBoxesLevel = 2;
    }
    else
    {
		sbMenuTree.checkBoxes=false;
        sbMenuTree.dragAndDrop=false;
    }

    sbMenuTree.imageArray = new Array("menuItem.gif","menuOpen.gif","menuClosed.gif", "","","");
    sbMenuTree.cutImages  = new Array("menuItemCut.gif","menuOpenCut.gif","menuClosedCut.gif", "","","");
    sbMenuTree.copyImages = new Array("menuItemCopy.gif","menuOpenCopy.gif","menuClosedCopy.gif", "","","");
    
    sbMenuTree.aFunc=sbMenuClick;
    sbMenuTree.cMenu = sbMenu;
    sbMenuTree.setXMLAutoLoading(sb_cms_empty_file + "?event=pl_menu_tree&cat_id="+sbCatTree.getSelectedItemId());
    sbMenuTree.loadXML(sb_cms_empty_file + "?event=pl_menu_tree&cat_id="+sbCatTree.getSelectedItemId(), sbMenuAfterLoad);
    
    sbResizeMenuDiv();
}

function sbShowMenu()
{
    if (!sbMenu || !sbMenuTree)
        return false;

    sbSelMenu = sbMenuTree.lastMenuSelected;
    
    var mId = sbSelMenu.id;
    var mType = sbMenuTree.getUserData(mId, "m_type");
    var level = parseInt(sbSelMenu.level);

    if (mType == "delim" || mType == "categs" || (!sbCopyMenuId && !sbCutMenuId) || level > sb_menu_max_deep || (level == 1 && sbSelMenu.childsCount >= sb_menu_max_items))
    { 
    	sbMenu.hideItem("paste");
    }
    else
    {
        if (sbMenuTree.nodeCut)
        {
            if(sbMenuTree._checkParentNodes(sbMenuTree.nodeCut.id, sbSelMenu))
                sbMenu.hideItem("paste");
            else
                sbMenu.showItem("paste");
        }
        else
        {
            if(sbMenuTree.nodeCopy && sbMenuTree._checkParentNodes(sbMenuTree.nodeCopy.id, sbSelMenu) && level >= sbMenuTree.nodeCopy.level)
                sbMenu.hideItem("paste");
            else
                sbMenu.showItem("paste");
        }
    }

    if (mType == "delim" || mType == "categs" || level > sb_menu_max_deep || (level == 1 && sbSelMenu.childsCount >= sb_menu_max_items))
    {
        sbMenu.hideItem("add");
        sbMenu.hideItem("add_delim");
        sbMenu.hideItem("add_categs");
    }
    else
    {
        sbMenu.showItem("add");
        sbMenu.showItem("add_delim");
        sbMenu.showItem("add_categs");
    }
    
    if (level <= 1)
    {
        sbMenu.hideItem("edit");
        sbMenu.hideItem("delete");
        sbMenu.hideItem("up");
        sbMenu.hideItem("down");
        sbMenu.showItem("refresh");
    }
    else
    {
        if (mType == "delim")
        {
            sbMenu.hideItem("edit");
            sbMenu.hideItem("refresh");
        }
        else
        {
            sbMenu.showItem("edit");
            sbMenu.showItem("refresh");
        }
        
        if (sbMenuTree.getPrevNode(sbSelMenu))
        	sbMenu.showItem("up");
        else
        	sbMenu.hideItem("up");
        	
        if (sbMenuTree.getNextNode(sbSelMenu))
        	sbMenu.showItem("down");
        else
        	sbMenu.hideItem("down");
        	
        sbMenu.showItem("delete");
    }

	if (sbMenu.isShowedItem("up") || sbMenu.isShowedItem("down"))
		sbMenu.showItem("updown_menu_delimeter");
	else
		sbMenu.hideItem("updown_menu_delimeter");
		
    return true;
};

function sbMenuUp()
{
	if (!sbSelMenu)
        return;

	var mPrev = sbMenuTree.getPrevNode(sbSelMenu);
	if (!mPrev)
		return;
	
	var mSel = mPrev;
	var mPar = sbMenuTree.getParentNode(sbSelMenu.id);	
	var mNext = sbMenuTree.getNextNode(sbSelMenu);
	
	sbSelMenu = 0;
	
	if (mNext)
	{
    	sbMenuTree._moveNodeTo(mSel, mPar, mNext);
    }
    else
    {
    	sbMenuTree._moveNodeTo(mSel, mPar);
    }
}

function sbMenuDown()
{
	if (!sbSelMenu)
        return;

	var mNext = sbMenuTree.getNextNode(sbSelMenu);
	if (!mNext)
		return;
	
	var mSel = sbSelMenu;
	var mPar = sbMenuTree.getParentNode(sbSelMenu.id);	
	var mNextNext = sbMenuTree.getNextNode(mNext);
	
	sbSelMenu = 0;
	
	if (mNextNext)
	{
    	sbMenuTree._moveNodeTo(mSel, mPar, mNextNext);
    }
    else
    {
    	sbMenuTree._moveNodeTo(mSel, mPar);
    }
}

function sbMenuClick(mId)
{
    if (!sbMenuTree.active) return;
    
    sbMenu.hide();
    
    var node = sbMenuTree._gisf(mId);
    
    if (node)
    {
        sbMenuTree.lastSelected.selected = 0;
        sbMenuTree.lastSelected.span.className="treeItem";
        if(sbMenuTree.lastSelected.acolor)
            sbMenuTree.lastSelected.span.style.color=sbMenuTree.lastSelected.acolor;
        sbMenuTree.lastSelected = null;
    }
}

function sbMenuTitleClick(e, mId)
{
    if (!sbMenuTree.active) return;
        
    var node = sbMenuTree._gisf(mId);   
    if (node)
    {
        sbCancelEvent(e);
        
        sbMenuTree._selectMenuItem(node);
        sbSelMenu = sbMenuTree.lastMenuSelected;
        sbMenuEdit();
    }
}

function sbMenuAdd(type)
{
    if (!type)
        type = "item";
        
    if (!sbSelMenu)
        return;

    var mId = sbSelMenu.id;
    var mLevel = parseInt(sbSelMenu.level);

    if (mLevel >= sb_menu_max_deep + 1)
    {
        return;
    }
    
    var strPage = sb_cms_modal_dialog_file+"?event=pl_menu_add_edit&m_cat_id="+sbCatTree.getSelectedItemId()+"&m_id_p="+mId+"&type="+type;
    var strAttr = "resizable=1,width=820,height=600";
    sbShowModalDialog(strPage, strAttr, sbMenuAfterAdd);
}

function sbMenuAddCategs()
{
    sbMenuAdd("categs");
}

function sbMenuAddDelim()
{
    if (!sbSelMenu)
        return;

    var mId = sbSelMenu.id;
    var mLevel = parseInt(sbSelMenu.level);
    
    if (mLevel >= sb_menu_max_deep + 1)
    {
        return;
    }
    
    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_menu_add_delim&m_id=" + mId + "&m_cat_id=" + sbCatTree.getSelectedItemId());

    if (isNaN(parseInt(res)))
    {
        sbShowMsgDiv(res, 'warning.png');
        sbSelMenu = 0;
        return;
    }   
    
    var obj = sbMenuTree.insertNewChild(mId, res, "----------", false, "CHECKED", false);
    if (obj)
    {
        obj.userData["t_m_type"] = "delim";
        
        obj.images[0] = "menuDelim.gif";
        obj.images[1] = "menuDelim.gif";
        obj.images[2] = "menuDelim.gif";
        
        obj.copyImages[0] = "menuDelimCopy.gif";
        obj.copyImages[1] = "menuDelimCopy.gif";
        obj.copyImages[2] = "menuDelimCopy.gif";
        
        obj.cutImages[0] = "menuDelimCut.gif";
        obj.cutImages[1] = "menuDelimCut.gif";
        obj.cutImages[2] = "menuDelimCut.gif";
        
        sbMenuTree._cp(obj);
        
        obj.level = parseInt(sbSelMenu.level) + 1;
        if (sbMenuTree.nodeCopy && sbMenuTree._checkParentNodes(sbMenuTree.nodeCopy.id, sbSelMenu)  && obj.level > sbMenuTree.nodeCopy.level)
        {
            sbMenuTree._changeSubImages(obj, "copy", true);
        }
    }
}

function sbMenuAfterAdd()
{
    if (!sbModalDialog.returnValue || !sbSelMenu)
    {
        sbSelMenu = 0;
        return;
    }
    
    var p_id = sbSelMenu.id;
    var m_id = sbModalDialog.returnValue.m_id;
    var m_title = sbModalDialog.returnValue.m_title;
    var m_type = sbModalDialog.returnValue.m_type;
    var m_show = (sbModalDialog.returnValue.m_show == 1 ? "CHECKED" : "");
    
    if (m_id != -1 && m_id != "")
    {
        var obj = sbMenuTree.insertNewChild(p_id, m_id, m_title, false, m_show, false);
        if (obj)
        {
            if (m_type == "categs")
            {
                obj.userData["t_m_type"] = "categs";
                
                obj.images[0] = "menuCategs.gif";
                obj.images[1] = "menuCategs.gif";
                obj.images[2] = "menuCategs.gif";
                
                obj.copyImages[0] = "menuCategsCopy.gif";
                obj.copyImages[1] = "menuCategsCopy.gif";
                obj.copyImages[2] = "menuCategsCopy.gif";
                
                obj.cutImages[0] = "menuCategsCut.gif";
                obj.cutImages[1] = "menuCategsCut.gif";
                obj.cutImages[2] = "menuCategsCut.gif";
                
                sbMenuTree._cp(obj);
            }
            
            obj.level = parseInt(sbSelMenu.level) + 1;
            if (sbMenuTree.nodeCopy && sbMenuTree._checkParentNodes(sbMenuTree.nodeCopy.id, sbSelMenu)  && obj.level > sbMenuTree.nodeCopy.level)
            {
                sbMenuTree._changeSubImages(obj, "copy", true);
            }
        }
    }

    sbSelMenu = 0;
}

function sbMenuEdit()
{
    sbMenu.hide();
    if (!sbSelMenu)
        return;

    var mId = sbSelMenu.id;
    var mLevel = parseInt(sbSelMenu.level);
    if (mLevel == 1)
    {
        sbSelMenu = 0;
        return;
    }
    
    var strPage = sb_cms_modal_dialog_file+"?event=pl_menu_add_edit&m_cat_id="+sbCatTree.getSelectedItemId()+"&m_id="+mId;
    var strAttr = "resizable=1,width=820,height=600";
    sbShowModalDialog(strPage, strAttr, sbMenuAfterEdit);
}

function sbMenuAfterEdit()
{
    sbMenuTree._unselectMenuItem();
    
    if (!sbModalDialog.returnValue || !sbSelMenu)
    {
        sbSelMenu = 0;
        return;
    }
    
    var m_id = sbSelMenu.id;
    var m_title = sbModalDialog.returnValue.m_title;
	var m_show = (sbModalDialog.returnValue.m_show == 1 ? true : false);
	
    if (m_title != "")
    {
        sbMenuTree.setItemText(m_id, m_title, "");
    }
    
    sbMenuTree.setCheck(m_id, m_show);
    
    sbSelMenu = 0;
}

function sbMenuDelete()
{
    if (!sbSelMenu)
        return;

    var mId = sbSelMenu.id;
    var mLevel = parseInt(sbSelMenu.level);

    if (mLevel == 1)
    {
        sbShowMsgDiv("<?php echo MENU_DELETE_ROOT_MSG; ?>", 'warning.png');
        sbSelMenu = 0;
        return;
    }
    
    if (confirm("<?php echo MENU_CONFIRM_DELETE_MSG; ?>"))
    {
        res = sbLoadSync(sb_cms_empty_file + "?event=pl_menu_delete&m_id=" + mId);
        if (res == "TRUE")
        {
            if (sbMenuTree.nodeCopy.id == mId)
                sbMenuTree.nodeCopy = 0;
            else if (sbMenuTree.nodeCut.id == mId)
                sbMenuTree.nodeCut = 0;
            
            if (sbCopyMenuId == mId)
            {
                sbCopyMenuId = 0;
                sbCopyCutMenuId = 0;
            }
            else if (sbCutMenuId == mId)
            {
                sbCutMenuId = 0;
                sbCopyCutMenuId = 0;
            }   
            sbMenuTree.deleteItem(mId);

        }
        else
        {
            sbShowMsgDiv("<?php echo MENU_DELETE_ERROR_MSG2; ?>", 'warning.png');
        }
    }

    sbSelMenu = 0;
}

function sbMenuRefresh()
{
    if (!sbSelMenu)
        return;

    sbMenuTree.refreshItem(sbSelMenu.id);
    sbSelMenu = 0;
}

function sbMenuPaste(sId, tId, bId)
{
    if (!sbSelMenu && !sId)
    {
        sbSelMenu = 0;
        return false;
    }

    var mId = (sbSelMenu ? sbSelMenu.id : tId);
    var mType = sbMenuTree.getUserData(mId, 'm_type');
    var mLevel = sbMenuTree.getLevel(mId);
    var mChilds = sbMenuTree.getChildsCount(mId);
    
    if (mType == "categs" || mType == "delim" || (mLevel == 1 && mChilds >= sb_menu_max_items))
        return false;
        
    if (!sId)
    {
        if (sbCopyMenuId)
        {
            var pasteMenuId = sbCopyMenuId;
            var action = "copy";
        }
        else if (sbCutMenuId)
        {
            var pasteMenuId = sbCutMenuId;
            var action = "cut";
        }
        else
            var pasteMenuId = -1;
    }
    else
    {
        pasteMenuId = sId;
        action = "cut";
    }

    if (pasteMenuId == -1)
    {
        sbSelMenu = 0;
        return false;
    }

    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_menu_paste&m_id=" + mId + "&paste_m_id=" + pasteMenuId + "&before_m_id=" + (bId ? bId : 0) + "&action=" + action);
    if (res != "" && isNaN(parseInt(res.substr(0,1))))
    {
        sbShowMsgDiv(res, 'warning.png');
        sbSelMenu = 0;
        return false;
    }

    if (action == "copy")
    {
        if (sbMenuTree.nodeCopy)
        {
            res = res.split("|");
            var tmp_res = [];
            var copy_result = [];
            var old_id = [];
            var new_id = [];
            
            for (var i = 0; i < res.length; i++)
            {
                tmp_res = res[i].split("::");
                copy_result[tmp_res[0]] = tmp_res[1];
                old_id[i] = tmp_res[0];
                new_id[i] = tmp_res[1];
            }
            
            sbMenuTree.doPaste(sbSelMenu.id, copy_result);
            
            for (var i = 0; i < new_id.length; i++)
            {
                var nodeText = sbMenuTree.getItemText(new_id[i]);
                if (nodeText)
                {
                    nodeText = nodeText.replace("sbMenuTitleClick(event, " + old_id[i] + ")", "sbMenuTitleClick(event, " + new_id[i] + ")");
                    sbMenuTree.setItemText(new_id[i], nodeText);
                }
            }
        }
        else if (sbCopyMenuId)
        {
            sbMenuRefresh();
        }
    }
    else
    {
        sbCopyCutMenuId = 0;
        
        if (sbMenuTree.nodeCut && !sId)
        {
            sbMenuTree.doPaste(mId);
        }
        else if (sbCutMenuId)
        {
            sbMenuRefresh();
        }
    }

    sbSelMenu = 0;
    sbCutMenuId = 0;
    
    return true;
}

function sbMenuCheckMove(sId, tId)
{
    if (!sId) return false;
    
    var mType = sbMenuTree.getUserData(tId, 'm_type');
    var mLevel = sbMenuTree.getLevel(tId);
    var mChilds = sbMenuTree.getChildsCount(tId);
    
    if (mType == "categs" || mType == "delim" || (mLevel == 1 && mChilds >= sb_menu_max_items) || mLevel > sb_menu_max_deep)
        return "noinner";
    else
        return "all";
}

function sbMenuCopy()
{
    if (!sbSelMenu)
        return;

    sbCopyCutMenuId = sbCatTree.getSelectedItemId();
    sbMenuTree.doCopy(sbSelMenu.id);
    sbCopyMenuId = sbSelMenu.id;
    sbCutMenuId = 0;
    
    sbSelMenu = 0;
}

function sbMenuCut()
{
    if (!sbSelMenu)
        return;
    
    sbCopyCutMenuId = sbCatTree.getSelectedItemId();
    sbMenuTree.doCut(sbSelMenu.id);
    sbCutMenuId = sbSelMenu.id;
    sbCopyMenuId = 0;
    
    sbSelMenu = 0;
}

function sbMenuCheck(mId, state)
{
    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_menu_check&m_id="+mId+"&state="+state);
    if (res != "")
    {
        sbShowMsgDiv(res, "warning.png");
        return 0;
    }

    return 1;
}

function sbMenuUnfold()
{
    sbMenuTree.openAllItems(sbMenuTree._gis[1]);
    sbSelMenu = 0;
}

function sbMenuFold()
{
    sbMenuTree.closeAllItems(sbMenuTree._gis[1]);
    sbSelMenu = 0;
}

function sbResizeMenuDiv()
{
    var e_list = document.getElementById("elems_list");
    var m_list = document.getElementById("menu_list");
    var con_el = document.getElementById("event_content");
    var e_header = document.getElementById("elems_list_header");
    var e_footer = document.getElementById("elems_list_footer");
    
    if (m_list)
    {
        m_list.style.width = 0;
        m_list.style.width = Math.max(con_el.offsetWidth - panel_width - 5, 0);
        
        sbMenuTree.allTree.style.width = m_list.style.width;

        m_list.style.height = Math.max(parseInt(document.body.clientHeight) - 25 - (e_header?e_header.offsetHeight:0) - (e_footer?e_footer.offsetHeight:0), 0);
        if (_isIE)
        {
            sbMenuTree.allTree.style.height = m_list.style.height;
        }
        else
        {
            sbMenuTree.allTree.style.height = m_list.offsetHeight - 10;
        }
    }
}

sbResizeFuncs[sbResizeFuncs.length]=sbResizeMenuDiv;
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>