<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
sbPDChangeType = function(el)
{
    var el_settings = sbGetE("btn_settings");
    var el_name = sbGetE("el_name");
    
    if (!el || !el_settings || !el_name)
        return;
        
    var type = el[el.selectedIndex].value;
    
    if(type == "tab" || type == "hr")
    {
        el_settings.style.display = "none";
        if (type == "hr")
        {
            el_name.disabled = true;
            el_name.value = "";
        }
        else
        {
            el_name.disabled = false;
        }
    }
    else
    {
        el_settings.style.display = "";
        el_name.disabled = false;
    }
}

sbPDKeyDown = function (e)
{
    if(e.keyCode == 13)
        sbPDAddField();
}

sbPDAddField = function()
{
    var el_type = sbGetE("el_type");
    var type = el_type[el_type.selectedIndex].value;
    var el_name = sbGetE("el_name");
    
    if(el_name.value == "" && type != "hr")
    {
        sbShowMsgDiv("<?php echo PLUGIN_DATA_NONAME_MSG; ?>", "warning.png");
        return;
    }
    if(type == "select_sprav" || type == "multiselect_sprav" || type == "radio_sprav" || type == "checkbox_sprav" || type == "link_sprav" || type == "jscript" || type == "php" || type == "categs" || type == "table" || type == "select_plugin" || type == "radio_plugin" || type == "checkbox_plugin" || type == "link_plugin" || type == "multiselect_plugin" || type == "elems_plugin")
    {
        sbShowMsgDiv("<?php echo PLUGIN_DATA_NOPROPS_MSG; ?>", "warning.png");
        return;
    }

    var tab = sbGetE("sb_tab0");
    var categs = tab.style.display == "none" ? "1" : "0";
    
    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_plugin_data_add&ident=" + sbCatTree.getSelectedItemId() + "&el_type=" + type + "&el_name=" + el_name.value + "&categs=" + categs);
    if (res == "FALSE")
    {
        sbShowMsgDiv("<?php echo PLUGIN_DATA_ERROR_ADD; ?>", "warning.png");
        return;
    }
    res = res.split("|");
    
    sbPDAddTr(res[0], res[1], res[2], type, el_name.value, 0, 0, 0, 0);
    el_name.value = "";
}

sbPDAddTr = function(id, type_img, type_title, type, name, info, sort, filter, mandatory)
{
    var tab = sbGetE("sb_tab0");
    var categs = tab.style.display == "none" ? "1" : "0";
    var menu = sbCatTree.getSelectedItemId() == "pl_menu" ? true : false;
    
    if (categs == "0")
    {
        var table = sbGetE("plugin_data_table");
        var null_tr = sbGetE("null_tr");
    }
    else
    {
        var table = sbGetE("categ_data_table");
        var null_tr = sbGetE("categ_null_tr");
    }
    
    if (!table || !null_tr)
        return;
      
    if (null_tr.className != "")
    {
        var cls = "even";
        if (_isIE)
            null_tr.removeAttribute("className");
        else
            null_tr.removeAttribute("class");
    }
    else
    {
        var cls = "";
        null_tr.className = "even";
    }
        
    var tr = document.createElement("TR");
    tr.setAttribute("id", id);
    if (_isIE)
        tr.setAttribute("className", cls);
    else
        tr.setAttribute("class", cls);
    tr.style.cursor = "default";
    if(_isIE)
    {
        tr.setAttribute("onmousedown", function(){sbPDStartDrag(event, this)});
    }
    else
    {
        tr.setAttribute("onmousedown", "sbPDStartDrag(event, this)");
    }
            
    // ID
    var td1 = document.createElement("TD");
    td1.innerHTML = id;
    td1.align = "center";
    td1.style.verticalAlign = "middle";
    td1.style.borderTop = "1px solid FFF5E0";
    tr.appendChild(td1);

    // IMG
    var td2 = document.createElement("TD");
    td2.innerHTML = type_img != "" ? "<img src='" + type_img + "' alt='" + type_title + "' title='" + type_title + "' width='16' height='16' onmousedown='_sbPDPreventNsDrag(event, true);' ondragstart='_sbPDPreventNsDrag(event);' />" : "&nbsp;";
    td2.align = "center";
    td2.style.verticalAlign = "middle";
    td2.style.borderTop = "1px solid FFF5E0";
    tr.appendChild(td2);

    //Наименование
    var td3 = document.createElement("TD");
    td3.style.verticalAlign = "middle";
    td3.style.borderTop = "1px solid FFF5E0";
    td3.innerHTML = "<span ondblclick='sbPDEditName(this)' id='name_" + id + "'>" + name + "</span>";
    tr.appendChild(td3);

    if (categs == "0" && !menu)
    {
        //Инфо.
        var td4 = document.createElement("TD");
        td4.align = "center";
        td4.style.verticalAlign = "middle";
        td4.style.borderTop = "1px solid FFF5E0";
        if (type != 'password' && type != 'label' && type != 'tab' && type != 'text' && type != 'longtext' && type != 'jscript' && type != 'table')
            td4.innerHTML = "<input type='checkbox' id='info_" + id + "' title='<?php echo PLUGIN_DATA_INFO_TITLE; ?>' onclick='sbPDChangeCheckbox(\"info\", this, " + id + ")'" + (info == 1 ? " checked='checked'" : "") + " />";
        else
            td4.innerHTML = "&nbsp;";
        tr.appendChild(td4);

        //Сорт.
        var td5 = document.createElement("TD");
        td5.align = "center";
        td5.style.verticalAlign = "middle";
        td5.style.borderTop = "1px solid FFF5E0";
        if (type != 'password' && type != 'label' && type != 'tab' && type != 'hr' && type != 'text' && type != 'longtext' && type != 'jscript' && type != 'multiselect_sprav' && type != 'checkbox_sprav' && type != 'select_sprav' && type != 'radio_sprav' && type != 'link_sprav' && type != 'categs' && type != 'google_coords' && type != 'yandex_coords' && type != 'table')
            td5.innerHTML = "<input type='checkbox' id='sort_" + id + "' title='<?php echo PLUGIN_DATA_SORT_TITLE; ?>' onclick='sbPDChangeCheckbox(\"sort\", this, " + id + ")'" + (sort == 1 ? " checked='checked'" : "") + " />";
        else
            td5.innerHTML = "&nbsp;";
        tr.appendChild(td5);
        
        //Фильтр
        var td6 = document.createElement("TD");
        td6.align = "center";
        td6.style.verticalAlign = "middle";
        td6.style.borderTop = "1px solid FFF5E0";
        if (type != 'password' && type != 'label' && type != 'tab' && type != 'hr' && type != 'jscript' && type != 'google_coords' && type != 'yandex_coords' && type != 'table')
            td6.innerHTML = "<input type='checkbox' id='filter_" + id + "' title='<?php echo PLUGIN_DATA_FILTER_TITLE; ?>' onclick='sbPDChangeCheckbox(\"filter\", this, " + id + ")'" + (filter == 1 ? " checked='checked'" : "") + " />";
        else
            td6.innerHTML = "&nbsp;";
        tr.appendChild(td6);
    }
        
    //Обязат.
    var td7 = document.createElement("TD");
    td7.align = "center";
    td7.style.verticalAlign = "middle";
    td7.style.borderTop = "1px solid FFF5E0";
    if (type != 'label' && type != 'tab' && type != 'hr' && type != 'checkbox' && type != 'jscript' && type != 'php')
        td7.innerHTML = "<input type='checkbox' id='mandatory_" + id + "' title='<?php echo PLUGIN_DATA_MANDATORY_TITLE; ?>' onclick='sbPDChangeCheckbox(\"mandatory\", this, " + id + ")'" + (mandatory == 1 ? " checked='checked'" : "") + " />";
    else
        td7.innerHTML = "&nbsp;";
    tr.appendChild(td7);
        
    // Свойства
    var td8 = document.createElement("TD");
    td8.align = "center";
    td8.style.verticalAlign = "middle";
    td8.style.borderTop = "1px solid FFF5E0";
    if (type != "hr")
        td8.innerHTML = "<img src='" + sb_cms_img_url + "/btn_props.png' border='0' title='<?php echo PLUGIN_DATA_PROPS; ?>' onmousedown='_sbPDPreventNsDrag(event, true);' ondragstart='_sbPDPreventNsDrag(event);' onclick='sbPDEditField(this, " + id + ");' style='cursor:hand;cursor:pointer;' width='20' height='20' />";
    else
        td8.innerHTML = "&nbsp;";
    tr.appendChild(td8);    

    // Удалить
    var td9 = document.createElement("TD");
    td9.align = "center";
    td9.style.verticalAlign = "middle";
    td9.style.borderTop = "1px solid FFF5E0";
    td9.innerHTML = "<img src='" + sb_cms_img_url + "/btn_delete.png' title='<?php echo PLUGIN_DATA_DELETE; ?>' onmousedown='_sbPDPreventNsDrag(event, true);' ondragstart='_sbPDPreventNsDrag(event);' onclick='sbPDDeleteField(" + id + ");' style='cursor:hand;cursor:pointer;' width='20' height='20' />";
    tr.appendChild(td9);
    
    var el = table.tBodies[0];
    if(el)
    {
        el.insertBefore(tr, null_tr);
    }
}

sbPDOldTitle = "";
sbPDEditName = function(el)
{
    sbPDOldTitle = el.innerHTML;
    el.innerHTML = "<input type='text' id='sbPDEditInput' value='" + sbPDOldTitle + "' onkeydown='sbPDEditKeyDown(event)' ondblclick='sbCancelEvent(event);' size='35' />";
    sbGetE("sbPDEditInput").focus();
    sbAddEvent(document, "click", sbPDAfterEditName);
}

sbPDAfterEditName = function(e, not_check)
{
    var e = window.event ? window.event : e;
    var el = sbGetE("sbPDEditInput");
    var tgt = sbEventTarget(e);
    
    if (!el || (!not_check && tgt == el))
        return;
        
    var text = el.value;
    var span_el = el.parentNode;
    if (sbPDOldTitle == text)
    {
        span_el.innerHTML = text;
        return;
    }   

    var tab = sbGetE("sb_tab0");
    var categs = tab.style.display == "none" ? "1" : "0";
    var el_tr = span_el.parentNode;
    
    while(el_tr.tagName != "TR")
        el_tr = el_tr.parentNode;

    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_plugin_data_rename&ident=" + sbCatTree.getSelectedItemId() + "&id=" + el_tr.id + "&text=" + text + "&categs=" + categs);
    if(res != "")
    {
        sbShowMsgDiv(res);
        span_el.innerHTML = sbPDOldTitle;
    }
    else
    {
        span_el.innerHTML = text;
    }
}

sbPDEditKeyDown = function(e)
{
    if(e.keyCode == 13)
        sbPDAfterEditName(e, true);
}

sbPDDeleteField = function(el_id)
{
    if(confirm("<?php echo PLUGIN_DATA_DELETE_MSG; ?>"))
    {
        var tab = sbGetE("sb_tab0");
        var categs = tab.style.display == "none" ? "1" : "0";
        var res = sbLoadSync(sb_cms_empty_file + "?event=pl_plugin_data_delete&ident=" + sbCatTree.getSelectedItemId() + "&id=" + el_id + "&categs=" + categs);
        if(res != "")
        {
            sbShowMsgDiv(res);
            return;
        }

        var el = sbGetE(el_id);
        var table = categs == "0" ? sbGetE("plugin_data_table") : sbGetE("categ_data_table");

        table = table.tBodies[0];
        table.removeChild(el);
        
        for (var i = 1; i < table.rows.length; i++)
        {
            if (i % 2 == 0)
            {
                if (_isIE)
                    table.rows[i].setAttribute("className", "even");
                else
                    table.rows[i].setAttribute("class", "even");
                table.rows[i].setAttribute("oldClassName", "even");
            }
            else
            {
                if (_isIE)
                    table.rows[i].removeAttribute("className");
                else
                    table.rows[i].removeAttribute("class");
                table.rows[i].removeAttribute("oldClassName");
            }
        }
    }
}

_sbPDPreventNsDrag = function (e, call)
{
    if(e && e.preventDefault)
    {
        e.preventDefault();
        return false;
    }
    return false;
}

sbPDChangeCheckbox = function(chk_type, el, el_id)
{
    var ch = el.checked ? 1 : 0;
    var tab = sbGetE("sb_tab0");
    var categs = tab.style.display == "none" ? "1" : "0";
        
    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_plugin_data_change&ident=" + sbCatTree.getSelectedItemId() + "&id=" + el_id + "&categs=" + categs + "&chk_type=" + chk_type + "&ch=" + ch);
    if(res != "")
    {
        sbShowMsgDiv(res);
        el.checked = !el.checked;
    }
}

sbPDEditedEl = null;

sbPDEditField = function(el, el_id)
{
    var tab = sbGetE("sb_tab0");
    var categs = tab.style.display == "none" ? "1" : "0";
    var strPage = sb_cms_modal_dialog_file + "?event=pl_plugin_data_edit&ident=" + sbCatTree.getSelectedItemId() + "&categs=" + categs;
    if (el)
    {
        strPage += "&id=" + el_id;
        sbPDEditedEl = el_id;
        sbPDChangeRowClass(el_id, "drag");
    }
    else
    {
        var el_type = sbGetE("el_type");
        var type = el_type[el_type.selectedIndex].value;
        var el_name = sbGetE("el_name");
        var title = el_name.value;
        
        strPage += "&type=" + type + "&title=" + sbEscapeEx(title);
    }
    strAttr = "resizable=1,width=800,height=600";
    
    sbShowModalDialog(strPage, strAttr, sbPDAfterEditField);
}

sbPDChangeRowClass = function(el_id, cls)
{
    var el_tr = sbGetE(el_id);
    if (el_tr)
    {
        if (!cls)
        {
            if (_isIE)
                el_tr.setAttribute("className", el_tr.getAttribute("oldClassName"));
            else
                el_tr.setAttribute("class", el_tr.getAttribute("oldClassName"));
        }
        else
        {
            if (_isIE)
            {
                if (el_tr.getAttribute("className") != "drag")
                {
                    el_tr.setAttribute("oldClassName", el_tr.getAttribute("className"));
                }
            }
            else
            {
                if (el_tr.getAttribute("class") != "drag")
                {
                    el_tr.setAttribute("oldClassName", el_tr.getAttribute("class"));
                }
            }
                   
            if (_isIE)
                el_tr.setAttribute("className", cls);
            else
                el_tr.setAttribute("class", cls);
        }
    }
}

sbPDAfterEditField = function()
{
    if (!sbModalDialog.returnValue)
    {
        if (sbPDEditedEl)
            sbPDChangeRowClass(sbPDEditedEl, null);
        sbPDEditedEl = null;
        return;
    }
    
    var res = sbModalDialog.returnValue;
    if (res.new_f)
    {
        var el_name = sbGetE("el_name");
        el_name.value = "";
        
        sbPDAddTr(res.id, res.img, res.type_title, res.type, res.title, res.info, res.sort, res.filter, res.mandatory);
    }
    else
    {
        var el_title = sbGetE("name_" + sbPDEditedEl);
        var el_info = sbGetE("info_" + sbPDEditedEl);
        var el_sort = sbGetE("sort_" + sbPDEditedEl);
        var el_filter = sbGetE("filter_" + sbPDEditedEl);
        var el_mandatory = sbGetE("mandatory_" + sbPDEditedEl);
        if (el_title)
            el_title.innerHTML = res.title;
        if (el_info)
            el_info.checked = res.info == 1;
        if (el_sort)
            el_sort.checked = res.sort == 1;
        if (el_filter)
            el_filter.checked = res.filter == 1;
        if (el_mandatory)
            el_mandatory.checked = res.mandatory == 1;
            
        sbPDChangeRowClass(sbPDEditedEl, null);
    }
    
    sbPDEditedEl = null;
}

sbPDDraggingEl = null;
sbPDOverEl = null;
sbPDTempOverEvent = new Array();

sbPDStartDrag = function(e, el)
{
    sbAddEvent(document, "mousemove", sbPDDrag);
    sbAddEvent(document, "mouseup", sbPDStopDrag);
    
    if (sbPDDraggingEl && sbPDDraggingEl != el)
        sbPDChangeRowClass(sbPDDraggingEl.id, null);
        
    sbPDChangeRowClass(el.id, "drag");
    sbPDDraggingEl = el;
    
    if(_isIE)
    {
        window.document.body.setCapture();
    }
    else
    {
        if (window.parent.frames)
        {
            for(var i=0; i<window.parent.frames.length; i++)
            {
                if(window.parent.frames[i] != window)
                {
                    sbPDTempOverEvent[sbPDTempOverEvent.length] = window.parent.frames[i].onmouseover;
                    window.parent.frames[i].onmouseover = sbPDStopDrag;
                }
            }
        }
    }
}

sbPDSetBorder = function(el, border)
{
    if (el)
    {
        var childs = el.childNodes;
        for(var i = 0; i < childs.length; i++)
        {
            if(childs[i].tagName == "TD")
            {
                if (_isIE)
                    childs[i].style.borderTopColor = border;
                else
                    childs[i].style.borderTop = "1px solid " + border;
            }
        }
    }
}

sbPDDrag = function(e)
{
    if (!sbPDDraggingEl)
    {
        sbPDOverEl = null;
        return;
    }
    
    var el = sbEventTarget(e);
    if (!el)
        return;
        
    while(el && el.tagName != "TR")
        el = el.parentNode;

    if (!el)
        return;
        
    var table = el; 
    while(table.tagName != "TABLE")
        table = table.parentNode;
    
    if (table.id != "categ_data_table" && table.id != "plugin_data_table")
        return;

    var first_tr = table.tBodies[0].childNodes[0];
    
    var tab = sbGetE("sb_tabs_con");
    var a1=sbGetAbsoluteTop(el);
    var a2=sbGetAbsoluteTop(tab);

    if(a1-a2-parseInt(tab.scrollTop)>parseInt(tab.offsetHeight)-50)
        tab.scrollTop=parseInt(tab.scrollTop)+30;
    if(a1-a2<parseInt(tab.scrollTop)+30)
        tab.scrollTop=parseInt(tab.scrollTop)-30;
        
    if (el == sbPDDraggingEl || el == sbPDDraggingEl.nextSibling || el == first_tr)
    {
        sbPDSetBorder(sbPDOverEl, "#FFF5E0");
        sbPDOverEl = null;
        return;
    }

    sbPDSetBorder(sbPDOverEl, "#FFF5E0");
    sbPDSetBorder(el, "black");
    sbPDOverEl = el;
}

sbPDStopDrag = function(e)
{
    if(_isIE)
    {
        window.document.body.releaseCapture();
    }
    else
    {
        if (window.parent.frames)
        {
            for(var i=0; i<window.parent.frames.length; i++)
            {
                if(window.parent.frames[i] != window)
                {
                    window.parent.frames[i].onmouseover = sbPDTempOverEvent.shift();
                }
            }
        }
    }
    
    sbRemoveEvent(document, "mousemove", sbPDDrag);
    sbRemoveEvent(document, "mouseup", sbPDStopDrag);

    if (!sbPDDraggingEl || !sbPDOverEl)
        return;
    
    sbPDSetBorder(sbPDOverEl, "#FFF5E0"); 
        
    var tab = sbGetE("sb_tab0");
    var categs = tab.style.display == "none" ? "1" : "0";
    var res = sbLoadSync(sb_cms_empty_file + "?event=pl_plugin_data_sort&ident=" + sbCatTree.getSelectedItemId() + "&id=" + sbPDDraggingEl.id + "&prev_id=" + sbPDOverEl.id + "&categs=" + categs);
    
    if (res != "")
    {
        sbPDOverEl = null;
        sbShowMsgDiv(res);
        return;
    }
    
    var table = (categs == "1" ? sbGetE("categ_data_table") : sbGetE("plugin_data_table"));
    table = table.tBodies[0];
    table.insertBefore(sbPDDraggingEl, sbPDOverEl);

    for (var i = 1; i < table.rows.length; i++)
    {
        if (i % 2 == 0)
        {
            if (_isIE)
                table.rows[i].setAttribute("className", "even");
            else
                table.rows[i].setAttribute("class", "even");
            table.rows[i].setAttribute("oldClassName", "even");
        }
        else
        {
            if (_isIE)
                table.rows[i].removeAttribute("className");
            else
                table.rows[i].removeAttribute("class");
            table.rows[i].removeAttribute("oldClassName");
        }
    }
    
    sbPDDraggingEl = null;
    sbPDOverEl = null;
}
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>