<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
function sbTree(htmlObject,width,height,rootId)
{
    // определяем родительский объект
    if(typeof(htmlObject)!="object")
        this.parentObject=sbGetE(htmlObject);
    else
        this.parentObject=htmlObject;

    this.mytype="sbTree";
    this.active=true;
    this.width=width; // ширина дерева
    this.height=height; // высота дерева
    this.def_img_x="18px"; // ширина иконки по умолчанию
    this.def_img_y="18px"; // высота иконки по умолчанию
    this.style_pointer="default"; // вид курсора при наведении на элемент дерева
    this.rootId=rootId; // идентификатор корневого уровня
    this.checkBoxes=true; // разрешены или нет чекбоксы
    this.checkBoxesLevel=-1; // уровень, с которого разрешены чекбоксы
    this.multiSelect=false; // разрешен ли множественный выбор
    this.cMenu=null; // контекстное меню

    // переменные для работы с DragAndDrop
    if (typeof(sbDragAndDrop) == "function")
    {
        this.dragAndDrop=true; // DragAndDrop включен (true)
        this.dragger= new sbDragAndDrop();
    }
    else
    {
        this.dragAndDrop=false; // DragAndDrop включен (true)
        this.dragger= null;
    }
    this.dadmode=2; // режим DragAndDrop (0 - только вложения, 1 - только вниз и вверх, 2 - и то, и другое
    this.dadlevel=0; // с какого уровня разрешено перетаскивание
    this.dadupdown=1; // можно ли перетаскивать вниз и вверх на одном уровне

    this.autoScroll=true; // прокрутка при перетаскивании
    this.lastSelected=null;
    this.lastMenuSelected=null;
    this.prevNode=null;
    this._autoOpenTimer=null;
    this._autoOpenId=0;
    this._selId=0;
    this.waitCall=null;

    this._aimgs=true; // разрешено или нет перетаскивание за картинку
    this.treeLinesOn=true; //отображать или нет линии дерева

    // переменные для работы с XML
    this.XMLLoader=new sbXMLLoader(this._parseXMLTree,this);
    this.XMLloadingWarning=0; // 1, если идет парсинг XML
    this.XMLsource=0; // URL файла, из которого идет динамическая подгрузка
    this.xmlstate=0; // был ли распарсен XML
    this.XMLLoadDopStr=""; // строка, добавляемая к адресу при подгрузке

    // переменные для работы с картинками
    this.treeIm=true;
    this.imPath="images/"; // путь к файлам с картинками
    // иконки чекбоксов
    // не отмечен, отмечен, частично отмечен, недоступен
    this.checkArray=new Array("iconUnCheckAll.gif","iconCheckAll.gif");
    // иконки линий дерева
    // левый нижний угол, T-образная, левый верхний, вертикальная черта
    this.lineArray=new Array("line2.gif","line3.gif","line4.gif","blank.gif","blank.gif","line1.gif");
    // иконки "минуса"
    // левый нижний минус, T-образный минус, левый верхний минус, простой минус, горизонтальный минус
    this.minusArray=new Array("minus2.gif","minus3.gif","minus4.gif","minus.gif","minus5.gif");
    // иконки "плюса"
    // левый нижний плюс, T-образный плюс, левый верхний плюс, простой плюс, горизонтальный плюс
    this.plusArray=new Array("plus2.gif","plus3.gif","plus4.gif","plus.gif","plus5.gif");
    // иконки папок
    // без вложений, открытая, закрытая
    this.imageArray=new Array("folderClosed.gif","folderOpen.gif","folderClosed.gif", "folderClosedCl.gif","folderOpenCl.gif","folderClosedCl.gif");
    this.cutImages=new Array("folderClosedCut.gif","folderOpenCut.gif","folderClosedCut.gif", "folderClosedCutCl.gif","folderOpenCutCl.gif","folderClosedCutCl.gif"); // иконки для вырезанных папок
    this.copyImages=new Array("folderClosedCopy.gif","folderOpenCopy.gif","folderClosedCopy.gif", "folderClosedCopyCl.gif","folderOpenCopyCl.gif","folderClosedCopyCl.gif"); // иконки для скопированных папок

    // массивы элементов
    this._gis=new Array(); // хранит ID элементов
    this._gns=new Array(); // хранит сами элементы
    this._gissi=0;

    this.nodeCut=0; // вырезанный элемент
    this.nodeCopy=0; // скопированный элемент
    this.pasteEls=new Array(); // массив скопированных или вырезанных элементов
    this.oldImg= new Array(0,0,0); // хранит "старые" иконки папок

    this.checkFuncHandler=0; // функция, вызываемая при пометке чекбокса
    this.openFuncHandler=0; // функция, вызываемая при открытии папки
    this.dblclickFuncHandler=0; // функция, вызываемая при двойном щелчке по папке
    this.pasteFuncHandler=0; // функция, вызываемая при попытке вставить элементы
    this.dragFunc=0; // функция, вызываемая перед Drop
    this.moveFunc=0; // функция, вызываемая при перетаскивании
    this.dropFunc=0; // функция, вызываемая после Drop
    this.arFunc=0; // функция, вызываемая при щелчке правой кнопкой
    this.aFunc=0; // функция, вызываемая при клике

    this.htmlNode=new sbTreeItem(this.rootId,"",0,this);
    this.htmlNode.htmlNode.childNodes[0].childNodes[0].style.display="none";
    this.htmlNode.htmlNode.childNodes[0].childNodes[0].childNodes[0].className="hiddenRow";

    this.allTree=this._createSelf();
    this.allTree.appendChild(this.htmlNode.htmlNode);
    this.allTree.onselectstart=new Function("return false;");

    this.selectionBar=document.createElement("DIV");
    this.selectionBar.className="treeSelectionBar";
    this.selectionBar.innerHTML="&nbsp;";
    this.selectionBar.style.display="none";

    this.allTree.appendChild(this.selectionBar);

    return this;
};
var btpt=sbTree.prototype;
// Создает и возвращает основной HTML-элемент дерева
btpt._createSelf=function()
{with(this){
    var div=document.createElement('div');
    div.className="treeContainer";
    if (this.width != "")
        div.style.width=this.width;
    if (this.height != "")
        div.style.height=this.height;

    parentObject.appendChild(div);

    return div;
}};

function sbTreeItem(itemId,itemText,parentObject,treeObject,actionHandler,mode)
{
    this.htmlNode="";
    this.acolor="";
    this.scolor="";
    this.tr=0;
    this.childsCount=0;
    this.span=0;
    this.childNodes=new Array();
    this.userData=new Array();

    this.copied=0;
    this.secure=0;
    this.selected=0;
    this.level=0;
    this.checkstate=0;
    this.treeNod=treeObject;
    this.label=itemText;
    this.parentObject=parentObject;
    this.actionHandler=actionHandler;
    this.images=new Array(treeObject.imageArray[0],treeObject.imageArray[1],treeObject.imageArray[2],treeObject.imageArray[3],treeObject.imageArray[4],treeObject.imageArray[5]);
    
    this.cutImages=new Array(treeObject.cutImages[0],treeObject.cutImages[1],treeObject.cutImages[2],treeObject.cutImages[3],treeObject.cutImages[4],treeObject.cutImages[5]);
    this.copyImages=new Array(treeObject.copyImages[0],treeObject.copyImages[1],treeObject.copyImages[2],treeObject.copyImages[3],treeObject.copyImages[4],treeObject.copyImages[5]);
    this.normImages=this.images;
    
    this.id=treeObject._gisa(itemId,this);
    if(this.treeNod.checkBoxes)this.htmlNode=this.treeNod._createItem(1,this,mode);
    else this.htmlNode=this.treeNod._createItem(0,this,mode);

    return this;
};

// Добавляет новый элемент в массив элементов и возвращает его ID.
// Если указанный ID уже существует в массиве, то к ID прибавляется текущее время + "_"
// _globalIdStorageAdd
btpt._gisa=function(itemId,itemObject)
{with(this){
    if(_gisf(itemId))
    {
        d=new Date();
        itemId=d.valueOf()+"_"+itemId;
        return _gisa(itemId,itemObject);
    }

    _gis[_gissi]=itemId;
    _gns[_gissi]=itemObject;
    _gissi++;

    return itemId;
}};

// Удаляет указанный элемент из массива элементов
// _globalIdStorageSub
btpt._giss=function(itemId)
{with(this){
    for(var i=0;i < _gissi;i++)
        if(_gis[i]==itemId)
        {
            _gis[i]=_gis[_gissi-1];
            _gns[i]=_gns[_gissi-1];
            _gissi--;
            _gis[_gissi]=0;
            _gns[_gissi]=0;
            break;
        }
}};

// Заменяет ID у указанного элемента из массива элементов
// _globalIdStorageReplace
btpt._gisr=function(itemId, newId)
{with(this){
    for(var i=0;i < _gissi;i++)
        if(_gis[i]==itemId)
        {
            _gis[i]=newId;
            _gns[i].id=newId;
            break;
        }
}};

// Ищет элемент в глобальном массиве элементов по его ID.
// _globalIdStorageFind
btpt._gisf=function(itemId)
{with(this){
    for(var i=0;i < _gissi;i++)
        if(_gis[i]==itemId)
        {
            return _gns[i];
        }

    return null;
}};

// Создает дерево по переданной XML-структуре
// afterCall - функция, которая будет вызвана после подгрузки XML
btpt.loadXMLString=function(xmlString,afterCall)
{with(this){
    if (!active) return;
    xmlstate=1;
    waitCall=afterCall||0;
    XMLLoader.loadXMLString(xmlString);
}};

// Подгружает дерево из указанного XML-файла
// afterCall - функция, которая будет вызвана после подгрузки XML
btpt.loadXML=function(file,afterCall)
{with(this){ 
    if (!active) return;
    xmlstate=1;
    waitCall=afterCall||0;
    if (waitCall)
        sbShowMsgDiv('<?php echo TREE_LOADING; ?>', 'loading.gif', false);
    XMLLoader.loadXML(file+XMLLoadDopStr);
}};

// Распарсивает XML
// dhtmlObject - объект дерева
// node - рутовый объект XML
// parentId - ID родительского элемента
// level - уровень дерева
btpt._parseXMLTree=function(dhtmlObject,node,parentId,level)
{
    if (!dhtmlObject.active) return;
    if(!dhtmlObject.parsCount)
        dhtmlObject.parsCount=1;
    else
        dhtmlObject.parsCount++;

    dhtmlObject.XMLloadingWarning=1;
    var nodeAskingCall="";

    if(!node)
    {
        node=dhtmlObject.XMLLoader.getXMLTopNode("tree");
        parentId=node.getAttribute("id");
        dhtmlObject.parsingOn=parentId;
        dhtmlObject.parsedArray=new Array();
        dhtmlObject.setCheckList="";
    }

    for(var i=0;i < node.childNodes.length;i++)
    {
        if((node.childNodes[i].nodeType==1)&&(node.childNodes[i].tagName == "item"))
        {
            var nodx=node.childNodes[i];
            var name=nodx.getAttribute("text");
            var cId=nodx.getAttribute("id");

            var aColor=nodx.getAttribute("aCol");
            var sColor=nodx.getAttribute("sCol");

            var chd=nodx.getAttribute("child");

            var atop=nodx.getAttribute("top");
            var aopen=nodx.getAttribute("open");
            var aselect=nodx.getAttribute("select");
            var acall=nodx.getAttribute("call");
            var achecked=nodx.getAttribute("checked");
            var tooltip = nodx.getAttribute("tooltip");
            var nocheckbox = nodx.getAttribute("nocheckbox");
            var style = nodx.getAttribute("style");
            var asecure = nodx.getAttribute("secure");
            var alevel = nodx.getAttribute("level");

            var im0 = nodx.getAttribute("im0");
            var im1 = nodx.getAttribute("im1");
            var im2 = nodx.getAttribute("im2");
            var im3 = nodx.getAttribute("im3");
            var im4 = nodx.getAttribute("im4");
            var im5 = nodx.getAttribute("im5");
            
            var im_copy0 = nodx.getAttribute("im_copy0");
            var im_copy1 = nodx.getAttribute("im_copy1");
            var im_copy2 = nodx.getAttribute("im_copy2");
            var im_copy3 = nodx.getAttribute("im_copy3");
            var im_copy4 = nodx.getAttribute("im_copy4");
            var im_copy5 = nodx.getAttribute("im_copy5");
            
            var im_cut0 = nodx.getAttribute("im_cut0");
            var im_cut1 = nodx.getAttribute("im_cut1");
            var im_cut2 = nodx.getAttribute("im_cut2");
            var im_cut3 = nodx.getAttribute("im_cut3");
            var im_cut4 = nodx.getAttribute("im_cut4");
            var im_cut5 = nodx.getAttribute("im_cut5");
            
            var zST="";

            if(aselect) zST+=",SELECT";
            if(atop) zST+=",TOP";
            if(aopen) zST+=",OPEN";
            if(achecked) zST+=",CHECKED";
            if(asecure) zST+=",SECURE";

            if(acall) nodeAskingCall=cId;

            var temp=dhtmlObject._gisf(parentId);
            temp.XMLload=1;
            var newNode=dhtmlObject.insertNewChild(parentId,cId,name,0,zST,chd);

            newNode.level = alevel;
            
            if (im0)
                newNode.images[0] = im0;
            if (im1)
                newNode.images[1] = im1;
            if (im2)
                newNode.images[2] = im2;
            if (im3)
                newNode.images[3] = im3;
            if (im4)
                newNode.images[4] = im4;
            if (im5)
                newNode.images[5] = im5;

            if (im_copy0)
                newNode.copyImages[0] = im_copy0;
            if (im_copy1)
                newNode.copyImages[1] = im_copy1;
            if (im_copy2)
                newNode.copyImages[2] = im_copy2;
            if (im_copy3)
                newNode.copyImages[3] = im_copy3;
            if (im_copy4)
                newNode.copyImages[4] = im_copy4;
            if (im_copy5)
                newNode.copyImages[5] = im_copy5;
                
            if (im_cut0)
                newNode.cutImages[0] = im_cut0;
            if (im_cut1)
                newNode.cutImages[1] = im_cut1;
            if (im_cut2)
                newNode.cutImages[2] = im_cut2;
            if (im_cut3)
                newNode.cutImages[3] = im_cut3;
            if (im_cut4)
                newNode.cutImages[4] = im_cut4;
            if (im_cut5)
                newNode.cutImages[5] = im_cut5;
                
            newNode.normImages = newNode.images;
            
            if(tooltip) newNode.span.parentNode.title=tooltip;
            if(style) newNode.span.style.cssText+=(";"+style);

            if(nocheckbox)
            {
                newNode.span.parentNode.previousSibling.previousSibling.childNodes[0].style.display='none';
                newNode.nocheckbox=true;
            }

            dhtmlObject.setItemColor(newNode,aColor,sColor);

            var zcall="";
            zcall=dhtmlObject._parseXMLTree(dhtmlObject,node.childNodes[i],cId,1);
            if(zcall!="") nodeAskingCall=zcall;
        }
        else
        {
            if((node.childNodes[i].nodeType==1)&&(node.childNodes[i].tagName == "userdata"))
            {
                var name=node.childNodes[i].getAttribute("name");
                if((name)&&(node.childNodes[i].childNodes[0]))
                {
                    dhtmlObject.setUserData(parentId,name,node.childNodes[i].childNodes[0].data);
                };
            };
        }
    };

    if(!level)
    {
        if (dhtmlObject.nodeCopy || dhtmlObject.nodeCut)
        {
            var tmpId = parentId;
            while (tmpId)
            {
                if (dhtmlObject.nodeCopy.id == tmpId)
                {
                    dhtmlObject._changeSubImages(dhtmlObject.nodeCopy, "copy");
                    break;
                }
                else if (dhtmlObject.nodeCut.id == tmpId)
                {
                    dhtmlObject._changeSubImages(dhtmlObject.nodeCut, "cut");
                    break;
                }
                tmpId = dhtmlObject.getParentId(tmpId);
            }
        }

        var parsedNodeTop=dhtmlObject._gisf(dhtmlObject.parsingOn);
        for(var i=0;i < dhtmlObject.parsedArray.length;i++)
            parsedNodeTop.htmlNode.childNodes[0].appendChild(dhtmlObject.parsedArray[i]);

        dhtmlObject.parsingOn=0;
        dhtmlObject.lastLoadedXMLId=parentId;

        dhtmlObject.XMLloadingWarning=0;
        var chArr=dhtmlObject.setCheckList.split(",");
        for(var n=0;n < chArr.length;n++)
            if(chArr[n])dhtmlObject.setCheck(chArr[n],1);

        dhtmlObject._rf(dhtmlObject);

        if(nodeAskingCall!="")
            dhtmlObject.selectItem(nodeAskingCall,true);

        if(dhtmlObject.waitCall)
            dhtmlObject.waitCall();
    }

    if(dhtmlObject.parsCount==1)
    {
        dhtmlObject.xmlstate=1;
    }
    dhtmlObject.parsCount--;

    return nodeAskingCall;
};

// Создает новую строку таблицы и возвращает ее
// _drawNewTr
btpt._dnt=function(htmlObject)
{
    var tr =document.createElement('tr');
    var td1=document.createElement('td');
    var td2=document.createElement('td');

    td1.appendChild(document.createTextNode(" "));
    td2.colSpan=3;
    td2.appendChild(htmlObject);
    tr.appendChild(td1);
    tr.appendChild(td2);

    return tr;
};

// Добавляет новый элемент в дерево
// parentObject - родительский элемент
// itemId - ID нового элемента
// itemText - текст нового элемент
// itemLevel - уровень нового элемента
// itemActionHandler - функция, вызываемая при выборе нового элемента
// image1 - изображение для элемента без вложенных элементов
// image2 - изображение для свернутого элемента
// image3 - изображение для развернутого элемента
// optionStr - строка опций
// childs - есть вложеннные элементы (1) или нет (0)
// beforeNode - элемент, после которого будет вставлен текущий элемент
// _attachChildNode
btpt._acn=function(parentObject,itemId,itemText,itemActionHandler,optionStr,childs,beforeNode)
{with(this){
    if(beforeNode)
        parentObject=beforeNode.parentObject;

    if(parentObject.XMLload==0&&XMLsource&&!XMLloadingWarning)
    {
        parentObject.XMLload=1;
        loadXML(XMLsource+sbGetUrlSymbol(XMLsource)+"id="+escape(parentObject.id));
        return;
    }

    var Count=parentObject.childsCount;
    var Nodes=parentObject.childNodes;

    if(beforeNode)
    {
        var ik,jk;
        for(ik=0;ik < Count;ik++)
            if(Nodes[ik]==beforeNode)
            {
                for(jk=Count;jk!=ik;jk--)
                    Nodes[1+jk]=Nodes[jk];
                break;
            }
        ik++;
        Count=ik;
    }

    if((!itemActionHandler)&&(aFunc)) itemActionHandler=aFunc;

    if(optionStr)
    {
        var tempStr=optionStr.split(",");
        for(var i=0;i < tempStr.length;i++)
        {
            switch(tempStr[i])
            {
                case "TOP": if(parentObject.childsCount>0)
                            {
                                beforeNode=new Object;
                                beforeNode.tr=parentObject.childNodes[0].tr.previousSibling;
                            }
                            for(ik=0;ik < Count;ik++)
                                Nodes[ik+Count]=Nodes[ik+Count-1];
                            Count=0;
                            break;
            }
        };
    };

    Nodes[Count]=new sbTreeItem(itemId,itemText,parentObject,this,itemActionHandler,1);
    parentObject.childsCount++;
    var tr=_dnt(Nodes[Count].htmlNode);
    if(XMLloadingWarning)
        Nodes[Count].htmlNode.parentNode.parentNode.style.display="none";

    if((beforeNode)&&(beforeNode.tr.nextSibling))
        parentObject.htmlNode.childNodes[0].insertBefore(tr,beforeNode.tr.nextSibling);
    else
        if((parsingOn)&&(parsingOn==parentObject.id))
        {
            parsedArray[parsedArray.length]=tr;
        }
        else
            parentObject.htmlNode.childNodes[0].appendChild(tr);

    if((beforeNode)&&(!beforeNode.span))beforeNode=null;

    if(XMLsource)if((childs)&&(childs!=0))Nodes[Count].XMLload=0;else Nodes[Count].XMLload=1;

    Nodes[Count].tr=tr;
    tr.nodem=Nodes[Count];

    if(parentObject.itemId==0)
        tr.childNodes[0].className="treeHiddenItem";

    if(optionStr)
    {
        var tempStr=optionStr.split(",");
        for(var i=0;i < tempStr.length;i++)
        {
            switch(tempStr[i])
            {
                 case "SELECT": selectItem(itemId,false);break;
                 case "CALL": selectItem(itemId,true);break;
                 case "CHILD": Nodes[Count].XMLload=0;break;
                 case "CHECKED":
                    if(XMLloadingWarning)
                        setCheckList+=","+itemId;
                    else
                        setCheck(itemId,1);
                    break;
                 case "OPEN": Nodes[Count].openMe=1;break;
                 case "SECURE": Nodes[Count].secure=1;break;
            }
        };
    };

    if(!XMLloadingWarning)
    {
        if(_gos(parentObject)< 0)
            openItem(parentObject.id);

        if(beforeNode)
        {
            _cp(beforeNode);
            _cl(beforeNode);
        }

        _cp(parentObject);
        _cl(parentObject);
        _cp(Nodes[Count]);

        if(parentObject.childsCount>=2)
        {
            _cp(Nodes[parentObject.childsCount-2]);
            _cl(Nodes[parentObject.childsCount-2]);
        }
        if(parentObject.childsCount!=2) _cp(Nodes[0]);
    }

    return Nodes[Count];
}};

// Добавляет новый элемент в дерево
// parentId - ID родительского элемента
// itemId - ID нового элемента
// itemText - текст нового элемента
// itemActionHandler - функция обработчик клика на элементе
// optionStr - строка опций (SELECT-выделить после вставки, CALL-вызвать функцию обработчик клика,
//                           CHECKED-помечен, CHILD-есть потомки, OPEN-развернуть ветку, SECURE-закрытый раздел)
// childs - есть вложенные элементы или нет
btpt.insertNewChild=function(parentId,itemId,itemText,itemActionHandler,optionStr,childs)
{with(this){
    var parentObject=_gisf(parentId);
    if(!parentObject) return(-1);

    return _acn(parentObject,itemId,itemText,itemActionHandler,optionStr,childs);
}};

// перерисовывает дерево, начиная с указанного уровня
// dhtmlObject - дерево
// itemObject - элемент, с которого будет перерисовываться дерево
// _redrawFrom
btpt._rf=function(dhtmlObject,itemObject)
{with(this){
    if(!itemObject)
    {
        var tempx=dhtmlObject._gisf(dhtmlObject.lastLoadedXMLId);
        dhtmlObject.lastLoadedXMLId=-1;
        if(!tempx)return 0;
    }
    else tempx=itemObject;

    for(var i=0;i< tempx.childsCount;i++)
    {
        if(!itemObject) tempx.childNodes[i].htmlNode.parentNode.parentNode.style.display="";
        if(tempx.childNodes[i].openMe==1)
        {
            _openItem(tempx.childNodes[i]);
            tempx.childNodes[i].openMe=0;
        }
        dhtmlObject._rf(dhtmlObject,tempx.childNodes[i]);
    };

    dhtmlObject._cl(tempx);
    dhtmlObject._cp(tempx);
}};

// Сворачивает указанную ветку
// _closeAll
btpt._ca=function(itemObject, rhide)
{with(this){
    if(rhide) _HideShow(itemObject,1);

    for(var i=0;i< itemObject.childsCount;i++)
        _ca(itemObject.childNodes[i], true);
}};

// Разворачивает указанную ветку
// _openAll
btpt._oa=function(itemObject)
{with(this){
    _HideShow(itemObject,2,true);
    for(var i=0;i< itemObject.childsCount;i++)
        _oa(itemObject.childNodes[i]);
}};

// Устанавливает корректную строку дерева и изображения элементов
// _correctPlus
btpt._cp=function(itemObject)
{with(this){
    var workArray=lineArray;
    var tmp=itemObject.htmlNode.childNodes[0].childNodes[0].childNodes[2].childNodes[0];
    if((XMLsource)&&(!itemObject.XMLload))
    {
        var workArray=plusArray;
        if (itemObject.secure)
            tmp.src=imPath+itemObject.images[5];
        else
            tmp.src=imPath+itemObject.images[2];
    }
    else
        if((itemObject.childsCount)||(itemObject.unParsed))
        {
            if((itemObject.htmlNode.childNodes[0].childNodes[1])&&(itemObject.htmlNode.childNodes[0].childNodes[1].style.display!="none"))
            {
                if(!itemObject.wsign) var workArray=minusArray;
                if (itemObject.secure)
                    tmp.src=imPath+itemObject.images[4];
                else
                    tmp.src=imPath+itemObject.images[1];
            }
            else
            {
                if(!itemObject.wsign) var workArray=plusArray;
                if (itemObject.secure)
                    tmp.src=imPath+itemObject.images[5];
                else
                    tmp.src=imPath+itemObject.images[2];
            }
        }
        else
        {
            if (itemObject.secure)
                tmp.src=imPath+itemObject.images[3];
            else
                tmp.src=imPath+itemObject.images[0];
        }

    var tempNum=2;
    tmp=itemObject.htmlNode.childNodes[0].childNodes[0].childNodes[0].childNodes[0];
    if(!itemObject.treeNod.treeLinesOn)
    {
        tmp.src=imPath+workArray[3];
    }
    else
    {
        if(itemObject.parentObject) tempNum=_gcs(itemObject.id,itemObject.parentObject);
        tmp.src=imPath+workArray[tempNum];
    }
}};

// Устанавливает корректные изображения для линий дерева
// _correctLine
btpt._cl=function(itemObject)
{with(this){
    var sNode=itemObject.parentObject;
    var tmp=itemObject.htmlNode.childNodes[0];
    try
    {
        if(sNode)
            if((_gls(itemObject.id,sNode)==0)||(!treeLinesOn))
            {
                for(var i=1;i<= itemObject.childsCount;i++)
                {
                    tmp.childNodes[i].childNodes[0].style.backgroundImage="";
                    tmp.childNodes[i].childNodes[0].style.backgroundRepeat="";
                }
            }
            else
                for(var i=1;i<= itemObject.childsCount;i++)
                {
                    tmp.childNodes[i].childNodes[0].style.backgroundImage="url("+imPath+lineArray[5]+")";
                    tmp.childNodes[i].childNodes[0].style.backgroundRepeat="repeat-y";
                }
    }
    catch(e){};
}};

// Возвращает тип элемента
// itemId - ID элемента
// itemObject - родительский элемент
// _getCountStatus
btpt._gcs=function(itemId,itemObject)
{with(this){
    try
    {
        if(itemObject.childsCount<= 1) {if(itemObject.id==rootId)return 4;else return 0;}

        if(itemObject.htmlNode.childNodes[0].childNodes[1].nodem.id==itemId) if(!itemObject.id)return 2;else return 1;
        if(itemObject.htmlNode.childNodes[0].childNodes[itemObject.childsCount].nodem.id==itemId)return 0;
    }
    catch(e){};

    return 1;
}};

// Возвращает тип элемента
// itemId - ID элемента
// itemObject - родительский элемент
// _getLineStatus
btpt._gls =function(itemId,itemObject)
{
    if(itemObject.htmlNode.childNodes[0].childNodes[itemObject.childsCount].nodem.id==itemId)
        return 0;

    return 1;
}

// Сворачивает/Разворачивает элемент
// itemObject - элемент
// mode - свернуть (1) развернуть (2)
btpt._HideShow=function(itemObject,mode,open)
{with(this){
    if((XMLsource)&&(!itemObject.XMLload))
    {
        itemObject.XMLload=1;
        loadXML(XMLsource+sbGetUrlSymbol(XMLsource)+"id="+escape(itemObject.id)+(open ? "&open=1" : ""), _selectItemAfterLoad);
        return;
    };

    var Nodes=itemObject.htmlNode.childNodes[0].childNodes;
    var Count=Nodes.length;
    if(Count>1)
    {
        if((Nodes[1].style.display!="none"||mode==1)&&mode!=2)
        {
            allTree.childNodes[0].border = "1";
            allTree.childNodes[0].border = "0";
            nodestyle="none";
        }
        else nodestyle="";

        for(var i=1;i< Count;i++)
            Nodes[i].style.display=nodestyle;
    }
    _cp(itemObject);
}};

// Возвращает состояние элемента
// itemObject - элемент
// _getOpenState
btpt._gos=function(itemObject)
{
    if(!itemObject) return;

    var z=itemObject.htmlNode.childNodes[0].childNodes;
    if (itemObject.XMLload == 0)
        return -1;

    if(z.length<= 1)
        return 0;
    if(z[1].style.display!="none")
        return 1;
    else
        return -1;
}

// ondblclick событие элемента
btpt.onRowClick2=function()
{with(this){
    if (!parentObject.treeNod.active) return 0;
    if(parentObject.treeNod.dblclickFuncHandler)
        if(!parentObject.treeNod.dblclickFuncHandler(parentObject.id))
            return 0;

    parentObject.treeNod._HideShow(parentObject);
}};

// onclick событие элемента
btpt.onRowClick=function()
{with(this){
    if (!parentObject.treeNod.active) return 0;
    if(parentObject.treeNod.openFuncHandler) if(!parentObject.treeNod.openFuncHandler(parentObject.id,parentObject.treeNod._gos(parentObject)))return 0;

    parentObject.treeNod._HideShow(parentObject);
}};

// Визуально выделяет элемент (для контекстного меню)
btpt._selectMenuItem=function(node)
{with(this){
    _unselectMenuItem();
    if (multiSelect)
    {
        var selItems=getAllSelected().split("^");
        var found=false;
        for (var i=0;i< selItems.length;i++)
        {
            if (selItems[i]==node.id)
            {
                found=true;
                break;
            }
        }
        if (!found)
            node.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].className="treeDragSelected";
        else
            node.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].className="treeMenuSelected";
    }
    else
    {
        if(node!=lastSelected)
            node.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].className="treeDragSelected";
        else
            node.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].className="treeMenuSelected";
    }
    
    lastMenuSelected=node;
}};

// Снимает выделение с элемента
btpt._unselectMenuItem=function()
{with(this){
    if (typeof(tree)=="undefined")
        var tree=this;

    if(tree.lastMenuSelected)
    {
    	try
    	{
	        if (tree.multiSelect)
	        {
	            var selItems=tree.getAllSelected().split("^");
	            var found=false;
	            for (var i=0;i< selItems.length;i++)
	            {
	                if (selItems[i]==tree.lastMenuSelected.id)
	                {
	                    found=true;
	                    break;
	                }
	            }
	            if (!found)
	                tree.lastMenuSelected.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].className="treeItem";
	            else
	                tree.lastMenuSelected.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].className="treeSelected";
	        }
	        else
	        {
	            if (tree.lastMenuSelected!=tree.lastSelected)
	                tree.lastMenuSelected.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].className="treeItem";
	            else
	                tree.lastMenuSelected.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].className="treeSelected";
	        }
	        tree.lastMenuSelected=null;
	    }
	    catch (e) { tree.lastMenuSelected=null; }    
    }
}};

// Событие при выделение элемента
// e - событие
// htmlObject - элемент
// mode - если false вызываем onSelect
btpt.onRowSelect=function(e,htmlObject,mode,notcall)
{with(this){
    if(!htmlObject)
        htmlObject=parentObject.span.parentNode;

    var tree = htmlObject.parentObject.treeNod;
    if (!tree.active) return 0;
    var span = htmlObject.parentObject.span;

    if (tree.multiSelect)
    {
        if(htmlObject.parentObject.selected==1)
        {
            var lastId="";
            htmlObject.parentObject.selected = 0;
            htmlObject.parentObject.span.className="treeItem";
            if(htmlObject.parentObject.acolor)
                htmlObject.parentObject.span.style.color=htmlObject.parentObject.acolor;
        }
        else
        {
            span.className="treeSelected";

            if(htmlObject.parentObject.scolor)
                span.style.color=htmlObject.parentObject.scolor;

            if (tree.lastSelected)
                var lastId=tree.getSelectedItemId();
            else
                var lastId="";

            tree.lastSelected=htmlObject.parentObject;
            htmlObject.parentObject.selected = 1;
        }
    }
    else
    {
        span.className="treeSelected";

        if(htmlObject.parentObject.scolor)
            span.style.color=htmlObject.parentObject.scolor;

        if(tree.lastSelected&&tree.lastSelected!=htmlObject.parentObject)
        {
            var lastId=tree.getSelectedItemId();
            tree.lastSelected.selected = 0;
            tree.lastSelected.span.className="treeItem";
            if(tree.lastSelected.acolor)
                tree.lastSelected.span.style.color=tree.lastSelected.acolor;
        }
        else
            var lastId="";

        tree.lastSelected=htmlObject.parentObject;
        htmlObject.parentObject.selected = 1;
    }

    if(!mode&&!notcall)
    {
        if(htmlObject.parentObject.actionHandler)
            htmlObject.parentObject.actionHandler(htmlObject.parentObject.id,lastId);
    }
}};

btpt.onRowRClick=function(e)
{with(this){
    if (!e) e=window.event;
        
    var node = this.childNodes[0].parentObject;
    var tree = node.treeNod;
    if (!tree.active) return 0;
    if(tree.arFunc)
    {
        if(!tree.arFunc(node.id))
            return false;
    }

    if (tree.cMenu)
    {
        tree.cMenu.hide();
        tree._selectMenuItem(node);
        tree.cMenu.tree=tree;
        tree.cMenu.hideFunc=tree._unselectMenuItem;
        tree.cMenu.show(e);
    }   
    
    return sbCancelEvent(e);
}};

// Событие при пометке checkbox-а
btpt.onCheckBoxClick=function(e)
{with(this){
    if (!treeNod.active) return 0;
    if(treeNod.checkFuncHandler)
        if (!treeNod.checkFuncHandler(parentObject.id,(parentObject.checkstate==1?0:1)))
            return 0;

    if(parentObject.checkstate==1)
        treeNod._setCheck(parentObject,false);
    else
        treeNod._setCheck(parentObject,true);

    return 1;
}};

// Создает HTML-код элемента
// acheck - доступен или нет checkbox
// itemObject - элемент

btpt._createItem=function(acheck,itemObject,mode)
{with(this){
    var table=document.createElement('table');

    table.cellSpacing=0;
    table.cellPadding=0;
    table.border=0;
    table.style.margin=0;
    table.style.padding=0;

    var tbody=document.createElement('tbody');
    var tr=document.createElement('tr');

    var td1=document.createElement('td');
    td1.vAlign="top";
	td1.style.width=20;
	
    var img0=document.createElement((itemObject.id==rootId)?"div":"img");
    img0.border="0";

    td1.appendChild(img0);
    img0.style.padding=0;
    img0.style.margin=0;

    var td11=document.createElement('td');
    td11.style.fontSize=1;
    td11.vAlign="top";
    td11.style.paddingTop=3;
    
    var inp=document.createElement((itemObject.id==rootId)?"div":"img");
    inp.checked=0;
    inp.src=imPath+checkArray[0];
    inp.style.width="16px";
    inp.style.height="16px";
    inp.border=0;

    td11.appendChild(inp);
    
    if(itemObject.id != rootId)
        inp.align="top";

    inp.onclick=onCheckBoxClick;
    inp.treeNod=this;
    inp.parentObject=itemObject;
    
    if(!acheck || _gnl(itemObject, 0) <  checkBoxesLevel) 
    {
    	inp.style.display="none";
    	td11.style.width=(_isIE ? 1 : 0);
    }
    else
    {
        td11.style.width = 16;
    	td11.style.paddingRight = 3;
    }
    
    var td12=document.createElement('td');
	td12.vAlign="top";
	td12.style.paddingTop=2;
	
    var img=document.createElement((itemObject.id==rootId)?"div":"img");
    img.onmousedown=sbPreventNsDrag;
    img.ondragstart=sbPreventNsDrag;
    img.className="treeImage";
    if(_aimgs)
    {
        img.parentObject=itemObject;
        if(itemObject.id!=rootId) img.align="top";
        img.onclick=onRowSelect;
    }
    if(!mode)
    {
        if (itemObject.secure)
            img.src=imPath+imageArray[3];
        else
            img.src=imPath+imageArray[0];
    }
    td12.appendChild(img);

    if(treeIm)
    {
        img.style.width=def_img_x;
        img.style.height=def_img_y;
        td12.style.width=def_img_x;
    }
    else
    {
    	td12.style.width=(_isIE ? 1 : 0);
        img.style.width=0;
        img.style.height=0;
    }

    var td2=document.createElement('td');

    itemObject.span=document.createElement('span');
    itemObject.span.className="treeItem";
    itemObject.span.setAttribute('title', '<?php echo TREE_CAT_ID;?>: '+itemObject.id)
    td2.noWrap=true;
    td2.style.padding="2px";
    if (_isIE)
    	td2.style.width="100%";

    itemObject.span.innerHTML=itemObject.label;
    td2.appendChild(itemObject.span);
    td2.parentObject=itemObject;
    td1.parentObject=itemObject;
    td2.onclick=onRowSelect;
    td1.onclick=onRowClick;
    td2.ondblclick=onRowClick2;

    if(dragAndDrop && !multiSelect)
    {
        if(_aimgs)
        {
            dragger.addDraggableItem(td12,this);
            td12.parentObject=itemObject;
        }
        dragger.addDraggableItem(td2,this);
    }

    td2.style.verticalAlign="";
    td2.style.cursor=style_pointer;

    tr.appendChild(td1);
    tr.appendChild(td11);
    tr.appendChild(td12);
    tr.appendChild(td2);

    tbody.appendChild(tr);
    table.appendChild(tbody);

    tr.oncontextmenu=onRowRClick;

    return table;
}};

// Задает файл XML, из которого будет производиться подгрузка дерева
// filePath - путь к XML-файлу
btpt.setXMLAutoLoading=function(filePath)
{with(this){
    XMLsource=filePath;
}};

// Раскрывает все ветки, начиная с указанной
// itemId - ID ветки
btpt.openAllItems=function(itemId)
{with(this){
    var temp=_gisf(itemId);
    if(!temp) return 0;

    _oa(temp);
}};

// Сворачивает все ветки, начиная с указанной
// itemId - ID ветки
btpt.closeAllItems=function(itemId)
{with(this){
    var temp=_gisf(itemId);
    if(!temp)
        return 0;
    _ca(temp);
}};

// Устанавливает пользовательские данные для ветки
// itemId - ID ветки
// name - имя атрибута
// value - значение атрибута
btpt.setUserData=function(itemId,name,value)
{with(this){ 
    var sNode=_gisf(itemId);
    if(!sNode) return;

    if(name=="hint")
        sNode.htmlNode.childNodes[0].childNodes[0].title=value;
    sNode.userData["t_"+name]=value;
}};

// Вытаскивает пользовательские данные для ветки
// itemId - ID ветки
// name - имя атрибута
btpt.getUserData=function(itemId,name)
{with(this){
    var sNode = _gisf(itemId);

    if(!sNode) return false;

    return sNode.userData["t_"+name];
}};

// Возвращает ID выделенной ветки
btpt.getSelectedItemId=function()
{with(this){
    if(lastSelected)
        if(_gisf(lastSelected.id))
            return lastSelected.id;

    return 0;
}};

// Задает цвета для ветки
// itemId - ID ветки
// defaultColor - цвет невыделенной ветки
// selectedColor - цвет выделенной ветки
btpt.setItemColor=function(itemId,defaultColor,selectedColor)
{with(this){
    if((itemId)&&(itemId.span))
        var temp=itemId;
    else
        var temp=_gisf(itemId);

    if(!temp)
        return 0;
    else
    {
        if(lastSelected&&temp.tr==lastSelected.tr)
        {
            if(selectedColor)
                temp.span.style.color=selectedColor;
        }
        else
        {
            if(defaultColor)temp.span.style.color=defaultColor;
        }

        if(selectedColor)temp.scolor=selectedColor;
        if(defaultColor)temp.acolor=defaultColor;
    }
}};

// Возвращает текст ветки
// itemId - ID ветки
btpt.getItemText=function(itemId)
{with(this){
    var temp=_gisf(itemId);
    if(!temp)return 0;
    return(temp.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].innerHTML);
}};

// Устанавливает текст ветки
// itemId - ID ветки
// newLabel - новый текст
// newTooltip - новая подсказка
btpt.setItemText=function(itemId,newLabel,newTooltip)
{with(this){
    var temp = _gisf(itemId);
    if(!temp) return 0;
    temp.label = newLabel;
    temp.span.innerHTML=newLabel;
    temp.span.parentNode.title=newTooltip||"";
}};

// Устанавливает ID ветки
// itemId - ID ветки
// newId - новый ID ветки
btpt.setItemId=function(itemId,newId)
{with(this){
    _gisr(itemId, newId);
}};

// Возвращает ID родительской ветки, если таковая есть (0 иначе)
// itemID - ID ветки
btpt.getParentId=function(itemId)
{with(this){
    var temp=_gisf(itemId);
    if((!temp)||(!temp.parentObject))return 0;
    return temp.parentObject.id;
}};

btpt.getParentNode=function(itemId)
{with(this){
    var temp=_gisf(itemId);
    if((!temp)||(!temp.parentObject))return 0;
    return temp.parentObject;
}};

// Меняет изображения иконок для элемента и всех его подэлементов
btpt._changeSubImages=function(itemObject, images, paste)
{with(this){
    if (!itemObject) return;

    if (paste) pasteEls[pasteEls.length] = itemObject.id;
    if (images == "copy")
    {
        itemObject.images = itemObject.copyImages;
    }
    else if (images == "cut")
    {
        itemObject.images = itemObject.cutImages;
    }
    else
    {
        itemObject.images = itemObject.normImages;    
    }
    
    for (var i=0; i< itemObject.childsCount; i++)
	{
		_changeSubImages(itemObject.childNodes[i], images, paste);
	};
	_cp(itemObject);

}};

btpt._clearCutCopy=function()
{with(this){
    if(nodeCut || nodeCopy)
        _changeSubImages(nodeCut?nodeCut.parentObject:nodeCopy.parentObject, imageArray)
    pasteEls = new Array();
    nodeCut=0;
    nodeCopy=0;
}};

// Вырезает ветку
// itemId - ID вырезаемой ветки
btpt.doCut=function(itemId)
{with(this){
    if (!active) return;
    var temp=_gisf(itemId);
    if (!temp || multiSelect) return;
    _clearCutCopy();
    nodeCut=temp;
    _changeSubImages(nodeCut, "cut", true)
}};

// Копирует ветку
// itemId - ID вырезаемой ветки
btpt.doCopy=function(itemId)
{with(this){
    if (!active) return;
    var temp=_gisf(itemId);
    if (!temp || multiSelect) return;
    _clearCutCopy();
    nodeCopy=temp;
    _changeSubImages(nodeCopy, "copy", true)
}};

// Вставляет вырезанную или скопированную ветку
// itemId - ID ветки, в которую производится вставка
btpt.doPaste=function(itemId, res)
{with(this){
    if (!active) return;
    var temp=_gisf(itemId);
    if (!temp || !_checkPaste(temp))
        return;

    if (typeof(pasteFuncHandler) == "function")
        pasteFuncHandler(temp.id);

    if(nodeCut)
    {
        _moveNodeTo(nodeCut,temp,null,true);
    }
    else if (nodeCopy)
    {
        if (!res)
            return;
        if(temp.XMLload==0&&XMLsource)
        {
            _openItem(temp);
        }
        else
        {
            _openItem(temp);
            _recreateBranch(nodeCopy,temp,res,true);
            _rf(this,temp);
            _changeSubImages(nodeCopy, "copy", true);
        }
    }
}};

btpt._recreateBranch=function(item,pItem,res,show)
{with(this){
    if (item.copied==1)
        return;
    var Count=pItem.childsCount;
    var Nodes=pItem.childNodes;
    var itemActionHandler = item.actionHandler;
    if((!itemActionHandler)&&(aFunc)) itemActionHandler=aFunc;
    var id = item.id;
    if (typeof(res[item.id]) != 'undefined')
    {
        id=res[item.id];
    }

    var newItem=new sbTreeItem(id,item.label,pItem,this,itemActionHandler,1);

    newItem.copied = 1;
    newItem.acolor=item.acolor;
    newItem.scolor=item.scolor;
    newItem.userData=new Array();
    newItem.userData=item.userData;
    newItem.secure=item.secure;
    newItem.level=parseInt(pItem.level) + 1;
    newItem.checkstate=item.checkstate;
    newItem.XMLload = item.XMLload;
	newItem.images=item.normImages;
    newItem.cutImages=item.cutImages;
    newItem.copyImages=item.copyImages;
    newItem.normImages=item.normImages;
    
    if (item.checkstate) setCheck(newItem.id, 1);

    pItem.childsCount++;
    var tr=_dnt(newItem.htmlNode);
    if (!show)
        tr.style.display="none";

    pItem.htmlNode.childNodes[0].appendChild(tr);

    newItem.tr=tr;
    tr.nodem=newItem;
    Nodes[Count]=newItem;

    for (var i=0;i< item.childsCount;i++)
    {
        _recreateBranch(item.childNodes[i],newItem,res,_gos(item)>=0);
    }

    newItem.copied = 0;
}};

btpt._checkPaste=function(item)
{with(this){
    if (!item || multiSelect || item.treeNod != this) return false;
    if(nodeCut)
    {
        for (var i=0;i< pasteEls.length;i++)
        {
            if (pasteEls[i] == item.id)
                return false;
        }
        if(item.id==nodeCut.parentObject.id) return false;
    }

    return true;
}};

// Разворачивает указанную ветку
// itemId - ID разворачиваемой ветки
btpt.openItem=function(itemId)
{with(this){
    if (!active) return;
    var temp=_gisf(itemId);
    if(!temp)
        return;
    else
        _openItem(temp);
}};

btpt._openItem=function(item)
{with(this){
    _HideShow(item,2);
    if(item.parentObject&&_gos(item.parentObject)< 0)
        _openItem(item.parentObject);
}};

// Сворачивает указанную ветку
// itemId - ID сворачиваемой ветки
btpt.closeItem=function(itemId)
{with(this){
    if (!active) return;
    if(rootId==itemId) return 0;
    var temp=_gisf(itemId);
    if(!temp) return 0;
    _HideShow(temp,1);
}};

// Возвращает уровень указанной ветки
// itemId - ID указанной ветки
btpt.getLevel=function(itemId)
{with(this){
    var temp=_gisf(itemId);
    if(!temp) return 0;
    return _gnl(temp,0);
}};

// Возвращает кол-во вложенных ветвей указанной ветки
// itemId - ID указанной ветки
btpt.getChildsCount=function(itemId)
{with(this){
    var temp=_gisf(itemId);
    if(!temp) return 0;
    return parseInt(temp.childsCount);
}};

// _getNodeLevel
btpt._gnl=function(itemObject,count)
{with(this){
    if(itemObject.parentObject)
        return _gnl(itemObject.parentObject,count+1);

    return parseInt(count);
}};

// Заново подгружает указанную ветку
// itemId - ID ветки
btpt.refreshItem=function(itemId)
{with(this){ 
    if (!active) return;
    if(!itemId)
        itemId=rootId;
    var temp=_gisf(itemId);
    var num=temp.childsCount;
    _selId = getSelectedItemId();
    if (num != 0)
    {
        while (num != 0)
        {
            _deleteNode(temp.childNodes[0].id,temp.childNodes[0],false);
            num--;
        }
    }
    loadXML(XMLsource+sbGetUrlSymbol(XMLsource)+"id="+escape(itemId), _selectItemAfterLoad);
}};

btpt._selectItemAfterLoad=function()
{with(this){
    sbHideMsgDiv();
    if(_selId) selectItem(_selId, true, true);
}};

// Выделяет или снимает выделение с ветки
// itemId - ID ветки
// mode - true - выделить ветку, false - снять выделение
btpt.selectItem=function(itemId, mode, notcall)
{with(this){
    if (!active) return;
    mode=sbConvertStringToBoolean(mode);
    var temp=_gisf(itemId);

    if(!temp)
    {
        alert("<?php echo TREE_NO_CATEG; ?>");
        return 0;
    }
    
    if(_gos(temp.parentObject)==-1)
        openItem(temp.parentObject.id);

    if(mode)
        onRowSelect(0,temp.htmlNode.childNodes[0].childNodes[0].childNodes[3],false, notcall);
    else
        onRowSelect(0,temp.htmlNode.childNodes[0].childNodes[0].childNodes[3],true, notcall);
}};

// Ставит или снимает метку закрытости c ветки
// itemId - ID ветки
// state - true - закрытый, false - открытый
btpt.setSecure=function(itemId,state)
{with(this){
    state=sbConvertStringToBoolean(state);
    var sNode=_gisf(itemId);
    if(!sNode)return;

    sNode.secure = state;
    _cp(sNode);
}};

// Ставит или снимает метку закрытости c ветки и вложенных веток
// itemId - ID ветки
// state - true - закрытый, false - открытый
btpt.setSecureAll=function(itemId,state)
{with(this){
    state=sbConvertStringToBoolean(state);
    var sNode=_gisf(itemId);
    if(!sNode)return;

    _setSecureAll(sNode,state);
}};

btpt._setSecureAll=function(item,state)
{with(this){
    item.secure = state;
    _cp(item);

    var Count=item.childsCount;
    for(var i=0; i< Count; i++)
    {
        _setSecureAll(item.childNodes[i], state);
    }
}};

// Устанавливает или снимает чекбокс с ветки
// itemId - ID ветки
// state - true - отмечена, false - не отмечена
btpt.setCheck=function(itemId,state)
{with(this){
    state=sbConvertStringToBoolean(state);
    var sNode=_gisf(itemId);
    if(!sNode)return;

    _setCheck(sNode,state);
}};

btpt._setCheck=function(sNode,state)
{with(this){
    var z=sNode.htmlNode.childNodes[0].childNodes[0].childNodes[1].childNodes[0];

    if(state)
        sNode.checkstate=1;
    else
        sNode.checkstate=0;

    z.src=imPath+checkArray[sNode.checkstate];
}};

// Устанавливает или снимает чекбокс с ветки и вложенных веток
// itemId - ID ветки
// state - true - отмечена, false - не отмечена
btpt.setCheckAll=function(itemId, state)
{with(this){
    state=sbConvertStringToBoolean(state);
    var sNode=_gisf(itemId);
    if(!sNode)return;

    _setCheckAll(sNode,state);
}};

btpt._setCheckAll=function(item,state)
{with(this){
    _setCheck(item,state);
    var Count=item.childsCount;
    for(var i=0;i< Count;i++)
    {
        _setCheckAll(item.childNodes[i],state);
    }
}};

// Возвращает 1 если чекбокс ветки отмечен и false в ином случае
// itemId - ID ветки
btpt.isItemChecked=function(itemId)
{with(this){
    var sNode=_gisf(itemId);
    if(!sNode)
        return 0;
    return sNode.checkstate;
}};

// Возвращает строку, содержащую все ID веток с помеченными чекбоксами, разделенные запятой
btpt.getAllChecked=function()
{
    if (!this.active) return;
    return this._getAllChecked("","",1);
}

btpt._getAllChecked=function(htmlNode,list,mode)
{
    if(!htmlNode) htmlNode=this.htmlNode;
    if((mode&&htmlNode.checkstate==1)||(!mode&&htmlNode.checkstate>0))
        if(!htmlNode.nocheckbox)
        {
            if(list)
                list+=","+htmlNode.id;
            else
                list=htmlNode.id;
        }
    var j=htmlNode.childsCount;
    for(var i=0;i< j;i++)
    {
        list=this._getAllChecked(htmlNode.childNodes[i],list,mode);
    };
    if(htmlNode.unParsed)
        list=this._getAllCheckedXML(htmlNode.unParsed,list,mode);

    if(list)
        return list;
    else
        return "";
};

// Возвращает строку, содержащую все ID помеченных веток, разделенные запятой (для режима multiselect)
btpt.getAllSelected=function()
{
    if (!this.active) return;
    return this._getAllSelected("","");
}

btpt._getAllSelected=function(htmlNode,list)
{
    if(!htmlNode) htmlNode=this.htmlNode;
    if(htmlNode.selected==1)
        if(list)
            list+="^"+htmlNode.id;
        else
            list=htmlNode.id;

    var j=htmlNode.childsCount;
    for(var i=0;i< j;i++)
    {
        list=this._getAllSelected(htmlNode.childNodes[i],list);
    };

    if(list)
        return list;
    else
        return "";
};

btpt.getAllSelectedText=function()
{
    if (!this.active) return;
    return this._getAllSelectedText("", "");
}

btpt._getAllSelectedText=function(htmlNode,list)
{
    if(!htmlNode) htmlNode=this.htmlNode;
    if(htmlNode.selected==1)
        if(list)
            list+=", "+htmlNode.label;
        else
            list=htmlNode.label;

    var j=htmlNode.childsCount;
    for(var i=0;i< j;i++)
    {
        list=this._getAllSelectedText(htmlNode.childNodes[i],list);
    };

    if(list)
        return list;
    else
        return "";
};

btpt._getAllCheckedXML=function(htmlNode,list,mode)
{
    var j=htmlNode.childNodes.length;
    for(var i=0;i< j;i++)
    {
        var tNode=htmlNode.childNodes[i];
        if(tNode.tagName=="item")
        {
            var z=tNode.getAttribute("checked");
            if((z!=null)&&(z!="")&&(z!="0"))
            if(((z=="-1")&&(!mode))||(z!="-1"))
            if(list)list+=","+tNode.getAttribute("id");
            else list=htmlNode.id;

            list=this._getAllChecked(tNode,list,mode);
        }
    };

    if(list)
        return list;
    else
        return "";
};

btpt._compressChildList=function(Count,Nodes)
{
    Count--;
    for(var i=0;i< Count;i++)
    {
        if(Nodes[i]==0)
        {
            Nodes[i]=Nodes[i+1];
            Nodes[i+1]=0;
        }
    };
};

btpt._deleteNode=function(itemId,htmlObject,skip)
{with(this){
    if(!skip)
    {
        _gisrs(htmlObject);
    }

    if((!htmlObject)||(!htmlObject.parentObject))return 0;
    var tempos=0;
    var tempos2=0;

    if(htmlObject.tr.nextSibling) tempos=htmlObject.tr.nextSibling.nodem;
    if(htmlObject.tr.previousSibling) tempos2=htmlObject.tr.previousSibling.nodem;

    var sN=htmlObject.parentObject;
    var Count=sN.childsCount;
    var Nodes=sN.childNodes;
    for(var i=0; i< Count; i++)
    {
        if(Nodes[i].id==itemId)
        {
            if(!skip) sN.htmlNode.childNodes[0].removeChild(Nodes[i].tr);
            Nodes[i]=0;
            break;
        }
    }

    _compressChildList(Count,Nodes);
    if(!skip)
    {
        sN.childsCount--;
    }

    if(tempos)
    {
        _cp(tempos);
        _cl(tempos);
    }
    if(tempos2)
    {
        _cp(tempos2);
        _cl(tempos2);
    }
}};

// _globalIdStorageRecSub
btpt._gisrs=function(itemObject)
{with(this){
    for(var i=0;i< itemObject.childsCount;i++)
    {
        _gisrs(itemObject.childNodes[i]);
    };
    _giss(itemObject.id);
}};

btpt._checkDelete=function(sNode)
{with(this){
    var res = (sNode==lastSelected);
    for(var i=0;i< sNode.childsCount;i++)
    {
        res = (res || _checkDelete(sNode.childNodes[i]));
    };

    if (sNode == nodeCopy) nodeCopy = 0;
    if (sNode == nodeCut) nodeCut = 0;

    return res;
}};
// Удаляет ветку целиком
// itemId - ID удаляемой ветки
// selectParent  выделить родительскую ветку после удаления

btpt.deleteItem=function(itemId, selectParent)
{with(this){
    if (!active) return;
    var sNode=_gisf(itemId);
    if(!sNode)return;

    if(_checkDelete(sNode) && selectParent)
        selectItem(getParentId(sNode.id), true);
    var zTemp=sNode.parentObject;
    _deleteNode(itemId,sNode,false);
    _cp(zTemp);
    _cl(zTemp);

    allTree.childNodes[0].border = "1";
    allTree.childNodes[0].border = "0";
}};

btpt._moveNodeTo=function(itemObject,targetObject,beforeNode,notcall)
{with(this){
    if (!active) return false;

    _clearCutCopy();

    if (dragFunc && !notcall)
        if(!dragFunc(itemObject.id,targetObject.id,(beforeNode?beforeNode.id:null)))
            return false;

    var c=itemObject.parentObject.childsCount;
    var z=itemObject.parentObject;
    if(targetObject.XMLload==0&&XMLsource)
    {
        _selId = getSelectedItemId();
        deleteItem(itemObject.id,false);
        openItem(targetObject.id);

        if(dropFunc&&!notcall)
            dropFunc(itemObject.id,targetObject.id,(beforeNode?beforeNode.id:null));

        return true;
    }

    openItem(targetObject.id);
    var Count=targetObject.childsCount;
    var Nodes=targetObject.childNodes;
    Nodes[Count]=itemObject;
    targetObject.childsCount++;

    var tr=_dnt(Nodes[Count].htmlNode);

    if(!beforeNode)
    {
        targetObject.htmlNode.childNodes[0].appendChild(tr);
        if(dadmode==1||dadmode==2)
            _fixNodesCollection(targetObject,beforeNode);
    }
    else
    {
        targetObject.htmlNode.childNodes[0].insertBefore(tr,beforeNode.tr);
        _fixNodesCollection(targetObject,beforeNode);
        Nodes=targetObject.childNodes;
    }

    itemObject.parentObject.htmlNode.childNodes[0].removeChild(itemObject.tr);
    if(!beforeNode||targetObject!=itemObject.parentObject)
    {
        for(var i=0;i< z.childsCount;i++)
        {
            if(z.childNodes[i].id==itemObject.id)
            {
                z.childNodes[i]=0;
                break;
            }
        }
    }
    else
        z.childNodes[z.childsCount-1]=0;

    _compressChildList(z.childsCount,z.childNodes);
    z.childsCount--;

    itemObject.tr=tr;
    tr.nodem=itemObject;
    itemObject.parentObject=targetObject;

    _cp(targetObject);
    _cl(targetObject);
    _cl(itemObject);
    _cp(itemObject);

    if(beforeNode)
    {
        _cp(beforeNode);
    }
    else
        if(targetObject.childsCount>=2)
        {
            _cp(Nodes[targetObject.childsCount-2]);
            _cl(Nodes[targetObject.childsCount-2]);
        }

    _cp(Nodes[targetObject.childsCount-1]);

    if(c>1)
    {
        _cp(z.childNodes[c-2]);
        _cl(z.childNodes[c-2]);
    }
    _cp(z);
    
    if(dropFunc&&!notcall)
        dropFunc(itemObject.id,targetObject.id,(beforeNode?beforeNode.id:null));

    return true;
}};

btpt._moveNode=function(itemObject,targetObject,realHtmlObject,notcall)
{with(this){
    if (!active) return;
    if (itemObject.treeNod!=targetObject.treeNod)
        return 0;
    
    var mode=dadmode;
    if((mode==2&&(realHtmlObject==selectionBar || targetObject.span.className != "treeDragSelected")) || mode==1)
    {
        var targetLevel=_gnl(targetObject,0);
        var z=_getNextNode(targetObject);
        if(targetLevel==1)
        {
            return _moveNodeTo(itemObject,z.parentObject,z,notcall);
        }
        if(z==-1)
        {
            z=htmlNode;
        }
        var zLevel = _gnl(z,0);

        if(zLevel< targetLevel)
        {
            return _moveNodeTo(itemObject,targetObject.parentObject,null,notcall);
        }
        while(true)
        {
            if(zLevel==targetLevel)
                break;
            else if (zLevel <  targetLevel)
                return _moveNodeTo(itemObject,targetObject.parentObject,null,notcall);

            z=_getNextNode(z);
            if(z==-1)
            {
                return _moveNodeTo(itemObject,targetObject.parentObject,null,notcall);
            }
            zLevel = _gnl(z,0);
        }
        return _moveNodeTo(itemObject,z.parentObject,z,notcall);
    }
    else
        return _moveNodeTo(itemObject,targetObject,null,notcall);
}};

btpt._fixNodesCollection=function(target,zParent)
{
    var flag=0;
    var icount=0;
    var Nodes=target.childNodes;
    var Count=target.childsCount-1;

    if(zParent==Nodes[Count]) return;
    for(var i=0;i< Count;i++)
        if(Nodes[i]==Nodes[Count])
        {
            Nodes[i]=Nodes[i+1];
            Nodes[i+1]=Nodes[Count];
        }

    for(var i=0;i< Count+1;i++)
    {
        if(flag)
        {
            var temp=Nodes[i];
            Nodes[i]=flag;
            flag=temp;
        }
        else
            if(Nodes[i]==zParent)
            {
                flag=Nodes[i];
                Nodes[i]=Nodes[Count];
            }
    }
};

btpt._clearStyles=function(itemObject)
{with(this){
    var td1=itemObject.htmlNode.childNodes[0].childNodes[0].childNodes[1];
    var td3=td1.nextSibling.nextSibling;

    itemObject.span.innerHTML=itemObject.label;

    if(checkBoxes)
    {
        td1.childNodes[0].style.display="";
        td1.childNodes[0].onclick=onCheckBoxClick;
    }
    else
        td1.childNodes[0].style.display="none";

    td1.childNodes[0].treeNod=this;

    dragger.removeDraggableItem(td3);
    if(dragAndDrop && !multiSelect)
        dragger.addDraggableItem(td3,this);

    td3.childNodes[0].className="treeItemw";
    td3.onclick=onRowSelect;
    td3.ondblclick=onRowClick2;
    td1.previousSibling.onclick=onRowClick;

    _cl(itemObject);
    _cp(itemObject);
    for(var i=0;i< itemObject.childsCount;i++)
        _clearStyles(itemObject.childNodes[i]);
}};

btpt._clearMove=function(htmlNode)
{
    if((htmlNode.parentObject)&&(htmlNode.parentObject.span))
    {
        if (this.getSelectedItemId() == htmlNode.parentObject.id)
            htmlNode.parentObject.span.className='treeSelected';
        else
            htmlNode.parentObject.span.className='treeItem';
        if(htmlNode.parentObject.acolor)
            htmlNode.parentObject.span.style.color=htmlNode.parentObject.acolor;
    }

    this.selectionBar.style.display="none";
};

btpt._setMove=function(htmlObject,shtmlObject,realHtmlNode,x,y,a1,a2)
{with(this){
    if (!active) return 0;
    
    var allow_move = "all";
    if (moveFunc)
    {
        allow_move = moveFunc(shtmlObject.parentObject.id, htmlObject.parentObject.id);
    }
    
    if(htmlObject.parentObject.span)
    {
        if(dadmode==0)
        {
            if (allow_move == "noinner")
                return 0;
                
            htmlObject.parentObject.span.className='treeDragSelected';
            if(htmlObject.parentObject.scolor)
                htmlObject.parentObject.span.style.color=htmlObject.parentObject.scolor;

            return 1;
        }
        else
        {
            var showSBar=true;
            var selItem=true;

            if (dadmode==2)
            {
                var prevLevel = _gnl(prevNode,0);
                var curLevel = _gnl(shtmlObject.parentObject,0);
                var tLevel = _gnl(htmlObject.parentObject,0);

                var parId = getParentId(shtmlObject.parentObject.id);
                var tParId = getParentId(htmlObject.parentObject.id);

                if (allow_move == "noafter" || tLevel == 1 || (prevNode==htmlObject.parentObject && prevLevel==curLevel) || (dadupdown == 0 && parId == tParId && curLevel == tLevel) || tLevel <  dadlevel)
                    showSBar=false;

                if (allow_move == "noinner" || parId == htmlObject.parentObject.id)
                    selItem = false;
            }
            if (dadmode==1)
            {
                if (allow_move == "noafter" || tLevel <  dadlevel)
                    return 0;
                    
                htmlObject.parentObject.span.className='treeItem';
            }
            else
            {
                if (selItem)
                {
                    htmlObject.parentObject.span.className='treeDragSelected';
                }
            }
            if(htmlObject.parentObject.acolor)
                htmlObject.parentObject.span.style.color=htmlObject.parentObject.acolor;

            if(showSBar&&selectionBar.style.display == "none")
            {
                selectionBar.style.top=a1-a2+16+"px";
                selectionBar.style.left="5px";
                selectionBar.style.display="";
            }

            if (showSBar || selItem)
                return 1;
            else
                return 0;
        }
    }
    else
        return 0;
}};

btpt._createDragNode=function(htmlObject)
{with(this){
    if (!active) return 0;
    if (cMenu) cMenu.hide();
    dhtmlObject=htmlObject.parentObject;

    var sourceLevel = _gnl(dhtmlObject,0);
    if (sourceLevel <  dadlevel)
        return 0;
    var dragSpan=document.createElement('DIV');
    dragSpan.innerHTML=dhtmlObject.label;
    dragSpan.style.position="absolute";
    dragSpan.className="treeDragDiv";

    if (dadmode==1||dadmode==2)
    {
        var z = dhtmlObject;
        while(true)
        {
            z=_getPrevNode(z);
            if(z==-1)
            {
                z=htmlNode;
                break;
            }
            if(_gnl(z,0)==sourceLevel)
                break;
        }
        prevNode = z;
    }
    return dragSpan;
}};

btpt._drag=function(sourceHtmlObject,dhtmlObject,targetHtmlObject,realHtmlObject)
{with(this){
    if (!active) return;
    if(_autoOpenTimer)
        clearTimeout(_autoOpenTimer);

    if(!targetHtmlObject.parentObject)
    {
        targetHtmlObject=htmlNode.htmlNode.childNodes[0].childNodes[0].childNodes[1].childNodes[0];
    }

    try 
    {    
        var z=targetHtmlObject.parentObject.treeNod;
        if (dadmode==2)
        {
            var parId=getParentId(sourceHtmlObject.parentObject.id);
            if (parId==targetHtmlObject.parentObject.id)
                realHtmlObject=selectionBar;
        }
        var wasMoved=_moveNode(sourceHtmlObject.parentObject,targetHtmlObject.parentObject, realHtmlObject);
    }
    catch (e)
    {    
    }
    finally
    {
        _clearMove(targetHtmlObject);
        z._clearMove("");
    }
    
    return;
}};

btpt._dragIn=function(htmlObject,shtmlObject,htmlRealObject,x,y)
{with(this){
    if (!active) return 0;
    if (htmlObject.parentObject.treeNod!=shtmlObject.parentObject.treeNod)
        return 0;
    if(!htmlObject.parentObject)
        return htmlObject;

    var a1=sbGetAbsoluteTop(htmlObject);
    var a2=sbGetAbsoluteTop(allTree);

    if(autoScroll)
    {
        if(a1-a2-parseInt(allTree.scrollTop)>parseInt(allTree.offsetHeight)-50)
            allTree.scrollTop=parseInt(allTree.scrollTop)+30;
        if(a1-a2< parseInt(allTree.scrollTop)+30)
            allTree.scrollTop=parseInt(allTree.scrollTop)-30;
    }
    if(dadmode==0 && _checkParentNodes(shtmlObject.parentObject.id,htmlObject.parentObject))
        return 0;

    var targetLevel = _gnl(htmlObject.parentObject,0);
    var curLevel = _gnl(shtmlObject.parentObject,0);
    if (targetLevel < (dadlevel - 1) || curLevel <  (dadlevel - 1))
    {
        if(_gos(htmlObject.parentObject)< 0 && htmlRealObject == htmlObject.parentObject.span)
        {
            _autoOpenTimer=window.setTimeout(new sbCallerFunction(this._autoOpenItem,this),500);
            _autoOpenId=htmlObject.parentObject.id;
        }
        return 0;
    }

    if(dadmode==1||dadmode==2)
    {
        var prevLevel = _gnl(prevNode,0);

        if (dadmode==1&&prevNode==htmlObject.parentObject && prevLevel==curLevel)
            return 0;
        if ((dadmode==2||dadmode==1)&&targetLevel>curLevel&&_checkParentNodes(shtmlObject.parentObject.id,htmlObject.parentObject))
            return 0;
    }

    if(htmlObject.parentObject.id!=shtmlObject.parentObject.id)
    {
        htmlObject.parentObject.span.parentNode.appendChild(selectionBar);
        if (!_setMove(htmlObject,shtmlObject,htmlRealObject,x,y,a1,a2))
            return 0;

        if(_gos(htmlObject.parentObject)< 0 && htmlRealObject == htmlObject.parentObject.span)
        {
            _autoOpenTimer=window.setTimeout(new sbCallerFunction(this._autoOpenItem,this),500);
            _autoOpenId=htmlObject.parentObject.id;
        }

        return htmlObject;
    }
    else
        return 0;
}};

btpt._autoOpenItem=function(treeObject)
{
    treeObject.openItem(treeObject._autoOpenId);
};

btpt._dragOut=function(htmlObject)
{with(this){
    if (!active) return;
    _clearMove(htmlObject);
    if(_autoOpenTimer)
        window.clearTimeout(_autoOpenTimer);
}};

btpt._checkParentNodes=function(itemId,htmlObject)
{with(this){
    if(htmlObject.id==itemId)
        return 1;
    if(htmlObject.parentObject)
        return _checkParentNodes(itemId,htmlObject.parentObject);
    else
        return 0;
}};

btpt.getNextNode=function(node)
{with(this){
    if(node.tr&&node.tr.nextSibling&&node.tr.nextSibling.nodem)
        return node.tr.nextSibling.nodem;

    return false;
}};

btpt.getPrevNode=function(node)
{with(this){
    if(node.tr&&node.tr.previousSibling&&node.tr.previousSibling.nodem)
        return node.tr.previousSibling.nodem;

    return false;
}};

btpt._getNextNode=function(item,mode)
{with(this){
    if(!mode&&item.childsCount)
        return item.childNodes[0];
    if(item==htmlNode)
        return -1;
    if(item.tr&&item.tr.nextSibling&&item.tr.nextSibling.nodem)
        return item.tr.nextSibling.nodem;

    return _getNextNode(item.parentObject,true);
}};

// Возвращает последнюю вложенную ветку в указанной ветке
// itemId - ID ветки
btpt.getLastChild=function(itemId)
{with(this){
    var item=_gisf(itemId);
    if(item.childsCount)
        return getLastChild(item.childNodes[item.childsCount-1].id);
    else
        return item;
}};

btpt._getPrevNode=function(node,mode)
{with(this){
    if(node.tr&&node.tr.previousSibling&&node.tr.previousSibling.nodem)
        return getLastChild(node.tr.previousSibling.nodem.id);

    if(node.parentObject)
        return node.parentObject;
    else
        return -1;
}};
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>