<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
<?php require_once(SB_CMS_LANG_PATH.'/pl_workflow.lng.php');?>

function sbStatusEdit(id)
{
	var strPage = sb_cms_modal_dialog_file+"?event=pl_workflow_edit"+(typeof(id) == "undefined" ? "" : "&id="+id);
	var strAttr = "resizable=1,width=700,height=500";
	sbShowModalDialog(strPage, strAttr, afterStatusEdit);
}

function afterStatusEdit()
{
	var value = (sbModalDialog.returnValue ? sbModalDialog.returnValue : "");

	var id = (value.id ? value.id : "");
	var title = (value.title ? value.title : "");
	var checked = (value.checked ? value.checked : "");
	var demo = (value.demo ? value.demo : "");

	// если есть то редактируем
	if(!value.order)
	{
		//изменение ответа
		var prevRow = sbGetE(id);
		if (prevRow)
		{
			var el_active = sbGetE("active_id" + id);
			var el_demo = sbGetE("demo_id" + id);
			var el_title = sbGetE("title_" + id);

			if(checked == 0 && el_active && !el_active.disabled)
				el_active.checked = false;
			else if(el_active && !el_active.disabled)
				el_active.checked = true;

			if(demo == 0 && el_demo && !el_demo.disabled)
				el_demo.checked = false;
			else if(el_demo && !el_demo.disabled)
				el_demo.checked = true;
				
			el_title.innerHTML = title;
		}
	}
	else
	{
		var order = (value.order ? value.order : "");

		var table = sbGetE("status_table");
		var null_tr = sbGetE("null_tr");

		if (!table || !null_tr)
			return;
	
		if (null_tr.className != "")
		{
			var cls = "even";
			if (_isIE)
	            null_tr.removeAttribute("className");
			else
				null_tr.removeAttribute("class");
		}
		else
		{
			var cls = "";
	        null_tr.className = "even";
		}
	    var tr = document.createElement("TR");
	
		tr.setAttribute("id", id);
	    if (_isIE)
	    	tr.setAttribute("className", cls);
		else
	    	tr.setAttribute("class", cls);
		tr.style.cursor = "default";
		if(_isIE)
	    {
			tr.setAttribute("onmousedown", function(){sbPDStartDrag(event, this)});
		}
		else
        {
			tr.setAttribute("onmousedown", "sbPDStartDrag(event, this)");
		}

        // Первая ячейка
        var td1 = document.createElement("TD");
		td1.style.verticalAlign = "middle";
		td1.style.borderTop = "1px solid #FFF5E0";
		td1.innerHTML = "<div><b id=\'title_"+ id +"\'>" + title + "</b></div>";
		tr.appendChild(td1);
		
		// Вторая ячейка
		var td2 = document.createElement("TD");
        td2.innerHTML = "<input type=\'hidden\' id=\'w_" + id + "_order\' value=\'"+ order +"\'><input type=\'checkbox\' onclick=\'changeActive("+ id +");\' id=\'active_id"+ id +"\' "+ (checked == 1 ? "checked=\'checked\'" : "") +">";
        td2.align = "center";
        td2.style.verticalAlign = "middle";
        td2.style.borderTop = "1px solid #FFF5E0";
        tr.appendChild(td2);

		// Третья ячейка
		var td3 = document.createElement("TD");
        td3.innerHTML = "<input type=\'checkbox\' onclick=\'changeDemo("+ id +");\' id=\'demo_id"+ id +"\' "+ (demo == 1 ? "checked=\'checked\'" : "") +">";
        td3.align = "center";
        td3.style.verticalAlign = "middle";
        td3.style.borderTop = "1px solid #FFF5E0";
        tr.appendChild(td3);
        
		// Четвертая ячейка
		var td4 = document.createElement("TD");
		td4.style.verticalAlign = "middle";
		td4.align = "center";
		td4.style.borderTop = "1px solid #FFF5E0";
		td4.innerHTML = "<img src=\'/cms/images/btn_props.png\' title=\'<?php echo KERNEL_EDIT; ?>\' onmousedown=\'_sbPDPreventNsDrag(event, true);\' ondragstart=\'_sbPDPreventNsDrag(event);\' onclick=\'sbStatusEdit("+ id +")\' style=\'cursor: pointer;\' width=\'20\' border=\'0\' height=\'20\'>";
        tr.appendChild(td4);

        // Пятая ячейка
        var td5 = document.createElement("TD");
        td5.align = "center";
        td5.style.verticalAlign = "middle";
        td5.style.borderTop = "1px solid #FFF5E0";
        td5.innerHTML = "<img src=\'/cms/images/btn_delete.png\' title=\'<?php echo KERNEL_DELETE; ?>\' onmousedown=\'_sbPDPreventNsDrag(event, true);\' ondragstart=\'_sbPDPreventNsDrag(event);\' onclick=\'sbDeleteElem("+ id +");\' style=\'cursor: pointer;\' width=\'20\' border=\'0\' height=\'20\'>";
        tr.appendChild(td5);
	
		var el = table.tBodies[0];
		if(el)
		{
			el.insertBefore(tr, null_tr);
		}
	}
}

function sbDeleteElem(id)
{
	if(confirm("<?php echo PL_WORKFLOW_CONFIRM_DELETE; ?>"))
	{
		var res = sbLoadSync(sb_cms_empty_file + "?event=pl_workflow_delete&id="+id);
		if(res == "OK")
		{
	        var el = sbGetE(id);
	        var table = sbGetE("status_table");
	
	        table = table.tBodies[0];
	        table.removeChild(el);
	        
	        for (var i = 1; i < table.rows.length; i++)
	        {
	            if (i % 2 == 0)
	            {
	                if (_isIE)
	                    table.rows[i].setAttribute("className", "even");
	                else
	                    table.rows[i].setAttribute("class", "even");
	                table.rows[i].setAttribute("oldClassName", "even");
	            }
	            else
	            {
	                if (_isIE)
	                    table.rows[i].removeAttribute("className");
	                else
	                    table.rows[i].removeAttribute("class");
	                table.rows[i].removeAttribute("oldClassName");
	            }
	        }
		}
		else
		{
			alert("<?php  echo PL_WORKFLOW_NO_DELETE_ELEM; ?>");
		}
	}
}

function changeActive(id)
{
	var res = sbLoadSync(sb_cms_empty_file + "?event=pl_workflow_change_active&id="+id);
	if(res != "TRUE")
	{
		alert("<?php echo PL_WORKFLOW_EDIT_CHANGE_ERROR; ?>");
		
		var el = sbGetE("active_id"+id);
		if(el && el.checked)
		{
			el.checked = false;
		}
		else
		{
			el.checked = true;
		}
	}
}

function changeDemo(id)
{
	var res = sbLoadSync(sb_cms_empty_file + "?event=pl_workflow_change_demo&id="+id);
	if(res != "TRUE")
	{
		alert("<?php echo PL_WORKFLOW_EDIT_CHANGE_ERROR; ?>");
		
		var el = sbGetE("demo_id"+id);
		if(el && el.checked)
		{
			el.checked = false;
		}
		else
		{
			el.checked = true;
		}
	}
}

function resortAll()
{
    var elems = new Array();
	var els = document.getElementsByName("w_orders[]");
	if (els)
	{
		for (var i = 0; i < els.length; i++)
		{
            var curPos = sbGetE("w_" + els[i].value + "_order");
            curPos.value = parseInt(i + 1);
        	elems[els[i].value] = parseInt(i + 1);
    	}
    }
	lastSortPosition = els.length;

	elems = sb_serialize(elems);
	var res = sbLoadSync(sb_cms_empty_file + "?event=pl_workflow_change_order&elems="+elems);
	if(res == "ERROR")
		alert("<?php echo PL_WORKFLOW_EDIT_NO_CHANGE_ORDER; ?>");
}

_sbPDPreventNsDrag = function (e)
{
    if(e && e.preventDefault)
	{
        e.preventDefault();
    	return false;
    }
	return false;
}

sbPDDraggingEl = null;
sbPDOverEl = null;
sbPDTempOverEvent = new Array();

sbPDSetBorder = function(el, border)
{
	if(el)
	{
        var childs = el.childNodes;
        for(var i = 0; i < childs.length; i++)
		{
			if(childs[i].tagName == "TD")
            {
				if (_isIE)
	            	childs[i].style.borderTop = "1px solid " + border;
				else
	            	childs[i].style.borderTop = "1px solid " + border;
        	}
    	}
	}
}

sbPDChangeRowClass = function(el_id, cls)
{
    var el_tr = sbGetE(el_id);
    if (el_tr)
	{
        if (!cls)
		{
			if (_isIE)
            	el_tr.setAttribute("className", el_tr.getAttribute("oldClassName"));
			else
        		el_tr.setAttribute("class", el_tr.getAttribute("oldClassName"));
        }
        else
		{
            if (_isIE)
			{
                if (el_tr.getAttribute("className") != "drag")
				{
                	el_tr.setAttribute("oldClassName", el_tr.getAttribute("className"));
            	}
            }
            else
			{
                if (el_tr.getAttribute("class") != "drag")
				{
                	el_tr.setAttribute("oldClassName", el_tr.getAttribute("class"));
            	}
            }

			if (_isIE)
            	el_tr.setAttribute("className", cls);
			else
        		el_tr.setAttribute("class", cls);
    	}
	}
}

	
        sbPDStartDrag = function(e, el)
        {
            sbAddEvent(document, "mousemove", sbPDDrag);
            sbAddEvent(document, "mouseup", sbPDStopDrag);

            if (sbPDDraggingEl && sbPDDraggingEl != el)
                sbPDChangeRowClass(sbPDDraggingEl.id, null);

            sbPDChangeRowClass(el.id, "drag");
            sbPDDraggingEl = el;

            if(_isIE)
            {
                window.document.body.setCapture();
            }
            else
            {
                if (window.parent.frames)
                {
                    for(var i=0; i < window.parent.frames.length; i++)
                    {
                        if(window.parent.frames[i] != window)
                        {
                            sbPDTempOverEvent[sbPDTempOverEvent.length] = window.parent.frames[i].onmouseover;
                            window.parent.frames[i].onmouseover = sbPDStopDrag;
                        }
                    }
                }
            }
        }

        sbPDDrag = function(e)
        {
            if (!sbPDDraggingEl)
            {
                sbPDOverEl = null;
                return;
            }
        
            var el = sbEventTarget(e);
            if (!el)
                return;
        
            while(el && el.tagName != "TR")
                el = el.parentNode;
        
            if (!el)
                return;

            var table = el;
            while(table.tagName != "TABLE")
                table = table.parentNode;

            if (table.id != "status_table")
                return;

            var first_tr = table.tBodies[0].childNodes[0];

            if (el == sbPDDraggingEl || el == sbPDDraggingEl.nextSibling || el == first_tr)
            {
                sbPDSetBorder(sbPDOverEl, "#FFF5E0");
                sbPDOverEl = null;
                return;
            }

            sbPDSetBorder(sbPDOverEl, "#FFF5E0");
            sbPDSetBorder(el, "black");
            sbPDOverEl = el;
        }

sbPDStopDrag = function(e)
{
    if(_isIE)
	{
    	window.document.body.releaseCapture();
    }
    else
	{
        if (window.parent.frames)
		{
            for(var i=0; i < window.parent.frames.length; i++)
			{
                if(window.parent.frames[i] != window)
				{
					window.parent.frames[i].onmouseover = sbPDTempOverEvent.shift();
            	}
        	}
    	}
	}

    sbRemoveEvent(document, "mousemove", sbPDDrag);
	sbRemoveEvent(document, "mouseup", sbPDStopDrag);

	if (!sbPDDraggingEl || !sbPDOverEl)
		return;

	sbPDSetBorder(sbPDOverEl, "#FFF5E0");

    var table = sbGetE("status_table");
    table = table.tBodies[0];
	table.insertBefore(sbPDDraggingEl, sbPDOverEl);

	for (var i = 1; i < table.rows.length; i++)
	{
		if (i % 2 == 0)
        {
        	if (_isIE)
            	table.rows[i].setAttribute("className", "even");
			else
            	table.rows[i].setAttribute("class", "even");
			table.rows[i].setAttribute("oldClassName", "even");
		}
		else
		{
			if (_isIE)
				table.rows[i].removeAttribute("className");
			else
				table.rows[i].removeAttribute("class");

			table.rows[i].removeAttribute("oldClassName");
		}
	}

	sbPDDraggingEl = null;
	sbPDOverEl = null;
	resortAll();
}
var lastSortPosition = 0;


<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>