<?php require_once(dirname(__FILE__).'/jheader.inc.php'); ?>
function sbXMLLoader(funcObject, dhtmlObject, async)
{
     this.xmlDoc="";
     if(arguments.length==2)
         this.async=true;
     else
         this.async=async;

     this.onloadAction=funcObject||null;
     this.mainObject=dhtmlObject||null;

     return this;
};

var pt = sbXMLLoader.prototype;
 
pt.getXMLTopNode=function(tagName)
{with(this){
    if(xmlDoc.responseXML)
    {
        var temp=xmlDoc.responseXML.getElementsByTagName(tagName);
        var z=temp[0];
    }
    else
        var z=xmlDoc.documentElement;
 
    if(z)
        return z;

    return document.createElement("DIV");
}};

pt.loadXMLString=function(xml)
{with(this){ 
    try
    {
        var parser = new DOMParser();
        xmlDoc = parser.parseFromString(xml, "text/xml");
    }
    catch(e)
    {
        xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
        xmlDoc.async = false;
        xmlDoc.loadXML(xml);
    }
    
    if (onloadAction)
    	onloadAction(mainObject,null,null,null);
}};

pt.loadXML=function(url)
{with(this){
    if (async)
        sbLoadAsync(url, new sbCallerFunction(this.afterLoad, this, null));
    else
        afterLoad(this, null, sbLoadSync(url));
}};

pt.afterLoad=function(obj, tmp, res)
{
    obj.loadXMLString(res);
};

pt.selectNodes = function( xpath, contextNode )
{with (this) {
	if ( !xmlDoc )
		return new Array() ;

	if ( _isIE )
	{
		if ( contextNode )
			return contextNode.selectNodes( xpath ) ;
		else
			return xmlDoc.selectNodes( xpath ) ;
	}
	else
	{
		var aNodeArray = new Array();

		var xPathResult = xmlDoc.evaluate( xpath, contextNode ? contextNode : xmlDoc,
				xmlDoc.createNSResolver(xmlDoc.documentElement), XPathResult.ORDERED_NODE_ITERATOR_TYPE, null) ;
		if ( xPathResult )
		{
			var oNode = xPathResult.iterateNext() ;
			while( oNode )
			{
				aNodeArray[aNodeArray.length] = oNode ;
				oNode = xPathResult.iterateNext();
			}
		}
		return aNodeArray ;
	}
}};
	
pt.selectSingleNode = function( xpath, contextNode )
{with(this){
	if ( !xmlDoc )
		return null ;

	if (_isIE)
	{
		if ( contextNode )
			return contextNode.selectSingleNode( xpath ) ;
		else
			return xmlDoc.selectSingleNode( xpath ) ;
	}
	else
	{
		xpath = xmlDoc.evaluate( xpath, contextNode ? contextNode : xmlDoc, xmlDoc.createNSResolver(xmlDoc.documentElement), 9, null);

		if ( xpath && xpath.singleNodeValue )
			return xpath.singleNodeValue ;
		else
			return null ;
	}
}};

pt.transformToObject = function( el )
{
	if ( !el )
		return null ;

	var obj = {} ;

	var attrs = el.attributes ;
	for ( var i = 0 ; i < attrs.length ; i++ )
	{
		var att = attrs[i] ;
		obj[ att.name ] = att.value ;
	}

	var childNodes = el.childNodes ;
	for ( i = 0 ; i < childNodes.length ; i++ )
	{
		var child = childNodes[i] ;

		if ( child.nodeType == 1 )
		{
			var childName = '$' + child.nodeName ;
			var childList = obj[ childName ] ;
			if ( !childList )
				childList = obj[ childName ] = [] ;

			childList.push( this.transformToObject( child ) ) ;
		}
	}

	return obj ;
}
<?php require_once(dirname(__FILE__).'/jfooter.inc.php'); ?>