<?php
/**
 * Файл отвечает за вывод КАПЧИ
 *
 * @author Казбек Елекоев <elekoev@binn.ru>
 * @version 4.0
 * @package SB_Core
 * @copyright Copyright (c) 2007, OOO "СИБИЭС Групп"
 */
require_once(dirname(__FILE__).'/header.inc.php');

sbProgStartSession();

if(isset($_GET['turing_id']) && $_GET['turing_id'] != '' && isset($_SESSION['sb_captcha']) && is_array($_SESSION['sb_captcha']))
{
	$_GET['turing_id'] = preg_replace('/[^A-Za-z0-9]+/', '', $_GET['turing_id']);
	
	if (isset($_SESSION['sb_captcha'][$_GET['turing_id']]))
	{
		require_once(SB_CMS_LIB_PATH.'/prog/sbCaptcha.inc.php');
	
		if (function_exists('imagejpeg'))
        {
        	header('Content-type: image/jpeg');
        }
        elseif (function_exists('imagegif'))
        {
        	header('Content-type: image/gif');
        }
    	elseif (function_exists('imagepng'))
        {
        	header('Content-type: image/png');
        }
		
		$captcha = new sbCaptcha($_SESSION['sb_captcha'][$_GET['turing_id']]);
		echo $captcha->GetTuring();
	}
}
exit(0);
?>