<?php
require_once(dirname(__FILE__).'/header.inc.php');

if(isset($_GET['code'])){
    getToken($_GET['code']);
}
/**
 *      
 */
function getToken($code){
    $redirect = filter_var('http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'], FILTER_SANITIZE_URL);
    $message=array(
        'code'=>$code,
        'client_id'=>trim(sbPlugins::getSetting('sb_services_rutube_youtube_key')),
        'client_secret'=>trim(sbPlugins::getSetting('sb_services_rutube_youtube_marker')),
        'redirect_uri'=>$redirect,
        'grant_type'=>'authorization_code'
    );

    $ch = curl_init('https://accounts.google.com/o/oauth2/token');
    curl_setopt($ch, CURLOPT_POSTFIELDS, $message);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    $res=curl_exec($ch);
    $obj = json_decode($res,true);
    curl_close($ch);
    $pattern=array('http://','www.');
    $replace=array('','');
    $domain=str_replace($pattern,$replace,SB_DOMAIN);
    if (array_key_exists('refresh_token', $obj)) {
        sql_query('UPDATE sb_users SET u_refresh_token=? WHERE u_id=?d', $obj['refresh_token'], $_SESSION['sbAuth']->getUserId());
        if(isset($_SESSION['curr_path']) && $_SESSION['curr_path']!=''){
            header('Location:'.$_SESSION['curr_path']);
        }else{
            header('Location:'.SB_DOMAIN.'/cms/admin/content.php?event=pl_settings_read_0&domain='.$domain);
        }
    } else {
        header('Location:'.SB_DOMAIN.'/cms/admin/content.php?event=pl_settings_read_0&domain='.$domain);
    }
}
require_once(SB_CMS_KERNEL_PATH.'/footer.inc.php');