<?php
define ('PL_CATEGS_H_ADD_EDIT_TITLE', 'Добавление / Редактирование раздела');
define ('PL_CATEGS_H_GET_TITLE', 'Выберите раздел');
define ('PL_CATEGS_H_CHANGES_TITLE', 'История изменений');

define ('PL_CATEGS_ERROR_NO_CATEG', 'Ошибка! Раздел не существует или был удален.');
define ('PL_CATEGS_EDIT_HEADER', 'Редактирование раздела');
define ('PL_CATEGS_ADD_HEADER', 'Добавление раздела');
define ('PL_CATEGS_TITLE', 'Название раздела');
define ('PL_CATEGS_CLOSED', 'Закрытый раздел');
define ('PL_CATEGS_CLOSE_SUB', 'Установить указанные права для подразделов');
define ('PL_CATEGS_GROUPS', 'Группы пользователей сайта, имеющие доступ к разделу');
define ('PL_CATEGS_TAB1', 'Основные');
define ('PL_CATEGS_TAB2', 'Права доступа');
define ('PL_CATEGS_TAB3', 'Модераторы');
define ('PL_CATEGS_EDIT_MODERATE_EMAIL_FIELD', 'Электронные адреса модераторов раздела (через запятую)');
define ('PL_CATEGS_EDIT_MODERATE_EMAIL_DESCR', 'Укажите электронные адреса модераторов раздела, которым будут отправляться уведомления о добавленных элементах.');
define ('PL_CATEGS_EDIT_MODERATE_FROM_SYSTEM_USERS', 'Выберите модераторов из списка пользователей системы');

define ('PL_CATEGS_NO_TITLE_MSG', 'Ошибка! Не указано название раздела.');
define ('PL_CATEGS_NO_GROUPS_MSG', 'Ошибка! Не указаны группы пользователей.');

define ('PL_CATEGS_SET_ACTIVE_OK', 'Редактирование элемента <i>%s</i> в модуле <i>%s</i>.');

define ('PL_CATEGS_EDIT_ERROR', 'Ошибка! Не удалось изменить свойства раздела.');
define ('PL_CATEGS_ADD_ERROR', 'Ошибка! Не удалось добавить раздел.');
define ('PL_CATEGS_SYSLOG_EDIT_ERROR', 'Ошибка! Не удалось изменить свойства раздела <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_EDIT_OK', 'Редактирование раздела <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_RIGHTS_OK', 'Изменение прав доступа к разделу <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_ADD_ERROR', 'Ошибка! Не удалось добавить раздел <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_ADD_OK', 'Добавление раздела <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_DELETE_ERROR1', 'Ошибка! Не удалось удалить раздел <i>%s</i> в модуле <i>%s</i>. Раздел или его подразделы содержат элементы. ');
define ('PL_CATEGS_SYSLOG_DELETE_ELEMENTS_ERROR', 'Ошибка! Не удалось удалить элементы раздела <i>%s</i> или его подразделов в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_DELETE_ERROR2', 'Ошибка! Не удалось удалить раздел <i>%s</i> в модуле <i>%s</i>. Возможно, раздел был удален другим пользователем.');
define ('PL_CATEGS_SYSLOG_DELETE_OK', 'Раздел <i>%s</i> и все его подразделы в модуле <i>%s</i> успешно удалены.');
define ('PL_CATEGS_SYSLOG_DELETE_WITH_ELEMENTS_OK', 'Раздел <i>%s</i> и все его подразделы с элементами в модуле <i>%s</i> успешно удалены.');
define ('PL_CATEGS_CHECK_ERROR', 'Ошибка! Возможно раздел был удален другим пользователем или у Вас нет прав доступа к данному разделу.');
define ('PL_CATEGS_SYSLOG_CHECK_OK', 'Изменение видимости раздела <i>%s</i> на сайте в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_CHECK_ERROR', 'Ошибка! Не удалось изменить видимость раздела <i>%s</i> на сайте в модуле <i>%s</i>. Возможно, раздел был удален другим пользователем.');
define ('PL_CATEGS_PASTE_ERROR', 'Ошибка! Возможно раздел был удален другим пользователем или у Вас нет прав доступа к данному разделу.');
define ('PL_CATEGS_ERROR_MAX_DEEP', 'Ошибка! Максимально возможная глубина вложенности разделов для данного модуля составляет %s.');
define ('PL_CATEGS_SYSLOG_COPY', 'Копирование раздела <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_CUT', 'Перенос раздела <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_COPY_WITH_ELEMENTS', 'Копирование раздела <i>%s</i> с элементами в модуле <i>%s</i>.');

define ('PL_CATEGS_SYSLOG_RIGHTS', 'Изменение прав на раздел <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_RIGHTS_ERROR', 'Ошибка! Не удалось изменить права на раздел <i>%s</i> в модуле <i>%s</i>. Возможно, раздел был удален другим пользователем.');
    
define ('PL_CATEGS_SYSLOG_DELETE_ELEM', 'Удаление элемента <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_DELETE_LINK', 'Удаление ссылки на элемент <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_DELETE_ELEM_ERROR', 'Ошибка! Не удалось удалить элемент <i>%s</i> в модуле <i>%s</i>. Возможно, элемент был удален другим пользователем.');    

define ('PL_CATEGS_SYSLOG_CUT_ELEM', 'Перенос элемента <i>%s</i> из раздела <i>%s</i> в раздел <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_COPY_ELEM', 'Копирование элемента <i>%s</i> из раздела <i>%s</i> в раздел <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_COPY_LINK', 'Копирование ссылки на элемент <i>%s</i> из раздела <i>%s</i> в раздел <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_CREATE_LINK', 'Создание ссылки на элемент <i>%s</i> в разделе <i>%s</i> в модуле <i>%s</i>.');
define ('PL_CATEGS_SYSLOG_PASTE_ERROR', 'Ошибка! Не удалось вставить выделенные элементы в модуле <i>%s</i>. Возможно, раздел, в который осуществляется вставка, был удален другим пользователем.');
define ('PL_CATEGS_SYSLOG_COPY_ELEM_ERROR', 'Ошибка! Не удалось создать копию элемента <i>%s</i> из раздела <i>%s</i> в модуле <i>%s</i>.');

define ('PL_CATEGS_ELEM_CATEG_CATEGS_TAB', 'Разделы');
define ('PL_CATEGS_ELEM_CATEG_PROPS_TAB', 'Свойства');
define ('PL_CATEGS_ELEM_CATEG_ELEMS_TAB', 'Список элементов');
define ('PL_CATEGS_ELEM_CATEG_NO_TEMPS_MSG', '<b style="color:red;">Внимание:</b> Вы не создали ни одного макета дизайна для вывода разделов (<i>Меню разработчика - Макеты дизайна компонентов - %s</i>).');
define ('PL_CATEGS_ELEM_TEMP', 'Макет дизайна');
define ('PL_CATEGS_ELEM_CATEGS_PARENT_SELECTION', 'Сохранять выделение у разделов верхнего уровня');
define ('PL_CATEGS_ELEM_CATEGS_QUERY_STRING', 'Сохранять GET-параметры для ссылок');
define ('PL_CATEGS_ELEM_CATEGS_SHOW_CLOSED', 'Выводить закрытые разделы');
define ('PL_CATEGS_ELEM_CATEGS_SHOW_CLOSED_DESC', 'Если следует выводить закрытые разделы, поставьте галочку выше. В этом случае пользователи, не имеющие доступа к закрытым разделам, будут видеть ссылки на них. Сами разделы останутся для этих пользователей недоступными. Иначе ссылки на закрытые разделы увидят только пользователи, имеющие к ним доступ.');
define ('PL_CATEGS_ELEM_CATEGS_SHOW_HIDDEN', 'Выводить скрытые разделы');
define ('PL_CATEGS_ELEM_CATEGS_BBCODE_ALLOW', 'Разрешать BB-коды');
define ('PL_CATEGS_ELEM_CATEGS_ROOT', 'Выводить корневой раздел');  
define ('PL_CATEGS_ELEM_CATEGS_LINK', 'Установить связь с выводом разделов верхнего уровня');  
define ('PL_CATEGS_ELEM_CATEGS_LINK_DESC', 'Если Вы желаете при выборе раздела на странице выводить его подразделы в данном компоненте, следует поставить галочку выше.');  
define ('PL_CATEGS_ELEM_CATEGS_FROM_TO', 'Выводить разделы, начиная от уровня');
define ('PL_CATEGS_ELEM_CATEGS_COUNT', 'Кол-во выводимых уровней');
define ('PL_CATEGS_ELEM_CATEGS_FROM_TO_HINT', 'Если не указать параметр "до", то будут выводится все уровни разделов, начиная со значения параметра "от".');
define ('PL_CATEGS_ELEM_CATEGS_FROM_TO_ERROR', 'Ошибка! Значение \"от\" должно быть больше или равно значению \"до\".');
        
define ('PL_CATEGS_ELEM_CATEGS_PAGE', 'Страница для вывода содержимого раздела');
define ('PL_CATEGS_ELEM_PAGE', 'Страница для вывода элемента');
define ('PL_CATEGS_CACHE_TAB', 'Кеширование');

define ('PL_CATEGS_USE_COMPONENT_CACHE', 'Не кешировать компонент');
define ('PL_CATEGS_CACHE_NOT_URL', 'Не учитывать URL');
define ('PL_CATEGS_CACHE_NOT_GET', 'Не учитывать GET-параметры');
define ('PL_CATEGS_CACHE_NOT_GET_LIST', 'кроме перечисленных');
define ('PL_CATEGS_CACHE_NOT_GET_LIST_HINT', 'Укажите через пробел GET-параметры, которые <b>должны</b> участвовать при формировании кэша.');


define ('PL_CATEGS_ELEM_CATEGS_NO_CATEGS_MSG', 'Ошибка! Не выбраны разделы, которые следует выводить.');
define ('PL_CATEGS_ELEM_CATEGS_NO_TEMPS_MSG', 'Ошибка! Не выбран макет дизайна для вывода разделов.');

define ('PL_CATEGS_ELEM_SEL_CAT_NO_TEMPS_ALERT', 'Ошибка! Не выбран макет дизайна для вывода выбранного раздела.');
define ('PL_CATEGS_ELEM_SEL_CAT_NO_TEMPS_MSG', '<b style="color:red;">Внимание:</b> Вы не создали ни одного макета дизайна для вывода выбранного раздела (<i>Меню разработчика - Макеты дизайна компонентов - %s</i>).');

define ('PL_CATEGS_ELEM_CATEGS_INFO_FROM_TO', 'Выводить уровни');
define ('PL_CATEGS_ELEM_CATEGS_INFO_TEMP_WAS_DELETED_MSG', 'макет дизайна был удален');
define ('PL_CATEGS_ELEM_CATEGS_INFO_CATEGS_WAS_DELETED_MSG', 'разделы были удалены');
define ('PL_CATEGS_ELEM_CATEGS_INFO_PARENT_SELECTION', 'Сохранять выделение');
define ('PL_CATEGS_ELEM_CATEGS_INFO_LINK', 'Установить связь с верхним уровнем');

define ('PL_CATEGS_DESIGN_EDIT_ERROR', 'Ошибка! Возможно макет дизайна был удален другим пользователем или у Вас нет прав доступа к данному макету дизайна.');
define ('PL_CATEGS_DESIGN_NO_TITLE_MSG', 'Ошибка! Не указано название макета дизайна.');
define ('PL_CATEGS_DESIGN_EDIT_TAB1', 'Основные');
define ('PL_CATEGS_DESIGN_EDIT_TITLE', 'Название макета дизайна');
define ('PL_CATEGS_DESIGN_EDIT_LANG', 'Язык');
define ('PL_CATEGS_DESIGN_EDIT_LANG_LABEL', 'Язык используется для вывода названия месяца и названия дня недели в полях типа "Дата".');
define ('PL_CATEGS_DESIGN_EDIT_CAT_ID_TAG', 'Идентификатор раздела');
define ('PL_CATEGS_DESIGN_EDIT_CAT_URL_TAG', 'Псевдостатический адрес раздела (ЧПУ)');
define ('PL_CATEGS_DESIGN_EDIT_PARENT_ID_TAG', 'Идентификатор родительского раздела');
define ('PL_CATEGS_DESIGN_EDIT_PARENT_URL_TAG', 'Псевдостатический адрес родительского раздела (ЧПУ)');
define ('PL_CATEGS_DESIGN_EDIT_CAT_TITLE_TAG', 'Название раздела');
define ('PL_CATEGS_DESIGN_EDIT_CAT_COUNT_TAG', 'Кол-во элементов раздела');
define ('PL_CATEGS_DESIGN_EDIT_CAT_SUB_COUNT_TAG', 'Кол-во подразделов');
define ('PL_CATEGS_DESIGN_EDIT_LINK_TAG', 'Ссылка на вывод содержимого раздела');
define ('PL_CATEGS_DESIGN_EDIT_TAB_FIELD', 'Поля раздела');
define ('PL_CATEGS_DESIGN_EDIT_TAB_LEVEL', 'Уровень %s');
define ('PL_CATEGS_DESIGN_EDIT_TAB_SEL_CAT', 'Вывод раздела');
define ('PL_CATEGS_DESIGN_EDIT_COPY_FROM', 'Копировать предыдущий уровень');
define ('PL_CATEGS_DESIGN_EDIT_PAGELIST_TAG', 'Номера страниц');
define ('PL_CATEGS_DESIGN_EDIT_TOP', 'Верх');
define ('PL_CATEGS_DESIGN_EDIT_SUB', 'Раздел с подразделами');
define ('PL_CATEGS_DESIGN_EDIT_SUB_SEL', 'Раздел с подразделами<br />(выбранный)');
define ('PL_CATEGS_DESIGN_EDIT_ITEM', 'Раздел без подразделов');
define ('PL_CATEGS_DESIGN_EDIT_ITEM_SEL', 'Раздел без подразделов<br />(выбранный)');
define ('PL_CATEGS_DESIGN_EDIT_BOTTOM', 'Низ');
define ('PL_CATEGS_DESIGN_EDIT_SUBITEMS_TAG', 'Вывод подразделов');
define ('PL_CATEGS_DESIGN_EDIT_CLOSED_ICON', 'Иконка закрытого раздела');
define ('PL_CATEGS_DESIGN_EDIT_CAT_ELEMS', 'Вывод элементов раздела');
define ('PL_CATEGS_DESIGN_EDIT_CAT_ELEMS_TITLE', 'Макет дизайна вывода списка элементов раздела');
define ('PL_PAGES_CATEGS_DESIGN_EDIT_TEMPS_LABEL', '<b style="color:red;">Внимание:</b> Вы не создали ни одного макета дизайна вывода элементов раздела (<i>Меню разработчика - Макеты дизайна компонентов</i>). <b style="color:red;">Создать страницу Вы не сможете.</b>');

define ('PL_CATEGS_DESIGN_EDIT_OK', 'Редактирование макета дизайна вывода разделов <i>%s</i>.');
define ('PL_CATEGS_DESIGN_EDIT_SYSTEMLOG_ERROR', 'Ошибка! Не удалось отредактировать макет дизайна вывода разделов <i>%s</i>.');
define ('PL_CATEGS_DESIGN_EDIT_ADD_OK', 'Добавление макета дизайна вывода разделов <i>%s</i>.');
define ('PL_CATEGS_DESIGN_EDIT_ADD_ERROR', 'Ошибка! Не удалось добавить новый макет дизайна вывода разделов. Возможно у Вас нет прав доступа к выбранному разделу.');
define ('PL_CATEGS_DESIGN_EDIT_ADD_SYSTEMLOG_ERROR', 'Ошибка! Не удалось добавить новый макет дизайна вывода разделов <i>%s</i>.');    

define ('PL_CATEGS_DESIGN_SELCAT_EDIT_OK', 'Редактирование макета дизайна вывода выбранного раздела <i>%s</i>.');
define ('PL_CATEGS_DESIGN_SELCAT_EDIT_SYSTEMLOG_ERROR', 'Ошибка! Не удалось отредактировать макет дизайна вывода выбранного раздела <i>%s</i>.');
define ('PL_CATEGS_DESIGN_SELCAT_EDIT_ADD_OK', 'Добавление макета дизайна вывода выбранного раздела <i>%s</i>.');
define ('PL_CATEGS_DESIGN_SELCAT_EDIT_ADD_ERROR', 'Ошибка! Не удалось добавить новый макет дизайна вывода выбранного раздела. Возможно у Вас нет прав доступа к выбранному разделу.');
define ('PL_CATEGS_DESIGN_SELCAT_EDIT_ADD_SYSTEMLOG_ERROR', 'Ошибка! Не удалось добавить новый макет дизайна вывода выбранного раздела <i>%s</i>.');    

define ('PL_CATEGS_DESIGN_DELETE_ERROR', 'Макет дизайна связан с компонентами одной или нескольких страниц или дизайнов сайта, либо используется в меню. Удаление невозможно!');

define ('PL_CATEGS_CHANGES_NO_HISTORY', 'История изменений элемента отсутствует.');
define ('PL_CATEGS_CHANGES_USER', 'Пользователь');
define ('PL_CATEGS_CHANGES_DATE', 'Дата и время');
define ('PL_CATEGS_CHANGES_ACTION', 'Действия');
define ('PL_CATEGS_CHANGES_ACTION_ADD', 'Добавление');
define ('PL_CATEGS_CHANGES_ACTION_EDIT', 'Редактирование');
define ('PL_CATEGS_CHANGES_ACTION_CUT', 'Перенос');
?>