<?php

define('PL_DUMPER_H_PLUGIN_NAME', 'Восстановление/Перенос сайта');
define('PL_DUMPER_H_CREATE_POINT', 'Создание контрольной точки восстановления');
define('PL_DUMPER_H_CRON_TITLE', 'Создание точки восстановления');
define('PL_DUMPER_H_CRON_DESCR', 'Данное задание осуществляет создание контрольных точек восстановления по заданному расписанию.');
define('PL_DUMPER_H_SAVE_CMS', '<b>Сохранить файлы системы</b>');

$GLOBALS['sb_character_help']['pl_dumper_init'] = array();
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Модуль <b>«Восстановление/Перенос сайта»</b> предназначен для создания контрольных точек для восстановления Системы и для переноса сайта на другой сервер.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Для создания контрольной точки для восстановления Системы введите описание точки и нажмите на кнопку <b>Создать точку восстановления</b>.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Описание точки восстановления должно быть понятным и достаточно полно информировать о текущем состоянии Системы, так как после создания точку восстановления и ее описание изменить уже будет нельзя.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'При создании точки восстановления к ней автоматически будет добавлены дата и время создания.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Если используется многосайтовая версия Системы, то при создании контрольной точки восстановления Системы будут созданы точки восстановления для всех сайтов, работающих на данной CMS.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Контрольные точки восстановления после создания помещаются в папку <b>/cms/backup</b> на сервере.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Чтобы произвести восстановление Системы до определенной ранее сохраненной контрольной точки перейдите на закладку <b>Восстановление/Перенос сайта</b>. Установите радиокнопку слева от даты создания точки восстановления и нажмите на кнопку <b>Восстановить</b>.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Если с момента создания контрольной точки восстановления Система была обновлена, то в процессе восстановления CMS сама скачает и установит необходимые обновления.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Если при переносе сайта с сервера (<b>1</b>) на сервер (<b>2</b>) обнаружится, что Система на сервере (<b>2</b>) более поздней версии, чем на сервере (<b>1</b>), то файл контрольной точки будет автоматически обновлен до нужной версии.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Чтобы удалить ранее созданную точку восстановления, нажмите на кнопку <img src="'.SB_CMS_IMG_URL.'/files_drop.png" width="20" height="20" align="absmiddle" /> справа от описания точки на закладке <b>Восстановление/Перенос сайта</b>.';
$GLOBALS['sb_character_help']['pl_dumper_init'][] = 'Для удаления всех ранее созданных точек восстановления нажмите на ссылку <b>[ удалить все точки восстановления ]</b>.';

?>