<?php
define('PL_PLUGIN_DATA_H_TITLE', 'Макеты данных модулей');
define('PL_PLUGIN_DATA_H_GET_PLUGIN_DATA_TITLE', 'Выберите элементы');

$GLOBALS['sb_character_help']['pl_plugin_data_init'] = array();
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Модуль <b>«Макеты данных модулей»</b> предназначен для расширения количества и состава полей в диалоговых окнах редактирования свойств элементов и разделов у тех модулей Системы, которые используются для управления содержимым сайта.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<p>В правой области окна расположен список тех модулей Системы, у которых диалоговые окна редактирования свойств элементов или разделов могут быть расширены.</p> 
<p>Левая область окна – рабочая, в которой, собственно, и задаются новые поля для элементов и разделов.</p>';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Выберите в правой области окна модуль, расширение полей которого собираетесь произвести. Далее, в левой части окна выберите закладку <b>Поля элементов</b> для добавления полей в диалоговое окно редактирования свойств элементов и закладку <b>Поля разделов</b> - для добавления полей в диалоговое окно редактирования свойств раздела.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Нажмите на кнопку <img src="'.SB_CMS_IMG_URL.'/btn_add.png" width="20" height="20" align="absmiddle" /> для добавления нового поля в диалоговое окно редактирования свойств элемента (раздела) выбранного модуля.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Обязательно заполните поле <b>Наименование</b> для вновь создаваемого поля (исключение составляет интерфейсный элемент <b>Разделитель</b>).';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Типы добавляемых полей (а также их свойства) для элементов и для разделов одинаковы.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<p>Для редактирования свойств поля нажмите на кнопку <img src="'.SB_CMS_IMG_URL.'/btn_props.png" width="20" height="20" align="absmiddle" /> справа от его наименования.</p> 
<p>Заполните все необходимые поля в диалоговом окне на всех закладках (для разных типов полей различное количество закладок), затем нажмите на кнопку <b>Сохранить</b>.</p>';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<p>Следует помнить, что новые поля добавляются в диалоговом окне редактирования свойств элемента (раздела) в крайнюю правую закладку (в случае, если закладок в диалоговом окне несколько).</p>
<p>Рекомендуется сначала добавить новую закладку, задав ей наименование, затем в нее добавлять новые поля.</p>';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'При указании ширины или высоты поля ввода указывайте:
<ul>
<li><b>«px»</b> без пробела после числа, если хотите указать точную ширину поля ввода в пикселях;
<li><b>«%»</b> без пробела после числа, если хотите задать ширину поля ввода в процентах от ширины диалогового окна редактирования свойств элемента (раздела).
</ul>';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Добавление поля типа <b>«Строка»</b> вставляет в диалоговое окно редактирования свойств элемента (раздела) строку для ввода текста длиной <b>до 255 символов</b>.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'При редактировании свойств элемента (раздела) на закладке <b>Дополнительные</b> флажки, установленные в поля:
<ul>
<li><b>Выводить значение поля в списке элементов</b>,
<li><b>Добавить поле в контекстное меню сортировки</b>,
<li><b>Добавить поле в фильтр элементов</b>,
<li><b>Поле обязательно для заполнения</b>
</ul> 
соответствуют установленным флажкам «Инфо», «Сорт.», «Фильтр» и «Обязат.» справа от наименования поля в списке всех добавленных полей.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Добавление поля типа <b>«Текст»</b> вставляет в диалоговое окно редактирования свойств элемента (раздела) поле для ввода текста размером <b>до 64 Кб</b>.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Добавление поля типа <b>«Большой текст»</b> вставляет в диалоговое окно редактирования свойств элемента (раздела) поле для ввода текста размером <b>до 4Гб</b>.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Поле типа <b>«Число»</b> - поле для ввода целых или дробных числовых данных.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Добавление поля типа <b>«Дата»</b> позволяет добавить в диалоговое окно редактирования свойств элемента (раздела) строку даты и времени.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Добавление поля типа <b>«Флажок»</b> позволяет разместить в диалоговом окне редактирования свойств элемента (раздела) экранную кнопку для указания включения/выключения определенной опции.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<b>«Изображение»</b> – поле, добавляющее в диалоговое окно редактирования свойств элемента (раздела) возможность загрузить для элемента (раздела) изображение. Например, иконку, фотографию и т.п.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Выбор поля типа <b>«Ссылка на страницу»</b> позволяет добавить в диалоговое окно редактирования свойств элементов (разделов) поле, в котором можно указать ссылку на любой внутренний и внешний ресурс.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Поле типа <b>«Выбор разделов»</b> позволяет добавить в диалоговое окно редактирования свойств элемента (раздела) возможность выбора любого модуля Системы, у которого есть разделы, для того, чтобы позже пользователь мог выбрать один из разделов этого модуля.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Для некоторых полей свойства необходимо определять сразу же при добавлении поля.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<p><b>«Файл»</b> – поле, добавляющее в диалоговое окно редактирования свойств элемента (раздела) возможность загрузить для элемента (раздела) любой файл.</p>
<p>Например, документ MS Word, таблицу MS Excel и т.п.</p>';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Поле типа <b>«Цвет»</b> добавляет в диалоговое окно редактирования свойств элемента (раздела) поле выбора цвета.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Добавление поля типа <b>«Пароль»</b> вставляет в диалоговое окно редактирования свойств элемента (раздела) строку для ввода пароля длиной до 255 символов. При вводе пароля вводимые символы будут внешне заменяться знаками вида "*".';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<p>Поле типа <b>«JavaScript»</b> предназначено для расчета значений других полей.</p> 
<p>Например, при заполнении электронного магазина пользователь работает с тремя полями:
<ul>
<li>Цена
<li>Скидка
<li>Цена со скидкой
</ul>
Ввод определенного кода в <b>JavaScript-поле</b> позволит сделать так, чтобы при вводе полей <b>Цена</b> и <b>Скидка</b> поле <b>Цена со скидкой</b> рассчитывалось и заполнялось автоматически.</p>
<p>Расчеты будут произведены в момент закрытия диалогового окна редактирования свойств элемента (раздела).</p>';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<p><b>Справочники</b> - это массивы различных данных, которые могут использоваться во многих местах Системы, когда требуется, чтобы пользователь выбрал из нескольких, заранее заданных, значений.</p>
<p>Например, список городов России, станций метро Москвы и т.д. и т.п.</p>';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Поле типа <b>«Выпадающий список»</b> используется, когда при заполнении свойств элемента (раздела) необходимо выбрать одно значение из списка.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Поле типа <b>«Множественный выбор»</b> используется в случаях, когда при заполнении свойств элемента (раздела) необходимо выбрать несколько значений из списка.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Поле типа <b>«Набор переключателей»</b> используется, когда при заполнении свойств элемента (раздела) необходимо выбрать одно значение из списка, отображенного в виде набора нескольких радиокнопок.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<b>«Набор флажков»</b> используется в случаях, когда при заполнении свойств элемента (раздела) необходимо выбрать несколько значений из списка. Реализуется в виде полей, в которые требуется расставить флажки.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<p><b>«Связанные списки»</b> - вид типов данных, позволяющий объединять несколько списков. Например, необходимо выбрать определенную станцию метро в конкретном городе. Тогда, после выбора города (к примеру, была выбрана Москва) будет отображен список станций только московского метро.</p>
<p>Когда выбирается справочник, то в основном списке выводятся подразделы выбранного справочника, а в связанном списке их элементы.</p>
<p>В приведенном примере список городов считается списком, а список станций метро – связанным списком.</p>';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<b>Интерфейсные элементы</b> - элементы, не отображающиеся на сайте и служащие для структурированного разбиения полей внутри диалогового окна редактирования свойств элемента (раздела).';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Добавление интерфейсного элемента типа <b>«Закладка»</b> позволяет разбить диалоговое окно редактирования свойств элемента (раздела) на закладки.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Интерфейсный элемент <b>«Разделитель»</b>, помещенный между двух вновь добавленных полей, добавит пунктирную горизонтальную черту между этими полями в диалоговом окне редактирования свойств элемента (раздела).';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Интерфейсный элемент <b>«Текстовая метка»</b> является поясняющим  текстом, когда необходима ремарка или требуется текстом отделить поля внутри окна редактирования свойств элемента (раздела).';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<p>После добавления полей они отображаются в общем списке полей для элементов (разделов).</p>
<p>Дополнительно предоставляется возможность присвоить полю определенную служебную функцию (или функции).</p> 
<p>Чтобы присвоить добавленному полю служебную функцию установите соответствующий флажок («Инфо», «Сорт.», «Фильтр» или «Обязат.») справа от наименования поля.</p>';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Установка флажка <b>«Инфо»</b> справа от поля означает, что данное поле будет выводиться в списке характеристик элемента (раздела) внутри CMS.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Установка флажка <b>«Фильтр»</b> справа от наименования поля позволяет добавить это поле в блок фильтрования.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Установка флажка <b>«Сорт.»</b> добавляет выбранное поле в список признаков сортировки в контекстном меню Системы.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Установите флажок в поле <b>«Обязат.»</b>, если хотите сделать вновь добавленное поле для пользователя обязательным к заполнению.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'При необходимости удалить какое-либо поле из вновь добавленных, выберите соответствующий модуль, затем закладку, на которой расположено поле, и нажмите на кнопку <img src="'.SB_CMS_IMG_URL.'/btn_delete.png" width="20" height="20" align="absmiddle" /> справа от наименования поля в общем списке добавленных полей.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = 'Изменять значения чисел можно как нажатием на стрелки <img src="'.SB_CMS_IMG_URL.'/up.gif" width="9" height="9" align="absmiddle" /> и <img src="'.SB_CMS_IMG_URL.'/down.gif" width="9" height="9" align="absmiddle" />, так и при помощи колесика мыши или кнопок «вверх» и «вниз» на клавиатуре компьютера.';
$GLOBALS['sb_character_help']['pl_plugin_data_init'][] = '<p>При редактировании свойств поля типа <b>«Число»</b> укажите в поле <b>Инкремент</b> число-коэффициент, на который будет увеличиваться (уменьшаться) предыдущее значение в поле ввода при нажатии на кнопку-стрелку вверх <img src="'.SB_CMS_IMG_URL.'/up.gif" width="9" height="9" align="absmiddle" /> (вниз <img src="'.SB_CMS_IMG_URL.'/down.gif" width="9" height="9" align="absmiddle" />).</p>
<p>Если в качестве <b>Инкремента</b> выбрано целое число, то значения могут быть только целыми. Дробные значения можно задать, указав в качестве <b>Инкремента</b> десятичную дробь.</p>
<p>При задании <b>Инкремента</b> задается также и количество знаков в десятичной части дроби.</p> 
<p>Обратите внимание на то, что разделителем целой и дробной части в Системе является «.» (точка).';
define ('PL_ELEMENTSLIST_H_TITLE', 'Выбор элемента модуля');
?>