<?php

// Функция декодирования ключа
function sbKeyDecode($str)
{
    $p_signal = $str[23] + $str[24] + $str[30] + 38;

    $foot_str = substr($str, -3);
    $str = substr_replace(substr($str, 0, strlen($str)-3), $foot_str, $p_signal, 3);

    $new_str = '';
    $jump    = array(15,304,545,150,1150,145,784,198,1209,1304,511,678,489,3984,984,387,34);
    $str     = substr($str, 38);

    for ($i = 0; $i <= strlen($str) - 1; $i++)
    {
    	$j = each($jump);
        if ($j)
        {
            $j = $j[1];
        }
        else
        {
            reset($jump);
            $j = 18;
        }
        $new_str .= chr(ord($str[$i])-$j);
    }

    return strrev($new_str);
}

function sbKeyCheck(&$plugins, $check_main = true)
{
    $authfile = @fopen(SB_CMS_KERNEL_PATH.'/key.php', 'rb');
    if (!is_resource($authfile))
    {
        return SB_AUTH_NO_KEY;
    }

    $authKEY = @fread($authfile, 50000);
    @fclose($authfile);

    // определяем хост, на котором запущена система
    $serverHost = defined('SB_KEY_DOMAIN') ? strtoupper(SB_KEY_DOMAIN) : strtoupper(SB_COOKIE_DOMAIN);

    // разбираем ключ
    $authKEY = sbKeyDecode($authKEY);
    $authKEY = explode("\n", $authKEY);

	if(!defined('SB_CLIENT_VALIDITY'))
    	define('SB_CLIENT_VALIDITY', $authKEY[0]);
    if(!defined('SB_CLIENT_LIC'))
    	define('SB_CLIENT_LIC', $authKEY[1]);
    if(!defined('SB_CLIENT_NAME'))
    	define('SB_CLIENT_NAME', $authKEY[2]);
    if(!defined('SB_DEALER'))
    	define('SB_DEALER', $authKEY[3]);

    $domains = array();
    for ($i = 4; $i < count($authKEY); $i++)
    {
        if ($authKEY[$i] == '~~#@~~')
        {
            break;
        }
        else
        {
            $domains[] = $authKEY[$i];
        }
    }
    $i++;

    // домен, с которого идет обращение к системе
    $authsrvname = md5(SB_CLIENT_VALIDITY.'&w#v*6@'.$serverHost.'3kl%*(256)xd!'.SB_CLIENT_LIC.'9op#q@%23');
    if (!in_array($authsrvname, $domains))
    {
        // имя домена не совпадает с именем домена в ключе
        return SB_AUTH_WRONG_KEY;
    }

    if ($authsrvname != $domains[0] && $check_main)
    {
    	$main_domain = '';
    	$main_base_dir = '';
    	$serverBasedir = '';

        foreach ($GLOBALS['sb_domains'] as $host => $value)
        {
        	if (md5(SB_CLIENT_VALIDITY.'&w#v*6@'.strtoupper($host).'3kl%*(256)xd!'.SB_CLIENT_LIC.'9op#q@%23') == $domains[0])
        	{
        		$main_domain = $host;
        		$main_base_dir = $value['basedir'];
        	}

        	if (strtoupper($host) == $serverHost)
        	{
        		$serverBasedir = $value['basedir'];
        	}
        }

        if ($main_domain == '')
            return SB_AUTH_WRONG_KEY;

        if (!is_dir($main_base_dir.'/cms') || !is_dir($serverBasedir.'/cms/.'))
            return sprintf(SB_AUTH_WRONG_MAIN_DOMAIN, strtoupper($main_domain), $serverHost);

        if(!defined('SB_MAIN_DOMAIN'))
        	define('SB_MAIN_DOMAIN', $main_domain);
    }
    else
    {
    	if(!defined('SB_MAIN_DOMAIN'))
    		define('SB_MAIN_DOMAIN', strtolower($serverHost));
    }

    //установленные плагины
    for (; $i < count($authKEY); $i++)
    {
        if ($authKEY[$i] == '##!!-*##')
        {
            break;
        }

        $plugins[] = $authKEY[$i];
    }

    return '';
}
?>