<?php
function fAbout_Sysinfo()
{
    $res = sql_query('SELECT MAX(u_update_id) FROM sb_updates');
    if ($res) {
        list($u_update_id) = $res[0];

        $major_ver = trim(substr($u_update_id, 0, 2), '0');
        $minor_ver = substr($u_update_id, 2);

        $ver = $major_ver . '.' . $minor_ver;

        if (empty($ver) || $ver < CMS_DISTR_VERSION) {
            $ver = CMS_DISTR_VERSION;
        }
    } else {
        $ver = CMS_DISTR_VERSION;
    }

    require_once(SB_CMS_LIB_PATH . '/sbIDN.inc.php');
    $idn = new sbIDN();
    echo '<table width="100%" cellspacing="0" cellpadding="5" class="form" style="border:0;">
          <tr><td>' . PL_ABOUT_INC_CMS_VERSION . ':</td><td width="1"><b>' . $ver . '</b></td></tr>
          <tr><td>' . PL_ABOUT_INC_CMS_LIC . ':</td><td><b>' . SB_CLIENT_LIC . '</b></td></tr>
          <tr><td>' . PL_ABOUT_INC_CMS_DOMAIN . ':</td><td><b>' . $idn->decode(SB_MAIN_DOMAIN) . '</b></td></tr>';
    if (SB_CLIENT_VALIDITY != -1) {
        echo '<tr><td>' . PL_ABOUT_INC_CMS_LIC_DATE . ':</td><td>' . PL_ABOUT_INC_CMS_LIC_DATE_BEFORE . ' <b>' . sb_date('d.m.Y',
                SB_CLIENT_VALIDITY) . '</b> (<a href="http://www.sbuilder.ru/buy_cms/" target="_blank">' . PL_ABOUT_INC_BUY . '</a>)</td></tr>';
    }

    echo '<tr><td colspan="2" class="delim"></td></tr>
    	  <tr><td>' . PL_ABOUT_INC_PHP_VERSION . ':</td><td>' . PHP_VERSION . '</td></tr>
          <tr><td>' . PL_ABOUT_INC_MYSQL_VERSION . ':</td><td>' . $GLOBALS['sbSql']->getVersion() . '</td></tr>
          <tr><td colspan="2" class="delim"></td></tr>
          <tr><td>' . PL_ABOUT_INC_MEMORY_SPACE . ':</td><td>' . (@ini_get('memory_limit') ? @ini_get('memory_limit') : ' - ') . '</td></tr>
          <tr><td>' . PL_ABOUT_INC_DISK_SPACE . ':</td><td>' . (@disk_free_space(SB_BASEDIR) ? round(@disk_free_space(SB_BASEDIR) / 1024 / 1024,
                2) . 'M' : ' - ') . '</td></tr>
          <tr><td colspan="2" class="delim"></td></tr>
          <tr><td>' . PL_ABOUT_INC_POST_MAX_SIZE . ':</td><td>' . (@ini_get('post_max_size') ? @ini_get('post_max_size') : ' - ') . '</td></tr>
          <tr><td>' . PL_ABOUT_INC_UPLOAD_MAX_SIZE . ':</td><td>' . (@ini_get('upload_max_filesize') ? @ini_get('upload_max_filesize') : ' - ') . '</td></tr>
          <tr><td>' . PL_ABOUT_INC_MAX_TIME . ':</td><td>' . (@ini_get('max_execution_time') ? @ini_get('max_execution_time') . ' ' . PL_ABOUT_INC_MAX_TIME_SECONDS : ' - ') . '</td></tr>
          </table><br />
          <div class="sbDS_more"><a href="' . SB_CMS_CONTENT_FILE . '?event=pl_about_read">' . KERNEL_MORE . '</a></div>';
}
