<?php
require_once(SB_CMS_LANG_PATH.'/pl_comments.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_comments', PL_COMMENTS_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_COMMENTS_H_SUB_MENU.'>'.PL_COMMENTS_H_SHOW_TITLE, 'all_comments', 'pl_comments_list_24.png');
	if ($_SESSION['sbPlugins']->isRightAvailable('pl_comments', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_COMMENTS_H_PLUGIN_GENERAL.'>'.PL_COMMENTS_H_PLUGIN_NAME_LIST, 'init');
	}
	
	$_SESSION['sbPlugins']->addToMainPage('info', PL_COMMENTS_H_INFO_COMMENTS_LIST);

	$_SESSION['sbPlugins']->addUserEvent('init', 'fComments_Init', 'design_read', PL_COMMENTS_H_PLUGIN_INIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fComments_Edit', 'design_read', PL_COMMENTS_H_PLUGIN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fComments_Edit_Submit', 'design_edit', PL_COMMENTS_H_PLUGIN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('all_comments', 'fComments_List_Init', 'read', PL_COMMENTS_H_PLUGIN_NAME_LIST);
	$_SESSION['sbPlugins']->addUserEvent('set_active', 'fComments_Set_Active', 'read');

	$_SESSION['sbPlugins']->addSystemEvent('info', 'fComments_Info');

	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_comments_delim', PL_COMMENTS_H_PLUGIN_NAME_LIST, '', '');
	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_comments_count_comments', PL_COMMENTS_H_INFO_COUNT_COMMENT, 'number', '', '3');
}

$_SESSION['sbPlugins']->addSystemEvent('show', 'fComments_Show', PL_COMMENTS_H_SHOW_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('hide', 'fComments_Hide');
$_SESSION['sbPlugins']->addSystemEvent('delete_file', 'fComments_Delete_File');
$_SESSION['sbPlugins']->addSystemEvent('delete', 'fComments_Delete', PL_COMMENTS_H_SHOW_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('edit_comment', 'fComments_Edit_Comment', PL_COMMENTS_H_EDIT_COMMENT_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('edit_comment_submit', 'fComments_Edit_Comment_Submit', PL_COMMENTS_H_EDIT_COMMENT_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('comments_list', 'fComments_Get_Elem_Comments_List', PL_COMMENTS_H_GET_COMMENTS_LIST);

$_SESSION['sbPlugins']->addElem(PL_COMMENTS_H_GET_COMMENTS_LIST, 'comments', 'fComments_Elem_Comments_list', 'fComments_Elem_Comments_List_Info', 'comments_list', '750', '560', 'edit', 'pl_comments');

//$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
//$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
//$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
//$_SESSION['sbPlugins']->addEventsRights('elems_edit', RIGHTS_H_ELEMS_EDIT_RIGHT);
?>