<?php

//	удалять домен так чтобы пропадал в меню настроек.

function fDomain_Manager_Init()
{
	echo '
		<style type="text/css">
	    	#event_content table.form tr.even:hover,
			#event_content table.form tr.odd:hover
			{
			    background-color: #E1FFE1;
			}

			#event_content
			{
				overflow-x: auto;
			}
		</style>
	    <script>
		    document.body.onselectstart = "";
		    document.body.setAttribute("unselectable", "off");

			function sbDeleteDomain(domain)
			{
				if(confirm("'.PL_DM_DELETE_CONFIRM.'"))
				{
					sbLoadAsync(sb_cms_empty_file + "?event=pl_domains_manager_delete&domain="+domain, afterDeleteDomain);
				}
			}

			function afterDeleteDomain(res)
			{
				if(res == "MAIN")
				{
					alert("'.PL_DM_DELETE_MAIN_ERR.'");
				}
				else if(res != "OK")
				{
					alert("'.PL_DM_DELETE_ERR.'");
				}
				else
				{
					alert("'.PL_DM_DELETE.'");
				}
				window.parent.location.reload();
			}

			function sbAddDomain()
			{
				var strPage = sb_cms_modal_dialog_file + "?event=pl_domains_manager_edit";
				var strAttr = "resizable=1,width=780,height=380";
				sbShowModalDialog(strPage, strAttr, afterAddDomain);
			}

			function afterAddDomain()
			{
				window.parent.location.reload();
			}
		</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$domains = array();
	if (!$_SESSION['sbAuth']->isAdmin())
	{
		sb_show_message(PL_DM_NO_DOMAINS_MSG, true, 'warning');
		return;
	}
	else
	{
		$domains = $GLOBALS['sb_domains'];
	}

	if(count($domains) > 0)
	{
		echo '<br /><br />
				<center>
					<table width="98%" cellspacing="0" cellpadding="5" class="form">
					<tr>
						<th class="header" width="190">&nbsp;'.PL_DM_DOMAIN.'&nbsp;</th>
						<th class="header" width="300">&nbsp;'.PL_DM_DOMAIN_PATH.'&nbsp;</th>
						<th class="header" width="50%">&nbsp;'.PL_DM_DOMAIN_ALIAS.'&nbsp;</th>
						<th class="header" width="50"></th>
					</tr>';

		require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

		$i = 0;
		foreach($domains as $key => $value)
		{
			if (isset($value['pointers']) && is_array(isset($value['pointers'])))
			{
				foreach ($value['pointers'] as $k => $v)
				{
					$value['pointers'][$k] = $idn->decode($v);
				}
			}

			echo '<tr'.($i % 2 != 0 ? ' class="even"' : ' class="odd"').'>
					<td style="text-align:center;">'.$idn->decode($key).'</td>
					<td style="text-align:center;">'.$value['basedir'].'</td>
					<td style="text-align:center;">'.(isset($value['pointers']) ? implode(', ', $value['pointers']) : '').'</td>
					<td style="text-align:center;"><img height="20" width="20" style="cursor: pointer;" onClick = "sbDeleteDomain(\''.$key.'\');" title="'.KERNEL_DELETE.'" src="'.SB_CMS_IMG_URL.'/btn_delete.png"/></td>
				</tr>';
			$i++;
		}

		$fld = new sbLayoutInput('submit', KERNEL_ADD, '', '', 'onclick="sbAddDomain()"');

		echo '<tr'.($i % 2 != 0 ? ' class="even"' : ' class="odd"').' id="last">
					<td colspan="4" align="center">'.$fld->getField().'</td>
				</tr>
			</table>
		</center>';
	}
	else
	{
		sb_show_message(PL_DM_NO_DOMAINS_MSG, '', 'warning');
		return;
	}
}

function fDomain_Manager_Edit()
{
	if(count($_POST) > 0)
	{
		extract($_POST);
	}
	else
	{
		$domain_name =  $domain_basedir = $aliases = '';
	}
	echo '<script>
            function cancel()
            {
                var res = new Object();
		        res.close = true;
				sbReturnValue(res);
            }
			sbAddEvent(window, "close", cancel);

			function checkValues()
            {
				var el_title = sbGetE("domain_name");

			    var reg = new RegExp("^[ ]+|[ ]+$", "g");
				var title = el_title.value.replace(reg, "");
                if (title == "")
                {
          	         alert("'.PL_DM_EDIT_NO_DOMAIN_ERR_MSG.'");
					return false;
                }

                var el_date = sbGetE("domain_basedir");
                if (el_date.value == "")
                {
					alert("'.PL_DM_EDIT_NO_PATH_ERR_MSG.'");
                    return false;
                }
			}
			</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_domains_manager_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()', 'main', 'enctype="multipart/form-data"');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '250';

	echo '<br /><br />';
	$layout->addHeader(PL_DM_EDIT_TAB1);

	$layout->addField(PL_DM_EDIT_DOMAIN_NAME_FIELD_TITLE, new sbLayoutInput('text', $domain_name, 'domain_name', 'domain_name', 'style="width:440px;"', true));
	$layout->addField(PL_DM_EDIT_ROOT_CAT_FIELD_TITLE, new sbLayoutInput('text', $domain_basedir, 'domain_basedir', '', 'style="width:440px;"', true));

	$options = array();
	if(isset($GLOBALS['sb_domains']))
	{
		foreach($GLOBALS['sb_domains'] as $key => $value)
		{
			$options[$key] = $key;
		}
	}

	$fld = new sbLayoutSelect($options, 'sym_link_dest');
	$fld->mHTML = '<div class="hint_div">'.PL_DM_EDIT_SYM_LINK_DEST_TITLE_DESC.'</div>';
	$layout->addField(PL_DM_EDIT_SYM_LINK_DEST_TITLE, $fld);

	$layout->addField(PL_DM_DOMAIN_ALIAS_FIELD, new sbLayoutInput('text', $aliases, 'aliases', '', 'style="width:440px;"'));

	$layout->addButton('submit', KERNEL_ADD, '', '', ($_SESSION['sbAuth']->isAdmin() ? '' : 'disabled="disabled"'));
	$layout->show();
}

function fDomain_Manager_Submit()
{
	if (!$_SESSION['sbAuth']->isAdmin())
	{
		return;
	}

	$tmp_domain_name = $domain_name = $domain_basedir = $aliases = '';
	extract($_POST);

	require_once(SB_CMS_LIB_PATH.'/sbIDN.inc.php');
	$idn = new sbIDN();

	$domain_name = trim($domain_name);
	$_POST['domain_basedir'] = trim($_POST['domain_basedir']);

	if(preg_match('/[а-я]+/i', $domain_name))
	{
		$tmp_domain_name = $domain_name;
		$domain_name = $idn->encode($domain_name);
	}

	if($domain_name != '' && array_key_exists($domain_name, $GLOBALS['sb_domains']))
	{
		fDomain_Manager_Edit();
		sb_show_message(sprintf(PL_DM_SUBMIT_EXIST_DOMAIN, ($tmp_domain_name != '' ? $tmp_domain_name : $domain_name)), false, 'warning');
		return;
	}

	if(trim($domain_basedir) == '')
	{
		fDomain_Manager_Edit();
		sb_show_message(PL_DM_SUBMIT_NO_BASEDIR, false, 'warning');
		return;
	}

//	Определяем основной домен, для копирования настроек с него.
	$main_domain = '';
	$GLOBALS['sbVfs']->mLocal = true;
	if(isset($GLOBALS['sb_domains']))
	{
		foreach($GLOBALS['sb_domains'] as $key => $value)
		{
			if(isset($GLOBALS['sb_domains'][$key]['basedir']) &&
				$GLOBALS['sbVfs']->exists($GLOBALS['sb_domains'][$key]['basedir'].'/cms') &&
				$GLOBALS['sbVfs']->is_dir($GLOBALS['sb_domains'][$key]['basedir'].'/cms'))
			{
				$main_domain = $key;
				break;
			}
		}
	}

	if($main_domain != '')
	{
		$res = sql_query('SELECT s_setting, s_value FROM sb_settings WHERE s_domain=?', $main_domain);
		if($res)
		{
			$main_domain = $idn->decode($main_domain);

			foreach($res as $key => $value)
			{
				list($s_setting, $s_value) = $value;
//				следующие настройки не копируем. Они связаны с путями либо предназначены для конкретного домена.
				if($s_setting == 'sb_404_page' || $s_setting == 'sb_captcha_img' || $s_setting == 'sb_files_watermark_img' ||
					$s_setting == 'sb_yandex_maps_id' || $s_setting == 'sb_yandex_maps_metrika')
				{
					continue;
				}

				$s_value = unserialize($s_value);

				if($s_setting == 'sb_site_name')
				{
					$s_value = sb_str_replace($main_domain, $tmp_domain_name, $s_value);
				}
				else
				{
					$s_value = sb_str_replace($main_domain, $domain_name, $s_value);
				}
				sql_query('INSERT INTO sb_settings SET s_setting=?, s_value=?, s_domain=?', $s_setting, serialize($s_value), $domain_name);
			}
		}
	}

//	добавляем новый домен в config.inc.php
	$error = false;
	$config_file = SB_BASEDIR.'/cms/kernel/config.inc.php';
	$conf_arr = $GLOBALS['sbVfs']->file($config_file);
	if($conf_arr)
	{
		$arr_index = 0;
		foreach($conf_arr as $key => $value)
		{
			if(sb_strpos($value, '$GLOBALS[\'sb_domains\']') !== false ||
				sb_strpos($value, '$GLOBALS["sb_domains"]') !== false)
			{
				$arr_index = $key;
			}
		}
		$arr_index++;

		$first_part = array_slice($conf_arr, 0, $arr_index);
		$second_part = array_slice($conf_arr, $arr_index);

		$alias_str = '';
		if(trim($aliases) != '')
		{
			$aliases = explode(' ', $aliases);
			foreach($aliases as $key => $value)
			{
				if(preg_match('/[а-я]+/i', $value))
				{
					$value = $idn->encode($value);
				}
				$alias_str .= '\''.$value.'\', ';
			}
			$alias_str = substr($alias_str, 0, -2);
		}
		$entered_strs = array('
$GLOBALS[\'sb_domains\'][\''.$domain_name.'\'] = array();
$GLOBALS[\'sb_domains\'][\''.$domain_name.'\'][\'basedir\'] = \''.$domain_basedir.'\';
$GLOBALS[\'sb_domains\'][\''.$domain_name.'\'][\'ftp_host\'] = \'local\';
$GLOBALS[\'sb_domains\'][\''.$domain_name.'\'][\'ftp_basedir\'] = \'\';
$GLOBALS[\'sb_domains\'][\''.$domain_name.'\'][\'ftp_user\'] = \'\';
$GLOBALS[\'sb_domains\'][\''.$domain_name.'\'][\'ftp_password\'] = \'\';
$GLOBALS[\'sb_domains\'][\''.$domain_name.'\'][\'pointers\'] = array('.$alias_str.');
');
		$f = $GLOBALS['sbVfs']->fopen($config_file, 'w');
		if(!$GLOBALS['sbVfs']->fwrite(implode('', array_merge($first_part, $entered_strs, $second_part)), $f))
		{
			sb_add_system_message(PL_DM_SUBMIT_INSERT_CONFIG_RECORD_ERR_MSG, SB_MSG_WARNING);
			$error = true;
		}
	}

//	создаем символическую ссылку
	if(function_exists('symlink'))
	{
		if(!$GLOBALS['sbVfs']->exists($_POST['domain_basedir']) || !$GLOBALS['sbVfs']->is_dir($_POST['domain_basedir']))
		{
			if(!$GLOBALS['sbVfs']->mkdir($_POST['domain_basedir']))
			{
				sb_add_system_message(sprintf(PL_DM_SUBMIT_INSERT_SYMBOL_LINK_ERR_MSG, ($tmp_domain_name != '' ? $tmp_domain_name : $domain_name)), SB_MSG_WARNING);
				$error = true;
			}
		}

		if(isset($GLOBALS['sb_domains'][$sym_link_dest]['basedir']) &&
			$GLOBALS['sbVfs']->exists($GLOBALS['sb_domains'][$sym_link_dest]['basedir'].'/cms') &&
			$GLOBALS['sbVfs']->is_dir($GLOBALS['sb_domains'][$sym_link_dest]['basedir'].'/cms'))
		{
			symlink($GLOBALS['sb_domains'][$sym_link_dest]['basedir'].'/cms', $_POST['domain_basedir'].'/cms');
		}
		else
		{
			sb_add_system_message(sprintf(PL_DM_SUBMIT_INSERT_SYMBOL_LINK_DEST_DIR_ERR_MSG, ($tmp_domain_name != '' ? $tmp_domain_name : $domain_name)), SB_MSG_WARNING);
			$error = true;
		}
	}
	else
	{
		sb_add_system_message(sprintf(PL_DM_SUBMIT_INSERT_SYMBOL_LINK_NO_FUNC_ERR_MSG, ($tmp_domain_name != '' ? $tmp_domain_name : $domain_name)), SB_MSG_WARNING);
		$error = true;
	}

//	копируем файл .htaccess из корня указаноого домена.
	if(isset($GLOBALS['sb_domains'][$sym_link_dest]['basedir']))
	{
		if(!$GLOBALS['sbVfs']->copy($GLOBALS['sb_domains'][$sym_link_dest]['basedir'].'/.htaccess', $_POST['domain_basedir'].'/.htaccess', true))
		{
			sb_add_system_message(PL_DM_SUBMIT_COPY_HTACCESS_ERR_MSG, SB_MSG_WARNING);
			$error = true;
		}
	}
	$GLOBALS['sbVfs']->mLocal = false;

	if($error)
	{

		sb_show_message(sprintf(PL_DM_SUBMIT_CREATED_WITH_ERR, ($tmp_domain_name != '' ? $tmp_domain_name : $domain_name)), false, 'warning');
		sb_add_system_message(sprintf(PL_DM_SUBMIT_CREATED_OK, ($tmp_domain_name != '' ? $tmp_domain_name : $domain_name)));
		$_POST = array();

		fDomain_Manager_Edit();
		return;
	}
	sb_add_system_message(sprintf(PL_DM_SUBMIT_CREATED_OK, ($tmp_domain_name != '' ? $tmp_domain_name : $domain_name)));

	echo '<script>
			sbReturnValue(1);
		</script>';
}

function fDomain_Manager_Delete()
{
	if (!$_SESSION['sbAuth']->isAdmin() || !isset($_GET['domain']) || $_GET['domain'] == '')
	{
		return;
	}
	$error = false;
	$GLOBALS['sbVfs']->mLocal = true;

	require_once(SB_CMS_LIB_PATH.'/sbIDN.inc.php');
	$idn = new sbIDN();

	$tmp_domain_name = $idn->decode($_GET['domain']);


	// удаляем символическую ссылку. Но если /cms является директорией то это основной домен и тогда его не удалем.
	if(isset($GLOBALS['sb_domains'][$_GET['domain']]['basedir']) &&
		$GLOBALS['sbVfs']->exists($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].'/cms') &&
		$GLOBALS['sbVfs']->is_dir($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].'/cms'))
	{
		echo 'MAIN';
		return;
	}
	elseif(isset($GLOBALS['sb_domains'][$_GET['domain']]['basedir']) &&
		$GLOBALS['sbVfs']->exists($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].'/cms') &&
			$GLOBALS['sbVfs']->is_file($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].'/cms'))
	{
		if(!$GLOBALS['sbVfs']->delete($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].'/cms'))
		{
			sb_add_system_message(sprintf(PL_DM_SUBMIT_DELETE_SYM_LINK_ERR_MSG, $tmp_domain_name), SB_MSG_WARNING);
			$error = true;
		}
	}
	else
	{
		sb_add_system_message(sprintf(PL_DM_SUBMIT_DELETE_SYM_LINK_ERR_MSG, $tmp_domain_name), SB_MSG_WARNING);
		$error = true;
	}

//	удаляем домен из config.inc.php
	$config_file = SB_BASEDIR.'/cms/kernel/config.inc.php';
	$conf_arr = $GLOBALS['sbVfs']->file($config_file);

	if($conf_arr)
	{
		$arr_index = 0;
		foreach($conf_arr as $key => $value)
		{
			if(sb_strpos($value, '$GLOBALS[\'sb_domains\'][\''.$_GET['domain'].'\']') !== false ||
				sb_strpos($value, '$GLOBALS["sb_domains"][\''.$_GET['domain'].'\']') !== false ||
				sb_strpos($value, '$GLOBALS[\'sb_domains\']["'.$_GET['domain'].'"]') !== false ||
				sb_strpos($value, '$GLOBALS["sb_domains"]["'.$_GET['domain'].'"]') !== false)
			{
				unset($conf_arr[$key]);
			}
		}

		$f = $GLOBALS['sbVfs']->fopen($config_file, 'w');
		if(!$GLOBALS['sbVfs']->fwrite(implode('', $conf_arr), $f))
		{
			sb_add_system_message(PL_DM_SUBMIT_CONFIG_DELETE_ERR_MSG, SB_MSG_WARNING);
			$error = true;
		}
	}

//	Удаляем файл .htaccess из корня указаноого домена.
	if(isset($GLOBALS['sb_domains'][$_GET['domain']]['basedir']) &&
		$GLOBALS['sbVfs']->exists($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].'/.htaccess') &&
		$GLOBALS['sbVfs']->is_file($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].'/.htaccess'))
	{
		if(!$GLOBALS['sbVfs']->delete($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].'/.htaccess'))
		{
			sb_add_system_message(sprintf(PL_DM_SUBMIT_DELETE_HTACCESS_ERR_MSG, $tmp_domain_name), SB_MSG_WARNING);
			$error = true;
		}
	}

//	удаляем данные (разделы, элементы) модуля "Управление страницами".
	$res = sql_query('SELECT c.cat_id, c.cat_level FROM sb_categs AS c, sb_categs AS c2
							WHERE c2.cat_left <= c.cat_left
							AND c2.cat_right >= c.cat_right
							AND c.cat_ident="pl_pages"
							AND c2.cat_ident = "pl_pages"
							AND c2.cat_title = ?
							AND c2.cat_level = 1
							ORDER BY c.cat_left', $_GET['domain']);

//	получили все разделы удаляемого домена
	$root_cat_id = 0;
	$categs = array();

	if($res)
	{
		foreach($res as $key => $value)
		{
			if($value[1] == 1)
			{
				$root_cat_id = $value[0];
			}
			$categs[] = $value[0];
		}
	}

	if(count($categs) > 0)
	{
		$pages = sql_query('SELECT p.p_name, p.p_filepath, p.p_filename, p.p_id, l.link_id, c.cat_id FROM sb_pages p, sb_catlinks l, sb_categs c
				WHERE l.link_cat_id = c.cat_id
				AND l.link_el_id = p.p_id
				AND c.cat_id IN (?a)', $categs);

		//	удаляем страницы и связи
		$cats_paths = array();
		if($pages)
		{
			$old_filepath = '';
			foreach($pages as $key => $value)
			{
				list($p_name, $filepath, $filename, $p_id, $link_id, $cat_id) = $value;

				$filepath = ($filepath != '' ? '/'.$filepath : '');
				$filename = ($filename != '' ? '/'.$filename : '');

				if($filepath != $old_filepath)
				{
					$cats_paths[] = $filepath;
					$old_filepath = $filepath;
				}

				if(isset($GLOBALS['sb_domains'][$_GET['domain']]['basedir']) &&
					$GLOBALS['sbVfs']->exists($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].$filepath.$filename) &&
					$GLOBALS['sbVfs']->is_file($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].$filepath.$filename) &&
					$filename != '')
				{
					if($GLOBALS['sbVfs']->is_writable($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].$filepath.$filename))
					{
						//	удаляем файл страницы
						if(!$GLOBALS['sbVfs']->delete($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].$filepath.$filename))
						{
							sb_add_system_message(sprintf(PL_DM_SUBMIT_DELETE_NO_RIGHTS_TO_DELETE, $p_name, $filepath.$filename));
							$error = true;
						}
						else
						{
							//	Удаляем страницу. Страницу из базы.
							sql_query('LOCK TABLES sb_pages WRITE, sb_catlinks WRITE, sb_catchanges WRITE');
						    if (sql_query('DELETE FROM sb_pages WHERE p_id=?d', $p_id))
						    {
								sql_query('DELETE FROM sb_catlinks WHERE link_id=?d', $link_id);
					    	    sql_query('DELETE FROM sb_catlinks WHERE link_src_cat_id=?d AND link_el_id=?d', $cat_id, $p_id);
					    	    sql_query('DELETE FROM sb_catchanges WHERE el_id=?d AND cat_ident=?', $p_id, 'pl_pages');
					    	    sql_query('UNLOCK TABLES');
						    }
						    else
						    {
						        sql_query('UNLOCK TABLES');
						        sb_add_system_message(sprintf(PL_DM_SUBMIT_DELETE_ELEM_ERROR, $p_name), SB_MSG_WARNING);
								$error = true;
						    }
						}
					}
					else
					{
						sb_add_system_message(sprintf(PL_DM_SUBMIT_DELETE_NO_RIGHTS_TO_DELETE, $p_name, $filepath.$filename));
						$error = true;
					}
				}
			}

			//	удаляем разделы в файловой системе
			foreach($cats_paths as $key => $value)
			{
				if(isset($GLOBALS['sb_domains'][$_GET['domain']]['basedir']) &&
					$GLOBALS['sbVfs']->exists($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].$value) &&
					$GLOBALS['sbVfs']->is_dir($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].$value) &&
					$value != '')
				{
					if($GLOBALS['sbVfs']->is_writable($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].$value))
					{
						if(!$GLOBALS['sbVfs']->delete($GLOBALS['sb_domains'][$_GET['domain']]['basedir'].$value))
						{
							sb_add_system_message(sprintf(PL_DM_SUBMIT_DELETE_NO_DELETE_CAT, $value));
							$error = true;
						}
					}
					else
					{
						sb_add_system_message(sprintf(PL_DM_SUBMIT_DELETE_NO_RIGHTS_TO_DELETE_CAT, $value));
						$error = true;
					}
				}
			}

			//	удаляет раздел и все его подразделы из базы
			require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
			$tree = new sbTree('pl_pages');

			if(!$tree->removeNode($root_cat_id))
			{
				sb_add_system_message(PL_DM_SUBMIT_DELETE_NO_DELETE_CAT_FROM_DB);
				$error = true;
			}
		}
	}
	$GLOBALS['sbVfs']->mLocal = false;

	//	удаляем настройки домена
	sql_query('DELETE FROM sb_settings WHERE s_domain = ?', $_GET['domain']);

//	удаляем домен из меню настроек
	require_once(SB_CMS_LANG_PATH.'/pl_settings.h.lng.php');
	foreach($_SESSION['sbPlugins']->mMenu as $key => $value)
	{
		if(stripos($value['item'], KERNEL_MENU_DEVELOP.'>'.PL_SETTINGS_H_DOMAINS_SETTINGS.'>'.PL_SETTINGS_H_SETTING.' '.$tmp_domain_name) !== false)
		{
			unset($_SESSION['sbPlugins']->mMenu[$key]);
		}
	}

	//	удаляем базу индексации для домена
	$res = sql_query('SELECT ss_id FROM sb_search WHERE ss_domains = ?', $_GET['domain']);
	if ($res)
	{
		list($ss_id) = $res[0];

		$count = -1;
		if(isset($_SESSION['sbPlugins']->mCron['pl_search']) && count($_SESSION['sbPlugins']->mCron['pl_search']) > 0)
		{
			foreach ($_SESSION['sbPlugins']->mCron['pl_search'] as $key => $value)
			{
				if ($value['task_func'] == 'fSearch_Cron_Refresh('.$ss_id.')')
				{
					$count = $key;
					break;
				}
			}
		}

		if ($count == 0 && count($_SESSION['sbPlugins']->mCron['pl_search']) == 1)
	    {
	    	$_SESSION['sbPlugins']->mCron['pl_search'] = array();
	    }
	    elseif ($count >= 0)
	    {
			$tmp = array();
			$j = 0;
	    	for ($i = 0; $i < count($_SESSION['sbPlugins']->mCron['pl_search']); $i++)
	    	{
				if ($i == $count)
					continue;

	    		$tmp[$j] = array();
	    		$tmp[$j]['task_path'] = $_SESSION['sbPlugins']->mCron['pl_search'][$i]['task_path'];
			    $tmp[$j]['task_func'] = $_SESSION['sbPlugins']->mCron['pl_search'][$i]['task_func'];
			    $tmp[$j]['task_name'] = $_SESSION['sbPlugins']->mCron['pl_search'][$i]['task_name'];
			    $tmp[$j]['task_descr'] = $_SESSION['sbPlugins']->mCron['pl_search'][$i]['task_descr'];
			    $j++;
			}
			$_SESSION['sbPlugins']->mCron['pl_search'] = $tmp;
		}

		if(count($_SESSION['sbPlugins']->mCron['pl_search']) == 0)
		{
			unset($_SESSION['sbPlugins']->mCron['pl_search']);
		}

		sql_query('DELETE FROM sb_search WHERE ss_id = ?d ', $ss_id);
		sql_query('DELETE FROM sb_cron WHERE sc_plugin_ident="pl_search" AND sc_func_name="fSearch_Cron_Refresh('.$ss_id.')"');

		sql_query('DROP TABLE sb_search_pages_'.$ss_id);
	}

	if($error)
	{
		echo 'ERROR';
	}
	else
	{
		echo 'OK';
	}
	sb_add_system_message(sprintf(PL_DM_SUBMIT_DELETE_DOMAIN, $tmp_domain_name));
}

?>