<?php
require_once(SB_CMS_LANG_PATH.'/pl_editor.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_editor', PL_EDITOR_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/constr_mod.doc'))
{
	// добавляем пункт в меню "Меню разработчика"
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_EDITOR_H_MENU_ITEM.'>'.PL_EDITOR_H_TEMPLATES_NAME, 'templates_init');
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_EDITOR_H_MENU_ITEM.'>'.PL_EDITOR_H_STYLES_NAME, 'styles_init', 'pl_editor_styles_24.png');

	// открытие и инициализация модуля
	$_SESSION['sbPlugins']->addUserEvent('templates_init', 'fEditor_Templates_Init', 'read', PL_EDITOR_H_PLUGIN_NAME);
	// редактирование модуля
	$_SESSION['sbPlugins']->addUserEvent('templates_edit', 'fEditor_Templates_Edit', 'read', PL_EDITOR_H_EDIT_TEMPLATE);
	// сохранение после редактирования
	$_SESSION['sbPlugins']->addUserEvent('templates_edit_submit', 'fEditor_Templates_Edit_Submit', 'elems_edit', PL_EDITOR_H_EDIT_TEMPLATE);
	// удаление
	$_SESSION['sbPlugins']->addUserEvent('templates_delete', 'fEditor_Templates_Delete', 'elems_delete');
	// копирование
	$_SESSION['sbPlugins']->addUserEvent('templates_paste', 'fEditor_Templates_Paste', 'elems_edit');
	
	// открытие и инициализация модуля
	$_SESSION['sbPlugins']->addUserEvent('styles_init', 'fEditor_Styles_Init', 'read', PL_EDITOR_H_PLUGIN_NAME);
	// редактирование модуля
	$_SESSION['sbPlugins']->addUserEvent('styles_edit', 'fEditor_Styles_Edit', 'elems_edit', PL_EDITOR_H_EDIT_STYLE);
	// сохранение после редактирования
	$_SESSION['sbPlugins']->addUserEvent('styles_edit_submit', 'fEditor_Styles_Edit_Submit', 'elems_edit', PL_EDITOR_H_EDIT_STYLE);
}
	
$_SESSION['sbPlugins']->addEventsRights('elems_edit', PL_EDITOR_H_EDIT_RIGHTS);
$_SESSION['sbPlugins']->addEventsRights('elems_delete', PL_EDITOR_H_DELETE_RIGHTS);
	
// события для работы диалоговых окон виз. редактора
$_SESSION['sbPlugins']->addSystemEvent('source', 'fEditor_Source', PL_EDITOR_H_SOURCE_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('find', 'fEditor_Find', PL_EDITOR_H_FIND_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('spell', 'fEditor_Spell', PL_EDITOR_H_SPELL_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('spell_checker', 'fEditor_Spell_Checker');
$_SESSION['sbPlugins']->addSystemEvent('spell_dialog', 'fEditor_Spell_Dialog');
$_SESSION['sbPlugins']->addSystemEvent('spell_controls', 'fEditor_Spell_Controls');
$_SESSION['sbPlugins']->addSystemEvent('color', 'fEditor_Color', PL_EDITOR_H_COLOR_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('special_char', 'fEditor_Special_Char', PL_EDITOR_H_SPECIAL_CHAR_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('templates', 'fEditor_Templates', PL_EDITOR_H_TEMPLATES_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('paste', 'fEditor_Paste', PL_EDITOR_H_PASTE_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('image_preview', 'fEditor_Image_Preview');
$_SESSION['sbPlugins']->addSystemEvent('image', 'fEditor_Image', PL_EDITOR_H_IMAGE_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('flash_preview', 'fEditor_Flash_Preview');
$_SESSION['sbPlugins']->addSystemEvent('flash', 'fEditor_Flash', PL_EDITOR_H_FLASH_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('movie', 'fEditor_Movie', PL_EDITOR_H_MOVIE_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('link', 'fEditor_Link', PL_EDITOR_H_LINK_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('anchor', 'fEditor_Anchor', PL_EDITOR_H_ANCHOR_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('imagemap', 'fEditor_Imagemap', PL_EDITOR_H_IMAGEMAP_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('table', 'fEditor_Table', PL_EDITOR_H_TABLE_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('table_cell', 'fEditor_Table_Cell', PL_EDITOR_H_TABLE_CELL_TITLE);

$_SESSION['sbPlugins']->addSystemEvent('popup', 'fEditor_Popup', PL_EDITOR_H_POPUP_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('full', 'fEditor_Full');
$_SESSION['sbPlugins']->addSystemEvent('toolbar', 'fEditor_Toolbar');

// Работа с редактируемыми блоками
$_SESSION['sbPlugins']->addSystemEvent('save_block', 'fEditor_Save_Block');
$_SESSION['sbPlugins']->addSystemEvent('delete_block', 'fEditor_Delete_Block');
$_SESSION['sbPlugins']->addSystemEvent('replace_block', 'fEditor_Replace_Block', PL_EDITOR_H_REPLACE_BLOCK_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('replace_block_submit', 'fEditor_Replace_Block_Submit', PL_EDITOR_H_REPLACE_BLOCK_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('block_settings', 'fEditor_Block_Settings', PL_EDITOR_H_SETTINGS_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('block_settings_submit', 'fEditor_Block_Settings_Submit');
$_SESSION['sbPlugins']->addSystemEvent('new_text', 'fEditor_New_Text', PL_EDITOR_H_NEW_TEXT_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('new_text_submit', 'fEditor_New_Text_Submit', PL_EDITOR_H_NEW_TEXT_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('add_block', 'fEditor_Add_Block', PL_EDITOR_H_ADD_BLOCK_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('add_block_submit', 'fEditor_Add_Block_Submit', PL_EDITOR_H_ADD_BLOCK_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('move_block', 'fEditor_Move_Block');

$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_editor_delim', PL_EDITOR_H_MENU_ITEM, '', '');
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_editor_fonts', PL_EDITOR_H_FONTS_SETTING, 'string', '', 'Arial;Tahoma;Times New Roman;Verdana;Comic Sans MS;Courier New;Georgia');
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_editor_font_sizes', PL_EDITOR_H_FONT_SIZES_SETTING, 'string', '', '8px;9px;10px;11px;12px;14px;16px;18px;20px;22px;24px;26px;28px;36px;48px;72px');
$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_editor_styles', PL_EDITOR_H_STYLES, 'string', '', '');

$options = array('br' => 'br', 'p' => 'p', 'div' => 'div');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_enter_mode', PL_EDITOR_H_SETTING_ENTER_MODE, 'select', $options, 'p');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_shift_enter_mode', PL_EDITOR_H_SETTING_SHIFT_ENTER_MODE, 'select', $options, 'br');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_enter_delim');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_tab_spaces', PL_EDITOR_H_SETTING_TAB_SPACES, 'number', '', '0');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_ident_offset', PL_EDITOR_H_SETTING_IDENT_OFFSET, 'number', '', '40');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_strong_delim');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_strong', PL_EDITOR_H_SETTING_STRONG, 'checkbox', '', '0');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_em', PL_EDITOR_H_SETTING_EM, 'checkbox', '', '0');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_strong_delim');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_design_item', PL_EDITOR_H_SETTING_DESIGN_ITEM, 'checkbox', '', '1');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_default_new_text', PL_EDITOR_H_SETTING_DEFAULT_NEW_TEXT, 'text_categs', '', '');
$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_icons_delim');
	
$options = array(
'icon_source' => '<img style="background-position: 0px -836px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_HTML,
'icon_cut' => '<img style="background-position: 0px -990px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_CUT,
'icon_copy' => '<img style="background-position: 0px -1012px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_COPY,
'icon_paste' => '<img style="background-position: 0px -551px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_PASTE,
'icon_pasteplain' => '<img style="background-position: -1px -529px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_PASTE_PLAIN,
'icon_pasteword' => '<img style="background-position: -1px -507px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_PASTE_WORD,
'icon_find' => '<img style="background-position: 0px -946px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_FIND,
'icon_spell' => '<img style="background-position: 0px -264px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_SPELL,                                                   
'icon_undo' => '<img style="background-position: 0px -44px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_UNDO,
'icon_redo' => '<img style="background-position: 0px -462px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_REDO,
'icon_link' => '<img style="background-position: -1px -705px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_LINK,
'icon_anchor' => '<img style="background-position: 0px -1232px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ANCHOR,
'icon_unlink' => '<img style="background-position: -2px -23px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_UNLINK,
'icon_image' => '<img style="background-position: -1px -814px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_IMAGE,
'icon_imagemap' => '<img style="background-position: -1px -794px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_IMAGEMAP,
'icon_flash' => '<img style="background-position: -1px -925px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_FLASH,
'icon_movie' => '<img style="background-position: 0px -484px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_MOVIE,
'icon_templates' => '<img style="background-position: 0px -133px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_TEMPLATES,
'icon_char' => '<img style="background-position: 0px -287px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_SPECIAL_CHAR,
'icon_pagebreak' => '<img style="background-position: -2px -594px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_PAGE_BREAK,
'icon_hr' => '<img style="background-position: 0px -858px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_HR,
'icon_bold' => '<img style="background-position: 0px -1188px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_BOLD,
'icon_italic' => '<img style="background-position: 0px -748px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ITALIC,
'icon_underline' => '<img style="background-position: 0px -66px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_UNDERLINE,
'icon_strike' => '<img style="background-position: -1px -242px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_STRIKE,
'icon_sub' => '<img style="background-position: 0px -220px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_SUBSCRIPT,
'icon_sup' => '<img style="background-position: 0px -198px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_SUPERSCRIPT,
'icon_left' => '<img style="background-position: 0px -726px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_LEFT,
'icon_center' => '<img style="background-position: 0px -1056px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_CENTER,
'icon_right' => '<img style="background-position: 0px -374px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_RIGHT,
'icon_justify' => '<img style="background-position: 0px -880px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_FULL,
'icon_numberlist' => '<img style="background-position: 0px -638px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ORDERED_LIST,
'icon_bulletlist' => '<img style="background-position: 0px -1100px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_UNORDERED_LIST,
'icon_indent' => '<img style="background-position: 0px -770px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_INDENT,      
'icon_outdent' => '<img style="background-position: 0px -616px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_OUTDENT,
'icon_fontcolor' => '<img style="background-position: 0px -902px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_FONT_COLOR,
'icon_backcolor' => '<img style="background-position: 0px -1210px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_BACKGROUND_COLOR,
'icon_select' => '<img style="background-position: -1px -309px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_SELECTALL,
'icon_removeformat' => '<img style="background-position: 0px -418px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_REMOVE_FORMAT,
'icon_borders' => '<img style="background-position: -1px -1167px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_SHOW_BLOCKS,
'icon_par' => '<img style="background-position: 0px -572px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_PARAGRAPH,
'icon_div' => '<img style="background-position: -1px -1343px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_DIV,
'icon_br' => '<img style="background-position: 0px -1122px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_BR,
'icon_nbsp' => '<img style="background-position: 0px -660px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_NBSP,
'combo_styles' => '<img src="'.SB_CMS_IMG_URL.'/data_types/select_sprav.gif" align="absmiddle" />&nbsp; - '.PL_EDITOR_H_BTN_STYLE,
'combo_formats' => '<img src="'.SB_CMS_IMG_URL.'/data_types/select_sprav.gif" align="absmiddle" />&nbsp; - '.PL_EDITOR_H_BTN_FONT_FORMAT,
'combo_fonts' => '<img src="'.SB_CMS_IMG_URL.'/data_types/select_sprav.gif" align="absmiddle" />&nbsp; - '.PL_EDITOR_H_BTN_FONT_NAME,
'combo_sizes' => '<img src="'.SB_CMS_IMG_URL.'/data_types/select_sprav.gif" align="absmiddle" />&nbsp; - '.PL_EDITOR_H_BTN_FONT_SIZE,
'icon_table' => '<img style="background-position: -1px -176px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_TABLE,
'icon_removetable' => '<img style="background-position: -2px -1364px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_REMOVE_TABLE,
'icon_tableedit' => '<img style="background-position: -1px -154px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_EDIT_TABLE,
'icon_celledit' => '<img style="background-position: -1px -1078px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_EDIT_CELL,
'icon_topalign' => '<img style="background-position: -2px -112px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ALIGN_TOP,
'icon_middlealign' => '<img style="background-position: -2px -684px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ALIGN_MIDDLE,
'icon_bottomalign' => '<img style="background-position: -2px -1146px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ALIGN_BOTTOM,
'icon_mergecol' => '<img style="background-position: 0px -1032px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_MERGE_COL,
'icon_mergerow' => '<img style="background-position: -2px -1386px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_MERGE_ROW,
'icon_merge' => '<img style="background-position: -1px -352px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_MERGE,         
'icon_splitcol' => '<img style="background-position: -1px -88px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_SPLIT_COL,
'icon_splitrow' => '<img style="background-position: -1px 0px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_SPLIT_ROW,
'icon_addcolbefore' => '<img style="background-position: 0px -1298px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ADDCOL_BEFORE,
'icon_addcol' => '<img style="background-position: 0px -1320px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ADDCOL_AFTER,
'icon_removecol' => '<img style="background-position: 0px -440px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_REMOVE_COL,
'icon_addrowbefore' => '<img style="background-position: 0px -1254px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ADDROW_BEFORE,
'icon_addrow' => '<img style="background-position: 0px -1276px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_ADDROW_AFTER,
'icon_removerow' => '<img style="background-position: 0px -396px;background-image: url('.SB_CMS_IMG_URL.'/editor/icons.png);" src="'.SB_CMS_IMG_URL.'/blank.gif" width="22" height="22" align="absmiddle" /> - '.PL_EDITOR_H_BTN_REMOVE_ROW
);

$values = array(
'icon_source', 'icon_cut', 'icon_copy', 'icon_paste', 'icon_pasteplain', 'icon_pasteword', 'icon_find', 'icon_spell', 'icon_undo',
'icon_redo', 'icon_link', 'icon_anchor', 'icon_unlink', 'icon_image', 'icon_imagemap', 'icon_flash', 'icon_movie', 'icon_templates',
'icon_char', 'icon_pagebreak', 'icon_hr', 'icon_bold', 'icon_italic', 'icon_underline', 'icon_strike', 'icon_sub', 'icon_sup', 'icon_left',
'icon_center', 'icon_right', 'icon_justify', 'icon_numberlist', 'icon_bulletlist', 'icon_indent', 'icon_outdent', 'icon_fontcolor', 
'icon_backcolor', 'icon_select', 'icon_removeformat', 'icon_borders', 'icon_par', 'icon_div', 'icon_br', 'icon_nbsp', 'icon_table',
'icon_removetable', 'icon_tableedit', 'icon_celledit', 'icon_topalign', 'icon_middlealign', 'icon_bottomalign', 'icon_mergecol',
'icon_mergerow', 'icon_merge', 'icon_splitcol', 'icon_splitrow', 'icon_addcolbefore', 'icon_addcol', 'icon_removecol', 
'icon_addrowbefore', 'icon_addrow', 'icon_removerow', 'combo_styles', 'combo_formats', 'combo_fonts', 'combo_sizes');

$_SESSION['sbPlugins']->addUserSetting(PL_EDITOR_H_SETTINGS_TAB, 'sb_editor_icons', PL_EDITOR_H_SETTING_ICONS, 'checkboxes', $options, $values);

unset($options);
unset($values);
?>