<?php
function fExport_Init()
{
    if(isset($_GET['del_id']) && intval($_GET['del_id']) != 0)
    {
        sql_param_query('DELETE FROM sb_export_import_templates WHERE seit_id=?d', intval($_GET['del_id']));
    }

    $plugins = $_SESSION['sbPlugins']->getExportImportInfo();
    $pluginsInfo = $_SESSION['sbPlugins']->getPluginsInfo();
    $GLOBALS['sb_cmp_sort_field'] = 'title';
    uasort($plugins, 'sb_cmp_array');

    foreach ($plugins as $key => $value)
    {
        	if (!isset($menuObj))
            {
                $menuObj = new sbCustomElements($key);

                $menuObj->mImagePath = '/plugins/';
                $menuObj->mCategsTreeLines = false;
                $menuObj->mHeaderHiddenStr = '<script src="'.SB_CMS_JSCRIPT_URL.'/sbPluginData.js.php"></script>';
            }
            if(!isset($pluginsInfo[$key]))
            {
                $menuObj->addItem($key, $value['title'], 'pl_export_outing&ident='.$key);
            }
            else
            {
                $menuObj->addItem($key, $value['title'], 'pl_export_outing&ident='.$key, str_replace('_24', '_16', substr($pluginsInfo[$key]['icon'], strrpos($pluginsInfo[$key]['icon'], '/') + 1)));
            }
    }

    if (isset($menuObj))
        $menuObj->init();
    else
        sb_show_message(PL_EXPORT_NO_MODULES, true, 'warning');
}

function fExport_Add_Template()
{
    if(!isset($_GET['ident']) || $_GET['ident'] == '' || !isset($_GET['type']) || $_GET['type'] == '')
    {
        return;
    }

    $ident = $_GET['ident'];
    $type = $_GET['type'];
    $class = 'sb'.ucfirst($type);

    $obj = new $class(SB_CMS_CONTENT_FILE . '?event=pl_export_add_template_submit&type='.$type.'&ident='.$ident.(isset($_GET['id'])? '&id='.$_GET['id'] : ''));
    if(isset($_GET['id']))
    {
        $obj->setEditTpl($_GET['id']);
    }

    $obj->getForm($ident)->show();
}

function fExport_Add_Template_Submit()
{
    if(!isset($_POST['templateName']) || '' == $_POST['templateName'])
    {
        sb_show_message(PL_EXPORT_NO_TEMPLATE_NAME, false, 'warning');
        fExport_Add_Template();
        return;
    }

    $ident = $_GET['ident'];
    $type = $_GET['type'];
    $class = 'sb'.ucfirst($type);
    $id = null;

    $obj = new $class();
    if(isset($_GET['id']))
    {
        $id = intval($_GET['id']);
    }
    $obj->createTemplate($id);

    echo '<script type="text/javascript">window.close();</script>';
}

function fExport_Edit()
{
    
    $obj = new sbExport();
    $layout = new sbLayout(SB_CMS_EMPTY_FILE . '?event=pl_export_edit_submit&plugin_ident='.$_GET['ident'], '_blank');

    $options = $obj->getTemplatesList($_GET['ident']);
    if(!empty($options))
    {
        $fld = new sbLayoutSelect($options, 'export_tpl');
    }
    else
    {
        $fld = new sbLayoutHTML('<div class="hint_div">'.PL_EXPORT_SELECT_NO_TPL.'</div>');
    }
    
    $layout->addField(PL_EXPORT_SELECT_TPL, $fld);
    
    if ($_GET['ident'] != 'pl_polls_results')
    {
        echo '<br/>
    <script type="text/javascript">
        function checkValues()
        {
            var cat = sbGetE("cat_id");
            if(!cat || cat.value == "")
            {
                alert("' . PL_EXPORT_EDIT_CHECK_FORM_CATEGS . '");
                return false;
            }
        }
    </script>';

        $fld = new sbLayoutCategs($_GET['ident'], '', $_GET['cat_id'], 'cat_id', 'cat_id', '', true);
        $fld->mMultiSelect = true;
        $layout->addField(PL_EXPORT_EDIT_EXPORT_CATEGS, $fld);

        $fld = new sbLayoutInput('checkbox', '1', 'sub_categ', 'sub_categ');
        $layout->addField(PL_EXPORT_EDIT_SUB_CATEGS, $fld);
    }
    else
    {
        echo '<br/><script type="text/javascript">function checkValues(){return true;}</script>';
        
        $fld = new sbLayoutInput('checkbox', '1', 'details', 'details');
        $layout->addField(PL_EXPORT_EDIT_DETAL_EXPORT, $fld);
        
        $fld = new sbLayoutInput('hidden', $_GET['cat_id'], 'cat_id');
        $layout->addField('', $fld);
        
        $fld = new sbLayoutInput('hidden', $_GET['id'], 'elem_id');
        $layout->addField('', $fld);
    }
    
    $edit_rights = $_SESSION ['sbPlugins']->isRightAvailable($_GET['ident'] == 'pl_polls_results'? 'pl_polls' : $_GET['ident'], 'read');

    $layout->addButton('submit', PL_EXPORT_EDIT_EXPORT_BUTTON, 'btf_save', 'btf_save', (($edit_rights && !empty($options)) ? 'sbnotdisable="yes"' : 'disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', 'btf_cancel', 'onclick="window.close();" sbnotdisable="yes"');

    $layout->show();
}

function fExport_Edit_Submit()
{
    $obj = new sbExport();
    $obj->export($_GET['plugin_ident'], $_POST['export_tpl'], $_POST['cat_id'], (isset($_POST['sub_categ']) && $_POST['sub_categ'] == 1)? true : false);
    if($obj->hasError())
    {
        echo '<script type="text/javascript">window.close();</script>';
    }
}
?>
