<?php
require_once(SB_CMS_LANG_PATH . '/pl_external_script.h.lng.php');
if($_SESSION['sbPlugins']->register('pl_external_script', PL_EXTERNAL_SCRIPT_TITLE, ''))
{
    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_EXTERNAL_SCRIPT_TITLE, 'init', 'pl_external_script_24.png');

    $_SESSION['sbPlugins']->addUserEvent('init', 'fExternal_Script_Init', 'read', PL_EXTERNAL_SCRIPT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('edit', 'fExternal_Script_Edit', 'elems_edit', PL_EXTERNAL_SCRIPT_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fExternal_Script_Edit_Submit', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('delete', 'fExternal_Script_Delete', 'delete');

    $res = sql_param_query('SELECT es_id, es_url FROM sb_external_script');
    if($res)
    {
        foreach($res as $row)
        {
            $_SESSION['sbPlugins']->addToCron('pl_external_script/cron/pl_external_script.php', 'fExternal_Script_Cron_Refresh('.$row[0].')', sprintf(PL_EXTERNAL_SCRIPT_H_CRON, sb_wordwrap($row[1], 20, '...', true)), PL_EXTERNAL_SCRIPT_DESC_CRON);
        }
    }

    $_SESSION['sbPlugins']->addEventsRights('elems_edit', PL_EXTERNAL_SCRIPT_H_RIGHTS_EDIT);
    $_SESSION['sbPlugins']->addEventsRights('delete', PL_EXTERNAL_SCRIPT_H_RIGHTS_DELETE);
}
?>
