<?php
require_once(SB_CMS_LANG_PATH.'/pl_faq.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_faq', PL_FAQ_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_FAQ_H_SUB_MENU.'>'.PL_FAQ_H_PLUGIN_NAME, 'init');
    $_SESSION['sbPlugins']->addToExportImport(true, false);

	$_SESSION['sbPlugins']->addToMainPage('info', PL_FAQ_H_PLUGIN_NAME);
	if ($_SESSION['sbPlugins']->isRightAvailable('pl_faq', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FAQ_H_PLUGIN_NAME.'>'.PL_FAQ_H_ELEM_LIST , 'design_list', 'pl_faq_list_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FAQ_H_PLUGIN_NAME.'>'.PL_FAQ_H_FULL_ELEM , 'design_full', 'pl_faq_full_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FAQ_H_PLUGIN_NAME.'>'.PL_FAQ_H_ELEM_CATEGS, 'design_categs', 'pl_faq_categs_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FAQ_H_PLUGIN_NAME.'>'.PL_FAQ_H_ELEM_SEL_CAT, 'design_selcat', 'pl_faq_sel_cat_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FAQ_H_PLUGIN_NAME.'>'.PL_FAQ_H_ELEM_FORM, 'design_form', 'pl_faq_form_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FAQ_H_PLUGIN_NAME.'>'.PL_FAQ_H_ELEM_FILTER_FORM, 'design_filter_form', 'pl_faq_filter_form_24.png');
	}

	$_SESSION['sbPlugins']->setMainEvent('init');

    $_SESSION['sbPlugins']->addUserEvent('init', 'fFaq_Init', 'read', PL_FAQ_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('edit', 'fFaq_Edit', 'read', PL_FAQ_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fFaq_Edit_Submit', 'elems_edit', PL_FAQ_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('set_active', 'fFaq_Set_Active', 'elems_public');
    $_SESSION['sbPlugins']->addUserEvent('delete', 'fFaq_Delete', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements', 'fFaq_Delete_With_Elements', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('paste', 'fFaq_Paste', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fFaq_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');

    $_SESSION['sbPlugins']->addUserEvent('categs_edit', 'fFaq_Categs_Edit', 'categs_edit', PL_FAQ_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('categs_submit', 'fFaq_Categs_Submit', 'categs_edit', PL_FAQ_H_PLUGIN_NAME);

    $_SESSION['sbPlugins']->addUserEvent('design_list', 'fFaq_Design_List', 'design_read', PL_FAQ_H_DESIGN_LIST_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_list_edit', 'fFaq_Design_List_Edit', 'design_read', PL_FAQ_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_list_edit_submit', 'fFaq_Design_List_Edit_Submit', 'design_edit', PL_FAQ_H_DESIGN_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_list_delete', 'fFaq_Design_List_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('design_full', 'fFaq_Design_Full', 'design_read', PL_FAQ_H_DESIGN_FULL_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_full_edit', 'fFaq_Design_Full_Edit', 'design_read', PL_FAQ_H_DESIGN_FULL_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_full_edit_submit', 'fFaq_Design_Full_Edit_Submit', 'design_edit', PL_FAQ_H_DESIGN_FULL_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_full_delete', 'fFaq_Design_Full_Delete', 'desing_edit');

    $_SESSION['sbPlugins']->addUserEvent('design_categs', 'fFaq_Design_Categs', 'design_read', PL_FAQ_H_DESIGN_CATEGS_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_categs_edit', 'fFag_Design_Categs_Edit', 'design_read', PL_FAQ_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_categs_edit_submit', 'fFaq_Design_Categs_Edit_Submit', 'design_edit', PL_FAQ_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_categs_delete', 'fFaq_Design_Categs_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('design_form', 'fFaq_Design_Form', 'design_read', PL_FAQ_H_DESIGN_FORM_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_form_edit', 'fFaq_Design_Form_Edit', 'design_read', PL_FAQ_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_form_edit_submit', 'fFaq_Design_Form_Edit_Submit', 'design_edit', PL_FAQ_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_form_delete', 'fFaq_Design_Form_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('design_selcat', 'fFaq_Design_Selcat', 'design_read', PL_FAQ_H_DESIGN_SEL_CAT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_selcat_edit', 'fFag_Design_Selcat_Edit', 'design_read', PL_FAQ_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_selcat_edit_submit', 'fFaq_Design_Selcat_Edit_Submit', 'design_edit', PL_FAQ_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_selcat_delete', 'fFaq_Design_Selcat_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('design_filter_form', 'fFaq_Design_Filter_Form', 'design_read', PL_FAQ_H_DESIGN_FILTER_FORM_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_filter_form_edit', 'fFag_Design_Filter_Form_Edit', 'design_read', PL_FAQ_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_filter_form_submit', 'fFaq_Design_Filter_Form_Submit', 'design_edit', PL_FAQ_H_DESIGN_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_filter_form_delete', 'fFaq_Design_Filter_Form_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addToConstructor('sb_faq');
	$_SESSION['sbPlugins']->addToCache();
	$_SESSION['sbPlugins']->addToComments('sb_faq', 'f_id', 'f_question', 'f_url');
	$_SESSION['sbPlugins']->addToWorkflow();
	$_SESSION['sbPlugins']->addSystemEvent('info', 'fFaq_Info');
	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_faq_delim', PL_FAQ_H_PLUGIN_NAME, '', '');
	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_faq_count_question', PL_FAQ_H_COUNT_QUESTION, 'number', '', '3');

	$fields = array();
	$fields['f_id'] = array('title' => PL_FAQ_H_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['f_author'] = array('title' => PL_FAQ_H_AUTHOR_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_F_AUTHOR}');
	$fields['f_email'] = array('title' => PL_FAQ_H_EMAIL_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_F_EMAIL}');
	$fields['f_phone'] = array('title' => PL_FAQ_H_PHONE_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
	$fields['f_date'] = array('title' => PL_FAQ_H_DATE_LABEL, 'flags' => '9', 'link_title' => '1', 'tag' => '{OPT_STD_F_DATE}');
	$fields['f_question'] = array('title' => PL_FAQ_H_QUESTION_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
	$fields['f_answer'] = array('title' => PL_FAQ_H_ANSWER_LABEL, 'flags' => '5', 'link_title' => '0', 'tag' => '');
	$fields['f_sort'] = array('title' => PL_FAQ_H_SORT_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['f_notify'] = array('title' => PL_FAQ_H_NOTIFY_LABEL, 'flags' => '10', 'link_title' => '0', 'tag' => '');
	$fields['f_show'] = array('title' => PL_FAQ_H_SHOW_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['f_user_id'] = array('title' => PL_FAQ_H_USERID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['f_url'] = array('title' => PL_FAQ_H_URL_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_F_URL}');
	$fields['f_pub_start'] = array('title' => PL_FAQ_H_PUB_START_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
	$fields['f_pub_end'] = array('title' => PL_FAQ_H_PUB_END_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
	$fields['f_ext_id'] = array('title' => PL_FAQ_H_EXT_ID, 'flags' => '0', 'link_title' => '0', 'tag' => '');

	$cat_fields = array();
	$cat_fields['answer_temp_id'] = array('title' => PL_FAQ_H_CAT_TEMP_ID_LABEL, 'flags' => '8');
	$cat_fields['moderates_list'] = array('title' => PL_FAQ_H_CAT_MODLIST_ID_LABEL, 'flags' => '20');
	$cat_fields['categs_moderate_email'] = array('title' => PL_FAQ_H_CAT_MODEMAIL_ID_LABEL, 'flags' => '4');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_faq', 'f_id', 'f_author', $fields, $cat_fields);
}

$_SESSION['sbPlugins']->addSystemEvent('elem_list', 'fFaq_Get_Elem_List', PL_FAQ_H_ELEM_LIST);
$_SESSION['sbPlugins']->addSystemEvent('elem_full', 'fFaq_Get_Elem_Full', PL_FAQ_H_FULL_ELEM);
$_SESSION['sbPlugins']->addSystemEvent('elem_form', 'fFaq_Get_Elem_Form', PL_FAQ_H_ELEM_FORM);
$_SESSION['sbPlugins']->addSystemEvent('elem_categs', 'fFaq_Get_Elem_Categs', PL_FAQ_H_ELEM_CATEGS);
$_SESSION['sbPlugins']->addSystemEvent('elem_selcat', 'fFaq_Get_Elem_Sel_Cat', PL_FAQ_H_ELEM_SEL_CAT);
$_SESSION['sbPlugins']->addSystemEvent('elem_cloud', 'fFaq_Get_Elem_Cloud', PL_FAQ_H_ELEM_CLOUD);
$_SESSION['sbPlugins']->addSystemEvent('elem_filter', 'fFaq_Get_Elem_Filter', PL_FAQ_H_ELEM_FILTER_FORM);
$_SESSION['sbPlugins']->addSystemEvent('elem_list_components', 'fFaq_Get_Elem_Components');

$_SESSION['sbPlugins']->addToRubrikator('pl_faq', PL_FAQ_H_PLUGIN_NAME, 'faq', 'pl_faq_design_categs', 'pl_faq_design_selcat');
$_SESSION['sbPlugins']->addToCalendar('list', 'fFaq_Get_Calendar', 'pl_faq/prog/pl_faq.php', array('f_date' => PL_FAQ_H_CALENDAR_DATE));
    
$_SESSION['sbPlugins']->addElem(PL_FAQ_H_ELEM_LIST, 'list', 'fFaq_Elem_List_Prog', 'fFaq_Elem_List_Info', 'elem_list', 800, 740, 'design_list_edit', 'pl_faq_list');
$_SESSION['sbPlugins']->addElem(PL_FAQ_H_FULL_ELEM, 'full', 'fFaq_Elem_Full_Prog', 'fFaq_Elem_Full_Info', 'elem_full', 750, 590, 'design_full_edit', 'pl_faq_full');
$_SESSION['sbPlugins']->addElem(PL_FAQ_H_ELEM_CATEGS, 'categs', 'fFaq_Elem_Categs_List_Prog', 'fFaq_Elem_Categs_List_Info', 'elem_categs', 800, 700, 'design_categs_edit', 'pl_faq_design_categs');
$_SESSION['sbPlugins']->addElem(PL_FAQ_H_ELEM_SEL_CAT, 'selcat', 'fFaq_Elem_Sel_Cat_Prog', 'fFaq_Elem_Sel_Cat_Info', 'elem_selcat', 800, 350, 'design_selcat_edit', 'pl_faq_design_sel_cat');
$_SESSION['sbPlugins']->addElem(PL_FAQ_H_ELEM_FORM, 'form', 'fFaq_Elem_Form_Prog', 'fFaq_Elem_Form_Info', 'elem_form', 800, 700, 'design_form_edit', 'pl_faq_form');
$_SESSION['sbPlugins']->addElem(PL_FAQ_H_ELEM_CLOUD, 'cloud', 'fFaq_Elem_Cloud_Prog', 'fFaq_Elem_Cloud_Info', 'elem_cloud', 800, 700);
$_SESSION['sbPlugins']->addElem(PL_FAQ_H_ELEM_FILTER_FORM, 'filter', 'fFaq_Elem_Filter_Prog', 'fFaq_Elem_Filter_Info', 'elem_filter', 800, 300, 'design_filter_form_edit', 'pl_faq_filter');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
?>