<?php
function fFilelist_Init()
{
    require_once(SB_CMS_LIB_PATH.'/sbFilesList.inc.php');

    $files = new sbFilesList();

// установка фильтра
    $filter = false;
    if(isset($_GET['clear_filter']) && $_GET['clear_filter'] == 1)
    {
    	// Если нужно сбросить фильтр
    	if(isset($_SESSION['sb_files_filter_name']))
    		unset($_SESSION['sb_files_filter_name']);
    	if(isset($_SESSION['sb_files_filter_datefrom']))
    		unset($_SESSION['sb_files_filter_datefrom']);
    	if(isset($_SESSION['sb_files_filter_dateto']))
    		unset($_SESSION['sb_files_filter_dateto']);
    }
    else
    {
    	// Имя файла
    	if (isset($_GET['c_file_name']) && $_GET['c_file_name'] != '')
    	{
    		// Если имя пришло из формы
    		$_SESSION['sb_files_filter_name'] = preg_replace('/[^a-zA-Z0-9_|*]+/', '', $_GET['c_file_name']);
    		$filter = true;
    	}
    	elseif(isset($_GET['c_file_name']) && $_GET['c_file_name'] == '' && isset($_SESSION['sb_files_filter_name']))
    	{
    		// Если в из формы пришло пустое значение - не приминяем фильтр по имени
    		unset($_SESSION['sb_files_filter_name']);
    	}
    	elseif(isset($_SESSION['sb_files_filter_name']) && $_SESSION['sb_files_filter_name'] != '')
    	{
    		// Если форма не пришла, оставляем сессию как есть
    		$_GET['c_file_name'] = $_SESSION['sb_files_filter_name'];
    		$filter = true;
    	}

    	// Дата последнего изменения - от
		if (isset($_GET['c_date_from']) && $_GET['c_date_from'] != '')
    	{
    		// Если дата пришла из формы
    		$filter_ldate_from = explode('.', preg_replace('/[^a-zA-Z0-9_|.:]+/', '', $_GET['c_date_from']));
			$_SESSION['sb_files_filter_datefrom'] = mktime(0, 0, 0, $filter_ldate_from[1], $filter_ldate_from[0], $filter_ldate_from[2]);
    		$filter = true;
    	}
    	elseif(isset($_SESSION['sb_files_filter_datefrom']) && isset($_GET['c_date_from']) && $_GET['c_date_from'] == '')
    	{
    		// Если дата пришла пустой - не приминяем фильтр
    		unset($_SESSION['sb_files_filter_datefrom']);
    	}
    	elseif(isset($_SESSION['sb_files_filter_datefrom']) && $_SESSION['sb_files_filter_datefrom'] != '')
    	{
    		// Если дата не пришла - оставляем как есть
    		$_GET['c_date_from'] = date('d.m.Y',$_SESSION['sb_files_filter_datefrom']);
    		$filter = true;
    	}

    	// Дата последнего изменения - до
		if (isset($_GET['c_date_to'])&& $_GET['c_date_to'] != '')
    	{
    		//Если дата пришла из формы
    		$filter_ldate_to = explode('.', preg_replace('/[^a-zA-Z0-9_|.:]+/', '', $_GET['c_date_to']));
			$_SESSION['sb_files_filter_dateto'] = mktime(23, 59, 59, $filter_ldate_to[1], $filter_ldate_to[0], $filter_ldate_to[2]);
    		$filter = true;
    	}
    	elseif(isset($_SESSION['sb_files_filter_dateto']) && isset($_GET['c_date_to']) && $_GET['c_date_to'] == '')
    	{
    		// Если дата пришла пустой - не приминяем фильтр
    		unset($_SESSION['sb_files_filter_dateto']);
    	}
    	elseif(isset($_SESSION['sb_files_filter_dateto']) && $_SESSION['sb_files_filter_dateto'] != '')
    	{
    		// Если не пришла - оставляем как есть
    		$_GET['c_date_to'] = date('d.m.Y',$_SESSION['sb_files_filter_dateto']);
    		$filter = true;
    	}
    }
    // Сохраняю старые гет параметры
    $olds_params = '';
    foreach($_GET as $key => $value)
    {
    	if($key == 'event' || $key == 'clear_filter' || $key == 'c_date_to' || $key == 'c_date_from' || $key == 'c_file_name')
    		continue;
    	$olds_params .= '&'.$key.'='.$value;
    }


    if ($_SESSION['sbPlugins']->isRightAvailable('pl_filelist', 'files_edit'))
    {
        $files->mFilesJavaScriptStr .= '
            function sbFilesEdit()
            {
                if (!sbCurFile)
                    return;

                sbCurFile.style.borderColor = "green";

                var el_id = sbCurFile.getAttribute("el_id");

                strPage = sb_cms_modal_dialog_file+"?event=pl_filelist_edit_file&file="+encodeURI(el_id);
                strAttr = "resizable=1,width=800,height=600";
                sbShowModalDialog(strPage, strAttr, sbFilesAfterAddEdit);
            }
            function sbFilesNew()
            {
                var path = sbFoldersTree.getSelectedItemId();

                strPage = sb_cms_modal_dialog_file+"?event=pl_filelist_edit_file&path="+encodeURI(path);
                strAttr = "resizable=1,width=800,height=600";
                sbShowModalDialog(strPage, strAttr, sbFilesAfterAddEdit);
            }
            function sbFilesAfterAddEdit()
            {
                if (!sbModalDialog.returnValue)
                {
                    if (sbCurFile.style) sbCurFile.style.borderColor = "red";
                    return;
                }

                var div_el = sbGetE("files_list_div");
                var from = "0";
                if (div_el)
                {
                    from = div_el.getAttribute("from");
                }

                setTimeout("sbFilesShow(\""+ sb_cms_empty_file + "?event=pl_filelist_read&path="+encodeURI(sbFoldersTree.getSelectedItemId())+"&files_from="+from+"\")", 0);
            }

            function showFilter()
		    {
		        var filter = sbGetE("sb_filter");
		        var filter_arr = sbGetE("filter_arrow");
		        var files_list = sbGetE("files_list");
		        var files_list = sbGetE("files_list");
		        if (!filter) return;
		        if (filter.style.display == "none")
		        {
		            filter.style.display = "";
		            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
		        }
		        else
		        {
		            filter.style.display = "none";
		            filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
		        }
		        sbResizeFldiv();
		    }

		    function setFilter()
		    {
		        var str = "'.SB_CMS_CONTENT_FILE.'?event=pl_filelist_init'.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
		        var found = false;
		        var frm = sbGetE("filter_form");

		        for (var i = 0; i < frm.elements.length; i++)
		        {
		            var el = frm.elements[i];
	                if (el.name != "")
	                {
	                    str += "&"+el.name+"="+el.value;
	                    found = true;
	                }
		        }
		        if (!found)
		        {
		            return false;
		        }
		        window.location = str;
		        return false;
		    }

		    function removeFilter(e)
		    {
		        window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_filelist_init&clear_filter=1";
		        return sbCancelEvent(e);
		    }

        ';

        $files->addFileMenuItem(PL_FILELIST_EDIT_MENU_ITEM, 'sbFilesEdit();');
	    $files->addFileMenuItem(PL_FILELIST_CREATE_MENU_ITEM, 'sbFilesNew();', false);
    }

 	if ($_SESSION['sbPlugins']->isRightAvailable('pl_filelist', 'files_folders_access'))
	{
	    $files->mFilesJavaScriptStr .= '
	        function sbFilesAccess()
            {
                if (!sbCurFile)
                    return;

                sbCurFile.style.borderColor = "green";

                var el_id = sbCurFile.getAttribute("el_id");

                strPage = sb_cms_modal_dialog_file+"?event=pl_filelist_edit_file_access&file="+encodeURI(el_id);
                strAttr = "resizable=1,width=450,height=300";
                sbShowModalDialog(strPage, strAttr, sbFilesAfterAccess);
            }
            function sbFilesAfterAccess()
            {
                sbCurFile.style.borderColor = "red";
            }
            function sbFoldersAccess()
            {
                strPage = sb_cms_modal_dialog_file+"?event=pl_filelist_edit_file_access&file="+encodeURI(sbSelFolder.id);
                strAttr = "resizable=1,width=450,height=300";
                sbShowModalDialog(strPage, strAttr, sbFoldersAfterAccess);
            }
            function sbFoldersAfterAccess()
            {
                sbSelFolder = 0;
            }';

	    $files->addFileMenuItem(PL_FILELIST_RIGHTS_MENU_ITEM, 'sbFilesAccess();');
	    $files->addFolderMenuItem(PL_FILELIST_FOLDER_RIGHTS_MENU_ITEM, 'sbFoldersAccess();');
	}

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_filelist', 'folders_upload') && sb_supportHTML5())
	{
	    // собираем мусор (удаленные по FTP папки) из таблицы прав на папки
	    $res = sql_query('SELECT f_path FROM sb_folders_rights WHERE f_domain=?', SB_COOKIE_DOMAIN);
	    if ($res)
	    {
	        foreach ($res as $value)
	        {
	            list($f_path) = $value;
	            if (!$GLOBALS['sbVfs']->exists($f_path))
	            {
	                sql_query('DELETE FROM sb_folders_rights WHERE f_path=? AND f_domain=?', $f_path, SB_COOKIE_DOMAIN);
	            }
 	        }
	    }

    	sb_show_message(PL_FILELIST_HTML5_UPLOAD);

        $empty_file = SB_CMS_EMPTY_FILE;
        $progress_msg = PL_FILELIST_AJAX_UPLOAD_PROGRESS;

        $files->mFilesJavaScriptStr .= '

            // HTML5 upload files
            window.ondragover = function(e) {
                e.preventDefault();
            }
            window.ondrop = function(e) {
                e.preventDefault();
                upload(e.dataTransfer.files);
            }

            function upload(obj) {
                sbAJAXInit(false);

                sbXMLHTTP.upload.addEventListener("progress", function(e) {
                    if (e.lengthComputable)
                    {
                        var progress = (e.loaded * 100) / e.total;
                        sbGetE("progressBar").style.width = progress+\'%\';
                    }
                }, false);

                sbXMLHTTP.onload = function() {
                    sbHideDisDiv();
                    sbHideMsgDiv();
                    if(sbXMLHTTP.responseText != "OK")
                    {
                        sbShowMsgDiv(sbXMLHTTP.responseText);
                        setTimeout(sbRefreshFiles, 5000);
                    }
                    else
                    {
                        sbRefreshFiles();
                    }
                }

                var fData = new FormData();
                for(i=0; i<obj.length; i++)
                {
                    if(typeof FormData == \'function\' || typeof FormData == \'object\')
                    {
                        fData.append(\'upfile_\'+i, obj[i]);
                    }
                }
                sbShowDisDiv();

                var progress_msg = \''.$progress_msg.'<div class="progressWrapper" style="opacity: 1;">\';
                    progress_msg += \'<div id="progressContainer" class="progressContainer">\';
                    progress_msg += \'<div id="progressBarStatus" class="progressBarStatus"></div>\';
                    progress_msg += \'<div id="progressBar" style="" class="progressBarInProgress"></div>\';
                    progress_msg += \'</div></div>\';
                sbShowMsgDiv(progress_msg, \'information.png\', false);
                sbXMLHTTP.open("POST", "'.$empty_file.'?event=pl_filelist_ajax_upload&path="+encodeURI(sbFoldersTree.getSelectedItemId()));
                sbXMLHTTP.send(fData);
                return;
            }';
	}

	// Вывод формы фильтра
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$files -> mFilesHeaderStr = '
    <div id="ajax_messages" style="display: none"></div>
    <table cellpadding="0" cellspacing="0" width="100%" align="center">
    	<tr id="filter_header">
        	<td width="100%" class="sb_filter_header">
        		<table cellpadding="0" cellspacing="0">
        			<tr>
            			<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.($filter == true ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" /></span></td>
            			<td class="sb_filter_on" id="sb_filter_on" style="'.($filter == true ? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
            		</tr>
            	</table>
        	</td>
    	</tr>
    	<tr>
    		<td valign="top">
            	<form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            		<div id="sb_filter" '.($filter == true ? '' : ' style="display:none;"').'>
            			<table cellpadding="0" cellspacing="0" class="sb_filter_table">
							<tr>
								<th class="sb_filter_th">'.PL_FILELIST_FILTER_NAME.':</th>
            					<td class="sb_filter_td">';
									$fld = new sbLayoutInput('text', isset($_GET['c_file_name']) ? $_GET['c_file_name'] : '', 'c_file_name', '', 'style="width: 100%;"');
    								$files -> mFilesHeaderStr .= $fld->getField().'
								</td>
								<th class="sb_filter_th">'.PL_FILELIST_FILTER_LASTCHANGE.':</th>
								<td class="sb_filter_td_noborder"><nobr>';
									$fld_lo = new sbLayoutDate((isset($_GET['c_date_from']) ? $_GET['c_date_from'] : ''), 'c_date_from');
									$fld_lo->mDropButton = true;
									$fld_lo->mShowTime = false;
									$fld_hi = new sbLayoutDate((isset($_GET['c_date_to']) ? $_GET['c_date_to'] : ''), 'c_date_to');
									$fld_hi->mDropButton = true;
									$fld_hi->mShowTime = false;
									$files -> mFilesHeaderStr .= $fld_lo->getJavaScript().'
			    					<table cellpadding="0" cellspacing="0">
			    						<tr>
			    							<td>'.KERNEL_FROM.'&nbsp;&nbsp;</td>
			    							<td>'.$fld_lo->getField().'</td>
			    							<td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td>
			    							<td>'.$fld_hi->getField().'</td>
			    						</tr>
			    					</table>
			    					</nobr>
			    				</td>
							</tr>
						</table>
						<div class="sb_filter_footer">
							<input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;
						</div>
					</div>
				</form>
			</table>
		</td>
	</tr>
</table>';

	$files->init();
}

/**
 * Событие, подгружаемое через AJAX и отвечающее за вывод списка файлов.
 *
 */
function fFilelist_Read()
{
    require_once(SB_CMS_LIB_PATH.'/sbFilesList.inc.php');

    $files = new sbFilesList();

    $files->init();
}

/**
 * Вывод диалогового окна вставки файла
 *
 */
function fFilelist_Get_Files()
{
    require_once(SB_CMS_LIB_PATH.'/sbFilesList.inc.php');

    $files = new sbFilesList();
    $files->mFilesLinkTitle = false;

    if (isset($_GET['types']) && $_GET['types'] != '')
    {
        $files->mFilesExtensions = explode(' ', $_GET['types']);
    }

// установка фильтра
    $filter = false;
    if(isset($_GET['clear_filter']) && $_GET['clear_filter'] == 1)
    {
    	// Если нужно сбросить фильтр
    	if(isset($_SESSION['sb_files_filter_name']))
    		unset($_SESSION['sb_files_filter_name']);
    	if(isset($_SESSION['sb_files_filter_datefrom']))
    		unset($_SESSION['sb_files_filter_datefrom']);
    	if(isset($_SESSION['sb_files_filter_dateto']))
    		unset($_SESSION['sb_files_filter_dateto']);
    }
    else
    {
    	// Имя файла
    	if (isset($_GET['c_file_name']) && $_GET['c_file_name'] != '')
    	{
    		// Если имя пришло из формы
    		$_SESSION['sb_files_filter_name'] = preg_replace('/[^a-zA-Z0-9_|*]+/', '', $_GET['c_file_name']);
    		$filter = true;
    	}
    	elseif(isset($_GET['c_file_name']) && $_GET['c_file_name'] == '' && isset($_SESSION['sb_files_filter_name']))
    	{
    		// Если в из формы пришло пустое значение - не приминяем фильтр по имени
    		unset($_SESSION['sb_files_filter_name']);
    	}
    	elseif(isset($_SESSION['sb_files_filter_name']) && $_SESSION['sb_files_filter_name'] != '')
    	{
    		// Если форма не пришла, оставляем сессию как есть
    		$_GET['c_file_name'] = $_SESSION['sb_files_filter_name'];
    		$filter = true;
    	}
    	// Дата последнего изменения - от
		if (isset($_GET['c_date_from']) && $_GET['c_date_from'] != '')
    	{
    		// Если дата пришла из формы
    		$filter_ldate_from = explode('.', preg_replace('/[^a-zA-Z0-9_|.:]+/', '', $_GET['c_date_from']));
			$_SESSION['sb_files_filter_datefrom'] = mktime(0, 0, 0, $filter_ldate_from[1], $filter_ldate_from[0], $filter_ldate_from[2]);
    		$filter = true;
    	}
    	elseif(isset($_SESSION['sb_files_filter_datefrom']) && isset($_GET['c_date_from']) && $_GET['c_date_from'] == '')
    	{
    		// Если дата пришла пустой - не приминяем фильтр
    		unset($_SESSION['sb_files_filter_datefrom']);
    	}
    	elseif(isset($_SESSION['sb_files_filter_datefrom']) && $_SESSION['sb_files_filter_datefrom'] != '')
    	{
    		// Если дата не пришла - оставляем как есть
    		$_GET['c_date_from'] = date('d.m.Y',$_SESSION['sb_files_filter_datefrom']);
    		$filter = true;
    	}

    	// Дата последнего изменения - до
		if (isset($_GET['c_date_to'])&& $_GET['c_date_to'] != '')
    	{
    		//Если дата пришла из формы
    		$filter_ldate_to = explode('.', preg_replace('/[^a-zA-Z0-9_|.:]+/', '', $_GET['c_date_to']));
			$_SESSION['sb_files_filter_dateto'] = mktime(23, 59, 59, $filter_ldate_to[1], $filter_ldate_to[0], $filter_ldate_to[2]);
    		$filter = true;
    	}
    	elseif(isset($_SESSION['sb_files_filter_dateto']) && isset($_GET['c_date_to']) && $_GET['c_date_to'] == '')
    	{
    		// Если дата пришла пустой - не приминяем фильтр
    		unset($_SESSION['sb_files_filter_dateto']);
    	}
    	elseif(isset($_SESSION['sb_files_filter_dateto']) && $_SESSION['sb_files_filter_dateto'] != '')
    	{
    		// Если не пришла - оставляем как есть
    		$_GET['c_date_to'] = date('d.m.Y',$_SESSION['sb_files_filter_dateto']);
    		$filter = true;
    	}
    }

    // Сохраняю старые гет параметры
    $olds_params = '';
    foreach($_GET as $key => $value)
    {
    	if($key == 'event' || $key == 'clear_filter' || $key == 'c_date_to' || $key == 'c_date_from' || $key == 'c_file_name')
    		continue;
    	$olds_params .= '&'.$key.'='.$value;
    }

    $files->mFilesSelectedFile = isset($_GET['path']) ? str_ireplace(array(SB_DOMAIN, 'http://'.SB_COOKIE_DOMAIN), array('', ''), $_GET['path']) : '';

    $files->mFilesFooterStr = '<table no="no" cellspacing="0" cellpadding="7" width="100%" class="form">
        <tr>
            <th width="300">
                '.PL_FILELIST_FILE.':
            </th>
            <td>
                <input type="text" id="path" value="'.$files->mFilesSelectedFile.'" style="width: 400px;" onfocus="select()">
            </td>
        </tr>
        <tr>
            <td class="footer" colspan="2">
                <div class="footer">
                <button onclick="chooseFile();">'.KERNEL_CHOOSE.'</button>&nbsp;&nbsp;
                <button onclick="sbCloseDialog();">'.KERNEL_CANCEL.'</button>
                </div>
            </td>
        </tr>
        </table>';

    $files->mFilesJavaScriptStr .= '
        function selFile(el)
        {
            var el_path = sbGetE("path");
            if (el_path)
            {
                el_path.value = "'.str_ireplace('https://', 'http://', SB_DOMAIN).'" + el.getAttribute("el_id");
            }
        }
        function chooseFile()
        {
            var el = sbGetE("path");
            if (!el || el.value == "")
            {
                alert("'.PL_FILELIST_NO_FILE_MSG.'");
                return;
            }

            var res = new Object();
            res.path = el.value;

            sbReturnValue(res);
        }

        function showFilter()
		    {
		        var filter = sbGetE("sb_filter");
		        var filter_arr = sbGetE("filter_arrow");
		        if (!filter) return;
		        if (filter.style.display == "none")
		        {
		            filter.style.display = "";
		            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
		        }
		        else
		        {
		            filter.style.display = "none";
		            filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
		        }
		        sbResizeFldiv();
		    }

		    function setFilter()
		    {
		        var str = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_filelist_get_files'.$olds_params.'";
		        var found = false;
		        var frm = sbGetE("filter_form");

		        for (var i = 0; i < frm.elements.length; i++)
		        {
		            var el = frm.elements[i];
	                if (el.name != "")
	                {
	                    str += "&"+el.name+"="+el.value;
	                    found = true;
	                }
		        }
		        if (!found)
		        {
		            return false;
		        }
		        window.location = str;
		        return false;
		    }

		    function removeFilter(e)
		    {
		        window.location = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_filelist_get_files'.$olds_params.'&clear_filter=1";
		        return sbCancelEvent(e);
		    }
    ';

    $files->mFilesClickFunc = 'selFile';
    // Форма фильтра
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	$files -> mFilesHeaderStr .= '
    <table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
        	<table cellpadding="0" cellspacing="0">
        	<tr>
            	<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.($filter == true ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" /></span></td>
            	<td class="sb_filter_on" id="sb_filter_on" style="'.($filter == true ? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
            </tr></table>
        </td>
    </tr>
    <tr>
    	<td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter" '.($filter == true ? '' : ' style="display:none;"').'>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
			<tr>


				<th class="sb_filter_th">'.PL_FILELIST_FILTER_NAME.':</th>
            	<td class="sb_filter_td">';
	$fld = new sbLayoutInput('text', isset($_GET['c_file_name']) ? $_GET['c_file_name'] : '', 'c_file_name', '', 'style="width: 100%;"');
    $files -> mFilesHeaderStr .= $fld->getField().'
				</td>




				<th class="sb_filter_th">'.PL_FILELIST_FILTER_LASTCHANGE.':</th>
				<td class="sb_filter_td_noborder"><nobr>';
	$fld_lo = new sbLayoutDate((isset($_GET['c_date_from']) ? $_GET['c_date_from'] : ''), 'c_date_from');
	$fld_lo->mDropButton = true;
	$fld_lo->mShowTime = false;

	$fld_hi = new sbLayoutDate((isset($_GET['c_date_to']) ? $_GET['c_date_to'] : ''), 'c_date_to');
	$fld_hi->mDropButton = true;
	$fld_hi->mShowTime = false;

	$files -> mFilesHeaderStr .= $fld_lo->getJavaScript().'
            <div id="ajax_messages" style="display: none"></div>
			    <table cellpadding="0" cellspacing="0"><tr><td>'.KERNEL_FROM.'&nbsp;&nbsp;</td><td>'.$fld_lo->getField().'</td><td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td><td>'.$fld_hi->getField().'</td></tr></table>
			    </nobr></td>
			</tr>
			</table>
					<div class="sb_filter_footer">
						<input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;
					</div>
				</div>
			</form>
			</table>
		</td>
	</tr></table>
	<center>';

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_filelist', 'folders_upload') && sb_supportHTML5())
	{
    	sb_show_message(PL_FILELIST_HTML5_UPLOAD);

        $empty_file = SB_CMS_EMPTY_FILE;
        $progress_msg = PL_FILELIST_AJAX_UPLOAD_PROGRESS;

        $files->mFilesJavaScriptStr .= '
            // HTML5 upload files
            window.ondragover = function(e) {
                e.preventDefault();
            }
            window.ondrop = function(e) {
                e.preventDefault();
                upload(e.dataTransfer.files);
            }

            function upload(obj) {
                sbAJAXInit(false);

                sbXMLHTTP.upload.addEventListener("progress", function(e) {
                    if (e.lengthComputable)
                    {
                        var progress = (e.loaded * 100) / e.total;
                        sbGetE("progressBar").style.width = progress+\'%\';
                    }
                }, false);

                sbXMLHTTP.onload = function() {
                    sbHideDisDiv();
                    sbHideMsgDiv();
                    if(sbXMLHTTP.responseText != "OK")
                    {
                        sbShowMsgDiv(sbXMLHTTP.responseText);
                        setTimeout(sbRefreshFiles, 5000);
                    }
                    else
                    {
                        sbRefreshFiles();
                    }
                }

                var fData = new FormData();
                for(i=0; i<obj.length; i++)
                {
                    if(typeof FormData == \'function\' || typeof FormData == \'object\')
                    {
                        fData.append(\'upfile_\'+i, obj[i]);
                    }
                }
                sbShowDisDiv();

                var progress_msg = \''.$progress_msg.'<div class="progressWrapper" style="opacity: 1;">\';
                    progress_msg += \'<div id="progressContainer" class="progressContainer">\';
                    progress_msg += \'<div id="progressBarStatus" class="progressBarStatus"></div>\';
                    progress_msg += \'<div id="progressBar" style="" class="progressBarInProgress"></div>\';
                    progress_msg += \'</div></div>\';
                sbShowMsgDiv(progress_msg, \'information.png\', false);
                sbXMLHTTP.open("POST", "'.$empty_file.'?event=pl_filelist_ajax_upload&path="+encodeURI(sbFoldersTree.getSelectedItemId()));
                sbXMLHTTP.send(fData);
                return;
            }';
	}

    $files->init();
}


function fFilelist_Edit_File()
{
    $filestring='';

    if(isset($_GET['file']))
    {
        // редактирование файла
        $file = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['file']));
    	// запрещаем выход на более высокий уровень (..)
        $file = preg_replace('/\.\.+/i', '', $file);
        $file = preg_replace('/\/\/+/i', '', $file);

        $check_path = dirname($file);
        if (!fFolders_Check_Rights($check_path))
        {
            sb_show_message(SB_FILELIST_DENY_ERROR_MSG, true, 'warning');
            return;
        }

        if (!$GLOBALS['sbVfs']->is_writable($file))
        {
             sb_show_message(PL_FILELIST_FILE_NOT_EDITING, true, 'warning');
             return;
        }

        if(isset($_POST['file_content']))
        {
            $filestring = $_POST['file_content'];
        }
        else
        {
            $GLOBALS['sbVfs']->fopen($file, 'r');
            while (!$GLOBALS['sbVfs']->feof())
            {
                $filestring .= $GLOBALS['sbVfs']->fgets();
            }
            $GLOBALS['sbVfs']->fclose();
        }

        $action = '&file='.urlencode($file);
    }
    elseif (isset($_GET['path']))
    {
        // создание файла
        $path = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['path']));
    	// запрещаем выход на более высокий уровень (..)
        $path = preg_replace('/\.\.+/i', '', $path);
        $path = preg_replace('/\/\/+/i', '', $path);

        if (!fFolders_Check_Rights($path))
        {
            sb_show_message(SB_FILELIST_DENY_ERROR_MSG, true, 'warning');
            return;
        }

        if (!$GLOBALS['sbVfs']->is_writable($path))
        {
             sb_show_message(PL_FILELIST_FOLDER_NOT_EDITING, true, 'warning');
             return;
        }

        $action = '&path='.urlencode($path);
    }
    else
    {
        return;
    }

    echo '<br /><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_filelist_edit_file_submit'.$action, 'thisDialog', 'post', '');
    $layout->mShowTitle = false;

    $layout->addField('', new sbLayoutTextarea($filestring, 'file_content', 'file_content', 'style="width:100%;height:400px;"'));
    $layout->addButton('submit', KERNEL_SAVE, 'save_file');

    if (isset($_GET['file']))
    {
        $layout->addButton('submit', KERNEL_SAVE_AS, 'save_file_as');
        $layout->addButton('submit', KERNEL_APPLY, 'apply');
    }

    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');
    $layout->show();

    echo '<script>
        function resizeTextarea()
        {
            var el = sbGetE("file_content");
            if (el)
                el.style.height = Math.max(0, document.body.clientHeight - 200);
        }
        sbAddEvent(window, "resize", resizeTextarea);
        sbAddEvent(window, "load", resizeTextarea);
    </script>';
}

function fFilelist_Edit_File_Submit()
{
	if ((isset($_POST['save_file']) || isset($_POST['apply'])) && isset($_GET['file']))
    {
        // сохранить файл
        $file = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['file']));
    	// запрещаем выход на более высокий уровень (..)
        $file = preg_replace('/\.\.+/i', '', $file);
        $file = preg_replace('/\/\/+/i', '', $file);

        $check_path = dirname($file);
        if (!fFolders_Check_Rights($check_path))
        {
            sb_show_message(SB_FILELIST_DENY_ERROR_MSG, false, 'warning');
            fFilelist_Edit_File();
            return;
        }

        //проверка существования одноименной директории
        $pathinfo = pathinfo($file);

        if ($pathinfo['filename'] != '')
        {
            $test_dir_name = $pathinfo['dirname'].'/'.$pathinfo['filename'];
            $test_dir_name = sb_str_replace('//', '/', $test_dir_name);

            if ($GLOBALS['sbVfs']->is_dir($test_dir_name))
            {
                sb_show_message(PL_FILELIST_EDIT_DIR_EXISTS, false, 'warning');
                fFilelist_Edit_File();
                return;
            }
        }

        // сохранение файла
        if(isset($_POST['file_content']))
        {
            if ($GLOBALS['sbVfs']->file_put_contents($file, $_POST['file_content']) !== false)
            {
                // записываем действие в системный журнал
                sb_add_system_message(sprintf(PL_FILELIST_EDIT_OK, $file));
                if (isset($_POST['save_file']))
                {
                    echo '<script>
                        sbReturnValue(false);
                    </script>';
                }
                else
                {
                    sb_show_message(sprintf(PL_FILELIST_EDIT_OK, $file));
                    fFilelist_Edit_File();
                }
            }
            else
            {
                // не удалось переименовать
                sb_show_message(sprintf(PL_FILELIST_EDIT_ERROR, $file), false, 'warning');
                // записываем действие в системный журнал
                sb_add_system_message(sprintf(PL_FILELIST_EDIT_ERROR, $file), SB_MSG_WARNING);
                fFilelist_Edit_File();
            }
        }

        return;
    }

    if (isset($_POST['save_file']) || isset($_POST['save_file_as']))
    {
        // диалог запроса нового имени файла
        if (isset($_GET['file']))
        {
            $file = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['file']));
        	// запрещаем выход на более высокий уровень (..)
            $file = preg_replace('/\.\.+/i', '', $file);
            $file = preg_replace('/\/\/+/i', '', $file);

            $path = dirname($file);
            if (!fFolders_Check_Rights($path))
            {
                sb_show_message(SB_FILELIST_DENY_ERROR_MSG, true, 'warning');
                return;
            }

            $file = basename($file);
        }
        else
        {
            $path = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['path']));
        	// запрещаем выход на более высокий уровень (..)
            $path = preg_replace('/\.\.+/i', '', $path);
            $path = preg_replace('/\/\/+/i', '', $path);

            if (!fFolders_Check_Rights($path))
            {
                sb_show_message(SB_FILELIST_DENY_ERROR_MSG, true, 'warning');
                return;
            }

            $file = '';
        }

        echo '<script>
        var allowedFileChars = " QAZWSXEDCRFVTGBYHNMJUIKLOPqwertasdfgzxcvbyhnmjuiklop_1234567890.-[]";

        function checkValues()
        {
            var el =  sbGetE("file_name");
            if (el.value == "")
            {
                alert("'.PL_FILELIST_EDIT_ERROR_NO_NAME.'");
                return false;
            }
            for (i = 0; i < el.value.length; i++)
            {
                if (allowedFileChars.indexOf(el.value.charAt(i)) == -1)
                {
                    alert("'.PL_FILELIST_EDIT_ERROR_INCORRECT_NAME.'");
                    return false;
                }
            }
            res = sbLoadSync(sb_cms_empty_file + "?event=pl_filelist_search_file&path='.$path.'&file=" + el.value);
            if (res == "TRUE")
		    {
		        if(window.confirm("'.PL_FILELIST_EDIT_FILE_EXISTS.'") != true)
		        {
		            return false;
		        }
		    }

            return true;
        }
        </script><br /><br />';

        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

        $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_filelist_edit_file_submit&path='.urlencode($path), 'thisDialog', 'post');

        $layout->addHeader(PL_FILELIST_EDIT_SAVE_AS_TITLE);
        $layout->addField(PL_FILELIST_EDIT_SAVE_AS_TITLE, new sbLayoutInput('text', $file, 'file_name', '', 'style="width:98%;"', true));
        $layout->addField('', new sbLayoutTextarea($_POST['file_content'], 'file_content', 'file_content', ''), '', '', 'style="display:none;"');
        $layout->addButton('submit', KERNEL_SAVE);
        $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');
        $layout->show();

        return;
    }

    // создать новый файл
    $path = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['path']));
	// запрещаем выход на более высокий уровень (..)
    $path = preg_replace('/\.\.+/i', '', $path);
    $path = preg_replace('/\/\/+/i', '', $path);

    if (!fFolders_Check_Rights($path))
    {
        sb_show_message(SB_FILELIST_DENY_ERROR_MSG, true, 'warning');
        return;
    }

    $file = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_POST['file_name']));
	// запрещаем выход на более высокий уровень (..)
    $file = preg_replace('/\.\.+/i', '', $file);
    $file = preg_replace('/\/\/+/i', '', $file);

    $file = str_replace('//', '/', $path.'/'.$file);

    //проверка существования одноименной директории
    $pathinfo = pathinfo($file);

    if ($pathinfo['filename'] != '')
    {
        $test_dir_name = $pathinfo['dirname'] . '/' . $pathinfo['filename'];
        $test_dir_name = sb_str_replace('//', '/', $test_dir_name);

        if ($GLOBALS['sbVfs']->is_dir($test_dir_name))
        {
            sb_show_message(sprintf(PL_FILELIST_EDIT_DIR_EXISTS, $file), false, 'warning');
            unset($_POST['file_name']);
            $_POST['save_file'] = 1;
            fFilelist_Edit_File_Submit();
            return;
        }
    }

    if ($GLOBALS['sbVfs']->file_put_contents($file, $_POST['file_content']) !== false)
    {
        echo '<script>
            sbReturnValue("refresh");
        </script>';
        // записываем действие в системный журнал
        sb_add_system_message(sprintf(PL_FILELIST_CREATE_OK, $file));
    }
    else
    {
        // не удалось переименовать
        sb_show_message(sprintf(PL_FILELIST_CREATE_ERROR, $file), false, 'warning');
        // записываем действие в системный журнал
        sb_add_system_message(sprintf(PL_FILELIST_CREATE_ERROR, $file), SB_MSG_WARNING);
        //fFilelist_Edit_File();
        unset($_POST['file_name']);
        $_POST['save_file'] = 1;
        fFilelist_Edit_File_Submit();
    }
}

function fFilelist_Search_File()
{
    $file = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['file']));
	// запрещаем выход на более высокий уровень (..)
    $file = preg_replace('/\.\.+/i', '', $file);
    $file = preg_replace('/\/\/+/i', '', $file);

    $path = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['path']));
	// запрещаем выход на более высокий уровень (..)
    $path = preg_replace('/\.\.+/i', '', $path);
    $path = preg_replace('/\/\/+/i', '', $path);

    if ($GLOBALS['sbVfs']->exists(str_replace('//', '/', $path.'/'.$file)))
    {
        echo 'TRUE';
    }
}

function fFilelist_Edit_File_Access()
{
    $file = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['file']));
	// запрещаем выход на более высокий уровень (..)
    $file = preg_replace('/\.\.+/i', '', $file);
    $file = preg_replace('/\/\/+/i', '', $file);

    if (!$GLOBALS['sbVfs']->is_dir($file))
        $check_path = dirname($file);
    else
        $check_path = $file;

    if (!fFolders_Check_Rights($check_path))
    {
        sb_show_message(SB_FILELIST_DENY_ERROR_MSG, true, 'warning');
        return;
    }

    $perms = $GLOBALS['sbVfs']->fileperms($file);
    $info = array();
    $info['user'] = array();
    $info['group'] = array();
    $info['all'] = array();

    if ($perms)
    {
        // Пользователь
        $info['user']['r'] = (($perms & 0x0100) ? true : false);
        $info['user']['w'] = (($perms & 0x0080) ? true : false);
        $info['user']['x'] = (($perms & 0x0040) ? (($perms & 0x0800) ? false : true ) : false);

        // Группа
        $info['group']['r'] = (($perms & 0x0020) ? true : false);
        $info['group']['w'] = (($perms & 0x0010) ? true : false);
        $info['group']['x'] = (($perms & 0x0008) ? (($perms & 0x0400) ? false : true ) : false);

        // Все
        $info['all']['r'] = (($perms & 0x0004) ? true : false);
        $info['all']['w'] = (($perms & 0x0002) ? true : false);
        $info['all']['x'] = (($perms & 0x0001) ? (($perms & 0x0200) ? false : true ) : false);
    }
    else
    {
        // Пользователь
        $info['user']['r'] = false;
        $info['user']['w'] = false;
        $info['user']['x'] = false;

        // Группа
        $info['group']['r'] = false;
        $info['group']['w'] = false;
        $info['group']['x'] = false;

        // Все
        $info['all']['r'] = false;
        $info['all']['w'] = false;
        $info['all']['x'] = false;
    }
    echo '<br /><br />';

    $html = '<table cellpadding="3" cellspacing="0" border="0" align="center">
    <tr>
        <td align="center" colspan="3"><b>'.PL_FILELIST_ACCESS_USER.'</b></td><td>&nbsp;</td>
        <td align="center" colspan="3"><b>'.PL_FILELIST_ACCESS_GROUP.'</b></td><td>&nbsp;</td>
        <td align="center" colspan="3"><b>'.PL_FILELIST_ACCESS_ALL.'</b></td>
    </tr>
    <tr>
        <td align="center">R</td><td align="center">W</td><td align="center">X</td><td>&nbsp;</td>
        <td align="center">R</td><td align="center">W</td><td align="center">X</td><td>&nbsp;</td>
        <td align="center">R</td><td align="center">W</td><td align="center">X</td>
    </tr>
    <tr>
        <td align="center"><input type="checkbox" value="4" name="user_r"'.($info['user']['r'] ? ' checked' : '').' /></td>
        <td align="center"><input type="checkbox" value="2" name="user_w"'.($info['user']['w'] ? ' checked' : '').' /></td>
        <td align="center"><input type="checkbox" value="1" name="user_x"'.($info['user']['x'] ? ' checked' : '').' /></td>
        <td>&nbsp;</td>
        <td align="center"><input type="checkbox" value="4" name="group_r"'.($info['group']['r'] ? ' checked' : '').' /></td>
        <td align="center"><input type="checkbox" value="2" name="group_w"'.($info['group']['w'] ? ' checked' : '').' /></td>
        <td align="center"><input type="checkbox" value="1" name="group_x"'.($info['group']['x'] ? ' checked' : '').' /></td>
        <td>&nbsp;</td>
        <td align="center"><input type="checkbox" value="4" name="all_r"'.($info['all']['r'] ? ' checked' : '').' /></td>
        <td align="center"><input type="checkbox" value="2" name="all_w"'.($info['all']['w'] ? ' checked' : '').' /></td>
        <td align="center"><input type="checkbox" value="1" name="all_x"'.($info['all']['x'] ? ' checked' : '').' /></td></tr>
    </table><br />
    <div align="center"><b>R</b> - '.PL_FILELIST_ACCESS_R.' &nbsp; <b>W</b> - '.PL_FILELIST_ACCESS_W.' &nbsp; <b>X</b> - '.PL_FILELIST_ACCESS_X.'</div><br />';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_filelist_edit_file_access_submit&file='.urlencode($file), 'thisDialog', 'post', '');

    $layout->addHeader(PL_FILELIST_EDIT_RIGHTS_TITLE);
    $layout->addField(PL_FILELIST_EDIT_SAVE_AS_TITLE, new sbLayoutHTML($html, true));
    $layout->addButton('submit', KERNEL_SAVE);
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fFilelist_Edit_File_Access_Submit()
{
    $file = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/i', '', $_GET['file']));
	// запрещаем выход на более высокий уровень (..)
    $file = preg_replace('/\.\.+/i', '', $file);
    $file = preg_replace('/\/\/+/i', '', $file);

    if (!$GLOBALS['sbVfs']->is_dir($file))
        $check_path = dirname($file);
    else
        $check_path = $file;

    if (!fFolders_Check_Rights($check_path))
    {
        sb_show_message(SB_FILELIST_DENY_ERROR_MSG, true, 'warning');
        return;
    }

    $user_r = (isset($_POST['user_r']) ? $_POST['user_r'] : 0);
    $user_w = (isset($_POST['user_w']) ? $_POST['user_w'] : 0);
    $user_x = (isset($_POST['user_x']) ? $_POST['user_x'] : 0);

    $group_r = (isset($_POST['group_r']) ? $_POST['group_r'] : 0);
    $group_w = (isset($_POST['group_w']) ? $_POST['group_w'] : 0);
    $group_x = (isset($_POST['group_x']) ? $_POST['group_x'] : 0);

    $all_r = (isset($_POST['all_r']) ? $_POST['all_r'] : 0);
    $all_w = (isset($_POST['all_w']) ? $_POST['all_w'] : 0);
    $all_x = (isset($_POST['all_x']) ? $_POST['all_x'] : 0);

    $mode = (100 * ($user_r + $user_w + $user_x) + 10 * ($group_r + $group_w + $group_x) + ($all_r + $all_w + $all_x));

    if ($GLOBALS['sbVfs']->chmod($file, $mode))
    {
        echo '<script>
            sbReturnValue(false);
        </script>';
        // записываем действие в системный журнал
        sb_add_system_message(sprintf(PL_FILELIST_EDIT_RIGHTS_OK, $file));
    }
    else
    {
        // не удалось переименовать
        sb_show_message(sprintf(PL_FILELIST_EDIT_RIGHTS_ERROR, $file), true, 'warning');
        // записываем действие в системный журнал
        sb_add_system_message(sprintf(PL_FILELIST_EDIT_RIGHTS_ERROR, $file), SB_MSG_WARNING);
    }
}

function fFilelist_Ajax_Upload()
{
    if (!$_SESSION['sbPlugins']->isRightAvailable('pl_filelist', 'folders_upload'))
	{
        return;
	}

    if(empty($_FILES))
    {
        return;
    }


    $path = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\/\\\\_\-\.\[\]]+/', '', $_GET['path']));
	// запрещаем выход на более высокий уровень (..)
    $path = preg_replace('/\.\.+/', '', $path);
    $path = preg_replace('/\/\/+/', '', $path);


    if (!fFolders_Check_Rights($path))
    {
        echo SB_FILELIST_DENY_ERROR_MSG;
        return;
    }

    $accept_types = array();
    if (!$_SESSION['sbAuth']->isAdmin())
    {
        $accept_types = $_SESSION['sbAuth']->getUploadingExts();
        if (count($accept_types) == 0)
        {
            sb_add_system_message(PL_FILES_UPLOAD_FILES_NO_ACCEPT_TYPES_ERROR, SB_MSG_WARNING);
            echo SB_LAYOUT_UPLOAD_ERROR;
   			return;
        }
    }

    // подключаем библиотеку работы с загрузкой файлов
    require_once(SB_CMS_LIB_PATH.'/sbUploader.inc.php');

    $file_errors = array();

    $GLOBALS['sbVfs']->mLocal = true;
	if (!$GLOBALS['sbVfs']->is_dir(SB_CMS_TMP_PATH))
    {
		/**
         * Если темповая директория не существует, то создаем ее
         */
        if (!$GLOBALS['sbVfs']->mkdir(SB_CMS_TMP_PATH))
        {
            sb_add_system_message(sprintf(PL_FILES_UPLOAD_FILES_TMP_ERROR, $_FILES['sb_file_upload']['name']), SB_MSG_WARNING);
            echo SB_LAYOUT_UPLOAD_ERROR;
    		return;
        }
    }
    else
    {
        // удаляем ранее загруженные файлы
		$files = $GLOBALS['sbVfs']->scandir(SB_CMS_TMP_PATH);
        if ($files)
        {
            for ($i = 0; $i < count($files); $i++)
        	{
            	$filename = $files[$i];
            	if (preg_match('/_upload.tmp$/', $filename) && $GLOBALS['sbVfs']->is_file(SB_CMS_TMP_PATH.'/'.$filename) && $GLOBALS['sbVfs']->filectime(SB_CMS_TMP_PATH.'/'.$filename) < time() - 3600)
            	{
            		$GLOBALS['sbVfs']->delete(SB_CMS_TMP_PATH.'/'.$filename);
            	}
        	}
        }
    }

    foreach($_FILES as $key=>$file)
    {
        $uploader = new sbUploader();
        $success = $uploader->upload($key, $accept_types);

        if (!$success)
        {
            $file_errors[] = $file['name'];
            continue;
        }

        $filename_tmp = str_replace('\\', '/', preg_replace('/[^\s0-9a-zA-Z\_\-\.\[\]]+/', '', $file['tmp_name']));
        $filename_tmp = preg_replace('/\.\.+/', '', $filename_tmp);
        $filename_tmp = trim(preg_replace('/\/\/+/', '', $filename_tmp));
        $filename_tmp .= '_upload.tmp';

        if (!$GLOBALS['sbVfs']->move_uploaded_file($file['tmp_name'], SB_CMS_TMP_PATH . '/' . $filename_tmp))
        {
            $file_errors[] = $file['name'];
            continue;
        }

        $filename = sb_strtolat($file['name']);
        $filename = trim(preg_replace('/[^\s0-9a-zA-Z\_\-\.\[\]]+/', '', str_replace(array(' ', '%20'), array('_', '_'), $filename)));

        $file_new = str_replace('//', '/', $path.'/'.$filename);

        //проверяем на наличие одноименной директории
        $test_dir_name = preg_replace('/\..*$/', '', SB_BASEDIR.'/'.$file_new);
        if($GLOBALS['sbVfs']->is_dir($test_dir_name))
        {
            $file_errors[] = $file['name'];
            continue;
        }

        if (!$GLOBALS['sbVfs']->copy(SB_CMS_TMP_PATH.'/'.$filename_tmp, SB_BASEDIR.'/'.$file_new))
        {
			$file_errors[] = $file['name'];
        }
        $GLOBALS['sbVfs']->delete(SB_CMS_TMP_PATH.'/'.$filename_tmp);
    }

    if(!empty($file_errors))
    {
        $file_errors = array_unique($file_errors);
        sb_add_system_message(sprintf(PL_FILELIST_AJAX_UPLOAD_FILES_ERROR, implode(', ', $file_errors), $uploader->getError()), SB_MSG_WARNING);
        echo sprintf(PL_FILELIST_AJAX_UPLOAD_FILES_ERROR, implode(', ', $file_errors));
        return;
    }
    echo  'OK';
}
?>
