<?php
require_once(SB_CMS_LANG_PATH.'/pl_forum.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_forum', PL_FORUM_H_PLUGIN_NAME, ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_FORUM_H_SUB_MENU.'>'.PL_FORUM_H_PLUGIN_NAME, 'init');

	$_SESSION['sbPlugins']->addToMainPage('info', PL_FORUM_H_PLUGIN_NAME);
	if($_SESSION['sbPlugins']->isRightAvailable('pl_forum', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FORUM_H_PLUGIN_NAME.'>'.PL_FORUM_H_CATEGS_TEMPLATE, 'categs_init', 'pl_forum_razdel_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FORUM_H_PLUGIN_NAME.'>'.PL_FORUM_H_SUBJECT_TEMPLATE, 'subjects_init', 'pl_forum_theme_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FORUM_H_PLUGIN_NAME.'>'.PL_FORUM_H_ADD_THEME_TEMPLATE, 'form_theme_init', 'pl_forum_add_themes_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FORUM_H_PLUGIN_NAME.'>'.PL_FORUM_H_ADD_MSG_TEMPLATE, 'form_msg_init', 'pl_forum_add_messages_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FORUM_H_PLUGIN_NAME.'>'.PL_FORUM_H_FILTER_TEMPLATE, 'filter_init', 'pl_forum_filter_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_FORUM_H_PLUGIN_NAME.'>'.PL_FORUM_H_MESSAGES_TEMPLATE, 'messages_init', 'pl_forum_messages_24.png');
	}

	$_SESSION['sbPlugins']->setMainEvent('init');
	
	$_SESSION['sbPlugins']->addUserEvent('init', 'fForum_Init', 'read', PL_FORUM_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fForum_Edit', 'read', PL_FORUM_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fForum_Edit_Submit', 'elems_edit', PL_FORUM_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fForum_Edit_Delete', 'elems_edit');

	$_SESSION['sbPlugins']->addUserEvent('set_active', 'fForum_Set_Active', 'elems_public');
    $_SESSION['sbPlugins']->addUserEvent('after_paste_elem', 'fForum_After_Paste', 'elems_edit');

    $_SESSION['sbPlugins']->addUserEvent('after_del_cats_w_elems', 'fForum_Del_Cats_W_Elems', 'elems_edit');
    
	$_SESSION['sbPlugins']->addUserEvent('categs_init', 'fForum_Categs_Init', 'design_read', PL_FORUM_H_CATEGS_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('categs_edit', 'fForum_Categs_Edit', 'design_read', PL_FORUM_H_CATEGS_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('categs_edit_submit', 'fForum_Categs_Edit_Submit', 'design_edit', PL_FORUM_H_CATEGS_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('categs_delete', 'fForum_Categs_Delete', 'design_edit');
	$_SESSION['sbPlugins']->addUserEvent('categs_before_drag_drop', 'fForum_Categs_Drag_Drop', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('cat_edit', 'fForum_Cat_Edit', 'categs_edit', PL_FORUM_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('cat_edit_submit', 'fForum_Cat_Edit_Submit', 'categs_edit', PL_FORUM_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('cat_active', 'fForum_Cat_Change_Active', 'categs_edit');
    $_SESSION['sbPlugins']->addUserEvent('cat_after_paste', 'fForum_Cat_After_Paste', 'categs_edit');
    $_SESSION['sbPlugins']->addUserEvent('cat_before_paste', 'fForum_Cat_Before_Paste', 'categs_edit');
    $_SESSION['sbPlugins']->addUserEvent('cat_delete', 'fForum_Cat_Delete', 'categs_delete');

	$_SESSION['sbPlugins']->addUserEvent('subjects_init', 'fForum_Subjects_Init', 'design_read', PL_FORUM_H_SUBJECT_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('subjects_edit', 'fForum_Subjects_Edit', 'design_read', PL_FORUM_H_SUBJECT_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('subjects_edit_submit', 'fForum_Subjects_Edit_Submit', 'design_edit', PL_FORUM_H_SUBJECT_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('subjects_delete', 'fForum_Subjects_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('form_theme_init', 'fForum_Form_Themes_Init', 'design_read', PL_FORUM_H_ADD_THEME_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('form_theme_edit', 'fForum_Form_Themes_Edit', 'design_read', PL_FORUM_H_ADD_THEME_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('form_theme_submit', 'fForum_Form_Themes_Submit', 'design_edit', PL_FORUM_H_ADD_THEME_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('form_theme_delete', 'fForum_Form_Themes_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('form_msg_init', 'fForum_Form_Msg_Init', 'design_read', PL_FORUM_H_ADD_MSG_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('form_msg_edit', 'fForum_Form_Msg_Edit', 'design_read', PL_FORUM_H_ADD_MSG_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('form_msg_submit', 'fForum_Form_Msg_Submit', 'design_edit', PL_FORUM_H_ADD_MSG_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('form_msg_delete', 'fForum_Form_Msg_Delete', 'design_edit');
	
	$_SESSION['sbPlugins']->addUserEvent('messages_init', 'fForum_Messages_Init', 'design_read', PL_FORUM_H_MESSAGES_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('messages_edit', 'fForum_Messages_Edit', 'design_read', PL_FORUM_H_MESSAGES_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('messages_edit_submit', 'fForum_Messages_Edit_Submit', 'design_edit', PL_FORUM_H_MESSAGES_TEMPLATE);

	$_SESSION['sbPlugins']->addUserEvent('filter_init', 'fForum_Forum_Filter_Init', 'design_read', PL_FORUM_H_FILTER_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('filter_edit', 'fForum_Forum_Filter_Edit', 'design_read', PL_FORUM_H_FILTER_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('filter_submit', 'fForum_Forum_Filter_Submit', 'design_edit', PL_FORUM_H_FILTER_TEMPLATE);
	$_SESSION['sbPlugins']->addUserEvent('filter_delete', 'fForum_Forum_Filter_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addToConstructor('sb_forum');
	$_SESSION['sbPlugins']->addToCache();

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_forum_delim', PL_FORUM_H_PLUGIN_NAME, '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_forum_msg_max_length', PL_FORUM_H_SETTING_MSG_MAX_LENGTH, 'number', '', '10000');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_forum_theme_max_length', PL_FORUM_H_SETTING_THEME_MAX_LENGTH, 'number', '', '100');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_forum_file_path', PL_FORUM_H_SETTING_FILE_PATH, 'string', '', '/forum_files');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_forum_icon_path', PL_FORUM_H_SETTING_ICON_PATH, 'string', '', '/forum_icons');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_forum_allow_ext', PL_FORUM_H_SETTING_ALLOW_EXT, 'string', '', 'jpg gif png zip rar');

	$_SESSION['sbPlugins']->addSystemEvent('info', 'fForum_Get_Last_Msg_List_Info');
	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_forum_delim', PL_FORUM_H_PLUGIN_NAME, '', '');
	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_forum_count_msg', PL_FORUM_H_INFO_COUNT_MSG, 'number', '', '3');
}

	$_SESSION['sbPlugins']->addSystemEvent('categ_list', 'fForum_Get_Categ_List', PL_FORUM_H_CATEG_LIST);
	$_SESSION['sbPlugins']->addSystemEvent('subject_list', 'fForum_Get_Subject_List', PL_FORUM_H_SUBJECT_LIST);
	$_SESSION['sbPlugins']->addSystemEvent('themes_form', 'fForum_Get_Themes_Form', PL_FORUM_H_THEMES_FORM);
	$_SESSION['sbPlugins']->addSystemEvent('msg_form', 'fForum_Get_Msg_Form', PL_FORUM_H_MSG_FORM);
	$_SESSION['sbPlugins']->addSystemEvent('last_theme_msg_list', 'fForum_Get_Last_List', PL_FORUM_H_LAST_THEME_MSG_LIST);
	$_SESSION['sbPlugins']->addSystemEvent('path', 'fForum_Get_Forum_Path', PL_FORUM_H_FORUM_PATH);
	$_SESSION['sbPlugins']->addSystemEvent('filter', 'fForum_Get_Forum_Filter', PL_FORUM_H_FORUM_FILTER);
	$_SESSION['sbPlugins']->addSystemEvent('author_mag', 'fForum_Get_Forum_Author_List', PL_FORUM_H_FORUM_AUTHOR_LIST_MSG);

	$_SESSION['sbPlugins']->addElem(PL_FORUM_H_CATEG_LIST, 'categ', 'fForum_Elem_Categ_List', 'fForum_Elem_Categ_List_Info', 'categ_list', 820, 700, 'categs_edit', 'pl_forum_categs');
	$_SESSION['sbPlugins']->addElem(PL_FORUM_H_SUBJECT_LIST, 'subject', 'fForum_Elem_Subject_List', 'fForum_Elem_Subject_List_Info', 'subject_list', 800, 700, 'subjects_edit', 'pl_forum_subjects');
	$_SESSION['sbPlugins']->addElem(PL_FORUM_H_THEMES_FORM, 'add_themes_form', 'fForum_Elem_Themes_Form', 'fForum_Elem_Themes_Form_Info', 'themes_form', 800, 700, 'form_theme_edit', 'pl_forum_form_themes');
	$_SESSION['sbPlugins']->addElem(PL_FORUM_H_MSG_FORM, 'add_msg_form', 'fForum_Elem_Msg_Form', 'fForum_Elem_Msg_Form_Info', 'msg_form', 800, 700, 'form_msg_edit', 'pl_forum_form_msg');
	$_SESSION['sbPlugins']->addElem(PL_FORUM_H_LAST_THEME_MSG_LIST, 'last_list', 'fForum_Elem_Last_List', 'fForum_Elem_Last_List_Info', 'last_theme_msg_list', 800, 700, 'subjects_edit', 'pl_forum_subjects');

	$_SESSION['sbPlugins']->addElem(PL_FORUM_H_FORUM_PATH, 'forum_path', 'fForum_Elem_Forum_Path', 'fForum_Elem_Forum_Path_Info', 'path', 800, 700, '', '');

	$_SESSION['sbPlugins']->addElem(PL_FORUM_H_FORUM_FILTER, 'forum_filter', 'fForum_Elem_Forum_Filter', 'fForum_Elem_Forum_Filter_Info', 'filter', 800, 300, 'filter_edit', 'pl_forum_filter');
	$_SESSION['sbPlugins']->addElem(PL_FORUM_H_FORUM_AUTHOR_LIST_MSG, 'author_list', 'fForum_Elem_Forum_Author_List', 'fForum_Elem_Forum_Author_List_Info', 'author_mag', 800, 700, 'subjects_edit', 'pl_forum_subjects');

	sb_add_rights();

	$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
	$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
	$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);

?>