<?php

	function fForum_Get_Last_Msg_List_Info()
	{
		@require_once(SB_CMS_LIB_PATH.'/prog/sbFunctions.inc.php');

		$count_m = sbPlugins::getUserSetting('sb_forum_count_msg');

		$cat_right_str = '';

		$cats = array();
		if (!$_SESSION['sbAuth']->isAdmin())
	    {
			$res = sql_query('SELECT cat_id, cat_rights FROM sb_categs WHERE cat_rights != "" AND cat_ident="pl_forum"');
	        if ($res)
	        {
	        	foreach($res as $value)
	        	{
		            $cat_rights = trim($value[1]);

		            if($cat_rights == '')
		            	continue;

				    $cat_rights = explode('^', $cat_rights);
				    $cat_groups = array();

				    foreach ($cat_rights as $right)
				    {
				    	if ($right[0] == 'g')
				    	{
				    		$cat_groups[] = intval(substr($right, 1));	
				    	}
				    	elseif ($right[0] == 'u')
				    	{
				    		if (intval(substr($right, 1)) == $_SESSION['sbAuth']->getUserId())
				    		{
				    			$cats[] = $value[0];
				    			break;
				    		}
				    	}
				    	else
				    	{
				    		$cat_groups[] = intval($right);
				    	}
				    }

					$groups = $_SESSION['sbAuth']->getUserGroups();
				    if (count(array_intersect($groups, $cat_groups)) > 0)
				    {
						$cats[] = $value[0];
				    }
	        	}
	        }
		}

		if(count($cats) > 0)
		{
			$cat_right_str = ' AND c.cat_id IN ('.implode(',', $cats).') ';
		}

		$res = false;
		if(count($cats) > 0 || $_SESSION['sbAuth']->isAdmin())
		{
			$res = sql_query('SELECT f.f_id, f.f_text, f.f_date, f.f_author, c.cat_title FROM sb_forum f, sb_categs c, sb_catlinks l
							WHERE c.cat_id=l.link_cat_id AND f.f_id=l.link_el_id AND c.cat_ident="pl_forum" '.$cat_right_str.'
							ORDER BY f.f_date DESC LIMIT 0, '.$count_m);
		}

	    if($res)
	    {
			$result = '<table width="100%" cellspacing="0" cellpadding="5" class="form" style="border: 0;">
		               <tr>
		                   <td colspan="4">
	                            <div class="hint_div" style="text-align:center;">'.PL_FORUM_H_INFO_LIST_MSG_TITLE.'</div>
		                   </td>
		               </tr>';
	        $r = 0;
	        foreach($res as $key => $value)
	        {
				list($f_id, $f_text, $f_date, $f_author, $theme_title) = $value;

				$r++;
				if($r%2 == 0)
					$class = 'even';
	            else
	                $class = 'add';

				$result .= '<tr style="border-bottom:1px solid red;"  class="'.$class.'">
	                    <td style="padding:5px 10px 5px 10px; vertical-align:top; width:1%;">
	                        <div class="smalltext">
								<nobr>'.sb_date('d.m.Y  H:i', $f_date).'</nobr><br />
								<b>'.$f_author.'</b>
							</div>
	                    </td>
	                    <td style="padding:5px 10px 0px 10px; vertical-align:top; width:100px;">
							'.$theme_title.'
	                    </td>
	                    <td>
	                        <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_forum_init&sb_sel_id='.$f_id.'">'.sbProgParseBBCodes($f_text, '', '', true).'</a>
	                    </td>
	                </tr>';
		    }

	        $result .= '</table><br />
			<div class="sbDS_more"><a href="'.SB_CMS_CONTENT_FILE.'?event=pl_forum_init">'.KERNEL_MORE.'</a></div>';
	        echo $result;
		}
		else
	    {
			echo '<div class="hint_div" style="text-align:center; height:30px; margin:20px 5px 20px 5px; padding:10px 0px 0px 0px;">'.PL_FORUM_H_INFO_NO_LIST_MSG.'</div>';
	    }
	}

/********************************** функции построения диалоговых окон ***********************************/

	function fForum_Get_Categ_List()
	{
	    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
	    $params = unserialize($_GET['params']);

	    echo '<script>
	        function chooseCat()
	        {
	            var res = new Object();
	            var params = new Array();

	            var el_cats = sbCatTree.getAllSelected();
	            if (el_cats.length == 0)
	            {
	                alert("'.PL_FORUM_H_ELEM_LIST_NO_CATEGS_MSG.'");
	                return;
	            }

	            params["ids"] = el_cats;
	            var el_temp = sbGetE("temp_id");

	            if (el_temp)
	            {
	                params["temp_id"] = el_temp.value;
	            }
	            else
	            {
	                alert("'.PL_FORUM_H_ELEM_LIST_NO_TEMPS_ALERT.'");
	                return;
	            }

                params["parent_link"] = sbGetE("parent_link").checked ? 1 : 0;

                var close_c = sbGetE("close_cat");
                if(close_c.checked)
                {
                    params["close_cat"] = 1;
                }

                var hidden_c = sbGetE("hidden_cat");
                if(hidden_c.checked)
                {
                    params["hidden_cat"] = 1;
                }
                var close_sub = sbGetE("close_subcat");

                if(close_sub.checked)
                {
                    params["close_subcat"] = 1;
                }
                
                var hidden_sub = sbGetE("hidden_subcat");
                if(hidden_sub.checked)
                {
                    params["hidden_subcat"] = 1;
                }

                var page_s = sbGetE("page_subcat");
                if(page_s.value != "")
                {
                    params["page_subcat"] = page_s.value;
                }

                var page_th = sbGetE("page_theme");
                if(page_th.value != "")
                {
                    params["page_theme"] = page_th.value;
                }

                var page_msg = sbGetE("page_msg");
                if(page_msg.value != "")
                {
                    params["page_msg"] = page_msg.value;
                }

	            res.temp_id = el_temp.value;
	            res.params = sb_serialize(params);

	            sbReturnValue(res);
			}
	    </script>';

	    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	    $layout = new sbLayout();
	    $layout->mTableWidth = '100%';
	    $layout->mTitleWidth = '200';

	    $layout->addTab(PL_FORUM_H_TAB_CATEG);

		$res = sql_param_query('SELECT cat.cat_id, cat.cat_level FROM sb_categs cat WHERE cat.cat_ident = "pl_forum" ');

	    $not_show_ids = array();
	    foreach ($res as $value)
	    {
	    	list($cat_id, $cat_level) = $value;
	    	
	    	if($cat_level != 1 && $cat_level != 0)
	    	{
	    		$not_show_ids[] = $cat_id;
	    	}
	    }

	    $categs = new sbJustCategs('pl_forum');
	    $categs->mCategsUseRights = false;
	    $categs->mCategsMenu = false;
	    $categs->mCategsMultiSelect = true;
	    $categs->mCategsNeverShowCats = $not_show_ids;
	    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

	    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
	    $categs->init();

	    $layout->addTab(PL_FORUM_H_TAB_PROP);
	    $layout->addHeader(PL_FORUM_H_TAB_PROP);

	    $options = array();
	    $res = sql_query('SELECT categs.cat_title, temps.ftc_id, temps.ftc_name FROM sb_categs categs, sb_catlinks links, sb_forum_temps_categs temps WHERE temps.ftc_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_forum_categs" ORDER BY categs.cat_left, temps.ftc_name');
	    if ($res)
	    {
	        $old_cat_title = '';
	        foreach ($res as $value)
	        {
	            list($cat_title, $ndl_id, $ndl_title) = $value;
	            if ($old_cat_title != $cat_title)
	            {
	                $options[uniqid()] = '-'.$cat_title;
	                $old_cat_title = $cat_title;
	            }
	            $options[$ndl_id] = $ndl_title;

	        }
	    }

	    if (count($options) > 0)
	    {
	    	$fld = new sbLayoutSelect($options, 'temp_id');
	        if (isset($_GET['temp_id']))
	        {
	            $fld->mSelOptions = array($_GET['temp_id']);
	        }
	    }
        else
        {
            $fld = new sbLayoutLabel('<div class="hint_div">'.PL_FORUM_H_CATEG_LIST_NO_TEMPS_MSG.'</div>', '', '', false);
        }

        $layout->addField(PL_FORUM_H_ELEM_TEMP, $fld);
        $layout->addField('', new sbLayoutDelim());

        $fld = new sbLayoutPage(isset($params['page_subcat']) ? $params['page_subcat'] : '', 'page_subcat', 'page_subcat', 'style="width: 400px;"');
		$fld->mHTML = '<div class="hint_div">'.PL_FORUM_H_ELEM_CAT_PAGE_HINT.'</div>';
        $layout->addField(PL_FORUM_H_ELEM_SUBCAT_PAGE, $fld);

        $fld = new sbLayoutPage(isset($params['page_theme']) ? $params['page_theme'] : '', 'page_theme', 'page_theme', 'style="width: 400px;"');
		$fld->mHTML = '<div class="hint_div">'.PL_FORUM_H_ELEM_LIST_PAGE_HINT.'</div>';
        $layout->addField(PL_FORUM_H_ELEM_THEME_PAGE, $fld);

        $fld = new sbLayoutPage(isset($params['page_msg']) ? $params['page_msg'] : '', 'page_msg', 'page_msg', 'style="width: 400px;"');
		$fld->mHTML = '<div class="hint_div">'.PL_FORUM_H_ELEM_LIST_MSG_PAGE_HINT.'</div>';
        $layout->addField(PL_FORUM_H_ELEM_MSG_PAGE, $fld);

        $layout->addField('', new sbLayoutDelim());

        $layout->addField(PL_FORUM_H_LIST_PARENT_LINK, new sbLayoutInput('checkbox', '1', 'parent_link', 'parent_link', ($params['parent_link'] == 1) ? 'checked="checked"': ''));

        $layout->addField(PL_FORUM_H_CLOSE_CAT, new sbLayoutInput('checkbox', '1', 'close_cat', 'close_cat', (isset($params['close_cat']) && $params['close_cat'] == 1) ? 'checked="checked"': ''));
        $layout->addField(PL_FORUM_H_HIDDEN_CAT, new sbLayoutInput('checkbox', '1', 'hidden_cat', 'hidden_cat', (isset($params['hidden_cat']) && $params['hidden_cat'] == 1) ? 'checked="checked"': ''));

        $layout->addField(PL_FORUM_H_CLOSE_SUBCAT, new sbLayoutInput('checkbox', '1', 'close_subcat', 'close_subcat', (isset($params['close_subcat']) && $params['close_subcat'] == 1) ? 'checked="checked"': ''));
        $layout->addField(PL_FORUM_H_HIDDEN_SUBCAT, new sbLayoutInput('checkbox', '1', 'hidden_subcat', 'hidden_subcat', (isset($params['hidden_subcat']) && $params['hidden_subcat'] == 1) ? 'checked="checked"': ''));

	    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
	    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	    $layout->show();
	}

	function fForum_Get_Subject_List()
	{
		require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
		$params = unserialize($_GET['params']);

	    if (!isset($params['use_filter']))
	    	$params['use_filter'] = 0;

		if (!isset($params['filter']))
			$params['filter'] = 'all';

	    if (!isset($params['filter_compare']))
			$params['filter_compare'] = 'IN';
			
		if (!isset($params['allow_bbcode']))
			$params['allow_bbcode'] = 1;
			
		echo '<script>
			function chooseCat()
	        {
				var res = new Object();
	            var params = new Array();

	            var el_cats = sbCatTree.getAllSelected();
	            if (el_cats.length == 0)
	            {
	                alert("'.PL_FORUM_H_ELEM_LIST_NO_CATEGS_MSG.'");
	                return;
	            }

	            params["ids"] = el_cats;
	            var el_temp = sbGetE("temp_id");
	            if (el_temp)
	            {
	                params["temp_id"] = el_temp.value;
	            }
	            else
	            {
	                alert("'.PL_FORUM_H_ELEM_LIST_NO_TEMPS_ALERT.'");
	                return;
	            }

	            var page = sbGetE("page_mess");
                if(page && page.value != "")
                {
                    params["page_mess"] = page.value; 
                }
	            
                var close = sbGetE("close_cat");
				if(close.checked)
				{
					params["close_cat"] = 1;
                }

                var hidden = sbGetE("hidden_cat");
                if(hidden.checked)
                {
                    params["hidden_cat"] = 1;
                }

				var link = sbGetE("themes_link");
				params["themes_link"] = (link.checked ? 1 : 0);

				var el_sort1 = sbGetE("sort1");
				var el_order1 = sbGetE("order1");
				var el_sort2 = sbGetE("sort2");

	            var el_order2 = sbGetE("order2");
	            var el_sort3 = sbGetE("sort3");
	            var el_order3 = sbGetE("order3");

	            params["sort1"] = el_sort1.value;
	            params["sort2"] = el_sort2.value;
	            params["sort3"] = el_sort3.value;

	            params["order1"] = el_order1.disabled ? "" : el_order1.value;
	            params["order2"] = el_order2.disabled ? "" : el_order2.value;
	            params["order3"] = el_order3.disabled ? "" : el_order3.value;

				var el_sort_mess = sbGetE("sort_mess");
				var el_order_mess = sbGetE("order_mess");

				params["sort_mess"] = el_sort_mess.value;
				params["order_mess"] = el_order_mess.value;

				params["use_filter"] = sbGetE("use_filter").checked ? 1 : 0;
				params["allow_bbcode"] = sbGetE("allow_bbcode").checked ? 1 : 0;

            	params["filter_logic"] = sbGetE("filter_logic").value;
        	    params["filter_text_logic"] = sbGetE("filter_text_logic").value;
    	        params["filter_compare"] = sbGetE("filter_compare").value;
	            params["filter_morph"] = sbGetE("filter_morph").checked ? 1 : 0;

	            res.temp_id = el_temp.value;
	            res.params = sb_serialize(params);

		        sbReturnValue(res);
			}

			function changeSort(el, el_id)
			{
				var order_el = sbGetE("order" + el_id);
				if (el.value == "RAND()" || el.value == "")
				{
					order_el.disabled = true;
				}
				else
				{
					order_el.disabled = false;
				}
			}

	        function changeFilterMorph(el)
	        {
	            sbGetE("filter_morph").disabled = (el.value != "IN");
	        }

	        function changeUseFilter(el)
	        {
	        	sbGetE("filter_morph").disabled = !el.checked || sbGetE("filter_compare").value != "IN";
	        	sbGetE("filter_logic").disabled = !el.checked;
	        	sbGetE("filter_text_logic").disabled = !el.checked;
	        	sbGetE("filter_compare").disabled = !el.checked;
	        }
		</script>';
		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	    $layout = new sbLayout();
	    $layout->mTableWidth = '100%';
	    $layout->mTitleWidth = '200';

	    $layout->addTab(PL_FORUM_H_TAB_THEME);

		$not_show_cats = sql_param_query('SELECT cat_id FROM sb_categs WHERE cat_ident="pl_forum" AND cat_level="3"');

		$never_show = array();
		if($not_show_cats)
		{
			foreach($not_show_cats as $key => $value)
			{
				$never_show[] = $value[0];
			}
		}
		
	    $categs = new sbJustCategs('pl_forum');
	    $categs->mCategsNeverShowCats = $never_show;
	    $categs->mCategsUseRights = false;
	    $categs->mCategsMenu = false;
	    $categs->mCategsMultiSelect = true;
	    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

	    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
	    $categs->init();

	    $layout->addTab(PL_FORUM_H_TAB_PROP);
	    $layout->addHeader(PL_FORUM_H_TAB_PROP);

	    $options = array();
	    $res = sql_query('SELECT categs.cat_title, temps.fts_id, temps.fts_name 
						    FROM sb_categs categs, sb_catlinks links, sb_forum_temps_subjects temps 
						    WHERE temps.fts_id=links.link_el_id AND categs.cat_id=links.link_cat_id 
						    			AND categs.cat_ident="pl_forum_subjects"
						    ORDER BY categs.cat_left, temps.fts_name');

	    if ($res)
	    {
	        $old_cat_title = '';
	        foreach ($res as $value)
	        {
	            list($cat_title, $ndl_id, $ndl_title) = $value;
	            if ($old_cat_title != $cat_title)
	            {
	                $options[uniqid()] = '-'.$cat_title;
	                $old_cat_title = $cat_title;
	            }
	            $options[$ndl_id] = $ndl_title;
	        }
	    }

	    if (count($options) > 0)
	    {
	    	$fld = new sbLayoutSelect($options, 'temp_id');
	        if (isset($_GET['temp_id']))
	        {
	            $fld->mSelOptions = array($_GET['temp_id']);
	        }
	    }
	    else
        {
        	$fld = new sbLayoutLabel('<div class="hint_div">'.PL_FORUM_H_ELEM_LIST_NO_TEMPS_MSG.'</div>', '', '', false);
	    }

		$layout->addField(PL_FORUM_H_ELEM_TEMP, $fld);

        $fld = new sbLayoutPage(isset($params['page_mess']) ? $params['page_mess'] : '', 'page_mess', '', 'style="width:400px;"');
		$fld->mHTML = '<div class="hint_div">'.PL_FORUM_H_ELEM_LIST_PAGE_HINT.'</div>';
    	$layout->addField(PL_FORUM_H_ELEM_MESSAGE_PAGE, $fld);

		$layout->addField(PL_FORUM_H_MSG_LIST_LINK, new sbLayoutInput('checkbox', '1', 'themes_link', 'themes_link', (isset($params['themes_link']) && $params['themes_link'] == 1 ? 'checked="checked"' : '')));

		$layout->addField('', new sbLayoutDelim());
		$fields = array('' => ' --- ',
                        'f.f_id' => PL_FORUM_H_SORT_ID,
                        'max_date' => PL_FORUM_DATE_MESSAGE,
                        'c.cat_title' => PL_FORUM_H_ELEM_FILE_NAME);

        $res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident="pl_forum"');
        if ($res)
        {
            list($pd_fields) = $res[0];
            $pd_fields = unserialize($pd_fields);

            foreach($pd_fields as $value)
            {
                if ($value['type'] == 'string' || 
                    $value['type'] == 'number' || 
                    $value['type'] == 'date' || 
                    $value['type'] == 'checkbox' || 
                    $value['type'] == 'image' || 
                    $value['type'] == 'link' || 
                    $value['type'] == 'file' || 
                    $value['type'] == 'color' || 
                    $value['type'] == 'select_sprav' ||
                    $value['type'] == 'radio_sprav' )
                {
                    $fields['f.user_f_'.$value['id']] = $value['title'];
                }
            }
        }

        $order = array('DESC' => PL_FORUM_H_ELEM_LIST_SORT_DESC,
                       'ASC'  => PL_FORUM_H_ELEM_LIST_SORT_ASC);
    
        $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
        $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'f.f_date'));
        $fld2 = new sbLayoutSelect($order, 'order1');
        $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
        $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();
    
        $layout->addField(PL_FORUM_H_ELEM_LIST_SORT_FIELD.' 1', $fld1);
    
        $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
        $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
        $fld2 = new sbLayoutSelect($order, 'order2');
        $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
        $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();
    
        $layout->addField(PL_FORUM_H_ELEM_LIST_SORT_FIELD.' 2', $fld1);
    
        $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
        $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
        $fld2 = new sbLayoutSelect($order, 'order3');
        $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
        $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

        $layout->addField(PL_FORUM_H_ELEM_LIST_SORT_FIELD.' 3', $fld1);

        $fields = array('' => ' --- ',
						'f.f_date' => PL_FORUM_DATE_MESSAGE);

        $fld1 = new sbLayoutSelect($fields, 'sort_mess', '', 'onchange="changeSort(this, \'_mess\');"');
        $fld1->mSelOptions = array((isset($params['sort_mess']) && $params['sort_mess'] != '' ? $params['sort_mess'] : ''));
        $fld2 = new sbLayoutSelect($order, 'order_mess');
        $fld2->mSelOptions = array((isset($params['order_mess']) && $params['order_mess'] != '' ? $params['order_mess'] : ''));
        $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

		$layout->addField(PL_FORUM_H_ELEM_LIST_SORT_MESS_FIELD, $fld1);

		$layout->addField('', new sbLayoutDelim());

    	$layout->addField(PL_FORUM_H_CLOSE_THEMES, new sbLayoutInput('checkbox', '1', 'close_cat', 'close_cat', (isset($params['close_cat']) && $params['close_cat'] == 1 ? 'checked="checked"' : '')));
        $layout->addField(PL_FORUM_H_HIDDEN_THEMES, new sbLayoutInput('checkbox', '1', 'hidden_cat', 'hidden_cat', (isset($params['hidden_cat']) && $params['hidden_cat'] == 1 ? 'checked="checked"' : '')));

        $layout->addField(PL_FORUM_H_BBCODE_ALLOW, new sbLayoutInput('checkbox', 'allow_bbcode', '1', 'allow_bbcode', (isset($params['allow_bbcode']) && $params['allow_bbcode'] == 1 ? 'checked="checked"' : '')));  
        
		$layout->addTab(PL_FORUM_H_ELEM_LIST_FILTER_TAB);
		$layout->addHeader(PL_FORUM_H_ELEM_LIST_FILTER_TAB);

		$layout->addField(PL_FORUM_H_ELEM_LIST_USE_FILTER, new sbLayoutInput('checkbox', '1', 'use_filter', '', (isset($params['use_filter']) && $params['use_filter'] == 1 ? 'checked="checked"' : '').' onclick="changeUseFilter(this)"'));	
	
	    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_logic');
	    $fld->mSelOptions = array((isset($params['filter_logic']) && $params['filter_logic'] != '' ? $params['filter_logic'] : ''));
	    $layout->addField(PL_FORUM_H_ELEM_LIST_FILTER_LOGIC, $fld);

		$fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_text_logic');
		$fld->mSelOptions = array((isset($params['filter_text_logic']) && $params['filter_text_logic'] != '' ? $params['filter_text_logic'] : ''));

	    $fld1 = new sbLayoutSelect(array('EQ' => PL_FORUM_H_ELEM_LIST_FILTER_TEXT_LOGIC_EQ, 'IN' => PL_FORUM_H_ELEM_LIST_FILTER_TEXT_LOGIC_IN), 'filter_compare', '', 'onchange="changeFilterMorph(this);"');
	    $fld1->mSelOptions = array((isset($params['filter_compare']) && $params['filter_compare'] != '' ? $params['filter_compare'] : ''));
	    $fld1->mHTML = '&nbsp;&nbsp;<input type="checkbox" value="1" id="filter_morph"'.(isset($params['filter_morph']) && $params['filter_morph'] == 1 ? ' checked="checked"' : '').(isset($params['filter_compare']) && $params['filter_compare'] != 'IN' ? ' disabled="disabled"' : '').' />&nbsp;&nbsp;'.PL_FORUM_H_ELEM_LIST_FILTER_MORPH;
	    $fld->mHTML = '&nbsp;&nbsp;'.$fld1->getField();

		$layout->addField(PL_FORUM_H_ELEM_LIST_FILTER_TEXT_LOGIC, $fld);

	    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
	    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	    $layout->show();
	}

	function fForum_Get_Themes_Form()
	{
		$params = unserialize($_GET['params']);
		echo '<script>
			function choose()
			{
				var res = new Object();
				var params = new Array();

				var el_cat = sbCatTree.getSelectedItemId();
				if (el_cat.length == 0)
				{
					alert("'.PL_FORUM_H_ELEM_FORM_NO_CATEGS_MSG.'");
					return;
				}

				params["id"] = el_cat;
				var el_temp = sbGetE("temp_id");

				if (el_temp)
				{
					params["temp_id"] = el_temp.value;
				}
				else
				{
					alert("'.PL_FORUM_H_ELEM_FORM_NO_TEMPS_ALERT.'");
					return;
				}

				var premod = sbGetE("premod_themes");
				if(premod.checked)
				{
					params["premod_themes"] = premod.value;
				}

				params["page"] = sbGetE("page").value;
				params["mod_emails"] = sbGetE("mod_emails").value;

	            res.temp_id = el_temp.value;
	            res.params = sb_serialize(params);
				sbReturnValue(res);
			}
		</script>';

		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
		require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

		$layout = new sbLayout();
		$layout->mTableWidth = '100%';
		$layout->mTitleWidth = '200';

		$layout->addTab(PL_FORUM_H_TAB_SUBCAT);

		$res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident="pl_forum" AND cat_level = "0" OR cat_level = "1" OR cat_level="3"');

		$never_show = array();
		foreach($res as $value)
		{
			$never_show[] = $value[0];
		}

		$categs = new sbJustCategs('pl_forum');
		$categs->mCategsUseRights = false;
		$categs->mCategsNeverShowCats = $never_show;
		$categs->mCategsMenu = false;
		$categs->mCategsSelectedId = $params['id'];

	    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
	    $categs->init();
	
	    $layout->addTab(PL_FORUM_H_TAB_PROP);
	    $layout->addHeader(PL_FORUM_H_TAB_PROP);

		$res = sql_query('SELECT categs.cat_title, temps.sftf_id, temps.sftf_title 
					FROM sb_categs categs, sb_catlinks links, sb_forum_form_theme temps
					WHERE temps.sftf_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_forum_form_themes"
					ORDER BY categs.cat_left, temps.sftf_title');
		if ($res)
		{
			$options = array();

			$old_cat_title = '';
			foreach ($res as $value)
			{
				list($cat_title, $st_id, $st_title) = $value;

				if ($old_cat_title != $cat_title)
				{
					$options[uniqid()] = '-'.$cat_title;
					$old_cat_title = $cat_title;
				}
				$options[$st_id] = $st_title;
			}

			$fld = new sbLayoutSelect($options, 'temp_id');
			$fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

			$layout->addField(PL_FORUM_H_ELEM_TEMP, $fld);
		}
		else
		{
			$layout->addField(PL_FORUM_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_FORUM_H_ELEM_FORM_NO_TEMPS_MSG.'</div>', '', '', false));
		}

		$layout->addField('', new sbLayoutDelim());
		$layout->addField(PL_FORUM_H_ELEM_FORM_PAGE, new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 480px;"'));

		$layout->addField('', new sbLayoutDelim());

		$layout->addField(PL_FORUM_H_ELEM_PREMOD_THEMES, new sbLayoutInput('checkbox', '1', 'premod_themes', 'premod_themes', (isset($params['premod_themes']) && $params['premod_themes'] == 1 ? 'checked="checked"' : '' )));
		$layout->addField(PL_FORUM_H_ELEM_FORM_MOD_EMAILES, new sbLayoutInput('input', (isset($params['mod_emails']) ? $params['mod_emails'] : ''), 'mod_emails', '', 'style="width: 510px;"'));

		$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
		$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

		$layout->show();
	}

	function fForum_Get_Msg_Form()
	{
		$params = unserialize($_GET['params']);
		echo '<script>
			function choose()
			{
				var res = new Object();
				var params = new Array();

				var el_cat = sbCatTree.getSelectedItemId();
				if (el_cat.length == 0)
				{
					alert("'.PL_FORUM_H_ELEM_FORM_MSG_NO_CATEGS_MSG.'");
					return;
				}

				params["id"] = el_cat;
				var el_temp = sbGetE("temp_id");

				if (el_temp)
				{
					params["temp_id"] = el_temp.value;
				}
				else
				{
					alert("'.PL_FORUM_H_ELEM_FORM_MSG_NO_TEMPS_ALERT.'");
					return;
				}

				var premod = sbGetE("premod_msg");
				if(premod.checked)
				{
					params["premod_msg"] = premod.value;
				}

				params["page"] = sbGetE("page").value;
				params["unsub_page"] = sbGetE("unsub_page").value;
				params["mod_emails"] = sbGetE("mod_emails").value;

	            res.temp_id = el_temp.value;
	            res.params = sb_serialize(params);
				sbReturnValue(res);
			}
		</script>';

		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
		require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');

		$layout = new sbLayout();
		$layout->mTableWidth = '100%';
		$layout->mTitleWidth = '200';

		$layout->addTab(PL_FORUM_H_TAB_THEME);
		$res = sql_query('SELECT cat_id FROM sb_categs WHERE cat_ident=? AND cat_level = 0 OR cat_level = 1 OR cat_level=2', 'pl_forum');

		$never_show = array();
		foreach($res as $value)
		{
			$never_show[] = $value[0];
		}

		$categs = new sbJustCategs('pl_forum');
		$categs->mCategsUseRights = false;
		$categs->mCategsNeverShowCats = $never_show;
		$categs->mCategsMenu = false;
		$categs->mCategsSelectedId = (isset($params['id']) && $params['id'] != '' ? $params['id'] : array());
	
		$layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
		$categs->init();

		$layout->addTab(PL_FORUM_H_TAB_PROP);
		$layout->addHeader(PL_FORUM_H_TAB_PROP);

		$res = sql_query('SELECT categs.cat_title, temps.sffm_id, temps.sffm_title 
					FROM sb_categs categs, sb_catlinks links, sb_forum_form_msg temps
					WHERE temps.sffm_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_forum_form_msg"
					ORDER BY categs.cat_left, temps.sffm_title');
		if ($res)
		{
			$options = array();

			$old_cat_title = '';
			foreach ($res as $value)
			{
				list($cat_title, $st_id, $st_title) = $value;

				if ($old_cat_title != $cat_title)
				{
					$options[uniqid()] = '-'.$cat_title;
					$old_cat_title = $cat_title;
				}

				$options[$st_id] = $st_title;
			}

			$fld = new sbLayoutSelect($options, 'temp_id');
			$fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

			$layout->addField(PL_FORUM_H_ELEM_TEMP, $fld);
		}
		else
		{
			$layout->addField(PL_FORUM_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_FORUM_H_ELEM_FORM_MSG_NO_TEMPS_MSG.'</div>', '', '', false));
		}

		$layout->addField('', new sbLayoutDelim());
		$layout->addField(PL_FORUM_H_ELEM_FORM_PAGE, new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 480px;"'));
		$layout->addField(PL_FORUM_H_ELEM_UNSUB_PAGE, new sbLayoutPage(isset($params['unsub_page']) ? $params['unsub_page'] : '', 'unsub_page', '', 'style="width: 480px;"'));

		$layout->addField('', new sbLayoutDelim());

		$layout->addField(PL_FORUM_H_ELEM_PREMOD_MSG, new sbLayoutInput('checkbox', '1', 'premod_msg', 'premod_msg', (isset($params['premod_msg']) && $params['premod_msg'] == 1 ? 'checked="checked"' : '' )));
		$layout->addField(PL_FORUM_H_ELEM_FORM_MOD_EMAILES, new sbLayoutInput('input', (isset($params['mod_emails']) ? $params['mod_emails'] : ''), 'mod_emails', '', 'style="width: 510px;"'));

		$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
		$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

		$layout->show();
	}

	function fForum_Get_Last_List()
	{
		require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
		$params = unserialize($_GET['params']);

	    echo '<script>
	        function chooseCat()
	        {
	            var res = new Object();
	            var params = new Array();

				var el_cats = sbCatTree.getAllSelected();
				if (el_cats.length == 0)
				{
					alert("'.PL_FORUM_H_ELEM_LAST_LIST_NO_CATEGS_MSG.'");
					return;
				}

	            params["ids"] = el_cats;
	            var el_temp = sbGetE("temp_id");

	            if (el_temp)
	            {
	                params["temp_id"] = el_temp.value;
				}
				else
	            {
					alert("'.PL_FORUM_H_ELEM_LAST_LIST_NO_TEMPS_ALERT.'");
					return;
	            }

                var close = sbGetE("close_cat");
				if(close.checked)
				{
					params["close_cat"] = 1;
                }

                var hidden = sbGetE("hidden_cat");
                if(hidden.checked)
                {
                    params["hidden_cat"] = 1;
                }

				params["sort_mess"] = "f.f_date";
				params["order_mess"] = "DESC";
				
				params["sort1"] = "max_date";
				params["order1"] = " DESC ";
				params["allow_bbcode"] = sbGetE("allow_bbcode").checked ? 1 : 0;
				
				res.temp_id = el_temp.value;
				res.params = sb_serialize(params);
				sbReturnValue(res);
			}
		</script>';

		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	    $layout = new sbLayout();
	    $layout->mTableWidth = '100%';
	    $layout->mTitleWidth = '200';

	    $layout->addTab(PL_FORUM_H_TAB_CATEG);

		$res = sql_param_query('SELECT cat.cat_id, cat.cat_level FROM sb_categs cat WHERE cat.cat_ident = "pl_forum" ');

	    $not_show_ids = array();
	    foreach ($res as $value)
	    {
	    	list($cat_id, $cat_level) = $value;

	    	if($cat_level != 1 && $cat_level != 0 && $cat_level != 2)
	    	{
	    		$not_show_ids[] = $cat_id;
	    	}
	    }

	    $categs = new sbJustCategs('pl_forum');
	    $categs->mCategsUseRights = false;
	    $categs->mCategsMenu = false;
	    $categs->mCategsMultiSelect = true;
	    $categs->mCategsNeverShowCats = $not_show_ids;
	    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

	    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
	    $categs->init();

	    $layout->addTab(PL_FORUM_H_TAB_PROP);
	    $layout->addHeader(PL_FORUM_H_TAB_PROP);

	    $options = array();
	    $res = sql_query('SELECT categs.cat_title, temps.fts_id, temps.fts_name 
						    FROM sb_categs categs, sb_catlinks links, sb_forum_temps_subjects temps 
						    WHERE temps.fts_id=links.link_el_id AND categs.cat_id=links.link_cat_id
						    			AND categs.cat_ident="pl_forum_subjects"
						    ORDER BY categs.cat_left, temps.fts_name');
		if ($res)
	    {
	        $old_cat_title = '';
	        foreach ($res as $value)
	        {
	            list($cat_title, $ndl_id, $ndl_title) = $value;
	            if ($old_cat_title != $cat_title)
	            {
	                $options[uniqid()] = '-'.$cat_title;
	                $old_cat_title = $cat_title;
	            }
	            $options[$ndl_id] = $ndl_title;

	        }
	    }

	    if (count($options) > 0)
	    {
	    	$fld = new sbLayoutSelect($options, 'temp_id');
	        if (isset($_GET['temp_id']))
	        {
	            $fld->mSelOptions = array($_GET['temp_id']);
	        }
	    }
        else
        {
            $fld = new sbLayoutLabel('<div class="hint_div">'.PL_FORUM_H_ELEM_LIST_NO_TEMPS_MSG.'</div>', '', '', false);
        }

		$layout->addField(PL_FORUM_H_ELEM_TEMP, $fld);

        $layout->addField('', new sbLayoutDelim());

    	$layout->addField(PL_FORUM_H_CLOSE_THEMES, new sbLayoutInput('checkbox', '1', 'close_cat', 'close_cat', (isset($params['close_cat']) && $params['close_cat'] == 1 ? 'checked="checked"' : '')));
        $layout->addField(PL_FORUM_H_HIDDEN_THEMES, new sbLayoutInput('checkbox', '1', 'hidden_cat', 'hidden_cat', (isset($params['hidden_cat']) && $params['hidden_cat'] == 1 ? 'checked="checked"' : '')));

        $layout->addField(PL_FORUM_H_BBCODE_ALLOW, new sbLayoutInput('checkbox', 'allow_bbcode', '1', 'allow_bbcode', (isset($params['allow_bbcode']) && $params['allow_bbcode'] == 1 ? 'checked="checked"' : '')));
        
		$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
		$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

		$layout->show();
	}

	function fForum_Get_Forum_Path()
	{
		require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
		$params = unserialize($_GET['params']);

		echo '<script>
			function chooseCat()
			{
				var res = new Object();
				var params = new Array();

				var el_cats = sbCatTree.getAllSelected();
				if (el_cats.length == 0)
				{
					alert("'.PL_FORUM_H_PATH_NO_CATEGS_MSG.'");
					return;
	            }

	            params["ids"] = el_cats;
	            var el_temp = sbGetE("temp_id");
	            if (el_temp)
	            {
	                params["temp_id"] = el_temp.value;
	            }
	            else
	            {
	                alert("'.PL_FORUM_H_PATH_NO_TEMPS_ALERT.'");
	                return;
	            }

	            var p_categs = sbGetE("categs_page");
	            if(p_categs.value != "")
	            {
					params["categs_page"] = p_categs.value;
				}

	            var p_themes = sbGetE("themes_page");
	            if(p_themes.value != "")
	            {
					params["themes_page"] = p_themes.value;
				}
				
	            params["show_hidden"] = sbGetE("show_hidden").checked ? 1 : 0;
	            params["show_closed"] = sbGetE("show_closed").checked ? 1 : 0;
	            
	            res.temp_id = el_temp.value;
	            res.params = sb_serialize(params);
	    
	            sbReturnValue(res);
	        }
	    </script>';
	    
	    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	    
	    $layout = new sbLayout();
	    $layout->mTableWidth = '100%';
	    $layout->mTitleWidth = '200';

		$layout->addTab(PL_FORUM_H_TAB_CATEG);

	    $categs = new sbJustCategs('pl_forum');
	    $categs->mCategsUseRights = false;
	    $categs->mCategsMenu = false;
	    $categs->mCategsMultiSelect = true;
	    $categs->mCategsCount = false;
	    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());
	    
	    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
	    $categs->init();
	    
	    $layout->addTab(PL_FORUM_H_TAB_PROP);
	    $layout->addHeader(PL_FORUM_H_TAB_PROP);

		$options = array();
		$res = sql_query('SELECT categs.cat_title, temps.mpt_id, temps.mpt_title FROM sb_categs categs, sb_catlinks links, sb_menu_path_temps temps WHERE temps.mpt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_menu_path_temps" ORDER BY categs.cat_left, temps.mpt_title');
	    if ($res)
	    {
	        $old_cat_title = '';
	        foreach ($res as $value)
	        {
	            list($cat_title, $mt_id, $mt_title) = $value;
	            if ($old_cat_title != $cat_title)
	            {
	                $options[uniqid()] = '-'.$cat_title;
	                $old_cat_title = $cat_title;
	            }
	            $options[$mt_id] = $mt_title;
	        }
	    }

	    if (count($options) > 0)
	    { 
	    	$fld = new sbLayoutSelect($options, 'temp_id');
	        if (isset($_GET['temp_id']))
	        {
	            $fld->mSelOptions = array($_GET['temp_id']);
	        }
	    }
	    else 
	    {
			$fld = new sbLayoutLabel('<div class="hint_div">'.PL_FORUM_H_PATH_NO_TEMPS_MSG.'</div>', '', '', false);
		}

		$layout->addField(PL_FORUM_H_ELEM_TEMP, $fld);

		$fld = new sbLayoutPage(isset($params['categs_page']) ? $params['categs_page'] : '' , 'categs_page', 'categs_page', 'style="width:400px;"');
		$fld->mHTML = '<div class="hint_div">'.PL_FORUM_H_ELEM_CAT_PAGE_HINT.'</div>';
		$layout->addField(PL_FORUM_H_PATH_SUBCATEGS_PAGE, $fld);
		
		$fld = new sbLayoutPage(isset($params['themes_page']) ? $params['themes_page'] : '' , 'themes_page', 'themes_page', 'style="width:400px;"');
		$fld->mHTML = '<div class="hint_div">'.PL_FORUM_H_ELEM_LIST_PAGE_HINT.'</div>';
		$layout->addField(PL_FORUM_H_PATH_THEMES_PAGE, $fld);

		$layout->addField('', new sbLayoutDelim());

	    $fld = new sbLayoutInput('checkbox', '1', 'show_closed', '', (isset($params['show_closed']) && $params['show_closed'] == 1 ? 'checked="checked"' : ''));
	    $fld->mHTML = '<div class="hint_div">'.PL_FORUM_H_PATH_SHOW_CLOSED_DESC.'</div>';
	    $layout->addField(PL_FORUM_H_CLOSE_POINT, $fld);

		$layout->addField(PL_FORUM_H_HIDDEN_POINT, new sbLayoutInput('checkbox', '1', 'show_hidden', '', ((isset($params['show_hidden']) && $params['show_hidden'] == 1) || !isset($params['show_hidden']) ? 'checked="checked"' : '')));

	    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
	    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
	    
	    $layout->show();
	}	

	function fForum_Get_Forum_Filter()
	{
		$params = unserialize($_GET['params']);
		echo '<script>
			function choose()
	        {
				var res = new Object();
				var params = new Array();
	
	            var el_temp = sbGetE("temp_id");
	            if (el_temp)
	            {
	                params["temp_id"] = el_temp.value;
				}
				else
	            {
					alert("'.PL_FORUM_H_FILTER_FORM_NO_TEMPS_ALERT.'");
					return;
				}
				params["page"] = sbGetE("page").value;

				res.temp_id = el_temp.value;
				res.params = sb_serialize(params);

				sbReturnValue(res);
	        }
		</script>';

		echo '<br /><br />';
		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

		$layout = new sbLayout();
		$layout->mTableWidth = '90%';
		$layout->mTitleWidth = '200';

		$layout->addHeader(PL_FORUM_H_FORUM_FILTER);

		$res = sql_query('SELECT categs.cat_title, temps.sffm_id, temps.sffm_title FROM sb_categs categs, sb_catlinks links, sb_forum_form_msg temps WHERE temps.sffm_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_forum_filter" ORDER BY categs.cat_left, temps.sffm_title');
		if ($res)
		{
			$options = array();
			$old_cat_title = '';

			foreach ($res as $value)
			{
				list($cat_title, $st_id, $st_title) = $value;
	            if ($old_cat_title != $cat_title)
	            {
					$options[uniqid()] = '-'.$cat_title;
	                $old_cat_title = $cat_title;
				}
				$options[$st_id] = $st_title;
	        }

			$fld = new sbLayoutSelect($options, 'temp_id');
			$fld->mSelOptions = isset($params['temp_id']) ? array($params['temp_id']) : array();

			$layout->addField(PL_FORUM_H_ELEM_TEMP, $fld);
	    }
		else
		{
			$layout->addField(PL_FORUM_H_ELEM_TEMP, new sbLayoutLabel('<div class="hint_div">'.PL_FORUM_H_FILTER_FORM_NO_TEMPS_MSG.'</div>', '', '', false));
		}

		$fld = new sbLayoutPage(isset($params['page']) ? $params['page'] : '', 'page', '', 'style="width: 450px;"');
		$fld->mHTML = '<div class="hint_div">'.PL_FORUM_H_FILTER_LIST_PAGE_HINT_LIST.'</div>';
		$layout->addField(PL_FORUM_H_FILTER_LIST_PAGE_LIST, $fld);

		$layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="choose();"'.($res ? '' : ' disabled="disabled"'));
		$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

		$layout->show();
	}
	
	function fForum_Get_Forum_Author_List()
	{
		require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
		$params = unserialize($_GET['params']);

	    if (!isset($params['use_filter']))
	    	$params['use_filter'] = 1;

		if (!isset($params['filter']))
			$params['filter'] = 'all';

	    if (!isset($params['filter_compare']))
			$params['filter_compare'] = 'IN';

		if (!isset($params['allow_bbcode']))
			$params['allow_bbcode'] = 1;
			
		echo '<script>
			function chooseCat()
	        {
        
				var res = new Object();
	            var params = new Array();

	            var el_cats = sbCatTree.getAllSelected();
	            if (el_cats.length == 0)
	            {
	                alert("'.PL_FORUM_H_ELEM_LIST_NO_CATEGS_MSG.'");
	                return;
	            }

	            params["ids"] = el_cats;
	            var el_temp = sbGetE("temp_id");
	            if (el_temp)
	            {
	                params["temp_id"] = el_temp.value;
	            }
	            else
	            {
	                alert("'.PL_FORUM_H_ELEM_LIST_NO_TEMPS_ALERT.'");
	                return;
	            }

	            var page = sbGetE("page_mess");
                if(page && page.value != "")
                {
                    params["page_mess"] = page.value; 
                }
	            
                var close = sbGetE("close_cat");
				if(close.checked)
				{
					params["close_cat"] = 1;
                }

                var hidden = sbGetE("hidden_cat");
                if(hidden.checked)
                {
                    params["hidden_cat"] = 1;
                }

                var link = sbGetE("themes_link");
                params["themes_link"] = (link.checked ? 1 : 0);

	            var el_sort1 = sbGetE("sort1");
	            var el_order1 = sbGetE("order1");
	            var el_sort2 = sbGetE("sort2");

	            var el_order2 = sbGetE("order2");
	            var el_sort3 = sbGetE("sort3");
	            var el_order3 = sbGetE("order3");

	            params["sort1"] = el_sort1.value;
	            params["sort2"] = el_sort2.value;
	            params["sort3"] = el_sort3.value;

	            params["order1"] = el_order1.disabled ? "" : el_order1.value;
	            params["order2"] = el_order2.disabled ? "" : el_order2.value;
	            params["order3"] = el_order3.disabled ? "" : el_order3.value;

				var el_sort_mess = sbGetE("sort_mess");
				var el_order_mess = sbGetE("order_mess");

				params["sort_mess"] = el_sort_mess.value;
				params["order_mess"] = el_order_mess.value;

				params["use_filter"] = sbGetE("use_filter").checked ? 1 : 0;

            	params["filter_logic"] = sbGetE("filter_logic").value;
        	    params["filter_text_logic"] = sbGetE("filter_text_logic").value;
    	        params["filter_compare"] = sbGetE("filter_compare").value;
	            params["filter_morph"] = sbGetE("filter_morph").checked ? 1 : 0;
	            params["allow_bbcode"] = sbGetE("allow_bbcode").checked ? 1 : 0;

	            res.temp_id = el_temp.value;
	            res.params = sb_serialize(params);

				sbReturnValue(res);
			}

			function changeSort(el, el_id)
			{
				var order_el = sbGetE("order" + el_id);
				if (el.value == "RAND()" || el.value == "")
				{
					order_el.disabled = true;
				}
				else
				{
					order_el.disabled = false;
				}
			}

	        function changeFilterMorph(el)
	        {
	            sbGetE("filter_morph").disabled = (el.value != "IN");
	        }

	        function changeUseFilter(el)
	        {
	        	sbGetE("filter_morph").disabled = !el.checked || sbGetE("filter_compare").value != "IN";
	        	sbGetE("filter_logic").disabled = !el.checked;
	        	sbGetE("filter_text_logic").disabled = !el.checked;
	        	sbGetE("filter_compare").disabled = !el.checked;
	        }
		</script>';
		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	    $layout = new sbLayout();
	    $layout->mTableWidth = '100%';
		$layout->mTitleWidth = '200';

		$layout->addTab(PL_FORUM_H_TAB_THEME);

//      из-за этого заголовка появляется прокрутка. Почему?
//	    $layout->addHeader(PL_FORUM_H_TAB_HEADER_THEME);

		$not_show_cats = sql_param_query('SELECT cat_id FROM sb_categs WHERE cat_ident="pl_forum" AND cat_level="3"');

		$never_show = array();
		if($not_show_cats)
		{
			foreach($not_show_cats as $key => $value)
			{
				$never_show[] = $value[0];
			}
		}

		$categs = new sbJustCategs('pl_forum');
	    $categs->mCategsNeverShowCats = $never_show;
	    $categs->mCategsUseRights = false;
	    $categs->mCategsMenu = false;
	    $categs->mCategsMultiSelect = true;
	    $categs->mCategsSelectedIds = (isset($params['ids']) && $params['ids'] != '' ? explode('^', $params['ids']) : array());

	    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
	    $categs->init();

	    $layout->addTab(PL_FORUM_H_TAB_PROP);
	    $layout->addHeader(PL_FORUM_H_TAB_PROP);

	    $options = array();
	    $res = sql_query('SELECT categs.cat_title, temps.fts_id, temps.fts_name 
						    FROM sb_categs categs, sb_catlinks links, sb_forum_temps_subjects temps 
						    WHERE temps.fts_id=links.link_el_id AND categs.cat_id=links.link_cat_id 
						    			AND categs.cat_ident="pl_forum_subjects"
						    ORDER BY categs.cat_left, temps.fts_name');
	    if ($res)
	    {
			$old_cat_title = '';
	        foreach ($res as $value)
			{
	            list($cat_title, $ndl_id, $ndl_title) = $value;
	            if ($old_cat_title != $cat_title)
	            {
	                $options[uniqid()] = '-'.$cat_title;
	                $old_cat_title = $cat_title;
	            }
	            $options[$ndl_id] = $ndl_title;
	        }
	    }

	    if (count($options) > 0)
	    {
	    	$fld = new sbLayoutSelect($options, 'temp_id');
	        if (isset($_GET['temp_id']))
	        {
	            $fld->mSelOptions = array($_GET['temp_id']);
	        }
	    }
	    else
        {
        	$fld = new sbLayoutLabel('<div class="hint_div">'.PL_FORUM_H_ELEM_LIST_NO_TEMPS_MSG.'</div>', '', '', false);
	    }

		$layout->addField(PL_FORUM_H_ELEM_TEMP, $fld);

        $fld = new sbLayoutPage(isset($params['page_mess']) ? $params['page_mess'] : '', 'page_mess', '', 'style="width:400px;"');
		$fld->mHTML = '<div class="hint_div">'.PL_FORUM_H_ELEM_AUTHOR_LIST_PAGE_HINT.'</div>';
    	$layout->addField(PL_FORUM_H_ELEM_MESSAGE_PAGE, $fld);

    	$layout->addField('', new sbLayoutDelim());
        $fields = array('' => ' --- ',
					'f.f_id' => PL_FORUM_H_SORT_ID,
					'max_date' => PL_FORUM_DATE_MESSAGE,
					'c.cat_title' => PL_FORUM_H_ELEM_FILE_NAME);

		$res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident="pl_forum"');
        if ($res)
        {
			list($pd_fields) = $res[0];
            $pd_fields = unserialize($pd_fields);

            foreach($pd_fields as $value)
            {
                if ($value['type'] == 'string' || 
                    $value['type'] == 'number' || 
                    $value['type'] == 'date' || 
                    $value['type'] == 'checkbox' || 
                    $value['type'] == 'image' || 
                    $value['type'] == 'link' || 
                    $value['type'] == 'file' || 
                    $value['type'] == 'color' || 
                    $value['type'] == 'select_sprav' ||
                    $value['type'] == 'radio_sprav' )
                {
                    $fields['f.user_f_'.$value['id']] = $value['title'];
                }
            }
        }

        $order = array('DESC' => PL_FORUM_H_ELEM_LIST_SORT_DESC,
                       'ASC'  => PL_FORUM_H_ELEM_LIST_SORT_ASC);
    
        $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
        $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'f.f_date'));
        $fld2 = new sbLayoutSelect($order, 'order1');
        $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
        $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();
    
        $layout->addField(PL_FORUM_H_ELEM_LIST_SORT_FIELD.' 1', $fld1);
    
        $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
        $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
        $fld2 = new sbLayoutSelect($order, 'order2');
        $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
        $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();
    
        $layout->addField(PL_FORUM_H_ELEM_LIST_SORT_FIELD.' 2', $fld1);
    
        $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
        $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
        $fld2 = new sbLayoutSelect($order, 'order3');
        $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
        $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

        $layout->addField(PL_FORUM_H_ELEM_LIST_SORT_FIELD.' 3', $fld1);

        $fields = array('' => ' --- ',
                        'f.f_date' => PL_FORUM_DATE_MESSAGE);

        $fld1 = new sbLayoutSelect($fields, 'sort_mess', '', 'onchange="changeSort(this, \'_mess\');"');
        $fld1->mSelOptions = array((isset($params['sort_mess']) && $params['sort_mess'] != '' ? $params['sort_mess'] : ''));
        $fld2 = new sbLayoutSelect($order, 'order_mess');
        $fld2->mSelOptions = array((isset($params['order_mess']) && $params['order_mess'] != '' ? $params['order_mess'] : ''));
        $fld1->mHTML = '&nbsp;&nbsp;'.$fld2->getField();

		$layout->addField(PL_FORUM_H_ELEM_LIST_SORT_MESS_FIELD, $fld1);

		$layout->addField('', new sbLayoutDelim());

		$layout->addField(PL_FORUM_H_THEMES_AUTHOR_LIST, new sbLayoutInput('checkbox', '1', 'themes_link', 'themes_link', (isset($params['themes_link']) && $params['themes_link'] == 1 ? 'checked="checked"' : '')));

    	$layout->addField(PL_FORUM_H_CLOSE_THEMES, new sbLayoutInput('checkbox', '1', 'close_cat', 'close_cat', (isset($params['close_cat']) && $params['close_cat'] == 1 ? 'checked="checked"' : '')));
        $layout->addField(PL_FORUM_H_HIDDEN_THEMES, new sbLayoutInput('checkbox', '1', 'hidden_cat', 'hidden_cat', (isset($params['hidden_cat']) && $params['hidden_cat'] == 1 ? 'checked="checked"' : '')));
		
        $layout->addField(PL_FORUM_H_BBCODE_ALLOW, new sbLayoutInput('checkbox', 'allow_bbcode', '1', 'allow_bbcode', (isset($params['allow_bbcode']) && $params['allow_bbcode'] == 1 ? 'checked="checked"' : '')));
        
		$layout->addTab(PL_FORUM_H_ELEM_LIST_FILTER_TAB);
		$layout->addHeader(PL_FORUM_H_ELEM_LIST_FILTER_TAB);

		$layout->addField(PL_FORUM_H_ELEM_LIST_USE_FILTER, new sbLayoutInput('checkbox', '1', 'use_filter', '', (isset($params['use_filter']) && $params['use_filter'] == 1 ? 'checked="checked"' : '').' onclick="changeUseFilter(this)"'));	
	
	    $fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_logic');
	    $fld->mSelOptions = array((isset($params['filter_logic']) && $params['filter_logic'] != '' ? $params['filter_logic'] : ''));
	    $layout->addField(PL_FORUM_H_ELEM_LIST_FILTER_LOGIC, $fld);

		$fld = new sbLayoutSelect(array('AND' => KERNEL_AND, 'OR' => KERNEL_OR), 'filter_text_logic');
		$fld->mSelOptions = array((isset($params['filter_text_logic']) && $params['filter_text_logic'] != '' ? $params['filter_text_logic'] : ''));

	    $fld1 = new sbLayoutSelect(array('EQ' => PL_FORUM_H_ELEM_LIST_FILTER_TEXT_LOGIC_EQ, 'IN' => PL_FORUM_H_ELEM_LIST_FILTER_TEXT_LOGIC_IN), 'filter_compare', '', 'onchange="changeFilterMorph(this);"');
	    $fld1->mSelOptions = array((isset($params['filter_compare']) && $params['filter_compare'] != '' ? $params['filter_compare'] : ''));
	    $fld1->mHTML = '&nbsp;&nbsp;<input type="checkbox" value="1" id="filter_morph"'.(isset($params['filter_morph']) && $params['filter_morph'] == 1 ? ' checked="checked"' : '').(isset($params['filter_compare']) && $params['filter_compare'] != 'IN' ? ' disabled="disabled"' : '').' />&nbsp;&nbsp;'.PL_FORUM_H_ELEM_LIST_FILTER_MORPH;
	    $fld->mHTML = '&nbsp;&nbsp;'.$fld1->getField();

		$layout->addField(PL_FORUM_H_ELEM_LIST_FILTER_TEXT_LOGIC, $fld);

	    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"'.(count($options) > 0 ? '' : ' disabled="disabled"'));
	    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	    $layout->show();
	}

/********************************** функции получения информации по элементам модуля ***********************************/

	function fForum_Elem_Categ_List_Info($params)
	{
	    $in_str = implode(',', explode('^', $params['ids']));
	    $in_str = '(0,'.$in_str.')';

	    $categs_str = '';
	    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
	    if ($res)
	    {
	        foreach ($res as $value)
	        {
	            $categs_str .= $value[0].', ';
	        }
	        $categs_str = substr($categs_str, 0, -2);
	    }

	    $res = sql_param_query('SELECT categs.cat_title, temps.ftc_name FROM sb_categs categs, sb_catlinks links, sb_forum_temps_categs temps
	                            WHERE temps.ftc_id=?d AND links.link_el_id=temps.ftc_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_forum_categs"', $params['temp_id']);

	    echo '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_TAB_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FORUM_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FORUM_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
                <div class="delim"></div>
                '.(isset($params['page_subcat']) && $params['page_subcat'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_SUBCAT_PAGE.':</b> '.$params['page_subcat'].'</div>' : '').'
                '.(isset($params['page_theme']) && $params['page_theme'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_THEME_PAGE.':</b> '.$params['page_theme'].'</div>' : '').'
                <div class="delim"></div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_CLOSE_CAT.':</b> '.(isset($params['close_cat']) && $params['close_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_CLOSE_SUBCAT.':</b> '.(isset($params['hidden_cat']) && $params['hidden_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_HIDDEN_CAT.':</b> '.(isset($params['close_subcat']) && $params['close_subcat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_HIDDEN_SUBCAT.':</b> '.(isset($params['hidden_subcat']) && $params['hidden_subcat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
	}

	function fForum_Elem_Subject_List_Info($params)
    {
        $in_str = implode(',', explode('^', $params['ids']));
        $in_str = '(0,'.$in_str.')';

        $categs_str = '';
        $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
        if ($res)
        {
            foreach ($res as $value)
            {
                $categs_str .= $value[0].', ';
            }
            $categs_str = substr($categs_str, 0, -2);
        }

        $res = sql_param_query('SELECT categs.cat_title, temps.fts_name FROM sb_categs categs, sb_catlinks links, sb_forum_temps_subjects temps
                                WHERE temps.fts_id=?d AND links.link_el_id=temps.fts_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_forum_subjects"', $params['temp_id']);

        echo '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_TAB_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FORUM_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FORUM_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
                <div class="delim"></div>
                '.(isset($params['page_mess']) && $params['page_mess'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_THEME_PAGE.':</b> '.$params['page_mess'].'</div>' : '').'
                <div class="delim"></div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_CLOSE_THEMES.':</b> '.(isset($params['close_cat']) && $params['close_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_HIDDEN_THEMES.':</b> '.(isset($params['hidden_cat']) && $params['hidden_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
    }

	function fForum_Elem_Themes_Form_Info($params)
	{
	    $in_str = '(0,'.$params['id'].')';

	    $categs_str = '';
	    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
	    if ($res)
	    {
	        $categs_str = '';
	        foreach ($res as $value)
	        {
	            $categs_str .= $value[0].', ';
	        }
	        $categs_str = substr($categs_str, 0, -2);
	    }
	    $res = sql_param_query('SELECT categs.cat_title, temps.sftf_title
	                    FROM sb_categs categs, sb_catlinks links, sb_forum_form_theme temps
						WHERE temps.sftf_id=?d 
						AND links.link_el_id=temps.sftf_id 
						AND categs.cat_id=links.link_cat_id 
						AND categs.cat_ident="pl_forum_form_themes"', $params['temp_id']);

	    echo '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_TAB_SUBCAT.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FORUM_H_INFO_SUBCATEGS_WAS_DELETED_MSG.'</span>').'</div>
	          <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FORUM_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
	          <div class="delim"></div>
	          <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_PREMOD_THEMES.':</b> '.(isset($params['premod_themes']) && $params['premod_themes'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
	}

	function fForum_Elem_Msg_Form_Info($params)
	{
	    $in_str = '(0,'.$params['id'].')';

	    $categs_str = '';
	    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
	    if ($res)
	    {
			$categs_str = '';
			foreach ($res as $value)
			{
				$categs_str .= $value[0].', ';
			}
			$categs_str = sb_substr($categs_str, 0, -2);
		}

		$res = sql_param_query('SELECT categs.cat_title, temps.sffm_title
						FROM sb_categs categs, sb_catlinks links, sb_forum_form_msg temps
						WHERE temps.sffm_id=?d 
						AND links.link_el_id=temps.sffm_id 
						AND categs.cat_id=links.link_cat_id 
						AND categs.cat_ident="pl_forum_form_msg"', $params['temp_id']);

		echo '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_TAB_THEME.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FORUM_H_INFO_THEME_WAS_DELETED_MSG.'</span>').'</div>
				<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FORUM_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
				<div class="delim"></div>
				<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_PREMOD_MSG.':</b> '.(isset($params['premod_msg']) && $params['premod_msg'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
	}

	function fForum_Elem_Last_List_Info($params)
	{
		$in_str = implode(',', explode('^', $params['ids']));
		$in_str = '(0,'.$in_str.')';

        $categs_str = '';
        $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
        if ($res)
        {
            foreach ($res as $value)
            {
                $categs_str .= $value[0].', ';
            }
            $categs_str = substr($categs_str, 0, -2);
        }

        $res = sql_param_query('SELECT categs.cat_title, temps.fts_name FROM sb_categs categs, sb_catlinks links, sb_forum_temps_subjects temps
                                WHERE temps.fts_id=?d AND links.link_el_id=temps.fts_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_forum_subjects"', $params['temp_id']);

        echo '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_TAB_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FORUM_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FORUM_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
                <div class="delim"></div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_CLOSE_THEMES.':</b> '.(isset($params['close_cat']) && $params['close_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_HIDDEN_THEMES.':</b> '.(isset($params['hidden_cat']) && $params['hidden_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
	}

	function fForum_Elem_Forum_Path_Info($params)
	{
		$in_str = implode(',', explode('^', $params['ids']));
		$in_str = '(0,'.$in_str.')';

		$categs_str = '';
		$res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');

	    if ($res)
	    {
	        $categs_str = '';
	        foreach ($res as $value)
	        {
	            $categs_str .= $value[0].', ';
	        }
	        $categs_str = substr($categs_str, 0, -2);
		}

		$res = sql_param_query('SELECT categs.cat_title, temps.sftp_title FROM sb_categs categs, sb_catlinks links, sb_forum_temps_path temps
							WHERE temps.sftp_id=?d AND links.link_el_id=temps.sftp_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_forum_path"', $params['temp_id']);

		echo '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_TAB_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FORUM_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
				<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FORUM_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
				<div class="delim"></div>
				<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_CLOSE_THEMES.':</b> '.(isset($params['show_closed']) && $params['show_closed'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
				<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_HIDDEN_THEMES.':</b> '.(isset($params['show_hidden']) && $params['show_hidden'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
	}

	function fForum_Elem_Forum_Filter_Info($params)
	{
		$res = sql_param_query('SELECT categs.cat_title, temps.sffm_title FROM sb_categs categs, sb_catlinks links, sb_forum_form_msg temps
				WHERE temps.sffm_id=?d AND links.link_el_id=temps.sffm_id AND categs.cat_id=links.link_cat_id
				AND categs.cat_ident="pl_forum_filter"', $params['temp_id']);

		echo '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FORUM_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
				<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_TAB_CATEGS.':</b> '.($params['page'] != '' ? $params['page'] : '').'</div>';
	}

	function fForum_Elem_Forum_Author_List_Info($params)
	{
		$in_str = implode(',', explode('^', $params['ids']));
		$in_str = '(0,'.$in_str.')';

		$categs_str = '';
		$res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN '.$in_str.' ORDER BY cat_left');
		if ($res)
        {
            foreach ($res as $value)
            {
				$categs_str .= $value[0].', ';
            }
			$categs_str = substr($categs_str, 0, -2);
        }

		$res = sql_param_query('SELECT categs.cat_title, temps.fts_name FROM sb_categs categs, sb_catlinks links, sb_forum_temps_subjects temps
                                WHERE temps.fts_id=?d AND links.link_el_id=temps.fts_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_forum_subjects"', $params['temp_id']);

        echo '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_TAB_CATEGS.':</b> '.($categs_str != '' ? $categs_str : '<span style="color:red;">'.PL_FORUM_H_INFO_CATEGS_WAS_DELETED_MSG.'</span>').'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_TEMP.':</b> '.($res ? $res[0][0].' -&gt; '.$res[0][1] : '<span style="color:red;">'.PL_FORUM_H_INFO_TEMP_WAS_DELETED_MSG.'</span>').'</div>
                <div class="delim"></div>
                '.(isset($params['page_mess']) && $params['page_mess'] != '' ? '<div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_ELEM_THEME_PAGE.':</b> '.$params['page_mess'].'</div>' : '').'
                <div class="delim"></div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_CLOSE_THEMES.':</b> '.(isset($params['close_cat']) && $params['close_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>
                <div style="padding-bottom: 5px;"><b>'.PL_FORUM_H_HIDDEN_THEMES.':</b> '.(isset($params['hidden_cat']) && $params['hidden_cat'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
	}

/********************************** функции получения элементов модуля ***********************************/

    function fForum_Elem_Categ_List($el_id, $temp_id, $params, $tag_id)
    {
        return "<?php include_once SB_CMS_PL_PATH.'/pl_forum/prog/pl_forum.php';\n
        fForum_Elem_Categ_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
    }

	function fForum_Elem_Subject_List($el_id, $temp_id, $params, $tag_id)
	{
		return "<?php include_once SB_CMS_PL_PATH.'/pl_forum/prog/pl_forum.php';\n
		fForum_Elem_Subject_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
	}

	function fForum_Elem_Themes_Form($el_id, $temp_id, $params, $tag_id)
	{
		return "<?php include_once SB_CMS_PL_PATH.'/pl_forum/prog/pl_forum.php';\n
		fForum_Form_Themes('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
	}

	function fForum_Elem_Msg_Form($el_id, $temp_id, $params, $tag_id)
	{
		return "<?php include_once SB_CMS_PL_PATH.'/pl_forum/prog/pl_forum.php'; \n
		fForum_Form_Msg('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
	}

	function fForum_Elem_Last_List($el_id, $temp_id, $params, $tag_id)
	{
		return "<?php include_once SB_CMS_PL_PATH.'/pl_forum/prog/pl_forum.php';\n
		fForum_Elem_Subject_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
	}

	function fForum_Elem_Forum_Path($el_id, $temp_id, $params, $tag_id)
	{
		return "<?php include_once SB_CMS_PL_PATH.'/pl_forum/prog/pl_forum.php';\n
		fForum_Elem_Forum_Path('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
	}

	function fForum_Elem_Forum_Filter($el_id, $temp_id, $params, $tag_id)
	{
		return "<?php include_once SB_CMS_PL_PATH.'/pl_forum/prog/pl_forum.php';\n
		fForum_Elem_Forum_Filter('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
		?>";
	}

	function fForum_Elem_Forum_Author_List($el_id, $temp_id, $params, $tag_id)
	{
		return "<?php include_once SB_CMS_PL_PATH.'/pl_forum/prog/pl_forum.php';\n
		fForum_Elem_Subject_List('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id', true);\n
		?>";
	}

?>