<?php

/**************************************** функции построения диалоговых окон **************************************/
function fPayment_Get_PreForm()
{
    require_once(SB_CMS_LIB_PATH . '/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);

    if (!isset($params['filter'])) {
        $params['filter'] = 'all';
    }

    if (!isset($params['subcategs'])) {
        $params['subcategs'] = 1;
    }

    echo '<script>
        function ch_field()
        {
            var centr = sbGetE("pr_cent")
            var secc = sbGetE("id_1");
            var user_s = sbGetE("id_3");
            if(centr.value == "pl_payment_chronopay")
            {
                secc.style.display = "none";
                user_s.style.display = "block";
            }
            else
            {
                secc.style.display = "block";
                user_s.style.display = "none";
            }
        }

        function chooseCat()
        {
            var res = new Object();
            var params = new Array();

            var el_fail_p = sbGetE("p_failed");
            if(el_fail_p.value == "")
            {
                alert("' . PL_PAYMENT_H_TEMP_PFAILED_PCENTER_ERROR . '");
                return;
            }

            var cat_id = sbGetE("pr_cent");
            if(cat_id.value == "")
            {
                alert("' . PL_PAYMENT_H_ELEM_LIST_NO_CATEGS_MSG . '");
                return;
            }

            params["id"] = cat_id.value;

            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("' . PL_PAYMENT_H_ELEM_FORM_NO_TEMPS_ALERT . '");
                return;
            }

            var p_send = sbGetE("p_senduserdata");
            if(p_send.checked)
            {
                params["p_senduserdata"] = p_send.value;
            }
            
            params["p_success"] = sbGetE("p_success").value;
            params["p_failed"] = sbGetE("p_failed").value;

            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }

        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }
    </script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_PAYMENT_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_PAYMENT_H_ELEM_LIST_PROPS_TAB);

    $resu = sql_param_query('SELECT cat_id, cat_title, cat_fields FROM sb_categs WHERE cat_ident="pl_payments"');

    $pr_cent = array();
    $cat_ = array();
    foreach ($resu as $value) {
        $cat_ = unserialize($value[2]);
        if ($cat_['cat_ident'] == 'pl_payment_assist' ||
            $cat_['cat_ident'] == 'pl_payment_rupay' ||
            $cat_['cat_ident'] == 'pl_payment_chronopay' ||
            $cat_['cat_ident'] == 'pl_payment_rfi_bank') {
            $pr_cent[$cat_['cat_ident']] = $value[1];
        }
    }

    $fld = new sbLayoutSelect($pr_cent, 'pr_cent', '', 'onchange="ch_field()";');
    $fld->mSelOptions = array(isset($params['id']) ? $params['id'] : '');
    $layout->addField(PL_PAYMENT_H_PROCES_CENTR, $fld);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.spt_id, temps.spt_title FROM sb_categs categs, sb_catlinks links, sb_payments_temps temps WHERE temps.spt_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_payment_temps" ORDER BY categs.cat_left, temps.spt_title');

    if ($res) {
        $old_cat_title = '';
        foreach ($res as $value) {
            list($cat_title, $spt_id, $spt_title) = $value;
            if ($old_cat_title != $cat_title) {
                $options[uniqid()] = '-' . $cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$spt_id] = $spt_title;
        }
    }

    if (count($options) > 0) {
        $fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id'])) {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    } else {
        $fld = new sbLayoutLabel('<div class="hint_div">' . PL_PAYMENT_H_ELEM_FORM_NO_TEMPS_MSG . '</div>', '', '',
            false);
    }

    $layout->addField(PL_PAYMENT_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fld_s = new sbLayoutPage(isset($params['p_success']) ? $params['p_success'] : '', 'p_success', '',
        'style="width: 400px;"');
    $fld_s->mHTML = '<div class="hint_div">' . PL_PAYMENT_H_PSUCCESS . '</div>';

    $fld_f = new sbLayoutPage(isset($params['p_failed']) ? $params['p_failed'] : '', 'p_failed', '',
        'style="width: 400px;"');
    $fld_f->mHTML = '<div class="hint_div">' . PL_PAYMENT_H_PFAILED . '</div>';

    $fld_ch = new sbLayoutInput('checkbox', '1', 'p_senduserdata', 'p_senduserdata',
        'style="margin: 0px;"' . (isset($params['p_senduserdata']) && $params['p_senduserdata'] == 1 ? 'checked = "checked"' : ''));


    $html_4 = '
' . $fld_s->getJavaScript() . '
' . $fld_f->getJavaScript() . '
    <div id="id_1" ' . (isset($params['id']) && $params['id'] == 'pl_payment_chronopay' ? 'style="display:none;"' : '') . '>
        <table width="100%">
            <tr>
                <td style="width:198px;" align="right">
<span style="font-family:Arial; font-size:12px;"><b>' . PL_PAYMENT_H_PAGE_SUCCESS . ':</b></span>
                </td>
                <td style="padding-left:20px;">
' . $fld_s->getField() . '
                </td>
            </tr>
        </table>
    </div>
    <div id="id_2">
        <table width="100%">
            <tr>
                <td style="width:198px;" align="right">
<span style="font-family:Arial; font-size:12px;"><b>' . PL_PAYMENT_H_PAGE_FAILED . ':</b></span>
                </td>
                <td style="padding-left:20px;">
' . $fld_f->getField() . '
                </td>
            </tr>
        </table>
    </div>
    <div id="id_3" ' . (isset($params['id']) && $params['id'] == 'pl_payment_chronopay' ? '' : 'style="display:none;"') . '>
        <table width="100%">
           <tr>
                <td style="width:198px;" align="right">
<span style="font-family:Arial; font-size:12px;"><b>' . PL_PAYMENT_USER_DATA_SEND . ':</b></span>
                </td>
                <td style="padding-left:20px;">
' . $fld_ch->getField() . '
                </td>
            </tr>
        </table>
    </div>';

    $layout->addField('', new sbLayoutHTML($html_4, true));

    $layout->addButton('button', KERNEL_SAVE, '', '',
        'onclick="chooseCat();"' . (count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');
    $layout->show();
}

function fPayment_Get_List_Transaction()
{
    require_once(SB_CMS_LIB_PATH . '/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);

    if (!isset($params['filter'])) {
        $params['filter'] = 'all';
    }

    if (!isset($params['subcategs'])) {
        $params['subcategs'] = 1;
    }

    echo '<script>
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();

            var el_cats = sbCatTree.getAllSelected();
            if (el_cats.length == 0)
            {
                alert("' . PL_PAYMENT_H_ELEM_LIST_NO_TRANS_MSG . '");
                return;
            }

            params["ids"] = el_cats;
            var el_temp = sbGetE("temp_id");
            if (el_temp)
            {
                params["temp_id"] = el_temp.value;
            }
            else
            {
                alert("' . PL_PAYMENT_H_ELEM_LIST_NO_TEMPS_ALERT . '");
                return;
            }

            var r_filter_all = sbGetE("r_filter_all");
            if (r_filter_all.checked)
            {
                params["filter"] = r_filter_all.value;
            }

            var filter_last = sbGetE("r_filter_last");
            if(filter_last.checked)
            {
                params["filter"] = filter_last.value 
                params["filter_last"] = sbGetE("spin_filter_last").value;
            }

            var filter_from_to = sbGetE("r_filter_from_to");
            if(filter_from_to.checked)
            {
                params["filter"] = filter_from_to.value
                var el_filter_from = sbGetE("spin_filter_from");
                var el_filter_to = sbGetE("spin_filter_to");

                if (el_filter_to.value != "" && el_filter_to.value != 0 && parseInt(el_filter_from.value) > parseInt(el_filter_to.value))
                {
                    alert("' . PL_PAYMENT_H_ELEM_LIST_FILTER_FROM_TO_ERROR . '");
                    return;
                }

                params["filter_from"] = el_filter_from.value;
                params["filter_to"] = el_filter_to.value;
            }

            var filter_summ = sbGetE("r_filter_summ");
            if(filter_summ.checked)
            {
                params["filter"] = filter_summ.value
                var el_filter_summ_from = sbGetE("spin_filter_summ_from");
                var el_filter_summ_to = sbGetE("spin_filter_summ_to");

                if (el_filter_summ_to.value != "" && el_filter_summ_to.value != 0 && parseInt(el_filter_summ_from.value) > parseInt(el_filter_summ_to.value))
                {
                    alert("' . PL_PAYMENT_H_ELEM_LIST_FILTER_FROM_TO_ERROR . '");
                    return;
                }

                params["filter_summ_from"] = el_filter_summ_from.value;
                params["filter_summ_to"] = el_filter_summ_to.value;
            }

            var filter_st = sbGetE("r_filter_stat");
            if(filter_st.checked)
            {
                params["filter_stat"] = filter_st.value;
                params["filter_status"] = sbGetE("r_filter_status").value;
            }

            var el_sort1 = sbGetE("sort1");
            var el_order1 = sbGetE("order1");
            var el_sort2 = sbGetE("sort2");
            var el_order2 = sbGetE("order2");
            var el_sort3 = sbGetE("sort3");
            var el_order3 = sbGetE("order3");
            
            params["sort1"] = el_sort1.value;
            params["sort2"] = el_sort2.value;
            params["sort3"] = el_sort3.value;
            
            params["order1"] = el_order1.disabled ? "" : el_order1.value;
            params["order2"] = el_order2.disabled ? "" : el_order2.value;
            params["order3"] = el_order3.disabled ? "" : el_order3.value;
                               
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;
            params["rubrikator"] = sbGetE("rubrikator").checked ? 1 : 0;
            
            res.temp_id = el_temp.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }

        function changeSort(el, el_id)
        {
            var order_el = sbGetE("order" + el_id);
            if (el.value == "RAND()" || el.value == "")
            {
                order_el.disabled = true;
            }
            else
            {
                order_el.disabled = false;
            }
        }
    </script>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE . '?event=pl_services_rutube_edit_movie_submit' . ($_SERVER['QUERY_STRING'] != '' ? '&' . $_SERVER['QUERY_STRING'] : ''),
        'thisDialog', 'post', 'checkValues()', 'main', 'enctype="multipart/form-data"');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addTab(PL_PAYMENT_H_PROCES_CENTR);

    $categs = new sbJustCategs('pl_payments');
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;
    $categs->mCategsSelectedId = (isset($params['ids']) && $params['ids'] != '' ? $params['ids'] : array());

    $layout->addField('', new sbLayoutHTML($categs->showTree('', '', '', false), true));
    $categs->init();

    $layout->addTab(PL_PAYMENT_H_ELEM_LIST_PROPS_TAB);
    $layout->addHeader(PL_PAYMENT_H_ELEM_LIST_PROPS_TAB);

    $options = array();
    $res = sql_query('SELECT categs.cat_title, temps.sptl_id, temps.sptl_title FROM sb_categs categs, sb_catlinks links, sb_payments_temps_list temps WHERE temps.sptl_id=links.link_el_id
                        AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_payments_temps_list" ORDER BY categs.cat_left, temps.sptl_title');
    if ($res) {
        $old_cat_title = '';
        foreach ($res as $value) {
            list($cat_title, $spt_id, $spt_title) = $value;
            if ($old_cat_title != $cat_title) {
                $options[uniqid()] = '-' . $cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$spt_id] = $spt_title;
        }
    }

    if (count($options) > 0) {
        $fld = new sbLayoutSelect($options, 'temp_id');
        if (isset($_GET['temp_id'])) {
            $fld->mSelOptions = array($_GET['temp_id']);
        }
    } else {
        $fld = new sbLayoutLabel('<div class="hint_div">' . PL_PAYMENT_H_ELEM_LIST_NO_TEMPS_MSG . '</div>', '', '',
            false);
    }

    $layout->addField(PL_PAYMENT_H_ELEM_TEMP, $fld);
    $layout->addField('', new sbLayoutDelim());

    $fields = sbPlugins::getSortFields('pl_payment');

    $res = sql_query('SELECT pd_fields FROM sb_plugins_data WHERE pd_plugin_ident="pl_payments"');
    if ($res) {
        list($pd_fields) = $res[0];
        $pd_fields = unserialize($pd_fields);

        foreach ($pd_fields as $value) {
            if ($value['type'] == 'string' ||
                $value['type'] == 'number' ||
                $value['type'] == 'date' ||
                $value['type'] == 'checkbox' ||
                $value['type'] == 'image' ||
                $value['type'] == 'link' ||
                $value['type'] == 'file' ||
                $value['type'] == 'color' ||
                $value['type'] == 'select_sprav' ||
                $value['type'] == 'radio_sprav'
            ) {
                $fields['user_f_' . $value['id']] = $value['title'];
            }
        }
    }
    $order = array(
        'DESC' => PL_PAYMENT_H_ELEM_LIST_SORT_DESC,
        'ASC' => PL_PAYMENT_H_ELEM_LIST_SORT_ASC
    );

    $fld1 = new sbLayoutSelect($fields, 'sort1', '', 'onchange="changeSort(this, 1);"');
    $fld1->mSelOptions = array((isset($params['sort1']) ? $params['sort1'] : 'sp_date'));
    $fld2 = new sbLayoutSelect($order, 'order1');
    $fld2->mSelOptions = array((isset($params['order1']) && $params['order1'] != '' ? $params['order1'] : 'DESC'));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_PAYMENT_H_ELEM_LIST_SORT_FIELD . ' 1', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort2', '', 'onchange="changeSort(this, 2);"');
    $fld1->mSelOptions = array((isset($params['sort2']) && $params['sort1'] != '' ? $params['sort2'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order2');
    $fld2->mSelOptions = array((isset($params['order2']) && $params['order1'] != '' ? $params['order2'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_PAYMENT_H_ELEM_LIST_SORT_FIELD . ' 2', $fld1);

    $fld1 = new sbLayoutSelect($fields, 'sort3', '', 'onchange="changeSort(this, 3);"');
    $fld1->mSelOptions = array((isset($params['sort3']) && $params['sort1'] != '' ? $params['sort3'] : ''));
    $fld2 = new sbLayoutSelect($order, 'order3');
    $fld2->mSelOptions = array((isset($params['order3']) && $params['order3'] != '' ? $params['order3'] : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . $fld2->getField();

    $layout->addField(PL_PAYMENT_H_ELEM_LIST_SORT_FIELD . ' 3', $fld1);

    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_PAYMENT_H_ELEM_LIST_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '',
            (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_PAYMENT_H_ELEM_LIST_RUBRIK_LINK, new sbLayoutInput('checkbox', '1', 'rubrikator', '',
            (isset($params['rubrikator']) && $params['rubrikator'] == 1 ? 'checked="checked"' : '')));

    $layout->addTab(PL_PAYMENT_H_ELEM_LIST_FILTER_TAB);
    $layout->addHeader(PL_PAYMENT_H_ELEM_LIST_FILTER_TAB);

    $html = '';
    $fld1 = new sbLayoutInput('radio', 'all', 'filter', 'r_filter_all',
        ($params['filter'] == 'all' ? ' checked="checked"' : ''));
    $fld1->mHTML = '&nbsp;&nbsp;' . PL_PAYMENT_H_ELEM_LIST_FILTER_ALL;
    $html .= $fld1->getField() . '<br /><br />';

    $fld2 = new sbLayoutInput('radio', 'last', 'filter', 'r_filter_last',
        ($params['filter'] == 'last' ? ' checked="checked"' : ''));
    $fld2_1 = new sbLayoutInput('input', (isset($params['filter_last']) ? $params['filter_last'] : ''), 'filter_last',
        'spin_filter_last', 'style="width: 50px;"');
    $fld2_1->mMinValue = 1;
    $html .= $fld2_1->getJavaScript() . '<table cellpadding="0" cellspacing="0"><tr><td>' . $fld2->getField() . '</td><td>&nbsp;&nbsp;' . PL_PAYMENT_H_ELEM_LIST_FILTER_LAST . '&nbsp;&nbsp;</td><td>' . $fld2_1->getField() . '</td><td>&nbsp;&nbsp;' . PL_PAYMENT_H_ELEM_LIST_FILTER_DAYS . '</td></tr></table><br />';

    $fld3 = new sbLayoutInput('radio', 'from_to', 'filter', 'r_filter_from_to',
        ($params['filter'] == 'from_to' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutInput('input', (isset($params['filter_from']) ? $params['filter_from'] : ''), 'filter_from',
        'spin_filter_from', 'style="width: 50px;"');
    $fld3_2 = new sbLayoutInput('input', (isset($params['filter_to']) ? $params['filter_to'] : ''), 'filter_to',
        'spin_filter_to', 'style="width: 50px;"');
    $fld3_1->mMinValue = 1;
    $html .= '<table cellpadding="0" cellspacing="0"><tr><td>' . $fld3->getField() . '</td><td>&nbsp;&nbsp;' . KERNEL_FROM . '&nbsp;&nbsp;</td><td>' . $fld3_1->getField() . '</td><td>&nbsp;&nbsp;' . KERNEL_TO . '&nbsp;&nbsp;</td><td>' . $fld3_2->getField() . '</td></tr></table><br />';

    $fld3 = new sbLayoutInput('checkbox', 'summ', 'filter_summ', 'r_filter_summ',
        ($params['filter'] == 'summ' ? ' checked="checked"' : ''));
    $fld3_1 = new sbLayoutInput('input', (isset($params['filter_summ_from']) ? $params['filter_summ_from'] : ''),
        'filter_summ_from', 'spin_filter_summ_from', 'style="width: 50px;"');
    $fld3_2 = new sbLayoutInput('input', (isset($params['filter_summ_to']) ? $params['filter_summ_to'] : ''),
        'filter_summ_to', 'spin_filter_summ_to', 'style="width: 50px;"');
    $fld3_1->mMinValue = 0;
    $fld3_2->mMinValue = 0;
    $html .= $fld3_1->getJavaScript() . '<table cellpadding="0" cellspacing="0"><tr><td>' . $fld3->getField() . '</td><td style="width:80px;">&nbsp;&nbsp;' . PL_PAYMENT_H_FILTER_SUMM . '</td><td>&nbsp;&nbsp;' . KERNEL_FROM . '&nbsp;&nbsp;</td><td>' . $fld3_1->getField() . '</td><td>&nbsp;&nbsp;' . KERNEL_TO . '&nbsp;&nbsp;</td><td>' . $fld3_2->getField() . '</td></tr></table>';
    $html .= '<br /><div class="hint_div">' . PL_PAYMENT_H_ELEM_LIST_FILTER_FROM_TO_HINT . '</div>';

    $stat = array();
    $stat[0] = ' --- ';
    $stat[1] = PL_PAYMENT_H_STATUS_0;
    $stat[2] = PL_PAYMENT_H_STATUS_1;
    $stat[3] = PL_PAYMENT_H_STATUS_2;
    $stat[4] = PL_PAYMENT_H_STATUS_3;
    $stat[5] = PL_PAYMENT_H_STATUS_4;
    $stat[6] = PL_PAYMENT_H_STATUS_5;
    $stat[7] = PL_PAYMENT_H_STATUS_6;
    $stat[8] = PL_PAYMENT_H_STATUS_7;

    $fld6 = new sbLayoutInput('checkbox', 'filter_stat', 'filter_stat', 'r_filter_stat',
        (isset($params['filter_stat']) && $params['filter_stat'] == 'filter_stat' ? ' checked="checked"' : ''));
    $fld6_1 = new sbLayoutSelect($stat, 'filter_status', 'r_filter_status', '');
    $fld6_1->mSelOptions = array((isset($params['filter_status']) ? $params['filter_status'] : 0));
    $html .= '<br /><table cellpadding="0" cellspacing="0"><tr><td>' . $fld6->getField() . '</td><td style="width:190px;">&nbsp;&nbsp;' . PL_PAYMENT_H_FILTER_STATUS . '</td><td>' . $fld6_1->getField() . '</td></tr></table><br />';

    $fld = new sbLayoutHTML($html);
    $layout->addField(PL_PAYMENT_H_ELEM_LIST_FILTER, $fld);

    $layout->addButton('button', KERNEL_SAVE, '', '',
        'onclick="chooseCat();"' . (count($options) > 0 ? '' : ' disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $layout->show();
}


/********************************* функции получения информации по элементам модуля ***********************************/

function fPayment_Get_PreForm_Info($params)
{
    $in_str = implode(',', explode('^', $params['id']));
    $in_str = '(0,' . $in_str . ')';

    $categs_str = '';

    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_fields LIKE "%' . $params['id'] . '%" AND cat_level="1"');
    if ($res) {
        $categs_str = '';
        foreach ($res as $value) {
            $categs_str .= $value[0] . ', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }


    $res = sql_param_query('SELECT categs.cat_title, temps.spt_title FROM sb_categs categs, sb_catlinks links, sb_payments_temps temps WHERE temps.spt_id=?d
                            AND links.link_el_id=temps.spt_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_payment_temps"',
    $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>' . PL_PAYMENT_H_PROCES_CENTR . ':</b> ' . ($categs_str != '' ? $categs_str : '<span style="color:red;">' . PL_PAYMENT_H_INFO_CENTR_WAS_DELETED_MSG . '</span>') . '</div>
          <div style="padding-bottom: 5px;"><b>' . PL_PAYMENT_H_ELEM_TEMP . ':</b> ' . ($res ? $res[0][0] . ' -&gt; ' . $res[0][1] : '<span style="color:red;">' . PL_PAYMENT_H_INFO_TEMP_WAS_DELETED_MSG . '</span>') . '</div>
          <div class="delim"></div>
          ' . (isset($params['p_success']) && $params['p_success'] != '' ? '<div style="padding-bottom: 5px;"><b>' . PL_PAYMENT_H_PAGE_SUCCESS . ':</b> ' . $params['p_success'] . '</div>' : '') . '
          ' . (isset($params['p_failed']) && $params['p_failed'] != '' ? '<div style="padding-bottom: 5px;"><b>' . PL_PAYMENT_H_PAGE_FAILED . ':</b> ' . $params['p_failed'] . '</div>' : '');
}

function fPayment_Set_List_Trans_Info($params)
{
    $in_str = implode(',', explode('^', $params['ids']));
    $in_str = '(0,' . $in_str . ')';

    $categs_str = '';
    $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_id IN ' . $in_str . ' ORDER BY cat_left');

    if ($res) {
        $categs_str = '';
        foreach ($res as $value) {
            $categs_str .= $value[0] . ', ';
        }
        $categs_str = substr($categs_str, 0, -2);
    }

    $res = sql_param_query('SELECT categs.cat_title, temps.spt_title FROM sb_categs categs, sb_catlinks links, sb_payments_temps temps WHERE temps.spt_id=?d
                            AND links.link_el_id=temps.spt_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident="pl_payment_temps"',
    $params['temp_id']);

    echo '<div style="padding-bottom: 5px;"><b>' . PL_PAYMENT_H_INFO_CATEGS . ':</b> ' . ($categs_str != '' ? $categs_str : '<span style="color:red;">' . PL_PAYMENT_H_INFO_CATEGS_WAS_DELETED_MSG . '</span>') . '</div>
            <div style="padding-bottom: 5px;"><b>' . PL_PAYMENT_H_ELEM_TEMP . ':</b> ' . ($res ? $res[0][0] . ' -&gt; ' . $res[0][1] : '<span style="color:red;">' . PL_PAYMENT_H_INFO_TEMP_WAS_DELETED_MSG . '</span>') . '</div>';
}


/***************************************** функции получения элементов модуля *******************************************/

function fPayment_Get_ListForm($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_payment/prog/pl_payment.php';\n
        fPayment_Form('$el_id', '$temp_id', '" . addslashes(serialize($params)) . "', '$tag_id');\n
        ?>";
}

function fPayment_Set_List_Trans($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_payment/prog/pl_payment.php';\n
        fPayment_List('$el_id', '$temp_id', '" . addslashes(serialize($params)) . "', '$tag_id');\n
        ?>";
}
