<?php

require_once (SB_CMS_LANG_PATH.'/pl_polls.h.lng.php');

if ($_SESSION ['sbPlugins']->register('pl_polls', PL_POLLS_H_PLUGIN_NAME, ''))
{
	$_SESSION ['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_POLLS_H_SUB_MENU.'>'.PL_POLLS_H_PLUGIN_NAME, 'init');
    $_SESSION['sbPlugins']->addToExportImport(true, false);

    $fields = array();
	$fields['spr_id'] = array('title' => PL_POOLS_H_SPR_ID);
	$fields['spr_option_id'] = array('title' => PL_POOLS_H_SPR_OPTION_ID);
	$fields['spr_date'] = array('title' => PL_POOLS_H_SPR_DATE);
	$fields['spr_ip'] = array('title' => PL_POOLS_H_SPR_IP);
	$fields['spr_text'] = array('title' => PL_POOLS_H_SPR_TEXT);


    $_SESSION['sbPlugins']->setExportImport('pl_polls_results', 1, false, PL_POLLS_H_RESULTS, 'sb_pools_results', $fields);
    
	if($_SESSION['sbPlugins']->isRightAvailable('pl_polls', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_POLLS_H_PLUGIN_NAME.'>'.PL_POLLS_H_ELEM_LIST, 'design_init', 'pl_polls_elem_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_POLLS_H_PLUGIN_NAME.'>'.PL_POLLS_H_ELEM_RESULT_LIST, 'design_result_init', 'pl_polls_result_elem_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_POLLS_H_PLUGIN_NAME.'>'.PL_POLLS_H_ELEM_CATEGS, 'design_categs', 'pl_polls_categs_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_POLLS_H_PLUGIN_NAME.'>'.PL_POLLS_H_ELEM_SEL_CAT, 'design_selcat', 'pl_polls_sel_cat_24.png');
	}

	$_SESSION['sbPlugins']->setMainEvent('init');

	$_SESSION['sbPlugins']->addUserEvent('init', 'fPolls_Init', 'read', PL_POLLS_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fPolls_Edit', 'read', PL_POLLS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fPolls_Edit_Submit', 'elems_edit', PL_POLLS_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fPolls_Delete', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements', 'fPolls_Delete_With_Elements', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('paste', 'fPolls_Paste', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fPolls_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');

	$_SESSION['sbPlugins']->addUserEvent('show_result', 'fPolls_Show_Result', 'elems_edit', PL_POLLS_H_SHOW_RESULT);
	$_SESSION['sbPlugins']->addUserEvent('edit_result', 'fPolls_Edit_Result', 'elems_edit', PL_POLLS_H_EDIT_RESULT);
	$_SESSION['sbPlugins']->addUserEvent('edit_result_submit', 'fPolls_Edit_Result_Submit', 'elems_edit', PL_POLLS_H_EDIT_RESULT);
	$_SESSION['sbPlugins']->addUserEvent('delete_result', 'fPolls_Delete_Result', 'elems_edit');

	$_SESSION['sbPlugins']->addUserEvent('stat', 'fPolls_Stat', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('stat_reload_graph', 'fPolls_Stat_Reload_Graph', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('set_active', 'fPolls_Set_Active', 'elems_public');

	$_SESSION['sbPlugins']->addUserEvent('design_init', 'fPolls_Design_Init', 'design_read', PL_POLLS_H_DESIGN_POLLS_LIST);
	$_SESSION['sbPlugins']->addUserEvent('design_edit', 'fPolls_Design_Edit', 'design_read', PL_POLLS_H_DESIGN_EDIT_POLLS_LIST);
	$_SESSION['sbPlugins']->addUserEvent('design_submit', 'fPolls_Design_Submit', 'design_edit', PL_POLLS_H_DESIGN_EDIT_POLLS_LIST);
	$_SESSION['sbPlugins']->addUserEvent('design_delete', 'fPolls_Design_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_result_init', 'fPolls_Design_Result_Init', 'design_read', PL_POLLS_H_DESIGN_POLLS_RESULTS);
	$_SESSION['sbPlugins']->addUserEvent('design_result_edit', 'fPolls_Design_Result_Edit', 'design_read', PL_POLLS_H_DESIGN_EDIT_POLLS_RESULTS);
	$_SESSION['sbPlugins']->addUserEvent('design_result_submit', 'fPolls_Design_Result_Submit', 'design_edit', PL_POLLS_H_DESIGN_EDIT_POLLS_RESULTS);
	$_SESSION['sbPlugins']->addUserEvent('design_result_delete', 'fPolls_Design_Result_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_categs', 'fPolls_Design_Categs', 'design_read', PL_POLLS_H_DESIGN_CATEGS_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_categs_edit', 'fPolls_Design_Categs_Edit', 'design_read', PL_POLLS_H_DESIGN_EDIT_CATEGS_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_categs_edit_submit', 'fPolls_Design_Categs_Edit_Submit', 'design_edit', PL_POLLS_H_DESIGN_EDIT_CATEGS_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_categs_delete', 'fPolls_Design_Categs_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_selcat', 'fPolls_Design_Selcat', 'design_read', PL_POLLS_H_DESIGN_SEL_CAT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_selcat_edit', 'fPolls_Design_Selcat_Edit', 'design_read', PL_POLLS_H_DESIGN_EDIT_SEL_CAT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_selcat_submit', 'fPolls_Design_Selcat_Edit_Submit', 'design_edit', PL_POLLS_H_DESIGN_EDIT_SEL_CAT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_selcat_delete', 'fPolls_Design_Selcat_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_polls_delim', PL_POLLS_H_PLUGIN_NAME, '', '', '', SB_COOKIE_DOMAIN, false);
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_polls_ip_count', PL_POLLS_H_SETTING_ONE_IP, 'number', '', '1', SB_COOKIE_DOMAIN, false);
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_polls_cookie_time', PL_POLLS_H_SETTING_COOKIE_TIME, 'number', '', '365', SB_COOKIE_DOMAIN, false);

	$_SESSION['sbPlugins']->addToWorkflow();

	$fields = array();
	$fields['sp_id'] = array('title' => PL_POLLS_H_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['sp_url'] = array('title' => PL_POLLS_H_URL_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_SP_URL}');
	$fields['sp_question'] = array('title' => PL_POLLS_H_QUESTION_LABEL, 'flags' => '5', 'link_title' => '1', 'tag' => '{OPT_STD_SP_QUESTION}');
	$fields['sp_active'] = array('title' => PL_POLLS_H_ACTIVE_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['sp_sort'] = array('title' => PL_POLLS_H_SORT_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['sp_pub_start'] = array('title' => PL_POLLS_H_PUB_START_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
	$fields['sp_pub_end'] = array('title' => PL_POLLS_H_PUB_END_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
	$fields['sp_ext_id'] = array('title' => PL_POLLS_H_EXT_ID, 'flags' => '8', 'link_title' => '0', 'tag' => '');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_polls', 'sp_id', 'sp_question', $fields);
}

$_SESSION['sbPlugins']->addToRubrikator('pl_polls', PL_POLLS_H_PLUGIN_NAME, 'polls', 'pl_polls_design_categs', 'pl_polls_design_sel_cat');
$_SESSION['sbPlugins']->addToConstructor('sb_polls', true);

$_SESSION['sbPlugins']->addSystemEvent('elems_list', 'fPolls_Get_Elem_List', PL_POLLS_H_ELEM_LIST);
$_SESSION['sbPlugins']->addSystemEvent('elems_results', 'fPolls_Get_Elem_Results', PL_POLLS_H_ELEM_RESULT_LIST);
$_SESSION['sbPlugins']->addSystemEvent('elem_categs', 'fPolls_Get_Elem_Categs', PL_POLLS_H_ELEM_CATEGS);
$_SESSION['sbPlugins']->addSystemEvent('elem_selcat', 'fPolls_Get_Elem_Sel_Cat', PL_POLLS_H_ELEM_SEL_CAT);

$_SESSION['sbPlugins']->addElem(PL_POLLS_H_ELEM_LIST, 'list', 'fPolls_Elem_List', 'fPolls_Elem_List_Info', 'elems_list', 800, 700, 'design_edit', 'pl_polls_design_list');
$_SESSION['sbPlugins']->addElem(PL_POLLS_H_ELEM_RESULT_LIST, 'results', 'fPolls_Elem_Results', 'fPolls_Elem_Results_Info', 'elems_results', 800, 700, 'design_result_edit', 'pl_polls_design_result');
$_SESSION['sbPlugins']->addElem(PL_POLLS_H_ELEM_CATEGS, 'categs', 'fPolls_Elem_Categs', 'fPolls_Elem_Categs_Info', 'elem_categs', 800, 700, 'design_categs_edit', 'pl_polls_design_categs');
$_SESSION['sbPlugins']->addElem(PL_POLLS_H_ELEM_SEL_CAT, 'selcat', 'fPolls_Elem_Sel_Cat', 'fPolls_Elem_Sel_Cat_Info', 'elem_selcat', 800, 350, 'design_selcat_edit', 'pl_polls_design_selcat');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);

?>