<?php
@require_once(SB_CMS_LANG_PATH.'/pl_robots.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_robots', PL_ROBOTS_H_PLUGIN_NAME, ''))
{
	require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();
    
	if (!$_SESSION['sbAuth']->isAdmin())
	{
		$res = sql_param_query('SELECT u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
		if ($res)
		{
		    $u_domains = explode(',', $res[0][0]);
		    $i = 0;
			foreach ($GLOBALS['sb_domains'] as $domain => $tmp)
		    {
		    	if (in_array($domain, $u_domains))
		    	{
		    		$_SESSION['sbPlugins']->addUserEvent('init_'.$i, 'fRobots_Init', 'file_read', PL_ROBOTS_H_INIT);
		    		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_ROBOTS_H_DOMAINS_SETTINGS.'>'.PL_ROBOTS_H_SETTING.' '.$idn->decode($domain).' > '.PL_ROBOTS_H_MENU_NAME, 'init_'.($i++).'&domain='.$domain);
		    	}
		    }
		}
	}
	else
	{
		$i = 0;
		foreach ($GLOBALS['sb_domains'] as $domain => $tmp)
	    {
	    	$_SESSION['sbPlugins']->addUserEvent('init_'.$i, 'fRobots_Init', 'file_read', PL_ROBOTS_H_INIT);
	    	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_ROBOTS_H_DOMAINS_SETTINGS.'>'.PL_ROBOTS_H_SETTING.' '.$idn->decode($domain).' > '.PL_ROBOTS_H_MENU_NAME, 'init_'.($i++).'&domain='.$domain);
	    }
	}
	
	$_SESSION['sbPlugins']->addUserEvent('submit', 'fRobots_Edit_Submit', 'file_edit', PL_ROBOTS_H_INIT);
	
	$_SESSION['sbPlugins']->addEventsRights('file_read', PL_ROBOTS_H_READ_RIGHTS);   
	$_SESSION['sbPlugins']->addEventsRights('file_edit', PL_ROBOTS_H_EDIT_RIGHTS);   
}

?>