<?php

function fSearch_Init()
{
	echo '<script>
    function sbEditDomain(ss_id)
    {
		var strPage = sb_cms_modal_dialog_file + "?event=pl_search_edit&id="+ss_id;
        var strAttr = "resizable=1,width=850,height=700";
        sbShowModalDialog(strPage, strAttr, afterEditDomain);
    }

    function afterEditDomain()
    {
    	var return_v = sbModalDialog.returnValue;
        if (return_v)
        {
			sbGetE("domain_"+return_v.id).innerHTML = return_v.domain;
        }
    }

    function sbAddDomain()
    {
        var strPage = sb_cms_modal_dialog_file + "?event=pl_search_edit";
        var strAttr = "resizable=1,width=850,height=700";
        sbShowModalDialog(strPage, strAttr, afterAddDomain);
    }

    function afterAddDomain()
    {
        if (sbModalDialog.returnValue)
        {
            window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_init";
		}
    }

    function sbDeleteDomains(ss_id)
    {
        if(confirm("'.PL_SEARCH_DELETE_CONFIRM_DELETE.'"))
	    {
			var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_search_delete&id="+ss_id);
			if (res == "")
	        {
	        	window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_init";
			}
			else
			{
				alert("'.PL_SEARCH_DELETE_NO_DELETED_ERR_MSG.'");

            }
	    }
	}

	function sbClearIndexingBase()
	{
		if(confirm("'.PL_SEARCH_INIT_CONFIRM_CLEAR_INDEXING_BASE.'"))
		{
			var res = sbLoadSync(sb_cms_empty_file+"?event=pl_search_clear_indexing_log");
			if(res == "")
			{
				window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_init";
			}
			else
			{
				alert("'.PL_SEARCH_INIT_NOT_CLEAR_INDEXING_BASE.'");
			}
		}
	}
	</script>
	<br /><br />';

	$res = sql_query('SELECT ss_id, ss_date, ss_domains FROM sb_search');
	if($res)
	{
		$html = '<table id="domains_table" style="width:100%;" cellpadding="5" cellspacing="0" class="form">
					<tr>
						<th class="header" style="width:33%;">'.PL_SEARCH_INIT_SEARCH_DOMAIN.'</th>
						<th class="header" style="width:33%;">'.PL_SEARCH_INIT_INDEXING_TIME.'</th>
						<th class="header" style="width:33%;">'.PL_SEARCH_INIT_COUNT_INDEXING_PAGES.'</th>
						<th class="header" style="width:1px;">&nbsp;</th>
					</tr>';

		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
		$layout = new sbLayout();

		require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

		// общее число проиндексированных страниц
	    $all_count_pages = 0;
	    $r = 0;
		foreach($res as $value)
		{
			list($ss_id, $ss_date, $ss_domains) = $value;

			$ss_domains = explode(',', $ss_domains);
			foreach ($ss_domains as $k => $v)
			{
				$ss_domains[$k] = $idn->decode($v);
			}
			$ss_domains = implode(', ', $ss_domains);

			// дата последней индексации
			$ss_date = is_null($ss_date) ? '-' : sb_date('d.m.Y '.KERNEL_IN.' H:i:s', $ss_date);
			// кол-во проиндексированных страниц
			$count = 0;

			$count_res = sql_query('SELECT COUNT(*) FROM sb_search_pages_'.intval($ss_id));
			if($count_res)
			{
				list($count) = $count_res[0];
				$all_count_pages += $count;
			}

			$class = ($r % 2 == 0 ? 'odd' : 'even');
			$r++;

			$html .= '<tr class="'.$class.'">
				<td align="center" id="domain_'.$ss_id.'">'.$ss_domains.'</td>
				<td align="center">'.$ss_date.'</td>
				<td align="center">'.$count.'</td>
				<td align="right"><nobr>
					'.($count > 0 ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_search_indexing_log&id='.$ss_id.'"><img src="'.SB_CMS_IMG_URL.'/files.png" alt="'.PL_SEARCH_INIT_INDEXING_LOG_LINK.'" title="'.PL_SEARCH_INIT_INDEXING_LOG_LINK.'" border="0"></a>
					&nbsp;' : '').'
					<img height="20" width="20" style="cursor: pointer;" onClick = "sbEditDomain('.$ss_id.');" title="'.KERNEL_EDIT.'" src="'.SB_CMS_IMG_URL.'/btn_props.png"/>
					'.($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'delete') ? '&nbsp;
					<img height="20" width="20" style="cursor: pointer;" onClick = "sbDeleteDomains('.$ss_id.');" title="'.KERNEL_DELETE.'" src="'.SB_CMS_IMG_URL.'/btn_delete.png"/>' : '').'&nbsp;
                    <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_search_history_show&id='.$ss_id.'"><img height="20" width="20" style="cursor: pointer;" title="'.PL_SEARCH_HISTORY.'" src="'.SB_CMS_IMG_URL.'/plugins/pl_polls_32.png"/></a>
				</nobr></td>
			</tr>';
		}

		$html .= '</table>';

		// общее число проиндексированных слов
		$all_count_words = 0;
		$count_res = sql_query('SELECT COUNT(*) FROM sb_search_words');
		if ($count_res)
		{
			list($all_count_words) = $count_res[0];
		}

		$layout->addField('', new sbLayoutHTML('<div class="hint_div">
													'.PL_SEARCH_INIT_COUNT_ALL_INDEXING_PAGES.': <span id="all_count_pages"><b>'.$all_count_pages.'</b></span><br />
													'.PL_SEARCH_INIT_COUNT_ALL_INDEXING_WORDS.': <span id="all_words_count"><b>'.$all_count_words.'</b></span>
													'.($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'delete') ? '<br /><br />[ <a href="#" onclick="sbClearIndexingBase();">'.PL_SEARCH_INIT_CLEAR_INDEXING_BASE.'</a> ]' : '').'
												</div><br />'.$html, true));
		$layout->addButton('button', KERNEL_ADD, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'elems_edit') ? '' : 'disabled="disabled"').' onClick="sbAddDomain();"' );
		$layout->show();
	}
	else
	{
		sb_show_message(PL_SEARCH_INIT_NO_SET_INDEXING_DOMAINS.($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'elems_edit') ? '<br /><br /><a href="#" onClick="sbAddDomain();">'.PL_SEARCH_INIT_ADD_INDEXING_DOMAIN.'</a>' : ''), true);
	}
}

function fSearch_Edit()
{
	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$result = sql_param_query('SELECT ss_domains, ss_settings FROM sb_search WHERE ss_id=?d', $_GET['id']);
        if($result)
        {
            list($ss_domains, $ss_settings) = $result[0];

            $ss_settings = unserialize($ss_settings);
            $ss_domains = explode(',', $ss_domains);
        }
		else
		{
			sb_show_message(PL_SEARCH_EDIT_ERROR, true, 'warning');
			return;
        }
    }
    elseif (count($_POST) > 0)
    {
		$ss_domains = array();
		extract($_POST);

		if(!isset($_GET['id']))
			$_GET['id'] = '';
	}
	else
	{
		$ss_settings = array();
		$ss_settings['extentions_files'] = PL_SERACH_EDIT_DEFAULT_EXTANTIONS_FILES;
		$ss_settings['dirs_not_allow'] = PL_SEARCH_EDIT_DEFAULT_DIRS_NOT_ALLLOW;
		$ss_settings['files_not_allow'] = PL_SEARCH_EDIT_DEFAULT_FILES_NOT_ALLLOW;
		$ss_settings['meta_tags'] = 1;
		$ss_settings['full_index'] = 1;
		$ss_settings['words_no_indexing'] = PL_SEARCH_DESIGN_EDIT_NO_INDEXING;
		$ss_settings['impermissible_words'] = 'bid mess_hash c_hash';
		$ss_settings['min_length_word'] = '3';
		$ss_settings['max_levels'] = '30';
		$ss_settings['characters_allow'] = '';
		$ss_settings['port'] = 80;
        $ss_settings['allow_closed_pages'] = 0;
		$ss_domains = array(str_replace('http://', '', SB_DOMAIN));

		$_GET['id'] = '';
	}

	foreach ($ss_domains as $key => $value)
	{
		$ss_domains[$key] = trim($value);
	}

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
    echo '<script>
    function setPage(el)
    {
    	if(el.value.substr(0, 7).toLowerCase() == "http://" || el.value.substr(0, 8).toLowerCase() == "https://")
    	{
    		el.value = el.value.replace("http://", "");
    		el.value = el.value.replace("https://", "");

    		var pos = el.value.indexOf("/");
    		if (pos != -1)
    		{
    			el.value = el.value.substr(pos + 1);
    		}
    	}
    }
    </script><br /><br />';

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_search_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', '');
	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '230';

	$layout->addHeader(PL_SEARCH_EDIT_EDIT_DOMAIN);

	require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();

	$html = '';
	$i = 0;
	foreach($GLOBALS['sb_domains'] as $key => $value)
	{
		$basedir = sb_str_replace(SB_BASEDIR, '', $value['basedir']);
		$robots = $GLOBALS['sbVfs']->file_get_contents($basedir . '/robots.txt');

		if ($robots != '')
		{
	        if(!isset($_GET['id']) || $_GET['id'] == '')
	        {
                $matches = array();
                preg_match_all('/Disallow:\s+(\S*)\s+/si' . SB_PREG_MOD, $robots, $matches);

                if (isset($matches[1]) && is_array($matches[1]))
                {
                    $matches[1] = array_map('fSearch_Trim', $matches[1]);
                    foreach($matches[1] as $key1=>$val)
                    {
                        if(preg_match('/[\*\$]/', $val))
                        {
                            unset($matches[1][$key1]);
                        }
                    }
                    $default = explode(' ', $ss_settings['dirs_not_allow']);
                    $diff = array_diff($matches[1], $default);
                    if(!empty($diff))
                    {
                        $ss_settings['dirs_not_allow'] .= ' ' . implode(' ', $diff);
                    }
                }
	        }

	        $matches = array();
	        preg_match('/Host:\s*(\S+)\s*/i' . SB_PREG_MOD, $robots, $matches);

	        if (isset($matches[1]))
	        {
	        	if (preg_match('/^www\./i', $matches[1]))
	        	{
	        		$key = 'www.'.$key;
	        	}
	        }
        }

		if(in_array($key, $ss_domains))
			$checked = 'checked="checked"';
		else
			$checked = '';

		$fld = new sbLayoutInput('checkbox', $key, 'ss_domains[]', 'ss_domains_'.$i, $checked);
		$html .= $fld->getField().' <label for="ss_domains_'.$i.'">'.$idn->decode($key).'</label><br />';
		$i++;
	}

	$layout->addField(PL_SEARCH_INIT_SEARCH_DOMAIN, new sbLayoutHTML($html, false));

	$options = array();
	$options['http'] = 'http';
	$options['https'] = 'https';
	$options['ftp'] = 'ftp';

	$fld = new sbLayoutSelect($options, 'ss_settings[scheme]');
	$fld->mSelOptions = array(isset($ss_settings['scheme']) ? $ss_settings['scheme'] : '');
	$layout->addField(PL_SEARCH_EDIT_PROTOCOL, $fld);

	$layout->addField(PL_SEARCH_EDIT_PORT, new sbLayoutInput('text', isset($ss_settings['port']) ? $ss_settings['port'] : 0, 'ss_settings[port]', 'spin_ss_settings[port]', 'style="width:80px;"'));
	$layout->addField(PL_SEARCH_EDIT_START_INDEXING_PAGE, new sbLayoutPage(isset($ss_settings['indexing_start_page']) ? $ss_settings['indexing_start_page'] : '/index.php', 'ss_settings[indexing_start_page]', '', 'style="width:440px;" onchange="setPage(this)"'));

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_SEARCH_EDIT_META_INDEXING, new sbLayoutInput('checkbox', '1', 'ss_settings[meta_tags]', '', (isset($ss_settings['meta_tags']) && $ss_settings['meta_tags'] == 1 ? 'checked="checked"' : '')));
    $layout->addField(PL_SEARCH_EDIT_CLOSED_PAGES_INDEXING, new sbLayoutInput('checkbox', '1', 'ss_settings[allow_closed_pages]', '', (isset($ss_settings['allow_closed_pages']) && $ss_settings['allow_closed_pages'] == 1 ? 'checked="checked"' : '')));
	$layout->addField(PL_SEARCH_EDIT_FULL_INDEX, new sbLayoutInput('checkbox', '1', 'ss_settings[full_index]', '', (isset($ss_settings['full_index']) && $ss_settings['full_index'] == 1 ? 'checked="checked"' : '')));

	$layout->addField('', new sbLayoutHTML('<div class="hint_div">'.PL_SEARCH_EDIT_FULL_INDEX_DESCR.'</div>'));
	$layout->addField(PL_SEARCH_EDIT_IMPERMISSIBLE_WORDS, new sbLayoutInput('text', $ss_settings['impermissible_words'], 'ss_settings[impermissible_words]', '', 'style="width:100%;"'));
	$layout->addField(PL_SEARCH_EDIT_WORDS_LIST_NO_INDEXING, new sbLayoutTextarea($ss_settings['words_no_indexing'], 'ss_settings[words_no_indexing]', '', 'style="width:100%;height:100px;"'));
	$layout->addField(PL_SEARCH_EDIT_EXT_FILES_INDEXING, new sbLayoutInput('text', $ss_settings['extentions_files'], 'ss_settings[extentions_files]', '', 'style="width:100%;"'));


    if(!empty($ss_settings['dirs_not_allow']))
    {
        $ss_settings['dirs_not_allow'] = sb_str_replace(' ', "\r\n", $ss_settings['dirs_not_allow']);
    }

    $layout->addField(PL_SEARCH_EDIT_DIRS_NOT_ALLOW_INDEXING, new sbLayoutTextarea($ss_settings['dirs_not_allow'], 'ss_settings[dirs_not_allow]', '', 'style="width:100%;"'));
    //$layout->addField(PL_SEARCH_EDIT_DIRS_NOT_ALLOW_INDEXING, new sbLayoutInput('text', $ss_settings['dirs_not_allow'], 'ss_settings[dirs_not_allow]', '', 'style="width:100%;"'));
	//$layout->addField(PL_SEARCH_EDIT_FILES_NOT_ALLOW_INDEXING, new sbLayoutInput('text', $ss_settings['files_not_allow'], 'ss_settings[files_not_allow]', '', 'style="width:100%;"'));
	$layout->addField(PL_SEARCH_EDIT_MIN_LENGTH_WORD, new sbLayoutInput('text', $ss_settings['min_length_word'], 'ss_settings[min_length_word]', 'spin_min_length_word', 'style="width:80px;"'));

	$fld = new sbLayoutInput('text', $ss_settings['characters_allow'], 'ss_settings[characters_allow]', '', 'style="width:100%;"');
	$fld->mHTML = '<div class="hint_div">'.PL_SEARCH_EDIT_CHARACTERS_ALLOW_HINT_DIV.'</div>';
	$layout->addField(PL_SEARCH_EDIT_CHARACTERS_ALLOW, $fld);
	$layout->addField(PL_SEARCH_EDIT_INDEX_LEVEL, new sbLayoutInput('text', $ss_settings['max_levels'], 'ss_settings[max_levels]', 'spin_max_levels', 'style="width:80px;"'));

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'elems_edit') ? '' : 'disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

	echo $layout->show(false).'<br /><br />';
}

function fSearch_Submit()
{
	if (!isset($_GET['id']))
		$_GET['id'] = '';

	$ss_settings = array();
	extract($_POST);

	if(!isset($ss_settings['full_index']))
		$ss_settings['full_index'] = 0;

	if(!isset($ss_settings['meta_tags']))
		$ss_settings['meta_tags'] = 0;

	if(!isset($ss_settings['port']) || $ss_settings['port'] == '0')
		$ss_settings['port'] = 80;

	if(!isset($ss_domains) || count($ss_domains) == 0)
	{
		sb_show_message(PL_SEARCH_SUBMIT_NO_DOMAIN, false, 'warning');
		fSearch_Edit();
		return;
	}

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$ss_domains = implode(',', $ss_domains);

	$row = array();
	$row['ss_domains'] = $ss_domains;
	$row['ss_settings'] = serialize($ss_settings);

    if ($_GET['id'] != '')
    {
        $res = sql_param_query('SELECT ss_domains FROM sb_search WHERE ss_id=?d', $_GET['id']);
        if ($res)
        {
			// редактирование
			list($old_domain) = $res[0];

			sql_param_query('UPDATE sb_search SET ?a WHERE ss_id=?d', $row, $_GET['id'], sprintf(PL_SEARCH_SUBMIT_EDIT_OK, $old_domain));

            echo '<script>
                    var res = new Object();
                    res.id = "'.$_GET['id'].'";
                    res.domain = "'.str_replace(',', ', ', $ss_domains).'";
					sbReturnValue(res);
				</script>';

    	    if ($old_domain != $ss_domains)
    	    {
				foreach ($_SESSION['sbPlugins']->mCron['pl_search'] as $key => $value)
				{
					if ($value['task_func'] == 'fSearch_Cron_Refresh('.intval($_GET['id']).')')
					{
						$_SESSION['sbPlugins']->mCron['pl_search'][$key]['task_name'] = sprintf(PL_SEARCH_SUBMIT_CRON_TITLE, $ss_domains);
						break;
    	    		}
    	    	}
    	    }
		}
		else
		{
			sb_show_message(PL_SEARCH_SUBMIT_EDIT_ERROR, false, 'warning');
			sb_add_system_message(sprintf(PL_SEARCH_SUBMIT_EDIT_SYSTEMLOG_ERROR, $ss_domains), SB_MSG_WARNING);

			fSearch_Edit();
			return;
		}
	}
	else
	{
		$error = true;

		sql_param_query('INSERT INTO sb_search SET ?a', $row);
		$id = sql_insert_id();

		if($id)
		{
			$sql = 'CREATE TABLE IF NOT EXISTS `sb_search_pages_'.$id.'` (
				`sp_url` varchar(255) character set '.SB_DB_CHARSET.' NOT NULL COMMENT  "'.PL_SEARCH_SUBMIT_BD_COMMENT_RELATIVE_PATH.'",
				`sp_title` varchar( 255 ) character set '.SB_DB_CHARSET.' NULL COMMENT  "'.PL_SEARCH_SUBMIT_BD_COMMENT_TITLE.'",
				`sp_text` mediumblob NULL COMMENT  "'.PL_SEARCH_SUBMIT_BD_COMMENT_ZIP_TEXT.'",
				`sp_last_modified` int(11) unsigned NULL COMMENT "'.PL_SEARCH_SUBMIT_BD_COMMENT_LAST_MODIFIED.'",
				`sp_flags` tinyint(1) unsigned NOT NULL COMMENT "'.PL_SEARCH_SUBMIT_BD_COMMENT_FLAGS.'",
				`sp_words_ids` text character set '.SB_DB_CHARSET.' NULL COMMENT "'.PL_SEARCH_SUBMIT_BD_COMMENT_WORDS_IDS.'",
				 PRIMARY KEY (`sp_url`),
				 KEY `sp_flags` (`sp_flags`),
				 FULLTEXT KEY `sp_words_ids` (`sp_words_ids`)
				) ENGINE = MYISAM DEFAULT CHARSET='.SB_DB_CHARSET;

			if(!sql_query($sql))
			{
				sql_param_query('DELETE FROM sb_search WHERE ss_id=?d', $id);

				sb_show_message(sprintf(PL_SEARCH_SUBMIT_ADD_ERROR, $ss_domains), false, 'warning');
				sb_add_system_message(sprintf(PL_SEARCH_SUBMIT_ADD_SYSTEMLOG_ERROR, $ss_domains), SB_MSG_WARNING);

				fSearch_Edit();
				return;
			}

			sb_add_system_message(sprintf(PL_SEARCH_SUBMIT_ADD_OK, $ss_domains));
			echo '<script>
					var res = new Object();
                    res.id = "'.$id.'";
                    res.domain = "'.str_replace(',', ', ', $ss_domains).'";
                    sbReturnValue(res);
                </script>';

			$count = 0;
			if (!isset($_SESSION['sbPlugins']->mCron['pl_search']))
        	{
				$_SESSION['sbPlugins']->mCron['pl_search'] = array();
			}
			else
			{
				$count = count($_SESSION['sbPlugins']->mCron['pl_search']);
			}

			$_SESSION['sbPlugins']->mCron['pl_search'][$count] = array();
			$_SESSION['sbPlugins']->mCron['pl_search'][$count]['task_path'] = 'pl_search/cron/pl_search.php';
        	$_SESSION['sbPlugins']->mCron['pl_search'][$count]['task_func'] = 'fSearch_Cron_Refresh('.$id.')';
    	    $_SESSION['sbPlugins']->mCron['pl_search'][$count]['task_name'] = sprintf(PL_SEARCH_SUBMIT_CRON_TITLE, $ss_domains);
	        $_SESSION['sbPlugins']->mCron['pl_search'][$count]['task_descr'] = PL_SEARCH_SUBMIT_CRON_DESCRIPTION;

			$error = false;
        }

		if ($error)
		{
			sb_show_message(sprintf(PL_SEARCH_SUBMIT_ADD_ERROR, $ss_domains), false, 'warning');
			sb_add_system_message(sprintf(PL_SEARCH_SUBMIT_ADD_SYSTEMLOG_ERROR, $ss_domains), SB_MSG_WARNING);

			fSearch_Edit();
			return;
        }
    }
}

function fSearch_Delete()
{
	$id = intval($_GET['id']);
	$res = sql_param_query('SELECT ss_domains FROM sb_search WHERE ss_id = ?d', $id);

	if(!$res)
	{
		echo 'FALSE';
		return;
	}

	list($ss_domains) = $res[0];

	$count = -1;
	if(isset($_SESSION['sbPlugins']->mCron['pl_search']) && count($_SESSION['sbPlugins']->mCron['pl_search']) > 0)
	{
		foreach ($_SESSION['sbPlugins']->mCron['pl_search'] as $key => $value)
		{
			if ($value['task_func'] == 'fSearch_Cron_Refresh('.$id.')')
			{
				$count = $key;
				break;
			}
		}
	}

	if ($count == 0 && count($_SESSION['sbPlugins']->mCron['pl_search']) == 1)
    {
    	$_SESSION['sbPlugins']->mCron['pl_search'] = array();
    }
    elseif ($count >= 0)
    {
		$tmp = array();
		$j = 0;
    	for ($i = 0; $i < count($_SESSION['sbPlugins']->mCron['pl_search']); $i++)
    	{
			if ($i == $count)
				continue;

    		$tmp[$j] = array();
    		$tmp[$j]['task_path'] = $_SESSION['sbPlugins']->mCron['pl_search'][$i]['task_path'];
		    $tmp[$j]['task_func'] = $_SESSION['sbPlugins']->mCron['pl_search'][$i]['task_func'];
		    $tmp[$j]['task_name'] = $_SESSION['sbPlugins']->mCron['pl_search'][$i]['task_name'];
		    $tmp[$j]['task_descr'] = $_SESSION['sbPlugins']->mCron['pl_search'][$i]['task_descr'];
		    $j++;
		}
		$_SESSION['sbPlugins']->mCron['pl_search'] = $tmp;
    }

	if(count($_SESSION['sbPlugins']->mCron['pl_search']) == 0)
	{
		unset($_SESSION['sbPlugins']->mCron['pl_search']);
	}

	sql_param_query('DELETE FROM sb_search WHERE ss_id = ?d ', $id, sprintf(PL_SEARCH_DELETE_DELETED_MSG, $ss_domains));
	sql_query('DELETE FROM sb_cron WHERE sc_plugin_ident="pl_search" AND sc_func_name="fSearch_Cron_Refresh('.$id.')"');
	sql_query('DROP TABLE sb_search_pages_'.$id);
}

function fSearch_Clear_Indexing_Log()
{
	$error = false;
	if(isset($_GET['search_base_id']))
	{
		$res = sql_param_query('SELECT ss_domains FROM sb_search WHERE ss_id=?d', $_GET['search_base_id']);
		if (!$res)
		{
			$error = true;
		}
		else
		{
			list($ss_domains) = $res[0];

			$res = sql_param_query('DELETE FROM sb_search_pages_'.intval($_GET['search_base_id']).' WHERE sp_url=?', urldecode($_GET['url']), sprintf(PL_SEARCH_INDEXING_LOG_PAGE_DELETED, urldecode($_GET['url']), $ss_domains));
			if(!$res)
			{
				$error = true;
			}
		}

		if($error)
		{
			sb_add_system_message(sprintf(PL_SEARCH_INDEXING_LOG_ERROR_PAGE_DELETED, urldecode($_GET['url']), $ss_domains), SB_MSG_ERROR);
			echo 'ERROR';
			return;
		}
	}
	elseif(isset($_GET['pages']) && $_GET['pages'] > 0)
	{
		$res = sql_param_query('SELECT ss_domains FROM sb_search WHERE ss_id=?d', $_GET['pages']);
		if (!$res)
		{
			$error = true;
		}
		else
		{
			list($ss_domains) = $res[0];

			$res = sql_query('TRUNCATE TABLE sb_search_pages_'.intval($_GET['pages']), sprintf(PL_SEARCH_INDEXING_LOG_DOMAIN_DELETED, $ss_domains));
			if(!$res)
			{
				$error = true;
			}
		}

		if($error)
		{
			sb_add_system_message(sprintf(PL_SEARCH_INDEXING_LOG_ERROR_DOMAIN_DELETED, $ss_domains), SB_MSG_ERROR);
			echo 'ERROR';
			return;
		}
	}
	else
	{
		$res = sql_query('SELECT ss_id FROM sb_search');
		if($res)
		{
			foreach($res as $value)
			{
				list($id) = $value;

				$res2 = sql_query('TRUNCATE TABLE sb_search_pages_'.intval($id));
				if(!$res2)
				{
					$error = true;
				}
			}
		}

		if ($error)
		{
			sb_add_system_message(PL_SEARCH_INDEXING_LOG_ERROR_BASE_DELETED, SB_MSG_ERROR);
			echo 'ERROR';
			return;
		}

		$res = sql_query('TRUNCATE TABLE sb_search_words');
		if(!$res)
		{
			$error = true;
		}

		if (!$error)
		{
			sb_add_system_message(PL_SEARCH_INDEXING_LOG_BASE_DELETED);
		}
		else
		{
			sb_add_system_message(PL_SEARCH_INDEXING_LOG_ERROR_BASE_DELETED_WORDS, SB_MSG_ERROR);
			echo 'ERROR';
			return;
		}
	}
}

function fSearch_Indexing_Log()
{
	$id = intval($_GET['id']);

	echo '
		<style type="text/css">
	    	#event_content table.form tr.even:hover,
			#event_content table.form tr.odd:hover
			{
			    background-color: #E1FFE1;
			}

			#event_content
			{
				overflow-x: auto;
			}
		</style>
	    <script>
		    document.body.onselectstart = "";
		    document.body.setAttribute("unselectable", "off");

			function sbDeleteFromLog(id, url, search_id)
		    {
		    	if (confirm("'.PL_SEARCH_INIT_CONFIRM_DELETE_PAGE.'"))
		    	{
					var res = sbLoadSync(sb_cms_empty_file+"?event=pl_search_clear_indexing_log&search_base_id="+search_id+"&url="+url);
					if(res == "")
					{
						var from = sbGetE("log_table").getAttribute("from");
		                window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_indexing_log&id='.$id.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'" + "&page_elems=" + from;
					}
					else
					{
						alert("'.PL_SEARCH_INDEXING_LOG_NOT_DELETE_PAGE.'");
					}
				}
			}

		    function showFilter()
		    {
		        var filter = sbGetE("sb_filter");
		        var filter_arr = sbGetE("filter_arrow");

		        if (!filter) return;
		        if (filter.style.display == "none")
		        {
		            filter.style.display = "";
		            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
		        }
		        else
		        {
		            filter.style.display = "none";
					filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
		        }
			}

		    function setFilter()
		    {
				var str = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_indexing_log&id='.$id.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
				var found = false;
				var frm = sbGetE("filter_form");

		        for (var i = 0; i < frm.elements.length; i++)
		        {
		            var el = frm.elements[i];
		            if (el.type == "select-one")
		            {
		                if (el.value != -1)
		                {
		                    str += "&"+el.name+"="+el.value;
		                    found = true;
		                }
		            }
		            else
		            {
		                if (el.name != "" && el.value != "")
		                {
		                    str += "&"+el.name+"="+el.value;
		                    found = true;
		                }
		            }
		        }

		        if (!found)
		        {
		            return false;
		        }

				window.location.href = str;
				return false;
		    }

			function sbClearPages()
			{
				if (confirm("'.PL_SEARCH_INIT_CONFIRM_CLEAR_PAGES.'"))
				{
					var res = sbLoadSync(sb_cms_empty_file+"?event=pl_search_clear_indexing_log&pages='.$id.'");
					if(res == "")
					{
						window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_init";
					}
					else
					{
		        		alert("'.PL_SEARCH_INIT_NOT_CLEAR_PAGES.'");
					}
				}
			}

			function removeFilter(e)
		    {
		        window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_indexing_log&id='.$id.(isset($_GET['order']) ? '&order='.$_GET['order'] : '').'";
		        return sbCancelEvent(e);
		    }
	</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	if (!isset($_GET['order']))
    {
        $_GET['order'] = 'sp_last_modified|desc';
	}
	else
    {
		$_GET['order'] = preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']);
		if (empty($_GET['order']))
		{
			$_GET['order'] = 'sp_last_modified|desc';
		}
    }

	$order_str = '';
    $order = explode('|', $_GET['order']);
    if (count($order) == 2)
    {
    	list($field, $ord) = $order;
    	$order_str = ' ORDER BY ';

		if($field == 'sp_words_ids')
			$order_str .= 'LENGTH(sp_words_ids) '.strtoupper($ord);
		else
			$order_str .= $field.' '.strtoupper($ord);

		if($field == 'sp_flags')
		{
			$order_str .= ', LENGTH(sp_words_ids) '.strtoupper($ord);
		}

		$order_str .= ', sp_url DESC';
	}

	$filter_str = '';
	if (isset($_GET['l_date_from']) && !empty($_GET['l_date_from']))
    {
		$_GET['l_date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_from']);

        $date_time = explode(' ', $_GET['l_date_from']);
        if (count($date_time) > 0)
        {
			$filter_str .= ' AND sp_last_modified >= '.sb_datetoint($_GET['l_date_from']);
        }
    }

    if (isset($_GET['l_date_to']) && !empty($_GET['l_date_to']))
    {
        $_GET['l_date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['l_date_to']);
        $date_time = explode(' ', $_GET['l_date_to']);
        if (count($date_time) > 0)
        {
            $filter_str .= ' AND sp_last_modified <= '.sb_datetoint($_GET['l_date_to']);
        }
    }

    if (isset($_GET['l_page_title']) && !empty($_GET['l_page_title']))
    {
		$filter_str .= ' AND sp_title LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['l_page_title']).'%');
    }

    if (isset($_GET['l_url']) && !empty($_GET['l_url']))
    {
		$filter_str .= ' AND sp_url LIKE '.$GLOBALS['sbSql']->escape('%'.trim($_GET['l_url']).'%');
    }

	if (isset($_GET['l_flags']) && !empty($_GET['l_flags']) && ($_GET['l_flags'] == 1 || $_GET['l_flags'] == 2))
    {
		$filter_str .= ' AND sp_flags = '.($_GET['l_flags'] == 2 ? '0' : '1');
    }
	elseif(isset($_GET['l_flags']) && !empty($_GET['l_flags']) && $_GET['l_flags'] == 3)
    {
		$filter_str .= ' AND sp_flags = 1 AND (sp_words_ids = "" OR sp_words_ids IS NULL)';
    }

	$href = SB_CMS_CONTENT_FILE.'?event=pl_search_indexing_log';
	foreach ($_GET as $key => $value)
    {
		if ($key != 'event')
        {
			if (!is_array($value))
            {
                if ($key != 'order')
                {
					$href .= '&'.$key.'='.urlencode($value);
                }
            }
            else
            {
                foreach ($value as $value2)
                {
					if ($key != 'order')
					{
						$href .= '&'.$key.'[]'.'='.urlencode($value2);
					}
				}
			}
		}
	}

//  строим фильтр
    echo '<table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
        	<table cellpadding="0" cellspacing="0">
        	<tr>
            	<td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">'.KERNEL_FILTER.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/'.($filter_str != '' ? 'fil_arrow_up' : 'fil_arrow_down').'.gif" id="filter_arrow" align="absmiddle" /></span></td>
            	<td class="sb_filter_on" id="sb_filter_on" style="'.($filter_str != '' ? '' : 'visibility: hidden;').'"><nobr><img src="'.SB_CMS_IMG_URL.'/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.SB_ELEMS_FILTER_ON.'&nbsp;&nbsp;<img src="'.SB_CMS_IMG_URL.'/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="'.SB_CMS_IMG_URL.'/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;'.KERNEL_CANCEL.'</span></nobr></td>
            </tr></table>
        </td>
    </tr>
    <tr><td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter" '.($filter_str != '' ? '' : ' style="display:none;"').'>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">'.PL_SEARCH_INDEXING_LOG_FILTER_DATE_TITLE.':</th>
                <td class="sb_filter_td"><nobr>';

	$fld_lo = new sbLayoutDate((isset($_GET['l_date_from']) ? $_GET['l_date_from'] : ''), 'l_date_from');
	$fld_lo->mDropButton = true;

	$fld_hi = new sbLayoutDate((isset($_GET['l_date_to']) ? $_GET['l_date_to'] : ''), 'l_date_to');
	$fld_hi->mDropButton = true;

	echo $fld_lo->getJavaScript().'
					<table cellpadding="0" cellspacing="0">
					<tr>
				    	<td>'.KERNEL_FROM.'&nbsp;&nbsp;</td>
				    	<td>'.$fld_lo->getField().'</td>
				    	<td>&nbsp;&nbsp;'.KERNEL_TO.'&nbsp;&nbsp;</td>
				    	<td>'.$fld_hi->getField().'</td>
				    </tr>
					</table>
				    </nobr>
                </td>
                <th class="sb_filter_th">'.PL_SEARCH_INDEXING_LOG_FILTER_PAGE_TITLE_TITLE.':</th>
                <td class="sb_filter_td_noborder">';
	$fld = new sbLayoutInput('text', isset($_GET['l_page_title']) ? $_GET['l_page_title'] : '', 'l_page_title', '', 'style="width: 100%;"');
	echo $fld->getField().
				'</td>
          	</tr>
			<tr>
				<th class="sb_filter_th">'.PL_SEARCH_INDEXING_LOG_TYPE_TITLE.':</th>
				<td class="sb_filter_td">';

	$options = array();
	$options[0] = ' --- ';
	$options[1] = PL_SEARCH_INDEXING_LOG_FILTER_OPT_OPENED;
	$options[2] = PL_SEARCH_INDEXING_LOG_FILTER_OPT_NOT_OPENED;
	$options[3] = PL_SEARCH_INDEXING_LOG_FILTER_OPT_NOT_TEXT;

	$fld = new sbLayoutSelect($options, 'l_flags');
	$fld->mSelOptions = array(isset($_GET['l_flags']) ? $_GET['l_flags'] : '');
	echo $fld->getField().'
				</td>
				<th class="sb_filter_th">'.PL_SEARCH_INDEXING_LOG_URL_TITLE.':</th>
				<td class="sb_filter_td_noborder">';
	$fld = new sbLayoutInput('text', isset($_GET['l_url']) ? $_GET['l_url'] : '', 'l_url', '', 'style="width:100%;"');
	echo $fld->getField().'</td>
			</tr>
			</table>
				<div class="sb_filter_footer"><input type="submit" value="'.KERNEL_APPLY.'">&nbsp;&nbsp;</div>
			</div>
			</form>
		</table>
	</td></tr></table><center>';

//  строим список проиндексированных страниц
	require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');
	$pager = new sbDBPager('index_log', 7, 50, 'content');

	$total = true;
	$res = $pager->init($total, 'SELECT sp_url, sp_title, sp_last_modified, sp_flags, sp_words_ids FROM sb_search_pages_'.$id.
					($filter_str != '' ? ' WHERE '.substr($filter_str, 5) : '').$order_str);

	$num_list = $pager->show();

	echo '<br /><br />';

	if($res)
	{
		$html = '
		<table id="log_table" style="width:98%;" cellpadding="5" cellspacing="0" class="form" from="'.$pager->mPage.'">
					<tr>
						<th class="header" style="width:70px;">
				            <nobr>
				            	<a href="'.$href.'&order=sp_flags|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'sp_flags|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
				            	&nbsp;'.PL_SEARCH_INDEXING_LOG_TYPE_TITLE.'&nbsp;
								<a href="'.$href.'&order=sp_flags|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'sp_flags|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
				            </nobr>
						</th>
						<th class="header" style="width:200px;">
							<nobr>
				            	<a href="'.$href.'&order=sp_last_modified|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'sp_last_modified|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
				            	&nbsp;'.PL_SEARCH_INDEXING_LOG_DATE_TITLE.'&nbsp;
								<a href="'.$href.'&order=sp_last_modified|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'sp_last_modified|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
				            </nobr>
						</th>
						<th class="header">
							<nobr>
				            	<a href="'.$href.'&order=sp_title|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'sp_title|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
				            	&nbsp;'.PL_SEARCH_INDEXING_LOG_TITLE_TITLE.'&nbsp;
								<a href="'.$href.'&order=sp_title|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'sp_title|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
				            </nobr>
						</th>
						<th class="header" style="width:50px;">
							<nobr>
				            	<a href="'.$href.'&order=sp_words_ids|asc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'sp_words_ids|asc' ? 's_asc_sel.gif' : 's_asc.gif').'" border="0" width="11" height="9"></a>
				            	&nbsp;'.PL_SEARCH_INDEXING_LOG_COUNT_INDEXING_WORDS_TITLE.'&nbsp;
								<a href="'.$href.'&order=sp_words_ids|desc"><img src="'.SB_CMS_IMG_URL.'/'.($_GET['order'] == 'sp_words_ids|desc' ? 's_desc_sel.gif' : 's_desc.gif').'" border="0" width="11" height="9"></a>
				            </nobr>
						</th>
						<th class="header" style="width:1px;">&nbsp;</th>
					</tr>';

		require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');
		$layout = new sbLayout();

		require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

		$r = 1;
		foreach($res as $value)
		{
			list($sp_url, $sp_title, $sp_last_modified, $sp_flags, $sp_words_ids) = $value;

			$sp_last_modified = is_null($sp_last_modified) ? '-' : sb_date('d.m.Y '.KERNEL_IN.' H:i:s', $sp_last_modified);

			$url = $idn->decode($sp_url);
			if (sb_strlen($url) > 100)
			{
				$url = sb_substr($url, 0, 100).'...';
			}

			$page_link = '<a href="'.($sp_url != '' ? $sp_url : '#').'" style="font-size:10px;color:#'.(isset($sp_flags) && $sp_flags == 1 && trim($sp_words_ids) != '' ? '33805E' : 'CC0066').';" target="_blank">'.$url.'</a>';

			$words_count = 0;
			if($sp_words_ids != '')
			{
				$words_count = (sb_substr_count(trim($sp_words_ids), ' ') + 1);
			}

			$class = ($r % 2 == 0 ? 'odd' : 'even');
			$r++;

			if(isset($sp_flags) && $sp_flags == 1 && trim($sp_words_ids) != '')
			{
				$type_title = PL_SEARCH_INDEXING_LOG_FILTER_OPT_OPENED;
				$img_src = '/information_log.png';
			}
			elseif(isset($sp_flags) && $sp_flags == 1)
			{
				$type_title = PL_SEARCH_INDEXING_LOG_FILTER_OPT_NOT_TEXT;
				$img_src = '/prevention_log.png';
			}
			else
			{
				$type_title = PL_SEARCH_INDEXING_LOG_FILTER_OPT_NOT_OPENED;
				$img_src = '/warning_log.png';
			}

			$html .= '<tr class="'.$class.'" id="id_'.$r.'">
				<td style="text-align:center"><img src="'.SB_CMS_IMG_URL.$img_src.'" title="'.$type_title.'"></td>
				<td style="font-size: 10px;text-align:center">'.$sp_last_modified.'</td>
				<td>'.$sp_title.'<br />'.$page_link.'</td>
				<td style="font-size: 10px;text-align:center">'.$words_count.'</td>
				<td style="text-align:right">'.($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'delete') ? '<img height="20" width="20" style="cursor: pointer;" onClick = "sbDeleteFromLog(\''.$r.'\', \''.urlencode($sp_url).'\', \''.$id.'\');" title="'.PL_SEARCH_INDEXING_LOG_DELETE_FROM_LOG.'" src="'.SB_CMS_IMG_URL.'/btn_delete.png"/>' : '&nbsp;').'</td>
			</tr>';
		}

		$html .= '</table>';

		echo '<div align="right" style="width:95%;">
			'.($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'delete') ? '[ <a href="#" onclick="sbClearPages();">'.PL_SEARCH_INIT_CLEAR_PAGES.'</a> ]&nbsp;&nbsp;&nbsp;' : '').
			'[ <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_search_init">'.PL_SEARCH_INIT_BACK.'</a> ]
			</div><center>'.$num_list.'<br /><br /></center>'.$html.'<center><br />'.$num_list.'<br /><br /></center>';

	}
	else
	{
		echo '<div align="right" style="width:95%;">
				[ <a href="'.SB_CMS_CONTENT_FILE.'?event=pl_search_init">'.PL_SEARCH_INIT_BACK.'</a> ]
			</div>';
		sb_show_message(PL_SEARCH_INDEXING_LOG_NO_RECORDS_IN_LOG, true);
	}
}


function fSearch_Design_Form_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['sstf_title'].'</a></b>
    <div class="smalltext" style="margin-top: 7px;">';

    static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages))
    {
        $view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
    }

    if (is_null($view_info_temps))
    {
        $view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
    }

    $id = intval($args['sstf_id']);

    $pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
                        WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_search_form" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

    $temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
                        WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_search_form" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

    if ($pages)
    {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_PAGES.':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';

        $num = min(3, count($pages));
        for ($i = 0; $i < $num; $i++)
        {
            list($p_id, $p_name) = $pages[$i];
            $result .= ($view_info_pages ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
        }

        if ($num < count($pages))
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
        else
            $result = substr($result, 0, -2);

        $result .= '</span></td></tr></table>';
    }
    else
    {
        $result .= KERNEL_USED_ON_PAGES.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
    }

    if ($temps)
    {
        $result .= '<table cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_TEMPS.':&nbsp;</td>
                        <td class="smalltext"><span style="color:green;">';

        $num = min(3, count($temps));
        for ($i = 0; $i < $num; $i++)
        {
            list($t_id, $t_name) = $temps[$i];
            $result .= ($view_info_temps ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_templates_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
        }

        if ($num < count($temps))
            $result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
        else
            $result = substr($result, 0, -2);

        $result .= '</span></td></tr></table>';
    }
    else
    {
        $result .= KERNEL_USED_ON_TEMPS.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
    }

    $result .= '</div>';

    return $result;
}

function fSearch_Design_Form_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	$elems = new sbElements('sb_search_temps_form', 'sstf_id', 'sstf_title', 'fSearch_Design_Form_Get', 'pl_search_design_form', 'pl_search_design_search_form');

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;

    $elems->addField('sstf_title');      // название макета дизайна
//    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_faq_form_32.png';

    $elems->addSorting(PL_SEARCH_DESIGN_FORM_SORT_BY_TITLE, 'sstf_title');
    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_search_design_form_edit';
    $elems->mElemsEditDlgWidth = 760;
    $elems->mElemsEditDlgHeight = 500;

    $elems->mElemsAddEvent =  'pl_search_design_form_edit';
    $elems->mElemsAddDlgWidth = 760;
    $elems->mElemsAddDlgHeight = 500;

    $elems->mElemsDeleteEvent = 'pl_search_design_form_delete';

    $elems->mCategsClosed = false;
    $elems->mCategsRubrikator = false;

    $elems->mElemsJavascriptStr .= '
          function linkPages(e)
          {
			  if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_search_form";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);

          }

          function linkTemps(e)
          {
              if (!sbSelEl)
              {
                  var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
              }
              else
                  var el_id = sbSelEl.getAttribute("el_id");

              strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_search_form";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
          }

          function searchList()
          {
              window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_init";
          }';

    $elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
    $elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
    $elems->addElemsMenuItem(PL_SEARCH_INIT_SEARCH_DOMAIN, 'searchList();', false);

	$elems->init();
}

function fSearch_Design_Form_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_search_design_search_form'))
		return;

    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
    {
        $result = sql_param_query('SELECT sstf_title, sstf_form FROM sb_search_temps_form WHERE sstf_id=?d', $_GET['id']);
        if ($result)
        {
            list($sstf_title, $sstf_form) = $result[0];
        }
        else
        {
            sb_show_message(PL_SEARCH_DESIGN_FORM_EDIT_ERROR, true, 'warning');
            return;
        }
    }
    elseif (count($_POST) > 0)
    {
        extract($_POST);
        if (!isset($_GET['id']))
            $_GET['id'] = '';
    }
    else
    {
        $sstf_title = $sstf_form = '';
        $_GET['id'] = '';
	}

	echo '<script>
            function checkValues()
            {
                var el_title = sbGetE("sstf_title");
                if (el_title.value == "")
                {
                     alert("'.PL_SERACH_DESIGN_FORM_NO_TITLE_MSG.'");
                     return false;
                }
            }';

    if ($htmlStr != '')
    {
        echo '
            function cancel()
            {
                var res = new Object();
                res.html = "'.$htmlStr.'";
                res.footer = "'.$footerStr.'";
                res.footer_link = "";
                sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
    }

    echo '</script>';
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_search_design_form_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
    $layout->mTableWidth = '95%';
	$layout->mTitleWidth = '160';

	echo '<br /><br />';
	$layout->addHeader(PL_SEARCH_DESIGN_FORM_EDIT_TAB1);

	$layout->addField(PL_SEARCH_DESIGN_FORM_TITLE, new sbLayoutInput('text', $sstf_title, 'sstf_title', '', 'style="width:97%;"', true));

	$fld = new sbLayoutTextarea($sstf_form, 'sstf_form', '', 'style="width:100%; height:250px;"');
	$fld->mTags = array('-', PL_SEARCH_DESIGN_FORM_HTML_FORM_TAG_VALUE, PL_SEARCH_DESIGN_FORM_QUERY_STRING_TAG, PL_SEARCH_DESIGN_FORM_OPTIONS_TAG);
    $fld->mValues = array(PL_SEARCH_DESIGN_FORM_EDIT_TAB1, PL_SEARCH_DESIGN_FORM_HTML_FORM, PL_SEARCH_DESIGN_FORM_SEARCH_FIELD_TAG, PL_SEARCH_DESIGN_FORM_SEARCH_LOGIC_FIELD_TAG);
	$layout->addField(PL_SEARCH_DESIGN_FORM_EDIT_TAB3 , $fld);

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'design_edit') ? '' : 'disabled="disabled"'));

	if ($_GET['id'] != '')
		$layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'design_edit') ? '' : 'disabled="disabled"'));

	$layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
	$layout->show();
}

function fSearch_Design_Form_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_search_design_search_form'))
		return;

	if (!isset($_GET['id']))
        $_GET['id'] = '';

	$sstf_title = $sstf_form = '';

    extract($_POST);

    if ($sstf_title == '')
    {
        sb_show_message(PL_SERACH_DESIGN_FORM_NO_TITLE_MSG, false, 'warning');
        fSearch_Design_Form_Edit();
        return;
    }

    $row = array();
    $row['sstf_title'] = $sstf_title;
    $row['sstf_form'] = $sstf_form;

	if ($_GET['id'] != '')
	{
		$res = sql_param_query('SELECT sstf_title FROM sb_search_temps_form WHERE sstf_id=?d', $_GET['id']);
		if ($res)
		{
	        //редактирование
	        list($old_title) = $res[0];

	        sql_param_query('UPDATE sb_search_temps_form SET ?a WHERE sstf_id=?d', $row, $_GET['id'], sprintf(PL_SEARCH_DESIGN_FORM_SUBMIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_search_temps_form', $_GET['id']);

			$footer_ar = fCategs_Edit_Elem('design_edit');
			if (!$footer_ar)
    	    {
    	    	sb_show_message(PL_SEARCH_DESIGN_FORM_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_SEARCH_DESIGN_FORM_SUBMIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fSearch_Design_Form_Edit();
    		    return;
    	    }
    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	    $row['sstf_id'] = intval($_GET['id']);

            $html_str = fSearch_Design_Form_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
    	    	echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	    	fSearch_Design_Form_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
			sb_show_message(PL_SEARCH_DESIGN_FORM_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_SEARCH_DESIGN_FORM_SUBMIT_SYSTEMLOG_ERROR, $sstf_title), SB_MSG_WARNING);

            fSearch_Design_Form_Edit();
		    return;
	    }
	}
	else
	{
		$error = true;

	    if (sql_param_query('INSERT INTO sb_search_temps_form SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id, 'design_edit'))
    		{
                sbQueryCache::updateTemplate('sb_search_temps_form', $id);
        		sb_add_system_message(sprintf(PL_SEARCH_DESIGN_FORM_SUBMIT_ADD_OK, $sstf_title));
        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';
        		$error = false;
    		}
    		else
    		{
				sql_query('DELETE FROM sb_search_temps_form WHERE sstf_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
			sb_show_message(PL_SEARCH_DESIGN_FORM_SUBMIT_ADD_ERROR, false, 'warning');
			sb_add_system_message(sprintf(PL_SEARCH_DESIGN_FORM_SUBMIT_ADD_SYSTEMLOG_ERROR, $sstf_title), SB_MSG_WARNING);

            fSearch_Design_Form_Edit();
		    return;
	    }
	}
}

function fSearch_Design_Form_Delete()
{
	$id = intval($_GET['id']);
	$pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
					WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_search_form" AND pages.p_id=elems.e_p_id LIMIT 1');
	$temps = false;

	if(!$pages)
	{
		$temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
					WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_search_form" AND temps.t_id=elems.e_p_id LIMIT 1');
	}

    if ($pages || $temps)
    {
		echo PL_SEARCH_DESIGN_FORM_DELETE_ERROR;
    }
}


function fSearch_Design_Results_Get($args)
{
	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['sstr_title'].'</a></b>
    <div class="smalltext" style="margin-top: 7px;">';

    static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages))
    {
        $view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
    }

    if (is_null($view_info_temps))
    {
        $view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read');
    }

    $id = intval($args['sstr_id']);

	$pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_search_results" AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

	$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_search_results" AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

	if ($pages)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_PAGES.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($pages));
	    for ($i = 0; $i < $num; $i++)
		{
			list($p_id, $p_name) = $pages[$i];
			$result .= ($view_info_pages ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
		}

		if ($num < count($pages))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
	    $result .= KERNEL_USED_ON_PAGES.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	if ($temps)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_TEMPS.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;">';

	    $num = min(3, count($temps));
	    for ($i = 0; $i < $num; $i++)
		{
			list($t_id, $t_name) = $temps[$i];
			$result .= ($view_info_temps ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_templates_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
		}

		if ($num < count($temps))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
		$result .= KERNEL_USED_ON_TEMPS.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

    $result .= '</div>';

    return $result;
}

function fSearch_Design_Results_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	$elems = new sbElements('sb_search_temps_results', 'sstr_id', 'sstr_title', 'fSearch_Design_Results_Get', 'pl_search_design_results', 'pl_search_design_results');

    $elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;
    $elems->mElemsIcon = SB_CMS_IMG_URL.'/plugins/pl_search_results_32.png';

    $elems->addSorting(PL_SEARCH_DESIGN_RESULTS_SORT_BY_TITLE, 'sstr_title');

    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;
    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_search_design_results_edit';
    $elems->mElemsEditDlgWidth = 800;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_search_design_results_edit';
    $elems->mElemsAddDlgWidth = 800;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mElemsDeleteEvent = 'pl_search_design_results_delete';

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = false;
	$elems->mElemsUseLinks = false;

	$elems->mElemsJavascriptStr .= '
	      function linkPages(e)
	      {
	          if (!sbSelEl)
	          {
	              var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
	          }
	          else
	              var el_id = sbSelEl.getAttribute("el_id");

	          strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_pages_get_links&id=" + el_id + "&ident[]=pl_search_results";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
	      }
	      function linkTemps(e)
	      {
	          if (!sbSelEl)
	          {
	              var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
	          }
	          else
	              var el_id = sbSelEl.getAttribute("el_id");

	          strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_get_links&id=" + el_id + "&ident[]=pl_search_results";
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
	      }
	      function searchList()
	      {
	          window.location = "'.SB_CMS_CONTENT_FILE.'?event=pl_search_init";
	      }';

	$elems->addElemsMenuItem(KERNEL_LINK_PAGES_MENU_ITEM, 'linkPages();');
	$elems->addElemsMenuItem(KERNEL_LINK_TEMPS_MENU_ITEM, 'linkTemps();');
	$elems->addElemsMenuItem(PL_SEARCH_INIT_SEARCH_DOMAIN, 'searchList();', false);

    $elems->init();
}

function fSearch_Design_Results_Edit($htmlStr= '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_search_design_results'))
		return;

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$result = sql_param_query('SELECT sstr_title, sstr_pagelist_id, sstr_perpage, sstr_top, sstr_element, sstr_bottom, sstr_no_results, sstr_found_word, sstr_lang FROM sb_search_temps_results WHERE sstr_id=?d', $_GET['id']);
   		if ($result)
	    {
			list($sstr_title, $sstr_pagelist_id, $sstr_perpage, $sstr_top, $sstr_element, $sstr_bottom, $sstr_no_results, $sstr_found_word, $sstr_lang) = $result[0];
	    }
	    else
	    {
			sb_show_message(PL_SEARCH_DESIGN_FORM_EDIT_ERROR, true, 'warning');
			return;
		}

		if(isset($sstr_found_word) && $sstr_found_word != '')
			$sstr_found_word = unserialize($sstr_found_word);
		else
			$sstr_found_word = array();
	}
	elseif (count($_POST) > 0)
	{
		$sstr_pagelist_id = $sstr_pagelist_id = 0;
		extract($_POST);

		if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
		$sstr_lang = SB_CMS_LANG;

		$sstr_pagelist_id = -1;
		$sstr_perpage = 10;

		$sstr_title = $sstr_top = $sstr_element = $sstr_bottom = '';
	    $sstr_no_results = PL_SEARCH_DESIGN_RESULTS_EDIT_NO_RESULTS_MSG;
	    $sstr_found_word = array();
	    $sstr_found_word['start'] = '<span style="font-weight:bold;font-size:14px;">';
	    $sstr_found_word['end'] = '</span>';
	    $sstr_found_word['date'] = '{DAY}.{MONTH}.{LONG_YEAR} {HOUR}:{MINUTE}';

	    $_GET['id'] = '';
	}
	echo '<script>
	        function checkValues()
            {
                var el_title = sbGetE("sstr_title");
                if (el_title.value == "")
                {
          	         alert("'.PL_SERACH_DESIGN_FORM_NO_TITLE_MSG.'");
          	         return false;
                }
            }';

	if ($htmlStr != '')
	{
	    echo '
            function cancel()
            {
                var res = new Object();
		        res.html = "'.$htmlStr.'";
		        res.footer = "'.$footerStr.'";
		        res.footer_link = "";
				sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
	}
	echo '</script>';

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_search_design_results_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
	$layout->mTableWidth = '100%';
	$layout->mTitleWidth = '185';

	$layout->addTab(PL_SEARCH_DESIGN_FORM_EDIT_TAB1);
	$layout->addHeader(PL_SEARCH_DESIGN_FORM_EDIT_TAB1);

	$layout->addField(PL_SEARCH_DESIGN_FORM_TITLE, new sbLayoutInput('text', $sstr_title, 'sstr_title', '', 'style="width:97%;"', true));

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutSelect($GLOBALS['sb_site_langs'], 'sstr_lang');
	$fld->mSelOptions = array($sstr_lang);
	$fld->mHTML = '<div class="hint_div" style="margin-top: 5px;">'.PL_SEARCH_DESIGN_EDIT_LANG_LABEL.'</div>';
	$layout->addField(PL_SEARCH_DESIGN_EDIT_LANG, $fld);

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($sstr_found_word['date'], 'sstr_found_word[date]', '', 'style="width:100%;height:50px;"');
	$fld->mTags = array('{DAY}', '{WEEKDAY}', '{WEEKDAY_SHORT}', '{MONTH}', '{MONTH_TEXTUAL}', '{LONG_YEAR}', '{SHORT_YEAR}', '{HOUR}', '{MINUTE}');
	$fld->mValues = array(KERNEL_DAY_TAG, KERNEL_WEEKDAY_TAG_FULL, KERNEL_WEEKDAY_TAG_SHORT, KERNEL_MONTH_TAG, KERNEL_MONTH_NAME_TAG, KERNEL_YEAR_4_TAG, KERNEL_YEAR_2_TAG, KERNEL_HOURS_TAG, KERNEL_MINUTES_TAG);
	$layout->addField(PL_SEARCH_DESIGN_EDIT_DATE, $fld);

	fPager_Design_Get($layout, $sstr_pagelist_id, 'sstr_pagelist_id', $sstr_perpage, 'sstr_perpage');

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_SEARCH_DESIGN_RESULTS_EDIT_NO_RESULTS, new sbLayoutTextarea($sstr_no_results, 'sstr_no_results', '', 'style="width:100%;height:50px;"'));

	$layout->addTab(PL_SEARCH_DESIGN_RESULTS_EDIT_LIST_TAB);
	$layout->addHeader(PL_SEARCH_DESIGN_RESULTS_EDIT_LIST_TAB);

	$tags = array('{NUM_LIST}', '{QUERY}', '{COUNT_RESULTS}', '{TIME_RESULTS}');
	$tags_values = array(PL_SEARCH_DESIGN_RESULTS_EDIT_NUM_LIST_TAG, PL_SEARCH_DESIGN_RESULTS_EDIT_QUERY_TAG, PL_SEARCH_DESIGN_RESULTS_EDIT_COUNT_RESULTS_TAG, PL_SEARCH_DESIGN_RESULTS_EDIT_TIME_TAG);

	$html = '<div align="center" class="hint_div" style="margin-top: 5px;">'.PL_SEARCH_DESIGN_FORM_EDIT_TAB1.'</div>';
	$layout->addField('', new sbLayoutHTML($html, true));
	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($sstr_top, 'sstr_top', '', 'style="width:100%;height:70px;"');
	$fld->mTags = $tags;
	$fld->mValues = $tags_values;
	$layout->addField(PL_SEARCH_DESIGN_RESULTS_EDIT_TOP, $fld);

	$fld = new sbLayoutTextarea($sstr_element, 'sstr_element', '', 'style="width:100%;height:120px;"');
	$fld->mTags = array('{PAGE_NUM}', '{PAGE_NAME}', '{LINK}', '{DESCRIPTION}', '{PAGE_DATE}', '{WORDS_COUNT}', '{ARCHIVE_LINK}');
	$fld->mValues = array(PL_SEARCH_DESIGN_RESULTS_EDIT_PAGE_NUM, PL_SEARCH_DESIGN_RESULTS_EDIT_PAGE_NAME, PL_SEARCH_DESIGN_RESULTS_EDIT_PAGE_LINK, PL_SEARCH_DESIGN_RESULTS_EDIT_PAGE_DESC, PL_SEARCH_DESIGN_RESULTS_EDIT_PAGE_DATE, PL_SEARCH_DESIGN_RESULTS_EDIT_WORDS_COUNT, PL_SEARCH_DESIGN_RESULTS_EDIT_ARCHIVE_LINK);
	$layout->addField(PL_SEARCH_DESIGN_RESULTS_EDIT_ELEMENT, $fld);

	$fld = new sbLayoutTextarea($sstr_bottom, 'sstr_bottom', '', 'style="width:100%;height:70px;"');
	$fld->mTags = $tags;
	$fld->mValues = $tags_values;
	$layout->addField(PL_SEARCH_DESIGN_RESULTS_EDIT_BOTTOM, $fld);

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_SEARCH_DESIGN_RESULTS_EDIT_START, new sbLayoutTextarea($sstr_found_word['start'], 'sstr_found_word[start]', '', 'style="width:100%;height:50px;"'));
	$layout->addField(PL_SEARCH_DESIGN_RESULTS_EDIT_END, new sbLayoutTextarea($sstr_found_word['end'], 'sstr_found_word[end]', '', 'style="width:100%;height:50px;"'));

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'design_edit') ? '' : 'disabled="disabled"'));

    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_search', 'design_edit') ? '' : 'disabled="disabled"'));

	$layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
	$layout->show();
}

function fSearch_Design_Results_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_search_design_results'))
		return;

    if (!isset($_GET['id']))
        $_GET['id'] = '';

	$sstr_no_results = $sstr_title = $sstr_top = $sstr_element = $sstr_bottom = '';
	$sstr_found_word = array();
	$sstr_pagelist_id = 0;
    extract($_POST);

    if ($sstr_title == '')
    {
        sb_show_message(PL_SERACH_DESIGN_FORM_NO_TITLE_MSG, false, 'warning');
        fSearch_Design_Results_Edit();
        return;
    }

	$row = array();
	$row['sstr_title'] = $sstr_title;
	$row['sstr_lang'] = $sstr_lang;
	$row['sstr_pagelist_id'] = $sstr_pagelist_id;
	$row['sstr_perpage'] = $sstr_perpage;
    $row['sstr_top'] = $sstr_top;
    $row['sstr_element'] = $sstr_element;
    $row['sstr_bottom'] = $sstr_bottom;
    $row['sstr_no_results'] = $sstr_no_results;
    $row['sstr_found_word'] = serialize($sstr_found_word);
	$row['sstr_cat_id'] = 0;

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT sstr_title FROM sb_search_temps_results WHERE sstr_id=?d', $_GET['id']);
	    if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_search_temps_results SET ?a WHERE sstr_id=?d', $row, $_GET['id'], sprintf(PL_SEARCH_DESIGN_RESULTS_SUBMIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_search_temps_results', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem('design_edit');
    	    if (!$footer_ar)
    	    {
    	        sb_show_message(PL_SEARCH_DESIGN_FORM_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_SEARCH_DESIGN_RESULTS_SUBMIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                fSearch_Design_Results_Edit();
    		    return;
    	    }

			$footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
			$row['sstr_id'] = intval($_GET['id']);

            $html_str = fSearch_Design_Results_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    if (!isset($_POST['btn_apply']))
    	    {
        	    echo '<script>
        		        var res = new Object();
        		        res.html = "'.$html_str.'";
        		        res.footer = "'.$footer_str.'";
        		        res.footer_link = "";
        				sbReturnValue(res);
        			  </script>';
    	    }
    	    else
    	    {
    	        fSearch_Design_Results_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_SEARCH_DESIGN_FORM_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_SEARCH_DESIGN_RESULTS_SUBMIT_SYSTEMLOG_ERROR, $sstr_title), SB_MSG_WARNING);

            fSearch_Design_Results_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_search_temps_results SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		if (fCategs_Add_Elem($id, 'design_edit'))
    		{
                sbQueryCache::updateTemplate('sb_search_temps_results', $id);
        		sb_add_system_message(sprintf(PL_SEARCH_DESIGN_RESULTS_SUBMIT_ADD_OK, $sstr_title));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
				sql_query('DELETE FROM sb_search_temps_results WHERE sstr_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_SEARCH_DESIGN_RESULTS_SUBMIT_ADD_ERROR, $sstr_title), false, 'warning');
            sb_add_system_message(sprintf(PL_SEARCH_DESIGN_RESULTS_SUBMIT_ADD_SYSTEMLOG_ERROR, $sstr_title), SB_MSG_WARNING);

            fSearch_Design_Results_Edit();
		    return;
	    }
	}
}

function fSearch_Design_Results_Delete()
{
    $id = intval($_GET['id']);

    $pages = sql_query('SELECT pages.p_id FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_search_results" AND pages.p_id=elems.e_p_id LIMIT 1');

    $temps = false;
    if (!$pages)
    {
        $temps = sql_query('SELECT temps.t_id FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_temp_id="'.$id.'" AND elems.e_ident="pl_search_results" AND temps.t_id=elems.e_p_id LIMIT 1');
    }

    if ($pages || $temps)
    {
        echo PL_SEARCH_DESIGN_FORM_DELETE_ERROR;
    }
}

function fSearch_Trim($val)
{
    return trim($val, '/');
}
?>