<?php
require_once(SB_CMS_LANG_PATH.'/pl_services_rutube.h.lng.php');

if($_SESSION['sbPlugins']->register('pl_services_rutube', PL_SR_H_PLUGIN_NAME , ''))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER.'>'.PL_SR_H_SUB_MENU.'>'.PL_SR_H_PLUGIN_NAME, 'init');
    $_SESSION['sbPlugins']->addToExportImport(true, false);

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_services_rutube', 'design_read'))
	{
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SR_H_PLUGIN_NAME.'>'.PL_SR_H_LIST_MOVIES, 'design_list_init', 'pl_services_rutube_list_24.png');
		$_SESSION['sbPlugins']->addTomenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SR_H_PLUGIN_NAME.'>'.PL_SR_H_FULL_MOVIE, 'design_full_init', 'pl_services_rutube_full_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SR_H_PLUGIN_NAME.'>'.PL_SR_H_ELEM_CATEGS, 'design_categs', 'pl_services_rutube_categs_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SR_H_PLUGIN_NAME.'>'.PL_SR_H_ELEM_SEL_CAT, 'design_selcat', 'pl_services_rutube_sel_cat_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SR_H_PLUGIN_NAME.'>'.PL_SR_H_ELEM_FORM, 'design_form', 'pl_services_rutube_form_24.png');
		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SR_H_PLUGIN_NAME.'>'.PL_SR_H_ELEM_FILTER_FORM, 'design_filter_form', 'pl_services_rutube_filter_form_24.png');
	}

	$_SESSION['sbPlugins']->setMainEvent('init');

    $_SESSION['sbPlugins']->addUserEvent('init', 'fServices_Rutube_Init', 'read', PL_SR_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('edit', 'fServices_Rutube_Upload', 'read', PL_SR_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('edit_import', 'fServices_Rutube_Import', 'elems_edit', PL_SR_H_IMPORT_MOVIE);
    $_SESSION['sbPlugins']->addUserEvent('upload_edit_submit', 'fServices_Rutube_Upload_Edit_Submit', 'elems_edit', PL_SR_H_EDIT_TITLE);                                
    $_SESSION['sbPlugins']->addUserEvent('import_edit_submit', 'fServices_Rutube_Import_Edit_Submit', 'elems_edit', PL_SR_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fServices_Rutube_Import', 'elems_edit', PL_SR_H_IMPORT_MOVIE);
    $_SESSION['sbPlugins']->addUserEvent('set_active', 'fServices_Rutube_Set_Active', 'elems_public');
    $_SESSION['sbPlugins']->addUserEvent('copy_elem', 'fServices_Rutube_Copy_Elem', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('delete_votes', 'fServices_Rutube_Delete_Votes', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements', 'fServices_Rutube_Delete_Cat_With_Elements', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fServices_Rutube_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');
    
    $_SESSION['sbPlugins']->addUserEvent('edit_movie', 'fServices_Rutube_Edit_Movie', 'elems_edit', PL_SR_H_EDIT_MOVIE);    
    $_SESSION['sbPlugins']->addUserEvent('edit_movie_submit', 'fServices_Rutube_Edit_Movie_Submit', 'elems_edit', PL_SR_H_EDIT_MOVIE);

    $_SESSION['sbPlugins']->addUserEvent('design_list_init', 'fServices_Rutube_Temps_List_Init', 'design_read', PL_SR_H_DESIGN_LIST);
    $_SESSION['sbPlugins']->addUserEvent('design_list_edit', 'fServices_Rutube_Temps_List_Edit', 'design_read', PL_SR_H_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_list_submit', 'fServices_Rutube_Temps_List_Submit', 'design_edit', PL_SR_H_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_list_delete', 'fServices_Rutube_Temps_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_full_init', 'fServices_Rutube_Temps_Full_Init', 'design_read', PL_SR_H_DESIGN_FULL);
    $_SESSION['sbPlugins']->addUserEvent('design_full_edit', 'fServices_Rutube_Temps_Full_Edit', 'design_read', PL_SR_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_full_submit', 'fServices_Rutube_Temps_Full_Submit', 'design_edit', PL_SR_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_full_delete', 'fServices_Rutube_Temps_Full_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('design_categs', 'fServices_Rutube_Design_Categs', 'design_read', PL_SR_H_DESIGN_CATEGS_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_categs_edit', 'fServices_Rutube_Design_Categs_Edit', 'design_read', PL_SR_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_categs_edit_submit', 'fServices_Rutube_Design_Categs_Edit_Submit', 'design_edit', PL_SR_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_categs_delete', 'fServices_Rutube_Design_Categs_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('design_selcat', 'fServices_Rutube_Design_Selcat', 'design_read', PL_SR_H_DESIGN_SELCAT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_selcat_edit', 'fServices_Rutube_Design_Selcat_Edit', 'design_read', PL_SR_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_selcat_edit_submit', 'fServices_Rutube_Design_Selcat_Edit_Submit', 'design_edit', PL_SR_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_selcat_delete', 'fServices_Rutube_Design_Selcat_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('design_form', 'fServices_Rutube_Design_Form', 'design_read', PL_SR_H_DESIGN_FORM_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_form_edit', 'fServices_Rutube_Design_Form_Edit', 'design_read', PL_SR_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_form_edit_submit', 'fServices_Rutube_Design_Form_Edit_Submit', 'design_edit', PL_SR_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_form_delete', 'fServices_Rutube_Design_Form_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addUserEvent('design_filter_form', 'fServices_Rutube_Design_Filter_Form', 'design_read', PL_SR_H_DESIGN_FILTER_FORM_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('design_filter_form_edit', 'fServices_Rutube_Design_Filter_Form_Edit', 'design_read', PL_SR_H_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_filter_form_edit_submit', 'fServices_Rutube_Design_Filter_Form_Edit_Submit', 'design_edit', PL_SR_H_DESIGN_EDIT);
	$_SESSION['sbPlugins']->addUserEvent('design_filter_form_delete', 'fServices_Rutube_Design_Filter_Form_Delete', 'design_edit');

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_services_rutube_delim', PL_SR_H_PLUGIN_NAME, '', '');
    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_services_rutube_desc', PL_SR_H_SETTING_DESCRIPTION, '', '');
    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_services_rutube_delim', PL_SR_H_PLUGIN_NAME, '', '');
	/*$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_services_rutube_partner_key', PL_SR_H_PARTNER_KEY, 'string', '', '');*/
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_services_rutube_youtube_key', PL_SR_H_PARTNER_YOUTUBE_KEY, 'string', '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_services_rutube_youtube_marker', PL_SR_H_PARTNER_YOUTUBE_MARKER, 'string', '', '');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_services_rutube_youtube_api_key', PL_SR_H_PARTNER_YOUTUBE_API_KEY, 'string', '', '');

	$_SESSION['sbPlugins']->addToConstructor('sb_services_rutube');
	$_SESSION['sbPlugins']->addToCache();
	$_SESSION['sbPlugins']->addToComments('sb_services_rutube', 'ssr_id', 'ssr_name', 'ssr_url');
	$_SESSION['sbPlugins']->addToWorkflow();

	$fields = array();
	$fields['ssr_id'] = array('title' => PL_SR_H_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['ssr_name'] = array('title' => PL_SR_H_NAME_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_SSR_NAME}');
	$fields['ssr_description'] = array('title' => PL_SR_H_DESCR_LABEL, 'flags' => '5', 'link_title' => '1', 'tag' => '{OPT_STD_SSR_DESCRIPTION}');
	$fields['ssr_date'] = array('title' => PL_SR_H_DATE_LABEL, 'flags' => '9', 'link_title' => '1', 'tag' => '{OPT_STD_SSR_DATE}');
	$fields['ssr_views'] = array('title' => PL_SR_H_VIEWS_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['ssr_rutube_id'] = array('title' => PL_SR_H_RUTUBE_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['ssr_author'] = array('title' => PL_SR_H_AUTHOR_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
	$fields['ssr_duration'] = array('title' => PL_SR_H_DURATION_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['ssr_size'] = array('title' => PL_SR_H_SIZE_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['ssr_user_id'] = array('title' => PL_SR_H_USER_ID_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['ssr_status'] = array('title' => PL_SR_H_STATUS_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['ssr_show'] = array('title' => PL_SR_H_SHOW_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
	$fields['ssr_url'] = array('title' => PL_SR_H_URL_LABEL, 'flags' => '4', 'link_title' => '1', 'tag' => '{OPT_STD_SSR_URL}');
	$fields['ssr_pub_start'] = array('title' => PL_SR_H_PUB_START_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');
	$fields['ssr_pub_end'] = array('title' => PL_SR_H_PUB_END_LABEL, 'flags' => '9', 'link_title' => '0', 'tag' => '');

	$cat_fields = array();
	$cat_fields['moderates_list'] = array('title' => PL_SR_H_CAT_MODLIST_ID_LABEL, 'flags' => '20');
	$cat_fields['categs_moderate_email'] = array('title' => PL_SR_H_CAT_MODEMAIL_ID_LABEL, 'flags' => '4');

	$_SESSION['sbPlugins']->addFieldsInfo('sb_services_rutube', 'ssr_id', 'ssr_name', $fields, $cat_fields);
}

$_SESSION['sbPlugins']->addToRubrikator('pl_services_rutube', PL_SR_H_PLUGIN_NAME, 'rutube', 'pl_services_rutube_design_categs', 'pl_services_rutube_design_selcat');
$_SESSION['sbPlugins']->addToCalendar('list', 'fServices_Rutube_Get_Calendar', 'pl_services_rutube/prog/pl_services_rutube.php', array('ssr_date' => PL_SR_H_CALENDAR_DATE));
$_SESSION['sbPlugins']->addToCron('pl_services_rutube/cron/pl_services_rutube.php', 'fServices_Rutube_Cron_Get_Info', PL_SR_H_CRON_IMPORT_INFO_MOVIE, PL_SR_H_CRON_IMPORT_INFO_MOVIE_DESCR);

$_SESSION['sbPlugins']->addSystemEvent('list_movies', 'fServices_Rutube_Get_Elem_List', PL_SR_H_LIST_MOVIES);
$_SESSION['sbPlugins']->addSystemEvent('full_movie', 'fServices_Rutube_Get_Elem_Full', PL_SR_H_FULL_MOVIES);
$_SESSION['sbPlugins']->addSystemEvent('elem_categs', 'fServices_Rutube_Get_Categs', PL_SR_H_CATEGS);
$_SESSION['sbPlugins']->addSystemEvent('elem_sel_categ', 'fServices_Rutube_Get_Sel_Categ', PL_SR_H_SEL_CATEG);
$_SESSION['sbPlugins']->addSystemEvent('elem_form', 'fServices_Rutube_Get_Form', PL_SR_H_FORM);
$_SESSION['sbPlugins']->addSystemEvent('elem_form_edit', 'fServices_Rutube_Get_Form_Edit', PL_SR_H_FORM_EDIT);
$_SESSION['sbPlugins']->addSystemEvent('elem_cloud', 'fServices_Rutube_Get_Elem_Cloud', PL_SR_H_ELEM_CLOUD);
$_SESSION['sbPlugins']->addSystemEvent('elem_filter', 'fServices_Rutube_Get_Elem_Filter', PL_SR_H_ELEM_FILTER_FORM);
$_SESSION['sbPlugins']->addSystemEvent('elem_list_components', 'fServices_Rutube_Get_Elem_Components');

$_SESSION['sbPlugins']->addElem(PL_SR_H_LIST_MOVIES, 'list', 'fServices_Rutube_List', 'fServices_Rutube_Get_Elem_List_Info', 'list_movies', 800, 600, 'design_list_edit', 'pl_services_rutube_temps_list');
$_SESSION['sbPlugins']->addElem(PL_SR_H_FULL_MOVIE, 'full', 'fServices_Rutube_Full', 'fServices_Rutube_Get_Elem_Full_Info', 'full_movie', 800, 500, 'design_full_edit', 'pl_services_rutube_temps_full');
$_SESSION['sbPlugins']->addElem(PL_SR_H_CATEGS, 'categs', 'fServices_Rutube_Categs', 'fServices_Rutube_Get_Categs_Info', 'elem_categs', 800, 700, 'design_categs_edit', 'pl_services_rutube_design_categs');
$_SESSION['sbPlugins']->addElem(PL_SR_H_SEL_CATEG, 'sel_categ', 'fServices_Rutube_Sel_Categ', 'fServices_Rutube_Get_Sel_Categ_Info', 'elem_sel_categ', 800, 350, 'design_selcat_edit', 'pl_services_rutube_design_selcat');
$_SESSION['sbPlugins']->addElem(PL_SR_H_FORM, 'form', 'fServices_Rutube_Form', 'fServices_Rutube_Get_Form_Info', 'elem_form', 800, 700, 'design_form_edit', 'pl_services_rutube_form');
$_SESSION['sbPlugins']->addElem(PL_SR_H_FORM_EDIT, 'form_edit', 'fServices_Rutube_Form', 'fServices_Rutube_Get_Form_Info', 'elem_form_edit', 800, 700, 'design_form_edit', 'pl_services_rutube_form');
$_SESSION['sbPlugins']->addElem(PL_SR_H_ELEM_CLOUD, 'cloud', 'fServices_Rutube_Elem_Cloud', 'fServices_Rutube_Elem_Cloud_Info', 'elem_cloud', 800, 700);
$_SESSION['sbPlugins']->addElem(PL_SR_H_ELEM_FILTER_FORM, 'filter', 'fServices_Rutube_Elem_Filter', 'fServices_Rutube_Elem_Filter_Info', 'elem_filter', 800, 300, 'design_filter_form_edit', 'pl_services_rutube_filter');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
?>