<?php
require_once(SB_CMS_LANG_PATH.'/pl_site_users.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_site_users', PL_SITE_USERS_H_PLUGIN_NAME, ''))
{
    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_ADMIN.'>'.PL_SITE_USERS_H_PLUGIN_NAME, 'init');

    $_SESSION['sbPlugins']->addToMainPage('info', PL_SITE_USERS_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addToExportImport(true, false);
    if ($_SESSION['sbPlugins']->isRightAvailable('pl_site_users', 'design_read'))
    {
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SITE_USERS_H_PLUGIN_NAME.'>'.PL_SITE_USERS_H_ELEM_LOGIN, 'login_temp', 'pl_site_users_login_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SITE_USERS_H_PLUGIN_NAME.'>'.PL_SITE_USERS_H_ELEM_REG, 'reg_temp', 'pl_site_users_reg_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SITE_USERS_H_PLUGIN_NAME.'>'.PL_SITE_USERS_H_ELEM_UPDATE, 'update_temp', 'pl_site_users_update_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SITE_USERS_H_PLUGIN_NAME.'>'.PL_SITE_USERS_H_ELEM_REMIND, 'remind_temp', 'pl_site_users_remind_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SITE_USERS_H_PLUGIN_NAME.'>'.PL_SITE_USERS_H_ELEM_LIST, 'list_temp', 'pl_site_users_list_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SITE_USERS_H_PLUGIN_NAME.'>'.PL_SITE_USERS_H_CATEGS_LIST, 'categ_temp', 'pl_site_users_group_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SITE_USERS_H_PLUGIN_NAME.'>'.PL_SITE_USERS_H_ELEM_DATA, 'data_temp', 'pl_site_users_data_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.KERNEL_MENU_DEVELOP_DESIGN.'>'.PL_SITE_USERS_H_PLUGIN_NAME.'>'.PL_SITE_USERS_H_ELEM_FILTER, 'filter_temp', 'pl_site_users_filter_24.png');
    }

    $_SESSION['sbPlugins']->setMainEvent('init');

    $_SESSION['sbPlugins']->addUserEvent('init', 'fSite_Users_Init', 'read', PL_SITE_USERS_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('check_login', 'fSite_Users_Check_Login', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('check_email', 'fSite_Users_Check_Email', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('edit', 'fSite_Users_Edit', 'read', PL_SITE_USERS_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fSite_Users_Edit_Submit', 'elems_edit', PL_SITE_USERS_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('delete', 'fSite_Users_Delete', 'elems_delete');

    $_SESSION['sbPlugins']->addUserEvent('cat_edit', 'fSite_Users_Cat_Edit', 'categs_edit', PL_SITE_USERS_H_EDIT_CATEG_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('cat_edit_submit', 'fSite_Users_Cat_Edit_Submit', 'categs_edit', PL_SITE_USERS_H_EDIT_CATEG_TITLE);

    // макеты дизайна формы логина
    $_SESSION['sbPlugins']->addUserEvent('login_temp', 'fSite_Users_Login_Temp', 'design_read', PL_SITE_USERS_H_LOGIN_TEMP_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('login_temp_edit', 'fSite_Users_Login_Temp_Edit', 'design_read', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('login_temp_submit', 'fSite_Users_Login_Temp_Submit', 'design_edit', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('login_temp_delete', 'fSite_Users_Login_Temp_Delete', 'design_edit');

    // макеты дизайна формы регистрации
    $_SESSION['sbPlugins']->addUserEvent('reg_temp', 'fSite_Users_Reg_Temp', 'design_read', PL_SITE_USERS_H_REG_TEMP_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('reg_temp_edit', 'fSite_Users_Reg_Temp_Edit', 'design_read', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('reg_temp_submit', 'fSite_Users_Reg_Temp_Submit', 'design_edit', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('reg_temp_delete', 'fSite_Users_Reg_Temp_Delete', 'design_edit');

    // макеты дизайна формы изменения данных
    $_SESSION['sbPlugins']->addUserEvent('update_temp', 'fSite_Users_Update_Temp', 'design_read', PL_SITE_USERS_H_UPDATE_TEMP_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('update_temp_edit', 'fSite_Users_Update_Temp_Edit', 'design_read', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('update_temp_submit', 'fSite_Users_Update_Temp_Submit', 'design_edit', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('update_temp_delete', 'fSite_Users_Update_Temp_Delete', 'design_edit');

    // макеты дизайна формы напоминания пароля
    $_SESSION['sbPlugins']->addUserEvent('remind_temp', 'fSite_Users_Remind_Temp', 'design_read', PL_SITE_USERS_H_REMIND_TEMP_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('remind_temp_edit', 'fSite_Users_Remind_Temp_Edit', 'design_read', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('remind_temp_submit', 'fSite_Users_Remind_Temp_Submit', 'design_edit', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('remind_temp_delete', 'fSite_Users_Remind_Temp_Delete', 'design_edit');

    // макеты дизайна вывода данных пользователя
    $_SESSION['sbPlugins']->addUserEvent('data_temp', 'fSite_Users_Data_Temp', 'design_read', PL_SITE_USERS_H_DATA_TEMP_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('data_temp_edit', 'fSite_Users_Data_Temp_Edit', 'design_read', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('data_temp_submit', 'fSite_Users_Data_Temp_Submit', 'design_edit', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('data_temp_delete', 'fSite_Users_Data_Temp_Delete', 'design_edit');

    // макеты дизайна вывода списка пользователей
    $_SESSION['sbPlugins']->addUserEvent('list_temp', 'fSite_Users_List_Temp', 'design_read', PL_SITE_USERS_H_LIST_TEMP_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('list_temp_edit', 'fSite_Users_List_Temp_Edit', 'design_read', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('list_temp_submit', 'fSite_Users_List_Temp_Submit', 'design_edit', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('list_temp_delete', 'fSite_Users_List_Temp_Delete', 'design_edit');

    // макеты дизайна вывода списка групп пользователей
    $_SESSION['sbPlugins']->addUserEvent('categ_temp', 'fSite_Users_Categ_Temp', 'design_read', PL_SITE_USERS_H_CATEG_TEMP_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('categ_temp_edit', 'fSite_Users_Categ_Temp_Edit', 'design_read', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('categ_temp_submit', 'fSite_Users_Categ_Temp_Submit', 'design_edit', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('categ_temp_delete', 'fSite_Users_Categ_Temp_Delete', 'design_edit');

    // макеты дизайна вывода формы фильтра
    $_SESSION['sbPlugins']->addUserEvent('filter_temp', 'fSite_Users_Filter_Temp', 'design_read', PL_SITE_USERS_H_FILTER_TEMP_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('filter_temp_edit', 'fSite_Users_Filter_Temp_Edit', 'design_read', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('filter_temp_submit', 'fSite_Users_Filter_Temp_Submit', 'design_edit', PL_SITE_USERS_H_TEMP_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('filter_temp_delete', 'fSite_Users_Filter_Temp_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addToConstructor('sb_site_users');
    $_SESSION['sbPlugins']->addToCache();
    $_SESSION['sbPlugins']->addToComments('sb_site_users', 'su_id', 'su_login', 'su_login');

    $_SESSION['sbPlugins']->addSystemEvent('info', 'fSite_Users_Info');
    $_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_site_users_delim', PL_SITE_USERS_H_PLUGIN_NAME, '', '');
    $_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_site_users_count_site_users', PL_SITE_USERS_H_INFO_COUNT_SITE_USERS, 'number', '', '3');

    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_site_users_delim', PL_SITE_USERS_H_PLUGIN_NAME, '', '');
    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_site_users_login_length', PL_SITE_USERS_H_SETTING_LOGIN_LENGTH, 'number', '', '4');
    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_site_users_password_length', PL_SITE_USERS_H_SETTING_PASSWORD_LENGTH, 'number', '', '6');
    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_site_users_max_upload_size', PL_SITE_USERS_H_SETTING_MAX_UPLOAD_SIZE, 'number', '', '2097152');
    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_site_users_max_upload_width', PL_SITE_USERS_H_SETTING_MAX_UPLOAD_WIDTH, 'number', '', '640');
    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'pl_site_users_max_upload_height', PL_SITE_USERS_H_SETTING_MAX_UPLOAD_HEIGHT, 'number', '', '480');

    $fields = array();
    $fields['su_id'] = array('title' => PL_SITE_USERS_H_SU_ID, 'flags' => '8', 'link_title' => '1', 'tag' => '');
    $fields['su_auto_login'] = array('title' => PL_SITE_USERS_H_AUTO_LOGIN, 'flags' => '4');
    $fields['su_last_ip'] = array('title' => PL_SITE_USERS_H_LAST_IP, 'flags' => '4');
    $fields['su_activation_code'] = array('title' => PL_SITE_USERS_H_ACT_CODE, 'flags' => '4');
    $fields['su_name'] = array('title' => PL_SITE_USERS_H_NAME, 'flags' => '4', 'link_title' => '1', 'tag' => '');
    $fields['su_pass'] = array('title' => PL_SITE_USERS_H_PASS, 'flags' => '16');
    $fields['su_email'] = array('title' => PL_SITE_USERS_H_EMAIL, 'flags' => '4', 'link_title' => '1', 'tag' => '');
    $fields['su_login'] = array('title' => PL_SITE_USERS_H_LOGIN, 'flags' => '4', 'link_title' => '1', 'tag' => '');
    $fields['su_reg_date'] = array('title' => PL_SITE_USERS_H_ELEM_LIST_SORT_REG_DATE, 'flags' => '9');
    $fields['su_last_date'] = array('title' => PL_SITE_USERS_H_ELEM_LIST_SORT_LAST_DATE, 'flags' => '9');
    $fields['su_active_date'] = array('title' => PL_SITE_USERS_H_ACT_DATE, 'flags' => '9');
    $fields['su_domains'] = array('title' => PL_SITE_USERS_H_DOMAINS, 'flags' => '4');
    $fields['su_status'] = array('title' => PL_SITE_USERS_H_STATUS, 'flags' => '19');
    $fields['su_pers_foto'] = array('title' => PL_SITE_USERS_H_PERS_FOTO, 'flags' => '4');
    $fields['su_pers_phone'] = array('title' => PL_SITE_USERS_H_PHONE, 'flags' => '4');
    $fields['su_pers_mob_phone'] = array('title' => PL_SITE_USERS_H_MOB_PHONE, 'flags' => '4');
    $fields['su_pers_birth'] = array('title' => PL_SITE_USERS_H_CALENDAR_BIRTH_DATE, 'flags' => '9');
    $fields['su_pers_sex'] = array('title' => PL_SITE_USERS_H_PERS_SEX, 'flags' => '17');
    $fields['su_pers_zip'] = array('title' => PL_SITE_USERS_H_PERS_ZIP, 'flags' => '4');
    $fields['su_pers_adress'] = array('title' => PL_SITE_USERS_H_PERS_ADRESS, 'flags' => '4');
    $fields['su_pers_addition'] = array('title' => PL_SITE_USERS_H_PERS_ADDITION, 'flags' => '4');
    $fields['su_work_name'] = array('title' => PL_SITE_USERS_H_WORK_NAME, 'flags' => '4', 'link_title' => '1', 'tag' => '');
    $fields['su_work_phone'] = array('title' => PL_SITE_USERS_H_WORK_PHONE, 'flags' => '4');
    $fields['su_work_phone_inner'] = array('title' => PL_SITE_USERS_H_WORK_PHONE_INNER, 'flags' => '4');
    $fields['su_work_fax'] = array('title' => PL_SITE_USERS_H_WORK_FAX, 'flags' => '4');
    $fields['su_work_email'] = array('title' => PL_SITE_USERS_H_WORK_EMAIL, 'flags' => '4');
    $fields['su_work_addition'] = array('title' => PL_SITE_USERS_H_WORK_ADDITION, 'flags' => '5');
    $fields['su_work_office_number'] = array('title' => PL_SITE_USERS_H_OFFICE_NUMBER, 'flags' => '4');
    $fields['su_work_unit'] = array('title' => PL_SITE_USERS_H_WORK_UNIT, 'flags' => '4');
    $fields['su_work_position'] = array('title' => PL_SITE_USERS_H_POSITION, 'flags' => '4');
    $fields['su_forum_nick'] = array('title' => PL_SITE_USERS_H_FORUM_NICK, 'flags' => '4', 'link_title' => '1', 'tag' => '');
    $fields['su_forum_text'] = array('title' => PL_SITE_USERS_H_FORUM_TEXT, 'flags' => '4');
    $fields['su_mail_lang'] = array('title' => PL_SITE_USERS_H_MAIL_LANG, 'flags' => '17');
    $fields['su_mail_status'] = array('title' => PL_SITE_USERS_H_MAIL_STATUS, 'flags' => '19');
    $fields['su_mail_date'] = array('title' => PL_SITE_USERS_H_MAIL_DATE, 'flags' => '9');
    $fields['su_mail_subscription'] = array('title' => PL_SITE_USERS_H_MAIL_SUBSCRIPTION, 'flags' => '20');
    $fields['su_ext_id'] = array('title' => PL_SITE_USERS_H_EXT_ID, 'flags' => '8');

    $cat_fields = array();
    $cat_fields['cat_user_lang'] = array('title' => PL_SITE_USERS_H_CAT_USERS_LANG, 'flags' => '17');
    $cat_fields['cat_status'] = array('title' => PL_SITE_USERS_H_CAT_STATUS, 'flags' => '19');
    $cat_fields['cat_domains'] = array('title' => PL_SITE_USERS_H_DOMAINS, 'flags' => '20');
    $cat_fields['categs_moderate_email'] = array('title' => PL_SITE_USERS_H_CAT_MOD_EMAIL, 'flags' => '4');
    $cat_fields['moderates_list'] = array('title' => PL_SITE_USERS_H_CAT_MOD_LIST, 'flags' => '20');

    $_SESSION['sbPlugins']->addFieldsInfo('sb_site_users', 'su_id', 'su_login', $fields, $cat_fields);
}

$_SESSION['sbPlugins']->addToRubrikator('pl_site_users', PL_SITE_USERS_H_PLUGIN_NAME, 'su', 'pl_site_users_categs', 'pl_site_users_list_temp');
$_SESSION['sbPlugins']->addToCalendar('list', 'fSite_Users_Get_Calendar', 'pl_site_users/prog/pl_site_users.php', array('su_reg_date' => PL_SITE_USERS_H_CALENDAR_REG_DATE, 'su_last_date' => PL_SITE_USERS_H_CALENDAR_LAST_DATE, 'su_pers_birth' => PL_SITE_USERS_H_CALENDAR_BIRTH_DATE));

$_SESSION['sbPlugins']->addSystemEvent('get_groups', 'fSite_Users_Get_Groups', PL_SITE_USERS_H_GET_GROUPS_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('elem_login', 'fSite_Users_Get_Elem_Login', PL_SITE_USERS_H_ELEM_LOGIN);
$_SESSION['sbPlugins']->addSystemEvent('elem_reg', 'fSite_Users_Get_Elem_Reg', PL_SITE_USERS_H_ELEM_REG);
$_SESSION['sbPlugins']->addSystemEvent('elem_update', 'fSite_Users_Get_Elem_Update', PL_SITE_USERS_H_ELEM_UPDATE);
$_SESSION['sbPlugins']->addSystemEvent('elem_remind', 'fSite_Users_Get_Elem_Remind', PL_SITE_USERS_H_ELEM_REMIND);
$_SESSION['sbPlugins']->addSystemEvent('elem_data', 'fSite_Users_Get_Elem_Data', PL_SITE_USERS_H_ELEM_DATA);
$_SESSION['sbPlugins']->addSystemEvent('elem_list', 'fSite_Users_Get_Elem_List', PL_SITE_USERS_H_ELEM_LIST);
$_SESSION['sbPlugins']->addSystemEvent('elem_filter', 'fSite_Users_Get_Elem_Filter', PL_SITE_USERS_H_ELEM_FILTER);
$_SESSION['sbPlugins']->addSystemEvent('categ_list', 'fSite_Users_Get_Elem_Categs', PL_SITE_USERS_H_CATEGS_LIST);

$_SESSION['sbPlugins']->addElem(PL_SITE_USERS_H_ELEM_LOGIN, 'login', 'fSite_Users_Elem_Login', 'fSite_Users_Elem_Login_Info', 'elem_login', 700, 600, 'login_temp_edit', 'pl_site_users_temp');
$_SESSION['sbPlugins']->addElem(PL_SITE_USERS_H_ELEM_REG, 'reg', 'fSite_Users_Elem_Reg', 'fSite_Users_Elem_Reg_Info', 'elem_reg', 800, 700, 'reg_temp_edit', 'pl_site_users_reg_temp');
$_SESSION['sbPlugins']->addElem(PL_SITE_USERS_H_ELEM_UPDATE, 'update', 'fSite_Users_Elem_Update', 'fSite_Users_Elem_Update_Info', 'elem_update', 800, 400, 'update_temp_edit', 'pl_site_users_update_temp');
$_SESSION['sbPlugins']->addElem(PL_SITE_USERS_H_ELEM_REMIND, 'remind', 'fSite_Users_Elem_Remind', 'fSite_Users_Elem_Remind_Info', 'elem_remind', 700, 250, 'remind_temp_edit', 'pl_site_users_remind_temp');
$_SESSION['sbPlugins']->addElem(PL_SITE_USERS_H_ELEM_LIST, 'list', 'fSite_Users_Elem_List', 'fSite_Users_Elem_List_Info', 'elem_list', 800, 700, 'list_temp_edit', 'pl_site_users_list_temp');
$_SESSION['sbPlugins']->addElem(PL_SITE_USERS_H_CATEGS_LIST, 'categs', 'fSite_Users_Categs_Prog', 'fSite_Users_Categs_Info', 'categ_list', 800, 700, 'categ_temp_edit', 'pl_site_users_categs');
$_SESSION['sbPlugins']->addElem(PL_SITE_USERS_H_ELEM_DATA, 'data', 'fSite_Users_Elem_Data', 'fSite_Users_Elem_Data_Info', 'elem_data', 700, 400, 'data_temp_edit', 'pl_site_users_data_temp');
$_SESSION['sbPlugins']->addElem(PL_SITE_USERS_H_ELEM_FILTER, 'filter', 'fSite_Users_Elem_Filter', 'fSite_Users_Elem_Filter_Info', 'elem_filter', 800, 300, 'filter_temp_edit', 'pl_site_users_filter');

$_SESSION['sbPlugins']->addEventsRights('categs_edit', PL_SITE_USERS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', PL_SITE_USERS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', PL_SITE_USERS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_edit', PL_SITE_USERS_H_ELEMS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_delete', PL_SITE_USERS_H_ELEMS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
