<?php

@require_once(SB_CMS_LANG_PATH.'/pl_sitemap.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_sitemap', PL_SITEMAP_H_PLUGIN_NAME, ''))
{
	require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    $idn = new sbIDN();

	if (!$_SESSION['sbAuth']->isAdmin())
	{
		$res = sql_param_query('SELECT u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
		if ($res)
		{
		    $u_domains = explode(',', $res[0][0]);
		    $i = 0;
			foreach ($GLOBALS['sb_domains'] as $domain => $tmp)
		    {
		    	if (in_array($domain, $u_domains))
		    	{
   			 		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SITEMAP_H_DOMAINS_SETTINGS.'>'.PL_SITEMAP_H_SETTING.' '.$idn->decode($domain).' > '.PL_SITEMAP_H_MENU_NAME, 'edit_sitemap&domain='.$domain);

   			 		$res = sql_query('SELECT sm_id FROM sb_sitemap WHERE sm_domain = ?', $domain);
					if($res && $res[0][0] != '')
					{
						$_SESSION['sbPlugins']->addToCron('pl_sitemap/cron/pl_sitemap.php', 'fSitemap_Cron_Refresh('.$res[0][0].')', sprintf(PL_SITEMAP_H_CRON_INDEXING, $domain), PL_SITEMAP_H_CRON_INDEXING_DESCR);
   			 		}
		    	}
		    }
		}
	}
	else
	{
		$i = 0;
		foreach ($GLOBALS['sb_domains'] as $domain => $tmp)
		{
    		$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SITEMAP_H_DOMAINS_SETTINGS.'>'.PL_SITEMAP_H_SETTING.' '.$idn->decode($domain).' > '.PL_SITEMAP_H_MENU_NAME, 'edit_sitemap&domain='.$domain);

			$res = sql_query('SELECT sm_id FROM sb_sitemap WHERE sm_domain = ?', $domain);
			if($res && $res[0][0] != '')
			{
				$_SESSION['sbPlugins']->addToCron('pl_sitemap/cron/pl_sitemap.php', 'fSitemap_Cron_Refresh('.$res[0][0].')', sprintf(PL_SITEMAP_H_CRON_INDEXING, $domain), PL_SITEMAP_H_CRON_INDEXING_DESCR);
			}
	    }
	}

	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_sitemap_delim', PL_SITEMAP_H_PLUGIN_NAME, '', '', '', 'all');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_sitemap_delay_microsecond', PL_SITEMAP_H_SETTINGS_DELAY_MICROSECOND, 'number', '', '300000', 'all');

	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_SITEMAP_H_DEV_MENU_NAME, 'init');

    $_SESSION['sbPlugins']->addUserEvent('init', 'fSitemap_Init', 'read', PL_SITEMAP_H_INIT_HEAD);
    $_SESSION['sbPlugins']->addUserEvent('edit', 'fSitemap_Edit', 'read', PL_SITEMAP_H_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('submit', 'fSitemap_Submit', 'edit_sitemap');
    $_SESSION['sbPlugins']->addUserEvent('delete', 'fSitemap_Delete', 'edit_sitemap');

	$_SESSION['sbPlugins']->addUserEvent('edit_sitemap', 'fSitemap_Edit_Data', 'read', PL_SITEMAP_H_INIT);
	$_SESSION['sbPlugins']->addUserEvent('edit_sitemap_submit', 'fSitemap_Edit_Data_Submit', 'edit_sitemap', PL_SITEMAP_H_INIT);
    $_SESSION['sbPlugins']->addUserEvent('clear_indexing_base', 'fSitemap_Clear_Indexing_Base', 'edit_sitemap');

	$_SESSION['sbPlugins']->addEventsRights('edit_sitemap', PL_SITEMAP_H_RIGHTS_EDIT_DESC);
}

?>