<?php
function fSystemlog_Create_Archive()
{
	$res = sql_query('SELECT MAX(sl_date), MIN(sl_date) FROM sb_system_log');
	if (!$res)
		return;
		
	list($sl_date_max, $sl_date_min) = $res[0];
	
	$file_name = 'cms/backup/log_'.sb_date('d_m_Y_H_i_s', $sl_date_max).'__'.sb_date('d_m_Y_H_i_s', $sl_date_min);
	
	require_once(SB_CMS_LIB_PATH.'/sbDumper.inc.php');
	
	$dumper = new sbDumper();
	
	if (!$dumper->createDump(SB_DUMPER_DUMP_TABLE, SB_DUMPER_DUMP_XML, $file_name.'.xml', true, $file_name.'.zip', 'sb_system_log', false, '', false, 'sl_date DESC'))
	{
		sb_add_system_message(sprintf(KERNEL_PROG_PL_SYSTEMLOG_CRON_ERROR, $file_name.'.zip'), SB_MSG_WARNING);
	}
	
	$log_date = intval(sbPlugins::getSetting('sb_system_log_date'));
    $time = time() - $log_date * 24 * 60 * 60;
    sql_query('DELETE FROM sb_system_log WHERE sl_date < '.$time);
}
?>