<?php
require_once(SB_CMS_LANG_PATH.'/pl_systemlog.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_systemlog', PL_SYSTEMLOG_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/system_log.doc'))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_ADMIN.'>'.KERNEL_MENU_LOGS.'>'.PL_SYSTEMLOG_H_PLUGIN_NAME, 'read');
	
	$_SESSION['sbPlugins']->addToMainPage('info', PL_SYSTEMLOG_H_PLUGIN_NAME);
	
	$_SESSION['sbPlugins']->addUserEvent('read', 'fSystemlog_Read', 'read', PL_SYSTEMLOG_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('excel', 'fSystemlog_Excel', 'read');
	$_SESSION['sbPlugins']->addUserEvent('archive', 'fSystemlog_Archive', 'read', PL_SYSTEMLOG_H_ARCHIVE_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('archive_delete', 'fSystemlog_Archive_Delete', 'read');
	$_SESSION['sbPlugins']->addUserEvent('archive_view', 'fSystemlog_Archive_View', 'read');
	$_SESSION['sbPlugins']->addUserEvent('archive_excel', 'fSystemlog_Archive_Excel', 'read');
	
	$_SESSION['sbPlugins']->addSystemEvent('info', 'fSystemlog_Info');
	
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_system_log_delim', PL_SYSTEMLOG_H_PLUGIN_NAME, '', '', '', 'all');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_system_log_date', PL_SYSTEMLOG_H_SETTING_DATE, 'number', '', '5', 'all');
	$_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_system_log_errors', PL_SYSTEMLOG_H_SETTING_ERRORS, 'checkbox', '', '1', 'all');
	
	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_system_log_user_delim', PL_SYSTEMLOG_H_PLUGIN_NAME, '', '');
	$_SESSION['sbPlugins']->addUserSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_system_log_main_page_count', PL_SYSTEMLOG_H_USER_SETTING_COUNT, 'number', '', '7');
}

$_SESSION['sbPlugins']->addToCron('pl_systemlog/cron/pl_systemlog.php', 'fSystemlog_Create_Archive', PL_SYSTEMLOG_H_CRON_TITLE, PL_SYSTEMLOG_H_CRON_DESCR);
?>