<?php
function fSystemlog_Read()
{
    echo '<style type="text/css">
        #event_content table.form tr.even:hover,
        #event_content table.form tr.odd:hover
        {
            background-color: #E1FFE1;
        }

        #event_content
        {
            overflow-x: auto;
        }
    </style>
    <script>
    document.body.onselectstart = "";
    document.body.setAttribute("unselectable", "off");

    function showFilter()
    {
        var filter = sbGetE("sb_filter");
        var filter_arr = sbGetE("filter_arrow");
        if (!filter) return;
        if (filter.style.display == "none")
        {
            filter.style.display = "";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
        }
        else
        {
            filter.style.display = "none";
            filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
        }
    }
    function setFilter()
    {
        var str = "' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_read' . (isset($_GET['order']) ? '&order=' . $_GET['order'] : '') . '";
        var found = false;
        var frm = sbGetE("filter_form");
        for (var i = 0; i < frm.elements.length; i++)
        {
            var el = frm.elements[i];
            if (el.type == "select-one")
            {
                if (el.value != -1)
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
            else
            {
                if (el.name != "" && el.value != "")
                {
                    str += "&"+el.name+"="+el.value;
                    found = true;
                }
            }
        }
        if (!found)
        {
            return false;
        }

        window.location = str;
        return false;
    }
    function removeFilter(e)
    {
        window.location = "' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_read' . (isset($_GET['order']) ? '&order=' . $_GET['order'] : '') . '";
        return sbCancelEvent(e);
    }
    function refreshJournal()
    {
        window.location = "' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_read' . (isset($_GET['order']) ? '&order=' . $_GET['order'] : '') . (isset($_GET['sl_date_from']) ? '&sl_date_from=' . $_GET['sl_date_from'] : '') . (isset($_GET['sl_date_to']) ? '&sl_date_to=' . $_GET['sl_date_to'] : '') . (isset($_GET['sl_user_login']) ? '&sl_user_login=' . $_GET['sl_user_login'] : '') . (isset($_GET['sl_user_ip']) ? '&sl_user_ip=' . $_GET['sl_user_ip'] : '') . (isset($_GET['sl_domain']) ? '&sl_domain=' . $_GET['sl_domain'] : '') . (isset($_GET['sl_message']) ? '&sl_message=' . $_GET['sl_message'] : '') . '";
    }
    </script>';

    $time = time() - intval(sbPlugins::getSetting('sb_system_log_date')) * 24 * 60 * 60;
    sql_param_query('DELETE FROM sb_system_log WHERE sl_date < ?', $time);

    if (isset($_GET['clear'])) {
        sql_param_query('DELETE FROM sb_system_log');
    }

    if (!isset($_GET['order'])) {
        $_GET['order'] = 'sl_date|desc';
    } else {
        $_GET['order'] = preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']);
        if (empty($_GET['order'])) {
            $_GET['order'] = 'sl_date|desc';
        }
    }

    $order_str = explode('|', $_GET['order']);
    if (count($order_str) == 2) {
        $order_str = 'ORDER BY sl.' . $order_str[0] . ' ' . strtoupper($order_str[1]) . ', sl.sl_id DESC';
    } else {
        $order_str = 'ORDER BY sl.sl_id DESC';
    }

    $filter_str = '';
    if (isset($_GET['sl_date_from']) && !empty($_GET['sl_date_from'])) {
        $_GET['sl_date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['sl_date_from']);
        $date_time = explode(' ', $_GET['sl_date_from']);
        if (count($date_time) > 0) {
            $filter_str .= ' AND sl.sl_date >= ' . sb_datetoint($_GET['sl_date_from']);
        }
    }

    if (isset($_GET['sl_date_to']) && !empty($_GET['sl_date_to'])) {
        $_GET['sl_date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['sl_date_to']);
        $date_time = explode(' ', $_GET['sl_date_to']);
        if (count($date_time) > 0) {
            $filter_str .= ' AND sl.sl_date <= ' . sb_datetoint($_GET['sl_date_to']);
        }
    }

    if (isset($_GET['sl_user_login']) && !empty($_GET['sl_user_login'])) {
        $_GET['sl_user_login'] = preg_replace('/[^a-zA-Z0-9\_\-]+/', '', $_GET['sl_user_login']);
        if (!empty($_GET['sl_user_login'])) {
            $filter_str .= ' AND sl.sl_user_login = "' . $_GET['sl_user_login'] . '"';
        }
    }

    if (isset($_GET['sl_user_ip']) && !empty($_GET['sl_user_ip'])) {
        $_GET['sl_user_ip'] = preg_replace('/[^0-9\.]+/', '', $_GET['sl_user_ip']);
        if (!empty($_GET['sl_user_ip'])) {
            $filter_str .= ' AND sl.sl_user_ip LIKE "' . $_GET['sl_user_ip'] . '%"';
        }
    }

    if (isset($_GET['sl_domain']) && !empty($_GET['sl_domain'])) {
        $_GET['sl_domain'] = preg_replace('/[^a-zA-Z0-9\-\.]+/', '', $_GET['sl_domain']);

        if (!empty($_GET['sl_domain'])) {
            $filter_str .= ' AND sl.sl_domain = "' . $_GET['sl_domain'] . '"';
        }
    }

    if (isset($_GET['sl_type']) && !empty($_GET['sl_type'])) {
        $filter_str .= ' AND sl.sl_type = ' . intval($_GET['sl_type']);
    }

    if (isset($_GET['sl_message']) && !empty($_GET['sl_message'])) {
        $filter_str .= ' AND sl.sl_message LIKE ' . $GLOBALS['sbSql']->escape('%' . trim($_GET['sl_message']) . '%');
    }

    $href = SB_CMS_CONTENT_FILE . '?event=pl_systemlog_read';
    $excel_href = SB_CMS_EMPTY_FILE . '?event=pl_systemlog_excel';
    $archive_href = SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive';
    $delete_href = SB_CMS_CONTENT_FILE . "?event=pl_systemlog_read&clear=true";

    foreach ($_GET as $key => $value) {
        if ($key != 'event') {
            if (!is_array($value)) {
                if ($key != 'order') {
                    $href .= '&' . $key . '=' . urlencode($value);
                }
                $excel_href .= '&' . $key . '=' . urlencode($value);
            } else {
                foreach ($value as $value2) {
                    if ($key != 'order') {
                        $href .= '&' . $key . '[]' . '=' . urlencode($value2);
                    }
                    $excel_href .= '&' . $key . '[]' . '=' . urlencode($value2);
                }
            }
        }
    }

    echo '
    <table cellpadding="0" cellspacing="0" width="100%" align="center">
    <tr id="filter_header">
        <td width="100%" class="sb_filter_header">
            <table cellpadding="0" cellspacing="0">
            <tr>
                <td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">' . KERNEL_FILTER . '&nbsp;&nbsp;<img src="' . SB_CMS_IMG_URL . '/' . ($filter_str != '' ? 'fil_arrow_up' : 'fil_arrow_down') . '.gif" id="filter_arrow" align="absmiddle" /></span></td>
                <td class="sb_filter_on" id="sb_filter_on" style="' . ($filter_str != '' ? '' : 'visibility: hidden;') . '"><nobr><img src="' . SB_CMS_IMG_URL . '/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;' . SB_ELEMS_FILTER_ON . '&nbsp;&nbsp;<img src="' . SB_CMS_IMG_URL . '/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="' . SB_CMS_IMG_URL . '/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;' . KERNEL_CANCEL . '</span></nobr></td>
            </tr></table>
        </td>
    </tr>
    <tr><td valign="top">
            <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
            <div id="sb_filter"' . ($filter_str != '' ? '' : ' style="display:none;"') . '>
            <table cellpadding="0" cellspacing="0" class="sb_filter_table">
            <tr>
                <th class="sb_filter_th">' . PL_SYSTEMLOG_DATE . ':</th>
                <td class="sb_filter_td"><nobr>';

    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $fld_lo = new sbLayoutDate((isset($_GET['sl_date_from']) ? $_GET['sl_date_from'] : ''), 'sl_date_from');
    $fld_lo->mDropButton = true;

    $fld_hi = new sbLayoutDate((isset($_GET['sl_date_to']) ? $_GET['sl_date_to'] : ''), 'sl_date_to');
    $fld_hi->mDropButton = true;

    echo $fld_lo->getJavaScript() .
        '<table cellpadding="0" cellspacing="0"><tr><td>' . KERNEL_FROM . '&nbsp;&nbsp;</td><td>' . $fld_lo->getField() . '</td><td>&nbsp;&nbsp;' . KERNEL_TO . '&nbsp;&nbsp;</td><td>' . $fld_hi->getField() . '</td></tr></table>
        </nobr>
                </td>
                <th class="sb_filter_th">' . PL_SYSTEMLOG_DOMAIN . ':</th>
                <td class="sb_filter_td_noborder">';

    require_once(SB_CMS_LIB_PATH . '/sbIDN.inc.php');
    $idn = new sbIDN();

    $options = array('-1' => ' --- ');
    $u_domains = array();
    foreach ($GLOBALS['sb_domains'] as $domain => $value) {
        $options[$domain] = $idn->decode($domain);
        $u_domains[] = $domain;
    }

    $fld = new sbLayoutSelect($options, 'sl_domain');
    if (isset($_GET['sl_domain'])) {
        $fld->mSelOptions[] = $_GET['sl_domain'];
    }
    echo $fld->getField();

    echo '      </td>
            </tr>
            <tr>
                <th class="sb_filter_th">' . PL_SYSTEMLOG_IP . ':</th>
                <td class="sb_filter_td">';

    $fld = new sbLayoutInput('text', isset($_GET['sl_user_ip']) ? $_GET['sl_user_ip'] : '', 'sl_user_ip', '', 'style="width: 100%;"');
    echo $fld->getField();

    echo '      </td>
                <th class="sb_filter_th">' . PL_SYSTEMLOG_LOGIN . ':</th>
                <td class="sb_filter_td_noborder">';

    $options = array('-1' => ' --- ');
    $res = sql_query('SELECT DISTINCT sl_user_login FROM sb_system_log ORDER BY sl_user_login ASC');
    if ($res) {
        foreach ($res as $val) {
            list($login) = $val;
            $options[$login] = $login;
        }
    }

    $fld = new sbLayoutSelect($options, 'sl_user_login');
    if (isset($_GET['sl_user_login'])) {
        $fld->mSelOptions[] = $_GET['sl_user_login'];
    }
    echo $fld->getField();

    echo '      </td>
            </tr>
            <tr>
                <th class="sb_filter_th">' . PL_SYSTEMLOG_MESSAGE . ':</th>
                <td class="sb_filter_td">';

    $fld = new sbLayoutInput('text', isset($_GET['sl_message']) ? $_GET['sl_message'] : '', 'sl_message', '', 'style="width: 100%;"');
    echo $fld->getField();

    echo '      </td>
                <th class="sb_filter_th">' . PL_SYSTEMLOG_TYPE . ':</th>
                <td class="sb_filter_td_noborder">';

    $options = array(
        '' => ' --- ',
        '1' => PL_SYSTEMLOG_TYPE_INFO,
        '2' => PL_SYSTEMLOG_TYPE_PREVEN,
        '3' => PL_SYSTEMLOG_TYPE_WARN,
        '4' => PL_SYSTEMLOG_TYPE_PHP_WARN,
        '5' => PL_SYSTEMLOG_TYPE_MYSQL_WARN
    );

    $fld = new sbLayoutSelect($options, 'sl_type');
    if (isset($_GET['sl_type'])) {
        $fld->mSelOptions[] = $_GET['sl_type'];
    }
    echo $fld->getField();

    echo '        </td>
            </tr>
            </table>
            <div class="sb_filter_footer">
                    <input type="submit" value="' . KERNEL_APPLY . '">&nbsp;&nbsp;
            </div>
            </div>
            </form>
        </table>
    </td></tr></table>
    <br>
    <center>
    <div align="right" style="width:95%">
    <a href="javascript:refreshJournal();"><img src="' . SB_CMS_IMG_URL . '/link.png" width="12" height="12" border="0" align="absmiddle">&nbsp;' . PL_SYSTEMLOG_REFRESH . '</a>
    &nbsp;&nbsp;&nbsp;
    <a href="' . $excel_href . '" target="_blank"><img src="' . SB_CMS_IMG_URL . '/icon_excel.png" width="20" height="20" border="0" align="absmiddle">&nbsp;' . PL_SYSTEMLOG_EXCEL . '</a>
    &nbsp;&nbsp;&nbsp;
    <a href="' . $archive_href . '"><img src="' . SB_CMS_IMG_URL . '/icon_archive.png" width="20" height="20" border="0" align="absmiddle">&nbsp;' . PL_SYSTEMLOG_ARCHIVE . '</a>
    &nbsp;&nbsp;&nbsp;
	<a href="' . $delete_href . '"><img src="' . SB_CMS_IMG_URL . '/warning_log.png" width="20" height="20" border="0" align="absmiddle">&nbsp;' . PL_SYSTEMLOG_DELETE . '</a>
    </div>';

    require_once(SB_CMS_LIB_PATH . '/sbDBPager.inc.php');

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $domains) = $res[0];

    $total = true;
    $pager = new sbDBPager('sl', 7, 25, 'content');

    if ($u_admin != 1) {
        $u_domains = explode(',', $domains);
        $result = $pager->init($total,
            'SELECT sl.sl_date, sl.sl_user_login, su.u_id, su.u_login, sl.sl_user_ip, sl.sl_message, sl.sl_type, sl.sl_domain FROM sb_system_log sl LEFT JOIN sb_users su ON sl.sl_user_id=su.u_id WHERE sl.sl_domain IN (?a) ' . $filter_str . ' ' . $order_str,
            $u_domains);
    } else {
        $result = $pager->init($total,
            'SELECT sl.sl_date, sl.sl_user_login, su.u_id, su.u_login, sl.sl_user_ip, sl.sl_message, sl.sl_type, sl.sl_domain FROM sb_system_log sl LEFT JOIN sb_users su ON sl.sl_user_id=su.u_id ' . ($filter_str != '' ? 'WHERE ' . substr($filter_str,
                    5) : '') . ' ' . $order_str);
    }

    $num_list = $pager->show();

    echo '<br>' . $num_list . '<br><br>
    <table width="98%" cellspacing="0" cellpadding="5" class="form">
    <tr>
        <th class="header" width="50">
            <nobr>
                <a href="' . $href . '&order=sl_type|asc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_type|asc' ? 's_asc_sel.gif' : 's_asc.gif') . '" border="0" width="11" height="9"></a>
                &nbsp;' . PL_SYSTEMLOG_TYPE . '&nbsp;
                <a href="' . $href . '&order=sl_type|desc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_type|desc' ? 's_desc_sel.gif' : 's_desc.gif') . '" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" width="80">
            <nobr>
                <a href="' . $href . '&order=sl_date|asc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_date|asc' ? 's_asc_sel.gif' : 's_asc.gif') . '" border="0" width="11" height="9"></a>
                &nbsp;' . PL_SYSTEMLOG_DATE . '&nbsp;
                <a href="' . $href . '&order=sl_date|desc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_date|desc' ? 's_desc_sel.gif' : 's_desc.gif') . '" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" width="70">
            <nobr>
                <a href="' . $href . '&order=sl_user_ip|asc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_user_ip|asc' ? 's_asc_sel.gif' : 's_asc.gif') . '" border="0" width="11" height="9"></a>
                &nbsp;' . PL_SYSTEMLOG_IP . '&nbsp;
                <a href="' . $href . '&order=sl_user_ip|desc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_user_ip|desc' ? 's_desc_sel.gif' : 's_desc.gif') . '" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" width="100">
            <nobr>
                <a href="' . $href . '&order=sl_user_login|asc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_user_login|asc' ? 's_asc_sel.gif' : 's_asc.gif') . '" border="0" width="11" height="9"></a>
                &nbsp;' . PL_SYSTEMLOG_LOGIN . '&nbsp;
                <a href="' . $href . '&order=sl_user_login|desc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_user_login|desc' ? 's_desc_sel.gif' : 's_desc.gif') . '" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header" width="100">
            <nobr>
                <a href="' . $href . '&order=sl_domain|asc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_domain|asc' ? 's_asc_sel.gif' : 's_asc.gif') . '" border="0" width="11" height="9"></a>
                &nbsp;' . PL_SYSTEMLOG_DOMAIN . '&nbsp;
                <a href="' . $href . '&order=sl_domain|desc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_domain|desc' ? 's_desc_sel.gif' : 's_desc.gif') . '" border="0" width="11" height="9"></a>
            </nobr>
        </th>
        <th class="header">
            <nobr>
                <a href="' . $href . '&order=sl_message|asc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_message|asc' ? 's_asc_sel.gif' : 's_asc.gif') . '" border="0" width="11" height="9"></a>
                &nbsp;' . PL_SYSTEMLOG_MESSAGE . '&nbsp;
                <a href="' . $href . '&order=sl_message|desc"><img src="' . SB_CMS_IMG_URL . '/' . ($_GET['order'] == 'sl_message|desc' ? 's_desc_sel.gif' : 's_desc.gif') . '" border="0" width="11" height="9"></a>
            </nobr>
        </th>
    </tr>';

    if ($result) {
        /**
         * Вывод таблицы
         */
        $view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read');

        for ($i = 0; $i < count($result); $i++) {
            list($sl_date, $sl_user_login, $u_id, $u_login, $sl_user_ip, $sl_message, $sl_type, $sl_domain) = $result[$i];

            if (!is_null($u_login)) {
                $sl_user_login = $u_login;
            }

            switch ($sl_type) {
                case 1:
                    $img = 'information_log.png';
                    break;
                case 2:
                    $img = 'prevention_log.png';
                    break;
                case 3:
                case 4:
                case 5:
                    $img = 'warning_log.png';
                    break;
                default:
                    $img = '';
                    break;
            }

            if (!is_null($u_id) && ($_SESSION['sbAuth']->isAdmin() || $view_info || $_SESSION['sbAuth']->getUserId() == $u_id)) {
                $sl_user_login = '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_kernel_user_info&id=' . $u_id . '" class="small">' . $sl_user_login . '</a>';
            }

            echo '<tr' . ($i % 2 != 0 ? ' class="even"' : ' class="odd"') . '>
                    <td style="text-align:center;">
                        <img src="' . SB_CMS_IMG_URL . '/' . $img . '" \>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        ' . sb_date('d.m.Y', $sl_date) . '<br />' . KERNEL_IN . '<br />' . sb_date('H:i:s', $sl_date) . '
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        ' . $sl_user_ip . '
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>' . $sl_user_login . '</b>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>' . $idn->decode($sl_domain) . '</b>
                    </td>
                    <td>';

            if ($sl_type == 3 || $sl_type == 4 || $sl_type == 5) {
                $debug_message = preg_replace('/ +/ms', ' ',
                    strip_tags(sb_str_replace(array('<br>', '<br />', '</tr>', '</td>', '</th>'), array("\n", "\n", "\n", " ", " "), $sl_message)));
                $debug_message = preg_replace('/\t+/ms', ' ', $debug_message);

                echo '<div class="hint_div">' . sb_break_long_words($sl_message, 70, '<br />') . '</div>';
                echo sbAuth::checkSupport() ? '<form action="http://www.sbuilder.ru/support/cabinet/" method="post" target="_blank">
                    <textarea name="tp_message" style="display: none;">[sb_error]' . $debug_message . '[/sb_error]</textarea>
                    <input type="hidden" name="tp_subject" value="' . PL_SYSTEMLOG_TP_SUBJECT . '" />
                    <input type="hidden" name="lic" value="' . SB_CLIENT_LIC . '" />
                    <input type="hidden" name="domain" value="' . SB_MAIN_DOMAIN . '" />
                    <div><input type="submit" value="' . PL_SYSTEMLOG_ERROR_BTN . '" class="tp_button" /></div>
                    </form>' : '';
            } else {
                echo '<div class="hint_div">' . $sl_message . '</div>';
            }

            echo '  </td>
                </tr>';
        }
    } else {
        $num_list = sb_show_message(PL_SYSTEMLOG_NO_MESSAGES, true, 'information', true);
    }

    echo '</table>
          <br>' . $num_list . '<br><br></center>';
}

function fSystemlog_Excel()
{
    header('Content-type: application/vnd.ms-excel; charset=' . strtolower(SB_CHARSET), true);
    header('Content-Disposition: attachment; filename="sbuilder_system_log.xls"');

    echo '<html>
        <head>
        <title></title>
        <meta http-equiv="Content-Type" content="text/html; charset=' . strtolower(SB_CHARSET) . '">
        <body>';

    if (!isset($_GET['order'])) {
        $_GET['order'] = 'sl_date|desc';
    } else {
        $_GET['order'] = preg_replace('/[^a-zA-Z0-9_|]+/', '', $_GET['order']);
        if (empty($_GET['order'])) {
            $_GET['order'] = 'sl_date|desc';
        }
    }

    $order_str = explode('|', $_GET['order']);
    if (count($order_str) == 2) {
        $order_str = 'ORDER BY sl.' . $order_str[0] . ' ' . strtoupper($order_str[1]) . ', sl.sl_id DESC';
    } else {
        $order_str = 'ORDER BY sl.sl_id DESC';
    }

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $domains) = $res[0];

    $u_domains = explode(',', $domains);

    $result = sql_param_query('SELECT sl.sl_date, sl.sl_user_login, su.u_login, sl.sl_user_ip, sl.sl_message, sl.sl_type, sl.sl_domain FROM sb_system_log sl LEFT JOIN sb_users su ON sl.sl_user_id=su.u_id {WHERE sl.sl_domain IN (?a)} ' . $order_str,
        ($u_admin != 1 ? $u_domains : SB_SQL_SKIP));

    if ($result) {
        /**
         * Вывод таблици
         */
        echo '<table border="1">
              <tr>
                <th width="100">
                    &nbsp;' . PL_SYSTEMLOG_TYPE . '&nbsp;
                </th>
                <th width="160">
                    &nbsp;' . PL_SYSTEMLOG_DATE . '&nbsp;
                </th>
                <th width="80">
                    &nbsp;' . PL_SYSTEMLOG_IP . '&nbsp;
                </th>
                <th width="100">
                    &nbsp;' . PL_SYSTEMLOG_LOGIN . '&nbsp;
                </th>
                <th width="100">
                    &nbsp;' . PL_SYSTEMLOG_DOMAIN . '&nbsp;
                </th>
                <th>
                    &nbsp;' . PL_SYSTEMLOG_MESSAGE . '&nbsp;
                </th>
             </tr>';

        require_once(SB_CMS_LIB_PATH . '/sbIDN.inc.php');
        $idn = new sbIDN();

        for ($i = 0; $i < count($result); $i++) {
            list($sl_date, $sl_user_login, $u_login, $sl_user_ip, $sl_message, $sl_type, $sl_domain) = $result[$i];

            if ($u_login != '') {
                $sl_user_login = $u_login;
            }

            switch ($sl_type) {
                case 1:
                    $sl_type = '<span style="color:green;">' . PL_SYSTEMLOG_TYPE_INFO . '</span>';
                    break;
                case 2:
                    $sl_type = '<span style="color:orange;">' . PL_SYSTEMLOG_TYPE_PREVEN . '</span>';
                    break;
                case 3:
                case 4:
                case 5:
                    $sl_type = '<span style="color:red;">' . PL_SYSTEMLOG_TYPE_WARN . '</span>';
                    break;
                default:
                    $sl_type = '';
                    break;
            }

            echo '<tr>
                    <td align="center" width="100" valign="top">
                        &nbsp;' . $sl_type . '&nbsp;
                    </td>
                    <td align="center" width="160" valign="top">
                        ' . sb_date('d.m.Y ' . KERNEL_IN . ' H:i:s', $sl_date) . '
                    </td>
                    <td align="center" width="80" valign="top">
                        ' . $sl_user_ip . '
                    </td>
                    <td align="center" width="100" valign="top">
                        <b>' . $sl_user_login . '</b>
                    </td>
                    <td align="center" width="100" valign="top">
                        <b>' . $idn->decode($sl_domain) . '</b>
                    </td>
                    <td valign="top">
                        ' . $sl_message . '
                    </td>
                </tr>';
        }

        echo '</table>';
    }

    echo '</body></html>';
}

function fSystemlog_Archive()
{
    require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mShowTitle = false;

    echo '<script>
    function deleteFile(file, page)
    {
        var str = file == "all" ? "' . PL_SYSTEMLOG_ARCHIVE_DELETE_ALL_REQUEST . '" : "' . PL_SYSTEMLOG_ARCHIVE_REQUEST . '";

        if(confirm(str))
        {
            var res = sbLoadSync("' . SB_CMS_EMPTY_FILE . '?event=pl_systemlog_archive_delete&file="+file);
            if(res != "")
            {
                sbShowMsgDiv(res, "warning.png");
            }

            if (file == "all")
            {
                window.location = sb_cms_content_file + "?event=pl_systemlog_archive";
            }
            else if (res == "")
            {
                window.location = sb_cms_content_file + "?event=pl_systemlog_archive&page_archive=" + page;
            }
        }
    }
    </script>
    <br /><br />';

    $dir = $GLOBALS['sbVfs']->scandir('cms/backup/');

    $pagesCount = 25;  // Кол-во архивов на одной странице
    $points = array(); // Массив точек восстановления

    // Сканируем папку
    for ($i = count($dir) - 1; $i >= 0; $i--) {
        if ($GLOBALS['sbVfs']->is_file('cms/backup/' . $dir[$i]) && strpos($dir[$i], 'log_') === 0) {
            $ext = explode('.', $dir[$i]);
            if (count($ext) != 2) {
                continue;
            }

            $file = $ext[0];
            if (!isset($points[$file])) {
                $points[$file] = array();
            }

            $points[$file]['date_end'] = str_replace('_', '.', substr($file, 4, 10));
            $points[$file]['time_end'] = str_replace('_', ':', substr($file, 15, 8));
            $points[$file]['date_start'] = str_replace('_', '.', substr($file, 25, 10));
            $points[$file]['time_start'] = str_replace('_', ':', substr($file, 36, 8));

            $points[$file]['type'] = $ext[1];
        }
    }

    function cmp_dates(&$ar1, &$ar2)
    {
        $time1 = sb_datetoint($ar1['date_end'] . ' ' . $ar1['time_end']);
        $time2 = sb_datetoint($ar2['date_end'] . ' ' . $ar2['time_end']);

        if ($time1 > $time2) {
            return -1;
        }
        if ($time1 < $time2) {
            return 1;
        }

        return 0;
    }

    uasort($points, 'cmp_dates');

    // Настраиваем страницы
    $num = count($points); // Всего архивов
    if ($num > 0) {
        // Всего страниц
        $totalPages = ceil($num / $pagesCount);

        // Номер текущей страницы
        if (isset($_GET['page_archive'])) {
            $page = min(max(1, intval($_GET['page_archive'])), $totalPages);
            $_GET['page_archive'] = $page;
        } else {
            $page = 1;
        }

        require_once(SB_CMS_LIB_PATH . '/sbDBPager.inc.php');

        $pager = new sbDBPager('archive', 7, $pagesCount);

        $pager->mNumberTemp = '&nbsp;<a href="{HREF}">{NUMBER}</a>&nbsp;';

        $pager->mBeginTemp = '<a href="{HREF}"><img src="' . SB_CMS_IMG_URL . '/begin.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_BEGIN . '" align="absmiddle"></a>';
        $pager->mBeginTempDisabled = '<img src="' . SB_CMS_IMG_URL . '/begin_gray.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_BEGIN . '" align="absmiddle">';

        $pager->mPrevTemp = '<a href="{HREF}"><img src="' . SB_CMS_IMG_URL . '/previous.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_PREV . '" align="absmiddle"></a>';
        $pager->mPrevTempDisabled = '<img src="' . SB_CMS_IMG_URL . '/previous_gray.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_PREV . '" align="absmiddle">';

        $pager->mNextTemp = '<a href="{HREF}"><img src="' . SB_CMS_IMG_URL . '/next.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_NEXT . '" align="absmiddle"></a>';
        $pager->mNextTempDisabled = '<img src="' . SB_CMS_IMG_URL . '/next_gray.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_NEXT . '" align="absmiddle">';

        $pager->mEndTemp = '<a href="{HREF}"><img src="' . SB_CMS_IMG_URL . '/end.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_END . '" align="absmiddle"></a>';
        $pager->mEndTempDisabled = '<img src="' . SB_CMS_IMG_URL . '/end_gray.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_END . '" align="absmiddle">';

        $pager->mNumElemsAll = $num;

        $labels = array(PL_SYSTEMLOG_ARCHIVE_TITLE, '');
        $values = array();

        $from = ($page - 1) * $pagesCount; // номер точки восстановления с которой нужно начать выводить список
        $to = min($num, $from + $pagesCount);
        $i = 0;
        foreach ($points as $file => $point) {
            if ($i < $from) {
                $i++;
                continue;
            }

            if ($i >= $to) {
                break;
            }

            if (isset($point['date_start']) && isset($point['date_end']) && isset($point['time_start']) && isset($point['time_end'])) {
                $values[] = array(
                    PL_SYSTEMLOG_ARCHIVE_PERIOD . ' ' . KERNEL_DATE_FROM . ' <i>' . $point['date_start'] . ' ' . $point['time_start'] . '</i> ' . KERNEL_DATE_TO . ' <i>' . $point['date_end'] . ' ' . $point['time_end'] . '</i> &nbsp; <a href="' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive_view&file=' . $file . '">' . KERNEL_MORE . '</a>',
                    '<img class="button" src="' . SB_CMS_IMG_URL . '/files_drop.png" width="20" height="20" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" alt="' . PL_SYSTEMLOG_ARCHIVE_DELETE_POINT . '" onclick="deleteFile(\'' . $file . '\', ' . $page . ');">'
                );
            } else {
                $values[] = array(
                    '<div class="hint_div">' . PL_SYSTEMLOG_ARCHIVE_CORRUPTED . '</div>',
                    '<img class="button" src="' . SB_CMS_IMG_URL . '/files_drop.png" width="20" height="20" onmouseup="sbPress(this, false);" onmousedown="sbPress(this, true);" alt="' . PL_SYSTEMLOG_ARCHIVE_DELETE_POINT . '" onclick="deleteFile(\'' . $file . '\', ' . $page . ');">'
                );
            }

            $i++;
        }

        $field = new sbLayoutTable($labels, $values);
        $field->mWidth = array('', '20');
        $field->mAlign = array('left', '');
        $field->mShowTable = true;
        $layout->addField('', $field);

        $html = '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_read">[ ' . KERNEL_BACK . ' ]</a> &nbsp;&nbsp;&nbsp; <a href="javascript:deleteFile(\'all\');">[ ' . PL_SYSTEMLOG_ARCHIVE_DELETE_ALL . ' ]</a>';
        $layout->addField('', new sbLayoutHTML($html), '', 'align = "right"');

        $pages = $pager->show();

        if ($pages != '') {
            $layout->addField('', new sbLayoutDelim());
            $layout->addField('', new sbLayoutHTML('<center>' . $pages . '</center>'));
        }
    } else {
        $layout->addField('',
            new sbLayoutHTML(sb_show_message(PL_SYSTEMLOG_ARCHIVE_EMPTY . '<br /><br /><div align="center"><a href="' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_read">[ ' . KERNEL_BACK . ' ]</a></div>',
                    true, 'information', true) . '<br /><br />'));
    }

    $layout->show();
}

function fSystemlog_Archive_Delete()
{
    if (!isset($_GET['file']) || (strpos($_GET['file'], 'log_') !== 0 && $_GET['file'] != 'all')) {
        echo PL_SYSTEMLOG_ARCHIVE_DELETE_ERROR;
        return;
    }

    $_GET['file'] = preg_replace('/[^a-zA-Z_0-9]/', '', $_GET['file']);

    $error = false;   // флаг ошибки

    if ($_GET['file'] == 'all') {
        $dir = $GLOBALS['sbVfs']->scandir('cms/backup/');
        foreach ($dir as $value) {
            if ($GLOBALS['sbVfs']->is_file('cms/backup/' . $value) && strpos($value, 'log_') === 0) {
                $error = !$GLOBALS['sbVfs']->delete('cms/backup/' . $value);
            }
        }
    } else {
        $file_zip = 'cms/backup/' . $_GET['file'] . '.zip';
        $file_xml = 'cms/backup/' . $_GET['file'] . '.xml';

        if ($GLOBALS['sbVfs']->exists($file_zip) && !$GLOBALS['sbVfs']->delete($file_zip)) {
            $error = true;
        }

        if ($GLOBALS['sbVfs']->exists($file_xml) && !$GLOBALS['sbVfs']->delete($file_xml)) {
            $error = true;
        }
    }

    if ($error && $_GET['file'] != 'all') {
        sb_add_system_message(PL_SYSTEMLOG_ARCHIVE_DELETE_SYSTEMLOG_ERROR, SB_MSG_WARNING);
        echo PL_SYSTEMLOG_ARCHIVE_DELETE_ERROR;
        return;
    }

    if ($_GET['file'] == 'all') {
        sb_add_system_message(PL_SYSTEMLOG_ARCHIVE_DELETE_ALL_OK);
    } else {
        sb_add_system_message(sprintf(PL_SYSTEMLOG_ARCHIVE_DELETE_OK, $_GET['file']));
    }
}

function fSystemlog_Archive_View()
{
    if (!isset($_GET['file']) || strpos($_GET['file'], 'log_') !== 0) {
        sb_show_message(PL_SYSTEMLOG_ARCHIVE_CORRUPTED . '<br /><br /><div align="center"><a href="' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive">[ ' . KERNEL_BACK . ' ]</a></div>',
            true, 'information');
        return;
    }

    $_GET['file'] = preg_replace('/[^a-zA-Z_0-9]/', '', $_GET['file']);

    $file_zip = 'cms/backup/' . $_GET['file'] . '.zip';
    $file_xml = 'cms/backup/' . $_GET['file'] . '.xml';

    $zip = false;
    $xml = false;

    if ($GLOBALS['sbVfs']->exists($file_zip)) {
        $zip = true;
    }

    if ($GLOBALS['sbVfs']->exists($file_xml)) {
        $xml = true;
    }

    if (!$zip && !$xml) {
        sb_show_message(PL_SYSTEMLOG_ARCHIVE_CORRUPTED . '<br /><br /><div align="center"><a href="' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive">[ ' . KERNEL_BACK . ' ]</a></div>',
            true, 'information');
        return;
    }

    if ($zip) {
        $tmp_id = uniqid();
        $tmp_dir = SB_CMS_TMP_PATH . '/' . $tmp_id;

        $GLOBALS['sbVfs']->mLocal = true;

        if (!$GLOBALS['sbVfs']->exists($tmp_dir)) {
            if (!$GLOBALS['sbVfs']->mkdir($tmp_dir)) {
                sb_show_message(PL_SYSTEMLOG_ARCHIVE_VIEW_UNZIP_ERROR . '<br /><br /><div align="center"><a href="' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive">[ ' . KERNEL_BACK . ' ]</a></div>',
                    true, 'information');
                $GLOBALS['sbVfs']->mLocal = false;
                return;
            }
        }

        if (!$GLOBALS['sbVfs']->is_writable($tmp_dir)) {
            sb_show_message(PL_SYSTEMLOG_ARCHIVE_VIEW_UNZIP_ERROR . '<br /><br /><div align="center"><a href="' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive">[ ' . KERNEL_BACK . ' ]</a></div>',
                true, 'information');
            $GLOBALS['sbVfs']->mLocal = false;
            return;
        }

        $file = $tmp_dir . str_replace('cms/backup', '', $file_xml);

        if (function_exists('gzopen64')) {
            $gz = @gzopen64(SB_BASEDIR . '/' . $file_zip, 'rb');
        } else {
            $gz = @gzopen(SB_BASEDIR . '/' . $file_zip, 'rb');
        }

        $fl = $GLOBALS['sbVfs']->fopen($file, 'ab');

        if (!$gz || !$fl) {
            sb_show_message(PL_SYSTEMLOG_ARCHIVE_VIEW_UNZIP_ERROR . '<br /><br /><div align="center"><a href="' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive">[ ' . KERNEL_BACK . ' ]</a></div>',
                true, 'information');
            if ($fl) {
                $GLOBALS['sbVfs']->fclose();
            }
            $GLOBALS['sbVfs']->delete($tmp_dir);
            $GLOBALS['sbVfs']->mLocal = false;
            return;
        }

        $GLOBALS['sbVfs']->mLocal = false;

        while (!@gzeof($gz)) {
            $str = trim(@gzgets($gz, 4096));
            $GLOBALS['sbVfs']->fwrite($str);
        }

        @gzclose($gz);
        $GLOBALS['sbVfs']->fclose();
        $GLOBALS['sbVfs']->mLocal = false;
    } else {
        $file = SB_BASEDIR . '/' . $file_xml;
    }

    $xml = simplexml_load_file($file);
    if (!$xml) {
        sb_show_message(PL_SYSTEMLOG_ARCHIVE_VIEW_XML_ERROR . '<br /><br /><div align="center"><a href="' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive">[ ' . KERNEL_BACK . ' ]</a></div>',
            true, 'information');
        if ($zip) {
            $GLOBALS['sbVfs']->mLocal = true;
            $GLOBALS['sbVfs']->delete($tmp_dir);
            $GLOBALS['sbVfs']->mLocal = false;
        }
        return;
    }

    $xpath = '/db/sb_system_log';
    $domain_xpath = '';
    $filter_xpath = '';

    if (isset($_GET['sl_date_from']) && !empty($_GET['sl_date_from'])) {
        $_GET['sl_date_from'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['sl_date_from']);
        $date_time = explode(' ', $_GET['sl_date_from']);
        if (count($date_time) > 0) {
            $filter_xpath .= 'sl_date >= "' . sb_datetoint($_GET['sl_date_from']) . '" and ';
        }
    }

    if (isset($_GET['sl_date_to']) && !empty($_GET['sl_date_to'])) {
        $_GET['sl_date_to'] = preg_replace('/[^0-9\.: ]+/', '', $_GET['sl_date_to']);
        $date_time = explode(' ', $_GET['sl_date_to']);
        if (count($date_time) > 0) {
            $filter_xpath .= 'sl_date <= "' . sb_datetoint($_GET['sl_date_to']) . '" and ';
        }
    }

    if (isset($_GET['sl_user_login']) && !empty($_GET['sl_user_login'])) {
        $_GET['sl_user_login'] = preg_replace('/[^a-zA-Z0-9]+/', '', $_GET['sl_user_login']);
        if (!empty($_GET['sl_user_login'])) {
            $filter_xpath .= 'sl_user_login="' . $_GET['sl_user_login'] . '" and ';
        }
    }

    if (isset($_GET['sl_user_ip']) && !empty($_GET['sl_user_ip'])) {
        $_GET['sl_user_ip'] = preg_replace('/[^0-9\.]+/', '', $_GET['sl_user_ip']);
        if (!empty($_GET['sl_user_ip'])) {
            $filter_xpath .= 'sl_user_ip = "' . $_GET['sl_user_ip'] . '" and ';
        }
    }

    if (isset($_GET['sl_domain']) && !empty($_GET['sl_domain'])) {
        $_GET['sl_domain'] = preg_replace('/[^a-zA-Z0-9\-\.]+/', '', $_GET['sl_domain']);

        if (!empty($_GET['sl_domain'])) {
            $filter_xpath .= 'sl_domain = "' . $_GET['sl_domain'] . '" and ';
        }
    }

    if (isset($_GET['sl_type']) && !empty($_GET['sl_type'])) {
        $filter_xpath .= 'sl_type = "' . intval($_GET['sl_type']) . '" and ';
    }

    if ($filter_xpath != '') {
        $filter_xpath = sb_substr($filter_xpath, 0, -5);
    }

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $u_domains) = $res[0];

    if ($u_admin != 1) {
        $u_domains = explode(',', $u_domains);

        $domain_xpath = array();
        foreach ($u_domains as $domain) {
            $domain_xpath[] = 'sl_domain="' . trim($domain) . '"';
        }

        $domain_xpath = '(' . implode(' or ', $domain_xpath) . ')';
    }

    if ($domain_xpath != '' || $filter_xpath != '') {
        $xpath .= '[' . $filter_xpath . ($filter_xpath != '' && $domain_xpath != '' ? ' and ' : '') . $domain_xpath . ']';
    }

    $xml = $xml->xpath($xpath);

    // Настраиваем страницы
    $pagesCount = 25;  // Кол-во сообщений на одной странице
    $num = 0;

    if ($xml) {
        $num = count($xml); // Всего сообщений
    }

    if ($num > 0) {
        echo '<style type="text/css">
            #event_content table.form tr.even:hover,
            #event_content table.form tr.odd:hover
            {
                background-color: #E1FFE1;
            }

            #event_content
            {
                overflow-x: auto;
            }
        </style>
        <script>
        document.body.onselectstart = "";
        document.body.setAttribute("unselectable", "off");

        function showFilter()
        {
            var filter = sbGetE("sb_filter");
            var filter_arr = sbGetE("filter_arrow");
            if (!filter) return;
            if (filter.style.display == "none")
            {
                filter.style.display = "";
                filter_arr.src = sb_cms_img_url + "/fil_arrow_up.gif";
            }
            else
            {
                filter.style.display = "none";
                filter_arr.src = sb_cms_img_url + "/fil_arrow_down.gif";
            }
        }
        function setFilter()
        {
            var str = "' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive_view&file=' . $_GET['file'] . '";
            var found = false;
            var frm = sbGetE("filter_form");
            for (var i = 0; i < frm.elements.length; i++)
            {
                var el = frm.elements[i];
                if (el.type == "select-one")
                {
                    if (el.value != -1)
                    {
                        str += "&"+el.name+"="+el.value;
                        found = true;
                    }
                }
                else
                {
                    if (el.name != "" && el.value != "")
                    {
                        str += "&"+el.name+"="+el.value;
                        found = true;
                    }
                }
            }
            if (!found)
            {
                return false;
            }

            window.location = str;
            return false;
        }
        function removeFilter(e)
        {
            window.location = "' . SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive_view&file=' . $_GET['file'] . '";
            return sbCancelEvent(e);
        }
        </script>';

        // Всего страниц
        $totalPages = ceil($num / $pagesCount);

        // Номер текущей страницы
        if (isset($_GET['page_archive'])) {
            $page = min(max(1, intval($_GET['page_archive'])), $totalPages);
            $_GET['page_archive'] = $page;
        } else {
            $page = 1;
        }

        require_once(SB_CMS_LIB_PATH . '/sbDBPager.inc.php');

        $pager = new sbDBPager('archive', 7, $pagesCount);

        $pager->mNumberTemp = '&nbsp;<a href="{HREF}">{NUMBER}</a>&nbsp;';

        $pager->mBeginTemp = '<a href="{HREF}"><img src="' . SB_CMS_IMG_URL . '/begin.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_BEGIN . '" align="absmiddle"></a>';
        $pager->mBeginTempDisabled = '<img src="' . SB_CMS_IMG_URL . '/begin_gray.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_BEGIN . '" align="absmiddle">';

        $pager->mPrevTemp = '<a href="{HREF}"><img src="' . SB_CMS_IMG_URL . '/previous.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_PREV . '" align="absmiddle"></a>';
        $pager->mPrevTempDisabled = '<img src="' . SB_CMS_IMG_URL . '/previous_gray.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_PREV . '" align="absmiddle">';

        $pager->mNextTemp = '<a href="{HREF}"><img src="' . SB_CMS_IMG_URL . '/next.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_NEXT . '" align="absmiddle"></a>';
        $pager->mNextTempDisabled = '<img src="' . SB_CMS_IMG_URL . '/next_gray.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_NEXT . '" align="absmiddle">';

        $pager->mEndTemp = '<a href="{HREF}"><img src="' . SB_CMS_IMG_URL . '/end.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_END . '" align="absmiddle"></a>';
        $pager->mEndTempDisabled = '<img src="' . SB_CMS_IMG_URL . '/end_gray.gif" width="14" height="15" border="0" alt="' . KERNEL_PAGER_END . '" align="absmiddle">';

        $pager->mNumElemsAll = $num;

        $num_list = $pager->show();

        $excel_href = SB_CMS_EMPTY_FILE . '?event=pl_systemlog_archive_excel&file=' . $_GET['file'];
        $archive_href = SB_CMS_CONTENT_FILE . '?event=pl_systemlog_archive';

        echo '<table cellpadding="0" cellspacing="0" width="100%" align="center">
        <tr id="filter_header">
            <td width="100%" class="sb_filter_header">
                <table cellpadding="0" cellspacing="0">
                <tr>
                    <td class="sb_filter_text"><span onclick="showFilter();" ondblclick="showFilter();" style="cursor:hand;cursor:pointer;">' . KERNEL_FILTER . '&nbsp;&nbsp;<img src="' . SB_CMS_IMG_URL . '/' . ($filter_xpath != '' ? 'fil_arrow_up' : 'fil_arrow_down') . '.gif" id="filter_arrow" align="absmiddle" /></span></td>
                    <td class="sb_filter_on" id="sb_filter_on" style="' . ($filter_xpath != '' ? '' : 'visibility: hidden;') . '"><nobr><img src="' . SB_CMS_IMG_URL . '/filter_on.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;' . SB_ELEMS_FILTER_ON . '&nbsp;&nbsp;<img src="' . SB_CMS_IMG_URL . '/filter_delim.gif" align="absmiddle" width="1" height="14">&nbsp;&nbsp;<span style="cursor: hand; cursor: pointer;" onclick="removeFilter(event);"><img src="' . SB_CMS_IMG_URL . '/filter_off.png" align="absmiddle" width="12" height="12">&nbsp;&nbsp;' . KERNEL_CANCEL . '</span></nobr></td>
                </tr></table>
            </td>
        </tr>
        <tr><td valign="top">
                <form id="filter_form" action="" method="get" onsubmit="return setFilter();">
                <div id="sb_filter"' . ($filter_xpath != '' ? '' : ' style="display:none;"') . '>
                <table cellpadding="0" cellspacing="0" class="sb_filter_table">
                <tr>
                    <th class="sb_filter_th">' . PL_SYSTEMLOG_DATE . ':</th>
                    <td class="sb_filter_td"><nobr>';

        require_once(SB_CMS_LIB_PATH . '/sbLayout.inc.php');

        $fld_lo = new sbLayoutDate((isset($_GET['sl_date_from']) ? $_GET['sl_date_from'] : ''), 'sl_date_from');
        $fld_lo->mDropButton = true;

        $fld_hi = new sbLayoutDate((isset($_GET['sl_date_to']) ? $_GET['sl_date_to'] : ''), 'sl_date_to');
        $fld_hi->mDropButton = true;

        echo $fld_lo->getJavaScript() .
            '<table cellpadding="0" cellspacing="0"><tr><td>' . KERNEL_FROM . '&nbsp;&nbsp;</td><td>' . $fld_lo->getField() . '</td><td>&nbsp;&nbsp;' . KERNEL_TO . '&nbsp;&nbsp;</td><td>' . $fld_hi->getField() . '</td></tr></table>
            </nobr>
                    </td>
                    <th class="sb_filter_th">' . PL_SYSTEMLOG_DOMAIN . ':</th>
                    <td class="sb_filter_td_noborder">';

        require_once(SB_CMS_LIB_PATH . '/sbIDN.inc.php');
        $idn = new sbIDN();

        $options = array('-1' => ' --- ');
        $u_domains = array();
        foreach ($GLOBALS['sb_domains'] as $domain => $value) {
            $options[$domain] = $idn->decode($domain);
            $u_domains[] = $domain;
        }

        $fld = new sbLayoutSelect($options, 'sl_domain');
        if (isset($_GET['sl_domain'])) {
            $fld->mSelOptions[] = $_GET['sl_domain'];
        }
        echo $fld->getField();

        echo '      </td>
                </tr>
                <tr>
                    <th class="sb_filter_th">' . PL_SYSTEMLOG_IP . ':</th>
                    <td class="sb_filter_td">';

        $fld = new sbLayoutInput('text', isset($_GET['sl_user_ip']) ? $_GET['sl_user_ip'] : '', 'sl_user_ip', '', 'style="width: 100%;"');
        echo $fld->getField();

        echo '      </td>
                    <th class="sb_filter_th">' . PL_SYSTEMLOG_LOGIN . ':</th>
                    <td class="sb_filter_td_noborder">';

        $options = array('-1' => ' --- ');
        $res = sql_query('SELECT DISTINCT sl_user_login FROM sb_system_log ORDER BY sl_user_login ASC');
        if ($res) {
            foreach ($res as $val) {
                list($login) = $val;
                $options[$login] = $login;
            }
        }

        $fld = new sbLayoutSelect($options, 'sl_user_login');
        if (isset($_GET['sl_user_login'])) {
            $fld->mSelOptions[] = $_GET['sl_user_login'];
        }
        echo $fld->getField();

        echo '      </td>
                </tr>
                <tr>
                    <th class="sb_filter_th">' . PL_SYSTEMLOG_TYPE . ':</th>
                    <td class="sb_filter_td_noborder">';

        $options = array(
            '' => ' --- ',
            '1' => PL_SYSTEMLOG_TYPE_INFO,
            '2' => PL_SYSTEMLOG_TYPE_PREVEN,
            '3' => PL_SYSTEMLOG_TYPE_WARN,
            '4' => PL_SYSTEMLOG_TYPE_PHP_WARN,
            '5' => PL_SYSTEMLOG_TYPE_MYSQL_WARN
        );

        $fld = new sbLayoutSelect($options, 'sl_type');
        if (isset($_GET['sl_type'])) {
            $fld->mSelOptions[] = $_GET['sl_type'];
        }
        echo $fld->getField();

        echo '      </td>
                    <th class="sb_filter_th">&nbsp;</th>
                    <td class="sb_filter_td_noborder">&nbsp;</td>
                </tr>
                </table>
                <div class="sb_filter_footer">
                        <input type="submit" value="' . KERNEL_APPLY . '">&nbsp;&nbsp;
                </div>
                </div>
                </form>
            </table>
        </td></tr></table>
        <br>
        <center><div align="right" style="width:95%">
        <a href="' . $excel_href . '" target="_blank"><img src="' . SB_CMS_IMG_URL . '/icon_excel.png" width="20" height="20" border="0" align="absmiddle">&nbsp;' . PL_SYSTEMLOG_EXCEL . '</a>
        &nbsp;&nbsp;&nbsp;
        <a href="' . $archive_href . '"><img src="' . SB_CMS_IMG_URL . '/icon_archive.png" width="20" height="20" border="0" align="absmiddle">&nbsp;' . PL_SYSTEMLOG_ARCHIVE . '</a>
        </div>
        <br />' . $num_list . '<br /><br />
        <table width="98%" cellspacing="0" cellpadding="5" class="form">
        <tr>
            <th class="header" width="50">
                <nobr>
                    &nbsp;' . PL_SYSTEMLOG_TYPE . '&nbsp;
                </nobr>
            </th>
            <th class="header" width="80">
                <nobr>
                    &nbsp;' . PL_SYSTEMLOG_DATE . '&nbsp;
                </nobr>
            </th>
            <th class="header" width="70">
                <nobr>
                    &nbsp;' . PL_SYSTEMLOG_IP . '&nbsp;
                </nobr>
            </th>
            <th class="header" width="100">
                <nobr>
                    &nbsp;' . PL_SYSTEMLOG_LOGIN . '&nbsp;
                </nobr>
            </th>
            <th class="header" width="100">
                <nobr>
                    &nbsp;' . PL_SYSTEMLOG_DOMAIN . '&nbsp;
                </nobr>
            </th>
            <th class="header">
                <nobr>
                    &nbsp;' . PL_SYSTEMLOG_MESSAGE . '&nbsp;
                </nobr>
            </th>
        </tr>';

        /**
         * Вывод таблицы
         */
        $view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_users', 'read');
        $from = ($page - 1) * $pagesCount; // номер точки восстановления с которой нужно начать выводить список
        $to = min($num, $from + $pagesCount);

        for ($i = $from; $i < $to; $i++) {
            $sl_date = (string)$xml[$i]->sl_date;
            $sl_user_login = (string)$xml[$i]->sl_user_login;
            $sl_user_ip = (string)$xml[$i]->sl_user_ip;
            $sl_message = (string)$xml[$i]->sl_message;
            $sl_type = (string)$xml[$i]->sl_type;
            $sl_domain = (string)$xml[$i]->sl_domain;
            $sl_user_id = (string)$xml[$i]->sl_user_id;

            if ($sl_user_id != -1) {
                $res = sql_param_query('SELECT u_id, u_login FROM sb_users WHERE u_id=?', $sl_user_id);
                if ($res) {
                    list($u_id, $u_login) = $res[0];

                    $sl_user_login = $u_login;
                } else {
                    $u_login = null;
                    $u_id = null;
                }
            } else {
                $u_login = null;
                $u_id = null;
            }

            switch ($sl_type) {
                case 1:
                    $img = 'information_log.png';
                    break;
                case 2:
                    $img = 'prevention_log.png';
                    break;
                case 3:
                case 4:
                case 5:
                    $img = 'warning_log.png';
                    break;
                default:
                    $img = '';
                    break;
            }

            if (!is_null($u_id) && $_SESSION['sbAuth']->isAdmin() || $view_info || $_SESSION['sbAuth']->getUserId() == $u_id) {
                $sl_user_login = '<a href="' . SB_CMS_CONTENT_FILE . '?event=pl_kernel_user_info&id=' . $u_id . '" class="small">' . $sl_user_login . '</a>';
            }

            echo '<tr' . ($i % 2 != 0 ? ' class="even"' : ' class="odd"') . '>
                    <td style="text-align:center;">
                        <img src="' . SB_CMS_IMG_URL . '/' . $img . '" \>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        ' . sb_date('d.m.Y', $sl_date) . '<br />' . KERNEL_IN . '<br />' . sb_date('H:i:s', $sl_date) . '
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        ' . $sl_user_ip . '
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>' . $sl_user_login . '</b>
                    </td>
                    <td style="font-size: 10px;text-align: center;">
                        <b>' . $idn->decode($sl_domain) . '</b>
                    </td>
                    <td>';

            if ($sl_type == 3 || $sl_type == 4 || $sl_type == 5) {
                $debug_message = preg_replace('/ +/ms', ' ',
                    strip_tags(sb_str_replace(array('<br>', '<br />', '</tr>', '</td>', '</th>'), array("\n", "\n", "\n", " ", " "), $sl_message)));
                $debug_message = preg_replace('/\t+/ms', ' ', $debug_message);

                echo '<div class="hint_div">' . sb_break_long_words($sl_message, 70, '<br />') . '</div>';
                echo sbAuth::checkSupport() ? '<form action="http://www.sbuilder.ru/support/cabinet/" method="post" target="_blank">
                    <textarea name="tp_message" style="display: none;">[sb_error]' . $debug_message . '[/sb_error]</textarea>
                    <input type="hidden" name="tp_subject" value="' . PL_SYSTEMLOG_TP_SUBJECT . '" />
                    <input type="hidden" name="lic" value="' . SB_CLIENT_LIC . '" />
                    <input type="hidden" name="domain" value="' . SB_MAIN_DOMAIN . '" />
                    <div><input type="submit" value="' . PL_SYSTEMLOG_ERROR_BTN . '" class="tp_button" /></div>
                    </form>' : '';
            } else {
                echo '<div class="hint_div">' . $sl_message . '</div>';
            }

            echo '  </td>
                </tr>';
        }

        echo '</table><br>' . $num_list . '<br><br></center>';
    } else {
        sb_show_message(PL_SYSTEMLOG_NO_MESSAGES, true);
    }

    if ($zip) {
        $GLOBALS['sbVfs']->mLocal = true;
        $GLOBALS['sbVfs']->delete($tmp_dir);
        $GLOBALS['sbVfs']->mLocal = false;
    }
}

function fSystemlog_Archive_Excel()
{
    if (!isset($_GET['file']) || strpos($_GET['file'], 'log_') !== 0) {
        return;
    }

    $_GET['file'] = preg_replace('/[^a-zA-Z_0-9]/', '', $_GET['file']);

    $file_zip = 'cms/backup/' . $_GET['file'] . '.zip';
    $file_xml = 'cms/backup/' . $_GET['file'] . '.xml';

    $zip = false;
    $xml = false;

    if ($GLOBALS['sbVfs']->exists($file_zip)) {
        $zip = true;
    }

    if ($GLOBALS['sbVfs']->exists($file_xml)) {
        $xml = true;
    }

    if (!$zip && !$xml) {
        return;
    }

    if ($zip) {
        $tmp_id = uniqid();
        $tmp_dir = SB_CMS_TMP_PATH . '/' . $tmp_id;

        $GLOBALS['sbVfs']->mLocal = true;

        if (!$GLOBALS['sbVfs']->exists($tmp_dir)) {
            if (!$GLOBALS['sbVfs']->mkdir($tmp_dir)) {
                $GLOBALS['sbVfs']->mLocal = false;
                return;
            }
        }

        if (!$GLOBALS['sbVfs']->is_writable($tmp_dir)) {
            $GLOBALS['sbVfs']->mLocal = false;
            return;
        }

        $file = $tmp_dir . str_replace('cms/backup', '', $file_xml);

        if (function_exists('gzopen64')) {
            $gz = @gzopen64(SB_BASEDIR . '/' . $file_zip, 'rb');
        } else {
            $gz = @gzopen(SB_BASEDIR . '/' . $file_zip, 'rb');
        }

        $fl = $GLOBALS['sbVfs']->fopen($file, 'ab');

        if (!$gz || !$fl) {
            $GLOBALS['sbVfs']->delete($tmp_dir);
            if ($fl) {
                $GLOBALS['sbVfs']->delete($file);
            }

            $GLOBALS['sbVfs']->mLocal = false;
            return;
        }

        $GLOBALS['sbVfs']->mLocal = false;

        while (!@gzeof($gz)) {
            $str = trim(@gzgets($gz, 4096));
            $GLOBALS['sbVfs']->fwrite($str);
        }

        @gzclose($gz);
        $GLOBALS['sbVfs']->fclose();
        $GLOBALS['sbVfs']->mLocal = false;
    } else {
        $file = SB_BASEDIR . '/' . $file_xml;
    }

    $xml = simplexml_load_file($file);
    $xpath = '/db/sb_system_log';

    $res = sql_param_query('SELECT u_admin, u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
    list($u_admin, $u_domains) = $res[0];

    if ($u_admin != 1) {
        $u_domains = explode(',', $u_domains);
        $xpath = array();
        foreach ($u_domains as $domain) {
            $xpath[] = 'sl_domain="' . trim($domain) . '"';
        }

        $xpath = '/db/sb_system_log[' . implode(' or ', $xpath) . ']';
    }

    $xml = $xml->xpath($xpath);

    header('Content-type: application/vnd.ms-excel; charset=' . strtolower(SB_CHARSET), true);
    header('Content-Disposition: attachment; filename="sbuilder_system_log.xls"');

    echo '<html>
        <head>
        <title></title>
        <meta http-equiv="Content-Type" content="text/html; charset=' . strtolower(SB_CHARSET) . '">
        <body>';

    $num = 0;

    if ($xml) {
        $num = count($xml); // Всего сообщений
    }

    if ($num > 0) {
        /**
         * Вывод таблици
         */
        echo '<table border="1">
              <tr>
                <th width="100">
                    &nbsp;' . PL_SYSTEMLOG_TYPE . '&nbsp;
                </th>
                <th width="160">
                    &nbsp;' . PL_SYSTEMLOG_DATE . '&nbsp;
                </th>
                <th width="80">
                    &nbsp;' . PL_SYSTEMLOG_IP . '&nbsp;
                </th>
                <th width="100">
                    &nbsp;' . PL_SYSTEMLOG_LOGIN . '&nbsp;
                </th>
                <th width="100">
                    &nbsp;' . PL_SYSTEMLOG_DOMAIN . '&nbsp;
                </th>
                <th>
                    &nbsp;' . PL_SYSTEMLOG_MESSAGE . '&nbsp;
                </th>
             </tr>';

        require_once(SB_CMS_LIB_PATH . '/sbIDN.inc.php');
        $idn = new sbIDN();

        for ($i = 0; $i < $num; $i++) {
            $sl_date = (string)$xml[$i]->sl_date;
            $sl_user_login = (string)$xml[$i]->sl_user_login;
            $sl_user_ip = (string)$xml[$i]->sl_user_ip;
            $sl_message = (string)$xml[$i]->sl_message;
            $sl_type = (string)$xml[$i]->sl_type;
            $sl_domain = (string)$xml[$i]->sl_domain;
            $sl_user_id = (string)$xml[$i]->sl_user_id;

            if ($sl_user_id != -1) {
                $res = sql_param_query('SELECT u_id, u_login FROM sb_users WHERE u_id=?', $sl_user_id);
                if ($res) {
                    list($u_id, $u_login) = $res[0];

                    $sl_user_login = $u_login;
                } else {
                    $u_login = null;
                    $u_id = null;
                }
            } else {
                $u_login = null;
                $u_id = null;
            }

            switch ($sl_type) {
                case 1:
                    $sl_type = '<span style="color:green;">' . PL_SYSTEMLOG_TYPE_INFO . '</span>';
                    break;
                case 2:
                    $sl_type = '<span style="color:orange;">' . PL_SYSTEMLOG_TYPE_PREVEN . '</span>';
                    break;
                case 3:
                case 4:
                case 5:
                    $sl_type = '<span style="color:red;">' . PL_SYSTEMLOG_TYPE_WARN . '</span>';
                    break;
                default:
                    $sl_type = '';
                    break;
            }

            echo '<tr>
                    <td align="center" width="100" valign="top">
                        &nbsp;' . $sl_type . '&nbsp;
                    </td>
                    <td align="center" width="160" valign="top">
                        ' . sb_date('d.m.Y ' . KERNEL_IN . ' H:i:s', $sl_date) . '
                    </td>
                    <td align="center" width="80" valign="top">
                        ' . $sl_user_ip . '
                    </td>
                    <td align="center" width="100" valign="top">
                        <b>' . $sl_user_login . '</b>
                    </td>
                    <td align="center" width="100" valign="top">
                        <b>' . $idn->decode($sl_domain) . '</b>
                    </td>
                    <td valign="top">
                        ' . $sl_message . '
                    </td>
                </tr>';
        }

        echo '</table>';
    }

    echo '</body></html>';

    if ($zip) {
        $GLOBALS['sbVfs']->mLocal = true;
        $GLOBALS['sbVfs']->delete($tmp_dir);
        $GLOBALS['sbVfs']->mLocal = false;
    }
}
