<?php
require_once(SB_CMS_LANG_PATH.'/pl_templates.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_templates', PL_TEMPLATES_H_PLUGIN_NAME, 'http://www.sbuilder.ru/docs/helps40/templates.doc'))
{
	$_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP.'>'.PL_TEMPLATES_H_PLUGIN_NAME, 'init');
	
	$_SESSION['sbPlugins']->addUserEvent('init', 'fTemplates_Init', 'read', PL_TEMPLATES_H_PLUGIN_NAME);
	$_SESSION['sbPlugins']->addUserEvent('edit', 'fTemplates_Edit', 'read', PL_TEMPLATES_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('edit_submit', 'fTemplates_Edit_Submit', 'elems_edit', PL_TEMPLATES_H_EDIT_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('set_tag', 'fTemplates_Set_Tag', 'elems_edit', PL_TEMPLATES_H_SET_TAG_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('set_tag_submit', 'fTemplates_Set_Tag_Submit', 'elems_edit', PL_TEMPLATES_H_SET_TAG_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('delete', 'fTemplates_Delete', 'elems_delete');
	$_SESSION['sbPlugins']->addUserEvent('paste', 'fTemplates_Paste', 'elems_edit');
	$_SESSION['sbPlugins']->addUserEvent('show_pages', 'fTemplates_Show_Pages', 'read', PL_TEMPLATES_H_SHOW_PAGES_TITLE);
	$_SESSION['sbPlugins']->addUserEvent('gen_pages', 'fTemplates_Gen_Pages', 'elems_edit', PL_TEMPLATES_H_GEN_PAGES_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('assoc_temp', 'fTemplates_Associate', 'elems_edit', PL_TEMPLATES_H_QUICKLY_CHANGE_TEMPLATE);
    $_SESSION['sbPlugins']->addUserEvent('assoc_submit', 'fTemplates_Associate_Submit', 'elems_edit', PL_TEMPLATES_H_QUICKLY_CHANGE_TEMPLATE);
}

$_SESSION['sbPlugins']->addSystemEvent('get_links', 'fTemplates_Get_Links', PL_TEMPLATES_H_GET_LINKS_TITLE);
$_SESSION['sbPlugins']->addSystemEvent('load_info', 'fTemplates_Load_Info', 'read');

$_SESSION['sbPlugins']->addEventsRights('categs_edit', RIGHTS_H_CATEGS_EDIT_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_delete', RIGHTS_H_CATEGS_DELETE_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('categs_rights', RIGHTS_H_CATEGS_RIGHTS_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('elems_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
?>