<?php
function fTemplates_Get($args)
{
	static $view_info = null;

	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['t_name'].'</a></b>
	<div class="smalltext" style="margin-top: 7px;">';

	$res = sql_query('SELECT COUNT(*) FROM sb_pages WHERE p_temp_id=?d GROUP BY p_temp_id', $args['t_id']);
    if ($res)
	    list($num_pages) = $res[0];
	else
	    $num_pages = 0;

	$result .= PL_TEMPLATES_H_GET_NUM_PAGES.': ';

    if($num_pages == 0)
    {
	    $result .= '<span style="color:red;">'.PL_TEMPLATES_H_GET_NOT_USED.'</span>';
    }
	else
	{
	    $result .= '<span style="color:green;"><a href="javascript:void(0);" onclick="linkPages(event);" id="'.$args['t_id'].'_num">'.$num_pages.'</a></span><br />';

	    $res = sql_param_query('SELECT p_id, p_name FROM sb_pages WHERE p_temp_id=?d ORDER BY p_name LIMIT 4', $args['t_id']);

	    if (is_null($view_info))
        {
            $view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
        }

        if ($res)
    	{
    	    $result .= '<table cellpadding="0" cellspacing="0">
    	                <tr>
    	                    <td valign="top" nowrap="nowrap" class="smalltext">'.PL_TEMPLATES_H_USED_ON_PAGES.':&nbsp;</td>
    	                    <td class="smalltext"><span style="color:green;">';

    	    $num = min(3, count($res));
    	    for ($i = 0; $i < $num; $i++)
    		{
    			list($p_id, $p_name) = $res[$i];

    			$result .= ($view_info ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
    		}

    		if ($num < count($res))
    			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
    	    else
    	        $result = substr($result, 0, -2);

    	    $result .= '</span></td></tr></table>';
    	}
	}

	$result .= '</div>';

    return $result;
}

function fTemplates_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

	$elems = new sbElements('sb_templates', 't_id', 't_name', 'fTemplates_Get', 'pl_templates_init', 'pl_templates');
    $elems->mCategsDeleteWithElementsMenu = true;

	$elems->mCategsClosed = false;
	$elems->mCategsRootName = PL_TEMPLATES_ROOT_NAME;

	$elems->addField('t_name');       // название макета дизайна

	$elems->addFilter(PL_TEMPLATES_FILTER_ID, 't_id', 'number');
	$elems->addFilter(PL_TEMPLATES_FILTER_NAME, 't_name', 'string');
    $elems->addFilter(PL_TEMPLATES_FILTER_HTML, 't_html', 'string');

	$elems->addSorting(PL_TEMPLATES_SORT_BY_ID, 't_id');
    $elems->addSorting(PL_TEMPLATES_SORT_BY_NAME, 't_name');

	$elems->mCategsPasteElemsMenuTitle = PL_TEMPLATES_CATEGS_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = PL_TEMPLATES_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_TEMPLATES_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_TEMPLATES_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = PL_TEMPLATES_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_templates_edit';
    $elems->mElemsEditDlgWidth = 'screen.availWidth - 100';
	$elems->mElemsEditDlgHeight = 'screen.availHeight - 100';

	$elems->mElemsAddEvent =  'pl_templates_edit';
    $elems->mElemsAddDlgWidth = 'screen.availWidth - 100';
	$elems->mElemsAddDlgHeight = 'screen.availHeight - 100';

	$elems->mElemsDeleteEvent = 'pl_templates_delete';
	$elems->mElemsAfterPasteEvent = 'pl_templates_paste';

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'elems_edit'))
	{
	    $elems->mElemsJavascriptStr .= '
          function pagesGen(el_id)
		  {
		      if (typeof(el_id) == "undefined")
		      {
		          el_id = sbSelEl.getAttribute("el_id");
		          var num_el = true;
		      }
		      else
		      {
		          var num_el = sbGetE(el_id + "_num");
		      }

		      if (num_el)
		      {
		          var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_gen_pages&id=" + el_id;
                  var strAttr = "resizable=0,width=600,height=400";
                  sbShowDialog(strPage, strAttr);
		      }
		  }';

        $elems->addElemsMenuItem(PL_TEMPLATES_PAGES_GEN_MENU_ITEM, 'pagesGen();');
        $elems->mElemsAfterEditFunc = 'pagesGen';

        //Быстрая смена макета
        $elems->mElemsJavascriptStr .= '
            function linkedNewTemplate()
            {
                var el_id = sbSelEl.getAttribute("el_id");

                if(el_id)
                {
                    strPage = "' . SB_CMS_MODAL_DIALOG_FILE . '?event=pl_templates_assoc_temp&id=" + el_id;
                    strAttr = "resizable=1,width=800,height=600";
                    sbShowModalDialog(strPage, strAttr, windowReload, null);
                }
            }

            function windowReload()
            {
                var div_el = sbGetE("elems_list_div");
                var from = "";
                if (div_el)
                {
                    from = div_el.getAttribute("from");
                }
                var url = sb_cms_empty_file + "?event=pl_templates_init&id=" + sbCatTree.getSelectedItemId() + "&page_elems=" + from;
                sbElemsShow(url);
            }
        ';
        $elems->addElemsMenuItem(PL_TEMPLATES_ASSOC_TEMP, 'linkedNewTemplate()');
	}

	$elems->mElemsJavascriptStr .= '
	      function linkPages(e)
	      {
	          if (!sbSelEl)
	          {
	              var el = sbEventTarget(e);

                  while (el.parentNode && !el.getAttribute("true_id"))
                      el = el.parentNode;

                  var el_id = el.getAttribute("el_id");
	          }
	          else
	              var el_id = sbSelEl.getAttribute("el_id");

	          strPage = "'.SB_CMS_MODAL_DIALOG_FILE.'?event=pl_templates_show_pages&id=" + el_id;
              strAttr = "resizable=1,width=800,height=600";
              sbShowModalDialog(strPage, strAttr, null, window);
	      }';

	$elems->addElemsMenuItem(PL_TEMPLATES_LINK_PAGES, 'linkPages();');

    $elems->init();
}

function fTemplates_Edit($htmlStr = '', $footerStr = '')
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_templates'))
		return;

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_templates_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');

	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addTab(PL_TEMPLATES_EDIT_TAB1);
    $layout->addHeader(PL_TEMPLATES_EDIT_TAB1);

    echo '<script src="'.SB_CMS_JSCRIPT_URL.'/sbTemplates.js.php"></script>
    <script>
        var num_tags = 0;
        function checkValues()
        {
            var el_name = sbGetE("t_name");
            if (el_name.value == "")
            {
      	         alert("'.PL_TEMPLATES_EDIT_NO_TITLE_MSG.'");
      	         return false;
            }

            if (num_tags > 0)
            {
                for (var i = 0; i < num_tags; i++)
                {
                    var e_params = sbGetE("e_params" + i);
                    var e_ident = sbGetE("e_ident" + i);

                    if (e_ident.value != "" && typeof(sb_pl_elems[e_ident.value]) != "undefined" && e_params.value == "")
                    {
                        alert("'.PL_TEMPLATES_EDIT_NO_PARAMS_MSG.'");
                        return false;
                    }
                }
            }
        }

        var was_changed = false;
        function onChangeHTML()
        {
            was_changed = true;
        }

    	function sbTabCheck(tab)
    	{
    	    if (tab == 2 && was_changed)
    	    {
    	        alert("'.PL_TEMPLATES_EDIT_HIDE_ELEMS_MSG.'");
    	        return false;
    	    }

    	    return true;
    	}';

    if ($htmlStr != '')
	{
	    if ($footerStr == '')
	    {
	        echo '
	            function cancel()
                {
                    sbReturnValue('.intval($_GET['id']).');
                }';
	    }
	    else
	    {
    	    echo '
                function cancel()
                {
                    var res = new Object();
    		        res.html = "'.$htmlStr.'";
    		        res.footer = "'.$footerStr.'";
    		        res.footer_link = "";
    		        res.not_call = 1;
    				sbReturnValue(res);
                }';
	    }

	    echo 'sbAddEvent(window, "close", cancel);';
	}

	echo '</script>';


    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
	    $result = sql_param_query('SELECT t_name, t_html, t_xslt, t_ctype
   		                           FROM sb_templates WHERE t_id=?d', $_GET['id']);

	   	if ($result)
	    {
        	list($t_name, $t_html, $t_xslt, $t_ctype) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_TEMPLATES_EDIT_ERROR, true, 'warning');
	        return;
	    }
	}
	elseif (count($_POST) > 0)
	{
    	extract($_POST);
    	if (!isset($_GET['id']))
            $_GET['id'] = '';
	}
	else
	{
	    $t_name = $t_xslt = '';
	    $t_ctype = 'text/html';

	    // макет дизайна по умолчанию
	    $t_html = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <title></title>

    <meta http-equiv="Content-Type" content="text/html; charset='.SB_CHARSET.'" />
    <meta name="keywords" content="" />
    <meta name="description" content="" />

    <link rel="shortcut icon" href="/favicon.ico" type="image/x-icon" />
</head>
<body>



</body>
</html>
';
		$_GET['id'] = '';
	}
	$layout->addField(PL_TEMPLATES_EDIT_NAME, new sbLayoutInput('text', $t_name, 't_name', '', 'style="width:500px;"', true));

	$layout->addField('', new sbLayoutDelim());

	$fld = new sbLayoutTextarea($t_html, 't_html', '', 'style="width:100%;height:400px;" onchange="onChangeHTML();"');

	if ($_SESSION['sbPlugins']->isPluginAvailable('pl_search'))
	{
    	$fld->mTags[] = '';
    	$fld->mTags[] = '-';
    	$fld->mTags[] = htmlentities('<!--sb_index_start-->');
        $fld->mTags[] = htmlentities('<!--sb_index_end-->');
        $fld->mTags[] = '-';
        $fld->mTags[] = htmlentities('<!--sb_index_start--><!--sb_index_links_start-->');
        $fld->mTags[] = htmlentities('<!--sb_index_links_end--><!--sb_index_end-->');
        $fld->mTags[] = '-';
        $fld->mTags[] = htmlentities('<!--sb_index_start--><!--sb_index_not_links_start-->');
        $fld->mTags[] = htmlentities('<!--sb_index_not_links_end--><!--sb_index_end-->');

        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH;
        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH_1;
        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH_BEGIN;
        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH_END;
        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH_2;
        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH_BEGIN;
        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH_END;
        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH_3;
        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH_BEGIN;
        $fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_SEARCH_END;
	}
	$fld->mTags[] = '-';
    $fld->mTags[] = '{SB_CSS_VERSION}';
    $fld->mTags[] = '{SB_JS_VERSION}';

	$fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_VERSION;
	$fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_VERSION_CSS;
	$fld->mValues[] = PL_TEMPLATES_EDIT_TAGS_VERSION_JS;

    $fld->mTopHtml = '<div style="width: 24px; height: 24px; cursor: hand; cursor: pointer;margin-left: 5px;margin-top: 10px;" onclick="setNewTag();"><b style="font-size: 8pt;">{..}</b></div>';

	$layout->addField(PL_TEMPLATES_EDIT_HTML, $fld);

	$layout->addTab(PL_TEMPLATES_EDIT_TAB2);
	$layout->addHeader(PL_TEMPLATES_EDIT_TAB2);

	$fld = new sbLayoutFile($t_xslt, 't_xslt', '', 'style="width:415px;"');
	$fld->mHTML = '<div class="hint_div">'.PL_TEMPLATES_EDIT_XSLT_LABEL.'</div>';
	$layout->addField(PL_TEMPLATES_EDIT_XSLT, $fld);

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_TEMPLATES_EDIT_CONTENT_TYPE, new sbLayoutInput('text', $t_ctype, 't_ctype', '', 'style="width:500px;"'));

    if (isset($_GET['id']) && $_GET['id'] != '')
    {
        $layout->addTab(PL_TEMPLATES_EDIT_TAB3);

        $elems = $_SESSION['sbPlugins']->getElems();
        if (0 == count($elems))
        {
            // зарегистрированных элементов нет
            $layout->addHeader(PL_TEMPLATES_EDIT_TAB2);
            $layout->addField('', new sbLayoutHTML(sb_show_message(PL_TEMPLATES_EDIT_NO_ELEMS_MSG, true, 'information', true), true));
        }
        else
        {
            $tags = array();
            preg_match_all('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, $t_html, $tags);
            if (count($tags[0]) == 0)
            {
                // тегов нет
                $layout->addHeader(PL_TEMPLATES_EDIT_TAB2);
                $layout->addField('', new sbLayoutHTML(sb_show_message(PL_TEMPLATES_EDIT_NO_TAGS_MSG, true, 'information', true), true));
            }
            else
            {
                echo '<script>
    	              sbElemsIdent = "temp";';

                $link_tags = array();
                if (count($_POST) > 0 && isset($e_tag) && is_array($e_tag) && count($e_tag) > 0)
            	{
            		foreach ($e_tag as $key => $value)
                	{
                		if (!in_array($value, $tags[0]))
                			continue;

                	    $link_tags[$value] = array();
                        $link_tags[$value]['e_ident'] = $e_ident[$key];
                        $link_tags[$value]['e_id'] = $e_id[$key];
                        $link_tags[$value]['e_temp_id'] = $e_temp_id[$key];
                        $link_tags[$value]['e_el_id'] = $e_el_id[$key];
                        $link_tags[$value]['e_params'] = $e_params[$key];
                        $link_tags[$value]['e_search'] = isset($e_search[$key]) ? $e_search[$key] : 'none';
                        $link_tags[$value]['e_edit'] = isset($e_edit[$key]) ? $e_edit[$key] : ($e_ident[$key] == '' ? '1' : '0');
                        $link_tags[$value]['e_yandex'] = isset($e_yandex[$key]) ? $e_yandex[$key] : '0';
                	}
            	}
            	else
            	{
                    $result = sql_param_query('SELECT e_id, e_tag, e_ident, e_temp_id, e_el_id, e_params, e_search, e_edit, e_yandex FROM sb_elems
      		                             WHERE e_p_id=?d AND e_link="temp" AND e_tag IN (?a)', $_GET['id'], $tags[0]);

                    if ($result)
                    {
                        foreach ($result as $value)
                        {
                            list($e_id, $e_tag, $e_ident, $e_temp_id, $e_el_id, $e_params, $e_search, $e_edit, $e_yandex) = $value;

                            if (isset($elems[$e_ident]) || $e_ident == '')
                            {
                                $link_tags[$e_tag] = array();
                                $link_tags[$e_tag]['e_ident'] = $e_ident;
                                $link_tags[$e_tag]['e_id'] = $e_id;
                                $link_tags[$e_tag]['e_temp_id'] = $e_temp_id;
                                $link_tags[$e_tag]['e_el_id'] = $e_el_id;
                                $link_tags[$e_tag]['e_params'] = $e_params;
                                $link_tags[$e_tag]['e_search'] = $e_search;
                                $link_tags[$e_tag]['e_edit'] = $e_edit;
                                $link_tags[$e_tag]['e_yandex'] = $e_yandex;
                            }
                        }
                    }
            	}

                $options_str = '<option value="" style="color: red;">'.KERNEL_ELEM_NOT_CHOOSED.'</option>';
                $js_str = '';

		        $cur_group = '';
                foreach ($elems as $ident => $value)
		        {
		            $tmp = explode('|', $value['name']);
		            $e_group = $tmp[0];
		            $value['name'] = $tmp[1];

		            if ($e_group != $cur_group)
		            {
		                if ($cur_group != '')
		                {
		                    $options_str .= '</optgroup>';
		                }
		                $options_str .= '<optgroup label="'.$e_group.'">';

		                $cur_group = $e_group;
		            }

  			        $options_str .= '<option value="'.$ident.'">'.$value['name'].'</option>';

  			        if ($value['get_event'] != '')
  			        {
  			           $js_str .= 'sb_pl_elems["'.$ident.'"] = new Array();
  			                       sb_pl_elems["'.$ident.'"]["event"] = "'.$value['get_event'].'";
  			                       sb_pl_elems["'.$ident.'"]["width"] = "'.$value['dlg_width'].'";
  			                       sb_pl_elems["'.$ident.'"]["height"] = "'.$value['dlg_height'].'";';
  			        }
		        }

		        if ($cur_group != '')
		            $options_str .= '</optgroup>';

                $i = 0;
                $table = array();
                $search_options = array('none' => KERNEL_ELEM_TAGS_SEARCH_0,
                						'' => '-'.KERNEL_ELEM_TAGS_SEARCH_INDEX,
    		                            'all' => KERNEL_ELEM_TAGS_SEARCH_1,
    		                            'links' => KERNEL_ELEM_TAGS_SEARCH_2,
    		                            'text' => KERNEL_ELEM_TAGS_SEARCH_3);

                foreach ($tags[0] as $value)
                {
                	if ($value == '{SB_CSS_VERSION}' || $value == '{SB_JS_VERSION}')
                	{
                		continue;
                	}

                    if (isset($link_tags[$value]))
                    {
                        $e_id = $link_tags[$value]['e_id'];
                        $e_ident = $link_tags[$value]['e_ident'];
                        $e_temp_id = $link_tags[$value]['e_temp_id'];
                        $e_el_id = $link_tags[$value]['e_el_id'];
                        $e_params = sb_htmlspecialchars($link_tags[$value]['e_params'], ENT_QUOTES);
                        $e_search = $link_tags[$value]['e_search'];
                        $e_edit = $link_tags[$value]['e_edit'];
                        $e_yandex = $link_tags[$value]['e_yandex'];

                        $js_str .= 'sb_pl_old_elems["'.$value.'"] = new Array();
  			                        sb_pl_old_elems["'.$value.'"]["e_id"] = "'.$e_id.'";
  			                        sb_pl_old_elems["'.$value.'"]["e_ident"] = "'.$e_ident.'";
  			                        sb_pl_old_elems["'.$value.'"]["e_temp_id"] = "'.$e_temp_id.'";
  			                        sb_pl_old_elems["'.$value.'"]["e_el_id"] = "'.$e_el_id.'";
  			                        sb_pl_old_elems["'.$value.'"]["e_params"] = "'.$e_params.'";
  			                        sb_pl_old_elems["'.$value.'"]["e_info"] = "event:pl_templates_load_info&e_id='.$e_id.'";
  			                        sb_pl_old_elems["'.$value.'"]["e_link"] = "temp";';
                    }
                    else
                    {
                        $e_id = -1;
                        $e_ident = '';
                        $e_temp_id = -1;
                        $e_el_id = -1;
                        $e_params = '';
                        $e_search = 'none';
                        $e_edit = 1;
                        $e_yandex = 0;
                    }

                    $tag = str_replace('_', ' ', trim($value, '{}'));

                    if ($e_ident != '')
    		        {
    			        $tag = '<b id="e_tag_td'.$i.'" style="font-size: 12px;">'.$tag.'</b>';
    		        }
    		        else
    		        {
     			        $tag = '<b id="e_tag_td'.$i.'" style="color: #999;font-size: 12px;">'.$tag.'</b>';
    		        }

    		        $str = '<select id="e_ident'.$i.'" name="e_ident['.$i.']" onchange="changeIdent('.$i.', this, true)" onkeyup="changeIdent('.$i.', this, true)" style="font-size: 13px;">
    		        '.($e_ident != '' ? sb_str_replace('"'.$e_ident.'"', '"'.$e_ident.'" selected="selected" style="background-color: #E2E2E2;"', $options_str) : $options_str).'</select>
    			     <input type="hidden" id="e_id'.$i.'" name="e_id['.$i.']" value="'.$e_id.'">
    			     <input type="hidden" id="e_el_id'.$i.'" name="e_el_id['.$i.']" value="'.$e_el_id.'">
    			     <input type="hidden" id="e_temp_id'.$i.'" name="e_temp_id['.$i.']" value="'.$e_temp_id.'">
    			     <input type="hidden" id="e_params'.$i.'" name="e_params['.$i.']" value="'.$e_params.'">
    			     <input type="hidden" id="e_tag'.$i.'" name="e_tag['.$i.']" value="'.$value.'">';

    		        if ($e_params != '')
    		            $info = '<img info="event:pl_templates_load_info&e_id='.$e_id.'" src="'.SB_CMS_IMG_URL.'/info.png" width="20" height="20" id="e_info'.$i.'" style="cursor:help;">';
    		        else
    		            $info = '<img info="" src="'.SB_CMS_IMG_URL.'/info.png" width="20" height="20" id="e_info'.$i.'" style="display:none;cursor:help;">';

    		        $btn = '<img src="'.SB_CMS_IMG_URL.'/btn_props.png" width="20" height="20" id="e_btn'.$i.'" onclick="browseEl('.$i.');" title="'.KERNEL_SETTINGS.'" style="cursor:hand;cursor:pointer;'.('' == $e_ident || '' == $elems[$e_ident]['get_event'] ? 'display:none;' : '').'" />';
    		        $edit = '<input type="checkbox" name="e_edit['.$i.']" id="e_edit'.$i.'" value="1"'.($e_edit == 1 ? ' checked="checked"' : '').' onclick="changeTempEl(\''.$i.'\')" />';
    		        $yandex = '<input type="checkbox" name="e_yandex['.$i.']" id="e_yandex'.$i.'" value="1"'.($e_yandex == 1 ? ' checked="checked"' : '').' onclick="changeTempEl(\''.$i.'\')" />';

    		        if($_SESSION['sbPlugins']->isPluginAvailable('pl_search'))
    		        {
    		            $fld = new sbLayoutSelect($search_options, 'e_search['.$i.']', 'e_search'.$i, 'style="font-size: 13px;" onchange="changeTempEl(\''.$i.'\')" onkeyup="changeTempEl(\''.$i.'\')"');
    		            $fld->mSelOptions[] = $e_search;

    		            $table[] = array($tag, $str, $fld->getField(), $edit, $yandex, $info, $btn);
    		        }
    		        else
    		        {
    		            $table[] = array($tag, $str, $edit, $yandex, $info, $btn);
    		        }

    		        $i++;
                }

                if($_SESSION['sbPlugins']->isPluginAvailable('pl_search'))
                {
    		        $label = array(KERNEL_ELEM_TAG, KERNEL_ELEM_TYPE, KERNEL_ELEM_SEARCH, KERNEL_ELEM_EDIT, KERNEL_ELEM_YANDEX, '', '');
    		        $align = array('left', 'left', 'center', 'center', 'center', 'center', 'center');
    		        $width = array('200', '', '1', '100', '100', '26', '26');
                }
    		    else
    		    {
    		        $label = array(KERNEL_ELEM_TAG, KERNEL_ELEM_TYPE, KERNEL_ELEM_EDIT, KERNEL_ELEM_YANDEX, '', '');
    		        $align = array('left', 'left', 'center', 'center', 'center', 'center');
    		        $width = array('200', '', '100', '100', '26', '26');
    		    }

    		    $fld = new sbLayoutTable($label, $table);
    		    $fld->mAlign = $align;
    		    $fld->mWidth = $width;

    		    $layout->addField('', $fld);
    		    $layout->mShowInfo = true;

    		    echo $js_str.'num_tags = '.$i.';</script>';
            }
        }
    }

  	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'elems_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'elems_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fTemplates_Set_Tag()
{
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    echo '<script>
        function checkValues()
        {
            if (sbGetE("el_name").value == "")
            {
                alert("'.PL_TEMPLATES_SET_TAG_ERROR_MSG.'");
                return false;
            }
        }
    </script>
    <br /><br />';

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_templates_set_tag_submit');
    $layout->mTableWidth = '95%';

    $layout->addHeader(PL_TEMPLATES_SET_TAG_HEADER);
    $layout->addField(PL_TEMPLATES_SET_TAG_NAME, new sbLayoutInput('text', isset($_POST['el_name']) ? $_POST['el_name'] : '', 'el_name', '', 'style="width: 300px"'));
    $layout->addField('', new sbLayoutInput('hidden', isset($_POST['el_text']) ? $_POST['el_text'] : '', 'el_text'));

    $layout->addButton('submit', KERNEL_ADD);
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');

    $layout->show();

    echo '<script>
    var args = (_isIE || _isFF ? dialogArguments : window.opener.sbModalDialog.args);
    var el_text = sbGetE("el_text");
    if (args && el_text) el_text.value = args.text;
    </script>';
}

function fTemplates_Set_Tag_Submit()
{
	if(preg_match('/[^_A-Za-z0-9'.$GLOBALS['sb_reg_upper_interval'].$GLOBALS['sb_reg_lower_interval'].'\s]+/'.SB_PREG_MOD, $_POST['el_name']))
    {
        sb_show_message(PL_TEMPLATES_SET_TAG_ERROR1, false, 'warning');
        fTemplates_Set_Tag();
        return;
    }

    $tag = str_replace(' ', '_', sb_strtoupper($_POST['el_name']));

    $str = array();
    preg_match_all('/\{([_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+)\}/'.SB_PREG_MOD, $_POST['el_text'], $str);

    if(in_array($tag, $str[1]))
    {
        sb_show_message(PL_TEMPLATES_SET_TAG_ERROR2, false, 'warning');
        fTemplates_Set_Tag();
        return;
    }

    echo '<script>
	        sbReturnValue("{'.$tag.'}");
		  </script>';
}

function fTemplates_Edit_Submit()
{
	// проверка прав доступа
	if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_templates'))
		return;

    if (!isset($_GET['id']))
        $_GET['id'] = '';

	extract($_POST);

	if ($t_name == '')
    {
        sb_show_message(PL_TEMPLATES_EDIT_NO_TITLE_MSG, false, 'warning');
        fTemplates_Edit();
        return;
    }

	$tags = array();
    preg_match_all('/\{[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+\}/'.SB_PREG_MOD, $t_html, $tags);
    if ($tags[0])
    {
        foreach($tags[0] as $tag)
        {
            if (substr_count($t_html, $tag) > 1 && $tag != '{SB_CSS_VERSION}' && $tag != '{SB_JS_VERSION}')
            {
                sb_show_message(sprintf(PL_TEMPLATES_EDIT_SAME_TAGS_MSG, $tag), false, 'warning');
                fTemplates_Edit();
                return;
            }
        }
    }

    $xml_ar = array();
    if (preg_match_all('/(<\?xml\s(.*?)\?>)/ims', $t_html, $xml_ar))
    {
    	$php_ar = array();
    	if (preg_match_all('/<\?(php)?\s(.*?)\?>/ims', $t_html, $php_ar))
    	{
    		$i = 0;
    	    foreach ($php_ar[0] as $php_code)
    	    {
    	    	$t_html = sb_str_replace($php_code, '***sb_php'.($i++).'***', $t_html);
    	    }
    	}

    	foreach ($xml_ar[0] as $xml)
    	{
    		$new_xml = '<?php echo \''.str_replace('\'', '"', $xml).'\'; ?>';
    		$t_html = sb_str_replace($xml, $new_xml, $t_html);
    	}

    	if (count($php_ar) > 0)
    	{
    		$i = 0;
    	    foreach ($php_ar[0] as $php_code)
    	    {
    	    	$t_html = sb_str_replace('***sb_php'.($i++).'***', $php_code, $t_html);
    	    }
    	}

    	$_POST['t_html'] = $t_html;
    }

    $row = array();
    $row['t_name'] = strip_tags($t_name);
    $row['t_html'] = $t_html;
    $row['t_xslt'] = $t_xslt;
    $row['t_ctype'] = $t_ctype;

    if ($_GET['id'] != '')
	{
	    $res = sql_param_query('SELECT t_name FROM sb_templates WHERE t_id=?d', $_GET['id']);
	    if ($res)
	    {
	        // редактирование
	        list($old_title) = $res[0];

    	    sql_param_query('UPDATE sb_templates SET ?a WHERE t_id=?d', $row, $_GET['id'], sprintf(PL_TEMPLATES_EDIT_OK, $old_title));

            if (isset($_GET['link_id']))
            {
                $footer_ar = fCategs_Edit_Elem();
        	    if (!$footer_ar)
        	    {
        	        sb_show_message(PL_TEMPLATES_EDIT_ERROR, false, 'warning');
                    sb_add_system_message(sprintf(PL_TEMPLATES_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);

                    fTemplates_Edit();
        		    return;
        	    }

        	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
            }
            else
            {
                $footer_str = '';
            }

    	    $row['t_id'] = intval($_GET['id']);

            $html_str = fTemplates_Get($row);
    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

    	    // сохраняем элементы
    	    sql_param_query('DELETE FROM sb_elems WHERE e_link="temp" AND e_p_id=?d', $_GET['id']);
    	    $removed_tags = array();

            if (isset($_POST['e_tag']) && count($tags[0]) != 0)
    	    {
    	        foreach ($e_tag as $key => $value)
            	{
            		if (in_array($value, $tags[0]))
            	    {
            	    	$elems_raw = array();
                	    $elems_raw['e_tag'] = $value;
                	    $elems_raw['e_ident'] = $e_ident[$key];
                	    $elems_raw['e_link'] = 'temp';
                        $elems_raw['e_temp_id'] = intval($e_temp_id[$key]);
                        $elems_raw['e_el_id'] = intval($e_el_id[$key]);
                        $elems_raw['e_p_id'] = intval($_GET['id']);
                        $elems_raw['e_params'] = $e_params[$key];
                        $elems_raw['e_search'] = isset($e_search[$key]) ? $e_search[$key] : 'none';
                        $elems_raw['e_edit'] = isset($e_edit[$key]) ? $e_edit[$key] : 0;
                        $elems_raw['e_yandex'] = isset($e_yandex[$key]) ? $e_yandex[$key] : 0;

                        if (!sql_param_query('INSERT INTO sb_elems SET ?a', $elems_raw))
	                    {
	                        sb_show_message(PL_TEMPLATES_EDIT_ELEMS_ERROR, false, 'warning');
                            sb_add_system_message(sprintf(PL_TEMPLATES_EDIT_ELEMS_SYSTEMLOG_ERROR, $t_name), SB_MSG_WARNING);

                            fTemplates_Edit($html_str, $footer_str);
                		    return;
	                    }

	                    $_POST['e_id'][$key] = sql_insert_id();
            	    }
            	    else
            	    {
            	    	$removed_tags[] = $value;
            	    	$_POST['e_id'][$key] = -1;
            	    }
            	}

            	$key = count($_POST['e_tag']);
            	foreach ($tags[0] as $value)
            	{
            	    if (!in_array($value, $e_tag))
            	    {
            	        $_POST['e_tag'][$key] = $value;
	                    $_POST['e_id'][$key] = sql_insert_id();
	                    $_POST['e_ident'][$key] = '';
                        $_POST['e_temp_id'][$key] = -1;
                        $_POST['e_el_id'][$key] = -1;
                        $_POST['e_params'][$key] = '';
                        $_POST['e_search'][$key] = 'none';
                        $_POST['e_edit'][$key] = 1;
                        $_POST['e_yandex'][$key] = 0;

                        $key++;
            	    }
            	}
    	    }

    	    if (count($removed_tags) > 0)
    	    {
    	    	$res = sql_query('SELECT p_id FROM sb_pages WHERE p_temp_id='.$_GET['id']);
    	    	if ($res)
    	    	{
    	    		$pages = array();
            	    foreach ($res as $page_res)
            	    {
            	    	list($pages[]) = $page_res;
            	    }
            	    $pages = implode(',', $pages);

            		$removed_tags = '"'.implode('","', $removed_tags).'"';

    	    		sql_query('DELETE FROM sb_elems WHERE e_link="page" AND e_p_id IN ('.$pages.') AND e_tag IN ('.$removed_tags.')');
    	    	}
    	    }

    	    if (!isset($_POST['btn_apply']))
    	    {
    	        if (!isset($_GET['link_id']))
    	        {
        		    echo '<script>
        			   	    sbReturnValue('.intval($_GET['id']).');
        			      </script>';
    	        }
    	        else
    	        {
            	    echo '<script>
            		        var res = new Object();
            		        res.html = "'.$html_str.'";
            		        res.footer = "'.$footer_str.'";
            		        res.footer_link = "";
            				sbReturnValue(res);
            			  </script>';
    	        }
    	    }
    	    else
    	    {
    	    	$res = sql_param_query('SELECT p_id FROM sb_pages WHERE p_temp_id=?d', $_GET['id']);
    			if ($res)
    			{
	    	    	$date = time();

	    	    	foreach ($res as $value)
	    	    	{
	    	    		sql_param_query('INSERT INTO sb_catchanges (el_id, cat_ident, change_date, change_user_id, action) VALUES ("'.$value[0].'", "pl_pages", ?d, ?d, "edit")', $date, $_SESSION['sbAuth']->getUserId());
	    	    	}

    				echo '<script>
	    	    		var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_gen_pages&id='.intval($_GET['id']).'";
	                  	var strAttr = "resizable=0,width=600,height=400";
	                  	sbShowDialog(strPage, strAttr);
	    	    	</script>';
    			}

    	        fTemplates_Edit($html_str, $footer_str);
    	    }
	    }
	    else
	    {
	        sb_show_message(PL_TEMPLATES_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_TEMPLATES_EDIT_SYSTEMLOG_ERROR, $t_name), SB_MSG_WARNING);

            fTemplates_Edit();
		    return;
	    }
	}
	else
	{
	    $error = true;
	    if (sql_param_query('INSERT INTO sb_templates SET ?a', $row))
	    {
    		$id = sql_insert_id();

    		$footer_ar = fCategs_Add_Elem($id);
    		if ($footer_ar)
    		{
        		sb_add_system_message(sprintf(PL_TEMPLATES_ADD_OK, $t_name));

        		if (!isset($_POST['btn_apply']))
    	        {
        		    echo '<script>
        			   	    sbReturnValue('.$id.');
        			      </script>';
    	        }
    	        else
    	        {
    	            $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);

    	            $_SERVER['QUERY_STRING'] .= '&id='.$id;
    		        $_GET['id'] = $id;

    		        $row['t_id'] = $id;

                    $html_str = fTemplates_Get($row);
            	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            		$html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

            	    fTemplates_Edit($html_str, $footer_str);
    	        }

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_templates WHERE t_id="'.$id.'"');
    		}
	    }

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_TEMPLATES_ADD_ERROR, $t_name), false, 'warning');
            sb_add_system_message(sprintf(PL_TEMPLATES_ADD_SYSTEMLOG_ERROR, $t_name), SB_MSG_WARNING);

            fTemplates_Edit();
		    return;
	    }
	}
}

function fTemplates_Delete()
{
    $res = sql_param_query('SELECT COUNT(*) FROM sb_pages WHERE p_temp_id=?d GROUP BY p_temp_id', $_GET['id']);
    if ($res)
	    list($num_pages) = $res[0];
	else
	    $num_pages = 0;

	if ($num_pages > 0)
	{
		printf(PL_TEMPLATES_DELETE_ERROR, $num_pages);
	}
	else
	{
		sql_param_query('DELETE FROM sb_elems WHERE e_link="temp" AND e_p_id=?d', $_GET['id']);
	}
}

function fTemplates_Paste()
{
    if ($_GET['action'] != 'copy' || !isset($_GET['e']) || !is_array($_GET['e']) || count($_GET['e']) <= 0 || !isset($_GET['ne']) || !is_array($_GET['ne']) || count($_GET['ne']) <= 0)
    {
        return;
    }

    $els = array();
    foreach ($_GET['e'] as $key => $value)
    {
        $els[$value] = $_GET['ne'][$key];
    }

    $res = sql_query('SELECT e_tag, e_ident, e_temp_id, e_el_id, e_p_id, e_params, e_search, e_edit, e_yandex FROM sb_elems
		                    WHERE e_link="temp" AND e_p_id IN ('.implode(',', $_GET['e']).')');

    if ($res)
    {
    	foreach ($res as $value)
    	{
    		list($e_tag, $e_ident, $e_temp_id, $e_el_id, $e_p_id, $e_params, $e_search, $e_edit, $e_yandex) = $value;

    		if (isset($els[$e_p_id]))
    		{
    			$row = array();
    			$row['e_tag'] = $e_tag;
    			$row['e_ident'] = $e_ident;
    			$row['e_link'] = 'temp';
    			$row['e_temp_id'] = $e_temp_id;
    			$row['e_el_id'] = $e_el_id;
    			$row['e_p_id'] = $els[$e_p_id];
    			$row['e_params'] = $e_params;
    			$row['e_search'] = $e_search;
    			$row['e_edit'] = $e_edit;
    			$row['e_yandex'] = $e_yandex;

    		    sql_param_query('INSERT INTO sb_elems SET ?a', $row);
    		}
    	}
    }
}

function fTemplates_Show_Pages()
{
    $res = sql_param_query('SELECT t_name FROM sb_templates WHERE t_id=?d', $_GET['id']);
    if ($res)
    {
        list($t_name) = $res[0];
    }
    else
    {
        sb_show_message(PL_TEMPLATES_EDIT_ERROR, true, 'warning');
        return;
    }

    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

    $total = true;
    $pager = new sbDBPager('lp', 7, 30, 'thisDialog');
    $result = $pager->init($total, 'SELECT pages.p_id, pages.p_name, pages.p_filename, pages.p_filepath, pages.p_state, categs.cat_left, categs.cat_right FROM sb_pages pages, sb_categs categs, sb_catlinks links WHERE pages.p_temp_id=?d AND links.link_el_id=pages.p_id AND links.link_cat_id=categs.cat_id AND categs.cat_ident="pl_pages" ORDER BY pages.p_name', $_GET['id']);

    $num_list = $pager->show();

    if ($result)
    {
        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

        echo '<br />
        <script>
        function showPage(pid)
        {
            var wnd = (_isIE ? dialogArguments : window.opener.sbModalDialog.args);
            wnd.location = sb_cms_content_file + "?event=pl_pages_init&sb_sel_id=" + pid;
            sbCloseDialog();
        }
        </script>';

        $layout = new sbLayout();
        $layout->mTableWidth = '95%';

        $values = array();
        $view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read');
        $res = sql_param_query('SELECT u_domains FROM sb_users WHERE u_id=?d', $_SESSION['sbAuth']->getUserId());
        if ($res)
        {
            $u_domains = explode(',', $res[0][0]);
        }
        else
        {
            $u_domains = array();
        }

        foreach ($result as $value)
        {
            list($p_id, $p_name, $p_filename, $p_filepath, $p_state, $left, $right) = $value;

            $res = sql_query('SELECT cat_title FROM sb_categs WHERE cat_left <= '.$left.' AND cat_right >= '.$right.' AND cat_level=1 AND cat_ident="pl_pages"');
            list($p_domain) = $res[0];

            $page_domain = $p_domain;

            if ($p_domain == SB_COOKIE_DOMAIN && SB_PORT != '80')
                $page_domain .= ':'.SB_PORT;

            if ('http://'.$page_domain != SB_DOMAIN && substr_count($p_domain, '.') > 0)
                $page_domain = 'www.'.$page_domain;

            $page_domain = 'http://'.$page_domain;

            $state = '';
			if ($_SESSION['sbPlugins']->isPluginAvailable('pl_workflow') && $_SESSION['sbPlugins']->isPluginInWorkflow('pl_pages'))
			{
				sb_get_workflow_status($state, 'pl_pages', $p_state);
				$state = preg_replace('=<br.*?/?>=i', '', $state);
			}
			else
			{
	        	switch($p_state)
	        	{
	        		case 0:
	        			$state = '<span style="color:red;">'.PL_PAGES_H_GET_STATE_NOT_PUBLISHED.'</span>';
	        			break;
	        		case 1:
	        			$state = '<span style="color:#33805E;">'.PL_PAGES_H_GET_STATE_PUBLISHED.'</span>';
	        			break;
	        	}
	        	$state = PL_PAGES_H_GET_STATE.': '.$state;
			}

            if($view_info && (in_array($p_domain, $u_domains) || $_SESSION['sbAuth']->isAdmin()))
            {
            	$page = '<b><a href="javascript:void(0);" onclick="showPage('.$p_id.');">'.$p_name.'</a></b>
	                     <div class="smalltext" style="margin-top: 7px;">'.
	                     PL_PAGES_H_GET_URL.': <a href="'.$page_domain.'/'.($p_filepath != '' ? $p_filepath.'/' : '').$p_filename.'" target="_blank" style="font-size:11px;">'.$page_domain.'/'.($p_filepath != '' ? $p_filepath.'/' : '').$p_filename.'</a><br />'.
                         $state.'</div>';
            }
            else
            {
                $page = '<b>'.$p_name.'</b>
	                     <div class="smalltext" style="margin-top: 7px;">'.
	                     PL_PAGES_H_GET_URL.': <a href="'.$page_domain.'/'.($p_filepath != '' ? $p_filepath.'/' : '').$p_filename.'" target="_blank" style="font-size:11px;">'.$page_domain.'/'.($p_filepath != '' ? $p_filepath.'/' : '').$p_filename.'</a><br />'.
                         $state.'</div>';
            }

			$values[] = array('<img src="'.SB_CMS_IMG_URL.'/plugins/pl_pages_32.png" align="absMiddle" width="32" height="32" border="0" title="ID - '.$p_id.'">', $page);
        }

        $width = array('1', '');
        $valign = array('top', 'top');
        $labels = array('', sprintf(PL_TEMPLATES_SHOW_PAGES_TITLE, $t_name));
        $fld = new sbLayoutTable($labels, $values);
        $fld->mWidth = $width;
        $fld->mVAlign = $valign;

        $layout->addField('', $fld);

        $layout->show();

        echo '<br />'.$num_list;
    }
    else
    {
        sb_show_message(PL_TEMPLATES_SHOW_PAGES_ERROR, true);
    }

    echo '<br /><br /><a href="javascript:window.close();">[ '.KERNEL_CLOSE.' ]</a><br /><br />';
}

function fTemplates_Gen_Pages()
{
    $res = sql_param_query('SELECT p_id FROM sb_pages WHERE p_temp_id=?d', $_GET['id']);
    if (!$res)
    {
        sb_show_message(PL_TEMPLATES_SHOW_PAGES_ERROR, true);
        echo '<br /><br /><a href="javascript:window.close();">[ '.KERNEL_CLOSE.' ]</a>';
        return;
    }

    $num_res = count($res);

    if (!isset($_GET['num']))
    {
        echo '<br /><br />'.
         '<div align="left" style="width: 80%;"><b>'.PL_TEMPLATES_GEN_PAGES_ALL.'</b>: '.$num_res.'</div><br />'.
         '<div align="left" style="width: 80%;"><b>'.PL_TEMPLATES_GEN_PAGES_CUR.'</b>: <span id="num">0</span></div><br />
          <div style="border: 1px solid black; width: 80%; height: 17px; background-color: red; text-align:center;">
   	          <b style="color: #fff;">0%</b>
          </div>
          <script>
              function reloadWnd()
              {
                  window.location = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_gen_pages&id='.$_GET['id'].'&num=0&good_num=0";
              }
              setTimeout("reloadWnd();", 100);
          </script>';
        return;
    }

    $num = intval($_GET['num']);
    $good_num = intval($_GET['good_num']);

    $time_end = ini_get('max_execution_time');
    if ($time_end > 0)
    {
        $time_end = time() + $time_end - 5;
    }
    else
    {
        $time_end = time() + 1000000;
    }

    $start_time = time();

    echo '<br /><br />'.
         '<div align="left" style="width: 80%;"><b>'.PL_TEMPLATES_GEN_PAGES_ALL.'</b>: '.$num_res.'</div><br />'.
         '<div align="left" style="width: 80%;"><b>'.PL_TEMPLATES_GEN_PAGES_CUR.'</b>: <span id="num">0</span></div><br />
          <div style="border: 1px solid black; width: 80%; height: 17px; background-color: red; text-align:left;">
   	          <div id="progress" style="width: 0%; height: 17px; background-color: green;text-align:center;">
   	              <b id="percent" style="color: #fff;">0%</b>
   	          </div>
   	      </div><br />
   	      <div id="close_link" style="display: none;"><a href="javascript:window.close();">[ '.KERNEL_CLOSE.' ]</a></div>';

    for ($i = $num; $i < $num_res; $i++)
   	{
   	    if(time() > $time_end)
   	    {
   	        $percent = round($i / $num_res * 100);
   	        echo '<script>
                  function reloadWnd()
   	              {
   	                  window.location = "'.SB_CMS_DIALOG_FILE.'?event=pl_templates_gen_pages&id='.$_GET['id'].'&num='.$i.'&good_num='.$good_num.'";
   	              }

   	              sbGetE("progress").style.width = "'.$percent.'%";
                  sbGetE("percent").innerHTML = "'.$percent.'%";
                  sbGetE("num").innerHTML = "'.$good_num.'";
   	              setTimeout("reloadWnd();", 100);
		      </script>';

            return;
   	    }

   	    if ($start_time - time() > 5)
   	    {
   	        header('SBuilder_Ping: Pong;', true);
   	    }

   	    if (fPages_Gen_Page($res[$i][0]))
   	        $good_num++;
	}

	if ($good_num != $num_res)
	{
	   sb_show_message(PL_TEMPLATES_GEN_PAGES_ERROR, false, 'warning');
	   echo '<script>
	        sbGetE("progress").style.width = "100%";
	        sbGetE("progress").style.backgroundColor = "'.($good_num != $num_res ? '#FF6600' : 'green').'";
	        sbGetE("percent").innerHTML = "100%";
	        sbGetE("num").innerHTML = "'.$good_num.'";
	        sbGetE("close_link").style.display = "";
	    </script>';
	}
	else
	{
		echo '<script>
	        sbGetE("progress").style.width = "100%";
	        sbGetE("progress").style.backgroundColor = "'.($good_num != $num_res ? '#FF6600' : 'green').'";
	        sbGetE("percent").innerHTML = "100%";
	        sbGetE("num").innerHTML = "'.$good_num.'";
	        setTimeout("window.close();", 500);
	    </script>';
	}
}

function fTemplates_Associate()
{
    //Получить список связанных страниц (если страниц нет, то сопоставление не имеет смысла)
    $res = sql_param_query('SELECT p_id FROM sb_pages WHERE p_temp_id=?d', intval($_GET['id']));
    if(!$res)
    {
        sb_show_message(PL_TEMPLATES_SHOW_PAGES_ERROR, true);
        echo '<br /><br /><a href="javascript:sbCloseDialog();">[ '.KERNEL_CLOSE.' ]</a>';
        return;
    }

    $pagesIDs = array();
    foreach ($res as $val) {
        $pageIDs[] = $val[0];
    }

    $associatedTemp = (isset($_POST['assoc_id'])) ? (int)$_POST['assoc_id'] : 0;
    echo '<script type="text/javascript">
        function checkValues(){
            return true;
        }

        function formReload(){
            var form = sbGetE("main");
            form.action = form.action.replace("pl_templates_assoc_submit", "pl_templates_assoc_temp");
            form.submit();
        }
    </script>
    <br /><br />
    ';
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_templates_assoc_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post');

	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

    //Список тегов старого темплейта, переопределенных на странице
    //$res = sql_param_query('SELECT t_html FROM sb_templates WHERE t_id = ?d', $_GET['id']);

    $res = sql_param_query('SELECT DISTINCT e_tag FROM sb_elems WHERE e_link="page" AND e_p_id IN (?a)', $pageIDs);
    if($res){
        $oldTempTags = array();
        foreach($res as $val){
            $oldTempTags[] = preg_replace('/^\{(.*)\}$/'.SB_PREG_MOD, '$1', $val[0]);
        }
    }

    //Выбираем список макетов для сопоставления
    $res_temp = sql_query('SELECT categs.cat_title, temps.t_id, temps.t_name, temps.t_html FROM sb_categs categs, sb_catlinks links, sb_templates temps WHERE temps.t_id != ?d AND temps.t_id=links.link_el_id AND categs.cat_id=links.link_cat_id AND categs.cat_ident=? ORDER BY categs.cat_left, temps.t_name', $_GET['id'],'pl_templates');
    if ($res_temp)
    {
        $options = array();
        $old_cat_title = '';
        foreach ($res_temp as $value)
        {
            list($cat_title, $t_id, $t_name, $t_html) = $value;

            //Проверяем наличие тегов в макете. Если тегов нет, то его не показываем в списке
            $tags = array();
            preg_match_all('/(?<=\{)[_A-Z0-9'.$GLOBALS['sb_reg_upper_interval'].']+(?=\})/'.SB_PREG_MOD, $t_html, $tags);
            if(isset($tags[0]) && empty($tags[0])){
                continue;
            }

            if($associatedTemp == 0){
                $associatedTemp = $t_id;
            }
            if ($old_cat_title != $cat_title)
            {
                $options[uniqid()] = '-'.$cat_title;
                $old_cat_title = $cat_title;
            }
            $options[$t_id] = $t_name;
        }


		$fld = new sbLayoutSelect($options, 'assoc_id', '', 'onchange="formReload();" onkeyup="formReload();"');
		$fld->mSelOptions = array($associatedTemp);
		$layout->addField(PL_TEMPLATES_ASSOC_TEMP_NAME, $fld);

        //Выбираем список тегов нового макета
        $res = sql_param_query('SELECT t_html FROM sb_templates WHERE t_id = ?d', $associatedTemp);
        if ($res) {
            $newTempTags = array();
            preg_match_all('/(?<=\{)[_A-Z0-9' . $GLOBALS['sb_reg_upper_interval'] . ']+(?=\})/' . SB_PREG_MOD, $res[0][0], $newTempTags);
            if (isset($newTempTags[0]) && is_array($newTempTags[0])) {
                $tmp = array('none' => KERNEL_ELEM_NOT_CHOOSED_PAGES);
                foreach($newTempTags[0] as $val){
                    $tmp[(string)$val] = $val;
                }
                $newTempTags = $tmp;
            }
        }
        else
        {
            sb_show_message(PL_TEMPLATES_ASSOC_ERROR, true);
            echo '<br /><br /><a href="javascript:sbCloseDialog();">[ '.KERNEL_CLOSE.' ]</a>';
            return;
        }

        $layout->addField('', new sbLayoutDelim());

        if(!empty($oldTempTags))
        {
            $layout->addField('',new sbLayoutHTML('<div class="hint_div">'.PL_TEMPLATES_ASSOC_DESC.'</div>', true));
            $layout->addField('', new sbLayoutDelim());

            //Формируем таблицу замены
            foreach($oldTempTags as $oldTag){
                $fld = new sbLayoutSelect($newTempTags, "tags[$oldTag]");
                if(in_array($oldTag, $newTempTags)){
                    $fld->mSelOptions = array($oldTag);
                }else{
                    $fld->mSelOptions = array('nones');
                }
                $layout->addField($oldTag, $fld);
            }
        }
        $layout->addButton('submit', KERNEL_ASSOC, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'elems_edit') ? '' : 'disabled="disabled"'));
        $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');
	}
    else
    {
        sb_show_message(PL_TEMPLATES_ASSOC_ERROR, true);
        echo '<br /><br /><a href="javascript:sbCloseDialog();">[ '.KERNEL_CLOSE.' ]</a>';
    }

    $layout->show();

    echo '<br /><br />';
}

function fTemplates_Associate_Submit()
{
    //Получить список связанных страниц
    $res = sql_param_query('SELECT p_id FROM sb_pages WHERE p_temp_id=?d', $_GET['id']);
    if ($res)
    {
        $pageIDs = array();
        foreach ($res as $val)
        {
            $pageIDs[] = $val[0];
        }

        if (isset($_POST['tags']))
        {
            //Выбираем все записи с элементами всех связанных страниц
            $res_elems = sql_param_query('SELECT e_id, e_tag FROM sb_elems WHERE e_p_id IN (?a) AND e_link="page"', $pageIDs);

            if ($res_elems)
            {
                $elemsToDelete = array();
                foreach ($res_elems as $row)
                {
                    $key = preg_replace('/^\{(.*)\}$/' . SB_PREG_MOD, '$1', $row[1]);
                    if (array_key_exists($key, $_POST['tags']) && $key != $_POST['tags'][$key] && $_POST['tags'][$key] != 'none')
                    {
                        $newTag = '{' . $_POST['tags'][$key] . '}';
                        sql_param_query('UPDATE sb_elems SET e_tag = ? WHERE e_id = ?d', $newTag, $row[0]);
                    }
                    elseif ($_POST['tags'][$key] == 'none')
                    {
                        //Если тег не сопоставлен с другим тегом из нового шаблона, то помечаем запись на удаление,
                        //т.е. устанавливаем для данного тега настройки по умолчанию
                        $elemsToDelete[] = $row[0];
                    }
                }
                if (!empty($elemsToDelete))
                {
                    sql_param_query('DELETE FROM sb_elems WHERE e_id IN (?a)', $elemsToDelete);
                }
            }
        }

        //Меняем идентификатор макета у страниц
        sql_param_query('UPDATE sb_pages SET p_temp_id=?d WHERE p_id IN (?a)', intval($_POST['assoc_id']), $pageIDs);
    }

    $res = sql_query('SELECT t_id, t_name FROM sb_templates WHERE t_id IN ('.intval($_GET['id']).', '.intval($_POST['assoc_id']).')');
    if ($res)
    {
        $temps = array();
        foreach ($res as $value)
        {
            $temps[$value[0]] = $value[1];
        }

        sb_add_system_message(sprintf(PL_TEMPLATES_ASSOC_SYSTEM_MESSAGE, $temps[$_GET['id']], $temps[$_POST['assoc_id']]));
    }

    //Указываем новый идентификатор макета как текущий и перегенерируем страницы
    $_GET['id'] = intval($_POST['assoc_id']);
    fTemplates_Gen_Pages();
}
?>