<?php
require_once(SB_CMS_LANG_PATH . '/pl_tester.h.lng.php');

if ($_SESSION['sbPlugins']->register('pl_tester', PL_TESTER_H_PLUGIN_NAME, '')) {
    $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_USER . '>' . PL_TESTER_H_SUB_MENU . '>' . PL_TESTER_H_PLUGIN_NAME, 'questions', 'pl_tester_24.png');

    if ($_SESSION['sbPlugins']->isRightAvailable('pl_tester', 'design_read')) {
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP . '>' . KERNEL_MENU_DEVELOP_DESIGN . '>' . PL_TESTER_H_PLUGIN_NAME . '>' . PL_TESTER_H_DESIGN,
            'design_init', 'pl_tester_design_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP . '>' . KERNEL_MENU_DEVELOP_DESIGN . '>' . PL_TESTER_H_PLUGIN_NAME . '>' . PL_TESTER_H_DESIGN_RESULT,
            'result_design', 'pl_tester_result_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP . '>' . KERNEL_MENU_DEVELOP_DESIGN . '>' . PL_TESTER_H_PLUGIN_NAME . '>' . PL_TESTER_H_DESIGN_RATING,
            'rating_design', 'pl_tester_rating_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP . '>' . KERNEL_MENU_DEVELOP_DESIGN . '>' . PL_TESTER_H_PLUGIN_NAME . '>' . PL_TESTER_H_DESIGN_CATEGS_TITLE,
            'categs_design', 'pl_tester_categs_24.png');
        $_SESSION['sbPlugins']->addToMenu(KERNEL_MENU_DEVELOP . '>' . KERNEL_MENU_DEVELOP_DESIGN . '>' . PL_TESTER_H_PLUGIN_NAME . '>' . PL_TESTER_H_DESIGN_SELCAT_TITLE,
            'selcat_design', 'pl_tester_sel_cat_24.png');
    }

    $_SESSION['sbPlugins']->setMainEvent('questions');

    $_SESSION['sbPlugins']->addUserEvent('questions', 'fTester_Questions', 'read', PL_TESTER_H_PLUGIN_NAME);
    $_SESSION['sbPlugins']->addUserEvent('edit_question', 'fTester_Edit_Question', 'elems_edit', PL_TESTER_H_EDIT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('update_question', 'fTester_Update_Question', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('delete_question', 'fTester_Delete_Question', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('delete_cat_with_elements', 'fTester_Del_Cat_With_Elems', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('show_question', 'fTester_Show_Question', 'elems_public');
    $_SESSION['sbPlugins']->addUserEvent('after_paste_question', 'fTester_After_Paste_Question', 'elems_edit');
    $_SESSION['sbPlugins']->addUserEvent('after_paste_with_elements', 'fTester_After_Paste_Categs_With_Elements', 'categs_edit|elems_edit');

    $_SESSION['sbPlugins']->addUserEvent('edit_test', 'fTester_Edit_Test', 'categs_edit');
    $_SESSION['sbPlugins']->addUserEvent('edit_test_update', 'fTester_Edit_Test_Update', 'categs_edit');
    $_SESSION['sbPlugins']->addUserEvent('delete_test', 'fTester_Delete_Test', 'categs_edit;');

    $_SESSION['sbPlugins']->addUserEvent('design_init', 'fTester_Design_Init', 'design_read', PL_TESTER_H_DESIGN_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('design_edit', 'fTester_Design_Edit', 'design_read', PL_TESTER_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('design_update', 'fTester_Design_Update', 'design_edit');
    $_SESSION['sbPlugins']->addUserEvent('design_delete', 'fTester_Design_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('result_design', 'fTester_Result_Design', 'design_read', PL_TESTER_H_DESIGN_RESULT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('result_design_edit', 'fTester_Result_Design_Edit', 'design_read', PL_TESTER_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('result_design_update', 'fTester_Result_Design_Update', 'design_edit');
    $_SESSION['sbPlugins']->addUserEvent('result_design_delete', 'fTester_Result_Design_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('rating_design', 'fTester_Rating_Design', 'design_read', PL_TESTER_H_DESIGN_RATING_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('rating_design_edit', 'fTester_Rating_Design_Edit', 'design_read', PL_TESTER_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('rating_design_update', 'fTester_Rating_Design_Update', 'design_edit');
    $_SESSION['sbPlugins']->addUserEvent('rating_design_delete', 'fTester_Rating_Design_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('categs_design', 'fTester_Categs_Design', 'design_read', PL_TESTER_H_DESIGN_CATEGS_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('categs_design_edit', 'fTester_Categs_Design_Edit', 'design_read', PL_TESTER_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('categs_design_update', 'fTester_Categs_Design_Update', 'design_edit');
    $_SESSION['sbPlugins']->addUserEvent('categs_design_delete', 'fTester_Categs_Design_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('selcat_design', 'fTester_Selcat_Design', 'design_read', PL_TESTER_H_DESIGN_SELCAT_TITLE);
    $_SESSION['sbPlugins']->addUserEvent('selcat_design_edit', 'fTester_Selcat_Design_Edit', 'design_read', PL_TESTER_H_DESIGN_EDIT);
    $_SESSION['sbPlugins']->addUserEvent('selcat_design_update', 'fTester_Selcat_Design_Update', 'design_edit');
    $_SESSION['sbPlugins']->addUserEvent('selcat_design_delete', 'fTester_Selcat_Design_Delete', 'design_edit');

    $_SESSION['sbPlugins']->addUserEvent('view_test_statistic', 'fTester_Test_Statistic', 'categs_edit');
    $_SESSION['sbPlugins']->addUserEvent('export_result', 'fTester_Statistic_Export', 'categs_edit');
    $_SESSION['sbPlugins']->addToWorkflow();

    $_SESSION['sbPlugins']->addToConstructor('sb_tester_questions');

    $fields = array();
    $fields['stq_id'] = array('title' => PL_TESTER_H_QUESTION_ID_LABEL, 'flags' => '8', 'link_title' => '1', 'tag' => '');
    $fields['stq_question'] = array('title' => PL_TESTER_H_QUESTION_LABEL, 'flags' => '5', 'link_title' => '1', 'tag' => '');
    $fields['stq_type'] = array('title' => PL_TESTER_H_QUESTION_TYPE_LABEL, 'flags' => '4', 'link_title' => '0', 'tag' => '');
    $fields['stq_order'] = array('title' => PL_TESTER_H_QUESTION_ORDER_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
    $fields['stq_show'] = array('title' => PL_TESTER_H_QUESTION_SHOW_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');
    $fields['stq_ball'] = array('title' => PL_TESTER_H_QUESTION_BALL_LABEL, 'flags' => '8', 'link_title' => '0', 'tag' => '');

    $cat_fields = array();

    $_SESSION['sbPlugins']->addFieldsInfo('sb_tester_questions', 'stq_id', 'stq_question', $fields, $cat_fields);

    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_tester_delim', PL_TESTER_H_PLUGIN_NAME, '', '');
    $_SESSION['sbPlugins']->addSetting(INDEX_KERNEL_PLUGIN_SETTING, 'sb_tester_restore_time', PL_TESTER_H_RESTORE_TEST_SETTING, 'number', '', '');
}

$_SESSION['sbPlugins']->addToRubrikator('pl_tester', PL_TESTER_H_PLUGIN_NAME, 'tester', 'pl_tester_categs_design', 'pl_tester_selcat_design');

$_SESSION['sbPlugins']->addSystemEvent('elem_test', 'fTester_Elem_Test_Get', PL_TESTER_H_TEST_NAME);
$_SESSION['sbPlugins']->addSystemEvent('elem_results', 'fTester_Elem_Results_Get', PL_TESTER_H_RESULT_NAME);
$_SESSION['sbPlugins']->addSystemEvent('elem_rating', 'fTester_Elem_Rating_Get', PL_TESTER_H_RATING_NAME);
$_SESSION['sbPlugins']->addSystemEvent('elem_categs', 'fTester_Elem_Categs_Get', PL_TESTER_H_CATEGS_NAME);
$_SESSION['sbPlugins']->addSystemEvent('elem_selcat', 'fTester_Elem_Selcat_Get', PL_TESTER_H_SELCAT_NAME);

$_SESSION['sbPlugins']->addElem(PL_TESTER_H_TEST_NAME, 'test', 'fTester_Elem_Test', 'fTester_Elem_Test_Info', 'elem_test', 800, 600, 'design_edit',
    'pl_tester_design');
$_SESSION['sbPlugins']->addElem(PL_TESTER_H_RESULT_NAME, 'results', 'fTester_Elem_Results', 'fTester_Elem_Results_Info', 'elem_results', 800, 600,
    'result_design_edit', 'pl_tester_result_design');
$_SESSION['sbPlugins']->addElem(PL_TESTER_H_RATING_NAME, 'rating', 'fTester_Elem_Rating', 'fTester_Elem_Rating_Info', 'elem_rating', 800, 600,
    'rating_design_edit', 'pl_tester_rating_design');
$_SESSION['sbPlugins']->addElem(PL_TESTER_H_CATEGS_NAME, 'categs', 'fTester_Elem_Categs_Prog', 'fTester_Elem_Categs_Info', 'elem_categs', 800, 600,
    'categs_design_edit', 'pl_tester_categs_design');
$_SESSION['sbPlugins']->addElem(PL_TESTER_H_SELCAT_NAME, 'selcat', 'fTester_Elem_Selcat_Prog', 'fTester_Elem_Selcat_Info', 'elem_selcat', 800, 600,
    'selcat_design_edit', 'pl_tester_selcat_design');

sb_add_rights();

$_SESSION['sbPlugins']->addEventsRights('elems_public', RIGHTS_H_ELEMS_PUBLIC_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_read', RIGHTS_H_DESIGN_READ_RIGHT);
$_SESSION['sbPlugins']->addEventsRights('design_edit', RIGHTS_H_DESIGN_EDIT_RIGHT);
