<?php
/********************************** вспомогательные функции, использующиеся другими модулями ***********************************/

function fTexts_Get($args)
{
    static $view_info_pages = null;
    static $view_info_temps = null;

    if (is_null($view_info_pages))
    {
        $view_info_pages = $_SESSION['sbPlugins']->isRightAvailable('pl_pages', 'read') && ($_GET['event'] == 'pl_texts_init' || (isset($_GET['real_event']) && $_GET['real_event'] == 'pl_texts_init'));
    }

    if (is_null($view_info_temps))
    {
        $view_info_temps = $_SESSION['sbPlugins']->isRightAvailable('pl_templates', 'read') && ($_GET['event'] == 'pl_texts_init' || (isset($_GET['real_event']) && $_GET['real_event'] == 'pl_texts_init'));
    }

    $id = intval($args['t_id']);

	$pages = sql_query('SELECT pages.p_id, pages.p_name FROM sb_pages pages, sb_elems elems
	                    WHERE elems.e_link="page" AND elems.e_el_id="'.$id.'" AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND pages.p_id=elems.e_p_id GROUP BY pages.p_id ORDER BY pages.p_name LIMIT 4');

	$temps = sql_query('SELECT temps.t_id, temps.t_name FROM sb_templates temps, sb_elems elems
	                    WHERE elems.e_link="temp" AND elems.e_el_id="'.$id.'" AND (elems.e_ident="pl_texts_html" OR elems.e_ident="pl_texts_plain") AND temps.t_id=elems.e_p_id GROUP BY temps.t_id ORDER BY temps.t_name LIMIT 4');

	$result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);" id="'.$args['t_id'].'_title">'.$args['t_name'].'</a></b>
        <div class="smalltext" style="margin-top: 7px;">';

	if(isset($args['t_id']))
	{
		$result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.PL_TEXTS_H_ID_TEXT.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:#33805E;">'.$args['t_id'].'</span></td>
					</tr>
					</table>';
	}

	if ($pages)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_PAGES.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;" id="'.$id.'_num">';

	    $num = min(3, count($pages));
	    for ($i = 0; $i < $num; $i++)
		{
			list($p_id, $p_name) = $pages[$i];
			$result .= ($view_info_pages ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_pages_init&sb_sel_id='.$p_id.'">'.$p_name.'</a>' : $p_name).', ';
		}

		if ($num < count($pages))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkPages(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
	    $result .= KERNEL_USED_ON_PAGES.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	if ($temps)
	{
	    $result .= '<table cellpadding="0" cellspacing="0">
	                <tr>
	                    <td valign="top" nowrap="nowrap" class="smalltext">'.KERNEL_USED_ON_TEMPS.':&nbsp;</td>
	                    <td class="smalltext"><span style="color:green;" id="'.$id.'_num">';

	    $num = min(3, count($temps));
	    for ($i = 0; $i < $num; $i++)
		{
			list($t_id, $t_name) = $temps[$i];
			$result .= ($view_info_temps ? '<a href="'.SB_CMS_CONTENT_FILE.'?event=pl_templates_init&sb_sel_id='.$t_id.'">'.$t_name.'</a>' : $t_name).', ';
		}

		if ($num < count($temps))
			$result .= '&nbsp;<a href="javascript:void(0);" onclick="linkTemps(event);">...</a>';
	    else
	        $result = substr($result, 0, -2);

	    $result .= '</span></td></tr></table>';
	}
	else
	{
	    $result .= KERNEL_USED_ON_TEMPS.': <span style="color: red;">'.KERNEL_NOT_USED.'</span><br />';
	}

	$state = '';
	sb_get_workflow_status($state, 'pl_texts', $args['t_status'], 0, 0, false);
	$state = preg_replace('=<br.*?/?>=i', '', $state);

	$result .= $state.'</div>';

    return $result;
}

function fTexts_Get_Links()
{
    require_once(SB_CMS_LIB_PATH.'/sbDBPager.inc.php');

    $total = true;
    $pager = new sbDBPager('lt', 7, 30, 'thisDialog');
    $result = false;

    if (isset($_GET['id']))
    {
        $res = sql_param_query('SELECT p_temp_id FROM sb_pages WHERE p_id=?d', $_GET['id']);
        if ($res)
        {
            $temp_id = $res[0][0];
            $result = $pager->init($total, 'SELECT DISTINCT t.t_id, t.t_name
                        FROM sb_texts t, sb_elems e
                        WHERE (e.e_ident="pl_texts_plain" OR e.e_ident="pl_texts_html") AND
                        ((e.e_p_id=?d AND e.e_link="page") OR (e.e_p_id=?d AND e.e_link="temp"))
                        AND t.t_id=e.e_el_id', $_GET['id'], $temp_id);
        }
    }

    $num_list = $pager->show();

    if ($result)
    {
        require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

        echo '<br />
        <script>
        function showText(pid)
        {
            if (_isFF || _isIE)
                var wnd = dialogArguments;
            else
                var wnd = window.opener;
            wnd.location = sb_cms_content_file + "?event=pl_texts_init&sb_sel_id=" + pid;
            window.close();
        }
        </script>';

        $layout = new sbLayout();
        $layout->mTableWidth = '95%';

        $values = array();
        $view_info = $_SESSION['sbPlugins']->isRightAvailable('pl_texts', 'read');
        foreach ($result as $value)
        {

            list($t_id, $t_name) = $value;

            if($view_info || $_SESSION['sbAuth']->isAdmin())
            {
            	$page = '<b><a href="javascript:void(0);" onclick="showText('.$t_id.');">'.$t_name.'</a></b>';
            }
            else
            {
                $page = '<b>'.$t_name.'</b>';
            }

            $values[] = array('<img src="'.SB_CMS_IMG_URL.'/plugins/pl_texts_32.png" align="absMiddle" width="32" height="32" border="0" title="ID - '.$t_id.'">', $page);
        }

        $width = array('1', '');
        $valign = array('top', 'top');
        $labels = array('', PL_TEXTS_H_GET_LINKS_TITLE);
        $fld = new sbLayoutTable($labels, $values);
        $fld->mWidth = $width;
        $fld->mVAlign = $valign;

        $layout->addField('', $fld);

        $layout->show();

        echo '<br />'.$num_list;
    }
    else
    {
        sb_show_message(PL_TEXTS_H_GET_LINKS_ERROR, true);
    }

    echo '<br /><br /><a href="javascript:window.close();">[ '.KERNEL_CLOSE.' ]</a><br /><br />';
}

function fTexts_Get_Status()
{
	$id = intval($_GET['id']);
	$res = sql_query('SELECT t_status FROM sb_texts WHERE t_id=?d', $id);
	if (!$res)
	{
		sb_show_message(PL_TEXTS_H_STATUS_EDIT_ERROR, true, 'warning');
	    return;
	}

	list($t_status) = $res[0];

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_texts_get_status_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', '');
	$layout->mTableWidth = '95%';

	$layout->addHeader(PL_TEXTS_H_ELEM_GET_STATUS);

	$edit_rights = $_SESSION['sbPlugins']->isRightAvailable('pl_texts', 'elems_edit');
	$edit_rights = $edit_rights && sb_add_workflow_status($layout, 'pl_texts', $id, 't_status', $t_status);

	$layout->addField('', new sbLayoutInput('hidden', '', 't_html'));

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($edit_rights ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    echo '<br /><br />';

    $layout->show();

    echo '<script>
    sbGetE("t_html").value = (_isIE ? dialogArguments.html : window.opener.sbModalDialog.args.html);
    </script>';
}

function fTexts_Get_Status_Submit()
{
	$id = intval($_GET['id']);

	$t_old_html = '';
    $res = sql_param_query('SELECT t_name, t_html, t_old_html FROM sb_texts WHERE t_id=?d', $id);
    if (!$res)
    {
    	sb_show_message(PL_TEXTS_H_STATUS_EDIT_ERROR, false, 'warning');
    	fTexts_Get_Status();
	    return;
    }

	list($t_name, $t_html, $t_old_html) = $res[0];

	if (isset($_POST['old_workflow']) && $_POST['old_workflow'] == 1)
	{
	  	$t_old_html = $t_html;
	}

	$t_status = 0;
    extract($_POST);

    if (intval($t_status) == 1)
	{
		$t_old_html = '';
	}

    $row = array();

    sb_submit_workflow_status($row, 't_status');

    $row['t_html'] = $t_html;
    $row['t_old_html'] = $t_old_html;

    // редактирование
    sql_param_query('UPDATE sb_texts SET ?a WHERE t_id=?d', $row, $id, sprintf(PL_TEXTS_H_STATUS_EDIT_OK, $t_name));

    $res_cat = sql_query('SELECT categs.cat_id, links.link_id FROM sb_categs categs, sb_catlinks links WHERE categs.cat_ident=? AND links.link_cat_id=categs.cat_id AND links.link_el_id=?d', 'pl_texts', $id);

    $_GET['plugin_ident'] = 'pl_texts';
    $_GET['link_src_cat_id'] = 0;
    $_GET['cat_id'] = $res_cat[0][0];
    $_GET['link_id'] = $res_cat[0][1];

    $footer_ar = fCategs_Edit_Elem();
    if (!$footer_ar)
    {
        sb_show_message(PL_TEXTS_H_STATUS_EDIT_ERROR, false, 'warning');
        fTexts_Get_Status();
        return;
    }

    sb_mail_workflow_status('pl_texts', $id, $t_name, $t_status);

    echo '<script>
        sbReturnValue(true);
    </script>';
}

/********************************** функции построения диалоговых окон ***********************************/

/**
 * Случайный текстовый блок
 */
function fTexts_Get_Random()
{
    require_once(SB_CMS_LIB_PATH.'/sbJustCategs.inc.php');
    $params = unserialize($_GET['params']);

    $js_str = '
        function chooseCat()
        {
            var res = new Object();
            var params = new Array();
            params["id"] = sbCatTree.getSelectedItemId();
            params["subcategs"] = sbGetE("subcategs").checked ? 1 : 0;

            res.el_id = sbCatTree.getSelectedItemId();
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout();
    $layout->mTableWidth = '100%';
    $layout->mTitleWidth = '200';

    $layout->addField(PL_TEXTS_H_SUBCATEGS, new sbLayoutInput('checkbox', '1', 'subcategs', '', (isset($params['subcategs']) && $params['subcategs'] == 1 ? 'checked="checked"' : '')));

    $layout->addButton('button', KERNEL_SAVE, '', '', 'onclick="chooseCat();"');
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog();"');

    $categs = new sbJustCategs('pl_texts');

    $categs->mCategsRootName = PL_TEXTS_H_ROOT_NAME;
    $categs->mCategsUseRights = false;
    $categs->mCategsMenu = false;

    if (isset($_GET['el_id']))
    {
        $categs->mCategsSelectedId = intval($_GET['el_id']);
    }

    $categs->mCategsJavascriptStr = $js_str;
    $categs->showTree($layout->show(false));
    $categs->init();
}

/**
 * Текстовый блок (HTML)
 * Текстовый блок (без форматирования)
 *
 */
function fTexts_Get_Text()
{
    require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');

    $elems = new sbElements('sb_texts', 't_id', 't_name', 'fTexts_Get', 'pl_texts_text', 'pl_texts');

    $t_name = '';
    $t_id = -1;

    if (isset($_GET['el_id']))
    {
        $res = sql_param_query('SELECT t_name FROM sb_texts WHERE t_id=?d', $_GET['el_id']);
        if ($res)
        {
            $t_id = intval($_GET['el_id']);
            list($t_name) = $res[0];
        }
    }

    $elems->mElemsSelectedId = $t_id;

    $elems->mElemsFooterStr = '<table cellspacing="0" cellpadding="7" width="100%" class="form">
        <tr><th>
            '.PL_TEXTS_H_TEXT.':
            </th>
            <td>
                <input type="text" id="t_name" value="'.$t_name.'" style="width: 400px;" redonly="readonly">
                <input type="hidden" id="t_id" value="'.$t_id.'">
            </td>
        </tr>
        <tr>
            <td colspan="2" class="footer">
            <div class="footer">
            <button onclick="chooseText();">'.KERNEL_CHOOSE.'</button>&nbsp;&nbsp;
            <button onclick="sbCloseDialog();">'.KERNEL_CANCEL.'</button>
            </div>
        </td></tr></table>';

    $elems->mElemsJavascriptStr .= '
        function selText(el)
        {
            var t_name = sbGetE("t_name");
            var t_id = sbGetE("t_id");

            if (t_name && t_id)
            {
                t_name.value = sbGetE(el.getAttribute("el_id") + "_title").innerHTML;
                t_id.value = el.getAttribute("el_id");
            }
        }
        function chooseText()
        {
            var t_name = sbGetE("t_name");
            var t_id = sbGetE("t_id");
            if (!t_id || t_id.value == -1)
            {
                alert("'.PL_TEXTS_H_NO_TEXT_MSG.'");
                return;
            }

            var res = new Object();
            var params = new Array();
            params["id"] = t_id.value;

            res.el_id = t_id.value;
            res.params = sb_serialize(params);

            sbReturnValue(res);
        }
    ';

    $elems->mElemsClickFunc = 'selText';

    $elems->mCategsRootName = PL_TEXTS_H_ROOT_NAME;
    $elems->mCategsClosed = false;

    $elems->addField('t_name');       // название текстового блока
    $elems->addField('t_status');       // название текстового блока

    $elems->addFilter(PL_TEXTS_H_NAME_FILTER, 't_name', 'string');
    $elems->addFilter(PL_TEXTS_H_TEXT_FILTER, 't_html', 'string');

    sb_add_workflow_filter($elems, 'pl_texts', 't_status', false);

    $elems->addSorting(PL_TEXTS_H_SORT_BY_NAME, 't_name');

    $elems->mCategsPasteElemsMenuTitle = PL_TEXTS_H_CATEGS_PASTE_ELEMS_MENU_TITLE;
    $elems->mCategsPasteLinksMenuTitle = PL_TEXTS_H_CATEGS_PASTE_LINKS_MENU_TITLE;

    $elems->mElemsAddMenuTitle  = PL_TEXTS_H_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_TEXTS_H_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_TEXTS_H_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = PL_TEXTS_H_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_texts_edit';
    $elems->mElemsEditDlgWidth = 800;
	$elems->mElemsEditDlgHeight = 600;

	$elems->mElemsAddEvent =  'pl_texts_edit';
    $elems->mElemsAddDlgWidth = 800;
	$elems->mElemsAddDlgHeight = 600;

	$elems->mElemsDeleteEvent = 'pl_texts_delete';

	$elems->mElemsUseLinks = true;

	if ($_SESSION['sbPlugins']->isRightAvailable('pl_texts', 'elems_edit'))
	{
	    $elems->mElemsJavascriptStr .= '
          function pagesGen(el_id)
		  {
		      if (typeof(el_id) == "undefined")
		      {
		          el_id = sbSelEl.getAttribute("el_id");
		          var num_el = true;
		      }
		      else
		      {
		          var num_el = sbGetE(el_id + "_num");
		      }

		      if (num_el)
		      {
		          var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_texts_gen_pages&id=" + el_id;
                  var strAttr = "resizable=0,width=600,height=200";
                  sbShowDialog(strPage, strAttr);
		      }
		  }';

        $elems->addElemsMenuItem(PL_TEXTS_H_PAGES_GEN_MENU_ITEM, 'pagesGen();');
        $elems->mElemsAfterEditFunc = 'pagesGen';
	}

    $elems->init();
}

/********************************** функции получения информации по элементам модуля ***********************************/

/**
 * Случайный текстовый блок
 */
function fTexts_Elem_Random_Info($params)
{
    $res = sql_param_query('SELECT cat_title FROM sb_categs WHERE cat_id=?d', $params['id']);
    if ($res)
    {
        echo '<div style="padding-bottom: 5px;"><b>'.PL_TEXTS_H_INFO_CATEG.':</b> '.$res[0][0].'</div>
              <div style="padding-bottom: 5px;"><b>'.PL_TEXTS_H_SUBCATEGS.':</b> '.(isset($params['subcategs']) && $params['subcategs'] == 1 ? KERNEL_YES : KERNEL_NO).'</div>';
    }
}

/**
 * Текстовый блок (HTML)
 * Текстовый блок (без форматирования)
 *
 */
function fTexts_Elem_Text_Info($params)
{
    $res = sql_param_query('SELECT t.t_name, c.cat_title FROM sb_texts t, sb_catlinks l, sb_categs c WHERE t.t_id=?d AND c.cat_ident="pl_texts" AND l.link_cat_id=c.cat_id AND l.link_el_id=t.t_id', $params['id']);
    if ($res)
    {
        echo '<div style="padding-bottom: 5px;"><b>'.PL_TEXTS_H_INFO_TEXT.':</b> '.$res[0][1].' -&gt; '.$res[0][0].'</div>';
    }
}

/********************************** функции получения элементов модуля ***********************************/

/**
 * Текстовый блок (HTML)
 */
function fTexts_Elem_Html($el_id, $temp_id, $params, $tag_id)
{
    $res = sql_param_query('SELECT t_html, t_status FROM sb_texts WHERE t_id=?d', $el_id);
   	if (!$res)
    {
        return '';
    }

    list($html, $status) = $res[0];

	if (defined('SB_VISUAL_EDITOR') && SB_VISUAL_EDITOR == 1)
		return $html;

	if ($status == 0)
		return '';

   	if (sbPlugins::getSetting('sb_texts_use_delim') > 0)
	{
		$html = preg_split('/<div[\s]+style[\s]*=[\s]*["|\'][\s]*page\-break\-after[\s]*:[\s]*always[;]?[\s]*["|\']>[\s]*<span[\s]+style[\s]*=[\s]*["|\'][\s]*display[\s]*:[\s]*none[\s]*[;]?[\s]*["|\']>[\s]*&nbsp;[\s]*<\/span>[\s]*<\/div>/i', $html);

		if (count($html) == 1)
		{
			if ($status == 1)
				return $html[0];
			else
				return "<?php include_once SB_CMS_PL_PATH.'/pl_texts/prog/pl_texts.php';\n
		        fTexts_Elem_Html('$el_id');\n
		        ?>";
		}
		else
		{
			return "<?php include_once SB_CMS_PL_PATH.'/pl_texts/prog/pl_texts.php';\n
		        fTexts_Elem_Pager('$el_id', '$tag_id');\n
		        ?>";
		}
	}
	else
	{
		if ($status == 1)
			return $html;
		else
			return "<?php include_once SB_CMS_PL_PATH.'/pl_texts/prog/pl_texts.php';\n
		        fTexts_Elem_Html('$el_id');\n
		        ?>";
	}
}

/**
 * Текстовый блок (без форматирования)
 */
function fTexts_Elem_Plain($el_id, $temp_id, $params, $tag_id)
{
    $res = sql_param_query('SELECT t_html, t_status FROM sb_texts WHERE t_id=?d', $el_id);
   	if (!$res)
   		return '';

   	list($html, $status) = $res[0];

   	if ($status == 0)
		return '';

   	if ($status == 1)
		return strip_tags($html);
	else
		return "<?php include_once SB_CMS_PL_PATH.'/pl_texts/prog/pl_texts.php';\n
		        fTexts_Elem_Plain('$el_id');\n
		        ?>";
}

/**
 * Случайный текстовый блок
 */
function fTexts_Elem_Random($el_id, $temp_id, $params, $tag_id)
{
    return "<?php include_once SB_CMS_PL_PATH.'/pl_texts/prog/pl_texts.php';\n
        fTexts_Elem_Random('$el_id', '$temp_id', '".addslashes(serialize($params))."', '$tag_id');\n
        ?>";
}

/**
 * Пустой текстовый блок (заглушка)
 */
function fTexts_Elem_Empty($el_id, $temp_id, $params, $tag_id)
{
    return '';
}
?>