<?php
function fUsers_Get($args)
{
    $foto = $args['u_pers_foto'];
    $foto_width = 88;

    $GLOBALS['sbVfs']->mLocal = true;

    if ($foto != '' && $GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/users/'.$foto))
    {
        $ar = $GLOBALS['sbVfs']->getimagesize(SB_CMS_USER_UPLOAD_PATH.'/users/'.$foto);
        if (!$ar || !in_array($ar[2], array(1,2,3)))
        {
            $foto = '<img src="'.SB_CMS_IMG_URL.'/nofoto.png" width="88" height="88" alt="'.$args['u_id'].'" title="'.$args['u_id'].'" />';
        }
        else
        {
            $foto_width = min(88, $ar[0]);
            $foto = '<img src="'.SB_CMS_USER_UPLOAD_URL.'/users/'.$foto.'" alt="'.$args['u_id'].'" title="'.$args['u_id'].'" width="'.$foto_width.'" />';

        }
    }
    else
    {
        $foto = '<img src="'.SB_CMS_IMG_URL.'/nofoto.png" width="88" height="88" alt="'.$args['u_id'].'" title="'.$args['u_id'].'" />';
    }

    $GLOBALS['sbVfs']->mLocal = false;

    $reg_date = $args['u_reg_date'];
    if ($reg_date)
        $reg_date = sb_date('d.m.Y '.KERNEL_IN.' H:i', $reg_date);
    else
        $reg_date = '-';

    $last_date = $args['u_last_date'];
    if ($last_date)
        $last_date = sb_date('d.m.Y '.KERNEL_IN.' H:i', $last_date);
    else
        $last_date = '-';

    $last_ip = $args['u_last_ip'] ? $args['u_last_ip'] : '-';

    if ($args['u_email'] != '' && $args['u_name'] != '')
        $fio = '<a href="mailto:'.$args['u_email'].'">'.$args['u_name'].'</a>';
    else
        $fio = $args['u_name'];

    $u_domains = array();
    if ($args['u_domains'] != '')
    {
    	require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

        $u_domains = explode(',', $args['u_domains']);
        foreach ($u_domains as $key => $value)
        {
        	$domain = $value;
            if ($value == SB_COOKIE_DOMAIN && SB_PORT != '80')
                $domain .= ':'.SB_PORT;

            if ('http://'.$domain != SB_DOMAIN && substr_count($domain, '.') > 0)
                $domain = 'www.'.$domain;

            $domain = 'http://'.$domain;

            $u_domains[$key] = '<a href="'.$domain.'" target="_blank" style="color: #cc0066;">'.$idn->decode($value).'</a>';
        }
        $u_domains = implode(', ', $u_domains);
    }

    $result = '<table width="100%" cellpadding="0" cellspacing="0">
    <tr><td width="110" align="center">'.$foto.'</td>
    <td valign="top"><b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['u_login'].'</a></b>
    <div class="smalltext" style="margin-top: 7px;">'
    .(isset($args['u_id']) ? PL_USERS_FILTER_ID.': <span style="color: #33805E;">'.$args['u_id'].'</span><br />' : '')
    .($fio != '' ? PL_USERS_GET_FIO.': <span style="color: #33805E;">'.$fio.'</span><br />' : '')
    .($args['u_work_title'] != '' ? PL_USERS_EDIT_WORK_TITLE.': <span style="color: #33805E;">'.$args['u_work_title'].'</span><br />' : '')
    .($args['u_pers_otdel'] != '' ? PL_USERS_GET_OTDEL.': <span style="color: #33805E;">'.$args['u_pers_otdel'].'</span><br />' : '')
    .PL_USERS_GET_REG_DATE.': <span style="color: #33805E;">'.$reg_date.'</span><br />'
    .PL_USERS_GET_LAST_DATE.': <span style="color: #33805E;">'.$last_date.' (IP: '.$last_ip.')</span><br />'
    .PL_USERS_GET_DOMAINS.': '.($args['u_admin'] == 1 ? '<span style="color: #33805E;">'.PL_USERS_GET_ALL : '<span style="color: #cc0066;">'.(count($u_domains) != 0 ? $u_domains : PL_USERS_GET_NONE)).'</span><br />'
    .($args['u_active_date'] != 0 ? PL_USERS_GET_ACTIVE_DATE.': <span style="color: #cc0066;">'.sb_date('d.m.Y H:i', $args['u_active_date']).'</span><br />' : '')
    .PL_USERS_GET_STATUS.': '.($args['u_block'] == 1 ? '<span style="color: red" id="elem_user_'.$args['u_id'].'">'.PL_USERS_GET_BLOCK_OK.'</span>' : '<span style="color: green" id="elem_user_'.$args['u_id'].'">'.PL_USERS_GET_BLOCK_NO.'</span>').'
    </div>
    </td></tr></table>';

	return $result;
}

function fUsers_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	$elems = new sbElements('sb_users', 'u_id', 'u_login', 'fUsers_Get', 'pl_users_init', 'pl_users');

	$elems->mShowIcons = false;

	$elems->addField('u_admin');               // админ
	$elems->addField('u_block');               // блокировка
	$elems->addField('u_email');               // e-mail
	$elems->addField('u_name');                // ФИО
	$elems->addField('u_pers_foto');           // фото
	$elems->addField('u_work_title');          // отдел/подразделение
	$elems->addField('u_pers_otdel');          // отдел/подразделение
	$elems->addField('u_domains');             // внутренний телефон сотрудника
	$elems->addField('u_reg_date');            // дата и время добавления пользователя
    $elems->addField('u_last_date');           // дата и время последнего входа в систему
    $elems->addField('u_active_date');         // дата и время последнего входа в систему
    $elems->addField('u_last_ip');             // IP-адрес последнего входа в систему

    $elems->addFilter(PL_USERS_FILTER_ID,	   'u_id', 'number');
    $elems->addFilter(PL_USERS_FILTER_LOGIN,   'u_login', 'string');
    $elems->addFilter(PL_USERS_EDIT_FIO,       'u_name', 'string');
    $elems->addFilter(PL_USERS_EDIT_DATE_REG,  'u_reg_date', 'date');
    $elems->addFilter(PL_USERS_EDIT_DATE_LAST, 'u_last_date', 'date');
    $elems->addFilter(PL_USERS_EDIT_IP_LAST,   'u_last_ip', 'string');
    $elems->addFilter(PL_USERS_EDIT_EMAIL,     'u_email', 'string');
    $elems->addFilter(PL_USERS_EDIT_WORK_TITLE,     'u_work_title', 'string');

	$elems->addSorting(PL_USERS_SORT_BY_ID,			'u_id');
	$elems->addSorting(PL_USERS_SORT_BY_LOGIN,      'u_login');
	$elems->addSorting(PL_USERS_SORT_BY_EMAIL,      'u_email');
	$elems->addSorting(PL_USERS_SORT_BY_NAME,       'u_name');
	$elems->addSorting(PL_USERS_SORT_BY_REG_DATE,   'u_reg_date');
	$elems->addSorting(PL_USERS_SORT_BY_LAST_DATE,  'u_last_date');

    $elems->mCategsAddMenuTitle = PL_USERS_CATEGS_ADD_MENU_TITLE;
    $elems->mCategsEditMenuTitle = PL_USERS_CATEGS_EDIT_MENU_TITLE;
    $elems->mCategsDeleteMenuTitle = PL_USERS_CATEGS_DELETE_MENU_TITLE;
    $elems->mCategsPasteMenuTitle = PL_USERS_CATEGS_PASTE_MENU_TITLE;
    $elems->mCategsCopyMenuTitle = PL_USERS_CATEGS_COPY_MENU_TITLE;
    $elems->mCategsPasteLinksMenuTitle = PL_USERS_CATEGS_PASTE_LINKS_MENU_TITLE;
    $elems->mCategsPasteElemsMenuTitle = PL_USERS_CATEGS_PASTE_ELEMS_MENU_TITLE;

    $elems->mElemsAddMenuTitle = PL_USERS_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = PL_USERS_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = PL_USERS_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle = PL_USERS_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent =  'pl_users_edit';
    $elems->mElemsEditDlgWidth = 800;
	$elems->mElemsEditDlgHeight = 700;

	$elems->mElemsAddEvent =  'pl_users_edit';
    $elems->mElemsAddDlgWidth = 800;
	$elems->mElemsAddDlgHeight = 700;

	$elems->mElemsDeleteEvent =  'pl_users_delete';

	$elems->mCategsAddEvent = 'pl_users_edit_cat';
	$elems->mCategsAddDlgWidth = 800;
	$elems->mCategsAddDlgHeight = 730;

	$elems->mCategsEditEvent = 'pl_users_edit_cat';
	$elems->mCategsEditDlgWidth = 800;
	$elems->mCategsEditDlgHeight = 700;

	$elems->mCategsDeleteEvent = 'pl_users_delete_cat';
	$elems->mCategsAfterPasteEvent =  'pl_users_copy_cat';
	$elems->mElemsAfterPasteEvent  =  'pl_users_paste';
	$elems->mElemsBeforePasteEvent  =  'pl_users_before_paste';

	$elems->mCategsClosed = false;
	$elems->mCategsRubrikator = true;

	$admin_cat_ids = array();

	$res = sql_query('SELECT cat_id, cat_closed, cat_level FROM sb_categs WHERE cat_ident=? ORDER BY cat_left', 'pl_users');
	if ($res)
	{
        for ($i = 0; $i < count($res); $i++)
        {
            list($cat_id, $cat_closed, $cat_level) = $res[$i];
            if ($cat_closed == 1 || $cat_level == 0)
            {
                $admin_cat_ids[] = $cat_id;
            }
        }
	}

	$elems->mCategsNotCheckable = $admin_cat_ids;
	$elems->mCategsNotCopyable = $admin_cat_ids;
	$elems->mCategsNotDeletable = $admin_cat_ids;
	$elems->mCategsNotEditable = $admin_cat_ids;
    $elems->mCategsDadMode = 1;
	$elems->mCategsMaxDeep = 2;
	$elems->mCategsCutMenu = false;
	$elems->mCategsPasteElemsMenuLevel = 2;
	$elems->mCategsPasteElemsMenu = 'cut';
	$elems->mCategsEditMenuLevel = 2;

	$elems->mElemsMenuLevel = 2;
	$elems->mElemsUseLinks = true;

        $elems->mElemsJavascriptStr .= '
		function sbUsersExport(c)
		{
			if(c && sbSelCat)
			{
				var cat_id = sbSelCat.id;
    		}
    		else
    		{
				var cat_id = sbCatTree.getSelectedItemId();
			}

			var args = new Object();
			var form = sbGetE("filter_form");
			if(form)
			{
				var els = form.elements;
				for(var i = 0; i < els.length; i++)
				{
					if(els[i] && els[i].type != "button" && els[i].value != "")
					{
						var reg_date = new RegExp("date_");
						var reg_spin = new RegExp("spin_");

						if(reg_date.test(els[i].id))
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "date";
						}
						else if(reg_spin.test(els[i].id))
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "number";
						}
						else if(els[i].type == "text")
						{
							args[els[i].name] = {};
							args[els[i].name]["value"]= els[i].value;
							args[els[i].name]["type"]= "string";
						}
					}
				}
   			}

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_edit&ident=pl_users&cat_id="+ cat_id;
			var strAttr = "resizable=1,width=765,height=600";
			sbShowModalDialog(strPage, strAttr, null, args);
		}
		function sbUsersImport(c)
		{
			if(c && sbSelCat)
			{
				var cat_id = sbSelCat.id;
    		}
    		else
    		{
				var cat_id = sbCatTree.getSelectedItemId();
			}

			var args = new Object();

			var strPage = "'.SB_CMS_DIALOG_FILE.'?event=pl_export_import_edit&ident=pl_users&cat_id="+ cat_id;
			var strAttr = "resizable=1,width=650,height=370";
			sbShowModalDialog(strPage, strAttr, sbAfterUsersImport, args);
		}

		function sbAfterUsersImport()
		{
			window.location.href = "'.SB_CMS_CONTENT_FILE.'?event=pl_users_init";
		}';

	$elems->addElemsMenuItem(PL_USERS_EDIT_EXPORT, 'sbUsersExport()', false);
	$elems->addElemsMenuItem(PL_USERS_EDIT_IMPORT, 'sbUsersImport()', false);
	$elems->addCategsMenuItem(PL_USERS_EDIT_EXPORT, 'sbUsersExport(true)');
	$elems->addCategsMenuItem(PL_USERS_EDIT_IMPORT, 'sbUsersImport(true)');

	$elems->init();
}

function fUsers_Check_Login()
{
    $res = sql_query('SELECT u_id FROM sb_users WHERE u_login=? AND u_id != ?d', $_GET['login'], $_GET['id']);
    if ($res)
        echo 'TRUE';
    else
        echo 'FALSE';
}

function fUsers_Edit()
{
	$edit_group = sbIsGroupEdit();

	if($edit_group)
	{
		//	проверка прав доступа
		if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_users'))
			return;
	}
	else
	{
		//	проверка прав доступа
		if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_users'))
			return;
	}

	$u_pass_1 = '';
	$u_pass_2 = '';
	$u_admin = 0;

	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '' && !$edit_group)
	{
		$result = sql_query('SELECT u_admin, u_block, u_notify, u_login, u_name, u_reg_date, u_last_ip, u_last_date, u_email, u_active_date,
	                                u_domains, u_uploading_exts, u_strip_php, u_pers_birth, u_pers_prof, u_pers_otdel, u_pers_dolj,
	                                u_pers_messanger_type, u_pers_messanger_id, u_pers_phone, u_pers_mob_phone, u_pers_address, u_pers_dop,
	                                u_pers_foto, u_work_title, u_work_phone, u_work_inner_phone, u_work_fax, u_work_email, u_work_office,
	                                u_work_dop, u_soap_token FROM sb_users WHERE u_id=?d', $_GET['id']);
	    if ($result)
	    {
        	list($u_admin, $u_block, $u_notify, $u_login, $u_name, $u_reg_date, $u_last_ip, $u_last_date, $u_email, $u_active_date,
                 $u_domains, $u_uploading_exts, $u_strip_php, $u_pers_birth, $u_pers_prof, $u_pers_otdel, $u_pers_dolj, $u_pers_messanger_type,
                 $u_pers_messanger_id, $u_pers_phone, $u_pers_mob_phone, $u_pers_address, $u_pers_dop, $u_pers_foto,
                 $u_work_title, $u_work_phone, $u_work_inner_phone, $u_work_fax, $u_work_email, $u_work_office, $u_work_dop, $u_soap_secret) = $result[0];
	    }
	    else
	    {
	        sb_show_message(PL_USERS_EDIT_ERROR, true, 'warning');
	        return;
	    }

		$u_pass = '';
		if ($u_active_date != 0)
            $u_active_date = sb_date('d.m.Y H:i', $u_active_date);
        else
            $u_active_date = '';

        $GLOBALS['sbVfs']->mLocal = true;

		if ($u_pers_foto == '' || !$GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto))
        {
            $u_pers_foto = '';
        }
        else
        {
            $ar = $GLOBALS['sbVfs']->getimagesize(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto);
            if (!$ar || !in_array($ar[2], array(1,2,3)))
            {
                // не картинка
                $u_pers_foto = '';
            }
            else
            {
                $u_pers_foto = SB_CMS_USER_UPLOAD_URL.'/users/'.$u_pers_foto;
            }
		}

        $GLOBALS['sbVfs']->mLocal = false;
        $u_domains = explode(',', $u_domains);
	}
	else
	{
	    $u_login = $u_name = $u_email = $u_active_date = $u_pers_birth = $u_pers_prof = $u_pers_otdel = $u_pers_dolj = $u_pers_messanger_type =
	    $u_pers_messanger_id = $u_pers_phone = $u_pers_mob_phone = $u_pers_address = $u_pers_dop = $u_work_title = $u_work_phone =
	    $u_work_inner_phone = $u_work_fax = $u_work_email = $u_work_office = $u_work_dop = $u_pers_foto = $u_soap_secret = '';

	    $u_domains[] = SB_COOKIE_DOMAIN;
	    $u_uploading_exts = 'jpg jpeg gif png bmp tif tiff txt pdf doc xls css js vbs csv swf fla wmv mp3 mov wav zip rar';

        $u_block = 0;
        $u_notify = 0;
        $u_reg_date = $u_last_date = $u_last_ip = null;

        if (!isset($_GET['id']))
            $_GET['id'] = '';

	    $u_admin = 0;
	    $res = sql_query('SELECT cat_closed FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
	    if ($res)
	    {
			list($u_admin) = $res[0];
			if ($u_admin != '1')
	        {
				$u_admin = 0;
			}
		}
		$u_strip_php = 1;
	}

	if (count($_POST) > 0)
	{
    	extract($_POST);
    	if (!isset($_POST['u_domains']))
    	{
        	$u_domains = array();
    	}
	}

	echo ' <script src="'.SB_CMS_JSCRIPT_URL.'/sbAJAX.js.php"></script>
	<script>
				function checkValues()
                {
                    var u_pers_messanger_type = sbGetE("u_pers_messanger_type");
                    var u_pers_messanger_id = sbGetE("u_pers_messanger_id");
                    ';

			if(!$edit_group)
			{
				echo '
                    var u_login = sbGetE("u_login");
                    var u_pass_1 = sbGetE("u_pass_1");
                    var u_pass_2 = sbGetE("u_pass_2");
                    var u_email = sbGetE("u_email");

					var myReg = /[^\w-А-Яа-я]+/;
                	if (u_login.value == "" || myReg.test(u_login.value))
                	{
                		alert("'.PL_USERS_NO_LOGIN_MSG.'");
                		return false;
                	}

                	if (u_login.value.length < 4)
                	{
                	    alert("'.PL_USERS_WRONG_LOGIN_MSG.'");
                		return false;
                	}

                	var myReg = /^\w+[\.\w\-_]*@\w+[\.\w\-]*\w\.\w{2,6}$/;
                	if(u_email.value == "" || !myReg.test(u_email.value))
                	{
                	    alert("'.PL_USERS_NO_E_MAIL.'");
                		return false;
                	}
				';


				if ($_GET['id'] == '')
    			{
        			echo 'if (u_pass_1.value == "")
                	{
                		alert("'.PL_USERS_NO_PASS_MSG.'");
                		return false;
                	}

                	if (u_pass_1.value.length < '.intval(sbPlugins::getSetting('sb_pass_length_limit')).')
                	{
                	    alert("'.PL_USERS_WRONG_PASS_MSG2.'");
                	    return false;
                	}';
		    	}
		    	else
		    	{
        			echo 'if (u_pass_1.value != "" && u_pass_1.value.length < '.intval(sbPlugins::getSetting('sb_pass_length_limit')).')
                	{
                	    alert("'.PL_USERS_WRONG_PASS_MSG2.'");
                	    return false;
                	}';
				}

				echo 'if (u_pass_1.value != u_pass_2.value)
                	{
                		alert("'.PL_USERS_WRONG_PASS_MSG.'");
                		return false;
                	}

                    var res = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_users_check_login&id='.$_GET['id'].'&login=" + u_login.value);
                    if (res == "TRUE")
                	{
                		alert("'.PL_USERS_SAME_LOGIN_MSG.'");
                		return false;
                	}';
			}

				echo '
                	if (u_pers_messanger_type.value != 0 && u_pers_messanger_id.value == "")
                	{
						alert("'.PL_USERS_NO_MESSANGER_MSG.'");
						return false;
					}
					return true;
                }
                function sbSoapTokenGenerator()
                {
                	var secret_num = Math.floor(Math.random() * 10);
                	var word = sbGetE("u_soap_word").value;
                	if(word == "")
                	{
                		alert("'.PL_USERS_NO_SOAP_SECRET_WORD.'");
                		return false;
                	}
                	var token = sbLoadSync("'.SB_CMS_EMPTY_FILE.'?event=pl_users_generate_soap_token&id='.intval($_GET['id']).'&word=" + word + "&num=" + secret_num);
                	sbGetE("u_soap_token").value = token;
                	sbGetE("u_soap_num").value = secret_num;
                	return true;
                }';
	if($edit_group)
	{
		echo '
			function cancel()
            {
				sbReturnValue("refresh");
			}
			sbAddEvent(window, "close", cancel);';
	}
	echo '</script>';

	//SB_CMS_EMPTY_FILE
    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_users_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()', '', 'enctype="multipart/form-data"');

	$layout->mTitleWidth = '200';
	// Основные
    $layout->addTab(PL_USERS_EDIT_TAB1);
    $layout->addHeader(PL_USERS_EDIT_TAB1);

	if(!$edit_group)
	{
	    $layout->addField(PL_USERS_EDIT_LOGIN, new sbLayoutInput('text', $u_login, 'u_login', '', 'style="width:200px;" autocomplete="off"', true));
    	$layout->addField(PL_USERS_EDIT_EMAIL, new sbLayoutInput('text', $u_email, 'u_email', '', 'style="width:200px;" autocomplete="off"', true));
    	$layout->addField('', new sbLayoutDelim());

    	$fld = new sbLayoutInput('password', $u_pass_1, 'u_pass_1', '', 'style="width:200px;" autocomplete="off" onkeyup="sb_pass_strength(\'u_pass_1\', \'u_login\', \'pass_meter\', '.intval(sbPlugins::getSetting('sb_pass_length_limit')).');"', true);
    	$fld->mHTML = '<div id="pass_meter">'.PL_USERS_EDIT_PASS_METER.'</div>';
    	$layout->addField(sprintf(PL_USERS_EDIT_PASS1, intval(sbPlugins::getSetting('sb_pass_length_limit'))), $fld);
    	$layout->addField(PL_USERS_EDIT_PASS2, new sbLayoutInput('password', $u_pass_2, 'u_pass_2', '', 'style="width:200px;" autocomplete="off"', true));
    	$layout->addField('', new sbLayoutDelim());
	}

    if ($u_admin == 1)
    {
    	$layout->addField(PL_USERS_EDIT_NOTIFY.sbGetGroupEditCheckbox('u_notify', $edit_group), new sbLayoutInput('checkbox', '1', 'u_notify', '', ($u_notify == 1 ? 'checked' : '').' style="margin:0px;"'));
        $layout->addField('', new sbLayoutDelim());
    }

    if ($_GET['id'] != $_SESSION['sbAuth']->getUserId())
    {
		$layout->addField(PL_USERS_EDIT_BLOCK.sbGetGroupEditCheckbox('u_block', $edit_group), new sbLayoutInput('checkbox', '1', 'u_block', '', ($u_block == 1 ? 'checked' : '').' style="margin:0px;"'));
		if(!$edit_group)
		{
			$layout->addField('', new sbLayoutDelim());
		}
	}

	if ($_GET['id'] != '' && !$edit_group)
	{
        $layout->addField(PL_USERS_EDIT_DATE_REG, new sbLayoutLabel($u_reg_date ? sb_date('d.m.Y '.KERNEL_IN.' H:i', $u_reg_date) : '-'));
        $layout->addField(PL_USERS_EDIT_DATE_LAST, new sbLayoutLabel($u_last_date ? sb_date('d.m.Y '.KERNEL_IN.' H:i', $u_last_date).' ('.PL_USERS_EDIT_IP_LAST.': '.($u_last_ip ? $u_last_ip : '-').')' : '-'));

        $layout->addField('', new sbLayoutInput('hidden', $u_reg_date, 'u_reg_date'));
        $layout->addField('', new sbLayoutInput('hidden', $u_last_date, 'u_last_date'));
        $layout->addField('', new sbLayoutInput('hidden', $u_last_ip, 'u_last_ip'));
    }

    // Права
    if ($u_admin != 1)
    {
        $layout->addTab(PL_USERS_EDIT_TAB_RIGHTS);
        $layout->addHeader(PL_USERS_EDIT_TAB_RIGHTS);

		$html = '<div class="hint_div">'.PL_USERS_EDIT_TAB_DESC.'</div>';

        $layout->addField('', new sbLayoutHTML($html, true));

        $activeDate = new sbLayoutDate($u_active_date, 'u_active_date');
        $activeDate->mDropButton = true;
        $layout->addField(PL_USERS_EDIT_ACTIVE_DATE.sbGetGroupEditCheckbox('u_active_date', $edit_group), $activeDate);

        require_once (SB_CMS_LIB_PATH.'/sbIDN.inc.php');
    	$idn = new sbIDN();

        $html = '';
        foreach ($GLOBALS['sb_domains'] as $key => $value)
        {
            $html .= '<div style="margin-top:5px;"><input type="checkbox" value="'.$key.'" name="u_domains[]" id="u_domains'.$key.'" style="margin:0px;"'.(in_array($key, $u_domains) ? ' checked' : '').'>&nbsp;<label for="u_domains'.$key.'">'.$idn->decode($key).'</label></div>';
        }

		$layout->addField('', new sbLayoutDelim());

        $fld = new sbLayoutHTML($html);
        $fld->mShowColon = false;

        $layout->addField(PL_USERS_EDIT_DOMAINS.sbGetGroupEditCheckbox('u_domains', $edit_group), $fld);

        $layout->addField('', new sbLayoutDelim());
        $layout->addField(PL_USERS_EDIT_UPLOAD_EXTS.sbGetGroupEditCheckbox('u_uploading_exts', $edit_group), new sbLayoutInput('text', $u_uploading_exts, 'u_uploading_exts', '', 'style="width:470px;"'));
		$layout->addField(PL_USERS_EDIT_STRIP_PHP.sbGetGroupEditCheckbox('u_strip_php', $edit_group), new sbLayoutInput('checkbox', '1', 'u_strip_php', '', ($u_strip_php == 1 ? 'checked' : '').' style="margin:0px;"'));
	}
	else
	{
        $layout->addField('', new sbLayoutInput('hidden', '', 'u_active_date'));
        $layout->addField('', new sbLayoutInput('hidden', $u_uploading_exts, 'u_uploading_exts'));
        $layout->addField('', new sbLayoutInput('hidden', $u_strip_php, 'u_strip_php'));
    }

    // Персональные
    $layout->addTab(PL_USERS_EDIT_TAB2);
    $layout->addHeader(PL_USERS_EDIT_TAB2);

    $layout->addField(PL_USERS_EDIT_FIO.sbGetGroupEditCheckbox('u_name', $edit_group), new sbLayoutInput('text', $u_name, 'u_name', '', 'style="width:470px;"'));
    
    $layout->addField('', new sbLayoutDelim());
    $layout->addField('', new sbLayoutLabel('<div class="hint_div">'.sb_str_replace(SB_BASEDIR, '', sprintf(PL_USERS_PERS_FOTO_HINT, SB_CMS_USER_UPLOAD_PATH.'/users')).'</div>', '', '', false));
    
    $settings = array(
        'path'  => SB_CMS_USER_UPLOAD_PATH,
        'local' => 1,
    );

    $fld = new sbLayoutImage($u_pers_foto, 'u_pers_foto', '', 'size="60%"', false, $settings);
    $fld->mLocal = true;

    $layout->addField(PL_USERS_EDIT_FOTO.sbGetGroupEditCheckbox('u_pers_foto', $edit_group), $fld);
    
    $layout->addField('', new sbLayoutDelim());
    
    $field = new sbLayoutDate($u_pers_birth, 'u_pers_birth', '', '');
    $field->mShowTime = false;
    $field->mDropButton = true;
    $layout->addField(PL_USERS_EDIT_BIRTH.sbGetGroupEditCheckbox('u_pers_birth', $edit_group), $field);

	$layout->addField(PL_USERS_EDIT_PROF.sbGetGroupEditCheckbox('u_pers_prof', $edit_group), new sbLayoutInput('text', $u_pers_prof, 'u_pers_prof', '', 'style="width:200px;"'));

    $values = array();
    for($i = 0; $i < count($GLOBALS['PL_USERS_MESSANGER_TYPE']); $i++)
    {
        $values[$i] = $GLOBALS['PL_USERS_MESSANGER_TYPE'][$i];
    }

    $field = new sbLayoutSelect($values, 'u_pers_messanger_type', '');
    $field->mSelOptions = array($u_pers_messanger_type);
    $layout->addField(PL_USERS_EDIT_MESSANGER_TYPE.sbGetGroupEditCheckbox('u_pers_messanger_type', $edit_group), $field);

    $layout->addField(PL_USERS_EDIT_MESSANGER_ID.sbGetGroupEditCheckbox('u_pers_messanger_id', $edit_group), new sbLayoutInput('text', $u_pers_messanger_id, 'u_pers_messanger_id', '', 'style="width:200px;"'));
    $layout->addField(PL_USERS_EDIT_TELEPHONE.sbGetGroupEditCheckbox('u_pers_phone', $edit_group), new sbLayoutInput('text', $u_pers_phone, 'u_pers_phone', '', 'style="width:200px;"'));
    $layout->addField(PL_USERS_EDIT_MOB_TELEPHONE.sbGetGroupEditCheckbox('u_pers_mob_phone', $edit_group), new sbLayoutInput('text', $u_pers_mob_phone, 'u_pers_mob_phone', '', 'style="width:200px;"'));
    $layout->addField(PL_USERS_EDIT_ADRESS.sbGetGroupEditCheckbox('u_pers_address', $edit_group), new sbLayoutInput('text', $u_pers_address, 'u_pers_address', '', 'style="width:470px;"'));

    $field = new sbLayoutTextarea($u_pers_dop, 'u_pers_dop', '', 'style="width:100%;"');
    $field->mShowToolbar = true;
    $field->mShowEnlargeBtn = true;
    $layout->addField(PL_USERS_EDIT_DOP.sbGetGroupEditCheckbox('u_pers_dop', $edit_group), $field);

    // Корпоративные
    $layout->addTab(PL_USERS_EDIT_TAB3);
    $layout->addHeader(PL_USERS_EDIT_TAB3);

    $layout->addField(PL_USERS_EDIT_WORK_TITLE.sbGetGroupEditCheckbox('u_work_title', $edit_group), new sbLayoutInput('text', $u_work_title, 'u_work_title', '', 'style="width:470px;"'));
    $layout->addField(PL_USERS_EDIT_OTDEL.sbGetGroupEditCheckbox('u_pers_otdel', $edit_group), new sbLayoutInput('text', $u_pers_otdel, 'u_pers_otdel', '', 'style="width:200px;"'));
    $layout->addField(PL_USERS_EDIT_DOLZJ.sbGetGroupEditCheckbox('u_pers_dolj', $edit_group), new sbLayoutInput('text', $u_pers_dolj, 'u_pers_dolj', '', 'style="width:200px;"'));
    $layout->addField(PL_USERS_EDIT_WORK_TELEPHONE.sbGetGroupEditCheckbox('u_work_phone', $edit_group), new sbLayoutInput('text', $u_work_phone, 'u_work_phone', '', 'style="width:200px;"'));
    $layout->addField(PL_USERS_EDIT_WORK_INNER_TELEPHONE.sbGetGroupEditCheckbox('u_work_inner_phone', $edit_group), new sbLayoutInput('text', $u_work_inner_phone, 'u_work_inner_phone', '', 'style="width:200px;"'));
    $layout->addField(PL_USERS_EDIT_WORK_FAX.sbGetGroupEditCheckbox('u_work_fax', $edit_group), new sbLayoutInput('text', $u_work_fax, 'u_work_fax', '', 'style="width:200px;"'));
    $layout->addField(PL_USERS_EDIT_WORK_EMAIL.sbGetGroupEditCheckbox('u_work_email', $edit_group), new sbLayoutInput('text', $u_work_email, 'u_work_email', '', 'style="width:200px;"'));
    $layout->addField(PL_USERS_EDIT_WORK_OFFICE.sbGetGroupEditCheckbox('u_work_office', $edit_group), new sbLayoutInput('text', $u_work_office, 'u_work_office', '', 'style="width:200px;"'));

    $field = new sbLayoutTextarea($u_work_dop, 'u_work_dop', '', 'style="width:100%;"');
    $field->mShowToolbar = true;
    $field->mShowEnlargeBtn = true;
    $layout->addField(PL_USERS_EDIT_DOP.sbGetGroupEditCheckbox('u_work_dop', $edit_group), $field);

	if(!$edit_group)
	{
    	$layout->getPluginFields('pl_users', $_GET['id'], 'u_id');
	}
	else
	{
		$layout->getPluginFields('pl_users', '', 'u_id', false, $edit_group);
	}

	if(!$edit_group)
	{
		//	SOAP
		$layout->addTab(PL_USERS_EDIT_TAB_SOAP);
		$layout->addHeader(PL_USERS_EDIT_TAB_SOAP);

		$u_soap_word = $u_soap_token = $u_soap_num = '';

		if(!empty($u_soap_secret))
		{
			$u_soap_secret = explode('|',$u_soap_secret);
			if(count($u_soap_secret) == 3)
	    	{
				$u_soap_word = $u_soap_secret[0];
				$u_soap_num = $u_soap_secret[1];
				$u_soap_token = $u_soap_secret[2];
			}
		}

		$layout->addField(PL_USERS_EDIT_SOAP_SECRET_WORD, new sbLayoutInput('text', $u_soap_word, 'u_soap_word', '', 'style="width:470px;"'));

		$fld = new sbLayoutInput('text', $u_soap_token, 'u_soap_token', '', 'style="width:470px;" readonly="readonly"');
		$fld1 = new sbLayoutInput('hidden', $u_soap_num, 'u_soap_num', '', '');
		$fld -> mHTML = $fld1 -> getField();
		$layout->addField(PL_USERS_EDIT_SOAP_SECRET_TOKEN, $fld);

		$layout->addField('', new sbLayoutInput('button', PL_USERS_EDIT_SOAP_SECRET_TOKEN_GENERATE, '', '', 'onclick="sbSoapTokenGenerator()"'));
	}

	$layout->addButton('submit', KERNEL_SAVE, '', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_users', 'elems_edit') ? '' : 'disabled'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', ($edit_group ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"'));
	$layout->show();
}

function fUsers_Edit_Submit()
{
	$edit_group = sbIsGroupEdit();
	if($edit_group)
	{
		//	проверка прав доступа
		if (!fCategs_Check_Elems_Rights($_GET['ids'][0], $_GET['cat_id'], 'pl_users'))
			return;
	}
	else
	{
		// проверка прав доступа
		if (!fCategs_Check_Elems_Rights((isset($_GET['id']) && $_GET['id'] != '' ? $_GET['id'] : 0), $_GET['cat_id'], 'pl_users'))
			return;
	}

	$admin = 0;
	$res = sql_query('SELECT cat_closed FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);
	if ($res)
	{
	   list($admin) = $res[0];

	   if ($admin == '1')
	       $admin = 1;
	   else
		   $admin = 0;
    }

    if (!isset($_GET['id']))
        $_GET['id'] = '';

	$ch_u_block = $ch_u_notify = $ch_u_name = $ch_u_active_date = $ch_u_domains = $ch_u_uploading_exts = $ch_u_strip_php = $ch_u_pers_birth = $ch_u_pers_prof = $ch_u_pers_otdel = $ch_u_pers_dolj = $ch_u_pers_messanger_type = $ch_u_pers_messanger_id = $ch_u_pers_phone = $ch_u_pers_mob_phone = $ch_u_pers_address = $ch_u_pers_dop = $ch_u_pers_foto = $ch_u_work_title = $ch_u_work_phone = $ch_u_work_inner_phone = $ch_u_work_fax = $ch_u_work_email = $ch_u_work_office = $ch_u_work_dop = 0;

    $u_block = 0;
    $u_notify = 0;
    $u_strip_php = 0;
    $u_domains = array(SB_COOKIE_DOMAIN);

	require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

	$layout = new sbLayout();
	$user_row = array();
	$user_row = $layout->checkPluginFields('pl_users', ($edit_group ? '' : $_GET['id']), 'u_id', false, $edit_group);
	if($user_row === false)
	{
		$layout->deletePluginFieldsFiles();
		fUsers_Edit();
		return;
	}

	extract($_POST);

	$u_block = intval($u_block);
	$u_notify = ($admin == 1 ? intval($u_notify) : 0);
	$u_strip_php = intval($u_strip_php);

	//	подключаем библиотеку работы с загрузкой файлов
	require_once(SB_CMS_LIB_PATH.'/sbUploader.inc.php');

	if($edit_group && $ch_u_pers_foto == 1)
	{
		$u_pers_foto = array();
		$res = sql_query('SELECT u_pers_foto FROM sb_users WHERE u_id IN (?a)', $_GET['ids']);
	    if ($res)
	    {
	    	foreach($res as $key => $value)
	    	{
	        	$u_pers_foto[] = $value[0];
	    	}
	    }
	}
	elseif(!$edit_group)
	{
		$u_pers_foto = '';

		$res = sql_query('SELECT u_pers_foto FROM sb_users WHERE u_id=?d', $_GET['id']);
		if ($res)
		{
			list($u_pers_foto) = $res[0];
		}
	}

    if ($u_active_date == '')
    {
        $u_active_date = 0;
    }
    else
    {
		$u_active_date = sb_datetoint($u_active_date);
	}

	$u_domains = implode(',', $u_domains);
	$GLOBALS['sbVfs']->mLocal = true;
    
    if(isset($_POST['u_pers_foto']) && $_POST['u_pers_foto'] != '')
    {
        $u_pers_foto = explode('/', $_POST['u_pers_foto_local']);
        $u_pers_foto = $u_pers_foto[count($u_pers_foto)-1];
    }
    elseif((!$edit_group || $edit_group && $ch_u_pers_foto == 1) && isset($_POST['u_pers_foto_local']) && isset($_POST['u_pers_foto_local_tmp']) && $_POST['u_pers_foto_local'] != '' && !isset($_POST['u_pers_foto_delete']))
    {
        $u_pers_foto = explode('/', $_POST['u_pers_foto_local']);
        $u_pers_foto = $u_pers_foto[count($u_pers_foto)-1];
        
        if (!$GLOBALS['sbVfs']->copy(SB_CMS_TMP_PATH.'/'.$_POST['u_pers_foto_local_tmp'], SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto, true))
        {
            $u_pers_foto = '';
        }
    }
    elseif(isset($_FILES['u_pers_foto']) && @is_uploaded_file($_FILES['u_pers_foto']['tmp_name']) && !isset($_POST['u_pers_foto_delete']))
    {
        // загружаем фотографию пользователя
        $uploader = new sbUploader();
        $uploader->setMaxFileSize(sbPlugins::getSetting('sb_files_max_upload_size'));
        $uploader->setMaxImageSize(sbPlugins::getSetting('sb_files_max_upload_width'), sbPlugins::getSetting('sb_files_max_upload_height'));

        // сохраняем файл
        $success = $uploader->upload('u_pers_foto', array ('gif', 'jpeg', 'jpg', 'png'));

        $file_name = false;
		if ($success)
		{
			$file_name = $uploader->move(SB_CMS_USER_UPLOAD_PATH.'/users/', time().$_FILES['u_pers_foto']['name']);
		}

        if (!$success || !$file_name)
		{
		    $GLOBALS['sbVfs']->mLocal = true;

			sb_show_message($uploader->getError(), false, 'warning');
			sb_add_system_message(sprintf(PL_USERS_EDIT_ERROR_SAVE_FILE, $_FILES['u_pers_foto']['name']), SB_MSG_WARNING);

			fUsers_Edit();
			return;
		}

		if ($edit_group && is_array($u_pers_foto) && count($u_pers_foto) > 0)
		{
			foreach ($u_pers_foto as $key => $value)
			{
		        if ($value != '' && $GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/users/'.$value) && $GLOBALS['sbVfs']->is_file(SB_CMS_USER_UPLOAD_PATH.'/users/'.$value))
				{
					$GLOBALS['sbVfs']->delete(SB_CMS_USER_UPLOAD_PATH.'/users/'.$value);
				}
			}
		}
		elseif(!$edit_group && $su_pers_foto != '' && $GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/pl_site_users/'.$su_pers_foto) && !$GLOBALS['sbVfs']->is_dir(SB_CMS_USER_UPLOAD_PATH.'/pl_site_users/'.$su_pers_foto))
		{
	        if ($_GET['id'] != '' && $u_pers_foto != '' && $GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto) && $GLOBALS['sbVfs']->is_file(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto))
	        {
				$GLOBALS['sbVfs']->delete(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto);
			}
		}
		$u_pers_foto = $file_name;
	}
	elseif(!$edit_group && isset($_POST['u_pers_foto_delete']) && $_GET['id'] != '' && $u_pers_foto != '' && $GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto) && $GLOBALS['sbVfs']->is_file(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto))
	{
        // удаляем фотографию пользователя
        $GLOBALS['sbVfs']->delete(SB_CMS_USER_UPLOAD_PATH.'/users/'.$u_pers_foto);
        $u_pers_foto = '';
	}
	elseif($edit_group && $ch_u_pers_foto == 1 && (!isset($_FILES['u_pers_foto']['tmp_name']) || $_FILES['u_pers_foto']['tmp_name'] == '') && count($u_pers_foto) > 0)
	{
		foreach($u_pers_foto as $key => $value)
		{
			//	удаляем фотографии пользователей
			if ($value != '' && $GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/users/'.$value) && !$GLOBALS['sbVfs']->is_dir(SB_CMS_USER_UPLOAD_PATH.'/users/'.$value))
			{
				$GLOBALS['sbVfs']->delete(SB_CMS_USER_UPLOAD_PATH.'/users/'.$value);
	        }
		}
		$u_pers_foto = '';
	}
	$GLOBALS['sbVfs']->mLocal = true;

	if(!$edit_group)
	{
		if ($u_pass_1 != $u_pass_2 || ($u_pass_1 != '' && sb_strlen($u_pass_1) < intval(sbPlugins::getSetting('sb_pass_length_limit'))))
		{
			sb_show_message(PL_USERS_EDIT_ERROR_PASSWORD, false, 'warning');
			fUsers_Edit();
			return;
		}
		if ($u_login == '')
		{
			sb_show_message(PL_USERS_EDIT_ERROR_LOGIN, false, 'warning');
			fUsers_Edit();
			return;
	    }
	}

	$u_soap_secret = '';
	if(isset($u_soap_word) && isset($u_soap_token) && isset($u_soap_num) && !empty($u_soap_word) && !empty($u_soap_token) && !empty($u_soap_num))
	{
		$u_soap_secret = $u_soap_word.'|'.$u_soap_num.'|'.$u_soap_token;
	}

	$row = array();
	if(!$edit_group)
    {
		$row['u_login'] = $u_login;
		$row['u_email'] = $u_email;
		$row['u_soap_token'] = $u_soap_secret;
	}

	if(!$edit_group || $edit_group && $ch_u_block == 1)
    {
		$row['u_block'] = $u_block;
    }
	if(!$edit_group || $edit_group && $ch_u_notify == 1)
	{
		$row['u_notify'] = $u_notify;
	}
	if(!$edit_group || $edit_group && $ch_u_name == 1)
	{
		$row['u_name'] = $u_name;
	}
	if(!$edit_group || $edit_group && $ch_u_active_date == 1)
	{
		$row['u_active_date'] = $u_active_date;
	}
	if(!$edit_group || $edit_group && $ch_u_domains == 1)
	{
		$row['u_domains'] = $u_domains;
	}
	if(!$edit_group || $edit_group && $ch_u_uploading_exts == 1)
	{
		$row['u_uploading_exts'] = $u_uploading_exts;
	}
	if(!$edit_group || $edit_group && $ch_u_strip_php == 1)
	{
		$row['u_strip_php'] = $u_strip_php;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_birth == 1)
	{
		$row['u_pers_birth'] = $u_pers_birth;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_prof == 1)
	{
		$row['u_pers_prof'] = $u_pers_prof;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_otdel == 1)
	{
		$row['u_pers_otdel'] = $u_pers_otdel;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_dolj == 1)
	{
		$row['u_pers_dolj'] = $u_pers_dolj;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_messanger_type == 1)
	{
		$row['u_pers_messanger_type'] = $u_pers_messanger_type;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_messanger_id == 1)
	{
		$row['u_pers_messanger_id'] = $u_pers_messanger_id;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_phone == 1)
	{
		$row['u_pers_phone'] = $u_pers_phone;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_mob_phone == 1)
	{
		$row['u_pers_mob_phone'] = $u_pers_mob_phone;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_address == 1)
	{
		$row['u_pers_address'] = $u_pers_address;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_dop == 1)
	{
		$row['u_pers_dop'] = $u_pers_dop;
	}
	if(!$edit_group || $edit_group && $ch_u_pers_foto == 1)
	{
		$row['u_pers_foto'] = $u_pers_foto;
	}
	if(!$edit_group || $edit_group && $ch_u_work_title == 1)
	{
		$row['u_work_title'] = $u_work_title;
	}
	if(!$edit_group || $edit_group && $ch_u_work_phone == 1)
	{
		$row['u_work_phone'] = $u_work_phone;
	}
	if(!$edit_group || $edit_group && $ch_u_work_inner_phone == 1)
	{
		$row['u_work_inner_phone'] = $u_work_inner_phone;
	}
	if(!$edit_group || $edit_group && $ch_u_work_fax == 1)
	{
		$row['u_work_fax'] = $u_work_fax;
	}
	if(!$edit_group || $edit_group && $ch_u_work_email == 1)
	{
		$row['u_work_email'] = $u_work_email;
	}
	if(!$edit_group || $edit_group && $ch_u_work_office == 1)
	{
		$row['u_work_office'] = $u_work_office;
	}
	if(!$edit_group || $edit_group && $ch_u_work_dop == 1)
	{
		$row['u_work_dop'] = $u_work_dop;
	}

	$row = array_merge($row, $user_row);
	if ($edit_group || $_GET['id'] != '')
	{
		if (!$edit_group)
    	{
			$res = sql_query('SELECT u_login, u_reg_date, u_last_date, u_last_ip, u_admin, u_pass, u_soap_token FROM sb_users WHERE u_id=?d', $_GET['id']);
    	}
    	else
    	{
			$res = true;
    	}

		if($res)
		{
	        // редактирование
			if (!$edit_group)
    		{
				list($old_login, $u_reg_date, $u_last_date, $u_last_ip, $u_admin, $u_pass, $old_soap_token) = $res[0];
		        if ($u_pass_1 != '')
				{
					$row['u_pass'] = md5($u_pass_1);
	    	        if($u_pass != md5($u_pass_1))
					{
						$row['u_pass_date'] = time();
	    	        }
	    	    }

	    	    // Генерирую soap_token, если он не совпадает с тем, который занесли в базу -
			 	// значит меняли логин или пароль
				if(isset($u_soap_word) && !empty($u_soap_word))
				{
			    	require_once(SB_CMS_LIB_PATH.'/sbSoap.inc.php');
					$soap = new sbSoap();
		    	    if($u_pass_1 != '')
		    	    	$new_soap = $soap->getSoapTokenHash($u_login, md5($u_pass_1), $_GET['id'], $u_soap_word, $u_soap_num);
		    	    else
		    	    	$new_soap = $soap->getSoapTokenHash($u_login, $u_pass, $_GET['id'], $u_soap_word, $u_soap_num);
		    	    $old_soap_token = explode('|',$old_soap_token);

		    	    if (!isset($old_soap_token[2]) || $new_soap != $old_soap_token[2])
		    	    {
		    	    	$row['u_soap_token'] = $u_soap_word.'|'.$u_soap_num.'|'.$new_soap;
			    	}
				}
			}

			if (!$edit_group)
    	    {
    	    	sql_query('UPDATE sb_users SET ?a WHERE u_id=?d', $row, $_GET['id'], sprintf(PL_USERS_EDIT_OK, $old_login, $u_login));
    	    }
    	    else
    	    {
				if (count($row) > 0)
				{
					sql_query('UPDATE sb_users SET ?a WHERE u_id IN (?a)', $row, $_GET['ids'], PL_USERS_EDIT_GROUP_OK);
				}
			}

			if($u_block == 1)
            {

	    	    if (!$edit_group)
	    	    {
	                sql_query('DELETE FROM sb_users_sessions WHERE us_user_id=?d', $_GET['id']);
	    	    }
	    	    else
	    	    {
					sql_query('DELETE FROM sb_users_sessions WHERE us_user_id IN (?a)', $_GET['ids']);
	    	    }
            }

			if(!$edit_group)
			{
				if($old_login == $_SESSION['sbAuth']->getUserLogin())
				{
					$_SESSION['sbAuth']->setUserLogin($_GET['id'], $u_login);
					$_SESSION['sbAuth']->setUserEmail($_GET['id'], $u_email);
					$_SESSION['sbAuth']->mName = $u_name;
        		}

	        	$row['u_id'] = intval($_GET['id']);
	        	$row['u_reg_date'] = $u_reg_date;
	        	$row['u_last_date'] = $u_last_date;
	        	$row['u_last_ip'] = $u_last_ip;
	        	$row['u_admin'] = $u_admin;

	            $footer_ar = fCategs_Edit_Elem();
	    	    if (!$footer_ar)
	    	    {
	    	        sb_show_message(PL_USERS_EDIT_ERROR, false, 'warning');
	                sb_add_system_message(sprintf(PL_USERS_EDIT_SYSTEMLOG_ERROR, $u_login), SB_MSG_WARNING);

	                fUsers_Edit();
	    		    return;
	    	    }
	    	    $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
	    	    $footer_link_str = $GLOBALS['sbSql']->escape($footer_ar[1], false, false);

	            $html_str = fUsers_Get($row);
	    	    $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
	            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

	    	    echo '<script>
	    		        var res = new Object();
	    		        res.html = "'.$html_str.'";
	    		        res.footer = "'.$footer_str.'";
	    		        res.footer_link = "'.$footer_link_str.'";
	    				sbReturnValue(res);
					</script>';
			}
			else
			{
	    	    echo '<script>
    					sbReturnValue("refresh");
					</script>';
			}
		}
		else
	    {
			sb_show_message(PL_USERS_EDIT_ERROR, false, 'warning');
			sb_add_system_message(sprintf(PL_USERS_EDIT_SYSTEMLOG_ERROR, $u_login), SB_MSG_WARNING);

			fUsers_Edit();
			return;
	    }
	}
	else
	{
	    $row['u_pass'] = md5($u_pass_1);
	    $row['u_pass_date'] = time();
	    $row['u_admin'] = $admin;
	    $row['u_reg_date'] = time();

	    $error = true;
	    if (sql_query('INSERT INTO sb_users (?#) VALUES (?a)', array_keys($row), array_values($row)))
	    {
    		$id = sql_insert_id();
    		if (fCategs_Add_Elem($id))
    		{
        		sb_add_system_message(sprintf(PL_USERS_ADD_OK, $u_login));

        		echo '<script>
        				sbReturnValue('.$id.');
        			  </script>';

        		$error = false;
    		}
    		else
    		{
    		    sql_query('DELETE FROM sb_users WHERE u_id=?d', $id);
    		}
	    }

	    $row['u_last_date'] = '';
	    $row['u_last_ip'] = '';

	    if ($error)
	    {
	        sb_show_message(sprintf(PL_USERS_ADD_ERROR, $u_login), false, 'warning');
            sb_add_system_message(sprintf(PL_USERS_ADD_SYSTEMLOG_ERROR, $u_login), SB_MSG_WARNING);

            fUsers_Edit();
		    return;
	    }
	}
}

function fUsers_Delete()
{
    if (!fCategs_Check_Rights($_GET['cat_id']))
    {
        return;
    }

    $id = intval($_GET['id']);

    if ($id == $_SESSION['sbAuth']->getUserId())
    {
        sb_add_system_message(sprintf(PL_USERS_DELETE_SYSLOG_ERROR_SAME_USER, $_SESSION['sbAuth']->getUserLogin()), SB_MSG_WARNING);
        echo PL_USERS_DELETE_ERROR_SAME_USER;
        return;
    }

    $res = sql_query('SELECT COUNT(*) FROM sb_users WHERE u_admin=1');
    list($num) = $res[0];
    $res = sql_query('SELECT u_admin, u_pers_foto FROM sb_users WHERE u_id=?d', $id);
	list($admin, $foto) = $res[0];

	if ($num == 1 && $admin == 1)
	{
	    sb_add_system_message(sprintf(PL_USERS_DELETE_SYSLOG_ERROR_ONE_USER, $_SESSION['sbAuth']->getUserLogin()), SB_MSG_WARNING);
		echo PL_USERS_DELETE_ERROR_ONE_USER;
		return;
	}
	else
	{
	    // чистим сессии пользователя и настройки интерфейса
		sql_query('DELETE FROM sb_users_sessions WHERE us_user_id=?d', $id);
		sql_query('DELETE FROM sb_users_settings WHERE us_user_id=?d', $id);

		$GLOBALS['sbVfs']->mLocal = true;

		if ($foto != '' && $GLOBALS['sbVfs']->exists(SB_CMS_USER_UPLOAD_PATH.'/users/'.$foto) && $GLOBALS['sbVfs']->is_file(SB_CMS_USER_UPLOAD_PATH.'/users/'.$foto))
		    $GLOBALS['sbVfs']->delete(SB_CMS_USER_UPLOAD_PATH.'/users/'.$foto);

		// чистим личные сообщения пользователя
		$res = sql_query('SELECT um_files FROM sb_users_messages WHERE um_to_id=?d OR (um_from_id=?d AND um_to_ids != ?)', $id, $id, '');
		if ($res)
		{
		    for ($i = 0; $i < count($res); $i++)
		    {
		        $um_files = @unserialize($res[0][0]);
		        for($j = 0; $j < count($um_files); $j++)
                {
                    $file = SB_CMS_USER_UPLOAD_PATH.'/messages/'.$um_files[$j];
                    if ($um_files[$j] != '' && $GLOBALS['sbVfs']->exists($file) && $GLOBALS['sbVfs']->is_file($file))
                        $GLOBALS['sbVfs']->delete($file);
                }
		    }
		}

		$GLOBALS['sbVfs']->mLocal = false;

		sql_query('DELETE FROM sb_users_messages WHERE um_to_id=?d OR (um_from_id=?d AND um_to_ids != ?)', $id, $id, '');
	}
}

function fUsers_Edit_Cat()
{
    $rights = array();
    $w_rights = array();
    $cat_rights = '';

    if (isset($_GET['cat_id']))
    {
        if (!fCategs_Check_Rights($_GET['cat_id']))
        {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        $res = sql_query('SELECT cat_title, cat_rubrik, cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['cat_id']);

        if ($res)
        {
            list($cat_title, $cat_rubrik, $cat_rights) = $res[0];
            $_GET['cat_id_p'] = '';
        }
        else
        {
            sb_show_message(PL_USERS_EDIT_CAT_ERROR_NO_CATEG, true, 'warning');
            return;
        }

        $res = sql_query('SELECT ur_plugin, ur_plugin_rights, ur_workflow_rights FROM sb_users_rights WHERE ur_cat_id=?d', $_GET['cat_id']);
        if ($res)
        {
            foreach ($res as $value)
            {
                list($plugin, $plugin_rights, $workflow_rights) = $value;

                if (trim($plugin_rights) != '')
                	$rights[$plugin] = explode('|', $plugin_rights);
                if (trim($workflow_rights) != '')
                	$w_rights[$plugin] = explode('|', $workflow_rights);
            }
        }
    }
    else
    {
        if (!fCategs_Check_Rights($_GET['cat_id_p']))
        {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        $res = sql_query('SELECT cat_rubrik, cat_rights FROM sb_categs WHERE cat_id=?d', $_GET['cat_id_p']);
        if ($res)
        {
            $cat_title = '';
            list($cat_rubrik, $cat_rights) = $res[0];
            $_GET['cat_id'] = '';
        }
        else
        {
            sb_show_message(PL_USERS_EDIT_CAT_ERROR_NO_CATEG, true, 'warning');
            return;
        }
    }

    echo '<script>
    	function checkValues()
    	{
    	    var cat_title = sbGetE("cat_title");
            if (cat_title.value == "")
    		{
    			alert("'.PL_USERS_EDIT_CAT_NO_TITLE_MSG.'");
        		return false;
    		}

    		return true;
    	}

    	var plugins = [];
    	var workflow_rights = [];

    	function changeRights(el)
    	{
    	    if (plugins[el.id])
    	    {
    	        for (var i = 0; i < plugins[el.id].length; i++)
    	        {
    	            sbGetE(plugins[el.id][i]).disabled = !el.checked;
    	            for (var j = 0; j < workflow_rights.length; j++)
		    		{
		    			var sub_el = sbGetE(el.id + "_workflow_" + workflow_rights[j]);
		    			if (sub_el)
		    			{
		    				sub_el.disabled = !el.checked;
		    			}
		    		}

		    		var sub_el = sbGetE(el.id + "_workflow");
    				if (sub_el)
	    			{
	    				sub_el.disabled = !el.checked;
	    			}

                    sbGetE(plugins[el.id][i]).checked = el.checked;
    	        }
    	    }
    	}

    	function changeWorkflowRights(pl_ident)
    	{
    		var el = sbGetE(pl_ident + "_workflow");
    		if (!el)
    			return;

    		for (var i = 0; i < workflow_rights.length; i++)
    		{
    			var sub_el = sbGetE(pl_ident + "_workflow_" + workflow_rights[i]);
    			if (sub_el)
    			{
    				sub_el.checked = el.checked;
    			}
    		}
    	}
	</script>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_users_edit_cat_submit&cat_id='.$_GET['cat_id'].'&cat_id_p='.$_GET['cat_id_p'], 'thisDialog', 'post', 'checkValues()');
    $layout->mTitleWidth = 270;

    $layout->addTab(PL_USERS_EDIT_CAT_TAB1);
    $layout->addHeader(PL_USERS_EDIT_CAT_TAB1);
    $layout->addField(PL_USERS_EDIT_CAT_TITLE, new sbLayoutInput('text', $cat_title, 'cat_title', '', 'style="width:400px;"', true));
    $layout->addField('', new sbLayoutDelim());
    $layout->addField(PL_USERS_EDIT_CAT_ACTIVE, new sbLayoutInput('checkbox', '1', 'cat_rubrik', '', ($cat_rubrik == 1 ? 'checked' : '')));

    $layout->addTab(PL_USERS_EDIT_CAT_TAB2);
    $layout->addHeader(PL_USERS_EDIT_CAT_TAB2);

    $plugins_info = $_SESSION['sbPlugins']->getPluginsInfo();
    $GLOBALS['sb_cmp_sort_field'] = 'title';
    uasort($plugins_info, 'sb_cmp_array');
    $num_plugins_info = count($plugins_info);

    //выбираем разделы, доступ к которым установлен для группы пользователей
    $group_rights = array();
    $res = sql_param_query('SELECT cat_ident, cat_id FROM sb_categs WHERE cat_rights REGEXP "[[:<:]]g'.$_GET['cat_id'].'[[:>:]]"');
    if($res)
    {
        foreach($res as $row)
        {
            if(!isset($group_rights[$row[0]]))
            {
                $group_rights[$row[0]] = array();
            }
            $group_rights[$row[0]][] = $row[1];
        }

        foreach ($group_rights as $key=>$val)
        {
            $group_rights[$key] = implode('^', $val);
        }
    }

    $i = 0;
    $html = '';
    foreach($plugins_info as $key => $value)
    {
        if (!isset($value['check_user']) || !$value['check_user'])
        {
            $i++;
            continue;
        }

        if ($html != '' && $i != $num_plugins_info)
            $layout->addField('', new sbLayoutDelim());

        $html = '<div style="margin-top: 5px;"><input type="checkbox" name="'.$key.'" id="'.$key.'" value="1"'.(isset($rights[$key]) ? ' checked="checked"' : '').' style="margin:0px;" align="middle" onclick="changeRights(this);">&nbsp;&nbsp;<label for="'.$key.'" style="color: #990033;">'.PL_USERS_EDIT_CAT_READ_RIGHT.'</label></div>';

        $js = '';
        if (count($value['rights']) > 0)
        {
            $html .= '<hr>';
            $js = '<script>
                       var rights = [];
                  ';

            foreach ($value['rights'] as $right_ident => $right_name)
            {
            	if ($right_ident == 'elems_public' && isset($value['use_workflow']) && $value['use_workflow'] && $_SESSION['sbPlugins']->isPluginAvailable('pl_workflow'))
            	{
            	    $html .= '<input type="hidden" name="'.$key.'_ar[]" value="'.$right_ident.'">';
            		continue;
            	}

                $js .= 'rights[rights.length] = "'.$key.$right_ident.'";';
                $html .= '<div style="margin-top:5px; margin-left:15px;">
                    <input type="checkbox" style="margin:0px;" name="'.$key.'_ar[]" id="'.$key.$right_ident.'" value="'.$right_ident.'"'.(!isset($rights[$key]) ? ' disabled="disabled"' : (in_array($right_ident, $rights[$key]) ? ' checked="checked"' : '')).'>&nbsp;&nbsp;<label for="'.$key.$right_ident.'">'.$right_name.'</label>
                </div>';
            }

            $js .= 'plugins["'.$key.'"] = rights;
                   </script>';
        }

        //выбор категорий
        if(isset($value['cat_id']) && $value['cat_id'] && $key != 'pl_comments' && $key != 'pl_calendar')
        {
            $fld = new sbLayoutCategs($key, $value['cat_id'], isset($group_rights[$key])? $group_rights[$key] : '', $key.'_allow_cat');
            $fld->mMultiSelect = true;
            $html .= '<div style="margin-top:15px; margin-left:15px;"><i>'.PL_USERS_EDIT_CAT_ALLOW_RIGHTS.'</i>'.$fld->getField().'</div>';
            $js .= $fld->getJavaScript();
        }

        $html .= $js;

        $title = $value['title'].($value['icon'] != '' ? '&nbsp;&nbsp;&nbsp;<img src="'.str_replace('_24', '_16', $value['icon']).'" align="absmiddle">' : '');

        $fld = new sbLayoutHTML($html);
        $fld->mShowColon = false;

        $layout->addField($title, $fld, ' valign="top"');

        $i++;
    }

    $res = sql_query('SELECT w_code, w_title FROM sb_workflow ORDER BY w_order');

    if ($res && $_SESSION['sbPlugins']->isPluginAvailable('pl_workflow'))
    {
    	$layout->addTab(PL_USERS_EDIT_CAT_TAB3);
    	$layout->addHeader(PL_USERS_EDIT_CAT_TAB3);

    	$workflow_rights = array();
    	$js = '<script>';

    	foreach ($res as $value)
    	{
    		$workflow_rights[$value[0]] = $value[1];
    		$js .= 'workflow_rights[workflow_rights.length] = "'.$value[0].'";';
    	}

    	$js .= '</script>';

    	$num_rights = count($workflow_rights);

	    $i = 0;
	    $html = '';
	    foreach($plugins_info as $key => $value)
	    {
	        if (!isset($value['use_workflow']) || !$value['use_workflow'])
	        {
	            $i++;
	            continue;
	        }

	        if (substr($key, 0, 10) == 'pl_plugin_')
	        {
	        	$pm_id = substr($key, 10);
		        $res_pm = sql_query('SELECT pm_elems_settings FROM sb_plugins_maker WHERE pm_id=?d', $pm_id);
			    if (!$res_pm)
			        continue;

	    		list($pm_elems_settings) = $res_pm[0];
	    		if ($pm_elems_settings != '')
	        		$pm_elems_settings = unserialize($pm_elems_settings);
	    		else
	        		$pm_elems_settings = array();

	        	if (!isset($pm_elems_settings['show_active_field']) || $pm_elems_settings['show_active_field'] != 1)
	        		continue;
	        }

	        if ($html != '' && $i != $num_plugins_info)
	            $layout->addField('', new sbLayoutDelim());

	        $html = '<div style="margin-top: 5px;"><input type="checkbox" name="'.$key.'_workflow" id="'.$key.'_workflow" value="1"'.(!isset($rights[$key]) ? ' disabled="disabled"' : (isset($w_rights[$key]) && count($w_rights[$key]) == $num_rights ? ' checked="checked"' : '')).' style="margin:0px;" align="middle" onclick="changeWorkflowRights(\''.$key.'\');">&nbsp;&nbsp;<label for="'.$key.'_workflow" style="color: #990033;">'.PL_USERS_EDIT_CAT_CHECK_ALL_WORKFLOWS_STATUS.'</label></div><hr>';

            foreach ($workflow_rights as $right_ident => $right_name)
	        {
	            $html .= '<div style="margin-top:5px; margin-left:15px;">
	                    <input type="checkbox" style="margin:0px;" name="'.$key.'_workflow_ar[]" id="'.$key.'_workflow_'.$right_ident.'" value="'.$right_ident.'"'.(!isset($rights[$key]) ? ' disabled="disabled"' : (isset($w_rights[$key]) && in_array($right_ident, $w_rights[$key]) ? ' checked="checked"' : '')).'>&nbsp;&nbsp;<label for="'.$key.'_workflow_'.$right_ident.'">'.$right_name.'</label>
	                </div>';
	        }

	        $title = $value['title'].($value['icon'] != '' ? '&nbsp;&nbsp;&nbsp;<img src="'.str_replace('_24', '_16', $value['icon']).'" align="absmiddle">' : '');

	        $fld = new sbLayoutHTML($html);
	        $fld->mShowColon = false;

			$layout->addField($title, $fld, ' valign="top"');
			$i++;
		}
	}

    $layout->addField('', new sbLayoutHTML($js));
    $layout->addField('', new sbLayoutInput('hidden', $cat_rights, 'cat_rights'));

    $layout->addButton('submit', KERNEL_SAVE);
    $layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');

    $layout->show();
}

function fUsers_Edit_Cat_Submit()
{
	$cat_rubrik = 0;
	extract($_POST);

    if($_GET['cat_id'] != '')
    {
        if (!fCategs_Check_Rights($_GET['cat_id']))
        {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        $cat_id = intval($_GET['cat_id']);

        //редактирование
        $res = sql_query('SELECT cat_left, cat_right FROM sb_categs WHERE cat_id=?d', $cat_id);
        if ($res)
        {
            $result = sql_query('UPDATE sb_categs SET cat_title=?, cat_rubrik=?d WHERE cat_id=?d', $cat_title, $cat_rubrik, $cat_id, sprintf(PL_USERS_EDIT_CAT_SYSLOG_EDIT_OK, $cat_title));
            if ($result)
            {
                sql_query('DELETE FROM sb_users_rights WHERE ur_cat_id=?d', $cat_id);

                $plugins_info = $_SESSION['sbPlugins']->getPluginsInfo();
                foreach($plugins_info as $key => $value)
                {
                    if (isset($_POST[$key]) && $_POST[$key] == 1)
                    {
                        $rights = array('read');
                        $workflow_rights = array();

                        if (isset($_POST[$key.'_ar']) && is_array($_POST[$key.'_ar']))
                        {
                            $rights = array_merge($rights, $_POST[$key.'_ar']);
                        }

                    	if (isset($_POST[$key.'_workflow_ar']) && is_array($_POST[$key.'_workflow_ar']))
                        {
                            $workflow_rights = $_POST[$key.'_workflow_ar'];
                        }

                        $rights = implode('|', $rights);
                        $workflow_rights = implode('|', $workflow_rights);

                        sql_query('INSERT INTO sb_users_rights (ur_cat_id, ur_plugin, ur_plugin_rights, ur_workflow_rights)
                                         VALUES(?d, ?, ?, ?)', $cat_id, $key, $rights, $workflow_rights);
                    }
                }

                list($cat_left, $cat_right) = $res[0];

                $count_res = sql_query('SELECT COUNT(*) FROM sb_categs categs, sb_catlinks links WHERE categs.cat_ident=? AND categs.cat_left >= ?d AND categs.cat_right <= ?d AND links.link_cat_id=categs.cat_id', 'pl_users', $cat_left, $cat_right);
                if ($count_res)
                {
                    $cat_count = $count_res[0][0];
                }
                else
                {
                    $cat_count = 0;
                }

                echo '<script>
        	        var res = new Object();
                    res.cat_title = "'.str_replace('"', '\\"', $cat_title).' ['.$cat_count.']";
                    res.cat_closed = 0;
                    res.cat_rubrik = '.intval($cat_rubrik).';
                    sbReturnValue(res);
        		  </script>';
            }



        }
        else
        {
            sb_show_message(PL_USERS_EDIT_CAT_EDIT_ERROR, true, 'warning');
            sb_add_system_message(sprintf(PL_USERS_EDIT_CAT_SYSLOG_EDIT_ERROR, $cat_title), SB_MSG_WARNING);
        }
    }
    else
    {
        if (!fCategs_Check_Rights($_GET['cat_id_p']))
        {
            sb_show_message(SB_ELEMS_DENY_MSG, true, 'warning');
            return;
        }

        //добавление
        require_once(SB_CMS_LIB_PATH.'/sbTree.inc.php');
        $tree = new sbTree('pl_users');

        $fields = array();
        $fields['cat_title'] = $cat_title;
        $fields['cat_closed'] = 0;
        $fields['cat_rubrik'] = $cat_rubrik;
        $fields['cat_rights'] = $cat_rights;

        $cat_id = $tree->insertNode($_GET['cat_id_p'], $fields);
        if ($cat_id)
        {
            $plugins_info = $_SESSION['sbPlugins']->getPluginsInfo();
            foreach($plugins_info as $key => $value)
            {
            	if (isset($_POST[$key]) && $_POST[$key] == 1)
                {
                    $rights = array('read');
                    $workflow_rights = array();

                    if (isset($_POST[$key.'_ar']) && is_array($_POST[$key.'_ar']))
                    {
                        $rights = array_merge($rights, $_POST[$key.'_ar']);
                    }

                    if (isset($_POST[$key.'_workflow_ar']) && is_array($_POST[$key.'_workflow_ar']))
                    {
                        $workflow_rights = $_POST[$key.'_workflow_ar'];
                    }

                    $rights = implode('|', $rights);
                    $workflow_rights = implode('|', $workflow_rights);

                    sql_query('INSERT INTO sb_users_rights (ur_cat_id, ur_plugin, ur_plugin_rights, ur_workflow_rights)
                                     VALUES(?d, ?, ?, ?)', $cat_id, $key, $rights, $workflow_rights);
                }
            }

            sb_add_system_message(sprintf(PL_USERS_EDIT_CAT_SYSLOG_ADD_OK, $cat_title));

            echo '<script>
    	        var res = new Object();
        	    res.cat_id = '.$cat_id.';
                res.cat_title = "'.str_replace('"', '\\"', $cat_title).' [0]";
                res.cat_closed = 0;
                res.cat_rubrik = '.intval($cat_rubrik).';
                sbReturnValue(res);
    		  </script>';
        }
        else
        {
            sb_show_message(PL_USERS_EDIT_CAT_ADD_ERROR, true, 'warning');
            sb_add_system_message(sprintf(PL_USERS_EDIT_CAT_SYSLOG_ADD_ERROR, $cat_title), SB_MSG_WARNING);
        }
    }

    //Устанавливаем права на разделы модулей
    if (isset($cat_id) && $cat_id)
    {
        foreach ($_POST as $cat_ident => $ids)
        {
            if (!preg_match('/_allow_cat$/', $cat_ident))
            {
                continue;
            }

            $cat_ident = sb_str_replace('_allow_cat', '', $cat_ident);
            $ids = explode('^', $ids);

            $res = sql_param_query('SELECT cat_id, cat_rights FROM sb_categs WHERE cat_ident=?s', $cat_ident);
            if ($res)
            {
                foreach ($res as $row)
                {
                    if (in_array($row[0], $ids)) //если для раздела установлены права
                    {
                        if (!preg_match('/\^?g' . $cat_id . '\^?/', $row[1])) //ранее права не были установлены
                        {
                            $row[1] = ($row[1] == '') ? 'g' . $cat_id : $row[1].'^g' . $cat_id;
                            sql_param_query('UPDATE sb_categs SET cat_rights=?s WHERE cat_id=?d', $row[1], $row[0]);
                        }
                    }
                    else //для раздела права не установлены или сняты
                    {
                        if (preg_match('/\^?g' . $cat_id . '\^?/', $row[1])) //ранее права были установлены
                        {
                            $row[1] = preg_replace('/g' . $_GET['cat_id'] . '\^?|\^?g' . $cat_id . '/', '', $row[1]);
                            sql_param_query('UPDATE sb_categs SET cat_rights=?s WHERE cat_id=?d', $row[1], $row[0]);
                        }
                    }
                }
            }
        }
    }
}

function fUsers_Delete_Cat()
{
    if (!fCategs_Check_Rights($_GET['cat_id']))
    {
        echo SB_ELEMS_DENY_MSG;
        return;
    }

    sql_query('DELETE FROM sb_users_rights WHERE ur_cat_id=?d', $_GET['cat_id']);
}

function fUsers_Copy_Cat()
{
    // копирование прав на раздел
    if (strtoupper($_GET['action']) == 'COPY')
    {
        $res = sql_query('SELECT ur_plugin, ur_plugin_rights, ur_workflow_rights FROM sb_users_rights WHERE ur_cat_id=?d', $_GET['paste_cat_id']);

        $cat_id = intval($_GET['new_cat_id']);

        for ($i = 0; $i < count($res); $i++)
        {
            list($ur_plugin, $ur_plugin_rights, $ur_workflow_rights) = $res[$i];
            sql_query('INSERT INTO sb_users_rights (ur_cat_id, ur_plugin, ur_plugin_rights, ur_workflow_rights) VALUES (?d, ?, ?, ?)', $cat_id, $ur_plugin, $ur_plugin_rights, $ur_workflow_rights);
        }
    }
}

function fUsers_Before_Paste()
{
    if (isset($_GET['action']) && $_GET['action'] == 'cut' && isset($_GET['e']) && is_array($_GET['e']) && count($_GET['e']) > 0)
    {
        $in_str = implode(',', $_GET['e']);

	    $res = sql_query('SELECT COUNT(*) FROM sb_users WHERE u_admin=1 AND u_id NOT IN ('.$in_str.')');
	    if ($res[0][0] == 0)
	    {
	        echo PL_USERS_DELETE_ERROR_ONE_USER;
	    }
    }
}

function fUsers_Paste()
{
	if ($_GET['action'] == 'cut')
	{
	    $in_str = implode(',', $_GET['e']);

	    $u_admin = 0;
	    $res = sql_query('SELECT cat_closed FROM sb_categs WHERE cat_id=?d', $_GET['new_cat_id']);
	    if ($res)
	    {
	        list($u_admin) = $res[0];
	        if ($u_admin != '1')
	        {
	            $u_admin = 0;
	        }
	    }

	    if ($u_admin == 1)
    	{
    	    sql_query('UPDATE sb_users SET u_admin=1 WHERE u_id IN ('.$in_str.')');
    	}
    	else
    	{
    	    sql_query('UPDATE sb_users SET u_admin=0 WHERE u_id IN ('.$in_str.')');
    	}
	}
}

function fUsers_Generate_Soap_Token()
{
	if(!isset($_GET['word']) || $_GET['word'] == '')
	{
		echo PL_USERS_NO_SOAP_SECRET_WORD;
		return false;
	}
	$secret_num = intval($_GET['num']);
	$id = intval($_GET['id']);
	$res = sql_query('SELECT u_login, u_pass FROM sb_users WHERE u_id = ?d', $id);
	if(!$res || $res == '')
	{
		echo PL_USERS_NO_SOAP_GENERATE_ACCES_ERROR;
		return false;
	}
	require_once(SB_CMS_LIB_PATH.'/sbSoap.inc.php');
	$soap = new sbSoap();

	echo $soap->getSoapTokenHash($res[0][0], $res[0][1], $id, $_GET['word'], $secret_num);
	return true;
}

?>