<?php

/**
 * Функции управления макетами дизайна модуля голосования
 *
 */
function fVoting_Get ($args)
{
    $result = '<b><a href="javascript:void(0);" onclick="sbElemsEdit(event);">'.$args['vt_title'].'</a></b>';
    return $result;
}

function fVoting_Design_Init()
{
	require_once(SB_CMS_LIB_PATH.'/sbElements.inc.php');
	$elems = new sbElements('sb_vote_temps', 'vt_id', 'vt_title', 'fVoting_Get', 'pl_voting_design_init', 'pl_voting_design');

	$elems->mCategsRootName = KERNEL_DESIGN_ROOT_NAME;

    $elems->addSorting(PL_VOTING_DESIGN_SORT_BY_TITILE, 'vt_title');

    $elems->mCategsPasteElemsMenuTitle = KERNEL_DESIGN_PASTE_ELEMS_MENU_TITLE;
    $elems->mElemsAddMenuTitle  = KERNEL_DESIGN_ELEMS_ADD_MENU_TITLE;
    $elems->mElemsEditMenuTitle = KERNEL_DESIGN_ELEMS_EDIT_MENU_TITLE;
    $elems->mElemsCopyMenuTitle = KERNEL_DESIGN_ELEMS_COPY_MENU_TITLE;
    $elems->mElemsCutMenuTitle  = KERNEL_DESIGN_ELEMS_CUT_MENU_TITLE;

    $elems->mElemsEditEvent = 'pl_voting_design_edit';
	$elems->mElemsEditDlgWidth = '900';
	$elems->mElemsEditDlgHeight = '700';

	$elems->mElemsAddEvent = 'pl_voting_design_edit';
	$elems->mElemsAddDlgWidth = '900';
	$elems->mElemsAddDlgHeight = '700';

	$elems->mCategsClosed = false;
	$elems->mElemsUseLinks = false;
	$elems->mCategsRubrikator = false;

    $elems->init();
}

function fVoting_Design_Edit ($htmlStr = '', $footerStr = '')
{
    if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
    {
        $result = sql_query('SELECT vt_title, vt_temp, vt_not_vote, vt_vote_ok
                                   FROM sb_vote_temps WHERE vt_id=?d', $_GET['id']);
        if ($result)
        {
            list($vt_title, $vt_temp, $vt_not_vote, $vt_vote_ok) = $result[0];
        }
        else
        {
            sb_show_message(PL_VOTING_DESIGN_EDIT_ERROR, true, 'warning');
            return;
        }
    }
    elseif (count($_POST) > 0)
    {
        extract($_POST);
        if (!isset($_GET['id']))
            $_GET['id'] = '';
    }
    else
    {
        $vt_temp = "<div align='center'>{MESSAGE}</div>
<form action='{ACTION}' method='post'>
	<input type='hidden' name='v_id' value='{ID}' />
	<input type='hidden' name='v_hash' value='{HASH}' />

	<input type='radio' name='v_sum' value='1' />
	<input type='radio' name='v_sum' value='2' />
	<input type='radio' name='v_sum' value='3' />
	<input type='radio' name='v_sum' value='4' />
	<input type='radio' name='v_sum' value='5' />

	<input type='submit' value='".PL_VOTING_VOTING."' />
</form>";

        $vt_title = '';
        $vt_not_vote = PL_VOTING_NOT_VOICE;
        $vt_vote_ok = PL_VOTING_SUCCESS_VOICE ;

        $_GET['id'] = '';
    }

    echo '<script>
            function checkValues()
            {
                var el_title = sbGetE("vt_title");
                if (el_title.value == "")
                {
                     alert("'.PL_VOTING_DESIGN_EDIT_NO_TITLE_MSG.'");
                     return false;
                }
            }';

    if ($htmlStr != '')
    {
        echo '
            function cancel()
            {
                var res = new Object();
                res.html = "'.$htmlStr.'";
                res.footer = "'.$footerStr.'";
                res.footer_link = "";
                sbReturnValue(res);
            }
            sbAddEvent(window, "close", cancel);';
    }
    echo '</script>
    <br><br>';

    require_once(SB_CMS_LIB_PATH.'/sbLayout.inc.php');

    $layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_voting_design_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()');
    $layout->mTableWidth = '95%';
    $layout->mTitleWidth = '200';

    $layout->addHeader(PL_VOTING_DESIGN_EDIT_TAB1);

    $layout->addField(PL_VOTING_DESIGN_TITILE, new sbLayoutInput('text', $vt_title, 'vt_title', 'vt_title', 'style="width:610px;"', false));
    $layout->addField('', new sbLayoutDelim());

    $fld = new sbLayoutTextarea($vt_temp, 'vt_temp', '', 'style="width:610px;height:250px;"');
    $fld->mTags = array('-',
                        '{MESSAGE}',
                        "<form action='{ACTION}' method='post'>
	<input type='hidden' name='v_hash' value='{HASH}' />

	<input type='submit' value='".PL_VOTING_VOTING."' />
</form>",
                        "<input type='radio' name='v_sum' value='' />"
                        );
    $fld->mValues = array(PL_VOTING_DESIGN_EDIT_GROUP_TAG, PL_VOTING_DESIGN_SYSTEM_MESSAGE, PL_VOTING_DESIGN_EDIT_FORM_TAG, PL_VOTING_DESIGN_VOICE);
    $layout->addField(PL_VOTING_DESIGN_EDIT_FORM_TAG, $fld);

    $layout->addField('', new sbLayoutDelim());

    $layout->addField(PL_VOTING_MSG_NOT_PERM_VOTE, new sbLayoutTextarea($vt_not_vote, 'vt_not_vote', '', 'style="width:610px;height:50px"'));
    $layout->addField(PL_VOTING_MSG_VOTING_OK, new sbLayoutTextarea($vt_vote_ok, 'vt_vote_ok', '', 'style="width:610px;height:50px;"'));

    $layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_voting', 'design_edit') ? '' : 'disabled="disabled"'));
    if ($_GET['id'] != '')
        $layout->addButton('submit', KERNEL_APPLY, 'btn_apply', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_voting', 'design_edit') ? '' : 'disabled="disabled"'));
    $layout->addButton('button', KERNEL_CANCEL, '', '', $htmlStr != '' ? 'onclick="cancel()"' : 'onclick="sbCloseDialog()"');
    $layout->show();
}

function fVoting_Design_Edit_Submit()
{
    if (!isset($_GET['id']))
        $_GET['id'] = '';

    extract($_POST);

    if ($vt_title == '')
    {
        sb_show_message(PL_VOTING_DESIGN_EDIT_NO_TITLE_MSG, false, 'warning');
        fVoting_Design_Edit();
        return;
    }

    $row = array();

    $row['vt_title'] = $vt_title;
    $row['vt_temp'] = $vt_temp;
    $row['vt_not_vote'] = $vt_not_vote;
    $row['vt_vote_ok'] = $vt_vote_ok;

    if ($_GET['id'] != '')
    {
        $res = sql_query('SELECT vt_title FROM sb_vote_temps WHERE vt_id=?d', $_GET['id']);
        if ($res)
        {
        	// редактирование
            list($old_title) = $res[0];

            sql_query('UPDATE sb_vote_temps SET ?a WHERE vt_id=?d', $row, $_GET['id'], sprintf(PL_VOTING_DESIGN_EDIT_OK, $old_title));
            sbQueryCache::updateTemplate('sb_vote_temps', $_GET['id']);

            $footer_ar = fCategs_Edit_Elem('elems_edit');
            if (!$footer_ar)
            {
                sb_show_message(PL_VOTING_DESIGN_EDIT_ERROR, false, 'warning');
                sb_add_system_message(sprintf(PL_VOTING_DESIGN_EDIT_SYSTEMLOG_ERROR, $old_title), SB_MSG_WARNING);
                fVoting_Design_Edit();
                return;
            }

            $footer_str = $GLOBALS['sbSql']->escape($footer_ar[0], false, false);
            $row['vt_id'] = intval($_GET['id']);

            $html_str = fVoting_Get ($row);
            $html_str = sb_str_replace(array("\r\n", "\r", "\n"), '', $html_str);
            $html_str = $GLOBALS['sbSql']->escape($html_str, false, false);

            if (!isset($_POST['btn_apply']))
            {
                echo '<script>
                        var res = new Object();
                        res.html = "'.$html_str.'";
                        res.footer = "'.$footer_str.'";
                        res.footer_link = "";
                        sbReturnValue(res);
                      </script>';
            }
            else
            {
                fVoting_Design_Edit ($html_str, $footer_str);
            }
        }
        else
        {
            sb_show_message(PL_VOTING_DESIGN_EDIT_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_VOTING_DESIGN_EDIT_SYSTEMLOG_ERROR, $vt_title), SB_MSG_WARNING);

            fVoting_Design_Edit ();
            return;
        }
    }
    else
    {
        $error = true;
        if (sql_query('INSERT INTO sb_vote_temps (?#) VALUES (?a)', array_keys($row), array_values($row)))
        {
            $id = sql_insert_id();

            if (fCategs_Add_Elem($id, 'elems_edit'))
            {
                sbQueryCache::updateTemplate('sb_vote_temps', $id);
                sb_add_system_message(sprintf(PL_VOTING_DESIGN_ADD_OK, $vt_title));
                echo '<script>
                        sbReturnValue('.$id.');
                      </script>';

                $error = false;
            }
            else
            {
                sql_query('DELETE FROM sb_vote_temps WHERE vt_id=?d', $id);
            }
        }

        if ($error)
        {
            sb_show_message(sprintf(PL_VOTING_DESIGN_ADD_ERROR, $vt_title), false, 'warning');
            sb_add_system_message(sprintf(PL_VOTING_DESIGN_ADD_SYSTEMLOG_ERROR, $vt_title), SB_MSG_WARNING);

            fVoting_Design_Edit ();
            return;
        }
    }
}

?>