<?php

function fWorkflow_Init()
{
	echo '<script src="'.SB_CMS_JSCRIPT_URL.'/sbWorkflow.js.php"></script>';

	$res = sql_query('SELECT w_id, w_title, w_order, w_code, w_on, w_show_demo FROM sb_workflow ORDER BY w_order');
	if($res)
	{
		echo '<br /><br />';

		require_once (SB_CMS_LIB_PATH.'/sbLayout.inc.php');
		$layout = new sbLayout();

		$html = '<table cellspacing="0" cellpadding="5" width="100%" style="empty-cells: show; -moz-user-select: none;-khtml-user-select: none;" id="status_table" class="form">
		        <tr>
					<th class="header">'.PL_WORKFLOW_INIT_TABLE_NAME_TITLE.'</th>
					<th class="header" width="150">'.PL_WORKFLOW_EDIT_PUBLIC.'</th>
					<th class="header" width="150">'.PL_WORKFLOW_EDIT_SHOW_DEMO.'</th>
					<th class="header" width="20">&nbsp;</th>
					<th class="header" width="20">&nbsp;</th>
				</tr>';

		$class = ' class="even"';
		foreach($res as $value)
		{
			list($w_id, $w_title, $w_order, $w_code, $w_on, $w_show_demo) = $value;

			$is_standart = ($w_code == 0 || $w_code == 1);

			if ($is_standart)
			{
				$w_title = '<b id="title_'.$w_id.'">'.$w_title.'</b><div class="hint_div" style="margin-top: 5px;">'.($w_code == 1 ? PL_WORKFLOW_INIT_PUBLIC_DESC : PL_WORKFLOW_INIT_NOT_PUBLIC_DESC).'</div>';
			}
			else
			{
				$w_title = '<b id="title_'.$w_id.'">'.$w_title.'</b>';
			}

			if ($class == '')
				$class = ' class="even"';
			else
				$class = '';

			$html .= '
				<tr '.$class.' id="'.$w_id.'" onmousedown="sbPDStartDrag(event, this)" style="cursor:default;">
			        <td style="vertical-align: middle; border-top: 1px solid #FFF5E0;">
						<div>'.$w_title.'</div>
					</td>
					<td style="vertical-align: middle; border-top: 1px solid #FFF5E0; text-align:center;">
						<input type="hidden" id="w_'.$w_id.'_order" value="'.$w_order.'">
						<input type="checkbox" onclick="changeActive('.$w_id.');" id="active_id'.$w_id.'" '.($w_on == 1 ? 'checked="checked"' : '').($is_standart ? 'disabled="disabled"' : '').'>
					</td>
					<td style="vertical-align: middle; border-top: 1px solid #FFF5E0; text-align:center;">
						<input type="checkbox" onclick="changeDemo('.$w_id.');" id="demo_id'.$w_id.'"'.($w_show_demo == 1 ? ' checked="checked"' : '').($is_standart ? 'disabled="disabled"' : '').'>
					</td>
			        <td style="vertical-align: middle; text-align:center; border-top: 1px solid #FFF5E0;">
			        	<img src="/cms/images/btn_props.png" title="'.KERNEL_EDIT.'" onmousedown="_sbPDPreventNsDrag(event, true);" ondragstart="_sbPDPreventNsDrag(event);" onclick="sbStatusEdit(\''.$w_id.'\')" style="cursor: pointer;" width="20" border="0" height="20">
					</td>
					<td style="vertical-align: middle; text-align:center; border-top: 1px solid #FFF5E0;">
						'.($is_standart ? '' : '<img src="/cms/images/btn_delete.png" title="'.KERNEL_DELETE.'" onmousedown="_sbPDPreventNsDrag(event, true);" ondragstart="_sbPDPreventNsDrag(event);" onclick="sbDeleteElem(\''.$w_id.'\');" style="cursor: pointer;" width="20" border="0" height="20">').'
						<input type="hidden" name="w_orders[]" value="'.$w_id.'">
					</td>
				</tr>';
		}

		if ($class != '')
			$class = '';
		else
			$class = 'class="even"';

		$html .= '
	            <tr id="null_tr" '.$class.'>
	                <td style="">&nbsp;</td>
	                <td style="">&nbsp;</td>
	                <td style="">&nbsp;</td>
	                <td style="">&nbsp;</td>
	                <td style="">&nbsp;</td>
	            </tr>
			</table>
			<script>
				lastSortPosition = '.(isset($res) ? count($res) : 0).';
			</script>';

		$layout->addField('', new sbLayoutHTML($html, true));
		$layout->addButton('button', KERNEL_ADD, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_workflow', 'elems_edit') ? '' : 'disabled="disabled"').' onclick="sbStatusEdit();"');

		$layout->show();
	}
}

function fWorkflow_Edit()
{
	if (count($_POST) == 0 && isset($_GET['id']) && $_GET['id'] != '')
	{
		$result = sql_query('SELECT w_id, w_title, w_on, w_code, w_accessible, w_show_demo FROM sb_workflow WHERE w_id=?d', $_GET['id']);
		if ($result)
		{
			list($w_id, $w_title, $w_on, $w_code, $w_accessible, $w_show_demo) = $result[0];

			$w_accessible = ($w_accessible != '' ? explode('|', $w_accessible) : array());
		}
		else
		{
			sb_show_message(PL_WORKFLOW_EDIT_ERROR, true, 'warning');
			return;
		}
	}
	else
	{
		$w_id = 0;
		$w_title = '';
		$w_on = 1;
		$w_code = -1;
		$w_show_demo = 0;

		$_GET['id'] = '';
	}

	echo '<script>
		function checkValues()
		{
			var el_title = sbGetE("w_title");
			if(el_title.value == "")
			{
				alert("'.PL_WORKFLOW_EDIT_NO_TITLE.'");
				return false;
			}
		}
	</script>
	<br /><br />';

	require_once (SB_CMS_LIB_PATH.'/sbLayout.inc.php');
	$layout = new sbLayout(SB_CMS_MODAL_DIALOG_FILE.'?event=pl_workflow_edit_submit'.($_SERVER['QUERY_STRING'] != '' ? '&'.$_SERVER['QUERY_STRING'] : ''), 'thisDialog', 'post', 'checkValues()', 'main');

	$layout->mTableWidth = '95%';
	$layout->mTitleWidth = '200';

	$layout->addHeader(PL_WORKFLOW_EDIT_TAB1);

	$layout->addField(PL_WORKFLOW_EDIT_TITLE, new sbLayoutInput('text', $w_title, 'w_title', '', 'style="width:440px;"'));
	$layout->addField(PL_WORKFLOW_EDIT_PUBLIC, new sbLayoutInput('checkbox', '1', 'w_on', '', ($w_on == 1 ? ' checked="checked"' : '').(isset($w_code) && ($w_code == 0 || $w_code == 1) ? 'disabled="disabled"' : '')));
	$layout->addField(PL_WORKFLOW_EDIT_SHOW_DEMO, new sbLayoutInput('checkbox', '1', 'w_show_demo', '', ($w_show_demo == 1 ? ' checked="checked"' : '').(isset($w_code) && ($w_code == 0 || $w_code == 1) ? 'disabled="disabled"' : '')));

	$html = '';
	$all_status = sql_query('SELECT w_code, w_title FROM sb_workflow ORDER BY w_order');
	if($all_status)
	{
		foreach($all_status as $value)
		{
			list($id, $title) = $value;
			if($id != $w_code)
			{
				$fld = new sbLayoutInput('checkbox', $id, 'accessible_s[]', 'status_'.$id, (!isset($w_accessible) || in_array($id, $w_accessible) ? 'checked="checked"' : ''));
				$html .= $fld->getField().'&nbsp;&nbsp;<label for="status_'.$id.'">'.$title.'</label><br />';
			}
		}
	}

	$layout->addField('', new sbLayoutDelim());

	$layout->addField(PL_WORKFLOW_EDIT_ACCESSIBLE, new sbLayoutHTML($html));

	$layout->addField('', new sbLayoutInput('hidden', $w_code, 'w_code'));

	$layout->addButton('submit', KERNEL_SAVE, 'btn_save', '', ($_SESSION['sbPlugins']->isRightAvailable('pl_workflow', 'elems_edit') ? '' : 'disabled="disabled"'));
	$layout->addButton('button', KERNEL_CANCEL, '', '', 'onclick="sbCloseDialog()"');
	$layout->show();
}

function fWorkflow_Edit_Submit()
{
	if (!isset($_GET['id']))
		$_GET['id'] = '';

	$w_title = '';
	$w_on = 0;
	$w_show_demo = 0;
	$accessible_s = '';

	extract($_POST);

	$row = array();
	$row['w_title'] = $w_title;
	$row['w_accessible'] = is_array($accessible_s) ? implode('|', $accessible_s) : '';

	if($_GET['id'] != '')
	{
		$res = sql_query('SELECT w_title FROM sb_workflow WHERE w_id=?d', $_GET['id']);
		if ($res)
		{
			// редактирование
			list($old_w_title) = $res[0];

			if($w_code != 0 && $w_code != 1)
			{
				$row['w_on'] = $w_on;
				$row['w_show_demo'] = $w_show_demo;
			}

			sql_query('UPDATE sb_workflow SET ?a WHERE w_id=?d', $row, $_GET['id'], sprintf(PL_WORKFLOW_EDIT_OK, $old_w_title));

			echo '<script>
						var res = new Object();
						res.id = "'.$_GET['id'].'";
						res.checked = "'.$w_on.'";
						res.demo = "'.$w_show_demo.'";
						res.title = "'.$w_title.'";
						sbReturnValue(res);
					</script>';
	    }
	    else
	    {
			sb_show_message(PL_WORKFLOW_EDIT_ERROR, false, 'warning');
			sb_add_system_message(sprintf(PL_WORKFLOW_EDIT_SYSTEMLOG_ERROR, $w_title), SB_MSG_WARNING);

			fWorkflow_Edit();
			return;
	    }
	}
	else
	{
		$max = sql_query('SELECT MAX(w_order) FROM sb_workflow');
		if ($max)
		{
			list ($w_order) = $max[0];
			$w_order++;
		}
		else
		{
			$w_order = 4;
		}

		$row['w_on'] = $w_on;
		$row['w_show_demo'] = $w_show_demo;
		$row['w_order'] = $w_order;
		$row['w_code'] = 0;

		$error = true;
	    if (sql_query('INSERT INTO sb_workflow (?#) VALUES (?a)', array_keys($row), array_values($row)))
	    {
    		$id = sql_insert_id();
    		sql_query('UPDATE sb_workflow SET w_code=?d WHERE w_id=?d', $id, $id);

       		sb_add_system_message(sprintf(PL_WORKFLOW_SUBMIT_ADD_OK, $w_title));
			echo '<script>
					var res = new Object();
					res.id = "'.$id.'";
					res.checked = "'.$w_on.'";
					res.demo = "'.$w_show_demo.'";
					res.title = "'.$w_title.'";
					res.order = "'.$w_order.'";
					sbReturnValue(res);
       			  </script>';
			$error = false;
	    }

	    if ($error)
	    {
	    	sb_show_message(PL_WORKFLOW_SUBMIT_ADD_ERROR, false, 'warning');
            sb_add_system_message(sprintf(PL_WORKFLOW_ADD_SYSTEMLOG_ERROR, $w_title), SB_MSG_WARNING);

            fWorkflow_Edit();
		    return;
	    }
	}
}

function fWorkflow_Change_Active()
{
	if(isset($_GET['id']) && $_GET['id'] != '')
	{
	    $res = sql_query('SELECT w_id, w_title, w_on FROM sb_workflow WHERE w_id = ?d', $_GET['id']);
	    if ($res)
	    {
			list($w_id, $w_title, $w_on) = $res[0];
			$w_on = ($w_on == 1 ? 0 : 1);

			$res = sql_query('UPDATE sb_workflow SET w_on=?d WHERE w_id=?d AND w_code != 0 AND w_code != 1 AND w_code != 2', $w_on, $w_id, sprintf(PL_WORKFLOW_EDIT_OK, $w_title));
			if($res)
			{
				echo 'TRUE';
			}
	    }
	}
}

function fWorkflow_Change_Demo()
{
	if(isset($_GET['id']) && $_GET['id'] != '')
	{
	    $res = sql_query('SELECT w_id, w_title, w_show_demo FROM sb_workflow WHERE w_id = ?d', $_GET['id']);
	    if ($res)
	    {
			list($w_id, $w_title, $w_show_demo) = $res[0];
			$w_show_demo = ($w_show_demo == 1 ? 0 : 1);

			$res = sql_query('UPDATE sb_workflow SET w_show_demo=?d WHERE w_id=?d AND w_code != 0 AND w_code != 1', $w_show_demo, $w_id, sprintf(PL_WORKFLOW_EDIT_OK, $w_title));
			if($res)
			{
				echo 'TRUE';
			}
	    }
	}
}

function fWorkflow_Delete()
{
	$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
	if ($id > 0)
	{
		$res_title = sql_query('SELECT w_title FROM sb_workflow WHERE w_id=?d', $id);

		sql_query('DELETE FROM sb_workflow WHERE w_id=?d AND w_code != 0 AND w_code != 1 AND w_code != 2', $id);
		$res = $GLOBALS['sbSql']->getAffectedRows();

		if($res > 0)
		{
			echo "OK";
			sb_add_system_message(sprintf(PL_WORKFLOW_EDIT_DELETE_OK, ($res_title ? $res_title[0][0] : '')));
			return;
		}
	}
	echo 'ERROR';
}

function fWorkflow_Change_Order()
{
	$error = false;
	$_GET['elems'] = isset($_GET['elems']) && $_GET['elems'] != '' ? unserialize($_GET['elems']) : '';

	if(is_array($_GET['elems']) && !empty($_GET['elems']))
	{
		foreach($_GET['elems'] as $key => $value)
		{
			$res = sql_query('UPDATE sb_workflow SET w_order=?d WHERE w_id=?d', $value, $key);
			if(!$res)
				$error = true;
		}
	}
	else
	{
		$error = true;
	}
	if($error)
		echo 'ERROR';
}

?>